
local ScreenScaleFactor = 2 
local CascadeEndGameDialog_border_x = 40
local LevelDialogDropDownY = Layout{0, ipad = 2, iphone5=30,pc=-75}
local DialogDropDownY = Layout{-2, ipad = 14, iphone5=30,pc=-75}
local DialogTitleY = 92
local DialogButtonY = -10

local Large_Dialog_Button_Y = -60/ScreenScaleFactor
local LargeLong_Dialog_Button_Y = -20/ScreenScaleFactor
local LargeLonger_Dialog_Button_Y = -60/ScreenScaleFactor+7
local Dialog_Button_Y = -45/ScreenScaleFactor
local Small_Dialog_Button_Y = -52/ScreenScaleFactor-3
local Dialog_Button_X = 100
local Dialog_Button_Right = Dialog_Button_X
local Dialog_Button_Left = -Dialog_Button_X

local toGoAlignment = "MidBottom"
local toGoOffset = {0,-1}
local amountToGoOffset = {0,-1}

local headerOffset = 60

local BottomCharacter_Alignment = {0,200}
local ChallengeYOffset = 75

local startQuestGameOptionsY = 170
local startQuestGameFirstLineY = 252
local startQuestGameLineSeparation = 36
local startQuestGameLeftAlignment = 15
local startQuestGameRightAlignment = 20
local startQuestGameLeftWidthLimit = 154
local startQuestGameRightWidthLimit = 116

local startQuestGameGoalY = 0
local startQuestGameGoalY_offset = 30

local startQuestGameStarGoalY = 16
local startQuestGameStarGoalY_offset = -11
local startQuestGameStarGoalX_offset = 86

local dialogWidth = 313

Resources.TopTenPanel_Challenge_GooglePlay = Resources.Actor:new {
	resource = "Actor",
	size = {dialogWidth,107},
	color = "White",
	alpha = 0,
	alignment = Layout{"MidBottom", android = "MidBottom"},
	alignTo = Layout{"MidBottom", android = "MidBottom"},
	alignmentOffset = Layout{{0,20 + headerOffset/2}, ipad = {0,20 + headerOffset/2}, iphone5={0,70 + headerOffset/2}, android = {0, 90 + headerOffset/2}},
	-- NOTE: This is no put into position via the Script so it always stays at bottom of screen

	Panel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogLowerChallenge.png",
		alignment = "Center",
		alignTo = "Center",
		zorder = -1,
	},
	
	competeAgainstText = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("Compete Against"),
		textAlignment = "Center",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 10},
		widthLimit = 125,
		shadowColor = "Cascade_LightTan",
		shadowOffset = {1, 1},
		shadowAlpha = 255,
		highlightColor = "Cascade_LightTan",
		highlightOffset = {-1, -1},
		highlightAlpha = 255,
		
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 22,
		},
	},

	TopTenButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		image = "ButtonWhiteMedShadow.png",
		alignment = Center,
		alignmentOffset = {0,0},
		textAlignmentOffset = {0,-3},
		textWidthLimit = 125,
		text = STRINGS("The Leaderboard"),	
		enterKey = true,
		shortcutKey = "t",
		visible = true,
	},
}


Scripts.ChallengeDialog_GooglePlay_TimeLeft_Update = function(self)
	local keepRunning = true
	while (keepRunning) do
		local hour = GetCurrentHourLocal()
		local min = GetCurrentMinuteLocal()
		local sec = GetCurrentSecondLocal()
		hour = 23-hour
		min = 59-min
		sec = 59-sec
		if((hour == 0) and (min == 0) and (sec == 0))then
			keepRunning = false
			self.visible = false
		end
		if(sec<10)then sec = "0"..sec end
		if(min<10)then min = "0"..min end
		local time = hour..":"..min..":"..sec
		self.text = STRINGS("Ends in ")..time
		ScriptDelay(950,"dialogTimers")
	end
end


-- GooglePlay Challenge

Resources.ChallengeDialog_GooglePlay = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "ChallengeDialog",
	alpha = 0,
	alignment = "MidTop",
	alignTo = "MidTop",
	alignmentOffset = {0, 0},

	introScriptName = "SlideOnTwoPanelsDialog_TopBar",
	dialogExitScriptName = "SlideOffTwoPanelsDialog_TopBar",

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogChallenge.png",
		zorder = 1,
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = Layout{{0,-25},iphone5={0,-25},ipad={0,-50}},
		extraScale = Layout{1.0, ipad=0.9},

		titleText = Resources.AppTitleDialogLabel_smaller:new {
			resource = "AppTitleDialogLabel_smaller",
			text = STRINGS("Google Challenge"),
			alignment = "MidTop",
            widthLimit = 180,
			alignmentOffset = {0, 70},
		},

		ChallengeDialog_TimeLeft = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS("Ends in 11:25"),
			textAlignment = "Center",
			alignment = "MidBottom",
			alignmentOffset = {0, -70},
			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontSize = 18,
			},        
			scripts = {"ChallengeDialog_GooglePlay_TimeLeft_Update"},
		},
		
		ScorePanel = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidTop",
			alignmentOffset = {0, 118},
			
			scoreText = Resources.AppDialogBoldLabel:new {
				resource = "AppDialogBoldLabel",
				text = STRINGS("Score:"),
				textAlignment = "Center",
				alignment = "MidTop",
				alignTo = "MidTop",
				alignmentOffset = {0, 0},
				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontSize = 18,
				},
			},
			
			ChallengeDialog_ScoreText = Resources.AppDialogBoldLabel:new {
				resource = "AppDialogBoldLabel",
				text = "10,000,000",
				textAlignment = "Center",
				alignment = "MidTop",
				alignTo = "MidTop",
				alignmentOffset = {0, 18},
				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontSize = 34,
				},
			},
			
			withText = Resources.AppDialogBoldLabel:new {
				resource = "AppDialogBoldLabel",
				text = STRINGS("With:"),
				textAlignment = "Center",
				alignment = "MidTop",
				alignTo = "MidTop",
				alignmentOffset = {0, 58},
				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontSize = 18,
				},
			},
		},
		
		ChallengeDialog_FeaturesPanel = Resources.Actor:new {
			resource = "Actor",
			color = "White",
			alpha = 0,
			alignment = MidTop,
			alignmentOffset = {0, 230},
			zorder = 2,
		},
		
		BoostPanel = Resources.Actor:new {
			resource = "Actor",	
			color = "White",
			alpha = 0,
			alignment = MidBottom,
			alignmentOffset = {0, -180},
			visible = Config.PayToWinChallenge,
			extraScale = 0.8,
			SelectBoostsLabel = Resources.AppTitleDialogLabel:new {
				resource = "AppTitleDialogLabel",
				text = STRINGS("Select Boosts"),
				alignment = MidTop,
				alignTo = MidTop,
				alignmentOffset = {0,0},
				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontSize = 20,	
				},
				zorder = 1,
			},
			Boost1 = Resources.QuestBoost:new {
				resource = "QuestBoost",
                alignmentOffset = {-80,20},
            },
			Boost2 = Resources.QuestBoost:new {
				resource = "QuestBoost",
                alignmentOffset = {0,20},
			},
			Boost3 = Resources.QuestBoost:new {
				resource = "QuestBoost",
				alignmentOffset = {80,20},
            },
		},
		
		--[[RewardPanel = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidBottom",
			alignmentOffset = {0, -172},
			
			winText = Resources.AppDialogBoldLabel:new {
				resource = "AppDialogBoldLabel",
				text = STRINGS("Win:"),
				textAlignment = "Center",
				alignment = "MidTop",
				alignTo = "MidTop",
				alignmentOffset = {0, 0},
				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontSize = 18,
				},
			},
			
			gold = Resources.Actor:new {
				resource = "Actor",
				image = "Gold_1bag.png",
				alignment = "MidTop",
				alignTo = "MidTop",
				alignmentOffset = {-62, 0},
				visible = true,
			},
			
			ChallengeDialog_RewardText = Resources.AppDialogBoldLabel:new {
				resource = "AppDialogBoldLabel",
				text = string.format(STRINGS("DailyChallengeRewardFormat"), 15),
				textAlignment = "Left",
				alignment = "MidTop",
				alignTo = "MidTop",
				alignmentOffset = {30, 22},
				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontSize = 34,
				},
			},
		},]]

		--[[ChallengeDialog_CheckMark = Resources.Actor:new {
			resource = "Actor",
			zorder = 5,
			image = "Check.png",
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {100,45-40+ChallengeYOffset-72},	
		},]]
		
		OkayButton = Resources.EndGameDialogBigButton:new {
			resource = "EndGameDialogBigButton",
			image = "ButtonSunsetLarge.png",
			buttonClosesDialog = true,
			alignment = MidBottom,
			alignmentOffset = Layout{{0,-10},iphone5={0,-10},ipad={0,-10}},
			textAlignmentOffset = {0,-1},
			text = STRINGS("Play"),
			enterKey = true,
			shortcutKey = "p",
			zorder = 2,
			scripts = {"DialogButtonGroove"},
			font	= Resources.AppButtonFont:new{
				resource = "AppButtonFont",
				fontSize = 44,
			},
		},
		
		CancelButton = Resources.CancelButton:new {
			resource = "CancelButton",
			image = "ButtonCloseWax.png",
			alignmentOffset = Layout{{-6,75},iphone5={-6,75},ipad={-6,75}}
		},
	},

	TopTenPanel = Resources.TopTenPanel_Challenge_GooglePlay:new {
		resource = "TopTenPanel_Challenge_GooglePlay",
		zorder = 20,
	},
}

Resources.ChallengeFeatureIcon = Resources.DialogButton:new {
	resource = "DialogButton",
	image = "FeatureIcon_Spins.png",
	alignment = "Center",
	alignTo = "Center",
	
	QuantityLabel = Resources.AppDialogSmallLabel:new {
        resource = "AppDialogSmallLabel",
        alignTo = Center,
        alignment = Center,
        alignmentOffset = {14, 14},
		widthLimit = 20,
		extraScale = 0.75,
		
		NumberMarker = Resources.Actor:new {
			image = "NumberMarker.png",
			alignment = Center,
			alignTo = Center,
			zorder = -1,
		},
        visible = false,
    },
}

Scripts.Preshow_ChallengeDialog_GooglePlay = function(dialog,screen)
	dialog.MainPanel.OkayButton:AddObserver(EventMap.GURU_BUTTONCLICK, screen)
	dialog.MainPanel.CancelButton:AddObserver(EventMap.GURU_BUTTONCLICK, screen)
end

Scripts.Present_ChallengeDialog_GooglePlay = function(dialog)

end

Scripts.Preshow_YesterdaysChallengeDialog_GooglePlay = function(dialog,newToday)
	
	-- test
	-- newToday = false

	local makeVisible = false
	if(newToday)then
		makeVisible = false
	else 
		makeVisible = true
	end

	dialog.MainPanel.ChallengeDialog_ResultsText1.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText2.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText3.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText4.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText_winner.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText_winner_picture.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText_winner_score.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText_congrats.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_LoadingText.visible = false
	dialog.TopTenPanel.visible = makeVisible
end

Scripts.Present_YesterdaysChallengeDialog_GooglePlay = function(dialog,newToday)

	-- test
	-- newToday = false

	if(newToday)then
		dialog.TopTenPanel.visible = false
		local delay = 500
		PlaySound("slot_machine_spin_loop_02.ogg")
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_bet_13.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText1.visible = true
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_bet_14.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText2.visible = true
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_bet_15.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText3.visible = true
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_bet_16.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText4.visible = true
		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("slot_machine_spin_stop_05.ogg")
		StopSound("slot_machine_spin_loop_02.ogg")
		PlaySound("slot_machine_bet_all_03.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText_winner.visible = true
		dialog.MainPanel.ChallengeDialog_ResultsText_winner_picture.visible = true
		dialog.MainPanel.ChallengeDialog_ResultsText_winner_score.visible = true
		PlaySound("pop_sparkle_01.ogg")
		FireParticle(dialog.MainPanel.ChallengeDialog_ResultsText_winner,"StarToss1.smaller","Center",dialog.hgeParticles)  
		FireParticle(dialog.MainPanel.ChallengeDialog_ResultsText_winner,"SparkleBurst1","Center",dialog.hgeParticles)
		CorrectedPop(dialog.MainPanel.ChallengeDialog_ResultsText_winner,{expandTo={1.1, 1.1},expandTime=100, shrinkTime=50})
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_spin_04_short.ogg")
		FireParticle(dialog.MainPanel.ChallengeDialog_ResultsText_winner_score,"Shine2","Center",dialog.hgeParticles)

		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("air_cannon_pressure_release_02.ogg")
		FireParticle(dialog.MainPanel.titleText,"Confetti1_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti2_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti3_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti4_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti5_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti6_normal_shape_short","MidTop",dialog.hgeParticles)
		PlaySound("crowd_indoor_cheer_02.ogg")
		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("slot_machine_win_08.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText_congrats.text = STRINGS("RIGHT ON!")
		dialog.MainPanel.ChallengeDialog_ResultsText_congrats.visible = true
		SlideOn(dialog.TopTenPanel,150,"bottom","wait")
	end
end

Scripts.Leave_YesterdaysChallengeDialog_GooglePlay = function(screen)
	StopSound("slot_machine_spin_loop_02.ogg")
end


Resources.YesterdaysChallengeDialog_GooglePlay = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "YesterdaysChallengeDialog",
	alpha = 0,
	--alignmentOffset = {0,LevelDialogDropDownY},

	introScriptName = "SlideOnTwoPanelsDialog",
	dialogExitScriptName = "SlideOffTwoPanelsDialog",

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogGeneric_Small.png",
		zorder = 1,
		titleText = Resources.AppTitleDialogLabel_smaller:new {
			resource = "AppTitleDialogLabel_smaller",
			text = STRINGS("Google Challenge Results"),
			alignment = MidTop,
			alignmentOffset = {0, 14},
            widthLimit = 222,
		},

		ChallengeDialog_ResultsText1 = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("And the winner..."),
			textAlignment = "Center",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,80+ChallengeYOffset-100},
			visible = false,
		},

		ChallengeDialog_ResultsText2 = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("of yesterday's..."),
			textAlignment = "Center",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,80+ChallengeYOffset-80},
			visible = false,
		},

		ChallengeDialog_ResultsText3 = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("Cascade Daily Challenge..."),
			textAlignment = "Center",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,80+ChallengeYOffset-60},
			visible = false,
		},

		ChallengeDialog_ResultsText4 = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("was..."),
			textAlignment = "Center",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,80+ChallengeYOffset-40},
			visible = false,
		},

		ChallengeDialog_ResultsText_winner = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS("No Results Yet..."),
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			widthLimit = 300,
			alignmentOffset = {0,-15},
			visible = false,
		},

		ChallengeDialog_ResultsText_winner_picture = Resources.RemotePlayerPicture:new {
			resource = "RemotePlayerPicture",
			image = "PlayerPic_Empty.png",
			defaultImage = "PlayerPic_Empty.png",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0, 20},
			size = {40, 40},
			resizeOnSetImage = false,
			PlayerFrame = Resources.Actor:new {
				image = "PlayerFrame.png",
				size = {40, 40},
				alignment = "Center",
				alignTo = "Center",
				zorder = 1,
			},
		},

		ChallengeDialog_ResultsText_winner_score = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS(""),
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			widthLimit = 300,
			alignmentOffset = {0,60},
			visible = false,
		},

		ChallengeDialog_ResultsText_congrats = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS(""),
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			widthLimit = 300,
			alignmentOffset = {0,110},
			visible = false,
		},

		ChallengeDialog_LoadingText = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			text = STRINGS("Loading Yesterday's Challenge..."),
			textAlignment = "Center",
			wrapLimit = 260,
			heightLimit = 110,
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0,0},
			font = Resources.DialogFont:new{
				resource = "DialogFont",
				fontSize = 24,
			},     
			visible = true,   
		},

		shareScoreButton = Resources.DialogSmallerButton:new {
			resource = "DialogSmallerButton",
			--image = "btnShare.png",
			text = STRINGS("Share"), 
			alignment = MidBottom,
			alignmentOffset = {0,-12},
			OnButtonClick = function (self, event)
				if self ~= event.button then
					return false
				end
				local shareText = self.dialog:GetShareText()
				if IsString(shareText) and shareText ~= "" then
                    Analytics_Brag()
					ShareText(shareText, "ChallengeResults", self)
				end
				return true
			end,		
			--scripts = {"JelloLoop"},
		},


		CancelButton = Resources.CancelButton:new {
			resource = "CancelButton",
		},
	},

	TopTenPanel = Resources.TopTenPanel_Challenge_GooglePlay:new {
		resource = "TopTenPanel_Challenge_GooglePlay",
		zorder = 2,
		visible = false,
	},
}

Resources.AreYouSureQuitDialog_Android = Resources.LargeLongerDialog:new
{
	resource = "LargeLongerDialog",
	class = "AreYouSureQuitDialog_Android",
	name = "AreYouSureQuitDialog_Android",
	image = "DialogGeneric_Small.png",
	title = "",
	
	Jasper_Customer_Support = Resources.Actor:new {
		resource = "Actor",
		image = "Jasper_Customer_Support@2x.png",
		alignment = "MidTop",
		extraScale = 0.68,
		alignmentOffset = {0,20},
	},

	text = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = "Are you sure\nyou want to quit?",
		alignment = Center,
		alignmentOffset = {0,20},
		fgColor = "Black",
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
        buttonClosesDialog = true,

		--Disabled for now
		--[[
        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end
		--]]
	},
	
    YesButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Short_Green.png",
        text = STRINGS("Yes"),
        alignment = "MidBottom",
        alignmentOffset = {-74,-34},
        textWidthLimit = 80,
        buttonClosesDialog = true,

		--Disabled for now
		--[[
		OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            --WP_MGR:Hide()
            self.parent.CloseDialog(self.parent)

            return true
        end,
		--]]
    },

    NoButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Short_Green.png",
        text = STRINGS("No"),
        alignment = "MidBottom",
        alignmentOffset = {74,-34},
        textWidthLimit = 80,
        buttonClosesDialog = true,

		--Disabled for now
		--[[
		OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end,
		--]]
    },
}


Scripts.Preshow_AreYouSureQuitDialog_Android = function(dialog)
end

Scripts.Present_AreYouSureQuitDialog_Android = function(dialog)
end

local CascadeEndGameDialog_Challenge_yoffset = -60
local endGameLineSeparation = 31
local endGameFirstLineY = 140
local endGameLabelX = 50
local endGameValueX = -50

Resources.CascadeEndGameDialog_Challenge_GooglePlay = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    title = "",
    class = "CascadeEndGameDialog",
    name = "CascadeEndGameDialog",
    enableVisibleUnderlay = true,
	alpha = 0,

	introScriptName = "SlideOnTwoPanelsDialog_TopBar",
	dialogExitScriptName = "SlideOffTwoPanelsDialog_TopBar",

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogGeneric_Small.png",

		DialogCharacter = Resources.DialogCharacter:new {
			resource = "DialogCharacter",
			zorder = 1,
		},

		TitleLabel = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("Challenge Over"),
    		alignment = MidTop,
			alignmentOffset = {-15, 15},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize 	= 30
			},
			widthLimit = 250,
		},

		goalScoreContainer = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidTop",
			alignmentOffset = {0, 170},
		
			SetScore = function (self, score)
				self.score.text = string.format(STRINGS("EndGameDialog_GoalScoreFormat"), Int2Comma(score))
			end,

			score = Resources.StartQuestGameDialogLabel:new {
				resource = "StartQuestGameDialogLabel",
				fgColor = "Cascade_DarkBrown",
				alignment = "MidTop",
				alignmentOffset = {0,-10},
				text = STRINGS("1,000,000"),
				font = Resources.DialogFont:new {resource = "DialogFont",fontSize = 22,},
				widthLimit = 180,
			},

			check = Resources.Actor:new {
				resource = "Actor",
				image = "Check.png",
				alignment = TopRight,
				alignmentOffset = {140,0},
				zorder = 10,
				visible = false,
			},

			X = Resources.Actor:new {
				resource = "Actor",
				image = "X.png",
				alignment = TopRight,
				alignTo = TopRight,
				alignmentOffset = {-10,-172},
				zorder = 10,
				visible = false
			},
		},

		GoalPanel = Resources.GoalPanel:new {
			resource = "GoalPanel",
			zorder = 2,
			LevelObjective = {
				class = "Label",
				visible = false,
			},
			Requirement = {
				class = "Actor",
				alignmentOffset = {0,105},
			},
            ObjectiveBanner = {
                class = "Actor",
				visible = false,
            },
		},
    
		scoreContainer = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidTop",
			alignmentOffset = {0,195},
		
			SetScore = function (self, score)
				self.score.text = string.format(STRINGS("EndGameDialog_ScoreFormat"), Int2Comma(score))
			end,

			score = Resources.StartQuestGameDialogBoldLabel:new {
				resource = "StartQuestGameDialogBoldLabel",
				text = STRINGS("Requirement:\nScore 45,000"),
				font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 36,	},
				bestStamp = Resources.BestStamp,
			},
		},
    
		ChallengeDialog_TopScoreToday = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopLeft,
			alignmentOffset = {30,endGameFirstLineY + 5 * endGameLineSeparation - 45},
			text = STRINGS("Today's Best:"),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
			widthLimit = 170,
		},
    
		dailyBest = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopLeft,
			alignmentOffset = {210,endGameFirstLineY + 5 * endGameLineSeparation - 45},
			text = STRINGS(""),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
			bestStamp = Resources.BestStamp,
			visible = true,
		},

		challengeBeatLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopLeft,
			alignmentOffset = {30,endGameFirstLineY + 5 * endGameLineSeparation - 20},
			text = STRINGS("Challenges Beat:"),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
			widthLimit = 170,
		},
    
		challengeBeat = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopLeft,
			alignmentOffset = {210,endGameFirstLineY + 5 * endGameLineSeparation - 20},
			text = STRINGS(""),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
		},

		ButtonCollection = Resources.EndGameDialogButtons_Challenge:new {
			resource = "EndGameDialogButtons_Challenge",
			alignment = "MidBottom",
			alignmentOffset = {0, 0},
		},
	
		CancelButton = Resources.CancelButton:new {
			resource = "CancelButton",
		},

		okayButton = Resources.DialogSmallerButton:new {
			resource = "DialogSmallerButton",
			image = "ButtonPlastic_Small_Orange.png",
			buttonClosesDialog = true,
			alignment = MidBottom,
			alignmentOffset = {-110,-12},
			text = STRINGS("Map"),
			enterKey = true,
			escapeKey = true,
			shortcutKey = "o",
			zorder = 2,
			visible = true,
		},
	},

	TopTenPanel = Resources.TopTenPanel_Challenge_GooglePlay:new {
		resource = "TopTenPanel_Challenge_GooglePlay",
		zorder = 2,
	},
    
    InitScoreSharing = function (self, textToShare)
		local shouldShowShareScoreButton = SOCIAL_MGR_IsAvailable() and IsString(textToShare) and string.len(textToShare) > 0
		--[[
		logprintf("InitScoreSharing: should show=%s, is avail=%s, textToShare=%s\n",
			tostring(shouldShowShareScoreButton),
			tostring(SOCIAL_MGR_IsAvailable()),
			tostring(textToShare))
		--]]
		if shouldShowShareScoreButton then
			self.MainPanel.ButtonCollection.shareScoreButton.textToShare = textToShare
			self.MainPanel.ButtonCollection.shareScoreButton.visible = true
		end
	end,
	
	OnPostSpawn = function (self)
		if self.MainPanel.ButtonCollection then
			if self.MainPanel.ButtonCollection.PlayAgainButton then
				self.MainPanel.ButtonCollection.PlayAgainButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end            
			if self.MainPanel.ButtonCollection.shareScoreButton then
				self.MainPanel.ButtonCollection.shareScoreButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end        
			if self.MainPanel.okayButton then
				self.MainPanel.okayButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.CancelButton then
				self.MainPanel.CancelButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.GoalPanel.StarGoal1.Star then
				self.MainPanel.GoalPanel.StarGoal1.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.GoalPanel.StarGoal2.Star then
				self.MainPanel.GoalPanel.StarGoal2.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.GoalPanel.StarGoal3.Star then
				self.MainPanel.GoalPanel.StarGoal3.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
		end
	end,
}

Resources.NewsItem_DailyChallengePlay_GooglePlay = Resources.NewsItem:new {
    resource = "NewsItem",
	
	imageSprite = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "TopRight",
        alignmentOffset = {-8-46,43},
	},

	ScorePanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {55, 47},
		
		scoreText = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS("Score:"),
			textAlignment = "Right",
			alignment = "MidRight",
			alignTo = "MidLeft",
			alignmentOffset = {0, 0},
			widthLimit = 40,
			font = Resources.DialogBoldFont:new {
				resource = "DialogBoldFont",
				fontSize = 14,
			},
		},
		
		NewsChallenge_ScoreText = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = "10,000,000",
			textAlignment = "Left",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {5, 0},
			font = Resources.DialogBoldFont:new {
				resource = "DialogBoldFont",
				fontSize = 20,
			},
		},
	},
	
	NewsChallenge_FeaturesPanel = Resources.Actor:new {
		resource = "Actor",
		image = "IconWell.png",
		color = "White",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {15, 62},
		zorder = 2,
	}, 
	
	RewardPanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "BottomLeft",
		alignTo = "BottomLeft",
		alignmentOffset = {55, -27},
		
		winText = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS("Win:"),
			textAlignment = "Right",
			alignment = "MidRight",
			alignTo = "MidLeft",
			alignmentOffset = {0, 0},
			widthLimit = 40,
			font = Resources.DialogBoldFont:new {
				resource = "DialogBoldFont",
				fontSize = 14,
			},
		},
		
		gold = Resources.Actor:new {
			resource = "Actor",
			image = "Gold_1bag.png",
			extraScale = 0.6,
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {-30, 0},
			visible = true,
		},
		
		NewsChallenge_RewardText = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = string.format(STRINGS("DailyChallengeRewardFormat"), 5),
			textAlignment = "Left",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {50, 0},
			widthLimit = 80,
			font = Resources.DialogBoldFont:new {
				resource = "DialogBoldFont",
				fontSize = 20,
			},
		},
	},
	
	NewsChallenge_TimeLeft = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS("Ends in 11:25"),
			textAlignment = "Right",
			alignment = "BottomRight",
			alignTo = "BottomRight",
			alignmentOffset = {-15, -51},
			widthLimit = 90,
			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontSize = 12,
			},        
			scripts = {"ChallengeDialog_GooglePlay_TimeLeft_Update"},
		},

	actionButton = Resources.DialogSmallButton:new {
		resource = "DialogSmallButton",
		image = "ButtonSunsetSmall.png",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignTo = BottomRight,
		alignmentOffset = {-10,-10},
        textWidthLimit = 70,
	},

    OnPostSpawn = function (self)
        self.imageSprite.image = "ChallengeCoin.png"
        self.titleLabel.text = STRINGS("Google Challenge")
        self.actionButton.action = "Daily Challenge"
        self.actionButton.text = STRINGS("Play")
	end,
}

Resources.NewsItem_DailyChallengeResults_GooglePlay = Resources.NewsItem:new {
    resource = "NewsItem",

    OnPostSpawn = function (self)
        self.imageSprite.image = "Medal_big_gold.png"
        self.titleLabel.text = STRINGS("Challenge Results")
        self.descriptionLabel.text = STRINGS("Here are the results from yesterday's Daily Challenge. Did you win?")
        self.actionButton.action = "Challenge Results"
        self.actionButton.text = STRINGS("View")
	end,
}

Resources.WelcomeToGoldDialog_GooglePlay = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "WelcomeToGoldDialog",
	class = "WelcomeToGoldDialog_GooglePlay",
    title = "",
	image = "Dialog_GoogleGold_Back.png",

    titleText = Resources.AppTitleDialogLabel:new {
        resource = "AppTitleDialogLabel",
        text = STRINGS("A special gift for all Google Players!"),
		alignment = MidTop,
		alignmentOffset = {0,65},
		wrapLimit = 275,
		heightLimit = 100,
        zorder = 1,
        shadowColor = "Cascade_White",
        shadowAlpha = 255,
        highlightColor = "Cascade_White",
        highlightAlpha = 255,
        shadowOffset = {2,2},
        highlightOffset = {-2,-2},
        zorder = 4,
    },

	topText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("x free bars!"),
		alignment = "Center",
		alignmentOffset = {0,70},
		wrapLimit = 250,
        zorder = 4,
        heightLimit = 40,
	},

	GoldBarsImage = Resources.Actor:new {
		resource = "Actor",
		alignment = Center,
		image = "Gold_1bag_big.png",
        alignmentOffset = {5,10},
        
        hgeParticles = {
            class = "hgeParticleLayer",
            zorder = 10,
        },
        zorder = 3,

        scripts = {"DialogButtonGroove"},
	},
	
	JasperImage = Resources.Actor:new {
		resource = "Actor",
		alignment = Center,
		image = "Dialog_GoogleGold_Jasper.png",
        alignmentOffset = {-65,-25},
       	zorder = 2,
	},
	
	AndroidImage = Resources.Actor:new {
		resource = "Actor",
		alignment = Center,
		image = "Dialog_GoogleGold_Android.png",
        alignmentOffset = {65,-25},
        zorder = 2,
	},
	
	Rainbow = Resources.Actor:new {
		resource = "Actor",
		alignment = TopLeft,
		image = "Dialog_GoogleGold_Rainbow.png",
        alignmentOffset = {51,57},
        zorder = 1,
	},

	text = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("Use Cascade Gold to buy Lives, Spins, Tricks and Boosts!"),
		alignment = "Center",
		alignmentOffset = {0,170},
		wrapLimit = 250,
        heightLimit = 50,
	},

	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
        image = "ButtonPlastic_Medium_Green.png",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0, -110},
		text = STRINGS("Get it!"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
        textWidthLimit = 115,
        textHeightLimit = 40,
        widthLimit = 150,
		clickSound = "coin_magic_03.ogg",
	
		font	= Resources.DialogTitleFont_bigger:new{
			resource = "DialogTitleFont_bigger",
		},
        OnPostSpawn = function (self)

        end,
	},
}

Scripts.Preshow_WelcomeToGoldDialog_GooglePlay = function(dialog,gold)
	--logprint("Preshow_WelcomeToGoldDialog gold: "..gold)
end

Scripts.Present_WelcomeToGoldDialog_GooglePlay = function(dialog,gold)

		local delay = 400

		PlaySound("slot_machine_win_02.ogg")
		FireParticle(dialog.GoldBarsImage,"Shine2","Center",dialog.hgeParticles)
		FireParticle(dialog.GoldBarsImage,"GoldSparkle1","Center",dialog.hgeParticles)

		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("air_cannon_pressure_release_02.ogg")
		FireParticle(dialog,"Confetti1_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti2_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti3_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti4_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti5_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti6_normal_shape_short","MidTop",dialog.hgeParticles)
		PlaySound("crowd_indoor_cheer_02.ogg")
		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("slot_machine_win_01.ogg")
end