
local spinImg = "Button_SPIN_BLANK_.png"
local spinText = STRINGS("Spin")
if Language == "en" then
    spinImg = "CascadeSpinButton.png"
    spinText = ""
end

--
-- DEBUG SETTINGS
--

local iPhone5_GameBoard_NudgeY = 44
local iPad_GameBoard_NudgeY = 22-18

-- Show extra info on screen to help place things?
local Debug_Placement = false --true

-- Set up debugging flags, but only if they haven't been defined.
if IsNil(Debug_Placement) then
	Debug_Placement = false
end

-- Specifies an alpha value for actors, one that changes depending on whether
-- or not Debug_Placement is true or not.
local function InvisibleUnlessDebugPlacementIsActive()
	if Debug_Placement == true then
		return 100
	else
		return 0
	end
end

-- Actor color to use for normally invisible actors that should be shown when
-- Debug_Placement is true.
local DebugPlacementColor = "Black"


Resources.GameLabel = Resources.Label:new {
	resource = "Label",
	text = STRINGS(""),
	fgColor = "Cascade_Black",
	shadowColor = "Cascade_Shadow",
	--shadowOffset = {1, 1},
	shadowAlpha = 0,
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
	},
}

Resources.GameLabelBold = Resources.Label:new {
	resource = "Label",
	text = STRINGS(""),
	fgColor = "Cascade_Black",
	highlightColor = "Cascade_Grey",
	highlightOffset = {-1, -1},
	highlightAlpha = 0,
	shadowColor = "Cascade_Shadow",
	shadowOffset = {1, 1},
	shadowAlpha = 0,
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
		fontSize = 24,
	},
}

Resources.GameLabelBold_small = Resources.GameLabelBold:new {
	resource = "GameLabelBold",
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
		fontSize = 22,
	},
}

Resources.GameLabelBold_smaller = Resources.GameLabelBold:new {
	resource = "GameLabelBold",
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
		fontSize = 18,
	},
}

Resources.GameLabelBold_20 = Resources.GameLabelBold:new {
	resource = "GameLabelBold",
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
		fontSize = 20,
	},
}

Resources.GameLabelText = Resources.Label:new {
	resource = "Label",
	text = STRINGS(""),
	fgColor = "Cascade_Black",
	highlightColor = "Cascade_Grey",
	highlightOffset = {-1, -1},
	highlightAlpha = 0,
	shadowColor = "Cascade_Shadow",
	shadowOffset = {1, 1},
	shadowAlpha = 0,
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
		fontSize = 18,
	},
}

Resources.GameLabelChunky = Resources.Label:new {
	resource = "Label",
	text = STRINGS(""),
	fgColor = "Panel_DarkBrown",
	highlightColor = "Panel_LightBrown",
	highlightOffset = {1, 1},
	highlightAlpha = 250,
	shadowColor = "Panel_ShadowBrown",
	shadowOffset = {-1, -1},
	shadowAlpha = 250,
	font	= Resources.AppButtonFont:new{
		resource = "AppButtonFont",
		fontSize = 30,
	},
}

Resources.BigGameLabel = Resources.Label:new {
	resource = "Label",
	text = STRINGS(""),
	fgColor = "Black",
	shadowColor = "Black",
	--shadowOffset = {1, 1},
	shadowAlpha = 0,
	font	= Resources.GameLabelFont:new{
		resource = "GameLabelFont",
		fontSize = 24,
	},
}

-- Used to position individual pieces.
Resources.BoardCell = Resources.Button:new {
	resource = "Button",
	size = {50,50},
	alpha = InvisibleUnlessDebugPlacementIsActive(),
	color = DebugPlacementColor,
}

Resources.MissingSquare = {
	class = "Button",
	background = {
		class = "Actor",
		alpha = 0,
	},
	active = false,
	missingSquare = true,
}

Resources.PresentSquare = {
	class = "Button",
	background = {
		class = "Actor",
		alpha = 255,
	},
	active = true,
	missingSquare = false,
}

Resources.CellBorderStyle = {
	alpha = 150,
	visible = true,  --ENABLE OR DISABLE BORDERS
}

local CellBorderStyle_BigBoard_Offset = 0 --1

Resources.CellBorderStyle_Top_Left_Inward = {
	class = "Actor",
	name = "CellBorder_Top_Left",
	alignment = MidRight,
	alignTo = MidTop,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleDown.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Top_Left_Inward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleDown_88.png",
	alignmentOffset = {0,-CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Top_Left_Inward",
}

Resources.CellBorderStyle_Top_Left_Outward = {
	class = "Actor",
	name = "CellBorder_Top_Left",
	alignment = MidRight,
	alignTo = MidTop,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleUpOutward.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Top_Left_Outward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleUpOutward_88.png",
	alignmentOffset = {0,-CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Top_Left_Outward",
}

Resources.CellBorderStyle_Top_Left_Straight = {
	class = "Actor",
	name = "CellBorder_Top_Left",
	alignment = MidRight,
	alignTo = MidTop,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleStraight.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Top_Left_Straight_BigBoard = {
	class = "Actor",
	image = "BorderWaggleStraight_88.png",
	alignmentOffset = {0,-CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Top_Left_Straight",
}

Resources.CellBorderStyle_Top_Right_Inward = {
	class = "Actor",
	name = "CellBorder_Top_Right",
	alignment = MidLeft,
	alignTo = MidTop,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleUp.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Top_Right_Inward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleUp_88.png",
	alignmentOffset = {0,-CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Top_Right_Inward",
}

Resources.CellBorderStyle_Top_Right_Outward = {
	class = "Actor",
	name = "CellBorder_Top_Right",
	alignment = MidLeft,
	alignTo = MidTop,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleDownOutward.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Top_Right_Outward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleDownOutward_88.png",
	alignmentOffset = {0,-CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Top_Right_Outward",
}

Resources.CellBorderStyle_Top_Right_Straight = {
	class = "Actor",
	name = "CellBorder_Top_Right",
	alignment = MidLeft,
	alignTo = MidTop,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleStraight.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Top_Right_Straight_BigBoard = {
	class = "Actor",
	image = "BorderWaggleStraight_88.png",
	alignmentOffset = {0,-CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Top_Right_Straight",
}

Resources.CellBorderStyle_Bottom_Left_Inward = {
	class = "Actor",
	name = "CellBorder_Bottom_Left",
	alignment = MidRight,
	alignTo = MidBottom,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleUp.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Bottom_Left_Inward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleUp_88.png",
	alignmentOffset = {0,CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Bottom_Left_Inward",
}

Resources.CellBorderStyle_Bottom_Left_Outward = {
	class = "Actor",
	name = "CellBorder_Bottom_Left",
	alignment = MidRight,
	alignTo = MidBottom,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleDownOutward.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Bottom_Left_Outward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleDownOutward_88.png",
	alignmentOffset = {0,CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Bottom_Left_Outward",
}

Resources.CellBorderStyle_Bottom_Left_Straight = {
	class = "Actor",
	name = "CellBorder_Bottom_Left",
	alignment = MidRight,
	alignTo = MidBottom,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleStraight.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Bottom_Left_Straight_BigBoard = {
	class = "Actor",
	image = "BorderWaggleStraight_88.png",
	alignmentOffset = {0,CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Bottom_Left_Straight",
}

Resources.CellBorderStyle_Bottom_Right_Inward = {
	class = "Actor",
	name = "CellBorder_Bottom_Right",
	alignment = MidLeft,
	alignTo = MidBottom,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleDown.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Bottom_Right_Inward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleDown_88.png",
	alignmentOffset = {0,CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Bottom_Right_Inward",
}

Resources.CellBorderStyle_Bottom_Right_Outward = {
	class = "Actor",
	name = "CellBorder_Bottom_Right",
	alignment = MidLeft,
	alignTo = MidBottom,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleUpOutward.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Bottom_Right_Outward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleUpOutward_88.png",
	alignmentOffset = {0,CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Bottom_Right_Outward",
}

Resources.CellBorderStyle_Bottom_Right_Straight = {
	class = "Actor",
	name = "CellBorder_Bottom_Right",
	alignment = MidLeft,
	alignTo = MidBottom,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleStraight.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Bottom_Right_Straight_BigBoard = {
	class = "Actor",
	image = "BorderWaggleStraight_88.png",
	alignmentOffset = {0,CellBorderStyle_BigBoard_Offset},
	resource = "CellBorderStyle_Bottom_Right_Straight",
}

Resources.CellBorderStyle_Left_Top_Inward = {
	class = "Actor",
	name = "CellBorder_Left_Top",
	alignment = MidBottom,
	alignTo = MidLeft,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleRight.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Left_Top_Inward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleRight_88.png",
	alignmentOffset = {-CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Left_Top_Inward",
}

Resources.CellBorderStyle_Left_Top_Outward = {
	class = "Actor",
	name = "CellBorder_Left_Top",
	alignment = MidBottom,
	alignTo = MidLeft,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleLeftOutward.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Left_Top_Outward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleLeftOutward_88.png",
	alignmentOffset = {-CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Left_Top_Outward",
}

Resources.CellBorderStyle_Left_Top_Straight = {
	class = "Actor",
	name = "CellBorder_Left_Top",
	alignment = MidBottom,
	alignTo = MidLeft,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleStraightVertical.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Left_Top_Straight_BigBoard = {
	class = "Actor",
	image = "BorderWaggleStraightVertical_88.png",
	alignmentOffset = {-CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Left_Top_Straight",
}

Resources.CellBorderStyle_Left_Bottom_Inward = {
	class = "Actor",
	name = "CellBorder_Left_Bottom",
	alignment = MidTop,
	alignTo = MidLeft,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleLeft.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Left_Bottom_Inward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleLeft_88.png",
	alignmentOffset = {-CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Left_Bottom_Inward",
}

Resources.CellBorderStyle_Left_Bottom_Outward = {
	class = "Actor",
	name = "CellBorder_Left_Bottom",
	alignment = MidTop,
	alignTo = MidLeft,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleRightOutward.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Left_Bottom_Outward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleRightOutward_88.png",
	alignmentOffset = {-CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Left_Bottom_Outward",
}

Resources.CellBorderStyle_Left_Bottom_Straight = {
	class = "Actor",
	name = "CellBorder_Left_Bottom",
	alignment = MidTop,
	alignTo = MidLeft,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleStraightVertical.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Left_Bottom_Straight_BigBoard = {
	class = "Actor",
	image = "BorderWaggleStraightVertical_88.png",
	alignmentOffset = {-CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Left_Bottom_Straight",
}

Resources.CellBorderStyle_Right_Top_Inward = {
	class = "Actor",
	name = "CellBorder_Right_Top",
	alignment = MidBottom,
	alignTo = MidRight,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleLeft.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Right_Top_Inward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleLeft_88.png",
	alignmentOffset = {CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Right_Top_Inward",
}

Resources.CellBorderStyle_Right_Top_Outward = {
	class = "Actor",
	name = "CellBorder_Right_Top",
	alignment = MidBottom,
	alignTo = MidRight,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleRightOutward.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Right_Top_Outward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleRightOutward_88.png",
	alignmentOffset = {CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Right_Top_Outward",
}

Resources.CellBorderStyle_Right_Top_Straight = {
	class = "Actor",
	name = "CellBorder_Right_Top",
	alignment = MidBottom,
	alignTo = MidRight,
	rotationAngle = {degrees = 0,},
	image = "BorderWaggleStraightVertical.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Right_Top_Straight_BigBoard = {
	class = "Actor",
	image = "BorderWaggleStraightVertical_88.png",
	alignmentOffset = {CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Right_Top_Straight",
}

Resources.CellBorderStyle_Right_Bottom_Inward = {
	class = "Actor",
	name = "CellBorder_Right_Bottom",
	alignment = MidTop,
	alignTo = MidRight,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleRight.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Right_Bottom_Inward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleRight_88.png",
	alignmentOffset = {CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Right_Bottom_Inward",
}

Resources.CellBorderStyle_Right_Bottom_Outward = {
	class = "Actor",
	name = "CellBorder_Right_Bottom",
	alignment = MidTop,
	alignTo = MidRight,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleLeftOutward.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Right_Bottom_Outward_BigBoard = {
	class = "Actor",
	image = "BorderWaggleLeftOutward_88.png",
	alignmentOffset = {CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Right_Bottom_Outward",
}

Resources.CellBorderStyle_Right_Bottom_Straight = {
	class = "Actor",
	name = "CellBorder_Right_Bottom",
	alignment = MidTop,
	alignTo = MidRight,
	rotationAngle = {degrees = 180,},
	image = "BorderWaggleStraightVertical.png",
	zorder = 5,
	resource = "CellBorderStyle",
}

Resources.CellBorderStyle_Right_Bottom_Straight_BigBoard = {
	class = "Actor",
	image = "BorderWaggleStraightVertical_88.png",
	alignmentOffset = {CellBorderStyle_BigBoard_Offset,0},
	resource = "CellBorderStyle_Right_Bottom_Straight",
}

Scripts.TapHereAction = function (arrow)
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x,currentPosition.y+arrowPointSpan}
	local loopCount = 1

	arrow.extraScale = 1.0
	
	local tapPointTime = 500
	local tapPointTime_back = 250

	while true do
		RotateTo(arrow, {revolutions=-0.05}, tapPointTime,false)
		ScaleTo(arrow, {0.8,0.8}, tapPointTime)
		SlideAndWait(arrow, adjustPosition, tapPointTime)
		RotateTo(arrow, {revolutions=0.05}, tapPointTime_back,false)
		ScaleTo(arrow, {1.0,1.0}, tapPointTime_back)
		SlideAndWait(arrow, currentPosition, tapPointTime_back)
	end
end

Resources.TapHerePointer = Resources.Actor:new {
	resource = "Actor",
	image = "TapHere.png",
	rotationPoint = "MidBottom",
	--rotationAngle = { degrees = 0 },
	--alignment = "MidTop",
	--alignTo = "MidBottom",
	--alignmentOffset = {0, 0},
	--scripts = {"TapHereAction"},
	zorder = 3,
	visible = false,
}

-- Resources for game piece views
--
-- Color names of HTML/X11 colors can be found at: http://en.wikipedia.org/wiki/Web_colors

--
-- Stock gem Resources
--

Resources.ClearPieceFlags = {
	isGem = false,
	isDiamond = false,
	isCrate = false,
	isBarrel = false,
	isBarrel2 = false,
	isMarsBarrel = false,
	isMarsBarrel2 = false,
	isSwitch = false,
	isDungeonSwitch = false,
	isEgyptSwitch = false,
	isWhimsySwitch = false,
	isGiftBox = false,
	isGiftBox2 = false,
	isGiftBox3 = false,
	isLocked = false,
	isStoneHit4 = false,
	isStoneHit3 = false,
	isStoneHit2 = false,
	isStoneHit1 = false,
	isMarsStoneHit4 = false,
	isMarsStoneHit3 = false,
	isMarsStoneHit2 = false,
	isMarsStoneHit1 = false,
	isKey = false,
	isChest = false,
	isMarsChest = false,
	isCoconut = false,
	isSuper = false,
	isVerticalSplash = false,
	isHorizontalSplash = false,
	isAreaSplash = false,
	isRealBarrel = false,
	isMaker = false,
	isLaser = false,
	isRedLaser = false,
	isBlueLaser = false,
	isGreenLaser = false,
	isYellowLaser = false,
	isPurpleLaser = false,
	isOrangeLaser = false,
	isWildLaser = false,
	isIce = false,
	isEmptyBalloon = false,
	isBalloons = false,
	isRedBalloon = false,
	isBlueBalloon = false,
	isGreenBalloon = false,
	isPurpleBalloon = false,
	isOrangeBalloon = false,
	isYellowBalloon = false,
	isRainbowBalloon = false,
	isGoldBar = false,
	isPickAxe = false,
	isBedRock = false,
	isMarkedGem = false,
	isSafe = false,
	isLastSafe = false,
	isInedible = false,
	isLink = false,
	isJailedLink = false,
	linkNumber = -1,
}

SkinVariantTable =
{
	["VineGrower"] = "VineGrowerGamePieceView",
	["MarsChest"] = "MarsChestGamePieceView",
	["MarsCrate"] = "MarsCrateGamePieceView",
	["MarsSteel"] = "MarsSteelGamePieceView",
	["DungeonSteel"] = "DungeonSteelGamePieceView",
	["EgyptSteel"] = "EgyptSteelGamePieceView",
	["Steel"] = "SteelGamePieceView",
	["Fence"] = "FenceGamePieceView",
	["IceMaker"] = "IceMakerGamePieceView",
	["Switch1_On"] = "SwitchOnGamePieceView",
	["Switch2_On"] = "SwitchOnGamePieceView",
	["Switch3_On"] = "SwitchOnGamePieceView",
	["Switch4_On"] = "SwitchOnGamePieceView",
	["Switch5_On"] = "SwitchOnGamePieceView",
	["DungeonSwitch_On"] = "DungeonSwitchOnGamePieceView",
    ["DungeonSwitchBlank_On"] = "DungeonSwitchBlankOnGamePieceView",
	["EgyptSwitch_On"] = "EgyptSwitchOnGamePieceView",
	["Switch1_Off"] = "SwitchOffGamePieceView",
	["Switch2_Off"] = "SwitchOffGamePieceView",
	["Switch3_Off"] = "SwitchOffGamePieceView",
	["Switch4_Off"] = "SwitchOffGamePieceView",
	["Switch5_Off"] = "SwitchOffGamePieceView",
	["DungeonSwitch_Off"] = "DungeonSwitchOffGamePieceView",
    ["DungeonSwitchBlank_Off"] = "DungeonSwitchBlankOffGamePieceView",
	["EgyptSwitch_Off"] = "EgyptSwitchOffGamePieceView",
	["Switch1_Toggle"] = "SwitchToggleGamePieceView",
	["Switch2_Toggle"] = "SwitchToggleGamePieceView",
	["Switch3_Toggle"] = "SwitchToggleGamePieceView",
	["Switch4_Toggle"] = "SwitchToggleGamePieceView",
	["Switch5_Toggle"] = "SwitchToggleGamePieceView",
	["DungeonSwitch_Toggle"] = "DungeonSwitchToggleGamePieceView",
    ["DungeonSwitchBlank_Toggle"] = "DungeonSwitchBlankToggleGamePieceView",
	["EgyptSwitch_Toggle"] = "EgyptSwitchToggleGamePieceView",
	["CommonPiece1"] = "Piece1View",
	["CommonPiece2"] = "Piece2View",
	["CommonPiece3"] = "Piece3View",
	["CommonPiece4"] = "Piece4View",
	["CommonPiece5"] = "Piece5View",
	["CommonPiece6"] = "Piece6View",
	["Link1"] = "Link1View",
	["Link2"] = "Link2View",
	["Link3"] = "Link3View",
	["Link4"] = "Link4View",
	["Link5"] = "Link5View",
	["Link6"] = "Link6View",
	["Link1_Special"] = "Link1View_Special",
	["Link2_Special"] = "Link2View_Special",
	["Link4_Special"] = "Link4View_Special",
	["Link1_Jailed"] = "Link1JailedView",
	["Link2_Jailed"] = "Link2JailedView",
	["Link3_Jailed"] = "Link3JailedView",
	["Link4_Jailed"] = "Link4JailedView",
	["Link5_Jailed"] = "Link5JailedView",
	["Link6_Jailed"] = "Link6JailedView",
	["Link1_Jailed_Special"] = "Link1JailedView_Special",
	["Link2_Jailed_Special"] = "Link2JailedView_Special",
	["Link4_Jailed_Special"] = "Link4JailedView_Special",
	["ColoredSwitch_1"] = "Piece1View_Switch",
	["ColoredSwitch_2"] = "Piece2View_Switch",
	["ColoredSwitch_3"] = "Piece3View_Switch",
	["ColoredSwitch_4"] = "Piece4View_Switch",
	["ColoredSwitch_5"] = "Piece5View_Switch",
	["ColoredSwitch_6"] = "Piece6View_Switch",
	["ColoredSwitch_Wild"] = "WildcardGamePieceView_Switch",
	["GoldBar1"] = "GoldBar1PieceView",
	["GoldBar2"] = "GoldBar2PieceView",
	["GoldBar3"] = "GoldBar3PieceView",
	["BedRock"] = "BedRock",
	["WhimsySteel"] = "WhimsySteelGamePieceView",
	["WhimsyMaker"] = "WhimsyMakerGamePieceView",
	["WhimsyFlippedMaker"] = "WhimsyFlippedMakerGamePieceView",
	["WhimsySwitch_On"] = "WhimsySwitchOnGamePieceView",
	["WhimsySwitch_Off"] = "WhimsySwitchOffGamePieceView",
	["WhimsySwitch1_On"] = "WhimsySwitchOnGamePieceView",
	["WhimsySwitch2_On"] = "WhimsySwitchOnGamePieceView",
	["WhimsySwitch3_On"] = "WhimsySwitchOnGamePieceView",
	["WhimsySwitch4_On"] = "WhimsySwitchOnGamePieceView",
	["WhimsySwitch5_On"] = "WhimsySwitchOnGamePieceView",
	["WhimsySwitch6_On"] = "WhimsySwitchOnGamePieceView",
	["WhimsySwitch1_Off"] = "WhimsySwitchOffGamePieceView",
	["WhimsySwitch2_Off"] = "WhimsySwitchOffGamePieceView",
	["WhimsySwitch3_Off"] = "WhimsySwitchOffGamePieceView",
	["WhimsySwitch4_Off"] = "WhimsySwitchOffGamePieceView",
	["WhimsySwitch5_Off"] = "WhimsySwitchOffGamePieceView",
	["WhimsySwitch6_Off"] = "WhimsySwitchOffGamePieceView",
	["WhimsySwitch_Toggle"] = "WhimsySwitchToggleGamePieceView",
	["WhimsySwitch1_Toggle"] = "WhimsySwitchToggleGamePieceView",
	["WhimsySwitch2_Toggle"] = "WhimsySwitchToggleGamePieceView",
	["WhimsySwitch3_Toggle"] = "WhimsySwitchToggleGamePieceView",
	["WhimsySwitch4_Toggle"] = "WhimsySwitchToggleGamePieceView",
	["WhimsySwitch5_Toggle"] = "WhimsySwitchToggleGamePieceView",
	["WhimsySwitch6_Toggle"] = "WhimsySwitchToggleGamePieceView",
}

Resources.DefaultDiamondGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "diamondSparkle1.png",
	matchColor = "#FFFFFF",		-- HTML/X11 'White'
	namePrefix = "Diamond_",
	isDiamond = true,
    
	--[[	-- The following animation looks bad, IMO, and needs work.  -- DavidL
	sparkleImage = "diamondSparkle1_2.png",
	scripts = {
		function (self)
			if not self.sparkleImage or self.sparkleImage == "" then
				return
			end

			while true do
				local delayMS = math.random(1000, 15000)
				ScriptDelay(delayMS)
				local oldImage = self.image
				self.image = self.sparkleImage
				ScriptDelay(100)
				self.image = oldImage
			end
		end,
	},
	--]]
}

Resources.DefaultKeyGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "key.png",
	matchColor = "#FFD700",		-- HTML/X11 'Gold'
	namePrefix = "Key_",
	isKey = true,
}

--
-- "Gems" piece image set
--

Resources.Gems_Piece1View = Resources.Actor:new {
	resource = "Actor",
	image = "GemBlue.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "Blue_",
	scaledFileName = "GemBlue_88.png",
	isGem = true,
}

Resources.Gems_Link1View = Resources.Actor:new {
	resource = "Actor",
	image = "LinkBlue.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "Blue_",
	isLink = true,
	linkNumber = 1,
}

Resources.Gems_Link1JailedView = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "Blue_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkBlue.png",
		zorder = -1,
	},
	linkNumber = 1,
}

Resources.Gems_Piece2View = Resources.Actor:new {
	resource = "Actor",
	image = "GemGreen.png",
	matchColor = "#00FF00",		-- HTML/X11 'Lime'
	namePrefix = "Green_",
	scaledFileName = "GemGreen_88.png",
	isGem = true,
}

Resources.Gems_Link2View = Resources.Actor:new {
	resource = "Actor",
	image = "LinkGreen.png",
	matchColor = "#00FF00",		-- HTML/X11 'Lime'
	namePrefix = "Green_",
	isLink = true,
	linkNumber = 2,
}

Resources.Gems_Link2JailedView = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	matchColor = "#00FF00",		-- HTML/X11 'Lime'
	namePrefix = "Green_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkGreen.png",
		zorder = -1,
	},
	linkNumber = 2,
}

Resources.Gems_Piece3View = Resources.Actor:new {
	resource = "Actor",
	image = "GemPurple.png",
	matchColor = "#FF00FF",		-- HTML/X11 'Magenta'
	namePrefix = "Purple_",
	scaledFileName = "GemPurple_88.png",
	isGem = true,
}

Resources.Gems_Link3View = Resources.Actor:new {
	resource = "Actor",
	image = "LinkPurple.png",
	matchColor = "#FF00FF",		-- HTML/X11 'Magenta'
	namePrefix = "Purple_",
	isLink = true,
	linkNumber = 3,
}

Resources.Gems_Link3JailedView = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	matchColor = "#FF00FF",		-- HTML/X11 'Magenta'
	namePrefix = "Purple_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkPurple.png",
		zorder = -1,
	},
	linkNumber = 3,
}

Resources.Gems_Piece4View = Resources.Actor:new {
	resource = "Actor",
	image = "GemRed.png",
	matchColor = "#FF5050",		-- an unnamed, reddish color
	namePrefix = "Red_",
	scaledFileName = "GemRed_88.png",
	isGem = true,
}

Resources.Gems_Link4View = Resources.Actor:new {
	resource = "Actor",
	image = "LinkRed.png",
	matchColor = "#FF5050",		-- an unnamed, reddish color
	namePrefix = "Red_",
	isLink = true,
	linkNumber = 4,
}

Resources.Gems_Link4JailedView = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	image = "LinkRed.png",
	matchColor = "#FF5050",		-- an unnamed, reddish color
	namePrefix = "Red_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkRed.png",
		zorder = -1,
	},
	linkNumber = 4,
}

Resources.Gems_Piece5View = Resources.Actor:new {
	resource = "Actor",
	image = "GemYellow.png",
	matchColor = "#FFFF00",		-- HTML/X11 'Yellow'
	namePrefix = "Yellow_",
	scaledFileName = "GemYellow_88.png",
	isGem = true,
}

Resources.Gems_Link5View = Resources.Actor:new {
	resource = "Actor",
	image = "LinkYellow.png",
	matchColor = "#FFFF00",		-- HTML/X11 'Yellow'
	namePrefix = "Yellow_",
	isLink = true,
	linkNumber = 5,
}

Resources.Gems_Link5JailedView = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	matchColor = "#FFFF00",		-- HTML/X11 'Yellow'
	namePrefix = "Yellow_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkYellow.png",
		zorder = -1,
	},
	linkNumber = 5,
}

Resources.Gems_Piece6View = Resources.Actor:new {
	resource = "Actor",
	image = "GemOrange.png",
	matchColor = "#FFD700",		-- HTML/X11 'Gold'
	namePrefix = "Orange_",
	scaledFileName = "GemOrange_88.png",
	isGem = true,
}

Resources.Gems_Link6View = Resources.Actor:new {
	resource = "Actor",
	image = "LinkOrange.png",
	matchColor = "#FFD700",		-- HTML/X11 'Gold'
	namePrefix = "Orange_",
	isLink = true,
	linkNumber = 6,
}

Resources.Gems_Link6JailedView = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	matchColor = "#FFD700",		-- HTML/X11 'Gold'
	namePrefix = "Orange_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkOrange.png",
		zorder = -1,
	},
	linkNumber = 6,
}

--Special Gems resources

Resources.Gems_SpecialRed = Resources.Actor:new {
	resource = "Actor",
	image = "GemSpecialRed.png",
	matchColor = "Red",
	namePrefix = "SpecialRed_",
	isSpecial = true,
	specialType = "SpecialRed",
	scaledFileName = "GemSpecialRed_88.png",
}

Resources.Gems_SpecialGreen = Resources.Actor:new {
	resource = "Actor",
	image = "GemSpecialGreen.png",
	matchColor = "Green",
	namePrefix = "SpecialGreen_",
	isSpecial = true,
	specialType = "SpecialGreen",
	scaledFileName = "GemSpecialGreen_88.png",
}

Resources.Gems_SpecialBlue = Resources.Actor:new {
	resource = "Actor",
	image = "GemSpecialBlue.png",
	matchColor = "Blue",
	namePrefix = "SpecialBlue_",
	isSpecial = true,
	specialType = "SpecialBlue",
	scaledFileName = "GemSpecialBlue_88.png",
}

Resources.Gems_Link1View_Special = Resources.Actor:new {
	resource = "Actor",
	image = "LinkBlue.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "Blue_",
	isLink = true,
	linkNumber = 1,
	specialType = "SpecialBlue",
}

Resources.Gems_Link1JailedView_Special = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "Blue_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkBlue.png",
		zorder = -1,
	},
	linkNumber = 1,
	specialType = "SpecialBlue",
}

Resources.Gems_Link2View_Special = Resources.Actor:new {
	resource = "Actor",
	image = "LinkGreen.png",
	matchColor = "Green",
	namePrefix = "Green_",
	isLink = true,
	linkNumber = 2,
	specialType = "SpecialGreen",
}

Resources.Gems_Link2JailedView_Special = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	matchColor = "Green",
	namePrefix = "Green_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkGreen.png",
		zorder = -1,
	},
	linkNumber = 2,
	specialType = "SpecialGreen",
}

Resources.Gems_Link4View_Special = Resources.Actor:new {
	resource = "Actor",
	image = "LinkRed.png",
	matchColor = "Red",
	namePrefix = "Red_",
	isLink = true,
	linkNumber = 4,
	specialType = "SpecialRed",
}

Resources.Gems_Link4JailedView_Special = Resources.Actor:new {
	resource = "Actor",
	image = "Jail.png",
	matchColor = "Red",
	namePrefix = "Red_",
	isJailedLink = true,
	LinkInJail = {
		class = "Actor",
		image = "LinkRed.png",
		zorder = -1,
	},
	linkNumber = 4,
	specialType = "SpecialRed",
}


--Obstacle resources

Resources.Gems_CrateGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Crate.png",
	matchColor = "Brown",
	namePrefix = "Crate_",
	isCrate = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MarsCrateGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "CrateD_25.png",
	matchColor = "Brown",
	namePrefix = "Crate_",
	isCrate = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MakerGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Maker.png",
	matchColor = "Brown",
	namePrefix = "Maker_",
	isMaker = true,
	scaledFileName = "EMPTY",
	zorder = 10,
}

Resources.Gems_WhimsyMakerGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Maker_Whimsy.png",
	matchColor = "Brown",
	namePrefix = "Maker_",
	isMaker = true,
	scaledFileName = "EMPTY",
	zorder = 10,
}

Resources.Icon_Lock = {
	class = "Actor",
	image = "FeatureLock.png",
	size = {30,30},
	alignment = Center,
}

Resources.Icon_Maker_On = {
	class = "Actor",
	image = "Icon_On.png",
	alignment = Center,
}

Resources.Icon_Maker_Off = {
	class = "Actor",
	image = "Icon_Off.png",
	alignment = Center,
}

Resources.Icon_Switch_On = {
	class = "Actor",
	image = "Switch_On.png",
	size = {25,25},
	alignment = Center,
}

Resources.Icon_Switch_Off = {
	class = "Actor",
	image = "Switch_Off.png",
	size = {25,25},
	alignment = Center,
}

Resources.Icon_Blank1 = {
	class = "Actor",
	visible = false,
}

Resources.Icon_Blank2 = {
	class = "Actor",
	visible = false,
}

Resources.Icon_Blank3 = {
	class = "Actor",
	visible = false,
}

Resources.Icon_QuestionMark = {
	class = "Actor",
	image = "",
	alignment = Center,
	QuestionMarkLabel = Resources.Label:new {
		resource = "Label",
		text = "?",
		font = Resources.AppGameFont:new{
			resource = "AppGameFont",
			fontSize = 25,
		},
		fgColor = "Black",
		highlightColor = "White",
		shadowColor = "White",
		alignment = Center,
	},
}

Resources.Icon_Marked = {
	class = "Actor",
    image = "Ring.png",
    name = "Icon_Marked",
	alignment = Center,
	zorder = 3,
	autoFillParent = true,
    IconDecoration = Resources.IconDecoration,
}

Resources.Icon_GemBlue = {
	class = "Actor",
	image = "GemBlue.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_GemGreen = {
	class = "Actor",
	image = "GemGreen.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_GemPurple = {
	class = "Actor",
	image = "GemPurple.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_GemRed = {
	class = "Actor",
	image = "GemRed.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_GemYellow = {
	class = "Actor",
	image = "GemYellow.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_GemOrange = {
	class = "Actor",
	image = "GemOrange.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_GemWild = {
	class = "Actor",
	image = "Wildgem.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_SpecialGemBlue = {
	class = "Actor",
	image = "GemSpecialBlue.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_SpecialGemGreen = {
	class = "Actor",
	image = "GemSpecialGreen.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_SpecialGemRed = {
	class = "Actor",
	image = "GemSpecialRed.png",
	alignment = Center,
	size = {20,20},
	alpha = 150,
}

Resources.Icon_GemBlue_Bright = {
    class = "Actor",
    image = "GemBlue.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_GemGreen_Bright = {
    class = "Actor",
    image = "GemGreen.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_GemPurple_Bright = {
    class = "Actor",
    image = "GemPurple.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_GemRed_Bright = {
    class = "Actor",
    image = "GemRed.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_GemYellow_Bright = {
    class = "Actor",
    image = "GemYellow.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_GemOrange_Bright = {
    class = "Actor",
    image = "GemOrange.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_GemWild_Bright = {
    class = "Actor",
    image = "Wildgem.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_SpecialBlue_Bright = {
    class = "Actor",
    image = "GemSpecialBlue.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_SpecialGreen_Bright = {
    class = "Actor",
    image = "GemSpecialGreen.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_SpecialRed_Bright = {
    class = "Actor",
    image = "GemSpecialRed.png",
    alignment = Center,
    size = {20,20},
}

Resources.Icon_GemBlueSwitch = {
    class = "Actor",
    image = "GemBlue.png",
    size = {25,25},
    alpha = 255,

    alignment = Center,
    alignTo = Center,
    scalingPoint = Center,
    alignmentOffset = {0,-2},
}

Resources.Icon_GemGreenSwitch = {
    class = "Actor",
    image = "GemGreen.png",
    size = {25,25},
    alpha = 255,

    alignment = Center,
    alignTo = Center,
    scalingPoint = Center,
    alignmentOffset = {0,-3},
}

Resources.Icon_GemPurpleSwitch = {
    class = "Actor",
    image = "GemPurple.png",
    size = {25,25},
    alpha = 255,

    alignment = Center,
    alignTo = Center,
    scalingPoint = Center,
    alignmentOffset = {0,-2},
}

Resources.Icon_GemRedSwitch = {
    class = "Actor",
    image = "GemRed.png",
    size = {25,25},
    alpha = 255,

    alignment = Center,
    alignTo = Center,
    scalingPoint = Center,
    alignmentOffset = {0,-3},
}

Resources.Icon_SwitchBlueGreen = {
    class = "Actor",
    children = {
        Resources.Actor:new {
            class = "Actor",
            image = "GemBlue.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,-15},
        },
        Resources.Actor:new {
            class = "Actor",
            image = "GemGreen.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,0},
        },
    },
    alignment = Center,
}

Resources.Icon_SwitchGreenPurple = {
    class = "Actor",
    children = {
        Resources.Actor:new {
            class = "Actor",
            image = "GemGreen.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,-15},
        },
        Resources.Actor:new {
            class = "Actor",
            image = "GemPurple.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,0},
        },
    },
    alignment = Center,
}

Resources.Icon_SwitchPurpleRed = {
    class = "Actor",
    children = {
        Resources.Actor:new {
            class = "Actor",
            image = "GemPurple.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,-15},
        },
        Resources.Actor:new {
            class = "Actor",
            image = "GemRed.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,0},
        },
    },
    alignment = Center,
}

Resources.Icon_SwitchRedBlue = {
    class = "Actor",
    children = {
        Resources.Actor:new {
            class = "Actor",
            image = "GemRed.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,-15},
        },
        Resources.Actor:new {
            class = "Actor",
            image = "GemBlue.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,0},
        },
    },
    alignment = Center,
}

Resources.Icon_SwitchYellowBlue = {
    class = "Actor",
    children = {
        Resources.Actor:new {
            class = "Actor",
            image = "GemYellow.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,-15},
        },
        Resources.Actor:new {
            class = "Actor",
            image = "GemBlue.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,0},
        },
    },
    alignment = Center,
}

Resources.Icon_SwitchYellowGreen = {
    class = "Actor",
    children = {
        Resources.Actor:new {
            class = "Actor",
            image = "GemYellow.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,-15},
        },
        Resources.Actor:new {
            class = "Actor",
            image = "GemGreen.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,0},
        },
    },
    alignment = Center,
}

Resources.Icon_SwitchYellowPurple = {
    class = "Actor",
    children = {
        Resources.Actor:new {
            class = "Actor",
            image = "GemYellow.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,-15},
        },
        Resources.Actor:new {
            class = "Actor",
            image = "GemPurple.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,0},
        },
    },
    alignment = Center,
}

Resources.Icon_SwitchYellowRed = {
    class = "Actor",
    children = {
        Resources.Actor:new {
            class = "Actor",
            image = "GemYellow.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,-15},
        },
        Resources.Actor:new {
            class = "Actor",
            image = "GemRed.png",
            size = {18,18},
            alpha = 255,
            alignment = "Center",
            alignmentOffset = {0,0},
        },
    },
    alignment = Center,
}


-- An 'aura' for icons
Resources.IconDecoration = Resources.Actor:new {
	resource = "Actor",
	image = "DiamondAura.png",
	alignment = "Center",
    alpha = 100,
	zorder = -1,
	scripts = {
		function (self)
			local revolutionsPerSecond = 0.04
			RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
		end,
	},
}

Resources.Icon_Key = {
	class = "Actor",
	image = "key.png",
	alignment = Center,
	size = {25,25},
}

Resources.Icon_PickAxe = {
	class = "Actor",
	image = "Icon_PickAxe.png",
	alignment = Center,
	size = {30,30},
	IconDecoration = Resources.IconDecoration,
}

Resources.Gems_FlippedMakerGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Maker.png",
	matchColor = "Brown",
	namePrefix = "Maker_",
	isMaker = true,
	scaledFileName = "EMPTY",
	zorder = 10,
	rotationAngle = {degrees = 180},
}

Resources.Gems_WhimsyFlippedMakerGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Maker_Whimsy.png",
	matchColor = "Brown",
	namePrefix = "Maker_",
	isMaker = true,
	scaledFileName = "EMPTY",
	zorder = 10,
	rotationAngle = {degrees = 180},
}

Resources.Gems_SwitchableMakerGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Maker.png",
	matchColor = "Brown",
	namePrefix = "Maker_",
	isMaker = true,
	isRealBarrel = true,
	scaledFileName = "EMPTY",
	zorder = 10,
}

Resources.Gems_BarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Boulder.png",
	matchColor = "Brown",
	namePrefix = "Barrel_",
	isBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_BarrelHit2_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Boulder2.png",
	matchColor = "Brown",
	namePrefix = "BarrelHit2_",
	isBarrel2 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MarsBoulderGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Boulder_band_removed_25.png",
	matchColor = "Brown",
	namePrefix = "Barrel_",
	isMarsBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MarsBoulderHit2_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Boulder2_25_red.png",
	matchColor = "Brown",
	namePrefix = "BarrelHit2_",
	isMarsBarrel2 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_RealBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Barrel.png",
	matchColor = "Brown",
	namePrefix = "RealBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_DoubleRealBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "BarrelChained.png",
	matchColor = "Brown",
	namePrefix = "RealBarrel2_",
	isRealBarrel2 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_BlueBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "BlueBarrel.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "BlueBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_GreenBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "GreenBarrel.png",
	matchColor = "#00FF00",		-- HTML/X11 'Lime'
	namePrefix = "GreenBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_PurpleBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "PurpleBarrel.png",
	matchColor = "#FF00FF",		-- HTML/X11 'Magenta'
	namePrefix = "PurpleBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_RedBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "RedBarrel.png",
	matchColor = "#FF5050",		-- an unnamed, reddish color
	namePrefix = "RedBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_SpecialRedBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "BarrelSpecialGem_red.png",
	matchColor = "Red",
	namePrefix = "SpecialRedBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
	specialType = "SpecialRed",
}

Resources.Gems_SpecialGreenBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "BarrelSpecialGem_green.png",
	matchColor = "Green",
	namePrefix = "SpecialGreenBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
	specialType = "SpecialGreen",
}

Resources.Gems_SpecialBlueBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "BarrelSpecialGem_blue.png",
	matchColor = "Blue",
	namePrefix = "SpecialBlueBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
	specialType = "SpecialBlue",
}

Resources.Gems_YellowBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "YellowBarrel.png",
	matchColor = "#FFFF00",		-- HTML/X11 'Yellow'
	namePrefix = "YellowBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_OrangeBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "OrangeBarrel.png",
	matchColor = "#FFD700",		-- HTML/X11 'Gold'
	namePrefix = "OrangeBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_WildBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "WildBarrel.png",
	matchColor = "White",
	namePrefix = "WildBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_SuperWildBarrelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "SuperWildBarrel.png",
	matchColor = "White",
	namePrefix = "SuperWildBarrel_",
	isRealBarrel = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_GiftBoxGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "giftbox_click2.png",
	matchColor = "Brown",
	namePrefix = "GiftBox_",
	scaledFileName = "EMPTY",
	isGiftBox = true,
    giftBoxImageCache1 = {
        class = "Actor",
        image = "giftbox_leftside.png",
        alpha = 0,
    },
    giftBoxImageCache2 = {
        class = "Actor",
        image = "giftbox_rightside.png",
        alpha = 0,
    },
    giftBoxImageCache3 = {
        class = "Actor",
        image = "giftbox_front.png",
        alpha = 0,
    },
    giftBoxImageCache4 = {
        class = "Actor",
        image = "giftbox_lid.png",
        alpha = 0,
    },
}

Resources.Gems_BoomerangGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Boomerang.png",
	matchColor = "Brown",
	namePrefix = "GiftBox_",
	scaledFileName = "EMPTY",
	isBoomerang = true,
}

Resources.Gems_GiftBox2GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "giftbox_click1.png",
	matchColor = "Brown",
	namePrefix = "GiftBox_",
	scaledFileName = "EMPTY",
    isGiftBox2 = true,
    giftBoxImageCache1 = {
        class = "Actor",
        image = "giftbox_leftside.png",
        alpha = 0,
    },
    giftBoxImageCache2 = {
        class = "Actor",
        image = "giftbox_rightside.png",
        alpha = 0,
    },
    giftBoxImageCache3 = {
        class = "Actor",
        image = "giftbox_front.png",
        alpha = 0,
    },
    giftBoxImageCache4 = {
        class = "Actor",
        image = "giftbox_lid.png",
        alpha = 0,
    },
}

Resources.Gems_GiftBox3GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "giftbox_start.png",
	matchColor = "Brown",
	namePrefix = "GiftBox_",
	scaledFileName = "EMPTY",
    isGiftBox3 = true,
    giftBoxImageCache1 = {
        class = "Actor",
        image = "giftbox_leftside.png",
        alpha = 0,
    },
    giftBoxImageCache2 = {
        class = "Actor",
        image = "giftbox_rightside.png",
        alpha = 0,
    },
    giftBoxImageCache3 = {
        class = "Actor",
        image = "giftbox_front.png",
        alpha = 0,
    },
    giftBoxImageCache4 = {
        class = "Actor",
        image = "giftbox_lid.png",
        alpha = 0,
    },
}

Resources.Gems_SwitchOnGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_On.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isOn = true,
}

Resources.Gems_DungeonSwitchOnGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Dungeon_On.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isDungeonSwitch = true,
	isOn = true,
}

Resources.Gems_DungeonSwitchBlankOnGamePieceView = Resources.Actor:new {
    resource = "Actor",
    image = "Switch_Blank_Dungeon_On.png",
    matchColor = "Brown",
    namePrefix = "Switch_",
    scaledFileName = "EMPTY",
    isSwitch = true,
    isDungeonSwitch = true,
    isOn = true,
}

Resources.Gems_EgyptSwitchOnGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Egypt_On.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isEgyptSwitch = true,
	isOn = true,
}

Resources.Gems_WhimsySwitchOnGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Whimsy_On.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isWhimsySwitch = true,
	isOn = true,
}

Resources.Gems_SwitchOffGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Off.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isOn = false,
}

Resources.Gems_DungeonSwitchOffGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Dungeon_Off.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isDungeonSwitch = true,
	isOn = false,
}

Resources.Gems_DungeonSwitchBlankOffGamePieceView = Resources.Actor:new {
    resource = "Actor",
    image = "Switch_Blank_Dungeon_Off.png",
    matchColor = "Brown",
    namePrefix = "Switch_",
    scaledFileName = "EMPTY",
    isSwitch = true,
    isDungeonSwitch = true,
    isOn = false,
}

Resources.Gems_EgyptSwitchOffGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Egypt_Off.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isEgyptSwitch = true,
	isOn = false,
}

Resources.Gems_WhimsySwitchOffGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Whimsy_Off.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isWhimsySwitch = true,
	isOn = false,
}

Resources.Gems_SwitchToggleGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Off.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isOn = false,
	isToggle = true,
}

Resources.Gems_DungeonSwitchToggleGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Dungeon_Off.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isDungeonSwitch = true,
	isOn = false,
	isToggle = true,
}

Resources.Gems_DungeonSwitchBlankToggleGamePieceView = Resources.Actor:new {
    resource = "Actor",
    image = "Switch_Blank_Dungeon_Off.png",
    matchColor = "Brown",
    namePrefix = "Switch_",
    scaledFileName = "EMPTY",
    isSwitch = true,
    isDungeonSwitch = true,
    isOn = false,
    isToggle = true,
}

Resources.Gems_EgyptSwitchToggleGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Egypt_Off.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isEgyptSwitch = true,
	isOn = false,
	isToggle = true,
}

Resources.Gems_WhimsySwitchToggleGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Switch_Whimsy_Off.png",
	matchColor = "Brown",
	namePrefix = "Switch_",
	scaledFileName = "EMPTY",
	isSwitch = true,
	isWhimsySwitch = true,
	isOn = false,
	isToggle = true,
}

Resources.Gems_StoneHit1_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit1.png",
	matchColor = "Gray",
	namePrefix = "StoneHit1_",
	isStoneHit1 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_StoneHit2_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit2.png",
	matchColor = "Gray",
	namePrefix = "StoneHit2_",
	isStoneHit2 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_StoneHit3_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit3.png",
	matchColor = "Gray",
	namePrefix = "StoneHit3_",
	isStoneHit3 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_StoneHit4_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit4.png",
	matchColor = "Gray",
	namePrefix = "StoneHit4_",
	isStoneHit4 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MarsStoneHit1_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit1_25.png",
	matchColor = "Gray",
	namePrefix = "StoneHit1_",
	isMarsStoneHit1 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MarsStoneHit2_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit2_25.png",
	matchColor = "Gray",
	namePrefix = "StoneHit2_",
	isMarsStoneHit2 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MarsStoneHit3_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit3_25.png",
	matchColor = "Gray",
	namePrefix = "StoneHit3_",
	isMarsStoneHit3 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MarsStoneHit4_GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit4_25.png",
	matchColor = "Gray",
	namePrefix = "StoneHit4_",
	isMarsStoneHit4 = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_LockGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Lock_chest_target2.png",
	matchColor = "Gray",
	namePrefix = "Lock_",
	scaledFileName = "EMPTY",
}

Resources.Gems_LockedGift1GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LockedGift1.png",
	matchColor = "Gray",
	namePrefix = "Lock_",
	scaledFileName = "EMPTY",
	isGiftBox = true,
	isLocked = true,
}

Resources.Gems_LockedGift2GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LockedGift2.png",
	matchColor = "Gray",
	namePrefix = "Lock_",
	scaledFileName = "EMPTY",
	isGiftBox2 = true,
	isLocked = true,
}

Resources.Gems_LockedGift3GamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LockedGift3.png",
	matchColor = "Gray",
	namePrefix = "Lock_",
	scaledFileName = "EMPTY",
	isGiftBox3 = true,
	isLocked = true,
}

Resources.Gems_SteelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Steel.png",
	matchColor = "Gray",
	namePrefix = "Steel_",
	scaledFileName = "EMPTY",
}

Resources.Gems_SteelBoulderGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "SteelBoulder.png",
	matchColor = "Gray",
	namePrefix = "Steel_",
	scaledFileName = "EMPTY",
}

Resources.Gems_SafeGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Safe_Background.png",
	matchColor = "Gray",
	namePrefix = "Steel_",
	scaledFileName = "EMPTY",
	isSafe = true,
	isLastSafe = false,

	Dial = Resources.Actor:new {
		resource = "Actor",
		image = "Safe_Dial.png",
		autoFillParent = true,
        zorder = 1,
	},

    GemHolder = Resources.Actor:new {
        resource = "Actor",
        zorder = 2,
        autoFillParent = true,
        alignmentOffset = {5,5},
    },
}

Resources.Gems_GoldBar1PieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Gold_1bar.png",
	matchColor = "Yellow",
	namePrefix = "Gold_",
	scaledFileName = "EMPTY",
	size = {75,48},
	isGoldBar = true,
}

Resources.Gems_GoldBar2PieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Gold_2bars.png",
	matchColor = "Yellow",
	namePrefix = "Gold_",
	scaledFileName = "EMPTY",
	size = {75,48},
	isGoldBar = true,
}

Resources.Gems_GoldBar3PieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Gold_3bars.png",
	matchColor = "Yellow",
	namePrefix = "Gold_",
	scaledFileName = "EMPTY",
	size = {75,48},
	isGoldBar = true,
}

Resources.Gems_MarsSteelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "SteelPlate_25.png",
	matchColor = "Gray",
	namePrefix = "Steel_",
	scaledFileName = "EMPTY",
}

Resources.Gems_DungeonSteelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Steel_Dungeon.png",
	matchColor = "Gray",
	namePrefix = "Steel_",
	scaledFileName = "EMPTY",
}

Resources.Gems_EgyptSteelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Steel_Egypt.png",
	matchColor = "Gray",
	namePrefix = "Steel_",
	scaledFileName = "EMPTY",
}

Resources.Gems_WhimsySteelGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Steel_Whimsy.png",
	matchColor = "Gray",
	namePrefix = "Steel_",
	scaledFileName = "EMPTY",
}

Resources.Gems_BedRock = Resources.Actor:new {
	resource = "Actor",
	image = "BedRock.png",
	matchColor = "Gray",
	namePrefix = "Steel_",
	scaledFileName = "EMPTY",
	isBedRock = true,
}

Resources.Gems_RedLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_red.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
}

Resources.Gems_BlueLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_blue.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
}

Resources.Gems_OrangeLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_orange.png",
	matchColor = "Orange",
	namePrefix = "OrangeLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isOrangeLaser = true,
}

Resources.Gems_GreenLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_green.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
}

Resources.Gems_YellowLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_yellow.png",
	matchColor = "Yellow",
	namePrefix = "YellowLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isYellowLaser = true,
}

Resources.Gems_PurpleLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_purple.png",
	matchColor = "Purple",
	namePrefix = "PurpleLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isPurpleLaser = true,
}

Resources.Gems_WildLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_wild.png",
	matchColor = "White",
	namePrefix = "WildLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isWildLaser = true,
}

Resources.Gems_SpecialRedLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialred.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
	specialType = "SpecialRed",
}

Resources.Gems_SpecialBlueLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialblue.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
	specialType = "SpecialBlue",
}

Resources.Gems_SpecialGreenLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialgreen.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
	specialType = "SpecialGreen",
}

Resources.Gems_RedLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_red.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
}

Resources.Gems_BlueLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_blue.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
}

Resources.Gems_OrangeLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_orange.png",
	matchColor = "Orange",
	namePrefix = "OrangeLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isOrangeLaser = true,
}

Resources.Gems_GreenLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_green.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
}

Resources.Gems_YellowLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_yellow.png",
	matchColor = "Yellow",
	namePrefix = "YellowLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isYellowLaser = true,
}

Resources.Gems_PurpleLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_purple.png",
	matchColor = "Purple",
	namePrefix = "PurpleLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isPurpleLaser = true,
}

Resources.Gems_WildLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_wild.png",
	matchColor = "White",
	namePrefix = "WildLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isWildLaser = true,
}

Resources.Gems_SpecialRedLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialred.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
	specialType = "SpecialRed",
}

Resources.Gems_SpecialBlueLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialblue.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
	specialType = "SpecialBlue",
}

Resources.Gems_SpecialGreenLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialgreen.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
	specialType = "SpecialGreen",
}

Resources.Gems_RustRedLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_red_Rusty.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
}

Resources.Gems_RustBlueLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_blue_Rusty.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
}

Resources.Gems_RustOrangeLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_orange_Rusty.png",
	matchColor = "Orange",
	namePrefix = "OrangeLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isOrangeLaser = true,
}

Resources.Gems_RustGreenLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_green_Rusty.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
}

Resources.Gems_RustYellowLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_yellow_Rusty.png",
	matchColor = "Yellow",
	namePrefix = "YellowLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isYellowLaser = true,
}

Resources.Gems_RustPurpleLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_purple_Rusty.png",
	matchColor = "Purple",
	namePrefix = "PurpleLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isPurpleLaser = true,
}

Resources.Gems_RustWildLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_wild_Rusty.png",
	matchColor = "White",
	namePrefix = "WildLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isWildLaser = true,
}

Resources.Gems_RustSpecialRedLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialred_Rusty.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
	specialType = "SpecialRed",
}

Resources.Gems_RustSpecialBlueLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialblue_Rusty.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
	specialType = "SpecialBlue",
}

Resources.Gems_RustSpecialGreenLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialgreen_Rusty.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
	specialType = "SpecialGreen",
}

Resources.Gems_RustRedLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_red_Rusty.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
}

Resources.Gems_RustBlueLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_blue_Rusty.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
}

Resources.Gems_RustOrangeLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_orange_Rusty.png",
	matchColor = "Orange",
	namePrefix = "OrangeLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isOrangeLaser = true,
}

Resources.Gems_RustGreenLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_green_Rusty.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
}

Resources.Gems_RustYellowLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_yellow_Rusty.png",
	matchColor = "Yellow",
	namePrefix = "YellowLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isYellowLaser = true,
}

Resources.Gems_RustPurpleLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_purple_Rusty.png",
	matchColor = "Purple",
	namePrefix = "PurpleLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isPurpleLaser = true,
}

Resources.Gems_RustWildLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_wild_Rusty.png",
	matchColor = "White",
	namePrefix = "WildLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isWildLaser = true,
}

Resources.Gems_RustSpecialRedLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialred_Rusty.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
	specialType = "SpecialRed",
}

Resources.Gems_RustSpecialBlueLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialblue_Rusty.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
	specialType = "SpecialBlue",
}

Resources.Gems_RustSpecialGreenLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialgreen_Rusty.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
	specialType = "SpecialGreen",
}

Resources.Gems_DungeonRedLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_red_Dungeon.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
}

Resources.Gems_DungeonBlueLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_blue_Dungeon.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
}

Resources.Gems_DungeonOrangeLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_orange_Dungeon.png",
	matchColor = "Orange",
	namePrefix = "OrangeLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isOrangeLaser = true,
}

Resources.Gems_DungeonGreenLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_green_Dungeon.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
}

Resources.Gems_DungeonYellowLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_yellow_Dungeon.png",
	matchColor = "Yellow",
	namePrefix = "YellowLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isYellowLaser = true,
}

Resources.Gems_DungeonPurpleLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_purple_Dungeon.png",
	matchColor = "Purple",
	namePrefix = "PurpleLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isPurpleLaser = true,
}

Resources.Gems_DungeonWildLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_wild_Dungeon.png",
	matchColor = "White",
	namePrefix = "WildLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isWildLaser = true,
}

Resources.Gems_DungeonSpecialRedLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialred_Dungeon.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
	specialType = "SpecialRed",
}

Resources.Gems_DungeonSpecialBlueLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialblue_Dungeon.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
	specialType = "SpecialBlue",
}

Resources.Gems_DungeonSpecialGreenLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialgreen_Dungeon.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
	specialType = "SpecialGreen",
}

Resources.Gems_DungeonRedLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_red_Dungeon.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
}

Resources.Gems_DungeonBlueLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_blue_Dungeon.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
}

Resources.Gems_DungeonOrangeLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_orange_Dungeon.png",
	matchColor = "Orange",
	namePrefix = "OrangeLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isOrangeLaser = true,
}

Resources.Gems_DungeonGreenLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_green_Dungeon.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
}

Resources.Gems_DungeonYellowLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_yellow_Dungeon.png",
	matchColor = "Yellow",
	namePrefix = "YellowLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isYellowLaser = true,
}

Resources.Gems_DungeonPurpleLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_purple_Dungeon.png",
	matchColor = "Purple",
	namePrefix = "PurpleLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isPurpleLaser = true,
}

Resources.Gems_DungeonWildLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_wild_Dungeon.png",
	matchColor = "White",
	namePrefix = "WildLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isWildLaser = true,
}

Resources.Gems_DungeonSpecialRedLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialred_Dungeon.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
	specialType = "SpecialRed",
}

Resources.Gems_DungeonSpecialBlueLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialblue_Dungeon.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
	specialType = "SpecialBlue",
}

Resources.Gems_DungeonSpecialGreenLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialgreen_Dungeon.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
	specialType = "SpecialGreen",
}
Resources.Gems_WhimsyRedLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_red_Whimsy.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
}

Resources.Gems_WhimsyBlueLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_blue_Whimsy.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
}

Resources.Gems_WhimsyOrangeLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_orange_Whimsy.png",
	matchColor = "Orange",
	namePrefix = "OrangeLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isOrangeLaser = true,
}

Resources.Gems_WhimsyGreenLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_green_Whimsy.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
}

Resources.Gems_WhimsyYellowLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_yellow_Whimsy.png",
	matchColor = "Yellow",
	namePrefix = "YellowLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isYellowLaser = true,
}

Resources.Gems_WhimsyPurpleLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_purple_Whimsy.png",
	matchColor = "Purple",
	namePrefix = "PurpleLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isPurpleLaser = true,
}

Resources.Gems_WhimsyWildLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_wild_Whimsy.png",
	matchColor = "White",
	namePrefix = "WildLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isWildLaser = true,
}

Resources.Gems_WhimsySpecialRedLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialred_Whimsy.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
	specialType = "SpecialRed",
}

Resources.Gems_WhimsySpecialBlueLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialblue_Whimsy.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
	specialType = "SpecialBlue",
}

Resources.Gems_WhimsySpecialGreenLaserHGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Laser_specialgreen_Whimsy.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
	specialType = "SpecialGreen",
}

Resources.Gems_WhimsyRedLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_red_Whimsy.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
}

Resources.Gems_WhimsyBlueLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_blue_Whimsy.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
}

Resources.Gems_WhimsyOrangeLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_orange_Whimsy.png",
	matchColor = "Orange",
	namePrefix = "OrangeLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isOrangeLaser = true,
}

Resources.Gems_WhimsyGreenLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_green_Whimsy.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
}

Resources.Gems_WhimsyYellowLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_yellow_Whimsy.png",
	matchColor = "Yellow",
	namePrefix = "YellowLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isYellowLaser = true,
}

Resources.Gems_WhimsyPurpleLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_purple_Whimsy.png",
	matchColor = "Purple",
	namePrefix = "PurpleLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isPurpleLaser = true,
}

Resources.Gems_WhimsyWildLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_wild_Whimsy.png",
	matchColor = "White",
	namePrefix = "WildLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isWildLaser = true,
}

Resources.Gems_WhimsySpecialRedLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialred_Whimsy.png",
	matchColor = "Red",
	namePrefix = "RedLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isRedLaser = true,
	specialType = "SpecialRed",
}

Resources.Gems_WhimsySpecialBlueLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialblue_Whimsy.png",
	matchColor = "Blue",
	namePrefix = "BlueLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isBlueLaser = true,
	specialType = "SpecialBlue",
}

Resources.Gems_WhimsySpecialGreenLaserVGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "LaserV_specialgreen_Whimsy.png",
	matchColor = "Green",
	namePrefix = "GreenLaser_",
	scaledFileName = "EMPTY",
	isLaser = true,
	isGreenLaser = true,
	specialType = "SpecialGreen",
}

Resources.Gems_FenceGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Fence.png",
	matchColor = "Gray",
	namePrefix = "Fence_",
	scaledFileName = "EMPTY",
}

Resources.Gems_VineGrowerGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Vines_Spawner.png",
	matchColor = "Gray",
	namePrefix = "VineGen_",
	scaledFileName = "EMPTY",
}

Resources.Gems_GoldGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Gold.png",
	matchColor = "Gray",
	namePrefix = "Gold_",
	scaledFileName = "EMPTY",
}

Resources.Gems_LavaGamePieceView = Resources.Actor:new {
	resource = "Actor",
	name = "LavaSquare",
	image = "Lava.png",
	matchColor = "Gray",
	namePrefix = "Lava_",
	isLava = true,
	scaledFileName = "EMPTY",
	size = {49,49},
	Glow = Resources.Actor:new {
		resource="Actor",
		autoFillParent = true,
		image = "Lava_glow.png",
		visible = false,
	},
}

Resources.Gems_ChestGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Chest.png",
	matchColor = "White",
	namePrefix = "Chest_",
	isChest = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_MarsChestGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Chest_25.png",
	matchColor = "White",
	namePrefix = "Chest_",
	isMarsChest = true,
	scaledFileName = "EMPTY",
}

Resources.Gems_CoconutGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Coconut_1.png",
	matchColor = "White",
	namePrefix = "Coconut_",
	scaledFileName = "EMPTY",
	isCoconut = true,
}

Resources.Gems_StoneGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit2.png",
	matchColor = "White",
	namePrefix = "Stone_",
	scaledFileName = "EMPTY",
}

Resources.Gems_WildcardGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Wildgem.png",
	matchColor = "White",
	namePrefix = "Wildcard_",
	scaledFileName = "EMPTY",
	--scripts = { "WildGemImageCycle" },
}

Resources.Gems_WildcardGamePieceView_Switch = Resources.Actor:new {
	resource = "Actor",
	image = "Wildgem.png",
	matchColor = "White",
	namePrefix = "Wildcard_",
	scaledFileName = "EMPTY",
	isSwitch = true,
}

Resources.Gems_WildcardSuperGemGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "SuperWildGem.png",
	matchColor = "White",
	namePrefix = "WildcardSuperGem_",
    isSuper = true,
	--scripts = { "SuperWildGemImageCycle" },
}

Resources.Gems_DiamondGamePieceView = Resources.DefaultDiamondGamePieceView:new {
	resource = "DefaultDiamondGamePieceView",
}

Resources.Gems_KeyGamePieceView = Resources.DefaultKeyGamePieceView:new {
	resource = "DefaultKeyGamePieceView",
}


--
-- "OldGems" piece image set
--

Resources.OldGems_Piece1View = Resources.Actor:new {
	resource = "Actor",
	image = "OldGemBlue.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "Blue_",
}

Resources.OldGems_Piece2View = Resources.Actor:new {
	resource = "Actor",
	image = "OldGemGreen.png",
	matchColor = "#00FF00",		-- HTML/X11 'Lime'
	namePrefix = "Green_",
}

Resources.OldGems_Piece6View = Resources.Actor:new {
	resource = "Actor",
	image = "OldGemOrange.png",
	matchColor = "#FFD700",		-- HTML/X11 'Gold'
	namePrefix = "Orange_",
}

Resources.OldGems_Piece3View = Resources.Actor:new {
	resource = "Actor",
	image = "OldGemPurple.png",
	matchColor = "#FF00FF",		-- HTML/X11 'Magenta'
	namePrefix = "Purple_",
}

Resources.OldGems_Piece4View = Resources.Actor:new {
	resource = "Actor",
	image = "OldGemRed.png",
	matchColor = "#FF5050",		-- an unnamed, reddish color
	namePrefix = "Red_",
}

Resources.OldGems_StoneGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "OldStoneUnbroken.png",
	matchColor = "White",
	namePrefix = "Stone_",
}

Resources.OldGems_WildcardGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Wildgem1.png",
	matchColor = "White",
	namePrefix = "Wildcard_",
	--scripts = { "WildGemImageCycle" },
}

Resources.OldGems_WildcardSuperGemGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "SuperWildGem.png",
	matchColor = "White",
	namePrefix = "WildcardSuperGem_",
    isSuper = true,
}

Resources.OldGems_Piece5View = Resources.Actor:new {
	resource = "Actor",
	image = "OldGemYellow.png",
	matchColor = "#FFFF00",		-- HTML/X11 'Yellow'
	namePrefix = "Yellow_",
}

Resources.OldGems_DiamondGamePieceView = Resources.DefaultDiamondGamePieceView:new {
	resource = "DefaultDiamondGamePieceView",
}

Resources.OldGems_KeyGamePieceView = Resources.DefaultKeyGamePieceView:new {
	resource = "DefaultKeyGamePieceView",
}



--
-- "Blocks" piece image set
--

Resources.Blocks_Piece1View = Resources.Actor:new {
	resource = "Actor",
	image = "block_blue.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "Blue_",
}

Resources.Blocks_Piece2View = Resources.Actor:new {
	resource = "Actor",
	image = "block_green.png",
	matchColor = "#00FF00",		-- HTML/X11 'Lime'
	namePrefix = "Green_",
}

Resources.Blocks_Piece6View = Resources.Actor:new {
	resource = "Actor",
	image = "block_orange.png",
	matchColor = "#FFD700",		-- HTML/X11 'Gold'
	namePrefix = "Orange_",
}

Resources.Blocks_Piece3View = Resources.Actor:new {
	resource = "Actor",
	image = "block_purple.png",
	matchColor = "#FF00FF",		-- HTML/X11 'Magenta'
	namePrefix = "Purple_",
}

Resources.Blocks_Piece4View = Resources.Actor:new {
	resource = "Actor",
	image = "block_red.png",
	matchColor = "#FF5050",		-- an unnamed, reddish color
	namePrefix = "Red_",
}

Resources.Blocks_StoneGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "block_stone.png",
	matchColor = "White",
	namePrefix = "Stone_",
}

-- NOTE: The 'Blocks' theme currently uses graphics from the 'Gems' theme.
Resources.Blocks_WildcardGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Wildgem1.png",
	matchColor = "White",
	namePrefix = "Wildcard_",
	--scripts = { "WildGemImageCycle" },
}

Resources.Blocks_WildcardSuperGemGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "SuperWildGem.png",
	matchColor = "White",
	namePrefix = "WildcardSuperGem_",
    isSuper = true,
}

Resources.Blocks_Piece5View = Resources.Actor:new {
	resource = "Actor",
	image = "block_yellow.png",
	matchColor = "#FFFF00",		-- HTML/X11 'Yellow'
	namePrefix = "Yellow_",
}

Resources.Blocks_DiamondGamePieceView = Resources.DefaultDiamondGamePieceView:new {
	resource = "DefaultDiamondGamePieceView",
}

Resources.Blocks_KeyGamePieceView = Resources.DefaultKeyGamePieceView:new {
	resource = "DefaultKeyGamePieceView",
}


--
-- "SlotMachine" piece image set
--

Resources.SlotMachine_Piece1View = Resources.Actor:new {
	resource = "Actor",
	image = "watermelon.png",
	matchColor = "#00FF00",		-- HTML/X11 'Lime'
	namePrefix = "Green_",
}

Resources.SlotMachine_Piece2View = Resources.Actor:new {
	resource = "Actor",
	image = "orange.png",
	matchColor = "#FFD700",		-- HTML/X11 'Gold'
	namePrefix = "Orange_",
}

Resources.SlotMachine_Piece3View = Resources.Actor:new {
	resource = "Actor",
	image = "grape.png",
	matchColor = "#FF00FF",		-- HTML/X11 'Magenta'
	namePrefix = "Purple_",
}

Resources.SlotMachine_Piece4View = Resources.Actor:new {
	resource = "Actor",
	image = "cherries.png",
	matchColor = "#FF5050",		-- an unnamed, reddish color
	namePrefix = "Red_",
}

Resources.SlotMachine_Piece5View = Resources.Actor:new {
	resource = "Actor",
	image = "bell.png",
	matchColor = "#FFFF00",		-- HTML/X11 'Yellow'
	namePrefix = "Yellow_",
}

Resources.SlotMachine_Piece6View = Resources.Actor:new {
	resource = "Actor",
	image = "plum.png",
	matchColor = "#00FFFF",		-- HTML/X11 'Cyan'
	namePrefix = "Blue_",
}

Resources.SlotMachine_StoneGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "StoneHit2.png",
	matchColor = "White",
	namePrefix = "Stone_",
}

Resources.SlotMachine_WildcardGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "bar.png",
	matchColor = "White",
	namePrefix = "Wildcard_",
	--scripts = { "WildGemImageCycle" },
}

Resources.SlotMachine_WildcardSuperGemGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "SuperWildGem.png",
	matchColor = "White",
	namePrefix = "WildcardSuperGem_",
    isSuper = true,
}

Resources.SlotMachine_DiamondGamePieceView = Resources.DefaultDiamondGamePieceView:new {
	resource = "Actor",
	image = "seven.png",
	matchColor = "#FFFFFF",		-- HTML/X11 'White'
	namePrefix = "Diamond_",
}

Resources.SlotMachine_KeyGamePieceView = Resources.DefaultKeyGamePieceView:new {
	resource = "DefaultKeyGamePieceView",
}


-- An 'aura' for super gems
Resources.SuperMatchGemDecoration = Resources.Actor:new {
	resource = "Actor",
    name = "SuperMatchGemDecoration",
	image = "SuperAura.png",
	alignment = "Center",
	zorder = -1,
	scripts = {
		function (self)
			local revolutionsPerSecond = 0.05
			RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
		end,
	},
}

-- An 'aura' for diamonds
Resources.DiamondGemDecoration = Resources.Actor:new {
	resource = "Actor",
	image = "DiamondAura.png",
	alignment = "Center",
    alpha = 100,
	zorder = -1,
	scripts = {
		function (self)
			local revolutionsPerSecond = 0.04
			RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
		end,
	},
}

-- A jail cell for jailed gems
Resources.JailedGemDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "JailedGemDecoration",
	image = "Jail.png",
	autoFillParent = true,
	zorder = 3,
}

Resources.InedibleBarGemDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "InedibleBarDecoration",
	image = "Inedible.png",
	autoFillParent = true,
	zorder = 2,
}

-- Double jailed gems
Resources.DoubleJailedGemDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "DoubleJailedGemDecoration",
	image = "DoubleJail.png",
	autoFillParent = true,
	zorder = 3,
}

-- Layer of amber
Resources.AmberGemDecoration = Resources.Actor:new {
    resource = "Actor",
	name = "AmberGemDecoration",
	image = "Amber1.png",
	autoFillParent = true,
	zorder = 3,
}

-- Ice
Resources.IceGemDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "IceGemDecoration",
	image = "Ice.png",
	autoFillParent = true,
	zorder = 3,
}

Resources.Gems_IceMakerGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "Ice_Maker.png",
	matchColor = "Gray",
	namePrefix = "IceGen_",
	scaledFileName = "EMPTY",
}

-- Balloons
Resources.BalloonsGemDecoration_Blue = Resources.Actor:new {
	resource = "Actor",
	name = "BalloonsGemDecoration",
	image = "BlueBalloon.png",
	alignment = Center,
	alignTo = Center,
	isBlueBalloon = true,
	layer = 2,
}

Resources.BalloonsGemDecoration_Green = Resources.Actor:new {
	resource = "Actor",
	name = "BalloonsGemDecoration",
	image = "GreenBalloon.png",
	alignment = Center,
	alignTo = Center,
	isGreenBalloon = true,
	layer = 2,
}

Resources.BalloonsGemDecoration_Purple = Resources.Actor:new {
	resource = "Actor",
	name = "BalloonsGemDecoration",
	image = "PurpleBalloon.png",
	alignment = Center,
	alignTo = Center,
	isPurpleBalloon = true,
	layer = 2,
}

Resources.BalloonsGemDecoration_Red = Resources.Actor:new {
	resource = "Actor",
	name = "BalloonsGemDecoration",
	image = "RedBalloon.png",
	alignment = Center,
	alignTo = Center,
	isRedBalloon = true,
	layer = 2,
}

Resources.BalloonsGemDecoration_Yellow = Resources.Actor:new {
	resource = "Actor",
	name = "BalloonsGemDecoration",
	image = "YellowBalloon.png",
	alignment = Center,
	alignTo = Center,
	isYellowBalloon = true,
	layer = 2,
}

Resources.BalloonsGemDecoration_Orange = Resources.Actor:new {
	resource = "Actor",
	name = "BalloonsGemDecoration",
	image = "OrangeBalloon.png",
	alignment = Center,
	alignTo = Center,
	isOrangeBalloon = true,
	layer = 2,
}

Resources.BalloonsGemDecoration_Rainbow = Resources.Actor:new {
	resource = "Actor",
	name = "BalloonsGemDecoration",
	image = "RainbowBalloon.png",
	alignment = Center,
	alignTo = Center,
	isRainbowBalloon = true,
	layer = 2,
}

Resources.BalloonsGemDecoration_Clear = Resources.Actor:new {
	resource = "Actor",
	name = "BalloonsGemDecoration",
	image = "ClearBalloon.png",
	alignment = Center,
	alignTo = Center,
	layer = 2,
}

Resources.Gems_BlueBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "BlueBalloon_Empty.png",
	matchColor = "Blue",
	namePrefix = "BlueBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isBlueBalloon = true,
}

Resources.Gems_GreenBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "GreenBalloon_Empty.png",
	matchColor = "Green",
	namePrefix = "GreenBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isGreenBalloon = true,
}

Resources.Gems_PurpleBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "PurpleBalloon_Empty.png",
	matchColor = "Purple",
	namePrefix = "PurpleBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isPurpleBalloon = true,
}

Resources.Gems_RedBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "RedBalloon_Empty.png",
	matchColor = "Red",
	namePrefix = "RedBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isRedBalloon = true,
}

Resources.Gems_YellowBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "YellowBalloon_Empty.png",
	matchColor = "Yellow",
	namePrefix = "YellowBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isYellowBalloon = true,
}

Resources.Gems_OrangeBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "OrangeBalloon_Empty.png",
	matchColor = "Orange",
	namePrefix = "OrangeBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isOrangeBalloon = true,
}

Resources.Gems_RainbowBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "RainbowBalloon_Empty.png",
	matchColor = "White",
	namePrefix = "RainbowBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isRainbowBalloon = true,
}

Resources.Gems_ClearBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "ClearBalloon_Empty.png",
	matchColor = "White",
	namePrefix = "ClearBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isClearBalloon = true,
}

Resources.Gems_SpecialBlueBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "BlueBalloon_Empty.png",
	matchColor = "Blue",
	namePrefix = "BlueBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isBlueBalloon = true,
	isSpecial = true,
	specialType = "SpecialBlue",
}

Resources.Gems_SpecialGreenBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "GreenBalloon_Empty.png",
	matchColor = "Green",
	namePrefix = "GreenBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isGreenBalloon = true,
	isSpecial = true,
	specialType = "SpecialGreen",
}

Resources.Gems_SpecialRedBalloonGamePieceView = Resources.Actor:new {
	resource = "Actor",
	image = "RedBalloon_Empty.png",
	matchColor = "Red",
	namePrefix = "RedBalloon_",
	scaledFileName = "EMPTY",
	isEmptyBalloon = true,
	isRedBalloon = true,
	isSpecial = true,
	specialType = "SpecialRed",
}

-- A layer of vines
Resources.VinesGemDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "VinesGemDecoration",
	image = "Vines.png",
	autoFillParent = true,
	zorder = 2,
	Glow = Resources.Actor:new {
		resource="Actor",
		image = "Vines_glow.png",
		visible = false,
		autoFillParent = true,
	},
}

-- An icon for vertical splash gems
Resources.VerticalSplashDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "VerticalSplashDecoration",
	image = "Vertical.png",
	autoFillParent = true,
	isVerticalSplash = true,
	Overlay = Resources.Actor:new {
		resource = "Actor",
		image = "Vertical.png",
		autoFillParent = true,
		alpha = 100,
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		visible = false,
	},
}

-- An 'aura' for vertical splash gems
Resources.VerticalSplashAura = Resources.Actor:new {
	resource = "Actor",
    name = "VerticalSplashAura",
	image = "SuperAura.png",
	alignment = "Center",
	zorder = -1,
	scripts = {
		function (self)
			local revolutionsPerSecond = 0.05
			RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
		end,
	},
}

-- An icon for horizontal splash gems
Resources.HorizontalSplashDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "HorizontalSplashDecoration",
	image = "Horizontal.png",
	autoFillParent = true,
	isHorizontalSplash = true,
	Overlay = Resources.Actor:new {
		resource = "Actor",
		image = "Horizontal.png",
		autoFillParent = true,
		alpha = 100,
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		visible = false,
	},
}

-- An 'aura' for Area splash gems
Resources.HorizontalSplashAura = Resources.Actor:new {
	resource = "Actor",
    name = "HorizontalSplashAura",
	image = "SuperAura.png",
	alignment = "Center",
	zorder = -1,
	scripts = {
		function (self)
			local revolutionsPerSecond = 0.05
			RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
		end,
	},
}

-- An icon for area splash gems
Resources.AreaSplashDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "AreaSplashDecoration",
	image = "Boom.png",
	autoFillParent = true,
	isAreaSplash = true,
	Overlay = Resources.Actor:new {
		resource = "Actor",
		image = "Boom.png",
		autoFillParent = true,
		alpha = 100,
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		visible = false,
	},
}

-- An 'aura' for Area splash gems
Resources.AreaSplashAura = Resources.Actor:new {
	resource = "Actor",
    name = "AreaSplashAura",
	image = "SuperAura.png",
	alignment = "Center",
	zorder = -1,
	scripts = {
		function (self)
			local revolutionsPerSecond = 0.05
			RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
		end,
	},
}

-- Decorations for all the combined splash types. They use the aura of the area splash decoration, since all auras are the same.

-- An icon for wide vertical splash gems
Resources.WideVerticalSplashDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "WideVerticalSplashDecoration",
	image = "WideVertical.png",
	autoFillParent = true,
	isVerticalSplash = true,
	isAreaSplash = true,
	Overlay = Resources.Actor:new {
		resource = "Actor",
		image = "WideVertical.png",
		autoFillParent = true,
		alpha = 100,
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		visible = false,
	},
}

-- An icon for wide horizontal splash gems
Resources.WideHorizontalSplashDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "WideHorizontalSplashDecoration",
	image = "WideHorizontal.png",
	autoFillParent = true,
	isHorizontalSplash = true,
	isAreaSplash = true,
	Overlay = Resources.Actor:new {
		resource = "Actor",
		image = "WideHorizontal.png",
		autoFillParent = true,
		alpha = 100,
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		visible = false,
	},
}

-- An icon for wide plus splash gems
Resources.WidePlusSplashDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "WidePlusSplashDecoration",
	image = "WidePlus.png",
	autoFillParent = true,
	isVerticalSplash = true,
	isHorizontalSplash = true,
	isAreaSplash = true,
	Overlay = Resources.Actor:new {
		resource = "Actor",
		image = "WidePlus.png",
		autoFillParent = true,
		alpha = 100,
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		visible = false,
	},
}

-- An icon for plus splash gems
Resources.PlusSplashDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "PlusSplashDecoration",
	image = "Plus.png",
	autoFillParent = true,
	isVerticalSplash = true,
	isHorizontalSplash = true,
	Overlay = Resources.Actor:new {
		resource = "Actor",
		image = "Plus.png",
		autoFillParent = true,
		alpha = 100,
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		visible = false,
	},
}

-- An icon for area splash gems
Resources.BombDecoration = Resources.Actor:new {
	resource = "Actor",
	name = "BombDecoration",
	image = "Bomb.png",
	alignment = Center,
	alignTo = Center,
	scalingPoint = Center,
	alignmentOffset = {3,-2},
	zorder = 2,
	TurnsLabel = Resources.Label:new {
		resource = "Label",
		font = Resources.AppDefaultFont:new {
			resource = "AppDefaultFont",
			fontSize = 22,
		},
		layer = 1,
		shadowAlpha = 100,
		shadowColor = "Black",
		highlightAlpha = 100,
		highlightColor = "Black",
		alignment = Center,
		alignmentOffset = {-3,2},
		fgColor = "White",
	},
}

-- An 'aura' for key
Resources.KeyGemDecoration = Resources.Actor:new {
	resource = "Actor",
	image = "DiamondAura.png",
	alignment = "Center",
    alpha = 100,
	zorder = -1,
	scripts = {
		function (self)
			local revolutionsPerSecond = 0.04
			RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
		end,
	},
}


local function CreateStandardBoardCellView(params)
	local cellResource = Resources.BoardCell:new {
		resource = "BoardCell",
		cellPosition = {params.boardX, params.boardY},
		size = params.cellSize,
		alignment = "Center",
		alignTo = "TopLeft",
		alignmentOffset = {params.centerX, params.centerY},
		tag = "Clickable",
		alpha = 0,
		clickOffset = {0,0},
		background = Resources.Actor:new {
			resource = "Actor",
			image = params.imageName,
			alpha = params.backgroundImageAlpha,
			alignment = "Center",
			alignmentOffset = {0,0},
		},
		highlight = Resources.Actor:new {
			resource = "Actor",
			image = "slot_highlight.png",
			alignment = "Center",
			alignmentOffset = {0,0},
			visible = false,
			zorder = 1,
		},
		shine = Resources.Actor:new {
			resource = "Actor",
			image = "slot_highlight.png",
			alignment = "Center",
			alignmentOffset = {0,0},
			visible = false,
			zorder = 2,
		},
	}
	
	local isStandardBoardSize = (params.boardWidth == 6) and (params.boardHeight == 7 or params.boardHeight == 1)
	if not isStandardBoardSize then
		-- make sure the board cell gets resized if we're playing around
		-- non-standard board sizes
		cellResource.background.autoFillParent = true
	end
	
	local cellView = CreateInstance(cellResource)
	return cellView
end

-- An icon for vertical splash gems
Resources.GoldBarDecoration = Resources.Label:new {
	resource = "Label",
	name = "GoldBarDecoration",
	fgColor = "Black",
	alignment = Center,
	visible = false,
}


-- Creates and adds a grid of actors to help align game pieces (to a board).
local function AddBoardCellViewsForBoard(container, boardWidth, boardHeight, param1, param2)
	-- Extract params, and figure out how cells will get instantiated:
	local cellFactory
	local getImageName
	local backgroundImageAlpha
	if IsFunction(param1) then
		cellFactory = param1
		getImageName = function () end
	else
		cellFactory = CreateStandardBoardCellView
		if not IsTable(param1) then
			getImageName = function() return param1 end
		else
			local imageNameIndex = 0
			getImageName = function()
				imageNameIndex = imageNameIndex + 1
				if imageNameIndex > #param1 then
					imageNameIndex = 1
				end
				return param1[imageNameIndex]
			end
		end
			
		backgroundImageAlpha = param2
	end

	-- Specify grid layout attributes.
	local allocatedWidthForCells = container.width / boardWidth
	local allocatedHeightForCells = container.height / boardHeight
	local intraCellPadding = 0 --jsupnik note: Changed this to 0 so that cell buttons don't overlap.
	local cellSize = {allocatedWidthForCells - (intraCellPadding / 2), allocatedHeightForCells - (intraCellPadding / 2)}

--[[
	--logprint(debug.traceback())
	logprintf("board size = %d, %d\n", boardWidth, boardHeight)
	logprintf("allocated size = %d, %d\n", allocatedWidthForCells, allocatedHeightForCells)
	logprintf("container size = %d, %d\n", container.width, container.height)
	logprintf("cell size = %d, %d\n", cellSize[1], cellSize[2])
	logprintf("\n")
--]]

	-- Create actors for each board cell.
	for boardX = 0,(boardWidth-1) do
		for boardY = 0,(boardHeight-1) do
			local centerX = (allocatedWidthForCells * (boardX + 1)) - (allocatedWidthForCells / 2)
			local centerY = (allocatedHeightForCells * (boardY + 1)) - (allocatedHeightForCells / 2)
			local cellView = cellFactory {
				boardWidth = boardWidth,
				boardHeight = boardHeight,
				boardX = boardX,
				boardY = boardY,
				cellSize = cellSize,
				centerX = centerX,
				centerY = centerY,
				imageName = getImageName(),
				backgroundImageAlpha = backgroundImageAlpha
			}
			cellView.name = string.format("BoardCell_%d_%d", boardX, boardY)
			container:AddChild(cellView)
		end
	end
end


local function AddPieceDropCellViewsForBoard(container, boardWidth, boardHeight)
	-- Specify grid layout attributes.
	local allocatedWidthForCells = container.width / boardWidth
	local allocatedHeightForCells = container.height / boardHeight
	local intraCellPadding = 4
	local cellSize = {allocatedWidthForCells - (intraCellPadding / 2), allocatedHeightForCells - (intraCellPadding / 2)}

--[[
	logprint(debug.traceback())
	logprintf("board size = %d, %d\n", boardWidth, boardHeight)
	logprintf("allocated size = %d, %d\n", allocatedWidthForCells, allocatedHeightForCells)
	logprintf("container size = %d, %d\n", container.width, container.height)
	logprintf("cell size = %d, %d\n", cellSize[1], cellSize[2])
	logprintf("\n");
--]]

	-- Create actors for each board cell.
	for boardX = 0,(boardWidth-1) do
		for boardY = 0,(boardHeight-1) do
			local centerX = (allocatedWidthForCells * (boardX + 1)) - (allocatedWidthForCells / 2)
			local centerY = (-1 * (allocatedHeightForCells * boardY)) - (allocatedHeightForCells / 2)
			local cellView = CreateInstance (
				Resources.BoardCell:new {
					resource = "BoardCell",
					name = string.format("PieceDropCell_%d_%d", boardX, boardY),
					cellPosition = {boardX,boardY},
					size = cellSize,
					alignment = "Center",
					alignTo = "BottomLeft",
					alignmentOffset = {centerX, centerY},
					--text = string.format("%d,%d", boardX, boardY),
				}
			)
			container:AddChild(cellView)
		end
	end
end

-- Resource for displaying if a space has been matched (on the main game board)
Resources.BoardSpaceMatchedView = Resources.Actor:new {
	resource = "Actor",
	image = "PatternSquare_1.png",
	alpha = 200, -- note: Set in C++
	--layer = 1,  -- note: set this for cloudy gem over
}

Resources.GemEaterView = Resources.Actor:new {
	resource = "Actor",
	image = "GemEater_Open.png",
}

SteelGlassGemScaling = 0.8

Resources.SteelGlassDecoration = Resources.Actor:new {
	resource = "Actor",
	image = "SteelGlass.png",
	autoFillParent = true,
	layer = 3,
}

-- Resource for displaying barriers to matching
Resources.RightBarrierView = Resources.Actor:new {
	resource = "Actor",
	image = "BarrierRight.png",
}

Resources.BottomBarrierView = Resources.Actor:new {
	resource = "Actor",
	image = "BarrierBottom.png",
}

-- Resource for displaying slot/column availability on a single slot (on the slots board)
Resources.CascadeSlotAvailabilityView = Resources.Actor:new {
	resource = "Actor",
	size = {40,40},
	--color = "Green",
	--alpha = 128,
	
	UpdateAvailability = function (self, slotAvailability, showInfinite)
		if slotAvailability == 0 then
			self.noSlotAvailability.visible = true
			self.finiteSlotAvailability.visible = false
			self.infiniteSlotAvailability.visible = false
		elseif slotAvailability > 0 then
			self.noSlotAvailability.visible = false
			self.finiteSlotAvailability.visible = true
			self.finiteSlotAvailability.text = tostring(slotAvailability)
			self.infiniteSlotAvailability.visible = false
		else
			self.noSlotAvailability.visible = false
			self.finiteSlotAvailability.visible = false
			self.infiniteSlotAvailability.visible = showInfinite
		end
	end,
	
	noSlotAvailability = Resources.Actor:new {
		resource = "Actor",
		--autoFillParent = true,
        size = {40+7,40+7},
		color = "Black",
		alpha = 0,
        alignment = "Center",
		
		bigX = Resources.Label:new {
			resource = "Label",
			fgColor = "Red",
			shadowColor = "Gray",
			shadowOffset = {1,1},
			font = {
				fontName = "arialn.ttf",
				fontSize = 30,
			},
			text = STRINGS("X"),
			alignment = "Center",
			visible = false,
		},

		visible = false,
	},
	
	finiteSlotAvailability = Resources.Label:new {
		resource = "Label",
		fgColor = "White",
		shadowColor = "Gray",
		shadowOffset = {1,1},
		font = {
			fontName = "IT441___.TTF",
			fontSize = 12,
		},
		text = STRINGS("X"),
		alignment = "BottomRight",
		alignmentOffset = {0,0},
		visible = false,
	},
	
	infiniteSlotAvailability = Resources.Actor:new {
		resource = "Actor",
		image = "VisionOverlay.png",
		alignment = "Center",
		visible = false,
	},
}

-- Change what side of the screen an actor is on.
-- Only works for actors with horizontal alignments relative to the center.
-- This function may not work in all cases.  You have been warned.
local function HACK_ChangeHorizontalSide(anActor, side)
	if anActor.alignment ~= "MidTop" and
	   anActor.alignment ~= "Center" and
	   anActor.alignment ~= "MidBottom"
	then
		return
	end

	local alignmentOffsetX = anActor.alignmentOffset.x
	if side == "right" then
		alignmentOffsetX = math.abs(alignmentOffsetX)
	elseif side == "left" then
		alignmentOffsetX = math.abs(alignmentOffsetX) * -1
	else
		error(string.format("specified side is neither 'right' nor 'left'.  (side=%s)", tostring(side)))
	end

	--[[
	logprintf("HACK_ChangeHorizontalSide(%s): handedness = %s, x = %d --> %d, y = %d\n",
		anActor.name,
		handedness,
		anActor.alignmentOffset.x, alignmentOffsetX,
		anActor.alignmentOffset.y)
	--]]

	anActor.alignmentOffset = {alignmentOffsetX, anActor.alignmentOffset.y}
end

--
-- RESOURCES
--

Resources.GoodJobWord = Resources.Actor:new{
	resource = "Actor",
	alignment = "Center",
	alignTo = "Center",
	alignmentOffset = {-3,-25},
	layer = 999,
	visible = false,
}

local function SwitchPanel(panel)
	--logprint("SwitchPanel Function")
	local isChallenge = panel.GoalContainer.InnerScoreLabel.score > 0
	local isLevel = panel.LevelGoalContainer.InnerScoreLabel.text ~= ""
	if(isChallenge)then
		-- Switch panel with goal score
		if(panel.GoalContainer.visible==true)then
			panel.TodayContainer.visible = true
			panel.GoalContainer.visible = false
		else
			if(panel.TodayContainer.visible == true) then
				panel.GoalContainer.visible = true
				panel.TodayContainer.visible = false
			end
		end
	else
		if(isLevel) then
		else
			-- Switch panel without
			panel.GoalContainer.visible = false
			if(panel.AllTimeContainer.visible==true)then
				panel.AllTimeContainer.visible = false
				panel.TodayContainer.visible = true
			else
				if(panel.TodayContainer.visible == true) then
					panel.TodayContainer.visible = false
					panel.AllTimeContainer.visible = true
				end
			end
		end
	end
end

Scripts.SwitchPanel = function(panel)
	--logprint("SwitchPanel")
	SwitchPanel(panel)
end

Scripts.PanelFlip = function(panel) 
	local delay = 10000
	while(true)do
		ScriptDelay(delay)	
		SwitchPanel(panel)
	end
end

local pc_Scale = 0.9

Resources.InnerScoreLabel = Resources.GameLabelBold_small:new {
	resource = "GameLabelBold_small",
	alignment = "Center",
	alignTo = "Center",
	alignmentOffset = {0, 0},
}

Resources.TrickContainer = Resources.Actor:new {
	resource = "Actor",
	alignment = Center,
	Trick = Resources.AppButton:new {
		resource = "AppButton",
		alignment = Center,
		useFrames = false,
		clickOffset = {1,1,},
		tag = "Clickable",
		CheckMark = Resources.Actor:new {
			resource = "Actor",
			image = "Check.png",
			alignment = Center,
			visible = false,
		},
	    SaleTag = Resources.SaleTag:new {
		    resource = "SaleTag",
		    alignment = Center,
		    alignTo = MidTop,
		    alignmentOffset = {0,5},
            extraScale = 0.50,
            --rotationAngle = {degrees = 15,},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
	    },
        QuantityLabel = Resources.Label:new {
            resource = "Label",
            alignment = BottomRight,
            fgColor = "Cascade_Black",
            shadowColor = "White",
			alignmentOffset = {-4,0},
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 16,
            },
            visible = false,
			CircleBackground = Resources.Actor:new {
				image = "NumberMarker.png",
				alignment = Center,
				alpha = 255,
				size = {18,18},
			},
        },
	},
}

--Continue Panel. Displays when player runs out of spins
Resources.NoMoreSpinsPanel = {
    class = "Actor",
    name = "NoMoreSpinsPanel",
	alignment = MidTop,
	size = (APP and APP.screenSize) or {320, 480},
	alpha = 0,
	layer = 5,
	visible = false,

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignmentOffset = Layout{{0,35},iphone5={0,75}},
		image = "OutOfSpinsBanner.png",

		DialogCharacter = Resources.DialogCharacter:new {
			resource = "DialogCharacter",
			zorder = 1,
			alignment = MidBottom,
			alignTo = MidBottom,
			alignmentOffset = {-120,8},
			image = "Character_Explorer_sad1.png",
		},

		titlePanel = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			alignment = "Center",
            fontSize = 40,
			alignmentOffset = {-10,-13},
			text = STRINGS("Out Of Spins"),
			widthLimit = 170,
            
            IconLives_broken_panel = Resources.Actor:new {
                resource = "Actor",
                alignment = Left,
                alignTo = Right,
                extraScale = 1.3,
                alignmentOffset = {10,0},
                image = "IconLives_broken_panel.png",
            },

			nearMissPanel = Resources.Actor:new {
				resource = "Actor",
                extraScale = 1.10,
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {10,65},
				image = "NearMissBanner.png",
				visible = false,
                
            },

                nearMissText = Resources.StartQuestGameDialogLabel:new {
                    resource = "StartQuestGameDialogLabel",
                    text = STRINGS(""),
                    --font = Resources.DialogFont:new {resource = "DialogFont",fontSize = 30,},
                    font = Resources.AppButtonFont:new {resource = "AppButtonFont",fontSize = 35,},

                    alignmentOffset = {10,80},
                    alignment = "Center",
                    widthLimit = 250,
                    fgColor = "Cascade_DarkBrown",
                },
		},
	},
	
	TopTenPanel = Resources.Actor:new {
		resource = "Actor",
		
		alpha = 0,
		size = {313,124},
		alignment = MidBottom,

		ButtonPanel = Resources.Actor:new {
			resource = "Actor",
			alpha = 0,
			alignTo = MidBottom,
			alignment = MidBottom,
			alignmentOffset = {0,70},
			size = {310,313},
			zorder = -2,

			PlayMoreButton = Resources.EndGameDialogBiggerButton:new {
				resource = "EndGameDialogBiggerButton",
				image = "Button_Continue.png",
				alignment = MidBottom,
                alignTo = MidBottom,
				alignmentOffset = {0, -200},
                extraScale = 1.2,


				tag = "Clickable",
				text = STRINGS("Continue"),
                textWidthLimit = 100,
				textColor = "Cascade_SignTextGold",
				textHighlightColor = "Cascade_DarkBrown",
				textShadowColor = "Cascade_DarkBrown",
				textLineSpacing = 10,
				textAlignmentOffset = {0,-4},
				font	= Resources.AppButtonFont:new{
					resource = "AppButtonFont",
					fontSize = 40,
				},


				clickSound = "slot_machine_jackpot_win_hit1.ogg",

				CascadeSpinButton_handle_PlayMoreButton = Resources.Actor:new {
					resource = "Actor",
					image = "Button_BAR_VERT_big.png",

					alignment = MidTop,
					alignTo = MidBottom,
					alignmentOffset = {0,-2},
					zorder = -1,
				},

				SaleTag = Resources.SaleTag:new {
					resource = "SaleTag",
					visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
                    alignmentOffset = {-75,-20},
				},

				BundleItemsTag = Resources.BundleItemsTag:new {
					resource = "BundleItemsTag",
					alignment = MidTop,
					alignTo = MidBottom,
					alignmentOffset = {85,-70},
                    extraScale = 0.8,
				},


				ContinueToken = Resources.Actor:new {
					resource = "Actor",
                    scripts = {"QuickWiggleLoop"},
					image = "ContinueToken_small.png",
					alignment = "Center",
					alignTo = "Center",
					zorder = 1,
					--size = {48,48},
					alignmentOffset = {0,26},

					QuantityLabel = Resources.ScoreCounter:new {
						resource = "ScoreCounter",
			
						alignment = "BottomRight",
						alignmentOffset = {-4,0},
			
						useCurrency = false,
						useComma = true,
						score = 0,

						labelProperties = {
							resource = "Label",
							fgColor = "Black",
							font = Resources.DialogBoldFont:new {
								resource = "DialogBoldFont",
								fontSize = 16,
							},
							widthLimit = 14,
						},


						QuantityLabel_background = Resources.Actor:new {
							image = "NumberMarker.png",
							alignment = "Center",
							alignTo = "Center",
							zorder = -1,
							size = {18,18},
						},
					},
				},

				OnPostSpawn = function (self)
					Scripts.LocalizedButtonOnAwake(self)
				end
			},

			EndGameButton = Resources.EndGameDialogBiggerButton:new {
				resource = "EndGameDialogBiggerButton",
				image = "QuitGameWood.png",
				alignmentOffset = {0,-100},
				alignment = MidBottom,
				tag = "Clickable",
				text = STRINGS("End Game"),
                textAlignmentOffset = {6,-15},
                textWidthLimit = 100,
				--textColor = "Cascade_Yellow",
				--textHighlightColor = "Cascade_DarkBrown",
				--textShadowColor = "Cascade_DarkBrown",
				font	= Resources.AppButtonFont:new{
					resource = "AppButtonFont",
					fontSize = 30,
				},
                
				enterKey = true,
				escapeKey = true,
				shortcutKey = "o",
				zorder = 2,
				--[[
				Icon_MoreLives_broken = Resources.Actor:new {
					resource = "Actor",
					image = "Icon_MoreLives_broken.png",
					alignment = "TopLeft",
					alignTo = "TopLeft",
					alignmentOffset = {0, 0},
				},
				--]]
                --[[ Shadow for Old Bar Buttons
				CascadeSpinButton_handle_EndGameButton = Resources.Actor:new {
					resource = "Actor",
					image = "Button_BAR_VERT_big.png",
					alignment = MidTop,
					alignTo = MidBottom,
					alignmentOffset = {0,0},
					zorder = -1,
				},
                --]]
			},

			UseTrickSign = Resources.Actor:new{
				resource = "Actor",
				image = "SmallCallOut.png",
                scripts = {"JelloLoop"},
				alignment = Center,
				alignTo = Center,
                alignmentOffset = {110, 20},
				--alignmentOffset = Layout{{2,-67},iphone5={2,-72},iphone={2,-69}},
				zorder = 3,
				visible = true,
				--size = Layout{{194/2,100/2},iphone5={194/2/1.35,100/2},iphone={194/2/1.35,100/2}},
				--scripts = {"QuickWiggleLoop"},
				useTricks = Resources.AppTitleDialogLabel_smaller:new {
					resource = "AppTitleDialogLabel_smaller",
					alignment = "Center",
					alignmentOffset = {0,-15},
					text = STRINGS("Use Tricks?"),
					widthLimit = 75,
                    heightLimit = 18,
					font	= Resources.AppButtonFont:new{
						resource = "AppButtonFont",
					},
				},
			},
		},
	},
}

local nudge_bottom_button_y = 1

--DEBUG: EnableCCLayout 
--Config.EnableCCLayout = false


Resources.SpecialGem_group1 = Resources.Actor:new {
	size = Layout{{44,25},ipad={33,20},iphone4={33,20},android={33,20}},
	color = "Blue",
	alpha = 0, -- for debuggin

	SpecialGem_ImageHolder = Resources.Actor:new {
		resource = "Actor",
		alpha = 0,
		
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = Layout{{0, 1},ipad={0,1},iphone4={0,1}},
		--size = Layout{{100/2/2,100/2/2},ipad={100/2/2,100/2/2},iphone4={100/2/2,100/2/2}},
		image = "GamePanel_GemSpecialBlue.png",

		SpecialGem_image = Resources.Actor:new {
			resource = "Actor",
			image = "GemSpecialGreen.png",
			autoFillParent = true,
		},
	},

	SpecialGem_label = Resources.ScoreCounter:new {
		resource = "ScoreCounter",
		useCurrency = false,
		useComma = true,
		zorder = 2,
                    
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = {15, 1},
		score = 10000,

		labelProperties = {
			resource = "GameLabelBold",
			fgColor = "Cascade_Black",
			widthLimit = 35,
			font	= Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontSize = 14,
			},
		},
	},
}

Resources.SpecialGem_group3 = Resources.Actor:new {
	size = Layout{{44,25},ipad={33,20},iphone4={33,20}},
	color = "Blue",
	alpha = 0, -- for debuggin

	SpecialGem_ImageHolder = Resources.Actor:new {
		resource = "Actor",
		alpha = 0,
		
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = Layout{{0, 0},ipad={0,0},iphone4={0,0}},
		size = Layout{{100/2/2,100/2/2},ipad={100/2/2,100/2/2},iphone4={100/2/2,100/2/2}},
		--image = "GamePanel_GemSpecialBlue.png",

		SpecialGem_image = Resources.Actor:new {
			image = "GemSpecialGreen.png",
			autoFillParent = true,
		},
	},

	SpecialGem_label = Resources.ScoreCounter:new {
		resource = "ScoreCounter",
		useCurrency = false,
		useComma = true,
		zorder = 2,
                    
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = Layout{{0, 2},ipad={0, 2},iphone4={0, 2}},
		score = 1000,

		labelProperties = {
			resource = "GameLabelBold",
			fgColor = "Cascade_Black",
			shadowColor = "White",
			highlightColor = "White",
			shadowAlpha = 200,
			highlightAlpha = 200,
			widthLimit = 35,
			font	= Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontSize = Layout{16,iphone4=16,ipad=16,iphone4=12},
			},
		},
	},
}

Resources.StarMeterStar = Resources.Actor:new {
	resource = "Actor",
	image = "GamePanel_ScoreMeter_Star_Silver.png",
	alignment = "Center",
	alignTo = "MidLeft",
	alignmentOffset = Layout{{40,-2},iphone4={40,-1},ipad={40,-2}},
	zorder = 2,
	visible = false,
}

Resources.StarMeterWorker = Resources.Actor:new {
	resource = "Actor",
	alignment = BottomRight,
	alignTo = BottomRight,
	size = {8,8},
	alignmentOffset = {1,1},
	resizeOnSetImage = false,
}

Resources.QuickQuestCup = Resources.Actor:new {
	resource = "Actor",
	alignment = BottomLeft,
	alignTo = BottomLeft,
	size = {10,10},
	alignmentOffset = {-4,3},
	resizeOnSetImage = false,
	image = "Quest_Cup_53.png",
	visible = false,
}

-- Base structure for the game screen's visible elements.
Resources.CascadeGameViewsIPhone = Resources.Actor:new {
	resource = "Actor",
	size = (APP and APP.screenSize) or {320, 480},
	alpha = 0,
	
	ApplyLayoutForGameFeatures = function (self, gameFeatures)
		local sideOppositeHand = "left"
		local sideWithHand = "right"
		if Config.left_handed_mode == true then
			sideOppositeHand = "right"
			sideWithHand = "left"
		end
		
		if gameFeatures.numSpins == -1 and gameFeatures.timeLimitInSeconds > 0 then
			-- timed mode
			self.RemainingSpinsContainer.visible = false
			self.TimeLimitLabels.visible = true
			self.TimeLimitLabels:ApplyLayout("bottom")
			--HACK_ChangeHorizontalSide(self.TimeLimitLabels, sideOppositeHand)
		elseif gameFeatures.numSpins >= 0 and gameFeatures.timeLimitInSeconds == 0 then
			-- limited-spins mode
			self.RemainingSpinsContainer.visible = true
			--HACK_ChangeHorizontalSide(self.RemainingSpinsContainer, sideOppositeHand)
			self.TimeLimitLabels.visible = false
		else
			-- combination of timed and limited spins
			self.RemainingSpinsContainer.visible = true
			--HACK_ChangeHorizontalSide(self.RemainingSpinsContainer, sideOppositeHand)
			self.TimeLimitLabels.visible = true
			self.TimeLimitLabels:ApplyLayout("top")
		end
		
		--HACK_ChangeHorizontalSide(self.MenuButton, sideWithHand)
	end,
	
	children = {
		--
		-- Sub-backgrounds
		--
		Resources.Actor:new {
			name = "TopHUDBackground",
			resource = "Actor",
			alpha = 100,
			color = "Black",
			alignment = "MidTop",
			alignmentOffset = {0, 1},
			size = {316, 28},
			visible = false,
		},

		Resources.Actor:new {
			name = "BottomHUDBackground",
			resource = "Actor",
			alpha = 100,
			color = "Black",
			alignment = "MidBottom",
			alignmentOffset = {0, -1},
			size = {316, 38},
			visible = false,
		},

		FloatText = Resources.Actor:new {
			resource = "Actor",
			image = "GamePanel_circle_alt2.png",
			layer = 5,
			visible = false,
			alignment = "Center",
			alignmentOffset = Layout{{0,-220},iphone4={0,-120},iphone5={0,-220}},
			extraScale = 0.5,
			MultiplierLabel = Resources.GameLabelChunkier:new {
				resource = "GameLabelChunkier",
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = {0,0},
				text = "",
				widthLimit = 40,
				font	= Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontSize = 40,
				},
			},
		},


		--
		-- Buttons
		--
		Resources.Button:new {
			name = "MenuButton",
			resource = "Button",
			image = "OptionsButton.png",
			useFrames = false,
			text = STRINGS(""),
			textWidthLimit = 56,
			--size = Layout {{30,30},iphone5 = {30,30},ipad = {160/4,40}},
			alignment = Layout{"BottomLeft", iphone5="BottomLeft", ipad="BottomLeft", pc="BottomLeft"},
			alignmentOffset = Layout{{6, 2}, iphone5={6, -4}, ipad={3, -1}},
			font = {
				fontName = "IT441___.TTF",
				fontSize = 17,
			},
			tag = "Clickable",
			escapeKey = true,
			layer = 3, --Prevent it from being covered by the goal presentation button
		},
		HelpButton = Resources.AppButton:new{
			resource = "AppButton",
			image = "btnHelp.png",
			size = Layout {{30,30},iphone5 = {160/4,40},ipad = {160/4,40}},
			shortcutKey = "?",
			functionKey = 282,--SDLK_F1
			alignment = Layout {"BottomRight", iphone5= "BottomRight", ipad= "BottomRight", pc="BottomRight"},
			alignTo = Layout {"BottomRight", iphone5= "BottomRight",  ipad= "BottomRight", pc="BottomRight"},
			alignmentOffset =  Layout{{-6, -4}, iphone5={-6,0}, ipad={-0,0},pc={-10,-10}},
			alignmentOffset = Layout{{-6, -3+nudge_bottom_button_y}, iphone5={-6, -3+nudge_bottom_button_y-3}, ipad={-3, -3+nudge_bottom_button_y}},

			tag = "Clickable",
			layer = 3, --Prevent it from being covered by the goal presentation button
			visible = false,
			useFrames = false,
		},

		Resources.Button:new {
			name = "SpinButton",
			resource = "Button",
            image = spinImg,
			alpha = 0,
			alignment = "MidBottom",
			alignmentOffset = ConfigPick{{0,-68},EnableSmallSpinButton={0,0}},
			font = {
				fontName = "IT441___.TTF",
				fontSize = 26,
			},
			tag = "Clickable",
			layer = 8, --Using a layer so that it sits over the goal presentation
			text_Spin = "",
			text_SpinAndMatch = "",
			text_Match = "",
			size = ConfigPick{EnableSmallSpinButton={382/7,411/7}},
			enterKey = true,

			ImageActor = Resources.Actor:new {
				resource = "Actor",
				image = spinImg,
                localizedLabel = Resources.Label:new {
                    resource = "Label",
                    alignment = Center,
                    alignTo = Center,
                    fgColor = {0xff,0xe9,0x60},
                    highlightColor = "Cascade_DarkBrown",
                     shadowColor = "Cascade_White",
					shadowAlpha = 50,
                    alpha = 255,
                    showHighlight = true,
                    font	= Resources.DialogBoldFont:new{
                    resource = "DialogBoldFont",
                    fontSize = 40,
                    },
                    text = spinText,
					widthLimit = 100,
                },

				SpinEffect = Resources.Actor:new{
					name = "",
					alignment = "MidTop",
					alignmentOffset = {0,4},
					alpha = 255,
					visible = false,
					scripts = {
						function (self)
							local revolutionsPerSecond = 1.0
							RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
						end,
					},
				},
				Handle = Resources.Actor:new {
					name = "",
					image = "CascadeSpinButton_handle.png",
					alignment = "MidTop",
					alignTo = "MidBottom",
					alignmentOffset = {0,0},
					alpha = 255,
					visible = ConfigPick{true,EnableSmallSpinButton=false},
					zorder = -1,
				},
			},

			-- Moved self.active to false so that useFrames kicks in first 
			-- And we don't get warning on setting frames without frames
			useFrames = false,
			OnPostSpawn = function (self)
				-- Spin Button animations are triggered by changing 'active' from
				-- false to true.  Make sure the spin button animates in on game
				-- start by initially setting this value to 'false'.
				self.active = false
			end,
			
			-- Make sure the spin button is invisible, by default.  If it needs
			-- to be shown (for first spin, for example), the Game Controller
			-- will handle.
			visible = false,

			--
			-- Animation Code
			--
			-- This code is placed here in order to try and keep spin-button's
			-- potentially adjustable stuff as grouped together as is
			-- reasonably possible.
			--
			
			-- Slides/animates the button in:
			AnimateIn = function (self)
				-- Make sure the button is in its final position, and not
				-- somewhere in-between a slide, or at the end of one,
				-- by triggerring a reset of its aligned position.
				self.alignmentOffset = self.alignmentOffset
				
				-- Make note of the button's final position, relative to a
				-- specific global point:
				local finalGlobalPosition = self:GetGlobalPoint("MidBottom")

				if(Config.EnableSmallSpinButton)then
					self.visible = true
					self:SetGlobalPoint("MidBottom", finalGlobalPosition)
					return
				end
				
				-- Move the actor to its initial position.
				self.rotation = { degrees = 0 }
				self:SetGlobalPoint("MidBottom", {self.screen.width / 2, self.screen.height + self.width})
                
                self.visible = true
				
				-- Slide the actor from its current and initial position, to its
				-- final position:
				local slideTimeMS = 200
				Scripts.InterpolateGlobalPoint(self, "MidBottom", finalGlobalPosition, slideTimeMS)
			end,
		},

		--
		-- Misc HUD Elements
		--
		
		Resources.Actor:new {
			resource = "Actor",
			name = "Logo",
			image = (UseIPhone5AppAssets() and "SmallLogo.png") or "SmallLogo.png",
			alignment = "MidTop",
			alignmentOffset = Layout{{2,1}, iphone5={0,5}, ipad={0,2}, pc={15,15}},
			--visible = Layout{false,iphone5=true,ipad=true},
			visible = false,
			
			logoButton = Resources.Button:new {
				resource = "Button",
				image = "",
				autoFillParent = true,
				clickSound = "",
				clickUpSound = "",
				highlightSound = "",
				alpha = 0,
				visible = not (IsAppDistributionPublicBeta() or IsAppDistributionPublicRelease()),
				visible = false,
			},
		},
		
		--
		-- Labels
		--

		MultiplierPanel = Resources.Actor:new {
			resource = "Actor",
			image = Layout{"GamePanel_Circle_alt.png",iphone4="GamePanel_Circle_alt_medium.png",ipad="GamePanel_Circle_alt_medium.png"},
			alignment = "Center",
			alignTo = "MidTop",
			alignmentOffset = {0,0},
			
			-- WITH RESOURCES
			alignmentOffset = Layout{{0, 17}, iphone4={56,12}, iphone5={0,24},  ipad={70, 12}, android={0,14}, androidShort={64, 7}, pc={-5,10}},

			-- WITHOUT RESOURCES
			--alignmentOffset = Layout{{0, 17}, iphone4={0,12}, iphone5={0,24},  ipad={0, 22}, pc={-5,10}},
			
			zorder = 4,
			visible = false,
			MultiplierLabel = Resources.GameLabelChunkier:new {
				resource = "GameLabelChunkier",
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = {0,0},
				text = STRINGS("1x"),
				widthLimit = Layout{20,iphone4=16,ipad=16},
				font	= Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontSize = 20,
				},
			},
		},
		
		Resources.AppButton:new {
			name = "ScoreContainer",
			resource = "AppButton",
			zorder = 2,
			image =  Layout{"GamePanel_ScoreMeter_Banner_medium.png",iphone4="GamePanel_ScoreMeter_Banner_medium.png",iphone5="GamePanel_ScoreMeter_Banner_medium.png",ipad="GamePanel_ScoreMeter_Banner.png"},
			alignment = ConfigPick{Layout{"TopRight", iphone5="TopRight", ipad="TopRight", pc="TopRight"},
									EnableCCLayout = Layout{"BottomRight", iphone5="BottomRight", ipad="BottomRight", pc="BottomRight"}},
			alignmentOffset = ConfigPick{Layout{{-2, 2}, iphone5={-6,48-36},  ipad={-2, 10}, android={-6,48-36-10}, androidShort={-6+4,48-36-10}, pc={-5,10},},
										EnableCCLayout = Layout{{0,-2}, iphone5={-2,-8},  ipad={-2, -2}, pc={-5,10}}},

			OnButtonClick = function (self, event)
				if self ~= event.button then return false end

				local gameScreen = self.parent.parent.parent
				local rootActor = self.parent.parent
				local allGameViews = self.parent
				local goal = "goal"
				local stats = gameScreen.Stats
				stats.levelName = gameScreen.LevelName 
				stats.levelNumber = gameScreen.LevelNumber
				stats.land = gameScreen.LandNumber
				stats.hiddenLevel = gameScreen.HiddenLevel
				local isLevelGame = gameScreen.IsLevelGame
				AddScriptWithParams(gameScreen,"ShowStarsDialog",rootActor,self,stats,isLevelGame)
			end,

			OnPostSpawn = function (self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			children = {
				GoalText = Resources.GameLabel:new {
					resource = "GameLabel",
					alignment = "MidLeft",
					alignTo = "MidLeft",
					alignmentOffset = Layout{{10, -2},iphone5={10, -2},ipad={10, 0}},

					text = STRINGS("Score:"),
					visible = false,
				},
            
                ScoreLabel = Resources.ScoreCounter:new {
                    useCurrency = false,
                    useComma = true,
                    zorder = 2,
                    
                    alignment = "MidRight",
                    alignTo = "MidRight",
                    alignmentOffset = Layout{{-13, -3},iphone4 = {-13, -2},iphone5 = {-13, -3},pc={-3,8}},
					score = 0,

                    labelProperties = {
						resource = "GameLabelBold",
						fgColor = "Cascade_Black",
						font	= Resources.DialogBoldFont:new{
							resource = "DialogBoldFont",
							fontSize = Layout{18,iphone4=12,ipad=18},
						},
                    },
                },

				StarMeter = Resources.Actor:new {
					resource = "Actor",
					image = Layout{"StarMeter.png",iphone4="StarMeter_medium.png",ipad="StarMeter.png"},
					alpha = 0,
                    alignment = "MidBottom",
                    alignTo = "MidBottom",
					alignmentOffset =  Layout{{-2,8},ipad={-2,8}},
					zorder = 3,
					size = Layout{{254/2,20},iphone4={191/2,20},iphone5={254/2,20},ipad={254/2,20}},

					meterFrame = Resources.Actor:new {
						resource = "Actor",
						image = Layout{"GamePanel_ScoreMeter_Tube.png",iphone4="GamePanel_ScoreMeter_Tube_medium.png",ipad="GamePanel_ScoreMeter_Tube.png"},
						--color = "Cascade_Black",
						size = Layout{{254/2,5},iphone4={191/2,5},iphone5={254/2,5},ipad={254/2,5}},
						alignment = Center,
						alignmentOffset = {0,-2},
						alpha = 150,
						meterBar = Resources.Actor:new {
							resource = "Actor",
							--color = "Cascade_Gold",
							image = Layout{"GamePanel_ScoreMeter_Tube_Fill.png",iphone4="GamePanel_ScoreMeter_Tube_Fill_medium.png",ipad="GamePanel_ScoreMeter_Tube_Fill.png"},
							size = Layout{{0,5},iphone4={0,4},iphone5={0,5},ipad={0,5}},
							alignment = TopLeft,
							alignmentOffset = {0,0},
						},
						visible = true,
						zorder = 1,
					},
					Star1 = Resources.StarMeterStar:new {
						resource = "StarMeterStar",
						workerImage = Resources.StarMeterWorker:new {
							resource = "StarMeterWorker",
						},
						quickQuestCup = Resources.QuickQuestCup:new {
							resource = "QuickQuestCup",
						},
					},
					Star2 = Resources.Actor:new {
						resource = "StarMeterStar",
						workerImage = Resources.StarMeterWorker:new {
							resource = "StarMeterWorker",
						},
						quickQuestCup = Resources.QuickQuestCup:new {
							resource = "QuickQuestCup",
						},
					},
					Star3 = Resources.Actor:new {
						resource = "StarMeterStar",
						workerImage = Resources.StarMeterWorker:new {
							resource = "StarMeterWorker",
						},
						quickQuestCup = Resources.QuickQuestCup:new {
							resource = "QuickQuestCup",
						},
					},
				},
            },
        },

		Resources.AppButton:new {
			name = "TopScoresContainer",
			resource = "AppButton",
			image = "GamePanel_ScoreMeter_Banner.png",
			useFrames = false,
			alpha = 0, -- just use file for size
			alignment =  ConfigPick{Layout{"TopLeft", iphone5="TopLeft", ipad="TopLeft"},
									EnableCCLayout = Layout{"TopRight", iphone5="TopRight", ipad="TopRight"}},
			alignmentOffset = ConfigPick{Layout{{2,2}, iphone5={6,48-36}, ipad={2,10}, android={6,48-36-10},androidShort={6-4,48-36-10}},
										EnableCCLayout = Layout{{-2,2}, iphone5={-6,48}, ipad={-6,6}}},
			zorder = 2,

			OnButtonClick = function (self, event)
				if self ~= event.button then return false end
				local isLevel = self.LevelGoalContainer.InnerScoreLabel.text ~= ""
				local isChallenge = self.GoalContainer.InnerScoreLabel.score > 0

				local gameScreen = self.parent.parent.parent
				local rootActor = self.parent.parent
				local allGameViews = self.parent
				local goal = "goal"
				local stats = gameScreen.Stats
				stats.levelName = gameScreen.LevelName 
				stats.levelNumber = gameScreen.LevelNumber
				stats.land = gameScreen.LandNumber
				stats.hiddenLevel = gameScreen.HiddenLevel
				local isLevelGame = gameScreen.IsLevelGame
				AddScriptWithParams(gameScreen,"ShowGoalDialog",rootActor,gameScreen.LevelGoalText1,gameScreen.LevelGoalText2,self,stats,isLevelGame)
			end,

			OnPostSpawn = function (self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			--scripts = {"PanelFlip"},

			LevelGoalContainer = Resources.Actor:new {
				image = Layout{"GamePanel_ScoreMeter_Banner.png",iphone4="GamePanel_ScoreMeter_Banner_medium.png",ipad="GamePanel_ScoreMeter_Banner.png"},
				visible = false,

				GoalText = Resources.Label:new {
					class = "Label",
					resource = "Label",
					alignment = "MidLeft",
					alignTo = "MidLeft",
					alignmentOffset = {14, 0},
					text = STRINGS(""),
					fgColor = "Cascade_Black",
					shadowColor = "Black",
					shadowOffset = {1, 1},
					font = {
						fontName = "dabd____.ttf",
						fontSize = 18,
					},
				},

				InnerScoreLabel = Resources.InnerScoreLabel:new {
					resource = "InnerScoreLabel",
                    
					alignment = "Center",
					alignTo = "Center",
					alignmentOffset = Layout{{0, 0},iphone5={0,0}},
					wrapLimit = Layout{135,iphone4=100,iphone5=135,ipad=135},
					heightLimit = Layout{30,iphone4=20,iphone5=27,ipad=26},

					text = STRINGS(""),
				},
				InnerCheckMark = Resources.Actor:new {
					resource = "Actor",
					image = "Check.png",
					extraScale = 0.5,
					alignment = Center,
					alignTo = Center,
					alignmentOffset = {0,0},
					zorder = 10,
					visible = false,
				},
			},
				
			GoalContainer = Resources.Actor:new {
				image = "GamePanel_ScoreMeter_Banner.png",
				visible = false,

				GoalText = Resources.GameLabelBold_smaller:new {
					resource = "GameLabelBold_smaller",
					alignment = "MidLeft",
					alignTo = "MidLeft",
					alignmentOffset = {6, 0},
					text = STRINGS("Goal:"),
                    widthLimit = 40,
				},

				InnerScoreLabel = Resources.ScoreCounter:new {
					useCurrency = false,
					useComma = true,
					zorder = 2,
                    
					alignment = "MidRight",
					alignTo = "MidRight",
					alignmentOffset = {-9, 0},
					score = 0,

					labelProperties = {
						resource = "GameLabelBold_smaller",
						widthLimit = 80,
					},
				},
				InnerCheckMark = Resources.Actor:new {
					resource = "Actor",
					image = "Check.png",
					alignment = MidLeft,
					alignmentOffset = {40,-5},
					zorder = 10,
					visible = false,
				},
			},
				
			TodayContainer = Resources.Actor:new {
				image = "GamePanel_ScoreMeter_Banner.png",
				visible = false,
				GoalText = Resources.Label:new {
					class = "Label",
					resource = "Label",
					alignment = "MidLeft",
					alignTo = "MidLeft",
					alignmentOffset = {10, -1},
					text = STRINGS("Today:"),
					fgColor = "Black",
					shadowColor = "Black",
					shadowOffset = {1, 1},
					shadowAlpha = 100,
					font = {
						fontName = "dabd____.ttf",
						fontSize = 18,
					},
				},
				InnerScoreLabel = Resources.ScoreCounter:new {
					useCurrency = false,
					useComma = true,
					zorder = 2,
                    
					alignment = "MidRight",
					alignTo = "MidRight",
					alignmentOffset = {-9, 0},
					score = 0,

					labelProperties = {
						alignment = "MidRight",
						alignTo = "MidRight",
						alignmentOffset = {-0, -1},
						text = STRINGS(""),
						fgColor = "White",
						shadowColor = "Black",
						shadowOffset = {1, 1},
						shadowAlpha = 100,
						font = {
							fontName = "dabd____.ttf",
							fontSize = 18,
						},
					},
				},
				InnerCheckMark = Resources.Actor:new {
					resource = "Actor",
					image = "Check.png",
					alignment = MidLeft,
					alignmentOffset = {40,-5},
					zorder = 10,
					visible = false,
				},
			},

			AllTimeContainer = Resources.Actor:new {
				image = "GamePanel_ScoreMeter_Banner.png",
				visible = false,

				GoalText = Resources.Label:new {
					class = "Label",
					resource = "Label",
					alignment = "MidLeft",
					alignTo = "MidLeft",
					alignmentOffset = {10, -1},
					text = STRINGS("Top:"),
					fgColor = "Black",
					shadowColor = "Black",
					shadowOffset = {1, 1},
					shadowAlpha = 100,
					font = {
						fontName = "dabd____.ttf",
						fontSize = 18,
					},
				},

				InnerScoreLabel = Resources.ScoreCounter:new {
					useCurrency = false,
					useComma = true,
					zorder = 2,
                    
					alignment = "MidRight",
					alignTo = "MidRight",
					alignmentOffset = {-9, 0},
					score = 0,

					labelProperties = {
						alignment = "MidRight",
						alignTo = "MidRight",
						alignmentOffset = {-0, -1},
						text = STRINGS(""),
						fgColor = "White",
						shadowColor = "Black",
						shadowOffset = {1, 1},
						shadowAlpha = 100,
						font = {
							fontName = "dabd____.ttf",
							fontSize = 14,
						},
					},
				},
				InnerCheckMark = Resources.Actor:new {
					resource = "Actor",
					image = "Check.png",
					alignment = MidLeft,
					alignmentOffset = {40,-5},
					zorder = 10,
					visible = false,
				},
			},
        },

		Resources.AppButton:new {
			name = "LabGoalButton",
			resource = "AppButton",
			image = "LabLevelIcon.png",
			extraScale = 0.65,
			alignment =  Layout{"TopRight", iphone5="TopRight", ipad="TopRight"},
			alignmentOffset = Layout{{35, 35}, iphone5={35, 35}, ipad={38, 35}},
			zorder = 2,
			visible = false,

			helpLabel = Resources.GameLabelBold:new {
				resource = "GameLabelBold",
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = {7, 0},
				text = "?",
				textColor = "White",
				highlightColor = "Cascade_DarkBlue",
				shadowColor = "Cascade_DarkBlue",
				highlightOffset = {1, 1},
				highlightAlpha = 255,
				shadowOffset = {-1, -1},
				shadowAlpha = 255,
				widthLimit = 25,

				font = Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontSize = 30,
				},
			},

			OnButtonClick = function (self, event)
				if self ~= event.button then return false end
		
				local gameScreen = self.parent.parent.parent
				local rootActor = self.parent.parent
				local levelName = gameScreen.LevelName
				local eventScore = gameScreen.EventScore
				AddScriptWithParams(gameScreen, "ShowLabEventGoalDialog", rootActor, self, levelName, eventScore)
			end,

			OnPostSpawn = function (self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,
		},

		Resources.Actor:new {
			name = "RemainingSpinsContainer",
			zorder = 2,
			resource = "Actor",
			--[[
			image = Layout{"GamePanel_Spins.png",iphone5="GamePanel_ScoreMeter_Banner.png",ipad="GamePanel_ScoreMeter_Banner_medium.png"},
			alignment = Layout{"BottomLeft", iphone5="TopLeft", ipad="TopLeft", pc="BottomLeft"},
			alignmentOffset = Layout{{50, -6}, iphone5={6,48}, ipad={2,24}, pc={20,-60}},
			--]]

			image = "GamePanel_Spins.png",
			alignment = Layout{"BottomLeft", iphone5="BottomLeft", ipad="BottomLeft", pc="BottomLeft"},
			alignmentOffset = Layout{{50, -8}, iphone5={50, -8-5}, ipad={45, -6-5}, pc={20,-60}},


			FairyToken1 = Resources.Actor:new {
				resource = "Actor",
				alignment = MidLeft,
				image = "Boost_SpinSaver.png",
				size = {50,50},
				zorder = -1,
				visible = false,
			},
			FairyToken2 = Resources.Actor:new {
				resource = "Actor",
				alignment = Center,
				image = "Boost_SpinSaver.png",
				size = {50,50},
				zorder = -1,
				visible = false,
			},
			FairyToken3 = Resources.Actor:new {
				resource = "Actor",
				alignment = MidRight,
				image = "Boost_SpinSaver.png",
				size = {50,50},
				zorder = -1,
				visible = false,
			},

			SpinsPickaxe = Resources.Actor:new {
				resource = "Actor",
				--alignment = MidRight,
				image = "PickAxe.png",
				--size = {50,50},
				zorder = -1,
				visible = false,
			},

			--[[
			SpinsText = Resources.GameLabelBold_smaller:new {
				resource = "GameLabelBold_smaller",
				--fgColor = "Cascade_White",
				alignment = "MidLeft",
				alignTo = "MidLeft",
				alignmentOffset = Layout{{4, 0},iphone5={34, 0},ipad={14, 0}},
				text = STRINGS("Spins:"),
				widthLimit = 55,
			},
			RemainingSpinsLabel = Resources.GameLabelBold_smaller:new {
				resource = "GameLabelBold_smaller",
				--fgColor = "Cascade_White",
				alignment = "Center",
				alignTo = "MidRight",
				alignmentOffset = Layout{{-14, 0},iphone5={-44,0},ipad={-34,0}},
				text = STRINGS(""),
			},
			--]]

			SpinsText = Resources.GameLabelBold_small:new {
				resource = "GameLabelBold_small",
				--fgColor = "Cascade_White",
				alignment = "MidLeft",
				alignTo = "MidLeft",
				alignmentOffset = {4, 0},
				text = STRINGS("Spins:"),
				widthLimit = 55,
			},
			RemainingSpinsLabel = Resources.GameLabelBold_small:new {
				resource = "GameLabelBold_small",
				--fgColor = "Cascade_White",
				alignment = "Center",
				alignTo = "MidRight",
				alignmentOffset = {-10, 0},
				text = STRINGS(""),
				widthLimit = 19,
			},
		},

		Resources.Actor:new {
			name = "SpecialGemPanel",
			zorder = 2,
			resource = "Actor",
			image = Layout{"GamePanel_ScoreMeter_Banner.png",iphone5="GamePanel_ScoreMeter_Banner.png",ipad="GamePanel_ScoreMeter_Banner_medium.png",iphone4="GamePanel_ScoreMeter_Banner_medium.png",android="GamePanel_ScoreMeter_Banner_medium.png"},
			alignment = Layout{"MidTop", iphone4 = "MidTop", iphone5="MidTop", ipad="MidTop", android="MidTop", androidShort="MidTop",pc="BottomLeft"},
			alignmentOffset = Layout{{50, -6}, iphone4 = {0,2}, iphone5={0,48}, ipad={0,13}, android={0,48-18}, androidShort={0,5}, pc={20,-60}},
				
			-- Use for 1 special gem
			SpecialGem1_1 = Resources.SpecialGem_group1:new {
				resource = "SpecialGem_group1",
				alignment = "Center",
				alignmentOffset = {0,0},
				--size = {44*3,25},
				SpecialGem_label = {
					class = "ScoreCounter",
					labelProperties = {
						widthLimit = 44*3,
					},
				},
				visible = false,
                isPopping = false,
			},

			-- Use for 2 special gems
			SpecialGem2_1 = Resources.SpecialGem_group1:new {
				resource = "SpecialGem_group1",
				alignment = "Center",
				alignmentOffset = {-34,0},
				SpecialGem_label = {
					class = "ScoreCounter",
					labelProperties = {
						widthLimit = 35,
					},
				},
				visible = false,
                isPopping = false,
			},
			SpecialGem2_2 = Resources.SpecialGem_group1:new {
				resource = "SpecialGem_group1",
				alignment = "Center",
				alignmentOffset = {14,0},
				SpecialGem_label = {
					class = "ScoreCounter",
					labelProperties = {
						widthLimit = 35,
					},
				},
				visible = false,
                isPopping = false,
			},

			-- Use for 3 special gems
			SpecialGem3_1 = Resources.SpecialGem_group3:new {
				resource = "SpecialGem_group3",
				alignment = "MidLeft",
				SpecialGem_label = {
					class = "ScoreCounter",
					labelProperties = {
						widthLimit = Layout {35, ipad=30, android=25},
					},
				},
				visible = true,
                isPopping = false,
			},
			SpecialGem3_2 = Resources.SpecialGem_group3:new {
				resource = "SpecialGem_group3",
				alignment = "Center",
				SpecialGem_label = {
					class = "ScoreCounter",
					labelProperties = {
						widthLimit = Layout {35, ipad=30, android=25},
					},
				},
				visible = true,
                isPopping = false,
			},
			SpecialGem3_3 = Resources.SpecialGem_group3:new {
				resource = "SpecialGem_group3",
				alignment = "MidRight",
				SpecialGem_label = {
					class = "ScoreCounter",
					labelProperties = {
						widthLimit = Layout {35, ipad=30, android=25},
					},
				},
				visible = true,
                isPopping = false,
			},

            ResetPopping = function(self)
                self.SpecialGem1_1.isPopping = false
                self.SpecialGem2_1.isPopping = false
                self.SpecialGem2_2.isPopping = false
                self.SpecialGem3_1.isPopping = false
                self.SpecialGem3_2.isPopping = false
                self.SpecialGem3_3.isPopping = false
            end,
		},
		
		Resources.Actor:new {
			name = "TimeLimitLabels",
			alpha = 0, --InvisibleUnlessDebugPlacementIsActive(),
			color = DebugPlacementColor,			
			
			ApplyLayout = function (self, layoutName)
				if layoutName == "top" then
					self.alignment = "MidTop"
					self.alignmentOffset = {50, 1}
					self.size = {70, 30}
					
					self.header.font = {
						fontName = "IT441___.TTF",
						fontSize = 12,
					}
					
					self.body.alignmentOffset = {0, 2}
					self.body.font = {
						fontName = "IT441___.TTF",
						fontSize = 16,
					}
					
				elseif layoutName == "bottom" then
					self.alignment = "MidBottom"
					self.alignmentOffset = {-123,-4}
					self.size = {70, 40}

					self.header.font = {
						fontName = "IT441___.TTF",
						fontSize = 14,
					}
					
					self.body.alignmentOffset = {0, 0}
					self.body.font = {
						fontName = "IT441___.TTF",
						fontSize = 20,
					}
				end
			end,

			OnPostSpawn = function (self)
				self:ApplyLayout("bottom left")
			end,
			
			header = Resources.Label:new {
				resource = "Label",
				alignment = "MidTop",
				alignmentOffset = {0, 0},
				text = STRINGS("TimeLeftHeader"),
				fgColor = "White",
				shadowColor = "Black",
				shadowOffset = {1, 1},
				shadowAlpha = 100,
				font = {
					fontName = "IT441___.TTF",
					fontSize = 14,
				},
				visible = false,	-- HACK: hide the title until proper title art comes in
			},
			
			body = Resources.Label:new {
				resource = "Label",
				alignment = "MidBottom",
				alignmentOffset = {0, 0},
				fgColor = "White",
				shadowColor = "Black",
				shadowOffset = {1, 1},
				shadowAlpha = 100,
				font = {
					fontName = "IT441___.TTF",
					fontSize = 20,
				},
			},
			
			SetValue = function (self, totalSecondsLeft, showAnimations)
				-- Set the label's text:
				local minutesLeft = totalSecondsLeft / 60
				local remainingSecondsLeft = totalSecondsLeft % 60
				self.body.text = string.format("%d:%02d", minutesLeft, remainingSecondsLeft)
				
				-- Set the label's style:
				local highlightAtTime = Config.time_left_highlighting or 15
				if totalSecondsLeft > highlightAtTime then
					self.body.fgColor = "White"
				else
					self.body.fgColor = "Red"
				end
				
				-- Play a sound and an animation, hackishly making sure to only play one per tick.
				-- (Which seemed to be faulty if the app wass backgrounded (by iOS)
				-- at the right moment.)
				if showAnimations == true then
					if APP.tickCount ~= self.lastAppTickOfEffects then
						self.lastAppTickOfEffects = APP.tickCount
						if totalSecondsLeft <= highlightAtTime and totalSecondsLeft >= 0 then
							--logprint("click: "..tostring(totalSecondsLeft)..", "..APP.tickCount)
							PlaySound("click2.ogg")
							RunScriptWithParams(self.body, Pop, {expandTime=150, shrinkTime=80})
						end
					else
						--logprint("ignore click: "..tostring(totalSecondsLeft)..", "..APP.tickCount)
					end
				end
			end,
		},
		
		TrickLauncherPanel  = Resources.Actor:new { 
			resource = "Actor",
			image = "TrickLauncher_base.png",
			alignment = "MidBottom",
			alignmentOffset = {0,10},
			alpha = 255,
			zorder = 2,
			visible = false,

			TrickLauncher = Resources.Actor:new {
				resource = "Actor",
				image = "TrickLauncher.png",
				alignment = "MidBottom",
				alignmentOffset = {0,-25},
				zorder = 1,
				--scripts = {"RotateBackAndForth"},
			},

			FlyingTrick = Resources.Actor:new {
				resource = "Actor",
				image="Trick_SuperMatch.png",
				alignmentOffset = {0,-15},
				alignment = "Center",
				layer = 2,
				visible = false, 
				--size = {40,40},
				--resizeOnSetImage = false,
			},

			TrickLauncher_base = Resources.Actor:new {
				resource = "Actor",
				image = "TrickLauncher_base.png",
				alignment = "MidBottom",
				alignmentOffset = {0,0},
				zorder = 1,
				--scripts = {"RotateBackAndForth"},
			},
		},

		TrickPanel = Resources.Actor:new {
			resource = "Actor",
			image = "GamePanel1.png",
			alignment =  ConfigPick{Layout{"BottomRight",ipad="BottomRight",iphone5="BottomRight"},
									EnableCCLayout = Layout{"TopLeft",ipad="TopLeft",iphone5="TopLeft"}},
			alignTo =   ConfigPick{	Layout{"BottomRight",ipad="BottomRight",iphone5="BottomRight"},
									EnableCCLayout = Layout{"TopLeft",ipad="TopLeft",iphone5="TopLeft"}},
			alignmentOffset = ConfigPick{Layout{{0,2},iphone5={0,-2},ipad={-2,0}},
										EnableCCLayout = Layout{{-0,-10},iphone5={2,40},ipad={-2,0}}},
			layer = 6,
			alpha = 0,
			Trick1Container = Resources.TrickContainer:new {
				resource = "TrickContainer",
				alignmentOffset = Layout{{-42,0}},
			},
			Trick2Container = Resources.TrickContainer:new {
				resource = "TrickContainer",
				alignmentOffset = Layout{{0,0}},
			},
			Trick3Container = Resources.TrickContainer:new {
				resource = "TrickContainer",
				alignmentOffset = Layout{{42,0}},
			},
			OnPostSpawn = function (self)
				self.Trick3Container.alignmentOffset = Layout{{-42,0}}
				self.Trick2Container.alignmentOffset = Layout{{0,0}}
				self.Trick1Container.alignmentOffset = Layout{{42,0}}
			end,
            HasOneTrick = function(self)
                local result = self.Trick1Container.Trick.visible or self.Trick2Container.Trick.visible or self.Trick3Container.Trick.visible
                return result
            end,
		},

		TrickActivePanel = Resources.Actor:new {
			resource = "Actor",
			image = "GamePanel1.png",
			alignmentOffset = Layout{{0,2},iphone5={0,-2},ipad={-2,0}},
			alignment = "MidBottom",
			alignTo = "MidBottom",
			zorder = 2,
			alpha = 0,
			TrickActiveContainer = Resources.TrickContainer:new {
				resource = "TrickContainer",
				alignmentOffset = Layout{{0,0}},
				visible = false,
			},
		},

		--
		-- PIECE-DROP ANIMATION, STARTING CELLS
		--
		Resources.Actor:new {
			name = "AllPieceDropCells",
			resource = "Actor",
			alpha = InvisibleUnlessDebugPlacementIsActive(),
			color = DebugPlacementColor,
			size = {300,350},
			alignment = "MidBottom",
			alignTo = "MidTop",
			--alignment = "MidBottom",
			alignmentOffset = {0,-8},
			cellNameFormat = "PieceDropCell_%d_%d",
			
			InitWithBoardSize = function (self, boardWidth, boardHeight)
				--
				-- Create actors to help position views for individual game
				-- pieces.
				--
				AddPieceDropCellViewsForBoard(self, boardWidth, boardHeight)
			end,
		},
		
		--
		-- BOARD CELL ALIGNMENT
		--
		Resources.Actor:new {
			name = "AllBoardCells",
			resource = "Actor",
			alpha = InvisibleUnlessDebugPlacementIsActive(),
			color = DebugPlacementColor,
			size = Layout{{300,350},pc={300*pc_Scale,350*pc_Scale}},
			--alignment = "MidTop",
            alignment = Layout{"MidTop",android="Center"},
            alignmentOffset =  Layout{{0, 36}, iphone4={0,26}, iphone5={0, 43+iPhone5_GameBoard_NudgeY}, ipad={0, 43+iPad_GameBoard_NudgeY}, android={0, -30},  androidShort={0, -36}, pc={0, 12}},
			InitWithBoardSize = function (self, boardWidth, boardHeight, gameLevel)
				--
				-- Create actors to help position views for individual game
				-- pieces.
				--
				self.boardWidth = boardWidth
				self.boardHeight = boardHeight
				
				-- The slot image to use if one wasn't specified:
				local defaultCellImageName = "slot_6.png"

				-- The slot image to actually use:
				local cellImageName = (gameLevel and gameLevel.cellImage) or defaultCellImageName

				-- Set up the board:
				AddBoardCellViewsForBoard(self, boardWidth, boardHeight, cellImageName, 255)
			end,
		},
		
		--
		-- SLOTS CELL ALIGNMENT
		--
		Resources.Actor:new {
			name = "AllSlotsCells",
			resource = "Actor",
			alpha = InvisibleUnlessDebugPlacementIsActive(),
			color = DebugPlacementColor,
			size = Layout{{300,58},pc={300*pc_Scale,50*pc_Scale}},
			--alignment = "MidTop",
            alignment = Layout{"MidTop",android="Center"},
			alignmentOffset =  Layout { {0, 386+2}, iphone4={0,386+2-6}, iphone5={0, 401+iPhone5_GameBoard_NudgeY+12}, ipad={0, 401+iPad_GameBoard_NudgeY+0}, android={0, 180+2}, androidShort={0, 180-3}, pc={0, 336} },
			
			InitWithBoardSize = function (self, boardWidth, boardHeight, gameLevel)
				--
				-- Create actors to help position views for individual game
				-- pieces.
				--
				self.boardWidth = boardWidth
				self.boardHeight = boardHeight

				-- The slot image to use if one wasn't specified:
				local defaultSlotImageName = ""

				-- The slot image to actually use:
				local slotImageName = (gameLevel and gameLevel.slotImage) or defaultSlotImageName

				AddBoardCellViewsForBoard(self, boardWidth, boardHeight, slotImageName, 255)
			end,
		},
		
		--
		-- COLUMN HIGHLIGHT VIEWS
		--
		Resources.Actor:new {
			name = "AllColumnHighlights",
			resource = "Actor",
			size = {300, 410},
			alignment = "MidTop",
			alignmentOffset = {0, 43},
			
			InitWithBoardSize = function (self, boardWidth, boardHeight)
				local pseudoBoardWidth = boardWidth
				local pseudoBoardHeight = 1
				local cellFactory = function (params)
					--logprint("make white cell")
					local cellResource = Resources.Actor:new {
						resource = "Actor",
						color = "White",
						alpha = 0,
						size = params.cellSize,
						alignment = "Center",
						alignTo = "TopLeft",
						alignmentOffset = {params.centerX, params.centerY},
					}
					local cellView = CreateInstance(cellResource)
					return cellView
				end
				AddBoardCellViewsForBoard(self, pseudoBoardWidth, pseudoBoardHeight, cellFactory)
			end,
		},
				
		--
		-- UNMATCHED SPACE VIEWS
		--
		Resources.Actor:new {
			name = "AllUnmatchedSpaces",
			resource = "Actor",
			alpha = 0,
			autoFillParent = true,
		},

		Resources.Actor:new {
			name = "AllGemEaters",
			resource = "Actor",
			alpha = 0,
			autoFillParent = true,
		},

		--
		-- Barrier Views
		--
		Resources.Actor:new {
			name = "AllBarriers",
			resource = "Actor",
			alpha = 0,
			autoFillParent = true,
			zorder = 4,
		},
		
		--
		-- MATCH ANIMATION VIEWS
		--
		Resources.Actor:new {
			name = "AllMatchAnimations",
			resource = "Actor",
			alpha = 0,
			autoFillParent = true,
		},
		
		--
		-- PIECE VIEWS (for all boards)
		--
		Resources.Actor:new {
			name = "AllGamePieces",
			resource = "Actor",
			alpha = 0,
			autoFillParent = true,
		},
		
		--
		-- SLOT AVAILABILITY VIEWS
		--
		Resources.Actor:new {
			name = "AllSlotAvailabilityViews",
			resource = "Actor",
			alpha = 0,
			autoFillParent = true,
		},
		
		--
		-- SCORE FLASHES
		--
		Resources.Actor:new {
			name = "AllScoreFlashes",
			resource = "Actor",
			alpha = 0,
			autoFillParent = true,
		},

		Resources.GoodJobWord:new {
			name = "FlashWord",
			resource="GoodJobWord",
			localizedLabel = Resources.AppDialogLabel:new {
				resource = "AppDialogLabel",
				alignment = Center,
				alignTo = Center,
				fgColor = {0xff,0xe9,0x60},
				highlightColor = "Cascade_DarkBrown",
				shadowColor = "Cascade_DarkBrown",
				alpha = 255,
				showHighlight = true,
				font	= Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontSize = 50,
				},
			},
		},

		Resources.TapHerePointer:new {
			name = "TapHerePointer",
			resource="TapHerePointer"
		},

		-- Panels

		NoMoreSpinsPanel = Resources.NoMoreSpinsPanel,

		TopBar = Resources.TopBar:new {
			resource = "TopBar",
			visible = false,
		},

		TopBar_SpecialGems = Resources.TopBar_SpecialGems:new {
			resource = "TopBar_SpecialGems",
			visible = false,
			alignmentOffset = Layout{{-2, 20},iphone5={-2, 25},ipad={-2, 25}}, -- Same as normal topbar
		},

		DebugWinButton = Resources.AppButton:new {
			resource = "AppButton",
			image = "btnRoundBlank.png",
			alpha = 50,
			star = Resources.Actor:new {
				resource = "Actor",
				image = "FeatureLock.png",
				alignment = "Center",
				alpha = 96,
			},
			alignment = "MidBottom",
			alignTo = "MidBottom",
			alignmentOffset = {-19,0},
			text = "",
			zorder = 1,
			visible = IsDebugUIAllowed(),
		},

		DebugLoseButton = Resources.AppButton:new {
			resource = "AppButton",
			image = "btnRoundBlank.png",
			alpha = 50,
			star = Resources.Actor:new {
				resource = "Actor",
				image = "btnClose.png",
				alignment = "Center",
				alpha = 96,
			},
			alignment = "MidBottom",
			alignTo = "MidBottom",
			alignmentOffset = {19,0},
			text = "",
			zorder = 1,
			visible = IsDebugUIAllowed(),
		},
	},
}

Resources.GemSwipeDraggable = Resources.Draggable:new {
	resource = "Draggable",
	clickPointIsAnchorPoint = true,
	autoPosition = true,
	alpha = 0,
	size = {4,4},
	clickSound = "",
	clickOffset = {0,0},
	layer = 10,
}

Resources.GemSwipeLine = Resources.Actor:new {
	resource = "Actor",
	image = "GemSwipeEffect.png",
	layer = 10,
	rotationPoint = Center,
}

PatternImageTable = {
	[1] = "PatternSquare_1.png",
	[2] = "PatternSquare_2.png",
	[3] = "PatternSquare_3.png",
	[4] = "PatternSquare_4.png",
	[5] = "PatternSquare_5.png",
}

-- These are special tables that balance out the gradient of the pattern based on how many patterns there are
-- In other words, if we have 2 hits, and use 1 and 2, they will be too light and not different enough
-- But we still need 1..5 for 5 hits
-- Using these tables we can balance out things, so when we only have 2 hits, we can use 2 and 4 so the difference is very noticable
-- And we don't have a 1 all the time, which is very light (but works okay when you have 5)

PatternImageTable1 = {
	[1] = PatternImageTable[3],
}

PatternImageTable2 = {
	[1] = PatternImageTable[2],
	[2] = PatternImageTable[4],
}

PatternImageTable3 = {
	[1] = PatternImageTable[2],
	[2] = PatternImageTable[3],
	[3] = PatternImageTable[4],
}

PatternImageTable4 = {
	[1] = PatternImageTable[1],
	[2] = PatternImageTable[2],
	[3] = PatternImageTable[3],
	[4] = PatternImageTable[4],
}

PatternImageTable5 = {
	[1] = PatternImageTable[1],
	[2] = PatternImageTable[2],
	[3] = PatternImageTable[3],
	[4] = PatternImageTable[4],
	[5] = PatternImageTable[5],
}

Scripts.PortalLoop_in = function(actor)
	local time = 1000
	
	ScriptDelay(1000)
	
	FireParticle(actor,"Portal1_in","MidTop",actor.hgeParticles,{0,10})

	while(true)do
		CorrectedPop(actor,  {expandTime=time, shrinkTime=time, expandTo={1.12, 1.0}})
		--CorrectedPop(actor,  {expandTime=time, shrinkTime=time, expandTo={1.0, 1.12}})
	end
end

Scripts.PortalLoop_out = function(actor)
	local time = 1000
	
	ScriptDelay(1000)

	FireParticle(actor,"Portal1_out","MidTop",actor.hgeParticles,{0,10})

	while(true)do
		CorrectedPop(actor,  {expandTime=time, shrinkTime=time, expandTo={1.12, 1.0}})
		--CorrectedPop(actor,  {expandTime=time, shrinkTime=time, expandTo={1.0, 1.12}})
	end
end

Resources.PortalEntrance_1 = {
	class = "Actor",
	image = "PortalEntrance_1.png",
	alignment = Center,
	PortalFront = {
		class = "Actor",
		image = "PortalEntrance_1_Front.png",
		alignment = TopLeft,
	},
	Glow = {
		class = "Actor",
		image = "PortalEntrance_1_Glow.png",
		alignment = TopLeft,
		scripts = {"PortalLoop_in"},
		hgeParticles = {
			class = "hgeParticleLayer",
			zorder = 100,
			tag = "hgeParticles_tag",
		},
	},
}

Resources.PortalExit_1 = {
	class = "Actor",
	image = "PortalExit_1.png",
	alignment = Center,
	PortalFront = {
		class = "Actor",
		image = "PortalExit_1_Front.png",
		alignment = TopLeft,
	},
	Glow = {
		class = "Actor",
		image = "PortalExit_1_Glow.png",
		alignment = TopLeft,
		scripts = {"PortalLoop_out"},
		hgeParticles = {
			class = "hgeParticleLayer",
			zorder = 100,
			tag = "hgeParticles_tag",
		},
	},
}

Resources.PortalEntrance_1_Wide = {
	class = "Actor",
	resource = "PortalEntrance_1",
	size = {64*3,64,},
}

Resources.PortalExit_1_Wide = {
	class = "Actor",
	resource = "PortalExit_1",
	size = {64*3,64,},
}