local loadingImg = ""
local loadingText = ""
if Language == "en" then
    loadingImg = "Loading_small.png"
else
    loadingText = STRINGS("Loading")
end

Resources.LoadingLayer = Resources.Actor:new {
    name = "Loading",
	resource = "Actor",
	size={200,120},
	alignment = "MidBottom",
	alignTo = "MidBottom",
	loadingLabel = Resources.Actor:new {
		resource = "Actor",
		image = loadingImg,
		alignment = Center,
	},
    localizedLabel = Resources.Label:new {
				resource = "Label",
				alignment = Center,
				alignTo = Center,
				fgColor = {0xff,0xe9,0x60},
				highlightColor = "White",
				shadowColor = "Cascade_DarkBrown",
				alpha = 255,
				showHighlight = true,
				font	= Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontSize = 30,
				},
              text = loadingText
			},
	alpha = 0,
	color = "Black",
	visible = false,
	rolloverable = true,
	layer = 500,
}

Resources.DialogTitleLabel = Resources.Label:new
{
	class = "Label",
	font = Resources.AppDialogTitleFont:new{
		resource = "AppDialogTitleFont",
	},
	alignment = MidTop,
	alignmentOffset = {0,80},
	fgColor = "White",
}

Resources.DialogLabel = Resources.Label:new {
	resource = "Label",
	font = Resources.DialogFont:new{
		resource = "DialogFont",
	},
	fgColor = "White",
}

Resources.AwardNameLabel = Resources.DialogLabel:new {
	resource = "DialogLabel",
	fgColor = "Black",
	alignment = Center,
	alignmentOffset = {0,0},
	lineSpacing = 10,
	wrapLimit = 50,
}

Resources.GameLabelChunkier = Resources.Label:new {
	resource = "Label",
	text = STRINGS(""),
	fgColor = "Cascade_Black",
	highlightColor = "Cascade_Grey",
	highlightOffset = {1, 1},
	highlightAlpha = 0,
	shadowColor = "Cascade_Shadow",
	shadowOffset = {-1, -1},
	shadowAlpha = 0,
	font	= Resources.AppButtonFont:new{
		resource = "AppButtonFont",
		fontSize = 36,
	},
}

Resources.AppDialogLabel = Resources.DialogLabel:new {
	resource = "DialogLabel",
	fgColor = "Cascade_DarkBrown",
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
	},
}

Resources.AppDialogLabel_small = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
		fontSize = 22,
	},
}

Resources.AppDialogDataLabel = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	font	= Resources.DialogFont:new{
		resource = "DialogFont",
		fontSize = 22,
	},
}

Resources.AppDialogDataLabel_small = Resources.AppDialogDataLabel:new {
	resource = "AppDialogDataLabel",
	font	= Resources.DialogFont:new{
		resource = "DialogFont",
		fontSize = 20,
	},
}

Resources.AppDialogDataLabel_smaller = Resources.AppDialogDataLabel:new {
	resource = "AppDialogDataLabel",
	font	= Resources.DialogFont:new{
		resource = "DialogFont",
		fontSize = 18,
	},
}

Resources.AppDialogSmallLabel = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	font	= Resources.DialogFont:new{
		resource = "DialogFont",
		fontSize = 18,
	},
}

Resources.AppDialogTinyLabel = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	font	= Resources.DialogFont:new{
		resource = "DialogFont",
		fontSize = 16,
	},
}

Resources.AppDialogBoldLabel = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
	},
}

Resources.AppDialogBoldLabel_small = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
		fontSize = 22,
	},
	highlightColor = "Cascade_White",
	highlightOffset = {-1,-1},
	highlightAlpha = 50,
	shadowColor = "Cascade_White",
	shadowAlpha = 150,
	shadowOffset = {1,1},
}

Resources.AppDialogBigBoldLabel_white = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	font	= Resources.DialogBoldFont:new{
		resource = "DialogBoldFont",
		fontSize = 70,
	},
	fgColor = "White",
	highlightColor = "DarkBlue",
	highlightOffset = {-1,-1},
	highlightAlpha = 255,
	shadowColor = "DarkBlue",
	shadowAlpha = 255,
	shadowOffset = {1,1},	
}

Resources.AppTitleDialogLabel = Resources.DialogLabel:new {
	resource = "DialogLabel",
	fgColor = "Cascade_DarkBrown",
	highlightColor = "Cascade_White",
	highlightOffset = {-1,-1},
	highlightAlpha = 50,
	shadowColor = "Cascade_White",
	shadowAlpha = 150,
	shadowOffset = {1,1},
	font	= Resources.DialogTitleFont:new{
		resource = "DialogTitleFont",
	},
}

Resources.AppTitleDialogLabel_UI2 = Resources.DialogLabel:new {
	resource = "DialogLabel",
	fgColor = "Cascade_DarkBrown",
	highlightColor = "Cascade_White",
	highlightOffset = {-1,-1},
	highlightAlpha = 50,
	shadowColor = "Cascade_White",
	shadowAlpha = 150,
	shadowOffset = {1,1},
	font	= Resources.DialogTitleFont:new{
		resource = "DialogTitleFont",
		fontSize = 22,
	},
	alignment = MidTop,
	alignmentOffset = {0, 4},
	widthLimit = 200,
}

Resources.AppTitleDialogLabel_UI2_bigger = Resources.DialogLabel:new {
	resource = "DialogLabel",
	fgColor = "Cascade_DarkBrown",
	highlightColor = "Cascade_White",
	highlightOffset = {-1,-1},
	highlightAlpha = 50,
	shadowColor = "Cascade_White",
	shadowAlpha = 150,
	shadowOffset = {1,1},
	font	= Resources.DialogTitleFont:new{
		resource = "DialogTitleFont",
		fontSize = 26,
	},
	alignment = MidTop,
	alignmentOffset = {0, 6},
	widthLimit = 200,
}

Resources.AppTitleDialogLabel_big = Resources.AppTitleDialogLabel:new {
	resource = "AppTitleDialogLabel",
	highlightColor = "Cascade_White",
	highlightOffset = {-1,-1},
	highlightAlpha = 150,
	shadowColor = "Cascade_White",
	shadowAlpha = 150,
	shadowOffset = {1,1},
	font	= Resources.DialogTitleFont_big:new{
		resource = "DialogTitleFont_big",
	},
}

Resources.AppTitleDialogLabel_bigger = Resources.AppTitleDialogLabel:new {
	resource = "AppTitleDialogLabel",
	font	= Resources.DialogTitleFont_bigger:new{
		resource = "DialogTitleFont_bigger",
	},
}

Resources.AppTitleDialogLabel_small = Resources.DialogLabel:new {
	resource = "DialogLabel",
	fgColor = "Cascade_DarkBrown",
	highlightColor = "Cascade_White",
	highlightOffset = {-1,-1},
	highlightAlpha = 50,
	shadowColor = "Cascade_White",
	shadowAlpha = 150,
	shadowOffset = {1,1},
	font	= Resources.DialogTitleFont_small:new{
		resource = "DialogTitleFont_small",
	},
}

Resources.AppTitleDialogLabel_smaller = Resources.AppTitleDialogLabel_small:new {
	resource = "AppTitleDialogLabel_small",
	font	= Resources.DialogTitleFont_smaller:new{
		resource = "DialogTitleFont_smaller",
	},
}

Resources.AppDialogSmallLabel = Resources.DialogLabel:new {
	resource = "DialogLabel",
	fgColor = "Cascade_DarkBrown",
	font	= Resources.DialogFont:new{
		resource = "DialogFont",
		fontSize = 20,
	},
}


Resources.TextLabel = Resources.AppDialogSmallLabel:new {
	resource = "AppDialogSmallLabel",
	alignment = Center,
	alignTo = MidTop,
	alignmentOffset = {0,280},
	wrapLimit = 250,
	--lineSpacing = 10,
}
