local LARGE__NUM_MIDDLE_PIECES = 3
local LARGE__MIDDLE_PIECES_Y_OFFSET = -18

local LARGE__TOP_PIECE_HEIGHT = 42
local LARGE__MIDDLE_PIECE_HEIGHT = 38
local LARGE__BOTTOM_PIECE_HEIGHT = 42

local LARGE__WIDTH = 278


Resources.NoteBubbleButton = Resources.AppButtonSmall:new {
	resource = "AppButtonSmall",
	image = "SmallWhiteButton.png",
}

local bottom_button = -2

Resources.NoteBubbleLeftButton = Resources.NoteBubbleButton:new
{
	resource = "NoteBubbleButton",
	alignment = "MidLeft",
	alignmentOffset = {10, bottom_button},  -- WARNING: Limit platform-specific edits to this to platform-specific areas!
	clickSound = "TinyClick.ogg",
}

Resources.NoteBubbleCenterButton = Resources.NoteBubbleButton:new
{
	resource = "NoteBubbleButton",
	alignment = "MidBottom",
	alignmentOffset = {0, bottom_button},  -- WARNING: Limit platform-specific edits to this to platform-specific areas!
	clickSound = "TinyClick.ogg",
}

Resources.NoteBubbleCenterBottomButton = Resources.NoteBubbleButton:new
{
	resource = "NoteBubbleButton",
	alignment = "MidBottom",
	alignmentOffset = {0, bottom_button},  -- WARNING: Limit platform-specific edits to this to platform-specific areas!
	clickSound = "TinyClick.ogg",
}

Resources.NoteBubbleRightButton = Resources.NoteBubbleButton:new
{
	resource = "NoteBubbleButton",
	alignment = "MidRight",
	alignmentOffset = {-10, bottom_button + 8},  -- WARNING: Limit platform-specific edits to this to platform-specific areas!
	clickSound = "TinyClick.ogg",
}

Resources.NoteBubbleButtonSet = Resources.Actor:new
{
	size = {LARGE__WIDTH, 4},
	color = "Green",
	alpha = 0, --64,
	alignment = "MidBottom",
	alignmentOffset = {0, bottom_button},
	children = 
	{
		leftButton = Resources.NoteBubbleLeftButton,
		rightButton = Resources.NoteBubbleRightButton,
	},
	zorder = 5,
}

Resources.NoteBubbleButtonSet0 = Resources.Actor:new
{
	name = "NoteBubbleButtonSet",
	size = {LARGE__WIDTH, 4},
	color = "Green",
	alpha = 0, --64,
	alignment = "MidBottom",
	alignmentOffset = {0, bottom_button},
}

Resources.NoteBubbleButtonSet1 = Resources.Actor:new
{
	name = "NoteBubbleButtonSet",
	size = {LARGE__WIDTH, 4},
	color = "Green",
	alpha = 0, --64,
	alignment = "MidBottom",
	alignmentOffset = {0, bottom_button},
	children = 
	{
		centerButton = Resources.NoteBubbleRightButton,
	},
	zorder = 5,
}

Resources.NoteBubbleButtonSet3 = Resources.Actor:new
{
	name = "NoteBubbleButtonSet",
	size = {LARGE__WIDTH, 4},
	color = "Green",
	alpha = 0, --64,
	alignment = "MidBottom",
	alignmentOffset = {0, bottom_button},
	children = {
		leftButton = Resources.NoteBubbleLeftButton,
		centerButton = Resources.NoteBubbleCenterButton,
		rightButton = Resources.NoteBubbleRightButton,
	},
	zorder = 5,
}

Resources.NoteBubbleMainText = Resources.Label:new {
	resource = "Label",
	font = Resources.NoteBubbleFont:new {
		resource = "NoteBubbleFont",
	},
	fgColor = "Cascade_Black",
	alignment = "Center",
	alignTo = "Center",
	alignmentOffset = {0,10},
	--centerWrap = true,
	wrapLimit = 250,
	heightLimit = 250,
}

Resources.NoteBubbleMainTextContainer = Resources.Button:new {
	resource = "Button",
	useFrames = false,
	image = "",
	alpha = 0,
	clickOffset = {0,0},
	text = STRINGS(""),
	size = {LARGE__WIDTH - (20), 
		LARGE__TOP_PIECE_HEIGHT
			+ (LARGE__MIDDLE_PIECE_HEIGHT * LARGE__NUM_MIDDLE_PIECES) + LARGE__MIDDLE_PIECES_Y_OFFSET
			+ LARGE__BOTTOM_PIECE_HEIGHT - (20)},
	alignment = "Center",
	alignmentOffset = {0,10},
	zorder = 5,
	MainText = Resources.NoteBubbleMainText,
}

Resources.SmallNoteBubbleMainText = Resources.Label:new {
	resource = "Label",
	font = Resources.NoteBubbleFont:new {
		resource = "NoteBubbleFont",
	},
	fgColor = "Cascade_Black",
	alignment = "Center",
	alignTo = "Center",
	alignmentOffset = {0,0},
    wrapLimit = 290,
    heightLimit = 175 - 60,
}

Resources.SmallNoteBubbleTextContainer = Resources.Button:new {
	resource = "Button",
	useFrames = false,
	image = "",
	alpha = 0,
	clickOffset = {0,0},
	text = STRINGS(""),
	size = {280,175/2},
	alignment = "Center",
	alignmentOffset = {0,14,},
	active = false,
	zorder = 5,
	MainText = Resources.SmallNoteBubbleMainText,
}

Resources.LargeNoteBubble = Resources.Actor:new{
	class = "NoteBubble",
	zorder = 101,
	cornerMargin = {16,16},

	DialogCharacter = Resources.DialogCharacter:new {
		resource = "DialogCharacter",
		alignmentOffset = {40,10},
		zorder = 1,
	},
	
	size = {
		LARGE__WIDTH,
		LARGE__TOP_PIECE_HEIGHT
			+ (LARGE__MIDDLE_PIECE_HEIGHT * LARGE__NUM_MIDDLE_PIECES) + LARGE__MIDDLE_PIECES_Y_OFFSET
			+ LARGE__BOTTOM_PIECE_HEIGHT
	},

	body = Resources.Actor:new {
		resource = "Actor",
		size = {
			LARGE__WIDTH,
			LARGE__TOP_PIECE_HEIGHT
				+ (LARGE__MIDDLE_PIECE_HEIGHT * LARGE__NUM_MIDDLE_PIECES) + LARGE__MIDDLE_PIECES_Y_OFFSET
				+ LARGE__BOTTOM_PIECE_HEIGHT
		},
		alpha = 0,

		body = Resources.Actor:new {
			resource = "Actor",
			image = "Bubble.png",
		}

		--[[
		top = Resources.Actor:new {
			resource = "Actor",
			zorder = 1,
			image = "objBubble.Long.Soft.Top.png",
		},
		
		middle_pieces = Resources.Actor:new {
			resource = "Actor",
			position = {0, 42},
			alpha = 0,
			
			piece_1 = Resources.Actor:new {
				resource = "Actor",
				image = "objBubble.Long.Soft.Middle.png",
				position = {0, LARGE__MIDDLE_PIECE_HEIGHT * 0},
			},
			
			piece_2 = Resources.Actor:new {
				resource = "Actor",
				image = "objBubble.Long.Soft.Middle.png",
				position = {0, LARGE__MIDDLE_PIECE_HEIGHT * 1},
			},
			
			piece_3 = Resources.Actor:new {
				resource = "Actor",
				image = "objBubble.Long.Soft.Middle.png",
				position = {0, LARGE__MIDDLE_PIECE_HEIGHT * 2},
			},
		},
		
		bottom = Resources.Actor:new {
			resource = "Actor",
			zorder = 1,
			image = "objBubble.Long.Soft.Bottom.png",
			position = {
				0,
				LARGE__TOP_PIECE_HEIGHT + (LARGE__MIDDLE_PIECE_HEIGHT * LARGE__NUM_MIDDLE_PIECES) + LARGE__MIDDLE_PIECES_Y_OFFSET
			},
		},
		--]]
	},
	
	BubbleCloseButton = Resources.NoteBubbleCloseButton:new{
		resource = "NoteBubbleCloseButton",
		image = "Btn_Exit.png",
		alignmentOffset = {-6,6},
		visible = false,
	},
	
	bubbleArrowRightBlocker = Resources.Actor:new {
		resource = "Actor",
		size = {10,35},
		color = "White",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = {7, 0},
		zorder = 4,
	},
	
	bubbleArrowRight = Resources.NoteBubbleArrowRight,
	
	bubbleArrowLeftBlocker = Resources.Actor:new {
		resource = "Actor",
		size = {10,35},
		color = "White",
		alignment = "MidRight",
		alignTo = "MidRight",
		alignmentOffset = {-7, 0},
		zorder = 4,
	},
	
	bubbleArrowLeft = Resources.NoteBubbleArrowLeft,
	
	bubbleArrowTopBlocker = Resources.Actor:new {
		resource = "Actor",
		size = {35,10},
		color = "White",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 7},
		zorder = 4,
	},
	
	bubbleArrowTop = Resources.NoteBubbleArrowTop,
	
	bubbleArrowBottomBlocker = Resources.Actor:new {
		resource = "Actor",
		size = {35,10},
		color = "White",
		alignment = "MidBottom",
		alignTo = "MidBottom",
		alignmentOffset = {0, -7},
		zorder = 4,
	},
	
	bubbleArrowBottom = Resources.NoteBubbleArrowBottom,

	MainTextContainer = Resources.NoteBubbleMainTextContainer,
}

Resources.SmallNoteBubble = Resources.Actor:new{
	class = "NoteBubble",
	zorder = 101,
	cornerMargin = {0,0},
	
	size = {320,175/2},
	image = "TutorialBox.png",
	
	MoleGuy = {
		class = "Actor",
		alignment = MidLeft,
		alignTo = MidRight,
		alignmentOffset = {-100,140},
		image = "FLIP_Jasper_Animate_Menu_BODY_with-Eyes-Mouth.png",
		nonPointingArm = {
			class = "Actor",
			image = "FLIP_Jasper_Animate_Menu_Right_Arm_Low.png",
		},
		pointingArm = {
			class = "Actor",
			image = "FLIP_Jasper_Animate_Menu_Left_Arm_Point.png",
			zorder = -1,
		},
	},

	BubbleCloseButton = {
		class = "Button",
		image = "",
		active = false,
	},

	MainTextContainer = Resources.SmallNoteBubbleTextContainer,
}

Resources.SmallNoteBubbleWithOkay = Resources.SmallNoteBubble:new{
	resource = "SmallNoteBubble",

	MainTextContainer = Resources.SmallNoteBubbleTextContainer,

	
	MoleGuy = {
		class = "Actor",
		pointingArm = {
			class = "Actor",
			image = "FLIP_Jasper_Animate_Menu_Left_Arm_Wave.png",
			zorder = -1,
		},
	},
}

Resources.AppNoteBubble = Resources.LargeNoteBubble:new {
	resource = "LargeNoteBubble",
	
	bubbleArrowRightBlocker = {
		class = "Actor",
		alignmentOffset = {7, 0},
		size = {14,35},
		alpha = 0,
		visible = false,
	},
	
	bubbleArrowRight = {
		class = "Actor",
		image = "objBubble.Soft.Arrow.png",
		alignmentOffset = {21, 0},
		scripts = {"AppPointRight"},
	},
	
	bubbleArrowLeftBlocker = {
		class = "Actor",
		alignmentOffset = {-7, 0},
		size = {14,35},
		alpha = 0,
		visible = false,
	},
	
	bubbleArrowLeft = {
		class = "Actor",
		image = "objBubble.Soft.Arrow.png",
		alignmentOffset = {-21, 0},
		scripts = {"AppPointLeft"},
	},
	
	bubbleArrowTopBlocker = {
		class = "Actor",
		alignmentOffset = {0, 7},
		size = {35,14},
		alpha = 0,
		visible = false,
	},
	
	bubbleArrowTop = {
		class = "Actor",
		image = "objBubble.Soft.Arrow.png",
		alignmentOffset = {0, 10},
		scripts = {"AppPointUp"},
	},
	
	bubbleArrowBottomBlocker = {
		class = "Actor",
		alignmentOffset = {0, -7},
		size = {35,14},
		alpha = 0,
		visible = false,
	},
	
	bubbleArrowBottom = {
		class = "Actor",
		image = "objBubble.Soft.Arrow.png",
		alignmentOffset = {0, 10},
		scripts = {"AppPointDown"},
	},
    
    MainTextContainer = {
        class = "Button",
        MainText = {
            class = "Label",
            font = Resources.NoteBubbleFont:new {
                resource = "NoteBubbleFont",
            },
        },
    },
}

Resources.SmallAppNoteBubble = Resources.SmallNoteBubble:new {
	resource = "SmallNoteBubble",
	
	bubbleArrowRightBlocker = {
		class = "Actor",
		alignmentOffset = {7, 0},
		size = {14,35},
		visible = false,
	},
	
	bubbleArrowRight = {
		class = "Actor",
		image = "objBubble.Soft.Arrow.png",
		alignmentOffset = {21, 0},
		scripts = {"AppPointRight"},
	},
	
	bubbleArrowLeftBlocker = {
		class = "Actor",
		alignmentOffset = {-7, 0},
		size = {14,35},
		visible = false,
	},
	
	bubbleArrowLeft = {
		class = "Actor",
		image = "objBubble.Soft.Arrow.png",
		alignmentOffset = {-21, 0},
		scripts = {"AppPointLeft"},
	},
	
	bubbleArrowTopBlocker = {
		class = "Actor",
		alignmentOffset = {0, 7},
		size = {35,14},
		visible = false,
	},
	
	bubbleArrowTop = {
		class = "Actor",
		image = "objBubble.Soft.Arrow.png",
		alignmentOffset = {0, 10},
		scripts = {"AppPointUp"},
	},
	
	bubbleArrowBottomBlocker = {
		class = "Actor",
		alignmentOffset = {0, -7},
		size = {35,14},
		visible = false,
	},
	
	bubbleArrowBottom = {
		class = "Actor",
		image = "objBubble.Soft.Arrow.png",
		alignmentOffset = {0, 10},
		scripts = {"AppPointDown"},
	},
    
    MainTextContainer = {
        class = "Button",
        MainText = {
            class = "Label",
            font = Resources.NoteBubbleFont:new {
                resource = "NoteBubbleFont",
            },
        },
    },
}

Resources.AppNoteBubble_noCharacter = Resources.AppNoteBubble:new {
	resource = "AppNoteBubble",

	DialogCharacter = {
		class = "Actor",
		visible = false,
	},	
	
}

local appArrowPointSpan = 5

Scripts.AppPointDown = function (arrow)
	arrow:KillTaggedScripts("PointDown")
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x,currentPosition.y+appArrowPointSpan}
	local loopCount = 1
	while true do
		SlideAndWait(arrow, adjustPosition, arrowPointTime)
		SlideAndWait(arrow, currentPosition, arrowPointTime)
	end
end

Scripts.AppPointUp = function (arrow)
	arrow:KillTaggedScripts("PointUp")
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x,currentPosition.y-appArrowPointSpan}
	local loopCount = 1
	while true do
		SlideAndWait(arrow, adjustPosition, arrowPointTime)
		SlideAndWait(arrow, currentPosition, arrowPointTime)
	end
end


Scripts.AppPointLeft = function (arrow)
	arrow:KillTaggedScripts("PointLeft")
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x-appArrowPointSpan,currentPosition.y}
	local loopCount = 1
	while true do
		SlideAndWait(arrow, adjustPosition, arrowPointTime)
		SlideAndWait(arrow, currentPosition, arrowPointTime)
	end
end


Scripts.AppPointRight = function (arrow)
	arrow:KillTaggedScripts("PointRight")
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x+appArrowPointSpan,currentPosition.y}
	local loopCount = 1
	while true do
		SlideAndWait(arrow, adjustPosition, arrowPointTime)
		SlideAndWait(arrow, currentPosition, arrowPointTime)
	end
end

Scripts.DelayedShow = function(bubble)
	ScriptDelay(250)
	bubble.visible = true
	--PlaySound("gametip.ogg")
	PlaySound("pop3.ogg")
end
