
AppScriptFiles = {
    -- Colors
    "AppColors.lua",

    -- Strings
    "AppStrings.lua",

    -- Data Model (Player)
    "AppPlayer.lua",
    "NewsFeed.lua",

	-- Misc UI
	"LayoutBox.lua",
	"AppFonts.lua",
	"AppLabels.lua",
	"AppButtons.lua",
	"TopBar.lua",
	"AppDialogs.lua",
	"AppDialogs_GooglePlay.lua",
	"TodoFeed.lua",

    -- Data Model
    "Buildings.lua",
    "DigSpots.lua",
    "FeatureSet.lua",
    "Levels.lua",
    "Levels_Land1.lua",
    "Levels_Land2.lua",
    "Levels_Land3.lua",
    "Levels_Land4.lua",
    "Levels_Land5.lua",
    "Levels_Land6.lua",
    "Levels_Land7.lua",
    "Levels_Land8.lua",
    "Levels_Land9.lua",
    "Levels_Land10.lua",
    "Levels_Land11.lua",
    "Levels_Land12.lua",
    "Levels_Land13.lua",
    "Levels_Land14.lua",
    "Levels_Land15.lua",
    "Levels_Land16.lua",
    "Levels_Land17.lua",
    "Levels_Land18.lua",
    "Levels_Land19.lua",
    "Levels_Land20.lua",
    "Levels_Land21.lua",
    "Levels_Land22.lua",
    "Levels_Land23.lua",
    "Levels_Land24.lua",
    "Levels_Land25.lua",
    "Levels_Land26.lua",
    "Levels_Land27.lua",
    "Levels_Land28.lua",
    "Levels_Land29.lua",
    "Levels_Land30.lua",
    "Levels_Land31.lua",
    "Levels_Land32.lua",
    "Levels_Land33.lua",
    "Levels_Land34.lua",
    "Levels_Events.lua",
    "Levels_alternate.lua",
    "Levels_test.lua",
    "Levels_unused.lua",
    "CascadePatterns.lua",
    "LandMap.lua",
    "Map.lua",

    -- Screens
    "DebugScreen.lua",
    "GameScreen.lua",
    "MenuScreen.lua",
    "MapScreen.lua",
    "AwardScreen.lua",

    -- Game UI and Animations
    "AppGameViews.lua",
    "AppGameAnimations.lua",
    "AppScoreFlash.lua",
    "AppMatchAnimations.lua",

    -- Minigame
    "MiniGames.lua",
    "Fortunes.lua",

    -- Help Messages
    "AppNoteManager.lua",
    "Help.lua",

    -- Cutscenes
    "BubbleBorder.lua",
    "Cutscenes.lua",
}


function InitAppSpecificResourceGroups()
	-- Set up resources to be cached while a game is running.
	APP.physFSManager:AddPathsToGroup(
		RES_MGR,
		"GlobalLoad",
		{
			-- Fonts and font images
			"/App/Fonts/",

			-- Images
			"/App/Images/",

			-- Particle Effects
			"/App/Particle Effects",
		}
	)

	APP.physFSManager:AddPathsToGroup(
		RES_MGR,
		"GameScreen",
		{
			"/App/Fonts",
			"/App/Images/GameElements",
			"/App/Images/Gems",
			"/App/Images/Particles",
			"/App/Images/GoodJobWords",
			"/GuruEngine/Images/Particles",
            
            -- Sounds
            "/App/Sounds/BlingBling.ogg",
			"/App/Sounds/boulder_impact_on_stones_14.ogg",
            "/App/Sounds/Cascade_Fantastic.ogg",
            "/App/Sounds/Cascade_FreeSpin2.ogg",
            "/App/Sounds/Cascade_Outrageous.ogg",
            "/App/Sounds/Cascade_RightOn.ogg",
            "/App/Sounds/Cascade_Yeah.ogg",
            "/App/Sounds/Cascade_Wow2.ogg",
            "/App/Sounds/cave_rocks_crashing_05.ogg",
            "/App/Sounds/cave_rocks_crashing_06.ogg",
            "/App/Sounds/cave_rocks_crashing_07.ogg",
            "/App/Sounds/CLEEP_B.ogg",
            "/App/Sounds/Click1.ogg",
            "/App/Sounds/Click2.ogg",
            "/App/Sounds/Click3.ogg",
            "/App/Sounds/Click4.ogg",
            "/App/Sounds/Click5.ogg",
            "/App/Sounds/crate_smash_01.ogg",
            "/App/Sounds/Hit_MetalRobotPunch1.ogg",
            "/App/Sounds/jail_cell_door_metal_impact_09.ogg",
            "/App/Sounds/large_wood_break_04.ogg",
            "/App/Sounds/laserShot1.ogg",
            "/App/Sounds/Magic_Absorb1.ogg",
            "/App/Sounds/Magic_Absorb3.ogg",
            "/App/Sounds/Magic_CollectorStopSpinning.ogg",
            "/App/Sounds/iOS/Magic_CrystalBlast7.caf",
            "/App/Sounds/Magical_EnergyLoop01.ogg",
            "/App/Sounds/Magic_Respawn_38_short.ogg",
            "/App/Sounds/Move2_down.ogg",
            "/App/Sounds/Move2_up.ogg",
            "/App/Sounds/Mystical_EnergyGlowLoop.ogg",
            "/App/Sounds/paddleChargeUpLoop.ogg",
            "/App/Sounds/Pickup_Coins06.ogg",
            "/App/Sounds/pop_sparkle_01.ogg",
            "/App/Sounds/score1.ogg",
            "/App/Sounds/score2.ogg",
            "/App/Sounds/score3.ogg",
            "/App/Sounds/score4.ogg",
            "/App/Sounds/score5.ogg",
            "/App/Sounds/score6.ogg",
            "/App/Sounds/score7.ogg",
            "/App/Sounds/score8.ogg",
            "/App/Sounds/score9.ogg",
            "/App/Sounds/score10.ogg",
            "/App/Sounds/slot_machine_bet_13.ogg",
            "/App/Sounds/slot_machine_bet_14.ogg",
            "/App/Sounds/slot_machine_bet_15.ogg",
            "/App/Sounds/slot_machine_bet_16.ogg",
            "/App/Sounds/slot_machine_jackpot_win_loop.ogg",
            "/App/Sounds/slot_machine_jackpot_win_hit1.ogg",
            "/App/Sounds/slot_machine_spin_stop_06.ogg",
            "/App/Sounds/slot_machine_wheel_stop_01.ogg",
            "/App/Sounds/slot_machine_win_01_crop2.ogg",
            "/App/Sounds/slot_machine_win_03.ogg",
            "/App/Sounds/slot_machine_win_05.ogg",
            "/App/Sounds/slot_machine_win_08.ogg",
            "/App/Sounds/slot_machine_win_09.ogg",
            "/App/Sounds/slot_machine_win_13.ogg",
            "/App/Sounds/slot_machine_win_21_short2.ogg",
            "/App/Sounds/slot_machine_win_21_short3.ogg",
            "/App/Sounds/slot_machine_win_23.ogg",
            "/App/Sounds/slot_machine_win_23_reverse.ogg",
            "/App/Sounds/swish05.ogg",
            "/App/Sounds/swish10.ogg",
            "/App/Sounds/Win3.ogg",
            "/App/Sounds/Win4.ogg",
            "/App/Sounds/Win5.ogg",
            "/App/Sounds/Win6.ogg",
            "/App/Sounds/Win7.ogg",
            "/App/Sounds/Win8.ogg",
            "/App/Sounds/Win9.ogg",
            "/App/Sounds/Win10.ogg",
            "/App/Sounds/Win11.ogg",

            "/App/Sounds/bwv_sand_paper_set_down_01.ogg",
            "/App/Sounds/magicwand_up5.ogg",
            "/App/Sounds/magicwand_down5.ogg",
            "/App/Sounds/magicwand.ogg",

            "/App/Sounds/iOS/BlingBling.caf",
			"/App/Sounds/iOS/boulder_impact_on_stones_14.caf",
            "/App/Sounds/iOS/Cascade_Fantastic.caf",
            "/App/Sounds/iOS/Cascade_FreeSpin2.caf",
            "/App/Sounds/iOS/Cascade_Outrageous.caf",
            "/App/Sounds/iOS/Cascade_RightOn.caf",
            "/App/Sounds/iOS/Cascade_Yeah.caf",
            "/App/Sounds/iOS/Cascade_Wow2.caf",
            "/App/Sounds/iOS/cave_rocks_crashing_05.caf",
            "/App/Sounds/iOS/cave_rocks_crashing_06.caf",
            "/App/Sounds/iOS/cave_rocks_crashing_07.caf",
            "/App/Sounds/iOS/CLEEP_B.caf",
            "/App/Sounds/iOS/Click1.caf",
            "/App/Sounds/iOS/Click2.caf",
            "/App/Sounds/iOS/Click3.caf",
            "/App/Sounds/iOS/Click4.caf",
            "/App/Sounds/iOS/Click5.caf",
            "/App/Sounds/iOS/crate_smash_01.caf",
            "/App/Sounds/iOS/Hit_MetalRobotPunch1.caf",
            "/App/Sounds/iOS/jail_cell_door_metal_impact_09.caf",
            "/App/Sounds/iOS/large_wood_break_04.caf",
            "/App/Sounds/iOS/laserShot1.caf",
            "/App/Sounds/iOS/Magic_Absorb1.caf",
            "/App/Sounds/iOS/Magic_Absorb3.caf",
            "/App/Sounds/iOS/Magic_CollectorStopSpinning.caf",
            "/App/Sounds/iOS/Magic_CrystalBlast7.caf",
            "/App/Sounds/iOS/Magic_Respawn_38_short.caf",
            "/App/Sounds/iOS/Magical_EnergyLoop01.caf",
            "/App/Sounds/iOS/Move2_down.caf",
            "/App/Sounds/iOS/Move2_up.caf",
            "/App/Sounds/iOS/Mystical_EnergyGlowLoop.caf",
            "/App/Sounds/iOS/paddleChargeUpLoop.caf",
            "/App/Sounds/iOS/pop_sparkle_01.caf",
            "/App/Sounds/iOS/Pickup_Coins06.caf",
            "/App/Sounds/iOS/score1.caf",
            "/App/Sounds/iOS/score2.caf",
            "/App/Sounds/iOS/score3.caf",
            "/App/Sounds/iOS/score4.caf",
            "/App/Sounds/iOS/score5.caf",
            "/App/Sounds/iOS/score6.caf",
            "/App/Sounds/iOS/score7.caf",
            "/App/Sounds/iOS/score8.caf",
            "/App/Sounds/iOS/score9.caf",
            "/App/Sounds/iOS/score10.caf",
            "/App/Sounds/iOS/slot_machine_bet_13.caf",
            "/App/Sounds/iOS/slot_machine_bet_14.caf",
            "/App/Sounds/iOS/slot_machine_bet_15.caf",
            "/App/Sounds/iOS/slot_machine_bet_16.caf",
            "/App/Sounds/iOS/slot_machine_win_09.caf",
            "/App/Sounds/iOS/slot_machine_win_13.caf",
            "/App/Sounds/iOS/slot_machine_jackpot_win_hit1.caf",
            "/App/Sounds/iOS/slot_machine_jackpot_win_loop.caf",
            "/App/Sounds/iOS/slot_machine_spin_stop_06.caf",
            "/App/Sounds/iOS/slot_machine_wheel_stop_01.caf",
            "/App/Sounds/iOS/slot_machine_win_21_short2.caf",
            "/App/Sounds/slot_machine_win_01_crop2.ogg",
            "/App/Sounds/iOS/slot_machine_win_03.caf",
            "/App/Sounds/iOS/slot_machine_win_05.caf",
            "/App/Sounds/iOS/slot_machine_win_08.caf",
            "/App/Sounds/iOS/slot_machine_win_21_short3.caf",
            "/App/Sounds/iOS/slot_machine_win_23.caf",
            "/App/Sounds/iOS/slot_machine_win_23_reverse.caf",
            "/App/Sounds/iOS/swish05.caf",
            "/App/Sounds/iOS/swish10.caf",
            "/App/Sounds/iOS/Win3.caf",
            "/App/Sounds/iOS/Win4.caf",
            "/App/Sounds/iOS/Win5.caf",
            "/App/Sounds/iOS/Win6.caf",
            "/App/Sounds/iOS/Win7.caf",
            "/App/Sounds/iOS/Win8.caf",
            "/App/Sounds/iOS/Win9.caf",
            "/App/Sounds/iOS/Win10.caf",
            "/App/Sounds/iOS/Win11.caf",

            "/App/Sounds/iOS/coin_magic_03.caf",
            "/App/Sounds/iOS/coin_magic_03_2.caf",
            "/App/Sounds/iOS/coin_magic_03_7.caf",
            "/App/Sounds/iOS/coin_magic_05.caf",
            "/App/Sounds/iOS/coin_magic_05_2.caf",
            "/App/Sounds/iOS/coin_magic_05_7.caf",

            "/App/Sounds/iOS/Hit_MetalRobotPunch1.caf",

            "/App/Sounds/iOS/slot_machine_win_19.caf",
            "/App/Sounds/iOS/Pickup_Key12_short.caf",
            "/App/Sounds/iOS/Cascade_Chimes.caf",
            "/App/Sounds/iOS/jail_cell_door_metal_impact_14.caf",
            "/App/Sounds/iOS/bwv_sand_paper_set_down_01.caf",
            "/App/Sounds/iOS/magicwand_up5.caf",
            "/App/Sounds/iOS/magicwand_down5.caf",
            "/App/Sounds/iOS/magicwand.caf",
		}
	)
end
