
local nudge_bottom_button_y = 1

local columnWidthTabs = 140 
local rowHeightTabs = 40

local columnWidth = 100
local rowHeight = 96

local numAwardPages = 5
local currentAwardPage = 1

Resources.AwardSectionButton = Resources.AppButtonSmall_blue:new{
	resource = "AppButtonSmall_blue",
	pageButton = true,
	wrapLimit = 175,
	alignment = TopLeft,
	alignTo = TopLeft,		
	alignmentOffset = {(columnWidth * 1)/2 ,rowHeight * 0 },
	textAlignmentOffset = {0,0},
	textHighlightAlpha = 0,
	textShadowAlpha = 100,
	useFrames = false,
	font = Resources.AppButtonFont:new{
		resource = "AppButtonFont",
		fontSize = 18,
	},
    OnButtonClick = function (self, event)
		if self ~= event.button then
			return
		end
        local screen = CurrentScreen()
		if self.name == "Previous" then
			if currentAwardPage > 1 then
				Scripts.UpdateAwardPage(screen,currentAwardPage - 1,0)
				return true
			end	
		elseif self.name == "Next" then
			if currentAwardPage < numAwardPages then
				Scripts.UpdateAwardPage(screen,currentAwardPage + 1,0)
				return true
			end
		end
    end,
    OnPostSpawn = function (self)
		self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
	end,
}

Resources.AwardScreen = {
	deviceOrientation = "Portrait",

	TopBar = Resources.TopBar:new {
		resource = "TopBar",
		visible = false,
	},
	
	backgroundImage = Resources.Actor:new {
		resource = "Actor",
		image = LandBackgroundTable[1],
		alignment = "Center",
		scripts = {"SparkleRandomly"},
		zorder = -2,

		AndroidGameBackground = Resources.Actor:new {
			resource = "Actor",
			image = LandBackgroundTable[1],
			alignment = "Center",
			alignTo = "Center",
			zorder = 0,
			visible = Layout{false,android=true},
		},

		OnPostSpawn = function (self)
			self.AndroidGameBackground.image = self.image
			MatchHeightToScreen(self.AndroidGameBackground)
		end,
	},
    
	GameCenterButton = Resources.GameCenterButton:new {
		resource = "GameCenterButton",
		image = "btnGameCenterButton_cascade.png",
		alignment = TopRight,
		alignTo = TopRight,
		alignmentOffset = Layout{{-7, 9}, ipad={-6,8}},
		HandleGameCenterReadyClick = function (self)
			GuruGameCenter_ShowAchievements()
			return true
		end,
	},
		
	BadgeInfo = Resources.Actor:new {
		resource = "Actor",
		alignment = MidTop,
		alignmentOffset = Layout{{0,0},iphone5={0,10}},
		size = Layout{iphone={280,170}},
		image = "AwardPostcard.png",

		Title =  Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
            textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {-42,-50},
			fgColor = "Black",
			widthLimit = 180,
		},

		PageTitle =  Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel_small",
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {30,-40},
			fgColor = "Black",
			--text = STRINGS("Achievements"),
		},

		--[[
		Panel = Resources.Actor:new {
			color = "White",
			alpha = 150,
			size = {1024,120},
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,0},
		},
		]]
		
		AwardImage = 
		{
			class = "Actor",
			alignment = "Center",
			alignTo = "TopRight",
			alignmentOffset = Layout{{-51,50},iphone={-49,48}},
			shaderType = "SHADERTYPE_BLENDCOMBINEDALPHA",
			scripts = {"SparkleRandomly"},
		},
		Text  =  Resources.AppDialogTinyLabel:new {
			resource = "AppDialogTinyLabel",
			wrapLimit = 180,
			textAlignment = "Center",
			alignment = "MidTop",
			alignmentOffset = {-40,75},
			fgColor = "Black",
			heightLimit = 150,
		},

		PageFooter =  Resources.AppDialogTinyLabel:new {
			resource = "AppDialogTinyLabel",
			shadowColor = "Black",
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = Layout{{0, 345+10}, iphone5={0, 395}, ipad={0, 355}, iphone={2, 340}, android = {0,360}, androidShort={0, 342}},
			fgColor = "White",
			widthLimit = 80,
		},
	},
    
    possibleAwardsLabel = Resources.Actor:new{
		color = "White",
		size = {columnWidthTabs * 2,rowHeightTabs * 0},
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = {0,-100},
		alpha = 100,
		zorder = 3,
    },
	

	HelpButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "HelpButton.png",
		shortcutKey = "?",
		functionKey = 282,--SDLK_F1
		alignment = "BottomRight",
		alignmentOffset = Layout{{-6, -3+nudge_bottom_button_y}, iphone5={-6, -3+nudge_bottom_button_y}, ipad={-3, -3+nudge_bottom_button_y}},
		visible = false,
		useFrames = false,
	},

		
    OptionsButton = Resources.Button:new {
		resource = "Button",
		image = "OptionsButton.png",
		useFrames = false,
		alignment = "BottomLeft",
		alignmentOffset = Layout{{6, 0}, iphone5={6, 0}, ipad={3, 0}},

		textColor = "White",
        textAlignmentOffset = {0,-2},
		font = {
			fontName = "fubd____.ttf",
			fontSize = 22,
		},
		textLineSpacing = 4,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:ShowOptionsDialog()
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 1,
	},	

	Previous = Resources.AwardSectionButton:new {
		resource = "AwardSectionButton",
		text = STRINGS("Prev"),
		alignment = "MidBottom",
		alignTo = "MidBottom",
		--alignmentOffset = Layout{ipad={columnWidthTabs * 0 + 20, 18},iphone5={columnWidthTabs * 0 + 15, 0},iphone={columnWidthTabs * 0 + 10, 28}},
		alignmentOffset = {-40-20,0},
		alpha = 128,
	},
	Next = Resources.AwardSectionButton:new {
		resource = "AwardSectionButton",
		alignment = "MidBottom",
		alignTo = "MidBottom",
		text = STRINGS("Next"),
		alignmentOffset = {40-20,0},
		--alignmentOffset = Layout{ipad={columnWidthTabs * 1 + 33, 18},iphone5={columnWidthTabs * 1 + 35, 0},iphone={columnWidthTabs * 1 + 50, 28}},
	},
	
	MenuButton = Resources.AppButtonSmall_green:new {
		resource = "AppButtonSmall_green",
		text = STRINGS("Back"),
		alignment = "BottomRight",
		alignTo = "BottomRight",
		alignmentOffset = Layout{{0,0},iphone5={0,0}},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false
			elseif self.text ~= "Menu" then return false end
			logprint("Do Quit")
			self.screen:DoQuit()
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 2,
		escapeKey = true,
	},	
}

Resources.AwardTemplate = {
	class = "Button",
	resource = "AppButton",
	text = STRINGS(""),
	useFrames = false,
	zorder = 4,
	shaderType = "SHADERTYPE_BLENDCOMBINEDALPHA",
	isNonrectangular = true,
	highlightChild = "AwardHighlight",
	AwardHighlight = Resources.Actor:new {
		--image = "AwardHighlight.png",
		zorder = 2,
		alignment = "Center",
		visible = false,
		alpha = 200,
		shaderType = "SHADERTYPE_BLENDCOMBINEDALPHA",
	},
	AwardShade = Resources.Actor:new {
		--image = "AwardShade.png",
		zorder = 1,
		alignment = "Center",
		visible = false,
		alpha = 128,
		AwardShadeLock = Resources.Actor:new {
			resource = "Actor",
			image = "FeatureLock.png",
			alignment = Center,
		},
	},	

	nameLabel = Resources.AwardNameLabel:new { 
		resource = "AwardNameLabel",
	},
	
	scripts = {"SparkleRandomly"},
}

Resources.LargeAwardProperties = {
	AwardShade = Resources.Actor:new {
		--image = "AwardShade.png",
		zorder = 1,
		alignment = "Center",
		visible = false,
		alpha = 128,
		AwardShadeLock = Resources.Actor:new {
			resource = "Actor",
			image = "FeatureLock.png",
			alignment = Center,
			visible = false,
		},
	},	

	nameLabel = Resources.AwardNameLabel:new { 
		resource = "AwardNameLabel",
	},
}


Scripts.Preshow_AwardScreen = function(screen)
end

Scripts.Present_AwardScreen = function(screen,landNumber)
    Scripts.UpdateAwardPage(screen,1,landNumber)
end

Scripts.Leave_AwardScreen = function(screen,leaveReason)
	--Insert animations here.

	if(leaveReason == "Quit") then 
		screen:DoQuit()
	end
end


local AwardPageNames = {
	"Achievements",
	"Land Stars 1",
	"Land Stars 2",
	"Land Stars 3",
	"Land Stars 4",
}

local AwardPages = {
	["Achievements"] = {
		"AwardCollector",
		"BigScore",
		"CrazyBigScore",
		"GemMaven",
		"BurstWizard",
		"SuperWildPro",
		"MatchMaker",
		"MultiAmazing",
		"ThePlayer",
	},
	["Land Stars 1"] = {
		"StarsLand1",
		"StarsLand2",
		"StarsLand3",
		"StarsLand4",
		"StarsLand5",
		"StarsLand6",
		"StarsLand7",
		"StarsLand8",
		"StarsLand9",
	},    
	["Land Stars 2"] = {
		"StarsLand10",
		"StarsLand11",
		"StarsLand12",
		"StarsLand13",
		"StarsLand14",
		"StarsLand15",
		"StarsLand16",
		"StarsLand17",
		"StarsLand18",
	},  
	["Land Stars 3"] = {
		"StarsLand19",
		"StarsLand20",
		"StarsLand21",
		"StarsLand22",
		"StarsLand23",
		"StarsLand24",
		"StarsLand25",
		"StarsLand26",
		"StarsLand27",
	}, 
	["Land Stars 4"] = {
		"StarsLand28",
		"StarsLand29",
		"StarsLand30",
		"StarsLand31",
		"StarsLand32",
		"StarsLand33",
	},
}

Scripts.UpdateAwardPage = function(screen,pageNum,landNumber)
	if (not (landNumber == 0)) then
		local backgroundImage = screen:FindChild("backgroundImage",true)
		backgroundImage.image = LandBackgroundTable[landNumber]
	end

	local newAwards
	-- Make all items not visible
	for i,n in ipairs(AwardPageNames) do
		local awardPage = AwardPages[n]
		if i == pageNum then
			newAwards = awardPage
			local pageTitle = screen:FindChild("PageTitle",true)
			--pageTitle.text = STRINGS(AwardPageNames[i])
			local pageFooter = screen:FindChild("PageFooter",true)
			pageFooter.text = STRINGS("Page ")..i..STRINGS(" of ")..numAwardPages
		end
		for k,v in ipairs(awardPage) do
			local awardButton = screen:FindChild(v,true)
			awardButton.visible = false
		end
	end
	
	-- Make items on selected page visible
	for k,v in ipairs(newAwards) do
		local awardButton = screen:FindChild(v,true)
		awardButton.visible = true
	end	
	
	-- Save current page 
	currentAwardPage = pageNum

	-- Update highlight tab
	local prevButton = screen:FindChild("Previous",true)
	local nextButton = screen:FindChild("Next",true)
	if pageNum == 1 then
		prevButton.alpha = 128
		prevButton.active = false
	else
		prevButton.alpha = 255
		prevButton.active = true
	end
	if pageNum == numAwardPages then
		nextButton.alpha = 128
		nextButton.active = false
	else
		nextButton.alpha = 255
		nextButton.active = true
	end
end
