
Scripts.DigSpot_sparkle = function(actor)
	local landActor = actor.parent
	local scrollableBackgroundActor = landActor.parent
	
	local launchedParticleEmitter = FireParticle(actor,"ObjectSparkle1","Center",scrollableBackgroundActor.hgeParticleLayer)
	actor.currentEmitter = launchedParticleEmitter
end

Scripts.DigSpot_StopSparkling = function(actor)
	if(actor.currentEmitter ~= nil) then
		actor.currentEmitter:Stop(true)
		actor.currentEmitter = nil
	end
end

function DigSpot(landNumber, params)
	local digSpot = {
		class = "Button",
		text = "",
		useFrames = false,
		image = "Land" .. landNumber .. "_DigSpot.png",
		emptyImage = "Land" .. landNumber .. "_DigSpot_Open.png",
		fullImage = "Land" .. landNumber .. "_DigSpot.png",
		zorder = 10,
		isDigSpot = true,
		clickSound = "ShovelDigDirt.ogg",
	}
	table.insertall(digSpot,params)
	if(Config.Debug_ShowAllDigSpots) then
		digSpot.class = "Draggable"
		digSpot.clickPointIsAnchorPoint = true
		digSpot.NumberLabel = {
			class = "Label",
			alignment = Center,
			text = "1",
			fgColor = "Black",
			font = Resources.Font,
		}
	end

	return digSpot
end

local X = -1

DigSpots = {
	Land3 = {
		DigSpot(3,{position = {259,-8},}),
		DigSpot(3,{position = {119,12},}),
		DigSpot(3,{position = {74,29},}),
		DigSpot(3,{position = {165,140},}),
		DigSpot(3,{position = {175,180},}), --5
		DigSpot(3,{position = {280,250},}),
		DigSpot(3,{position = {145,260},}),
		DigSpot(3,{position = {124,363},}),
		DigSpot(3,{position = {117,440},}),
		DigSpot(3,{position = {114,477},}), --10
		DigSpot(3,{position = {15,560},}),
		DigSpot(3,{position = {300,590},}),
		DigSpot(3,{position = {151,624},}),
		DigSpot(3,{position = {200,645},}),
		DigSpot(3,{position = {133,731},}), --15
		DigSpot(3,{position = {270,750},}),
		DigSpot(3,{position = {78,800},}), 
		DigSpot(3,{position = {125,830},}),
		DigSpot(3,{position = {115,920},}),
		DigSpot(3,{position = {82,1020},}), --20
		DigSpot(3,{position = {260,1030},}),
		DigSpot(3,{position = {45,1105},}),
		DigSpot(3,{position = {109,1087},}),
		DigSpot(3,{position = {160,1200},}),
		DigSpot(3,{position = {40,1254},}),
	},
	Land4 = {
		DigSpot(4,{position = {138,97},}),
		DigSpot(4,{position = {233,64},}),
		DigSpot(4,{position = {240,161},}),
		DigSpot(4,{position = {215,248},}),
		DigSpot(4,{position = {62,343},}), --5
		DigSpot(4,{position = {169,365},}),
		DigSpot(4,{position = {164,428},}),
		DigSpot(4,{position = {219,542},}),
		DigSpot(4,{position = {81,586},}),
		DigSpot(4,{position = {156,566},}), --10
		DigSpot(4,{position = {85,738},}),
		DigSpot(4,{position = {173,726},}),
		DigSpot(4,{position = {262,771},}),
		DigSpot(4,{position = {195,810},}),
		DigSpot(4,{position = {268,996},}), --15
		DigSpot(4,{position = {94,939},}),
		DigSpot(4,{position = {145,940},}),
		DigSpot(4,{position = {206,960},}),
		DigSpot(4,{position = {77,1100},}),
		DigSpot(4,{position = {265,1104},}), --20
		DigSpot(4,{position = {245,1063},}),
		DigSpot(4,{position = {237,1196},}),
		DigSpot(4,{position = {100,1230},}),
		DigSpot(4,{position = {172,1319},}),
		DigSpot(4,{position = {91,1393},}), --25
	},
	Land5 = {
		DigSpot(5,{position = {106,64},}),
		DigSpot(5,{position = {246,194},}),
		DigSpot(5,{position = {194,239},}),
		DigSpot(5,{position = {102,287},}),
		DigSpot(5,{position = {100,366},}), --5
		DigSpot(5,{position = {168,385},}),
		DigSpot(5,{position = {234,469},}),
		DigSpot(5,{position = {186,508},}),
		DigSpot(5,{position = {96 ,553},}),
		DigSpot(5,{position = {102,657},}), --10
		DigSpot(5,{position = {154,650},}),
		DigSpot(5,{position = {222,732},}),
		DigSpot(5,{position = {192,804},}),
		DigSpot(5,{position = {104,953},}),
		DigSpot(5,{position = {141,829},}), --15
		DigSpot(5,{position = {220,1002},}),
		DigSpot(5,{position = {178,1027},}),
		DigSpot(5,{position = {232,1097},}),
		DigSpot(5,{position = {147,992},}),
		DigSpot(5,{position = {146,1168},}), --20
		DigSpot(5,{position = {95 ,1231},}),
		DigSpot(5,{position = {81 ,1268},}),
		DigSpot(5,{position = {126,1283},}),
		DigSpot(5,{position = {165,1317},}),
		DigSpot(5,{position = {122,1406},}), --25
	},
	Land6 = {
		DigSpot(6,{position = {110,20},}),
		DigSpot(6,{position = {119,74},}),
		DigSpot(6,{position = {86,285},}),
		DigSpot(6,{position = {150,289},}),
		DigSpot(6,{position = {266,300},}), --5
		DigSpot(6,{position = {125,258},}),
		DigSpot(6,{position = {198,421},}),
		DigSpot(6,{position = {143,421},}),
		DigSpot(6,{position = {69,467},}),
		DigSpot(6,{position = {69,552},}), --10
		DigSpot(6,{position = {42,595},}),
		DigSpot(6,{position = {32,804},}),
		DigSpot(6,{position = {105,798},}),
		DigSpot(6,{position = {275,881},}),
		DigSpot(6,{position = {178,840},}), --15
		DigSpot(6,{position = {264,925},}),
		DigSpot(6,{position = {279,1023},}),
		DigSpot(6,{position = {227,1011},}),
		DigSpot(6,{position = {287,1133},}),
		DigSpot(6,{position = {273,1200},}), --20
		DigSpot(6,{position = {225,1218},}),
		DigSpot(6,{position = {287,1253},}),
		DigSpot(6,{position = {288,1323},}),
		DigSpot(6,{position = {213,1361},}),
		DigSpot(6,{position = {51,1363},}), --25
	},	
	Land7 = {
		DigSpot(7,{position = {93,44},}),
		DigSpot(7,{position = {248,45},}),
		DigSpot(7,{position = {291,305},}),
		DigSpot(7,{position = {253,234},}),
		DigSpot(7,{position = {76,306},}), --5
		DigSpot(7,{position = {27,346},}),
		DigSpot(7,{position = {301,383},}),
		DigSpot(7,{position = {127,461},}),
		DigSpot(7,{position = {101,564},}),
		DigSpot(7,{position = {167,574},}), --10
		DigSpot(7,{position = {111,648},}),
		DigSpot(7,{position = {256,641},}),
		DigSpot(7,{position = {184,691},}),
		DigSpot(7,{position = {100,746},}),
		DigSpot(7,{position = {250,762},}), --15
		DigSpot(7,{position = {13,809},}),
		DigSpot(7,{position = {101,873},}),
		DigSpot(7,{position = {82,1044},}),
		DigSpot(7,{position = {20,894},}),
		DigSpot(7,{position = {264,1079},}), --20
		DigSpot(7,{position = {17,1139},}),
		DigSpot(7,{position = {40,1085},}),
		DigSpot(7,{position = {40,1191},}),
		DigSpot(7,{position = {144,1197},}),
		DigSpot(7,{position = {289,1207},}), --25
	},	
	Land8 = {
		DigSpot(8,{position = {31,4},}),
		DigSpot(8,{position = {189,22},}),
		DigSpot(8,{position = {296,179},}),
		DigSpot(8,{position = {145,86},}),
		DigSpot(8,{position = {101,291},}), --5
		DigSpot(8,{position = {80,338},}),
		DigSpot(8,{position = {301,294},}),
		DigSpot(8,{position = {287,384},}),
		DigSpot(8,{position = {40,413},}),
		DigSpot(8,{position = {282,613},}), --10
		DigSpot(8,{position = {295,458},}),
		DigSpot(8,{position = {204,618},}),
		DigSpot(8,{position = {211,789},}),
		DigSpot(8,{position = {17,800},}),
		DigSpot(8,{position = {156,860},}), --15
		DigSpot(8,{position = {186,1030},}),
		DigSpot(8,{position = {222,1001},}),
		DigSpot(8,{position = {149,932},}),
		DigSpot(8,{position = {53,1074},}),
		DigSpot(8,{position = {156,1061},}), --20
		DigSpot(8,{position = {117,1118},}),
		DigSpot(8,{position = {289,1099},}),
		DigSpot(8,{position = {41,1232},}),
		DigSpot(8,{position = {295,1209},}),
		DigSpot(8,{position = {157,1366},}), --25
	},
	Land9 = {
		DigSpot(9,{position = {95,-8},}),
		DigSpot(9,{position = {165,16},}),
		DigSpot(9,{position = {103,108},}),
		DigSpot(9,{position = {152,125},}),
		DigSpot(9,{position = {159,210},}), --5
		DigSpot(9,{position = {209,399},}),
		DigSpot(9,{position = {138,321},}),
		DigSpot(9,{position = {165,477},}),
		DigSpot(9,{position = {101,588},}),
		DigSpot(9,{position = {155,604},}), --10
		DigSpot(9,{position = {12,639},}),
		DigSpot(9,{position = {195,700},}),
		DigSpot(9,{position = {88,669},}),
		DigSpot(9,{position = {58,704},}),
		DigSpot(9,{position = {134,760},}), --15
		DigSpot(9,{position = {224,759},}),
		DigSpot(9,{position = {138,801},}),
		DigSpot(9,{position = {133,927},}),
		DigSpot(9,{position = {158,962},}),
		DigSpot(9,{position = {91,1049},}), --20
		DigSpot(9,{position = {150,1041},}),
		DigSpot(9,{position = {81,1115},}),
		DigSpot(9,{position = {233,1335},}),
		DigSpot(9,{position = {140,1262},}),
		DigSpot(9,{position = {121,1368},}), --25
	},
	Land10 = {
		DigSpot(10,{position = {183,14},}),
		DigSpot(10,{position = {201,85},}),
		DigSpot(10,{position = {120,286},}),
		DigSpot(10,{position = {196,332},}),
		DigSpot(10,{position = {141,315},}), --5
		DigSpot(10,{position = {115,469},}),
		DigSpot(10,{position = {91,506},}),
		DigSpot(10,{position = {203,545},}),
		DigSpot(10,{position = {192,482},}),
		DigSpot(10,{position = {250,535},}), --10
		DigSpot(10,{position = {91,602},}),
		DigSpot(10,{position = {137,687},}),
		DigSpot(10,{position = {225,754},}),
		DigSpot(10,{position = {102,710},}),
		DigSpot(10,{position = {272,809},}), --15
		DigSpot(10,{position = {102,835},}),
		DigSpot(10,{position = {257,1011},}),
		DigSpot(10,{position = {190,939},}),
		DigSpot(10,{position = {175,1033},}),
		DigSpot(10,{position = {102,1087},}), --20
		DigSpot(10,{position = {146,1111},}),
		DigSpot(10,{position = {203,1162},}),
		DigSpot(10,{position = {215,1225},}),
		DigSpot(10,{position = {127,1284},}),
		DigSpot(10,{position = {84,1288},}), --25
	},
	Land11 = {
		DigSpot(11,{position = {55,13},}),
		DigSpot(11,{position = {116,-4},}),
		DigSpot(11,{position = {200,87},}),
		DigSpot(11,{position = {122,108},}),
		DigSpot(11,{position = {187,335},}), --5
		DigSpot(11,{position = {138,391},}),
		DigSpot(11,{position = {80,468},}),
		DigSpot(11,{position = {101,504},}),
		DigSpot(11,{position = {145,665},}),
		DigSpot(11,{position = {162,711},}), --10
		DigSpot(11,{position = {74,594},}),
		DigSpot(11,{position = {67,717},}),
		DigSpot(11,{position = {110,773},}),
		DigSpot(11,{position = {98,858},}),
		DigSpot(11,{position = {153,850},}), --15
		DigSpot(11,{position = {133,896},}),
		DigSpot(11,{position = {198,932},}),
		DigSpot(11,{position = {54,1044},}),
		DigSpot(11,{position = {85,1103},}),
		DigSpot(11,{position = {252,1248},}), --20
		DigSpot(11,{position = {179,1140},}),
		DigSpot(11,{position = {216,1381},}),
		DigSpot(11,{position = {167,1308},}),
		DigSpot(11,{position = {76,1275},}),
		DigSpot(11,{position = {62,1382},}), --25
	},
	Land12 = {
		DigSpot(12,{position = {152,15},}),
		DigSpot(12,{position = {31,80},}),
		DigSpot(12,{position = {305,263},}),
		DigSpot(12,{position = {216,62},}),
		DigSpot(12,{position = {142,110},}), --5
		DigSpot(12,{position = {169,253},}),
		DigSpot(12,{position = {229,276},}),
		DigSpot(12,{position = {98,429},}),
		DigSpot(12,{position = {140,498},}),
		DigSpot(12,{position = {59,536},}), --10
		DigSpot(12,{position = {221,575},}),
		DigSpot(12,{position = {117,635},}),
		DigSpot(12,{position = {17,704},}),
		DigSpot(12,{position = {150,763},}),
		DigSpot(12,{position = {110,792},}), --15
		DigSpot(12,{position = {262,906},}),
		DigSpot(12,{position = {263,968},}),
		DigSpot(12,{position = {108,953},}),
		DigSpot(12,{position = {256,1049},}),
		DigSpot(12,{position = {63,1084},}), --20
		DigSpot(12,{position = {198,1061},}),
		DigSpot(12,{position = {183,1133},}),
		DigSpot(12,{position = {104,1182},}),
		DigSpot(12,{position = {61,1287},}),
		DigSpot(12,{position = {291,1378},}), --25
	},
	Land13 = {
		DigSpot(13,{position = {136,96},}),
		DigSpot(13,{position = {104,66},}),
		DigSpot(13,{position = {269,254},}),
		DigSpot(13,{position = {231,187},}),
		DigSpot(13,{position = {189,261},}), --5
		DigSpot(13,{position = {158,370},}),
		DigSpot(13,{position = {103,423},}),
		DigSpot(13,{position = {101,550},}),
		DigSpot(13,{position = {297,373},}),
		DigSpot(13,{position = {243,562},}), --10
		DigSpot(13,{position = {32,714},}),
		DigSpot(13,{position = {134,521},}),
		DigSpot(13,{position = {57,1431},}),
		DigSpot(13,{position = {143,801},}),
		DigSpot(13,{position = {149,859},}), --15
		DigSpot(13,{position = {244,943},}),
		DigSpot(13,{position = {158,902},}),
		DigSpot(13,{position = {186,1016},}),
		DigSpot(13,{position = {69,1115},}),
		DigSpot(13,{position = {75,1156},}), --20
		DigSpot(13,{position = {170,1308},}),
		DigSpot(13,{position = {257,1443},}),
		DigSpot(13,{position = {135,1258},}),
		DigSpot(13,{position = {197,1346},}),
		DigSpot(13,{position = {104,1348},}), --25
	},
	Land14 = {
		DigSpot(14,{position = {151,50},}),
		DigSpot(14,{position = {100,118},}),
		DigSpot(14,{position = {115,196},}),
		DigSpot(14,{position = {85,153},}),
		DigSpot(14,{position = {129,328},}), --5
		DigSpot(14,{position = {184,376},}),
		DigSpot(14,{position = {235,495},}),
		DigSpot(14,{position = {151,554},}),
		DigSpot(14,{position = {35,688},}),
		DigSpot(14,{position = {135,601},}), --10
		DigSpot(14,{position = {226,699},}),
		DigSpot(14,{position = {103,699},}),
		DigSpot(14,{position = {80,853},}),
		DigSpot(14,{position = {98,887},}),
		DigSpot(14,{position = {238,883},}), --15
		DigSpot(14,{position = {190,931},}),
		DigSpot(14,{position = {179,1012},}),
		DigSpot(14,{position = {235,1105},}),
		DigSpot(14,{position = {154,1069},}),
		DigSpot(14,{position = {261,1148},}), --20
		DigSpot(14,{position = {85,1057},}),
		DigSpot(14,{position = {31,1147},}),
		DigSpot(14,{position = {21,1246},}),
		DigSpot(14,{position = {239,1321},}),
		DigSpot(14,{position = {95,1427},}), --25
	},
	Land15 = {
		DigSpot(15,{position = {179,34},}),
		DigSpot(15,{position = {70,86},}),
		DigSpot(15,{position = {263,175},}),
		DigSpot(15,{position = {89,215},}),
		DigSpot(15,{position = {193,222},}), --5
		DigSpot(15,{position = {112,289},}),
		DigSpot(15,{position = {225,388},}),
		DigSpot(15,{position = {181,485},}),
		DigSpot(15,{position = {121,470},}),
		DigSpot(15,{position = {94,528},}), --10
		DigSpot(15,{position = {16,601},}),
		DigSpot(15,{position = {183,602},}),
		DigSpot(15,{position = {226,643},}),
		DigSpot(15,{position = {198,741},}),
		DigSpot(15,{position = {69,779},}), --15
		DigSpot(15,{position = {52,968},}),
		DigSpot(15,{position = {15,908},}),
		DigSpot(15,{position = {73,876},}),
		DigSpot(15,{position = {181,971},}),
		DigSpot(15,{position = {274,1131},}), --20
		DigSpot(15,{position = {112,1101},}),
		DigSpot(15,{position = {242,1244},}),
		DigSpot(15,{position = {95,1219},}),
		DigSpot(15,{position = {74,1312},}),
		DigSpot(15,{position = {79,1439},}), --25
	},
	Land16 = {
		DigSpot(16,{position = {132,30},}),
		DigSpot(16,{position = {98,121},}),
		DigSpot(16,{position = {184,226},}),
		DigSpot(16,{position = {212,154},}), 
		DigSpot(16,{position = {163,354},}), --5
		DigSpot(16,{position = {50,401},}),
		DigSpot(16,{position = {111,500},}),
		DigSpot(16,{position = {227,509},}),
		DigSpot(16,{position = {168,603},}), 
		DigSpot(16,{position = {145,640},}), --10
		DigSpot(16,{position = {218,680},}),
		DigSpot(16,{position = {92,824},}),
		DigSpot(16,{position = {190,810},}),
		DigSpot(16,{position = {260,866},}),
		DigSpot(16,{position = {83,912},}), --15
		DigSpot(16,{position = {199,968},}),
		DigSpot(16,{position = {177,1020},}),
		DigSpot(16,{position = {134,984},}),
		DigSpot(16,{position = {75,1051},}),
		DigSpot(16,{position = {174,1093},}), --20
		DigSpot(16,{position = {73,1188},}),
		DigSpot(16,{position = {74,1273},}),
		DigSpot(16,{position = {172,1189},}),
		DigSpot(16,{position = {161,1351},}),
		DigSpot(16,{position = {83,1440},}), --25
	},
	Land17 = {
		DigSpot(17,{position = {132,135},}),
		DigSpot(17,{position = {171,84},}),
		DigSpot(17,{position = {138,230},}),
		DigSpot(17,{position = {206,290},}),
		DigSpot(17,{position = {208,343},}), --5
		DigSpot(17,{position = {209,417},}),
		DigSpot(17,{position = {294,431},}),
		DigSpot(17,{position = {66,499},}),
		DigSpot(17,{position = {213,597},}),
		DigSpot(17,{position = {99,581},}), --10
		DigSpot(17,{position = {80,640},}),
		DigSpot(17,{position = {249,645},}),
		DigSpot(17,{position = {165,706},}),
		DigSpot(17,{position = {164,799},}),
		DigSpot(17,{position = {57,812},}), --15
		DigSpot(17,{position = {178,866},}),
		DigSpot(17,{position = {72,921},}),
		DigSpot(17,{position = {237,1015},}),
		DigSpot(17,{position = {293,1026},}),
		DigSpot(17,{position = {231,1128},}), --20
		DigSpot(17,{position = {124,1136},}),
		DigSpot(17,{position = {275,1206},}),
		DigSpot(17,{position = {180,1245},}),
		DigSpot(17,{position = {200,1462},}),
		DigSpot(17,{position = {93,1454},}), --25
	},
	Land18 = {
		DigSpot(18,{position = {112,162},}),
		DigSpot(18,{position = {100,265},}),
		DigSpot(18,{position = {256,175},}),
		DigSpot(18,{position = {260,281},}),
		DigSpot(18,{position = {206,361},}), --5
		DigSpot(18,{position = {126,399},}),
		DigSpot(18,{position = {114,458},}),
		DigSpot(18,{position = {118,513},}),
		DigSpot(18,{position = {96,562},}),
		DigSpot(18,{position = {236,574},}), --10
		DigSpot(18,{position = {189,648},}),
		DigSpot(18,{position = {84,625},}),
		DigSpot(18,{position = {116,702},}),
		DigSpot(18,{position = {235,742},}),
		DigSpot(18,{position = {235,820},}), --15
		DigSpot(18,{position = {113,767},}),
		DigSpot(18,{position = {75,947},}),
		DigSpot(18,{position = {236,985},}),
		DigSpot(18,{position = {113,1011},}),
		DigSpot(18,{position = {278,1139},}), --20
		DigSpot(18,{position = {42,1166},}),
		DigSpot(18,{position = {123,1161},}),
		DigSpot(18,{position = {122,1253},}),
		DigSpot(18,{position = {114,1303},}),
		DigSpot(18,{position = {266,1223},}), --25
	},
	Land19 = {
		DigSpot(19,{position = {200,262},}),
		DigSpot(19,{position = {150,309},}),
		DigSpot(19,{position = {110,355},}),
		DigSpot(19,{position = {217,439},}),
		DigSpot(19,{position = {219,355},}), --5
		DigSpot(19,{position = {126,418},}),
		DigSpot(19,{position = {153,470},}),
		DigSpot(19,{position = {198,523},}),
		DigSpot(19,{position = {111,571},}),
		DigSpot(19,{position = {141,607},}), --10
		DigSpot(19,{position = {174,644},}),
		DigSpot(19,{position = {180,599},}),
		DigSpot(19,{position = {82,923},}),
		DigSpot(19,{position = {124,717},}),
		DigSpot(19,{position = {229,973},}), --15
		DigSpot(19,{position = {144,792},}),
		DigSpot(19,{position = {274,1134},}),
		DigSpot(19,{position = {147,982},}),
		DigSpot(19,{position = {163,1054},}),
		DigSpot(19,{position = {254,1237},}), --20
		DigSpot(19,{position = {190,1219},}),
		DigSpot(19,{position = {257,1474},}),
		DigSpot(19,{position = {203,1459},}),
		DigSpot(19,{position = {67,1428},}),
		DigSpot(19,{position = {60,1466},}), --25
	},
	Land20 = {
		DigSpot(20,{position = {185,119},}),
		DigSpot(20,{position = {91,111},}),
		DigSpot(20,{position = {102,199},}),
		DigSpot(20,{position = {118,248},}),
		DigSpot(20,{position = {79,327},}), --5
		DigSpot(20,{position = {119,398},}),
		DigSpot(20,{position = {210,436},}),
		DigSpot(20,{position = {117,506},}),
		DigSpot(20,{position = {218,541},}),
		DigSpot(20,{position = {116,562},}), --10
		DigSpot(20,{position = {118,639},}),
		DigSpot(20,{position = {210,653},}),
		DigSpot(20,{position = {143,744},}),
		DigSpot(20,{position = {224,736},}),
		DigSpot(20,{position = {212,815},}), --15
		DigSpot(20,{position = {223,884},}),
		DigSpot(20,{position = {152,919},}),
		DigSpot(20,{position = {213,971},}),
		DigSpot(20,{position = {105,1167},}),
		DigSpot(20,{position = {262,1069},}), --20
		DigSpot(20,{position = {113,1103},}),
		DigSpot(20,{position = {87,1225},}),
		DigSpot(20,{position = {263,1387},}),
		DigSpot(20,{position = {197,1384},}),
		DigSpot(20,{position = {95,1441},}), --25
	},
	Land21 = {
		DigSpot(21,{position = {286,-35},}),
		DigSpot(21,{position = {216,169},}),
		DigSpot(21,{position = {269,195},}),
		DigSpot(21,{position = {214,65},}),
		DigSpot(21,{position = {176,317},}), --5
		DigSpot(21,{position = {34,321},}),
		DigSpot(21,{position = {98,381},}),
		DigSpot(21,{position = {267,519},}),
		DigSpot(21,{position = {205,581},}),
		DigSpot(21,{position = {26,423},}), --10
		DigSpot(21,{position = {197,694},}),
		DigSpot(21,{position = {270,737},}),
		DigSpot(21,{position = {138,790},}),
		DigSpot(21,{position = {311,802},}),
		DigSpot(21,{position = {73,915},}), --15
		DigSpot(21,{position = {16,941},}),
		DigSpot(21,{position = {154,954},}),
		DigSpot(21,{position = {51,1024},}),
		DigSpot(21,{position = {170,1046},}),
		DigSpot(21,{position = {106,1103},}), --20
		DigSpot(21,{position = {310,1158},}),
		DigSpot(21,{position = {184,1186},}),
		DigSpot(21,{position = {241,1359},}),
		DigSpot(21,{position = {247,1413},}),
		DigSpot(21,{position = {114,1460},}), --25
	},
	Land22 = {
		DigSpot(22,{position = {179,56},}),
		DigSpot(22,{position = {66,158},}),
		DigSpot(22,{position = {109,166},}),
		DigSpot(22,{position = {224,224},}),
		DigSpot(22,{position = {79,270},}), --5
		DigSpot(22,{position = {234,296},}),
		DigSpot(22,{position = {110,368},}),
		DigSpot(22,{position = {269,476},}),
		DigSpot(22,{position = {92,572},}),
		DigSpot(22,{position = {231,626},}), --10
		DigSpot(22,{position = {267,663},}),
		DigSpot(22,{position = {201,715},}),
		DigSpot(22,{position = {152,746},}),
		DigSpot(22,{position = {262,985},}),
		DigSpot(22,{position = {127,908},}), --15
		DigSpot(22,{position = {216,1055},}),
		DigSpot(22,{position = {225,1124},}),
		DigSpot(22,{position = {169,967},}),
		DigSpot(22,{position = {52,1044},}),
		DigSpot(22,{position = {81,1097},}), --20
		DigSpot(22,{position = {204,1205},}),
		DigSpot(22,{position = {217,1323},}),
		DigSpot(22,{position = {169,1264},}),
		DigSpot(22,{position = {171,1405},}),
		DigSpot(22,{position = {75,1472},}), --25
	},
	Land23 = {
		DigSpot(23,{position = {151,26},}),
		DigSpot(23,{position = {174,119},}),
		DigSpot(23,{position = {268,143},}),
		DigSpot(23,{position = {64,173},}),
		DigSpot(23,{position = {65,236},}), --5
		DigSpot(23,{position = {122,374},}),
		DigSpot(23,{position = {204,384},}),
		DigSpot(23,{position = {95,470},}),
		DigSpot(23,{position = {259,517},}),
		DigSpot(23,{position = {71,571},}), --10
		DigSpot(23,{position = {92,652},}),
		DigSpot(23,{position = {67,620},}),
		DigSpot(23,{position = {145,610},}),
		DigSpot(23,{position = {273,797},}),
		DigSpot(23,{position = {117,894},}), --15
		DigSpot(23,{position = {58,868},}),
		DigSpot(23,{position = {97,953},}),
		DigSpot(23,{position = {254,964},}),
		DigSpot(23,{position = {151,1017},}),
		DigSpot(23,{position = {230,1115},}), --20
		DigSpot(23,{position = {104,1155},}),
		DigSpot(23,{position = {213,1202},}),
		DigSpot(23,{position = {219,1295},}),
		DigSpot(23,{position = {164,1396},}),
		DigSpot(23,{position = {89,1465},}), --25
	},
	Land24 = {
		DigSpot(24,{position = {216,150},}),
		DigSpot(24,{position = {107,213},}),
		DigSpot(24,{position = {54,267},}),
		DigSpot(24,{position = {224,380},}),
		DigSpot(24,{position = {92,397},}), --5
		DigSpot(24,{position = {249,441},}),
		DigSpot(24,{position = {198,424},}),
		DigSpot(24,{position = {248,477},}),
		DigSpot(24,{position = {111,532},}),
		DigSpot(24,{position = {246,602},}), --10
		DigSpot(24,{position = {191,610},}),
		DigSpot(24,{position = {244,689},}),
		DigSpot(24,{position = {73,616},}),
		DigSpot(24,{position = {266,811},}),
		DigSpot(24,{position = {116,720},}), --15
		DigSpot(24,{position = {174,819},}),
		DigSpot(24,{position = {287,920},}),
		DigSpot(24,{position = {35,859},}),
		DigSpot(24,{position = {77,942},}),
		DigSpot(24,{position = {68,1060},}), --20
		DigSpot(24,{position = {269,1099},}),
		DigSpot(24,{position = {26,1170},}),
		DigSpot(24,{position = {63,1236},}),
		DigSpot(24,{position = {227,1281},}),
		DigSpot(24,{position = {135,1423},}), --25
	},
	Land25 = {
		DigSpot(25,{position = {275,69},}),
		DigSpot(25,{position = {27,115},}),
		DigSpot(25,{position = {209,153},}),
		DigSpot(25,{position = {274,173},}),
		DigSpot(25,{position = {254,306},}), --5
		DigSpot(25,{position = {60,332},}),
		DigSpot(25,{position = {209,398},}),
		DigSpot(25,{position = {20,415},}),
		DigSpot(25,{position = {284,501},}),
		DigSpot(25,{position = {106,529},}), --10
		DigSpot(25,{position = {291,607},}),
		DigSpot(25,{position = {286,686},}),
		DigSpot(25,{position = {289,817},}),
		DigSpot(25,{position = {138,624},}),
		DigSpot(25,{position = {260,927},}), --15
		DigSpot(25,{position = {42,944},}),
		DigSpot(25,{position = {279,986},}),
		DigSpot(25,{position = {150,892},}),
		DigSpot(25,{position = {263,1138},}),
		DigSpot(25,{position = {65,1032},}), --20
		DigSpot(25,{position = {276,1262},}),
		DigSpot(25,{position = {201,1237},}),
		DigSpot(25,{position = {32,1186},}),
		DigSpot(25,{position = {99,1317},}),
		DigSpot(25,{position = {143,1459},}), --25
	},
	Land26 = {
		DigSpot("26b",{position = {195,132},}),
		DigSpot("26b",{position = {93,189},}),
		DigSpot("26b",{position = {118,221},}),
		DigSpot("26b",{position = {200,273},}),
		DigSpot(26,{position = {60, 407},}), --5
		DigSpot(26,{position = {98, 457},}), 
		DigSpot(26,{position = {164,496},}), 
		DigSpot(26,{position = {85,550},}),
		DigSpot("26b",{position = {169,591},}),
		DigSpot("26b",{position = {108,684},}), --10
		DigSpot("26b",{position = {150,700},}),
		DigSpot("26b",{position = {134,789},}), 
		DigSpot(26,{position = {286,803},}), 
		DigSpot(26,{position = {155,833},}), 
		DigSpot(26,{position = {212,905},}), --15
		DigSpot(26,{position = {174,1008},}), 
		DigSpot(26,{position = {270,940},}), 
		DigSpot(26,{position = {230,1000},}),
		DigSpot(26,{position = {170,843},}),
		DigSpot(26,{position = {55,628},}), --20
		DigSpot("26b",{position = {103,1089},}),
		DigSpot("26b",{position = {222,1222},}),
		DigSpot("26b",{position = {108,1314},}),
		DigSpot("26b",{position = {151,1352},}),
		DigSpot("26b",{position = {220,1304},}), --25
	},
	Land27 = {
		DigSpot("27a",{position = {220,128},}),
		DigSpot("27b",{position = {105,220},}),
		DigSpot("27b",{position = {240,250},}),
		DigSpot("27b",{position = {275,290},}),
		DigSpot("27b",{position = {225,318},}), --5
		DigSpot("27b",{position = {80,320},}),
		DigSpot("27b",{position = {225,360},}),
		DigSpot("27a",{position = {140,615},}),
		DigSpot("27a",{position = {240,635},}),
		DigSpot("27b",{position = {285,700},}), --10
		DigSpot("27b",{position = {215,725},}),
		DigSpot("27a",{position = {35,740},}),
		DigSpot("27b",{position = {160,753},}),
		DigSpot("27b",{position = {40,850},}),
		DigSpot("27b",{position = {40,900},}), --15
		DigSpot("27a",{position = {150,978},}),
		DigSpot("27b",{position = {20,1000},}),
		DigSpot("27a",{position = {203,1016},}),
		DigSpot("27a",{position = {125,1053},}),
		DigSpot("27b",{position = {50,1120},}), --20
		DigSpot("27a",{position = {95,1260},}),
		DigSpot("27a",{position = {130,1340},}),
		DigSpot("27a",{position = {151,1386},}),
		DigSpot("27a",{position = {280,1395},}),
		DigSpot("27a",{position = {109,1442},}), --25
	},
	Land28 = {
		DigSpot("28",{position = {200,133},}),
		DigSpot("28",{position = {240,210},}),
		DigSpot("28",{position = {120,228},}),
		DigSpot("28",{position = {220,280},}),
		DigSpot("28",{position = {70,330},}),	--5
		DigSpot("28",{position = {210,350},}),
		DigSpot("28",{position = {80,400},}),
		DigSpot("28",{position = {100,460},}),	
		DigSpot("28",{position = {100,550},}),
		DigSpot("28",{position = {120,630},}),	--10
		DigSpot("28",{position = {250,730},}),
		DigSpot("28",{position = {80,730},}),
		DigSpot("28",{position = {270,790},}),	
		DigSpot("28",{position = {100,900},}),
		DigSpot("28",{position = {243,894},}),	--15
		DigSpot("28",{position = {220,940},}),
		DigSpot("28",{position = {220,990},}),
		DigSpot("28",{position = {287,1045},}),
		DigSpot("28",{position = {120,1050},}),
		DigSpot("28",{position = {170,1150},}),	--20
		DigSpot("28",{position = {70,1230},}),
		DigSpot("28",{position = {194,1250},}),
		DigSpot("28",{position = {96,1307},}),
		DigSpot("28",{position = {160,1325},}),
		DigSpot("28",{position = {85,1370},}),	--25
		DigSpot("28",{position = {190,1400},}),	
		DigSpot("28",{position = {90,1565},}),
		DigSpot("28",{position = {270,1600},}),
		DigSpot("28",{position = {90,1655},}),
		DigSpot("28",{position = {150,1682},}),	--30
		DigSpot("28",{position = {200,1700},}),
		DigSpot("28",{position = {158,1754},}),
		DigSpot("28",{position = {123,1800},}),
		DigSpot("28",{position = {260,1925},}),
		DigSpot("28",{position = {250,2010},}),	--35
		DigSpot("28",{position = {180,2040},}),
		DigSpot("28",{position = {250,2140},}),
		DigSpot("28",{position = {190,2285},}),
		DigSpot("28",{position = {105,2354},}),
		DigSpot("28",{position = {100,2458},}),	--40
	},
	Land29 = {
		DigSpot("29",{position = {155,50},}),
		DigSpot("29",{position = {200,104},}),
		DigSpot("29",{position = {202,153},}),
		DigSpot("29",{position = {115,178},}),
		DigSpot("29",{position = {193,216},}),	--5
		DigSpot("29",{position = {197,273},}),
		DigSpot("29",{position = {112,371},}),
		DigSpot("29",{position = {242,374},}),	
		DigSpot("29",{position = {232,493},}),
		DigSpot("29",{position = {195,529},}),	--10
		DigSpot("29",{position = {139,794},}),
		DigSpot("29",{position = {221,805},}),
		DigSpot("29",{position = {242,850},}),	
		DigSpot("29",{position = {238,895},}),
		DigSpot("29",{position = {121,971},}),	--15
		DigSpot("29",{position = {265,962},}),
		DigSpot("29",{position = {258,1011},}),
		DigSpot("29",{position = {176,1077},}),
		DigSpot("29",{position = {115,1050},}),
		DigSpot("29",{position = {163,1127},}),	--20
		DigSpot("29",{position = {172,1188},}),
		DigSpot("29",{position = {239,1348},}),
		DigSpot("29",{position = {104,1344},}),
		DigSpot("29",{position = {152,1375},}),
		DigSpot("29",{position = {171,1436},}),	--25
		DigSpot("29",{position = {70,1467},}),	
		DigSpot("29",{position = {114,1523},}),
		DigSpot("29",{position = {227,1516},}),
		DigSpot("29",{position = {273,1579},}),
		DigSpot("29",{position = {219,1622},}),	--30
		DigSpot("29",{position = {91,1680},}),
		DigSpot("29",{position = {176,1707},}),
		DigSpot("29",{position = {19,1768},}),
		DigSpot("29",{position = {86,1797},}),
		DigSpot("29",{position = {137,1877},}),	--35
		DigSpot("29",{position = {196,1980},}),
		DigSpot("29",{position = {205,2092},}),
		DigSpot("29",{position = {78,2174},}),
		DigSpot("29",{position = {80,2272},}),
		DigSpot("29",{position = {113,2484},}),	--40
	},
	Land30 = {
		DigSpot("30a",{position = {54,237},}),
		DigSpot("30a",{position = {84,281},}),
		DigSpot("30a",{position = {31,315},}),
		DigSpot("30a",{position = {35,380},}),
		DigSpot("30a",{position = {287,232},}),	--5
		DigSpot("30a",{position = {29,451},}),
		DigSpot("30a",{position = {48,559},}),
		DigSpot("30a",{position = {296,421},}),	
		DigSpot("30a",{position = {298,575},}),
		DigSpot("30a",{position = {219,602},}),	--10
		DigSpot("30a",{position = {92,582},}),
		DigSpot("30b",{position = {235,802},}),
		DigSpot("30b",{position = {286,813},}),	
		DigSpot("30b",{position = {31,814},}),
		DigSpot("30b",{position = {60,873},}),	--15
		DigSpot("30b",{position = {239,886},}),
		DigSpot("30b",{position = {286,925},}),
		DigSpot("30b",{position = {249,970},}),
		DigSpot("30b",{position = {91,936},}),
		DigSpot("30b",{position = {36,976},}),	--20
		DigSpot("30b",{position = {35,1016},}),
		DigSpot("30b",{position = {60,1065},}),
		DigSpot("30b",{position = {272,1049},}),
		DigSpot("30a",{position = {204,1157},}),
		DigSpot("30a",{position = {242,1188},}),	--25
		DigSpot("30a",{position = {85,1227},}),	
		DigSpot("30a",{position = {137,1275},}),
		DigSpot("30b",{position = {127,1498},}),
		DigSpot("30b",{position = {226,1532},}),	
		DigSpot("30a",{position = {247,1700},}),	--30
		DigSpot("30a",{position = {97,1717},}),
		DigSpot("30a",{position = {96,1773},}),
		DigSpot("30a",{position = {43,1857},}),	
		DigSpot("30a",{position = {60,1985},}),	
		DigSpot("30a",{position = {241,1978},}),	--35
		DigSpot("30a",{position = {76,2082},}),
		DigSpot("30a",{position = {272,2078},}),
		DigSpot("30a",{position = {207,2339},}),
		DigSpot("30a",{position = {152,2420},}),
		DigSpot("30a",{position = {123,2471},}),	--40
	},
	Land31 = {
		DigSpot("31a",{position = {182,95},}),
		DigSpot("31a",{position = {205,138},}),
		DigSpot("31a",{position = {107,201},}),
		DigSpot("31a",{position = {224,231},}),
		DigSpot("31a",{position = {202,333},}),	--5
		DigSpot("31a",{position = {193,395},}),
		DigSpot("31a",{position = {186,450},}),
		DigSpot("31a",{position = {183,504},}),	
		DigSpot("31b",{position = {219,584},}),
		DigSpot("31a",{position = {83,611},}),	--10
		DigSpot("31a",{position = {205,705},}),
		DigSpot("31a",{position = {182,784},}),
		DigSpot("31a",{position = {182,837},}),	
		DigSpot("31a",{position = {84,668},}),
		DigSpot("31a",{position = {65,881},}),	--15
		DigSpot("31b",{position = {145,993},}),
		DigSpot("31b",{position = {257,1063},}),
		DigSpot("31b",{position = {62,1124},}),
		DigSpot("31a",{position = {168,1236},}),
		DigSpot("31a",{position = {225,1278},}),	--20
		DigSpot("31b",{position = {150,1370},}),
		DigSpot("31b",{position = {247,1353},}),
		DigSpot("31b",{position = {206,1407},}),
		DigSpot("31a",{position = {199,1459},}),
		DigSpot("31b",{position = {243,1755},}),	--25
		DigSpot("31b",{position = {66,1825},}),	
		DigSpot("31b",{position = {196,1900},}),
		DigSpot("31b",{position = {67,1941},}),
		DigSpot("31b",{position = {235,1936},}),	
		DigSpot("31b",{position = {202,1971},}),	--30
		DigSpot("31b",{position = {172,2021},}),
		DigSpot("31b",{position = {217,2068},}),
		DigSpot("31b",{position = {227,2122},}),	
		DigSpot("31b",{position = {199,2175},}),	
		DigSpot("31b",{position = {194,2227},}),	--35
		DigSpot("31b",{position = {206,2277},}),
		DigSpot("31b",{position = {108,2477},}),
		DigSpot("31b",{position = {251,2499},}),
		DigSpot("31b",{position = {142,2519},}),
		DigSpot("31b",{position = {156,2562},}),	--40
	},
	Land32 = {
		DigSpot("32",{position = {130,152},}),
		DigSpot("32",{position = {107,201},}),
		DigSpot("32",{position = {138,255},}),
		DigSpot("32",{position = {137,319},}),
		DigSpot("32",{position = {127,383},}),	--5
		DigSpot("32",{position = {98,557},}),
		DigSpot("32",{position = {211,588},}),
		DigSpot("32",{position = {236,692},}),	
		DigSpot("32",{position = {95,641},}),
		DigSpot("32",{position = {38,720},}),	--10
		DigSpot("32",{position = {207,779},}),
		DigSpot("32",{position = {149,897},}),
		DigSpot("32",{position = {206,931},}),	
		DigSpot("32",{position = {75,1056},}),
		DigSpot("32",{position = {156,1075},}),	--15
		DigSpot("32",{position = {89,1114},}),
		DigSpot("32",{position = {188,1180},}),
		DigSpot("32",{position = {281,1245},}),
		DigSpot("32",{position = {131,1296},}),
		DigSpot("32",{position = {119,1372},}),	--20
		DigSpot("32",{position = {175,1399},}),
		DigSpot("32",{position = {118,1476},}),
		DigSpot("32",{position = {131,1605},}),
		DigSpot("32",{position = {148,1652},}),
		DigSpot("32",{position = {190,1745},}),	--25
		DigSpot("32",{position = {127,1843},}),	
		DigSpot("32",{position = {60,1838},}),
		DigSpot("32",{position = {37,1898},}),
		DigSpot("32",{position = {67,1941},}),	
		DigSpot("32",{position = {120,1968},}),	--30
		DigSpot("32",{position = {66,2007},}),
		DigSpot("32",{position = {227,2068},}),
		DigSpot("32",{position = {206,2124},}),	
		DigSpot("32",{position = {81,2163},}),	
		DigSpot("32",{position = {119,2206},}),	--35
		DigSpot("32",{position = {134,2255},}),
		DigSpot("32",{position = {107,2312},}),
		DigSpot("32",{position = {125,2354},}),
		DigSpot("32",{position = {256,2459},}),
		DigSpot("32",{position = {108,2477},}),	--40
	},
	Land33 = {
		DigSpot("33a",{position = {93,116},}),   --1
		DigSpot("33a",{position = {270,131},}),  --2
		DigSpot("33a",{position = {115,178},}),  --3
		DigSpot("33a",{position = {106,283},}),  --4
		DigSpot("33a",{position = {296,332},}),	--5
		DigSpot("33a",{position = {102,390},}),  --6
		DigSpot("33a",{position = {103,494},}),  --7
		DigSpot("33a",{position = {286,581},}),	--8
		DigSpot("33a",{position = {45,583},}),   --9
		DigSpot("33a",{position = {219,609},}),	--10
		DigSpot("33a",{position = {124,672},}),  --11
		DigSpot("33a",{position = {23,735},}),  --12
		DigSpot("33a",{position = {147,882},}),	--13
		DigSpot("33a",{position = {223,918},}),  --14
		DigSpot("33a",{position = {34,977},}),	--15
		DigSpot("33a",{position = {120,1013},}),  --16
		DigSpot("33a",{position = {172,1150},}), --17
		DigSpot("33a",{position = {248,1244},}), --18
		DigSpot("33a",{position = {89,1229},}), --19
		DigSpot("33a",{position = {112,1305},}),	--20
		DigSpot("33a",{position = {67,1394},}),  --21
		DigSpot("33a",{position = {84,1458},}), --22
		DigSpot("33a",{position = {111,1561},}), --23
		DigSpot("33a",{position = {285,1545},}), --24
		DigSpot("33a",{position = {162,1639},}),	--25
		DigSpot("33a",{position = {88,1723},}),	--26
		DigSpot("33a",{position = {122,1787},}),  --27
		DigSpot("33a",{position = {64,1823},}),  --28
		DigSpot("33a",{position = {136,1849},}),	--29
		DigSpot("33a",{position = {110,1954},}),	--30
		DigSpot("33b",{position = {107,2054},}), --31
		DigSpot("33b",{position = {227,2068},}), --32
		DigSpot("33b",{position = {303,2103},}),	--33
		DigSpot("33b",{position = {9, 2121},}),	--34
		DigSpot("33b",{position = {-8,2201},}),	--35
		DigSpot("33b",{position = {328,2178},}), --36
		DigSpot("33b",{position = {233, 2245},}), --37
		DigSpot("33b",{position = {101,2350},}), --38
		DigSpot("33b",{position = {151, 2425},}), --39
		DigSpot("33b",{position = {116,2484},}),	--40
	},
	LandX = {
		DigSpot(X,{position = {145,140},}),
		DigSpot(X,{position = {145,190},}),
		DigSpot(X,{position = {145,240},}),
		DigSpot(X,{position = {145,290},}),
		DigSpot(X,{position = {145,340},}), --5
		DigSpot(X,{position = {145,390},}),
		DigSpot(X,{position = {145,440},}),
		DigSpot(X,{position = {145,490},}),
		DigSpot(X,{position = {145,540},}),
		DigSpot(X,{position = {145,590},}), --10
		DigSpot(X,{position = {145,640},}),
		DigSpot(X,{position = {145,690},}),
		DigSpot(X,{position = {145,740},}),
		DigSpot(X,{position = {145,790},}),
		DigSpot(X,{position = {145,840},}), --15
		DigSpot(X,{position = {145,890},}),
		DigSpot(X,{position = {145,940},}),
		DigSpot(X,{position = {145,990},}),
		DigSpot(X,{position = {145,1040},}),
		DigSpot(X,{position = {145,1090},}), --20
		DigSpot(X,{position = {145,1140},}),
		DigSpot(X,{position = {145,1190},}),
		DigSpot(X,{position = {145,1240},}),
		DigSpot(X,{position = {145,1290},}),
		DigSpot(X,{position = {145,1340},}), --25
	},
}



Resources.DigSpot_TapHerePointer = Resources.Actor:new {
	resource = "Actor",
	image = "TapHere.png",
	rotationPoint = "MidBottom",
	alignment = "Center",
	alignTo = "Center",
	alignmentOffset = {40,-20},
	scripts = {"TapHereAction"},
	layer = 100,
}

Scripts.AddDigSpotTapHere = function(digSpotActor)
	if(digSpotActor.tapHereIndicator == nil) then
		digSpotActor.tapHereIndicator = Resources.DigSpot_TapHerePointer
	end
end

Scripts.DigSpotFoundAnimation = function(digSpotActor,particle)
	local tapHereIndicator = digSpotActor.parent:FindChild("tapHereIndicator",true)
	if(tapHereIndicator ~= nil) then
		FadeOutAndDestroy(tapHereIndicator,500)
	end

	digSpotActor:KillTaggedScripts("DigSpot_sparkle")
	Scripts.DigSpot_StopSparkling(digSpotActor)
	local pick = math.random(1,6)
	if(pick==1)then
		PlaySound("gravel_impact_01.ogg")
	elseif(pick==2)then
		PlaySound("gravel_impact_02.ogg")
	elseif(pick==3)then
		PlaySound("gravel_impact_05.ogg")
	elseif(pick==4)then
		PlaySound("gravel_impact_08.ogg")
	elseif(pick==5)then
		PlaySound("gravel_impact_09.ogg")
	elseif(pick==6)then
		PlaySound("gravel_impact_10.ogg")
	end

	--Fire a particle emitter at the dig spot
    if (particle ~= "") then
        if (particle ~= "Gold") then
            FireParticle(digSpotActor, particle .. "Toss")
        elseif (particle == "Gold") then
			PlaySound("slot_machine_win_09.ogg")
			FireParticle(digSpotActor,"GoldToss")
			PlaySound("coin_magic_05.ogg")
		end
        if(particle=="SpecialGreen")then
            FireParticle(digSpotActor, "Explosion4_green")
        elseif(particle=="SpecialRed")then
            FireParticle(digSpotActor, "Explosion4_red")
        elseif(particle=="SpecialBlue")then
            FireParticle(digSpotActor, "Explosion4_blue")
        elseif(particle=="Gold")then
            FireParticle(digSpotActor, "Explosion4_yellow")
        end
    end

	--Change to empty dig spot image
	digSpotActor.image = digSpotActor.emptyImage

	--Fade out empty dig spot image
	digSpotActor:FadeOut(2000,false,false)

	ScriptDelay(2000)
	digSpotActor.image = digSpotActor.fullImage
end

Scripts.Preshow_BuyDialog = function(dialog)

end


Scripts.Present_BuyDialog = function(dialog)
	
	-- TODO: Add more animation

	PlaySound("slot_machine_win_01.ogg")
	
end
