
LandBackgroundTable = {
	[1] = "Bkg_sky.jpg",
	[2] = "Cascade_Lake.jpg",
	[3] = "Purple_Mountain.jpg",
	[4] = "Land4_Sapphire_MENU.jpg",
	[5] = "Land5_Jungle_Menu.jpg",
	[6] = "Aztec_Lost_City.jpg",
	[7] = "Volcano.jpg",
	[8] = "Diamond_Glacier.jpg",
	[9] = "LAND_9_Beach_Menu.jpg",
	[10] = "Land10_Hidden_Temple_Menu.jpg",
	[11] = "Land11_Menu.jpg",
	[12] = "Land12_Menu.jpg",
	[13] = "Land13_Menu.jpg",
	[14] = "Land14_Menu.jpg",
	[15] = "LAND15_Menu.jpg",
	[16] = "Land16_Menu.jpg",
	[17] = "Land17_Menu.jpg",
	[18] = "Land18_Menu.jpg",
	[19] = "Land19_Menu.jpg",
	[20] = "Land20_Menu.jpg",
	[21] = "Land21_Menu.jpg",
	[22] = "Land22_Menu.jpg",
	[23] = "Land23_Menu.jpg",
	[24] = "Land24_Menu.jpg",
	[25] = "Land25_Menu.jpg",
	[26] = "Land26_Menu.jpg",
	[27] = "Land27_Menu.jpg",
	[28] = "Land28_Menu.jpg",
	[29] = "Land29_Menu.jpg",
	[30] = "Land30_Menu.jpg",
	[31] = "Land31_Menu.jpg",
	[32] = "Land32_Menu.jpg",
	[33] = "Land33_Menu.jpg",
	[34] = "Land34_Menu.jpg",
}

Resources.GameScreen = {
	deviceOrientation = "Portrait",
	screenShouldPromptForPlayerChoice = true,
    
	loadingLayer = Resources.LoadingLayer:new {
		resource = "LoadingLayer",
	},

    memoryUsageButton = Resources.Button:new {
        resource = "Button",
        text = STRINGS(""),
        image = "",
        alpha = 128,
        color = "White",
        size = {40,40},
        alignment = TopRight,
        layer = 10,
		OnButtonClick = function (self, event)
			if self ~= event.button then 
                return false 
            end
            LogVideoMemoryUsage()
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
        visible = false,
    },
    
    --Images whose textures we want to force to be resident for perf reasons.
    imageCache = Resources.Actor:new {
        resource = "Actor",
        visible = false,
        border1 = {
            class = "Actor",
            image = "slot_highlight.png",
        },
        border2 = {
            class = "Actor",
            image = "slot_highlight_Blue.png",
        },
        border3 = {
            class = "Actor",
            image = "slot_highlight_Green.png",
        },
        border4 = {
            class = "Actor",
            image = "slot_highlight_Orange.png",
        },
        border5 = {
            class = "Actor",
            image = "slot_highlight_Purple.png",
        },
        border6 = {
            class = "Actor",
            image = "slot_highlight_Red.png",
        },
        border7 = {
            class = "Actor",
            image = "slot_highlight_White.png",
        },
        border8 = {
            class = "Actor",
            image = "slot_highlight_Wild.png",
        },
        border9 = {
            class = "Actor",
            image = "slot_highlight_Yellow.png",
        },
    },
}


local iPhone5_GameBoard_NudgeY = 44+24
local iPad_GameBoard_NudgeY = 22-18+24

local boxNudge = {x=0,y=0}
local boxSize = {x=50,y=0}
local boxStart = {x=40,y=464}

Resources.ReelBackground = Resources.Actor:new {
	resource = "Actor",
    alpha = 0,
    size = {768/2,1136/2},
	alignment = "Center",
	alignTo = "Center",
	alignmentOffset = Layout{{0,(-56/2)-4},iphone4={0,(-56/2)-4-7},iphone5={0,-4},ipad={0,-56/2},android={0,(-56/2)+2},androidShort={0,(-56/2)-3}},
	zorder = 1,
    Box1 = {
        class = "Actor",
        image = "GameBoard_box1_plain.png",
        position = {boxStart.x+(boxSize.x*0)+boxNudge.x,boxStart.y+boxNudge.y},
        zorder = 1,
    },
    Box2 = {
        class = "Actor",
        image = "GameBoard_box2_plain.png",
        position = {boxStart.x+(boxSize.x*1)+boxNudge.x,boxStart.y+boxNudge.y},
        zorder = 2,
    },
    Box3 = {
        class = "Actor",
        image = "GameBoard_box3_plain.png",
        position = {boxStart.x+(boxSize.x*2)+boxNudge.x,boxStart.y+boxNudge.y},
        zorder = 1,
    },
    Box4 = {
        class = "Actor",
        image = "GameBoard_box4_plain.png",
        position = {boxStart.x+(boxSize.x*3)+boxNudge.x,boxStart.y+boxNudge.y},
        zorder = 2,
    },
    Box5 = {
        class = "Actor",
        image = "GameBoard_box5_plain.png",
        position = {boxStart.x+(boxSize.x*4)+boxNudge.x,boxStart.y+boxNudge.y},
        zorder = 1,
    },
    Box6 = {
        class = "Actor",
        image = "GameBoard_box6_plain.png",
        position = {boxStart.x+(boxSize.x*5)+boxNudge.x,boxStart.y+boxNudge.y},
        zorder = 2,
    },
}

local boxNudge_large = {x=0,y=0}
local boxSize_large = {x=44,y=0}
local boxStart_large = {x=37,y=468}

Resources.ReelBackground_large = Resources.ReelBackground:new {
	resource = "ReelBackground",
	alignmentOffset = Layout{{0,-32-4},iphone5={0,-4},ipad={0,-28},android={0,-28+2},androidShort={0,-28-3}},
    Box1 = {
        class = "Actor",
        image = "GameBoard_box1_plain_large.png",
        position = {boxStart_large.x+(boxSize_large.x*0)+boxNudge_large.x,boxStart_large.y+boxNudge_large.y},
        zorder = 1,
    },
    Box2 = {
        class = "Actor",
        image = "GameBoard_box2_plain_large.png",
        position = {boxStart_large.x+(boxSize_large.x*1)+boxNudge_large.x,boxStart_large.y+boxNudge_large.y},
        zorder = 2,
    },
    Box3 = {
        class = "Actor",
        image = "GameBoard_box3_plain_large.png",
        position = {boxStart_large.x+(boxSize_large.x*2)+boxNudge_large.x,boxStart_large.y+boxNudge_large.y},
        zorder = 3,
    },
    Box4 = {
        class = "Actor",
        image = "GameBoard_box4_plain_large.png",
        position = {boxStart_large.x+(boxSize_large.x*3)+boxNudge_large.x,boxStart_large.y+boxNudge_large.y},
        zorder = 4,
    },
    Box5 = {
        class = "Actor",
        image = "GameBoard_box5_plain_large.png",
        position = {boxStart_large.x+(boxSize_large.x*4)+boxNudge_large.x,boxStart_large.y+boxNudge_large.y},
        zorder = 3,
    },
    Box6 = {
        class = "Actor",
        image = "GameBoard_box6_plain_large.png",
        position = {boxStart_large.x+(boxSize_large.x*5)+boxNudge_large.x,boxStart_large.y+boxNudge_large.y},
        zorder = 2,
    },
    Box7 = {
        class = "Actor",
        image = "GameBoard_box7_plain_large.png",
        position = {boxStart_large.x+(boxSize_large.x*6)+boxNudge.x,boxStart_large.y+boxNudge.y},
        zorder = 1,
    },
}

Resources.BackgroundImage = Resources.Actor:new {
	resource = "Actor",
	image = LandBackgroundTable[1],
	alignment = "Center",
	alignTo = "Center",
	zorder = -2,
	
	AndroidGameBackground = Resources.Actor:new {
		resource = "Actor",
		image = LandBackgroundTable[1],
		alignment = "Center",
		alignTo = "Center",
		zorder = 0,
		visible = Layout{false,android=true},
	},

	OnPostSpawn = function (self)
		self.AndroidGameBackground.image = self.image
		MatchHeightToScreen(self.AndroidGameBackground)
	end,

	ReelBackground = Resources.ReelBackground:new {
		resource = "ReelBackground",
	},
	BoardFrame = Resources.Actor:new {
		name = "BoardFrame",
		resource = "Actor",
		alpha = 0,
		color = "Blue",
		size = Layout{{300+8,350+8}},
        alignment = Layout{"MidTop",android="Center"},
        alignmentOffset =  Layout{{0, 36}, android={0, -39}, iphone5={0, 43+iPhone5_GameBoard_NudgeY}, ipad={0, 43+iPad_GameBoard_NudgeY}, pc={0, 12}},
		hgeParticleLayer = {
			class = "hgeParticleLayer",
			alignment = "MidTop",
			alignTo = "MidTop",
			zorder = -1,
			tag = hgeLayerTag,
		},
	},
}

Resources.BackgroundImage_large = Resources.Actor:new {
	resource = "Actor",
	image = LandBackgroundTable[1],
	alignment = "Center",
	alignTo = "Center",
	zorder = -2,

	AndroidGameBackground = Resources.Actor:new {
		resource = "Actor",
		image = LandBackgroundTable[1],
		alignment = "Center",
		alignTo = "Center",
		zorder = 0,
		visible = Layout{false,android=true},
	},

	OnPostSpawn = function (self)
		self.AndroidGameBackground.image = self.image
		MatchHeightToScreen(self.AndroidGameBackground)
	end,

	ReelBackground = Resources.ReelBackground_large:new {
		resource = "ReelBackground_large",
	},
	BoardFrame = Resources.Actor:new {
		name = "BoardFrame",
		resource = "Actor",
		alpha = 0,
		color = "Blue",
		size = Layout{{300+8,350+8}},
        alignment = Layout{"MidTop",android="Center"},
        alignmentOffset =  Layout{{0, 36}, android={0, -39}, iphone5={0, 43+iPhone5_GameBoard_NudgeY}, ipad={0, 43+iPad_GameBoard_NudgeY}, pc={0, 12}},
		hgeParticleLayer = {
			class = "hgeParticleLayer",
			alignment = "MidTop",
			alignTo = "MidTop",
			zorder = -1,
			tag = hgeLayerTag,
		},
	},
}

Resources.GameScreen_Land1 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[1],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[1],

		Black =  Resources.Actor:new{
			resource = "Actor",
			color = "Black",
			size = {1000,1000},
			alpha = 0,
			visible = true,
		},
	},

}

Resources.GameScreen_Land1_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[1],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[1],
	},

}

Resources.GameScreen_Land2 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[2],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[2],
	},
}

Resources.GameScreen_Land2_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[2],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[2],
	},
}

Resources.GameScreen_Land3 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[3],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[3],
	},
}

Resources.GameScreen_Land3_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[3],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[3],
	},
}

Resources.GameScreen_Land4 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[4],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[4],
	},
}

Resources.GameScreen_Land4_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[4],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[4],
	},
}

Resources.GameScreen_Land5 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[5],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[5],
	},
}

Resources.GameScreen_Land5_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[5],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[5],
	},
}

Resources.GameScreen_Land6 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[6],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[6],
	},
}

Resources.GameScreen_Land6_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[6],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[6],
	},
}

Resources.GameScreen_Land7 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[7],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[7],
	},
}

Resources.GameScreen_Land7_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[7],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[7],
	},
}

Resources.GameScreen_Land8 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[8],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[8],
	},
}

Resources.GameScreen_Land8_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[8],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[8],
	},
}


Resources.GameScreen_Land9 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[9],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[9],
	},
}

Resources.GameScreen_Land9_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[9],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[9],
	},
}

Resources.GameScreen_Land10 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[10],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[10],
	},
}

Resources.GameScreen_Land10_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[10],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[10],
	},
}

Resources.GameScreen_Land11 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[11],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[11],
	},
}

Resources.GameScreen_Land11_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[11],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[11],
	},
}

Resources.GameScreen_Land12 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[12],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[12],
	},
}

Resources.GameScreen_Land12_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[12],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[12],
	},
}

Resources.GameScreen_Land13 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[13],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[13],
	},
}

Resources.GameScreen_Land13_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[13],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[13],
	},
}

Resources.GameScreen_Land14 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[14],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[14],
	},
}

Resources.GameScreen_Land14_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[14],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[14],
	},
}

Resources.GameScreen_Land15 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[15],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[15],
	},
}

Resources.GameScreen_Land15_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[15],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[15],
	},
}

Resources.GameScreen_Land16 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[16],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[16],
	},
}

Resources.GameScreen_Land16_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[16],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[16],
	},
}

Resources.GameScreen_Land17 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[17],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[17],
	},
}

Resources.GameScreen_Land17_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[17],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[17],
	},
}

Resources.GameScreen_Land18 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[18],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[18],
	},
}

Resources.GameScreen_Land18_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[18],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[18],
	},
}

Resources.GameScreen_Land19 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[19],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[19],
	},
}

Resources.GameScreen_Land19_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[19],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[19],
	},
}

Resources.GameScreen_Land20 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[20],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[20],
	},
}

Resources.GameScreen_Land20_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[20],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[20],
	},
}

Resources.GameScreen_Land21 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[21],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[21],
	},
}

Resources.GameScreen_Land21_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[21],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[21],
	},
}

Resources.GameScreen_Land22 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[22],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[22],
	},
}

Resources.GameScreen_Land22_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[22],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[22],
	},
}

Resources.GameScreen_Land23 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[23],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[23],
	},
}

Resources.GameScreen_Land23_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[23],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[23],
	},
}

Resources.GameScreen_Land24 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[24],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[24],
	},
}

Resources.GameScreen_Land24_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[24],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[24],
	},
}

Resources.GameScreen_Land25 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[25],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[25],
	},
}

Resources.GameScreen_Land25_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[25],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[25],
	},
}

Resources.GameScreen_Land26 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[26],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[26],
	},
}

Resources.GameScreen_Land26_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[26],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[26],
	},
}

Resources.GameScreen_Land27 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[27],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[27],
	},
}

Resources.GameScreen_Land27_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[27],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[27],
	},
}

Resources.GameScreen_Land28 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[28],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[28],
	},
}

Resources.GameScreen_Land28_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[28],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[28],
	},
}

Resources.GameScreen_Land29 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[29],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[29],
	},
}

Resources.GameScreen_Land29_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[29],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[29],
	},
}

Resources.GameScreen_Land30 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[30],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[30],
	},
}

Resources.GameScreen_Land30_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[30],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[30],
	},
}

Resources.GameScreen_Land31 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[31],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[31],
	},
}

Resources.GameScreen_Land31_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[31],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[31],
	},
}

Resources.GameScreen_Land32 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[32],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[32],
	},
}

Resources.GameScreen_Land32_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[32],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[32],
	},
}

Resources.GameScreen_Land33 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[33],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[33],
	},
}

Resources.GameScreen_Land33_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[33],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[33],
	},
}

Resources.GameScreen_Land34 =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[34],
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = LandBackgroundTable[34],
	},
}

Resources.GameScreen_Land34_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = LandBackgroundTable[34],
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = LandBackgroundTable[34],
	},
}

Resources.GameScreen_DailyChallenge =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = "DailyChallenge_bg.jpg",
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = "DailyChallenge_bg.jpg",
	},
}

Resources.GameScreen_DailyChallenge_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = "DailyChallenge_bg.jpg",
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = "DailyChallenge_bg.jpg",
	},
}

Resources.GameScreen_LabLevel =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = "Special_Game_LAB.jpg",
	backgroundImage = Resources.BackgroundImage:new {
		resource = "BackgroundImage",
		image = "Special_Game_LAB.jpg",
	},
}

Resources.GameScreen_LabLevel_large =  {
	deviceOrientation = "Portrait",
	resource = "GameScreen",
	cutsceneImageName = "Special_Game_LAB.jpg",
	backgroundImage = Resources.BackgroundImage_large:new {
		resource = "BackgroundImage_large",
		image = "Special_Game_LAB.jpg",
	},
}


Scripts.Preshow_GameScreen = function(screen,newScreen)
	--logprint("Preshow_GameScreen")
	local loadingLayer = screen:FindChild("loadingLayer",true)
	loadingLayer.visible = false
end

Scripts.Present_GameScreen = function(screen)

end

Scripts.ExitToReturnScreen = function(screen,destinationScreen)
	--logprint("ExitToReturnScreen")
	local loadingLayer = screen:FindChild("loadingLayer",true)
	loadingLayer.visible = true
	screen.RootActor.backgroundImage.ReelBackground.visible = false
	ScriptBreak()
	ScriptBreak()
	SwitchToScreen(destinationScreen)
end

Scripts.ExitToReturnScreenViaPlayerSwitch = function(screen,destinationScreen)
	-- Switch to the intermediate "PlayerSwitchScreen".  Once this is done,
	-- we'll do a player-switch.
	Scripts.ExitToReturnScreen(screen, "PlayerSwitchScreen")

	-- Switch current-player
    Authentication_FinalizeRemotePlayerSwitch()

	-- Finally, switch to the destination screen, now that player-switching is
	-- complete.
	SwitchToScreen(destinationScreen)
end

Scripts.Leave_GameScreen = function(screen)
	--logprint("Leave_GameScreen")
end