
local spinImg = "Button_SPIN_BLANK_.png"
local spinText = STRINGS("Spin")
if Language == "en" then
	spinImg = "CascadeSpinButton.png"
	spinText = ""
end

-- Used for first time game
FirstTimeUser_GameSeed = 4  -- 2 is good because it shows a multi-direction match, 20 is good too but only shows a match 3

-- Use this to debug gameseeds
--Debug_GameSeed=2

Resources.LargeNoteBubbleNoClose = Resources.AppNoteBubble:new {
	resource = "AppNoteBubble",
	BubbleCloseButton = {
		class = "Button",
		image = "",
		active = false,
	},
	MainTextContainer = {
		class = "Button",
		active = false,
	},
}

local BoostLockedIntro = STRINGS("This Boost is locked.").."\n\n"
local TrickLockedIntro = STRINGS("This Trick is locked.").."\n\n"
local RingLockedIntro = STRINGS("This Ring is locked.").."\n\n"
local LockedOuttro = "\n\n"..STRINGS("Keep playing to free it!")

HelpScripts = {
	["gameIntroduceFeature"] = {
		["spinButton"] = {
			text = STRINGS("Tap Spin To Begin!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = "SpinButton",
			alignmentPoint = "MidTop",
			direction = BUBBLE_POINT_DOWN,
			offset = {0,-30},
		},
		["firstCell"] = {
			text = STRINGS("Touch this spot to make the gem on the bottom come up and create a match of 3 or more of the same colors."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "FIRST_MATCH",},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_DOWN,
			offset = {0,0},
		},
		["wildPiece"] = {
			text = STRINGS("Touch this spot to make the wild gem on the bottom come up and match any color."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "WILD_MATCH",},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_DOWN,
			offset = {0,0},
		},
		["diamond"] = {
			text = STRINGS("7 or more Gems\nmakes a Diamond!\nMatch 3 or more Diamonds to make a Super Wild Gem!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "DIAMOND",},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		["superWild"] = {
			text = STRINGS("3 or more Diamonds\nmakes a Super Wild!\nSuper Wild will match any color, and then match all gems of that color on the board!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "SUPERWILD",},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		["key"] = {
			text = STRINGS("A Super Wild match\nmakes a Key!\nMatch 3 or more Keys to clear the board and level up the multiplier!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "KEY",},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		["spinButtonAgain"] = {
			text = STRINGS("Now Tap To Spin Again!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = "SpinButton",
			alignmentPoint = "MidTop",
			direction = BUBBLE_POINT_DOWN,
			offset = {0,40},
		},

	},

	["menuHelp"] = {
		{
			text = STRINGS("Welcome to Cascade!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = "backgroundImage",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_NONE,
			offset = {0,0},			
		},
		{
			text = STRINGS("Tap here to start a game of Cascade."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "playGameButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_DOWN,
			offset = {0,0},			
		},
		{
			text = STRINGS("Change the board size here."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "buttonSet1",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_DOWN,
			offset = {0,0},			
		},
		{
			text = STRINGS("Change the game mode here. Spins is turn based, while Blitz is timed based."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "buttonSet2",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_DOWN,
			offset = {0,0},			
		},
		{
			text = STRINGS("Tap the player button to see your stats and change your name."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "PlayerButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_UP,
			offset = {0,0},				
		},
		{
			text = STRINGS("Do something amazing in the game and you will get an award! Tap here to see the awards."),	
			resourceName = "AppNoteBubble",
			alignmentTarget = "awardsButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		{
			text = STRINGS("Tap here to play the challenge of the day."),	
			resourceName = "AppNoteBubble",
			alignmentTarget = "StartChallengeButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		{
			text = STRINGS("Top scores are recorded here."),	
			resourceName = "AppNoteBubble",
			alignmentTarget = "leaderboard",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		{
			text = STRINGS("Use the arrow buttons to move between top score lists."),	
			resourceName = "AppNoteBubble",
			alignmentTarget = "nextButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		{
			text = STRINGS("Tap here to get more great Funkitron games!"),						
			resourceName = "AppNoteBubble",
			alignmentTarget = "moreFunButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		{
			text = STRINGS("This button lets you share the game with others. If you like the game, tell your friends about it!"),						
			resourceName = "AppNoteBubble",
			alignmentTarget = "shareButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},
		},
		{
			text = STRINGS("Tap here to change master volume, music volume, and other options."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "OptionsButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {8,0},			
		},
		{
			text = STRINGS("Tap here to quit Cascade."),									
			resourceName = "AppNoteBubble",
			alignmentTarget = "QuitButton",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},			
		},
		{
			text = STRINGS("That's all for now. Tap 'Help' on any screen to learn more about it."),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",		
		},
	},
	["awardHelp"] = {
		{
			text = STRINGS("This is where you can see all the awards you have won. Click 'Next' for more."),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",		
		},
		{
			text = STRINGS("Here is one of the awards. They turn bright when you win them. Click on them for more info."),			
			resourceName = "AppNoteBubble",
			alignmentTarget = "BigScore",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
			offset = {0,0},			
		},
		{
			text = STRINGS("NeedToWinAwardHelp"),			
			resourceName = "AppNoteBubble",
			alignmentTarget = "Text",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_UP,
			offset = {-10,-20},			
		},
		{
			text = STRINGS("EarningAwardHelp"),			
			resourceName = "AppNoteBubble",
			alignmentTarget = "Text",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_UP,
			offset = {-10,20},			
		},
		{
			text = STRINGS("HowManyAwardsHelp"),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",		
		},
	},
	["gameHelp"] = {
		{
			text = STRINGS("The goal of Cascade is to get as many points as you can..."),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_UP,
			alignmentTarget = "ScoreLabel",
			alignmentPoint = "Center",		
			offset = {-20,-20},
		},
		{
			text = STRINGS("Before you run out of spins!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = "RemainingSpinsContainer",
			alignmentPoint = Center,
			offset = {-30,0},
			direction = BUBBLE_POINT_DOWN,
		},
		{
			text = STRINGS("Before you run out of time!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = "TimeLimitLabels",
			alignmentPoint = Center,
			offset = {-30,0},
			direction = BUBBLE_POINT_DOWN,
		},
		{
			text = STRINGS("Tap Spin to begin"),
			resourceName = "AppNoteBubble",
			alignmentTarget = "SpinButton",
			alignmentPoint = MidTop,
			offset = {0,30},
			direction = BUBBLE_POINT_DOWN,
		},
		{
			text = STRINGS("Move the gems that appear on the bottom reel..."),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_DOWN,
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "BottomLeft",		
			offset = {0,40},
		},
		{
			text = STRINGS("...up to the locations on the board that match 3 or more."),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_DOWN,
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "MidLeft",		
			offset = {0,50},
		},
		{
			text = STRINGS("Match all the gems in the real to get a free spin and increase the multiplier."),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",		
		},
		{
			text = STRINGS("Match 7 or more GEMS to make DIAMONDS!"),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",		
		},
		{
			text = STRINGS("Match DIAMONDS to make SUPER WILD GEMS!"),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",		
		},
		{
			text = STRINGS("Match SUPER WILD GEMS to make KEYS!"),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",		
		},
		{
			text = STRINGS("Match KEYS to clear the board and increase the multiplier!"),			
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",		
		},
		{
			text = STRINGS("Click here to quit your game and return to the menu."),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_DOWN,
			alignmentPoint = "Center",
			alignmentTarget = "MenuButton",
			offset = {10,0},
		},

	},
	
	["SuperMatch"] = {
		["SpinButton"] = {
			text = STRINGS("Tap a main board gem to activate your super match. You can spin afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_NONE,
		},
		["SlotCell"] = {
			text = STRINGS("Tap a main board gem to activate your super match. Slot cells will not be affected."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_NONE,
		},
		["SingleColorGem"] = {
			text = STRINGS("You must choose a single-color gem for super match."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_NONE,
		},
		["UncoveredGem"] = {
			text = STRINGS("You cannot super match this type of gem. Try a clean gem of the same color."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_NONE,
		},
	},
	["Hammer"] = {
		["SpinButton"] = {
			text = STRINGS("Tap a main board gem to use the hammer. You can spin afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["TrickButton"] = {
			text = STRINGS("Tap a main board gem to use the hammer. You can try other tricks afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["SlotCell"] = {
			text = STRINGS("Tap a main board gem to use the hammer. Slot cells will not be affected."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["ContinueToken"] = {
		["HasTokens"] = {
			text = STRINGS("A continue token lets you keep playing without losing a life! Tap continue to use it."),
			resourceName = "SmallNoteBubble",
			alignmentPoint = "MidTop",
			offset = {0,-100},
			direction = BUBBLE_POINT_NONE,
		},
		["NoTokens"] = {
			text = STRINGS("Oh no, you're about to lose! Tap the continue button and I'll give you a free continue token!"),
			resourceName = "SmallNoteBubble",
			alignmentPoint = "MidTop",
			offset = {0,-100},
			direction = BUBBLE_POINT_NONE,
		},
		["ThreeMoreTokens"] = {
			text = STRINGS("Have some more tokens in case you get stuck again later!"),
			resourceName = "SmallNoteBubbleWithOkay",
			alignmentPoint = "MidTop",
			offset = {0,-100},
			direction = BUBBLE_POINT_NONE,
		},
	},
	["GemSwipe"] = {
		["SpinButton"] = {
			text = STRINGS("Drag on a main board gem to activate your GemSwipe. You can spin afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["TrickButton"] = {
			text = STRINGS("Drag on a main board gem to activate your GemSwipe. You can try other tricks afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["SlotCell"] = {
			text = STRINGS("Drag on a main board gem to activate your GemSwipe.. Slot cells will not be affected."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["MakeWild"] = {
		["SpinButton"] = {
			text = STRINGS("Tap a gem to activate Make Wild. You can spin afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["TrickButton"] = {
			text = STRINGS("Tap a gem to activate Make Wild. You can try other tricks afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["SingleColorGem"] = {
			text = STRINGS("You must choose a single-color gem for Make Wild."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["GemYouCanPlayOn"] = {
			text = STRINGS("You must choose a gem you could normally play a slot gem onto for Make Wild."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllBoardCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["Shifter"] = {
		["SpinButton"] = {
			text = STRINGS("Tap a gem in the reels to activate Shifter. You can spin afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllSlotsCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["TrickButton"] = {
			text = STRINGS("Tap a gem in the reels to activate Shifter. You can try other tricks afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllSlotsCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["BoardButton"] = {
			text = STRINGS("Tap a gem in the reels to activate Shifter. You can play on the board afterwards."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllSlotsCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
		["EmptySlot"] = {
			text = STRINGS("You must tap a gem, not an empty space, in the reels."),
			resourceName = "AppNoteBubble",
			alignmentTarget = "AllSlotsCells",
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["trickDefinitions"] = {
		["SuperMatch"] = {
			text = GetLocalizedString("PostBuy_SuperMatch_Description"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["MakeWild"] = {
			text = GetLocalizedString("PostBuy_MakeWild_Description"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["MegaMatch"] = {
			text = GetLocalizedString("PostBuy_MegaMatch_Description"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["WildSpin"] = {
			text = GetLocalizedString("PostBuy_WildSpin_Description"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["GemSwipe"] = {
			text = GetLocalizedString("PostBuy_GemSwipe_Description"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["Shifter"] = {
			text = GetLocalizedString("PostBuy_Shifter_Description"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["Hammer"] = {
			text = GetLocalizedString("PostBuy_Hammer_Description"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["powerupBubbles"] = {
		["crates"] = {
			text = STRINGS("Stones: Match next to each stone to smash it."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasCrates"] = {
			text = STRINGS("Stones: Match next to each stone to smash it."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasChests"] = {
			text = STRINGS("Treasure Chests: Match by dropping them to the bottom for 10x points."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["easyDiamonds"] = {
			text = STRINGS("Easy Diamonds: You only need 6 gems to make a diamond."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["jailedSquares"] = {
			text = STRINGS("Jailed Gems: Match the jailed gem to free it."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["LuckyWilds"] = {
			text = STRINGS("Lucky Wilds: You will get more wild gems spun up."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["missingSquares"] = {
			text = STRINGS("Missing Squares:Some squares are missing."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasMissingSquares"] = {
			text = STRINGS("Missing Squares: Some squares are missing."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["gemTypes6"] = {
			text = STRINGS("Orange Gems: Adds orange gems to the board."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["largeBoard"] = {
			text = STRINGS("Large Board: This level has a large board."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},

		["modeSpins1"] = {text = STRINGS("1 Spin: Start the game with only 1 spin."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins2"] = {text = STRINGS("2 Spins: Start the game with only 2 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins3"] = {text = STRINGS("3 Spins: Start the game with only 3 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins4"] = {text = STRINGS("4 Spins: Start the game with only 4 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins5"] = {text = STRINGS("5 Spins: Start the game with only 5 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins6"] = {text = STRINGS("6 Spins: Start the game with only 6 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins7"] = {text = STRINGS("7 Spins: Start the game with only 7 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins8"] = {text = STRINGS("8 Spins: Start the game with only 8 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins9"] = {text = STRINGS("9 Spins: Start the game with only 9 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins10"] = {text = STRINGS("10 Spins: Start the game with only 10 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins11"] = {text = STRINGS("11 Spins: Start the game with only 11 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins12"] = {text = STRINGS("12 Spins: Start the game with only 12 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins13"] = {text = STRINGS("13 Spins: Start the game with only 13 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins14"] = {text = STRINGS("14 Spins: Start the game with only 14 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins15"] = {text = STRINGS("15 Spins: Start the game with only 15 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins16"] = {text = STRINGS("16 Spins: Start the game with only 16 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins17"] = {text = STRINGS("17 Spins: Start the game with only 17 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins18"] = {text = STRINGS("18 Spins: Start the game with only 18 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},
		["modeSpins19"] = {text = STRINGS("19 Spins: Start the game with only 19 spins."),resourceName = "AppNoteBubble",alignmentTarget = {tag = "ClickedPowerup"},direction = BUBBLE_POINT_UP,		},

		["modeSpins20"] = {
			text = STRINGS("20 Spins: Start the game with 20 spins."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["modeSpins10"] = {
			text = STRINGS("10 Spins: Start the game with 10 spins."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["coverage"] = {
			text = STRINGS("Pattern: Get rid of the pattern of tar squares."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasCoverage"] = {
			text = STRINGS("Pattern: Get rid of the pattern of tar squares."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["treasureChest"] = {
			text = STRINGS("Treasure Chests: Drop each treasure chest to the bottom to open it."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasVines"] = {
			text = STRINGS("Vines: Stop the vines from spreading!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasBarrels"] = {
			text = STRINGS("Boulders: Stop the boulders from falling!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasDiamondMode"] = {
			text = STRINGS("Diamond Mode: Match Diamonds, Super Wilds, and Keys for huge scores!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasStones"] = {
			text = STRINGS("Rocks: Match twice to crack the rocks!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasBombs"] = {
			text = STRINGS("Bombs: Match before the timer ticks down and goes boom!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasSteel"] = {
			text = STRINGS("Steel: Unbreakable!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		["hasJailedSquares"] = {
			text = STRINGS("Jails: Match the gem color to break the gem out of jail!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedPowerup"},
			direction = BUBBLE_POINT_UP,
		},
		
		
		--Not sure if this is needed...
		["Tweak_Difficulty_Easiest"] = {},
		["Tweak_Difficulty_Easy"] = {},
		["Tweak_Difficulty_Easier"] = {},
		["Tweak_Difficulty_Default"] = {},
		["Tweak_Difficulty_Harder"] = {},
		["Tweak_Difficulty_Hard"] = {},
		["Tweak_Difficulty_Hardest"] = {},
		["Boost_Lucky"] = {},
		["Boost_Pro"] = {},
	},
	["boostBubbles"] = {
		["LuckyWilds"] = {
			text = BoostLockedIntro..STRINGS("Unlock Lucky Wilds\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["SpinSaver"] = {
			text = BoostLockedIntro..STRINGS("Unlock Spin Saver\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["MultiplierBonus"] = {
			text = BoostLockedIntro..STRINGS("Unlock Multiplier Bonus\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["BetterBurst"] = {
			text = BoostLockedIntro..STRINGS("Unlock Better Burst\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["StartBurst"] = {
			text = BoostLockedIntro..STRINGS("Unlock Start Burst\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["WildBoard"] = {
			text = BoostLockedIntro..STRINGS("Unlock Wild Board\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["boostBubbles_NoTutorial"] = {
		["SpinSaver"] = {
			text = STRINGS("You can play your free Spin Saver by playing the tutorial on level %s."),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["MultiplierBonus"] = {
			text = STRINGS("You can play your free Multiplier Bonus by playing the tutorial on level %s."),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["StartBurst"] = {
			text = STRINGS("You can play your free Start Burst by playing the tutorial on level %s."),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["trickBubbles"] = {
		["SuperMatch"] = {
			text = TrickLockedIntro..STRINGS("Unlock Super Match\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["MakeWild"] = {
			text = TrickLockedIntro..STRINGS("Unlock Make Wild\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["MegaMatch"] = {
			text = TrickLockedIntro..STRINGS("Unlock Mega Match\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["WildSpin"] = {
			text = TrickLockedIntro..STRINGS("Unlock Wild Spin\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["GemSwipe"] = {
			text = TrickLockedIntro..STRINGS("Unlock Gem Swipe\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["Shifter"] = {
			text = TrickLockedIntro..STRINGS("Unlock Shifter\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["Hammer"] = {
			text = TrickLockedIntro..STRINGS("Unlock Hammer\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["SpinNow"] = {
			text = TrickLockedIntro..STRINGS("Unlock Spin Now\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedTrick"},
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["ringBubbles"] = {
		["bonusSpin"] = {
			text = RingLockedIntro..STRINGS("Unlock Ring of Power\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedRing"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["extraLife"] = {
			text = RingLockedIntro..STRINGS("Unlock Ring of Life\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedRing"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["cascadeVision"] = {
			text = RingLockedIntro..STRINGS("Unlock Ring of True Seeing\nby beating level %s")..LockedOuttro,
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedRing"},
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["tapFreeBoost"] = {
		["SpinSaver"] = {
			text = STRINGS("Tap Spin Saver to turn it on for this level!"),
			resourceName = "LargeNoteBubbleNoClose",
			alignmentTarget = {tag = "FreeBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["MultiplierBonus"] = {
			text = STRINGS("Tap Multiplier Bonus to turn it on for this level!"),
			resourceName = "LargeNoteBubbleNoClose",
			alignmentTarget = {tag = "FreeBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["StartBurst"] = {
			text = STRINGS("Tap Start Burst to turn it on for this level!"),
			resourceName = "LargeNoteBubbleNoClose",
			alignmentTarget = {tag = "FreeBoost"},
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	["featureBubbles"] = {
		["regularBoard"] = {
			text = STRINGS("Regular Board"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["largeBoard"] = {
			text = STRINGS("Large Board"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["modeSpins4"] = {
			text = STRINGS("4 spins"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["modeSpins5"] = {
			text = STRINGS("5 spins"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["modeSpins6"] = {
			text = STRINGS("6 spins"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["modeSpins7"] = {
			text = STRINGS("7 spins"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["gemTypes4"] = {
			text = STRINGS("4 Gem Types"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["gemTypes5"] = {
			text = STRINGS("5 Gem Types"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["gemTypes6"] = {
			text = STRINGS("6 Gem Types"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["LuckyWilds"] = {
			text = STRINGS("Lucky Wilds"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["WildBoard"] = {
			text = STRINGS("Wild Board"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["StartBurst"] = {
			text = STRINGS("StartBurst"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["startSuperwild"] = {
			text = STRINGS("Start Superwild"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringBurst4"] = {
			text = STRINGS("Constant Bursts"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringBurst5"] = {
			text = STRINGS("Constant Bursts"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringBurst6"] = {
			text = STRINGS("Constant Bursts"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringSuperwild"] = {
			text = STRINGS("Constant Superwilds"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringChests"] = {
			text = STRINGS("Constant Chests"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["pattern"] = {
			text = STRINGS("Pattern Mode"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["fewMissingSquares"] = {
			text = STRINGS("Shaped Board"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["fewVines"] = {
			text = STRINGS("Vines"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["fewSteel"] = {
			text = STRINGS("Steel"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["someCrates"] = {
			text = STRINGS("Crates"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["someJails"] = {
			text = STRINGS("Jails"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["someStones"] = {
			text = STRINGS("Stones"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["someTripleStones"] = {
			text = STRINGS("Strong Stones"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["lotsBombs"] = {
			text = STRINGS("Bombs"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["lotsBarrels"] = {
			text = STRINGS("Boulders"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringBombs4"] = {
			text = STRINGS("Constant Bombs"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringBombs5"] = {
			text = STRINGS("Constant Bombs"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringBarrels"] = {
			text = STRINGS("Constant Boulders"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringBombBarrels"] = {
			text = STRINGS("Bomb Boulders"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["recurringBombChests"] = {
			text = STRINGS("Bomb Chests"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["always10Barrels"] = {
			text = STRINGS("Boulder Horde"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["fewLava"] = {
			text = STRINGS("Lava"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["someAmber"] = {
			text = STRINGS("Amber"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
		["someIce"] = {
			text = STRINGS("Ice"),
			resourceName = "AppNoteBubble_noCharacter",
			alignmentTarget = {tag = "ClickedFeature"},
			direction = BUBBLE_POINT_VERTICAL,
		},
	},
	
	chooseFeatureIntro = {
		{
			text = STRINGS("In Supreme Mode, you can choose from 16 special powers to take with you into the game."),
			resourceName = "LargeNoteBubbleNoClose",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",
		},
		{
			text = STRINGS("Right now, the only power you can use is 'Pattern'. Click it to turn it on."),
			resourceName = "LargeNoteBubbleNoClose",
            button_states = BUBBLE_ALL_BUTTONS_OFF,
			direction = BUBBLE_POINT_DOWN,
			alignmentPoint = "MidTop",
			alignmentTarget = "pattern",
			offset = {0,40},
		},
	},
	packageSelected = {
		{
			text = STRINGS("Now click play to start!"),
			resourceName = "LargeNoteBubbleNoClose",
            button_states = BUBBLE_ALL_BUTTONS_OFF,
			direction = BUBBLE_POINT_VERTICAL,
			alignmentPoint = "Center",
			alignmentTarget = "playGameButton",
		},
	},
	secondSlot = {
		{
			text = STRINGS("Here's the new slot you unlocked!"),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_DOWN,
			alignmentPoint = "MidTop",
			alignmentTarget = "featureHolder2",
		},
		{
			text = STRINGS("Now you can turn on two special powers at once!"),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_DOWN,
			alignmentPoint = "MidTop",
			alignmentTarget = "featureHolder2",
		},
		{
			text = STRINGS("Click a locked slot to see how to unlock more slots!"),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_DOWN,
			alignmentPoint = "MidTop",
			alignmentTarget = "featureHolder3",
		},
		{
			text = STRINGS("Click your star count to see how to unlock more stars!"),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_RIGHT,
			alignmentPoint = "MidLeft",
			alignmentTarget = "starCount",
		},
	},
	newFeatureWithRoom = {
		{
			text = STRINGS("Here's the new special power you earned last game!"),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_VERTICAL,
			alignmentPoint = "Center",
			alignmentTarget = "extraTurns",
		},
		{
			text = STRINGS("Click it and you can find coins in your next game that give extra turns!"),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_VERTICAL,
			alignmentPoint = "Center",
			alignmentTarget = "extraTurns",
		},
	},
	newFeatureNoRoom = {
		{
			text = STRINGS("Here's the new special power you earned last game!"),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_VERTICAL,
			alignmentPoint = "Center",
			alignmentTarget = "extraTurns",
		},
		{
			text = STRINGS("Click here to disable the currently selected special power."),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_VERTICAL,
			alignmentPoint = "Center",
			alignmentTarget = "checkMark",
		},
	},
	newFeatureRoomCreated = {
		{
			text = STRINGS("Now you can click Extra Turns to enable it!"),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_VERTICAL,
			alignmentPoint = "Center",
			alignmentTarget = "extraTurns",
		},
	},
	outOfSpace = {
		{
			text = STRINGS("To make room for additional special powers, you can turn off powers that you have selected."),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
			alignmentPoint = "Center",
		},
		{
			text = STRINGS("Click a powerup to turn it off to reclaim its space and star cost."),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_VERTICAL,
			alignmentPoint = "Center",
			alignmentTarget = "featureHolder1",
		},
	},
	["reelBubbles"] = {
		["SLOT_GEM"] = {
			text = STRINGS("FindColumnAboveReelHelp"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedReel"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["SLOT_DIAMOND"] = {
			text = STRINGS("FindColumnAboveReelHelp_DIAMOND"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedReel"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["SLOT_WILD"] = {
			text = STRINGS("FindColumnAboveReelHelp_WILD"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedReel"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["SLOT_KEY"] = {
			text = STRINGS("FindColumnAboveReelHelp_KEY"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedReel"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["SLOT_EMPTY"] = {
			text = STRINGS("FindColumnAboveReelHelp_EMPTY"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedReel"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["dontHaveToTap"] = {
			text = STRINGS("You don't have to tap slot gems to make matches. Just tap in the column above, and the gem will automatically fly up."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedReel"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
    ["cellBubbles"] = {
		["CELL_SPLASH"] = {
			text = STRINGS("CellSplashHelp"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedCell"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["CELL_LASER"] = {
			text = STRINGS("CellLaserHelp"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedCell"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["CELL_SUPERWILD"] = {
			text = STRINGS("CellSuperwildHelp"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedCell"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["SLOT_EMPTY"] = {
			text = STRINGS("CellEmptyHelp"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedCell"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["SLOT_MISSING"] = {
			text = STRINGS("CellMissingHelp"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ClickedCell"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
    ["IntroduceTrick"] = {
		["SuperMatch"] = {
			text = STRINGS("Tap here to match every %s gem on the board!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "MostCommonColor"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["Shifter"] = {
			text = STRINGS("First tap the slot gem you want to move."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ShifterStart"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["ShifterEnd"] = {
			text = STRINGS("Then tap which slot you want to move it to."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "ShifterEnd"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["MakeWild_Reels"] = {
			text = STRINGS("Tap a slot gem to turn it into a wild gem that matches any color."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "MakeWild"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["MakeWild_Reels_Flipped"] = {
			text = STRINGS("You can also use Make Wild to turn slot pieces into wilds!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "MakeWild"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["MakeWild_Board"] = {
			text = STRINGS("You can also use Make Wild to turn board pieces into wilds!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "MakeWild"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["MakeWild_Board_Flipped"] = {
			text = STRINGS("Tap a board piece to turn it into a wild gem that will match with any color!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "MakeWild"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["GemSwipe"] = {
			text = STRINGS("Press down on the board where you want to begin matching..."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "GemSwipe"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_ALL_BUTTONS_OFF,
		},
		["GemSwipeEnd"] = {
			text = STRINGS("Swipe your finger across the board to define a line, and then lift up to match every cell along it."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "GemSwipe"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_ALL_BUTTONS_OFF,
		},
		["GemSwipeMissed"] = {
			text = STRINGS("That Gem Swipe didn't hit any legal gems. Make sure it's at least two spaces long and hits colored gems."),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["Hammer"] = {
			text = STRINGS("Tap a gem or obstacle you'd like to get rid of."),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
    ["MoreLevelsDialog"] = {
		["NotEnoughGems"] = {
			text = STRINGS("You don't have enough special gems to open this gate. Find more special gems in the previous lands."),
			resourceName = "AppNoteBubble",
			direction = BUBBLE_POINT_NONE,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
    ["QuickQuest"] = {
        ["FirstUnlocked"] = {
            text = STRINGS("Quickly collect all the gold cups and win a big prize!"),
            resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "FirstQuickQuest"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
        },
        ["FirstIcon"] = {
            text = STRINGS("Earn this star to win the gold cup!"),
            resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "FirstQuickQuestIcon"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
        },
    },
    ["Discoveries"] = {
		["NotEnoughWorkers"] = {
			text = STRINGS("Find more Explorers by beating levels to unlock this discovery."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "NotEnoughWorkers"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["FirstWorker"] = {
			text = STRINGS("If you win this star, you'll get an explorer to help unlock a discovery. Find all the explorers to learn more!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "FirstWorker"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
			offset = {27,48},
		},
		["FirstSpecialGem"] = {
			text = STRINGS("This level has Special Gems! Collect them to open up fun new lands."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "FirstSpecialGem"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
			offset = {0,0},
		},
		["DiscoveryReady"] = {
			text = STRINGS("You've found all the explorers you need for this discovery. Tap it to build it!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "DiscoveryReady"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["DiscoveryDialog"] = {
			text = STRINGS("Spend gold to build the discovery, and it will make special gems forever!"),
			resourceName = "AppNoteBubble",
			alignment = Center,
			direction = BUBBLE_POINT_NONE,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["DiscoveryBuilt"] = {
			text = STRINGS("When the discovery fills up, you can tap it to harvest the gems. In the meantime, you can tap it to upgrade it."),
			resourceName = "AppNoteBubble",
			alignment = Center,
			alignmentTarget = {tag = "DiscoveryBuilt"},
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
	["SecretTunnels"] = {
		["FirstUnlocked"] = {
			text = STRINGS("You've unlocked Secret Tunnels! These are side levels you can play to earn gold and special gems."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "FirstSideLevel"},
			alignmentPoint = "MidTop",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["LevelLocked"] = {
			text = STRINGS("You must complete level %s to unlock this secret tunnel."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "LockedTunnel"},
			alignmentPoint = "MidTop",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["TunnelLocked"] = {
			text = STRINGS("You must complete secret tunnel %s to unlock this secret tunnel."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "LockedTunnel"},
			alignmentPoint = "MidTop",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
	["LevelBubble"] = {
		["LevelLocked"] = {
			text = STRINGS("You must complete level %s to unlock this level."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "LockedLevel"},
			alignmentPoint = "MidTop",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["GateLocked"] = {
			text = STRINGS("You must unlock land %s to play this level."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "LockedLevel"},
			alignmentPoint = "MidTop",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
	["DigSpotBubbles"] = {
		["DigSpotIntro"] = {
			text = STRINGS("It looks like something's buried here. Tap the spot to find out what!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "DigSpot"},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_ALL_BUTTONS_OFF,
		},
		["DigSpotOuttro"] = {
			text = STRINGS("You found some special gems! Keep an eye out for more places to dig. You never know where or when they'll appear!"),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "DigSpot"},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
	["TopBarGem"] = {
		["SpecialGreen"] = {
			text = STRINGS("Earth Gems:\n\nUse these to unlock future lands."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "TappedSpecialGem"},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["SpecialBlue"] = {
			text = STRINGS("Water Gems:\n\nUse these to unlock future lands."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "TappedSpecialGem"},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
		["SpecialRed"] = {
			text = STRINGS("Fire Gems:\n\nUse these to unlock future lands."),
			resourceName = "AppNoteBubble",
			alignmentTarget = {tag = "TappedSpecialGem"},
			alignmentPoint = "Center",
			direction = BUBBLE_POINT_VERTICAL,
            button_states = BUBBLE_OKAY_BUTTON_ON,
		},
	},
}

GameTipScripts = {
	["gameTips"] = {
		{
			title = STRINGS("Welcome!"),
			--titleImage = "titleSpinToGetGems.png",
			image = spinImg,


            localizedLabel = Resources.Label:new {
                resource = "Label",
                alignment = Center,
                alignTo = Center,
                fgColor = {0xff,0xe9,0x60},
                highlightColor = "White",
                shadowColor = "Cascade_DarkBrown",
                alpha = 255,
                showHighlight = true,
                font	= Resources.DialogBoldFont:new{
                    resource = "DialogBoldFont",
                    fontSize = 30,
                },
            text = spinText,
            },

			text = STRINGS("Let's learn how to play Cascade! Tapping the Spin button will fill the slots along the bottom of the screen with gems."),
			size = {143, 143},
		},
		{
			title = STRINGS("Tap to Match Gems"),
			image = "Help_Match3.png",
			text = STRINGS("Tap a square to fling a gem upwards from the slot below that column."),
			size = {256, 209},
		},
		{
			title = STRINGS("Tap to Match Gems"),
			image = "Help_Match3.png",  
			text = STRINGS("A gem from the slots can be flung upwards to form a group of at least 3 matching gems."),
			size = {256, 209},
		},
		{
			title = STRINGS("Matching Gems"),
			image = "",  
			text = STRINGS("Matches do not have to be in a straight line."),
			size = {256, 209},
			["extraImages"] = {
				{
					image = "GemGreen.png",
					alignmentOffset = {80,190},
					zorder = 2,
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {80,240},
					zorder = 2,
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {125,190},
					zorder = 2,
				},
				{
					image = "GemYellow.png",
					alignmentOffset = {250,190},
					zorder = 2,
				},
				{
					image = "GemYellow.png",
					alignmentOffset = {250,240},
					zorder = 2,
				},
				{
					image = "GemYellow.png",
					alignmentOffset = {200,240},
					zorder = 2,
				},
			}
		},
		{
			title = STRINGS("Match All Gems!"),
			image = "Help_FreeSpin.png",  
			text = STRINGS("Matching all the gems in the slots gives you a free spin!"),
			size = {159, 214},
		},
		{
			title = STRINGS("Earn Stars"),
			image = "StarBig.png",  
			text = STRINGS("Each level has a minimum score required to earn a star. Higher scores will earn more stars! Use the meter in the upper right corner to track your progress."),
			size = {130, 130},
		},
		{
			title = STRINGS("Wilds!"),
			image = "Wildgem.png",  
			text = STRINGS("Wild gems match any color."),
			size = {56, 60},
		},
		{
			title = STRINGS("Super Wilds!"),
			image = "SuperWildGem.png",  
			text = STRINGS("Matching 3 colors at once with a wild gem makes a super wild gem!"),
			size = {50, 50},
			alignmentOffset = {90, 5},
			equals = true,
			["extraImages"] = {

				{
					image = "Wildgem.png",
					alignmentOffset = {120,215},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemBlue.png",
					alignmentOffset = {80,175},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {80,215},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemBlue.png",
					alignmentOffset = {120,175},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemYellow.png",
					alignmentOffset = {160,215},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemYellow.png",
					alignmentOffset = {160,255},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemYellow.png",
					alignmentOffset = {120,255},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {40,215},
					zorder = 2,
					size = {35, 35},
				},
			}
		},
		{
			title = STRINGS("Burst Gems"),
			image = "",  
			text = STRINGS("Matches of at least 8 gems make a burst gem."),
			size = {50, 50},
			["extraImages"] = {
				{
					image = "Boom.png",
					alignmentOffset = {101,220},
					zorder = 3,
				},
				{
					image = "Vertical.png",
					alignmentOffset = {161,220},
					zorder = 5,
				},
				{
					image = "Horizontal.png",
					alignmentOffset = {221,220},
					zorder = 3,
				},
				{
					image = "GemYellow.png",
					alignmentOffset = {221,220},
					zorder = 2,
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {101,220},
					zorder = 2,
				},
				{
					image = "GemBlue.png",
					alignmentOffset = {161,220},
					zorder = 2,
				},
			}
		},
		{
			title = STRINGS("Burst Gems"),
			image = "",  
			size = {50, 50},
			text = STRINGS("If the match is taller than it is wide, it makes a horizontal burst gem."),
			alignmentOffset = {80, 0},
			equals = true,
			["extraImages"] = {
				{
					image = "GemRed.png",
					alignmentOffset = {251,220},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "Horizontal.png",
					alignmentOffset = {251,220},
					zorder = 5,
					size = {35, 35},
				},
				{
					image = "GemRed.png",
					alignmentOffset = {120,270},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemRed.png",
					alignmentOffset = {160,270},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemRed.png",
					alignmentOffset = {120,230},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemRed.png",
					alignmentOffset = {120,190},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemRed.png",
					alignmentOffset = {120,150},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemRed.png",
					alignmentOffset = {80,270},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemRed.png",
					alignmentOffset = {80,230},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemRed.png",
					alignmentOffset = {160,150},
					zorder = 2,
					size = {35, 35},
				},
			}
		},
		{
			title = STRINGS("Burst Gems"),
			image = "",  
			size = {50, 50},
			text = STRINGS("If the match is wider than it is tall, it makes a vertical burst gem."),
			alignmentOffset = {90, 0},
			equals = true,
			["extraImages"] = {
				{
					image = "GemGreen.png",
					alignmentOffset = {251,220},
					zorder = 5,
					size = {35, 35},
				},
				{
					image = "Vertical.png",
					alignmentOffset = {251,220},
					zorder = 5,
					size = {35, 35},
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {50,180},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {130,180},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {50,220},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {90,220},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {130,220},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {170,220},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {50,260},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemGreen.png",
					alignmentOffset = {90,260},
					zorder = 2,
					size = {35, 35},
				},
			}
		},
		{
			title = STRINGS("Burst Gems"),
			image = "",  
			size = {50, 50},
			text = STRINGS("If the match spans the same number of rows and columns, it makes an area burst gem. "),
			alignmentOffset = {80, 0},
			equals = true,
			["extraImages"] = {
				{
					image = "GemPurple.png",
					alignmentOffset = {251,220},
					zorder = 5,
					size = {35, 35},
				},
				{
					image = "Boom.png",
					alignmentOffset = {251,220},
					zorder = 5,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {80,180},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {120,180},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {80,220},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {120,220},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {160,220},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {160,260},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {120,260},
					zorder = 2,
					size = {35, 35},
				},
				{
					image = "GemPurple.png",
					alignmentOffset = {80,260},
					zorder = 2,
					size = {35, 35},
				},
			}
		},
		{
			title = STRINGS("Have Fun!"),
			image = "Character_GemHold.png",  
			text = STRINGS("That's all for now! Have fun!"),
			size = {200, 200},
		},
	},
}

Resources.DimOverlay = Resources.Actor:new {
	name = "DimOverlay",
	resource = "Actor",
	alpha = 128,
	color = "Black",
	layer = 7,
	visible = false,
}

Resources.FullScreenDim = Resources.Actor:new {
	resource = "Actor",
	name = "FullScreenDim",
	visible = false,
	alpha = 0,
	dimAbove = Resources.DimOverlay:new {
		resource = "DimOverlay",
		alignment = MidBottom,
		alignTo = MidTop,
		visible = true,
	},
	dimLeftSide = Resources.DimOverlay:new {
		resource = "DimOverlay",
		size = {500,1500}, --So big it definitely covers whole side no matter where it's placed
		alignment = MidRight,
		alignTo = MidLeft,
		visible = true,
	},
	dimRightSide = Resources.DimOverlay:new {
		resource = "DimOverlay",
		alignment = MidLeft,
		alignTo = MidRight,
		size = {500,1500}, --So big it definitely covers whole side no matter where it's placed
		visible = true,
	},
	dimBetweenReelsAndBoard = Resources.DimOverlay:new {
		resource = "DimOverlay",
		alignment = MidTop,
		alignTo = MidBottom,
		visible = true,
	},
	dimBelowReels = Resources.DimOverlay:new {
		resource = "DimOverlay",
		visible = true,
	},
}

Scripts.ResizeFullScreenDim = function(self,rootGameView)
	self.size = self.parent.size
	self.dimAbove.size = {self.size.x, self.globalPosition.y}
	local reelTop = rootGameView.AllSlotsCells.globalPosition.y
	local boardBottom = rootGameView.AllBoardCells.globalPosition.y + self.size.y
	self.dimBetweenReelsAndBoard.size = {self.size.x, reelTop - boardBottom}
	self.dimBelowReels.size = {self.size.x, 1000}
	self.dimBelowReels.globalPosition = {self.globalPosition.x,reelTop + rootGameView.AllSlotsCells.size.y}
end

Scripts.ShowDimOverlay = function(self,rootGameView)
	WaitForTaggedScriptCompletion(rootGameView,"Piece_Drop")
	FadeIn(self,200)
end

Scripts.HideDimOverlay = function(self,rootGameView)
	WaitForTaggedScriptCompletion(rootGameView,"Piece_Drop")
	FadeOutAndDestroy(self,200)
end

Resources.DisableOverlay = Resources.Actor:new {
	name = "DisableOverlay",
	resource = "Actor",
	zorder = 10,
	rolloverable = true,
}

Resources.CaptionFirstGate = Resources.Label:new {
	resource = "Label",
	name = "Caption",
	wrapLimit = 280,
    heightLimit = 62,
	layer = 899,
	centerWrap = true,
	text = STRINGS("Tap the gate to move on to the next land!"),
	font = Resources.NoteBubbleFont:new {
		resource = "NoteBubbleFont",
	},
	margins = Resources.Margins:new
	{
		class	= "Margins",
		left	= 10,
		right	= 10,
		top		= 10,
		bottom	= 10,
	},
	fgColor = "Black",
	backgroundLayer = Resources.Actor:new {
		resource = "Actor",
		image = "TutorialBox.png",
		alignment = Center,
		alignTo = Center,
	},
}

Resources.CaptionDefaults = Resources.Label:new {
	resource = "Label",
	name = "Caption",
	wrapLimit = 280,
    heightLimit = 62,
	layer = 899,
	centerWrap = true,
	font = Resources.NoteBubbleFont:new {
		resource = "NoteBubbleFont",
	},
	margins = Resources.Margins:new
	{
		class	= "Margins",
		left	= 10,
		right	= 10,
		top		= 10,
		bottom	= 10,
	},
	fgColor = "Black",
	backgroundLayer = Resources.Actor:new {
		resource = "Actor",
		image = "TutorialBox.png",
		alignment = Center,
		alignTo = Center,
		character = Resources.Actor:new {
			resource = "Actor",
			image = "Character_Explorer.png",
			alignment = MidBottom,
			alignTo = TopLeft,
			alignmentOffset = {40,20},
			scripts = {"DialogButtonGroove"},
			visible = false, -- took off character for now
		},
	},
}

Resources.CaptionNoCharacter = Resources.Label:new {
	resource = "Label",
	name = "Caption",
	wrapLimit = 280,
    heightLimit = 62,
	layer = 899,
	centerWrap = true,
	font = Resources.NoteBubbleFont:new {
		resource = "NoteBubbleFont",
	},
	margins = Resources.Margins:new
	{
		class	= "Margins",
		left	= 10,
		right	= 10,
		top		= 10,
		bottom	= 10,
	},
	fgColor = "Black",
	backgroundLayer = Resources.Actor:new {
		resource = "Actor",
		image = "TutorialBox.png",
		alignment = Center,
		alignTo = Center,
	},
}

Resources.CaptionHigh = Resources.CaptionDefaults:new {
	resource = "CaptionDefaults",
	
	alignment = Center,
	alignmentOffset = {0,-125},


	visible = false,
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
	delayTime = 1000,
}

Resources.CaptionHighNoCharacter = Resources.CaptionNoCharacter:new {
	resource = "CaptionNoCharacter",
	
	alignment = Center,
	alignmentOffset = {0,-125},

	visible = false,
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
	delayTime = 1000,
}

Resources.CaptionMiddle = Resources.CaptionDefaults:new {
	resource = "CaptionDefaults",
	
	alignment = Center,
	alignmentOffset = {0,-50},

	visible = false,
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
	delayTime = 1000,
}

Resources.CaptionMiddleNoCharacter = Resources.CaptionNoCharacter:new {
	resource = "CaptionNoCharacter",
	
	alignment = Center,
	alignmentOffset = {0,-50},

	visible = false,
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
	delayTime = 1000,
}

Resources.CaptionMiddleDelayed = Resources.CaptionMiddle:new {
	resource = "CaptionMiddle",
	
	visible = false,
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
	delayTime = 1000,
}

Resources.CaptionMiddleCelebrating = Resources.CaptionMiddleNoCharacter:new {
	resource = "CaptionMiddleNoCharacter",
	
	MoleGuy = {
		class = "Actor",
		alignment = Center,
		alignmentOffset = {0,250},
		image = "Jasper_Animate_Menu_BODY_with-Eyes-Mouth.png",
		nonPointingArm = {
			class = "Actor",
			image = "Jasper_Animate_Menu_Right_Arm_Pump.png",
		},
		pointingArm = {
			class = "Actor",
			image = "Jasper_Animate_Menu_Left_Arm_Wave.png",
			zorder = -1,
		},
	},
	
	visible = false,
	introScript = "DelayedSlideSelf_FromTop_Celebrate",
	updateScript = "DelayedSlideSelf_FromTop_Celebrate_Update",
	exitScript = "SlideSelf_ToTopAndBottom",
	delayTime = 1000,
}

Resources.CaptionLow = Resources.CaptionDefaults:new {
	resource = "CaptionDefaults",
	
	alignment = Center,
    alignmentOffset = {0,80},
}

Resources.CaptionLowNoCharacter = Resources.CaptionNoCharacter:new {
	resource = "CaptionNoCharacter",
	
	alignment = Center,
	alignmentOffset = {0,80},

	visible = false,
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
	delayTime = 1000,
}

Resources.CaptionLowDelayed = Resources.CaptionLow:new {
	resource = "CaptionLow",
	
	visible = false,
	introScript = "DelayedSlideSelf_FromBottom",
	updateScript = "DelayedSlideSelf_FromBottom_Update",
	exitScript = "SlideSelf_ToBottom",
	delayTime = 1000,
}

Resources.CaptionHighDelayed = Resources.CaptionHigh:new {
	resource = "CaptionHigh",
	
	visible = false,
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
	delayTime = 1000,
}

Resources.CaptionHighDelayedNoCharacter = Resources.CaptionHighNoCharacter:new {
	resource = "CaptionHighNoCharacter",
	
	visible = false,
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
	delayTime = 1000,
}

Resources.TapHereFlipped = Resources.Actor:new {
	resource = "Actor",
	name = "Circle",
	image = "Tips_TapHere.png",
	layer = 999,
	scripts = {"SqueezeSquareLoopFlipped"},
	introScript = "SlideSelf_FromTop",
	updateScript = "SlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
}

Resources.TapHereDefault = Resources.Actor:new {
	resource = "Actor",
	name = "Circle",
	image = "Tips_TapHere.png",
	layer = 999,
	scripts = {"SqueezeSquareLoop"},
	introScript = "SlideSelf_FromTop",
	updateScript = "SlideSelf_FromTop_Update",
	exitScript = "SlideSelf_ToTop",
}

Resources.InvisibleCircle = Resources.Actor:new {
	resource = "Actor",
	name = "Circle",
	size = {0,0},
}

Resources.ReelTapHereOnRight = Resources.Actor:new {
	resource = "Actor",
	size = {150,150},
	alpha = 0,
	layer = 999,
	MoleGuy = {
		class = "Actor",
		alignment = MidLeft,
		alignTo = MidRight,
		alignmentOffset = {-55,15},
		image = "FLIP_Jasper_Animate_Menu_BODY_with-Eyes-Mouth.png",
		nonPointingArm = {
			class = "Actor",
			image = "FLIP_Jasper_Animate_Menu_Right_Arm_Low.png",
		},
		pointingArm = {
			class = "Actor",
			image = "FLIP_Jasper_Animate_Menu_Left_Arm_Point.png",
			zorder = -1,
		},
	},
	introScript = "SlideSelf_FromBottom",
	updateScript = "SlideSelf_FromBottom_Update",
	exitScript = "SlideSelf_ToBottom",
}

Resources.ReelTapHereOnLeft = Resources.Actor:new {
	resource = "Actor",
	size = {150,150},
	alpha = 0,
	layer = 999,
	MoleGuy = {
		class = "Actor",
		alignment = MidRight,
		alignTo = MidLeft,
		alignmentOffset = {55,15},
		image = "Jasper_Animate_Menu_BODY_with-Eyes-Mouth.png",
		nonPointingArm = {
			class = "Actor",
			image = "Jasper_Animate_Menu_Right_Arm_Low.png",
		},
		pointingArm = {
			class = "Actor",
			image = "Jasper_Animate_Menu_Left_Arm_Point.png",
			zorder = -1,
		},
	},
	introScript = "SlideSelf_FromBottom",
	updateScript = "SlideSelf_FromBottom_Update",
	exitScript = "SlideSelf_ToBottom",
}

Resources.TapHereDelayed = Resources.TapHereDefault:new {
	resource = "TapHereDefault",
	visible = false,
	delayTime = 1300,
	scripts = {"SqueezeSquareLoop",},
	introScript = "DelayedSlideSelf_FromTop",
	updateScript = "DelayedSlideSelf_FromTop_ChangeCenter_Update",
	exitScript = "SlideSelf_ToTop",
}

Resources.TapHereDelayedFromBottom = Resources.TapHereDefault:new {
	resource = "TapHereDefault",
	visible = false,
	delayTime = 1300,
	scripts = {"SqueezeSquareLoop",},
	introScript = "DelayedSlideSelf_FromBottom",
	updateScript = "DelayedSlideSelf_FromBottom_ChangeCenter_Update",
	exitScript = "SlideSelf_ToBottom",
}

Resources.TapHereFromBottom = Resources.TapHereDefault:new {
	resource = "TapHereDefault",
	visible = false,
	delayTime = 0,
	scripts = {"SqueezeSquareLoop",},
	introScript = "DelayedSlideSelf_FromBottom",
	updateScript = "DelayedSlideSelf_FromBottom_ChangeCenter_Update",
	exitScript = "SlideSelf_ToBottom",
}

Resources.ReelTapHereDelayedOnRight = Resources.ReelTapHereOnRight:new {
	resource = "ReelTapHereOnRight",
	visible = false,
	delayTime = 1300,
	introScript = "DelayedSlideSelf_FromBottom",
	updateScript = "DelayedSlideSelf_FromBottom_Update",
	exitScript = "SlideSelf_ToBottom",
}

Resources.ReelTapHereDelayedOnLeft = Resources.ReelTapHereOnLeft:new {
	resource = "ReelTapHereOnLeft",
	visible = false,
	delayTime = 1300,
	introScript = "DelayedSlideSelf_FromBottom",
	updateScript = "DelayedSlideSelf_FromBottom_Update",
	exitScript = "SlideSelf_ToBottom",
}

Scripts.DelayedShowSelf = function(actor)
	ScriptDelay(actor.delayTime)
	actor.visible = true
end

Scripts.DelayedSlideSelf_FromBottom = function(actor)
	ScriptDelay(actor.delayTime)
	SlideOn(actor,150,"bottom","wait")
end

Scripts.SlideSelf_FromBottom = function(actor)
	SlideOn(actor,150,"bottom","wait")
end

Scripts.DelayedSlideSelf_FromBottom_Update = function(actor,newText)
	SlideOff(actor,150,"bottom","wait")
	actor.text = newText
	ScriptDelay(actor.delayTime)
	SlideOn(actor,150,"bottom","wait")
end

Scripts.SlideSelf_FromBottom_Update = function(actor,newText)
	SlideOff(actor,150,"bottom","wait")
	actor.text = newText
	SlideOn(actor,150,"bottom","wait")
end

Scripts.SlideSelf_FromTop = function(actor)
	SlideOn(actor,150,"top","wait")
end

Scripts.DelayedSlideSelf_FromTop = function(actor)
	ScriptDelay(actor.delayTime)
	SlideOn(actor,150,"top","wait")
end

Scripts.SlideSelf_ToTop = function(actor)
	SlideOff(actor,150,"top","wait")
	actor:Destroy()
end

Scripts.SlideSelf_ToBottom = function(actor)
	SlideOff(actor,150,"bottom","wait")
	actor:Destroy()
end

Scripts.SlideSelf_ToTopAndBottom = function(actor)
	SlideOff(actor.MoleGuy,150,"bottom","wait")
	SlideOff(actor,150,"top","wait")
	actor:Destroy()
end

Scripts.SlideSelf_FromTop_Update = function(actor,newText)
	SlideOff(actor,150,"top","wait")
	actor.text = newText
	SlideOn(actor,150,"top","wait")
end

Scripts.DelayedSlideSelf_FromTop_Update = function(actor,newText)
	SlideOff(actor,150,"top","wait")
	actor.text = newText
	ScriptDelay(actor.delayTime)
	SlideOn(actor,150,"top","wait")
end

Scripts.DelayedSlideSelf_FromTop_ChangeCenter_Update = function(actor,newCenter)
	SlideOff(actor,150,"top","wait")
	actor.center = newCenter
	ScriptDelay(actor.delayTime)
	SlideOn(actor,150,"top","wait")
end

Scripts.DelayedSlideSelf_FromBottom_ChangeCenter_Update = function(actor,newCenter)
	SlideOff(actor,150,"bottom","wait")
	actor.center = newCenter
	ScriptDelay(actor.delayTime)
	SlideOn(actor,150,"bottom","wait")
end

Scripts.DelayedSlideSelf_FromTop_Celebrate = function(actor)
	actor.MoleGuy.visible = false
	ScriptDelay(actor.delayTime)
	SlideOn(actor,150,"top","wait")
	SlideOn(actor.MoleGuy,250,"bottom","wait")
	actor.visible = true
end

Scripts.DelayedSlideSelf_FromTop_Celebrate_Update = function(actor,newText)
	SlideOff(actor,150,"top","wait")
	actor.text = newText
	actor.MoleGuy.visible = false
	ScriptDelay(actor.delayTime)
	SlideOn(actor,150,"top","wait")
	SlideOn(actor.MoleGuy,250,"bottom","wait")
	actor.visible = true
end

level1_bubble1_skipped_tapspin = {
	extraScript = "Intro_SpinToBegin",
	exitScript = "Intro_RestoreAllElements",
	slowingFactor = 1.25,
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_Match_1_Color_1",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece1,
				applyMatchFlags = true,
			},
			[2] = {
				patternName = "Short_Help_Match_1_Color_2",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece2,
				applyMatchFlags = true,
			},
			[3] = {
				patternName = "Short_Help_Match_1_Color_3",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece3,
				applyMatchFlags = true,
			},
			[4] = {
				patternName = "Short_Help_Match_1_Color_4",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece4,
				applyMatchFlags = true,
			},
			[5] = {
				patternName = "Short_Help_Match_1_Color_5",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece5,
				applyMatchFlags = true,
			},
		},
		initialNumRemainingSpins = 2,
		enableMatchOnSpin = false,
		spawnSuperGemWithPlaySize = 0, --Disable burst gems
		spawnSuperGemWithNumberOfColors = 0, --Disable superwilds
	},
	unclickableCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},

	showSpinButton = true,
	exitCondition = "Timer",
	delay = 500,
}

level1_bubble2_tapspin = {
	extraScript = "IntroduceMoleGuy",
	exitScript = "Intro_RestoreAllElements",
	unclickableCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXXXXX",
		},
	},

	showSpinButton = true,
	exitCondition = "Spin",
	bubbleText = STRINGS("Tap the spin button to get started!"),
	bubbleResource = "CaptionMiddleNoCharacter",
}

level1_bubble3_skipped = "Skipped"

level1_bubble4_skipped = "Skipped"

level1_bubble5_skipped = "Skipped"

level1_bubble6_skipped_spintobegin = "Skipped"

level1_bubble7_showgems = {
	extraScript = "Intro_ChangeToSet",
	exitScript = "Intro_RestoreAllElements",
	
	--Fill reels with the gem colors for the shorter tutorial
	reelPatterns = {
		[1] = {
			patternName = "ReelPosition1",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece4,
			applyMatchFlags = true,
		},
		[2] = {
			patternName = "ReelPosition2",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece1,
			applyMatchFlags = true,
		},
		[3] = {
			patternName = "ReelPosition3",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_Wildcard,
			applyMatchFlags = true,
		},
		[4] = {
			patternName = "ReelPosition4",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece3,
			applyMatchFlags = true,
		},
		[5] = {
			patternName = "ReelPosition5",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece2,
			applyMatchFlags = true,
		},
		[6] = {
			patternName = "ReelPosition6",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece3,
			applyMatchFlags = true,
		},
	},
	properties = {
		enableMatchOnSpin = false,
		gemsMoveDiagonally = false,
	},
	--Prompt to tap 1,5
	unclickableCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"X XXXX",
			"XXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"   XXX",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"X XXXX",
		},
	},
	circlePosition = {1,5},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnRight",

	bubbleText = STRINGS("Tap the yellow gem to make the blue one fly to its spot and replace it."),
	bubbleResource = "CaptionHighDelayedNoCharacter",
			
	exitCondition = "PlaceGem",
	hideSpinButton = true,
	noNewGems = true,
}

level1_bubble8_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		--Make sure one of the gems that's falling in from the top
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_Match_2_Color_1",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece1,
				applyMatchFlags = true,
			},
			[2] = {
				patternName = "Short_Help_Match_2_Color_2",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece5,
				applyMatchFlags = true,
			},
		},
		gemsMoveDiagonally = false,
	},
	--Prompt to tap 4,4
	unclickableCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXX X",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXX XX",
			"XXX  X",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXXX X",
		},
	},
	circlePosition = {4,4},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnLeft",
	bubbleText = STRINGS("This makes a match of 3 of the same color. Matches don't have to be in a straight line. Tap again!"),
	bubbleResource = "CaptionHighDelayedNoCharacter",
			
	exitCondition = "PlaceGem",
	hideSpinButton = true,
	noNewGems = true,
}

level1_bubble9_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_Match_3_Color_1",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece4,
				applyMatchFlags = true,
			},
		},
		gemsMoveDiagonally = false,
	},
	--Prompt to tap 2,3
	unclickableCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XX XXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"X XXXX",
			"X    X",
			"X X  X",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XX XXX",
		},
	},
	circlePosition = {2,3},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnRight",
			
	bubbleText = STRINGS("Wild Gems match all colors that have 2 or more gems touching them."),
	bubbleResource = "CaptionHighDelayedNoCharacter",
	exitCondition = "PlaceGem",
	hideSpinButton = true,
	noNewGems = true,
}

level1_bubble10_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_Match_4_Color_1",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece1,
				applyMatchFlags = true,
			},
			[2] = {
				patternName = "Short_Help_Match_4_Color_2",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece2,
				applyMatchFlags = true,
			},
			[3] = {
				patternName = "Short_Help_Match_4_Color_3",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece4,
				applyMatchFlags = true,
			},
			[4] = {
				patternName = "Short_Help_Match_4_Color_4",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece5,
				applyMatchFlags = true,
			},
		},
		gemsMoveDiagonally = false,
	},
	
	bubbleText = STRINGS("Now it's your turn. Find some matches of your own!"),
	bubbleResource = "CaptionHighDelayedNoCharacter",
	circlePosition = {3,4},
	circleResource = "InvisibleCircle",
	reelResource = "ReelTapHereDelayedOnRight",
	noNewGems = true,
	exitCondition = "PlaceGem",
}

level1_bubble11_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_Match_5_Color_1",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece1,
				applyMatchFlags = true,
			},
			[2] = {
				patternName = "Short_Help_Match_5_Color_2",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece3,
				applyMatchFlags = true,
			},
			[3] = {
				patternName = "Short_Help_Match_5_Color_3",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece5,
				applyMatchFlags = true,
			},
		},
		gemsMoveDiagonally = false,
	},
	
	exitCondition = "PlaceGem",
}

level1_bubble12_showgems = {
	extraScript = "Intro_CircleGoal",
	exitScript = "Intro_RestoreAllElements",
	properties = {
		gemsMoveDiagonally = true,
	},
	
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXXXXX",
		},
	},
	
	bubbleText = STRINGS("You beat the level goal!"),
	bubbleResource = "CaptionMiddleCelebrating",

	hideSpinButton = true,
	nextButtonProperties = "HelpNextButton",
	exitCondition = "NextButton",
}

level1_bubble13_showgems = {
	extraScript = "Intro_CircleSpins",
	exitScript = "Intro_RestoreAllElements",
	properties = {
		gemsMoveDiagonally = true,
	},
	
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXXXXX",
		},
	},
	
	bubbleText = STRINGS("You still have spins left, so you get a bonus Cascade!"),
	bubbleResource = "CaptionMiddleCelebrating",

	hideSpinButton = true,
	nextButtonProperties = "HelpNextButton",
	exitCondition = "NextButton",
}

level1_bubble14_showgems = { --Transition state to clear animation elements
	extraScript = "Intro_RemoveCircles",
	hideSpinButton = true,
	exitCondition = "Timer",
	delay = 1,
}

level1_generic_match = {
	exitScript = "Intro_RestoreAllElements",
	allowHints = true,
	exitCondition = "PlaceGem",
}

level1_generic_spin = { 
	exitScript = "Intro_RestoreAllElements",
	allowHints = true,
	exitCondition = "Spin",
}

level2_bubble1_showgems = {
	extraScript = "Intro_HideTricks",
	exitScript = "Intro_RestoreAllElements",
	unclickableCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXX XX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"    XX",
			"    XX",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXX XX",
		},
	},
	reelPatterns = {
		[1] = {
			patternName = "ReelPosition1",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece5,
			applyMatchFlags = true,
		},
		[2] = {
			patternName = "ReelPosition2",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece2,
			applyMatchFlags = true,
		},
		[3] = {
			patternName = "ReelPosition3",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece3,
			applyMatchFlags = true,
		},
		[4] = {
			patternName = "ReelPosition4",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece1,
			applyMatchFlags = true,
		},
		[5] = {
			patternName = "ReelPosition5",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece1,
			applyMatchFlags = true,
		},
		[6] = {
			patternName = "ReelPosition6",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece4,
			applyMatchFlags = true,
		},
	},
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_Level2_Color1",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece1,
				applyMatchFlags = true,
			},
			[2] = {
				patternName = "Short_Help_Level2_Color2",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece2,
				applyMatchFlags = true,
			},
			[3] = {
				patternName = "Short_Help_Level2_Color3",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece3,
				applyMatchFlags = true,
			},
			[4] = {
				patternName = "Short_Help_Level2_Color4",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece4,
				applyMatchFlags = true,
			},
			[5] = {
				patternName = "Short_Help_Level2_Color5",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece5,
				applyMatchFlags = true,
			},
		},
		gemsMoveDiagonally = false,
	},
	circlePosition = {3,4},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereOnRight",
	bubbleText = STRINGS("Make a big match and you'll get a special burst gem!"),
	bubbleResource = "CaptionHighDelayedNoCharacter",
	hideSpinButton = true,
	exitCondition = "PlaceGem",
}

level2_bubble2_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		--Don't reapply patterns
		initialPatterns = {
		},
	},
	unclickableCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXX X",
			"XXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXX ",
			"XXXXX ",
			"XXX   ",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXXX X",
		},
	},
	circlePosition = {4,5},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnLeft",
	bubbleText = STRINGS("When you make a match with the gem, it'll clear the whole column!"),
	bubbleResource = "CaptionHighNoCharacter",
	exitCondition = "PlaceGem",
}

level2_bubble3_showgems = { --Final bubble
	bubbleText = STRINGS("There are a lot of matches here. Try to find them all!"),
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXXXXX",
		},
	},
	bubbleResource = "CaptionHigh",
	exitCondition = "NextButton",
}

level2_bubble4_original = { --Transition state to fill the board with default stuff
	hiddenCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	properties = { --No effect pattern refills board
		initialPatterns = {
			[1] = {
				patternName = "FullBoardSmall",
				isPatternSet = false,
			},
		}
	},
	hideSpinButton = true,
	exitCondition = "Timer",
	delay = 1,
	extraScript = "Intro_RestoreAllElements",
}

level5_bubble1_showgems = {
	extraScript = "Intro_HideTricks",
	exitScript = "Intro_RestoreAllElements",
	unclickableCells = {
		filledCells = {
			"XXXXXXX",
			"X XXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"X     X",
			"X    XX",
			"X XXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"X XXXXX",
		},
	},
	reelPatterns = {
		[1] = {
			patternName = "ReelPosition2",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece1,
			applyMatchFlags = true,
		},
		[2] = {
			patternName = "ReelPosition1",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece1,
			applyMatchFlags = true,
		},
		[3] = {
			patternName = "ReelPosition4",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece4,
			applyMatchFlags = true,
		},
		[4] = {
			patternName = "ReelPosition3",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece4,
			applyMatchFlags = true,
		},
		[5] = {
			patternName = "ReelPosition6",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece3,
			applyMatchFlags = true,
		},
		[6] = {
			patternName = "ReelPosition7",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece3,
			applyMatchFlags = true,
		},
	},
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_BurstTeacher_Color1",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece1,
				applyMatchFlags = true,
			},
			[2] = {
				patternName = "Short_Help_BurstTeacher_Color2",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece2,
				applyMatchFlags = true,
			},
			[3] = {
				patternName = "Short_Help_BurstTeacher_Color3",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece3,
				applyMatchFlags = true,
			},
			[4] = {
				patternName = "Short_Help_BurstTeacher_Color4",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece4,
				applyMatchFlags = true,
			},
			[5] = {
				patternName = "Short_Help_BurstTeacher_Color5",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece5,
				applyMatchFlags = true,
			},
		},
		gemsMoveDiagonally = false,
	},
	circlePosition = {1,1},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereOnRight",
	bubbleText = STRINGS("Differently shaped matches make different kinds of burst gems! Match a group that's wider than it is tall to make a vertical burst."),
	bubbleResource = "CaptionMiddleNoCharacter",
	hideSpinButton = true,
	exitCondition = "PlaceGem",
}

level5_bubble2_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		--Don't reapply patterns
		initialPatterns = {
		},
	},
	unclickableCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			" XXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"X XXXXX",
			"X XXXXX",
			"  XXXXX",
			"X XXXXX",
			"X XXXXX",
			"X XXXXX",
			"X XXXXX",
			"X XXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			" XXXXXX",
		},
	},
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_BurstTeacher_Step2_Color1",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece1,
				applyMatchFlags = true,
			},
		},
	},
	circlePosition = {0,2},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnLeft",
	bubbleText = STRINGS("Matching a vertical burst gem clears the column."),
	bubbleResource = "CaptionLowNoCharacter",
	exitCondition = "PlaceGem",
}

level5_bubble3_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		--Don't reapply patterns
		initialPatterns = {
		},
	},
	unclickableCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXX X",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXX   ",
			"XXXX   ",
			"XXXXXX ",
			"XXXXXX ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXXXX X",
		},
	},
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_BurstTeacher_Step3_Color4",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece4,
				applyMatchFlags = true,
			},
		},
	},
	circlePosition = {5,3},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnLeft",
	bubbleText = STRINGS("A big match that's taller than it is wide makes a horizontal burst gem."),
	bubbleResource = "CaptionLowNoCharacter",
	exitCondition = "PlaceGem",
}

level5_bubble4_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		--Don't reapply patterns
		initialPatterns = {
		},
	},
	unclickableCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXX ",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXXXXX ",
		},
	},
	properties = {
		initialPatterns = {
			[1] = {
				patternName = "Short_Help_BurstTeacher_Step4_Color3",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece3,
				applyMatchFlags = true,
			},
			[2] = {
				patternName = "Short_Help_BurstTeacher_Step4_Color2",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece2,
				applyMatchFlags = true,
			},
		},
	},
	circlePosition = {6,3},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnLeft",
	bubbleText = STRINGS("Matching a horizontal burst gem clears the row."),
	bubbleResource = "CaptionHighNoCharacter",
	exitCondition = "PlaceGem",
}

level5_bubble5_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		--Don't reapply patterns
		initialPatterns = {
		},
	},
	unclickableCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXX XXX",
			"XXXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXX   X",
			"XXX   X",
			"XXX   X",
		},
	},
	dimmedReels = {
		filledCells = {
			"XXX XXX",
		},
	},
	properties = {
		initialPatterns = {
			{
				patternName = "Short_Help_BurstTeacher_Step4_Color2",
				isPatternSet = false,
				matchFlags = CascadeMatchFlags_CommonPiece2,
				applyMatchFlags = true,
			},
		},
	},
	circlePosition = {3,6},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnLeft",
	bubbleText = STRINGS("Making a big match of equal height and width creates an area burst gem."),
	bubbleResource = "CaptionHighNoCharacter",
	exitCondition = "PlaceGem",
}

level5_bubble6_showgems = {
	exitScript = "Intro_RestoreAllElements",
	properties = {
		--Don't reapply patterns
		initialPatterns = {
		},
	},
	unclickableCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XX XXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XX   XX",
			"XX   XX",
		},
	},
	dimmedReels = {
		filledCells = {
			"XX XXXX",
		},
	},
	circlePosition = {2,7},
	circleResource = "TapHereDelayed",
	reelResource = "ReelTapHereDelayedOnLeft",
	bubbleText = STRINGS("Matching an area burst gem clears the surrounding gems."),
	bubbleResource = "CaptionHighNoCharacter",
	exitCondition = "PlaceGem",
}

level1_bubble18_original = {
	exitScript = "Intro_RestoreAllElements",
	--Force two matches of the color that was missing to ensure at least one match this spin
	reelPatterns = {
		[1] = {
			patternName = "ReelPosition2",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece1,
			applyMatchFlags = true,
		},
		[2] = {
			patternName = "ReelPosition5",
			isPatternSet = false,
			matchFlags = CascadeMatchFlags_CommonPiece1,
			applyMatchFlags = true,
		},
	},
	unclickableCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	dimmedCells = {
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	bubbleText = STRINGS("You used all 6 gems in one spin! This gives you a free spin and a score multiplier."),
	bubbleResource = "CaptionHighDelayed",
	nextButtonProperties = "HelpNextButton",
	exitCondition = "NextButton",
}

TeachingModeTable = {
	["Level1"] = {
		[1] = level1_bubble1_skipped_tapspin,
		[2] = level1_bubble2_tapspin,
		[3] = level1_bubble3_skipped,
		[4] = level1_bubble4_skipped,
		[5] = level1_bubble5_skipped,
		[6] = level1_bubble6_skipped_spintobegin,
		[7] = level1_bubble7_showgems,
		[8] = level1_bubble8_showgems,
		[9] = level1_bubble9_showgems,
		[10] = level1_bubble10_showgems,
		[11] = level1_bubble11_showgems,
		[12] = level1_bubble12_showgems,
		[13] = level1_bubble13_showgems,
		[14] = level1_bubble14_showgems,
	},
	["Level2"] = {
		[1] = level2_bubble1_showgems,
		[2] = level2_bubble2_showgems,
		[3] = level2_bubble3_showgems,
		[4] = "Skipped",
		[5] = level1_generic_match,
		[6] = level1_generic_match,
		[7] = level1_generic_match,
		[8] = level1_generic_match,
		[9] = level1_bubble18_original,
	},
	["Level3"] = {
		[1] = {
			extraScript = "Intro_HideTricks",
			exitScript = "Intro_RestoreAllElements",
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXX XX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XX  XX",
					"XXX  X",
					"XX    ",
					"XX  XX",
				},
			},
			reelPatterns = {
				[1] = {
					patternName = "ReelPosition1",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					patternName = "ReelPosition2",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					patternName = "ReelPosition3",
					isPatternSet = false,
					clearPieces = true,
				},
				[4] = {
					patternName = "ReelPosition4",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyMatchFlags = true,
				},
				[5] = {
					patternName = "ReelPosition5",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
				[6] = {
					patternName = "ReelPosition6",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			properties = {
				initialPatterns = {
					[1] = {
						patternName = "MultiColorSetup_Color1",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = true,
					},
					[2] = {
						patternName = "MultiColorSetup_Color2",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyMatchFlags = true,
					},
					[3] = {
						patternName = "MultiColorSetup_Color3",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyMatchFlags = true,
					},
					[4] = {
						patternName = "MultiColorSetup_Color4",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						applyMatchFlags = true,
					},
					[5] = {
						patternName = "MultiColorSetup_Color5",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						applyMatchFlags = true,
					},
				},
			},
			circlePosition = {3,5},
			circleResource = "TapHereDelayed",
			reelResource = "ReelTapHereDelayedOnRight",
			bubbleText = STRINGS("Match three different colors with a wild to get a super wild gem!"),
			bubbleResource = "CaptionHighDelayedNoCharacter",
			hideSpinButton = true,
			exitCondition = "PlaceGem",
		},
		[2] = {
			exitScript = "Intro_RestoreAllElements",
			properties = {
				--Don't reapply patterns
				initialPatterns = {
				},
				automaticFreeSpinAfterClearingSlots = false,
			},
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXX X",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXX X",
					"XXX   ",
				},
			},
			circlePosition = {4,5},
			circleResource = "TapHereDelayed",
			reelResource = "ReelTapHereDelayedOnLeft",
			bubbleText = STRINGS("Match the super wild with a blue match to match every blue gem on the board."),
			bubbleResource = "CaptionHighNoCharacter",
			exitCondition = "PlaceGem",
		},
		[3] = { --Final bubble
			bubbleText = STRINGS("I wonder what happens if you can match two colors at once with a super wild..."),
			bubbleResource = "CaptionHigh",
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			properties = {
				initialPatterns = {
					[1] = {
						patternName = "FullBoardSmall",
						isPatternSet = false,
					},
				}
			},
			hideSpinButton = true,
			exitCondition = "NextButton",
		},
	},
	["Level4"] = { --Make a second splash gem to fit in with the first
		[1] = {
			extraScript = "Intro_HideTricks",
			exitScript = "Intro_RestoreAllElements",
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXX XX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXX   ",
					"XXX   ",
					"XXX   ",
				},
			},
			reelPatterns = {
				[1] = {
					patternName = "ReelPosition1",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					patternName = "ReelPosition2",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					patternName = "ReelPosition3",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
				[4] = {
					patternName = "ReelPosition4",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
				[5] = {
					patternName = "ReelPosition5",
					isPatternSet = false,
					clearPieces = true,
				},
				[6] = {
					patternName = "ReelPosition6",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			properties = {
				--useMissingSquares = false,
				initialPatterns = {
					--Moved from the level definition
					[1] = {
						patternName = "OuterBlock_topleftcorner",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece4,
					},
					[2] = {
						patternName = "OuterBlock_toprightcorner",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece2,
					},
					[3] = {
						patternName = "OuterBlock_bottomleftcorner",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece3,
					},
					[4] = {
						patternName = "OuterBlock_bottomrightcorner",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece1,
					},
					--Set up a mix between two splash gems
					[5] = {
						patternName = "CandyMixingSetup_BlueCorner",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = true,
					},
					[6] = {
						patternName = "CandyMixingSetup_BlueShieldTop",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyMatchFlags = true,
					},
					[7] = {
						patternName = "CandyMixingSetup_BlueShieldLeft",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyMatchFlags = true,
					},
					[8] = {
						patternName = "CandyMixingSetup_ExistingVertical",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = true,
						specials = CascadePieceSpecial_VerticalSplash,
						applyPieceSpecials = true,
					},
				},
			},
			circlePosition = {3,5},
			circleResource = "TapHereDelayed",
			reelResource = "ReelTapHereDelayedOnRight",
			bubbleText = STRINGS("Match these eight blue gems to get a burst gem."),
			bubbleResource = "CaptionHighDelayedNoCharacter",
			hideSpinButton = true,
			exitCondition = "PlaceGem",
		},
		[2] = {
			exitScript = "Intro_RestoreAllElements",
			properties = {
				--Don't reapply patterns
				initialPatterns = {
				},
				automaticFreeSpinAfterClearingSlots = false,
			},
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XX XXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"X   XX",
				},
			},
			circlePosition = {2,6},
			circleResource = "TapHereDelayed",
			reelResource = "ReelTapHereDelayedOnRight",
			bubbleText = STRINGS("If you match two burst gems in the same match, they mix together."),
			bubbleResource = "CaptionHighNoCharacter",
			exitCondition = "PlaceGem",
		},
		[3] = { --Final bubble
			bubbleText = STRINGS("Try combining other kinds of burst gems for other special effects."),
			bubbleResource = "CaptionHigh",
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			hideSpinButton = true,
			exitCondition = "NextButton",
		},
	},
	["Level5"] = {
		[1] = level5_bubble1_showgems,
		[2] = level5_bubble3_showgems,
		[3] = level5_bubble5_showgems,
	},
	["Level6"] = { --Demonstrate how to do coverage mode.
		[1] = {
			extraScript = "Intro_HideTricks",
			exitScript = "Intro_RestoreAllElements",
			properties = {
				useMissingSquares = false,
				initialPatterns = {
					--Setting generic gems from previous help level, just as a background
					[1] = {
						patternName = "AreaSetup_Match1",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = true,
					},
					[2] = {
						patternName = "AreaSetup_Match2",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyMatchFlags = true,
					},
					[3] = {
						patternName = "AreaSetup_MustNotMatch",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyMatchFlags = true,
					},
					[4] = { --Makes all gems animate dropping in
						patternName = "FullBoardSmall",
						isPatternSet = false,
					},
				},
			},

			bubbleText = STRINGS("To pass this level, clear out the cloudy squares behind the gems"),
			bubbleResource = "CaptionHighDelayed",
			exitCondition = "Spin",
		},
		[2] = {
			exitScript = "Intro_RestoreAllElements",
			properties = {
				--Don't reapply patterns
				initialPatterns = {
				},
			},
			reelPatterns = {
				[1] = {
					patternName = "ReelPosition5",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
				[2] = {
					patternName = "ReelPosition6",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyMatchFlags = true,
				},
			},
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXX X",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXX  ",
					"XXXXX ",
					"XXXXXX",
				},
			},
			circlePosition = {4,4},
			circleResource = "TapHereDelayed",
			reelResource = "ReelTapHereDelayedOnLeft",
			bubbleText = STRINGS("Each time you match on a cloudy square, the clouds get thinner."),
			bubbleResource = "CaptionHighDelayedNoCharacter",
			exitCondition = "PlaceGem",
		},
		[3] = {
			exitScript = "Intro_RestoreAllElements",
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXX ",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXX  ",
					"XXXXX ",
					"XXXXX ",
				},
			},
			circlePosition = {5,6},
			circleResource = "TapHereDelayed",
			reelResource = "ReelTapHereDelayedOnLeft",
			bubbleText = STRINGS("These take two matches to clear, but brighter clouds take more."),
			bubbleResource = "CaptionHighDelayedNoCharacter",
			exitCondition = "PlaceGem",
		},
		[4] = {
			exitScript = "Intro_RestoreAllElements",
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("You still have to beat the star goal to win."),
			bubbleResource = "CaptionHigh",
			exitCondition = "NextButton",
		},
		[5] = {
			exitCondition = "Timer",
			delay = 1,
			extraScript = "Intro_RestoreAllElements",
		},
	},
	["Level7"] = { --Teaches how to do hammer
		[1] = {
			--It is not immediately obvious that this is a tutorial. 
			--Use an animation to fake the game start and goal.
			extraScript = "Intro_SimulateNormal_HideHammer",
			--Force the cloudy gem in the top left to be unreachable via gem type 1, 
			--by making it be a triangle of 2, 3, and 4.
			properties = {
				initialPatterns = {
					--Setting generic gems from previous help level, just as a background
					[1] = {
						patternName = "Tower2_block7",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyMatchFlags = true,
					},
					[2] = {
						patternName = "Tower2_block6",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyMatchFlags = true,
					},
					[3] = {
						patternName = "Help_Level7_Pattern3",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						applyMatchFlags = true,
					},
				},
			},

			checkConsumable = "Hammer",

			--Use a timer to bring up the spin button at the right time
			exitCondition = "Timer",
			delay = 500,

			--No spin button yet
			hideSpinButton = true,
		},
		[2] = {
			properties = { --Prevent patterns from being reapplied over and over again
				initialPatterns = {
				},
			},
			extraScript = "Intro_SimulateNormal_Continued",
			showSpinButton = true,
			exitCondition = "Spin",
		},
		[3] = {
			--Force gem type 1 in the leftmost reel.
			reelPatterns = {
				[1] = {
					patternName = "ReelPosition1",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
			},
			--Dim everything, and point out that it's hard to match the pattern when it's in the corner there.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					" XXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("Sure is hard to hit those cloudy squares in the corner."),
			bubbleResource = "CaptionLow",
			exitCondition = "NextButton",
		},
		[4] = {
			extraScript = "Intro_GiveHammer",
			--Give the free hammer with an animation, and ask player to tap it to activate it.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("This hammer will help. Try tapping it!"),
			bubbleResource = "CaptionLow",
			circleTrick = "Hammer",
			trickResource = "TapHereDelayedFromBottom",
			exitCondition = "Trick",
			trickName = "Hammer",
			grantConsumable = "Hammer=1",
			markConsumableGiven = "Hammer",
		},
		[5] = {
			extraScript = "Intro_UseHammer",
			--Direct them to tap that corner position.
			unclickableCells = {
				filledCells = {
					" XXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					" XXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("Use the hammer to match this cloudy square."),
			circlePosition = {0,0},
			circleResource = "TapHereDelayed",
			bubbleResource = "CaptionLow",
			exitCondition = "PlaceGem",
			markConsumableUsed = "Hammer",
		},
		[6] = {
			skipForConsumable = "Hammer",
			--Give 3 more hammers. End tutorial when they tap next.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("Here's three more hammers. Have fun!"),
			bubbleResource = "CaptionLow",
			exitCondition = "NextButton",
		},
		[7] = {
			skipForConsumable = "Hammer",
			extraScript = "Intro_Give3Hammers",
			exitCondition = "Timer",
			grantConsumable = "Hammer=3",
			delay = 1,
		},
	},
	["Level9"] = { --Introduces the workings of spin saver
		[1] = {
			--It is not immediately obvious that this is a tutorial. 
			--Use an animation to fake the game start and goal.
			extraScript = "Intro_SimulateNormal",
			--Force matches for every gem but 1. Topleft and bottomright corners are missing.
			properties = {
				initialPatterns = {
					[1] = {
						patternName = "Help_Level9_Pattern1",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = true,
					},
					[2] = {
						patternName = "Help_Level9_Pattern2",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyMatchFlags = true,
					},
					[3] = {
						patternName = "Help_Level9_Pattern3",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyMatchFlags = true,
					},
					[4] = {
						patternName = "Help_Level9_Pattern4",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						applyMatchFlags = true,
					},
					[5] = {
						patternName = "Help_Level9_Pattern5",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						applyMatchFlags = true,
					},
				},
			},
			
			exitCondition = "Timer",
			delay = 500,

			--No spin button yet
			hideSpinButton = true,
		},
		[2] = {
			properties = {
				initialPatterns = { --Prevent patterns from being reapplied over and over again
				},
				--Prevent Blue gems from appearing.
				boardPieceMix = {
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 9,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
			},
			extraScript = "Intro_SimulateSpinSaver",
			hideSpinButton = true,
			exitCondition = "Timer",
			delay = 1500,
		},
		[3] = {
			bubbleText = STRINGS("Those Spin Savers let you get a free spin even if there's still a gem left in the reels."),
			properties = {
				spinSaverActivations = 3,
			},
			bubbleResource = "CaptionHigh",
			extraScript = "Intro_SimulateNormal_Continued",
			showSpinButton = true,
			exitCondition = "Spin",
		},
		[4] = {
			--Reel gems to prevent either the 1 or 2 column from matching
			reelPatterns = {
				[1] = {
					patternName = "ReelPosition1",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
				[2] = {
					patternName = "ReelPosition2",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
				[3] = {
					patternName = "ReelPosition3",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyMatchFlags = true,
				},
				[4] = {
					patternName = "ReelPosition4",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyMatchFlags = true,
				},
				[5] = {
					patternName = "ReelPosition5",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyMatchFlags = true,
				},
				[6] = {
					patternName = "ReelPosition6",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyMatchFlags = true,
				},
			},
			exitCondition = "PlaceGem",
		},
		[5] = level1_generic_match,
		[6] = level1_generic_match,
		[7] = level1_generic_match,
		[8] = level1_generic_match,
		[9] = {
			properties = {
				--Restore blue gem spawns
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 9,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("You got a free spin and a higher multiplier! Hope that helps you finish this level."),
			bubbleResource = "CaptionHigh",
			exitCondition = "NextButton",
		},
	},
	
	["Level12"] = { --Teaches hammer vs obstacles
		[1] = {
			--It is not immediately obvious that this is a tutorial. 
			--Use an animation to fake the game start and goal.
			extraScript = "Intro_SimulateNormal",

			--Prevent patterns from the level from recurring
			properties = {
				initialPatterns = {
				},
			},

			checkConsumable = "Hammer",

			--Use a timer to bring up the spin button at the right time
			exitCondition = "Timer",
			delay = 500,

			--No spin button yet
			hideSpinButton = true,
		},
		[2] = {
			extraScript = "Intro_SimulateNormal_Continued",
			showSpinButton = true,
			exitCondition = "Spin",
		},
		[3] = {
			--Dim everything, and point out that it's hard to reach the gems on the inside of the crates.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XX  XX",
					"XX  XX",
					"XX  XX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("With those crates in a ring, there's no way to replace the inside gems."),
			bubbleResource = "CaptionLow",
			exitCondition = "NextButton",
		},
		[4] = {
			extraScript = "Intro_GiveHammer",
			--Give the free hammer with an animation, and ask player to tap it to activate it.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("But hammers can break crates too! Let's try it!"),
			bubbleResource = "CaptionLow",
			exitCondition = "Trick",
			trickName = "Hammer",
			circleTrick = "Hammer",
			trickResource = "TapHereDelayedFromBottom",
			grantConsumable = "Hammer=1",
			markConsumableGiven = "Hammer",
		},
		[5] = {
			extraScript = "Intro_UseHammer",
			--Direct them to tap that corner position.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XX XXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XX XXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("A hammer destroys any destructible obstacle."),
			circlePosition = {2,1},
			circleResource = "TapHereDelayed",
			bubbleResource = "CaptionLow",
			exitCondition = "PlaceGem",
			markConsumableUsed = "Hammer",
		},
		[6] = {
			skipForConsumable = "Hammer",
			--Give 3 more hammers. End tutorial when they tap next.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("Here's three more hammers. Have fun!"),
			bubbleResource = "CaptionLow",
			exitCondition = "NextButton",
		},
		[7] = {
			skipForConsumable = "Hammer",
			extraScript = "Intro_Give3Hammers",
			exitCondition = "Timer",
			grantConsumable = "Hammer=3",
			delay = 1,
		},
	},
	["Level14"] = { --Teaches shifter
		[1] = {
			--It is not immediately obvious that this is a tutorial. 
			--Use an animation to fake the game start and goal.
			extraScript = "Intro_SimulateNormal_HideShifter",

			--Force colors that will ensure all but the leftmost and rightmost gem match.
			properties = {
				initialPatterns = {
					[1] = {
						patternName = "Help_Level14_Pattern1",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = true,
					},
					[2] = {
						patternName = "Help_Level14_Pattern2",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyMatchFlags = true,
					},
					[3] = {
						patternName = "Help_Level14_Pattern3",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyMatchFlags = true,
					},
					[4] = {
						patternName = "Help_Level14_Pattern4",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						applyMatchFlags = true,
					},
					[5] = {
						patternName = "Help_Level14_Pattern5",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						applyMatchFlags = true,
					},
				},
				boardPieceMix = { --Forbid piece types 1 and 5 so we don't accidentally render the shifter unnecessary.
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 9,
					},
				},
			},

			checkConsumable = "Shifter",

			--Use a timer to bring up the spin button at the right time
			exitCondition = "Timer",
			delay = 500,

			--No spin button yet
			hideSpinButton = true,
		},
		[2] = {
			properties = {
				initialPatterns = {
					--Prevent the patterns from being reapplied each time
				},
			},
			extraScript = "Intro_SimulateNormal_Continued",
			showSpinButton = true,
			exitCondition = "Spin",
		},
		[3] = {
			--Force a spin where only the center 4 gems can match and allow ordinary play.
			reelPatterns = {
				[1] = {
					patternName = "ReelPosition1",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
				[2] = {
					patternName = "ReelPosition2",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyMatchFlags = true,
				},
				[3] = {
					patternName = "ReelPosition3",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyMatchFlags = true,
				},
				[4] = {
					patternName = "ReelPosition4",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyMatchFlags = true,
				},
				[5] = {
					patternName = "ReelPosition5",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyMatchFlags = true,
				},
				[6] = {
					patternName = "ReelPosition6",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyMatchFlags = true,
				},
			},

			exitCondition = "PlaceGem",
		},
		[4] = level1_generic_match,
		[5] = level1_generic_match,
		[6] = level1_generic_match,
		[7] = {
			extraScript = "Intro_GiveShifter",
			--Give the free shifter with an animation, and ask player to tap it to activate it.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("No matches! This Shifter will let you move these gems to places where they can match!"),
			bubbleResource = "CaptionHigh",
			exitCondition = "Trick",
			trickName = "Shifter",
			circleTrick = "Shifter",
			trickResource = "TapHereDelayedFromBottom",
			grantConsumable = "Shifter=1",
			markConsumableGiven = "Shifter",
			hideSpinButton = true,
		},
		[8] = {
			extraScript = "Intro_UseShifter",
			--Direct them to tap the leftmost gem.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					" XXXXX",
				},
			},
			unclickableReels = {
				filledCells = {
					" XXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("Tap the gem you want to move."),
			bubbleResource = "CaptionHigh",
			circlePosition = {0,1},
			circleResource = "Actor", --This will make it invisible
			reelResource = "TapHereFromBottom",
			exitCondition = "PlaceGem",
		},
		[9] = {
			extraScript = "Intro_UseShifter",
			--Direct them to tap the rightmost gem.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXX ",
				},
			},
			unclickableReels = {
				filledCells = {
					"XXXXX ",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("Tap a destination reel, and it will swap."),
			bubbleResource = "CaptionHigh",
			circlePosition = {5,1},
			circleResource = "Actor", --This will make it invisible
			reelResource = "TapHereFromBottom",
			exitCondition = "PlaceGem",
			markConsumableUsed = "Hammer",
		},
		[10] = level1_generic_match,
		[11] = level1_generic_match,
		[12] = {
			skipForConsumable = "Shifter",
			--Give 3 more shifters. End tutorial when they tap next.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("So shifters can get you free spins! Here's 3 more to enjoy."),
			bubbleResource = "CaptionHigh",
			exitCondition = "NextButton",
		},
		[13] = {
			skipForConsumable = "Shifter",
			extraScript = "Intro_Give3Shifters",
			exitCondition = "Timer",
			grantConsumable = "Shifter=3",
			delay = 1,
		},
	},
	["Level17"] = { --Introduces the workings of start burst
		[1] = {
			--It is not immediately obvious that this is a tutorial. 
			--Use an animation to fake the game start and goal.
			extraScript = "Intro_SimulateNormal",
			--Force the colors now, but leave the bursts hidden, as we will be presenting them later.
			properties = {
				initialPatterns = {
					[1] = {
						patternName = "Help_Level17_Color1",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = true,
					},
				},
			},
			
			exitCondition = "Timer",
			delay = 500,

			--No spin button yet
			hideSpinButton = true,
		},
		[2] = {
			properties = {
				initialPatterns = { --Apply start burst gems
					[1] = {
						patternName = "Help_Level17_VerticalBurst",
						isPatternSet = false,
						specials = CascadePieceSpecial_VerticalSplash,
						applyPieceSpecials = true,
					},
					[2] = {
						patternName = "Help_Level17_AreaBurst",
						isPatternSet = false,
						specials = CascadePieceSpecial_AreaSplash,
						applyPieceSpecials = true,
					},
					[3] = {
						patternName = "Help_Level17_HorizontalBurst",
						isPatternSet = false,
						specials = CascadePieceSpecial_HorizontalSplash,
						applyPieceSpecials = true,
					},
				},
			},
			extraScript = "Intro_SimulateStartBurst",
			hideSpinButton = true,
			exitCondition = "Timer",
			delay = 1500,
		},
		[3] = {
			properties = {
				initialPatterns = { --Prevent patterns from being reapplied over and over again
				},
			},
			bubbleText = STRINGS("Start Burst puts 3 bursts in random places on the board."),
			bubbleResource = "CaptionHigh",
			extraScript = "Intro_SimulateNormal_Continued",
			showSpinButton = true,
			exitCondition = "Spin",
		},
		[4] = {
			--Reel gems to prevent either the 1 or 2 column from matching
			reelPatterns = {
				[1] = {
					patternName = "ReelPosition4",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
			},
			exitCondition = "PlaceGem",
		},
		[5] = {
			dimmedCells = {
				filledCells = {
					"XXXXXXX",
					"XXXXXXX",
					"XXXXXXX",
					"XXXXXXX",
					"XXXXXXX",
					"XXXXXXX",
					"XXXXXXX",
					"XXXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXXX",
				},
			},
			bubbleText = STRINGS("Start Burst gives you a big leg up on clearing those crates!"),
			bubbleResource = "CaptionHigh",
			exitCondition = "NextButton",
		},
	},
	["Level22"] = { --Teaches how to do supermatch
		[1] = {
			--It is not immediately obvious that this is a tutorial. 
			--Use an animation to fake the game start and goal.
			extraScript = "Intro_SimulateNormal_HideSuperMatch",
			--Force a treasure chest sitting at the top of a blue column that cannot immediately be matched by gems
			properties = {
				initialPatterns = {
					[1] = {
						patternName = "Help_Level22_Chest",
						isPatternSet = false,
						matchFlags = 0,
						applyMatchFlags = true,
						specials = CascadePieceSpecials_Treasure,
						applyPieceSpecials = true,
					},
					[2] = {
						patternName = "Help_Level22_Color1",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = true,
					},
					[3] = {
						patternName = "Help_Level22_Color2",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyMatchFlags = true,
					},
					[4] = {
						patternName = "Help_Level22_Color3",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyMatchFlags = true,
					},
					[5] = {
						patternName = "Help_Level22_Color4",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						applyMatchFlags = true,
					},
					[6] = {
						patternName = "Help_Level22_Color6",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_CommonPiece6,
						applyMatchFlags = true,
					},
				},
			},

			checkConsumable = "SuperMatch",

			--Use a timer to bring up the spin button at the right time
			exitCondition = "Timer",
			delay = 500,

			--No spin button yet
			hideSpinButton = true,
		},
		[2] = {
			properties = { --Prevent patterns from being reapplied over and over again
				initialPatterns = {
				},
			},
			extraScript = "Intro_SimulateNormal_Continued",
			showSpinButton = true,
			exitCondition = "Spin",
		},
		[3] = {
			--Force reels 2-4 to not be gem type 1.
			reelPatterns = {
				[1] = {
					patternName = "ReelPosition2",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyMatchFlags = true,
				},
				[2] = {
					patternName = "ReelPosition3",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyMatchFlags = true,
				},
				[3] = {
					patternName = "ReelPosition4",
					isPatternSet = false,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyMatchFlags = true,
				},
			},
			--Dim everything, and point out that if we had blue, we could match the chest.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XX XXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("If only there were a blue gem in the slots, you could drop this chest."),
			bubbleResource = "CaptionLow",
			exitCondition = "NextButton",
		},
		[4] = {
			extraScript = "Intro_GiveSuperMatch",
			--Give the free supermatch with an animation, and ask player to tap it to activate it.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("This Super Match can get rid of every gem of one color. Try tapping it!"),
			bubbleResource = "CaptionLow",
			circleTrick = "SuperMatch",
			trickResource = "TapHereDelayedFromBottom",
			exitCondition = "Trick",
			trickName = "SuperMatch",
			grantConsumable = "SuperMatch=1",
			markConsumableGiven = "SuperMatch",
		},
		[5] = {
			extraScript = "Intro_UseSuperMatch",
			--Direct them to tap the middle of the blue stripe
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XX XXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XX XXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("Tap a blue gem to match all the blues!"),
			circlePosition = {2,4},
			circleResource = "TapHereDelayed",
			bubbleResource = "CaptionLow",
			exitCondition = "PlaceGem",
			markConsumableUsed = "SuperMatch",
		},
		[6] = {
			skipForConsumable = "Supermatch",
			--Give 3 more supermatches. End tutorial when they tap next.
			unclickableCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedCells = {
				filledCells = {
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
					"XXXXXX",
				},
			},
			dimmedReels = {
				filledCells = {
					"XXXXXX",
				},
			},
			bubbleText = STRINGS("Here's three more Super Matches. Have fun!"),
			bubbleResource = "CaptionHigh",
			exitCondition = "NextButton",
		},
		[7] = {
			skipForConsumable = "Supermatch",
			extraScript = "Intro_Give3SuperMatches",
			exitCondition = "Timer",
			grantConsumable = "SuperMatch=3",
			delay = 1,
		},
	},
	["Level31"] = { --Shows what multiplier bonus does, which is not very much.
		[1] = {
			--It is not immediately obvious that this is a tutorial. 
			--Use an animation to fake the game start and goal.
			extraScript = "Intro_SimulateNormal",
			--Nothing to force
			exitCondition = "Timer",
			delay = 500,

			--No spin button yet
			hideSpinButton = true,
		},
		[2] = {
			properties = {
				--Turn on the multiplier bonus
				multiplierBonus = 1,
			},
			extraScript = "Intro_SimulateMultiplierBonus",
			hideSpinButton = true,
			exitCondition = "Timer",
			delay = 1500,
		},
		[3] = {
			bubbleText = STRINGS("That's a tough star goal, but this multiplier bonus will double your points!"),
			bubbleResource = "CaptionHigh",
			extraScript = "Intro_SimulateNormal_Continued",
			showSpinButton = true,
			exitCondition = "Spin",
		},
	},
}

Scripts.Intro_HideAllElements = function(rootGameView)
	--logprint("Intro_HideAllElements")

	local MenuButton = rootGameView:FindChild("MenuButton",true)
	local SpinButton = rootGameView:FindChild("SpinButton",true)
	local Logo = rootGameView:FindChild("Logo",true)
	local ScoreContainer = rootGameView:FindChild("ScoreContainer",true)
	local TopScoresContainer = rootGameView:FindChild("TopScoresContainer",true)
	local RemainingSpinsContainer = rootGameView:FindChild("RemainingSpinsContainer",true)
	local TrickPanel = rootGameView:FindChild("TrickPanel",true)
	local StarMeter = rootGameView:FindChild("StarMeter",true)
	local GoalContainer = rootGameView:FindChild("LevelGoalContainer",true)
	
	local AllPieceDropCells = rootGameView:FindChild("AllPieceDropCells",true)
	local AllBoardCells = rootGameView:FindChild("AllBoardCells",true)
	local AllSlotsCells = rootGameView:FindChild("AllSlotsCells",true)
	local AllGamePieces = rootGameView:FindChild("AllGamePieces",true)
	local AllUnmatchedSpaces = rootGameView:FindChild("AllUnmatchedSpaces",true)

	local screen = rootGameView.parent
	local boxes = screen.backgroundImage.ReelBackground
	boxes.zorder = 2

	boxes.visible = false
	AllPieceDropCells.visible = false
	AllBoardCells.visible = false
	AllSlotsCells.visible = false
	AllGamePieces.visible = false
	AllUnmatchedSpaces.visible = false
	GoalContainer.visible = false

	MenuButton.visible = false
	SpinButton.visible = false
	screen.parent:KillTaggedScripts("SlideSpinButtonUpThenSlideDownAndAway") --Suppresses spin button appearance sound
	Logo.visible = false
	ScoreContainer.visible = false
	TopScoresContainer.visible = false
	RemainingSpinsContainer.visible = false
	TrickPanel.visible = false
	StarMeter.visible = false
	
	SlideOff(rootGameView.TutorialSkipButton,250,"bottom","nowait")

	screen.backgroundImage.backgroundDim = {
		class = "Actor",
		color = "Black",
		alpha = 128,
		autoFillParent = true,
		zorder = 0,
	}
end

Scripts.Intro_HideTricks = function(rootGameView)
	local TrickPanel = rootGameView:FindChild("TrickPanel",true)
	TrickPanel.visible = false

	--Present basic elements as if it were a normal level.
	local MenuButton = rootGameView:FindChild("MenuButton",true)
	local Logo = rootGameView:FindChild("Logo",true)
	local ScoreContainer = rootGameView:FindChild("ScoreContainer",true)
	local TopScoresContainer = rootGameView:FindChild("TopScoresContainer",true)
	local RemainingSpinsContainer = rootGameView:FindChild("RemainingSpinsContainer",true)
	local StarMeter = rootGameView:FindChild("StarMeter",true)
	local GoalContainer = rootGameView:FindChild("LevelGoalContainer",true)
	
	local AllPieceDropCells = rootGameView:FindChild("AllPieceDropCells",true)
	local AllBoardCells = rootGameView:FindChild("AllBoardCells",true)
	local AllSlotsCells = rootGameView:FindChild("AllSlotsCells",true)
	local AllGamePieces = rootGameView:FindChild("AllGamePieces",true)
	local AllUnmatchedSpaces = rootGameView:FindChild("AllUnmatchedSpaces",true)
	
	local screen = rootGameView.parent
	local boxes = screen.backgroundImage.ReelBackground

	screen.parent:KillTaggedScripts("SlideSpinButtonUpThenSlideDownAndAway") --Suppresses spin button appearance sound

	FadeInNoChildren(AllPieceDropCells,250)
	FadeInNoChildren(AllBoardCells,250)
	FadeInNoChildren(AllSlotsCells,250)
	FadeInNoChildren(boxes,250)
	FadeInNoChildren(AllGamePieces,250)
	FadeInNoChildren(AllUnmatchedSpaces,250)

	if(TrickPanel.position.y >300)then
		FadeInNoChildren(ScoreContainer,250,"top","nowait")
	else
		FadeInNoChildren(ScoreContainer,250,"bottom","nowait")
	end
	
	FadeInNoChildren(GoalContainer,250,"top","nowait")
	FadeInNoChildren(RemainingSpinsContainer,250,"bottom","nowait")
	FadeInNoChildren(MenuButton,250,"bottom","nowait")
	FadeInNoChildren(TopScoresContainer,250,"top","nowait")
	FadeInNoChildren(StarMeter,250,"top","nowait")
	--[[
	if IsIPhone5() or APP.useIPhone5AppAssets then
		FadeInNoChildren(Logo,250,"top","nowait")
	elseif IsIPad() or APP.useIPadAppAssets then
		FadeInNoChildren(Logo,250,"top","nowait")
	end
	--]]

	local boardWidth = AllBoardCells.boardWidth
	local boardHeight = AllBoardCells.boardHeight

	ScriptDelay(350)
	local playSoundOnce = false
	for y=0,boardHeight-1 do
		for x=0,boardWidth-1 do
			local nameOfMatchingActor = "BoardSpaceMatchedView_" .. x .. "_" .. y
			local matchingActor = rootGameView:FindChild(nameOfMatchingActor,true)
			if(matchingActor)then
				playSoundOnce = true
				ScaleIn(matchingActor,{1.25,1.25},250,false)
				FadeIn(matchingActor,250)
			end
		end
	end

	if(playSoundOnce)then
		PlaySound("slot_machine_win_21_short3.ogg")
	end
end

Scripts.Intro_SimulateNormal_HideHammer = function(rootGameView)
	local trickPanel = rootGameView:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "Hammer") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick.parent.visible = false
	Scripts.Intro_SimulateNormal(rootGameView)
end

Scripts.Intro_SimulateNormal_HideShifter = function(rootGameView)
	local trickPanel = rootGameView:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "Shifter") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick.parent.visible = false
	Scripts.Intro_SimulateNormal(rootGameView)
end

Scripts.Intro_SimulateNormal_HideSuperMatch = function(rootGameView)
	local trickPanel = rootGameView:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "SuperMatch") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick.parent.visible = false
	Scripts.Intro_SimulateNormal(rootGameView)
end

Scripts.Intro_SimulateNormal = function(rootGameView)
	local isLevelGame = true
	local gameScreen = rootGameView.parent.parent
	local MenuButton = gameScreen:FindChild("MenuButton",true)
	local SpinButton = gameScreen:FindChild("SpinButton",true)
	local Logo = gameScreen:FindChild("Logo",true)
	local ScoreContainer = gameScreen:FindChild("ScoreContainer",true)
	local MultiplierPanel = gameScreen:FindChild("MultiplierPanel",true)
	local TopScoresContainer = gameScreen:FindChild("TopScoresContainer",true)
	local RemainingSpinsContainer = gameScreen:FindChild("RemainingSpinsContainer",true)
	local SpecialGemPanel = gameScreen:FindChild("SpecialGemPanel",true)
	local TrickPanel = gameScreen:FindChild("TrickPanel",true)
	local AllPieceDropCells = gameScreen:FindChild("AllPieceDropCells",true)
	local AllBoardCells = gameScreen:FindChild("AllBoardCells",true)
	local AllSlotsCells = gameScreen:FindChild("AllSlotsCells",true)
	local AllGamePieces = gameScreen:FindChild("AllGamePieces",true)
	local StarMeter = gameScreen:FindChild("StarMeter",true)
	local GameBoard = gameScreen:FindChild("ReelBackground",true)
	
	local boardWidth = AllBoardCells.boardWidth
	local boardHeight = AllBoardCells.boardHeight

	ScriptDelay(250)
	SlideOn(AllBoardCells,250,"right","nowait")
	SlideOn(AllGamePieces,250,"right","nowait")
	PlaySound("Win11_60.ogg")

	local showTricks = isLevelGame or Config.PayToWinChallenge

	if(TrickPanel.position.y >300)then
		if(showTricks) then
			SlideOn(TrickPanel,250,"bottom","nowait")
		end
		SlideOn(ScoreContainer,250,"top","nowait")
	else
		if(showTricks) then
			SlideOn(TrickPanel,250,"top","nowait")
		end
		SlideOn(ScoreContainer,250,"bottom","nowait")
	end
	
	local subpanelsShowing = false
	subpanelsShowing = subpanelsShowing or SpecialGemPanel.SpecialGem1_1.visible
	subpanelsShowing = subpanelsShowing or SpecialGemPanel.SpecialGem2_1.visible
	subpanelsShowing = subpanelsShowing or SpecialGemPanel.SpecialGem2_2.visible
	subpanelsShowing = subpanelsShowing or SpecialGemPanel.SpecialGem3_1.visible
	subpanelsShowing = subpanelsShowing or SpecialGemPanel.SpecialGem3_2.visible
	subpanelsShowing = subpanelsShowing or SpecialGemPanel.SpecialGem3_3.visible
	SlideOn(RemainingSpinsContainer,250,"bottom","nowait")
	if subpanelsShowing then
		SlideOn(SpecialGemPanel,250,"top","nowait")
	end

	SlideOn(MenuButton,250,"bottom","nowait")

	SlideOn(TopScoresContainer,250,"top","nowait")
	if IsIPhone5() or APP.useIPhone5AppAssets then
		if(Logo.visible)then
			SlideOn(Logo,250,"top","nowait")
		end
	elseif IsIPad() or APP.useIPadAppAssets then
		if(Logo.visible)then
			SlideOn(Logo,250,"top","nowait")
		end
	end

	ScriptDelay(350)
	local playSoundOnce = false
	for y=0,boardHeight-1 do
		for x=0,boardWidth-1 do
			local nameOfMatchingActor = "BoardSpaceMatchedView_" .. x .. "_" .. y
			local matchingActor = gameScreen:FindChild(nameOfMatchingActor,true)
			if(matchingActor)then
				playSoundOnce = true
				ScaleIn(matchingActor,{1.25,1.25},250,false)
				FadeIn(matchingActor,250)
			end
		end
	end

	if(playSoundOnce)then
		PlaySound("slot_machine_win_21_short3.ogg")
	end

	gameScreen:StartGameMusic()

	local gameBoard = gameScreen:FindChild("ReelBackground",true)
	if(gameBoard)then
		SlideOn(gameBoard,500,"bottom","nowait")
	end

	StopSound("slot_machine_spin_loop_02.ogg")
end

Scripts.Intro_SimulateSpinSaver = function(rootGameView)
	Scripts.Present_SpinSaver(rootGameView)
end

Scripts.Intro_SimulateStartBurst = function(rootGameView, controller)
	local affectedPieceViews = {}
	affectedPieceViews[1] = controller:FindGamePieceViewAt({3,1})
	affectedPieceViews[2] = controller:FindGamePieceViewAt({5,3})
	affectedPieceViews[3] = controller:FindGamePieceViewAt({0,4})
	Scripts.Present_StartBurst(rootGameView, affectedPieceViews)
end

Scripts.Intro_SimulateMultiplierBonus = function(rootGameView, controller)
	Scripts.Present_MultiplierBonus(rootGameView)
end

Scripts.Intro_SimulateNormal_Continued = function(rootGameView)
	local gameScreen = rootGameView.parent.parent
	ScriptDelay(500)
	local allBoardCells = gameScreen:FindChild("AllBoardCells",true)
	allBoardCells:AddScript("BoardShine","")

	gameScreen.showGoal = true

	rootGameView:AddScript("FinishGameIntroIntro_LetsGo","FinishGameIntroIntro_LetsGo")
	
	ScriptDelay(1000)

	--Needed: stats.levelName, stats.levelNumber
	--Needed: Goal text
	
	local goal1 = gameScreen.LevelGoalText1
    local goal2 = gameScreen.LevelGoalText2
	local stats = {}
	stats.levelName = gameScreen.LevelName
	stats.levelNumber = gameScreen.LevelNumber
	local isLevelGame = gameScreen.IsLevelGame

	if(goal1 ~= "" and gameScreen.showGoal) then
		local topScoresContainer = gameScreen:FindChild("TopScoresContainer",true)
		Scripts.ShowGoalDialog(rootGameView,gameScreen,goal1,goal2,topScoresContainer,stats,isLevelGame)
	end
	gameScreen.showGoal = true
end

Scripts.Intro_SpinToBegin = function(rootGameView)
	local gameScreen = rootGameView.parent.parent
	local MenuButton = gameScreen:FindChild("MenuButton",true)
	local SpinButton = gameScreen:FindChild("SpinButton",true)
	local Logo = gameScreen:FindChild("Logo",true)
	local ScoreContainer = gameScreen:FindChild("ScoreContainer",true)
	local MultiplierPanel = gameScreen:FindChild("MultiplierPanel",true)
	local TopScoresContainer = gameScreen:FindChild("TopScoresContainer",true)
	local RemainingSpinsContainer = gameScreen:FindChild("RemainingSpinsContainer",true)
	local TrickPanel = gameScreen:FindChild("TrickPanel",true)
	local AllPieceDropCells = gameScreen:FindChild("AllPieceDropCells",true)
	local AllBoardCells = gameScreen:FindChild("AllBoardCells",true)
	local AllSlotsCells = gameScreen:FindChild("AllSlotsCells",true)
	local AllGamePieces = gameScreen:FindChild("AllGamePieces",true)
	local StarMeter = gameScreen:FindChild("StarMeter",true)
	local GameBoard = gameScreen:FindChild("ReelBackground",true)
	
	local boardWidth = AllBoardCells.boardWidth
	local boardHeight = AllBoardCells.boardHeight
	
	ScriptDelay(250)
	SlideOn(AllBoardCells,250,"right","nowait")
	SlideOn(AllGamePieces,250,"right","nowait")
	PlaySound("Win11_60.ogg")

	local showTricks = isLevelGame or Config.PayToWinChallenge

	if(TrickPanel.position.y >300)then
		if(showTricks) then
			SlideOn(TrickPanel,250,"bottom","nowait")
		end
		SlideOn(ScoreContainer,250,"top","nowait")
	else
		if(showTricks) then
			SlideOn(TrickPanel,250,"top","nowait")
		end
		SlideOn(ScoreContainer,250,"bottom","nowait")
	end

	--[[if IsIPhone5() or APP.useIPhone5AppAssets then
		SlideOn(RemainingSpinsContainer,250,"top","nowait")
	elseif IsIPad() or APP.useIPadAppAssets then
		SlideOn(RemainingSpinsContainer,250,"top","nowait")
	else--]]
		SlideOn(RemainingSpinsContainer,250,"bottom","nowait")
	--end
	SlideOn(MenuButton,250,"bottom","nowait")

	SlideOn(TopScoresContainer,250,"top","nowait")
	if IsIPhone5() or APP.useIPhone5AppAssets then
		if(Logo.visible)then
			SlideOn(Logo,250,"top","nowait")
		end
	elseif IsIPad() or APP.useIPadAppAssets then
		if(Logo.visible)then
			SlideOn(Logo,250,"top","nowait")
		end
	end

	ScriptDelay(350)
	local playSoundOnce = false
	for y=0,boardHeight-1 do
		for x=0,boardWidth-1 do
			local nameOfMatchingActor = "BoardSpaceMatchedView_" .. x .. "_" .. y
			local matchingActor = gameScreen:FindChild(nameOfMatchingActor,true)
			if(matchingActor)then
				playSoundOnce = true
				ScaleIn(matchingActor,{1.25,1.25},250,false)
				FadeIn(matchingActor,250)
			end
		end
	end

	if(playSoundOnce)then
		PlaySound("slot_machine_win_21_short3.ogg")
	end

	gameScreen:StartGameMusic()

	local gameBoard = gameScreen:FindChild("ReelBackground",true)
	if(gameBoard)then
		SlideOn(gameBoard,500,"bottom","nowait")
	end

	StopSound("slot_machine_spin_loop_02.ogg")
end
	
Scripts.IntroduceMoleGuy = function(rootGameView)
	--Show Jasper pointing at spin button
	rootGameView.ReelCircle = Resources.ReelTapHereOnLeft:new {
		resource = "ReelTapHereOnLeft",
		alignment = MidBottom,
		alignmentOffset = {-20,0},
		visible = false,

		MoleGuy = {
			class = "Actor",
			pointingArm = {
				class = "Actor",
				rotationAngle = {degrees = -40},
				position = {15,20},
			},
		},
	}
	SlideOn(rootGameView.ReelCircle,250,"bottom","nowait")
end

Scripts.Intro_RestoreAllElements = function(rootGameView)
	local MenuButton = rootGameView:FindChild("MenuButton",true)
	local Logo = rootGameView:FindChild("Logo",true)
	local ScoreContainer = rootGameView:FindChild("ScoreContainer",true)
	local TopScoresContainer = rootGameView:FindChild("TopScoresContainer",true)
	TopScoresContainer:ClearLayer()
	local RemainingSpinsContainer = rootGameView:FindChild("RemainingSpinsContainer",true)

	RemainingSpinsContainer:ClearLayer()
	if(RemainingSpinsContainer.ScriptCircle ~= nil) then
		RemainingSpinsContainer.ScriptCircle:Destroy()
	end
	local TrickPanel = rootGameView:FindChild("TrickPanel",true)
	local StarMeter = rootGameView:FindChild("StarMeter",true)
	local GoalContainer = rootGameView:FindChild("LevelGoalContainer",true)
	if(GoalContainer.ScriptCircle ~= nil) then
		GoalContainer.ScriptCircle:Destroy()
	end
	
	local AllPieceDropCells = rootGameView:FindChild("AllPieceDropCells",true)
	local AllBoardCells = rootGameView:FindChild("AllBoardCells",true)
	local AllSlotsCells = rootGameView:FindChild("AllSlotsCells",true)
	local AllGamePieces = rootGameView:FindChild("AllGamePieces",true)
	local AllUnmatchedSpaces = rootGameView:FindChild("AllUnmatchedSpaces",true)
	
	local screen = rootGameView.parent
	local boxes = screen.backgroundImage.ReelBackground

	--Interrupt slide-on animation, since that will make gems spawn in wrong place.
	AllPieceDropCells:StopSlide()
	AllSlotsCells:StopSlide()
	AllGamePieces:StopSlide()
	boxes:StopSlide()

	local fadeSpeed = 250
	if(AllBoardCells.visible == false) then
		--logprint("Restoringboard")
		FadeInNoChildren(AllPieceDropCells,fadeSpeed)
		FadeInNoChildren(AllBoardCells,fadeSpeed)
		FadeInNoChildren(AllSlotsCells,fadeSpeed)
		FadeInNoChildren(boxes,fadeSpeed)
		FadeInNoChildren(AllGamePieces,fadeSpeed)
		FadeInNoChildren(AllUnmatchedSpaces,fadeSpeed)
	end

	if(ScoreContainer.visible == false) then
		if(TrickPanel.position.y >300)then
			SlideOn(ScoreContainer,fadeSpeed,"top","nowait")
		else
			SlideOn(ScoreContainer,fadeSpeed,"bottom","nowait")
		end
		SlideOn(GoalContainer,fadeSpeed,"top","nowait")
		SlideOn(RemainingSpinsContainer,250,"bottom","nowait")
		SlideOn(MenuButton,fadeSpeed,"bottom","nowait")
		SlideOn(TopScoresContainer,fadeSpeed,"top","nowait")
		SlideOn(StarMeter,fadeSpeed,"top","nowait")
	end
	
	if(TrickPanel.position.y >300)then
		SlideOn(TrickPanel,fadeSpeed,"bottom","nowait")
	else
		SlideOn(TrickPanel,fadeSpeed,"top","nowait")
	end
	
	if(screen.backgroundImage.backgroundDim ~= nil) then
		FadeOutAndDestroy(screen.backgroundImage.backgroundDim,200)
	end
end

Scripts.Intro_ShowReels = function(rootGameView) 
	local AllPieceDropCells = rootGameView:FindChild("AllPieceDropCells",true)
	local AllSlotsCells = rootGameView:FindChild("AllSlotsCells",true)
	local screen = rootGameView.parent
	local boxes = screen.backgroundImage.ReelBackground
	local AllGamePieces = rootGameView:FindChild("AllGamePieces",true)
	
	--Slide on reels from left
	SlideOn(AllPieceDropCells,250,"left","nowait")
	SlideOn(AllSlotsCells,250,"left","nowait")
	SlideOn(AllGamePieces,250,"left","nowait")
	SlideOn(boxes,250,"left","nowait")
end

Scripts.Intro_ShowReadySetGo = function(rootGameView)
	logprint("Intro_ShowReadySetGo")
	local screen = rootGameView.parent
	local AllBoardCells = rootGameView:FindChild("AllBoardCells",true)
	local AllUnmatchedSpaces = rootGameView:FindChild("AllUnmatchedSpaces",true)
	
	--Slide on empty-looking board from right.
	SlideOn(AllBoardCells,250,"right","nowait")
	SlideOn(AllUnmatchedSpaces,250,"right","nowait")
	
	if(screen.backgroundImage.backgroundDim ~= nil) then
		FadeOutAndDestroy(screen.backgroundImage.backgroundDim,200)
	end
end

Scripts.Intro_Light1 = function(rootGameView)
	ScriptBreak()
	WaitForTaggedScriptCompletion(rootGameView,"Piece_Flyup")
	PlaySound("score1.ogg")
	
	local flungGemPosition = rootGameView:FindChild("BoardCell_3_4",true)
	local centerPoint = GetGlobalCenterPoint(flungGemPosition)
	
	StartParticleEmitterFromFile {
		file = "StarBurst2",
		position = centerPoint,
	}
end

Scripts.Intro_Light2 = function(rootGameView)
	ScriptBreak()
	WaitForTaggedScriptCompletion(rootGameView,"Piece_Flyup")
	PlaySound("score2.ogg")
	
	local flungGemPosition = rootGameView:FindChild("BoardCell_1_5",true)
	local centerPoint = GetGlobalCenterPoint(flungGemPosition)
	
	StartParticleEmitterFromFile {
		file = "StarBurst2",
		position = centerPoint,
	}
end

Scripts.Intro_Light3 = function(rootGameView)
	ScriptBreak()
	WaitForTaggedScriptCompletion(rootGameView,"Piece_Flyup")
	PlaySound("score3.ogg")

	local flungGemPosition = rootGameView:FindChild("BoardCell_4_1",true)
	local centerPoint = GetGlobalCenterPoint(flungGemPosition)
	
	StartParticleEmitterFromFile {
		file = "StarBurst2",
		position = centerPoint,
	}
end

Scripts.Intro_ChangeToSet = function(rootGameView)
	local screen = rootGameView.parent
	if(screen.backgroundImage.backgroundDim ~= nil) then
		FadeOutAndDestroy(screen.backgroundImage.backgroundDim,200)
	end
end

Scripts.Intro_ShowMainBoard = function(rootGameView)
	ScriptDelay(1000)
	SlideOff(rootGameView.TutorialSkipButton,250,"bottom","nowait")

	--Show everything but the tricks

	local MenuButton = rootGameView:FindChild("MenuButton",true)
	local Logo = rootGameView:FindChild("Logo",true)
	local ScoreContainer = rootGameView:FindChild("ScoreContainer",true)
	local TopScoresContainer = rootGameView:FindChild("TopScoresContainer",true)
	local RemainingSpinsContainer = rootGameView:FindChild("RemainingSpinsContainer",true)
	local StarMeter = rootGameView:FindChild("StarMeter",true)
	local TrickPanel = rootGameView:FindChild("TrickPanel",true)
	local GoalContainer = rootGameView:FindChild("LevelGoalContainer",true)

	if(TrickPanel.position.y >300)then
		SlideOn(ScoreContainer,250,"top","nowait")
	else
		SlideOn(ScoreContainer,250,"bottom","nowait")
	end
	
	SlideOn(GoalContainer,250,"top","nowait")
	SlideOn(RemainingSpinsContainer,250,"bottom","nowait")
	SlideOn(MenuButton,250,"bottom","nowait")
	SlideOn(TopScoresContainer,250,"top","nowait")
	SlideOn(StarMeter,250,"top","nowait")
end

Scripts.Intro_CircleGoal = function(rootGameView)
	local GoalContainer = rootGameView:FindChild("LevelGoalContainer",true)
	
	local TopScoresContainer = rootGameView:FindChild("TopScoresContainer",true)
	TopScoresContainer.layer = 2
	ScriptDelay(1250)

	GoalContainer.ScriptCircle = Resources.Actor:new {
		resource = "Actor",
		alignment = Center,
		image = "Tips_GreenCircle.png",
		layer = 4,
	}
	Pop(GoalContainer.ScriptCircle)
end

Scripts.Intro_CircleSpins = function(rootGameView)
	ScriptDelay(1250)
	
	local GoalContainer = rootGameView:FindChild("LevelGoalContainer",true)
	if(GoalContainer.ScriptCircle ~= nil) then
		FadeOutAndDestroy(GoalContainer.ScriptCircle,250)
	end
	local TopScoresContainer = rootGameView:FindChild("TopScoresContainer",true)
	TopScoresContainer:ClearLayer()
	local RemainingSpinsContainer = rootGameView:FindChild("RemainingSpinsContainer",true)
	
	RemainingSpinsContainer.layer = 2

	RemainingSpinsContainer.ScriptCircle = Resources.Actor:new {
		resource = "Actor",
		alignment = Center,
		image = "Tips_GreenCircle.png",
		layer = 1000,
	}
end

Scripts.Intro_RemoveCircles = function(rootGameView)
	local RemainingSpinsContainer = rootGameView:FindChild("RemainingSpinsContainer",true)
	RemainingSpinsContainer:ClearLayer()
	FadeOutAndDestroy(RemainingSpinsContainer.ScriptCircle,250)
end

Scripts.Intro_GiveHammer = function(rootActor)
	--Make a hammer on the middle of the screen
	rootActor.PowerupImage = Resources.Actor:new {
		resource = "Actor",
		layer = 2020,
		image = "Trick_Hammer_big.png",
		alignment = Center,
		powerupName = "Hammer",
	}
	rootActor:AddScript("TrickAcquired","TrickAcquired")
	
	local trickPanel = rootActor:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "Hammer") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick.parent.visible = true
	acquiredTrick.layer = 500
end

Scripts.Intro_UseHammer = function(rootActor)
	rootActor.TrickLauncherPanel.layer = 500
end

Scripts.Intro_Give3Hammers = function(rootActor)
	--Make a hammer on the middle of the screen
	rootActor.PowerupImage = Resources.Actor:new {
		resource = "Actor",
		layer = 2020,
		image = "Trick_Hammer_big.png",
		anotherHammer = Resources.Actor:new {
			class = "Actor",
			image = "Trick_Hammer_big.png",
			zorder = -1,
			position = {5,5},
		},
		yetAnotherHammer = Resources.Actor:new {
			class = "Actor",
			image = "Trick_Hammer_big.png",
			zorder = -2,
			position = {10,10},
		},
		alignment = Center,
		powerupName = "Hammer",
	}
	rootActor:AddScript("TrickAcquired","TrickAcquired")
	ScriptDelay(1000)
	
	local trickPanel = rootActor:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "Hammer") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick:ClearLayer()
end

Scripts.Intro_GiveShifter = function(rootActor)
	ScriptDelay(500)
	--Make a shifter on the middle of the screen
	rootActor.PowerupImage = Resources.Actor:new {
		resource = "Actor",
		layer = 2020,
		image = "Trick_Shifter_big.png",
		alignment = Center,
		powerupName = "Shifter",
	}
	rootActor:AddScript("TrickAcquired","TrickAcquired")
	
	local trickPanel = rootActor:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "Shifter") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick.parent.visible = true
	acquiredTrick.layer = 500
end

Scripts.Intro_UseShifter = function(rootActor)
	rootActor.TrickLauncherPanel.layer = 500
end

Scripts.Intro_Give3Shifters = function(rootActor)
	--Make a hammer on the middle of the screen
	rootActor.PowerupImage = Resources.Actor:new {
		resource = "Actor",
		layer = 2020,
		image = "Trick_Shifter_big.png",
		anotherHammer = Resources.Actor:new {
			class = "Actor",
			image = "Trick_Shifter_big.png",
			zorder = -1,
			position = {5,5},
		},
		yetAnotherHammer = Resources.Actor:new {
			class = "Actor",
			image = "Trick_Shifter_big.png",
			zorder = -2,
			position = {10,10},
		},
		alignment = Center,
		powerupName = "Shifter",
	}
	rootActor:AddScript("TrickAcquired","TrickAcquired")
	ScriptDelay(1000)
	
	local trickPanel = rootActor:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "Shifter") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick:ClearLayer()
end

Scripts.Intro_GiveSuperMatch = function(rootActor)
	--Make a hammer on the middle of the screen
	rootActor.PowerupImage = Resources.Actor:new {
		resource = "Actor",
		layer = 2020,
		image = "Trick_SuperMatch_big.png",
		alignment = Center,
		powerupName = "SuperMatch",
	}
	rootActor:AddScript("TrickAcquired","TrickAcquired")
	
	local trickPanel = rootActor:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "SuperMatch") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick.parent.visible = true
	acquiredTrick.layer = 500
end

Scripts.Intro_UseSuperMatch = function(rootActor)
	rootActor.TrickLauncherPanel.layer = 500
end

Scripts.Intro_Give3SuperMatches = function(rootActor)
	--Make a SuperMatch on the middle of the screen
	rootActor.PowerupImage = Resources.Actor:new {
		resource = "Actor",
		layer = 2020,
		image = "Trick_SuperMatch_big.png",
		anotherHammer = Resources.Actor:new {
			class = "Actor",
			image = "Trick_SuperMatch_big.png",
			zorder = -1,
			position = {5,5},
		},
		yetAnotherHammer = Resources.Actor:new {
			class = "Actor",
			image = "Trick_SuperMatch_big.png",
			zorder = -2,
			position = {10,10},
		},
		alignment = Center,
		powerupName = "SuperMatch",
	}
	rootActor:AddScript("TrickAcquired","TrickAcquired")
	ScriptDelay(1000)
	
	local trickPanel = rootActor:FindChild("TrickPanel",true)
	local acquiredTrick
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == "SuperMatch") then
			acquiredTrick = consideredTrick
		end
	end
	acquiredTrick:ClearLayer()
end

Resources.HelpNextButton = Resources.Button:new {
	resource = "Button",
	image = "",
	text = STRINGS(""),
	useFrames = false,
	layer = 900,
	tag = "Clickable",

	TapAnywhereLabel = Resources.Label:new {
		resource = "Label",
		alignment = Center,
		alignmentOffset = {0,20},
		text = STRINGS("Tap Anywhere to Continue"),
        wrapLimit = 250,
		font = Resources.NoteBubbleFont:new{
			resource = "NoteBubbleFont",
			fontSize = 20,
		},
		fgColor = "Cascade_White",
		highlightColor = "Cascade_Black",
		highlightAlpha = 0,
		shadowColor = "Cascade_Black",
		shadowAlpha = 255,
		scripts = {"WiggleLoop"},
	},

	TutorialNextButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = BottomRight,
		alignmentOffset = Layout{{-4,2}, iphone5 = {-4,-4}, ipad={-4,-4}},
		text = STRINGS("Next"),
		shortcutKey = "N",
		tag = "Clickable",
	},
}

Resources.HelpNextButtonLow = Resources.HelpNextButton:new {
	resource = "HelpNextButton",
	TapAnywhereLabel = {
		class = "Label",
		alignmentOffset = Layout{{0,135}, iphone5 = {0,145}, ipad={0,135}}, 
	},
}

Scripts.Preshow_Tutorial = function(rootGameView)
	--logprint("Preshow_Tutorial")
	--Create and slide on next and skip buttons
	rootGameView.TutorialNextButton = Resources.HelpNextButton:new {
		resource = "HelpNextButton",
		size = {rootGameView.size.x,rootGameView.size.y},
		visible = false,
	}
	
	rootGameView.TutorialSkipButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = MidBottom,
		alignmentOffset = Layout{{4,2}, iphone5 = {4,-4}, ipad={0,-4}},
		text = STRINGS("Skip"),
		shortcutKey = "S",
		layer = 901,
		tag = "Clickable",
    }
	if(Config.AlwaysShowTutorial ~= true) then
		SlideOn(rootGameView.TutorialSkipButton,250,"bottom","nowait")
	else
		rootGameView.TutorialSkipButton.visible = false
	end
end

Scripts.Intro_LetsGo = function(rootGameView)
	Scripts.Intro_RestoreAllElements(rootGameView)
	--Scripts.StartingNewGame_LetsGo(rootGameView,rootGameView.parent.parent)
end

Scripts.Tutorial_ShowNextButton = function(rootGameView)
	--logprint("Tutorial_ShowNextButton")
	if(rootGameView.TutorialNextButton.visible == false) then
		--logprint("Tutorial_ShowNextButton showing")
		ScriptDelay(1000)
		FadeIn(rootGameView.TutorialNextButton,250)
	end
end

Scripts.Tutorial_HideNextButton = function(rootGameView)
	--logprint("Tutorial_HideNextButton")
	if(rootGameView.TutorialNextButton.visible == true) then
		--logprint("Tutorial_HideNextButton hiding")
		FadeOut(rootGameView.TutorialNextButton,250)
		--SlideOff(rootGameView.TutorialNextButton,250,"bottom","wait")
	end
end

Scripts.Cleanup_Tutorial = function(rootGameView)
	--Destroy next and spin buttons
	SlideOff(rootGameView.TutorialNextButton,250,"bottom","nowait")
	if(rootGameView.TutorialSkipButton.visible) then
		SlideOff(rootGameView.TutorialSkipButton,250,"bottom","wait")
	end

	rootGameView:DestroyChild(rootGameView.TutorialNextButton)
	rootGameView:DestroyChild(rootGameView.TutorialSkipButton)
end
