-- Land 1: intro, patterns

table.insertall(LevelDefs,
{

	["Welcome"] = {
		levelName = "Welcome!!!",					
		introScript = "Land1_Welcome",
		resource = "GameScreen_Land1",	
		Features = {
			regularBoard = true, --Changed Phelan
			modeSpins2 = true, 
			splashMode = true,
			gemTypes5 = true, --Changed Phelan
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = false,
			missingSquares = {
				patternName = "BottomTopRows", 
				isPatternSet = false,
			},
		},		
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",75000},
				[3] = {"score",125000},
			},
		},
	},
	["Level2"] = {
		levelName = "On The Road!",					
		resource = "GameScreen_Land1",		
		introScript = "Land1_Level2",
		Features = {
			modeSpins3 = true, --Ignore GLOBAL setting, use additionalNumRemainingSpins to bring it up to desired number
			splashMode = true,
			hasMissingSquares = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "MissingCorners",  --was "MissingCorners2"
				isPatternSet = false,
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
	},
	["Level3"] = {
		levelName = "I Got This!",					
		resource = "GameScreen_Land1",		
		introScript = "Land1_Level3",
		Features = {
			modeSpins4 = true, --Ignore GLOBAL setting, use additionalNumRemainingSpins to bring it up to desired number
			splashMode = true,
			hasMissingSquares = true, 
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "EightSpots1_less", --was "EightSpots1_less"
				isPatternSet = false,
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",40000},
				[3] = {"score",50000},
			},
		},
	},
	["Level4"] = {
		levelName = "Fun Fun Fun!",					
		resource = "GameScreen_Land1",		
		introScript = "Land1_Level4",
		Features = {
			modeSpins4 = true, --Ignore GLOBAL setting, use additionalNumRemainingSpins to bring it up to desired number
			splashMode = true,
			hasMissingSquares = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "FourSpots2", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",90000},
				[3] = {"score",100000},
			},
		},
	},
	["Level5"] = {
		levelName = "A Bit Bigger!",					
		resource = "GameScreen_Land1",		
		introScript = "Land1_Intro",	
		onlyShowCutsceneOnce = true,
		Features = {
			modeSpins8 = true, --5 before Operation Easy
			splashMode = true,
			largeBoard = true,
			hasMissingSquares = true,
 			gemTypes5 = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "CornerSides", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",150000},
			},
		},
	},

	["SimpleCoverage1"] = {
		levelName = "Cloudy Gems!",					
		resource = "GameScreen_Land1",		
		introScript = "Land1_Tip1",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			hasCoverage = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "SimpleSquare",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["SimpleCoverage2"] = {
		levelName = "Four Clouds!",					
		resource = "GameScreen_Land1",	
		introScript = "Land1_Tip2",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins8 = true, --already matched Operation Easy
			hasCoverage = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "FourBlocks",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},
	["SimpleCoverage3"] = {
		levelName = "Cloud Corners!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins12 = true,  --7 before Operation Easy
			hasCoverage = true,
			gemTypes5 = true,
			hasMissingSquares = true,
			regularBoard = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "OuterCorners_empty_less", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "OuterCorners2",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["SimpleCoverage4"] = {
		levelName = "Cloud Climby!",
		resource = "GameScreen_Land1",		
		--introScript = "Land1_Tip3",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins8 = true, --6 before Operation Easy
			hasCoverage = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "StaircaseUp_empty", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StaircaseUp",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},

	["BigBoard2"] = {
		levelName = "Big Cloud!",					
		resource = "GameScreen_Land1",		
		introScript = "Land1_Tip4",
		onlyShowCutsceneOnce = true,
		outtroScript = "Land1_Outtro",
		Features = {
			splashMode = true,
			modeSpins8 = true, --already matched Operation Easy
			hasCoverage = true,
			largeBoard = true,
			gemTypes6 = true,
			hasMissingSquares = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = false,
			missingSquares = {
				patternName = "BigCastle1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BigCratePattern1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

})