-- Land 10: gem collection

table.insertall(LevelDefs,
{

	["GemCollect1"] = {
		levelName = "Sapphire Sparkle",
		introScript = "Land10_Intro",
		resource = "GameScreen_Land10",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Columns",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
			},
		},
		goals = {
			main = {"getGem",50,"Blue","Blues",{matchFlags = CascadeMatchFlags_CommonPiece1},"Collect"},
			stars = {
				[1] = {"score",125000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["GemClear1"] = {
		levelName = "Get the Red Out",
		introScript = "Land10_Tip1",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 9,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
				reelPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 4,
					},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Red","Reds",{matchFlags = CascadeMatchFlags_CommonPiece4},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",450000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["GemCollect2"] = {
		levelName = "Topaz Trial",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--6 before Operation Easy
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    frequencies = {1,0,1,0,1,0,1,0,1,0},
				},
			}, 
		},
		goals = {
			main = {"getGem",30,"Yellow","Yellows",{matchFlags = CascadeMatchFlags_CommonPiece5},"Collect"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",650000},
			},
		},
		expectedScore = 100000,
	},

	["BombCollect_Updated"] = {
		levelName = "Orange Bombs",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 35,
					frequencies = {2,2,3,3,4,4},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleMissingPattern1",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 35,
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyPieceSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",700000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},

	["EverythingIsTicking"] = {
		levelName = "Everything Is Ticking",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBombs = true,
			hasBarrels = true,
			hasChests = true,
		},
		tricks = TricksDefault,
		boosts = World9Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 10,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 10,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 10,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 10,
				},
				{
					name = "Blue Bomb",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					turnsToLoss = 15,
					weight = 1,
				},
				{
					name = "Green Bomb",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					turnsToLoss = 15,
					weight = 1,
				},
				{
					name = "Purple Bomb",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					turnsToLoss = 15,
					weight = 1,
				},
				{
					name = "Red Bomb",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					turnsToLoss = 15,
					weight = 1,
				},
				{
					name = "Boulder Bomb",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					turnsToLoss = 10,
					weight = 2,
				},
				{
					name = "Chest Bomb",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					turnsToLoss = 30,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BottomRow_Spot1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[2] = {
					patternName = "BottomRow_Spot2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = {
					patternName = "BottomRow_Spot3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[4] = {
					patternName = "BottomRow_Spot4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[5] = {
					patternName = "BottomRow_Spot5",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[6] = {
					patternName = "BottomRow_Spot6",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
			},
		},
		goals = {
			main = {"getGem",50,"Bomb","Bombs",{turnsToLoss = true},"Defuse"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",1250000},
			},
		},
		expectedScore = 100000,
	},

	["BottomVines"] = {
		levelName = "Weeding",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins7 = true,--6 before Operation Easy
			regularBoard = true,
			gemTypes5 = true,
			hasVines = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 10,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BottomCheckers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[2] = {
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
				reelPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 4,
					},
				},
			},
		},
		goals = {
			main = {"getGem",60,"Green","Greens",{matchFlags = CascadeMatchFlags_CommonPiece2},"Collect"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},

	["SideColumns"] = {
		levelName = "Topaz Towers",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    frequencies = {1,2,2,2,1,2,2,2},
				},
			}, 
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "SideCols",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[2] = {
					patternName = "MidCols",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Yellow","Yellows",{matchFlags = CascadeMatchFlags_CommonPiece5},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",800000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000,
	},

	["YellowMiniTowers"] = {
		levelName = "Mini Columns",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--already matched Operation Easy
			largeBoard = true,
			gemTypes4 = true,
			hasMissingSquares = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "FourBins", 
				isPatternSet = false,
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LowCols",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				[2] = {
					patternName = "Line3_large",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["6ColorClear_Updated"] = {
		levelName = "Agent Orange",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes6 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 5.5,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 5.5,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 5.5,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
				},
				reelPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 6,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "EmptyPatterns",
					isPatternSet = true,
					randomAdditionalPositions = 3,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["TopVines"] = {
		levelName = "Kudzu",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "UpperLine1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "UpperLine2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",40,"Green","Greens",{matchFlags = CascadeMatchFlags_CommonPiece2},"Collect"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000,
	},

	["GemCollect4"] = {
		levelName = "Windows",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,--7 before Operation Easy
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
		useMissingSquares = true,
			missingSquares = {
				patternName = "Lattice", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"getGem",30,"Blue","Blues",{matchFlags = CascadeMatchFlags_CommonPiece1},"Collect"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000,
	},

	["BombCollect2"] = {
		levelName = "Amethyst Bombs",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--8 before Operation Easy (lowered)
			regularBoard = true,
			gemTypes6 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World10Boosts,
		Properties = {
			reelPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 12,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 11,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 5,
					},
				},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 12,
					frequencies = {1,2,1,2,3,2,1,2,1,2},
				},
			},
			additionalInitialPatterns = {
				[1] = {

					applyTurnsToLoss = true,

					patternName = "Scatter1",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 15,
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
				},
				[2] = {

					applyTurnsToLoss = true,

					patternName = "Scatter2",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 15,
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",55,"Purple","Purples",{matchFlags = CascadeMatchFlags_CommonPiece3},"Collect"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["BombVines"] = {
		levelName = "Overgrown Bombs",
		resource = "GameScreen_Land1",
		outtroScript = "Land10_Outtro",
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			largeBoard = true,
			gemTypes6 = true,
			hasVines = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "VineLoops",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {

					applyTurnsToLoss = true,

					patternName = "EdgeBombs",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 25,
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyPieceSpecials = true,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
				},
				reelPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 4,
					},
				},
			},
		},
		goals = {
			main = {"getGem",45,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},"Collect"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["BottomRow"] = {
		levelName = "Out of Reach",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "LowerLine2", 
				isPatternSet = false,
			},
			--[[
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					frequencies = {3,4,9,10,15,16,21,22},
				},
				[2] = {
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					frequencies = {2,5,8,11,14,17,20,23},
				},
				[3] = {
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					frequencies = {1,6,7,12,13,18,19,24},
				},
			},
			]]
			additionalInitialPatterns = {
				{
					patternName = "LowerLine1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Yellow","Yellows",{matchFlags = CascadeMatchFlags_CommonPiece5},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["GemTreasures"] = {
		levelName = "Blocked Chests",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins6 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = {
			{name = Config.World9Tricks_Trick1},
			{name = Config.World9Tricks_Trick2},
			{name = Config.World9Tricks_Trick3},
		},
		boosts = World10Boosts,
		Properties = {
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 4,
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BottomChecks2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				[2] = { 
					patternName = "UpperLine1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",300000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["BottomVines_side"] = {
		levelName = "Emerald Harvest",
		resource = "GameScreen_Land10",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasVines = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 10,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BottomCheckers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[2] = {
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
				reelPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 4,
					},
				},
			},
		},
		goals = {
			main = {"getGem",40,"Green","Greens",{matchFlags = CascadeMatchFlags_CommonPiece2},"Collect"},
			stars = {
				[1] = {"score",70000},
				[2] = {"score",300000},
				[3] = {"score",350000},
			},
		},
	},

	["GemCollect4_side"] = {
		levelName = "Lattice",
		resource = "GameScreen_Land10",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
		useMissingSquares = true,
			missingSquares = {
				patternName = "Lattice", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"getGem",20,"Blue","Blues",{matchFlags = CascadeMatchFlags_CommonPiece1},"Collect"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["GemTreasures_side"] = {
		levelName = "Blockage",
		resource = "GameScreen_Land10",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = {
			{name = Config.World9Tricks_Trick1},
			{name = Config.World9Tricks_Trick2},
			{name = Config.World9Tricks_Trick3},
		},
		boosts = World10Boosts,
		Properties = {
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 4,
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BottomChecks2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				[2] = { 
					patternName = "UpperLine1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",700000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},

	["Land10Side4_side"] = {
		levelName = "Orange Checkerboard",
		resource = "GameScreen_Land10",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSteel = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			gemsMoveDiagonally = false,
			additionalInitialPatterns = {
				{
					patternName = "10-4_Checkerboard",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				{
					patternName = "10-4_Blue",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "10-4_Green",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "10-4_Purple",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "10-4_Red",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "10-4_Yellow",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},
})