-- Land 11: lava, double boulders

table.insertall(LevelDefs,
{

	["LavaPool"] = {
		levelName = "Lava Pool",
		resource = "GameScreen_Land1",		
		introScript = "Land11_Intro",
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins5 = true,--already matched Operation Easy
			gemTypes6 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 4,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "BottomPile1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "TopCorners_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",250000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000,
	},

	["JailedLava"] = {
		levelName = "Jailed Lava",
		resource = "GameScreen_Land1",	
		outtroScript = "Land11_Tip1",	
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins8 = true,--already matched Operation Easy
			gemTypes6 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "LittleCratePattern1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "Line",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",350000},
			},
		},
		expectedScore = 100000,
	},

	["LavaChests"] = {
		levelName = "Volcano Treasure",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins5 = true,--already matched Operation Easy
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BigCratePattern7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{ 
					patternName = "Line8_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",7,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",90000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["2HitBoulderTest_Updated"] = {
		levelName = "Double Boulders",
		resource = "GameScreen_Land1",
		introScript = "Land11_Tip2",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrels = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					weight = 6,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "StripesAndColumns_alt1",
					isPatternSet = false,
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				{
					patternName = "DoubleBoulders_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyPieceSpecials = true,
					specials = 0,
					applyExtraHits = true,
					extraHits = 0,
				},
				{
					patternName = "DoubleBoulders_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = 0,
					applyExtraHits = true,
					extraHits = 0,
				},
				{
					patternName = "DoubleBoulders_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = 0,
					applyExtraHits = true,
					extraHits = 0,
				},
				{
					patternName = "DoubleBoulders_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = 0,
					applyExtraHits = true,
					extraHits = 0,
				},
				{
					patternName = "DoubleBoulders_Color5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyPieceSpecials = true,
					specials = 0,
					applyExtraHits = true,
					extraHits = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels},},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},

	["BouldersAndLava"] = {
		levelName = "Lava Rocks",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "StripesAndColumns_alt2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",125000},
				[3] = {"score",150000},
			},
		},
	},

	["StackOfBoulders"] = {
		levelName = "Stack of Boulders",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes6 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{ --Barrels
					patternName = "LeftColumn1",
					isPatternSet = false,
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				{
					patternName = "LeftColumn2",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				{
					patternName = "VerticalCenterLine",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels},},
			stars = {
				[1] = {"score",45000},
				[2] = {"score",70000},
				[3] = {"score",300000},
			},
		},
	},

	["LavaPattern_Updated"] = {
		levelName = "Ring of Fire",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins6 = true,--7 before Operation Easy
            hasLava = true,
            hasSteel = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "OuterNoTopLarge_LavaPattern",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "U_Lining No Corners",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				{
					patternName = "Umlaut Large",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "InsideCorners_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["LavaVines"] = {
		levelName = "Stuck in the Middle",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins5 = true,--6 before Operation Easy (lowered)
			gemTypes5 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "LeftColumn1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "RightColumn1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "LeftColumn2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "RightColumn2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",60000},
				[2] = {"score",120000},
				[3] = {"score",240000},
			},
		},
		expectedScore = 100000,
	},

	["LavaBombs"] = {
		levelName = "Eruption",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins6 = true,--already matched Operation Easy
			gemTypes6 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "LavaBombs",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "CrateBottomBlock1",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 22,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",200000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},

	["DoubleBoulderBombs"] = {
		levelName = "Barred Bombs",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins5 = true,--6 before Operation Easy (lowered)
			hasBombs = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					anyOneMatchFlag = true,
					applyExtraHits = true,
					extraHits = 1,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
					turnsToLoss = 4,
					frequencies = {1,1,1,1,1,1,1,1,1,1,1,1,},
				},
			},
			additionalInitialPatterns = { 
				{ 
					patternName = "Wedge1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 4,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
				},
				{
					patternName = "Wedge1_row4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 4,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"getGem",25,"Boulder","Boulders",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels, extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",650000},
				[2] = {"score",750000},
				[3] = {"score",850000},
			},
		},
		expectedScore = 100000,
	},

	["BoulderTreasure"] = {
		levelName = "Mining",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			regularBoard = true,
			gemTypes5 = true,
			treasureChest = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
			additionalInitialPatterns = { 
				{ --Barrels
					patternName = "Scattered",
					isPatternSet = false,
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",200000},
				[3] = {"score",350000},
			},
		},
	},

	["AvoidLava"] = {
		levelName = "Convection",
		resource = "GameScreen_Land1",	
		introScript = "Land11_Tip3",
		onlyShowCutsceneOnce = true,
		outtroScript = "Land11_Outtro",	
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins2 = true,
			gemTypes4 = true,
		},
		tricks = {
			{name = Config.World10Tricks_Trick1},
			{name = Config.World10Tricks_Trick2},
			{name = Config.World10Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Row4Center",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",1100000},
				[2] = {"score",1500000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000,
	},

	["LavaSplash"] = {
		levelName = "Deep Lava",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins6 = true, --7 before Operation Easy (lowered)
			gemTypes6 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Volcano",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",200000},
				[3] = {"score",450000},
			},
		},
		expectedScore = 100000,
	},

	["TreasureJails"] = {
		levelName = "Break-In",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins6 = true,--already matched Operation Easy
			gemTypes5 = true,
			treasureChest = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{ 
					patternName = "TopCorners",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				{
					patternName = "Breakin Color1",
					isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "Breakin Color2",
					isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "Breakin Color3",
					isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "Breakin Color4",
					isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "Breakin Color5",
					isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				{
					patternName = "OuterRing_noTop",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",150000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000,
	},

	["SplashVines"] = {
		levelName = "In the Jungle",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins6 = true,--already matched Operation Easy
			gemTypes6 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					frequencies = {3,4,9,10,15,16,21,22},
				},
				[2] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					frequencies = {2,5,8,11,14,17,20,23},
				},
				[3] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					frequencies = {1,6,7,12,13,18,19,24},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Checkers",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000,
	},

	["LavaSplash_side"] = {
		levelName = "Lots of Lava",
		resource = "GameScreen_Land11",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins5 = true,
			gemTypes5 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Volcano_less",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",450000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["DoubleBoulderBombs_side"] = {
		levelName = "Double Boulder Bombs",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins6 = true,
			hasBombs = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					anyOneMatchFlag = true,
					applyExtraHits = true,
					extraHits = 1,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
					turnsToLoss = 6,
					frequencies = {1,1,1,1,1,1,1,1,1,1,1,1,},
				},
			},
			additionalInitialPatterns = { 
				{ 
					patternName = "Wedge1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 6,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
				},
				{
					patternName = "Wedge1_row4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 6,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Boulder","Boulders",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels, extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},

	["LavaChests_side"] = {
		levelName = "Lava Chests",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins9 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BigCratePattern7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{ 
					patternName = "Line8_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",400000},
				[3] = {"score",1800000},
			},
		},
		expectedScore = 100000,
	},
	["Land11Side4_side"] = {
		levelName = "Lava Pipe",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes3 = true,
			hasSteel = true,
			hasLava = true,
			hasJailedSquares = true,
			hasMissingReels = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "11-4_Steel",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,

					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "11-4_Blue",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,

					applyPieceSpecials = true,
					specials = 0,
				},
				{
					patternName = "11-4_Green",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,

					applyPieceSpecials = true,
					specials = 0,
				},
				{
					patternName = "11-4_Jail",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,

					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
				{
					patternName = "11-4_Lava",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,

					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			boardPieceMix = {
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 11,
				},
				{
					name = "Red Vertical Burst",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 0.225,
				},
				{
					name = "Yellow Vertical Burst",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 0.225,
				},
				{
					name = "Orange Vertical Burst",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 0.225,
				},
			},
			reelPieceMix = {
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Blue","Blues",{matchFlags = CascadeMatchFlags_CommonPiece1},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},
})