-- Level 12: barrels of fun

table.insertall(LevelDefs,
{
	["BarrelGemTest"] = {
		levelName = "Barrels of Fun",
		resource = "GameScreen_Land12",
		introScript = "Land12_Intro",
		Features = {
			splashMode = true,
			modeSpins5 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes6 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Orange Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Blue Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Orange Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Orange Area",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 8,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
				},
			},
		},
		goals = {
			main = {"getGem",30,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},"Break"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["PottedPlants"] = {
		levelName = "Potted Plants",
		resource = "GameScreen_Land12",
		outtroScript = "Land12_Outtro",
		Features = {
			splashMode = true,
			modeSpins8 = true,--9 before Operation Easy
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
			spawnGemOnBreak =
			{
				{
					name = "Vine Blue",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Vine Green",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Vine Purple",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Vine Red",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Vine Yellow",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {2,3,4,2,3,4,3,2,4},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "SideCols",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},

	["BarrelsOfBombs"] = {
		levelName = "Dynamite",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 3,
				},
				{
					name = "Green Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 3,
				},
				{
					name = "Purple Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 3,
				},
				{
					name = "Red Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 3,
				},
				{
					name = "Yellow Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 3,
				},
				{
					name = "Blue Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 2,
				},
				{
					name = "Green Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 2,
				},
				{
					name = "Purple Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 2,
				},
				{
					name = "Red Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 2,
				},
				{
					name = "Yellow Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 2,
				},
			},
			 endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,2,1,0,1,1,0,1,1},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "FourSpots2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
				},
			},
		},
		goals = {
			main = {"getGem",30,"Bomb","Bombs",{turnsToLoss = true},"Defuse"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["CrateDropper"] = {
		levelName = "Warehouse",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true, --already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Crate",
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,1,0,1,1,0,1},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Checkers",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = { --Barrels
					patternName = "DoubleLine",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					applyIsGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelsOfCrazy_pattern"] = {
		levelName = "Barrels Of Crazy",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins6 = true, --already matched Operation Easy
			largeBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 3,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 3,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 3,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 3,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 6,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 6,
				},
				{
					name = "Lava",
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
					weight = 12,
				},
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 12,
				},
				{ 
					name = "Crate",
					matchFlags = 0,
					specials = CascadePieceSpecials_Crates,
					weight = 6,
				},
				{ 
					name = "Stone",
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					weight = 6,
                    skinVariant = "Stone",
                    extraHits = 1,
				},
				{ 
					name = "Treasure",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 6,
				},
				{
					name = "Horizontal Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Jail 1",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
				{
					name = "Jail 2",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
				{
					name = "Jail 3",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
				{
					name = "Jail 4",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
				{
					name = "Vines 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
				{
					name = "Vines 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
				{
					name = "Vines 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
				{
					name = "Vines 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
				{
					name = "Bomb 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
				{
					name = "Bomb 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
				{
					name = "Bomb 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
				{
					name = "Bomb 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 6.5, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
			endGameProperties = {
				spawnGemOnBreak = 
				{
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 3,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 3,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 3,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 3,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 6,
					},
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 6,
					},
					{ 
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 12,
					},
					{ 
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 6,
					},
					{ 
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						weight = 6,
						skinVariant = "Stone",
						extraHits = 1,
					},
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
					},
					{
						name = "Horizontal Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Area Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Jail 1",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 3,
					},
					{
						name = "Jail 2",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 3,
					},
					{
						name = "Jail 3",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 3,
					},
					{
						name = "Jail 4",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 3,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "FullBoardLarge",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",3000000},
			},
		},
	},
	["BarrelsOfTreasure_boulders"] = {
		levelName = "Treasure Or Boulder?",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins6 = true,--already matched Operation Easy
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 1,

				},
				{ 
					name = "Treasure",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 1,
				},

			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,1,1},
				},
			},
		},
		goals = {
			main = {"getGem",12,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["BarrelsOfSuperWilds_jails"] = {
		levelName = "Wild Or Jail?",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
            hasJailedSquares = true,
            hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 5,
				},
				{
					name = "Jail 1",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 2",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 3",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 4",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 5",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},

			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 4, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"getGem",25,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",800000},
				[3] = {"score",2000000},
			},
		},
	},
	["TargetPractice"] = {
		levelName = "Target Practice",
		introScript = "Land12_Tip1",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins6 = true,--already matched Operation Easy
			largeBoard = true,
			gemTypes5 = true,
            hasCoverage = true,
            hasBarrelsOfFun = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Targets_Blank", 
				isPatternSet = false,
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 5.5, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Targets_Targets",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},
	["LavaSeeds_Updated"] = {
		levelName = "Lava Seeds",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			regularBoard = true,
			gemTypes5 = true,
            hasBarrelsOfFun = true,
            hasLava = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 11* 0.75, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Lava",
					matchFlags = 0,
					specials = CascadePieceSpecials_Lava,
					weight = 11,
				},
			},
		},
		goals = {
			main = {"finish",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
	["ExplodingLava"] = {
		levelName = "Exploding Lava",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
            hasLava = true,
            hasBombs = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "ExplodingLava_Empty", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "ExplodingLava_Lava",
					isPatternSet = false,
                    applyMatchFlags = true,
					matchFlags = 0,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
                    applyTurnsToLoss = true,
                    turnsToLoss = 20,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{turnsToLoss = true},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},
	["DoubleBreakout"] = {
		levelName = "Double Breakout",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins8 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
            hasBarrelsOfFun = true,
            hasJailedSquares = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			spawnGemOnBreak = {
				{ 
					name = "Color1Jail",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Jailed,
                    cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
				{ 
					name = "Color2Jail",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Jailed,
                    cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
				{ 
					name = "Color3Jail",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Jailed,
                    cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
				{ 
					name = "Color4Jail",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Jailed,
                    cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
				{ 
					name = "Color5Jail",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_Jailed,
                    cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "DoubleBreakout_Everything",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    applyIsGemSpawner = true,
					isGemSpawner = true,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
	},
	["TonsOfTreasure"] = {
		levelName = "Tons of Treasure",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins6 = true, --7 before Operation Easy (lowered)
			regularBoard = true,
			gemTypes4 = true,
            hasChests = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			addToBoardPieceMix = {
				{
					name = "Treasure Chest",
					matchFlags = 0,
					weight = 8, 
					specials = CascadePieceSpecials_Treasure,
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Tower2_block1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[2] = {
					patternName = "Tower1_block1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = {
					patternName = "BombVines1_inner1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[4] = {
					patternName = "BombVines1_inner2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[5] = {
					patternName = "BombVines1_inner3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[6] = {
					patternName = "BombVines1_inner4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
			},
		},
		goals = {
			main = {"getGem",40,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},
	["SecureAmmunition"] = {
		levelName = "Secure Munitions",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			largeBoard = true,
			gemTypes5 = true,
            hasBarrelsOfFun = true,
			hasJailedSquares = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 5.5, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "AmmoBoard", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "AmmoJails1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					matchRequirement = 2,
					applyMatchRequirement = true,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[2] = {
					patternName = "AmmoJails2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					matchRequirement = 2,
					applyMatchRequirement = true,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[3] = {
					patternName = "AmmoJails3",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					matchRequirement = 2,
					applyMatchRequirement = true,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[4] = {
					patternName = "AmmoJails4",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					matchRequirement = 2,
					applyMatchRequirement = true,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[5] = {
					patternName = "AmmoJails5",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					matchRequirement = 2,
					applyMatchRequirement = true,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[6] = {
					patternName = "AmmoBombs1",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[7] = {
					patternName = "AmmoBombs2",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[8] = {
					patternName = "AmmoBombs3",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[9] = {
					patternName = "AmmoBombs4",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				[10] = {
					patternName = "AmmoBombs5",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",200000},
			},
		},
	},
	["WildJungle_Updated"] = {
		levelName = "The Wild Jungle",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes5 = true,
            hasBarrelsOfFun = true,
			hasVines = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "WildJungle1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyIsGemSpawner = true,
                    isGemSpawner = false,
				},
				[2] = {
					patternName = "WildJungle2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyIsGemSpawner = true,
                    isGemSpawner = false,
				},
				[3] = {
					patternName = "WildJungle3",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyIsGemSpawner = true,
                    isGemSpawner = false,
				},
				[4] = {
					patternName = "WildJungle4",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyIsGemSpawner = true,
                    isGemSpawner = false,
				},
				[5] = {
					patternName = "WildJungle5",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    applyIsGemSpawner = true,
                    isGemSpawner = false,
				},
				[6] = {
					patternName = "WildJungle6",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
                    applyIsGemSpawner = true,
                    isGemSpawner = false,
				},
			},
			spawnGemOnBreak = 
			{
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 5,
				},
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 6, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},
	["Terraforming"] = {
		levelName = "Terraforming",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins6 = true,--already matched Operation Easy
			largeBoard = true,
			gemTypes6 = true,
            hasBarrelsOfFun = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
		additionalInitialPatterns = {
				[1] = {
					patternName = "Terraforming",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
                    applyIsGemSpawner = true,
                    isGemSpawner = false,
				},
			},
			spawnGemOnBreak = 
			{
				{
					name = "Horizontal Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 6",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 6",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 6",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 2, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	["LavaSeeds_side"] = {
		levelName = "Barrels of Lava",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
            hasBarrelsOfFun = true,
            hasLava = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 10 * 0.75, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Lava",
					matchFlags = 0,
					specials = CascadePieceSpecials_Lava,
					weight = 11,
				},
			},
		},
		goals = {
			main = {"finish",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",170000},
				[3] = {"score",180000},
			},
		},
	},

	["BarrelsOfBombs_side"] = {
		levelName = "Barrels of Bombs",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 3,
				},
				{
					name = "Green Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 3,
				},
				{
					name = "Purple Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 3,
				},
				{
					name = "Red Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 3,
				},
				{
					name = "Yellow Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 3,
				},
				{
					name = "Blue Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 2,
				},
				{
					name = "Green Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 2,
				},
				{
					name = "Purple Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 2,
				},
				{
					name = "Red Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 2,
				},
				{
					name = "Yellow Bomb Short",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 2,
				},
			},
			 endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,2,1,0,1,1,0,1,1},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "FourSpots2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
			},
		},
		goals = {
			main = {"getGem",25,"Bomb","Bombs",{turnsToLoss = true},"Defuse"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",1200000},
			},
		},
	},

	["PottedPlants_side"] = {
		levelName = "Pruning",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
			spawnGemOnBreak =
			{
				{
					name = "Vine Blue",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Vine Green",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Vine Purple",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Vine Red",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Vine Yellow",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {2,3,4,2,3,4,3,2,4},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Sides4",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
			reelPieceMix = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 10,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 10,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 10,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 10,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 10,
                    },
                    {
                        name = "Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
                        weight = 20,
                    },
				},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",170000},
				[2] = {"score",500000},
				[3] = {"score",600000},
			},
		},
	},
	["Land12Side4_side"] = {
		levelName = "BarBarrelrels of Fun",
		resource = "GameScreen_Land12",		
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				{
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
					spawnTypes = {"Always Barrel of Fun"},
					frequencies = {0, 0, 0, 0, 0, 0, 0, 0, 0},
				}
			},
			additionalNamedMixes = {
				{
					name = "Always Barrel of Fun",
					{
						name = "Barrel",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						spawnTypes = {"Powerup"},
					},
				},
				{
					name = "Powerup",
					{
						name = "Recursive Barrel",
						weight = 3,
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						spawnTypes = {"Always Barrel of Fun"},
					},
					{
						name = "FunA",
						weight = 2,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash,
					},
					{
						name = "FunB",
						weight = 2,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash,
					},
					{
						name = "FunC",
						weight = 2,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash,
					},
				},
			},
		},
		goals = {
			main = {"getGem",250,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels},"Break"},
			stars = {
				[1] = {"score",4000000},
				[2] = {"score",12500000},
				[3] = {"score",14000000},
			},
		},
	}
})