-- Land 13: missing reels

table.insertall(LevelDefs,
{
	["SplitLevel"] = {
		levelName = "Split Level",
		introScript = "Land13_Intro",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes5 = true,
            hasMissingSquares = true,
            hasMissingReels = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingSquares = true,
            missingSquares = {
				patternName = "VerticalStripeCenterLarge", 
				isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
				patternName = "CenterReel_Large", 
				isPatternSet = false,
            },
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},
	["SideShot"] = {
		levelName = "Side Shot",
		resource = "GameScreen_Land1",
		introScript = "Land13_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins6 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes4 = true,
            hasMissingReels = true,
            hasCoverage = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "RightReels", 
				isPatternSet = false,
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "RightColumn1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "RightColumn2",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "RightColumn3",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",1500000},
				[2] = {"score",2000000},
				[3] = {"score",2500000},
			},
		},
	},
	["NarrowContinuation"] = {
		levelName = "Look Ma, No Edge",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins1 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasMissingReels = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World4Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "BottomTopRows_large",
                isPatternSet = false,
            },
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",4000000},
				[2] = {"score",6000000},
				[3] = {"score",8000000},
			},
		},
		expectedScore = 100000,
	},
	["HalfReels"] = {
		levelName = "Half Reels",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes6 = true,
            hasMissingReels = true,
            hasChests = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
		},
		boosts = World4Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "HalfReelsLarge",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "HalfReelsChestsLarge",
					isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
				},
            },
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},

	["BombColumn"] = {
		levelName = "Bomb Column",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes5 = true,
            hasMissingReels = true,
            hasBombs = true,
            hasStones = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
		},
		boosts = World4Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "CenterReel_Large",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BombColumn Walls",
					isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
                [2] = {
					patternName = "BombColumn Bomb1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                },
                [3] = {
					patternName = "BombColumn Bomb2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 16,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                },
                [4] = {
					patternName = "BombColumn Bomb3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 17,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                },
                [5] = {
					patternName = "BombColumn Bomb4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 18,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                },
                [6] = {
					patternName = "BombColumn Bomb5",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 19,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                },
                [7] = {
					patternName = "BombColumn Bomb6",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                },
                [8] = {
					patternName = "BombColumn Bomb7",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 21,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                },
                [9] = {
					patternName = "BombColumn Bomb8",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 22,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                },
            },
		},
		goals = {
			main = {"getGem",8,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},"Defuse"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},
	["BurstReels"] = {
		levelName = "Burst Reels",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes5 = true,
            hasTripleStones = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BurstReels",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "BurstReels_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[3] = {
					patternName = "BurstReels_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[4] = {
					patternName = "BurstReels_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[5] = {
					patternName = "BurstReels_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[6] = {
					patternName = "BurstReels_Color5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
			},
            reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 3,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 3,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 3,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 3,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 3,
				},
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Blue Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},
	["LavaTide_Updated"] = {
		levelName = "Lava Tide",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			regularBoard = true,
			gemTypes4 = true,
            hasMissingReels = true,
            hasLava = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "RightReels", 
				isPatternSet = false,
            },
			useMissingSquares = true,
            missingSquares = {
				patternName = "TopRightCorner", 
				isPatternSet = false,
            },

			additionalInitialPatterns = { 
				[1] = {
					patternName = "RightColumn1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				[2] = {
					patternName = "RightColumn2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				[3] = {
					patternName = "RightColumn3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",1500000},
			},
		},
	},
	["MiniCascade"] = {
		levelName = "Mini Cascade",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins6 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes4 = true,
            hasMissingReels = true,
			hasMissingSquares = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
		},
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels",
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "Border",
                isPatternSet = false,
            },
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},
	["RemoteJungle"] = {
		levelName = "Remote Jungle",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
            hasMissingReels = true,
            hasVines = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "CenterStripe_Reels", 
				isPatternSet = false,
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CenterStripe",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},
	["Snake"] = {
		levelName = "Snake",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes3 = true,
            hasMissingSquares = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingSquares = true,
            missingSquares = {
				patternName = "SnakeMissing", 
				isPatternSet = false,
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "SnakePresent",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 3,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",250000},
			},
		},
	},
	["Swimming"] = {
		levelName = "White Water",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes5 = true,
            hasMissingReels = true,
			hasMissingSquares = true,
			hasBarrels = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
		},
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "SideCols",
                isPatternSet = false,
            },
			addToBoardPieceMix = {
				{
					name = "2-hit boulder",
					extraHits = 1,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 5,
				},
				{
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 5,
				},
			},
		},
		goals = {
			main = {"getGem",40,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels, extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",400000},
				[3] = {"score",550000},
			},
		},
		expectedScore = 100000,
	},
	["JungleRace"] = {
		levelName = "Jungle Race",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins4 = true,--5 before Operation Easy
			largeBoard = true,
			gemTypes5 = true,
			hasVines = true,
			hasBombs = true,
			hasTripleStones = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
		},
		boosts = World13Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Pyramid",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
				},
				[2] = {
					patternName = "Pyramid_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[3] = {
					patternName = "Pyramid_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[4] = {
					patternName = "Pyramid_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[5] = {
					patternName = "Pyramid_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[6] = {
					patternName = "Pyramid_Color5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[7] = {
					patternName = "SideSeeds_bomb",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
					applyExtraHits = true,
					extraHits = 2,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Bomb","Bombs",{specials = CascadePieceSpecials_Stone, extraHits = 0,},"Defuse"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",400000},
				[3] = {"score",550000},
			},
		},
		expectedScore = 100000,
	},
	["StepByStep"] = {
		levelName = "Step by Step",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins4 = true,--5 before Operation Easy
			largeBoard = true,
			gemTypes5 = true,
            hasMissingReels = true,
			hasMissingSquares = true,
			hasChests = true,
			hasCrates = true,
			hasTripleStones = true,
			hasSteel = true,
			hasJailedSquares = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
		},
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "StepByStep_Absent",
                isPatternSet = false,
            },
			spawnGemOnBreak = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 11,
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StepByStep_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[2] = {
					patternName = "StepByStep_Crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "StepByStep_Barrels",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				[4] = {
					patternName = "StepByStep_TripleStones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				[5] = {
					patternName = "StepByStep_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[6] = {
					patternName = "StepByStep_Jails",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["Columns"] = {
		levelName = "Split Columns",
		resource = "GameScreen_Land1",
		introScript = "Land13_Tip2",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes4 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "Columns_Reels",
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "BombColumn Walls",
                isPatternSet = false,
            },
            reelPieceMix = {
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 4,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",430000},
				[2] = {"score",480000},
				[3] = {"score",530000},
			},
		},
	},
	["Breakout"] = {
		levelName = "Strata",
		resource = "GameScreen_Land1",
		outtroScript = "Land13_Outtro",
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy
			largeBoard = true,
			gemTypes4 = true,
			hasMissingReels = true,
			hasCrates = true,
			hasJailedSquares = true,
			hasVines = true,
			hasLava = true,
			hasTripleStones = true,
			hasCoverage = true,
			hasBarrels = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Breakout_VinesAndPattern",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				[2] = {
					patternName = "Breakout_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Breakout_Boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
				},
				[4] = {
					patternName = "Breakout_Jails",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
				[5] = {
					patternName = "Breakout_TripleStones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				[6] = {
					patternName = "Breakout_Crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",3000000},
			},
		},
	},

	["SplitLevel_side"] = {
		levelName = "Split Clouds",
		--introScript = "Land13_Intro",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes5 = true,
            hasMissingSquares = true,
            hasMissingReels = true,
			hasCoverage = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingSquares = true,
            missingSquares = {
				patternName = "VerticalStripeCenterLarge", 
				isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
				patternName = "CenterReel_Large", 
				isPatternSet = false,
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "SplitLevel_side_pattern",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["HalfReels_side"] = {
		levelName = "Between the Lines",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasMissingReels = true,
            hasChests = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
		},
		boosts = World4Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "HalfReelsLarge",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "HalfReels_side_pattern",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
            },
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",3200000},
			},
		},
		expectedScore = 100000,
	},

	["JungleRace_side"] = {
		levelName = "Tick Tick Boom?",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasVines = true,
			hasBombs = true,
			hasTripleStones = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
		},
		boosts = World13Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Pyramid_side",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
				},
				[2] = {
					patternName = "SideSeeds_bomb_side",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = true,
					turnsToLoss = 27,
					applyExtraHits = true,
					extraHits = 2,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",2,"Bomb","Bombs",{specials = CascadePieceSpecials_Stone, extraHits = 0,},"Defuse"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["Land13Side4_side"] = {
		levelName = "Treasure Tower",
		resource = "GameScreen_Land12",		
		Features = {
			splashMode = true,
			modeSpins2 = true,
			largeBoard = true,
			gemTypes3 = true,
			hasBombs = true,
			hasStones = true,
			hasJailedSquares = true,
			hasMissingReels = true,
		},
		tricks = {
			{name = Config.World13Tricks_Trick1},
			{name = Config.World13Tricks_Trick2},
			{name = Config.World13Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "13-4_Treasure",
				isPatternSet = false,
            },
			addToBoardPieceMix = {
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1.0,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1.0,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1.0,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "13-4_Treasure",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,

					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "13-4_Rocks",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,

					applyExtraHits = true,
					extraHits = 2,

					applyMatchFlags = true,
					matchFlags = 0,

					applyTurnsToLoss = true,
					turnsToLoss = 6,
				},
				{
					patternName = "13-4_Orange",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,

					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed_ColorKeyGem,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,

					applyTurnsToLoss = true,
					turnsToLoss = 10,
				}
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{matchFlags = 0, specials = CascadePieceSpecials_Treasure}, "Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1800000},
				[3] = {"score",1900000},
			},
		},
	}
})