-- Land 14: vine generators

table.insertall(LevelDefs,
{
	["StemTheTide"] = {
		levelName = "Stem the Tide",
		resource = "GameScreen_Land14",
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes4 = true,
			hasVineGenerators = true,
			hasStones = true,
			hasJailedSquares = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "StemTide_Missing", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StemTide_Stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "StemTide_VineGenerator",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "StemTide_Splash1",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[4] = {
					patternName = "StemTide_Splash2",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[5] = {
					patternName = "StemTide_Splash3",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[6] = {
					patternName = "StemTide_Jail1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyMatchRequirement = true,
				},
				[7] = {
					patternName = "StemTide_Jail2",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",275000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["Deforestation"] = {
		levelName = "Deforestation",
		resource = "GameScreen_Land14",
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Deforestation_VineGenerator",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			spawnGemOnBreak = 
			{
				{
					name = "Horizontal Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Horizontal Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Area Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 2, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"getGem",25,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},"Clear"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",700000},
				[3] = {"score",900000},
			},
		},
	},
   
	["VineGrowerTest"] = {
		levelName = "Germination",
		resource = "GameScreen_Land14",	
		introScript = "Land14_Intro",	
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins5 = true, --6 before Operation Easy
			gemTypes5 = true,
			hasVineGenerators = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "MissingSides1_spots1",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["Squeeze"] = {
		levelName = "Squeeze",
		resource = "GameScreen_Land14",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			hasVineGenerators = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels",
                isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "SideCols_small",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000,
	},

	["TripleTimeThreat"] = {
		levelName = "No Pressure",
		resource = "GameScreen_Land14",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins6 = true,--7 before Operation Easy
			gemTypes5 = true,
			hasVineGenerators = true,
			hasBombs = true,
			hasLava = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "ReelPosition1",
                isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "LeftColumnLarge",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
				},
				{
					patternName = "RightColumnLarge",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
				},
			},
			additionalRegularPlacements = {
				{ 
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 15,
					frequencies = {0,1,1,1,2,2,3,3,3,3},
					isPatternSet = false,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},"Defuse"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",700000},
			},
		},
		expectedScore = 100000,
	},

	["VineGrowerTreasure"] = {
		levelName = "Undergrowth",
		resource = "GameScreen_Land14",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins7 = true,--8 before Operation Easy
			gemTypes5 = true,
			hasVineGenerators = true,
			hasChests = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "Dungeon2_bombs2",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{ 
					patternName = "TopShelf_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 7,
				},
			},
		},
		goals = {
			main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["EmptySpacesVineGenerator"] = {
		levelName = "Greenhouse",
		resource = "GameScreen_Land14",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins6 = true,--7 before Operation Easy
			gemTypes5 = true,
			hasVineGenerators = true,
			hasCoverage = true,
			hasJailedSquares = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "LowerLine1",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Line4",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "LowerLine2",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "LowerLine3",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},

	["VineGrowerBombs"] = {
		levelName = "Bomb Box",
		resource = "GameScreen_Land14",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins5 = true,
			gemTypes5 = true,
			hasVineGenerators = true,
			hasMissingSquares = true,
			hasCrates = true,
			hasBombs = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Sides1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "Row5Center",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "BottomBox",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 18,
				},
				{
					patternName = "SideCrates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",400000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["VineGrowerStone"] = {
		levelName = "Plant Box",
		resource = "GameScreen_Land14",	
		introScript = "Land14_Tip1",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins9 = true,--10 before Operation Easy
			gemTypes5 = true,
			hasVineGenerators = true,
			hasStones = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "HolePunch",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "MiddleSquare",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},

	["Grove"] = {
		levelName = "Grove",
		resource = "GameScreen_Land14",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins4 = true,--5 before Operation Easy
			gemTypes4 = true,
			hasMissingSquares = true,
			hasVines = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "CornerBoxBorders_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "CornerBox_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},

	["Vinewheel"] = {
		levelName = "Corner Creep",
		resource = "GameScreen_Land14",	
		outtroScript = "Land14_Outtro",
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins5 = true,--6 before Operation Easy
			gemTypes3 = true,
			hasVineGenerators = true,
			hasMissingSquares = true,
			hasVines = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Propeller_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "PropellerSides_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "LargeCorners",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "VineGrower",
					applySkinVariant = true,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 2.5,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines, skinVariant = "Default"},},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},

	["BombBarrels"] = {
		levelName = "Ticking Barrels",
		resource = "GameScreen_Land14",
		introScript = "Land14_Tip2",
		Features = {
			splashMode = true,
			modeSpins8 = true, --9 before Operation Easy
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
			hasBombs = true,
			hasStones = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Stone",
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "FullBoardSmall",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 10, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					turnsToLoss = 7,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BurstCollector"] = {
		levelName = "Burst Collector",					
		resource = "GameScreen_Land14",		
		Features = {
			modeSpins2 = true,
			gemTypes4 = true,
			splashMode = true,
			regularBoard = true,
		},
		tricks = {
			{name = Config.World14Tricks_Trick1},
			{name = Config.World14Tricks_Trick2},
			{name = Config.World14Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		Properties = {
		},
		goals = {
			main = {"getGem",19,"Burst","Bursts",
				{
					{specials = CascadePieceSpecial_HorizontalSplash,},
					{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash,},
					{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_AreaSplash,},
					{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash +  CascadePieceSpecial_AreaSplash,},
					{specials = CascadePieceSpecial_VerticalSplash,},
					{specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,},
					{specials = CascadePieceSpecial_AreaSplash,},
				},
				"Trigger",
			},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",5000000},
			},
		},
	},

	["Multibomb"] = {
		levelName = "Minefield",
		resource = "GameScreen_Land14",
		Features = {
			splashMode = true,
			modeSpins7 = true,--8 before Operation Easy
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
			hasBombs = true,
			hasChests = true,
			hasBarrels = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Bomb 1",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Bomb 2",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Bomb 3",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Bomb 4",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Bomb 5",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 1,
				},
			},
			endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
			additionalInitialPatterns = {
				[1] = {
					applyTurnsToLoss = true,
					patternName = "StripesAndColumns_alt1",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 18,
					isPatternSet = false,
					applyPieceSpecials = true,
				},
			},
			additionalRegularPlacements = {
				{
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 18,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
				{ 
					matchFlags = 0,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
					turnsToLoss = 12,
                    frequencies = {2,4,6,8,10},
				},
				{ 
					matchFlags = 0,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
					turnsToLoss = 12,
                    frequencies = {2,4,6,8,10},
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					turnsToLoss = 8,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
		},

		goals = {
			main = {"getGem",40,"Bomb","Bombs",
				{
					{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},
					{specials = CascadePieceSpecials_Treasure,},
					{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels, extraHits = 0,}
				},
				"Defuse"
			},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},

	["CornerVineGenerator"] = {
		levelName = "Funnel",
		resource = "GameScreen_Land14",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins5 = true, --6 before Operation Easy
			gemTypes4 = true,
			hasVineGenerators = true,
			hasJailedSquares = true,
			hasCrates = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "TopRow4",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "VineGrower",
					applySkinVariant = true,
				},
				{
					patternName = "TopRow5",
					isPatternSet = false,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					applyPieceSpecials = true,
					matchFlags = 0,
				},
				{
					patternName = "InverseLine2",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				{
					patternName = "InverseStairMini",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
				{
					patternName = "TopRow23",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},

		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",700000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000,
	},

	["VineGrowerTest_side"] = {
		levelName = "Green Cover",
		resource = "GameScreen_Land14",	
		--introScript = "Land14_Intro",	
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins6 = true,
			gemTypes5 = true,
			hasVineGenerators = true,
			hasCoverage = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "MissingSides1_spots1",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "VineGrowerTest_pattern",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",10000},
				[2] = {"score",30000},
				[3] = {"score",60000},
			},
		},
		expectedScore = 100000,

	},

	["EmptySpacesVineGenerator_side"] = {
		levelName = "Shrubbery",
		resource = "GameScreen_Land14",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins4 = true,
			gemTypes4 = true,
			hasVineGenerators = true,
			hasCoverage = true,
			hasJailedSquares = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "LowerLine1",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Line4",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "LowerLine2",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "LowerLine3",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",1300000},
			},
		},
		expectedScore = 100000,
	},

	["BombBarrels_side"] = {
		levelName = "Falling Skies",
		resource = "GameScreen_Land14",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
			hasBombs = true,
			hasStones = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Stone",
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 0,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "FullBoardSmall",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 10, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					turnsToLoss = 8,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",700000},
			},
		},
	},
	
	["Land14Side4_side"] = {
		levelName = "Vine Harvest",
		resource = "GameScreen_Land14",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World14Tricks,
		boosts = World14Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "14-4_Reel",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "14-4_Steel",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					
					applyMatchFlags = true,
					matchFlags = 0,

					applyTurnsToLoss = true,
					turnsToLoss = 35,
				},
				{
					patternName = "14-4_Rocks",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					
					applyMatchFlags = true,
					matchFlags = 0,

					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "14-4_Rainbow",
					isPatternSet = false,
					
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
				},
				{
					patternName = "14-4_VineGen",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_VineGenerator,
					
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,

					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Vine","Vines",{specials = CascadePieceSpecials_Vines},"Harvest"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",700000},
			},
		},
	},
})