-- Land 15: coconuts, 4-hit stone

table.insertall(LevelDefs,
{
	["CoconutTest"] = {
		levelName = "Coconuts",
		introScript = "Land15_Intro",
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins6 = true,--7 before Operation Easy
			gemTypes6 = true,
			splashMode = true,
			regularBoard = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Horizontal Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 6",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 6",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 6",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Spots1",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",250000},
				[3] = {"score",450000},
			},
		},
	},

	["CoconutOrange"] = {
		levelName = "Hidden Oranges",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins6 = true,--7 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 11,
				},

			},
			additionalInitialPatterns = { 
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["4StoneTest"] = {
		levelName = "Fortress",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins9 = true,--10 before Operation Easy
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,
			hasChests = true,
			hasMissingSquares = true,
			hasStones = true,
			hasBombs = true,
			hasBarrelsOfFun = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Blue Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
			},
			useMissingSquares = true,
            missingSquares = {
                patternName = "MidColsAlt",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{ 
					patternName = "TopCorners_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyTurnsToLoss = true,
					turnsToLoss = 35,
				},
				{
					patternName = "SidesAlt",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,2,2,1,2,1,3,3},
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",500000},
				[3] = {"score",600000},
			},
		},
	},

	["CoconutsAnd4Stone"] = {
		levelName = "Stone Islands",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
			},
			useMissingSquares = true,
            missingSquares = {
                patternName = "SidesBottomShifted",
                isPatternSet = false,
            },
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "Dungeon2_bombs2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
                    frequencies = {1,3,5,7,9,10},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["DiagonalDig"] = {
		levelName = "Diagonal Dig",	
		introScript = "Land15_Tip1",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes4 = true,
			splashMode = true,
			regularBoard = true,
		},
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "InverseStairLower",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				{
					patternName = "Top2MinusRight",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},

	["DoubleBombPressure"] = {
		levelName = "Double Bomb Pressure",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins6 = true,--7 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "ScatterNoBottom",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyTurnsToLoss = true,
					turnsToLoss = 18,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,2,3,3,2,3,3,4},
					applyTurnsToLoss = true,
					turnsToLoss = 18,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",250000},
				[3] = {"score",350000},
			},
		},
	},

	["UpAndDown"] = {
		levelName = "Up and Down",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins4 = true,--5 before Operation Easy
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
					specials = CascadePieceSpecial_VerticalSplash,
				},
			},
			useMissingSquares = true,
            missingSquares = {
                patternName = "BlankTopCols",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "StoneCols",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 0,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "CoconutCols",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["CoconutLava"] = {
		levelName = "Coconuts of Fire",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins6 = true,--7 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Lava",
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
					weight = 1,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "ScatterNoBottom2",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,2,2,3,4},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",500000},
				[3] = {"score",900000},
			},
		},
	},

	["VineChestCoconut"] = {
		levelName = "Entanglement",					
		resource = "GameScreen_Land15",	
		outtroScript = "Land15_Outtro",	
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Vine 1",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Vine 2",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Vine 3",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Vine 4",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},

			},
			additionalInitialPatterns = { 
				{
					patternName = "BigBottomColumn1",
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				{
					patternName = "BigBottomColumn2",
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				{
					patternName = "BigBottomColumn3",
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				{
					patternName = "BigBottomColumn4",
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				{
					patternName = "BigBottomColumn5",
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				{
					patternName = "BigBottomColumn6",
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				{
					patternName = "BigBottomColumn7",
					applyPieceSpecials = true,
					specials = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {0,4,2,2},
				},
				[2] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
                    frequencies = {1,4,8,6,6},
				},
			},
		},
		goals = {
			main = {"getGem",8,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",1200000},
			},
		},
	},

	["RockinTree"] = {
		levelName = "Rockin' Tree",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins6 = true,--7 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
		},

		Properties = {
			useMissingSquares = true,
            missingSquares = {
                patternName = "TopRock_space",
                isPatternSet = false,
            },
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
					specials = CascadePieceSpecial_VerticalSplash,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Tree2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "TopRock",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "Tree2_hanging",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
                    frequencies = {1,3,5,7,9,10},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Crate","Crates",{specials = CascadePieceSpecials_Crates},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},
	
	["BuriedTreasure"] = {
		levelName = "Buried Treasure",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
			hasStones = true,
			hasSteel = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 5,
				},
			},
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_leftSide",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "BuriedTreasure_LeftColumn_top",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					applyIsGemSpawner = true,
					isGemSpawner = false,
				},
				{
					patternName = "BuriedTreasure_LeftColumn_side",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "BuriedTreasure_LeftColumn_bottom",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,3,5,7,9,10},
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure, isGemSpawner = false},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

	["SkyTop"] = {
		levelName = "Sky Top",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			hasStones = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 5,
				},
			},
			useMissingSquares = true,
            missingSquares = {
                patternName = "SkyTop_empty",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "SkyTop_pattern",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "SkyTop_blockers1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "SkyTop_blockers2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "SkyTop_blockers3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "SkyTop_blockers4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 0,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
                    frequencies = {1,3,5,7,9,10},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",110000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
	
	["BadCoconut"] = {
		levelName = "Bad Coconut",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			hasStones = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Vine 1",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Vine 2",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Vine 3",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Vine 4",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
			},

			additionalInitialPatterns = { 
				{
					patternName = "BadCoconut_drop1",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{
					patternName = "BadCoconut_bottom1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "BadCoconut_pattern1",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "BadCoconut_pattern1",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
                    frequencies = {1,3,5,7,9,10},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",75000},
				[3] = {"score",200000},
			},
		},
	},
	
	["CoconutsVerseLava"] = {
		levelName = "Coconuts VS. Lava",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins7 = true,--8 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "CoconutVersesLava_stone1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 0,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "CoconutVersesLava_stone2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "CoconutVersesLava_stone3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				{
					patternName = "CoconutVersesLava_stone4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "CoconutVersesLava_lava1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "CoconutVersesLava_pattern1",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,3,5,7,9,10},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",600000},
			},
		},
	},
	["BarrelsOfCoconuts"] = {
		levelName = "Barrels Of Coconuts",
		resource = "GameScreen_Land15",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy
			hasCoverage = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				--[[
				{
					name = "Orange Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				--]]
				{
					name = "Blue Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				--[[
				{
					name = "Orange Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				--]]
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				--[[
				{
					name = "Orange Area",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				--]]
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 5,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,2,3,1,2,3},
				},
				[2] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,2,3,1,2,3},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "FullBoardSmall",
					isPatternSet = false,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000,
	},

	["CoconutTest_side"] = {
		levelName = "Coconutty",
		--introScript = "Land15_Intro",
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins7 = true,
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
			hasCoverage = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{

				{
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},


				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				
				{
					name = "Vertical Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				
			},
			additionalInitialPatterns = { 
				{
					patternName = "CoconutTest_side_pattern",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{
					patternName = "CoconutTest_side_pattern",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			--main = {"getGem",20,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",750000},
			},
		},
	},

	["BadCoconut_side"] = {
		levelName = "Good Coconut",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins6 = true,
			gemTypes5 = true,
			splashMode = true,
			hasStones = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Horizontal Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
			},

			additionalInitialPatterns = { 
				{
					patternName = "BadCoconut_drop1",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{
					patternName = "BadCoconut_bottom1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				--[[
				{
					patternName = "BadCoconut_pattern1",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				--]]
				{
					patternName = "BadCoconut_pattern1",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
                    frequencies = {1,4,7,10,11,12},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",250000},
				[3] = {"score",1300000},
			},
		},
	},

	["SkyTop_side"] = {
		levelName = "Open Sky",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins6 = true,
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,	--7x8
			hasStones = true,
		},
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 5,
				},
			},
			useMissingSquares = true,
            missingSquares = {
                patternName = "SkyTop_side_empty",
                isPatternSet = false,
            },
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "SkyTop_side_pattern",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				{
					patternName = "SkyTop_side_blockers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				--[[{
					patternName = "SkyTop_blockers2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "SkyTop_blockers3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "SkyTop_blockers4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 0,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				--]]
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
                    frequencies = {1,3,5,7,9,10},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",2400000},
			},
		},
	},

	["Land15Side4_side"] = {
		levelName = "Coconut Canopy",					
		resource = "GameScreen_Land15",		
		Features = {
			modeSpins7 = true,
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
			hasCoconuts = true,
			hasVines = true,
		},
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "15-4_Vines",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,

					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
				{
					patternName = "15-4_Coconuts",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Coconut,

					applyMatchFlags = true,
					matchFlags = 0,

					applySpawnTypes = true,
					spawnTypes = {"CoconutDrop"},
				},
			},
			additionalNamedMixes = {
				{
					name = "CoconutDrop",
					{
						name = "VSplash",
						weight = 1,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash,
					},
				},
			},
		},
		goals = {
			main = {"getGem",5,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",275000},
				[3] = {"score",700000},
			},
		},
	},
})