-- Land 16: amber

table.insertall(LevelDefs,
{
	["MatrioshkaBursts"] = {
		levelName = "Matrioshka Bursts",
		resource = "GameScreen_Land16",
		Features = {
			modeSpins5= true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 5, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
			spawnGemOnBreak = 
			{
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Blue Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Green Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Purple Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Red Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Yellow Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",1200000},
				[2] = {"score",1500000},
				[3] = {"score",1800000},
			},
		},
	},

	["AmberTest"] = {
		levelName = "Blocks of Amber",
		introScript = "Land16_Intro",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "AboveAboveLittleBottom1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Line",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				{
					patternName = "UpperLine3",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				{
					patternName = "LittleBottom2",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Amber","Ambers",{specials = CascadePieceSpecials_Amber},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",800000},
			},
		},
	},
	["AmberTreasure"] = {
		levelName = "Treasures in Amber",
		resource = "GameScreen_Land16",		
		introScript = "Land16_Tip2",
		Features = {
			modeSpins6 = true,--7 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "Middle5Stripes2",
					isPatternSet = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				{
					patternName = "Middle5Stripes",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure | CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_treasure,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",15,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["AmberRing"] = {
		levelName = "Pipeline",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins7 = true,--8 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "OuterTube", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				{
					patternName = "OuterRing_large_noTop",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Amber","Ambers",{specials = CascadePieceSpecials_Amber},},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",100000},
				[3] = {"score",150000},
			},
		},
	},

	["SuperwildBreakout"] = {
		levelName = "Superwild Breakout",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
			hasAmber = true,
			hasJailedSquares = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "SWBO_Amber",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber + CascadePieceSpecial_ClearKeyColorOnMatch,
				},
				{
					patternName = "SWBO_Oranges",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",150000},
				[3] = {"score",400000},
			},
		},
	},

	["TickingAmber"] = {
		levelName = "Trapped Bombs",
		introScript = "Land16_Tip1",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels", 
				isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "Columns",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				{
					patternName = "AmberBombsB1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "AmberBombsB2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "AmberBombsG",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "AmberBombsY",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				{
					patternName = "AmberBombsR1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "AmberBombsR2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "AmberBombsP",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{turnsToLoss = true,},"Defuse"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["Checkers"] = {
		levelName = "Checkers",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins7 = true,
			gemTypes6 = true,--already matched Operation Easy
			splashMode = true,
			largeBoard = true,
			hasCrates = true,
			hasAmber = true,
			hasJailedSquares = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "Checkers_Amber",
					isPatternSet = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "Checkers_Jails",
					isPatternSet = false,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "Checkers_Crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",750000},
			},
		},
	},
	["Layers"] = {
		levelName = "Geology",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "MiddleRing_large",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				{
					patternName = "InnerRing_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "InnerHole_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "OuterRing_large",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",250000},
			},
		},
	},
	 
	["AmberPool"] = {
		levelName = "Amber Pool",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins6 = true,--7 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "LittleCornerBox",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "CornerAngle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "CornerAngleSmall",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",500000},
			},
		},
	},

	["AmberBoulders"] = {
		levelName = "Rocks in Amber",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins6 = true,--7 before Operation Easy
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Col6_large",
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "Reels67", 
				isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "Col7_boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					applyExtraHits = true,
				},
				{
					patternName = "Col7_amber",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels | CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_boulder,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",
			{
				{specials = CascadePieceSpecials_Barrels,},
				{specials = CascadePieceSpecials_Barrels | CascadePieceSpecials_Amber,},
			},
			"Break"},
			stars = {
				[1] = {"score",3000000},
				[2] = {"score",4000000},
				[3] = {"score",5000000},
			},
		},
	},

	["CoconutKnockdown"] = {
		levelName = "Coconut Knockdown",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
			hasCoconuts = true,
			hasStones = true,
			hasAmber = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Stone",
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					weight = 1,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "CoconutKnockdown",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber_treasure + CascadePieceSpecials_Coconut,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber_treasure,
					applyMatchFlags = true,
					matchFlags = 0,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"getGem",10,"Stone","Stones",{specials = CascadePieceSpecials_Stones, extraHits = 0,skinVariant = "Stone", },"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",250000},
				[3] = {"score",550000},
			},
		},
	},
	["TimedExcavation"] = {
		levelName = "Timed Excavation",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins5 = true,--6 before Operation Easy
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
			hasCrates = true,
			hasBarrels = true,
			hasAmber = true,
			hasJailedSquares = true,
			hasStones = true,
			hasVines = true,
			hasBombs = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "TimedExcavation_Vines",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyTurnsToLoss = true,
					turnsToLoss = 30,
				},
				{
					patternName = "TimedExcavation_TripleStones",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "TimedExcavation_Jails",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed - CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 23,
				},
				{
					patternName = "TimedExcavation_Boulders",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyExtraHits = true,
					extraHits = 1,
					applyTurnsToLoss = true,
					turnsToLoss = 22,
				},
				{
					patternName = "TimedExcavation_Amber",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber_bomb + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyTurnsToLoss = true,
					turnsToLoss = 21,
				},
				{
					patternName = "TimedExcavation_Crates",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{turnsToLoss = true,},"Defuse"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},
	["Impurities"] = {
		levelName = "Impurities",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins1 = true,
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,
		},
		tricks = {
			{name = Config.World16Tricks_Trick1},
			{name = Config.World16Tricks_Trick2},
			{name = Config.World16Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World16Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 7,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 7,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 7,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 7,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 1,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",3000000},
			},
		},
	},
	["AmberRainbow"] = {
		levelName = "Amber Rainbow",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins10 = true,--11 before Operation Easy
			gemTypes6 = true,
			splashMode = true,
			largeBoard = true,
			hasJailedSquares = true,
			hasAmber = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "AmberRainbow_Amber",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "AmberRainbow_Jails",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "AmberRainbow_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "AmberRainbow_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "AmberRainbow_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "AmberRainbow_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "AmberRainbow_Color5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				{
					patternName = "AmberRainbow_Color6",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},
	["CornersAndMid"] = {
		levelName = "Corners and Middle",
		resource = "GameScreen_Land16",		
		outtroScript = "Land16_Outtro",
		Features = {
			modeSpins6 = true,
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
			hasMissingSquares = true,
			hasBarrels = true,
			hasAmber = true,
			hasSteel = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "CornersAndMid_Missing",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "CornersAndMid_Boulders",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "CornersAndMid_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "CornersAndMid_Amber",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber + CascadePieceSpecial_HorizontalSplash,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
				},
				{
					patternName = "CornersAndMid_AreaAmber",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber + CascadePieceSpecial_AreaSplash,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["AmberTest_side"] = {
		levelName = "Rows of Amber",
		--introScript = "Land16_Intro",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins8 = true,
			gemTypes5 = true,
			splashMode = true,
			regularBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "AmberTest_side_pattern2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},

				{
					patternName = "AmberTest_side_pattern3",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				{
					patternName = "AmberTest_side_pattern1",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Amber","Ambers",{specials = CascadePieceSpecials_Amber},},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",400000},
				[3] = {"score",1100000},
			},
		},
	},

	["Checkers_side"] = {
		levelName = "Chess",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins7 = true,
			gemTypes6 = true,
			splashMode = true,
			largeBoard = true,
			hasCrates = true,
			hasAmber = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "Checkers_side_amber",
					isPatternSet = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "Checkers_side_crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					--applyMatchRequirement = true,
					--matchRequirement = 2,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 5,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 5,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 5,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 5,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 5,
				},
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Blue Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 5,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",1300000},
			},
		},
	},
	["AmberPool_side"] = {
		levelName = "Amber Moat",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins7 = true,
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
		},
		tricks = World16Tricks,
		boosts = World16Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "AmberPool_side_amber",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "AmberPool_side_stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "AmberPool_side_crates",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},
	
	["Land16Side4_side"] = {
		levelName = "Amber Clog",
		resource = "GameScreen_Land16",		
		Features = {
			modeSpins1 = true,
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,
			hasAmber = true,
		},
		tricks = {
			{name = Config.World16Tricks_Trick1},
			{name = Config.World16Tricks_Trick2},
			{name = Config.World16Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World16Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "PurpleAmber",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 2,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
				},
				{
					name = "GreenAmber",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 2,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
				},
				{
					name = "RedAmber",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 2,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
				},
				{
					name = "OrangeAmber",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 2,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
				},
				{
					name = "RainbowAmber",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 5,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
				},
			},
		},
		goals = {
			main = {"getGem",50,"Amber","Ambers",{specials = CascadePieceSpecials_Amber},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",900000},
			},
		},
	},
})