-- Land 17: colored barrels, fences

table.insertall(LevelDefs,
{
	["ColoredBarrelTreasure"] = {
		levelName = "Treasure Barrels",
		introScript = "Land17_Intro",	
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{ 
					name = "Treasure",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {0,1,1,2,3,4,5},
					matchFlags = 31,
					anyOneMatchFlag = true,
				},
			},
		},
		goals = {
			main = {"getGem",15,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",600000},
			},
		},
	},

	["BarrelReel"] = {
		levelName = "Reel Crazy",
		outtroScript = "Land17_Outtro",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
            reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 5,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 5,
				},
				{
					name = "Lava",
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
					weight = 12,
				},
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 12,
				},
				{ 
					name = "Crate",
					matchFlags = 0,
					specials = CascadePieceSpecials_Crates,
					weight = 6,
				},
				{ 
					name = "Stone",
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					weight = 6,
                    skinVariant = "Stone",
                    extraHits = 1,
				},
				{ 
					name = "Treasure",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 6,
				},
				{
					name = "Horizontal Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Jail 1",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 2",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 3",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 4",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 5",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Vines 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1,
				},
				{
					name = "Vines 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1,
				},
				{
					name = "Vines 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1,
				},
				{
					name = "Vines 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1,
				},
				{
					name = "Bomb 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
				{
					name = "Bomb 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
				{
					name = "Bomb 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
				{
					name = "Bomb 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
				{
					name = "Bomb 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
					weight = 1.5,
				},
				{
					name = "Blue Amber",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 2,
				},
				{
					name = "Green Amber",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 2,
				},
				{
					name = "Purple Amber",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 2,
				},
				{
					name = "Red Amber",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 2,
				},
				{
					name = "Yellow Amber",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 2,
				},
				{
					name = "Super Wild Amber",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 2,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",950000},
				[2] = {"score",1300000},
				[3] = {"score",1600000},
			},
		},
	},

	["BarrelReel2"] = {
		levelName = "Barrel Jails",
		introScript = "Land17_Tip2",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
            reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 10,
				},
			},
			spawnGemOnBreak = {
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 12,
				},
				{
					name = "Jail 1",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
				{
					name = "Jail 2",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
				{
					name = "Jail 3",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
				{
					name = "Jail 4",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
				{
					name = "Jail 5",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 3,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",400000},
				[3] = {"score",700000},
			},
		},
	},

	["ImpossibleBarrels"] = {
		levelName = "Impossible Barrels",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 5,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},

			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 16,
					weight = 2,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"getGem",25,"Yellow","Yellows",{matchFlags = CascadeMatchFlags_CommonPiece5, isGemSpawner = false},},
			stars = {
				[1] = {"score",2000000},
				[2] = {"score",3000000},
				[3] = {"score",3500000},
			},
		},
	},

	["FenceTest"] = {
		levelName = "Fences",
		introScript = "Land17_Tip1",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes3 = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Line3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					applyExtraHits = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",1500000},
				[2] = {"score",2500000},
				[3] = {"score",3500000},
			},
		},
	},

	["FencePatterns"] = {
		levelName = "Corral",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "MissingMiddleLargeReels", 
				isPatternSet = false,
            },
			spawnGemOnBreak = {
				{
					name = "Horizontal Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Area Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {1,1,1,1},
					matchFlags = 15,
					anyOneMatchFlag = true,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Corral",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "CorralCenter",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",700000},
			},
		},
	},

	["Firecracker"] = {
		levelName = "Long Fuse",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "InnerL", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_leftSide", 
				isPatternSet = false,
            },
			spawnGemOnBreak = 
			{
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			additionalInitialPatterns = { 
				{ --Barrels
					patternName = "BorderColor1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{ --Barrels
					patternName = "BorderColor2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{ --Barrels
					patternName = "BorderColor3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{ --Barrels
					patternName = "BorderColor4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					applyIsGemSpawner = true,
				},
				{ --Barrels
					patternName = "BorderColor5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					applyIsGemSpawner = true,
				},
				{
					patternName = "Bin4_Bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					applyTurnsToLoss = true,
					turnsToLoss = 40,
				},
				{
					patternName = "AboveBottomCorner",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},

		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{turnsToLoss = true},"Defuse"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["LavaTube"] = {
		levelName = "Lava Tube",					
		resource = "GameScreen_Land17",	
		Features = {
			largeBoard = true, 
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "MissingMiddleLargeReels", 
				isPatternSet = false,
            },
			spawnGemOnBreak = 
			{
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				--[[
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				--]]
			},
			additionalInitialPatterns = {
				{
					patternName = "FenceTube",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "FenceTube_bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{ 
					patternName = "FenceTube_top",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					--applyTurnsToLoss = true,
					--turnsToLoss = 40,
				},
			},	
			additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {1,1,1,1},
					matchFlags = 15,
					anyOneMatchFlag = true,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	["TreasureCave"] = {
		levelName = "Treasure Cave",					
		resource = "GameScreen_Land17",	
		Features = {
			largeBoard = true, 
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true, 
			treasureChest = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			--[[
			useMissingSquares = true,
			missingSquares = {
				patternName = "Slanted_TopWedge", 
				isPatternSet = false,
			},
			--]]
			spawnGemOnBreak = 
			{
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {1,1,3},
					matchFlags = 31,
					anyOneMatchFlag = true,
				},
			},

			additionalInitialPatterns = { 
				{ 
					patternName = "Slanted_BottomWedge_top",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					--applyTurnsToLoss = true,
					--turnsToLoss = 40,
				},
				{
					patternName = "Slanted_BottomWedge_inner",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Slanted_BottomWedge_cover",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "Slanted_TopWedge",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
	},

	["BurstChest"] = {
		levelName = "Burst Chests",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSteel = true,
			hasChests = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			gemsMoveDiagonally = false,
			additionalRegularPlacements = {
				[1] = {
					specials = CascadePieceSpecials_Treasure + CascadePieceSpecial_AreaSplash,
                    frequencies = {1,2,3,4,5,6,7,8,9,},
					matchFlags = 0,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "BurstChests_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "BurstChests_PatternMid",
					isPatternSet = false,
					clearPieces = true,
					applyMatchRequirement = true,
					matchRequirement = 5,
				},
				{
					patternName = "BurstChests_PatternOutside",
					isPatternSet = false,
					clearPieces = true,
					applyMatchRequirement = true,
					matchRequirement = 5,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",450000},
				[2] = {"score",750000},
				[3] = {"score",900000},
			},
		},
	},

	["RubeMachine"] = {
		levelName = "Rube Machine",					
		resource = "GameScreen_Land17",	
		Features = {
			largeBoard = true, 
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true, 
			hasCrates = true,
			hasSteel = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "MissingLargeSideReels", 
				isPatternSet = false,
            },
			useMissingSquares = true,
			missingSquares = {
				patternName = "RubeMachine_missing", 
				isPatternSet = false,
			},
			spawnGemOnBreak = 
			{
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 4,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 4,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 4,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 4,
				},
				{
					name = "Blue Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "RubeMachine_piece1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},				
				{
					patternName = "RubeMachine_piece2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "RubeMachine_gem1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					patternName = "RubeMachine_gem2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				{
					patternName = "RubeMachine_gem3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				{ 
					patternName = "RubeMachine_gem4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					--applyTurnsToLoss = true,
					--turnsToLoss = 40,
				},
				{
					patternName = "RubeMachine_gem5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{ --Barrels
					patternName = "RubeMachine_leftcol",
					isPatternSet = false,
					applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},	
			additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {1,1,1,1},
					matchFlags = 15,
					anyOneMatchFlag = true,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",900000},
				[2] = {"score",950000},
				[3] = {"score",1000000},
			},
		},
	},

	["PatternVille"] = {
		levelName = "PatternVille",				
		resource = "GameScreen_Land17",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			hasCoverage = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 2,
				},
				{
					name = "Stone",
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					weight = 6,
				},
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 6,
					isGemSpawner = false,
				},
				{
					name = "Crate",
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					weight = 6,
				},
			},


			additionalInitialPatterns = { 
				{
					patternName = "PatternVille",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				--[[
				{
					patternName = "PatternVille_1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{
					patternName = "PatternVille_2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{
					patternName = "PatternVille_3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{
					patternName = "PatternVille_4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{
					patternName = "PatternVille_5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				{
					patternName = "PatternVille_6",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				--]]
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
	},

	["SuperWildHunt2"] = {
		levelName = "Super Wild Hunt",					
		resource = "GameScreen_Land17",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1,
                },
                {
                    name = "Yellow",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1,
                },
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 2,
				},
			},

			additionalInitialPatterns = {
				{
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "CornerSteel_topRight_inside",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "CornerSteel_bottomLeft_inside",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "CornerSteel_bottomRight_inside",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "CornerSteel_topRight_inside",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "CornerSteel_bottomLeft_inside",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "CornerSteel_bottomRight_inside",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "CornerSteel_topLeft",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},	
				{
					patternName = "CornerSteel_topRight",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},	
				{
					patternName = "CornerSteel_bottomLeft",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},	
				{
					patternName = "CornerSteel_bottomRight",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},	
			},
			additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {1,1,1,1,1,1},
					matchFlags = 15,
					anyOneMatchFlag = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
	},

	["OneColorReels"] = {
		levelName = "Two Color Reels",					
		resource = "GameScreen_Land17",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			gemTypes3 = true,
			regularBoard = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 2,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "FullBoardSmall",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 3,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},
	["BarrelsInBarrels"] = {
		levelName = "___Barrels in Barrels",
		resource = "GameScreen_Land17",		
		Features = {
			splashMode = true,
			modeSpins10 = true,
			gemTypes5 = true,
			largeBoard = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
		spawnGemOnBreak = 
			{
				{
                    name = "Blue Barrel",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 4,
                },
				{
                    name = "Red Barrel",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 4,
                },
				{
                    name = "Purple Barrel",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 4,
                },
				{
                    name = "Green Barrel",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 4,
                },
				{
                    name = "Yellow Barrel",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 4,
                },
				{
                    name = "Blue Burst",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
                },
				{
                    name = "Red Burst",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
                },
				{
                    name = "Yellow Burst",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
                },
				{
                    name = "Green Burst",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
                },
				{
                    name = "Purple Burst",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
                },
			},
			additionalInitialPatterns = {
				{
					patternName = "Barrel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Barrel","Barrels",{specials = CascadePieceSpecials_ColorBarrels},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

	["ColoredBarrelTreasure_side"] = {
		levelName = "Barrel Boulder",	
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{ 
					name = "Treasure",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 1.5,
				},
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {0,0,1,1,2,3,4},
					matchFlags = 31,
					anyOneMatchFlag = true,
				},
			},
		},
		goals = {
			main = {"getGem",10,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",700000},
				[3] = {"score",800000},
			},
		},
	},

    ["FenceTest_side"] = {
		levelName = "Barrel-O'-Ffencive",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
            reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 5,
				},
			},
			spawnGemOnBreak = {
                {
					name = "1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Horizontal Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 0.75,
				},
				{
					name = "Horizontal Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 0.75,
				},
				{
					name = "Horizontal Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 0.75,
				},
				{
					name = "Horizontal Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 0.75,
				},
                {
					name = "Vertical Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 0.95,
				},
				{
					name = "Vertical Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 0.95,
				},
				{
					name = "Vertical Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 0.95,
				},
				{
					name = "Vertical Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 0.95,
				},
				{
					name = "Area Splash 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 0.85,
				},
				{
					name = "Area Splash 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 0.85,
				},
				{
					name = "Area Splash 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 0.85,
				},
				{
					name = "Area Splash 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 0.85,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Line3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone,},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["BurstChest_side"] = {
		levelName = "Choice Bursters",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSteel = true,
			hasChests = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			gemsMoveDiagonally = false,
            reelPieceMix = {
				{
					name = "Blue Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Green Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Purple Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Red Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "Wild Barrel",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 5,
				},
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 5,
				},
			},
			spawnGemOnBreak = {
				{
                    name = "Chest Burster",
					specials = CascadePieceSpecials_Treasure + CascadePieceSpecial_AreaSplash,
					matchFlags = 0,
                    weight = 1,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "BurstChests_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "BurstChests_PatternMid",
					isPatternSet = false,
					clearPieces = true,
					applyMatchRequirement = true,
					matchRequirement = 5,
				},
				{
					patternName = "BurstChests_PatternOutside",
					isPatternSet = false,
					clearPieces = true,
					applyMatchRequirement = true,
					matchRequirement = 5,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},
    ["Land17Side4_side"] = {
		levelName = "Bomb Battle",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSteel = true,
			hasBombs = true,
			hasMissingReels = true,
			hasBarrelsOfFun = true,
			hasVines = true,
			hasVineGenerators = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			gemsMoveDiagonally = false,
			useMissingReels = true,
			missingReels = {
				patternName = "17-4_Reel",
				isPatternSet = false,
			},
			additionalRegularPlacements = {
				{
					matchFlags = 0xF,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					frequencies = {0, 0},
					inactiveForInitialPlacement = false,
				},
				{
					matchFlags = 0xF,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash,
					frequencies = {10},
					inactiveForInitialPlacement = true,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "17-4_Steel",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,

					--applyTurnsToLoss = true,
					--turnsToLoss = 60,
				},
				{
					patternName = "17-4_VineGen",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_VineGenerator,
					
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,

					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "17-4_Fence",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
				},
				{
					patternName = "17-4_Hp1",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4, 

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applySpawnTypes = true,
					spawnTypes = {"Double Boulder"},
				},
				{
					patternName = "17-4_Hp2",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6, 

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applySpawnTypes = true,
					spawnTypes = {"Double Boulder"},
				},
				{
					patternName = "17-4_Hp3",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5, 

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applySpawnTypes = true,
					spawnTypes = {"Double Boulder"},
				},
				{
					patternName = "17-4_Hp4",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2, 

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applySpawnTypes = true,
					spawnTypes = {"Double Boulder"},
				},
				{
					patternName = "17-4_Hp5",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1, 

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applySpawnTypes = true,
					spawnTypes = {"Double Boulder"},
				},
				{
					patternName = "17-4_Hp6",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3, 

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applySpawnTypes = true,
					spawnTypes = {"Double Boulder"},
				},
				{
					patternName = "17-4_Boss",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover,

					applyTurnsToLoss = true,
					turnsToLoss = 70,
				},
				{
					patternName = "17-4_Weapon",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash,
				},
			},
			additionalNamedMixes = {
				{
					name = "Double Boulder",
					{
						weight = 1,
						specials = CascadePieceSpecials_Barrels,
						matchFlags = 0,
						extraHits = 1,
					},
				},
			},
		},
		goals = {
			main = {"getGem",1,"Bomb","Bombs",{matchFlags = CascadeMatchFlags_CommonPiece6, specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",800000},
				[3] = {"score",2000000},
			},
		},
	},
})