-- Land 18: makers

table.insertall(LevelDefs,
{
	["OrangeChute"] = {
		levelName = "Maker's Dozen",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasOrangeGems = true,
			hasMakers = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "OrangeChute_blanks", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_leftSide", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Always Orange",
					delay = 0,
					{
						name = "Orange",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece6,
					},
				},
				[2] = {
					name = "Some Horizontal",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Some Horizontal",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Orange"},
				},
				[2] = {
					patternName = "RubeMachine_gem3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Some Horizontal"},
				},
			},
		},
		goals = {
			main = {"getGem",13,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6}},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",1000000},
				[3] = {"score",1400000},
			},
		},
	},

	["CrazyMakers"] = {
		levelName = "Crazy Makers",
		resource = "GameScreen_Land18",
		outtroScript = "Land18_Outtro",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasCrates = true,
			hasAmber = true,
			hasJailedSquares = true,
			hasLava = true,
			hasChests = true,
			hasVines = true,
			hasStones = true,
			hasBombs = true,
			hasMakers = true,
			hasBarrels = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Crazy Mix",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 5,
					},
					{
						name = "Lava",
						specials = CascadePieceSpecials_Lava,
						matchFlags = 0,
						weight = 1,
					},
					{ 
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 12,
					},
					{ 
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 6,
					},
					{ 
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						weight = 6,
						skinVariant = "Stone",
						extraHits = 1,
					},
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
					},
					{
						name = "Horizontal Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Area Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Jail 1",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 2,
					},
					{
						name = "Jail 2",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 2,
					},
					{
						name = "Jail 3",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 2,
					},
					{
						name = "Jail 4",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 2,
					},
					{
						name = "Vines 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = .5,
					},
					{
						name = "Vines 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = .5,
					},
					{
						name = "Vines 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = .5,
					},
					{
						name = "Vines 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = .5,
					},
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 2.25,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 2.25,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 2.25,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 2.25,
					},
					{
						name = "Blue Amber",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2.25,
					},
					{
						name = "Green Amber",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2.25,
					},
					{
						name = "Purple Amber",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2.25,
					},
					{
						name = "Red Amber",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2.25,
					},
					{
						name = "Super Wild Amber",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch + CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Crazy Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CrazyMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Crazy Mix"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},
	["BlockedTubes"] = {
		levelName = "Blocked Tubes",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasChests = true,
			hasCrates = true,
			hasMakers = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Crates and Chests",
					delay = 0,
					{ 
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 7.5,
					},
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2.5,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BombPattern1_top",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Crates and Chests"},
				},
			},
		},
		goals = {
			main = {"getGem",8,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	["Rube2"] = {
		levelName = "Goldberg's Revenge",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasChests = true,
			hasStones = true,
			hasMakers = true,
			hasFences = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasSteel = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "RubeMissing", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "RubeReels", 
				isPatternSet = false,
            },
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Vertical",
						delay = -1,
					},
					[2] = {
						name = "Horizontal",
						delay = -1,
					},
					[3] = {
						name = "Area Burst",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Vertical",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
				},
				[2] = {
					name = "Horizontal",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
				},
				[3] = {
					name = "Area Burst",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
				},
				[4] = {
					name = "Regular Mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "RubeMakersRegular",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix"},
				},
				[2] = {
					patternName = "RubeMakersA",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Area Burst"},
				},
				[3] = {
					patternName = "RubeMakersH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Horizontal"},
				},
				[4] = {
					patternName = "RubeMakersV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Vertical"},
				},
				[5] = {
					patternName = "RubeSteel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[6] = { 
					patternName = "RubeChest",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				[7] = {
					patternName = "RubeStone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[8] = {
					patternName = "RubeFences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				[9] = {
					patternName = "RubePlaceH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				[10] = {
					patternName = "RubePlaceV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				[11] = {
					patternName = "RubePlaceA",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_AreaSplash,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
	},

	["BombChutes"] = {
		levelName = "Bomb Chutes",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBombs = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasMakers = true,
			hasBarrels = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "ChuteBombsMissing", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_Large", 
				isPatternSet = false,
            },
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Bomb Mix",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Bomb Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
							reset = true,
						},
					},
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 1.5,
					},
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 1.5,
					},
					{
						name = "Bomb Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels + CascadePieceSpecial_Valuable,
						turnsToLoss = 20,
						weight = 1.5,
					},
				},
				[2] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BombChutes",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix", "Normal mix"},
				},
			[2] = {
					patternName = "ChuteBombs",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
			},
		},
		goals = {
			main = {"getGem",15,"Bomb","Bombs",
				{
					{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},
					{specials = CascadePieceSpecials_Barrels + CascadePieceSpecial_Valuable},
				}
				,"Defuse"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},
	["AmberMakers"] = {
		levelName = "Patterns in Amber",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins8 = true,--6 before
			largeBoard = true,
			gemTypes6 = true,
			hasAmber = true,
			hasMakers = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasCoverage = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "AmberPatternMissing", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "2LeftReels", 
				isPatternSet = false,
            },
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Super Wilds",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Amber Mix",
					delay = 0,
					{
						name = "Blue Amber",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
					{
						name = "Green Amber",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
					{
						name = "Purple Amber",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
					{
						name = "Red Amber",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
					{
						name = "Yellow Amber",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
					{
						name = "Orange Amber",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
				},
				[2] = {
					name = "Super Wilds",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							newDelay = 0,
							cooldown = 1,
							gemType = {
								matchFlags = CascadeMatchFlags_Wildcard,
							},
						},
					},
					{
						name = "Super Wild Amber",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch + CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Leftcol_1mod3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Amber Mix"},
				},
				[2] = {
					patternName = "Leftcol_2mod3",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "RubeMachine_gem3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Super Wilds"},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",600000},
				[3] = {"score",750000},
			},
		},
	},

	["CoconutFall"] = {
		levelName = "Coconut Fall",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasCoconuts = true,
			hasVines = true,
			hasSteel = true,
			hasMakers = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Vine 1",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Vine 2",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Vine 3",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Vine 4",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Vine 5",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 1,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Coconuts",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
							reset = true,
						},
					},
					{ 
						name = "Coconut",
						matchFlags = 0,
						specials = CascadePieceSpecials_Coconut,
						weight = 8,
						isGemSpawner = true,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "TopCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Coconuts"},
				},
				[3] = {
					patternName = "Row2Mids",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[4] = {
					patternName = "SidesRow3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[5] = {
					patternName = "AroundTopSideCorners_inner",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"getGem",8,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	["ThinkBig"] = {
		levelName = "Think Big",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasChests = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "One more normal gem A",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[2] = {
					name = "One more normal gem B",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[3] = {
					name = "One more normal gem C",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[4] = {
					name = "One more normal gem D",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[5] = {
					name = "One more normal gem E",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[6] = {
					name = "One more normal gem F",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[7] = {
					name = "One more normal gem G",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[8] = {
					name = "One more normal gem H",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[9] = {
					name = "One more normal gem I",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[10] = {
					name = "One more normal gem J",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[11] = {
					name = "Infinite normal gems",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[12] = {
					name = "Two Chests Ever A",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = false,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
				},
				[13] = {
					name = "Two Chests Ever B",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = false,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
				},
				[14] = {
					name = "Two Chests Ever C",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = false,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
				},
				[15] = {
					name = "Two Chests Ever D",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = false,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
				},
				[16] = {
					name = "Two Chests Ever E",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = false,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
				},
				[17] = {
					name = "Two Chests Ever F",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = false,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Two Chests Ever A",
						delay = -1,
					},
					[2] = {
						name = "Two Chests Ever B",
						delay = -1,
					},
					[3] = {
						name = "Two Chests Ever C",
						delay = -1,
					},
					[4] = {
						name = "Two Chests Ever D",
						delay = -1,
					},
					[5] = {
						name = "Two Chests Ever E",
						delay = -1,
					},
					[6] = {
						name = "Two Chests Ever F",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Line8_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {
						"One more normal gem A",
						"One more normal gem B",
						"One more normal gem C",
						"One more normal gem D",
						"One more normal gem E",
						"Two Chests Ever A",
						"One more normal gem F",
						"Two Chests Ever B",
						"One more normal gem G",
						"Two Chests Ever C",
						"One more normal gem H",
						"Two Chests Ever D",
						"One more normal gem I",
						"Two Chests Ever E",
						"One more normal gem J",
						"Two Chests Ever F",
						"Infinite normal gems",
					},
				},
			},
		},
		goals = {
			main = {"getGem",12,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",450000},
				[2] = {"score",600000},
				[3] = {"score",900000},
			},
		},
	},
	["Scarcity"] = {
		levelName = "Scarcity",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasCoverage = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Scarce Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 4,
							newDelay = 1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 8,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Line8_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Scarce Mix"},
				},
				[2] = {
					patternName = "Line7_large",
					isPatternSet = false,
					clearPieces = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
	["SpaceCrunch"] = {
		levelName = "Space Crunch",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMakers = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Make More Makers",
					delay = 8,
					events = { --Make 1 maker every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
							reset = true,
						},
					},
					{
						name = "Maker",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						spawnBelowTypes = {"Make More Makers","Four Color Mix",},
						weight = 1,
					},
				},
				[2] = {
					name = "Four Color Mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Steel,
					spawnBelowTypes = {"Make More Makers","Four Color Mix",},
                    frequencies = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,},
				},
			},
		},
		goals = {
			main = {"finish",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",600000},
				[3] = {"score",700000},
			},
		},
	},
	["Stripes"] = {
		levelName = "Stripes",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasFences = true,
			hasChests = true,
			hasBarrels = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "Reels67", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Stripe 1",
					delay = 0,
					cooldowns = {0},
					events = {
						[1] = {
							eventType = "getGem",
							newDelay = 4,
							cooldown = 4,
							gemType = {
							},
						},
						[2] = {
							eventType = "emitCount",
							newDelay = -1,
							count = 10,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
				},
				[2] = {
					name = "Stripe 2",
					delay = 1,
					cooldowns = {1},
					events = {
						[1] = {
							eventType = "getGem",
							newDelay = 4,
							cooldown = 4,
							gemType = {
							},
						},
						[2] = {
							eventType = "emitCount",
							newDelay = -1,
							count = 10,
							reset = true,
						},
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
				},
				[3] = {
					name = "Stripe 3",
					delay = 2,
					cooldowns = {2},
					events = {
						[1] = {
							eventType = "getGem",
							newDelay = 4,
							cooldown = 4,
							gemType = {
							},
						},
						[2] = {
							eventType = "emitCount",
							newDelay = -1,
							count = 10,
							reset = true,
						},
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
				},
				[4] = {
					name = "Stripe 4",
					delay = 3,
					cooldowns = {3},
					events = {
						[1] = {
							eventType = "getGem",
							newDelay = 4,
							cooldown = 4,
							gemType = {
							},
						},
						[2] = {
							eventType = "emitCount",
							newDelay = -1,
							count = 10,
							reset = true,
						},
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
				[5] = {
					name = "Stripe 5",
					delay = 4,
					cooldowns = {4},
					events = {
						[1] = {
							eventType = "getGem",
							newDelay = 4,
							cooldown = 4,
							gemType = {
							},
						},
						[2] = {
							eventType = "emitCount",
							newDelay = -1,
							count = 10,
							reset = true,
						},
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
				},
				[6] = {
					name = "Infinite normal gems",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Line8_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Stripe 1","Stripe 2","Stripe 3","Stripe 4","Stripe 5","Infinite normal gems",},
				},
				[2] = {
					patternName = "Line7_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[3] = {
					patternName = "Line6_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[4] = {
					patternName = "Line5_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[5] = {
					patternName = "Line4_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[6] = {
					patternName = "Line3_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[7] = {
					patternName = "Line2_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[8] = {
					patternName = "Line1_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[9] = {
					patternName = "Stripes Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
				},
				[10] = {
					patternName = "RubeMachine_gem4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				[11] = {
					patternName = "RubeMachine_gem5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",450000},
				[2] = {"score",550000},
				[3] = {"score",640000},
			},
		},
	},
	["WhackARed"] = {
		levelName = "Whack A Red",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Three Reds every 4 turns",
						delay = -1,
					},
				},
			},
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Three Reds every 4 turns",
					delay = 0,
					events = {
						[2] = {
							eventType = "emitCount",
							newDelay = 2,
							count = 2,
							reset = false,
						},
						[3] = {
							eventType = "emitCount",
							newDelay = 2,
							count = 3,
							reset = true,
						},
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
				[2] = {
					name = "Infinite normal gems",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "WhackARed Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Three Reds every 4 turns"},
				},
				[2] = {
					patternName = "WhackARed Red",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Red","Reds",{matchFlags = CascadeMatchFlags_CommonPiece4},},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",450000},
				[3] = {"score",500000},
			},
		},
	},
	["PowersCombined"] = {
		levelName = "Powers Combined",
		resource = "GameScreen_Land18",
		introScript = "Land18_Tip1",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			normalBoard = true,
			gemTypes5 = true,
			hasMakers = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Bursts pretty often",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Bursts pretty often",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 4,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 4,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 4,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 4,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 4,
					},
					{
						name = "Blue Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Green Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Red Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Purple Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Yellow Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Blue Vertical",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Green Vertical",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Purple Vertical",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Red Vertical",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Yellow Vertical",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Blue Area",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Green Area",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Purple Area",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Red Area",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Yellow Area",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "PowerCombined Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bursts pretty often"},
				},
			},
		},
		goals = {
			main = {"getGem",45,"Combo Burst","Combo Bursts",
					{
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash +  CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,},
					},
					"Make",
				},
			stars = {
				[1] = {"score",2000000},
				[2] = {"score",3000000},
				[3] = {"score",3500000},
			},
		},
	},
	["MakerFloor"] = {
		levelName = "Maker Floor",
		resource = "GameScreen_Land18",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			hasChests = true,
			hasMakers = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSteel = true,
			hasFences = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			additionalNamedMixes = {
                [1] = {
                    name = "Make Chests 1",
                    delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Normal Mix 1",
							reset = true,
						},
					},
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [2] = {
					name = "Normal Mix 1",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Make Chests 1",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
				[3] = {
                    name = "Make Chests 2",
                    delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Normal Mix 2",
							reset = true,
						},
					},
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [4] = {
					name = "Normal Mix 2",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Make Chests 2",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
				[5] = {
                    name = "Make Chests 3",
                    delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Normal Mix 3",
							reset = true,
						},
					},
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [6] = {
					name = "Normal Mix 3",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Make Chests 3",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
            },
			additionalInitialPatterns = {
				{
					patternName = "Row7Evens_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
				},
				{
					patternName = "MakerFloor_maker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Chests 1","Normal Mix 1",},
				},
				{
					patternName = "MakerFloor_maker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Chests 2","Normal Mix 2",},
				},
				{
					patternName = "MakerFloor_maker3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Chests 3","Normal Mix 3",},
				},
				{
					patternName = "FourTreasures",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "Row8Evens_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",7,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",450000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},
	["MakerIntro"] = {
		levelName = "Maker Chutes",
		resource = "GameScreen_Land18",
		introScript = "Land18_Intro",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrels = true,
			hasMakers = true,
			hasMissingReels = true,
			hasMissingSquares = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
                patternName = "CenterReel_Large",
                isPatternSet = false,
            },
			useMissingSquares = true,
			missingSquares = {
				patternName = "Cols35Punch", 
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Burst Mix",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue H",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Green H",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Purple H",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Red H",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Yellow H",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
				},
				[2] = {
					name = "Boulders",
					delay = 0,
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Burst Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "TopCorners_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Burst Mix"},
				},
				[2] = {
					patternName = "BombColumn Bomb1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulders"},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",150000},
			},
		},
	},

	["MakerIntro_side"] = {
		levelName = "Tower Chutes",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrels = true,
			hasMakers = true,
			hasMissingReels = true,
			hasMissingSquares = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
                patternName = "CenterReel_Large",
                isPatternSet = false,
            },
			useMissingSquares = true,
			missingSquares = {
				patternName = "MakerIntro_side_missing", 
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Burst Mix",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue H",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Green H",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Purple H",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Red H",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Yellow H",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
				},
				[2] = {
					name = "Boulders",
					delay = 0,
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Burst Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "MakerIntro_side_pattern1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Burst Mix"},
				},
				[2] = {
					patternName = "MakerIntro_side_pattern2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulders"},
				},
			},
		},
		goals = {
			main = {"getGem",30,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

    ["OrangeChute_side"] = {
		levelName = "Burnt Crust",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasOrangeGems = true,
			hasMakers = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "OrangeChute_side_Missing",
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_leftSide", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
                {
                    name = "Lava",
                    delay = 0,
                    {
                        name = "Lava",
                        specials = CascadePieceSpecials_Lava,
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        weight = 1,
                    },
                },

				{
					name = "Always Orange",
					delay = 0,
					{
						name = "Orange",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece6,
					},
				},
				{
					name = "Some Horizontal",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Some Horizontal",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Orange"},
				},
				{
					patternName = "RubeMachine_gem3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Some Horizontal"},
				},
                {
                    patternName = "OrangeChute_side_LavaMakers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Lava"},
                },
			},
		},
		goals = {
			main = {"getGem",10,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6}},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",350000},
			},
		},
	},

    ["MakerFloor_side"] = {
		levelName = "Airstrike",
		resource = "GameScreen_Land18",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			hasChests = true,
			hasMakers = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSteel = true,
			hasFences = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
            additionalRegularPlacements = {
                {
                    name = "Bomb 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover + CascadePieceSpecial_VerticalSplash,
                    turnsToLoss = 15,
                    frequencies = {2,10,},
                },
                {
                    name = "Bomb 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover + CascadePieceSpecial_VerticalSplash,
                    turnsToLoss = 15,
                    frequencies = {3,9,},
                },
                {
                    name = "Bomb 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover + CascadePieceSpecial_VerticalSplash,
                    turnsToLoss = 15,
                    frequencies = {4,8,},
                },
                {
                    name = "Bomb 4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover + CascadePieceSpecial_VerticalSplash,
                    turnsToLoss = 15,
                    frequencies = {5,7,},
                },
                {
                    name = "Bomb 5",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover + CascadePieceSpecial_VerticalSplash,
                    turnsToLoss = 15,
                    frequencies = {1,6,},
                },
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 7,
				},
			},
			additionalNamedMixes = {
                [1] = {
                    name = "Add 3 Chests",
                    delay = -1,
                    events = {
                        [1] = {
                            eventType = "population",
                            count = 0,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 3.
                            eventType = "emitCount",
                            count = 3,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [2] = {
                    name = "Add 2 Chests",
                    delay = -1,
                    events = {
                        [1] = {
                            eventType = "population",
                            count = 1,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                               specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 3.
                            eventType = "emitCount",
                            count = 2,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [3] = {
                    name = "Add 1 Chest",
                    delay = -1,
                    events = {
                        [1] = { 
                            eventType = "population",
                            count = 2,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 3.
                            eventType = "emitCount",
                            count = 1,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [4] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
            },
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Add 3 Chests",
						delay = -1,
					},
					[2] = {
						name = "Add 2 Chests",
						delay = -1,
					},
					[3] = {
						name = "Add 1 Chest",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Row7Evens_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
				},
				{
					patternName = "Row6Evens_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Add 3 Chests","Add 2 Chests","Add 1 Chest","Normal mix",},
				},
				{
					patternName = "FourTreasures",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "Row8Evens_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",16,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",750000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},
	
	["Land18Side4_side"] = {
		levelName = "Just One Orange",
		resource = "GameScreen_Land10",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			gemsMoveDiagonally = false,
			useMissingReels = true,
			missingReels = {
				patternName = "18-4_Reel",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "18-4_Orange",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				{
					patternName = "18-4_Yellow",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				{
					patternName = "18-4_Missing",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
			},
			additionalRegularPlacements = {
				{
					matchFlags = 0xF,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					frequencies = {0, 1},
					inactiveForInitialPlacement = true,
				},
			},
			additionalNamedMixes = {
				{
					name = "SpawnOrange",
					delay = 10,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 10,
							reset = true
						},
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
			},
		},
		goals = {
			main = {"getGem",1,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},"Collect"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},
})