-- Land 19: locks

table.insertall(LevelDefs,
{
	["LockTest"] = {
		levelName = "Open Locks",					
		resource = "GameScreen_Land19",	
		introScript = "Land19_Intro",
		Features = {
			regularBoard = true,
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			hasLocks = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "ZigzagRows2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Lock","Locks",{specials = CascadePieceSpecials_Lock}},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["LockChests"] = {
		levelName = "Locked Chests",					
		resource = "GameScreen_Land19",	
		Features = {
			regularBoard = true,
			modeSpins12 = true,
			splashMode = true,
			gemTypes5 = true,
			treasureChest = true,
			hasChests = true,
			hasLocks = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "BottomZig",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "MiddleZig",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",850000},
				[3] = {"score",1500000},
			},
		},
	},

	["LockCoconuts"] = {
		levelName = "Lock Coconuts",					
		resource = "GameScreen_Land19",	
		Features = {
			regularBoard = true,
			modeSpins9 = true,
			splashMode = true,
			gemTypes5 = true,
			hasCoconuts = true,
			hasLocks = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Lock",
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock,
					weight = 11,
				},

			},
			additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,2,3,4,2,3,2,3},
				},
			},
		},		
		goals = {
			main = {"getGem",7,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},

	["LockPattern"] = {
		levelName = "Locked Pattern",					
		resource = "GameScreen_Land19",	
		Features = {
			regularBoard = true,
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			hasLocks = true,
			hasCoverage = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "XPattern",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",600000},
				[3] = {"score",900000},
			},
		},
	},

	["SkinnyLocks"] = {
		levelName = "Skinny Locks",					
		resource = "GameScreen_Land19",	
		Features = {
			regularBoard = true,
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			hasLocks = true,
			hasMissingSquares = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "EvenMids", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				{
					patternName = "OddMids",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Lock","Locks",{specials = CascadePieceSpecials_Lock},},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",350000},
				[3] = {"score",600000},
			},
		},
	},

	["ColoredBarrelLocks"] = {
		levelName = "Trapped Barrels",
		resource = "GameScreen_Land19",
		introScript = "Land19_Tip1",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
			hasLocks = true,
			hasBarrels = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					weight = 11,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "ZigzagChecks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "BarrelChecks",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lock","Locks",{specials = CascadePieceSpecials_Lock},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},

	["LockCols"] = {
		levelName = "Lock Columns",
		resource = "GameScreen_Land19",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasMakers = true,
			hasStones = true,
			hasLocks = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_Large", 
				isPatternSet = false,
            },
			useMissingSquares = true,
			missingSquares = {
				patternName = "TopCorners_large", 
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Always Locks",
					delay = 0,
					{
						name = "Lock",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Lock,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "SideCols",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "MidCols",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Umlaut Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Locks"},
				},
			},	
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone"}},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",900000},
			},
		},
	},
	["LockAmber"] = {
		levelName = "Amber Locks",					
		resource = "GameScreen_Land19",	
		Features = {
			regularBoard = true,
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			hasLocks = true,
			hasAmber = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "AmberLocks_locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock | CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_lock,
					applyCancelSpecials = true,
				},
				{
					patternName = "AmberLocks_amber",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Lock","Locks",
				{
					{specials = CascadePieceSpecials_Lock,},
					{specials = CascadePieceSpecials_Lock | CascadePieceSpecials_Amber,},
				},
			},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
	},

	["LockedGarden"] = {
		levelName = "Locked Garden",					
		resource = "GameScreen_Land19",	
		Features = {
			largeBoard = true,
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			hasChests = true,
			hasLocks = true,
			hasMakers = true,
			hasVineGenerators = true,
			hasVines = true,
			hasStones = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "AroundBottomCorners_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Row7Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock,
				},
				{
					patternName = "Dungeon2_floor1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock,
				},
				{
					patternName = "Row1Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Treasure Chest"},
				},
				{
					patternName = "BottomCorners_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Treasure Chest",
					delay = 0,
					events = { --When there are no chests, make 1 chest and then stop
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							newDelay = 1,
							cooldown = 1,
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
						},
					},
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
			},
		},		
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",2000000},
				[3] = {"score",3000000},
			},
		},
	},

	["FaultLines"] = {
		levelName = "Fault Lines",					
		resource = "GameScreen_Land19",	
		Features = {
			largeBoard = true,
			modeSpins10 = true,
			splashMode = true,
			gemTypes4 = true,
			hasStones = true,
			hasLocks = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "StackedCs",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "FaultLine_Locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock,
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",700000},
				[3] = {"score",2000000},
			},
		},
	},


	["BombLocks"] = {
		levelName = "Locks and Bombs",					
		resource = "GameScreen_Land19",	
		Features = {
			regularBoard = true,
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			hasLocks = true,
			hasBombs = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			--gemsMoveDiagonally = false,
			additionalInitialPatterns = { 
				{
					patternName = "Checkers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Checkers2",
					isPatternSet = false,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 10,
					frequencies = {1,2,3,4,5,6,7},
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},
	
	["GrowingSpace"] = {
		levelName = "Growing Space",					
		resource = "GameScreen_Land19",	
		Features = {
			regularBoard = true,
			modeSpins11 = true,
			splashMode = true,
			gemTypes4 = true,
			hasLocks = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "GrowingSpace",
					isPatternSet = false,
					specials = CascadePieceSpecials_Lock,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "GrowingSpace_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "GrowingSpace_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "GrowingSpace_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "GrowingSpace_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Lock","Locks",{specials = CascadePieceSpecials_Lock},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1300000},
				[3] = {"score",2000000},
			},
		},
	},
	
	["PandorasLocks"] = {
		levelName = "Pandora's Locks",					
		resource = "GameScreen_Land19",	
		outtroScript = "Land19_Outtro",
		Features = {
			largeBoard = true,
			modeSpins11 = true,
			splashMode = true,
			gemTypes4 = true,
			hasLocks = true,
			hasVines = true,
			hasLava = true,
			hasMakers = true,
			hasBombs = true,
			hasBarrels = true,
			hasSteel = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "PandorasLocks_Locks",
					isPatternSet = false,
					specials = CascadePieceSpecials_Lock,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "PandorasLocks_Lava",
					isPatternSet = false,
					specials = CascadePieceSpecials_Lava,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "PandorasLocks_Vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "PandorasLocks_Steel",
					isPatternSet = false,
					specials = CascadePieceSpecials_Steel,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "PandorasLocks_BombMakers",
					isPatternSet = false,
					specials = CascadePieceSpecials_Steel,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					spawnBelowTypes = {"Make Bombs"},
					applySpawnBelowTypes = true,
				},
				{
					patternName = "PandorasLocks_BoulderMaker",
					isPatternSet = false,
					specials = CascadePieceSpecials_Steel,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					spawnBelowTypes = {"Make Boulders"},
					applySpawnBelowTypes = true,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Make Bombs",
					delay = 0,
					events = { --Make 1 bomb every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue Bomb",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
					},
					{
						name = "Green Bomb",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
					},
					{
						name = "Purple Bomb",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
					},
					{
						name = "Red Bomb",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
					},
				},
				[2] = {
					name = "Make Boulders",
					delay = 0,
					{
						name = "2-hit boulder",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						extraHits = 1,
					},
					{
						name = "Boulder",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						extraHits = 0,
					},
					events = { --Make 1 boulder every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Make Bombs",
						delay = -1,
					},
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Lock","Locks",{specials = CascadePieceSpecials_Lock},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1000000},
				[3] = {"score",1700000},
			},
		},
	},
	
	["Dispensers"] = {
		levelName = "Dispensers",					
		resource = "GameScreen_Land19",	
		Features = {
			largeBoard = true,
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			hasLocks = true,
			hasMakers = true,
			hasStones = true,
			hasChests = true,
			hasFences = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Dispensers_Missing", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				{
					patternName = "Dispensers_Locks",
					isPatternSet = false,
					specials = CascadePieceSpecials_Lock,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Dispensers_Stones",
					isPatternSet = false,
					specials = CascadePieceSpecials_Stone,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Dispensers_MakeChestAndLock",
					isPatternSet = false,
					specials = CascadePieceSpecials_Steel,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					spawnBelowTypes = {"Make Chest","Make Lock",},
					applySpawnBelowTypes = true,
				},
				{
					patternName = "Dispensers_MakeStoneAndWild1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Steel,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					spawnBelowTypes = {"Make Wild","Make Stone",},
					applySpawnBelowTypes = true,
				},
				{
					patternName = "Dispensers_MakeStoneAndWild2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Steel,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					spawnBelowTypes = {"Make Wild","Make Stone",},
					applySpawnBelowTypes = true,
				},
				{
					patternName = "Dispensers_Fence",
					isPatternSet = false,
					specials = CascadePieceSpecials_Fence,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Dispensers_MakeWideVertical1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Steel,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					spawnBelowTypes = {"Make Wide Vertical 1", "Make Lock"},
					applySpawnBelowTypes = true,
				},
				{
					patternName = "Dispensers_MakeWideVertical2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Steel,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					spawnBelowTypes = {"Make Wide Vertical 2", "Make Lock"},
					applySpawnBelowTypes = true,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Make Chest",
					delay = 0,
					events = { --Make at most 1 chest at a time
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Chest",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
					},
				},
				[2] = {
					name = "Make Lock",
					delay = 0,
					--No events needed; a lock will block production of further gems
					{
						name = "Lock",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Lock,
					},
				},
				[3] = {
					name = "Make Wild",
					delay = -1,
					{
						name = "Wild 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_Wildcard,
					},
					events = { --Make one wild each time a stone is broken
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								specials = CascadePieceSpecials_Stone,
							},
						},
					},
				},
				[4] = {
					name = "Make Stone",
					delay = 0,
					{
						name = "Wild 1",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
					},
				},
				[5] = {
					name = "Make Wide Vertical 1",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Wide Vertical Blue",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
					},
				},
				[6] = {
					name = "Make Wide Vertical 2",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Wide Vertical Blue",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
					},
				},
			},
		},		
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
	},
	
	["BarrierBusting"] = {
		levelName = "Barrier Busting",					
		resource = "GameScreen_Land19",	
		Features = {
			largeBoard = true,
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
			hasStones = true,
			hasLocks = true,
			hasCrates = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Stone",
					weight = 1,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					extraHits = 1,
				},
				{
					name = "Crate",
					weight = 1.5,
					matchFlags = 0,
					specials = CascadePieceSpecials_Crates,
				},
				{
					name = "Triple Stone",
					weight = .50,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					extraHits = 2,
				},
				{
					name = "Barrel",
					weight = 3,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					spawnTypes = {"Stuff From Barrels",},
				},
				{
					name = "Normal Gem 1",
					weight = 11,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					name = "Normal Gem 2",
					weight = 11,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					name = "Normal Gem 3",
					weight = 11,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					name = "Normal Gem 4",
					weight = 11,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					name = "Normal Gem 5",
					weight = 11,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Stuff From Barrels",
					delay = 0,
					{
						name = "Triple Stone",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						extraHits = 2,
					},
					{
						name = "Lock",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Lock,
					},
					{
						name = "Vertical Burst 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
					},
					{
						name = "Vertical Burst 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
					},
					{
						name = "Vertical Burst 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
					},
					{
						name = "Vertical Burst 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
					},
					{
						name = "Vertical Burst 5",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
					},
				},
			},
		},		
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",850000},
				[2] = {"score",1500000},
				[3] = {"score",3000000},
			},
		},
	},

	["LockTest_side"] = {
		levelName = "Lock Checks",					
		resource = "GameScreen_Land19",	
		--introScript = "Land19_Intro",
		Features = {
			regularBoard = true,
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			hasLocks = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "LockTest_side_pattern1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Lock","Locks",{specials = CascadePieceSpecials_Lock}},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
	},

    ["LockedGarden_side"] = {
		levelName = "Locked Volcano",
		resource = "GameScreen_Land19",	
		Features = {
			largeBoard = true,
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			hasChests = true,
			hasLocks = true,
			hasMakers = true,
			hasStones = true,
			hasLava = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "LockedGarden_side_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Row7Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock,
				},
				{
					patternName = "Dungeon2_floor1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock,
				},
				{
					patternName = "Row1Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Treasure Chest"},
				},
				{
					patternName = "BottomCorners_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_Lava,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
                {
                    patternName = "LockedGarden_side_LavaMakers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Lava"},

                },
			},
			additionalNamedMixes = {
				{
					name = "Treasure Chest",
					delay = 0,
					events = { --When there are no chests, make 1 chest and then stop
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							newDelay = 1,
							cooldown = 1,
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
						},
					},
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
                {
                    name = "Lava",
                    delay = 0,
                    {
                        name = "Lava",
                        specials = CascadePieceSpecials_Lava,
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        weight = 1,
                    },
                },
			},
		},		
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",1000000},
				[3] = {"score",1100000},
			},
		},
	},

    ["LockChests_side"] = {
		levelName = "Between the Pins",
		resource = "GameScreen_Land19",	
		Features = {
			regularBoard = true,
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			treasureChest = true,
			hasChests = true,
			hasLocks = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "LockedChests_side_Missing",
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				{
					patternName = "LockedChests_side_Locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",1000000},
			},
		},
	},

})