-- Land 2: crates

table.insertall(LevelDefs,
{

	["HorizontalBursts"] = {
		levelName = "Boulder Stack",					
		resource = "GameScreen_Land2",	
		introScript = "Land2_Tip2",		
		onlyShowCutsceneOnce = true,
		Features = {
			modeSpins6 = true,
			splashMode = true,
			regularBoard = true,
			hasMissingSquares = true,
 			gemTypes4 = true,
			hasBarrels = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "RightColumn2", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "2RightReels", 
				isPatternSet = false,
            },
			additionalInitialPatterns =
			{
				{
					patternName = "RightColumn1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
	},

	["VerticalBursts"] = {
		levelName = "Crate Row",					
		resource = "GameScreen_Land2",	
		introScript = "Land2_Tip3",	
		onlyShowCutsceneOnce = true,	
		Features = {
			modeSpins6 = true,
			splashMode = true,
			largeBoard = true,
			hasMissingSquares = true,
 			gemTypes4 = true,
			hasCrates = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "VerticalBursts_missing", 
				isPatternSet = false,
			},
			additionalInitialPatterns =
			{
				{
					patternName = "Line2_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",5,"Crate","Crates",{specials = CascadePieceSpecials_Crates},"Break"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["SimpleCrateCoverage1"] = {
		levelName = "Crate Break",					
		resource = "GameScreen_Land1",		
		introScript = "Land2_Intro",
		Features = {
			splashMode = true,
			modeSpins11 = true, --already matched
			hasCoverage = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Inner_I",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Inner_I",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",750000},
			},
		},
	},

	["SimpleCrateCoverage2"] = {
		levelName = "Break Away!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true, --already matched
			hasCoverage = true,
			hasCrates = true,
			gemTypes5 = true, 
			regularBoard = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "MiddleRing",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "MiddleRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},

	["SimpleCrateCoverage3"] = {
		levelName = "Rock and Roll",					
		resource = "GameScreen_Land1",		
		introScript = "Land2_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins10 = true, --9 before Operation Easy
			hasCoverage = true,
			hasCrates = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "OuterRing_sides",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Line1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["CoverageEmpty1"] = {
		levelName = "Whipping Wind",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins10 = true, --already matched
			hasCoverage = true,
			hasCrates = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "MissingSides1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Stripes",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "MissingSides1_spots1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "MissingSides1_spots2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},

	["CoverageEmpty2"] = {
		levelName = "Flower Stems",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true, -- 8 before Operation Easy (lowered)
			hasCoverage = true,
			hasCrates = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Columns",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Columns_middles",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Columns_topmiddlebottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",200000},
			},
		},
	},

	["CoverageEmpty3"] = {
		levelName = "Field Of Flowers",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins6 = true, --8 before Operation Easy (lowered)
			hasCoverage = true,
			hasCrates = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			--useMissingSquares = true,
			missingSquares = {
				patternName = "Castle2", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StripesAndColumns_corners",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "StripesAndColumns_alt2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "StripesAndColumns_alt1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",200000},
			},
		},
	},

	["BigCrateBoard1"] = {
		levelName = "Big Crates!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasCrates = true,
			modeSpins8 = true, --already matched
			gemTypes5 = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = false,
			missingSquares = {
				patternName = "BigCastle1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Pile1_large",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Pile1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
	},

	["BigCrateBoard2"] = {
		levelName = "Shelves!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasCrates = true,
			hasStones = true,
			modeSpins9 = true, --already matched Operation Easy
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = false,
			missingSquares = {
				patternName = "BigCastle1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Shelves1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Shelves1_top",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Shelves1_bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},

	["BigCrateBoard3"] = {
		levelName = "Pillars!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasCrates = true,
			hasStones = true,
			hasMissingSquares = true,
			modeSpins8 = true, --already matched Operation Easy
			gemTypes5 = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = false,
			missingSquares = {
				patternName = "BigCastle1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Pillars1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Pillars1_bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Pillars1_top",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",750000},
				[3] = {"score",1000000},
			},
		},
	},

	["BigCrateBoard4"] = {
		levelName = "Castle Door",					
		resource = "GameScreen_Land1",		
		outtroScript = "Land2_Outtro",
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasCrates = true,
			hasStones = true,
			modeSpins7 = true, --10 before Operation Easy (lowered)
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "BigCastle2", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BigCastle2_windows",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "BigCastle2_door",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",160000},
				[3] = {"score",320000},
			},
		},
	},

	-- Side levels/ Secret Tunnels

	["CoverageEmpty3_side"] = {
		levelName = "Crate Field",					
		resource = "GameScreen_Land2",		
		Features = {
			splashMode = true,
			modeSpins7 = true,
			hasCoverage = true,
			hasCrates = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StripesAndColumns_corners",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "StripesAndColumns_alt2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "StripesAndColumns_alt1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 0,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

	["BigCrateBoard1_side"] = {
		levelName = "Pile of Crates",					
		resource = "GameScreen_Land2",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			regularBoard = true,
			hasCrates = true,
			modeSpins6 = true,
			gemTypes5 = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = false,
			missingSquares = {
				patternName = "BigCastle1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Pile1_regular",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["BigCrateBoard4_side"] = {
		levelName = "Enter the Castle",					
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasCrates = true,
			hasStones = true,
			modeSpins8 = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "BigCastle2", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BigCastle2_windows",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "BigCastle2_door_alt",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
	},

    ["VerticalBursts_side"] = {
        levelName = "Trench Run",               
        resource = "GameScreen_Land2",
        Features = {
            modeSpins4 = true,
            gemTypes4 = true,
            largeBoard = true,
            splashMode = true,
            hasMissingSquares = true,
            hasCrates = true,
        },
        tricks = World2Tricks,
        boosts = World2Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "Trench02",
                -- patternName = "Trench02-2", -- less constraining
                isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
                patternName = "MissingLargeSideReels", 
                isPatternSet = false,
            },
            additionalInitialPatterns = {
                {
                    patternName = "SmallColumns_Edges",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Crates,
                    matchFlags = 0,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Crate","Crates",{specials = CascadePieceSpecials_Crates,},"Break"},
            stars = {
                [1] = {"score",500000},
                [2] = {"score",700000},
                [3] = {"score",1000000},
            },
        },
    },

})