-- Land 20: double barrels, double jails

table.insertall(LevelDefs,
{
	["Barrel2Test"] = {
		levelName = "Twice the Barrel",
		resource = "GameScreen_Land12",
        introScript = "Land20_Barrel2Test_Intro",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
					extraHits = 1,
					applyExtraHits = true,
				},
			},
            endGameProperties = {
                spawnGemOnBreak = 
                {
                    {
                        name = "Super Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
                        specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                        weight = 8,
                    },
                },
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true, extraHits = 0},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1200000},
				[3] = {"score",2400000},
			},
		},
	},

    ["ItTakesTwo"] = {
		levelName = "It Takes Two",
		resource = "GameScreen_Land20",
        introScript = "Land20_Intro",
		Features = {
			hasJailedSquares = true,
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "ItTakesTwo_Jails",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},
		goals = {
			main = {"getGem",11,"Jail","Jails",{specials = CascadePieceSpecials_Jailed, extraHits = 0},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000, 
	},

    ["JailBroken4"] = {
		levelName = "Jail Broken",
		resource = "GameScreen_Land20",
        introScript = "Land20_JailBroken_Intro",
        outtroScript = "Land20_JailBroken_Outtro",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasChests = true,
            hasMakers = true,
            hasSteel = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalNamedMixes = {
				{
					name = "TreasureMix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 5,
                            newDelay = 5,
                        },
                    },
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
					},
                },
            },
            additionalInitialPatterns = {
				{
					patternName = "JailBroken2_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "JailBroken4_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
                {
					patternName = "JailBroken2_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"TreasureMix"},
				},
                {
					patternName = "JailBroken2_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
            endGameProperties = {
				additionalNamedMixes = {
					{
						name = "TreasureMix",
						delay = -1,
					},
				},
			},
		},
		goals = {
            --main = {"finish",true},
			main = {"getGem",100,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",1100000},
			},
		},
	},

    ["JailhouseRocks5"] = {
		levelName = "Jailhouse Rocks",
		resource = "GameScreen_Land20",
        --introScript = "Land20_JailhouseRocks_Intro",
        --outtroScript = "Land20_JailhouseRocks_Outtro",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes3 = true,
            hasJailedSquares = true,
            hasStones = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

                    name = "Orange",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,

					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                },
            },

            reelPieceMix = {
				{
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 3,
                },
                {
                    name = "Vertical Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 3,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 3,
                },
                {
                    name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 5,
                },
                {
                    name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 5,
                },
                {
                    name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 5,
                },
			},

            additionalRegularPlacements = {
                {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,0,1,0,2,0,2,0,3,0,3,0,0,4},
                    applyExtraHits = true,
                    extraHits = 1,
				},
			},

		},
		goals = {
            main = {"getGem",2,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",2000000},
			},
		},
	},

    ["DoNotOpen2"] = {
		levelName = "Do Not Open",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			regularBoard = true,
			gemTypes3 = true,
			hasBarrelsOfFun = true,
            treasureChest = true,
            hasBombs = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
					name = "Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 6,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				{
					extraHits = 1,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,8,64},
				},
			},
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                },
            },
		},
		goals = {
			main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",2000000},
				[3] = {"score",4000000},
			},
		},
	},

    ["DoubleQuarantine2"] = {
		levelName = "Double Quarantine",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes6 = true,
            hasJailedSquares = true,
            hasVineGenerators = true,
            hasCoverage = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "DoubleQuarantine_JailsAndWilds",
					isPatternSet = false,

                    name = "Wildcard",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_Wildcard,

					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,

				},
                {
					patternName = "DoubleQuarantine_Vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    skinVariant = "VineGrower",
                    applySkinVariant = true,

				},
                {
					patternName = "DoubleQuarantine_Lava",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
                {
					patternName = "DoubleQuarantine_Clouds",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
            main = {"patterns",0},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",500000},
			},
		},
	},

    ["BehindBars2"] = {
		levelName = "Behind Bars",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasCoverage = true,
            hasMissingReels = true,
            hasMissingSquares = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "BehindBars_Reels",
				isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
				patternName = "BehindBars2_Missing",
				isPatternSet = false,
			},
            additionalInitialPatterns = {
                {
					patternName = "BehindBars2_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "BehindBars2_1xClouds",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
                {
					patternName = "BehindBars2_2xClouds",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
            },
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",3000000},
				[3] = {"score",6000000},
			},
		},
	},

    ["HedgeTrimmers"] = {
		levelName = "Hedge Trimmers",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
            hasMissingSquares = true,
            hasMissingReels = true,
            hasVines = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Horizontal Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Horizontal Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Horizontal Splash 4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
			},
            useMissingReels = true,
            missingReels = {
				patternName = "HedgeTrimmer_Reels",
				isPatternSet = false,
            },
			additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,1,1,1},
				},
			},
            useMissingSquares = true,
			missingSquares = {
				patternName = "HedgeTrimmer_Missing",
				isPatternSet = false,
			},
            additionalInitialPatterns = {
                {
					patternName = "HedgeTrimmer_Vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
                {
					patternName = "HedgeTrimmer_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
                {
					patternName = "HedgeTrimmer_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
                {
					patternName = "HedgeTrimmer_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
                {
					patternName = "HedgeTrimmer_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
                {
					patternName = "HedgeTrimmer_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
            },

		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",600000},
			},
		},
	},

    ["DoABarrelRoll"] = {
		levelName = "Do a Barrel Roll!",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins1 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasMissingSquares = true,
		},
		tricks = {
			{name = Config.World4Tricks_Trick1},
			{name = Config.World4Tricks_Trick2},
			{name = Config.World4Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
                    name = "Barrel",
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					weight = 4,
					extraHits = 1,
					matchFlags = 0,
				},
			},
            reelPieceMix = {
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 5,
				},
			},
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
            useMissingSquares = true,
			missingSquares = {
				patternName = "DoABarrelRoll_Missing",
				isPatternSet = false,
			},
		},
		goals = {
			main = {"getGem",18,"Single Barrel","Single Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true, extraHits=0},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",150000},
			},
		},
	},

    ["JailTrimmers"] = {
		levelName = "Jail Trimmers",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
            hasMissingSquares = true,
            hasVines = true,
            hasJailedSquares,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 2,
                },
                {
                    name = "Horizontal Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 2,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Area Splash 4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
			},
            useMissingReels = true,
            missingReels = {
				patternName = "HedgeTrimmer_Reels",
				isPatternSet = false,
            },
			additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,1,1,1},
				},
			},
            useMissingSquares = true,
			missingSquares = {
				patternName = "JailTrimmer_Missing",
				isPatternSet = false,
			},
            additionalInitialPatterns = {
                {
                    patternName = "JailTrimmer_Vines",
					isPatternSet = false,

                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                },
                {
					patternName = "JailTrimmer_Vines",
					isPatternSet = false,

					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
                {
					patternName = "JailTrimmer_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
            },

		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1200000},
				[3] = {"score",1900000},
			},
		},
	},

    ["PrisonLattice"] = {
		levelName = "Prison Lattice",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
            hasMissingSquares = true,
            hasMissingReels = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            spawnGemOnBreak = {
                {
						name = "Jail 1",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						cancelSpecials = CascadePieceSpecials_Jailed,
                        applyExtraHits = true,
                        extraHits = 1,
						weight = 2,
					},
					{
						name = "Jail 2",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						cancelSpecials = CascadePieceSpecials_Jailed,
                        applyExtraHits = true,
                        extraHits = 1,
						weight = 2,
					},
					{
						name = "Jail 3",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						cancelSpecials = CascadePieceSpecials_Jailed,
                        applyExtraHits = true,
                        extraHits = 1,
						weight = 2,
					},
					{
						name = "Jail 4",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						cancelSpecials = CascadePieceSpecials_Jailed,
                        applyExtraHits = true,
                        extraHits = 1,
						weight = 2,
					},
--[[
                    {
						name = "Jail 5",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						cancelSpecials = CascadePieceSpecials_Jailed,
                        applyExtraHits = true,
                        extraHits = 1,
						weight = 2,
					},
--]]
			},
            useMissingReels = true,
            missingReels = {
				patternName = "PrisonLattice_Reels",
				isPatternSet = false,
            },
            useMissingSquares = true,
			missingSquares = {
				patternName = "PrisonLattice_Missing",
				isPatternSet = false,
			},
            additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,2,3,4},
				},
			},
            additionalInitialPatterns = {
                {
                    patternName = "PrisonLattice_Clouds",
                    isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
                },
            },

		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["PrisonersDualemma4"] = {
		levelName = "Prisoner's Dualemma",
		resource = "GameScreen_Land20",
        outtroScript = "Land20_Outtro",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            spawnGemOnBreak = {
                {
                    name = "Jail Horiz 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 2",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 3",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 4",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 5",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 2",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 3",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 4",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 5",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
			},
            additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,2,3,4,5},
				},
			},
            useMissingReels = true,
			missingReels = {
				patternName = "PrisonersDualemma_Reels",
				isPatternSet = false,
			},
            endGameProperties = {
                spawnGemOnBreak = 
                {
                    {
                        name = "Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
                        weight = 1,
                    },
                },
--[[
                additionalInitialPatterns = {
                    patternName = "SomePatternWithEverything",
                    isPatternSet = false,
                    applyExtraHits = true,
                    extraHits = 0,
                }
--]]
			},
            additionalInitialPatterns = {
                {
                    patternName = "PrisonersDualemma_Clouds",
                    isPatternSet = false,
--[[
                    matchRequirement = 2,
					applyMatchRequirement = true,
--]]
                },
                {
                    patternName = "PrisonersDualemma_Jails",
                    isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
                },
            },

		},
		goals = {
			main = {"gemsRemain",0,"Jail","Jails",{cancelSpecials = CascadePieceSpecials_Jailed},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["BailJarrel"] = {
		levelName = "Bail Jarrel",
		resource = "GameScreen_Land20",
        --introScript = "Land20_BailJarrel_Intro",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
                    name = "Jail 1",
                    specials = CascadePieceSpecials_Jailed,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail 2",
                    specials = CascadePieceSpecials_Jailed,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail 3",
                    specials = CascadePieceSpecials_Jailed,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail 4",
                    specials = CascadePieceSpecials_Jailed,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail 5",
                    specials = CascadePieceSpecials_Jailed,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
			},
			additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
					extraHits = 1,
					applyExtraHits = true,
				},
			},
		},
		goals = {
			main = {"getGem",9,"Jail","Jails",{specials = CascadePieceSpecials_Jailed, extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
	},


    ["BarreledTreasure"] = {
		levelName = "Barreled Treasure",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes3 = true,
			hasBarrelsOfFun = true,
            hasChests = true,
            hasMissingReels = true,
            hasMissingSquares = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            spawnGemOnBreak = 
			{
                {
                    name = "chest",
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
                    weight = 1,
                },
            },
            useMissingReels = true,
            missingReels = {
				patternName = "BarrelledTreasure_Reels",
				isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "BarrelledTreasure_Missing",
                isPatternSet = false,
            },
            additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,1,1,1,1,1,1,1},
					extraHits = 1,
					applyExtraHits = true,
				},
			},
            additionalInitialPatterns = {
            },
		},
		goals = {
			main = {"getGem",10,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",650000},
			},
		},
	},


    ["DoubleBarrelSlotGun"] = {
		levelName = "Double-Barrel Slot Gun",
		resource = "GameScreen_Land20",
        introScript = "Land20_MultiJailrelBlitz_Intro",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			regularBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasMakers = true,
            hasMissingReels = true,
            hasMissingSquares = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            spawnGemOnBreak = 
			{
                {
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
--[[
                {
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
--]]
            },

            additionalNamedMixes = {
				{
					name = "BarrelMix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 22,
                            newDelay = 1,
                        },
                    },
					{ 
						name = "Barrel",
						matchFlags = 0,

						applyExtraHits = true,
                        extraHits = 1,

                        applyPieceSpecials = true,
                        specials = CascadePieceSpecials_Barrels,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,

						weight = 2,
					},
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 2,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 2,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 2,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 2,
                    },
--[[
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 2,
                    },
--]]
                },
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "DoubleBarrelSlotGun_Missing",
                isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
				patternName = "DoubleBarrelSlotGun_Reels",
				isPatternSet = false,
            },
            additionalInitialPatterns = {
				{
					patternName = "DoubleBarrelSlotGun_Jails",
					isPatternSet = false,

					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,

					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "DoubleBarrelSlotGun_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"BarrelMix"},
				},
                                {
                    patternName = "DoubleBarrelSlotGun_Steel",
                    isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
                },
			},
            endGameProperties = {
                spawnGemOnBreak = 
                {
                    {
                        name = "Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
                        weight = 1,
                    },
                },
			},
            reelPieceMix = {
				{
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 2,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 2,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 2,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 2,
                },
--[[
                {
                    name = "Yellow",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 2,
                },
--]]
			},
		},
		goals = {
            --main = {"getGem",4,"Jail","Jails",{specials = CascadePieceSpecials_Jailed, extraHits = 0},"Break"},
            main = {"gemsRemain",0,"Jail","Jails",{cancelSpecials = CascadePieceSpecials_Jailed},"Break"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
	},

	 ["ItTakesTwo_side"] = {
		levelName = "Iron Wing",
		resource = "GameScreen_Land20",
		Features = {
			hasJailedSquares = true,
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "ItTakesTwo_side_pattern1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Jail","Jails",{specials = CascadePieceSpecials_Jailed, extraHits = 0},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000, 
	},

    ["DoNotOpen2_side"] = {
		levelName = "Do Not Open II",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins2 = true,
			largeBoard = true,
			gemTypes3 = true,
			hasBarrelsOfFun = true,
            hasBombs = true,
            hasCoverage = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
					name = "Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,3,5,8,64},
				},
			},
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "DoNotOpen2_side_Clouds",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
                },
            },
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["JailhouseRocks5_side"] = {
		levelName = "Jailhouse Locks",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes3 = true,
            hasJailedSquares = true,
            hasLocks = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

                    name = "Orange",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,

					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

					specials = CascadePieceSpecials_Lock,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
                },
            },

            reelPieceMix = {
				{
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 3,
                },
                {
                    name = "Vertical Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 3,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 3,
                },
                {
                    name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 5,
                },
                {
                    name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 5,
                },
                {
                    name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 5,
                },
			},

            additionalRegularPlacements = {
                {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,0,1,0,2,0,2,0,3,0,3,0,0,4},
                    applyExtraHits = true,
                    extraHits = 1,
				},
			},

		},
		goals = {
            main = {"gemsRemain",0,"Lock","Locks",{specials = CascadePieceSpecials_Lock,},"Break"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",1000000},
				[3] = {"score",1300000},
			},
		},
	},

})