-- Land 21: Cascade party, have gem goals

table.insertall(LevelDefs,
{
-------------------------
--- LAND 21, Dave -------
-------------------------

	["Battlement1"] = {
		levelName = "Battlement",					
		resource = "GameScreen_Land21",		
        introScript = "Land21_Intro",
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasStones = true,
			modeSpins6 = true,
			gemTypes4 = true,
			hasMissingSquares = true,
            hasBarrels = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Battlement1", 
				isPatternSet = false,
			},
			spawnGemOnBreak = 
			{
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Battlement1_windows",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "Battlement1_walls2_a",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "Battlement1_walls2_b",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					applyExtraHits = true,
					--isGemSpawner = true,
					--applyIsGemSpawner = true,
				},
				{
					patternName = "Battlement1_roof2",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["DropIt1"] = {
		levelName = "Drop It",					
		resource = "GameScreen_Land21",		
        introScript = "Land21_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasStones = true,
			modeSpins9 = true,
			gemTypes5 = true,
			hasMissingSquares = true,
			hasCoconuts = true,
			hasMakers = true,
			hasMissingReels = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "DropIt1", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "CenterReel_Large", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Always Orange Vertical",
					delay = 0,
					{
						name = "Orange Burst",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecial_VerticalSplash,
					},
				},
				[2] = {
					name = "Coconuts",
					delay = 0,
					events = { --When there are less than 3 coconuts, make 1 coconut and then stop
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "population",
							count = 3,
							comparator = "less",
							newDelay = 1,
							cooldown = 1,
							gemType = {
								specials = CascadePieceSpecials_Coconut,
							},
						},
					},
					{ 
						name = "Coconut",
						matchFlags = 0,
						specials = CascadePieceSpecials_Coconut,
						weight = 8,
						applyIsGemSpawner = true,
						isGemSpawner = true,
						spawnTypes = {"Always Horizontal Burst"},

					},
				},
				[3] = {
					name = "Always Horizontal Burst",
					delay = 0,
					{
						name = "Blue Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Green Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Purple Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Red Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Yellow Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					--[[
					{
						name = "Orange Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					--]]
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Coconuts",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "DropIt1_pattern_tower1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "DropIt1_pattern_tower2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "DropIt1_pattern_tower3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					--extraHits = 1,
					--applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "DropIt1_pattern_tower4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "DropIt1_pattern_tower5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{ 
					patternName = "DropIt1_chest",
					--patternName = "DropIt1_test",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Always Orange Vertical"},
				},
				{
					patternName = "DropIt1_chest",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "RubeMachine_gem3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Coconuts"},
				},
				{
					patternName = "RubeMachine_gem1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Coconuts"},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",1200000},
			},
		},
	},

	["HashTag1"] = {
		levelName = "Hash Tag Battle",					
		resource = "GameScreen_Land21",		
        introScript = "Land21_Tip2",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins7 = true,
			hasCoverage = true,
			hasCrates = true,
			gemTypes4 = true, 
			regularBoard = true,
			hasMakers = true,
			hasAmber = true,
			hasBombs = true,
			hasVines = true,
			hasJailedSquares = true,
			hasChests = true,
			hasStones = true,
			hasBarrels = true,
			hasLava = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Crazy Mix",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 5,
					},
					{
						name = "Lava",
						specials = CascadePieceSpecials_Lava,
						matchFlags = 0,
						weight = 1,
					},
					{ 
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 12,
					},
					{ 
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 6,
					},
					{ 
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						weight = 6,
						skinVariant = "Stone",
						extraHits = 1,
					},
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
					},
					{
						name = "Horizontal Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Area Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Jail 1",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 2,
					},
					{
						name = "Jail 2",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 2,
					},
					{
						name = "Jail 3",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 2,
					},
					{
						name = "Jail 4",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 2,
					},
					{
						name = "Vines 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = .5,
					},
					{
						name = "Vines 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = .5,
					},
					{
						name = "Vines 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = .5,
					},
					{
						name = "Vines 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = .5,
					},
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 2.25,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 2.25,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 2.25,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 2.25,
					},
					{
						name = "Blue Amber",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2.25,
					},
					{
						name = "Green Amber",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2.25,
					},
					{
						name = "Purple Amber",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2.25,
					},
					{
						name = "Red Amber",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2.25,
					},
					{
						name = "Super Wild Amber",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch + CascadePieceSpecials_Amber,
						cancelSpecials = CascadePieceSpecials_Amber,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Maker_TopLeft1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Crazy Mix"},
				},
				{
					patternName = "Maker_TopRight1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Crazy Mix"},
				},
				{
					patternName = "Maker_Center1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Crazy Mix"},
				},
				{
					patternName = "HashTag1",
					isPatternSet = false,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Crazy Mix",
						delay = -1,
					},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",1500000},
				[3] = {"score",2000000},
			},
		},
	},
-------------------------
--- LAND 21, Jonathan ---
-------------------------

	["PictureFrame"] = {
		levelName = "Picture Frame",
		resource = "GameScreen_Land21",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingSquares = true,
			hasCoverage = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "CenterRect",
				isPatternSet = false,
			},

            additionalInitialPatterns = {
				{
					patternName = "PictureFrame_pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 4,
				},
            },

		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",900000},
				[3] = {"score",1150000},
			},
		},
	},
	
	["BurstCrazy"] = {
		levelName = "Burst Crazy",
		resource = "GameScreen_Land21",
		Features = {
			splashMode = true,
			modeSpins3 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrels = true,
			hasBarrelsOfFun = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            endGameProperties = {

                boardPieceMix = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 11,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 11,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 11,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 11,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 11,
                    },
                },
            },
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Blue H",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green H",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple H",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red H",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow H",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Blue V",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green V",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple V",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red V",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow V",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Blue A",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green A",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple A",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red A",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow A",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Double Barrel",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					extraHits = 1,
					weight = 5,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Two-hit Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					weight = 5,
				},
			},
		},
		goals = {
			main = {"getGem",15,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,isGemSpawner = false, extraHits = 0},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",2000000},
				[3] = {"score",4000000},
			},
		},
	},

-------------------------
--- LAND 21, Naomi ------
-------------------------

  ["Persistence"] = {
		levelName = "Hit the Spot",
		resource = "GameScreen_Land21",
		introScript = "Land21_Tip6",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
			hasStones = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            spawnGemOnBreak = {
                {
                    name = "Stone",
                    weight = 2,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
                },
			},
            additionalInitialPatterns = {
				{
					patternName = "XSingleJails",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed | CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed_ColorBarrel,
					applyCancelSpecials = true,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
				},
				{
					patternName = "XDoubleJails",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed | CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed_ColorBarrel,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
				},
            },

		},
		goals = {
			main = {"getGem",11,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",250000},
				[3] = {"score",450000},
			},
		},
	},

	["VerticalHits"] = {
		levelName = "Column Mover",					
		resource = "GameScreen_Land21",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			hasCrates = true,
			hasMakers = true,
			hasSteel = true,
			gemTypes4 = true,
			largeBoard = true,
			hasMissingSquares = true,
            hasMissingReels = true,
			hasFences = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "VerticalHits_missing",
				isPatternSet = false,
			},
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalNamedMixes = {
				{
					name = "Verticals",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Verticals",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "FrameCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "Line1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "VerticalHits_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Verticals"},
				},
				{
					patternName = "VerticalHits_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Crate","Crates",{specials = CascadePieceSpecials_Crates},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",500000},
			},
		},
	},

	["Quarry"] = {
		levelName = "Quarry",
		resource = "GameScreen_Land21",
		introScript = "Land21_Tip4",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasStones = true,
			hasBarrels = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Quarry_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
			additionalRegularPlacements = {
				{ 
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
                    frequencies = {0,0,2,0,0,4},
				},
				{ 
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,0,3,0,5},
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},

		goals = {
			main = {"getGem",20,"Stone or Boulder","Stones and Boulders",
				{
					{specials = CascadePieceSpecials_Stone, extraHits = 0,},
					{specials = CascadePieceSpecials_Barrels, extraHits = 0,}
				},
				"Break"
			},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",1800000},
			},
		},
	},

	["SerialThreats"] = {
		levelName = "Serial Threats",					
		resource = "GameScreen_Land21",
		introScript = "Land21_Tip5",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			hasMakers = true,
			hasVines = true,
			hasBombs = true,
			hasLava = true,
			gemTypes4 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
                [1] = {
                    name = "Vine Mix",
                    delay = 0,
					events = {
						{
							eventType = "emitCount",
							count = 4,
							newDelay = -1,
						},
					},
					{
						name = "Vines 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Vines 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Vines 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Vines 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
                },
                [2] = {
                    name = "Always Lava",
                    delay = 0,
					events = {
						{
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
						},
					},
                    {
						name = "Lava",
						specials = CascadePieceSpecials_Lava,
						matchFlags = 0,
						weight = 12,
					},
                },
				[3] = {
                    name = "Bomb Mix",
                    delay = 0,
					events = { --Make 1 gem every move
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                    },
                    {
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1,
					},
                },
            },
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Vine Mix",
						delay = -1,
					},
					[2] = {
						name = "Always Lava",
						delay = -1,
					},
					[3] = {
						name = "Bomb Mix",
						delay = -1,
					},
				},
			},
            additionalInitialPatterns = { 
                [1] = {
                    patternName = "TopCorners",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Vine Mix","Always Lava","Bomb Mix",},
                },
            },
		},
		goals = {
			main = {"getGem",10,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},"Defuse"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",1000000},
			},
		},
	},


-------------------------
--- LAND 21, Zach -------
-------------------------

    ["Sand"] = {
		levelName = "Sand",
		resource = "GameScreen_Land21",
		introScript = "Land21_Tip3",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasBarrels = true,
            hasSteel = true,
            hasMissingSquares = true,
            hasMissingReels = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "Sand_Missing",
				isPatternSet = false,
			},
            useMissingReels = true,
            missingReels = {
                patternName = "Sand_Reels",
                isPatternSet = false,
            },
            additionalInitialPatterns = {
				{
					patternName = "Sand_Steel",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
                {
					patternName = "Sand_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulders","Gems"},
				},
            },
            additionalNamedMixes = {
				{
					name = "Boulders",
					delay = 0,
					events = { --Make 1 gems every move
						{
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
                    {
                        name = "Boulder",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        applyExtraHits = true,
                        extraHits = 1,
                        weight = 5,
                    },
				},
				{
					name = "Gems",
					delay = 0,
                    {
						name = "1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 3,
					},
                    {
						name = "2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 3,
					},
                    {
						name = "3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 3,
					},
                    {
						name = "4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 3,
					},
				},
			},
		},
		goals = {
			main = {"haveGem",12,"Boulders","Boulders",{specials = CascadePieceSpecials_Barrels,},},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",100000},
			},
		},
	},

    ["Spider"] = {
		levelName = "Spider",
		resource = "GameScreen_Land21",
        introScript = "Land21_Spider",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasLava = true,
            hasVineGenerators = true,
            hasVines = true,
            hasMissingSquares = true,
            hasMissingReels = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "Spider_Missing",
				isPatternSet = false,
			},
            useMissingReels = true,
            missingReels = {
                patternName = "Spider_Reels",
                isPatternSet = false,
            },
            additionalInitialPatterns = {
                {
                    patternName = "Spider_Vines",
					isPatternSet = false,

                    specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
                },
                {
					patternName = "Spider_Lava",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,

				},
                {
					patternName = "Spider_Steel",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,

				},
            },
		},
		goals = {
			main = {"getGem",29,"Lava or Vine","Lava and Vines",
				{
					{specials = CascadePieceSpecials_Lava,},
                    {cancelSpecials = CascadePieceSpecials_Vines,},
				},
				"Break",
			},
			stars = {
				[1] = {"score",60000},
				[2] = {"score",90000},
				[3] = {"score",200000},
			},
		},
	},

    ["BurningBush"] = {
		levelName = "Burning Bush",
		resource = "GameScreen_Land21",
        introScript = "Land21_BurningBush",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasLava = true,
            hasMissingSquares = true,
            hasMissingReels = true,
            hasVines = true,
            hasVineGenerators = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "BurningBush_Reels",
				isPatternSet = false,
            },
            useMissingSquares = true,
			missingSquares = {
				patternName = "BurningBush_Missing",
				isPatternSet = false,
			},
            additionalInitialPatterns = {
                {
					patternName = "BurningBush_Vines",
					isPatternSet = false,

					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
                {
					patternName = "BurningBush_Lava",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},

                {
					patternName = "BurningBush_VineGenerators",
					isPatternSet = false,

                    specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "VineGrower",
					applySkinVariant = true,
				},
            },
            endGameProperties = {
            }
		},
		goals = {
			main = {"haveGem",5,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines, skinVariant = "Default"},},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",1125000},
				[3] = {"score",1500000},
			},
		},
	},

    ["Re:Fuse"] = {
        levelName = "Re:Fuse",
		resource = "GameScreen_Land21",
        introScript = "Land21_Refuse",
        outtroScript = "Land21_Outtro",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
            hasBombs = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
					name = "Bomb 1",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},

                {
					name = "Bomb 2",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},

                {
					name = "Bomb 3",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},

                {
					name = "Bomb 4",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,1,2,3,4,5,5,5},
				},
			},
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
		},
		goals = {
        main = {"haveGem",7,"Bomb or Double Barrel","Bombs and Double Barrels",{
            {specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},
            {specials = CascadePieceSpecials_Barrels, extraHits = 1},
        },
        "Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",2500000},
			},
		},
	},

    ["MakerOfBoulders"] = {
		levelName = "Maker Of Boulders",
		resource = "GameScreen_Land21",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
            hasMakers = true,
			hasBarrels = true,
			hasLava = true,
			hasSteel = true,
			hasMissingReels = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "BoulderMix",
					delay = 0,
					events = { 
						{
                            eventType = "emitCount",
                            count = 2,
                            newDelay = -1,
                            reset = true,
                        },
						{
                            eventType = "population",
                            count = 4,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Barrels,
                            },
                        },
					},
                    {
						name = "Boulder",
						applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
			},
            useMissingReels = true,
            missingReels = {
				patternName = "MakerOfBoulders_Reels",
				isPatternSet = false,
            },
            additionalInitialPatterns = {
                {
					patternName = "MakerOfBoulders_Makers",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"BoulderMix"},
				},

                {
					patternName = "MakerOfBoulders_Boulders",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},

                {
					patternName = "MakerOfBoulders_Lava",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},

                {
					patternName = "MakerOfBoulders_Steel",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},

            },
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",1600000},
			},
		},
	},

    ["ColorWheel"] = {
		levelName = "Color Wheel",
		resource = "GameScreen_Land21",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes6 = true,
			hasBarrelsOfFun = true,
            hasMissingSquares = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "ColorWheel_Missing",
                isPatternSet = false,
            },
            additionalNamedMixes =
			{
				{
					name = "GreenMix",
					{
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
				},
				{
					name = "YellowMix",
					{
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
				},
				{
					name = "BlueMix",
					{
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
				},
				{
					name = "PurpleMix",
					{
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
				},
				{
					name = "OrangeMix",
					{
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
				},
				{
					name = "RedMix",
					{
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        weight = 1,
                    },
				},
			},
            reelPieceMix = {
				{
					name = "Barrel, Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"BlueMix"},
					weight = 1,
				},
				{
					name = "Barrel, Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"GreenMix"},
					weight = 1,
				},
				{
					name = "Barrel, Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"PurpleMix"},
					weight = 1,
				},
				{
					name = "Barrel, Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"RedMix"},
					weight = 1,
				},
				{
					name = "Barrel, Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"YellowMix"},
					weight = 1,
				},
				{
					name = "Barrel, Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"OrangeMix"},
					weight = 1,
				},
			},
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                    {
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        weight = 1,
                    },
                },
            },
            additionalRegularPlacements = {
                {
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    frequencies = {1,1,1},
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    frequencies = {1,1,1},
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    frequencies = {1,1,1},
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    frequencies = {1,1,1},
                },
                {
                    name = "Yellow",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    frequencies = {1,1,1},
                },
                {
                    name = "Orange",
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                    frequencies = {1,1,1},
                },
                {
					name = "Barrel, Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"BlueMix"},
					frequencies = {1,1,1},
                    anyOneMatchFlag = false,
				},
				{
					name = "Barrel, Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"GreenMix"},
					frequencies = {1,1,1},
                    anyOneMatchFlag = false,
				},
				{
					name = "Barrel, Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"PurpleMix"},
					frequencies = {1,1,1},
                    anyOneMatchFlag = false,
				},
				{
					name = "Barrel, Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"RedMix"},
					frequencies = {1,1,1},
                    anyOneMatchFlag = false,
				},
				{
					name = "Barrel, Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"YellowMix"},
					frequencies = {1,1,1},
                    anyOneMatchFlag = false,
				},
				{
					name = "Barrel, Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    applySpawnTypes = true,
                    spawnTypes = {"OrangeMix"},
					frequencies = {1,1,1},
                    anyOneMatchFlag = false,
				},
            },
		},
		goals = {
			main = {"getGem",30,"Barrel","Barrels",{specials = CascadePieceSpecials_ColorBarrels,isGemSpawner = true,},},
			stars = {
				[1] = {"score",15000},
				[2] = {"score",20000},
				[3] = {"score",50000},
			},
		},
	},

	["Battlement1_side"] = {
		levelName = "Battlement 2",					
		resource = "GameScreen_Land21",		
        --introScript = "Land21_Intro",
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasStones = true,
			modeSpins6 = true,
			gemTypes4 = true,
			hasMissingSquares = true,
            hasBarrels = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Battlement1_side", 
				isPatternSet = false,
			},
			spawnGemOnBreak = 
			{
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Battlement1_side_windows",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "Battlement1_side_walls2_a",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "Battlement1_side_walls2_b",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					applyExtraHits = true,
					--isGemSpawner = true,
					--applyIsGemSpawner = true,
				},
				{
					patternName = "Battlement1_side_roof2",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

    ["PictureFrame_side"] = {
		levelName = "Picture Flame",
		resource = "GameScreen_Land21",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingSquares = true,
			hasCoverage = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "CenterRect",
				isPatternSet = false,
			},

            additionalInitialPatterns = {
				{
					patternName = "PictureFrame_side_pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
                {
					patternName = "PictureFrame_side_lava",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
            },

		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1300000},
				[3] = {"score",1500000},
			},
		},
	},

    ["VerticalHits_side"] = {
		levelName = "Extinguish",
		resource = "GameScreen_Land21",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			hasCrates = true,
			hasMakers = true,
			hasSteel = true,
			gemTypes3 = true,
			largeBoard = true,
			hasMissingSquares = true,
            hasMissingReels = true,
			hasFences = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "VerticalHits_missing",
				isPatternSet = false,
			},
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalNamedMixes = {
				{
					name = "Verticals",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					--{
					--	name = "Red Burst",
					--	matchFlags = CascadeMatchFlags_CommonPiece4,
					--	specials = CascadePieceSpecial_VerticalSplash,
					--	weight = 2,
					--},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Verticals",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "FrameCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "Line1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "VerticalHits_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Verticals"},
				},
				{
					patternName = "VerticalHits_side_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1500000},
				[3] = {"score",1700000},
			},
		},
	},

})