-- Land 22: gem eaters

table.insertall(LevelDefs,
{
--------------------
-- Land 22: Jonathan
--------------------

	["UseItOrLoseIt_Jon"] = {
		levelName = "Use It or Lose It",
		resource = "GameScreen_Land22",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMakers = true,
			hasGemEaters = true,
			hasCoverage = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasFences = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Nice Things",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
							reset = true,
						},
					},
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 3,
					},
					{
						name = "Horizontal Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
				},
				[2] = {
					name = "4 color mix",
					delay = 0,
					{
						name = "Color 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Color 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Color 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Color 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Nice Things",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "UseItOrLoseIt_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Nice Things","4 color mix",},
				},
				{
					patternName = "UseItOrLoseIt_Fence",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "UseItOrLoseIt_Eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "UseItOrLoseIt_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "UseItOrLoseIt_Missing", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_leftSide", 
				isPatternSet = false,
            },
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},


	["BurstHoarding"] = {
		levelName = "Burst Hoarding",
		resource = "GameScreen_Land22",	
		introScript = "Land22_Tip3",	
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins6 = true,
			gemTypes5 = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
		},
		goals = {
			main = {
				"haveGem",7,"Burst","Bursts",
				{
					{specials = CascadePieceSpecial_HorizontalSplash,},
					{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash,},
					{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_AreaSplash,},
					{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash +  CascadePieceSpecial_AreaSplash,},
					{specials = CascadePieceSpecial_VerticalSplash,},
					{specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,},
					{specials = CascadePieceSpecial_AreaSplash,},
				},
			},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",700000},
			},
		},
		expectedScore = 100000,
	},

	["BadBarrels"] = {
		levelName = "Bad Barrels",
		resource = "GameScreen_Land22",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins6 = true,
			gemTypes5 = true,
			hasVines = true,
			hasBombs = true,
			hasBarrelsOfFun = true,
			hasLava = true,
			hasGemEaters = true,
			hasCoverage = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Bad Barrels",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
							reset = true,
						},
					},
					{
						name = "Barrel",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						spawnTypes = {"Bad Barrel Stuff"},
						weight = 1,
					},
				},
				[2] = {
					name = "5 colors",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
				},
				[3] = {
					name = "Bad Barrel Stuff",
					{
						name = "Blue Vines",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Green Vines",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Purple Vines",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Red Vines",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Yellow Vines",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Lava",
						matchFlags = 0,
						specials = CascadePieceSpecials_Lava,
						weight = 5,
					},
					{
						name = "Blue Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 7,
						weight = 1,
					},
					{
						name = "Green Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 7,
						weight = 1,
					},
					{
						name = "Purple Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 7,
						weight = 1,
					},
					{
						name = "Red Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 7,
						weight = 1,
					},
					{
						name = "Yellow Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 7,
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Bad Barrel Stuff",
						{
							name = "Blue",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							weight = 1,
						},
						{
							name = "Green",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							weight = 1,
						},
						{
							name = "Purple",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							weight = 1,
						},
						{
							name = "Red",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							weight = 1,
						},
						{
							name = "Yellow",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							weight = 1,
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "BadBarrels_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "HalfReelsChestsLarge",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bad Barrels","5 colors"},
				},
				{
					patternName = "TopSlots_seed",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",700000},
			},
		},
		expectedScore = 100000,
	},

	["AutoTrimmer"] = {
		levelName = "Auto-trimmer",
		resource = "GameScreen_Land22",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins5 = true,
			gemTypes5 = true,
			hasVines = true,
			hasGemEaters = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalInitialPatterns = {
				 {
					patternName = "AutoTrimmer_GemEaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "BigCratePattern4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",25,"Vine","Vines", {cancelSpecials = CascadePieceSpecials_Vines},"Trim"},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",150000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["PatternEater"] = {
		levelName = "Pattern Eater",
		resource = "GameScreen_Land22",	
		introScript = "Land22_Intro",	
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins6 = true,
			gemTypes5 = true,
			hasGemEaters = true,
			hasCoverage = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalInitialPatterns = {
				 {
					patternName = "PatternEater_GemEaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "PatternEater_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 3,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	

	["SpinEater"] = {
		levelName = "Spin Eater",
		resource = "GameScreen_Land22",	
		outtroScript = "Land22_Outtro",	
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins1 = true,
			gemTypes4 = true,
			hasGemEaters = true,
		},
		tricks = {
			{name = Config.World22Tricks_Trick1},
			{name = Config.World22Tricks_Trick2},
			{name = Config.World22Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World22Boosts,
		Properties = {
			additionalInitialPatterns = {
				 {
					patternName = "TopSlots_seed",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",3500000},
				[2] = {"score",5000000},
				[3] = {"score",8500000},
			},
		},
		expectedScore = 100000,
	},
	
	["ImpossibleChests"] = { --Plan: It drops chests with orange gems, one at a time.
		levelName = "Impossible Chests",
		resource = "GameScreen_Land22",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins5 = true,
			gemTypes4 = true,
			hasChests = true,
			hasMakers = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Orange Gem 1",
					delay = 0,
					shuffle = false,
					events = {
						[1] = { --Turn chest on
							eventType = "emitCount",
							count = 1,
							reset = false,
							newDelay = 0,
							targetMix = "Chest 1",
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
					},
					{
						name = "Orange Gem",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[2] = {
					name = "Chest 1",
					delay = -1,
					shuffle = false,
					cooldowns = {0,0,-1,},
					events = {
						[1] = { --Turn on event that can turn on next pair
							eventType = "emitCount",
							count = 1, 
							reset = false,
							setCooldowns = {
                                [3] = 0,
							},
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[3] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
							newDelay = 1,
							targetMix = "Orange Gem 2",
							cooldown = -1,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
				[3] = {
					name = "Orange Gem 2",
					delay = -1,
					shuffle = false,
					events = {
						[1] = { --Turn chest on
							eventType = "emitCount",
							count = 1,
							reset = false,
							newDelay = 0,
							targetMix = "Chest 2",
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
					},
					{
						name = "Orange Gem",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[4] = {
					name = "Chest 2",
					delay = -1,
					shuffle = false,
					cooldowns = {0,0,-1,},
					events = {
						[1] = { --Turn on event that can turn on next pair
							eventType = "emitCount",
							count = 1, 
							reset = false,
							setCooldowns = {
                                [3] = 0,
							},
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[3] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
							newDelay = 1,
							targetMix = "Orange Gem 3",
							cooldown = -1,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
				[5] = {
					name = "Orange Gem 3",
					delay = -1,
					shuffle = false,
					events = {
						[1] = { --Turn chest on
							eventType = "emitCount",
							count = 1,
							reset = false,
							newDelay = 0,
							targetMix = "Chest 3",
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
					},
					{
						name = "Orange Gem",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[6] = {
					name = "Chest 3",
					delay = -1,
					shuffle = false,
					cooldowns = {0,0,-1,},
					events = {
						[1] = { --Turn on event that can turn on next pair
							eventType = "emitCount",
							count = 1, 
							reset = false,
							setCooldowns = {
                                [3] = 0,
							},
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[3] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
							newDelay = 1,
							targetMix = "Orange Gem 4",
							cooldown = -1,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
				[7] = {
					name = "Orange Gem 4",
					delay = -1,
					shuffle = false,
					events = {
						[1] = { --Turn chest on
							eventType = "emitCount",
							count = 1,
							reset = false,
							newDelay = 0,
							targetMix = "Chest 4",
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
					},
					{
						name = "Orange Gem",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[8] = {
					name = "Chest 4",
					delay = -1,
					shuffle = false,
					cooldowns = {0,0,-1,},
					events = {
						[1] = { --Turn on event that can turn on next pair
							eventType = "emitCount",
							count = 1, 
							reset = false,
							setCooldowns = {
                                [3] = 0,
							},
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[3] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
							newDelay = 1,
							targetMix = "Orange Gem 5",
							cooldown = -1,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
				[9] = {
					name = "Orange Gem 5",
					delay = -1,
					shuffle = false,
					events = {
						[1] = { --Turn chest on
							eventType = "emitCount",
							count = 1,
							reset = false,
							newDelay = 0,
							targetMix = "Chest 5",
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
					},
					{
						name = "Orange Gem",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[10] = {
					name = "Chest 5",
					delay = -1,
					shuffle = false,
					cooldowns = {0,0,-1,},
					events = {
						[1] = { --Turn on event that can turn on next pair
							eventType = "emitCount",
							count = 1, 
							reset = false,
							setCooldowns = {
                                [3] = 0,
							},
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[3] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
							newDelay = 1,
							targetMix = "Orange Gem 6",
							cooldown = -1,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
				[11] = {
					name = "Orange Gem 6",
					delay = -1,
					shuffle = false,
					events = {
						[1] = { --Turn chest on
							eventType = "emitCount",
							count = 1,
							reset = false,
							newDelay = 0,
							targetMix = "Chest 6",
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
					},
					{
						name = "Orange Gem",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[12] = {
					name = "Chest 6",
					delay = -1,
					shuffle = false,
					cooldowns = {0,0,-1,},
					events = {
						[1] = { --Turn on event that can turn on next pair
							eventType = "emitCount",
							count = 1, 
							reset = false,
							setCooldowns = {
                                [3] = 0,
							},
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[3] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
							newDelay = 1,
							targetMix = "Orange Gem 7",
							cooldown = -1,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
				[13] = {
					name = "Orange Gem 7",
					delay = -1,
					shuffle = false,
					events = {
						[1] = { --Turn chest on
							eventType = "emitCount",
							count = 1,
							reset = false,
							newDelay = 0,
							targetMix = "Chest 7",
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
					},
					{
						name = "Orange Gem",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[14] = {
					name = "Chest 7",
					delay = -1,
					shuffle = false,
					cooldowns = {0,0,-1,},
					events = {
						[1] = { --Turn on event that can turn on next pair
							eventType = "emitCount",
							count = 1, 
							reset = false,
							setCooldowns = {
                                [3] = 0,
							},
						},
						[2] = { --Turn self off
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[3] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
							newDelay = 1,
							targetMix = "Orange Gem 1",
							cooldown = -1,
						},
					},
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
				[15] = {
					name = "5 Color Mix",
					delay = 0,
					shuffle = false,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TopRow_Column1_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Orange Gem 3","Chest 3","5 Color Mix",},
				},
				[2] = {
					patternName = "TopRow_Column2_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Orange Gem 6","Chest 6","5 Color Mix",},
				},
				[3] = {
					patternName = "TopRow_Column3_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Orange Gem 4","Chest 4","5 Color Mix",},
				},
				[4] = {
					patternName = "TopRow_Column4_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Orange Gem 1","Chest 1","5 Color Mix",},
				},
				[5] = {
					patternName = "TopRow_Column5_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Orange Gem 5","Chest 5","5 Color Mix",},
				},
				[6] = {
					patternName = "TopRow_Column6_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Orange Gem 2","Chest 2","5 Color Mix",},
				},
				[7] = {
					patternName = "TopRow_Column7_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Orange Gem 7","Chest 7","5 Color Mix",},
				},
			},
		},
		goals = {
			main = {"getGem",7,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",900000},
				[2] = {"score",1000000},
				[3] = {"score",1300000},
			},
		},
		expectedScore = 100000,
	},

--------------------
-- Land 22: Naomi
--------------------

	["ChestEaters"] = {
		levelName = "Chest Eaters",
		resource = "GameScreen_Land22",		
		Features = {
			splashMode = true,
			treasureChest = true,
			modeSpins5 = true,
			gemTypes5 = true,
			regularBoard = true,
			hasChests = true,
			hasGemEaters = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Line2",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				[2] = {
					patternName = "Line4",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["ColumnEater"] = {
		levelName = "Conveyor Belt",
		resource = "GameScreen_Land22",
		introScript = "Land22_Tip1",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasMakers = true,
			hasBarrels = true,
			hasGemEaters = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "LeftColumn2Large", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_leftSide", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Always Boulder",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 3,
							reset = true,
						},
					},
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
				[2] = {
					name = "4 Color Mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Leftcol_1mod3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
				},
				{
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Boulder","4 Color Mix"},
				},
				{
					patternName = "Spider_Lava",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"getGem",8,"Boulders","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1100000},
				[3] = {"score",1800000},
			},
		},
	},

	["Stonewalling"] = {
		levelName = "Stonewalling",
		resource = "GameScreen_Land22",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			regularBoard = true,
			gemTypes5 = true,
            hasStones = true,
			hasBarrelsOfFun = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
            additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applySpawnTypes = true,
					spawnTypes = {"Stones"},
                    frequencies = {0,1,2,1,2,2,3,2,3},
				},
            },
            additionalNamedMixes = {
				{
					name = "Stones",
                    { 
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						weight = 6,
						skinVariant = "Stone",
						extraHits = 2,
					},
				},
			},
		},
		goals = {
			main = {"haveGem",12,"Stone","Stones",{specials = CascadePieceSpecials_Stone,},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",500000},
				[3] = {"score",800000},
			},
		},
	},

	["HalfAndHalf"] = {
		levelName = "Half and Half",
		resource = "GameScreen_Land22",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins5 = true,
			gemTypes5 = true,
			hasVines = true,
			hasLava = true,
			hasGemEaters = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BottomCols",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "TopCols",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Line",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "MissingOuterCorners",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava or Vine","Lava and Vines",
				{
					{specials = CascadePieceSpecials_Vines,},
					{specials = CascadePieceSpecials_Lava,},
				},
			},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},

	["BurstTraps"] = {
		levelName = "Burst Traps",
		resource = "GameScreen_Land22",	
		introScript = "Land22_Tip2",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			hasBombs = true,
			hasCrates = true,
			hasGemEaters = true,
			gemTypes4 = true,
			largeBoard = true,
			hasMissingSquares = true,
		},
		tricks = TricksDefault,  
		boosts = World22Boosts,
		Properties = {
			useMissingSquares = true,
            missingSquares = {
				patternName = "BottomHole", 
				isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "BigBottomColumn4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyTurnsToLoss = true,
					turnsToLoss = 30,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "BurstTraps_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecials_Crates},"Defuse"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",1500000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000,
	},

    ["RockCollection"] = {
		levelName = "Rock Collection",
		resource = "GameScreen_Land22",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes5 = true,
            hasBarrels = true,
            hasGemEaters = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
            additionalInitialPatterns = {
				{
					patternName = "Line5",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
            },
            additionalRegularPlacements = {
				{
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1,1,1,1},
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},
		goals = {
			main = {"haveGem",6,"Boulders","Boulders",{specials = CascadePieceSpecials_Barrels,},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",250000},
				[3] = {"score",450000},
			},
		},
	},
	["Treasury"] = {
		levelName = "Treasury",
		resource = "GameScreen_Land22",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			gemTypes4 = true,
			regularBoard = true,
			hasChests = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					frequencies = {1,2,1,2,3,2,1,2,1,2,3,1,2,1},
				},
			},
		},
		goals = {
			main = {"haveGem",13,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["OrangeEaters"] = {
		levelName = "Knockdown Oranges",					
		resource = "GameScreen_Land22",		
		Features = {
			modeSpins8 = true,
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,
			hasSteel = true,
			hasStones = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasBombs = true,
		},
		Properties = {
			useMissingSquares = true,
            missingSquares = {
                patternName = "OrangeEaters_missing",
                isPatternSet = false,
            },
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "OrangeEaters_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "OrangeEaters_orange1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyTurnsToLoss = true,
					turnsToLoss = 50,
				},
				{
					patternName = "OrangeEaters_orange2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyTurnsToLoss = true,
					turnsToLoss = 40,
				},
				{
					patternName = "OrangeEaters_orange3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "BottomCorners_large",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6,},"Drop"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",900000},
			},
		},
	},

	["PatternEater_side"] = {
		levelName = "Pattern Eater 2",
		resource = "GameScreen_Land22",	
		--introScript = "Land22_Intro",	
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins6 = true,
			gemTypes5 = true,
			hasGemEaters = true,
			hasCoverage = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalInitialPatterns = {
				 {
					patternName = "PatternEater_side_GemEaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "PatternEater_side_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 3,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",700000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},

    ["OrangeEaters_side"] = {
		levelName = "Lemon Drops",
		resource = "GameScreen_Land22",		
		Features = {
			modeSpins6 = true,
			gemTypes4 = true,
			splashMode = true,
			largeBoard = true,
			hasStones = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasBombs = true,
			hasGemEaters = true,
		},
		Properties = {
			useMissingSquares = true,
            missingSquares = {
                patternName = "OrangeEaters_missing",
                isPatternSet = false,
            },
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "OrangeEaters_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "OrangeEaters_side_orange1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyTurnsToLoss = true,
					turnsToLoss = 55,
				},
				{
					patternName = "OrangeEaters_side_orange2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyTurnsToLoss = true,
					turnsToLoss = 40,
				},
				{
					patternName = "OrangeEaters_side_orange3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "OrangeEaters_side_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Yellow","Yellows",{matchFlags = CascadeMatchFlags_CommonPiece5,},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

    ["HalfAndHalf_side"] = {
		levelName = "Half and Half and Half",
		resource = "GameScreen_Land22",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins7 = true,
			gemTypes5 = true,
			hasVines = true,
			hasLava = true,
			hasGemEaters = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "HalfAndHalf_side_Vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "HalfAndHalf_side_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Line",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "HalfHalfHalf_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava or Vine","Lava and Vines",
				{
					{specials = CascadePieceSpecials_Vines,},
					{specials = CascadePieceSpecials_Lava,},
				},
			},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},

})