-- Land 23: gift boxes

table.insertall(LevelDefs,
{
-------------------------
--- LAND 23, Jonathan ---
-------------------------

	["BoxSpiral"] = {
		levelName = "Box Spiral",					
		resource = "GameScreen_Land23",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasGiftBoxes = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasFences = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
			useMissingSquares = true,
            missingSquares = {
                patternName = "BoxSpiral_Empty",
                isPatternSet = false,
            },
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Box1",
					delay = 0,
					{
						name = "Wide Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
				},
				[2] = {
					name = "Box2",
					delay = 0,
					{
						name = "Wide Vertical",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
				},
				[3] = {
					name = "Box3",
					delay = 0,
					{
						name = "Wide Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
				},
				[4] = {
					name = "Box4",
					delay = 0,
					{
						name = "Wide Vertical",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
				},
				[5] = {
					name = "Box5",
					delay = 0,
					{
						name = "Wide Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
				},
				[6] = {
					name = "Box6",
					delay = 0,
					{
						name = "Wide Vertical",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
				},
				[7] = {
					name = "Box7",
					delay = 0,
					{
						name = "Wide Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
				},
				[8] = {
					name = "Box8",
					delay = 0,
					{
						name = "Wide Horizontal",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BoxSpiral_Box1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box1"},
				},
				[2] = {
					patternName = "BoxSpiral_Box2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box2"},
				},
				[3] = {
					patternName = "BoxSpiral_Box3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box3"},
				},
				[4] = {
					patternName = "BoxSpiral_Box4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box4"},
				},
				[5] = {
					patternName = "BoxSpiral_Box5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box5"},
					applyExtraHits = true,
					extraHits = 1,
				},
				[6] = {
					patternName = "BoxSpiral_Box6",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box6"},
					applyExtraHits = true,
					extraHits = 2,
				},
				[7] = {
					patternName = "BoxSpiral_Box7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box7"},
					applyExtraHits = true,
					extraHits = 1,
				},
				[8] = {
					patternName = "BoxSpiral_Box8",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box8"},
					applyExtraHits = true,
					extraHits = 1,
				},
				[9] = {
					patternName = "BoxSpiral_Fences",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
				},
			},
		},
		goals = {
			main = {"getGem",8,"Gift","Gifts",{specials = CascadePieceSpecials_Stone, isGemSpawner = true, extraHits = 0},"Open"},
			stars = {
				[1] = {"score",750000},
				[2] = {"score",1200000},
				[3] = {"score",1650000},
			},
		},
		expectedScore = 100000, 
	},

	["Regifting"] = {
		levelName = "Regifting",					
		resource = "GameScreen_Land23",
		outtroScript = "Land23_Outtro",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasGiftBoxes = true,
			hasMissingSquares = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "TopCorners_large", 
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Box in a Box",
					delay = 0,
					{
						name = "Gift Box",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Box in a Box",},
						extraHits = 2,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Regifting_1Hit",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box in a Box",},
				},
				[2] = {
					patternName = "Regifting_2Hit",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box in a Box",},
					applyExtraHits = true,
					extraHits = 1,
				},
				[3] = {
					patternName = "Regifting_3Hit",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Box in a Box",},
					applyExtraHits = true,
					extraHits = 2,
				},
			},
		},
		goals = {
			main = {"haveGem",9,"1-Hit Box","1-Hit Boxes",{specials = CascadePieceSpecials_Stone, isGemSpawner = true, extraHits = 0},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},

	["SuperWall"] = {
		levelName = "Super Wall",					
		resource = "GameScreen_Land23",
		introScript = "Land23_Tip3",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasGiftBoxes = true,
			hasCoverage = true,
			hasStones = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
			},
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Blue vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Blue horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Blue area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Make 2-hit",
					delay = 0,
					{
						name = "Gift Box",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Make 1-hit",},
						extraHits = 1,
						weight = 1,
					},
				},
				[2] = {
					name = "Make 1-hit",
					delay = 0,
					{
						name = "Gift Box",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Make Stone",},
						extraHits = 0,
						weight = 1,
					},
				},
				[3] = {
					name = "Make Stone",
					delay = 0,
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Stone",
						extraHits = 1,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make 2-hit",},
					applyMatchRequirement = true,
					matchRequirement = 3,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",2000000},
				[2] = {"score",2500000},
				[3] = {"score",3500000},
			},
		},
		expectedScore = 100000, 
	},

	["LockedLava"] = {
		levelName = "Locked Lava",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasLava = true,
			hasLocks = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LockedLava_Locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock,
				},
				[2] = {
					patternName = "LockedLava_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lava,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, 
	},

	["Pinata"] = {
		levelName = "Pinata",			
		resource = "GameScreen_Land23",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasGiftBoxes = true,
			hasChests = true,
			hasMakers = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
			
			additionalNamedMixes = {
				[1] = {
					name = "Make Gifts",
					delay = 0,
					{
						name = "Gift Box",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Make Chests",},
						weight = 1,
					},
				},
				[2] = {
					name = "Make Chests",
					delay = 0,
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "HalfReelsChestsLarge",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Gifts",},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",400000},
				[3] = {"score",575000},
			},
		},
		expectedScore = 100000, 
	},

	["LockedBoxes"] = {
		levelName = "Locked Boxes",
		resource = "GameScreen_Land23",
		Features = {
			modeSpins9 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasGiftBoxes = true,
			hasLocks = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            additionalNamedMixes = {
				{
					name = "Make Locks",
					delay = 0,
					{
                        name = "Lock",
                        matchFlags = 0,
						specials = CascadePieceSpecials_Lock,
                        weight = 1,
                    },
                },
            },
			additionalInitialPatterns = {
                {
					patternName = "LockBox_Gifts3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Locks",},
					applyExtraHits = true,
					extraHits = 2,
				},
                {
					patternName = "LockBox_Gifts2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Locks",},
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "LockBox_Gifts1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Locks",},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Gift","Gifts",{specials = CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000, 
	},

	["UpAndDownAgain"] = {
		levelName = "Up and Down Again",
		resource = "GameScreen_Land23",
		Features = {
			modeSpins9 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasGiftBoxes = true,
			hasCoconuts = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            additionalNamedMixes = {
				{
					name = "Make Coconuts",
					delay = 0,
					{
                        name = "Coconut",
                        matchFlags = 0,
						specials = CascadePieceSpecials_Coconut,
						spawnTypes = {"Make Vertical Bursts"},
                        weight = 1,
                    },
                },
				{
					name = "Make Vertical Bursts",
					delay = 0,
					{
                        name = "Vertical Burst 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
					{
                        name = "Vertical Burst 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
					{
                        name = "Vertical Burst 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
					{
                        name = "Vertical Burst 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
					{
                        name = "Vertical Burst 5",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                },
            },
			additionalInitialPatterns = {
                {
					patternName = "UpAndDownAgain_Gifts3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Coconuts",},
					applyExtraHits = true,
					extraHits = 2,
				},
                {
					patternName = "UpAndDownAgain_Gifts2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Coconuts",},
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "UpAndDownAgain_Gifts1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Coconuts",},
				},
			},
		},
		goals = {
			main = {"getGem",16,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",650000},
			},
		},
		expectedScore = 100000, 
	},
	
	["PresentPlacer"] = {
		levelName = "Present Placer",
		resource = "GameScreen_Land23",
		introScript = "Land23_Tip2",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasGiftBoxes = true,
			hasBarrelsOfFun = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasCoverage = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            additionalNamedMixes = {
				{
					name = "Make Presents",
					delay = 0,
					{
                        name = "Present",
                        matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Make Horizontal and Area Bursts"},
                        weight = 1,
                    },
                },
				{
					name = "Make Horizontal and Area Bursts",
					delay = 0,
					{
                        name = "Horizontal Burst 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Area Burst 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 3,
                    },
					{
                        name = "Area Burst 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 3,
                    },
					{
                        name = "Area Burst 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 3,
                    },
					{
                        name = "Area Burst 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 3,
                    },
					{
                        name = "Super Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                        weight = 1,
                    },
                },
            },
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 7,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 7,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 7,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 7,
				},
				{
					name = "Blue Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Presents"},
					weight = 4,
				},
				{
					name = "Green Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Presents"},
					weight = 4,
				},
				{
					name = "Purple Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Presents"},
					weight = 4,
				},
				{
					name = "Red Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Presents"},
					weight = 4,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
			},
			additionalInitialPatterns = {
                {
					patternName = "RightColumnLarge",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "Col6_large", 
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "Reels67", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",2400000},
			},
		},
		expectedScore = 100000, 
	},

-------------------------
--- LAND 23, Naomi ------
-------------------------

	["BasicBoxes"] = {
		levelName = "Basic Boxes",					
		resource = "GameScreen_Land23",
		introScript = "Land23_Intro",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasBarrels = true,
			hasCoverage = true,
			hasMissingReels = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Make Horizontal and Area Bursts",
					delay = 0,
					{
                        name = "Horizontal Burst 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Super Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                        weight = 1,
                    },
                },
            },
            useMissingReels = true,
            missingReels = {
                patternName = "CenterStripe_Reels",
                isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "SideBarrels",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyExtraHits = true,
					extraHits = 2,
					spawnTypes = {"Make Horizontal and Area Bursts"},
				},
				{ 
					patternName = "CenterStripe",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",175000},
				[2] = {"score",200000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000, 
	},

	["UnwelcomeGifts"] = {
		levelName = "Unwelcome Gifts",					
		resource = "GameScreen_Land23",
		Features = {
			modeSpins9 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasVines = true,
			hasMissingReels = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels",
                isPatternSet = false,
            },
			spawnGemOnBreak = 
			{
				{
					name = "Vines 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
				{
					name = "Vines 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
				{
					name = "Vines 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
				{
					name = "Vines 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
				{
					name = "Vines 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1.5,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Border1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyExtraHits = true,
					extraHits = 2,
				},
				{
					patternName = "Border2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Gift","Gifts",{specials = CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000, 
	},

	["ColorSpout"] = {
		levelName = "Color Spout",
		resource = "GameScreen_Land23",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasStones = true,
			hasMissingReels = true,
			hasSteel = true,
			hasGemEaters = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "ColorSpout_reels",
				isPatternSet = false,
            },
			gemsMoveDiagonally = false,
			additionalNamedMixes = {
				[1] = {
					name = "Stripe 1",
					delay = 0,
					cooldowns = {0},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 5,
							newDelay = 0,
							targetMix = "Stripe 2",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
				},
				[2] = {
					name = "Stripe 2",
					delay = 1,
					cooldowns = {1},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 5,
							newDelay = 0,
							targetMix = "Stripe 3",
							reset = true,
						},
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
				},
				[3] = {
					name = "Stripe 3",
					delay = 2,
					cooldowns = {2},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 5,
							newDelay = 0,
							targetMix = "Stripe 4",
							reset = true,
						},
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
				},
				[4] = {
					name = "Stripe 4",
					delay = 3,
					cooldowns = {3},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 5,
							newDelay = 0,
							targetMix = "Stripe 5",
							reset = true,
						},
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
				[5] = {
					name = "Stripe 5",
					delay = 4,
					cooldowns = {4},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 5,
							newDelay = 0,
							targetMix = "Stripe 1",
							reset = true,
						},
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Tower2_block7",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Stripe 1","Stripe 2","Stripe 3","Stripe 4","Stripe 5"},
				},
				{
					patternName = "ColorSpout_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "LeftNoTopNoBottom",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
                {
                    patternName = "ColorSpout_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
                },
				{
					patternName = "BombVines1_inner1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1500000},
			},
		},
	},

	["Plumbing"] = {
		levelName = "Plumbing",
		resource = "GameScreen_Land23",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
            hasCoverage = true,
            hasMakers = true,
			hasGiftBoxes = true,
			hasBombs = true,
			hasMissingSquares = true,
			hasMissingReels = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "JugHoles", 
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "Reels26", 
				isPatternSet = false,
			},
            additionalNamedMixes = {
				{
					name = "Horizontal Splash Mix",
					delay = 0,
					events = {
                        {
                            eventType = "emitCount",
                            count = 3,
                            newDelay = 1,
                        },
                    },
					{
                        name = "Blue Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Green Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Purple Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Red Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
					{
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1.5,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1.5,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1.5,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1.5,
                    },
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = .5,
					},
                },
                {
					name = "Gift Mix",
					delay = 0,
					{
                        name = "Gift",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        weight = 1,
						spawnTypes = {"Bomb Mix"},
                    },

                },
				{
					name = "Bomb Mix",
					delay = 0,
					{
						name = "Orange Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 0.75,
					},
                },
            },
			additionalInitialPatterns = {
                {
					patternName = "Plumbing_makers",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Horizontal Splash Mix","Gift Mix",},
				},
                {
					patternName = "JugHandles",
					isPatternSet = false,
                    matchRequirement = 3,
                    applyMatchRequirement = true,
				},
			},

		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000, 
	},

	["TowerRaid"] = {
		levelName = "Tower Raid",
		resource = "GameScreen_Land23",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
            hasMakers = true,
			hasBombs = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasChests = true,
			hasFences = true,
			hasStones = true,
			hasGemEaters = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "TowerToTheClouds_Reels",
				isPatternSet = false,
            },
			useMissingSquares = true,
            missingSquares = {
				patternName = "TowerRaid_missing",
				isPatternSet = false,
            },
			additionalNamedMixes = {
				{
					name = "Horizontal Splash Mix 1",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Vertical Splash Mix 1",
							reset = true,
						},
                    },
					{
                        name = "Blue Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Green Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Purple Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Red Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                },
				{
					name = "Vertical Splash Mix 1",
					delay = 0,
					events = {
                        [1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Area Splash Mix 1",
							reset = true,
						},
                    },
					{
                        name = "Blue Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                    {
                        name = "Green Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                    {
                        name = "Purple Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                    {
                        name = "Red Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                },
				{
					name = "Area Splash Mix 1",
					delay = 0,
					events = {
                        [1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Horizontal Splash Mix 1",
							reset = true,
						},
                    },
					{
                        name = "Blue Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Green Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Purple Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Red Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                },
				{
					name = "Horizontal Splash Mix 2",
					delay = 0,
					events = {
                        [1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Vertical Splash Mix 2",
							reset = true,
						},
                    },
					{
                        name = "Blue Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Green Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Purple Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Red Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                },
				{
					name = "Vertical Splash Mix 2",
					delay = 0,
					events = {
                        [1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Area Splash Mix 2",
							reset = true,
						},
                    },
					{
                        name = "Blue Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                    {
                        name = "Green Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                    {
                        name = "Purple Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                    {
                        name = "Red Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                },
				{
					name = "Area Splash Mix 2",
					delay = 0,
					events = {
                        [1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Horizontal Splash Mix 2",
							reset = true,
						},
                    },
					{
                        name = "Blue Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Green Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Purple Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Red Splash",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                },
				{
					name = "Bomb Mix",
					delay = 0,
					{
						name = "Blue Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1,
					},
					{
						name = "Green Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1,
					},
					{
						name = "Purple Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1,
					},
					{
						name = "Red Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1,
					},
                },
            },
			additionalInitialPatterns = {
                {
					patternName = "TopRow_Column3_Large",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Horizontal Splash Mix 1","Vertical Splash Mix 1","Area Splash Mix 1",},
				},
				{
					patternName = "TopRow_Column5_Large",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Horizontal Splash Mix 2","Vertical Splash Mix 2","Area Splash Mix 2",},
				},
				{
					patternName = "TopRow_Column4_Large",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Bomb Mix"},
				},
				{
					patternName = "TowerRaid_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					specials = CascadePieceSpecial_AreaSplash,
					applyPieceSpecials = true,
				},
				{
					patternName = "TowerRaid_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "TowerRaid_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "TowerRaid_bomb",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
				},
				{
					patternName = "TowerRaid_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Horizontal Splash Mix 1",
						delay = -1,
					},
					[2] = {
						name = "Vertical Splash Mix 1",
						delay = -1,
					},
					[3] = {
						name = "Area Splash Mix 1",
						delay = -1,
					},
					[4] = {
						name = "Horizontal Splash Mix 2",
						delay = -1,
					},
					[5] = {
						name = "Vertical Splash Mix 2",
						delay = -1,
					},
					[6] = {
						name = "Area Splash Mix 2",
						delay = -1,
					},
					[7] = {
						name = "Bomb Mix",
						delay = -1,
					},
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",700000},
				[3] = {"score",950000},
			},
		},
		expectedScore = 100000, 
	},

-------------------------
--- LAND 23, Zach -------
-------------------------

    ["AirDrop"] = {
		levelName = "Air Drop",
		resource = "GameScreen_Land23",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
            hasCoverage = true,
            hasMakers = true,
			hasGiftBoxes = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            additionalNamedMixes = {
				{
					name = "GemMix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 4,
                            newDelay = 1,
                        },
                    },
					{
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
					{
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                },
                {
					name = "GiftMix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 6,
                            newDelay = 1,
                        },
                    },
					{
                        name = "Gift",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        weight = 1,
                    },
                },
            },
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "AirDrop_Gifts",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
                {
					patternName = "AirDrop_MakersGems",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"GemMix"},
				},
                {
					patternName = "AirDrop_MakersGifts",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"GiftMix"},
				},
                {
					patternName = "AirDrop_Clouds",
					isPatternSet = false,
                    matchRequirement = 4,
                    applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",125000},
			},
		},
		expectedScore = 100000, 
	},

    ["TowerToTheClouds"] = {
		levelName = "Tower to the Clouds",
		resource = "GameScreen_Land23",
		introScript = "Land23_Tip1",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
            hasMakers = true,
            hasMissingReels = true,
            hasBarrelsOfFun = true,
			hasGiftBoxes = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            additionalNamedMixes = {
				{
					name = "Mix_Barrels",
					{
						name = "Barrel",
                        applyPieceSpecials = true,
                        specials = CascadePieceSpecials_Barrels,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        spawnTypes = {"Mix_GiftsFromBarrels"},
                        applyExtraHits = true,
                        extraHits = 1,
						weight = 1,
					},
				},
                {
					name = "Mix_GiftsFromBarrels",
					delay = 0,
                    {
                        name = "Gift 3x",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        spawnTypes = {"Mix_Barrels"},
                        applyExtraHits = true,
                        extraHits = 2,
                        weight = 1,
                    },
                },
                {
					name = "Mix_GiftsFromMakers",
					delay = 0,
					{
                        name = "Gift 1x",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        spawnTypes = {"Mix_Barrels"},
                        weight = 1,
                    },
                },
            },
            useMissingReels = true,
            missingReels = {
				patternName = "TowerToTheClouds_Reels",
				isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "TowerToTheClouds_Gifts",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    spawnTypes = {"Mix_Barrels"},
				},
                {
					patternName = "TowerToTheClouds_Makers",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Mix_GiftsFromMakers"},
				},
			},
		},
		goals = {
			main = {"haveGem",7,"Gift","Gifts",{specials = CascadePieceSpecials_Stone, isGemSpawner = true,},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000, 
	},

	["BasicBoxes_side"] = {
		levelName = "Center Boxes",					
		resource = "GameScreen_Land23",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasBarrels = true,
			hasCoverage = true,
			hasMissingReels = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Make Horizontal and Area Bursts",
					delay = 0,
					{
                        name = "Horizontal Burst 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Horizontal Burst 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 3,
                    },
					{
                        name = "Super Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                        weight = 1,
                    },
                },
            },
            useMissingReels = true,
            missingReels = {
                patternName = "CenterStripe_Reels_side",
                isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "SideBarrels_side",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyExtraHits = true,
					extraHits = 2,
					spawnTypes = {"Make Horizontal and Area Bursts"},
				},
				{ 
					patternName = "CenterStripe_side",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",750000},
				[3] = {"score",850000},
			},
		},
		expectedScore = 100000, 
	},

    ["TowerToTheClouds_side"] = {
		levelName = "Tower of Terror",
		resource = "GameScreen_Land23",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
            hasMakers = true,
            hasMissingReels = true,
            hasBarrelsOfFun = true,
			hasGiftBoxes = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            additionalNamedMixes = {
				{
					name = "Mix_Barrels",
					{
						name = "Barrel",
                        applyPieceSpecials = true,
                        specials = CascadePieceSpecials_Barrels,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        spawnTypes = {"Mix_GiftsFromBarrels"},
						weight = 1,
					},
				},
                {
					name = "Mix_GiftsFromBarrels",
					delay = 0,
                    {
                        name = "Gift 3x",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        spawnTypes = {"Mix_Barrels"},
                        weight = 1,
                    },
                },
                {
					name = "Mix_GiftsFromMakers",
					delay = 0,
					{
                        name = "Gift 1x",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        spawnTypes = {"Mix_Barrels"},
                        weight = 1,
                    },
                },
            },
            useMissingReels = true,
            missingReels = {
				patternName = "TowerToTheClouds_side_Reels",
				isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "TowerToTheClouds_side_Gifts",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    spawnTypes = {"Mix_Barrels"},
				},
                {
					patternName = "TowerToTheClouds_side_Makers",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Mix_GiftsFromMakers"},
				},
			},
		},
		goals = {
			main = {"haveGem",12,"Gift","Gifts",{specials = CascadePieceSpecials_Stone, isGemSpawner = true,},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000, 
	},

    ["UpAndDownAgain_side"] = {
		levelName = "Up and Down and Up Again",
		resource = "GameScreen_Land23",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasGiftBoxes = true,
			hasCoconuts = true,
		},
		tricks = World23Tricks,
		boosts = World23Boosts,
		Properties = {
            additionalNamedMixes = {
				{
					name = "Make Coconuts",
					delay = 0,
					{
                        name = "Coconut",
                        matchFlags = 0,
						specials = CascadePieceSpecials_Coconut,
						spawnTypes = {"Make Gifts"},
                        weight = 1,
                    },
                },
                {
                    name = "Make Gifts",
                    delay = 0,
                    {
                        name = "Gift 2x",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applySpawnTypes = true,
                        spawnTypes = {"Make Vertical Bursts",},
                        applyExtraHits = true,
                        extraHits = 2,
                        weight = 1,
                    },
                    {
                        name = "Gift 1x",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applySpawnTypes = true,
                        spawnTypes = {"Make Vertical Bursts",},
                        applyExtraHits = true,
                        extraHits = 1,
                        weight = 1,
                    },
                    {
                        name = "Gift 0x",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        applySpawnTypes = true,
                        spawnTypes = {"Make Vertical Bursts",},
                        weight = 1,
                    },
                },
				{
					name = "Make Vertical Bursts",
					delay = 0,
					{
                        name = "Vertical Burst 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
					{
                        name = "Vertical Burst 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
					{
                        name = "Vertical Burst 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
					{
                        name = "Vertical Burst 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
					{
                        name = "Vertical Burst 5",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_VerticalSplash,
                        weight = 1,
                    },
                },
            },
			additionalInitialPatterns = {
                {
					patternName = "UpAndDownAgain_side_Gifts3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Coconuts",},
					applyExtraHits = true,
					extraHits = 2,
				},
                {
					patternName = "UpAndDownAgain_side_Gifts2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Coconuts",},
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "UpAndDownAgain_side_Gifts1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make Coconuts",},
				},
			},
		},
		goals = {
			main = {"getGem",12,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",900000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
})