-- Land 24: portals

table.insertall(LevelDefs,
{
	["LongWayDown2"] = {
		levelName = "Long Way Down",
		resource = "GameScreen_Land24",			
		Features = {
			splashMode = true,
			modeSpins5 = true,
			gemTypes5 = true,
			largeBoard = true,
			hasChests = true,
			hasPortals = true,
			hasMakers = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{0,6},{6,1},"PortalEntrance_1","PortalExit_1"},
				[2] = {{6,6},{1,2},"PortalEntrance_1","PortalExit_1"},
				[3] = {{1,5},{5,2},"PortalEntrance_1","PortalExit_1"},
				[4] = {{5,5},{2,3},"PortalEntrance_1","PortalExit_1"},
				[5] = {{2,4},{4,3},"PortalEntrance_1","PortalExit_1"},
				[6] = {{4,4},{3,4},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Treasure Chest",
					delay = 0,
					events = { --When there are no chests, make 1 chest and then stop
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							newDelay = 0,
							cooldown = 1,
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
						},
					},
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
                [2] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
            additionalInitialPatterns = { 
                [1] = {
                    patternName = "CornerSteel_topLeft_inside",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Treasure Chest","Normal mix",},
                },
            },
			
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},

	["Rube3"] = {
		levelName = "Domino Effect",
		resource = "GameScreen_Land24",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasChests = true,
			hasStones = true,
			hasMakers = true,
			hasFences = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasSteel = true,
			hasPortals = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "Reels567", 
				isPatternSet = false,
            },
			useMissingSquares = true,
			missingSquares = {
				patternName = "Domino_missing", 
				isPatternSet = false,
            },
			portals = {
				[1] = {{0,1},{6,2},"PortalEntrance_1","PortalExit_1"},
				[2] = {{6,2},{4,4},"PortalEntrance_1","PortalExit_1"},
				[3] = {{6,1},{0,7},"PortalEntrance_1","PortalExit_1"},
				[4] = {{0,7},{4,2},"PortalEntrance_1","PortalExit_1"},
				[5] = {{4,2},{5,5},"PortalEntrance_1","PortalExit_1"},
				[6] = {{6,4},{5,7},"PortalEntrance_1","PortalExit_1"},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Vertical",
						delay = -1,
					},
					[2] = {
						name = "Horizontal",
						delay = -1,
					},
					[3] = {
						name = "Area Burst",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Vertical",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
				},
				[2] = {
					name = "Horizontal",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
				},
				[3] = {
					name = "Area Burst",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Domino_makerA",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Area Burst"},
				},
				[2] = {
					patternName = "Domino_makerH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Horizontal"},
				},
				[3] = {
					patternName = "Domino_makerV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Vertical"},
				},
				[4] = {
					patternName = "Domino_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[5] = { 
					patternName = "Domino_chest",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				[6] = {
					patternName = "Domino_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[7] = {
					patternName = "Domino_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				[8] = {
					patternName = "Domino_horiz",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",2500000},
			},
		},
	},
	["TriplePortalRow"] = {
		levelName = "Triple Portal Row",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			hasStones = true,
			hasCoverage = true,
			largeBoard = true,
			hasBombs = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{0,1},{0,3},"PortalEntrance_1","PortalExit_1"},
				[2] = {{0,4},{0,6},"PortalEntrance_1","PortalExit_1"},
				[3] = {{1,1},{1,3},"PortalEntrance_1","PortalExit_1"},
				[4] = {{1,4},{1,6},"PortalEntrance_1","PortalExit_1"},
				[5] = {{2,1},{2,3},"PortalEntrance_1","PortalExit_1"},
				[6] = {{2,4},{2,6},"PortalEntrance_1","PortalExit_1"},
				[7] = {{3,1},{3,3},"PortalEntrance_1","PortalExit_1"},
				[8] = {{3,4},{3,6},"PortalEntrance_1","PortalExit_1"},
				[9] = {{4,1},{4,3},"PortalEntrance_1","PortalExit_1"},
				[10] = {{4,4},{4,6},"PortalEntrance_1","PortalExit_1"},
				[11] = {{5,1},{5,3},"PortalEntrance_1","PortalExit_1"},
				[12] = {{5,4},{5,6},"PortalEntrance_1","PortalExit_1"},
				[13] = {{6,1},{6,3},"PortalEntrance_1","PortalExit_1"},
				[14] = {{6,4},{6,6},"PortalEntrance_1","PortalExit_1"},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "DoubleLineLarge",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				[2] = {
					patternName = "3LayerBombs_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
			},
			additionalRegularPlacements = {
				{
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 15,
					frequencies = {1,1,2,2,3,3,3},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone"},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["FillTheTank"] = {
		levelName = "Fill the Tank",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins9 = true,
			hasCoverage = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSteel = true,
			hasCrates = true,
			hasMakers = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{0,3},{0,5},"PortalEntrance_1","PortalExit_1"},
				[2] = {{6,3},{6,5},"PortalEntrance_1","PortalExit_1"},
				[3] = {{3,3},{3,5},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Gem-Crate Mix",
					delay = 0,
					{ 
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 1,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2.5,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2.5,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2.5,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2.5,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "FillTheTank_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Gem-Crate Mix"},
				},
				{
					patternName = "FillTheTank_crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "BigCratePattern9",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "Bottom3_large",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000,
	},

	["YayPortal"] = {
		levelName = "Yay Portal",
		resource = "GameScreen_Land1",	
		introScript = "Land24_Intro",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasChests = true,
			hasPortals = true,
			hasFences = true,
			hasMakers = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			portals = {
				[1] = {{0,5},{5,1},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
                [1] = {
                    name = "Add 3 Chests",
                    delay = -1,
					shuffle = false,
                    events = {
                        [1] = {
                            eventType = "population",
                            count = 0,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 3.
                            eventType = "emitCount",
                            count = 3,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [2] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
            },
			additionalInitialPatterns = { 
				{
					patternName = "Portal_topLeft",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Add 3 Chests","Normal mix",},
				},
				{
					patternName = "Portal_topRight",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "Portal_bottomLeft",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",9,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},

	["BombChase"] = {
		levelName = "Bomb Chase",
		resource = "GameScreen_Land24",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasMakers = true,
			hasMissingReels = true,
			hasSteel = true,
			hasPortals = true,
			hasBombs = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "2LeftReels", 
				isPatternSet = false,
            },
			portals = {
				[1] = {{5,1},{0,0},"PortalEntrance_1","PortalExit_1"},
				[2] = {{0,6},{5,2},"PortalEntrance_1","PortalExit_1"},
				[3] = {{5,6},{3,0},"PortalEntrance_1","PortalExit_1"},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Bomb Mix",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Bomb Mix",
					delay = 0,
					{
						name = "Bomb Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels + CascadePieceSpecial_Valuable,
						turnsToLoss = 5,
						weight = 2.5,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CornerSteel_topRight_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix"},
				},
				[2] = {
					patternName = "LeftColumn2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Tower1_block6",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels + CascadePieceSpecial_Valuable,
					turnsToLoss = 6,
					applyTurnsToLoss = true,
				}
			},
		},
		goals = {
			main = {"getGem",20,"Bomb","Bombs",{specials = CascadePieceSpecials_Barrels + CascadePieceSpecial_Valuable},"Defuse"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",1100000},
			},
		},
	},

	["OverAndOver"] = {
		levelName = "Over And Over",
		resource = "GameScreen_Land1",	
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasPortals = true,
			hasMakers = true,
			hasChests = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{0,4},{3,2},"PortalEntrance_1","PortalExit_1"},
				[2] = {{3,5},{6,3},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
                [1] = {
                    name = "Add 4 Chests",
                    delay = -1,
                    events = {
                        [1] = {
                            eventType = "population",
                            count = 0,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 4.
                            eventType = "emitCount",
                            count = 4,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
            },
			additionalInitialPatterns = { 
				{
					patternName = "OverAndOver_topLeft",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Add 4 Chests",},
				},
				{
					patternName = "OverAndOver_topRight",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "OverAndOver_bottomLeft",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,--CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "OverAndOver_topMiddle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "OverAndOver_bottomMiddle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,--CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",12,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",250000},
				[3] = {"score",600000},
			},
		},
	},

	["TwoTowers"] = {
		levelName = "Two Towers",
		resource = "GameScreen_Land1",	
		introScript = "Land24_Tip1",	
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasCoverage = true,
			hasPortals = true,
			hasFences = true,
			hasMissingSquares = true,
			hasMissingReels = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			portals = {
				[1] = {{4,6},{0,1},"PortalEntrance_1","PortalExit_1"},
				[2] = {{5,6},{1,1},"PortalEntrance_1","PortalExit_1"},
				[3] = {{6,6},{2,1},"PortalEntrance_1","PortalExit_1"},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "TwoTowers_middle", 
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "TwoTowers_Reels", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				{
					patternName = "TwoTowers_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "TwoTowers_pattern",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",350000},
			},
		},
	},

	["BurstChain"] = {
		levelName = "Ripples",					
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins10 = true,
			hasStones = true,
			hasFences = true,
			gemTypes4 = true,
			regularBoard = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BottomChecksLeft",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "BottomChecksLeft2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
			addToBoardPieceMix = {
				{
                    name = "Area Burst 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
                    weight = 1.5,
                },
				{
                    name = "Area Burst 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
                    weight = 1.5,
                },
				{
                    name = "Area Burst 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
                    weight = 1.5,
                },
				{
                    name = "Area Burst 4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
                    weight = 1.5,
                },
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone"},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
	},

	["SplitFall"] = {
		levelName = "Split Fall",					
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			hasSteel = true,
			hasFences = true,
			gemTypes4 = true,
			largeBoard = true,
			treasureChest = true,
			hasGemEaters = true,
			hasChests = true,
			hasMissingSquares = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "TopCornerSlant", 
				isPatternSet = false,
			},
			portals = {
				[1] = {{6,7},{2,3},"PortalEntrance_1","PortalExit_1"},
				[2] = {{0,7},{4,3},"PortalEntrance_1","PortalExit_1"},
				[3] = {{3,6},{3,1},"PortalEntrance_1","PortalExit_1"},
				[4] = {{3,1},{3,4},"PortalEntrance_1","PortalExit_1"},
				[5] = {{3,4},{3,7},"PortalEntrance_1","PortalExit_1"},
			},
			additionalInitialPatterns = {
				{
					patternName = "SplitFall_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "SplitFall_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "SplitFall_eater",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",450000},
			},
		},
	},

	["GemShower"] = {
		levelName = "Trickle Down",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasStones = true,
			hasCoverage = true,
			largeBoard = true,
			gemTypes4 = true,
			hasFences = true,
			hasMissingSquares = true,
			hasMissingReels = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World24Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			useMissingSquares = true,
            missingSquares = {
                patternName = "NarrowSpout_missing",
                isPatternSet = false,
            },
			additionalInitialPatterns = { 
				{
					patternName = "NarrowSpout_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "NarrowSpout_pattern",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "NarrowSpout_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
		expectedScore = 100000,
	},

	["PortalsGemEaters"] = {
		levelName = "Pits of Doom",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasGemEaters = true,
			hasChests = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{1,2},{0,4},"PortalEntrance_1","PortalExit_1"},
				[2] = {{3,2},{2,4},"PortalEntrance_1","PortalExit_1"},
				[3] = {{5,2},{4,4},"PortalEntrance_1","PortalExit_1"},
			},
			additionalInitialPatterns = {
				{
					patternName = "PitsOfDoom_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					frequencies = {1,10,10},
				},
			},
		},
		goals = {
			main = {"getGem",7,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000,
	},

	["RockFall"] = {
		levelName = "Rock Fall",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			hasMissingSquares = true,
			hasPortals = true,
			hasLocks = true,
			hasBarrels = true,
			hasGemEaters = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{0,0},{0,5},"PortalEntrance_1","PortalExit_1"},
				[2] = {{1,0},{1,5},"PortalEntrance_1","PortalExit_1"},
				[3] = {{2,0},{2,5},"PortalEntrance_1","PortalExit_1"},
				[4] = {{3,0},{3,5},"PortalEntrance_1","PortalExit_1"},
				[5] = {{4,0},{4,5},"PortalEntrance_1","PortalExit_1"},
				[6] = {{5,0},{5,5},"PortalEntrance_1","PortalExit_1"},
				[7] = {{6,0},{6,5},"PortalEntrance_1","PortalExit_1"},
				[8] = {{0,4},{0,7},"PortalEntrance_1","PortalExit_1"},
				[9] = {{1,4},{1,7},"PortalEntrance_1","PortalExit_1"},
				[10] = {{2,4},{2,7},"PortalEntrance_1","PortalExit_1"},
				[11] = {{3,4},{3,7},"PortalEntrance_1","PortalExit_1"},
				[12] = {{4,4},{4,7},"PortalEntrance_1","PortalExit_1"},
				[13] = {{5,4},{5,7},"PortalEntrance_1","PortalExit_1"},
				[14] = {{6,4},{6,7},"PortalEntrance_1","PortalExit_1"},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "Line8_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				{
                    patternName = "Line7_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    weight = 0,
                },
				{
                    patternName = "Line6_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    weight = 0,
                },
				{
                    patternName = "Line5_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    weight = 0,
                },
				{
					patternName = "Line4_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",175000},
			},
		},
	},

	["LavaChecks"] = {
		levelName = "Checkered Lava",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			regularBoard = true,
			modeSpins8 = true,
			gemTypes5 = true,
			hasLava = true,
			hasJailedSquares = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BottomChecks3Rows",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "BottomChecks3Rows2",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["CornerBlocks"] = {
		levelName = "Corner Blocks",
		resource = "GameScreen_Land24",		
		outtroScript = "Land24_Outtro",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			hasPortals = true,
			gemTypes3 = true,
			hasVines = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{4,2},{0,0},"PortalEntrance_1","PortalExit_1"},
				[2] = {{5,2},{1,0},"PortalEntrance_1","PortalExit_1"},
				[3] = {{6,2},{2,0},"PortalEntrance_1","PortalExit_1"},
				[4] = {{4,7},{0,5},"PortalEntrance_1","PortalExit_1"},
				[5] = {{5,7},{1,5},"PortalEntrance_1","PortalExit_1"},
				[6] = {{6,7},{2,5},"PortalEntrance_1","PortalExit_1"},
				[7] = {{0,3},{4,4},"PortalEntrance_1","PortalExit_1"},
				[8] = {{1,3},{5,4},"PortalEntrance_1","PortalExit_1"},
				[9] = {{2,3},{6,4},"PortalEntrance_1","PortalExit_1"},

			},
			useMissingReels = true,
			missingReels = {
				patternName = "TowerToTheClouds_Reels", 
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "Quadrants_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "CornerBlocks_vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["YayPortal_side"] = {
		levelName = "Down Up Down",
		resource = "GameScreen_Land1",	
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasChests = true,
			hasPortals = true,		
			hasFences = true,		
			hasMakers = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			portals = {
				[1] = {{2,5},{3,1},"PortalEntrance_1","PortalExit_1"},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "YayPortal_side_missing", 
				isPatternSet = false,
            },			
			additionalNamedMixes = {
                [1] = {
                    name = "Add 3 Chests",
                    delay = -1,
                    events = {
                        [1] = {
                            eventType = "population",
                            count = 0,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 3.
                            eventType = "emitCount",
                            count = 3,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [2] = {
                    name = "Add 2 Chests",
                    delay = -1,
                    events = {
                        [1] = {
                            eventType = "population",
                            count = 1,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                               specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 3.
                            eventType = "emitCount",
                            count = 2,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [3] = {
                    name = "Add 1 Chest",
                    delay = -1,
                    events = {
                        [1] = { 
                            eventType = "population",
                            count = 2,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 3.
                            eventType = "emitCount",
                            count = 1,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
                [4] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
            },
			
			additionalInitialPatterns = { 
				{
					patternName = "Portal_topLeft_side",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Add 3 Chests",},
				},
				{
					patternName = "Portal_bottomLeft_side",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,--CascadePieceSpecials_Steel,
					matchFlags = 0,
				},

			},
		},
		goals = {
			main = {"getGem",9,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",600000},
				[3] = {"score",700000},
			},
		},
	},

    ["OverAndOver_side"] = {
		levelName = "revO dnA revO",
		resource = "GameScreen_Land1",	
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasPortals = true,
			hasMakers = true,
			hasChests = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			portals = {
				{{6,6},{6,4},"PortalEntrance_1","PortalExit_1"},
                {{6,4},{6,3},"PortalEntrance_1","PortalExit_1"},
                {{6,3},{3,5},"PortalEntrance_1","PortalExit_1"},
                {{3,5},{3,4},"PortalEntrance_1","PortalExit_1"},
                {{3,4},{3,3},"PortalEntrance_1","PortalExit_1"},
                {{3,3},{3,2},"PortalEntrance_1","PortalExit_1"},
                {{3,2},{0,4},"PortalEntrance_1","PortalExit_1"},
                {{0,4},{0,3},"PortalEntrance_1","PortalExit_1"},
                {{0,3},{0,2},"PortalEntrance_1","PortalExit_1"},
                {{0,2},{0,1},"PortalEntrance_1","PortalExit_1"},
                {{0,1},{0,0},"PortalEntrance_1","PortalExit_1"},
                {{0,0},{6,7},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
                [1] = {
                    name = "Add 4 Chests",
                    delay = -1,
                    events = {
                        [1] = {
                            eventType = "population",
                            count = 0,
                            comparator = "equals",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Treasure,
                            },
                        },
                        [2] = { --Stop when you've made 4.
                            eventType = "emitCount",
                            count = 4,
                            newDelay = -1,
                        },
                    },
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
            },
			additionalInitialPatterns = { 
				{
					patternName = "OverAndOver_side_topLeft",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Add 4 Chests",},
				},
				{
					patternName = "OverAndOver_side_topRight",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "OverAndOver_side_bottomLeft",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,--CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "OverAndOver_side_topMiddle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "OverAndOver_side_bottomMiddle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,--CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",12,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",350000},
				[3] = {"score",450000},
			},
		},
	},

    ["RockFall_side"] = {
		levelName = "Rock Float",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			hasMissingSquares = true,
			hasPortals = true,
			hasLocks = true,
			hasBarrels = true,
			hasGemEaters = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			portals = {
				{{0,0},{0,5},"PortalEntrance_1","PortalExit_1"},
				{{1,0},{1,5},"PortalEntrance_1","PortalExit_1"},
				{{2,0},{2,5},"PortalEntrance_1","PortalExit_1"},
				{{3,0},{3,5},"PortalEntrance_1","PortalExit_1"},
				{{4,0},{4,5},"PortalEntrance_1","PortalExit_1"},
				{{5,0},{5,5},"PortalEntrance_1","PortalExit_1"},
				{{6,0},{6,5},"PortalEntrance_1","PortalExit_1"},

                {{0,4},{0,7},"PortalEntrance_1","PortalExit_1"},
				{{1,4},{1,7},"PortalEntrance_1","PortalExit_1"},
				{{2,4},{2,7},"PortalEntrance_1","PortalExit_1"},
				{{3,4},{3,7},"PortalEntrance_1","PortalExit_1"},
				{{4,4},{4,7},"PortalEntrance_1","PortalExit_1"},
				{{5,4},{5,7},"PortalEntrance_1","PortalExit_1"},
				{{6,4},{6,7},"PortalEntrance_1","PortalExit_1"},

                {{0,5},{0,7},"PortalEntrance_1","PortalExit_1"},
				{{1,5},{1,7},"PortalEntrance_1","PortalExit_1"},
				{{2,5},{2,7},"PortalEntrance_1","PortalExit_1"},
				{{3,5},{3,7},"PortalEntrance_1","PortalExit_1"},
				{{4,5},{4,7},"PortalEntrance_1","PortalExit_1"},
				{{5,5},{5,7},"PortalEntrance_1","PortalExit_1"},
				{{6,5},{6,7},"PortalEntrance_1","PortalExit_1"},

			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "Line8_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				{
                    patternName = "RockFall_side_Line7_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    weight = 0,
                },
				{
                    patternName = "RockFall_side_Line6_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    weight = 0,
                    extraHits = 1,
					applyExtraHits = true,
                },
				{
                    patternName = "RockFall_side_Line5_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    weight = 0,
                },
				{
					patternName = "RockFall_side_Line4_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",175000},
			},
		},
	},

})