-- Land 25: lasers

table.insertall(LevelDefs,
{
	["LaserWelcome"] = {
		levelName = "Lasers! Pew Pew!",
		resource = "GameScreen_Land25",	
		introScript = "Land25_Intro",
		Features = {
			modeSpins7 = true, 
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaserWelcome_pattern1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
				{
					patternName = "LaserWelcome_pattern_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "MarsStone",
					applySkinVariant = true,
				},
				{
					patternName = "LaserWelcome_pattern_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "MarsSteel",
					applySkinVariant = true,
				},
				{
					patternName = "LaserWelcome_pattern_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "MarsChest",
				},
			},
		},		
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
	},

	["LaserWelcome_side"] = {
		levelName = "Pew! Pew! Pew!",
		resource = "GameScreen_Land24",	
		Features = {
			largeBoard = true,
			modeSpins8 = true, 
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaserWelcome_side_pattern1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
				{
					patternName = "LaserWelcome_side_pattern_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "MarsStone",
					applySkinVariant = true,
				},
				{
					patternName = "LaserWelcome_side_pattern_steel",
					isPatternSet = false,

                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Fence,
                    matchFlags = 0,
--[[
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "MarsSteel",
					applySkinVariant = true,
--]]
				},
				{
					patternName = "LaserWelcome_side_pattern_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "MarsChest",
				},
			},
		},		
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			--main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",350000},
			},
		},
	},

	["LaserWall"] = {
		levelName = "Laser Wall",
		resource = "GameScreen_Land24",	
		Features = {
			largeBoard = true, 
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true, 
			hasLasers = true,
			hasStones = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "LaserWall_Reels",
				isPatternSet = false,
            },
			useMissingSquares = true,
			missingSquares = {
				patternName = "RightColumn2_Large",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Laser1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser1",},
						weight = 1,
					},
				},
				[2] = {
					name = "Laser2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser2",},
						weight = 1,
					},
				},
				[3] = {
					name = "Laser3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser3",},
						weight = 1,
					},
				},
				[4] = {
					name = "Laser4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser4",},
						weight = 1,
					},
				},
				[5] = {
					name = "Laser5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser5",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Laser1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[2] = {
						name = "Laser2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[3] = {
						name = "Laser3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[4] = {
						name = "Laser4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[5] = {
						name = "Laser5",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser5",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "RightColumnLarge",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "MarsStone",
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
				[2] = {
					patternName = "LaserWall_Laser1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser1",},
				},
				[3] = {
					patternName = "LaserWall_Laser2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
				},
				[4] = {
					patternName = "LaserWall_Laser3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
				[5] = {
					patternName = "LaserWall_Laser4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser4",},
				},
				[6] = {
					patternName = "LaserWall_Laser5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser5",},
				},
				[7] = {
					patternName = "LaserWall_Laser6",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser1",},
				},
				[8] = {
					patternName = "LaserWall_Laser7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
				},
				[9] = {
					patternName = "LaserWall_Laser8",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",3400000},
			},
		},
	},

    ["LaseTheRainbow"] = {
		levelName = "Lase the Rainbow",
		resource = "GameScreen_Land24",	
		Features = {
			regularBoard = true,
			modeSpins6 = true, 
			splashMode = true,
			gemTypes4 = true,
			hasLasers = true,
			hasStones = true,
            hasBarrels = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
            additionalRegularPlacements = {
                {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,0,1,0,2,0,2,0,3,0,3,0,0,4},
                    applyExtraHits = true,
                    extraHits = 1,
					skinVariant = "MarsBoulder",
				},
			},
			additionalNamedMixes = {
				{
					name = "LaserH 1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 2",},
						weight = 1,
					},
				},
                {
					name = "LaserH 2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 3",},
						weight = 1,
					},
				},
                {
					name = "LaserH 3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 4",},
						weight = 1,
					},
				},
                {
					name = "LaserH 4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 1",},
						weight = 1,
					},
                },
                {
					name = "Gems Mix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 22,
                            newDelay = 1,
                        },
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 2,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 2,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 2,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 2,
                    },
                },
			},
			endGameProperties = {
				additionalNamedMixes = {
                    {
						name = "LaserH 1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaseTheRainbow_Lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH 3",},
				},
                {
					patternName = "LaseTheRainbow_Stones",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "MarsStone",
					applySkinVariant = true,
				},
                {
                    patternName = "LaseTheRainbow_Boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyExtraHits = true,
                    extraHits = 1,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "MarsBoulder",
                },
                {
                    patternName = "LaseTheRainbow_Makers",
					isPatternSet = false,

                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Gems Mix"},
                },
                {
                    patternName = "LaseTheRainbow_Eaters",
					isPatternSet = false,
                    gemEater = true,
					applyGemEater = true,
                },
                {
                    patternName = "LaseTheRainbow_Steel",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
					skinVariant = "MarsSteel",
					applySkinVariant = true,
                },
			},
		},		
		goals = {
			main = {"getGem",20,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels, extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",450000},
				[3] = {"score",500000},
			},
		},
	},

	["PewPew"] = {
		levelName = "Scatter Shot",
		resource = "GameScreen_Land24",
        introScript = "Land25_ScatterShot",
		Features = {
			regularBoard = true, 
			modeSpins2 = true,
			splashMode = true,
			gemTypes4 = true, 
			hasLasers = true,
		},
		tricks = {
			{name = Config.World25Tricks_Trick1},
			{name = Config.World25Tricks_Trick2},
			{name = Config.World25Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World25Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Horizontal Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
				},
				{
					name = "Vertical Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Horizontal Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Horizontal Color Changing Laser",},
							weight = 1,
						},
					},
					{
						name = "Vertical Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Vertical Color Changing Laser",},
							weight = 1,
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "PewPew_HorizontalBursts",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Horizontal Color Changing Laser",},
				},
				{
					patternName = "PewPew_VerticalBursts",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Vertical Color Changing Laser",},
				},
			},
		},		
		goals = {
			main = {"getGem",100,"Laser","Lasers",{
				{specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,},
				{specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,}, 
				{specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash |CascadePieceSpecial_HorizontalSplash,}, 
			},"Fire"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1300000},
				[3] = {"score",2300000},
			},
		},
	},

	--Testing level here
	["OlympusMons"] = {
		levelName = "Olympus Mons",
		resource = "GameScreen_Land24",	
		Features = {
			largeBoard = true, 
			modeSpins5 = true, 
			splashMode = true,
			gemTypes5 = true,
			hasLava = true,
			hasMissingReels = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "OlympusMons_reels",
                isPatternSet = false,
            },

            additionalRegularPlacements = {
				{
					matchFlags = 15,
					anyOneMatchFlag = true,
					--specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_DontMoveDown + CascadePieceSpecial_DontCountForCoverage + CascadePieceSpecial_DontCountForMatchSize + CascadePieceSpecial_SpreadAdjacent + CascadePieceSpecial_SpreadAndConsume,
				},
            },

			useMissingSquares = true,
			missingSquares = {
				patternName = "OlympusMons_missing",
				isPatternSet = false,
			},
			
			additionalInitialPatterns = { 
				[1] = {
					patternName = "OlympusMons_lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				[2] = {
					patternName = "OlympusMons_core",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",400000},
				[3] = {"score",900000},
			},
		},
	},
	--Testing level ended

    ["SeekAndDestroy"] = {
		levelName = "Seek and Destroy",
		resource = "GameScreen_Land25",	
		Features = {
			largeBoard = true, 
			modeSpins5 = true, 
			splashMode = true,
			gemTypes6 = true, 
			hasLasers = true,
            hasBombs = true,
            hasGemEaters = true,
			hasCoverage = true,
            hasSteel = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {

            additionalRegularPlacements = {
				{
					matchFlags = 63,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 7,
					frequencies = {1,0,2,0,3,0,4,0,5,0,6,0},
				},
            },

			useMissingReels = true,
            missingReels = {
				patternName = "SeekAndDestroy_Reels",
				isPatternSet = false,
            },
			useMissingSquares = true,
			missingSquares = {
				patternName = "SeekAndDestroy_Missing",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
                {
					name = "LaserV",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
				{
					name = "Boulder",
					delay = 0,
					{
						name = "Boulder",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 12,
						skinVariant = "MarsBoulder",
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
                    {
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "SeekAndDestroy_LasersH",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
                {
					patternName = "SeekAndDestroy_LasersV",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
                {
					patternName = "SeekAndDestroy_Clouds",
					isPatternSet = false,
					applyMatchFlags = true,
					applyPieceSpecials = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applySkinVariant = true,
					skinVariant = "MarsBoulder",
				},
                {
					patternName = "SeekAndDestroy_Eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
                {
					patternName = "SeekAndDestroy_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulder"},
				},
			},
		},		
		goals = {
			main = {"getGem",12,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
	},

	["LockTumblers"] = {
		levelName = "Lock Tumblers",
		resource = "GameScreen_Land24",	
		Features = {
			largeBoard = true, 
			modeSpins7 = true, 
			splashMode = true,
			gemTypes4 = true, 
			hasLasers = true,
			hasBarrels = true,
			hasCoverage = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "ReelPosition7", 
				isPatternSet = false,
            },
			useMissingSquares = true,
			missingSquares = {
				patternName = "LockTumblers_Missing",
				isPatternSet = false,
			},
			boardPieceMix = {
				{
					name = "Two Hit Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					skinVariant = "MarsBoulder",
					weight = 11,
				},
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
			},
			additionalNamedMixes = {
                {
                    name = "Laser Mix",
                    {
                        name = "Laser 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"Laser Mix",},
                        weight = 1,
                        skinVariant = "LaserH",
                    },
                    {
                        name = "Laser 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"Laser Mix",},
                        weight = 1,
                        skinVariant = "LaserH",
                    },
                    {
                        name = "Laser 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"Laser Mix",},
                        weight = 1,
                        skinVariant = "LaserH",
                    },
                    {
                        name = "Laser 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"Laser Mix",},
                        weight = 1,
                        skinVariant = "LaserH",
                    },
                },
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Laser Mix",
						{
							name = "Laser 1",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser Mix",},
							weight = 1,
							skinVariant = "LaserH",
						},
						{
							name = "Laser 2",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser Mix",},
							weight = 1,
							skinVariant = "LaserH",
						},
						{
							name = "Laser 3",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser Mix",},
							weight = 1,
							skinVariant = "LaserH",
						},
						{
							name = "Laser 4",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser Mix",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LockTumblers_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "MarsSteel",
				},
				{
					patternName = "LockTumblers_Laser",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser Mix",},
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
					skinVariant = "LaserH",
				},
				{
					patternName = "LockTumblers_Boulders",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "MarsBoulder",
				},
				{
					patternName = "LockTumblers_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 3,
					clearPieces = true,
				},
                {
					patternName = "LockTumblers_Makers",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Laser Mix",},
					applySkinVariant = true,
					skinVariant = "",
				},
                {
					patternName = "LockTumblers_Eaters",
					isPatternSet = false,
                    gemEater = true,
					applyGemEater = true,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",900000},
			},
		},
	},

    ["WildLasers"] = {
		levelName = "Wild Lasers",
		resource = "GameScreen_Land24",
        introScript = "Land25_WildLasers",
		Features = {
			largeBoard = true, 
			modeSpins5 = true, 
			splashMode = true,
			gemTypes5 = true, 
			hasLasers = true,
			hasJailedGems = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingReels = false,
            missingReels = {
				patternName = "EdgeReels_Large",
				isPatternSet = false,
            },
			additionalNamedMixes = {
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
				{
					name = "LaserH_1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_1",},
						weight = 1,
					},
				},
                {
					name = "LaserV",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
                    {
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
                    {
						name = "LaserH_1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH_1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "WildLasers_HorizontalLasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "WildLasers_HorizontalLasers_Colored",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH_1",},
				},
                {
					patternName = "WildLasers_VerticalLasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
                {
					patternName = "WildLasers_Targets",
					isPatternSet = false,
					
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "MarsStone",
				},
                {
                    patternName = "WildLasers_Fences",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Fence,
                    matchFlags = 0,
                },
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone,},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",2500000},
			},
		},
	},

    ["LengthyLaser"] = {
		levelName = "Lengthy Laser",
		resource = "GameScreen_Land24",	
		Features = {
			largeBoard = true, 
			modeSpins5 = true, 
			splashMode = true,
			gemTypes6 = true, 
			hasLasers = true,
			hasGiftBoxes = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Gift_Horizontal",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_1",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_2",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_3",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_4",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_5",},
						weight = 1,
					},
					{
						name = "Laser6",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_6",},
						weight = 1,
					},
				},
				{
					name = "LaserH_1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_1",},
						weight = 1,
					},
				},
				{
					name = "LaserH_2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_2",},
						weight = 1,
					},
				},
				{
					name = "LaserH_3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_3",},
						weight = 1,
					},
				},
				{
					name = "LaserH_4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_4",},
						weight = 1,
					},
				},
				{
					name = "LaserH_5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_5",},
						weight = 1,
					},
				},
				{
					name = "LaserH_6",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_6",},
						weight = 1,
					},
				},
                {
					name = "Gift_Vertical",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_1",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_2",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_3",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_4",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_5",},
						weight = 1,
					},
					{
						name = "Laser6",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_6",},
						weight = 1,
					},
				},
                {
					name = "LaserV_1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_1",},
						weight = 1,
					},
				},
                {
					name = "LaserV_2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_2",},
						weight = 1,
					},
				},
                {
					name = "LaserV_3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_3",},
						weight = 1,
					},
				},
                {
					name = "LaserV_4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_4",},
						weight = 1,
					},
				},
                {
					name = "LaserV_5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_5",},
						weight = 1,
					},
				},
                {
					name = "LaserV_6",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_6",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserH_1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH_1",},
							weight = 1,
						},
					},
					{
						name = "LaserH_2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH_2",},
							weight = 1,
						},
					},
					{
						name = "LaserH_3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH_3",},
							weight = 1,
						},
					},
					{
						name = "LaserH_4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH_4",},
							weight = 1,
						},
					},
					{
						name = "LaserH_5",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH_5",},
							weight = 1,
						},
					},
					{
						name = "LaserH_6",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece6,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH_6",},
							weight = 1,
						},
					},
					{
						name = "LaserV_1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_1",},
							weight = 1,
						},
					},
					{
						name = "LaserV_2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_2",},
							weight = 1,
						},
					},
					{
						name = "LaserV_3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_3",},
							weight = 1,
						},
					},
					{
						name = "LaserV_4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_4",},
							weight = 1,
						},
					},
					{
						name = "LaserV_5",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_5",},
							weight = 1,
						},
					},
					{
						name = "LaserV_6",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece6,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_6",},
							weight = 1,
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LengthyLaser_Vertical_0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applySpawnTypes = true,
					spawnTypes = {"LaserV_6",},
				},
				{
					patternName = "LengthyLaser_Vertical_1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Gift_Vertical"},
					applyExtraHits = true,
					extraHits = 0,
				},
				{
					patternName = "LengthyLaser_Vertical_2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Gift_Vertical"},
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "LengthyLaser_Vertical_3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Gift_Vertical"},
					applyExtraHits = true,
					extraHits = 2,
				},
				{
					patternName = "LengthyLaser_Horizontal_1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Gift_Horizontal"},
					applyExtraHits = true,
					extraHits = 0,
				},
				{
					patternName = "LengthyLaser_Horizontal_2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Gift_Horizontal"},
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "LengthyLaser_Horizontal_3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Gift_Horizontal"},
					applyExtraHits = true,
					extraHits = 2,
				},
			},
		},		
		goals = {
			main = {"getGem",13,"Gift","Gifts",{specials = CascadePieceSpecials_Stone, extraHits = 0,},"Open"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",1400000},
			},
		},
	},

    ["MoltenCore"] = {
		levelName = "Molten Core",
		resource = "GameScreen_Land24",	
		Features = {
			largeBoard = true, 
			modeSpins4 = true, 
			splashMode = true,
			gemTypes5 = true, 
			hasLasers = true,
            hasLava = true,
            hasMakers = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {

            useMissingReels = true,
            missingReels = {
				patternName = "MoltenCore_Reels",
				isPatternSet = false,
            },

			endGameProperties = {
				additionalNamedMixes = {
                    {
						name = "Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
                    {
						name = "Lava Mix",
						{
							name = "Orange",
							matchFlags = CascadeMatchFlags_CommonPiece6,
							weight = 1,
						},
					},
				},
			},
            additionalNamedMixes = {
                {
					name = "Laser",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser",},
						weight = 1,
					},
				},
				{
					name = "Barrel Mix",
					{
						name = "Barrel",
                        applyPieceSpecials = true,
                        specials = CascadePieceSpecials_Barrels,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        spawnTypes = {"Lava Mix"},
						weight = 1,
					},
				},
                {
					name = "Lava Mix",
					delay = 0,
                    {
                        name = "Lava",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Lava,
                        weight = 1,
                    },
                },
            },

			additionalInitialPatterns = {
				{
					patternName = "MoltenCore_Lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser",},
				},

                {
					patternName = "MoltenCore_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Lava,
				},
                {
					patternName = "MoltenCore_Makers",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Barrel Mix",},
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",800000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},
	
    ["LaserDispenser"] = {
		levelName = "Laser Dispenser",
		resource = "GameScreen_Land24",	
		Features = {
			largeBoard = true, 
			modeSpins7 = true, 
			splashMode = true,
			gemTypes5 = true, 
			hasLasers = true,
			hasMakers = true,
			hasChests = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "LaserDispenser_Reels",
				isPatternSet = false,
            },
			additionalNamedMixes = {
				{
					name = "Left Maker Chest",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								specials = CascadePieceSpecials_Crates,
							},
						},
					},
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
						skinVariant = "MarsChest",
					},
				},
				{
					name = "Right Maker Chest",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								specials = CascadePieceSpecials_Crates,
							},
						},
					},
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
						skinVariant = "MarsChest",
					},
				},
				{
					name = "Make Crates",
					delay = 0,
					{ 
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 6,
						skinVariant = "MarsCrate",
					},
				},
				{
					name = "Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Color Changing Laser",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Color Changing Laser",},
							weight = 1,
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaserDispenser_HorizontalBursts",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Color Changing Laser",},
				},
				{
					patternName = "LaserDispenser_LeftMaker",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Left Maker Chest","Make Crates"},
				},
				{
					patternName = "LaserDispenser_RightMaker",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Right Maker Chest","Make Crates"},
				},
				{
					patternName = "LaserDispenser_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "MarsSteel",
				},
			},
		},		
		goals = {
			main = {"getGem",20,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1200000},
				[3] = {"score",3300000},
			},
		},
	},

    ["ImpossibleBlast"] = {
		levelName = "Impossible Blast",
		resource = "GameScreen_Land25",	
		outtroScript = "Land25_Outtro",
		Features = {
			largeBoard = true, 
			modeSpins5 = true, 
			splashMode = true,
			gemTypes5 = true, 
			hasLasers = true,
			hasMakers = true,
            hasGemEaters = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "ImpossibleBlast_Reels",
				isPatternSet = false,
            },
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
			},
			additionalNamedMixes = {
                {
					name = "Gems Mix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 22,
                            newDelay = 1,
                        },
                    },
                    {
                        name = "1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "5",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                    {
                        name = "6",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        weight = 4,
                    },
                },
				{
					name = "LaserH 1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 3",},
						weight = 1,
					},
				},
                {
					name = "LaserH 2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 4",},
						weight = 1,
					},
				},
                {
					name = "LaserH 3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 5",},
						weight = 1,
					},
				},
                {
					name = "LaserH 4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 1",},
						weight = 1,
					},
				},
                {
					name = "LaserH 5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 2",},
						weight = 1,
					},
				},
                {
					name = "LaserV 5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserH 1",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
                    {
						name = "LaserH 1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 5",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 5",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "ImpossibleBlast_Lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH 2",},
				},
                {
					patternName = "ImpossibleBlast_Eaters",
					isPatternSet = false,
                    gemEater = true,
					applyGemEater = true,

				},
                {
					patternName = "ImpossibleBlast_Makers",
					isPatternSet = false,

                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Gems Mix"},
				},
			},
		},
		goals = {
			main = {"getGem",12,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6}},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

    ["LaserSusan"] = {
		levelName = "Laser Susan",
		resource = "GameScreen_Land25",	
		Features = {
			largeBoard = true, 
			modeSpins5 = true, 
			splashMode = true,
			gemTypes4 = true, 
			hasLasers = true,
			hasCoverage = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "LaserSusan_Reels",
				isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
				patternName = "LaserSusan_Missing",
				isPatternSet = false,
            },
			additionalNamedMixes = {
				{
					name = "LaserH 1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserV 2",},
						weight = 1,
					},
				},
                {
					name = "LaserV 1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserH 2",},
						weight = 1,
					},
				},
                {
					name = "LaserH 2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserV 3",},
						weight = 1,
					},
				},
                {
					name = "LaserV 2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserH 3",},
						weight = 1,
					},
				},
                {
					name = "LaserH 3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserV 4",},
						weight = 1,
					},
				},
                {
					name = "LaserV 3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserH 4",},
						weight = 1,
					},
				},
                {
					name = "LaserH 4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserV 1",},
						weight = 1,
					},
				},
                {
					name = "LaserV 4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserH 1",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
                    {
						name = "LaserH 1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV 2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserV 1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 2",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH 2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV 3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserV 2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 3",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH 3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV 4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserV 3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 4",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH 4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV 1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserV 4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 1",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaserSusan_Lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV 2",},
				},
                {
					patternName = "LaserSusan_Clouds",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 3,
					clearPieces = true,
                    specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
                {
					patternName = "LaserSusan_VineGenerators",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    skinVariant = "VineGrower",
                    applySkinVariant = true,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},
	["SlowFill"] = {
		levelName = "Slow Fill",
		resource = "GameScreen_Land18",
        introScript = "Land25_SlowFill",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMakers = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Scarce Mix",
						delay = 0,
						events = {
							[1] = {
								eventType = "emitCount",
								count = 2,
								newDelay = 1,
								reset = true,
							},
						},
						{
							name = "Blue",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							weight = 2,
						},
						{
							name = "Green",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							weight = 2,
						},
						{
							name = "Purple",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							weight = 2,
						},
						{
							name = "Red",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							weight = 2,
						},
						{
							name = "Yellow",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							weight = 2,
						},
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Scarce Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 4,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "UpperLine1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Scarce Mix"},
				},
			},
		},
		goals = {
			main = {"gemsRemain",12,"Gem","Gems",{
						{matchFlags = CascadeMatchFlags_CommonPiece1,},
						{matchFlags = CascadeMatchFlags_CommonPiece2,},
						{matchFlags = CascadeMatchFlags_CommonPiece3,},
						{matchFlags = CascadeMatchFlags_CommonPiece4,},
						{matchFlags = CascadeMatchFlags_CommonPiece5,},
					}},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",80000},
				[3] = {"score",100000},
			},
		},
	},
	["RandomRocks"] = {
		levelName = "Random Rocks",
		resource = "GameScreen_Land18",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMakers = true,
			hasPortals = true,
			treasureChest = true,
			hasMissingReels = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Intermittent Stones",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 2,
							newDelay = 2,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 3,
							newDelay = 1,
							reset = false,
						},
						[3] = {
							eventType = "emitCount",
							count = 5,
							newDelay = 2,
							reset = false,
						},
						[4] = {
							eventType = "emitCount",
							count = 8,
							newDelay = 3,
							reset = false,
						},
						[5] = {
							eventType = "emitCount",
							count = 9,
							newDelay = 2,
							reset = false,
						},
						[6] = {
							eventType = "emitCount",
							count = 10,
							newDelay = 1,
							reset = false,
						},
						[7] = {
							eventType = "emitCount",
							count = 12,
							newDelay = 3,
							reset = false,
						},
						[8] = {
							eventType = "emitCount",
							count = 13,
							newDelay = 2,
							reset = true,
						},
					},
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						extraHits = 1,
						skinVariant = "MarsStone",
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "SideCols",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Intermittent Stones"},
				},
				[2] = {
					patternName = "RandomStones_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "MarsStone",
				},
			},
			--     
			-- XX XX
			-- XX XX
			--   X 
			--   X  
			-- XX XX
			--   X  
			--   X 
			portals = {
				{{0,0},{1,1},"PortalEntrance_1","PortalExit_1"},
				{{0,1},{2,1},"PortalEntrance_1","PortalExit_1"},
				{{0,2},{4,1},"PortalEntrance_1","PortalExit_1"},
				{{0,3},{5,1},"PortalEntrance_1","PortalExit_1"},
				{{0,4},{1,2},"PortalEntrance_1","PortalExit_1"},
				{{0,5},{2,2},"PortalEntrance_1","PortalExit_1"},
                {{0,6},{4,2},"PortalEntrance_1","PortalExit_1"},
				{{0,7},{5,2},"PortalEntrance_1","PortalExit_1"},
				{{6,0},{3,3},"PortalEntrance_1","PortalExit_1"},
				--{{6,1},{3,4},"PortalEntrance_1","PortalExit_1"},
				{{6,2},{1,5},"PortalEntrance_1","PortalExit_1"},
				{{6,3},{2,5},"PortalEntrance_1","PortalExit_1"},
				{{6,4},{4,5},"PortalEntrance_1","PortalExit_1"},
				{{6,5},{5,5},"PortalEntrance_1","PortalExit_1"},
				{{6,6},{3,6},"PortalEntrance_1","PortalExit_1"},
				--{{6,7},{3,7},"PortalEntrance_1","PortalExit_1"},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{ specials = CascadePieceSpecials_Treasure,},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",800000},
			},
		},
	},

	["LockTumblers_side"] = {
		levelName = "Space Invaders",
		resource = "GameScreen_Land25",	
		Features = {
			largeBoard = true, 
			modeSpins9 = true,
			splashMode = true,
			gemTypes4 = true, 
			hasLasers = true,
			hasBarrels = true,
			hasCoverage = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "SpaceInvaders_missing",
				isPatternSet = false,
			},
			boardPieceMix = {
				{
					name = "Two Hit Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					skinVariant = "MarsBoulder",
					weight = 6,
				},
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
			},
			additionalNamedMixes = {
				{
					name = "Laser1",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Laser1",},
						weight = 1,
					},
				},
				{
					name = "Laser2",
					delay = 0,
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Laser2",},
						weight = 1,
					},
				},
				{
					name = "Laser3",
					delay = 0,
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Laser3",},
						weight = 1,
					},
				},
				{
					name = "Laser4",
					delay = 0,
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Laser4",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Laser1",
						delay = 0,
						{
							name = "Laser1",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser1",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "Laser2",
						delay = 0,
						{
							name = "Laser2",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser2",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "Laser3",
						delay = 0,
						{
							name = "Laser3",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser3",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "Laser4",
						delay = 0,
						{
							name = "Laser4",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser4",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Bin1_Bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser1",},
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
					skinVariant = "LaserV",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
				},
				{
					patternName = "Bin2_Bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
					skinVariant = "LaserV",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyMatchFlags = true,
				},
				{
					patternName = "Bin3_Bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
					skinVariant = "LaserV",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyMatchFlags = true,
				},
				{
					patternName = "Bin4_Bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser4",},
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
					skinVariant = "LaserV",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyMatchFlags = true,
				},
				{
					patternName = "SpaceInvaders_boulders",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "MarsBoulder",
					applyMatchRequirement = true,
					matchRequirement = 3,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",700000},
				[3] = {"score",1600000},
			},
		},
	},

	["LengthyLaser_side"] = {
		levelName = "Light Reflection",
		resource = "GameScreen_Land25",	
		Features = {
			largeBoard = true, 
			modeSpins5 = true, 
			splashMode = true,
			gemTypes4 = true, 
			hasLasers = true,
			hasGiftBoxes = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			additionalNamedMixes = {					
				{
					name = "LaserH_6",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH_6",},
						weight = 1,
					},
				},
                {
					name = "Gift_Vertical",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_1",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_2",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_3",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_4",},
						weight = 1,
					},
				},
                {
					name = "LaserV_1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_1",},
						weight = 1,
					},
				},
                {
					name = "LaserV_2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_2",},
						weight = 1,
					},
				},
                {
					name = "LaserV_3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_3",},
						weight = 1,
					},
				},
                {
					name = "LaserV_4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV_4",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV_1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_1",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserV_2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_2",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserV_3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_3",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserV_4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV_4",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
                    {
						name = "LaserH_6",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece6,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH_6",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LightReflect_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "MarsSteel",
					applySkinVariant = true,
				},
				{
					patternName = "Dungeon2_floor1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applySpawnTypes = true,
					spawnTypes = {"LaserH_6",},
				},
				{
					patternName = "LargeCorners",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Gift_Vertical"},
					applyExtraHits = true,
					extraHits = 2,
				},
				{
					patternName = "LightReflect_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"getGem",4,"Gift","Gifts",{specials = CascadePieceSpecials_Stone, extraHits = 0,},"Open"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",3500000},
			},
		},
	},

})