-- Land 26: ice

table.insertall(LevelDefs,
{

	["IceBarrels"] = {
		levelName = "Barrels of Ice",
		outtroScript = "Land26_Outtro",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes6 = true,
			hasIce = true,
			hasBarrelsOfFun = true,
			hasBombs = true,
		},
		Properties = {
            reelPieceMix = {
				{
					name = "Blue Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Green Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Purple Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Red Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Yellow Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Orange Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 10,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Ice 1",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 3,
				},
				{
					name = "Ice 2",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 3,
				},
				{
					name = "Ice 3",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 3,
				},
				{
					name = "Ice 4",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 3,
				},
				{
					name = "Ice 5",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 3,
				},
				{
					name = "Ice 6",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 3,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 15,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
		},
		goals = {
			main = {"haveGem",5,"Bomb","Bombs",{turnsToLoss = true,}},
			-- Also considering making this a haveGem goal, where we try to have a certain number of bombs on the board.
			stars = {
				[1] = {"score",30000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["FreezerBurn"] = {
		levelName = "Freezer Burn",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasIce = true,
            hasLava = true,
            hasMakers = true,
            hasMissingReels = true,
            hasMissingSquares = true,
            hasBarrels = true,
		},
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "FreezerBurn_Missing",
				isPatternSet = false,
			},
            useMissingReels = true,
			missingReels = {
				patternName = "FreezerBurn_Reels",
				isPatternSet = false,
			},
            additionalRegularPlacements = {
                {
                    name = "Barrel",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                    spawnTypes = {"Burst Mix"},
                    frequencies = {1,0,2,0,2,0,2,0,3,0,3,0,0,4},
                },
			},
            additionalNamedMixes = {
                {
                    name = "Burst Mix",
                    delay = 0,
					{
						name = "H 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
                    {
						name = "H 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
                    {
						name = "H 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
                    {
						name = "H 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
                    {
						name = "H 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
                    {
						name = "V 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
                    {
						name = "V 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
                    {
						name = "V 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
                    {
						name = "V 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
                    {
						name = "V 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
                    {
						name = "A 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 0.5,
					},
                    {
						name = "A 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 0.5,
					},
                    {
						name = "A 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 0.5,
					},
                    {
						name = "A 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 0.5,
					},
                    {
						name = "A 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 0.5,
					},
                },
                {
                    name = "Ice Mix",
                    {
                        name = "Ice 1",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 3,
                    },
                    {
                        name = "Ice 2",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 3,
                    },
                    {
                        name = "Ice 3",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 3,
                    },
                    {
                        name = "Ice 4",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 3,
                    },
                    {
                        name = "Ice 5",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 3,
                    },
                },
                {
					name = "Lava Mix",
					delay = 0,
                    {
                        name = "Lava",
                        applyPieceSpecials = true,
                        applyMatchFlags = true,
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Lava,
                        weight = 1,
                    },
                },
			},
			additionalInitialPatterns = {
				{
					patternName = "FreezerBurn_MakersIce",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Ice Mix",},
					applySkinVariant = true,
					skinVariant = "",
				},
                {
					patternName = "FreezerBurn_MakersLava",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Lava Mix",},
					applySkinVariant = true,
					skinVariant = "",
				},
                {
					patternName = "FreezerBurn_Lava",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Lava,
				},
                {
					patternName = "FreezerBurn_Ice",
					isPatternSet = false,
                    applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
			},
		},
		goals = {
            main = {"haveGem",4,"Ice.singular","Ice.plural",{spreadSpecials = CascadePieceSpecials_Ice},},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",450000},
			},
		},
	},

    ["AnInconvenientTrough"] = {
		levelName = "An Inconvenient Trough",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasIce = true,
            hasGemEaters = true,
            hasBarrels = true,
            hasMissingSquares = true,
		},
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "AnInconvenientTrough_Missing",
				isPatternSet = false,
			},
            additionalRegularPlacements = {
                {
                    name = "Coconut",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Coconut,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
					spawnTypes = {"Ice Mix",},
                    frequencies = {1,0,1,0,2,0,2,0,3,0,3,0,0,4},
                },
			},
            additionalNamedMixes = {
                {
                    name = "Ice Mix",
                    {
                        name = "Ice 1",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 3,
                    },
                    {
                        name = "Ice 2",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 3,
                    },
                    {
                        name = "Ice 3",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 3,
                    },
                    {
                        name = "Ice 4",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 3,
                    },
                },
            },
			additionalInitialPatterns = {
                {
					patternName = "AnInconvenientTrough_MakersIce",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Ice Mix",},
					applySkinVariant = true,
					skinVariant = "",
				},
                {
					patternName = "AnInconvenientTrough_Ice",
					isPatternSet = false,
                    applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
                {
					patternName = "AnInconvenientTrough_Eaters",
					isPatternSet = false,
                    gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
            main = {"getGem",6,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut, isGemSpawner = true},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",75000},
				[3] = {"score",125000},
			},
		},
	},

    ["IceChest"] = {
		levelName = "Ice Chest",
		introScript = "Land26_Tip2",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasIce = true,
            treasureChest = true,
		},
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					frequencies = {1, 2, 2, 2, 2},
				},
			},
			additionalInitialPatterns = {
                {
					patternName = "IceChest_Ice",
					isPatternSet = false,
                    applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
                {
					patternName = "IceChest_Steel",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "IceMaker",
				},
				{
					-- Necessary to set up ice maker correctly
					patternName = "IceChest_Steel",
					isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "TopCorners",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
            main = {"getGem",8,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",200000},
			},
		},
	},

	["Permafrost"] = {
		levelName = "Permafrost",	
		introScript = "Land26_Tip1",				
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasIce = true,
			hasBombs = true,
		},
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BottomChecks4Rows2_large",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				{
					patternName = "BottomChecks4Rows_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000, 
	},

	["FirstFrost"] = {
		levelName = "First Frost",	
		introScript = "Land26_Intro",				
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasIce = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "FirstFrost_missing",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "FirstFrost_ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ice.singular","Ice.plural",{spreadSpecials = CascadePieceSpecials_Ice},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",325000},
			},
		},
		expectedScore = 100000, 
	},

	["TripleSpreader"] = {
		levelName = "Triple Spreader",					
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasIce = true,
			hasVines = true,
			hasLava = true,
		},
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "TripleSpreader_ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				{
					patternName = "TripleSpreader_vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "TripleSpreader_lava",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Lava,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Spreader","Spreaders",
				{
					{spreadSpecials = CascadePieceSpecials_Ice,},
					{cancelSpecials = CascadePieceSpecials_Vines,},
					{specials = CascadePieceSpecials_Lava,},
				},
			},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",675000},
			},
		},
		expectedScore = 100000, 
	},

	["StainedGlass"] = {
		levelName = "Stained Glass",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins3 = true, 
			splashMode = true,
			gemTypes4 = true, 
			hasIce = true,
			hasAmber = true,
			largeBoard = true,
		},
		Properties = {
			useMissingReels = true,
            missingReels = {
				--patternName = "MissingMiddleLargeReels", 
				patternName = "TwoTowers_Reels",
				isPatternSet = false,
            },
			
			additionalInitialPatterns = {
				{
					patternName = "VerticalStripeCenterLarge",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "StainedGlass_ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",500000},
			},
		},
	},

	["NoTwoAlike"] = {
		levelName = "No Two Alike",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins4 = true, 
			splashMode = true,
			gemTypes5 = true, 
			hasIce = true,
			largeBoard = true,
		},
		tricks = World26Tricks,
		boosts = World26Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Snowflake_ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",175000},
				[3] = {"score",200000},
			},
		},
	},

	["GlacialPace"] = {
		levelName = "Glacial Pace",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins10 = true, 
			splashMode = true,
			gemTypes5 = true, 
			hasIce = true,
			hasBarrels = true,
			largeBoard = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "GlacialPace_ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},		
		goals = {
			main = {"getGem",28,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
	},

	["BackAndForth"] = {
		levelName = "Back and Forth",
		Features = {
			largeBoard = true, 
			modeSpins4 = true,
			splashMode = true,
			gemTypes4 = true, 
			hasLasers = true,
			hasChests = true,
			hasStone = true,
			hasMakers = true,
		},
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeAndCenter_large", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				{
					name = "Horizontal Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
				},
				{
					name = "Vertical Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
				},
				{
					name = "Make Stone 1",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Normal mix 1",
							reset = true,
						},
					},
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Stone",
						extraHits = 0,
						weight = 1,
					},
				},
				{
					name = "Make Stone 2",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Normal mix 2",
							reset = true,
						},
					},
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Stone",
						extraHits = 1,
						weight = 1,
					},
				},
				{
					name = "Make Stone 3",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Normal mix 3",
							reset = true,
						},
					},
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Stone",
						extraHits = 2,
						weight = 1,
					},
				},
				{
					name = "Make Stone 4",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Normal mix 4",
							reset = true,
						},
					},
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Stone",
						extraHits = 3,
						weight = 1,
					},
				},
				{
					name = "Normal mix 1",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Make Stone 1",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
				{
					name = "Normal mix 2",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Make Stone 2",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
				{
					name = "Normal mix 3",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Make Stone 3",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
				{
					name = "Normal mix 4",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Make Stone 4",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Horizontal Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Horizontal Color Changing Laser",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "Vertical Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Vertical Color Changing Laser",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "BackAndForth_LaserH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Horizontal Color Changing Laser",},
				},
				{
					patternName = "BackAndForth_LaserV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Vertical Color Changing Laser",},
				},
				{
					patternName = "BombColumn Bomb2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 0,
				},
				{
					patternName = "BombColumn Bomb4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "BombColumn Bomb6",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 2,
				},
				{
					patternName = "BombColumn Bomb8",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 3,
				},
				{
					patternName = "StemTide_Splash1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 3,
				},
				{
					patternName = "BombColumn Bomb1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Stone 1","Normal mix 1"},
				},
				{
					patternName = "BombColumn Bomb3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Stone 2","Normal mix 2"},
				},
				{
					patternName = "BombColumn Bomb5",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Stone 3","Normal mix 3"},
				},
				{
					patternName = "BombColumn Bomb7",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Stone 4","Normal mix 4"},
				},
				{
					patternName = "BackAndForth_steel",
					isPatternSet = false,				
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{ 
					patternName = "StemTide_Jail1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				{
					patternName = "BackAndForth_fences",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
				},
			},
		},		
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",750000},
				[3] = {"score",1000000},
			},
		},
	},

	["Icebox"] = {
		levelName = "Icebox",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins4 = true, 
			splashMode = true,
			gemTypes3 = true, 
			hasIce = true,
			hasLocks = true,
			hasSteel = true,
			hasMissingReels = true,
			largeBoard = true,
		},
		tricks = World26Tricks,
		boosts = World26Boosts,
		Properties = {
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Icebox_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				[2] = {
					patternName = "Icebox_lock",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Icebox_ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
			},
			useMissingReels = true,
            missingReels = {
				patternName = "Reels67", 
				isPatternSet = false,
            },
		},		
		goals = {
			main = {"gemsRemain",0,"Ice.singular","Ice.plural",{spreadSpecials = CascadePieceSpecials_Ice},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",2000000},
				[3] = {"score",4200000},
			},
		},
	},
	["ShootingGallery"] = {
		levelName = "Shooting Gallery",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasMakers = true,
			hasBarrels = true,
			hasGemEaters = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "ShootingGallery_missing", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_left3", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Laser1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser1",},
						weight = 1,
					},
				},
				[2] = {
					name = "Laser2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser2",},
						weight = 1,
					},
				},
				[3] = {
					name = "Laser3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser3",},
						weight = 1,
					},
				},
				[4] = {
					name = "Laser4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser4",},
						weight = 1,
					},
				},
				[5] = {
					name = "Laser5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser5",},
						weight = 1,
					},
				},
				[6] = {
					name = "Always Barrel",
					delay = 0,
					{
						name = "Barrel",
						weight = 3,
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						spawnTypes = {"Always Orange",},
					},
				},
				[7] = {
					name = "Always Orange",
					delay = 0,
					{
						name = "Normal Gem 6",
						weight = 11,
						matchFlags = CascadeMatchFlags_CommonPiece6,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Laser1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[2] = {
						name = "Laser2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[3] = {
						name = "Laser3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[4] = {
						name = "Laser4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[5] = {
						name = "Laser5",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser5",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "BuriedTreasure_LeftColumn_bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"Always Orange"},
				},
				{
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Barrel"},
				},
				{
					patternName = "Spider_Lava",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "JailedBurst Test Jail",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
				},
				{
					patternName = "JailBroken_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
				{
					patternName = "JailBroken2_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser4",},
				},
				{
					patternName = "JailedBurst Test VerticalBurst",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser5",},
				},
				{
					patternName = "ShootingGallery_laser6",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser1",},
				},
				{
					patternName = "ShootingGallery_laser7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
				},
				{
					patternName = "FlowerPot1_seed1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
			},
		},
		goals = {
			main = {"getGem",5,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},"Destroy"},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},
	["Cryolock"] = {
		levelName = "Cryolock",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins8 = true, 
			splashMode = true,
			gemTypes4 = true, 
			hasLocks = true,
			hasSteel = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasMakers = true,
			largeBoard = true,
		},
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Regular Mix",
					delay = 1,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "Cryolock_missing", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Cryolock_clear",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Cryolock_lock",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Cryolock_steel",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[4] = {
					patternName = "Cryolock_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix"},
				},
			},
			useMissingReels = true,
            missingReels = {
				patternName = "Cryolock_reels", 
				isPatternSet = false,
            },
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",350000},
				[3] = {"score",400000},
			},
		},
	},
	["NoTwoAlike_side"] = {
		levelName = "Flurry",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins4 = true, 
			splashMode = true,
			gemTypes5 = true, 
			hasIce = true,
			hasBombs = true,
			largeBoard = true,
		},
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "LittleX",
					isPatternSet = false,
					applyPieceSpecials = true,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 7,
				},
				{
					patternName = "Snowflake_ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 11,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",700000},
				[3] = {"score",1200000},
			},
		},
	},

	["TropicalIce"] = {
		levelName = "Tropical Ice",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins10 = true, 
			splashMode = true,
			gemTypes3 = true, 
			hasIce = true,
			hasMissingSquares = true,
			hasCoconuts = true,
			regularBoard = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingSquares = true,
            missingSquares = {
                patternName = "TropicalIce_pattern",
                isPatternSet = false,
            },
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
                    frequencies = {1,1,2,3,3},
				},
			},
			spawnGemOnBreak = {
				{
					name = "Ice 1",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 3,
				},
				{
					name = "Ice 2",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 3,
				},
				{
					name = "Ice 3",
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 3,
				},
			},
		},		
		goals = {
			main = {"getGem",10,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1500000},
				[3] = {"score",2000000},
			},
		},
	},

	["GlacialPace_side"] = {
		levelName = "Icy Chasm",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins10 = true, 
			splashMode = true,
			gemTypes5 = true, 
			hasIce = true,
			hasBarrels = true,
			regularBoard = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Canyon1",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},		
		goals = {
			main = {"getGem",24,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},
	["IceChest_side"] = {
		levelName = "Cooler",
		resource = "GameScreen_Land26",	
		Features = {
			modeSpins5 = true, 
			splashMode = true,
			gemTypes4 = true, 
			hasIce = true,
			hasChests = true,
			regularBoard = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Cooler_chests",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
				},
				[2] = {
					patternName = "LowerLine1",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
			},
		},		
		goals = {
			main = {"getGem",12,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
	},

})
