-- Land 27: balloons

table.insertall(LevelDefs,
{
	["BalloonsTest"] = {
		levelName = "Up in a Balloon",	
		introScript = "Land27_Intro",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasBalloons = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Line1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				[2] = {
					patternName = "Line4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				[3] = {
					patternName = "Line7",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
			},
		},
		goals = {
			main = {"getGem",18,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
			stars = {
				[1] = {"score",60000},
				[2] = {"score",70000},
				[3] = {"score",80000},
			},
		},
		expectedScore = 100000, 
	},
	
	["BalloonTreasureTest"] = {
		levelName = "Rise and Fall",					
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasBalloons = true,
			hasChests = true,
			hasBarrelsOfFun = true,
		},
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 10,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 10,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 10,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 10,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 10,
				},
				{
					name = "Blue Burst",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Burst",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Burst",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Burst",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Burst",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Barrel with balloon chest",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					weight = 3,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Balloon Chest",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure_Balloon,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					weight = 1,
				},
			},
		},
		goals = {
			main = {"getGem",8,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, 
	},
	["BalloonMakerTest"] = {
		levelName = "Balloon Flood",
		introScript = "Land27_Tip1",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBalloons = true,
			hasMakers = true,
		},
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Balloon",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CrateBottomBlock1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon"},
				},
			},
		},
		goals = {
			main = {"getGem",50,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",250000},
				[3] = {"score",350000},
			},
		},
	},

	["FloatOn"] = {
		levelName = "Float On",
		introScript = "Land27_Tip2",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBalloons = true,
			hasMakers = true,
			hasSteel = true,
			hasStones = true,
			hasMissingSquares = true,
			hasMissingReels = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "FloatOn_missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_leftSide",
				isPatternSet = false,
			},
			portals = {
				[1] = {{2,5},{6,2},"PortalEntrance_1","PortalExit_1"},
				[2] = {{0,7},{2,0},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Balloon",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon | CascadePieceSpecial_VerticalSplash,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon | CascadePieceSpecial_VerticalSplash,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon | CascadePieceSpecial_VerticalSplash,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon | CascadePieceSpecial_VerticalSplash,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Balloon",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Bin4_Bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon"},
				},
				{
					patternName = "FloatOn_clear",
					clearPieces = true,
					isPatternSet = false,
				},
				{
					patternName = "RubeMakersH",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "RubePlaceH",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "FloatOn_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",2000000},
				[3] = {"score",5000000},
			},
		},
	},
	["ParadiseRises"] = {
		levelName = "Paradise Rises",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasBalloons = true,
			hasStone = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "ParadiseRises_house",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				[2] = {
					patternName = "ParadiseRises_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				--[[{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				--]]
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",100000},
			},
		},
		expectedScore = 100000, 
	},
	["HeliumTank"] = {
		levelName = "Helium Tank",					
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasBalloons = true,
			hasSteel = true,
			hasLocks = true,
			hasChests = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "HeliumTank_balloons",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				[2] = {
					patternName = "HeliumTank_steel",
					isPatternSet = false,				
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[3] = {
					patternName = "HeliumTank_lock",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[4] = {
					patternName = "HeliumTank_chests",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",45000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000, 
	},
	["LaserDarts"] = {
		levelName = "Laser Darts",					
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasBalloons = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasLasers = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "LaserDarts_missing",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "LaserH 1",
					delay = 0,
					{
						name = "LaserH 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 1",},
						weight = 1,
					},
				},
				{
					name = "LaserH 2",
					delay = 0,
					{
						name = "LaserH 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 2",},
						weight = 1,
					},
				},
				{
					name = "LaserH 3",
					delay = 0,
					{
						name = "LaserH 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 3",},
						weight = 1,
					},
				},
				{
					name = "LaserH 4",
					delay = 0,
					{
						name = "LaserH 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 4",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserH 1",
						delay = 0,
						{
							name = "LaserH 1",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laserh,
							spawnTypes = {"LaserH 1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 2",
						delay = 0,
						{
							name = "LaserH 2",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 3",
						delay = 0,
						{
							name = "LaserH 3",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "LaserH 4",
						delay = 0,
						{
							name = "LaserH 4",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LaserDarts_balloons",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				[2] = {
					patternName = "LaserDarts_lasers1",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"LaserH 1",},
				},
				[3] = {
					patternName = "LaserDarts_lasers2",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"LaserH 2",},
				},
				[4] = {
					patternName = "LaserDarts_lasers3",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"LaserH 3",},
				},
				[5] = {
					patternName = "LaserDarts_lasers4",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"LaserH 4",},
				},
			},
			useMissingReels = true,
            		missingReels = {
				patternName = "LaserDarts_reels", 
				isPatternSet = false,
        		},
		},
		goals = {
			main = {"gemsRemain",0,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",550000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, 
	},
	["Amulet"] = {
		levelName = "Amulet",					
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasFences = true,
			hasLasers = true,
			hasStone = true,
			hasCoverage = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Amulet_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[2] = {
					patternName = "Amulet_stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "Amulet_lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Horizontal Color Changing Laser",},
				},		
			}, --end of add'l ini'l patterns
			additionalNamedMixes = {
				{
					name = "Horizontal Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Horizontal Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Horizontal Color Changing Laser",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",150000},
				[3] = {"score",275000},
			},
		},
		expectedScore = 100000, 
	},
	["CoconutForever"] = {
		levelName = "Coconut Forever",					
		Features = {
			modeSpins9 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasBalloons = true,
			hasCoconuts = true,
		},
		Properties = {
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 10,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 10,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 10,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 10,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 10,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 10,
				},
			},
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 10,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 10,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 10,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 10,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 10,
				},
			},
			additionalNamedMixes = {
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "CoconutForever_coconuts",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
					applyIsGemSpawner = true,
				},
				{
					patternName = "RubeMachine_gem3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
			},
			spawnGemOnBreak = {
				{
					name = "Balloon Coconut",
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut_Balloon,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					isGemSpawner = true,
					weight = 1,
				},
			},
		},
		goals = {
			main = {"getGem",12,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut, isGemSpawner = true},"Drop"},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",1000000},
				[3] = {"score",1300000},
			},
		},
		expectedScore = 100000, 
	},

	["BalloonBelt"] = {
		levelName = "Two Way Street",
		outtroScript = "Land27_Outtro",			
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasMakers = true,
			hasBarrels = true,
			hasGemEaters = true,
			hasBalloons = true,
		},
		Properties = {
			gemsMoveDiagonally = false,
			useMissingSquares = true,
			missingSquares = {
				patternName = "BalloonBelt_Missing", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_left3", 
				isPatternSet = false,
            },
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "4 Color Mix",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Always Boulder",
					delay = 0,
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
				[2] = {
					name = "4 Color Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 3,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
				},
				[3] = {
					name = "Balloon",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 3,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
					},
				},
				
			},
			portals = {
				[1] = {{0,7},{2,0},"PortalEntrance_1","PortalExit_1"},
			},
			additionalInitialPatterns = { 
				{
					patternName = "BalloonBelt_horiz",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				{
					patternName = "BalloonBelt_boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
					applyExtraHits = true,
				},
				{
					patternName = "BalloonBelt_Balloons",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
				},
				{
					patternName = "RubeMakersH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"4 Color Mix","Always Boulder",},
				},
				{
					patternName = "BalloonBelt_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "BalloonBelt_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "BalloonBelt_FlippedMaker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon",},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Blue Balloon","Blue Balloons",{matchFlags = CascadeMatchFlags_CommonPiece1, specials = CascadePieceSpecials_Balloon},"Pop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1500000},
				[3] = {"score",3000000},
			},
		},
	},

	["BlockAndBust"] = {
		levelName = "Block and Bust",					
		Features = {
			modeSpins9 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasBarrelsOfFun = true,
			hasStones = true,
		},
		Properties = {
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 5,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Stone",
					weight = 1,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					extraHits = 2,
				},
			},
		},
		goals = {
			main = {"getGem",40,"Stone","Stones",{specials = CascadePieceSpecials_Stone, extraHits = 0,},"Break",},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, 
	},

	["BombChest2"] = {
		levelName = "Bomb Chest 2",		
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasChests = true,
			hasBombs = true,
			hasLasers = true,
		},
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BombChest2_Chest1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applyTurnsToLoss = true,
					turnsToLoss = 45,
				},
				{
					patternName = "BombChest2_Chest2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applyTurnsToLoss = true,
					turnsToLoss = 50,
				},
				{
					patternName = "BombChest2_Chest3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applyTurnsToLoss = true,
					turnsToLoss = 55,
				},
				{
					patternName = "BombChest2_Chest4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applyTurnsToLoss = true,
					turnsToLoss = 60,
				},
				{
					patternName = "BombChest2_Chest5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applyTurnsToLoss = true,
					turnsToLoss = 65,
				},
				{
					patternName = "BombChest2_Chest6",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applyTurnsToLoss = true,
					turnsToLoss = 70,
				},
				{
					patternName = "BombChest2_Chest7",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applyTurnsToLoss = true,
					turnsToLoss = 75,
				},
				{
					patternName = "BombChest2_Laser",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
			},
			additionalNamedMixes = {
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
		},
		goals = {
			main = {"getGem",7,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop",},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},

	["BalloonReels"] = {
		levelName = "Popping In",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBalloons = true,
			hasBarrelsOfFun = true,
		},
		Properties = {
            reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Balloon 1",
					weight = 1,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Balloon,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				{
					name = "Balloon 2",
					weight = 1,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Balloon,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				{
					name = "Balloon 3",
					weight = 1,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Balloon,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				{
					name = "Balloon 4",
					weight = 1,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Balloon,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				{
					name = "Balloon 5",
					weight = 1,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_Balloon,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",90000},
				[3] = {"score",100000},
			},
		},
	},

	["Meltdown"] = {
		levelName = "Meltdown",
		Features = {
			largeBoard = true, 
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true, 
			hasLasers = true,
			hasIce = true,
			hasMakers = true,
			hasMissingReels = true,
			hasLasers = true,
			hasBarrels = true,
			hasBombs = true,
			hasMissingSquares = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Meltdown_missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "Horizontal Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						weight = 1,
					},
				},
				{
					name = "Vertical Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"Vertical Color Changing Laser",},
						weight = 1,
					},
				},
				{
					name = "Bomb Mix",
					delay = 0,
					events = { --Make 1 gem every move
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                    },
					{
						name = "Bomb Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels + CascadePieceSpecial_Valuable,
						turnsToLoss = 7,
						weight = 1.5,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Horizontal Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Horizontal Color Changing Laser",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					{
						name = "Vertical Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Vertical Color Changing Laser",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "Bomb Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "BigBottomColumn4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Horizontal Color Changing Laser",},
				},
				{
					patternName = "BottomCorners_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Vertical Color Changing Laser",},
				},
				{
					patternName = "TopCorners_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix"},
				},
				{
					patternName = "Meltdown_ice",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "IceMaker",
				},
				{
					-- Necessary to set up ice maker correctly
					patternName = "Meltdown_ice",
					isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "OrangeEaters_orange1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
				{
					patternName = "OrangeEaters_orange2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
				},
				{
					patternName = "OrangeEaters_orange3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applyTurnsToLoss = true,
					turnsToLoss = 9,
				},
				{
					patternName = "RowSides3_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applyTurnsToLoss = true,
					turnsToLoss = 9,
				},
				{
					patternName = "RowSides5_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
				},
				{
					patternName = "RowSides7_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
			},
		},		
		goals = {
			main = {"getGem",20,"Bomb","Bombs",{turnsToLoss = true,spreadSpecials = 0}},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",900000},
			},
		},
	},

	["DuelingMakers"] = {
		levelName = "Dueling Makers",
		Features = {
			largeBoard = true, 
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true, 
			hasMakers = true,
			hasBalloons = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasBarrels = true,
			hasStone = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "DuelingMakers_missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_leftSide",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Balloon",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon | CascadePieceSpecial_HorizontalSplash,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon | CascadePieceSpecial_HorizontalSplash,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon | CascadePieceSpecial_HorizontalSplash,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon | CascadePieceSpecial_HorizontalSplash,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
				},
				[2] = {
					name = "Boulders and gems",
					delay = 0,
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 8,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Balloon",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "FlowerPot1_seed1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon"},
				},
				{
					patternName = "TopRow_Column3_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulders and gems"},
				},
				{
					patternName = "DuelingMakers_stone",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 0,
				},

			},
		},		
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone,},},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},

	["ClearTheAir_side"] = {
		levelName = "Clear the Air",	
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasBalloons = true,
			hasGemEaters = true,
			hasCoverage = true,
			hasPortals = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "ClearTheAir_missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "MissingReel1",
				isPatternSet = false,
			},
			portals = {
				[1] = {{0,2},{2,1},"PortalEntrance_1","PortalExit_1"},
				[2] = {{0,3},{3,1},"PortalEntrance_1","PortalExit_1"},
				[3] = {{0,4},{4,1},"PortalEntrance_1","PortalExit_1"},
				[4] = {{0,5},{5,1},"PortalEntrance_1","PortalExit_1"},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "ClearTheAir_orange",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
				[2] = {
					patternName = "ClearTheAir_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000, 
	},

	["Fountain_side"] = {
		levelName = "Fountain of Treasure",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasChests = true,
			hasFences = true,
		},
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Chest",
					delay = 0,
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "BombColumn Bomb4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Chest"},
				},
				{ 
					patternName = "BombColumn Bomb3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				{
					patternName = "Fountain_fences",
					isPatternSet = false,
					specials = CascadePieceSpecials_Fence,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",250000},
			},
		},
	},
	["BalloonWall"] = {
		levelName = "Balloon Wall",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBalloons = true,
			hasMakers = true,
			hasCoverage = true,
		},
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Slow Balloon Fill",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					events = {
						{
							eventType = "emitCount",
							count = 1,
							reset = true,
							newDelay = 2,
						}
					},
				},
			},
			gemsMoveDiagonally= false,
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BalloonWall_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Slow Balloon Fill"},
				},
				[2] = {
					patternName = "BalloonWall_Pattern",
					isPatternSet = false,
					clearPieces = true,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				[3] = {
					patternName = "BalloonWall_Balloons",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",400000},
			},
		},
	},

})