-- Land 28: glass

local function ImbalanceMix(gemType, threshold)
	local matchFlags
	if(gemType == 1) then
		matchFlags = CascadeMatchFlags_CommonPiece1
	end
	if(gemType == 2) then
		matchFlags = CascadeMatchFlags_CommonPiece2
	end
	if(gemType == 3) then
		matchFlags = CascadeMatchFlags_CommonPiece3
	end
	if(gemType == 4) then
		matchFlags = CascadeMatchFlags_CommonPiece4
	end
	if(gemType == 5) then
		matchFlags = CascadeMatchFlags_CommonPiece5
	end
	local retVal = {
        name = "Imbalance_" .. gemType .. "_" .. threshold,
        delay = -1,
		events = {
			[1] = {
				eventType = "population",
				count = threshold,
				comparator = "less",
				newDelay = -1,
				gemType = {
					matchFlags = matchFlags,
				},
			},
			[2] = {
				eventType = "population",
				count = threshold - 1,
				comparator = "greater",
				newDelay = 0,
				gemType = {
					matchFlags = matchFlags,
				},
			},
		},
		{
			name = "Gem" .. gemType,
			matchFlags = matchFlags,
			weight = 1,
		},
	}
	return retVal
end

table.insertall(LevelDefs,
{
--Jonathan Levels
	["WindowRows"] = {
		levelName = "Window Rows",		
		introScript = "Land28_Intro",			
		resource = "GameScreen_Land28",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasSteelGlass = true,
			regularBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "WindowRows_Glass",
				isPatternSet = false,
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, 
	},
	["HiddenCloud"] = {
		levelName = "Hidden Cloud",	
		introScript = "Land28_Tip1",				
		resource = "GameScreen_Land28",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasCoverage = true,
			largeBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "HiddenCloud_Glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "HiddenCloud_Glass",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000, 
	},
	["NoTouchTreasure"] = {
		levelName = "No Touch Treasure",	
		introScript = "Land28_Tip2",				
		resource = "GameScreen_Land28",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasTreasure = true,
			largeBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "MissingMiddleLargeReels",
				isPatternSet = false,
			},
			useSteelGlass = true,
			steelGlass = {
				patternName = "NoTouchTreasure_Glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "NoTouchTreasure_Treasure",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000, 
	},
	["UnstableBalloons"] = {
		levelName = "Unstable Balloons",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			hasBalloons = true,
			hasBombs = true,
			hasMakers = true,
			largeBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			additionalNamedMixes = {
                {
                    name = "Bomb Balloons",
                    delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 3,
							reset = true,
						},
					},
					{
						name = "Bomb Balloon 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon + CascadePieceSpecial_Valuable,
						cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
						turnsToLoss = 23,
						weight = 1,
					},
					{
						name = "Bomb Balloon 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon + CascadePieceSpecial_Valuable,
						cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
						turnsToLoss = 23,
						weight = 1,
					},
					{
						name = "Bomb Balloon 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon + CascadePieceSpecial_Valuable,
						cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
						turnsToLoss = 23,
						weight = 1,
					},
					{
						name = "Bomb Balloon 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon + CascadePieceSpecial_Valuable,
						cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
						turnsToLoss = 23,
						weight = 1,
					},
				},
                {
                    name = "Balloons",
                    delay = 0,
					{
						name = "Balloon 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
					{
						name = "Balloon 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
					{
						name = "Balloon 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
					{
						name = "Balloon 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
				},
                {
                    name = "Normal Gems",
                    delay = 0,
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "UnstableBalloons_UpwardMakers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Balloons","Balloons"},
				},
				[2] = {
					patternName = "UnstableBalloons_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal Gems",},
				},
				[3] = {
					patternName = "UnstableBalloons_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				[4] = {
					patternName = "UnstableBalloons_Balloons",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
			},
		},
		goals = {
			main = {"getGem",8,"Bomb","Bombs",{cancelSpecials = 0, turnsToLoss = true,},"Defuse"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
	["BlockedBounce"] = {
		levelName = "Blocked Bounce",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasBalloons = true,
			hasChests = true,
			hasSteelGlass = true,
			hasCoconuts = true,
			hasLasers = true,
			largeBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "BlockedBounce_Glass",
				isPatternSet = false,
			},
			additionalNamedMixes = {
                {
                    name = "Balloon Chest",
                    delay = 0,
					{
						name = "Balloon Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
						augmentSpecials = CascadePieceSpecial_SplashImmune,
						weight = 1,
					},
				},
				{
                    name = "Laser Mix",
                    {
                        name = "Laser 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"Laser Mix",},
                        weight = 1,
                        skinVariant = "LaserH",
                    },
                    {
                        name = "Laser 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"Laser Mix",},
                        weight = 1,
                        skinVariant = "LaserH",
                    },
                    {
                        name = "Laser 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"Laser Mix",},
                        weight = 1,
                        skinVariant = "LaserH",
                    },
                    {
                        name = "Laser 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"Laser Mix",},
                        weight = 1,
                        skinVariant = "LaserH",
                    },
                },
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Laser Mix",
						{
							name = "Laser 1",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser Mix",},
							weight = 1,
							skinVariant = "LaserH",
						},
						{
							name = "Laser 2",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser Mix",},
							weight = 1,
							skinVariant = "LaserH",
						},
						{
							name = "Laser 3",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser Mix",},
							weight = 1,
							skinVariant = "LaserH",
						},
						{
							name = "Laser 4",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser Mix",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BlockedBounce_Lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecials_Laser,
					applySpawnTypes = true,
					spawnTypes = {"Laser Mix"},
				},
				[2] = {
					patternName = "BlockedBounce_CoconutBalloons",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Coconut_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applySpawnTypes = true,
					spawnTypes = {"Balloon Chest",},
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{cancelSpecials = 0, specials = CascadePieceSpecials_Treasure,},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2250000},
			},
		},
		expectedScore = 100000, 
	},
	
	["GetWild"] = {
		levelName = "Get Wild",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
			regularBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			additionalNamedMixes = {
                {
                    name = "Wilds",
                    delay = 0,
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 1,
					},
				},
			},
			boardPieceMix = {
				{
					name = "Piece1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Piece2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Piece3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Piece4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Piece5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Barrel With Wild",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					spawnTypes = {"Wilds"},
					weight = 6,
				},
			},
		},
		goals = {
			main = {"haveGem",7,"Wild","Wilds",{matchFlags = CascadeMatchFlags_Wildcard,},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
	
	["ColorBalance"] = {
		levelName = "Color Balance",
		introScript = "Land28_ColorBalance",
		resource = "GameScreen_Land28",
		Features = {
			modeSpins2 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			largeBoard = true,
		},
		tricks = {
			{name = Config.World28Tricks_Trick1},
			{name = Config.World28Tricks_Trick2},
			{name = Config.World28Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World28Boosts,
		Properties = {
			additionalNamedMixes = {
                {
                    name = "Restock 1",
                    delay = -1,
					events = {
						[1] = {
							eventType = "population",
							count = 8,
							comparator = "less",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece1,
							},
						},
						[2] = {
							eventType = "population",
							count = 8,
							comparator = "greater",
							newDelay = -1,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece1,
							},
						
						},
						[3] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
						},
					},
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
				},
                {
                    name = "Restock 2",
                    delay = -1,
					events = {
						[1] = {
							eventType = "population",
							count = 8,
							comparator = "less",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece2,
							},
						},
						[2] = {
							eventType = "population",
							count = 8,
							comparator = "greater",
							newDelay = -1,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece2,
							},
						},
						[3] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
						},
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
				},
                {
                    name = "Restock 3",
                    delay = -1,
					events = {
						[1] = {
							eventType = "population",
							count = 8,
							comparator = "less",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece3,
							},
						},
						[2] = {
							eventType = "population",
							count = 8,
							comparator = "greater",
							newDelay = -1,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece3,
							},
						},
						[3] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
						},
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
				},
                {
                    name = "Restock 4",
                    delay = -1,
					events = {
						[1] = {
							eventType = "population",
							count = 8,
							comparator = "less",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece4,
							},
						},
						[2] = {
							eventType = "population",
							count = 8,
							comparator = "greater",
							newDelay = -1,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece4,
							},
						},
						[3] = {
							eventType = "emitCount",
							count = 5,
							newDelay = -1,
						},
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
                {
                    name = "Regular Mix",
                    delay = 0,
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Line8_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Restock 1","Restock 2","Restock 3","Restock 4","Regular Mix",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",1100000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000, 
	},

	["SteelPlacer"] = {
		levelName = "Steel Placer",
		resource = "GameScreen_Land28",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasSteel = true,
			hasBarrelsOfFun = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
            additionalNamedMixes = {
				{
					name = "Make Steel",
					delay = 0,
					{
                        name = "Present",
                        matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
                        weight = 1,
                    },
                },
            },
			reelPieceMix = {
				{
					name = "Blue Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Steel"},
					weight = 11,
				},
				{
					name = "Green Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Steel"},
					weight = 11,
				},
				{
					name = "Purple Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Steel"},
					weight = 11,
				},
				{
					name = "Red Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Steel"},
					weight = 11,
				},
				{
					name = "Wild Barrel",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"Make Steel"},
					weight = 5,
				},
			},
		},
		goals = {
			main = {"getGem",24,"Barrel","Barrels",{specials = CascadePieceSpecials_ColorBarrels, isGemSpawner = true},"Break"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",35000},
				[3] = {"score",50000},
			},
		},
		expectedScore = 100000, 
	},
	["GlassCheckerboard"] = {
		levelName = "Glass Checkerboard",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasCoverage = true,
			regularBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "Checkers",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Checkers2",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				[2] = {
					patternName = "Checkers",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",550000},
			},
		},
		expectedScore = 100000, 
	},
	["GlassHalfEmpty"] = {
		levelName = "Glass Half Empty",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasSteel = true,
			hasCoverage = true,
			largeBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "GlassHalfEmpty_Glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "GlassHalfEmpty_Glass",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
					clearPieces  = true,
				},
				[2] = {
					patternName = "GlassHalfEmpty_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				[3] = {
					patternName = "GlassHalfEmpty_NormalGems",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = 0,
				},
			},
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Blue Burst",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Green Burst",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Purple Burst",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Red Burst",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
				{
					name = "Yellow Burst",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 4,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",225000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, 
	},
	["InCaseOfEmergency"] = {
		levelName = "In Case Of Emergency",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasGifts = true,
			hasChests = true,
			regularBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "InCaseOfEmergency_Glass",
				isPatternSet = false,
			},
            additionalNamedMixes = {
				{
					name = "Treasures",
					delay = 0,
					{
                        name = "Treasure",
                        matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
                        weight = 1,
                    },
                },
            },
			additionalInitialPatterns = {
				[1] = {
					patternName = "InCaseOfEmergency_Gifts",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
					applySpawnTypes = true,
					spawnTypes = {"Treasures"},
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{cancelSpecials = 0, specials = CascadePieceSpecials_Treasure,},"Drop"},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",150000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000, 
	},
	["MixAndMatch"] = {
		levelName = "Mix and Match",
		resource = "GameScreen_Land28",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Blue Burst",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 3,
				},
				{
					name = "Green Burst",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 3,
				},
				{
					name = "Purple Burst",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 3,
				},
				{
					name = "Red Burst",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 3,
				},
				{
					name = "Yellow Burst",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 3,
				},
			},
			reelPieceMix = {
			{
					name = "Blue Burst",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 5,
				},
				{
					name = "Green Burst",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 5,
				},
				{
					name = "Purple Burst",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 5,
				},
				{
					name = "Red Burst",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 5,
				},
				{
					name = "Yellow Burst",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 5,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
			},
		},
		goals = {
			main = {"getGem",75,"Combo Burst","Combo Bursts",
					{
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash +  CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,},
					},
					"Make",
				},
			stars = {
				[1] = {"score",4000000},
				[2] = {"score",4750000},
				[3] = {"score",5000000},
			},
		},
	},

	--Michael Levels
	["Cornerstone"] = {
		levelName = "Cornerstone",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "Cornerstone_glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Cornerstone_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",100000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
	["BalloonTube"] = {
		levelName = "Balloon Tube",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasSteelGlass = true,
			hasSteel = true,
			hasStones = true,
			hasBalloons = true,
			hasMissingReels = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "BalloonTube_glass",
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "BalloonTube_reels", 
				isPatternSet = false,
            },
			additionalInitialPatterns = {
				[1] = {
					patternName = "BalloonTube_balloon",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				[2] = {
					patternName = "BalloonTube_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "BalloonTube_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000, 
	},
	["BalloonStand"] = {
		levelName = "Balloon Stand",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBalloons = true,
			hasMakers = true,
			hasSteelGlass = true,
			hasStone = true,
		},
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "BalloonStand_glass",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Balloon",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BalloonStand_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon"},
				},
				[2] = {
					patternName = "BalloonStand_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "BalloonStand_glass",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				[4] = {
				patternName = "BalloonStand_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",27,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},
	["StuckBalloons"] = {
		levelName = "Stuck in the Air",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBalloons = true,
			hasMakers = true,
			hasSteelGlass = true,
		},
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "StuckBalloons_glass",
				isPatternSet = false,
			},
			
			additionalNamedMixes = {
				[1] = {
					name = "Balloon",
					delay = 0,
					--[[
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					--]]
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 5",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
				},
				[2] = {
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
				[3] = {
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "LaserV",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "LaserH",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StuckBalloons_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon"},
				},
				[2] = {
					patternName = "StuckBalloons_laserV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
				[3] = {
					patternName = "StuckBalloons_laserH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
			},
		},
		goals = {
			main = {"getGem",25,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
			stars = {
				[1] = {"score",10000},
				[2] = {"score",50000},
				[3] = {"score",90000},
			},
		},
	},
	["Oven"] = {
		levelName = "Oven",
		resource = "GameScreen_Land28",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasSteelGlass = true,
			hasFences = true,
			hasStone = true,
			hasMissingReels = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "Oven_glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Oven_fence",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				[2] = {
					patternName = "Oven_lava",
					isPatternSet = false,
						applyPieceSpecials = true,
						applyMatchFlags = true,
						specials = CascadePieceSpecials_Lava,
						matchFlags = 0,
				},
				[3] = {
					patternName = "Oven_fence",
					isPatternSet = false,
						applyPieceSpecials = true,
						applyMatchFlags = true,
						specials = CascadePieceSpecials_Fence,
						matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000, 
	},
	["Passersby"] = {
		levelName = "Passersby",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasMakers = true,
			hasBarrels = true,
			hasGemEaters = true,
			hasMissingReels = true,
			hasSteelGlass = true,
			hasBarrels = true,
		},
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "Passersby_glass",
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "Passersby_reels", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Boulders",
					delay = 0,
					{ 
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 2,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Passersby_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulders"},
				},
				[2] = {
					patternName = "Passersby_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"getGem",27,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",1000000},
			},
		},
	},
	["RoomForRed"] = {
		levelName = "Room for Red",
		introScript = "Land28_Tip5",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
			hasSteelGlass = true,
		},
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "RoomForRed_glass",
				isPatternSet = false,
			},
			spawnGemOnBreak = 
			{
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 2,
				},
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 2, 
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
			},
		},
		goals = {
			main = {"haveGem",24,"Red","Reds",{matchFlags = CascadeMatchFlags_CommonPiece4},},
			stars = {
				[1] = {"score",20000},
				[2] = {"score",250000},
				[3] = {"score",1000000},
			},
		},
	},
	-- Naomi levels

	["BlockedBombs"] = {
		levelName = "Blocked Bombs",
		introScript = "Land28_Tip3",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasSteelGlass = true,
			regularBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "LittleCratePattern1",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "Line1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 40,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",800000},
				[3] = {"score",1300000},
			},
		},
		expectedScore = 100000, 
	},

	["LockedCabinet"] = {
		levelName = "Locked Cabinet",
		outtroScript = "Land28_Outtro",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			largeBoard = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "Reels26", 
				isPatternSet = false,
            },
			useSteelGlass = true,
			steelGlass = {
				patternName = "MidCols",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "LockedCabinet_Locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lock","Locks",{specials = CascadePieceSpecials_Lock}},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000, 
	},
	["GlassSafe"] = {
		levelName = "Glass Safe",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasStones = true,
			largeBoard = true,
			hasJailedSquares = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "TopCenterBlock",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "Row5Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				{
					patternName = "Row2Center3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "Row3Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				{
					patternName = "Row4Center3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "NoTouchTreasure_Treasure",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000, 
	},

	["GlassHouses"] = {
		levelName = "Glass Houses",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasBarrels = true,
			largeBoard = true,
			hasMakers = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "GlassHouse",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "Boulders",
					delay = 0,
					events = { --Make 1 gem every move
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                    },
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
			},
			
			additionalInitialPatterns = {
				{
					patternName = "Row1Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulders"},
				},
			},
		},
		goals = {
			main = {"getGem",24,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",80000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000, 
	},

	["DelayedGratification"] = {
		levelName = "Delayed Gratification",					
		resource = "GameScreen_Land28",
		introScript = "Land28_Tip4",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			hasSteelGlass = true,
			largeBoard = true,
			hasMakers = true,
			hasMissingSquares = true,
			hasBombs = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "DelayedGratification_glass",
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "DelayedGratification_missing", 
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Bomb Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
							reset = true,
						},
					},
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 1.5,
					},
				},
				[2] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Bomb Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "DelayedGratification_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix", "Normal mix"},
				},
			},
		},
		goals = {
			main = {"getGem",15,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},"Defuse"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000, 
	},
	["Antigravity"] = {
		levelName = "Antigravity",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			hasMakers = true,
			gemTypes5 = true,
		},
		Properties = {
			gemsMoveDiagonally = false,
			useMissingSquares = true,
			missingSquares = {
				patternName = "UpArrowNegativeSpace", 
				isPatternSet = false,
            },
			useMissingReels = true,
            missingReels = {
				patternName = "MissingLargeSideReels", 
				isPatternSet = false,
            },
			portals = {
				[1] = {{3,3},{3,2},"PortalEntrance_1","PortalExit_1"},
				[2] = {{3,2},{3,1},"PortalEntrance_1","PortalExit_1"},
				[3] = {{3,4},{3,3},"PortalEntrance_1","PortalExit_1"},
				[4] = {{3,5},{3,4},"PortalEntrance_1","PortalExit_1"},
				[5] = {{3,6},{3,5},"PortalEntrance_1","PortalExit_1"},
				[6] = {{4,3},{4,2},"PortalEntrance_1","PortalExit_1"},
				[7] = {{4,2},{4,1},"PortalEntrance_1","PortalExit_1"},
				[8] = {{4,4},{4,3},"PortalEntrance_1","PortalExit_1"},
				[9] = {{4,5},{4,4},"PortalEntrance_1","PortalExit_1"},
				[10] = {{4,6},{4,5},"PortalEntrance_1","PortalExit_1"},
				[11] = {{2,3},{2,2},"PortalEntrance_1","PortalExit_1"},
				[12] = {{2,2},{2,1},"PortalEntrance_1","PortalExit_1"},
				[13] = {{2,4},{2,3},"PortalEntrance_1","PortalExit_1"},
				[14] = {{2,5},{2,4},"PortalEntrance_1","PortalExit_1"},
				[15] = {{2,6},{2,5},"PortalEntrance_1","PortalExit_1"},
				[16] = {{3,7},{3,6},"PortalEntrance_1","PortalExit_1"},
				[17] = {{2,7},{2,6},"PortalEntrance_1","PortalExit_1"},
				[18] = {{4,7},{4,6},"PortalEntrance_1","PortalExit_1"},
				[19] = {{0,7},{2,7},"PortalEntrance_1","PortalExit_1"},
				[20] = {{6,7},{4,7},"PortalEntrance_1","PortalExit_1"},
				[21] = {{3,0},{3,7},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
                {
                    name = "Regular Mix",
                    delay = 0,
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Gem 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Antigrav_makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	--begin Land 28 side levels
	["PictureFrame2"] = {
		levelName = "Picture Frame 2",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSteelGlass = true,
		},
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "PictureFrame2_pattern",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "PictureFrame2_pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",600000},
				[3] = {"score",1200000},
			},
		},
	},
	["Conservatory"] = {
		levelName = "Conservatory",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasSteelGlass = true,
			hasVines = true,
		},
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "Conservatory_glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Conservatory_vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["SuperSafe"] = {
		levelName = "Super Safe",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasStones = true,
			largeBoard = true,
			hasJailedSquares = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "TopCenterBlock",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "Treasures",
					delay = 0,
					{
                        name = "Treasure",
                        matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
                        weight = 1,
                    },
                },
            },
			additionalInitialPatterns = {
				{
					patternName = "NoTouchTreasure_Treasure",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
					applySpawnTypes = true,
					spawnTypes = {"Treasures"},
				},
				{
					patternName = "Row5Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				{
					patternName = "Row2Center3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					--applyExtraHits = true,
					--extraHits = 1,
				},
				{
					patternName = "Row3Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				{
					patternName = "Row4Center3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",1600000},
			},
		},
		expectedScore = 100000, 
	},

	["DelayedGratification2"] = {
		levelName = "Delayed Gratification 2",					
		resource = "GameScreen_Land28",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			hasSteelGlass = true,
			largeBoard = true,
			hasMakers = true,
			hasMissingSquares = true,
			hasBombs = true,
			hasBalloons = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "DelayedGratification2_glass",
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "DelayedGratification2_missing", 
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Balloon Bomb Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
							reset = true,
						},
					},
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Balloon,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Balloon,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Balloon,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Balloon,
						turnsToLoss = 15,
						weight = 1.5,
					},
				},
				[2] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Balloon Bomb Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "DelayedGratification2_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon Bomb Mix"},
				},
			},
		},
		goals = {
			main = {"getGem",5,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Balloon},"Defuse"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000, 
	},

	["ColorImbalance"] = {
		levelName = "Color Imbalance",
		introScript = "Land28_ColorImbalance",
		resource = "GameScreen_Land28",
		Features = {
			modeSpins2 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			largeBoard = true,
		},
		tricks = {
			{name = Config.World28Tricks_Trick1},
			{name = Config.World28Tricks_Trick2},
			{name = Config.World28Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World28Boosts,
		Properties = {
			additionalNamedMixes = {
                ImbalanceMix(1, 8),
                ImbalanceMix(2, 8),
                ImbalanceMix(3, 8),
                ImbalanceMix(4, 8),
                ImbalanceMix(1, 10),
                ImbalanceMix(2, 10),
                ImbalanceMix(3, 10),
                ImbalanceMix(4, 10),
                ImbalanceMix(1, 12),
                ImbalanceMix(2, 12),
                ImbalanceMix(3, 12),
                ImbalanceMix(4, 12),
                ImbalanceMix(1, 14),
                ImbalanceMix(2, 14),
                ImbalanceMix(3, 14),
                ImbalanceMix(4, 14),
                ImbalanceMix(1, 16),
                ImbalanceMix(2, 16),
                ImbalanceMix(3, 16),
                ImbalanceMix(4, 16),
                ImbalanceMix(1, 18),
                ImbalanceMix(2, 18),
                ImbalanceMix(3, 18),
                ImbalanceMix(4, 18),
                ImbalanceMix(1, 20),
                ImbalanceMix(2, 20),
                ImbalanceMix(3, 20),
                ImbalanceMix(4, 20),
                ImbalanceMix(1, 22),
                ImbalanceMix(2, 22),
                ImbalanceMix(3, 22),
                ImbalanceMix(4, 22),
                ImbalanceMix(1, 24),
                ImbalanceMix(2, 24),
                ImbalanceMix(3, 24),
                ImbalanceMix(4, 24),
                ImbalanceMix(1, 26),
                ImbalanceMix(2, 26),
                ImbalanceMix(3, 26),
                ImbalanceMix(4, 26),
                ImbalanceMix(1, 28),
                ImbalanceMix(2, 28),
                ImbalanceMix(3, 28),
                ImbalanceMix(4, 28),
                ImbalanceMix(1, 30),
                ImbalanceMix(2, 30),
                ImbalanceMix(3, 30),
                ImbalanceMix(4, 30),
                ImbalanceMix(1, 32),
                ImbalanceMix(2, 32),
                ImbalanceMix(3, 32),
                ImbalanceMix(4, 32),
                ImbalanceMix(1, 34),
                ImbalanceMix(2, 34),
                ImbalanceMix(3, 34),
                ImbalanceMix(4, 34),
                ImbalanceMix(1, 36),
                ImbalanceMix(2, 36),
                ImbalanceMix(3, 36),
                ImbalanceMix(4, 36),
                ImbalanceMix(1, 38),
                ImbalanceMix(2, 38),
                ImbalanceMix(3, 38),
                ImbalanceMix(4, 38),
                ImbalanceMix(1, 40),
                ImbalanceMix(2, 40),
                ImbalanceMix(3, 40),
                ImbalanceMix(4, 40),
                ImbalanceMix(1, 42),
                ImbalanceMix(2, 42),
                ImbalanceMix(3, 42),
                ImbalanceMix(4, 42),
                ImbalanceMix(1, 44),
                ImbalanceMix(2, 44),
                ImbalanceMix(3, 44),
                ImbalanceMix(4, 44),
                ImbalanceMix(1, 46),
                ImbalanceMix(2, 46),
                ImbalanceMix(3, 46),
                ImbalanceMix(4, 46),
                ImbalanceMix(1, 48),
                ImbalanceMix(2, 48),
                ImbalanceMix(3, 48),
                ImbalanceMix(4, 48),
                {
                    name = "Regular Mix",
                    delay = 0,
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Line8_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {
						"Imbalance_1_8","Imbalance_2_8","Imbalance_3_8","Imbalance_4_8",
						"Imbalance_1_10","Imbalance_2_10","Imbalance_3_10","Imbalance_4_10",
						"Imbalance_1_12","Imbalance_2_12","Imbalance_3_12","Imbalance_4_12",
						"Imbalance_1_14","Imbalance_2_14","Imbalance_3_14","Imbalance_4_14",
						"Imbalance_1_16","Imbalance_2_16","Imbalance_3_16","Imbalance_4_16",
						"Imbalance_1_18","Imbalance_2_18","Imbalance_3_18","Imbalance_4_18",
						"Imbalance_1_20","Imbalance_2_20","Imbalance_3_20","Imbalance_4_20",
						"Imbalance_1_22","Imbalance_2_22","Imbalance_3_22","Imbalance_4_22",
						"Imbalance_1_24","Imbalance_2_24","Imbalance_3_24","Imbalance_4_24",
						"Imbalance_1_26","Imbalance_2_26","Imbalance_3_26","Imbalance_4_26",
						"Imbalance_1_28","Imbalance_2_28","Imbalance_3_28","Imbalance_4_28",
						"Imbalance_1_30","Imbalance_2_30","Imbalance_3_30","Imbalance_4_30",
						"Imbalance_1_32","Imbalance_2_32","Imbalance_3_32","Imbalance_4_32",
						"Imbalance_1_34","Imbalance_2_34","Imbalance_3_34","Imbalance_4_34",
						"Imbalance_1_36","Imbalance_2_36","Imbalance_3_36","Imbalance_4_36",
						"Imbalance_1_38","Imbalance_2_38","Imbalance_3_38","Imbalance_4_38",
						"Imbalance_1_40","Imbalance_2_40","Imbalance_3_40","Imbalance_4_40",
						"Imbalance_1_42","Imbalance_2_42","Imbalance_3_42","Imbalance_4_42",
						"Imbalance_1_44","Imbalance_2_44","Imbalance_3_44","Imbalance_4_44",
						"Imbalance_1_46","Imbalance_2_46","Imbalance_3_46","Imbalance_4_46",
						"Imbalance_1_48","Imbalance_2_48","Imbalance_3_48","Imbalance_4_48",
						"Regular Mix",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",1300000},
				[3] = {"score",3000000},
			},
		},
		expectedScore = 100000, 
	},
	--end Land 28 side levels

})