-- Land 29: axes and bedrock

table.insertall(LevelDefs,
{
	["KeyGemTest"] = {
		levelName = "Into the Mines",
		introScript = "Land29_Intro",			
		resource = "GameScreen_Land29",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasColoredKeyGems = true,
			hasStones = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Red Wall",
					patternName = "KeyGemTest_RedWall",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Remove Blue Wall",
					patternName = "KeyGemTest_BlueWall",
					isPatternSet = false,
					applyIcon = true,
					clearPieces = true,
				},
			
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "KeyGemTest_RedWall",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "KeyGemTest_BlueWall",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "KeyGemTest_RedKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Wall"},
				},
				[4] = {
					patternName = "KeyGemTest_BlueKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Wall"},
				},
				[5] = {
					patternName = "KeyGemTest_Stone",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 2,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bedrock.singular","Bedrock.plural",{specials = CascadePieceSpecials_Steel,},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000, 
	},

	
	["RotatingLasers"] = {
		levelName = "Rotating Lasers",
		resource = "GameScreen_Land29",
		Features = {
			splashMode = true,
			modeSpins3 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasLasers = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						skinVariant = "RustLaserV",
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						skinVariant = "RustLaserV",
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						skinVariant = "RustLaserV",
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						skinVariant = "RustLaserV",
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
				[2] = {
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						skinVariant = "RustLaserH",
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						skinVariant = "RustLaserH",
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						skinVariant = "RustLaserH",
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						skinVariant = "RustLaserH",
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "LaserV",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "RustLaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "LaserH",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "RustLaserH",
						},
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "RotatingLasers_Lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
					applySkinVariant = true,
					skinVariant = "RustLaserH",
				},
			},
		},
		goals = {
			main = {"getGem",20,"Combo Burst","Combo Bursts",
					{
						{specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash,},
						{specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash | CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash | CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash +  CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,},
					},
					"Make",
				},
			stars = {
				[1] = {"score",1500000},
				[2] = {"score",2250000},
				[3] = {"score",3500000},
			},
		},
	},
	["LongestChest"] = {
		levelName = "Longest Chest",
		resource = "GameScreen_Land29",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasChests = true,
			hasMakers = true,
			hasPortals = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "One Chest Always",
					delay = 0,
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "population",
							count = 1,
							newDelay = 0,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
					},
				},
				[2] = {
					name = "Normal Mix",
					delay = 0,
					{
						name = "Gem1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Gem2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Gem3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Gem4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Gem5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "RubeMachine_gem1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"One Chest Always","Normal Mix"},
				},
			},
			portals = {
				[1] = {{0,7},{1,0},"PortalEntrance_1","PortalExit_1"},
				[2] = {{1,7},{2,0},"PortalEntrance_1","PortalExit_1"},
				[3] = {{2,7},{3,0},"PortalEntrance_1","PortalExit_1"},
				[4] = {{3,7},{4,0},"PortalEntrance_1","PortalExit_1"},
				[5] = {{4,7},{5,0},"PortalEntrance_1","PortalExit_1"},
				[6] = {{5,7},{6,0},"PortalEntrance_1","PortalExit_1"},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop"},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",400000},
				[3] = {"score",450000},
			},
		},
	},
	
	["LaserJail"] = {
		levelName = "Laser Jail",
		resource = "GameScreen_Land29",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes6 = true,
			hasLasers = true,
			hasJailedSquares = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						skinVariant = "RustLaserV",
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						skinVariant = "RustLaserV",
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						skinVariant = "RustLaserV",
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						skinVariant = "RustLaserV",
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						skinVariant = "RustLaserV",
						weight = 1,
					},
					{
						name = "Laser6",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						skinVariant = "RustLaserV",
						weight = 1,
					},
				},
				[2] = {
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						skinVariant = "RustLaserH",
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						skinVariant = "RustLaserH",
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						skinVariant = "RustLaserH",
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						skinVariant = "RustLaserH",
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						skinVariant = "RustLaserH",
						weight = 1,
					},
					{
						name = "Laser6",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						skinVariant = "RustLaserH",
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "LaserV",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "RustLaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "LaserH",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "RustLaserH",
						},
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "LaserJail_HorizontalLasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
					skinVariant = "RustLaserH",
					applySkinVariant = true,
				},
				{
					patternName = "LaserJail_VerticalLasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
					skinVariant = "RustLaserV",
					applySkinVariant = true,
				},
				{
					patternName = "LaserJail_Jails",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyExtraHits = true,
					extraHits = 1,
				},

                --Color patterns
                {
                    patternName = "LaserJail_Blue",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                },
                {
                    patternName = "LaserJail_Green",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                },
                {
                    patternName = "LaserJail_Purple",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                },
                {
                    patternName = "LaserJail_Red",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                },
                {
                    patternName = "LaserJail_Yellow",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                },
                {
                    patternName = "LaserJail_Orange",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                },
			},
		},
		goals = {
            main = {"gemsRemain",0,"Jail","Jails",{cancelSpecials = CascadePieceSpecials_Jailed},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
	},
	
	["ScrollingBursts"] = {
		levelName = "Scrolling Bursts",
		resource = "GameScreen_Land29",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes6 = true,
			hasMakers = true,
			hasPortals = true,
			hasGemEaters = true,
			hasCoverage = true,
			hasMissingSquares = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Burst Mix",
					delay = 0,
					{
						name = "Burst 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Burst 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Burst 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Burst 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Burst 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Burst 6",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Burst Mix",
						delay = -1,
					},
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "ScrollingBursts_Missing",
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "ScrollingBursts_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Burst Mix"},
				},
				[2] = {
					patternName = "ScrollingBursts_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 4,
				},
				[3] = {
					patternName = "ScrollingBursts_GemEater",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
			},
			portals = {
				[1] = {{0,1},{0,7},"PortalEntrance_1","PortalExit_1"},
				[2] = {{0,7},{1,7},"PortalEntrance_1","PortalExit_1"},
				[3] = {{1,7},{2,7},"PortalEntrance_1","PortalExit_1"},
				[4] = {{2,7},{3,7},"PortalEntrance_1","PortalExit_1"},
				[5] = {{3,7},{4,7},"PortalEntrance_1","PortalExit_1"},
				[6] = {{4,7},{5,7},"PortalEntrance_1","PortalExit_1"},
				[7] = {{5,7},{6,7},"PortalEntrance_1","PortalExit_1"},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},
	
	--begin Michael levels
	
	["DunkTank"] = {
		levelName = "Dunk Tank",					
		resource = "GameScreen_Land29",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasChests = true,
			hasSteel = true,
			hasFences = true,
			hasMissingSquares = true,
			largeBoard = true,
			hasColoredKeyGems = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Green Wall",
					patternName = "DunkTank_gemisteel",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			useMissingSquares = true,
            missingSquares = {
				patternName = "DunkTank_missing",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "DunkTank_gemisteel",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "DunkTank_keygem",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Wall"},
				},
				[3] = {
					patternName = "DunkTank_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[4] = {
					patternName = "DunkTank_void",
					clearPieces = true,
					isPatternSet = false,
				},
				[5] = {
					patternName = "DunkTank_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
				},
				[6] = {
					patternName = "DunkTank_fence",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000, 
	},

	["Parfait"] = {
		levelName = "Parfait",					
		resource = "GameScreen_Land29",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			largeBoard = true,
			hasColoredKeyGems = true,
			hasStones = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "Parfait_glass",
				isPatternSet = false,
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Green Wall",
					patternName = "Parfait_greenGemisteel",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Remove Blue Wall",
					patternName = "Parfait_blueGemisteel",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "Remove Red Wall",
					patternName = "Parfait_redGemisteel",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Parfait_greenGemisteel",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "Parfait_blueGemisteel",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "Parfait_redGemisteel",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[4] = {
					patternName = "Parfait_greenKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Wall"},
				},
				[5] = {
					patternName = "Parfait_blueKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Wall"},
				},
				[6] = {
					patternName = "Parfait_redKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Wall"},
				},
				[7] = {
					patternName = "Parfait_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},

	["DugTooDeep"] = {
		levelName = "Dug Too Deep",
		resource = "GameScreen_Land29",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasFences = true,
			hasLava = true,
			hasStones = true,
			hasAmber = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "DugTooDeep_fences",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Fence,
                    matchFlags = 0,
				},
				[2] = {
					patternName = "DugTooDeep_lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				[3] = {
					patternName = "DugTooDeep_amber",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				[4] = {
					patternName = "DugTooDeep_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Amber","Ambers",{specials = CascadePieceSpecials_Amber},},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["CoalVein"] = {
		levelName = "Coal Vein",
		resource = "GameScreen_Land29",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasCrates = true,
			hasStones = true,
			hasBarrels = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CoalVein_crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "CoalVein_boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				[3] = {
					patternName = "CoalVein_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
	},

	["GoldDrop"] = {
		levelName = "Gold Drop",					
		resource = "GameScreen_Land29",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasCoconuts = true,
			hasSteel = true,
			hasFences = true,
			hasChests = true,
			largeBoard = true,
			hasColoredKeyGems = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Green Keygem",
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Wall"},
					weight = 11,
				},

			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Green Wall",
					patternName = "PickYourNose_upperGemisteel",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Remove Yellow Wall",
					patternName = "PickYourNose_lowerGemisteel",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "PickYourNose_lowerGemisteel",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemYellow",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "PickYourNose_upperGemisteel",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "PickYourNose_keygem",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Yellow Wall"},
				},
				[4] = {
					patternName = "PickYourNose_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[5] = {
					patternName = "PickYourNose_coconut",
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				[6] = {
					patternName = "PickYourNose_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
				},
				--[[
				[6] = {
					patternName = "PickYourNose_fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				--]]
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",400000},
				[3] = {"score",750000},
			},
		},
		expectedScore = 100000, 
	},
	["Hypobaric"] = {
		levelName = "Hypobaric",					
		introScript = "Land29_Tip2",
        resource = "GameScreen_Land29",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			hasSteel = true,
			largeBoard = true,
			hasColoredKeyGems = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Green Rock",
					patternName = "Hypobaric_greenRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Remove Blue Rock",
					patternName = "Hypobaric_blueRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "Remove Red Rock",
					patternName = "Hypobaric_redRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[4] = {
					entryName = "Remove Orange Rock",
					patternName = "Hypobaric_orangeRock",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Hypobaric_blueRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "Hypobaric_greenRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "Hypobaric_redRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[4] = {
					patternName = "Hypobaric_orangeRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemOrange",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[5] = {
					patternName = "Hypobaric_bluePick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Rock"},
				},
				[6] = {
					patternName = "Hypobaric_greenPick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Rock"},
				},
				[7] = {
					patternName = "Hypobaric_redPick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Rock"},
				},
				[8] = {
					patternName = "Hypobaric_orangePick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Orange Rock"},
				},
				[9] = {
					patternName = "Hypobaric_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[10] = {
					patternName = "Hypobaric_giftBox",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 2,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Stone","Stones",{specials = CascadePieceSpecials_Stone, extraHits = 0},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
	["TimeToBlast"] = {
		levelName = "Time to Blast",					
		resource = "GameScreen_Land29",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes6 = true,
			regularBoard = true,
			hasBombs = true,
			hasColoredKeyGems = true,
			hasSteel = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Blue Rock",
					patternName = "TimeToBlast_blueRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Remove Red Rock",
					patternName = "TimeToBlast_redRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "Remove Green Rock",
					patternName = "TimeToBlast_greenRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[4] = {
					entryName = "Remove Purple Rock",
					patternName = "TimeToBlast_purpleRock",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TimeToBlast_blueRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "TimeToBlast_redRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "TimeToBlast_bluePick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Rock"},
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				[4] = {
					patternName = "TimeToBlast_redPick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Rock"},
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				[5] = {
					patternName = "TimeToBlast_bombs1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				[6] = {
					patternName = "TimeToBlast_bombs2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 22,
				},
				[7] = {
					patternName = "TimeToBlast_bombs3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 24,
				},
				[8] = {
					patternName = "TimeToBlast_greenRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[9] = {
					patternName = "TimeToBlast_purpleRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[10] = {
					patternName = "TimeToBlast_greenPick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Rock"},
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				[11] = {
					patternName = "TimeToBlast_purplePick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Purple Rock"},
					cancelSpecials = CascadePieceSpecials_Amber_bomb,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000, 
	},
	["PayDirt"] = {
		levelName = "Pay Dirt",
		resource = "GameScreen_Land29",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasCrates = true,
			hasChests = true,
			hasBarrels = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "PayDirt_crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				[2] = {
					patternName = "PayDirt_boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applyExtraHits = true,
					extraHits = 1,
				},
				[3] = {
					patternName = "PayDirt_gold",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},
	--end Michael levels
	

    --begin Roh levels
    ["PrisonBreak"] = {
        --Match jailed keygems to remove steel surrounding the next jailed keygem. Goal: Free N jailed gems.
        levelName = "Prison Break",                 
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins6 = true,
            gemTypes5 = true,

            hasJailedSquares = true,
			hasColoredKeyGems = true,
            hasSteel = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            additionalNamedPatterns = {
                [1] = {
                    entryName = "Remove Red Wall",
                    patternName = "PrisonBreak_RedWall",
                    isPatternSet = false,
                    clearPieces = true,
                },
                [2] = {
                    entryName = "Remove Blue Wall",
                    patternName = "PrisonBreak_BlueWall",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                [3] = {
                    entryName = "Remove Green Wall",
                    patternName = "PrisonBreak_GreenWall",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                [4] = {
                    entryName = "Remove Yellow Wall",
                    patternName = "PrisonBreak_YellowWall",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                --GemiSteel Walls
                {
                    patternName = "PrisonBreak_RedWall",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "PrisonBreak_BlueWall",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "PrisonBreak_GreenWall",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "PrisonBreak_YellowWall",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemYellow",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },


                -- --KEYS
                {
                    patternName = "PrisonBreak_RedKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Red Wall"},
                },
                {
                    patternName = "PrisonBreak_BlueKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Blue Wall"},
                },
                {
                    patternName = "PrisonBreak_GreenKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Green Wall"},
                },
                {
                    patternName = "PrisonBreak_YellowKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Yellow Wall"},
                },

                -- --Jails
                {
                    patternName = "PrisonBreak_Jails",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    specials = CascadePieceSpecials_Jailed,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyCancelSpecials = true,
                },
				{
                    patternName = "PrisonBreak_KeyJails",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    specials = CascadePieceSpecials_Jailed,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed_ColorKeyGem,
                    applyCancelSpecials = true,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",400000},
                [3] = {"score",1000000},
            },
        },
        expectedScore = 100000, 
    },

    ["SteelDig"] = {
        --Match colored key gems (from board mix) to break up steel, then match patterns. 
        levelName = "The Big Dig",                 
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes5 = true,
            
            hasSteel = true,
            hasStones = true,
            hasColoredKeyGems = true,
            hasCoverage = true,
            hasMakers = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            additionalNamedMixes = {
                {
                    name = "Counting Mix",
                    delay = -1,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 5,
                            newDelay = -1,
                            reset = true,
                        },
                        {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = 0,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                },
                {
                    name = "Blue Key Mix",
                    delay = 0,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece1,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_GemBlue",
                            },
                        },
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Blue Steel"},
                    },
                },
                {
                    name = "Green Key Mix",
                    delay = 0,--5,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece2,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_SpecialGemGreen",
                            },
                        },
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Green Steel"},
                    },
                },
                {
                    name = "Purple Key Mix",
                    delay = 0,--10,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece3,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_GemPurple",
                            },
                        },
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Purple Steel"},
                    },
                },
                {
                    name = "Red Key Mix",
                    delay = 0,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece4,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_SpecialGemRed",
                            },
                        },
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Red Steel"},
                    },
                },
                {
                    name = "Yellow Key Mix",
                    delay = 0,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece5,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_GemYellow",
                            },
                        },
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Yellow Steel"},
                    },
                },
                {
                    name = "5 Color Mix",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "Remove Blue Steel",
                    patternName = "SteelDig_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Green Steel",
                    patternName = "SteelDig_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Purple Steel",
                    patternName = "SteelDig_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Red Steel",
                    patternName = "SteelDig_RedSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Yellow Steel",
                    patternName = "SteelDig_YellowSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                --Maker
                {
                    patternName = "SteelDig_Makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Counting Mix","Blue Key Mix","Green Key Mix","Red Key Mix","Purple Key Mix","Yellow Key Mix","5 Color Mix"},
                },

                --clear squares
                {
                    patternName = "SteelDig_Squares",
                    isPatternSet = false,
                    matchRequirement = 1,
                    applyMatchRequirement = true,
                },
                {
                    patternName = "SteelDig_Stones",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyExtraHits = true,
                    extraHits = 1,
                },

                --GemiSteel Steels
                {
                    patternName = "SteelDig_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "SteelDig_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "SteelDig_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "SteelDig_RedSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "SteelDig_YellowSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemYellow",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"patterns",0,},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",200000},
                [3] = {"score",300000},
            },
        },
        expectedScore = 100000, 
    },
    
    ["LavaDam"] = {
        levelName = "Lava Dam",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes5 = true,

            hasSteel = true,
            hasLava = true,
            hasColoredKeyGems = true,
            hasMissingReels = true,
            hasMissingSquares = true,
            hasMakers = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "LavaDam_Reels", 
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "LavaDam_Missing", 
                isPatternSet = false,
            },
            additionalNamedMixes = {
                {
                    name = "Burst Mix",
                    delay = -1,
                    events = {
                        {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
                                matchFlags = 0,
                                skinVariant = "BedRock",
                            },
                        },
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 4,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 4,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 4,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 4,
                    },
                    {
                        name = "Burst 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Burst 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Burst 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                    {
                        name = "Burst 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = CascadePieceSpecial_HorizontalSplash,
                        weight = 1,
                    },
                },
                {
                    name = "Blue Key Mix",
                    delay = 0,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece1,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_GemBlue",
                            },
                        },
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Blue Steel"},
                    },
                },
                {
                    name = "Green Key Mix",
                    delay = 8,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece2,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_SpecialGemGreen",
                            },
                        },
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Green Steel"},
                    },
                },
                {
                    name = "Purple Key Mix",
                    delay = 16,--10,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece3,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_GemPurple",
                            },
                        },
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Purple Steel"},
                    },
                },
                {
                    name = "Red Key Mix",
                    delay = 24,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece4,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_SpecialGemRed",
                            },
                        },
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Red Steel"},
                    },
                },
                {
                    name = "4 Color Mix",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "Remove Blue Steel",
                    patternName = "LavaDam_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Green Steel",
                    patternName = "LavaDam_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Purple Steel",
                    patternName = "LavaDam_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Red Steel",
                    patternName = "LavaDam_RedSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "LavaDam_Makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Burst Mix","Blue Key Mix","Green Key Mix","Red Key Mix","Purple Key Mix","4 Color Mix"},
                },
                {
                    patternName = "LavaDam_Lava",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Lava,
                    matchFlags = 0,
                },

                --GemiSteel Steels
                {
                    patternName = "LavaDam_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "LavaDam_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "LavaDam_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "LavaDam_RedSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
            },
            endGameProperties = {
                additionalNamedMixes = {
                    [1] = {
                        name = "Burst Mix",
                        delay = -1,
                    },
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
            stars = {
                [1] = {"score",300000},
                [2] = {"score",500000},
                [3] = {"score",950000},
            },
        },
    },

    ["JungleTrap"] = {
        levelName = "Jungle Trap",
        resource = "GameScreen_Land29",
		outtroScript = "Land29_Outtro",	
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins11 = true,
            gemTypes5 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
            hasVines = true,
            hasVineGenerators = true,
            hasCoverage = true,
            hasMakers = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            additionalNamedMixes = {
                {
                    name = "Burst Mix",
                    delay = -1,
                    events = {
                        {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
                                matchFlags = 0,
                                skinVariant = "BedRock",
                            },
                        },
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 4,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 4,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 4,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 4,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 4,
                    },
                    {
                        name = "Burst 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecial_BlockSplash,
                        weight = 1,
                    },
                    {
                        name = "Burst 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        specials = CascadePieceSpecial_BlockSplash,
                        weight = 1,
                    },
                    {
                        name = "Burst 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        specials = CascadePieceSpecial_BlockSplash,
                        weight = 1,
                    },
                    {
                        name = "Burst 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = CascadePieceSpecial_BlockSplash,
                        weight = 1,
                    },
                    {
                        name = "Burst 5",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        specials = CascadePieceSpecial_BlockSplash,
                        weight = 1,
                    },
                },
                {
                    name = "Blue Key Mix",
                    delay = 0,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece1,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_SpecialGemBlue",
                            },
                        },
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Blue Steel"},
                    },
                },
                {
                    name = "Red Key Mix",
                    delay = 8,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece4,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_GemRed",
                            },
                        },
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Red Steel"},
                    },
                },
                {
                    name = "Purple Key Mix",
                    delay = 16,--10,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece3,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_GemPurple",
                            },
                        },
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Purple Steel"},
                    },
                },
                {
                    name = "Green Key Mix",
                    delay = 24,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece2,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_SpecialGemGreen",
                            },
                        },
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Green Steel"},
                    },
                },
                {
                    name = "Yellow Key Mix",
                    delay = 32,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 1,
                            reset = true,
                        },
                        [2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                matchFlags = CascadeMatchFlags_CommonPiece5,
                                icon = "Icon_PickAxe",
                            },
                        },
                        [3] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_GemYellow",
                            },
                        },
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                        specials = CascadePieceSpecial_CantCover,
                        icon = "Icon_PickAxe",
                        matchPatterns = {"Remove Yellow Steel"},
                    },
                },
                {
                    name = "5 Color Mix",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "Remove Blue Steel",
                    patternName = "JungleTrap_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Green Steel",
                    patternName = "JungleTrap_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Purple Steel",
                    patternName = "JungleTrap_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Red Steel",
                    patternName = "JungleTrap_RedSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Yellow Steel",
                    patternName = "JungleTrap_YellowSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "JungleTrap_Makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Burst Mix","Blue Key Mix","Green Key Mix","Red Key Mix","Purple Key Mix","Yellow Key Mix","5 Color Mix"},
                },

                {
                    patternName = "JungleTrap_Coverage",
                    isPatternSet = false,
                    applyMatchRequirement = true,
                    matchRequirement = 1,
                },
                {
                    patternName = "JungleTrap_VineGrowers",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_VineGenerator,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    skinVariant = "VineGrower",
                    applySkinVariant = true,
                },
                {
                    patternName = "JungleTrap_Vines",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_Vines,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                },

                --GemiSteel Steels
                {
                    patternName = "JungleTrap_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "JungleTrap_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "JungleTrap_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "JungleTrap_RedSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "JungleTrap_YellowSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemYellow",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"patterns",0,},
            stars = {
                [1] = {"score",400000},
                [2] = {"score",500000},
                [3] = {"score",700000},
            },
        },
    },

    ["RockCity"] = {
        levelName = "Rock City",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes5 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
            hasChests = true,
            hasStones = true,
            hasMissingReels = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "RockCity_Reels", 
                isPatternSet = false,
            },
            additionalNamedPatterns = {
                {
                    entryName = "Remove Green Steel",
                    patternName = "RockCity_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Purple Steel",
                    patternName = "RockCity_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Red Steel",
                    patternName = "RockCity_RedSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Yellow Steel",
                    patternName = "RockCity_YellowSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "RockCity_Chests",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Treasure,
                },
                {
                    patternName = "RockCity_Stones",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 2,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                },

                -- --KEYS
                {
                    patternName = "RockCity_GreenKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Green Steel"},
                },
                {
                    patternName = "RockCity_PurpleKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Purple Steel"},
                },
                {
                    patternName = "RockCity_RedKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Red Steel"},
                },
                {
                    patternName = "RockCity_YellowKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Yellow Steel"},
                },

                --GemiSteel Steels
                {
                    patternName = "RockCity_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "RockCity_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "RockCity_RedSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "RockCity_YellowSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemYellow",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop"},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",500000},
                [3] = {"score",800000},
            },
        },
    },

    ["Stratum"] = {
        levelName = "Stratum",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins6 = true,
            gemTypes4 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
            hasMissingSquares = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "Stratum_Missing", 
                isPatternSet = false,
            },
            additionalNamedPatterns = {
                {
                    entryName = "Remove Green Steel",
                    patternName = "Stratum_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Purple Steel",
                    patternName = "Stratum_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Red Steel",
                    patternName = "Stratum_RedSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Blue Steel",
                    patternName = "Stratum_BlueSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                

                -- --KEYS
                {
                    patternName = "Stratum_GreenKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed - CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Green Steel"},
                },
                {
                    patternName = "Stratum_PurpleKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed - CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Purple Steel"},
                },
                {
                    patternName = "Stratum_RedKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Red Steel"},
                },
                {
                    patternName = "Stratum_BlueKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Blue Steel"},
                },

                --GemiSteel Steels
                {
                    patternName = "Stratum_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "Stratum_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "Stratum_RedSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "Stratum_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Bedrock.singular","Bedrock.plural",{specials = CascadePieceSpecials_Steel,},},
            stars = {
                [1] = {"score",200000},
                [2] = {"score",600000},
                [3] = {"score",1000000},
            },
        },
    },

    ["BlockedPlumbing"] = {
        levelName = "Blocked Plumbing",
        resource = "GameScreen_Land29",
		Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes6 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "Remove Green Steel",
                    patternName = "BlockedPlumbing_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Purple Steel",
                    patternName = "BlockedPlumbing_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Red Steel",
                    patternName = "BlockedPlumbing_RedSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Blue Steel",
                    patternName = "BlockedPlumbing_BlueSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Yellow Steel",
                    patternName = "BlockedPlumbing_YellowSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Orange Steel",
                    patternName = "BlockedPlumbing_OrangeSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalNamedMixes = {
                {
                    name = "No Blue",
                    delay = 0,
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                    {
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        weight = 1,
                    },
                },
                {
                    name = "Some Blue",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                    {
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        weight = 1,
                    },
                },
                {
                    name = "More Blue",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1.5,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                    {
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        weight = 1,
                    },
                },
                {
                    name = "Heavy Blue",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 3,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                    {
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = {
                --Makers
                {
                    patternName = "BlockedPlumbing_Makers0",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"No Blue"},
                },
                {
                    patternName = "BlockedPlumbing_Makers1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Some Blue"},
                },
                {
                    patternName = "BlockedPlumbing_Makers2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"More Blue"},
                },
                {
                    patternName = "BlockedPlumbing_Makers3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Heavy Blue"},
                },

                -- --KEYS
                {
                    patternName = "BlockedPlumbing_BlueKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Blue Steel"},
                },
                {
                    patternName = "BlockedPlumbing_GreenKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Green Steel"},
                },
                {
                    patternName = "BlockedPlumbing_PurpleKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Purple Steel"},
                },
                {
                    patternName = "BlockedPlumbing_RedKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Red Steel"},
                },
                {
                    patternName = "BlockedPlumbing_YellowKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Yellow Steel"},
                },
                {
                    patternName = "BlockedPlumbing_OrangeKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Orange Steel"},
                },

                --GemiSteel Steels
                {
                    patternName = "BlockedPlumbing_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "BlockedPlumbing_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "BlockedPlumbing_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "BlockedPlumbing_RedSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "BlockedPlumbing_YellowSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemYellow",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "BlockedPlumbing_OrangeSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemOrange",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"getGem",40,"Blue","Blues",{matchFlags = CascadeMatchFlags_CommonPiece1},"Collect"},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",100000},
                [3] = {"score",150000},
            },
        },
    },

    ["BalloonParty"] = {
        levelName = "Balloon Party",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins10 = true,
            gemTypes5 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
            hasStones = true,
            hasBalloons = true,
			hasVines = true,
			hasJailedSquares = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "Remove Purple Steel",
                    patternName = "Line3_large",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                --Cover
                {
                    patternName = "BalloonParty_Vines",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_Vines,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                },
                {
                    patternName = "BalloonParty_Stone1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    patternName = "BalloonParty_Stone2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyExtraHits = true,
                    extraHits = 1,
                },


                {
                    patternName = "BalloonParty_Key",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Purple Steel"},

                    -- Add Jail
                    specials = CascadePieceSpecials_Jailed,
                    cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
                    applyCancelSpecials = true,
                },
                {
                    patternName = "Line3_large",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "Line1_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {
                    patternName = "Line2_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
            },
        },
        goals = {
            main = {"getGem",14,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",400000},
                [3] = {"score",750000},
            },
        },
    },

    ["AxeWarp"] = {
        levelName = "Axe Warp",
        resource = "GameScreen_Land29",
		introScript = "Land29_Tip1",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins5 = true,
            gemTypes5 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
            hasPortals = true,
            hasSteelGlass = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            portals = {
                [1] = {{4,0},{0,3},"PortalEntrance_1","PortalExit_1"},
                [2] = {{5,1},{3,5},"PortalEntrance_1","PortalExit_1"},
                [3] = {{6,2},{6,7},"PortalEntrance_1","PortalExit_1"},
            },
            useSteelGlass = true,
            steelGlass = {
                patternName = "AxeWarp_Glass",
                isPatternSet = false,
            },
            additionalNamedPatterns = {
                {
                    entryName = "Remove Green Steel",
                    patternName = "AxeWarp_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Purple Steel",
                    patternName = "AxeWarp_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Red Steel",
                    patternName = "AxeWarp_RedSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Blue Steel",
                    patternName = "AxeWarp_BlueSteel",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "AxeWarp_Stones",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyExtraHits = true,
                    extraHits = 1,
                },

                --Keys
                {
                    patternName = "AxeWarp_BlueKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Blue Steel"},
                },
                {
                    patternName = "AxeWarp_GreenKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Green Steel"},
                },
                {
                    patternName = "AxeWarp_PurpleKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Purple Steel"},
                },
                {
                    patternName = "AxeWarp_RedKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Red Steel"},
                },

                --Bedrock
                {
                    patternName = "AxeWarp_BlueSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "AxeWarp_GreenSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "AxeWarp_PurpleSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "AxeWarp_RedSteel",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Bedrock.singular","Bedrock.plural",{specials = CascadePieceSpecials_Steel,},},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",100000},
                [3] = {"score",1000000},
            },
        },
    },


    --end Roh levels

	["LostKeys"] = {
		levelName = "Axe Drop",
		introScript = "Land29_Tip3",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasMakers = true,
			hasGemEaters = true,
			hasColoredKeyGems = true,
			hasCoverage = true,
			hasSteel = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "LeftColumn2Large", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "HedgeTrimmer_Reels", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Blue Key Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
						[2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece1,
                                icon = "Icon_PickAxe",
                            },
                        },
						[3] = {
                            eventType = "population",
                            count = 3,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
						[4] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece1,
                                icon = "Icon_PickAxe",
                            },
                        },
						[5] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
								icon = "Icon_GemBlue",
                            },
                        },
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"BlueSteel"},
					},
				},
				[2] = {
					name = "Green Key Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
						[2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece2,
                                icon = "Icon_PickAxe",
                            },
                        },
						[3] = {
                            eventType = "population",
                            count = 3,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
						[4] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece2,
                                icon = "Icon_PickAxe",
                            },
                        },
						[5] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
								icon = "Icon_GemGreen",
                            },
                        },
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"GreenSteel"},
					},
				},
				[3] = {
					name = "Purple Key Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
						[2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece3,
                                icon = "Icon_PickAxe",
                            },
                        },
						[3] = {
                            eventType = "population",
                            count = 3,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
						[4] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece3,
                                icon = "Icon_PickAxe",
                            },
                        },
						[5] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
								icon = "Icon_GemPurple",
                            },
                        },
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"PurpleSteel"},
					},
				},
				[4] = {
					name = "Red Key Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
						[2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece4,
                                icon = "Icon_PickAxe",
                            },
                        },
						[3] = {
                            eventType = "population",
                            count = 3,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
						[4] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece4,
                                icon = "Icon_PickAxe",
                            },
                        },
						[5] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
								icon = "Icon_SpecialGemRed",
                            },
                        },
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"RedSteel"},
					},
				},
				[5] = {
					name = "4 Color Mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalNamedPatterns = {
				{
                    entryName = "BlueSteel",
                    patternName = "LostKeys_steel1",
                    isPatternSet = false,
					clearPieces = true,
                },
				{
                    entryName = "GreenSteel",
                    patternName = "LostKeys_steel2",
                    isPatternSet = false,
					clearPieces = true,
                },
				{
                    entryName = "PurpleSteel",
                    patternName = "LostKeys_steel3",
                    isPatternSet = false,
					clearPieces = true,
                },
				{
                    entryName = "RedSteel",
                    patternName = "LostKeys_steel4",
                    isPatternSet = false,
					clearPieces = true,
                },
			},
			additionalInitialPatterns = { 
				{
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Blue Key Mix","Green Key Mix","Red Key Mix","Purple Key Mix","4 Color Mix"},
				},
				{
					patternName = "Spider_Lava",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "RightColumnLarge",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "LostKeys_steel1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "LostKeys_steel2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "LostKeys_steel3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},{
					patternName = "LostKeys_steel4",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "RubeMachine_gem2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"BlueSteel"},
				},
				{
					patternName = "RubeMakersA",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"GreenSteel"},
				},
				{
					patternName = "BurningBush_Lava",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"RedSteel"},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",1300000},
				[3] = {"score",1600000},
			},
		},
	},

	-- Dave Levels BEGIN 
	["HitPay"] = {
		levelName = "Hit Pay!",					
		resource = "GameScreen_Land29",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasColoredKeyGems = true,
            hasJailedSquares = true,
			hasAmber = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedPatterns = {
				{
					entryName = "Remove Red Wall",
					patternName = "DigDigDig_Wall1",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Green Wall",
					patternName = "DigDigDig_Wall2",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Blue Wall",
					patternName = "DigDigDig_Wall3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Yellow Wall",
					patternName = "DigDigDig_Wall4",
					isPatternSet = false,
					clearPieces = true,
				},
			
			},
			additionalInitialPatterns = {
				{
					patternName = "DigDigDig_Wall1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "DigDigDig_Wall2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "DigDigDig_Wall3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "DigDigDig_Wall4",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemYellow",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},

				{
					patternName = "DigDigDig2_RedKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Wall"},

					-- Add Jail
					specials = CascadePieceSpecials_Jailed,
					cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,

				},
				{
					patternName = "DigDigDig2_GreenKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Wall"},

					-- Add Jail
					specials = CascadePieceSpecials_Jailed,
					cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "DigDigDig2_BlueKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Wall"},

					--Add Amber
					--[[
					cancelSpecials = CascadePieceSpecials_Amber + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					--]]

					-- Add Jail
					specials = CascadePieceSpecials_Jailed,
					cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
				},
				{
					patternName = "DigDigDig2_YellowKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Yellow Wall"},

					--Add Amber
					--[[
					cancelSpecials = CascadePieceSpecials_Amber + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					--]]

					-- Add Jail
					specials = CascadePieceSpecials_Jailed,
					cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bedrock.singular","Bedrock.plural",{specials = CascadePieceSpecials_Steel,},},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",400000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},

	["SideCut"] = {
		levelName = "Side Cut",
		resource = "GameScreen_Land29",
		--introScript = "Land13_Tip1",
		--onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasColoredKeyGems = true,
            hasMissingReels = true,
            hasMissingSquares = true,
            hasCoverage = true,
            hasCrates = true,
            hasAmber = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
            useMissingReels = true,
            useMissingSquares = true,
            missingReels = {
				patternName = "LeftReels", 
				isPatternSet = false,
            },
            missingSquares = {
                patternName = "SideCut_Missing", 
                isPatternSet = false,
            },
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				--[[
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
				--]]
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 7,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
				},
			},
			additionalNamedPatterns = {
				{
					entryName = "Remove Red Wall",
					patternName = "SideCut_SideRow1",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Blue Wall",
					patternName = "SideCut_SideRow2",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Green Wall",
					patternName = "SideCut_SideRow3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Purple Wall",
					patternName = "SideCut_SideRow4",
					isPatternSet = false,
					clearPieces = true,
				},
			},


			additionalInitialPatterns = { 
				 {
					patternName = "SideCut_Treasures",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
				},

				{
					patternName = "SideCut_Crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},

				{
					patternName = "SideCut_SideRow1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "SideCut_SideRow2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "SideCut_SideRow3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "SideCut_SideRow4",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				--[[
				{
					patternName = "SideCut_Steel",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				--]]
				--[[
				{
					patternName = "SideCut_Fence",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				--]]
				{
					patternName = "SideCut_RedKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Wall"},

					--Add Amber
					---[[
					cancelSpecials = CascadePieceSpecials_Amber + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					--]]

					-- Add Jail
					--[[
					specials = CascadePieceSpecials_Jailed,
					cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
					--]]

				},
				{
					patternName = "SideCut_GreenKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Wall"},

					--Add Amber
					---[[
					cancelSpecials = CascadePieceSpecials_Amber + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					--]]

					-- Add Jail
					--[[
					specials = CascadePieceSpecials_Jailed,
					cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
					--]]
				},
				{
					patternName = "SideCut_BlueKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Wall"},

					--Add Amber
					---[[
					cancelSpecials = CascadePieceSpecials_Amber + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					--]]

					-- Add Jail
					--[[
					specials = CascadePieceSpecials_Jailed,
					cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
					--]]
				},
				{
					patternName = "SideCut_PurpleKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Purple Wall"},

					--Add Amber
					---[[
					cancelSpecials = CascadePieceSpecials_Amber + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					--]]

					-- Add Jail
					--[[
					specials = CascadePieceSpecials_Jailed,
					cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
					--]]
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

    ["ReleaseTheBurst"] = {
        levelName = "Release The Burst",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes5 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
			hasJailedSquares = true,
			hasPortals = true,
			hasSteelGlass = true,
			hasCoverage = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "ReleaseTheBurst_Windows",
				isPatternSet = false,
			},
			portals = {
				[1] = {{3,2},{3,4},"PortalEntrance_1","PortalExit_1"},
			},
            additionalNamedPatterns = {
                {
                    entryName = "Remove Purple Steel",
                    patternName = "ReleaseTheBurst_Bedrock",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                --Cover
				{
					patternName = "ReleaseTheBurst_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 4,
				},
				{
					patternName = "ReleaseTheBurst_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
                {
                    patternName = "ReleaseTheBurst_Key",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Purple Steel"},

                    -- Add Jail
                    specials = CascadePieceSpecials_Jailed,
                    cancelSpecials = CascadePieceSpecials_Jailed + CascadePieceSpecial_CantCover,
                    applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
                },
                {
                    patternName = "ReleaseTheBurst_Bedrock",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "ReleaseTheBurst_Burst1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    applyCancelSpecials = true,
                },
                {
                    patternName = "ReleaseTheBurst_Burst2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_VerticalSplash,
                    applyCancelSpecials = true,
                },
                {
                    patternName = "ReleaseTheBurst_Burst3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_AreaSplash,
                    applyCancelSpecials = true,
                },
            },
        },
        goals = {
            main = {"patterns",0,},
            stars = {
                [1] = {"score",250000},
                [2] = {"score",350000},
                [3] = {"score",450000},
            },
        },
    },
	-- Dave Levels END 

	["PrizeInside"] = {
        levelName = "Prize Inside",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins8 = true,
            gemTypes5 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
            hasCoconuts = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
			additionalNamedMixes = {
				{
                    name = "Blue Mix",
                    delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
				},
				{
                    name = "Green Key Mix",
                    delay = 0,
					{
						name = "Green Key",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Green Steel"},
						weight = 1,
					},
				},
				{
                    name = "Purple Key Mix",
                    delay = 0,
					{
						name = "Purple Key",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Purple Steel"},
						weight = 1,
					},
				},
				{
                    name = "Red Key Mix",
                    delay = 0,
					{
						name = "Red Key",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Red Steel"},
						weight = 1,
					},
				},
            },
            additionalNamedPatterns = {
                {
                    entryName = "Remove Green Steel",
                    patternName = "Row2_3",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Purple Steel",
                    patternName = "Row2_5",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Red Steel",
                    patternName = "Row2_7",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "Remove Blue Steel",
                    patternName = "Row2_1",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "TopRow1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Green Key Mix"},
                },
				{
                    patternName = "TopRow3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Purple Key Mix"},
                },
				{
                    patternName = "TopRow5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Red Key Mix"},
                },
				{
                    patternName = "TopRow7",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Blue Mix"},
                },
                {
                    patternName = "RockCity_RedKey",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyMatchPatterns = true,
                    matchPatterns = {"Remove Blue Steel"},
                },

                --GemiSteel Steels
                {
                    patternName = "Row2_3",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "Row2_5",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "Row2_7",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
                {
                    patternName = "Row2_1",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"getGem",4,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
                [1] = {"score",150000},
                [2] = {"score",400000},
                [3] = {"score",650000},
            },
        },
    },

	["PickaxePopup"] = {
        levelName = "Pickaxe Pop-up",
		introScript = "Land29_Tip4",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            regularBoard = true,
            modeSpins7 = true,
            gemTypes5 = true,

            hasSteel = true,
            hasColoredKeyGems = true,
            hasBalloons = true,
			hasPortals = true,
			hasSteelGlass = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "Line1",
				isPatternSet = false,
			},
			portals = {
				[1] = {{0,4},{0,6},"PortalEntrance_1","PortalExit_1"},
				[2] = {{1,3},{1,6},"PortalEntrance_1","PortalExit_1"},
				[3] = {{4,3},{4,6},"PortalEntrance_1","PortalExit_1"},
				[4] = {{5,4},{5,6},"PortalEntrance_1","PortalExit_1"},
			},
            additionalNamedPatterns = {
                {
                    entryName = "Remove Purple Steel",
                    patternName = "PickaxePopup_purple",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
				{
                    entryName = "Remove Blue Steel",
                    patternName = "PickaxePopup_blue",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
				{
                    entryName = "Remove Green Steel",
                    patternName = "PickaxePopup_green",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
				{
                    entryName = "Remove Red Steel",
                    patternName = "PickaxePopup_red",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "PickaxePopup_purple",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
				{
                    patternName = "PickaxePopup_blue",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
				{
                    patternName = "PickaxePopup_red",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
				{
                    patternName = "PickaxePopup_green",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    skinVariant = "BedRock",
                    applySkinVariant = true,
                },
				{
                    patternName = "Line1",
                    isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
                {
                    patternName = "BottomRow_Spot1",
                    isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecial_FallUp,
					applyMatchPatterns = true,
                    matchPatterns = {"Remove Purple Steel"},
                },
				{
                    patternName = "BottomRow_Spot2",
                    isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecial_FallUp,
					applyMatchPatterns = true,
                    matchPatterns = {"Remove Green Steel"},
                },
				{
                    patternName = "BottomRow_Spot5",
                    isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecial_FallUp,
					applyMatchPatterns = true,
                    matchPatterns = {"Remove Blue Steel"},
                },
				{
                    patternName = "BottomRow_Spot6",
                    isPatternSet = false,
					applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecial_FallUp,
					applyMatchPatterns = true,
                    matchPatterns = {"Remove Red Steel"},
                },
            },
        },
        goals = {
            main = {"patterns",0,},
			stars = {
                [1] = {"score",100000},
                [2] = {"score",300000},
                [3] = {"score",550000},
            },
        },
    },

	["BarrelEscape"] = {
        levelName = "Barrel Escape",                 
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins5 = true,
            gemTypes4 = true,

            hasJailedSquares = true,
			hasColoredKeyGems = true,
            hasSteel = true,
			hasBarrelsOfFun = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Red Key Mix",
					delay = 0,
					{
						name = "Red Key",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Red Wall"},
					},
				},
				[2] = {
					name = "Green Key Mix",
					delay = 0,
					{
						name = "Green Key",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Green Wall"},
					},
				},
				[3] = {
					name = "Blue Key Mix",
					delay = 0,
					{
						name = "Blue Key",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Blue Wall"},
					},
				},
				[4] = {
					name = "Purple Key Mix",
					delay = 0,
					{
						name = "Purple Key",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Purple Wall"},
					},
				},
			},
            additionalNamedPatterns = {
                [1] = {
                    entryName = "Remove Red Wall",
                    patternName = "PrisonBreak_RedWall",
                    isPatternSet = false,
                    clearPieces = true,
                },
                [2] = {
                    entryName = "Remove Blue Wall",
                    patternName = "PrisonBreak_BlueWall",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                [3] = {
                    entryName = "Remove Green Wall",
                    patternName = "PrisonBreak_GreenWall",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
                [4] = {
                    entryName = "Remove Purple Wall",
                    patternName = "PrisonBreak_YellowWall",
                    isPatternSet = false,
                    applyIcon = true,
                    clearPieces = true,
                },
            },
            additionalInitialPatterns = {
                --GemiSteel Walls
                {
                    patternName = "PrisonBreak_RedWall",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_SpecialGemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "PrisonBreak_BlueWall",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "PrisonBreak_GreenWall",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "PrisonBreak_YellowWall",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },

                -- --KEYS
                {
                    patternName = "PrisonBreak_RedKey",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					spawnTypes = {"Red Key Mix"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
                {
                    patternName = "PrisonBreak_BlueKey",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_Jailed | CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed_ColorBarrel,
					applyCancelSpecials = true,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					spawnTypes = {"Blue Key Mix"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
                },
                {
                    patternName = "PrisonBreak_GreenKey",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					spawnTypes = {"Green Key Mix"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
                },
                {
                    patternName = "PrisonBreak_YellowKey",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_Jailed | CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed_ColorBarrel,
					applyCancelSpecials = true,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					spawnTypes = {"Purple Key Mix"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
                },

                -- --Jails
                {
                    patternName = "PrisonBreak_Jails",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    specials = CascadePieceSpecials_Jailed,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyCancelSpecials = true,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Jail","Jails",
				{
					{specials = CascadePieceSpecials_Jailed,},
					{specials = CascadePieceSpecials_Jailed | CascadePieceSpecials_ColorBarrels,},
				},
			"Break"},
            stars = {
                [1] = {"score",200000},
                [2] = {"score",750000},
                [3] = {"score",1500000},
            },
        },
        expectedScore = 100000, 
    },
	["Tripmining"] = {
		levelName = "Bye Bye Birdie",					
		resource = "GameScreen_Land29",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes3 = true,
			hasSteel = true,
			largeBoard = true,
			hasColoredKeyGems = true,
			hasIce = true,
			hasVines = true,
			hasVineGenerators = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Green Rock",
					patternName = "Tripmining_greenRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Remove Blue Rock",
					patternName = "Tripmining_blueRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "Remove Red Rock",
					patternName = "Hypobaric_redRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[4] = {
					entryName = "Remove Orange Rock",
					patternName = "Hypobaric_orangeRock",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Tripmining_blueRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_SpecialGemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "Tripmining_greenRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "Hypobaric_orangeRock",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemOrange",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[4] = {
					patternName = "Hypobaric_bluePick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Rock"},
				},
				[5] = {
					patternName = "Hypobaric_greenPick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Rock"},
				},
				[6] = {
					patternName = "Hypobaric_orangePick",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Orange Rock"},
				},
				[7] = {
					patternName = "Tripmining_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[8] = {
					patternName = "Hypobaric_giftBox",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 3,
				},
				[9] = {
					patternName = "Bin2_Bottom",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "IceMaker",
				},
				[10] = {
					-- Necessary to set up ice maker correctly
					patternName = "Bin2_Bottom",
					isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				[11] = {
					patternName = "Bin3_Bottom",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},

			},
		},
		goals = {
			main = {"getGem",1,"Stone","Stones",{specials = CascadePieceSpecials_Stone, extraHits = 0},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000, 
	},

})