-- Land 3: treasure chests

table.insertall(LevelDefs,
{

	["Dropping1"] = {
		levelName = "Treasure Chest",
		introScript = "Land3_Intro",
		resource = "GameScreen_Land3",		
		Features = {
			splashMode = true,
			treasureChest = true,
			modeSpins9 = true, --already matched Operation Easy
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["Dropping3"] = {
		levelName = "Drop 6",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true, --already matched Operation Easy
			treasureChest = true,
			gemTypes5 = true,
			regularBoard = true,
			hasMissingSquares = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "TopWindow", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000,
	},

	["CrossBoardCoverage1"] = {
		levelName = "X Marks Spot",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins10 = true, --already matched Operation Easy
			hasCoverage = true,
			gemTypes5 = true,
			regularBoard = true,
			hasMissingSquares = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "FourCorners_small", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "FourCorners_pattern_small",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",90000},
				[2] = {"score",100000},
				[3] = {"score",120000},
			},
		},
	},

	["CrateBlockDrop1"] = {
		levelName = "Crate Block!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true, --already matched Operation Easy
			treasureChest = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",100000},
				[3] = {"score",125000},
			},
		},
	},

	["CoverageCrate_RightSide"] = {
		levelName = "Break The Door",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true, --already matched Operation Easy
			hasCoverage = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "RightSide",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "RightSide",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},
	["CoverageCrate_Frame"] = {
		levelName = "Break The Wall",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true, --already matched Operation Easy
			hasCoverage = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Frame",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Frame",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},

	["CrateBlockDrop2"] = {
		levelName = "Get Those Chests!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true, --already matched Operation Easy
			treasureChest = true,
			hasStones = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "DoubleLine",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},

	["CoverageCrate_Blocks1"] = {
		levelName = "Break The Blocks",					
		resource = "GameScreen_Land1",		
		introScript = "Land3_Tip2",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins9 = true, --already matched Operation Easy
			hasCoverage = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Blocks1",
					isPatternSet = false,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Blocks1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",750000},
			},
		},
	},

	["Drop_Empty1"] = {
		levelName = "The Crevasse",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins10 = true, --already matched Operation Easy
			treasureChest = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "MiddleLine", 
				isPatternSet = false,
			},
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",150000},
			},
		},
	},

	["Drop_Empty_Large1"] = {
		levelName = "Big Jump",					
		resource = "GameScreen_Land3",	
		outtroScript = "Land3_Outtro",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			treasureChest = true,
			largeBoard = true,
			hasCrates = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "MiddleLine_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "DoubleUpperLine2_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",140000},
				[3] = {"score",200000},
			},
		},
	},

	["StairClear"] = {
		levelName = "Stair Clear",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins8 = true, --already matched Operation Easy
			hasCrates = true,
			hasStones = true,
			gemTypes5 = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "DiagonalStripes_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "OutsideTriangles_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},

	["DrillDown"] = {
		levelName = "Drill Down",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true, --already matched Operation Easy
			hasCrates = true,
			hasStones = true,
			treasureChest = true,
			regularBoard = true,
			gemTypes5 = true,
			hasCoverage = true, 
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			regularPlacements = {
				[1] = {
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					frequencies = {3,8,13,15},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleMiddle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "LittleBottom2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",150000},
				[3] = {"score",225000},
			},
		},
		expectedScore = 100000,
	},

	["Inaccessible"] = {
		levelName = "Inaccessible",
		resource = "GameScreen_Land1",		
		introScript = "Land3_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins12 = true, --already matched Operation Easy
			hasCrates = true,
			gemTypes4 = true,
			regularBoard = true,
			hasMissingSquares = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "IsolateCorners", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleMissingPattern2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Crate","Crates",{specials = CascadePieceSpecials_Crates},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},
	["Chest_Floor"] = {
		levelName = "Treasure Floor",
		resource = "GameScreen_Land1",		
		--introScript = "Land3_Tip3",
		Features = {
			splashMode = true,
			modeSpins9 = true, --already matched Operation Easy
			hasCrates = true,
			hasStones = true,
			hasChests = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "FourBins", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Bin1_Bottom",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[2] = {
					patternName = "Bin2_Bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Bin3_Bottom",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[4] = {
					patternName = "Bin4_Bottom",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[5] = {
					patternName = "FourTreasures",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["HardPattern"] = {
		levelName = "Hard Pattern",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true, --already matched Operation Easy
			hasCoverage = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BigTopCorners",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "TopFunnel1",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "TopCorners",
					isPatternSet = false,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	-- Side levels

	["StairClear_side"] = {
		levelName = "Stair Fall",
		resource = "GameScreen_Land3",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins6 = true,
			hasCrates = true,
			hasStones = true,
			gemTypes5 = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "DiagonalStripes_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "OutsideTriangles_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",30,"Crate","Crates",{specials = CascadePieceSpecials_Crates},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",575000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},

	["DrillDown_side"] = {
		levelName = "Dig Down",
		resource = "GameScreen_Land3",		
		Features = {
			splashMode = true,
			modeSpins10 = true,
			hasCrates = true,
			hasStones = true,
			treasureChest = true,
			regularBoard = true,
			gemTypes5 = true,
			hasCoverage = true, 
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			regularPlacements = {
				[1] = {
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					frequencies = {3,8,13,15},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Line3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "LittleBottom2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["Drop_Empty_Large1_side"] = {
		levelName = "Mind the Gap",					
		resource = "GameScreen_Land3",	
		Features = {
			splashMode = true,
			modeSpins7 = true,
			treasureChest = true,
			largeBoard = true,
			hasCrates = true,
			gemTypes4 = true,
			hasMissingSquares = true,
		},
		tricks = World3Tricks,
		boosts = World3Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "MiddleLine_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "DoubleUpperLine2_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",1500000},
			},
		},
	},

    ["Drop_Empty1_side"] = {
        --CONCEPT: Good and bad things fall, focus on the chests!
        levelName = "Crazy Avalanche",
        resource = "GameScreen_Land3",      
        Features = {
            splashMode = true,
            modeSpins10 = true,
            largeBoard = true,
            gemTypes5 = true,
            hasChests = true,
        },
        tricks = World3Tricks,
        boosts = World3Boosts,
        Properties = {
            addToBoardPieceMix = {
                {
                    name = "Treasure Chest",
                    matchFlags = 0,
                    weight = 3, 
                    specials = CascadePieceSpecials_Treasure,
                },
                {
                    name = "Boulder",
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    weight = 12,
                },
                {
                    name = "Wild Gems",
                    matchFlags = CascadeMatchFlags_Wildcard,
                    weight = 1,
                },
            },
        },
        goals = {
            main = {"getGem",10,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
            stars = {
                [1] = {"score",150000},
                [2] = {"score",300000},
                [3] = {"score",600000},
            },
        },
        expectedScore = 100000,
    },

})