-- Land 31: pattern gems (rings)

table.insertall(LevelDefs,
{
	["SquishyPattern"] = {
		levelName = "Squishy Pattern",					
		resource = "GameScreen_Land31",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasSteelGlass = true,
			hasPatternGems = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "SquishyPattern_Glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "SquishyPattern_Pattern",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
				[2] = {
					patternName = "SquishyPattern_Crates",
					isPatternSet = false,
					specials = CascadePieceSpecials_Crates,
					applyPieceSpecials = true,
					matchFlags = 0,
					applyMatchFlags = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",35000},
				[2] = {"score",50000},
				[3] = {"score",100000},
			},
		},
		expectedScore = 100000, 
	},
	
	["PandorasLocks2"] = {
		levelName = "Pandora's Locks 2",					
		resource = "GameScreen_Land31",
		outtroScript = "Land31_Outtro",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasPatternGems = true,
			hasSteel = true,
			hasMakers = true,
			hasBombs = true,
			hasLava = true,
			hasIce = true,
			hasVines = true,
			hasLocks = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "BarrelContents",
					delay = 0,
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						turnsToLoss = 10,
						weight = 1,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						turnsToLoss = 10,
						weight = 1,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						turnsToLoss = 10,
						weight = 1,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						turnsToLoss = 10,
						weight = 1,
					},
				},
				[2] = {
					name = "MakeNBombs",
					delay = 0,
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						turnsToLoss = 10,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						turnsToLoss = 10,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						turnsToLoss = 10,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						turnsToLoss = 10,
						icon = "Icon_Marked",
						weight = 1,
					},
					events = {
						{
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = false,
						},
						{
							eventType = "emitCount",
							count = 2,
							newDelay = 1,
							reset = false,
						},
						{
							eventType = "emitCount",
							count = 3,
							newDelay = 1,
							reset = false,
						},
						{
							eventType = "emitCount",
							count = 4,
							newDelay = 1,
							reset = false,
						},
						{
							eventType = "emitCount",
							count = 5,
							newDelay = 1,
							reset = false,
						},
						{
							eventType = "emitCount",
							count = 6,
							newDelay = -1,
							reset = false,
						},
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "MakeNBombs",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "PandorasLocks2_Marked",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
				[2] = {
					patternName = "PandorasLocks2_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "EgyptSteel",
				},
				[3] = {
					patternName = "PandorasLocks2_Locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[4] = {
					patternName = "PandorasLocks2_Ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				[5] = {
					patternName = "PandorasLocks2_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
					applyMatchFlags = true,
				},
				[6] = {
					patternName = "PandorasLocks2_Vines",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
				[7] = {
					patternName = "PandorasLocks2_Barrels",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"BarrelContents"},
				},
				[8] = {
					patternName = "PandorasLocks2_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"MakeNBombs"},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},

	["PresentPickup"] = {
		levelName = "Present Pickup",
		resource = "GameScreen_Land31",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
			hasGiftBoxes = true,
			hasCoconuts = true,
			hasVines = true,
			hasBombs = true,
			hasLava = true,
			hasCrates = true,
			hasJailedGems = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Crazy Mix",
					delay = 0,
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 6,
					},
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 6,
					},
					{
						name = "Lava",
						specials = CascadePieceSpecials_Lava,
						matchFlags = 0,
						weight = 8,
					},
					{ 
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 12,
					},
					{ 
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 6,
					},
					{ 
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						weight = 6,
						skinVariant = "Stone",
						extraHits = 1,
					},
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
					},
					{
						name = "Horizontal Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Wide Vertical Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Wide Vertical Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Wide Vertical Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Wide Vertical Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						anyOneMatchFlag = true,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Jail 1",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 3,
					},
					{
						name = "Jail 2",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 3,
					},
					{
						name = "Jail 3",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 3,
					},
					{
						name = "Jail 4",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 3,
					},
					{
						name = "Vines 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1.5,
					},
					{
						name = "Vines 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1.5,
					},
					{
						name = "Vines 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1.5,
					},
					{
						name = "Vines 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1.5,
					},
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 1.5,
					},
					{
						name = "Ice 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},
					{
						name = "Ice 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},
					{
						name = "Ice 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},
					{
						name = "Ice 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},
				},
			},
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 4, 
					specials = CascadePieceSpecials_Barrels,
					spawnTypes = {"Crazy Mix"},
					icon = "Icon_Marked",
				},
				{
					name = "GiftBox",
					matchFlags = 0,
					weight = 1, 
					specials = CascadePieceSpecials_Stone,
					spawnTypes = {"Crazy Mix"},
					icon = "Icon_Marked",
				},
				{
					name = "Coconuts",
					matchFlags = 0,
					weight = 4, 
					specials = CascadePieceSpecials_Coconut,
					spawnTypes = {"Crazy Mix"},
					icon = "Icon_Marked",
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "BottomRow_Spot1_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyPieceSpecials = true,
					specials = 0,
					applySpawnTypes = true,
					spawnTypes = {},
					applyIcon = true,
					icon = "",
				},
				{
					patternName = "BottomRow_Spot2_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = 0,
					applySpawnTypes = true,
					spawnTypes = {},
					applyIcon = true,
					icon = "",
				},
				{
					patternName = "BottomRow_Spot3_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = 0,
					applySpawnTypes = true,
					spawnTypes = {},
					applyIcon = true,
					icon = "",
				},
				{
					patternName = "BottomRow_Spot4_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = 0,
					applySpawnTypes = true,
					spawnTypes = {},
					applyIcon = true,
					icon = "",
				},
				{
					patternName = "BottomRow_Spot5_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyPieceSpecials = true,
					specials = 0,
					applySpawnTypes = true,
					spawnTypes = {},
					applyIcon = true,
					icon = "",
				},
				{
					patternName = "BottomRow_Spot6_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = 0,
					applySpawnTypes = true,
					spawnTypes = {},
					applyIcon = true,
					icon = "",
				},
				{
					patternName = "BottomRow_Spot7_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = 0,
					applySpawnTypes = true,
					spawnTypes = {},
					applyIcon = true,
					icon = "",
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Crazy Mix",
						delay = -1,
					},
				},
			},
		},
		goals = {
			main = {"getGem",34,"Ring","Rings",{icon = "Icon_Marked",},"Collect",},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["RingChase"] = {
		levelName = "Ring Chase",
		resource = "GameScreen_Land31",
		introScript = "Land31_Intro",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasPatternGems = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			addToBoardPieceMix = {
				{
					name = "Ring 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					icon = "Icon_Marked",
					weight = 1.5,
				},
				{
					name = "Ring 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					icon = "Icon_Marked",
					weight = 1.5,
				},
				{
					name = "Ring 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					icon = "Icon_Marked",
					weight = 1.5,
				},
				{
					name = "Ring 4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					icon = "Icon_Marked",
					weight = 1.5,
				},
				{
					name = "Ring 5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					icon = "Icon_Marked",
					weight = 1.5,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "RingChase_Marked",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
				[2] = {
					patternName = "RingChase_NotMarked",
					isPatternSet = false,
					applyIcon = true,
					icon = "",
				},
			},
			endGameProperties = {
				multiplyBoardPieceMix = {
					{
						name = "Ring 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 0,
					},
					{
						name = "Ring 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 0,
					},
					{
						name = "Ring 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 0,
					},
					{
						name = "Ring 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 0,
					},
					{
						name = "Ring 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 0,
					},
				},
			},
		},
		goals = {
			main = {"getGem",30,"Ring","Rings",{icon = "Icon_Marked",},"Collect",},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",150000},
				[3] = {"score",240000},
			},
		},
	},

	["RingSearch"] = {
		levelName = "Ring Search",
		resource = "GameScreen_Land31",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasCrates = true,
			hasJailedGems = true,
			hasStones = true,
			hasPatternGems = true,
			hasBedrock = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large",
				isPatternSet = false,
			},
			additionalNamedPatterns = {
				[1] = {
					patternName = "RingSearch_Wall1",
					entryName = "ClearWall1",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					patternName = "RingSearch_Wall2",
					entryName = "ClearWall2",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					patternName = "RingSearch_Wall3",
					entryName = "ClearWall3",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "RingSearch_Marked",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
				[2] = {
					patternName = "RingSearch_Crates",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
				},
				[3] = {
					patternName = "RingSearch_Stones",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
				},
				[4] = {
					patternName = "RingSearch_Jailed",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
				[5] = {
					patternName = "RingSearch_Key1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"ClearWall1"},
					applyIcon = true,
					icon = "Icon_PickAxe",
				},
				[6] = {
					patternName = "RingSearch_Key2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"ClearWall2"},
					applyIcon = true,
					icon = "Icon_PickAxe",
				},
				[7] = {
					patternName = "RingSearch_Key3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"ClearWall3"},
					applyIcon = true,
					icon = "Icon_PickAxe",
				},
				[8] = {
					patternName = "RingSearch_Wall1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				[9] = {
					patternName = "RingSearch_Wall2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				[10] = {
					patternName = "RingSearch_Wall3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				[11] = {
					patternName = "RingSearch_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[12] = {
					patternName = "RingSearch_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[13] = {
					patternName = "RingSearch_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[14] = {
					patternName = "RingSearch_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},"Collect",},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",800000},
				[3] = {"score",1100000},
			},
		},
	},

    --Begin Roh Levels
    ["RingGrid"] = {
        levelName = "Ring Grid",
		introScript = "Land31_Tip1",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins4 = true,
            gemTypes6 = true,

            hasPatternGems = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            additionalInitialPatterns = {
                [3] = {
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",200000},
                [3] = {"score",500000},
            },
        },
        expectedScore = 100000,
    },

    ["GarbagePile"] = {
        levelName = "Garbage Pile",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins6 = true,
            gemTypes4 = true,

            hasPatternGems = true,
            hasBarrels = true,
            hasBarrelsOfFun = true,
            hasStones = true,
            hasVines = true,
            hasLava = true,
            hasBalloons = true,
            hasCrates = true,
            hasTreasure = true,
            hasGifts = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            spawnGemOnBreak = 
            {
                {
                    name = "Blue Area",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Green Area",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Purple Area",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Red Area",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
            },
            addToBoardPieceMix = {
                {
                    name = "Blue Area",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.3,
                },
                {
                    name = "Green Area",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.3,
                },
                {
                    name = "Purple Area",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.3,
                },
                {
                    name = "Red Area",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.3,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "GarbagePile_Boulders",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Barrels,
                    matchFlags = 0,
                    applyExtraHits = true,
                    extraHits = 1,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Coconuts",
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Coconut,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Gifts",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                    applyExtraHits = true,
                    extraHits = 2,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Vines",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_Vines,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Lava",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Lava,
                    matchFlags = 0,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Balloons",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Crates",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Crates,
                    matchFlags = 0,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Crates",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Crates,
                    matchFlags = 0,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Treasure",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Treasure,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Stone",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 2,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_Barrels",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},},
            stars = {
                [1] = {"score",400000},
                [2] = {"score",1000000},
                [3] = {"score",3000000},
            },
        },
        expectedScore = 100000,
    },

    ["RingStamper"] = {
        levelName = "Ring Stamper",
        Features = {
            splashMode = true,
            modeSpins7 = true,
            largeBoard = true,
            gemTypes5 = true,

            hasPatternGems = true,
            hasMissingReels = true,
            hasMissingSquares = true,
            hasMakers = true,
            hasGemEaters = true,
            hasBarrelsOfFun = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            portals = {
                [1] = {{0,5},{6,0},"PortalEntrance_1","PortalExit_1"},
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "RingStamper_Missing", 
                isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
                patternName = "RingStamper_Reels", 
                isPatternSet = false,
            },
            additionalNamedPatterns = {
                [1] = {
                    entryName = "StampGems",
                    patternName = "RingStamper_Targets",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_Marked",
                    addPieces = true,
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"StampGems"},
                        weight = 1,
                    },
                },
                {
                    name = "Assorted",
                    delay = 0,
                    {
                        name = "Wilds",
                        matchFlags = CascadeMatchFlags_Wildcard,
                        weight = 0.5,
                    },
                    {
                        patternName = "Chests",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Treasure,
                        weight = 0.2,
                    },
                    {
                        name = "Double Boulders",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        extraHits = 1,
                        weight = 4,
                    },
                    {
                        name = "Boulders",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        weight = 0.5,
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "RingStamper_Maker",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Assorted"},
                },
                {
                    patternName = "RingStamper_Switch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"StampGems"},
                },
                {
                    patternName = "RingStamper_Steel",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "EgyptSteel",
                },
                {
                    patternName = "RingStamper_Eaters",
                    isPatternSet = false,
                    gemEater = true,
                    applyGemEater = true,
                },
            },
        },
        goals = {
            main = {"getGem",10,"Ring","Rings",{icon = "Icon_Marked", extraHits = 0,},"Collect"},
            stars = {
                [1] = {"score",500000},
                [2] = {"score",750000},
                [3] = {"score",1000000},
            },
        },
    },
    ["Bobbing"] = {
        levelName = "Bobbing",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins5 = true,
            gemTypes5 = true,

            hasPatternGems = true,
            hasBalloons = true,
            hasBarrelsOfFun = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            additionalNamedMixes = {
                {
                    name = "Balloons",
                    delay = 0,
                    {
                        name = "Balloon 1",
                        weight = 1,
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_ColorBarrels | CascadePieceSpecials_Balloon_Obstacle,
                        cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
                        spawnTypes = {"Balloons"},
                        icon = "Icon_Marked",
                    },
                    {
                        name = "Balloon 2",
                        weight = 1,
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        specials = CascadePieceSpecials_ColorBarrels | CascadePieceSpecials_Balloon_Obstacle,
                        cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
                        spawnTypes = {"Balloons"},
                        icon = "Icon_Marked",
                    },
                    {
                        name = "Balloon 3",
                        weight = 1,
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        specials = CascadePieceSpecials_ColorBarrels | CascadePieceSpecials_Balloon_Obstacle,
                        cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
                        spawnTypes = {"Balloons"},
                        icon = "Icon_Marked",
                    },
                    {
                        name = "Balloon 4",
                        weight = 1,
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = CascadePieceSpecials_ColorBarrels | CascadePieceSpecials_Balloon_Obstacle,
                        cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
                        spawnTypes = {"Balloons"},
                        icon = "Icon_Marked",
                    },
                    {
                        name = "Balloon 5",
                        weight = 1,
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        specials = CascadePieceSpecials_ColorBarrels | CascadePieceSpecials_Balloon_Obstacle,
                        cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
                        spawnTypes = {"Balloons"},
                        icon = "Icon_Marked",
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "Bobbing_Balloons",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_ColorBarrels | CascadePieceSpecials_Balloon_Obstacle,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
                    applySpawnTypes = true,
                    spawnTypes = {"Balloons"},
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "Bobbing_ColorBarrels",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_ColorBarrels,
                    applySpawnTypes = true,
                    spawnTypes = {"Balloons"},
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
            },
        },
        goals = {
            main = {"getGem",25,"Ring","Rings",{icon = "Icon_Marked"},"Collect"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",175000},
                [3] = {"score",300000},
            },
        },
    },
    ["RainDance"] = {
        levelName = "Rain Dance",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins5 = true,
            gemTypes5 = true,

            hasPatternGems = true,
            hasVineGenerators = true,
            hasMissingReels = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
            boardPieceMix = {
                --marked gems
                {
                    name = "BlueMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1.5,
                    icon = "Icon_Marked",
                },
                {
                    name = "GreenMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1.5,
                    icon = "Icon_Marked",
                },
                {
                    name = "PurpleMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1.5,
                    icon = "Icon_Marked",
                },
                {
                    name = "RedMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1.5,
                    icon = "Icon_Marked",
                },
                {
                    name = "YellowMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 1.5,
                    icon = "Icon_Marked",
                },

                --unmarked
                {
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 10,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 10,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 10,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 10,
                },
                {
                    name = "Yellow",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 10,
                },
                {
                    name = "Blue Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.2,
                },
                {
                    name = "Green Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.2,
                },
                {
                    name = "Purple Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.2,
                },
                {
                    name = "Red Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.2,
                },
                {
                    name = "Yellow Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.2,
                },
                {
                    name = "Blue Area",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.2,
                },
                {
                    name = "Green Area",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.2,
                },
                {
                    name = "Purple Area",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.2,
                },
                {
                    name = "Red Area",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.2,
                },
                {
                    name = "Yellow Area",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 0.2,
                },
            },
            additionalInitialPatterns = { 
                --Vine Generators
                {
                    patternName = "RainDance_VineGenerators",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_VineGenerator,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    skinVariant = "VineGrower",
                    applySkinVariant = true,
                },

                --Pattern to wipe initial rings?
                {
                    patternName = "RainDance_VineGenerators",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_VineGenerator,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    skinVariant = "VineGrower",
                    applySkinVariant = true,
                },
                {
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "",
                    filter = {
                        icon = "Icon_Marked",
                    },
                },
            },
        },
        goals = {
            main = {"getGem",30,"Ring","Rings",{icon = "Icon_Marked", cancelSpecials = 0,},"Collect"},
            stars = {
                [1] = {"score",300000},
                [2] = {"score",400000},
                [3] = {"score",600000},
            },
        },
    },
    ["RingMaker"] = {
        levelName = "Ring Maker",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins5 = true,
            gemTypes4 = true,

            hasPatternGems = true,
            hasMakers = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "BlockLeft",
                    patternName = "RingMaker_BlockerA",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    addPieces = true,
					applySkinVariant = true,
					skinVariant = "EgyptSteel",

                    --just in case
                    applyTurnsToLoss = true,
                    turnsToLoss = -1,
                    applyIcon = true,
                    icon = "",
                },
                {
                    entryName = "BlockRight",
                    patternName = "RingMaker_BlockerB",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    addPieces = true,
					applySkinVariant = true,
					skinVariant = "EgyptSteel",

                    applyTurnsToLoss = true,
                    turnsToLoss = -1,
                    applyIcon = true,
                    icon = "",
                },
                {
                    entryName = "UnblockLeft",
                    patternName = "RingMaker_BlockerA",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "UnblockRight",
                    patternName = "RingMaker_BlockerB",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        matchPatterns = {"UnblockLeft","BlockRight"},
                        weight = 1,
                    },
                },
                {
                    name = "Toggle2",
                    delay = 0,
                    {
                        name = "Switch_Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"UnblockRight","BlockLeft"},
                        weight = 1,
                    },
                },

                --Mix A
                {
                    name = "MixA",
                    delay = 0,
                    {
                        name = "BlueMarked",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 2,
                        icon = "Icon_Marked",
                    },
                    {
                        name = "GreenMarked",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 2,
                        icon = "Icon_Marked",
                    },
                    {
                        name = "PurpleMarked",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 2,
                        icon = "Icon_Marked",
                    },
                    {
                        name = "RedMarked",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 2,
                        icon = "Icon_Marked",
                    },

                    {
                        name = "Double Boulders Marked",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        extraHits = 1,
                        weight = 2,
                        icon = "Icon_Marked",
                    },
                    {
                        name = "BouldersMarked",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        weight = 2,
                        icon = "Icon_Marked",
                    },

                    {
                        name = "Bomb 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
                        turnsToLoss = 12,
                        weight = 0.2,
                    },
                    {
                        name = "Bomb 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
                        turnsToLoss = 12,
                        weight = 0.2,
                    },
                    {
                        name = "Bomb 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
                        turnsToLoss = 12,
                        weight = 0.2,
                    },
                    {
                        name = "Bomb 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
                        turnsToLoss = 12,
                        weight = 0.2,
                    },
                },

                --Mix B
                {
                    name = "MixB",
                    delay = 0,

                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "RingMaker_MakerA",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"MixA"},
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "RingMaker_MakerB",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"MixB"},
                },

                {
                    patternName = "RingMaker_Switch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"UnblockLeft","BlockRight"},
                },

                {
                    patternName = "RingMaker_Steel",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "EgyptSteel",
                },
            },
        },
        goals = {
            main = {"getGem",50,"Ring","Rings",{icon = "Icon_Marked"},"Collect"},
            stars = {
                [1] = {"score",90000},
                [2] = {"score",150000},
                [3] = {"score",225000},
            },
        },
    },
    ["RainbowStripe"] = {
        levelName = "Rainbow Stripe",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins10 = true,
            gemTypes6 = true,

            hasPatternGems = true,
            hasSteel = true,
            hasBarrels = true,
            hasBarrelsOfFun = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            gemsMoveDiagonally = false,
            useMissingReels = true,
            missingReels = {
                patternName = "CenterReel_Large",
                isPatternSet = false,
            },
            portals = {
                {{0,7},{1,0},"PortalEntrance_1","PortalExit_1"},
                {{1,7},{2,0},"PortalEntrance_1","PortalExit_1"},
                {{6,7},{5,0},"PortalEntrance_1","PortalExit_1"},
                {{5,7},{4,0},"PortalEntrance_1","PortalExit_1"},
            },
            additionalNamedMixes = {
                {
                    name = "Blue",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        icon = "Icon_Marked",
                        weight = 1,
                    },
                },
                {
                    name = "Green",
                    delay = 0,
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        icon = "Icon_Marked",
                        weight = 1,
                    },
                },
                {
                    name = "Purple",
                    delay = 0,
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        icon = "Icon_Marked",
                        weight = 1,
                    },
                },
                {
                    name = "Red",
                    delay = 0,
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        icon = "Icon_Marked",
                        weight = 1,
                    },
                },
                {
                    name = "Yellow",
                    delay = 0,
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        icon = "Icon_Marked",
                        weight = 1,
                    },
                },
                {
                    name = "Orange",
                    delay = 0,
                    {
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        icon = "Icon_Marked",
                        weight = 1,
                    },
                },
				{
					name = "Normal Mix",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                    {
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        weight = 1,
                    },
				}
            },
            additionalInitialPatterns = { 
                {
                    patternName = "RainbowStripe_Rings",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_Marked",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_ColorBarrels,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                },
                { 
                    patternName = "RainbowStripe_Boulders",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    patternName = "RainbowStripe_Maker",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal Mix",},
                },

                --color placing
                {
                    patternName = "RainbowStripe_Blue",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applySpawnTypes = true,
                    spawnTypes = {"Blue"},
                },
                {
                    patternName = "RainbowStripe_Green",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applySpawnTypes = true,
                    spawnTypes = {"Green"},
                },
                {
                    patternName = "RainbowStripe_Purple",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applySpawnTypes = true,
                    spawnTypes = {"Purple"},
                },
                {
                    patternName = "RainbowStripe_Red",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applySpawnTypes = true,
                    spawnTypes = {"Red"},
                },
                {
                    patternName = "RainbowStripe_Yellow",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    applySpawnTypes = true,
                    spawnTypes = {"Yellow"},
                },
                {
                    patternName = "RainbowStripe_Orange",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                    applySpawnTypes = true,
                    spawnTypes = {"Orange"},
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked"}},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",400000},
                [3] = {"score",1000000},
            },
        },
    },
    ["GiftWrapping"] = {
        levelName = "Gift Wrapping",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins6 = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasGifts = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            spawnGemOnBreak = 
            {
                {
                    name = "Blue Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Green Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Purple Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Red Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Yellow Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Blue Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Green Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Purple Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Red Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Yellow Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "WrapGifts1",
                    patternName = "GiftWrapping_Targets",
                    isPatternSet = false,
                    filter = {  
                        specials = CascadePieceSpecials_Stone,
                        extraHits = 1,
                        isGemSpawner = true,
                    },
                    applyExtraHits = true,
                    extraHits = 2,
                },
                {
                    entryName = "WrapGifts2",
                    patternName = "GiftWrapping_Targets",
                    isPatternSet = false,
                    filter = {      
                        specials = CascadePieceSpecials_Stone,
                        extraHits = 0,
                        isGemSpawner = true,
                    },
                    applyExtraHits = true,
                    extraHits = 1,
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"WrapGifts1","WrapGifts2"},
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "GiftWrapping_Switch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"WrapGifts1","WrapGifts2"},
                },
                {
                    patternName = "GiftWrapping_Gifts",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applyExtraHits = true,
                    extraHits = 2,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Gift","Gifts",{specials = CascadePieceSpecials_Stone, skinVariant = "Default"}},
            stars = {
                [1] = {"score",250000},
                [2] = {"score",500000},
                [3] = {"score",650000},
            },
        },
    },
    ["DropsOfGold"] = {
        levelName = "Drops of Gold",
        Features = {
            splashMode = true,
            regularBoard = true,
            modeSpins5 = true,
            gemTypes4 = true,

            hasSwitches = true,
        },
        tricks = {
            {name = Config.World31Tricks_Trick1},
            {name = Config.World31Tricks_Trick2},
            {name = Config.World31Tricks_Trick3},
            {name = Config.TricksDefault_Trick2_OneMoreSpin},
        },
        boosts = World31Boosts,
        Properties = {
            reelPieceMix = {
                --Doing this to remove wilds... they undermine the level strategy.
                {
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1,
                },
            },
            boardPieceMix = {
                {
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1,
                },
                {
                    name = "YellowMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 2.2,
                    icon = "Icon_Marked",
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "BlueMaker",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                    },
                },
                {
                    entryName = "GreenMaker",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                    },
                },
                {
                    entryName = "PurpleMaker",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                    },
                },
                {
                    entryName = "RedMaker",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                    },
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        weight = 1,
                        matchPatterns = {"BlueMaker"},
                    },
                },
                {
                    name = "Toggle2",
                    delay = 0,
                    {
                        name = "Switch_Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        weight = 1,
                        matchPatterns = {"GreenMaker"},
                    },
                },
                {
                    name = "Toggle3",
                    delay = 0,
                    {
                        name = "Switch_Toggle3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Toggle3"},
                        weight = 1,
                        matchPatterns = {"PurpleMaker"},
                    },
                },
                {
                    name = "Toggle4",
                    delay = 0,
                    {
                        name = "Switch_Toggle4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Toggle4"},
                        weight = 1,
                        matchPatterns = {"RedMaker"},
                    },
                },
            },
            additionalInitialPatterns = { 
                --Remove marked gems
                {
                    patternName = "GiftWrapping_Blue",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyIcon = true,
                    icon = "",
                },
                {
                    patternName = "GiftWrapping_Green",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyIcon = true,
                    icon = "",
                },
                {
                    patternName = "GiftWrapping_Purple",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyIcon = true,
                    icon = "",
                },
                {
                    patternName = "GiftWrapping_Red",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyIcon = true,
                    icon = "",
                },
                --Switches
                {
                    patternName = "OrangeFactory_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"BlueMaker"},
					--icon = "",
                },
                {
                    patternName = "OrangeFactory_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"GreenMaker"},
					--icon = "",
                },
                {
                    patternName = "OrangeFactory_Switch3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle3"},
                    applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"PurpleMaker"},
					--icon = "",
                },
                {
                    patternName = "OrangeFactory_Switch4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle4"},
                    applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"RedMaker"},
					--icon = "",
                },
				{
					patternName = "MissingCorners",
					applyIcon = true,
					icon = "",
				},
            },
        },
        goals = {
            main = {"getGem",50,"Ring","Rings",{icon = "Icon_Marked"},"Collect"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",250000},
                [3] = {"score",400000},
            },
        },
    },
    ["GarbagePile_side"] = {
        levelName = "Garbage Dump",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes5 = true,

            hasPatternGems = true,
            hasBarrels = true,
            hasBarrelsOfFun = true,
            hasStones = true,
            hasVines = true,
            hasLava = true,
            hasBalloons = true,
            hasCrates = true,
            hasTreasure = true,
            hasGifts = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            additionalRegularPlacements = {
                {
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    icon = "Icon_Marked",
                    frequencies = {3,4,5,6,6,6,6,6,6,6,6,6,6,6},
                },
                {
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    isGemSpawner = true,
                    icon = "Icon_Marked",
                    frequencies = {4,5,6,7,7,7,7,7,7,7,7,7},
                },
                {
                    matchFlags = 31,
					anyOneMatchFlag = true,
                    specials = CascadePieceSpecials_AreaSplash,
                    frequencies = {4,5,6,7,7,7,7,7,7,7,7,7},
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "RemoveSwitch",
                    patternName = "GarbagePile_side_maker",
                    clearPieces = true,
                },
            },
            spawnGemOnBreak = {
                {
                    name = "Blue Area",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 2,
                },
                {
                    name = "Green Area",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 2,
                },
                {
                    name = "Purple Area",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 2,
                },
                {
                    name = "Red Area",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 2,
                },
                {
                    name = "Yellow Area",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 2,
                },
                {
                    name = "Blue Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Green Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Purple Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Red Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Yellow Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
            },
            additionalInitialPatterns = {
                --broken maker
                {
                    patternName = "GarbagePile_side_maker",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"MixA"},
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                --one-hit switch
                {
                    patternName = "GarbagePile_side_switch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"RemoveSwitch"},
                },
                {
                    patternName = "GarbagePile_side_burst",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_side_Ice",
                    isPatternSet = false,
                    applySpreadSpecials = true,
                    spreadSpecials = CascadePieceSpecials_Ice,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_side_Amber",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    cancelSpecials = CascadePieceSpecials_Amber,
                    applyCancelSpecials = true,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Amber,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },

                {
                    patternName = "GarbagePile_side_Gifts",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                    applyExtraHits = true,
                    extraHits = 2,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_side_Lava",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Lava,
                    matchFlags = 0,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },  
                {
                    patternName = "GarbagePile_side_Balloons",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_side_Crates",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Crates,
                    matchFlags = 0,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_side_Treasure",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Treasure,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_side_Stone1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 0,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_side_Stone2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 1,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },
                {
                    patternName = "GarbagePile_side_Stone3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 2,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                    applyIcon = true,
                    icon = "Icon_Marked",
                },

                --Color placement
                {
                    patternName = "GarbagePile_side_Blue",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                },
                {
                    patternName = "GarbagePile_side_Green",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                },
                {
                    patternName = "GarbagePile_side_Purple",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                },
                {
                    patternName = "GarbagePile_side_Red",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                },
                {
                    patternName = "GarbagePile_side_Yellow",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",400000},
                [3] = {"score",1000000},
            },
        },
        expectedScore = 100000,
    },
    ["RainbowStripe_side"] = {
        levelName = "Over the Rainbows",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins8 = true,
            gemTypes6 = true,

            hasPatternGems = true,
            hasBarrelsOfFun = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
            additionalNamedMixes = {
                {
                    name = "Blue",
                    delay = 0,
                    {
                        name = "Blue Area",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        icon = "Icon_Marked",
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        icon = "Icon_Marked",
                        weight = 2,
                    },
                },
                {
                    name = "Green",
                    delay = 0,
                    {
                        name = "Green Area",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        icon = "Icon_Marked",
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        icon = "Icon_Marked",
                        weight = 2,
                    },
                },
                {
                    name = "Purple",
                    delay = 0,
                    {
                        name = "Purple Area",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        icon = "Icon_Marked",
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        icon = "Icon_Marked",
                        weight = 2,
                    },
                },
                {
                    name = "Red",
                    delay = 0,
                    {
                        name = "Red Area",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        icon = "Icon_Marked",
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        icon = "Icon_Marked",
                        weight = 2,
                    },
                },
                {
                    name = "Yellow",
                    delay = 0,
                    {
                        name = "Yellow Area",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        icon = "Icon_Marked",
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        icon = "Icon_Marked",
                        weight = 2,
                    },
                },
                {
                    name = "Orange",
                    delay = 0,
                    {
                        name = "Orange Area",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        icon = "Icon_Marked",
						specials = CascadePieceSpecial_AreaSplash,
                        weight = 1,
                    },
                    {
                        name = "Orange",
                        matchFlags = CascadeMatchFlags_CommonPiece6,
                        icon = "Icon_Marked",
                        weight = 2,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "RainbowStripe_side_Rings",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_Marked",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_ColorBarrels,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                },

                --color placing
                {
                    patternName = "RainbowStripe_side_Blue",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applySpawnTypes = true,
                    spawnTypes = {"Blue"},
                },
                {
                    patternName = "RainbowStripe_side_Green",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applySpawnTypes = true,
                    spawnTypes = {"Green"},
                },
                {
                    patternName = "RainbowStripe_side_Purple",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applySpawnTypes = true,
                    spawnTypes = {"Purple"},
                },
                {
                    patternName = "RainbowStripe_side_Red",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applySpawnTypes = true,
                    spawnTypes = {"Red"},
                },
                {
                    patternName = "RainbowStripe_side_Yellow",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    applySpawnTypes = true,
                    spawnTypes = {"Yellow"},
                },
                {
                    patternName = "RainbowStripe_side_Orange",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                    applySpawnTypes = true,
                    spawnTypes = {"Orange"},
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked"}},
            stars = {
                [1] = {"score",150000},
                [2] = {"score",800000},
                [3] = {"score",1200000},
            },
        },
    },
    --End Roh Levels

	["SuperColumns"] = {
		levelName = "Super Columns",
		resource = "GameScreen_Land31",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "Columns_Reels",
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "BombColumn Walls",
                isPatternSet = false,
            },
            reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 8,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
	},
    --Begin Side Levels
    ["RingChase_side"] = {
        levelName = "Garbage Disposal",
        Features = {
            splashMode = true,
            modeSpins5 = true,
            largeBoard = true,
            gemTypes5 = true,

            hasGemEaters = true,
            hasBarrels = true,
            hasBarrelsOfFun = true,
            hasPatternGems = true,
        },
        tricks = World31Tricks,
        boosts = World31Boosts,
        Properties = {
            spawnGemOnBreak = 
            {
                {
                    name = "Blue Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Green Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Purple Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Red Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Yellow Horizontal",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Blue Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Green Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Purple Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Red Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Yellow Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Blue Area",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Green Area",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Purple Area",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Red Area",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Yellow Area",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
            },
            boardPieceMix = {
                --marked
                {
                    name = "BlueMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1,
                    icon = "Icon_Marked",
                },
                {
                    name = "GreenMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1,
                    icon = "Icon_Marked",
                },
                {
                    name = "PurpleMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1,
                    icon = "Icon_Marked",
                },
                {
                    name = "RedMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1,
                    icon = "Icon_Marked",
                },
                {
                    name = "YellowMarked",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 1,
                    icon = "Icon_Marked",
                },
                {
                    name = "Double Boulders Marked",
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    extraHits = 1,
                    weight = 1,
                    icon = "Icon_Marked",
                },
                {
                    name = "BouldersMarked",
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    weight = 1,
                    icon = "Icon_Marked",
                },

                --unmarked
                {
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 10,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 10,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 10,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 10,
                },
                {
                    name = "Yellow",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 10,
                },
                {
                    name = "Double Boulders",
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    extraHits = 1,
                    weight = 3,
                },
                {
                    name = "Boulders",
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    weight = 3,
                },
                {
                    name = "Barrels",
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    isGemSpawner = true,
                    weight = 1,
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "RingChase_side_Eaters",
                    isPatternSet = false,
                    gemEater = true,
                    applyGemEater = true,
                },
            },
        },
        goals = {
            main = {"getGem",50,"Ring","Rings",{icon = "Icon_Marked"},"Collect"},
            stars = {
                [1] = {"score",150000},
                [2] = {"score",500000},
                [3] = {"score",900000},
            },
        },
    },
	["SayWhen"] = {
		levelName = "Say When",					
		resource = "GameScreen_Land31",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasPatternGems = true,
			hasSwitches = true,
			hasSteelGlass = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "SayWhen_glass",
				isPatternSet = false,
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Refill",
					patternName = "SayWhen_rings",
					isPatternSet = false,
					addPieces = true,
					applyIcon = true,
					icon = "Icon_Marked",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On0",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "EgyptSwitch_Toggle",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Refill",},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On0",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "EgyptSwitch_Toggle",
						spawnTypes = {"TurnOn3"},
						matchPatterns = {"Refill",},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On0",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "EgyptSwitch_Toggle",
						matchPatterns = {"Refill",},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "SayWhen_switches",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "EgyptSwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Refill",},
				},
				[2] = {
					patternName = "SayWhen_rings",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
			},
			endGameProperties = {
				additionalNamedPatterns = {
					[1] = {
						entryName = "Refill",
						patternName = "LittleEmptyPattern",
						isPatternSet = false,
						addPieces = true,
					},
				},
			},
		},
		goals = {
			main = {"getGem",28,"Ring","Rings",{icon = "Icon_Marked",spreadSpecials = 0,},"Collect",},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000, 
	},
	["QuickThaw"] = {
		--Use portals and makers to place the ice bombs.
		--Defuse N bombs goal.
		levelName = "Quick Thaw",
		resource = "GameScreen_Land31",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBombs = true,
			hasIce = true,
			hasMakers = true,
			hasPortals = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Make Ice Bombs",
					delay = 0,
					events = {
						{
							eventType = "emitCount",
							count = 1,
							newDelay = 3,
						},
					},
					{
						name = "Ice Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						spreadSpecials = CascadePieceSpecials_Ice,
						turnsToLoss = 4,
						weight = 1,
					},
					{
						name = "Ice Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						spreadSpecials = CascadePieceSpecials_Ice,
						turnsToLoss = 4,
						weight = 1,
					},
					{
						name = "Ice Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						spreadSpecials = CascadePieceSpecials_Ice,
						turnsToLoss = 4,
						weight = 1,
					},
					{
						name = "Ice Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						spreadSpecials = CascadePieceSpecials_Ice,
						turnsToLoss = 4,
						weight = 1,
					},
					{
						name = "Ice Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
						spreadSpecials = CascadePieceSpecials_Ice,
						turnsToLoss = 4,
						weight = 1,
					},
				}
			},
			portals = {
				[1] = {{2,7},{1,5},"PortalEntrance_1","PortalExit_1"},
				[2] = {{3,7},{3,1},"PortalEntrance_1","PortalExit_1"},
				[3] = {{4,7},{5,5},"PortalEntrance_1","PortalExit_1"},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					spreadSpecials = CascadePieceSpecials_Ice,
					turnsToLoss = 4,
					frequencies = {1,2,2,3,3,4,4,5,5,5},
				},
			},
            additionalInitialPatterns = {
                {
                    patternName = "QuickThaw_IceBombs",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 4,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
                },
                {
                    patternName = "QuickThaw_Makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Ice Bombs"},
                },
			},
		},
		goals = {
			main = {"getGem",10,"Bomb","Bombs",{spreadSpecials = 0, turnsToLoss = true,},"Defuse",},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",500000},
			},
		},
	},
	["PunchClockVillain"] = {
		--A switch with a bomb controls the creation of more and more bad things in the level

	--[[
	With each wave, surround switch with 2-hit stones, so that it's hard to shotgun

	The waves:
		1. Some bombs
		2. Scattering of Ice.
		3. Scattering of Lava.
		4. Scattering of Vines.
		5. Thick Scattering of crates and stones.
		6. Bombs with Ice
		7. Lava with Vines
		8. Barrels with all 3 spreaders
		9. Bombs with Vines
		10. Bomb chests
		11. Scattering of all 3 spreaders
		12. A bunch of chests. This is the last hit.'

		]]--

		levelName = "Punch Clock Villain",
		resource = "GameScreen_Land31",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins10 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBombs = true,
			hasIce = true,
			hasLava = true,
			hasVines = true,
			hasStones = true,
			hasSwitches = true,
			hasCrates = true,
			hasBarrelsOfFun = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			additionalNamedPatterns = {
                {
                    entryName = "Stones Around Switch",
                    patternName = "PunchClockVillain_Stones",
					addPieces = true,
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
                    skinVariant = "Stone",

					--And turn off anything it might've overwritten
					applySpawnTypes = true,
                    spawnTypes = {},
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applySpreadSpecials = true,
					spreadSpecials = 0,
                },
                {
                    entryName = "Triple Stones Around Switch",
                    patternName = "PunchClockVillain_Stones",
					addPieces = true,
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
                    skinVariant = "Stone",

					--And turn off anything it might've overwritten
					applySpawnTypes = true,
                    spawnTypes = {},
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applySpreadSpecials = true,
					spreadSpecials = 0,
                },
                {
                    entryName = "Place Bombs 1",
                    patternName = "PunchClockVillain_Bombs1",
					addPieces = true,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
                },
                {
                    entryName = "Clear for Bombs 1",
                    patternName = "PunchClockVillain_Bombs1",
					clearPieces = true,
                },
                {
                    entryName = "Place Ice 1",
                    patternName = "PunchClockVillain_Ice1",
					addPieces = true,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
                },
                {
                    entryName = "Clear for Ice 1",
                    patternName = "PunchClockVillain_Ice1",
					clearPieces = true,
                },
                {
                    entryName = "Place Lava 1",
                    patternName = "PunchClockVillain_Lava1",
					addPieces = true,
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Lava,

					--And turn off anything it might've overwritten
					applySpawnTypes = true,
                    spawnTypes = {},
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applySpreadSpecials = true,
					spreadSpecials = 0,
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
                    skinVariant = "Default",
					applyTurnsToLoss = true,
					turnsToLoss = -1,
                },
                {
                    entryName = "Place Vines 1",
                    patternName = "PunchClockVillain_Vines1",
					addPieces = true,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
                },
                {
                    entryName = "Clear for Vines 1",
                    patternName = "PunchClockVillain_Vines1",
					clearPieces = true,
                },
                {
                    entryName = "Place Stones 1",
                    patternName = "PunchClockVillain_Stones1",
					addPieces = true,
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
                    skinVariant = "Stone",

					--And turn off anything it might've overwritten
					applySpawnTypes = true,
                    spawnTypes = {},
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applySpreadSpecials = true,
					spreadSpecials = 0,
                },
                {
                    entryName = "Place Crates 1",
                    patternName = "PunchClockVillain_Crates1",
					addPieces = true,
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Crates,

					--And turn off anything it might've overwritten
					applySpawnTypes = true,
                    spawnTypes = {},
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applySpreadSpecials = true,
					spreadSpecials = 0,
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
                    skinVariant = "Default",
                },
                {
                    entryName = "Place Barrels 1",
                    patternName = "PunchClockVillain_Barrels1",
					addPieces = true,
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
					applySpawnTypes = true,
                    spawnTypes = {"Random Spreader"},

					--And turn off anything it might've overwritten
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applySpreadSpecials = true,
					spreadSpecials = 0,
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
                    skinVariant = "Default",
                },
                {
                    entryName = "Place Bomb Chests 1",
                    patternName = "PunchClockVillain_BombChests1",
					addPieces = true,
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
					applyTurnsToLoss = true,
					turnsToLoss = 20,

					--And turn off anything it might've overwritten
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applySpreadSpecials = true,
					spreadSpecials = 0,
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
                    skinVariant = "Default",
					applySpawnTypes = true,
                    spawnTypes = {},
                },
                {
                    entryName = "Place Chests 1",
                    patternName = "PunchClockVillain_Chests1",
					addPieces = true,
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,

					--And turn off anything it might've overwritten
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applySpreadSpecials = true,
					spreadSpecials = 0,
					applyExtraHits = true,
					extraHits = 0,
					applySkinVariant = true,
                    skinVariant = "Default",
					applySpawnTypes = true,
                    spawnTypes = {},
					applyTurnsToLoss = true,
					turnsToLoss = -1,
                },
			},
			additionalNamedMixes = {
                {
                    name = "Switch Hit 2",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Switch Hit 3"},
                        matchPatterns = {"Stones Around Switch","Clear for Ice 1","Place Ice 1"},
						turnsToLoss = 15,
                        weight = 1,
                    },
                },
                {
                    name = "Switch Hit 3",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Switch Hit 4"},
                        matchPatterns = {"Stones Around Switch","Place Lava 1"},
						turnsToLoss = 15,
                        weight = 1,
                    },
                },
                {
                    name = "Switch Hit 4",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Switch Hit 5"},
                        matchPatterns = {"Stones Around Switch","Clear for Vines 1","Place Vines 1"},
						turnsToLoss = 15,
                        weight = 1,
                    },
                },
                {
                    name = "Switch Hit 5",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Switch Hit 6"},
                        matchPatterns = {"Stones Around Switch","Place Crates 1", "Place Stones 1"},
						turnsToLoss = 20,
                        weight = 1,
                    },
                },
                {
                    name = "Switch Hit 6",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Switch Hit 7"},
                        matchPatterns = {"Triple Stones Around Switch","Clear for Bombs 1","Place Bombs 1","Clear for Ice 1","Place Ice 1"},
						turnsToLoss = 20,
                        weight = 1,
                    },
                },
                {
                    name = "Switch Hit 7",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Switch Hit 8"},
                        matchPatterns = {"Triple Stones Around Switch","Place Lava 1","Clear for Vines 1","Place Vines 1"},
						turnsToLoss = 25,
                        weight = 1,
                    },
                },
                {
                    name = "Switch Hit 8",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Endgame Switch Hit"},
                        matchPatterns = {"Triple Stones Around Switch","Place Barrels 1"},
						turnsToLoss = 25,
                        weight = 1,
                    },
                },
                {
                    name = "Endgame Switch Hit",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "EgyptSwitch_Toggle",
                        spawnTypes = {"Endgame Switch Hit"},
                        matchPatterns = {},
                        weight = 1,
                    },
                },
                {
                    name = "Random Spreader",
                    delay = 0,
                    {
                        name = "Vine1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecial_Vines,
                        weight = 1,
                    },
                    {
                        name = "Vine2",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecial_Vines,
                        weight = 1,
                    },
                    {
                        name = "Vine3",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecial_Vines,
                        weight = 1,
                    },
                    {
                        name = "Vine4",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecial_Vines,
                        weight = 1,
                    },
                    {
                        name = "Ice1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        spreadSpecials = CascadePieceSpecials_Ice,
                        weight = 1,
                    },
                    {
                        name = "Ice2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        spreadSpecials = CascadePieceSpecials_Ice,
                        weight = 1,
                    },
                    {
                        name = "Ice3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        spreadSpecials = CascadePieceSpecials_Ice,
                        weight = 1,
                    },
                    {
                        name = "Ice4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        spreadSpecials = CascadePieceSpecials_Ice,
                        weight = 1,
                    },
                    {
                        name = "Lava",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Lava,
                        weight = 4,
                    },
                },
			},
            additionalInitialPatterns = {
                {
                    patternName = "PunchClockVillain_Switch",
					applyMatchFlags = true,
                    matchFlags = 0,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
                    skinVariant = "EgyptSwitch_Toggle",
					applySpawnTypes = true,
                    spawnTypes = {"Switch Hit 2"},
					applyMatchPatterns = true,
                    matchPatterns = {"Stones Around Switch","Clear for Bombs 1","Place Bombs 1"},
					applyTurnsToLoss = true,
					turnsToLoss = 15,
                },
			},
		},
		goals = {
			main = {"getGem",9,"Switch","Switches",{skinVariant = "EgyptSwitch_Toggle",},"Flip",},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
	},
	--Begin Michael Levels
	["JewelryShop"] = {
		levelName = "Jewelry Shop",					
		resource = "GameScreen_Land31",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,

			hasPatternGems = true,
            hasMissingReels = true,
            hasIce = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large",
                isPatternSet = false,
            },
			addToBoardPieceMix = {
                {
                    name = "Mark1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    icon = "Icon_Marked",
					applySpreadSpecials = true,
					--spreadSpecials = CascadePieceSpecials_Ice,
                    weight = 3,
                },
                {
                    name = "Mark2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    icon = "Icon_Marked",
					applySpreadSpecials = true,
					--spreadSpecials = CascadePieceSpecials_Ice,
                    weight = 3,
                },
                {
                    name = "Mark3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    icon = "Icon_Marked",
					applySpreadSpecials = true,
					--spreadSpecials = CascadePieceSpecials_Ice,
                    weight = 3,
                },
                {
                    name = "Mark4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    icon = "Icon_Marked",
					applySpreadSpecials = true,
					--spreadSpecials = CascadePieceSpecials_Ice,
                    weight = 3,
                },
                {
                    name = "Mark5",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    icon = "Icon_Marked",
					applySpreadSpecials = true,
					--spreadSpecials = CascadePieceSpecials_Ice,
                    weight = 3,
                },
            },
			additionalInitialPatterns = {
				[1] = {
					patternName = "JewelryShop_pattern",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				[2] = {
					patternName = "JewelryShop_steel",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "IceMaker",
				},
				[3] = {
					-- Necessary to set up ice maker correctly
					patternName = "JewelryShop_steel",
					isPatternSet = false,
                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "",
				},
			},
		},
		goals = {
			main = {"getGem",40,"Ring","Rings",{icon = "Icon_Marked",spreadSpecials = 0,},"Collect",},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",575000},
			},
		},
		expectedScore = 100000, 
	},
	["PharaohsTreasure"] = {
		levelName = "Pharaoh's Treasure",					
		resource = "GameScreen_Land31",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasPatternGems = true,
			hasAmber = true,
			hasCrates = true,
			hasStones = true,
			hasSwitches = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 1,
				},
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Rebuild",
					patternName = "PharaohsTreasure_stone",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                    filter = {
                        extraHits = 0,
                    },
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On0",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "EgyptSwitch_Toggle",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Rebuild",},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "PharaohsTreasure_switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "EgyptSwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Rebuild",},
				},
				[2] = {
					patternName = "PharaohsTreasure_rings",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
					--applySpreadSpecials = true,
					--spreadSpecials = CascadePieceSpecials_Ice,
				},
				[3] = {
					patternName = "PharaohsTreasure_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[4] = {
					patternName = "PharaohsTreasure_amber",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
				[5] = {
					patternName = "PharaohsTreasure_crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000, 
	},
	["FreeRefills"] = {
		levelName = "Free Refills",					
		resource = "GameScreen_Land31",
		introScript = "Land31_Tip3",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasPatternGems = true,
			hasSwitches = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Refill1",
					patternName = "FreeRefills_cup1",
					isPatternSet = false,
					addPieces = true,
					applyIcon = true,
					icon = "Icon_Marked",
				},
				[2] = {
					entryName = "Refill2",
					patternName = "FreeRefills_cup2",
					isPatternSet = false,
					addPieces = true,
					applyIcon = true,
					icon = "Icon_Marked",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On0",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "EgyptSwitch_Toggle",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Refill1",},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On0",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "EgyptSwitch_Toggle",
						spawnTypes = {"TurnOn2"},
						matchPatterns = {"Refill2",},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "FreeRefills_switches1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "EgyptSwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Refill1",},
				},
				[2] = {
					patternName = "FreeRefills_switches2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "EgyptSwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Refill2",},
				},
				[3] = {
					patternName = "FreeRefills_cup1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
				[4] = {
					patternName = "FreeRefills_cup2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
			},
			endGameProperties = {
				additionalNamedPatterns = {
					[1] = {
						entryName = "Refill1",
						patternName = "LittleEmptyPattern",
						isPatternSet = false,
						addPieces = true,
					},
					[2] = {
						entryName = "Refill2",
						patternName = "LittleEmptyPattern",
						isPatternSet = false,
						addPieces = true,
					},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",400000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
	["WhatsInTheBox"] = {
		levelName = "What's in the Barrel?",					
		resource = "GameScreen_Land31",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasPatternGems = true,
			hasMakers = true,
			hasBarrelsOfFun = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Ring",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					isPatternSet = false,
					icon = "Icon_Marked",
					weight = 2,
				},
				{
					name = "Green Ring",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					isPatternSet = false,
					icon = "Icon_Marked",
					weight = 2,
				},
				{
					name = "Purple Ring",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					isPatternSet = false,
					icon = "Icon_Marked",
					weight = 2,
				},
				{
					name = "Red Ring",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					isPatternSet = false,
					icon = "Icon_Marked",
					weight = 2,
				},
				{
					name = "Yellow Ring",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					isPatternSet = false,
					icon = "Icon_Marked",
					weight = 2,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,1,1,2},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "WhatsInTheBox_Barrels",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyMatchFlags = true,
					matchFlags = true,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						isPatternSet = false,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						isPatternSet = false,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						isPatternSet = false,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						isPatternSet = false,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						isPatternSet = false,
						weight = 2,
					},
				},
			},
		},
		goals = {
			--main = {"haveGem",13,"Ring","Rings",{icon = "Icon_Marked",},},
			main = {"getGem",20,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000, 
	},
	["Pinpoint"] = {
		levelName = "Pinpoint",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBalloons = true,
			hasMakers = true,
		},
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Balloon",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon Ring 1",
						weight = 2,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						applyIcon = true,
						icon = "Icon_Marked",
					},
					{
						name = "Balloon Ring 2",
						weight = 2,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						applyIcon = true,
						icon = "Icon_Marked",
					},
					{
						name = "Balloon Ring 3",
						weight = 2,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						applyIcon = true,
						icon = "Icon_Marked",
					},
					{
						name = "Balloon Ring 4",
						weight = 2,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						applyIcon = true,
						icon = "Icon_Marked",
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CrateBottomBlock1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon"},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Ring","Rings",{icon = "Icon_Marked",specials = 0,},"Collect"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
	--End Michael Levels
	
    ["DoABarrelRoll2"] = {
		levelName = "Do a Barrel Roll 2!",
		resource = "GameScreen_Land31",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = {
			{name = Config.World31Tricks_Trick1},
			{name = Config.World31Tricks_Trick2},
			{name = Config.World31Tricks_Trick3},
		},
		boosts = World31Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
                    name = "Barrel1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
                    name = "Barrel2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
                    name = "Barrel3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
                    name = "Barrel4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
			},
            reelPieceMix = {
				{
                    name = "Barrel1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
                    name = "Barrel2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
                    name = "Barrel3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
                    name = "Barrel4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
					weight = 11,
				},
				{
					name = "BarrelWild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 5,
				},
			},
			endGameProperties = {
				spawnGemOnBreak = 
				{
					{
						name = "Barrel1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Barrel2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Barrel3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Barrel4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
				},
			},
		},
		goals = {
			main = {"haveGem",48,"Barrel","Barrels",{specials = CascadePieceSpecial_ColorBarrels, isGemSpawner = true,},},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["BrassRing"] = {
		levelName = "Brass Ring",
		introScript = "Land31_Tip2",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasBarrels = true,
			hasGemEaters = true,
			hasPatternGems = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Maker Mix",
					delay = 0,
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 1,
					},
					{ 
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 4,
					},
					{
						name = "Horizontal Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = .25,
					},
					{
						name = "Horizontal Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = .25,
					},
					{
						name = "Horizontal Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = .25,
					},
					{
						name = "Horizontal Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = .25,
					},
					{
						name = "Area Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = .25,
					},
					{
						name = "Area Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = .25,
					},
					{
						name = "Area Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = .25,
					},
					{
						name = "Area Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = .25,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Blue Ring",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Green Ring",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Purple Ring",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Red Ring",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_Marked",
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Maker Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "UseIt_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Maker Mix"},
				},
				{
					patternName = "UseIt_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["MountDoom"] = {
		levelName = "Mount Doom",
		introScript = "Land31_Tip4",
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins6 = true,
			gemTypes5 = true,
			hasPatternGems = true,
			hasLava = true,
		},
		tricks = World31Tricks,
		boosts = World31Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "MountDoom_rings",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
				{
					patternName = "MountDoom_lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					patternName = "MountDoom_stone",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",200000},
				[3] = {"score",450000},
			},
		},
		expectedScore = 100000,
	},
	
    ["RecoveringPattern"] = {
		levelName = "Recovering Pattern",
		resource = "GameScreen_Land31",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes6 = true,
			hasPatternGems = true,
			hasMakers = true,
			hasPortals = true,
		},
		tricks = {
			{name = Config.World31Tricks_Trick1},
			{name = Config.World31Tricks_Trick2},
			{name = Config.World31Tricks_Trick3},
		},
		boosts = World31Boosts,
		Properties = {
            additionalNamedMixes = {
				[1] = {
					name = "One Ring Per Turn",
					delay = 0,
					{
						name = "Ring 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Ring 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Ring 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Ring 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Ring 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Ring 6",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						icon = "Icon_Marked",
						weight = 1,
					},
					events = {
						{
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
						},
						{
							eventType = "getGem",
							newDelay = 1,
							gemType = {
								icon = "Icon_Marked",
							},
						},
						{
							eventType = "population",
							count = 0,
							comparator = "equals",
							gemType = {
								icon = "Icon_Marked",
							},
							newDelay = -1,
						},
					}, 
				},
				[2] = {
					name = "Normal Mix",
					delay = 0,
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Gem 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
					{
						name = "Gem 6",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "RecoveringPattern_Pattern",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				},
				[2] = {
					patternName = "RecoveringPattern_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"One Ring Per Turn","Normal Mix",},
				},
			},
            portals = {
                [1] = {{1,1},{1,3},"PortalEntrance_1","PortalExit_1"},
                [2] = {{1,3},{1,5},"PortalEntrance_1","PortalExit_1"},
                [3] = {{2,1},{2,3},"PortalEntrance_1","PortalExit_1"},
                [4] = {{2,3},{2,5},"PortalEntrance_1","PortalExit_1"},
                [5] = {{4,1},{4,3},"PortalEntrance_1","PortalExit_1"},
                [6] = {{4,3},{4,5},"PortalEntrance_1","PortalExit_1"},
                [7] = {{5,1},{5,3},"PortalEntrance_1","PortalExit_1"},
                [8] = {{5,3},{5,5},"PortalEntrance_1","PortalExit_1"},
            },
		},
		goals = {
			main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",150000},
				[3] = {"score",250000},
			},
		},
	},

})