-- Land 33: safes

table.insertall(LevelDefs,
{
	-- Begin Jonathan levels
	["LaserProof"] = {
		levelName = "Laser Proof",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasLasers = true,
			hasSafes = true,
			hasStones = true,
			hasMissingReels = true,
			hasSteel = true,
			hasCoverage = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "LaserH",
							{
								name = "Laser1",
								matchFlags = CascadeMatchFlags_CommonPiece1,
								specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"LaserH"},
								weight = 1,
							},
							{
								name = "Laser2",
								matchFlags = CascadeMatchFlags_CommonPiece2,
								specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"LaserH"},
								weight = 1,
							},
							{
								name = "Laser3",
								matchFlags = CascadeMatchFlags_CommonPiece3,
								specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"LaserH"},
								weight = 1,
							},
							{
								name = "Laser4",
								matchFlags = CascadeMatchFlags_CommonPiece4,
								specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"LaserH"},
								weight = 1,
							},
						},
						{
							name = "Normal Gem",
							{
								name = "Normal1",
								matchFlags = CascadeMatchFlags_CommonPiece1,
								weight = 1,
							},
							{
								name = "Normal2",
								matchFlags = CascadeMatchFlags_CommonPiece2,
								weight = 1,
							},
							{
								name = "Normal3",
								matchFlags = CascadeMatchFlags_CommonPiece3,
								weight = 1,
							},
							{
								name = "Normal4",
								matchFlags = CascadeMatchFlags_CommonPiece4,
								weight = 1,
							},
						},
					} 

					local colors = {1, 2, 3, 4}
					table.insertall(namedMixes, MakeRandomSafe({colors, colors, colors, colors,}, "Safe1", "Normal Gem"))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "LaserProof_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "LaserProof_Safes",
					isPatternSet = false,
					replacePieces = {"Safe1_Step0"},
				},
				{
					patternName = "LaserProof_Lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"LaserH"},
				},
				{
					patternName = "LaserProof_Stones",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserH",
						{
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH"},
							skinVariant = "LaserH",
							weight = 1,
						},
					},
				}
			}
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",1000000},
				[3] = {"score",2500000},
			},
		},
		expectedScore = 100000, 
	},
	["RemoteSafe"] = {
		levelName = "Remote Safe",
		introScript = "Land33_Tip13",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasMissingSquares = true,
			hasSafes = true,
			hasCoconuts = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "RemoteSafe_Missing",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "Superwild Mix",
							delay = 0,
							{
								name = "Superwild",
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecial_ClearKeyColorOnMatch,
								weight = 1,
							},
						},
					} 

					local colors = {1, 2, 3, 4, 5,}
					table.insertall(namedMixes, MakeRandomSafe({colors,colors, colors, colors,}, "Safe1", "Superwild Mix"))

					return namedMixes
				end
			),
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					spawnTypes = {"Superwild Mix"},
					weight = 1,
					frequencies = {0, 1, 2, 5},
					inactiveForInitialPlacement = true,
				}
			},
			additionalInitialPatterns = {
				{
					patternName = "RemoteSafe_Safe",
					isPatternSet = false,
					replacePieces = {"Safe1_Step0",},
				},
			},
		},
		goals = {
			main = {"getGem",2,"Safe","Safes",{specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable, },"Open"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",750000},
			},
		},
		expectedScore = 100000, 
	},
	["RemoteSafe2"] = {
		levelName = "Remote Safe 2",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasLasers = true,
			hasSafes = true,
			hasMissingReels = true,
			hasMissingSquares = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "2LeftReels",
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "LeftColumn2Large",
				isPatternSet = false,
			},
			
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 1,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3, --Extra wilds so it's easier to make superwilds
				},
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "Treasure Chest",
							{
								name = "Treasure Chest",
								matchFlags = 0,
								specials = CascadePieceSpecials_Treasure,
								weight = 1,
							},
						},
					} 
					
					-- Creates the list {1, 2, 3, 4, 5, 1, 2, 3, 4, 5, etc. } up to i elements
					local function Combi(amt,start)
						c = {start}
						for j = 1,amt-1 do
							c[#c+1] = (j - 1) % 5 + 1
						end
						return c
					end

					table.insertall(namedMixes, MakeFixedSafe(Combi(2,5), "Safe1", "Treasure Chest"))
					table.insertall(namedMixes, MakeFixedSafe(Combi(3,5), "Safe2", "Treasure Chest"))
					table.insertall(namedMixes, MakeFixedSafe(Combi(4,5), "Safe3", "Treasure Chest"))
					table.insertall(namedMixes, MakeFixedSafe(Combi(5,5), "Safe4", "Treasure Chest"))
					table.insertall(namedMixes, MakeFixedSafe(Combi(6,5), "Safe5", "Treasure Chest"))
					table.insertall(namedMixes, MakeFixedSafe(Combi(7,5), "Safe6", "Treasure Chest"))
					table.insertall(namedMixes, MakeFixedSafe(Combi(8,5), "Safe7", "Treasure Chest"))
					table.insertall(namedMixes, MakeFixedSafe(Combi(9,5), "Safe8", "Treasure Chest"))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "Large 0,0",
					isPatternSet = false,
                    replacePieces = {"Safe1_Step0"},
				},
				{
					patternName = "Large 1,0",
					isPatternSet = false,
					replacePieces = {"Safe2_Step0"},
				},
				{
					patternName = "Large 2,0",
					isPatternSet = false,
					replacePieces = {"Safe3_Step0"},
				},
				{
					patternName = "Large 3,0",
					isPatternSet = false,
					replacePieces = {"Safe4_Step0"},
				},
				{
					patternName = "Large 4,0",
					isPatternSet = false,
					replacePieces = {"Safe5_Step0"},
				},
				{
					patternName = "Large 5,0",
					isPatternSet = false,
					replacePieces = {"Safe6_Step0"},
				},
				{
					patternName = "Large 6,0",
					isPatternSet = false,
					replacePieces = {"Safe7_Step0"},
				},
				{
					patternName = "Large 7,0",
					isPatternSet = false,
					replacePieces = {"Safe8_Step0"},
				},
			},
		},
		goals = {
			main = {"getGem",8,"Safe","Safes",{specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable, },"Open"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",2000000},
				[3] = {"score",3000000},
			},
		},
		expectedScore = 100000, 
	},
	["SafePlacer"] = {
		levelName = "Safe Placer",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins9 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasSafes = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "Superwild Mix",
							{
								name = "Superwild",
								weight = 1,
								matchFlags = CascadeMatchFlags_Wildcard,
							},
						}
					} 

					local colors = {1, 2, 3, 4,}
					table.insertall(namedMixes, MakeRandomSafe({colors, colors, colors, colors,  colors}, "Safe1", "Superwild Mix"))

					return namedMixes
				end
			),
			addToReelPieceMix = {
				{
					name = "Safe1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"Safe1_Step1_1"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 5,
				},
				{
					name = "Safe2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"Safe1_Step1_2"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 5,
				},
				{
					name = "Safe3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"Safe1_Step1_3"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 5,
				},
				{
					name = "Safe4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"Safe1_Step1_4"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 5,
				},
			},
		},
		goals = {
			main = {"getGem",24,"Safe","Safes",{specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable, },"Open"},
			stars = {
				[1] = {"score",800000},
				[2] = {"score",1200000},
				[3] = {"score",1600000},
			},
		},
		expectedScore = 100000, 
	},

	-- Begin Daniel levels
	["SideShooter"] = {
		levelName = "Shoot the Bomb",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSafes = true,
			hasLasers = true,
			hasFences = true,
			hasSwitches = true,
			hasMissingReels = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "SideShooter_Reel",
				isPatternSet = false,
			},
			additionalNamedPatterns = {
				{
					entryName = "laser0_on",
					patternName = "Large 0,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
					addPieces = true,
				},
				{
					entryName = "laser0_off",
					patternName = "Large 0,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "laser1_on",
					patternName = "Large 1,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
					addPieces = true,
				},
				{
					entryName = "laser1_off",
					patternName = "Large 1,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "laser2_on",
					patternName = "Large 2,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
					addPieces = true,
				},
				{
					entryName = "laser2_off",
					patternName = "Large 2,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "laser3_on",
					patternName = "Large 3,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
					addPieces = true,
				},
				{
					entryName = "laser3_off",
					patternName = "Large 3,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "laser4_on",
					patternName = "Large 4,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
					addPieces = true,
				},
				{
					entryName = "laser4_off",
					patternName = "Large 4,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "laser5_on",
					patternName = "Large 5,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
					addPieces = true,
				},
				{
					entryName = "laser5_off",
					patternName = "Large 5,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "laser6_on",
					patternName = "Large 6,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
					addPieces = true,
				},
				{
					entryName = "laser6_off",
					patternName = "Large 6,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "laser7_on",
					patternName = "Large 7,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
					addPieces = true,
				},
				{
					entryName = "laser7_off",
					patternName = "Large 7,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "switchUp0_on",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"upButton7"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser0_off", "laser7_on", "switchDown7_on"},
				},
				{
					entryName = "switchUp1_on",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"upButton0"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser1_off", "laser0_on", "switchDown0_on"},
				},
				{
					entryName = "switchUp2_on",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"upButton1"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser2_off", "laser1_on", "switchDown1_on"},
				},
				{
					entryName = "switchUp3_on",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"upButton2"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser3_off", "laser2_on", "switchDown2_on"},
				},
				{
					entryName = "switchUp4_on",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"upButton3"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser4_off", "laser3_on", "switchDown3_on"},
				},
				{
					entryName = "switchUp5_on",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"upButton4"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser5_off", "laser4_on", "switchDown4_on"},
				},
				{
					entryName = "switchUp6_on",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"upButton5"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser6_off", "laser5_on", "switchDown5_on"},
				},
				{
					entryName = "switchUp7_on",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"upButton6"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser7_off", "laser6_on", "switchDown6_on"},
				},
				{
					entryName = "switchDown0_on",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"downButton1"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser7_off", "laser0_off", "laser1_on", "switchUp1_on"},
				},
				{
					entryName = "switchDown1_on",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"downButton2"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser0_off", "laser1_off", "laser2_on", "switchUp2_on"},
				},
				{
					entryName = "switchDown2_on",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"downButton3"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser1_off", "laser2_off", "laser3_on", "switchUp3_on"},
				},
				{
					entryName = "switchDown3_on",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"downButton4"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser2_off", "laser3_off", "laser4_on", "switchUp4_on"},
				},
				{
					entryName = "switchDown4_on",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"downButton5"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser3_off", "laser4_off", "laser5_on", "switchUp5_on"},
				},
				{
					entryName = "switchDown5_on",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"downButton6"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser4_off", "laser5_off", "laser6_on", "switchUp6_on"},
				},
				{
					entryName = "switchDown6_on",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"downButton7"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser5_off", "laser6_off", "laser7_on", "switchUp7_on"},
				},
				{
					entryName = "switchDown7_on",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"downButton0"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser6_off", "laser7_off", "laser0_on", "switchUp0_on"},
				},
				{
					entryName = "target0",
                    patternName = "Large 0,6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials =  CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
					matchPatterns = {"topSwitchToSteel", "bottomSwitchToSteel"},
                    addPieces = true,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
				{
					entryName = "target1",
                    patternName = "Large 1,6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials =  CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"target0"},
                    addPieces = true,
					applyTurnsToLoss = true,
					turnsToLoss = 16,
				},
				{
					entryName = "target2",
                    patternName = "Large 2,6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials =  CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"target6"},
                    addPieces = true,
					applyTurnsToLoss = true,
					turnsToLoss = 16,
				},
				{
					entryName = "target3",
                    patternName = "Large 3,6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials =  CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"target1"},
                    addPieces = true,
					applyTurnsToLoss = true,
					turnsToLoss = 16,
				},
				{
					entryName = "target5",
                    patternName = "Large 5,6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials =  CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"target7"},
                    addPieces = true,
					applyTurnsToLoss = true,
					turnsToLoss = 16,
				},
				{
					entryName = "target6",
                    patternName = "Large 6,6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials =  CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"target1"},
                    addPieces = true,
					applyTurnsToLoss = true,
					turnsToLoss = 16,
				},
				{
					entryName = "target7",
                    patternName = "Large 7,6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials =  CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"target2"},
                    addPieces = true,
					applyTurnsToLoss = true,
					turnsToLoss = 16,
				},
				{
					entryName = "topSwitchToSteel",
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "bottomSwitchToSteel",
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			additionalNamedMixes = {
				{
					name = "upButton0",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"upButton7"},
						matchPatterns = {"laser0_off", "laser7_on", "switchDown7_on"},
						weight = 1,
					},
				},
				{
					name = "upButton1",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"upButton0"},
						matchPatterns = {"laser1_off", "laser0_on", "switchDown0_on"},
						weight = 1,
					},
				},
				{
					name = "upButton2",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"upButton1"},
						matchPatterns = {"laser2_off", "laser1_on", "switchDown1_on"},
						weight = 1,
					},
				},
				{
					name = "upButton3",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"upButton2"},
						matchPatterns = {"laser3_off", "laser2_on", "switchDown2_on"},
						weight = 1,
					},
				},
				{
					name = "upButton4",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"upButton3"},
						matchPatterns = {"laser4_off", "laser3_on", "switchDown3_on"},
						weight = 1,
					},
				},
				{
					name = "upButton5",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"upButton4"},
						matchPatterns = {"laser5_off", "laser4_on", "switchDown4_on"},
						weight = 1,
					},
				},
				{
					name = "upButton6",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"upButton5"},
						matchPatterns = {"laser6_off", "laser5_on", "switchDown5_on"},
						weight = 1,
					},
				},
				{
					name = "upButton7",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"upButton6"},
						matchPatterns = {"laser7_off", "laser6_on", "switchDown6_on"},
						weight = 1,
					},
				},
				{
					name = "downButton0",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"downButton1"},
						matchPatterns = {"laser7_off", "laser0_off", "laser1_on", "switchUp1_on"},
						weight = 1,
					},
				},
				{
					name = "downButton1",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"downButton2"},
						matchPatterns = {"laser0_off", "laser1_off", "laser2_on", "switchUp2_on"},
						weight = 1,
					},
				},
				{
					name = "downButton2",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"downButton3"},
						matchPatterns = {"laser1_off", "laser2_off", "laser3_on", "switchUp3_on"},
						weight = 1,
					},
				},
				{
					name = "downButton3",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"downButton4"},
						matchPatterns = {"laser2_off", "laser3_off", "laser4_on", "switchUp4_on"},
						weight = 1,
					},
				},
				{
					name = "downButton4",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"downButton5"},
						matchPatterns = {"laser3_off", "laser4_off", "laser5_on", "switchUp5_on"},
						weight = 1,
					},
				},
				{
					name = "downButton5",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"downButton6"},
						matchPatterns = {"laser4_off", "laser5_off", "laser6_on", "switchUp6_on"},
						weight = 1,
					},
				},
				{
					name = "downButton6",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"downButton7"},
						matchPatterns = {"laser5_off", "laser6_off", "laser7_on", "switchUp7_on"},
						weight = 1,
					},
				},
				{
					name = "downButton7",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"downButton0"},
						matchPatterns = {"laser6_off", "laser7_off", "laser0_on", "switchUp0_on"},
						weight = 1,
					},
				},
				{
					name = "LaserH",
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "SideShooter_Fence",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Large 3,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecials_Laser,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySpawnTypes = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"upButton2"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser3_off", "laser2_on", "switchDown2_on"},
				},
				{
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"downButton4"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"laser2_off", "laser3_off", "laser4_on", "switchUp4_on"},
				},
				{
                    patternName = "Large 4,6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"target5"},
                    addPieces = true,
					applyTurnsToLoss = true,
					turnsToLoss = 16,
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
						},
					},
				},
			},
		},
		goals = {
			main = {"getGem",7,"Bomb","Bombs",{specials =  CascadePieceSpecial_Valuable | CascadePieceSpecials_Stone,},"Shoot"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},
	
	["CombiLock"] = {
		levelName = "Combination Lock",
		introScript = "Land33_Tip6",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes5 = true,

			hasPortals = true,
			hasFences = true,
			hasLasers = true,
			hasSteel = true,
			hasOrangeGems = true,
			hasSteelGlass = true,
			hasSwitches = true,
			hasJailedSquares = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = ExecuteInline(
			function ()
				local props = {}
				-- Steel pattern template
				local function SteelPattern(r, c)
					return {
						entryName = "replaceSteel" .. r .. "_" .. c,
						patternName = "Large " .. r .. "," .. c,
						isPatternSet = false,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Steel,
						applyMatchFlags = true,
						matchFlags = 0,
					}
				end
					
				-- Fence pattern template
				local function FencePattern(r, c)
					return {
						entryName = "replaceFence" .. r .. "_" .. c,
						patternName = "Large " .. r .. "," .. c,
						isPatternSet = false,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Fence,
						applyMatchFlags = true,
						matchFlags = 0,
					}
				end
				
				-- Switch pattern template
				local function SwitchPattern(r, c)
					local pattern = "Large 3,0"
					local nextC = (c + 6) % 7
					if r == 2 then
						pattern = "Large 3,6"
						nextC = (c + 1) % 7
					end

					return {
						entryName = "switch" .. r .. "_" .. c,
						patternName = pattern,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"switch" .. r .. "_" .. nextC},
						applyMatchFlags = true,
						matchFlags = 0,
						applySpawnTypes = true,
						applySkinVariant = true,
						skinVariant = "Switch1_Toggle",
						applyMatchPatterns = true,
						matchPatterns = {"replaceSteel" .. r .. "_" .. c, "replaceFence" .. r .. "_" .. nextC},
					}
				end
				
				-- Switch piece mix template
				local function SwitchPieceMix(r, c)
					local nextC = (c + 6) % 7
					if r == 2 then
						nextC = (c + 1) %  7
					end

					return {
						name = "switch" .. r .. "_" .. c,
						{
							name = "switch",
							matchFlags = 0,
							specials = CascadePieceSpecials_Stone,
							skinVariant = "Switch1_Toggle",
							spawnTypes = {"switch" .. r .. "_" .. nextC},
							matchPatterns = {"replaceSteel" .. r .. "_" .. c, "replaceFence" .. r .. "_" .. nextC},
							weight = 1,
						}
					}
				end
				
				local namedPatterns = {}
				local namedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
							spawnTypes = {"LaserV",},
							weight = 1,
						},
					},
				}
				
				-- Add all the steel/fence/switch named patterns/mixes to the namedPatterns and namedMixes list
				for i = 1,2 do
					for j = 0,6 do
						namedPatterns[#namedPatterns+1] = SteelPattern(i,j)
						namedPatterns[#namedPatterns+1] = FencePattern(i,j)
						namedPatterns[#namedPatterns+1] = SwitchPattern(i,j)

						namedMixes[#namedMixes+1] = SwitchPieceMix(i,j)
					end
				end

				-- Setting the additionalNamedPatterns to namedPatterns
				props.additionalNamedPatterns = namedPatterns

				-- Setting the additionalNamedMixes to namedMixes
				props.additionalNamedMixes = namedMixes
				
				props.additionalInitialPatterns = {
					{
						patternName = "CombiLockSteel",
						isPatternSet = false,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Steel,
						applyMatchFlags = true,
						matchFlags = 0,
					},
					FencePattern(1, 3), SwitchPattern(1, 3), -- Initial fence position of 1st row
					FencePattern(2, 3), SwitchPattern(2, 3), -- Initial fence position of 2nd row
					{
						patternName = "CombiLockFence_Stationary",
						isPatternSet = false,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Fence,
						applyMatchFlags = true,
						matchFlags = 0,
					},
					{
						patternName = "CombiLockLaser",
						isPatternSet = false,
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_VerticalSplash | CascadePieceSpecials_Laser,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_Wildcard,
						applySpawnTypes = true,
						spawnTypes = {"LaserV"},
					},
					{
						patternName = "CombiLockSafe",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece6,
					},
					{
						patternName = "CombiLockSafe",
						isPatternSet = false,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Jailed,
						applyCancelSpecials = true,
						cancelSpecials = CascadePieceSpecials_Jailed,
						applyExtraHits = true,
						extraHits = 1,
					},
				}

				props.portals = {
					{{1,0},{1,3},"PortalEntrance_1","PortalExit_1"},
					{{5,0},{5,3},"PortalEntrance_1","PortalExit_1"},
				}
				
				props.useSteelGlass = true

				props.steelGlass = {
					patternName = "CombiLockWindows",
					isPatternSet = false,
				}

				props.endGameProperties = {
					additionalNamedMixes = {
						{
							name = "LaserV",
							delay = 0,
							{
								name = "Laser",
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecials_Laser,
								spawnTypes = {"LaserV",},
								weight = 1,
							},
						},
					},
				}

				return props
			end
		),
		goals = {
			main = {"getGem",2,"Orange","Oranges",{specials = 0, matchFlags = CascadeMatchFlags_CommonPiece6},"Collect"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",1200000},
			},
		},
	},
	
	["GreenOrBlue"] = {
		levelName = "Green or Blue?",	
		introScript = "Land33_Tip5",				
		resource = "GameScreen_Land33",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,

			hasSafes = true,
			hasVineGenerators = true,
			hasIce = true,
			hasLasers = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedPatterns = {
				{
					entryName = "IceMakerA",
					patternName = "Large 1,1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					entryName = "IceMakerB",
					patternName = "Large 5,4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "IceMakerA",
							events = {
								{
									eventType = "emitCount",
									count = 1,
									patterns = {"IceMakerA"},
								},
							},
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Steel,
								spreadSpecials = CascadePieceSpecials_Ice,
								skinVariant = "IceMaker",
								weight = 1,
							},
						},
						{
							name = "IceMakerB",
							events = {
								{
									eventType = "emitCount",
									count = 1,
									patterns = {"IceMakerB"},
								},
							},
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Steel,
								spreadSpecials = CascadePieceSpecials_Ice,
								skinVariant = "IceMaker",
								weight = 1,
							},
						},
						{
							name = "VineMaker",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_VineGenerator,
								cancelSpecials = CascadePieceSpecials_Vines,
								weight = 1,
							},
						},
					} 
					
					-- Need 2 different ice maker mixes because they need to apply different patterns
					table.insertall(namedMixes, MakeFixedSafe({1, 2, 1, 2, 1}, "Safe1", "IceMakerA"))
					table.insertall(namedMixes, MakeFixedSafe({1, 2, 1, 2, 1}, "Safe2", "IceMakerB"))
					table.insertall(namedMixes, MakeFixedSafe({2, 1, 2, 1, 2}, "Safe3", "VineMaker"))
					
					return namedMixes
				end
			), 
			additionalInitialPatterns = {
				{
					patternName = "Large 1,1",
					isPatternSet = false,
					replacePieces = {"Safe1_Step0"},
				},
				{
					patternName = "Large 5,4",
					isPatternSet = false,
					replacePieces = {"Safe2_Step0"},
				},
				{
					patternName = "Large 1,4",
					isPatternSet = false,
					replacePieces = {"Safe3_Step0"},
				},
				{
					patternName = "Large 5,1",
					isPatternSet = false,
					replacePieces = {"Safe3_Step0"},
				},
			},
		},
		goals = {
			main = {"getGem",4,"Safe","Safes",{specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable, },"Open"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, 
	},
	
	["HiddenSafe"] = {
		levelName = "Underground Infiltration",
		introScript = "Land33_Tip12",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes3 = true,
			largeBoard = true,

			hasSteel = true,
			hasFences = true,
			hasLasers = true,
			hasIce = true,
			hasChests = true,
			hasStones = true,
			hasMissingReels = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "ReelPosition4",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "Laser",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"Laser"},
								skinVariant = "LaserH",
								weight = 1,
							},
						},
					} 

					local colors = {1, 2, 3}
					table.insertall(namedMixes, MakeRandomSafe({colors,colors, colors, colors, colors, colors}, "Safe1", "Laser"))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "HiddenSafe_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "HiddenSafe_Fence",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
				},
				{
					patternName = "HiddenSafe_Stone",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 3,
				},
				{
					patternName = "Large 4,1",
					isPatternSet = false,
					replacePieces = {"Safe1_Step0"},
				},
				{
					patternName = "Large 7,5",
					isPatternSet = false,
					replacePieces = {"Safe1_Step0"},
				},
				{
					patternName = "Large 6,2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel | CascadePieceSpecial_CantCover,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "IceMaker",
				},
				{
					patternName = "Large 6,2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "Large 6,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "HiddenSafe_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			portals = {
				{{2,4},{2,7},"PortalEntrance_1","PortalExit_1"},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Laser",
						{
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser"},
							skinVariant = "LaserH",
							weight = 1,
						},
					},
				}
			}
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure, },"Open"},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",700000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000, 
	},

	
	["SafeBelt"] = {
		levelName = "Order Matters",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasSafes = true,
			hasLava = true,
			hasIce = true,
			hasBombs = true,
			hasStones = true,
			hasSwitches = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedPatterns = {
				{
					entryName = "Switch_1",
					patternName = "SafeBelt_1A",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					entryName = "Switch_1B",
					patternName = "Large 4,2",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
				},
				{
					entryName = "Switch_1C",
					patternName = "Large 2,2",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"Safe3_Step0"},
				},
				{
					entryName = "Switch_2",
					patternName = "SafeBelt_1B",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
				},
				{
					entryName = "Switch_2B",
					patternName = "Large 4,4",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
				{
					entryName = "Switch_2C",
					patternName = "Large 2,4",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"Safe4_Step0"},
				},
				{
					entryName = "Switch_3",
					patternName = "RightColumnLarge",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "Switch_3B",
					patternName = "LeftColumnLarge",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"IceMix"},
				},
				{
					entryName = "Switch_4",
					patternName = "TestCoverage2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_AreaSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					filter = {specials = CascadePieceSpecials_Lava},
				},
				{
					entryName = "Switch_4B",
					patternName = "TestCoverage2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash,
					applySpreadSpecials = true,
					spreadSpecials = 0,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					filter = {cancelSpecials = CascadePieceSpecials_Ice},
				},
				{
					entryName = "Switch_4C",
					patternName = "Large 2,4",
					addPieces = true,
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch | CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
				},
				{
					entryName = "Switch_4_Safe1",
					patternName = "Large 7,3",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"Safe5_Step0"},
				},
				{
					entryName = "Switch_4_Safe2",
					patternName = "Large 5,3",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"Safe6_Step0"},
				},
				{
					entryName = "Switch_4_Safe3",
					patternName = "Large 3,3",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"Safe7_Step0"},
				},
				{
					entryName = "Switch_5",
					patternName = "LargeRow_7",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
				},
				{
					entryName = "Switch_6",
					patternName = "LargeRow_5",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					entryName = "Switch_7",
					patternName = "LargeRow_3",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone
				},
			},
			additionalNamedMixes = ExecuteInline(
				function ()

					local iceMix = {name = "IceMix"}
					AddColorsToPieceMix(iceMix, {1, 2, 3, 4, 5}, {
						name = "Ice",
						spreadSpecials = CascadePieceSpecials_Ice,
						cancelSpecials = CascadePieceSpecials_Ice,
					})

					local namedMixes = {
						{
							name = "Switch_1",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Toggle",
								matchPatterns = {"Switch_1", "Switch_1B", "Switch_1C"},
								weight = 1,
							},
						},
						{
							name = "Switch_2",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Toggle",
								matchPatterns = {"Switch_2", "Switch_2B", "Switch_2C"},
								weight = 1,
							},
						},
						{
							name = "Switch_3",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Toggle",
								matchPatterns = {"Switch_3", "Switch_3B"},
								weight = 1,
							},
						},
						{
							name = "Switch_4",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Toggle",
								matchPatterns = {"Switch_4", "Switch_4B", "Switch_4C", "Switch_4_Safe1", "Switch_4_Safe2", "Switch_4_Safe3", "Switch_4_Safe4",},
								weight = 1,
							},
						},
						{
							name = "Switch_5",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Toggle",
								matchPatterns = {"Switch_5"},
								weight = 1,
							},
						},
						{
							name = "Switch_6",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Toggle",
								matchPatterns = {"Switch_6"},
								weight = 1,
							},
						},
						{
							name = "Switch_7",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Toggle",
								matchPatterns = {"Switch_7"},
								weight = 1,
							},
						},
						iceMix,
					}

					local colors = {1, 2, 3, 4}

					table.insertall(namedMixes, MakeRandomSafe({colors}, "Safe1", "Switch_1"))
					table.insertall(namedMixes, MakeRandomSafe({colors, colors}, "Safe2", "Switch_2"))
					table.insertall(namedMixes, MakeRandomSafe({colors, colors}, "Safe3", "Switch_3"))
					table.insertall(namedMixes, MakeRandomSafe({colors, colors, colors}, "Safe4", "Switch_4"))
					table.insertall(namedMixes, MakeRandomSafe({colors, colors, colors}, "Safe5", "Switch_5"))
					table.insertall(namedMixes, MakeRandomSafe({colors, colors, colors}, "Safe6", "Switch_6"))
					table.insertall(namedMixes, MakeRandomSafe({colors, colors, colors}, "Safe7", "Switch_7"))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "Large 4,2",
					isPatternSet = false,
					replacePieces = {"Safe1_Step0"},
				},
				{
					patternName = "Large 4,4",
					isPatternSet = false,
					replacePieces = {"Safe2_Step0"},
				},
			},
		},
		goals = {
			main = {"getGem",7,"Switch","Switches",{skinVariant = "Switch1_Toggle",},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",650000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000, 
	},

	
	["SafeBombs"] = {
		levelName = "Down We Go",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins9 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,

			hasBombs = true,
			hasBalloons = true,
			hasSafes = true,
			hasMissingSquares = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "SafeBombs_Missing",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "WildBomb",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecials_Balloon,
								cancelSpecials = CascadePieceSpecials_Balloon,
								turnsToLoss = 99,
								weight = 1,
							},
						},
					}

					local colors = {1, 2, 3, 4}
					table.insertall(namedMixes, MakeRandomSafe({colors, colors, colors, colors}, "SafeA", "WildBomb"))
					table.insertall(namedMixes, MakeRandomSafe({colors, colors, colors}, "SafeB", "WildBomb"))
					table.insertall(namedMixes, MakeRandomSafe({colors, colors}, "SafeC", "WildBomb"))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "SafeBombs_Bombs",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = true,
					turnsToLoss = 27,
					applyExtraHits = true,
					extraHits = 3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
				},
				{
					patternName = "SafeBombs_SafeA",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"SafeA_Step1_4"},
                    applyTotalSpawns = true,
                    totalSpawns = 4,
				},
				{
					patternName = "SafeBombs_SafeB",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"SafeB_Step1_3"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "SafeBombs_SafeC",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"SafeC_Step1_2"},
                    applyTotalSpawns = true,
                    totalSpawns = 2,
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "WildBomb",
						{
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Balloon,
							cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
							weight = 1,
						},
					},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",900000},
				[2] = {"score",1200000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000, 
	},

	["ShrinkingSafes"] = {
		levelName = "Shrinking Safes",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,

			hasSafes = true,
			hasIce = true,
			hasVines = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function ()

					local vineMix = {name = "VineMix"}
					AddColorsToPieceMix(vineMix, {1, 2, 3, 4, 5}, {
						name = "Vine",
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
					})

					local namedMixes = {
						{
							name = "LavaMix",
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Lava,
								weight = 1,
							},
						},
						vineMix,
						{
							name = "Superwild",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecial_ClearKeyColorOnMatch | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash | CascadePieceSpecial_AreaSplash,
								weight = 1,
							},
						},
					}

					table.insertall(namedMixes, MakeFixedSafe({2, 1}, "SafeLayer1", "LavaMix"))
					table.insertall(namedMixes, MakeFixedSafe({2, 1, 5, 3, 4}, "SafeLayer2", "VineMix"))
					table.insertall(namedMixes, MakeFixedSafe({2, 1, 5, 3, 4, 2, 5, 1}, "SafeLayer3", "Superwild"))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "ShrinkingSafes_SafeLayer1",
					isPatternSet = false,
                    replacePieces = {"SafeLayer1_Step0"},
				},
				{
					patternName = "ShrinkingSafes_SafeLayer2",
					isPatternSet = false,
					replacePieces = {"SafeLayer2_Step0"},
				},
				{
					patternName = "Large 4,3",
					isPatternSet = false,
					replacePieces = {"SafeLayer3_Step0"},
				},
			},
		},
		goals = {
			main = {"getGem",25,"Safe","Safes",{specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable},"Open"},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
	-- End Daniel levels




	--Begin Randi levels
	["CodenameRainbow"] = { 
		levelName = "Codename Rainbow",
		introScript = "Land33_Intro",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes6 = true,
			largeBoard = true,
			hasSafes = true,
			hasMissingSquares = true,
			hasMissingReels = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			addToReelPieceMix = {
				{
					name = "Wilds",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 1,
				},
			},
			useMissingReels = true,
			missingReels = {
				patternName = "CodenameRainbow_MissingReels",
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "CodenameRainbow_MissingSquares",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function () 

					local exampleNamedMixes = {
						{
							name = "Superwild",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecial_ClearKeyColorOnMatch,
								weight = 1,
							},
						},
					} 
		
					table.insertall(exampleNamedMixes, MakeFixedSafe({4,6,5,2,1,3,7}, "Safe1", "Superwild"))
					
					
					return exampleNamedMixes
				end 
			), 
			additionalInitialPatterns = {
				
				{
					patternName = "CodenameRainbow_Safe",
					isPatternSet = false,
					replacePieces = {"Safe1_Step0"},
				},
				
			},
		},
		goals = {
			main = {"getGem",1,"Safe","Safes",{specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable, },"Open"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
	},

	["GatheringSupplies"] = { 
		levelName = "Gathering Supplies",	
		introScript = "Land33_Tip7",				
		resource = "GameScreen_Land33",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,

			hasSafes = true,
			hasRings = true,
			hasBarrelsOfFun = true,
			hasCrates = true,
			hasBarrels = true,
			hasStones = true,
			hasGiftBoxes = true,
			hasCoconuts = true,
			hasBalloons = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function () 

					local exampleNamedMixes = {
						{
							name = "Superwild",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecial_ClearKeyColorOnMatch,
								icon = "Icon_Marked",
								weight = 1,
							},
						},
						{
							name = "Boulder",
							{
								specials = CascadePieceSpecials_Barrels,
								icon = "Icon_Marked",
								extraHits = 1,
								weight = 1,
							},
						},
						{
							name = "Stone",
							{
								specials = CascadePieceSpecials_Stone,
								matchFlags = 0,
								icon = "Icon_Marked",
								extraHits = 2,
								weight = 1,
							},
						},
						{
							name = "Chest",
							{
								specials = CascadePieceSpecials_Treasure,
								icon = "Icon_Marked",
								weight = 1,
							},
						},
						{
							name = "Barrel",
							{
								specials = CascadePieceSpecials_ColorBarrels,
								icon = "Icon_Marked",
								matchFlags = CascadeMatchFlags_Wildcard,
								spawnTypes = {"Wild"},
								weight = 1,
							},
						},
						{
							name = "Wild",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								weight = 1,
							},
						},
						{
							name = "Wild_Ring",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								icon = "Icon_Marked",
								weight = 1,
							},
						},
						{
							name = "Crate",
							{
								specials = CascadePieceSpecials_Crates,
								matchFlags = 0,
								icon = "Icon_Marked",
								weight = 1,
							},
						},
						{
							name = "Gift",
							{
								specials = CascadePieceSpecials_Stone,
								spawnTypes = {"Wild"},
								extraHits = 1,
								icon = "Icon_Marked",
								matchFlags = 0,
								weight = 1,
							},
						},
						{
							name = "Coconut",
							{
								specials = CascadePieceSpecials_Coconut,
								spawnTypes = {"Wild"},
								matchFlags = 0,
								icon = "Icon_Marked",
								weight = 1,
							},
						},
						{
							name = "Balloon",
							{
								specials = CascadePieceSpecials_Balloon,
								matchFlags = CascadeMatchFlags_Wildcard,
								icon = "Icon_Marked",
								cancelSpecials = CascadePieceSpecials_Balloon,
								weight = 1,
							},
						},
					} 

					table.insertall(exampleNamedMixes, MakeFixedSafe({3,2,1}, "Safe1", "Barrel"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({2,1,2}, "Safe2", "Chest"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,4,3,2,1}, "Safe3", "Boulder"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({4,1,3,1,2}, "Safe4", "Coconut"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({2,3,2,4,1}, "Safe5", "Wild_Ring"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,2,4,2,3}, "Safe6", "Balloon"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({4,3,1,3,4}, "Safe7", "Gift"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({3,1,2,4,3}, "Safe8", "Superwild"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,4,2,1,3}, "Safe9", "Stone"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({3,2,3,4,1}, "Safe10", "Crate"))
					
					
					return exampleNamedMixes
				end 
			), 
			additionalInitialPatterns = {
				{
					patternName = "GatheringSuppliesNew_Safe1",
					isPatternSet = false,
                    replacePieces = {"Safe1_Step0"},
				},
				
				{
					patternName = "GatheringSuppliesNew_Safe2",
					isPatternSet = false,
					replacePieces = {"Safe2_Step0"},
				},
				{
					patternName = "GatheringSuppliesNew_Safe3",
					isPatternSet = false,
					replacePieces = {"Safe3_Step0"},
				},
				{
					patternName = "GatheringSuppliesNew_Safe4",
					isPatternSet = false, 
					replacePieces = {"Safe4_Step0"},
				},
				{
					patternName = "GatheringSuppliesNew_Safe5",
					isPatternSet = false,
					replacePieces = {"Safe5_Step0"},
				},
				{
					patternName = "GatheringSuppliesNew_Safe6",
					isPatternSet = false,
					replacePieces = {"Safe6_Step0"},
				},
				{
					patternName = "GatheringSuppliesNew_Safe7",
					isPatternSet = false,
					replacePieces = {"Safe7_Step0"},
				},
				{
					patternName = "GatheringSuppliesNew_Safe8",
					isPatternSet = false,
					replacePieces = {"Safe8_Step0"},
				},
				{
					patternName = "GatheringSuppliesNew_Safe9",
					isPatternSet = false,
					replacePieces = {"Safe9_Step0"},
				},
				{
					patternName = "GatheringSuppliesNew_Safe10",
					isPatternSet = false,
					replacePieces = {"Safe10_Step0"},
				},
			},
		},
		goals = {
			main = {"getGem", 10, "Ring", "Rings", {icon = "Icon_Marked", extraHits = 0, cancelSpecials = 0,}, "Collect"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

	["HatchingAPlan"] = { 
		levelName = "Hatching a Plan",					
		resource = "GameScreen_Land33",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasSafes = true,
			hasFences = true,
			hasChests = true,
			hasMissingReels = true,
			hasMakers = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "HatchingAPlan_MissingReels",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function () 
					local exampleNamedMixes = {
						{
							name = "ChestMix",
							events = {
								[1] = {
									eventType = "population",
									newDelay = 0,
									count = 3,
									comparator = "less",
									setCooldowns = 1,
									gemType = {specials = CascadePieceSpecials_Treasure,},	
								},
								[2] = {
									eventType = "emitCount",
									count = 1,
									newDelay = -1,
									reset = true,
								},
							},
							delay = 1,
							{
								name = "Chest",
								matchFlags = 0,
								specials = CascadePieceSpecials_Treasure,
								weight = 2,
							},
						},
						{
							name = "BlueBurstGemMix",
							{
								matchFlags = CascadeMatchFlags_CommonPiece1,
								specials = CascadePieceSpecial_HorizontalSplash,
								weight = 1, 
							},
						},
						{
							name = "GreenBurstGemMix",
							{
								matchFlags = CascadeMatchFlags_CommonPiece2,
								specials = CascadePieceSpecial_HorizontalSplash,
								weight =1,
							},
						},
						{
							name = "PurpleBurstGemMix",
							{
								matchFlags= CascadeMatchFlags_CommonPiece3,
								specials = CascadePieceSpecial_HorizontalSplash,
								weight =1,
							},
						},
						{
							name = "RedBurstGemMix",
							{
								matchFlags = CascadeMatchFlags_CommonPiece4,
								specials = CascadePieceSpecial_HorizontalSplash,
								weight = 1,
							},
						},
					} 
		
					table.insertall(exampleNamedMixes, MakeFixedSafe({3,1,2,3,4,2}, "Tier3Safe1", "BlueBurstGemMix"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({4,2,4,1,2,3}, "Tier3Safe2", "GreenBurstGemMix"))
					
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,3,2,1,4},"Tier2Safe1","PurpleBurstGemMix"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({2,4,3,2,1},"Tier2Safe2","BlueBurstGemMix"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({3,2,3,1,3},"Tier2Safe3","PurpleBurstGemMix"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({4,1,3,2,3},"Tier2Safe4","BlueBurstGemMix"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,3,2,4,2},"Tier2Safe5","RedBurstGemMix"))

					table.insertall(exampleNamedMixes, MakeFixedSafe({4,2,1,3}, "Tier1Safe1","GreenBurstGemMix"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({2,1,4,2}, "Tier1Safe2","RedBurstGemMix"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({3,4,2,1}, "Tier1Safe3", "GreenBurstGemMix"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,3,1,4}, "Tier1Safe4", "PurpleBurstGemMix"))
					
					return exampleNamedMixes
				end 
			), 
			additionalInitialPatterns = {
				{
					patternName = "HatchingAPlan_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"ChestMix"},
				},
				{
					patternName = "HatchingAPlan_Tier1Safe1",
					isPatternSet = false,
                    replacePieces = {"Tier1Safe1_Step0"},
				},
				{
					patternName  = "HatchingAPlan_Tier1Safe2",
					isPatternSet = false,
					replacePieces = {"Tier1Safe2_Step0"},
				},
				{
					patternName = "HatchingAPlan_Tier1Safe3",
					isPatternSet = false,
					replacePieces = {"Tier1Safe3_Step0"},
				},
				{
					patternName = "HatchingAPlan_Tier1Safe4",
					isPatternSet = false,
					replacePieces = {"Tier1Safe4_Step0"},
				},
				{
					patternName = "HatchingAPlan _Tier2Safe1",
					isPatternSet = false,
					replacePieces = {"Tier2Safe1_Step0"},
				},
				{
					patternName = "HatchingAPlan_Tier2Safe2",
					isPatternSet = false,
					replacePieces = {"Tier2Safe2_Step0"},
				},
				{
					patternName = "HatchingAPlan_Tier2Safe3",
					isPatternSet = false,
					replacePieces = {"Tier2Safe3_Step0"},
				},
				{
					patternName = "HatchingAPlan_Tier2Safe4",
					isPatternSet = false,
					replacePieces = {"Tier2Safe4_Step0"},
				},
				{
					patternName = "HatchingAPlan_Tier2Safe5",
					isPatternSet = false,
					replacePieces = {"Tier2Safe5_Step0"},
				},
				{
					patternName = "HatchingAPlan_Tier3Safe1",
					isPatternSet = false,
					replacePieces = {"Tier3Safe1_Step0"},
				},
				{
					patternName = "HatchingAPlan_Tier3Safe2",
					isPatternSet = false,
					replacePieces = {"Tier3Safe2_Step0"},
				},
				{
					patternName = "HatchingAPlan_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "HatchingAPlan_Fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},
	["StepByStepByStep"] = { 
		levelName = "Step by Step by Step",					
		resource = "GameScreen_Land33",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasSafes = true,
			hasJailedSquares = true,
			hasBarrelsOfFun = true,
			hasBalloons = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
		
			additionalNamedMixes = ExecuteInline(
				function () 

					local exampleNamedMixes = {
						{
							name = "ChestBalloon",
							{
								matchFlags= 0,
								specials =  CascadePieceSpecials_Treasure_Balloon,
								cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
								augmentSpecials = CascadePieceSpecial_SplashImmune,
								weight =1,
							},
						},
						{
							name = "Superwild",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecial_ClearKeyColorOnMatch,
								weight = 1,
							},
						},
						{
							name = "BlueBarrel",
							{
								specials = CascadePieceSpecials_ColorBarrels,
								matchFlags = CascadeMatchFlags_CommonPiece1,
								spawnTypes = {"ChestBalloon"},
								weight =1,
							},
						},
						{
							name = "GreenBarrel",
							{
								specials = CascadePieceSpecials_ColorBarrels,
								matchFlags = CascadeMatchFlags_CommonPiece2,
								spawnTypes = {"ChestBalloon"},
								weight = 1,
							},
						},
						{
							name = "PurpleBarrel",
							{
								specials = CascadePieceSpecials_ColorBarrels,
								matchFlags = CascadeMatchFlags_CommonPiece3,
								spawnTypes = {"ChestBalloon"},
								weight =1,
							},
						},
						{
							name = "RedBarrel",
							{
								specials = CascadePieceSpecials_ColorBarrels,
								matchFlags= CascadeMatchFlags_CommonPiece4,
								spawnTypes = {"ChestBalloon"},
								weight = 1,
							},
						},
						{
							name = "GreenBarrel2",
							{
								specials = CascadePieceSpecials_ColorBarrels,
								matchFlags= CascadeMatchFlags_CommonPiece2,
								spawnTypes = {"ChestBalloon"},
								weight = 1,
							},
						},
						{
							name = "BlueBarrel2",
							{
								specials = CascadePieceSpecials_ColorBarrels,
								matchFlags = CascadeMatchFlags_CommonPiece1,
								spawnTypes = {"ChestBalloon"},
								weight = 1,
							},

						},
					} 
		
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,3,1,2}, "Safe1", "BlueBarrel"))--unused?
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,1,3,2}, "Safe2", "GreenBarrel"))--unused?
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,4,2,1}, "Safe3", "PurpleBarrel"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({3,2,3,4}, "Safe4", "RedBarrel"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({2,1,2,3}, "Safe5", "GreenBarrel2"))
					table.insertall(exampleNamedMixes, MakeFixedSafe({4,2,4,3}, "Safe6", "BlueBarrel2"))
					
					
					return exampleNamedMixes
				end 
			), 
			additionalRegularPlacements = {
				{
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					frequencies = {3,6,9,12,15,20,23},
				},
				{
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					frequencies ={3,6,9,12,15,20,23},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "StepByStepByStep_Safe3",
					isPatternSet = false,
                    replacePieces = {"Safe3_Step0"},
				},
				{
					patternName = "StepByStepByStep_Safe4",
					isPatternSet = false,
					replacePieces = {"Safe4_Step0"},
				},
				{
					patternName = "StepByStepByStep_Safe5",
					isPatternSet = false,
					replacePieces = {"Safe5_Step0"},
				},
				{
					patternName = "StepByStepByStep_Safe6",
					isPatternSet = false,
					replacePieces = {"Safe6_Step0"},
				},
				{
					patternName = "StepByStepByStep_Tier1Jail",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
				{
					patternName = "StepByStepByStep_Tier2Jail",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyExtraHits = true,
					extraHits = 1,
				},
							
			},
		},
		goals = {
			main = {"getGem", 4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure },"Drop"},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",850000},
				[3] = {"score",1500000},
			},
		},
	},
	["AtBay"] = { 
		levelName = "At Bay",
        introScript = "Land33_Tip8",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasSafes = true,
			hasVineGenerators = true,
			hasVines = true,
			hasIce = true,
			hasLava = true,
			
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function () 

					local exampleNamedMixes = {
						{
							name = "Superwild",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								
								weight = 1,
							},
						},
					} 
		
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,1,2}, "Safe1", "Superwild"))--note: first entry skipped
					
					
					return exampleNamedMixes
				end 
			), 
			additionalInitialPatterns = {
				{
					patternName = "AtBay_Vines",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_VineGenerator,
					applyCancelSpecials = true,
					cancelSpecials= CascadePieceSpecials_Vines,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{	
					patternName = "AtBay_VineSafe1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName= "AtBay_VineSafe2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true, 
					specials =CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_VineSafe3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_VineSafe4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_VineSafe5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_VineSafe6",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_VineSafe7",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "AtBay_LavaSafe1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_LavaSafe2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_LavaSafe3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_LavaSafe4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_LavaSafe5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_Ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				{
					patternName = "AtBay_IceSafe1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_IceSafe2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_IceSafe3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_IceSafe4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
				{
					patternName = "AtBay_IceSafe5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},
			},
		},
		goals = {
			main = {"getGem",17,"Safe","Safes",{specials = CascadePieceSpecials_Safe| CascadePieceSpecial_Valuable}, "Open"},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",800000},
				[3] = {"score",1400000},
			},
		},
	},
	["SurpriseParole"] = { 
		levelName = "Surprise Parole",
		introScript = "Land33_Tip3",
		outtroScript = "Land33_Tip4",
		resource = "GameScreen_Land33",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasStones = true,
			hasJailedSquares = true,
			hasSafes = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function () 

					local exampleNamedMixes = {
						{
							name = "Superwild",
							{
								matchFlags = CascadeMatchFlags_CommonPiece6,
								specials = CascadePieceSpecials_Jailed,
								cancelSpecials= CascadePieceSpecials_Jailed,
								weight = 1,
							},
						},
					} 
		
					table.insertall(exampleNamedMixes, MakeFixedSafe({1,1,2,3}, "Safe1", "Superwild"))--Note: 1st entry skipped
					
					return exampleNamedMixes
				end 
			), 
			additionalInitialPatterns = {
				{
					patternName = "SurpriseParole_StonesTopRow",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
				},
				{
					patternName = "SurpriseParole_Stones",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
				},
				{
					patternName = "SurpriseParole_Locks",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
				{
                    --Note: first safe gem determined by board piece mix
					patternName = "SurpriseParole_Safe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
                    applyTotalSpawns = true,
                    totalSpawns = 4,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6, specials = CascadePieceSpecials_Jailed,},"Free"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},

	--End Randi levels

	-- Begin Brooke's levels
	["StrongArm"] = {
		levelName = "Strong Arm",
		introScript = "Land33_Tip9",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasStones = true,
			hasJailedSquares = true,
			hasSafes = true,
			hasCoverage = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function ()
					local myPieceMixes = {
						[1] = {
							name = "Superwild",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecial_ClearKeyColorOnMatch,
								weight = 1,
							},
						},
					}-- No comma here!

					local colors = {1,2,3,4,5}

					table.insertall(myPieceMixes, MakeRandomSafe({colors, colors, colors,}, "Safe1", "Superwild"))
					table.insertall(myPieceMixes, MakeRandomSafe({colors, colors, colors, colors,}, "Safe2", "Superwild"))
					table.insertall(myPieceMixes, MakeRandomSafe({colors, colors, colors, colors, colors, }, "Safe3", "Superwild"))

					--logprint(SerializeToString(myPieceMixes))

					return myPieceMixes
				end
			),
			additionalInitialPatterns = { 
				--Cloudy
				{
					patternName = "StrongArm_Cloudy",
                    isPatternSet = false,
                    applyMatchRequirement = true,
					matchRequirement = 2,
				},
				--Jails
				{
					patternName = "StrongArm_Jails",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
				--Stones
                {
                    patternName = "StrongArm_Stones",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
                    patternName = "StrongArm_Stones3",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
				},
				--Safes				
				{
					patternName = "StrongArm_Safe1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1_2"},
                    applyTotalSpawns = true,
                    totalSpawns = 3,
				},			
				{
					patternName = "StrongArm_Safe2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applySpawnTypes = true,
					spawnTypes = {"Safe2_Step1_5"},
                    applyTotalSpawns = true,
                    totalSpawns = 4,
				},
				{
					patternName = "StrongArm_Safe3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applySpawnTypes = true,
					spawnTypes = {"Safe3_Step1_4"},
                    applyTotalSpawns = true,
                    totalSpawns = 5,
				},
			},
		},
		goals = {
			main = {"patterns", 0},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",750000},
				[3] = {"score",1000000},
			},
		},
	},

	["Trespasser"] = {
		levelName = "Trespasser",
		introScript = "Land33_Tip2",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSteel = true,
			hasGemEaters = true,
			hasChests = true,
			hasLocks = true,
			hasFences = true,
			hasMissingReels = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			--Missing Reels
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large", 
				isPatternSet = false,
			},
			
			addToBoardPieceMix = {
				{
					name = "Chest",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 5,
				},
			},
			additionalInitialPatterns = { 
				--Steel
                {
                    patternName = "Trespasser_Steel",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Fence
                {
                    patternName = "Trespasser_Fence",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Gem Eaters
				{
                    patternName = "Trespasser_GemEaters",
                    isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				--Locks
				{
					patternName = "Trespasser_Locks",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem", 4, "Chest", "Chests", {specials = CascadePieceSpecials_Treasure}, "Drop"},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},

	["Hustle"] = {
		levelName = "Hustle",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes3 = true,
			hasSteel = true,
			hasGemEaters = true,
			hasChests = true,
			hasLocks = true,
			hasSwitches = true,
			hasMissingReels = true,
			hasMissingSquares = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			--Missing Reels
			useMissingReels = true,
			missingReels = {
				patternName = "MissingLargeSideReels", 
				isPatternSet = false,
			},

			--Missing Squares 
			useMissingSquares = true,
			missingSquares = {
				patternName = "Hustle_Missing", 
				isPatternSet = false,
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Stones",
                    patternName = "Hustle_Stones",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					addPieces = true,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"Toggle1"},
						weight = 1,
						matchPatterns = {"Stones",},
					},
				},
			},
			additionalInitialPatterns = { 
				--Steel
                {
                    patternName = "Hustle_Steel",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Gem Eaters
				{
                    patternName = "Hustle_GemEaters",
                    isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				--Locks
				{
					patternName = "Hustle_Locks",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Switch - can I make a switch spawn gem eaters?
				{
					patternName = "Hustle_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Stones",},
				},
			},
			endGameProperties = {
				--turn off switch?
			},
		},
		goals = {
			main = {"gemsRemain", 0, "Lock", "Locks", {specials = CascadePieceSpecials_Lock}, "Open"},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",610000},
				[3] = {"score",800000},
			},
		},
	},

	["SafeInside"] = {
		levelName = "Safe Inside",
		introScript = "Land33_Tip1",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSteel = true,
			hasSafes = true,
			hasBedRock = true,
			hasMissingSquares = true,
			hasMissingReels = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			--Missing Squares
			useMissingSquares = true,
			missingSquares = {
				patternName = "SafeInside_Missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local myPieceMixes = {
						[1] = {
							name = "Key Red Mix",
							delay = 0,
							{
								name = "Key Red",
								matchFlags = CascadeMatchFlags_CommonPiece4,
								specials = CascadePieceSpecial_CantCover,
								icon = "Icon_PickAxe",
								matchPatterns = {"Remove Wall Red"},
								weight = 1,
							},
						},
						[2] = {
							name = "Key Blue Mix",
							delay = 0,
							{
								name = "Key Blue",
								matchFlags = CascadeMatchFlags_CommonPiece1,
								specials = CascadePieceSpecial_CantCover,
								icon = "Icon_PickAxe",
								matchPatterns = {"Remove Wall Blue"},
								weight = 1,
							},
						},
					}-- No comma here!

					table.insertall(myPieceMixes, MakeFixedSafe({4, 2, 4, 2, 1}, "Safe1", "Key Red Mix"))
					table.insertall(myPieceMixes, MakeFixedSafe({1, 3, 1, 3, 4}, "Safe2", "Key Blue Mix"))

					return myPieceMixes
				end
			),
			additionalNamedPatterns = {
				{
					entryName = "Remove Wall Blue",
					patternName = "SafeInside_BedrockBlue",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Wall Red",
					patternName = "SafeInside_BedrockRed",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Wall Purple",
					patternName = "SafeInside_BedrockPurple",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				--Bedrock
				{
					patternName = "SafeInside_BedrockBlue",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "SafeInside_BedrockRed",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "SafeInside_BedrockPurple",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				--PickAxe
				{
					patternName = "SafeInside_Pickaxe",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Wall Purple"},
				},
				--Steel
                {
                    patternName = "SafeInside_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Safes			
				{
					patternName = "SafeInside_Safe1",
					isPatternSet = false,
                    replacePieces = {"Safe1_Step0"},
				},			
				{
					patternName = "SafeInside_Safe2",
					isPatternSet = false,
					replacePieces = {"Safe2_Step0"},
				},
			},
		},
		goals = {
			main = {"gemsRemain", 0, "Bedrock.singular", "Bedrock.plural", {specials = CascadePieceSpecials_Steel, skinVariant = "BedRock"}, "Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",450000},
			},
		},
	},
	--End Brooke's Levels
	--Begin Josh's Levels
	["SafeTreasure"] = {
		levelName = "Cracking The Vault",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasChests = true,
			hasSafes = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function()
			
				local exampleNamedMixes = {
					{
						name = "Treasures",
						{
							matchFlags = 0,
							specials = CascadePieceSpecials_Treasure,
							weight = 1,
						},
					},
				}
			
				table.insertall(exampleNamedMixes, MakeRandomSafe({{1,2,3,4,5}, {1,2,3,4,5}, {1,2,3,4,5}}, "TreasureSafes", "Treasures"))
				return exampleNamedMixes
				end
			),

			additionalInitialPatterns = { 
				--Safes
				{
					patternName = "SafeTreasure_Safes", 
					isPatternSet = false,
					replacePieces = {"TreasureSafes_Step0"},
				},
				-- Chests
				{
					patternName = "SafeTreasure_Chests", 
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem", 6, "Chest", "Chests", {specials = CascadePieceSpecials_Treasure}, "Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",700000},
			},
		},
	},
	["DangerSafes"] = {
		levelName = "Dangerous Safes",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBombs = true,
			hasSafes = true,
			hasChests = true, 
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function()
			
				local exampleNamedMixes = {
					{
						name = "Bombs mix",
						{
							name = "Treasure Bombs",
							matchFlags = 0,
							specials = CascadePieceSpecials_Treasure,
							turnsToLoss = 16,
							weight = 1,
						},
					},
				}
			
				table.insertall(exampleNamedMixes, MakeRandomSafe({{1,2,3,4}, {1,2,3,4}, {1,2,3,4}}, "BombSafe1", "Bombs mix"))
				return exampleNamedMixes
				end
			),
			
			additionalRegularPlacements={
				{
					matchFlags = 15, -- with anyOneMatchFlag, randomizes among 4 colors
					anyOneMatchFlag = true, 
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 16,
					frequencies = {1,3,4,5,6,9},
				},
			},

			additionalInitialPatterns = { 
				--Safes
				{
					patternName = "DangerSafes_Safes", 
					isPatternSet = false,
					replacePieces = {"BombSafe1_Step0"},
				},
			},
		},
		goals = {
			main = {"getGem",8,"Chest","Chests",{specials = CascadePieceSpecials_Treasure, turnsToLoss = true, },"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",450000},
				[3] = {"score",1300000},
			},
		},
	},
	["LaserField"] = {
		levelName = "Laser Field",
		introScript = "Land33_Tip11",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasLasers = true,
			hasSafes = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasSteel = true,
			hasJailedSquares = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			--Missing Squares
			useMissingSquares = true,
			missingSquares = {
				patternName = "LaserField_MissingSquares",
				isPatternSet = false,
			},
			--missingReels
			useMissingReels = true,
			missingReels = {
				patternName = "LaserField_MissingReels",
				isPatternSet = false,
			},

			additionalNamedMixes = ExecuteInline(
				function()
					local exampleNamedMixes = {
						{
							name = "Laser H",
							delay = 0,
							{
								name = "Laser1",
								matchFlags = CascadeMatchFlags_CommonPiece1,
								specials = CascadePieceSpecials_Laser|CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"Laser H",},
								weight = 1,
							},
							{
								name = "Laser2",
								matchFlags = CascadeMatchFlags_CommonPiece2,
								specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"Laser H",},
								weight = 1,
							},
							{
								name = "Laser3",
								matchFlags = CascadeMatchFlags_CommonPiece3,
								specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"Laser H",},
								weight = 1,
							},
							{
								name = "Laser4",
								matchFlags = CascadeMatchFlags_CommonPiece4,
								specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
								spawnTypes = {"Laser H",},
								weight = 1,
							},
						},
					}
				
					local c = {1, 2, 3, 4}
					table.insertall(exampleNamedMixes, MakeRandomSafe({c, c}, "LaserSafe1", "Laser H"))
					table.insertall(exampleNamedMixes, MakeRandomSafe({c, c, c}, "LaserSafe2", "Laser H"))
					table.insertall(exampleNamedMixes, MakeRandomSafe({c, c, c, c}, "LaserSafe3", "Laser H"))
					return exampleNamedMixes
				end
			),

			additionalInitialPatterns = { 
				--Safes
				{
					patternName = "LaserField_Safe1", 
					isPatternSet = false,
					replacePieces = {"LaserSafe1_Step0"},
				},
				{
					patternName = "LaserField_Safe2", 
					isPatternSet = false,
					replacePieces = {"LaserSafe2_Step0"},
				},
				{
					patternName = "LaserField_Safe3", 
					isPatternSet = false,
					replacePieces = {"LaserSafe3_Step0"},
				},
				--Jailed gems
				{
					patternName = "LaserField_Jails",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyExtraHits = true,
					extraHits = 1,
				},
				--Steel
				{
					patternName = "LaserField_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Laser H",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser H",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
		},
		goals = {
			main = {"getGem", 6, "Jail", "Jails", {specials = CascadePieceSpecials_Jailed, extraHits = 0,}, "Break"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",350000},
				[3] = {"score",750000},
			},
		},
	},
	["JungleSafes"] = {
		levelName = "Jungle Safes",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSafes = true,
			hasVines = true,
			hasVineGenerators = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function()
			
				local exampleNamedMixes = {
					{
						name = "Vine Generator",
						{
							matchFlags = 0,
							specials = CascadePieceSpecials_VineGenerator,
							cancelSpecials = CascadePieceSpecials_Vines,
							weight = 1,
						},
					},
				}
			
				table.insertall(exampleNamedMixes, MakeRandomSafe({{1,2,3,4}, {1,2,3,4}, {1,2,3,4}}, "VineSafes", "Vine Generator"))
				return exampleNamedMixes
				end
			),
			
			additionalInitialPatterns = { 
				--Safes
				{
					patternName = "JungleSafes_Safes", 
					isPatternSet = false,
					replacePieces = {"VineSafes_Step0"},
				},
				--Vines
				{
					patternName = "JungleSafes_Vines",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
			
				},
			},
		},
		goals = {
			main = {"getGem", 4, "Safe", "Safes", {specials = CascadePieceSpecials_Safe|CascadePieceSpecial_Valuable}, "Open"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",800000},
			},
		},
	},
	["GreatEscape"] = {
		levelName = "The Great Escape",
		introScript = "Land33_Tip15",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasRings = true,
			hasBarrelsOfFun = true,
			hasFences = true,
			hasMakers = true,
			hasMissingReels = true,
			hasBarrels =true,
			hasBombs = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Ring Mix",
					delay = 0,
					{
						name = "Blue Ring",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Green Ring",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Purple Ring",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Red Ring",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name  = "Boulder Bomb",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						turnsToLoss = 8,
						weight = .7,
					},
				},
			},
			spawnGemOnBreak = 
			{
				{
					name = "BlueBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 2,
				},
				{
					name = "GreenBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 2,
				},
				{
					name = "PurpleBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 2,
				},
				{
					name = "RedBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 2,
				},
				{
					name = "BlueBurstV",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "GreenBurstV",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "PurpleBurstV",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "RedBurstV",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				
			},
			additionalInitialPatterns = { 
				--Fences
				{
					patternName = "GreatEscape_Fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Ring Makers
				{
					patternName = "GreatEscape_Makers1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Ring Mix"},
				},
				--Rings
				{
					patternName = "GreatEscape_Rings",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
				}
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
				},
			},

			useMissingReels = true,
			missingReels = {
				patternName = "GreatEscape_MissingReel",
				isPatternSet = false,
			},
		},
		goals = {
			main = {"getGem", 25, "Ring", "Rings", {icon = "Icon_Marked"}, "Collect"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["BigHeist"] = {
		levelName = "First Big Heist",
		introScript = "Land33_FirstBigHeist",
		resource = "GameScreen_Land33",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSafes = true,
			hasSteel = true,
			hasLocks = true,
			hasJailedSquares = true,
			hasSwitches = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
				function()
			
				local exampleNamedMixes = {
					{
						name = "Treasure Mix",
						delay = 0,
						{
							name = "Treasure",
							matchFlags = 0,
							specials = CascadePieceSpecials_Treasure,
							weight = 1,
						},
					},
				}
			
				table.insertall(exampleNamedMixes, MakeRandomSafe({{1,2,3,4},{1,2,3,4},}, "HeistSafe", "Treasure Mix"))
				return exampleNamedMixes
				end
			),
			additionalNamedPatterns = {
				[1] = {
					entryName = "RemoveSteel1",
					patternName = "BigHeist_RemoveSteel1",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "RemoveSteel2",
					patternName = "BigHeist_RemoveSteel2",
					isPatternSet = false, 
					clearPieces = true,
				},
				[3] = {
					entryName = "RemoveSteel3",
					patternName = "BigHeist_RemoveSteel3",
					isPatternSet = false,
					clearPieces = true,
				},
				[4] = {
					entryName = "MakeJails1",
					patternName = "BigHeist_Jails2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					addPieces = true,

				},
			},

			additionalInitialPatterns = { 
				--Safes
				{
					patternName = "BigHeist_Safe", 
					isPatternSet = false,
					replacePieces = {"HeistSafe_Step0"},
				},
				--Steel 
				{
					patternName = "BigHeist_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Switches
				{
					patternName = "BigHeist_Switch1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"Switch1 Mix"},
					applyMatchPatterns = true,
					matchPatterns = {"RemoveSteel1",},
				},
				{
					patternName = "BigHeist_Switch2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Switch2_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"Switch2 Mix"}, 
					applyMatchPatterns = true,
					matchPatterns = {"RemoveSteel2",},
				},
				{
					patternName = "BigHeist_Switch3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Switch3_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"Switch3 Mix"}, 
					applyMatchPatterns = true,
					matchPatterns = {"RemoveSteel3", "MakeJails1",},
				},
				--Locks 
				{
					patternName = "BigHeist_Locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Jails
				{
					patternName = "BigHeist_Jails1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true, 
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
				--Clear gems
				{
					patternName = "BigHeist_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
			},
		},
		goals = {
			main = {"getGem", 1, "Safe", "Safes", {specials = CascadePieceSpecials_Safe|CascadePieceSpecial_Valuable}, "Open"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},
	--End Josh's Levels

    --Begin Roh's Levels
    ["BigStruggle"] = {
        levelName = "The Big Struggle",
		introScript = "Land33_Tip16",
		outtroScript = "Land33_Outtro",
        resource = "GameScreen_Land33",  
        Features = {
            largeBoard = true,
            splashMode = true,
            modeSpins7 = true, 
            gemTypes4 = true,

            hasIce = true,
            hasSwitches = true,
            hasStones = true,
            hasSafes = true,
        },
        tricks = World33Tricks,
        boosts = World33Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "ClearRock",
                    patternName = "BigStruggle_Clear",
                    isPatternSet = false,
                    clearPieces = true,
                    filter = {
                        specials = CascadePieceSpecials_Stone,
                    },
                },
                {
                    entryName = "ClearIce",
                    patternName = "BigStruggle_Clear",
                    isPatternSet = false,
                    clearPieces = true,
                    filter = {
                        spreadSpecials = CascadePieceSpecials_Ice,
                    },
                },
                {
                    entryName = "ClearLava",
                    patternName = "BigStruggle_Clear",
                    isPatternSet = false,
                    clearPieces = true,
                    filter = {
                        specials = CascadePieceSpecials_Lava,
                    },
                },
                {
                    entryName = "BossForm1",
                    patternName = "BigStruggle_Form1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
                },
                {
                    entryName = "BossForm2_Eyes",
                    patternName = "BigStruggle_Form2_Eyes",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
                    addPieces = true,
                },
                {
                    entryName = "BossForm2",
                    patternName = "BigStruggle_Form2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
                    applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    entryName = "BossForm3_Eyes",
                    patternName = "BigStruggle_Form3_Eyes",
                    isPatternSet = false,
                    applySpreadSpecials = true,
                    spreadSpecials = CascadePieceSpecials_Ice,
                    addPieces = true,
                },
                {
                    entryName = "BossForm3",
                    patternName = "BigStruggle_Form3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
                    applyExtraHits = true,
                    extraHits = 2,
                },
            },
            additionalNamedMixes = ExecuteInline(
                function ()
                    local namedMixes = {                        
                        {
                            name = "Superwild",
                            {
                                matchFlags = CascadeMatchFlags_Wildcard,
                                specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                                weight = 1,
                            },
                        },

                        --Switches
                        {
                            name = "Toggle1",
                            delay = 0,
                            {
                                name = "Switch_Toggle1",
                                matchFlags = 0,
                                specials = CascadePieceSpecials_Stone,
                                skinVariant = "Switch1_Toggle",
                                spawnTypes = {"Toggle2"},
                                matchPatterns = {"ClearRock","ClearIce","BossForm1"},
                                weight = 1,
                            },
                        },
                        {
                            name = "Toggle2",
                            delay = 0,
                            {
                                name = "Switch_Toggle2",
                                matchFlags = 0,
                                specials = CascadePieceSpecials_Stone,
                                skinVariant = "Switch1_Toggle",
                                spawnTypes = {"Toggle3"},
                                matchPatterns = {"ClearRock","BossForm2","BossForm2_Eyes"},
                                weight = 1,
                            },
                        },

                        {
                            name = "Toggle3",
                            delay = 0,
                            {
                                name = "Switch_Toggle3",
                                matchFlags = 0,
                                specials = CascadePieceSpecials_Stone,
                                skinVariant = "Switch1_Toggle",
                                spawnTypes = {"Toggle1"},
                                matchPatterns = {"ClearRock", "ClearLava","BossForm3","BossForm3_Eyes"},
                                weight = 1,
                            },
                        },
                    } 
                    
                    table.insertall(namedMixes, MakeFixedSafe({4,1,3,4}, "Safe1", "Superwild"))
                    table.insertall(namedMixes, MakeFixedSafe({4,2,4,1}, "Safe2", "Superwild"))
                    table.insertall(namedMixes, MakeFixedSafe({4,3,1,2}, "Safe3", "Superwild"))
                    table.insertall(namedMixes, MakeFixedSafe({4,4,1,3,1,2}, "Safe4", "Superwild"))
                    
                    return namedMixes
                end
            ), 
            additionalInitialPatterns = { 
                --Safes
                {
                    patternName = "BigStruggle_Safe1",
                    isPatternSet = false,
                    replacePieces = {"Safe1_Step0"},
                },
                {
                    patternName = "BigStruggle_Safe2",
                    isPatternSet = false,
                    replacePieces = {"Safe2_Step0"},
                },
                {
                    patternName = "BigStruggle_Safe3",
                    isPatternSet = false,
                    replacePieces = {"Safe3_Step0"},
                },
                {
                    patternName = "BigStruggle_Safe4",
                    isPatternSet = false,
                    replacePieces = {"Safe4_Step0"},
                },

                --Switches
                {
                    patternName = "BigStruggle_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"ClearRock","BossForm1"},
                },
            },
        },      
        goals = {
            main = {"getGem", 4, "Safe", "Safes", {specials = CascadePieceSpecials_Safe|CascadePieceSpecial_Valuable}, "Open"},
            stars = {
                [1] = {"score",250000},
                [2] = {"score",500000},
                [3] = {"score",750000},
            },
        },
    },
    ["TripWire"] = {
        levelName = "Trip Wire",
		introScript = "Land33_Tip10",
        resource = "GameScreen_Land33",  
        Features = {
            largeBoard = true,
            splashMode = true,
            modeSpins7 = true, 
            gemTypes4 = true,

            hasSafes = true,
            hasSwitches = true,
            hasLava = true,
            hasAmber = true,
            hasStones = true,
            hasBombs = true,
            hasBarrels = true,
            hasBarrelsOfFun = true,
        },
        tricks = World33Tricks,
        boosts = World33Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    --turn red gems into bombs
                    entryName = "MakeRedBombs",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyTurnsToLoss = true,
                    turnsToLoss = 15,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = 0,
                    },
                },
                {
                    entryName = "MakeBoulderBombsFromBlue",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyTurnsToLoss = true,
                    turnsToLoss = 15,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = 0,
                    },
                },
                {
                    entryName = "MakeAmber",
                    patternName = "TripWire_Amber",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    cancelSpecials = CascadePieceSpecials_Amber,
                    applyCancelSpecials = true,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Amber,
					filter = {
						specials = 0,
					},
                },
                {
                    entryName = "MakeAmber2",
                    patternName = "TripWire_Amber",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    cancelSpecials = CascadePieceSpecials_Amber - CascadePieceSpecial_CantCover,
                    applyCancelSpecials = true,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Amber,
					filter = {
						specials = CascadePieceSpecial_CantCover,
					},
                },
                {
                    entryName = "MakeStoneWall",
                    patternName = "TripeWire_StoneWalls",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyExtraHits = true,
                    extraHits = 1,
                    addPieces = true,
                    filter = {
                        specials = 0,
                    },

                    --Remove bomb + cancel specials
                    applyTurnsToLoss = true,
                    turnsToLoss = -1,
                    applyCancelSpecials = true,
                    cancelSpecials = 0,
                },
                {
                    entryName = "MakeColorBarrels",
                    patternName = "TripWire_ColorBarrels",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_ColorBarrels,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                    addPieces = true,
                    applyTurnsToLoss = true,
                    turnsToLoss = -1,
                    filter = {
                        specials = 0,
                    },
                },
                {
                    entryName = "MakeLava",
                    patternName = "TripWire_Lava",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Lava,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
                    filter = {
                        specials = 0,
                    },
                },
            },
            additionalNamedMixes = ExecuteInline(
                function ()
                    local namedMixes = {                        
                        {
                            name = "Superwild",
                            {
                                matchFlags = CascadeMatchFlags_Wildcard,
                                specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                                weight = 1,
                            },
                        },

                        --Switches
                        {
                            name = "Toggle1",
                            delay = 0,
                            {
                                name = "Switch_Toggle1",
                                matchFlags = 0,
                                specials = CascadePieceSpecials_Stone,
                                skinVariant = "Switch1_Toggle",
                                spawnTypes = {"Toggle2"},
                                weight = 1,
                            },
                        },
                    } 
                    
                    table.insertall(namedMixes, MakeFixedSafe({3,2,4,1}, "Safe1", "Superwild"))
                    
                    return namedMixes
                end
            ), 
            spawnGemOnBreak = {
                {
                    matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                    weight = 1,
                },
                {
                    matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                    weight = 1,
                },
                {
                    matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                    weight = 1,
                },
                {
                    matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                    weight = 1,
                },
            },
            additionalInitialPatterns = { 
                --Single Multi-Hit Safe
                {
                    patternName = "TripWire_Safe1",
                    isPatternSet = false,
                    replacePieces = {"Safe1_Step0"},
                },

                --One-off Switches
                {
                    patternName = "TripWire_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeRedBombs"},
                },
                {
                    patternName = "TripWire_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeBoulderBombsFromBlue"},
                },
                {
                    patternName = "TripWire_Switch3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeAmber", "MakeAmber2"},
                },
                {
                    patternName = "TripWire_Switch4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeStoneWall"},
                },
                {
                    patternName = "TripWire_Switch5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeColorBarrels"},
                },
                {
                    patternName = "TripWire_Switch6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeLava"},
                },
            },
        },      
        goals = {
            main = {"getGem", 1, "Safe", "Safes", {specials = CascadePieceSpecials_Safe|CascadePieceSpecial_Valuable}, "Open"},
            stars = {
                [1] = {"score",300000},
                [2] = {"score",1500000},
                [3] = {"score",2500000},
            },
        },
    },
    --End Roh's Levels
	--Begin Michael's level
	["CutToTheChase"] = {
        levelName = "Cut to the Chase",
		introScript = "Land33_Tip14",
        resource = "GameScreen_Land33",  
        Features = {
            largeBoard = true,
            splashMode = true,
            modeSpins6 = true, 
            gemTypes4 = true,
			hasPortals = true,
			hasSafes = true,
			hasBombs = true,
			hasChests = true,
			hasBarrels = true, --boulders
			hasIce = true,
            hasStones = true,
			hasFences = true,
			hasMissingReels = true,
        },
        tricks = World33Tricks,
        boosts = World33Boosts,
        Properties = {
		useMissingReels = true,
			missingReels = {
				patternName = "CutToTheChase_reels",
				isPatternSet = false,
			},
		portals = {
				[1] = {{1,7},{5,0},"PortalEntrance_1","PortalExit_1"},
				[2] = {{0,7},{4,0},"PortalEntrance_1","PortalExit_1"},
				[3] = {{2,7},{6,0},"PortalEntrance_1","PortalExit_1"},
			},
            additionalNamedMixes = ExecuteInline(
                function ()
                    local namedMixes = {                        
                        {
                            name = "EscapeVehicle",
                            {
                                --matchFlags = 0,
                                --specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover + CascadePieceSpecials_Treasure,
								specials = CascadePieceSpecials_Treasure,
								turnsToLoss = 20,
                                weight = 1,
                            },
                        },
                    } 
                    
                    table.insertall(namedMixes, MakeFixedSafe({4,1}, "Safe1", "EscapeVehicle"))
                    
                    return namedMixes
                end
            ), 
			addToBoardPieceMix = {
                {
                    name = "Boulders",
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    weight = 5,
                },
            },
            additionalInitialPatterns = { 
                --Safe
                {
                    patternName = "CutToTheChase_safe",
                    isPatternSet = false,
                    replacePieces = {"Safe1_Step0"},
                },
				--Obstacles
				{
					patternName = "CutToTheChase_ice",
					isPatternSet = false,
                    applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				{
					patternName = "CutToTheChase_stones",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 1,
				},
				--fence
				{
					patternName = "CutToTheChase_steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
				},
            },
        },      
        goals = {
            main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure, },"Open"},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",300000},
                [3] = {"score",450000},
            },
        },
    },
})