-- Land 34: gem eaters: the sequel!

table.insertall(LevelDefs,
{
	--Begin Jonathan Levels
	["SideSlide"] = {
		levelName = "Side Slide",
		resource = "GameScreen_Land34",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSteelBoulders = true,
			hasMakers = true,
			hasPortals = true,
			hasGemEaters = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "One Steel Boulder Always",
					delay = 0,
					{
						name = "Cannonball",
						matchFlags = 0,
						specials = CascadePieceSpecials_SteelBoulder,
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "population",
							count = 1,
							newDelay = 0,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_SteelBoulder,
							},
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
					},
				},
				[2] = {
					name = "Normal Mix",
					delay = 0,
					{
						name = "Gem1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Gem2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Gem3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Gem4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Gem5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Cannonball",
						matchFlags = 0,
						specials = CascadePieceSpecials_SteelBoulder,
						weight = 6,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Large 0,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"One Steel Boulder Always","Normal Mix"},
				},
				{
					patternName = "Large 6,6",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				{
					patternName = "Large 7,6",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
			},
			portals = {
				[1] = {{0,7},{1,0},"PortalEntrance_1","PortalExit_1"},
				[2] = {{1,7},{2,0},"PortalEntrance_1","PortalExit_1"},
				[3] = {{2,7},{3,0},"PortalEntrance_1","PortalExit_1"},
				[4] = {{3,7},{4,0},"PortalEntrance_1","PortalExit_1"},
				[5] = {{4,7},{5,0},"PortalEntrance_1","PortalExit_1"},
				[6] = {{5,7},{6,0},"PortalEntrance_1","PortalExit_1"},
			},
		},
		goals = {
			main = {"eatGem",30,"Cannonball","Cannonballs",{specials = CascadePieceSpecials_SteelBoulder,},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",140000},
				[3] = {"score",300000},
			},
		},
	},
	["Timing"] = {
		levelName = "Timing",
		resource = "GameScreen_Land34",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasSwitches = true,
			hasGemEaters = true,
			hasBalloons = true,
			hasChests = true,
			hasMissingReels = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "Reels567",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "Switch1",
					delay = 0,
					{
						name = "Switch1",
						weight = 1,
						specials = CascadePieceSpecials_Stone,
						matchFlags = 0,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"Switch1"},
						matchPatterns = {"Turn on Maker Light"},
					},
				},
				{
					name = "Treasure Mix",
					delay = -1,
					{
						name = "Treasure",
						weight = 1,
						specials = CascadePieceSpecials_Treasure,
						matchFlags = 0,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							patterns = {"Set Maker 1 Icon Off"},
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								matchPatterns = {"Turn on Maker Light"},
							},
						},
					},
				},
				{
					name = "Staggered Balloons 1",
					delay = 2,
					{
						name = "Impossible Balloon",
						weight = 1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						matchFlags = CascadeMatchFlags_CommonPiece6,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
						},
					},
				},
				{
					name = "Staggered Balloons 2",
					delay = 3,
					{
						name = "Impossible Balloon",
						weight = 1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						matchFlags = CascadeMatchFlags_CommonPiece6,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 3,
						},
					},
				},
				{
					name = "Staggered Balloons 3",
					delay = 5,
					{
						name = "Impossible Balloon",
						weight = 1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						matchFlags = CascadeMatchFlags_CommonPiece6,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 5,
						},
					},
				},
			},
			additionalNamedPatterns = {
				{
					entryName = "Turn on Maker Light",
					patternName = "Timing_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				{
					entryName = "Turn off Maker Light",
					patternName = "Timing_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Timing_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Treasure Mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
				{
					patternName = "Timing_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Timing_BasicGemEaters",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyGemEater = true,
					gemEater = true,
					clearPieces = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 1,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
				},
				{ --One in two times
					patternName = "Timing_StaggeredEater1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 1,
					applyGemEaterDelay = true,
					gemEaterDelay = 0,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
				},
				{ --One in three times
					patternName = "Timing_StaggeredEater2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 2,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
				},
				{ --One in five times
					patternName = "Timing_StaggeredEater3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 4,
					applyGemEaterDelay = true,
					gemEaterDelay = 3,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
				},
				{
					patternName = "Timing_StaggeredMaker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Staggered Balloons 1"},
				},
				{
					patternName = "Timing_StaggeredMaker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Staggered Balloons 2"},
				},
				{
					patternName = "Timing_StaggeredMaker3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Staggered Balloons 3"},
				},
				{
					patternName = "Timing_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"Switch1"},
					applyMatchPatterns = true,
					matchPatterns = {"Turn on Maker Light"},
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",400000},
				[3] = {"score",450000},
			},
		},
	},
	--Begin Daniel Levels
	["SteelFlood"] = {
		levelName = "Steel Flood",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasGemEaters = true,
			hasSteelBoulders = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 20,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 20,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 20,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 20,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 10,
				},
				{
					name = "Superwild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 3,
				},
			},
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					specials = CascadePieceSpecials_SteelBoulder,
					frequencies = {0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 3, 3},
					inactiveForInitialPlacement = true,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "SmallRow_6",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 6,
				},
			},
		},
		goals = {
			main = {"eatGem",30,"Cannonball","Cannonballs",{specials = CascadePieceSpecials_SteelBoulder},},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",500000},
				[3] = {"score",650000},
			},
		},
	},

	["BalloonEater"] = {
		levelName = "Balloon Eater",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes6 = true,
			regularBoard = true,
			hasGemEaters = true,
			hasBalloons = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					namedMixes = {}

					-- Ballon piece mix
					balloonMix = {name = "Balloons"}

					-- Add appropriate balloon colors to balloon piece mix (red, orange, yellow)
					AddColorsToPieceMix(balloonMix, {4, 5, 6}, {
						name = "Balloon",
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					})

					-- Add ballon piece mix to namedMixes list
					namedMixes[#namedMixes+1] = balloonMix

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "SmallRow_0",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "SmallRow_6",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloons"},
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"eatGem",25,"Balloon","Balloons",{specials = CascadePieceSpecials_Balloon},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",70000},
				[3] = {"score",200000},
			},
		},
	},

	
	["FavoriteLetter"] = {
		levelName = "Favorite Letter",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasCoverage = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "LargeRow_0",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "FavoriteLetter_R",
					applyMatchRequirement = true,
					matchRequirement = 3,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",300000},
				[3] = {"score",440000},
			},
		},
	},

	
	["ToughBombs"] = {
		levelName = "Tough Bombs",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasGemEaters = true,
			hasSteelBoulders = true,
			hasBombs = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalInitialPatterns = ExecuteInline(
				function ()
					initialPatterns = {}

					-- Sets up the bottom row of gem eaters so that only 1 eats at a time
					for i = 0,6 do
						initialPatterns[#initialPatterns+1] = {
							patternName = "Large 7," .. i,
							isPatternSet = false,
							applyGemEater = true,
							gemEater = true,
							applyGemEaterCooldown = true,
							gemEaterCooldown = 6,
							applyGemEaterDelay = true,
							gemEaterDelay = i,
						}
					end

					return initialPatterns
				end
			),
			additionalRegularPlacements = {
				{
					specials = CascadePieceSpecials_SteelBoulder,
					turnsToLoss = 21,
					matchFlags = 0,
					frequencies = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
					inactiveForInitialPlacement = true,
				}
			},
		},
		goals = {
			main = {"eatGem", 10, "Bomb","Bombs", {specials = CascadePieceSpecials_SteelBoulder},},
			stars = {
				[1] = {"score",35000},
				[2] = {"score",55000},
				[3] = {"score",200000},
			},
		},
	},

	
	["JammingMachine"] = {
		levelName = "Jamming Machine",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasGemEaters = true,
			hasInedibleGems = true,
			hasSteelBoulders = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "LargeRow_0",
				isPatternSet = false,
			},
			additionalNamedPatterns = {
				{
					entryName = "SteelToJammers",
					patternName = "TestCoverage2",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"Jammers"},
					filter = {specials = CascadePieceSpecials_SteelBoulder},
				},
				{
					entryName = "JammersToSteel",
					patternName = "TestCoverage2",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_SteelBoulder,
					applyCancelSpecials = true,
					cancelSpecials = 0,
					applyMatchFlags = true,
					matchFlags = 0,
					filter = {specials = CascadePieceSpecials_Inedible_Bar},
				},
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "SteelToJammersSwitch",
							{
								name = "Switch",
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								spawnTypes = {"JammerToSteelSwitch"},
								matchPatterns = {"SteelToJammers"},
								weight = 1,
								skinVariant = "Switch1_Off",
							},
						},
						{
							name = "JammerToSteelSwitch",
							{
								name = "Switch",
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								spawnTypes = {"SteelToJammersSwitch"},
								matchPatterns = {"JammersToSteel"},
								weight = 1,
								skinVariant = "Switch1_On",
							},
						},
					}
					
					-- Create the piece mix containing inedible gems
					local jammerMix = {name = "Jammers"}
					AddColorsToPieceMix(jammerMix, {1, 2, 3, 4, 5}, {
						name = "Jammer",
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					})
					namedMixes[#namedMixes+1] = jammerMix

					return namedMixes
				end
			),
			additionalInitialPatterns = ExecuteInline(
				function ()
					local initialPatterns = {
						{
							patternName = "Large 4,3",
							isPatternSet = false,
							applyPieceSpecials = true,
							specials = CascadePieceSpecials_Stone,
							applyMatchFlags = true,
							matchFlags = 0,
							applySpawnTypes = true,
							spawnTypes = {"JammerToSteelSwitch"},
							applyMatchPatterns = true,
							matchPatterns = {"SteelToJammers"},
							applySkinVariant = true,
							skinVariant = "Switch1_Off",
						},
					}

					-- Set up gem eater patterns/delays
					for i = 1,4 do
						initialPatterns[#initialPatterns+1] = {
							patternName = "JammingMachine_GemEater" .. i,
							isPatternSet = false,
							applyGemEater = true,
							gemEater = true,
							applyGemEaterCooldown = true,
							gemEaterCooldown = 3,
							applyGemEaterDelay = true,
							gemEaterDelay = i-1,
						}
					end

					return initialPatterns
				end
			),
			additionalRegularPlacements = {
				{
					specials = CascadePieceSpecials_SteelBoulder,
					matchFlags = 0,
					frequencies = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
					inactiveForInitialPlacement = true,
				}
			},
		},
		goals = {
			main = {"haveGem", 16, "Gem Eater","Gem Eaters", {specials = CascadePieceSpecials_Inedible_Bar}, "Jam"},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",100000},
				[3] = {"score",300000},
			},
		},
	},
	
	["Whirlpool"] = {
		levelName = "The Whirlpool",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasGemEaters = true,
			hasSteelBoulders = true,
			hasPortals = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			gemsMoveDiagonally = false,
			useMissingSquares = true,
			missingSquares = {
				patternName = "LargeRow_0",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline (
				function ()
					local colors = {1, 2, 3, 4, 5, 7}

					--The good barrel mix has bursts
					local goodBarrelMix = {name = "GoodBarrelMix"}

					--Adding burst pieces to the good barrel mix
					AddColorsToPieceMix(goodBarrelMix, colors, {
						name = "A",
						specials = CascadePieceSpecial_AreaSplash,
						weight = 20,
					})
					AddColorsToPieceMix(goodBarrelMix, colors, {
						name = "V",
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 20,
					})
					AddColorsToPieceMix(goodBarrelMix, colors, {
						name = "H",
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 20,
					})
					AddColorsToPieceMix(goodBarrelMix, colors, {
						name = "HV",
						specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash,
						weight = 11,
					})
					AddColorsToPieceMix(goodBarrelMix, colors, {
						name = "HA",
						specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_AreaSplash,
						weight = 7,
					})
					AddColorsToPieceMix(goodBarrelMix, colors, {
						name = "VA",
						specials = CascadePieceSpecial_VerticalSplash | CascadePieceSpecial_AreaSplash,
						weight = 7,
					})
					AddColorsToPieceMix(goodBarrelMix, colors, {
						name = "HVA",
						specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash | CascadePieceSpecial_AreaSplash,
						weight = 3,
					})

					local bombColors = {1, 2, 3, 4, 5}

					--The bad barrel mix has cannonballs and bombs
					local badBarrelMix = {
						name = "BadBarrelMix",
						{
							name = "Cannonbomb",
							specials = CascadePieceSpecials_SteelBoulder,
							turnsToLoss = 8,
							weight = 7,
						}
					}

					AddColorsToPieceMix(badBarrelMix, bombColors, {
						name = "Bomb",
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					})

					return {goodBarrelMix, badBarrelMix}
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "Large 4,3",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
			additionalRegularPlacements = {
				{
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
					spawnTypes = {"GoodBarrelMix"},
					frequencies = {0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 2, 0, 2, 0, 2},
					--inactiveForInitialPlacement = true,
				},
				{
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
					spawnTypes = {"BadBarrelMix"},
					frequencies = {0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
					extraHits = 1,
					--inactiveForInitialPlacement = true,
				},
			},
			portals = ExecuteInline(
				function ()
					local portals = {}
					
					-- Portals make gem travel in a spiral shape
					for i = 0,2 do
						for r = 3-i, 4+i do
							portals[#portals+1] = {{2-i,r+1},{2-i,r},"PortalEntrance_1","PortalExit_1"}
						end

						for c = 2-i, 3+i do
							portals[#portals+1] = {{c+1,5+i},{c,5+i},"PortalEntrance_1","PortalExit_1"}
						end

						for c = 2-i, 2+i do
							portals[#portals+1] = {{c,3-i},{c+1,3-i},"PortalEntrance_1","PortalExit_1"}
						end
					end
					return portals
				end
			),
		},
		goals = {
			main = {"eatGem", 10, "Cannonball","Cannonballs", {specials = CascadePieceSpecials_SteelBoulder},},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",700000},
				[3] = {"score",1100000},
			},
		},
	},
	
	["CheckeredEaters"] = {
		levelName = "Deadly Orange",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasGemEaters = true,
			hasOranges = true,
			hasBombs = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "LargeRow_0",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 3,
				},
				{
					patternName = "LargeRow_1",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 3,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
				},
				{
					patternName = "LargeRow_2",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 3,
					applyGemEaterDelay = true,
					gemEaterDelay = 2,
				},
				{
					patternName = "LargeRow_3",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 3,
					applyGemEaterDelay = true,
					gemEaterDelay = 3,
				},
				{
					patternName = "LargeRow_7",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 3,
				},
				{
					patternName = "LargeRow_6",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 3,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
				},
				{
					patternName = "LargeRow_5",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 3,
					applyGemEaterDelay = true,
					gemEaterDelay = 2,
				},
				{
					patternName = "LargeRow_4",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 3,
					applyGemEaterDelay = true,
					gemEaterDelay = 3,
				},
			},
			additionalRegularPlacements = {
				{
					specials = CascadePieceSpecial_CantCover,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					turnsToLoss = 6,
					frequencies = {0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,},
					inactiveForInitialPlacement = true,
				}
			},
		},
		goals = {
			main = {"eatGem", 20, "Orange","Oranges", {specials = CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
	},

	
	
	["PirateBattle"] = {
		levelName = "Pirate Battle",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasGemEaters = true,
			hasBalloons = true,
			hasSteel = true,
			hasMakers = true,
			hasMissingReels = true,
			hasSteelBoulders = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			gemsMoveDiagonally = false,
			useMissingReels = true,
			missingReels = {
				patternName = "PirateBattle_Reels",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					local regularMix = {
						name = "RegularMix",
						{
							name = "Cannonball",
							matchFlags = 0,
							specials = CascadePieceSpecials_SteelBoulder,
							turnsToLoss = 5,
							weight = .5,
						},
					}

					local colors = {1, 2, 3, 4}

					AddColorsToPieceMix(regularMix, colors, {name = "Gem"})

					local balloonMix = {
						name = "BalloonMix",
						{
							name = "Cannonballoon",
							matchFlags = 0,
							specials = CascadePieceSpecials_SteelBoulder | CascadePieceSpecials_Balloon,
							cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
							turnsToLoss = 6,
							weight = 1.5,
						},
					}

					AddColorsToPieceMix(balloonMix, colors, {
						name = "Balloon",
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					})

					-- Used for additionalInitialPatterns, same as BalloonMix except without bombs
					local balloonMixStart = {name = "BalloonStartMix"}
					
					AddColorsToPieceMix(balloonMixStart, colors, {
						name = "Balloon",
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					})

					return {regularMix, balloonMix, balloonMixStart}
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "PirateBattle_GemEaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "PirateBattle_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "PirateBattle_DownMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"RegularMix"},
				},
				{
					patternName = "PirateBattle_UpMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"BalloonMix"},
				},
				{
					patternName = "PirateBattle_BalloonColumns",
					isPatternSet = false,
					replacePieces = {"BalloonStartMix"},
				},
			},
		},
		goals = {
			main = {"eatGem",20,"Cannonballoon","Cannonballoons", {cancelSpecials = CascadePieceSpecials_Balloon_Obstacle},}, -- Temporary name for a cannonball inside a balloon
			stars = {
				[1] = {"score",35000},
				[2] = {"score",60000},
				[3] = {"score",100000},
			},
		},
	},
	
	["LavaPiper"] = {
		levelName = "Hull Breached",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins3 = true,
			splashMode = true,
			gemTypes3 = true,
			largeBoard = true,
			hasLava = true,
			hasSteel = true,
			hasSteelGlass = true,
			hasBarrelsOfFun = true,
			hasStones = true,
			hasGemEaters = true,
			hasOrangeGems = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "LavaPiper_Reel",
				isPatternSet = false,
			},
			useSteelGlass = true,
			steelGlass = {
				patternName = "LavaPiper_Window",
				isPatternSet = false,
			},
			addToReelPieceMix = {
				{
					name = "BlueBarrel",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Barrels - CascadePieceSpecial_DontCountForMatchSize,
					spawnTypes = {"Stone"},
					weight = 5,
				},
				{
					name = "GreenBarrel",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Barrels - CascadePieceSpecial_DontCountForMatchSize,
					spawnTypes = {"Stone"},
					weight = 5,
				},
				{
					name = "PurpleBarrel",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Barrels - CascadePieceSpecial_DontCountForMatchSize,
					spawnTypes = {"Stone"},
					weight = 5,
				},
				--[[
				{
					name = "RedBarrel",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Barrels - CascadePieceSpecial_DontCountForMatchSize,
					spawnTypes = {"Stone"},
					weight = 5,
				},
				--]]
			},
			additionalNamedMixes = {
				{
					name = "Stone",
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LavaPiper_NoMatch1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				{
					patternName = "LavaPiper_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Large 7,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "TopCorners_large",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
			},
		},
		goals = {
			main = {"eatGem",1,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	--End Daniel Levels

	--Begin Randi Levels
	["Turnover"]={
		levelName = "Turnover",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,

			hasBarrels = true,
			hasGemEaters = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Piece1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 2.3,
				},
				{
					name = "Piece2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 2.3,
				},
				{
					name = "Piece3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 2.3,
				},
				{
					name = "Piece4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 2.3,
				},
				{
					name = "Boulder",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					weight = 1.3,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Turnover_GemEaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 1,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Piece1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Piece2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Piece3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
				},
			},
		},
		goals = {
			main = {"getGem",13,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels, extraHits = 0,},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",750000},
			},
		}, 
	},
	["EmptyTheTraps"] = {
		levelName = "Empty the Traps",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,

			hasGemEaters = true,
			hasSteelBoulders = true,
			hasInedibleGems = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "EmptyTheTraps_GemEaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				{
					patternName = "EmptyTheTraps_InitialInedibles",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Inedible_Bar,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					filter = {specials = 0,},
				},
				{
					patternName = "EmptyTheTraps_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Inedibles",},
				},
			},
			additionalNamedPatterns = {
				{
					entryName = "Inedibles",
					patternName = "EmptyTheTraps_GemEaters",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Inedible_Bar,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					filter = {specials = 0,},
				},
			},
			additionalNamedMixes = {
				{
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"Toggle1"},
						weight = 1,
						matchPatterns = {"Inedibles",},
					},
				},
			},
			addToBoardPieceMix = {
				{
					name = "SteelBoulders",
					specials = CascadePieceSpecials_SteelBoulder,
					matchFlags = 0,
					weight = 2,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Piece1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Piece2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Piece3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Piece4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
		},
		goals = {
			main = {"eatGem",9,"Cannonball", "Cannonballs", {specials = CascadePieceSpecials_SteelBoulder, cancelSpecials=0,},},
			stars = {
				[1]={"score",25000},
				[2]={"score",100000},
				[3]={"score",500000},
			},
		},
	},
	["BombOrBooty"]={
		levelName = "Bomb Or Booty",
		resource = "GameScreen_Land34",
		Features = {
			regularBoard = true,
			splashMode = true,
			gemTypes4 = true,
			modeSpins4 = true,
			hasBarrelsOfFun = true,
			hasBombs = true,
			hasChests = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "BombMix",
					{
						name = "P1",
						turnsToLoss = 10,
						matchFlags = CascadeMatchFlags_CommonPiece1, --is there a good way to get a random color instead of setting matchFlags
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						weight = 1,
					},
					{
						name = "P2",
						turnsToLoss = 10,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						weight = 1,
					},
					{
						name = "P3",
						turnsToLoss = 10,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						weight = 1,
					},
					{
						name = "P4",
						turnsToLoss = 10,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						weight = 1,
					},
				},
				{
					name = "ChestMix",
					{
						specials = CascadePieceSpecials_Treasure,
						matchFlags = 0,
						weight = 1,
					},
				},
			},	
			boardPieceMix = {
				{
					name = "Piece1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 2,
				},
				{
					name = "Piece2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 2,
				},
				{
					name = "Piece3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 2,
				},
				{
					name = "Piece4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 2,
				},
				{
					name = "BombBarrel1",
					specials = CascadePieceSpecials_ColorBarrels,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					spawnTypes = {"BombMix",},
					weight = .1,
				},
				{
					name = "BombBarrel2",
					specials = CascadePieceSpecials_ColorBarrels,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					spawnTypes = {"BombMix",},
					weight = .1,
				},
				{
					name = "BombBarrel3",
					specials = CascadePieceSpecials_ColorBarrels,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					spawnTypes = {"BombMix",},
					weight = .1,
				},
				{
					name = "BombBarrel4",
					specials = CascadePieceSpecials_ColorBarrels,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					spawnTypes = {"BombMix",},
					weight = .1,
				},
				{
					name = "ChestBarrel1",
					specials = CascadePieceSpecials_ColorBarrels,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					spawnTypes = {"ChestMix",},
					weight = .075,
				},
				{
					name = "ChestBarrel2",
					specials = CascadePieceSpecials_ColorBarrels,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					spawnTypes = {"ChestMix",},
					weight = .075,
				},
				{
					name = "ChestBarrel3",
					specials = CascadePieceSpecials_ColorBarrels,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					spawnTypes = {"ChestMix",},
					weight = .075,
				},
				{
					name = "ChestBarrel4",
					specials = CascadePieceSpecials_ColorBarrels,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					spawnTypes = {"ChestMix",},
					weight = .075,
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest", "Chests", {specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score", 80000},
				[2] = {"score", 600000},
				[3] = {"score", 1000000},
			},
		},
	},
	["PlunderingRings"]={
		levelName = "Plundering Rings",
		resource = "GameScreen_Land34",
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins3 = true,
			gemTypes4 = true,

			hasGemEaters = true,
			hasMarkedGems = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			addToBoardPieceMix = {
				name = "Rings",
				{
					name = "P1",
					icon = "Icon_Marked",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "P2",
					icon = "Icon_Marked",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "P3",
					icon = "Icon_Marked",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "P4",
					icon = "Icon_Marked",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				--gemEater set up here
				{
					patternName = "PlunderingRings_GemEater1",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown =1,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
				},
				{
					patternName = "PlunderingRings_GemEater2",
					isPatternset = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 1,
				},		
			},
		},
		goals = {
			main = {"eatGem", 25, "Ring", "Rings", {icon = "Icon_Marked"}},
			stars = {
				[1]={"score", 100000},
				[2]={"score", 600000},
				[3]={"score", 880000},
			},
		},
	},
	["DropTheAnchor"]={
		levelName = "Drop The Anchor",
		resource = "GameScreen_Land34",
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins3 = true,
			gemTypes5 = true,
			hasFences = true,
			hasSwitches = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalNamedMixes = { ---consider removing the middle reel spot, would create a better balance between start, mid, and end game play -Randi
				{
					name = "switch2",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch3"},
						matchPatterns = {"stage3", "removeStage2",},
						weight = 1,
					},
				},
				{
					name = "switch3",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch4"},
						matchPatterns = {"stage4","removeStage3",},
						weight = 1,
					},
				},
				{
					name = "switch4",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch5"},
						matchPatterns = {"stage5","removeStage4",},
						weight = 1,
					},
				},
				{
					name = "switch5",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch6"},
						matchPatterns = {"stage6","removeStage5",},
						weight = 1,
					},
				},
				{
					name = "switch6",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch7"},
						matchPatterns = {"stage7","removeStage6",},
						weight = 1,
					},
				},
				{
					name = "switch7",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch8"},
						matchPatterns = {"stage8","removeStage7",},
						weight = 1,
					},
				},
				{
					name = "switch8",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch9"},
						matchPatterns = {"stage9","removeStage8",},
						weight = 1,
					},
				},
				{
					name = "switch9",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch9"},
						matchPatterns = {"stage9"},
						weight = 1,
					},
				},
			},
			additionalNamedPatterns={
				{
					entryName = "stage2",
					patternName = "DropTheAnchor_stage2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "removeStage1",
					patternName = "DropTheAnchor_removeStage1",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "stage3",
					patternName = "DropTheAnchor_stage3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "removeStage2",
					patternName = "DropTheAnchor_removeStage2",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "stage4",
					patternName = "DropTheAnchor_stage4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "removeStage3",
					patternName = "DropTheAnchor_removeStage3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "stage5",
					patternName = "DropTheAnchor_stage5",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "removeStage4",
					patternName = "DropTheAnchor_removeStage4",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "stage6",
					patternName = "DropTheAnchor_stage6",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "removeStage5",
					patternName = "DropTheAnchor_removeStage5",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "stage7",
					patternName = "DropTheAnchor_stage7",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "removeStage6",
					patternName = "DropTheAnchor_removeStage6",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "stage8",
					patternName = "DropTheAnchor_stage8",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "removeStage7",
					patternName = "DropTheAnchor_stage7",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "stage9",
					patternName = "DropTheAnchor_stage9",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "removeStage8",
					patternName = "DropTheAnchor_stage8",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "DropTheAnchor_stage1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "DropTheAnchor_switch",
					isPatternSet = false,
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"switch2"},
					applyMatchPatterns = true,
					matchPatterns = {"stage2","removeStage1"},
				},
				{
					patternName = "DropTheAnchor_AreaBurst",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_AreaSplash,
				},
			},
			endGameProperties={
				boardPieceMix = {
					{
						name = "p1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "p2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "p3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "p4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},	
			},
		},
		goals = {
			main = {"gemsRemain", 0, "Fence", "Fences",{specials = CascadePieceSpecials_Fence,},"Drop"},
			stars = {
				[1] ={"score",30000},
				[2] ={"score",50000},
				[3] ={"score",300000},
			},
		},
	},
	["LavaLevel"] = {
		levelName = "Fire in the Hole",
		resource = "GameScreen_Land34",
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins10 = true,
			gemTypes4 = true, --originally built with 5 gems but it seemed too hard
			hasGemEaters = true,
			hasLava = true,
			hasBarrels = true,
			hasSwitches = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "switch1",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch1"},
						matchPatterns = {"resetLava","switch1_Boulders",},
						weight = 1,
					},
				},
				{
					name = "switch2",
					{
						name = "switch",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"switch1"},
						matchPatterns = {"resetLava","switch2_Boulders",},
						weight = 1,
					},
				},
			},
			additionalNamedPatterns = {
				{
					entryName = "clearTraps",
					patternName = "LavaLevel_GemEater",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "resetLava",
					patternName = "LavaLevel_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				{
					entryName = "switch1_Boulders",
					patternName = "LavaLevel_Boulders1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					entryName = "switch2_Boulders",
					patternName = "LavaLevel_Boulders2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LavaLevel_GemEater",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 0,
				},
				{
					patternName = "LavaLevel_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "LavaLevel_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"switch1"},
					applyMatchPatterns = true,
					matchPatterns = {"resetLava","switch1_Boulders",},
				},
				{
					patternName = "LavaLevel_Switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"switch2"},
					applyMatchPatterns = true,
					matchPatterns = {"resetLava","switch2_Boulders",},-- turn off the switches in the end game properties
				},
			},
			endGameProperties= {
				additionalNamedMixes = {
					{
						name = "switch1",
						delay = -1,
					},
					{
						name = "switch2",
						delay  = -1,
					},
				},
			},
		},
		goals = {
			main = {"eatGem", 7,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels},},
			stars = {
				[1] = {"score", 500000},
				[2] = {"score", 600000},
				[3] = {"score", 850000},
			},
		},
	}, 
	--End Randi Levels
	--Begin Brooke Levels
	["SharkBait"] = {
		levelName = "Shark Bait",
		resource = "GameScreen_Land34",  
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins5 = true, 
			gemTypes5 = true,
			hasGemEaters = true,
			hasStones = true,
			hasChests = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalRegularPlacements = {
				--Chests 
				{
					name = "Chest",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					frequencies = {1,1},
				},
			},
			additionalInitialPatterns = { 
				--Gem Eaters
				{
					patternName = "SharkBait_GemEaters1",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 2,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 2,
				},
				{
					patternName = "SharkBait_GemEaters2",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 2,
				},
				{
					patternName = "SharkBait_GemEaters3",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 0,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 2,
				},
				--Stones
				{
					patternName = "SharkBait_Stones1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "SharkBait_Stones2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},      
		goals = {
			main = {"getGem", 4, "Chest", "Chests", {specials = CascadePieceSpecials_Treasure}, "Drop"},
			stars = {
				[1] = {"score",90000},
				[2] = {"score",150000},
				[3] = {"score",200000},
			},
		},
	},

	--side level
	["FeedingTime"] = {
		levelName = "Jolly Roger",
		resource = "GameScreen_Land34",  
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins6 = true, 
			gemTypes5 = true,
			hasGemEaters = true,
			hasMissingSquares = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "FeedingTime_Missing",
				isPatternSet = false,
			},
			boardPieceMix = {
				{
					name = "Piece1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 2.4,
				},
				{
					name = "Piece2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 2.4,
				},
				{
					name = "Piece3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 2.4,
				},
				{
					name = "Piece4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 2.4,
				},
				{
					name = "Piece5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 2.4,
				},
				{
					name = "Piece1 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 0.85,
				},
				{
					name = "Piece2 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 0.85,
				},
				{
					name = "Piece3 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 0.85,
				},
				{
					name = "Piece4 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 0.85,
				},
				{
					name = "Piece5 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 0.85,
				},
			},
			additionalInitialPatterns = {
				--Gem Eaters 
				{
					patternName = "FeedingTime_GemEaters1",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 1,
				},
				{
					patternName = "FeedingTime_GemEaters2",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 0,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 1,
				},
				{
					patternName = "FeedingTime_InedibleGems",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Inedible_Bar,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Piece1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Piece2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Piece3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Piece4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Piece5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
		},      
		goals = {
			main = {"eatGem", 65, "Gem", "Gems", 
				{
					{matchFlags = CascadeMatchFlags_CommonPiece1},
					{matchFlags = CascadeMatchFlags_CommonPiece2},
					{matchFlags = CascadeMatchFlags_CommonPiece3},
					{matchFlags = CascadeMatchFlags_CommonPiece4},
					{matchFlags = CascadeMatchFlags_CommonPiece5},
					{matchFlags = CascadeMatchFlags_Wildcard},
					{matchFlags = CascadeMatchFlags_Wildcard, specials = CascadePieceSpecial_ClearKeyColorOnMatch},
				}, 
			},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",45000},
				[3] = {"score",200000},
			},
		},
	},
	
	["Goldfishing"] = {
		levelName = "Goldfishing",
		resource = "GameScreen_Land34",  
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins3 = true, 
			gemTypes3 = true,
			hasLasers = true,
			hasMakers = true,
			hasPortals = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasOrangeGems = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "Goldfishing_Reels",
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "Goldfishing_Missing",
				isPatternSet = false,
			},
			--alternate between 2 normal gems and 1 orange
			additionalNamedMixes = {
				[1] = {
					name = "Oranges",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Normals",
							reset = true,
						},
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[2] = {
					name = "Normals",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = 0,
							targetMix = "Oranges",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
				},
				[3] = {
					name = "LaserV",
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV"},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV"},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				--Maker
				{
					patternName = "Goldfishing_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Oranges", "Normals",},
				},
				--Orange Gems
				{
					patternName = "Goldfishing_Oranges",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				--Lasers
				{
					patternName = "Goldfishing_Laser1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applySpawnTypes = true,
					spawnTypes = {"LaserV"},
				},
				{
					patternName = "Goldfishing_Laser2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applySpawnTypes = true,
					spawnTypes = {"LaserV"},
				},
			},
			portals = {
				[1] = {{0,6},{2,5},"PortalEntrance_1","PortalExit_1"},
				[2] = {{2,6},{4,5},"PortalEntrance_1","PortalExit_1"},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						{
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							skinVariant = "LaserV",
							weight = 1,
						}
					},
				},
			},
		},      
		goals = {
			main = {"getGem", 30, "Orange", "Oranges", {matchFlags = CascadeMatchFlags_CommonPiece6}, "Clear"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
	},

	--side level
	["FaultySieve"] = {
		levelName = "Faulty Sieve",
		resource = "GameScreen_Land34",  
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins4 = true, 
			gemTypes4 = true,
			hasSteel = true,
			hasBarrels = true,
			hasGemEaters = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			addToBoardPieceMix = {
				{
					name = "Piece1",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 6,
				},
				{
					name = "Piece2",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					extraHits = 1,
					weight = 4,
				},
				{
					name = "Piece3",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					turnsToLoss = 5,
					weight = 3,
				},
			},
			additionalNamedMixes = {
				{
					name = "NormalMix",
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				-- Clear Boulders and bombs
				{
					patternName = "FullBoardLarge",
					isPatternSet = false,
					replacePieces = {"NormalMix"},
				},
				-- Gem eaters
				{
					patternName = "FaultySieve_Eaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 1,
				},
				-- Steel
				{
					patternName = "FaultySieve_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
			},
		},      
		goals = {
			main = {"eatGem", 20, "Boulder", "Boulders", {specials = CascadePieceSpecials_Barrels, extraHits = 0,},},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
	},
	--End Brooke Levels
	--Begin Josh Levels
	["CannonBall"] = {
	    levelName = "Cannonball Run",
	    resource = "GameScreen_Land34",  
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins8 = true, 
	        gemTypes5 = true,
	
	        hasSteelBoulders = true,
			hasInedibleGems = true,
			hasPortals = true,
			hasGemEaters = true,
			hasMakers = true,
			hasBombs = true,
	    },
	    tricks = World34Tricks,
	    boosts = World34Boosts,
	    Properties = {
			portals = {
				[1] = {{0,7}, {1,0}, "PortalEntrance_1", "PortalExit_1",},
				[2] = {{1,7}, {2,0}, "PortalEntrance_1", "PortalExit_1",},
				[3] = {{6,7}, {5,0}, "PortalEntrance_1", "PortalExit_1",},
				[4] = {{5,7}, {4,0}, "PortalEntrance_1", "PortalExit_1",},

			},
			additionalNamedMixes = {
				{
					name = "CannonBallMix",
					delay = 0,
					events = {
						[1] = {
							eventType = "population",
							comparator = "less", 
							count = 5,
							gemType = {
								specials = CascadePieceSpecials_SteelBoulder,
							},
							newDelay = 0,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							reset = true,
							newDelay = -1,
						},
					},
					{
						name = "Cannon Ball",
						specials = CascadePieceSpecials_SteelBoulder,
						turnsToLoss = 12,
						matchFlags = 0,
						weight = 1,
					},
				},
				{
					name = "NormalMix",
					delay = 0,
					{
						name = "Blue Gems",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 10,
					},
					{
						name = "Green Gems",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 10,
					},
					{
						name = "Purple Gems",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 10,
					},
					{
						name = "Red Gems",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 10,
					},
					{
						name = "Steel Blue Gems",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
						weight = 2,
					},
					{
						name = "Steel Green Gems",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
						weight = 2,
					},
					{
						name = "Steel Purple Gems",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
						weight = 2,
					},
					{
						name = "Steel Red Gems",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
						weight = 2,
					},
				},
			},
	        additionalInitialPatterns = { 
	            --Makers
				{
	                patternName = "CannonBall_Makers",
	                isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"CannonBallMix", "NormalMix"},
	            },
				--Gem eaters
				{
					patternName = "CannonBall_GemEaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 0,
					applyGemEaterDelay = true,
					gemEaterDelay = 0,
				},
	        },
	    },      
	    goals = {
	        main = {"eatGem", 12, "Cannonball", "Cannonballs", {specials = CascadePieceSpecials_SteelBoulder,},},
	        stars = {
	            [1] = {"score",300000},
	            [2] = {"score",400000},
	            [3] = {"score",500000},
	        },
	    },
	},
	["HungryChest"] = {
	    levelName = "Hungry Chests",
	    resource = "GameScreen_Land34",  
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins4 = true, 
	        gemTypes3 = true,
	
	        hasMakers = true,
			hasFences = true,
			hasChests = true,
			hasInedibleGems = true,
			hasGemEaters = true,
			hasSteel = true,
			hasMissingReels = true,
	    },
	    tricks = World34Tricks,
	    boosts = World34Boosts,
	    Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "HungryChest_MissingReel",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "SteelGemMix",
					delay = 0,
					{
						name = "Steel Blue Gems",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
						weight = 2,
					},
					{
						name = "Steel Green Gems",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
						weight = 2,
					},
					{
						name = "Steel Purple Gems",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
						weight = 2,
					},
					{
						name = "Steel Red Gems",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Inedible_Bar,
						cancelSpecials = CascadePieceSpecials_Inedible_Bar,
						weight = 2,
					},
				},
				{
					name = "TreasureMix",
					delay = 0,
					events = {
						[1] = {
							eventType = "population",
							comparator = "less",
							count = 2,
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
							newDelay = 0,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							reset = true,
							newDelay = -1,
						},
					},
					{
						name = "Treasure Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
			},
			addToReelPieceMix = {
				{
					name = "BlueBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1.8,
				},
				{
					name = "GreenBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1.8,
				},
				{
					name = "PurpleBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1.8,
				},
			},
	        additionalInitialPatterns = { 
	            --Gem Eaters
				{
	                patternName = "HungryChest_GemEaters",
	                isPatternSet = false,
	                applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 0,
					applyGemEaterDelay = true,
					gemEaterDelay =1,
	            },
				--Fences
				{
					patternName = "HungryChest_Fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Makers
				{
	                patternName = "CannonBall_Makers",
	                isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"TreasureMix","SteelGemMix"},
				},
				--Steel Gem
				{
					patternName = "HungryChest_SteelGems",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Inedible_Bar,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
				},
				--Steel
				{
					patternName = "HungryChest_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
	    },      
	    goals = {
	        main = {"eatGem", 4, "Chest", "Chests", {specials = CascadePieceSpecials_Treasure,},},
	        stars = {
	            [1] = {"score",500000},
	            [2] = {"score",670000},
	            [3] = {"score",1000000},
	        },
	    },
	},
	["XSpot"] = {
	    levelName = "X Marks the Spot",
	    resource = "GameScreen_Land34",  
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins10 = true, 
	        gemTypes4 = true,
	
			hasCrates = true,
	        hasStones = true,
			hasBarrels = true,
			hasBarrelsOfFun = true,
			hasChests = true,
			hasAmber = true,
			hasColoredKeyGems = true,
			hasBedRock = true,
	    },
	    tricks = World34Tricks,
	    boosts = World34Boosts,
	    Properties = {
			additionalNamedPatterns = {
				{
					entryName = "Remove Wall Blue",
					patternName = "XSpot_BlueBedRock",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Wall Green",
					patternName = "XSpot_GreenBedRock",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Wall Purple",
					patternName = "XSpot_PurpleBedRock",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Remove Wall Red",
					patternName = "XSpot_RedBedRock",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalNamedMixes = {
				{
					name = "BluePickaxeMix",
					delay = 0,
					{
						name = "Pickaxe",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"Remove Wall Blue"},
						weight = 1,
					},
				},
				{
					name = "GreenPickaxeMix",
					delay = 0,
					{
						name = "Pickaxe",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"Remove Wall Green"},
						weight = 1,
					},
				},
				{
					name = "PurplePickaxeMix",
					delay = 0,
					{
						name = "Pickaxe",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"Remove Wall Purple"},
						weight = 1,
					},
				},
				{
					name = "RedPickaxeMix",
					delay = 0,
					{
						name = "Pickaxe",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"Remove Wall Red"},
						weight = 1,
					},
				},
			},
			multiplyReelPieceMix = {
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 2,
				},
			},
	        additionalInitialPatterns = { 
				--Amber Treasure
	            {
	                patternName = "XSpot_AmberTreasure",
	                isPatternSet = false,
	                applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure | CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber_treasure,
	            },
				--Pickaxe
				{
						patternName = "XSpot_BluePickaxeBarrel",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = 0,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Barrels,
						applySpawnTypes = true,
						spawnTypes = {"BluePickaxeMix"},
				},
				--Blue Bedrock
				{
					patternName = "XSpot_BlueBedRock",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				--Red Pickaxe Barrel
				{
						patternName = "XSpot_RedPickaxeBarrel",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = 0,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Barrels,
						applySpawnTypes = true,
						spawnTypes = {"RedPickaxeMix"},
				},
				--Red Bedrock
				{
					patternName = "XSpot_RedBedRock",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemRed",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				--Green Pickaxe Barrel
				{
						patternName = "XSpot_GreenPickaxeBarrel",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = 0,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Barrels,
						applySpawnTypes = true,
						spawnTypes = {"GreenPickaxeMix"},
				},
				--Green Bedrock
				{
					patternName = "XSpot_GreenBedRock",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				--Purple Pickaxe Barrel
				{
						patternName = "XSpot_PurplePickaxeBarrel",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = 0,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Barrels,
						applySpawnTypes = true,
						spawnTypes = {"PurplePickaxeMix"},
				},
				--Purple Bedrock
				{
					patternName = "XSpot_PurpleBedRock",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				--Crates
				{
					patternName = "XSpot_Crates",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
				},
				--Stones
				{
					patternName = "XSpot_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant =true,
					skinVariant = "Stone",
				},
				--Boulders
				{
					patternName = "XSpot_Boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Clear Pieces
				{
					patternName = "XSpot_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
	        },
	    },      
	    goals = {
	        main = {"getGem",1, "Chest", "Chests", {specials = CascadePieceSpecials_Treasure,},},
	        stars = {
	            [1] = {"score",180000},
	            [2] = {"score",500000},
	            [3] = {"score",1200000},
	        },
	    },
	},
	["ClearPath"] = {
	    levelName = "Clearing The Path",
	    resource = "GameScreen_Land34",  
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins3 = true, 
	        gemTypes4 = true,
	
	        hasVines = true,
			hasBombs = true,
			hasGemEaters = true,
			hasSteelBoulders = true,
	    },
	    tricks = World34Tricks,
	    boosts = World34Boosts,
	    Properties = {
	        additionalInitialPatterns = { 
				--Vines
	            {
	                patternName = "ClearPath_Vines",
	                isPatternSet = false,
	                applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
	            },
				--Steel Boulders
				{
					patternName = "ClearPath_SteelBoulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_SteelBoulder | CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = true,
					turnsToLoss = 40,
				},
				--Gem Eaters
				{
					patternName = "ClearPath_GemEaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
	        },
	    },      
	    goals = {
	        main = {"eatGem",5, "Bomb", "Bombs", {turnsToLoss = true},},
	        stars = {
	            [1] = {"score",100000},
	            [2] = {"score",300000},
	            [3] = {"score",500000},
	        },
	    },
	},
	["SaveTheBooty"] = {
	    levelName = "Save The Booty",
	    resource = "GameScreen_Land34",  
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins6 = true, 
	        gemTypes4 = true,

			hasBalloons = true,
			hasOrangeGems = true,
			hasMakers = true,
			hasBombs = true,
			hasSteel = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasGemEaters = true,
			hasSteelBoulders = true,
	    },
	    tricks = World34Tricks,
	    boosts = World34Boosts,
	    Properties = {
			gemsMoveDiagonally = false,
			useMissingSquares = true,
			missingSquares = {
				patternName = "SaveTheBooty_MissingSquares",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "SaveTheBooty_MissingReels",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "OrangeBalloonMix",
					delay = 0,
					events = {
						[1]= {
							eventType = "population",
							comparator = "less",
							count = 3,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece6,
							},
							newDelay = 0,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = true,
						},
					},
					{
						name ="Orange Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials =CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
				},
				{
					name = "NormalBalloonMix",
					delay = 0,
					{
						name ="Blue Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials =CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
					{
						name ="Green Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials =CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
					{
						name ="Red Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials =CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
					{
						name ="Purple Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials =CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 1,
					},
					--{
					--	name ="Yellow Balloon",
					--	matchFlags = CascadeMatchFlags_CommonPiece5,
					--	specials =CascadePieceSpecials_Balloon,
					--	cancelSpecials = CascadePieceSpecials_Balloon,
					--	weight = 1,
					--},
				},
				{
					name = "BurstMix",
					delay = -1,
					events = {
						[1] = {
							eventType = "population",
							comparator = "less",
							count = 6,
							gemType = {
								specials = CascadePieceSpecial_HorizontalSplash,
							},
							newDelay = 0,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							reset = true,
							newDelay = -1,
						},
					},
					{
						name = "BlueBurstH",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "GreenBurstH",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "PurpleBurstH",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "RedBurstH",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					--{
					--	name = "YellowBurstH",
					--	matchFlags = CascadeMatchFlags_CommonPiece5,
					--	specials = CascadePieceSpecial_HorizontalSplash,
					--	weight = 1,
					--},
					{
						name = "WildBurstH",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1.5,
					}
				},
				{
					name = "NormalMix",
					delay = 0,
					{
						name = "Blue gem",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green gem",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple gem",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red gem",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					--{
					--	name = "yellow gem",
					--	matchFlags = CascadeMatchFlags_CommonPiece5,
					--	weight = 1,
					--},
				},
			},
			additionalInitialPatterns = {
				--Makers
				{
					patternName = "SaveTheBooty_Makers1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"OrangeBalloonMix", "NormalBalloonMix"},
				},
				{
					patternName = "SaveTheBooty_Makers2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"BurstMix", "NormalMix"},
				},
				--Balloons
				{
					patternName = "SaveTheBooty_Balloons",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				--Gem eaters
				{
					patternName = "SaveTheBooty_GemEaters1",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 4,
					applyGemEaterDelay = true,
					gemEaterDelay = 4,
				},
				{
					patternName = "SaveTheBooty_GemEaters2",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 1,
					applyGemEaterDelay = true,
					gemEaterDelay = 2,
				},
				{
					patternName = "SaveTheBooty_GemEaters3",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 0,
					applyGemEaterDelay = true,
					gemEaterDelay = 0,
				},
				{
					patternName = "SaveTheBooty_GemEaters4",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 4,
					applyGemEaterDelay = true,
					gemEaterDelay = 5,
				},
				{
					patternName = "SaveTheBooty_GemEaters5",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 4,
					applyGemEaterDelay = true,
					gemEaterDelay = 6,
				},
				--oranges
				{
					patternName = "SaveTheBooty_Oranges",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				--Bursts
				{
					patternName = "SaveTheBooty_Bursts",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				--Steel
				{
					patternName = "SaveTheBooty_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
			},
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					specials = CascadePieceSpecials_SteelBoulder,
					turnsToLoss = 5,
					frequencies = {1,0,1,1,3,4,7},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "BurstMix",
						delay = -1,
					},
				},
			},
	    },      
	    goals = {
	        main = {"getGem",4, "Orange", "Oranges", {matchFlags = CascadeMatchFlags_CommonPiece6, specials = 0,},"Clear",},
	        stars = {
	            [1] = {"score",400000},
	            [2] = {"score",700000},
	            [3] = {"score",2250000},
	        },
	    },
	},
	["TidalWave"] = {
	    levelName = "Tidal Wave",
	    resource = "GameScreen_Land34",  
	    Features = {
	        regularBoard = true,
	        splashMode = true,
	        modeSpins6 = true, 
	        gemTypes5 = true,
	
	        hasGemEaters = true,
			hasCoconuts = true,
			hasMakers = true,
	    },
	    tricks = World34Tricks,
	    boosts = World34Boosts,
	    Properties = {
			spawnGemOnBreak = {
				{
					name = "BlueBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "GreenBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "PurpleBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "RedBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "YellowBurstH",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
			},
	        additionalInitialPatterns = {
				--Gem Eaters
				{
					patternName = "TidalWave_GemEaters1",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 8,
					applyGemEaterDelay = true,
					gemEaterDelay = 0,
				},
				{
					patternName = "TidalWave_GemEaters2",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 8,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
				},
				{
					patternName = "TidalWave_GemEaters3",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 8,
					applyGemEaterDelay = true,
					gemEaterDelay = 2,
				},
				{
					patternName = "TidalWave_GemEaters4",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 8,
					applyGemEaterDelay = true,
					gemEaterDelay = 3,
				},
				{
					patternName = "TidalWave_GemEaters5",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 8,
					applyGemEaterDelay = true,
					gemEaterDelay = 4,
				},
				{
					patternName = "TidalWave_GemEaters6",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 8,
					applyGemEaterDelay = true,
					gemEaterDelay = 5,
				},
	        },
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
					frequencies = {0, 0, 0, 0, 1, 2, 3, 4},
					inactiveForInitialPlacement = true,
				},
			},
	    },      
	    goals = {
	        main = {"getGem",10, "Coconut", "Coconuts", {specials = CascadePieceSpecials_Coconut,}, "Drop"},
	        stars = {
	            [1] = {"score",50000},
	            [2] = {"score",100000},
	            [3] = {"score",200000},
	        },
	    },
	},
	["DavyJones"] = {
		levelName = "Davy Jones' Locker",
		resource = "GameScreen_34",
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins4 = true,
			gemTypes4 = true,

			hasGemEaters = true,
			hasInedibleGems = true,
		},
		tricks = World34Tricks,
		boosts = World34Boosts,
		Properties = {
			additionalInitialPatterns = {
				--Gem eaters
				{
					patternName = "DavyJones_GemEaters1",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				{
					patternName = "DavyJones_GemEaters2",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				{
					patternName = "DavyJones_GemEaters3",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
			},
			additionalRegularPlacements = {
				{
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					frequencies = {0, 0, 1},
				}, 
				{
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					frequencies = {0, 0, 1},
				}, 
				{
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					frequencies = {0, 0, 1},
				}, 
				{
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					frequencies = {0, 0, 1},
				}, 
			},
		},
		goals = {
			main = {"eatGem", 150, "Gem", "Gems", {},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score", 100000},
				[3] = {"score", 200000},
			},
		},
	},
	["RisingTide"] = {
	    levelName = "Rising Tide",
	    resource = "GameScreen_Land34",  
	    Features = {
	        regularBoard = true,
	        splashMode = true,
	        modeSpins10 = true, 
	        gemTypes5 = true,
	
	        hasBarrelsOfFun = true,
			hasStones = true,
			hasJailedSquares = true,
			hasChests = true,
			hasGemEaters = true,
	    },
	    tricks = World34Tricks,
	    boosts = World34Boosts,
	    Properties = {
			additionalNamedMixes = {
				{
					name = "BarrelMix",
					delay = 0,
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 3.5,
					},
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						extraHits = 2,
						skinVariant = "Stone",
						weight = 3,
					},
					{
						name = "Blue jailed Gem",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Jailed,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = .5,
					},
					{
						name = "Green jailed Gem",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Jailed,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = .5,
					},
					{
						name = "Purple jailed Gem",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Jailed,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = .5,
					},
					{
						name = "Red jailed Gem",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Jailed,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = .5,
					},
					{
						name = "Yellow jailed Gem",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Jailed,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = .5,
					},
				},
			},
			addToBoardPieceMix = {
				{
					name = "Barrel",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					spawnTypes = {"BarrelMix"},
					weight = 6,
				},
			},
	        additionalInitialPatterns = { 
				--Gem Eaters
				{
					patternName = "RisingTide_GemEaters1",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 7,
					applyGemEaterDelay = true,
					gemEaterDelay = 0,
				},
				{
					patternName = "RisingTide_GemEaters2",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 7,
					applyGemEaterDelay = true,
					gemEaterDelay = 9,
				},
				{
					patternName = "RisingTide_GemEaters3",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 7,
					applyGemEaterDelay = true,
					gemEaterDelay = 18,
				},
				{
					patternName = "RisingTide_GemEaters4",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 7,
					applyGemEaterDelay = true,
					gemEaterDelay = 27,
				},
				{
					patternName = "RisingTide_GemEaters5",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 7,
					applyGemEaterDelay = true,
					gemEaterDelay = 36,
				},
				{
					patternName = "RisingTide_GemEaters6",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 7,
					applyGemEaterDelay = true,
					gemEaterDelay = 45,
				},
				{
					patternName = "RisingTide_GemEaters7",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 7,
					applyGemEaterDelay = true,
					gemEaterDelay = 54,
				},
	        },
	    },      
	    goals = {
	        main = {"getGem",10, "Chest", "Chests", {specials = CascadePieceSpecials_Treasure,}, "Open",},
	        stars = {
	            [1] = {"score",125000},
	            [2] = {"score",300000},
	            [3] = {"score",650000},
	        },
	    },
	},
	--End Josh Levels

    --Begin Roh levels
    ["GrapesOfWrath"] = {
        levelName = "Grapes of Wrath",
        resource = "GameScreen_Land34",  
        Features = {
            regularBoard = true,
            splashMode = true,
            modeSpins4 = true, 
            gemTypes5 = true,

            hasGemEaters = true,
        },
        tricks = World34Tricks,
        boosts = World34Boosts,
        Properties = {
            additionalInitialPatterns = { 
                --Gem Eaters
                {
                    patternName = "LowerLine1",
                    isPatternSet = false,
                    applyGemEater = true,
                    gemEater = true,
                    applyGemEaterCooldown = true,
                    gemEaterCooldown = 0,
                },
            },
        },      
        goals = {
            main = {"eatGem",50, "Purple", "Purples", {matchFlags = CascadeMatchFlags_CommonPiece3},},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",100000},
                [3] = {"score",200000},
            },
        },
    },
    ["CuckoooForCoconuts"] = {
        levelName = "Cuckoo for Coconuts",
        resource = "GameScreen_Land1",  
        Features = {
            largeBoard = true,
            splashMode = true,
            modeSpins8 = true, 
            gemTypes5 = true,

            hasGemEaters = true,
            hasSwitches = true,
            hasCoconuts = true,
            hasInedibleGems = true,
        },
        tricks = World34Tricks,
        boosts = World34Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "MakeCoconut",
                    patternName = "CuckoooForCoconuts_CoconutTarget",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Coconut,
					applyCancelSpecials = true,
					cancelSpecials = 0,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
                    addPieces = true,
                },
                {
                    entryName = "MakeInedible",
                    patternName = "CuckoooForCoconuts_InedibleTarget",
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Inedible_Bar,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					filter = {specials = 0},
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "Switch1_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"MakeCoconut"},
                        weight = 1,
                    },
                },
                {
                    name = "Toggle2",
                    delay = 0,
                    {
                        name = "Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "Switch1_Toggle",
                        spawnTypes = {"Toggle2"},
                        matchPatterns = {"MakeInedible"},
                        weight = 1,
                    },
                },
            },
            spawnGemOnBreak = {
                {
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1,
                },
                {
                    name = "Yellow",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1,
                },
            },
            additionalInitialPatterns = { 
                --Eaters
                {
                    patternName = "CuckoooForCoconuts_Eater2",
                    isPatternSet = false,
                    applyGemEater = true,
                    gemEater = true,
                    applyGemEaterCooldown = true,
                    gemEaterCooldown = 2,
                },
                {
                    patternName = "CuckoooForCoconuts_Eater1",
                    isPatternSet = false,
                    applyGemEater = true,
                    gemEater = true,
                },

                --Switch1 (Coconuts)
                {
                    patternName = "CuckoooForCoconuts_Switch1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeCoconut"},
                },

                --Switch2 (Inedible)
                {
                    patternName = "CuckoooForCoconuts_Switch2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeInedible"},
                },
            },
        },      
        goals = {
            main = {"eatGem",7, "Coconut", "Coconuts", {specials = CascadePieceSpecials_Coconut,},},
            stars = {
                [1] = {"score",90000},
                [2] = {"score",600000},
                [3] = {"score",1000000},
            },
        },
    },
    --End Roh levels
})