-- Land 4: jails

table.insertall(LevelDefs,
{

	["GemJail1"] = {
		levelName = "Break All",					
		resource = "GameScreen_Land4",		
		introScript = "Land4_Intro",
		Features = {
			hasJailedSquares = true,
			modeSpins9 = true, --already matched Operation Easy
			splashMode = true,
			gemTypes6 = true,
			regularBoard = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleBottom2",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",12,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["GemJailScore1"] = {
		levelName = "Break and Score",					
		resource = "GameScreen_Land4",		
		introScript = "Land4_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			modeSpins13 = true, --already matched Operation Easy
			hasJailedSquares = true,
			splashMode = true,
			hasCrates = true,
			regularBoard = true,
			gemTypes5 = true, 
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "ButterflyPattern1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "ButterflyPattern1_reverse",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",350000},
				[3] = {"score",400000},			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["GemJailScore2"] = {
		levelName = "Spots",					
		resource = "GameScreen_Land4",		
		Features = {
			hasJailedSquares = true,
			splashMode = true,
			modeSpins8 = true, --already matched Operation Easy
			hasCrates = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Spots1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Spots2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["GemJailScore3"] = {
		levelName = "Columns",					
		resource = "GameScreen_Land4",		
		Features = {
			modeSpins13 = true, --already matched Operation Easy
			hasJailedSquares = true,
			splashMode = true,
			hasCrates = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Columns",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Columns2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",800000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["GemJailScore4"] = {
		levelName = "Score Jail",					
		resource = "GameScreen_Land4",		
		Features = {
			modeSpins13 = true, --already matched Operation Easy
			hasJailedSquares = true,
			splashMode = true,
			hasCrates = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "InverseStair1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "InverseLine1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",600000},
				[3] = {"score",700000}, 
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["JailGate1"] = {
		levelName = "Jail Gate",					
		resource = "GameScreen_Land4",		
		Features = {
			modeSpins5 = true, --8 before Operation Easy (lowered)
			hasJailedSquares = true,
			hasCoverage = true,
			splashMode = true,
			hasMissingSquares = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "LittleMissingPattern2", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleCratePattern3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},

				[2] = {
					patternName = "LittleCratePattern3",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["JailDrop1"] = {
		levelName = "Jail Drop",					
		resource = "GameScreen_Land4",		
		Features = {
			modeSpins10 = true, --already matched Operation Easy
			hasJailedSquares = true,
			treasureChest = true,
			hasCrates = true,
			splashMode = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleBottom12",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "LittleBottom1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},
	["JailDrop2"] = {
		levelName = "Barriers",					
		resource = "GameScreen_Land4",		
		Features = {
			modeSpins10 = true, --already matched Operation Easy
			hasJailedSquares = true,
			treasureChest = true,
			hasCrates = true,
			splashMode = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "SideSpots1", 
				isPatternSet = false,
			},

			additionalInitialPatterns = {
				[1] = {
					patternName = "MiddleLine",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "TopAndBottom1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",150000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["JailDrop3"] = {
		levelName = "Jail Block",					
		resource = "GameScreen_Land4",	
		Features = {
			modeSpins13 = true, --already matched Operation Easy
			hasJailedSquares = true,
			treasureChest = true,
			hasCrates = true,
			splashMode = true,
			regularBoard = true,
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "TopBottomSpots1", 
				isPatternSet = false,
			},

			additionalInitialPatterns = {
				[1] = {
					patternName = "Blocks3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Blocks4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["JailDrop4"] = {
		levelName = "Meters",					
		resource = "GameScreen_Land4",	
		Features = {
			modeSpins13 = true, --already matched Operation Easy
			hasJailedSquares = true,
			treasureChest = true,
			hasCrates = true,
			splashMode = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			missingSquares = {
				patternName = "TopBottomSpots1", 
				isPatternSet = false,
			},

			additionalInitialPatterns = {
				[1] = {
					patternName = "Poles1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Poles2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["JailCoverage1"] = {
		levelName = "Jail Pattern",					
		resource = "GameScreen_Land4",		
		Features = {
			modeSpins11 = true, --already matched Operation Easy
			hasJailedSquares = true,
			hasCoverage = true,
			hasCrates = true,
			splashMode = true,
			regularBoard = true, 
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Sides1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Sides4",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},

				[2] = {
					patternName = "Sides4",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},

				[3] = {
					patternName = "MiddleLine",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["CustomColor1"] = {
		levelName = "Painted",					
		resource = "GameScreen_Land4",		
		Features = {
			hasCrates = true,
			hasCoverage = true,
			modeSpins8 = true, --already matched Operation Easy
			splashMode = true,
			hasJailedSquares = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "MiddleRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "InnerRing",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "MissingOuterCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
				[4] = {
					patternName = "OuterRing_topleftcorner",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[5] = {
					patternName = "OuterRing_toprightcorner",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[6] = { 
					patternName = "OuterRing_bottomleftcorner",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[7] = { 
					patternName = "OuterRing_bottomrightcorner",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score", 300000},
				[2] = {"score", 500000},
				[3] = {"score", 800000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["Continuation"] = {
		levelName = "The Biggest Spin",
		resource = "GameScreen_Land4",		
		Features = {
			splashMode = true,
			modeSpins1 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = {
			{name = Config.World4Tricks_Trick1},
			{name = Config.World4Tricks_Trick2},
			{name = Config.World4Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World4Boosts,
		Properties = {
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",4000000},
			},
		},
		expectedScore = 100000,
	},

	["ImpossibleColor_Updated"] = {
		levelName = "Impossible Color",
		introScript = "Land4_Tip2",
		resource = "GameScreen_Land4",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			hasJailedSquares = true,
			regularBoard = true,
			gemTypes5 = true,
			hasOrangeGems = true,
		},
		tricks = {
			{name = Config.TricksDefault_Trick1},
			{name = Config.TricksDefault_Trick2},
			{name = Config.TricksDefault_Trick3}, --was: TricksSpinNow_Trick3}
		},
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "RandomPositions",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
				[2] = {
					patternName = "RandomPositions_less",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",150000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000,
	},

	["ASplashOfGreatness"] = {
		levelName = "Burst of Greatness",
		resource = "GameScreen_Land4",		
		outtroScript = "Land4_Outtro",
		Features = {
			splashMode = true,
			modeSpins5 = true, --8 before Operation Easy (lowered)
			hasStones = true,
			hasCrates = true,
			hasCoverage = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					frequencies = {3,4,9,10,15,16,21,22},
				},
				[2] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					frequencies = {2,5,8,11,14,17,20,23},
				},
				[3] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					frequencies = {1,6,7,12,13,18,19,24},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "FullBoardSmall",
					isPatternSet = false,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "LowerLine2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "CrateBottomBlock1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",750000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["JailCoverage1_side"] = {
		levelName = "Side Jails",					
		resource = "GameScreen_Land4",		
		Features = {
			modeSpins9 = true,
			hasJailedSquares = true,
			hasCoverage = true,
			hasCrates = true,
			splashMode = true,
			regularBoard = true, 
			gemTypes5 = true,
			hasMissingSquares = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Sides1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Sides4",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Sides4",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},


	["CustomColor1_side"] = {
		levelName = "Color Corners",					
		resource = "GameScreen_Land4",		
		Features = {
			hasCrates = true,
			hasCoverage = true,
			modeSpins8 = true,
			splashMode = true,
			hasJailedSquares = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "MiddleRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "InnerRing",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				--[[
				[3] = {
					patternName = "MissingOuterCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 5,
					applyMatchRequirement = true,
				},
				]]
				[4] = {
					patternName = "OuterRing_topleftcorner",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[5] = {
					patternName = "OuterRing_toprightcorner",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[6] = { 
					patternName = "OuterRing_bottomleftcorner",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[7] = { 
					patternName = "OuterRing_bottomrightcorner",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score", 150000},
				[2] = {"score", 650000},
				[3] = {"score", 1000000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["GemJailScore4_side"] = {
		levelName = "Inverted Stair",					
		resource = "GameScreen_Land4",		
		Features = {
			modeSpins8 = true,
			hasJailedSquares = true,
			splashMode = true,
			hasCrates = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "InverseStair1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",500000}, 
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

    ["GemJail1_side"] = {
        levelName = "Solitary Confinement",                    
        resource = "GameScreen_Land4",
        Features = {
            modeSpins5 = true,
            splashMode = true,
            gemTypes5 = true,
            largeBoard = true,

            hasJailedSquares = true,
            hasCrates = true,
            hasBarrels = true,
            hasStones = true,
        },
        tricks = World4Tricks,
        boosts = World4Boosts,
        Properties = {
            additionalInitialPatterns = {
                [1] = {
                    patternName = "FlowerBuds",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    specials = CascadePieceSpecials_Jailed,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyCancelSpecials = true,
                },
                [3] = {
                    patternName = "EmptyFlowers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 1,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                    applyMatchRequirement = true,
                },
            },
        },
        goals = {
            main = {"getGem",3,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
            stars = {
                [1] = {"score",150000},
                [2] = {"score",300000},
                [3] = {"score",600000},
            },
        },
        expectedScore = 100000, --Uncomment to override expected high score calculations.
    },
})