-- Land 5: vines

table.insertall(LevelDefs,
{

	["VinesScore1"] = {
		levelName = "Vines",
		resource = "GameScreen_Land1",
		introScript = "Land5_Intro",
		Features = {
			splashMode = true,
			hasVines = true,
			modeSpins13 = true, --12 before Operation Easy
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BottomCorners",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",800000},
				[3] = {"score",1300000},
			},
		},
		expectedScore = 100000,
	},
	["VinesRemove1"] = {
		levelName = "Vines! Vines!",
		resource = "GameScreen_Land1",	
		introScript = "Land5_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			hasVines = true,
			hasCrates = true,
			modeSpins7 = true, --already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BottomCorners",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "AroundBottomCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "TopCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",250000},
				[3] = {"score",750000},
			},
		},
		expectedScore = 100000,
	},
	["VinesDrop1"] = {
		levelName = "Vine Drop",
		resource = "GameScreen_Land1",		
		introScript = "Land5_Tip2",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			treasureChest = true,
			hasVines = true,
			hasCrates = true,
			modeSpins11 = true, --10 before Operation Easy
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "TopCorners",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "AroundTopCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000,
	},
	["VinesPattern1"] = {
		levelName = "Vine Pattern",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			hasVines = true,
			hasCrates = true,
			modeSpins11 = true, --already matched Operation Easy
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleBottom1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "AboveLittleBottom1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "LittleBottom1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000,
	},
	["PyramidDrop"] = {
		levelName = "Pyramid Drop",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true, 
			hasChests = true, 
			hasStones = true, 
			hasCrates = true, 
		},
		tricks = TricksDefault,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "PyramidDrop_Crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[2] = {
					patternName = "PyramidDrop_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "PyramidDrop_Chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},
	["VinesDrop2"] = {
		levelName = "Vine Block",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			treasureChest = true,
			hasVines = true,
			modeSpins10 = true, --9 before Operation Easy
			hasCrates = true,
			regularBoard = true, --Changed Phelan
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "InnerSidePattern",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "DumbBellPattern",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["VinesPattern2_Updated"] = {
		levelName = "Creep Creep",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			hasCrates = true,
			hasVines = true,
			hasJailedSquares = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "MissingInnerCorners",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "MissingOuterCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "MissingCorners",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000,
	},

	["VinesRemove3"] = {
		levelName = "Vine Trouble",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasVines = true,
			hasCrates = true,
			hasStones = true,
			modeSpins10 = true, --9 before Operation Easy
			regularBoard = true,
			gemTypes5 = true, 
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "OuterBlock_bottomrightcorner_middle",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "OuterBlock_topleftcorner_middle",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[3] = {
					patternName = "OuterBlock_topleftcorner",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[4] = {
					patternName = "OuterBlock_bottomrightcorner",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000,
	},

	["VinesDrop3"] = {
		levelName = "Mine Shaft",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			treasureChest = true,
			hasVines = true,
			modeSpins5 = true, --7 before Operation Easy (lowered)
			hasCrates = true,
			hasStones = true,
			regularBoard = true, 
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BombVines1_inner",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Columns",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Columns2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",300000},
				[3] = {"score",350000},
			},
		},
		expectedScore = 100000,
	},

	["JailPairs"] = {
		levelName = "Jail Pairs",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			hasJailedSquares = true,
			modeSpins6 = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "JailPairs_Color1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[2] = {
					patternName = "JailPairs_Color2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = {
					patternName = "JailPairs_Color3",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[4] = {
					patternName = "JailPairs_Color4",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[5] = {
					patternName = "JailPairs_Color5",
					isPatternSet = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
			},
		},
		goals = {
			main = {"getGem",30,"Jail","Jails",{specials = CascadePieceSpecials_Jailed},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",400000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["VinesPattern3"] = {
		levelName = "Vine Horde",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			hasCrates = true,
			hasVines = true,
			largeBoard = true,
			modeSpins9 = true, --already matched Operation Easy
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BottomPileTop1_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines, 
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "BottomPile1_large",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "BottomPile1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["VinesDrop4"] = {
		levelName = "Treasure Shelves",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			treasureChest = true,
			hasVines = true,
			modeSpins13 = true, --12 before Operation Easy
			largeBoard = true,
			hasMissingSquares = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "UnderFloors2_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "UnderFloors1_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Floors1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["VinesPattern4"] = {
		levelName = "Vine Break",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			hasCrates = true,
			hasVines = true,
			hasJailedSquares = true,
			largeBoard = true,
			modeSpins7 = true, --already matched Operation Easy
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BottomJail1_Center_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "BottomJail1_Cover_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Dungeon4_jail1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[4] = {
					patternName = "BottomJail1_large",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",800000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000,
	},

	["VinesRemove5_Updated"] = {
		levelName = "Final Vine Battle",
		resource = "GameScreen_Land1",		
		outtroScript = "Land5_Outtro",
		Features = {
			splashMode = true,
			hasVines = true,
			largeBoard = true,
			modeSpins5 = true,
			gemTypes4 = true, 
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "VineBattle1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["EntrenchedVine_Updated"] = {
		levelName = "Entrenched Vines",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasVines = true,
			modeSpins5 = true,
			hasStones = true,
			regularBoard = true,
			gemTypes4 = true,
			hasMissingSquares = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "OuterCorners",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "MissingOuterCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},

	["VinesPattern4_side"] = {
		levelName = "Caged Vines",
		resource = "GameScreen_Land5",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			hasCrates = true,
			hasVines = true,
			hasJailedSquares = true,
			largeBoard = true,
			modeSpins9 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BottomJail1_Center_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Dungeon4_jail1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "BottomJail1_large",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",800000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000,
	},

	["VinesRemove5_Updated_side"] = {
		levelName = "Overgrown",
		resource = "GameScreen_Land5",
		Features = {
			splashMode = true,
			hasVines = true,
			regularBoard = true,
			modeSpins6 = true,
			gemTypes4 = true, 
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "VineBattleSmaller",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",700000},
			},
		},
		expectedScore = 100000,
	},

	["EntrenchedVine_Updated_side"] = {
		levelName = "Corner Vines",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasVines = true,
			modeSpins6 = true,
			hasStones = true,
			regularBoard = true,
			gemTypes4 = true,
			hasMissingSquares = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "IsolateCorners",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "MissingOuterCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

    ["VinesPattern1_side"] = {
        levelName = "Jungle Rock",
        resource = "GameScreen_Land1",      
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins8 = true,
            gemTypes4 = true,
            
            hasVines = true,
            hasCoverage = true,
            hasCrates = true,
        },
        tricks = TricksDefault,
        boosts = World5Boosts,
        Properties = {
            additionalInitialPatterns = {
                {
                    patternName = "VinesPattern1_side_vines",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_Vines,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                },
                {
                    patternName = "VinesPattern1_side_stones",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    patternName = "VinesPattern1_side_pattern",
                    isPatternSet = false,
                    matchRequirement = 2,
                    applyMatchRequirement = true,
                },
            },
        },
        goals = {
            main = {"patterns",0,},
            stars = {
                [1] = {"score",1000000},
                [2] = {"score",1400000},
                [3] = {"score",2000000},
            },
        },
        expectedScore = 1000000,
    },

})