-- Land 6: boulders

table.insertall(LevelDefs,
{

	["Barrels1"] = {
		levelName = "Boulder Fall",
		resource = "GameScreen_Land1",		
		introScript = "Land6_Intro",
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins8 = true, --7 before Operation Easy
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1},
				},
			},
		},
		goals = {
			main = {"getGem",30,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsPattern1"] = {
		levelName = "Boulder Pattern",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			hasCoverage = true,
			modeSpins8 = true, --already matched Operation Easy
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Stripes1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				[2] = {
					patternName = "Stripes1",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				}, 
				[3] = {
					patternName = "TopFunnel3_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[4] = {
					patternName = "TopFunnel3_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[5] = {
					patternName = "TopFunnel3_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[6] = {
					patternName = "TopFunnel3_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[7] = {
					patternName = "TopFunnel3_Color5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsDrop1"] = {
		levelName = "Boulder Drop",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			treasureChest = true,
			modeSpins9 = true, --already matched Operation Easy
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1},
				},
			},
			additionalInitialPatterns = {

			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["WaffleIron"] = {
		levelName = "Waffle Iron",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			hasMissingSquares = true,
			gemTypes3 = true,
			hasCoverage = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "WaffleIron_Missing", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "WaffleIron_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 4,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsPattern2"] = {
		levelName = "Rollin Rollin",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			hasCoverage = true,
			modeSpins8 = true, --7 before Operation Easy
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "RightShelves1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				[2] = {
					patternName = "RightShelves1",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",500000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsDrop2"] = {
		levelName = "Vine Boulder",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			treasureChest = true,
			hasVines = true,
			hasCrates = true,
			modeSpins8 = true, --already matched Operation Easy
			gemTypes5 = true, 
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BottomCenter1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "BottomCenterCover1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "BottomCenterSides2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsPattern3"] = {
		levelName = "Down Down",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			hasCoverage = true,
			modeSpins7 = true, --already matched Operation Easy
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1,1,1,1,1,1},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Stripe1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
                [2] = {
					patternName = "LeftPairs1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[3] = {
					patternName = "LeftPairs2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[4] = {
					patternName = "LeftPairs3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[5] = {
					patternName = "RightPairs1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[6] = {
					patternName = "RightPairs2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[7] = {
					patternName = "RightPairs3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsDrop3"] = {
		levelName = "Boulder Jail",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			treasureChest = true,
			hasJailedSquares = true,
			modeSpins8 = true, --10 before Operation Easy (lowered)
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "TopBlock1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
				},
				[2] = {
					patternName = "Line3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",350000},
				[3] = {"score",450000},
			},
		},
		expectedScore = 100000,
	},

	["Barrels4_Updated"] = {
		levelName = "Big Boulder",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins10 = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 11,
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TopBlock1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				[2] = {
					patternName = "BigBoulder_Color1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = 0,
				},
				[3] = {
					patternName = "BigBoulder_Color2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = 0,
				},
				[4] = {
					patternName = "BigBoulder_Color3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = 0,
				},
				[5] = {
					patternName = "BigBoulder_Color4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = 0,
				},
				[6] = {
					patternName = "BigBoulder_Color5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsDrop4"] = {
		levelName = "Big Boulder Jail",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			treasureChest = true,
			hasJailedSquares = true,
			largeBoard = true,
			modeSpins5  = true, --7 before Operation Easy (lowered)
			gemTypes5= true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Steps1Top_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
				},
				[2] = {
					patternName = "Steps1_large",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",160000},
				[3] = {"score",320000},
			},
		},
		expectedScore = 100000,
	},

	["Barrels5_Updated"] = {
		levelName = "Boulder Battle",
		resource = "GameScreen_Land1",		
		outtroScript = "Land6_Outtro",
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins12 = true,
			largeBoard = true,
			gemTypes5 = true, 
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = { --Make sure there's always barrels on the board
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {0,0,0,0,0,0,0, 0,0,0,0,0,0,0}, --Always 14 boulders in play
				},
			},
			additionalInitialPatterns = {

			},
		},
		goals = {
			main = {"getGem",160,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelQueue"] = {
		levelName = "Boulder Queue",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			hasCrates = true,
			modeSpins10 = true, --already matched Operation Easy
			largeBoard = true,
			gemTypes4 = true,
			hasMissingSquares = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			gemsMoveDiagonally= false,
			--Missing squares
			useMissingSquares = true,
			missingSquares = {
				patternName = "IsolateSidesLarge", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = { --Crates
					patternName = "TopCorners_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = { --Barrels
					patternName = "NotTopCorners_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"getGem",14,"Boulder","Boulders",{matchFlags = 0,specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",55000},
				[2] = {"score",60000},
				[3] = {"score",70000},
			},
		},
		expectedScore = 100000,
	},

	["ShiftingSands"] = {
		levelName = "Shifting Sands",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins7 = true,--already matched Operation Easy
			hasCoverage = true,
			largeBoard = true,
			gemTypes5 = true, 
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			--Guarantee always 21 barrels
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {
						0,0,0,0,0,0,0,
						0,0,0,0,0,0,0,
						0,0,0,0,0,0,0,
					},
					inactiveForInitialPlacement = true,
				},
			},
			additionalInitialPatterns = {
				[1] = { --Barrels for 3 rows
					patternName = "BigThreeNearBottomRows",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				[2] = { --Guarantee different colors for each gem on bottom row
					patternName = "BigBottomColumn1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[3] = {
					patternName = "BigBottomColumn2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[4] = {
					patternName = "BigBottomColumn3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[5] = {
					patternName = "BigBottomColumn4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[6] = {
					patternName = "BigBottomColumn5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[7] = {
					patternName = "BigBottomColumn6",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[8] = {
					patternName = "BigBottomColumn7",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[9] = { --They need to match the bottom row only
					patternName = "BigCratePattern4",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},
	["TrickLevel"] = {
		levelName = "Deceptively Hard",
		resource = "GameScreen_Land1",		
		introScript = "Land6_Tip2",
		Features = {
			splashMode = true,
			modeSpins2 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasCoverage = true,
		},
		tricks = {
			{name = Config.World6Tricks_Trick1},
			{name = Config.World6Tricks_Trick2},
			{name = Config.World6Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = { --A single, easily-accessed tile to end the level.
					patternName = "Silo1_seed",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",2000000},
				[2] = {"score",3000000},
				[3] = {"score",4000000},
			},
		},
		expectedScore = 100000,
	},

	["GoWild"] = {
		levelName = "Go Wild",
		resource = "GameScreen_Land1",		
		introScript = "Land6_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins7 = true, --already matched Operation Easy
			gemTypes6 = true,
			regularBoard = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					frequencies = {1,2,3,4,5,6,7,8},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",900000},
				[2] = {"score",1500000},
				[3] = {"score",2500000},
			},
		},
		expectedScore = 100000,
	},
	
	["GoWild_side"] = {
		levelName = "Prismatic Burst",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			gemTypes6 = true,
			largeBoard = true,
			hasCoverage = true,
			hasBarrels = true,
			hasMissingSquares = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
					useMissingSquares = true,
					missingSquares = {
					patternName = "MiddleLine_large", 
					isPatternSet = false,
				},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					frequencies = {1,2,3,4,5,6,7,8},
				},
				[2] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "TestCoverageMid",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "BoulderStripe2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1000000},
				[3] = {"score",1300000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsDrop3_side"] = {
		levelName = "Boulders on Top",
		resource = "GameScreen_Land6",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			treasureChest = true,
			hasJailedSquares = true,
			modeSpins10 = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Top3Rows",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
				},
				[2] = {
					patternName = "Line4",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsDrop4_side"] = {
		levelName = "Boulder Stair",
		resource = "GameScreen_Land6",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			treasureChest = true,
			hasJailedSquares = true,
			regularBoard = true,
			modeSpins8  = true,
			gemTypes5 = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Steps1Top",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
				},
				[2] = {
					patternName = "Steps1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",350000},
				[3] = {"score",450000},
			},
		},
		expectedScore = 100000,
	},

	["Barrels5_Updated_side"] = {
		levelName = "Boulderama",
		resource = "GameScreen_Land6",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes5 = true, 
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = { --Make sure there's always barrels on the board
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {0,0,0,0,0,0,0, 0,0,0,0,0,0,0}, --Always 14 boulders in play
				},
			},
			additionalInitialPatterns = {

			},
		},
		goals = {
			main = {"getGem",100,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",450000},
			},
		},
		expectedScore = 100000,
	},

})