-- Land 7: bombs

table.insertall(LevelDefs,
{

	--BOMB LEVELS
	["Bomb1"] = {
		levelName = "Da Bomb",
		resource = "GameScreen_Land1",		
		introScript = "Land7_Intro",
		Features = {
			splashMode = true,
			modeSpins8 = true,--7 before Operation Easy
			hasBombs = true,
			gemTypes6 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "HolePunch_MissingCorners",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
				[2] = {
					patternName = "MissingOuterCorners",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 7,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",100000},
				[3] = {"score",160000},
			},
		},
		expectedScore = 100000,
	},

	["BombDungeon1"] = {
		levelName = "Bomb Break-In",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins3 = true,
			hasBombs = true,
			hasStones = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = {
			{name = Config.World7Tricks_Trick1},
			{name = Config.World7Tricks_Trick2},
			{name = Config.World7Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "AroundSides_inner",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 9,
				},
				[2] = {
					patternName = "AroundSides",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",60000},
				[3] = {"score",120000},
			},
		},
		expectedScore = 100000,
	},

	["BombFalling2"] = {
		levelName = "Bomb Toss",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,--already matched Operation Easy
			hasBombs = true,
			hasJailedSquares = true,
			hasCrates = true,
			hasStones = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World7Tricks,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LowerLine3",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "MiddleLine",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[3] = {
					patternName = "LowerLine2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[4] = {
					patternName = "TopFrame1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 10,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},"Defuse"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["BombDungeon2"] = {
		levelName = "Bomb Dungeon",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--7 before Operation Easy (lowered)
			hasBombs = true,
			hasStones = true,
			hasCrates = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Dungeon1_bomb1",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},

				{
					patternName = "Dungeon1_bomb2",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},

				{
					patternName = "Dungeon1_bomb3",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				
				{
					patternName = "Dungeon1_bomb4",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},

				{
					patternName = "Dungeon1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},

				{
					patternName = "Dungeon1_door",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},

				{ --Line of color
					patternName = "Line8_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{ --Line of color
					patternName = "Line7_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{ --Line of color
					patternName = "Line6_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000,
	},

	["BombTower1"] = {
		levelName = "Bomb Tower",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,--7 before Operation Easy
			hasBombs = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Tower1_block1",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},

				{
					patternName = "Tower1_block2",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},

				{
					patternName = "Tower1_block3",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				
				{
					patternName = "Tower1_block4",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "Tower1_block5",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "Tower1_block6",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "Tower1_block7",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["BombFalling3"] = {
		levelName = "Bomb Fall",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,--already matched Operation Easy
			hasBombs = true,
			hasJailedSquares = true,
			hasStones = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World7Tricks,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Wedge1_row5",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Wedge1_row2",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[3] = {
					patternName = "Wedge1_row3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[4] = {
					patternName = "Wedge1_row4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 10,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},"Defuse"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},

	["BombFalling4"] = {
		levelName = "Bomby",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			hasBombs = true,
			hasJailedSquares = true,
			hasStones = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World7Tricks,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Ledge1_row1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Ledge1_row2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[3] = {
					patternName = "Ledge1_row3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[4] = {
					patternName = "Ledge1_row4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 10,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},"Defuse"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},

	["BombDungeon3"] = {
		levelName = "Bomb Dungeon 2",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--7 before Operation Easy (lowered)
			hasBombs = true,
			hasStones = true,
			hasCrates = true,
			largeBoard = true,
			gemTypes5 = true, 
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Dungeon2_bombs1",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},

				{
					patternName = "Dungeon2_bombs2",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},

				{
					patternName = "Dungeon2_bombs3",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
				
				{
					patternName = "Dungeon2_bombs4",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				{
					patternName = "Dungeon2_floor1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "Dungeon2_bombs5",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},

				{
					patternName = "Dungeon2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},

				{
					patternName = "Dungeon2_roof",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},

				{
					patternName = "Dungeon2_sky1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "Dungeon2_sky2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "Dungeon2_sky3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},

	["BombPattern1"] = {
		levelName = "Stormy Bombs!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,--7 before Operation Easy
			hasCoverage = true,
			hasBombs = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 10,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "BombPattern1_top",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				{
					patternName = "BombPattern1_middle",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				{
					patternName = "BombPattern1_crate",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

	["BombDrop1"] = {
		levelName = "Treasure Bombs",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasChests = true,
			modeSpins10 = true,--already matched Operation Easy
			hasBombs = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					turnsToLoss = 25,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
			additionalInitialPatterns = { 
			},
		},
		goals = {
			main = {"getGem",15,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",750000},
			},
		},
		expectedScore = 100000,
	},

	["BombVines1"] = {
		levelName = "Bombs! Vines!",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasVines = true,
			hasCrates = true,
			hasBombs = true,
			modeSpins12 = true,--already matched Operation Easy
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 15,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BombVines1_inner1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[2] = {
					patternName = "BombVines1_inner2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = {
					patternName = "BombVines1_inner3",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[4] = {
					patternName = "BombVines1_inner4",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[5] = {
					patternName = "BombVines1_cover",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},

	["BombFalling1"] = {
		levelName = "Boulder Bomb",
		resource = "GameScreen_Land1",		
		introScript = "Land7_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins7 = true, --8 before Operation Easy (lowered)
			hasBombs = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				{
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 10,
					frequencies = {1,1,1,1,1,1,1,1,1,1,1,1,},
				},
				{
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1,1,1,1,1,1,1,1,1,},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000,
	},

	["BombFallingCombined"] = {
		levelName = "Bombed Boulders",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins7 = true,--already matched Operation Easy
			hasBombs = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
					turnsToLoss = 4,
					frequencies = {0,0,0,0,},
				},
			},
		},
		goals = {
			main = {"getGem",50,"Boulder","Boulders",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",750000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["BombDungeon4_Updated"] = {
		levelName = "Bomb Lair",
		resource = "GameScreen_Land1",		
		outtroScript = "Land7_Outtro",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			hasBombs = true,
			hasStones = true,
			hasCrates = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				{
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 35,
					frequencies = {2,3,4,5,6,7,8,9,10,11},
				},
			},
			additionalInitialPatterns = {
				{ 
					patternName = "Dungeon4_inside1",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyTurnsToLoss = true,
					turnsToLoss = 50,
				},

				{
					patternName = "Dungeon4_cover1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},

				{
					patternName = "Dungeon4_inside2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},

				{
					patternName = "Dungeon4_cover2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},

				{
					patternName = "Dungeon4_jail1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{turnsToLoss = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["EverythingFall"] = {
		levelName = "Everything Fall",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			treasureChest = true,
			modeSpins12 = true,--already matched Operation Easy
			hasBombs = true,
			gemTypes4 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			additionalRegularPlacements = {
				{ --Decreasing populations of bombs
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 15,
					frequencies = {1,1,2,2,3,3,4,4,5,5},
				},
				{ --Always have 9 barrels in play
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {0,0,0,0,0, 0,0,0,0,},
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",900000},
				[2] = {"score",1200000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000,
	},

	["BombDungeon3_side"] = {
		levelName = "Crate Bombs",
		resource = "GameScreen_Land7",		
		Features = {
			splashMode = true,
			modeSpins7 = true,
			hasBombs = true,
			hasStones = true,
			hasCrates = true,
			largeBoard = true,
			gemTypes5 = true, 
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Dungeon2_bombs1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "Dungeon2_bombs2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 30,
				},
				{
					patternName = "Dungeon2_bombs3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "Dungeon2_bombs4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "Dungeon2_floor1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "Dungeon2_bombs5",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "Dungeon2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "Dungeon2_roof",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "Dungeon2_sky1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "Dungeon2_sky2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "Dungeon2_sky3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},			
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",950000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

	["BombDrop1_side"] = {
		levelName = "Bomb Drop",
		resource = "GameScreen_Land7",		
		Features = {
			splashMode = true,
			hasChests = true,
			modeSpins10 = true,
			hasBombs = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					turnsToLoss = 21,
					frequencies = {1,3,5,7,9,11,13,15},
				},
			},
			additionalInitialPatterns = { 
			},
		},
		goals = {
			main = {"getGem",10,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",350000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000,
	},

	["BombFallingCombined_side"] = {
		levelName = "Ticking Boulders",
		resource = "GameScreen_Land7",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins7 = true,
			hasBombs = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalRegularPlacements = {
				{
					matchFlags = 0,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
					turnsToLoss = 6,
					frequencies = {0,0,0,0,},
				},
			},
		},
		goals = {
			main = {"getGem",40,"Boulder","Boulders",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",750000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},

    ["BombDungeon1_side"] = {
		levelName = "Bomb Break-Out",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins4 = true,
			hasBombs = true,
			hasStones = true,
			gemTypes5 = true,
			largeBoard = true,
		},
		tricks = {
			{name = Config.World7Tricks_Trick1},
			{name = Config.World7Tricks_Trick2},
			{name = Config.World7Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BombDungeon1_side_bombs",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 18,
				},
				[2] = {
					patternName = "BombDungeon1_side_barriers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000,
	},
})