-- Land 8: steel

table.insertall(LevelDefs,
{

	["Land8_Level1"] = {
		levelName = "Steel n Stones",					
		resource = "GameScreen_Land8",		
		introScript = "Land8_Intro",
		Features = {
			splashMode = true,
			modeSpins7 = true,--8 before Operation easy (lowered)
			hasCrates = true,
			hasStones = true,
			hasSteel = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			useMissingSquares = false,
			missingSquares = {
				patternName = "HiddenHallways1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "TopAndBottomCorners1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "V_Bottom2",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "V_Bottom1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",18,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["Land8_Level2"] = {
		levelName = "Stone Pattern",					
		resource = "GameScreen_Land8",		
		introScript = "Land8_Tip1",
		onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			hasCoverage = true,
			hasCrates = true,
			hasStones = true,
			hasSteel = true,
			gemTypes5 = true, 
			regularBoard = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "TopLine1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "TopLine1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "TopFunnel1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},

	["Land8_Level3"] = {
		levelName = "Pillars",					
		resource = "GameScreen_Land8",		
		Features = {
			splashMode = true,
			modeSpins10 = true,--already matched Operation Easy
			treasureChest = true,
			hasSteel = true,
			hasStones = true,
			gemTypes5 = true, 
			regularBoard = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "TopFunnel2",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "StonePillars1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
	},

	["Land8_Level4"] = {
		levelName = "Break Out",					
		resource = "GameScreen_Land1",		
		Features = {
			hasJailedSquares = true,
			modeSpins7 = true,--already matched Operation Easy
			splashMode = true,
			hasSteel = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Spider1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				{
					patternName = "SteelSides2",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",18,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",100000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["Land8_Level5_Updated"] = {
		levelName = "Vine Battle",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasVines = true,
			hasSteel = true,
			gemTypes4 = true,
			regularBoard = true,
			modeSpins5 = true,
		},
		tricks = TricksDefault,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BottomSeeds1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "SteelBottom1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",750000},
				[3] = {"score",1000000},
			},
		},
	},

	["Land8_Level6"] = {
		levelName = "Boulders and Steel",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins7 = true,--already matched Operation Easy
			hasSteel = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1,1,1},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Line7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				{
					patternName = "RandomSteel1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",25,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",125000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["Land8_Level7"] = {
		levelName = "Steely Bomb",
		resource = "GameScreen_Land1_large",		
		Features = {
			splashMode = true,
			modeSpins8 = true,--already matched Operation Easy
			hasBombs = true,
			hasStones = true,
			hasBarrels = true,
			hasSteel = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BombCell1_bomb",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
					applyTurnsToLoss = true,
					turnsToLoss = 45,
				},
				{
					patternName = "BombCell1_barrel",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
				},
				{
					patternName = "BombCell1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "BombCell1_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels},},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",250000},
				[3] = {"score",350000},
			},
		},
		expectedScore = 100000,
	},

	["Land8_Level8"] = {
		levelName = "Spout On",					
		resource = "GameScreen_Land8",		
		Features = {
			splashMode = true,
			modeSpins8 = true,--already matched Operation Easy
			largeBoard = true,
			hasStones = true,
			hasSteel = true,
			hasVines = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			useMissingSquares = false,
			additionalInitialPatterns = {
				{
					patternName = "Spout1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "Pile1_bottom",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Pile1_top",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "Pile1_middle",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",14,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			--main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",125000},
				[3] = {"score",150000},
			},
		},
	},

	["Land8_Level9"] = {
		levelName = "Flow",					
		resource = "GameScreen_Land8",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--8 before Operation Easy (lowered)
			hasCoverage = true,
			hasStones = true,
			hasSteel = true,
			largeBoard = true,
			hasJailedSquares = true,
			gemTypes5 = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "Flow1_inner",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "Flow1_inner",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Flow1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "Flow1_inner2",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",100000},
				[3] = {"score",125000},
			},
		},
	},

	["Land8_Level10_Updated"] = {
		levelName = "Boulders and Treasure",					
		resource = "GameScreen_Land8",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			treasureChest = true,
			hasSteel = true,
			hasCrates = true,
			hasBarrels = true,
			hasStones = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1,1,1},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "TopFunnel3_bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "TopFunnel3",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "TopFunnel3_top",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "TopFunnel3_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "TopFunnel3_Color2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "TopFunnel3_Color3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "TopFunnel3_Color4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "TopFunnel3_Color5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
			},
		},
		goals = {
			main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",800000},
			},
		},
	},

	["Land8_Level11"] = {
		levelName = "Bomb Escape",					
		resource = "GameScreen_Land1",		
		Features = {
			hasJailedSquares = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			splashMode = true,
			hasSteel = true,
			largeBoard = true,
			hasBombs = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "SteelJail1_bomb",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "SteelJail1_Colors1",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				{
					patternName = "SteelJail1_Colors2",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "SteelJail1_Colors3",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "SteelJail1_top",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				{
					patternName = "SteelJail1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",125000},
				[3] = {"score",150000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["EmptyColumns"] = {
		levelName = "Empty Columns",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasStones = true,
			regularBoard = true,
			modeSpins6 = true,
			gemTypes4 = true,
			hasCoverage = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "EmptyColumns_Missing", 
				isPatternSet = false,
			},
			gemsMoveDiagonally = false,
			additionalInitialPatterns = {
				{
					patternName = "TopCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "EmptyColumns_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
					clearPieces = true,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

	["Land8_Level13"] = {
		levelName = "21 Stones",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasStones = true,
			modeSpins9 = true,--already matched Operation Easy
			hasSteel = true,
			largeBoard = true,
			hasVines = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Silo1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Silo1_seed",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "Silo1_top",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",21,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},

	["Land8_Level14_Updated"] = {
		levelName = "Vine Bomb",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins9 = true,
			hasBombs = true,
			hasVines = true,
			hasSteel = true,
			largeBoard = true,
			gemTypes5 = true, 
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "SideSeeds_bomb",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyTurnsToLoss = true,
					turnsToLoss = 55,
				},
				{
					patternName = "SideSeeds",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "SideSeeds_shelf",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "SideSeeds_shelf2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Stone},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["Land8_Level15"] = {
		levelName = "Bomb Bomb Bomb!",
		resource = "GameScreen_Land1",		
		outtroScript = "Land8_Outtro",
		Features = {
			splashMode = true,
			modeSpins5 = true,--7 before Operation Easy (lowered)
			hasBombs = true,
			hasVines = true,
			hasBarrels = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			additionalRegularPlacements = {
				{
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {2,1,2,1,2},
				},
				{
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 10,
					frequencies = {1,2,1,2,1},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "TopSlots_seed",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "TopSlots",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",12,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},"Defuse"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},

	["Land8_Level8_side"] = {
		levelName = "Narrow Spout",					
		resource = "GameScreen_Land8",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			hasStones = true,
			hasSteel = true,
			hasVines = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			useMissingSquares = false,
			additionalInitialPatterns = {
				{
					patternName = "Spout1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "Pile1_bottom_narrow",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Pile1_top",
					isPatternSet = false,		
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "Dungeon4_inside2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",10,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			--main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",100000},
				[3] = {"score",450000},
			},
		},
	},

	["Land8_Level9_side"] = {
		levelName = "Zigzag",					
		resource = "GameScreen_Land8",		
		Features = {
			splashMode = true,
			modeSpins7 = true,
			hasCoverage = true,
			hasStones = true,
			hasSteel = true,
			largeBoard = true,
			hasJailedSquares = true,
			gemTypes5 = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "Flow1_inner",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{
					patternName = "Flow1_inner",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "Flow1",
					isPatternSet = false,	
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "Flow1_inner2",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",700000},
			},
		},
	},

	["Land8_Level13_side"] = {
		levelName = "Crate Column",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasStones = true,
			modeSpins9 = true,
			hasSteel = true,
			largeBoard = true,
			hasVines = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Silo1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "Silo1_seed",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				{
					patternName = "Silo1_top",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",21,"Crate","Crates",{specials = CascadePieceSpecials_Crates},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",900000},
				[3] = {"score",1500000},
			},
		},
	},
	
	
	["Land8Side4_side"] = {
		levelName = "Countdown",					
		resource = "GameScreen_Land8",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			gemTypes5 = true,
			largeBoard = true,
			hasBombs = true,
			hasSteel = true,
		},
		tricks = TricksDefault,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "BottomCorners_large",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					
					applyTurnsToLoss = true,
					turnsToLoss = 20,

					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			additionalRegularPlacements = {
				{
					frequencies = {0, 0, 0, 0, 0, 0, 0},
					matchFlags = 0x1F,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover,
					turnsToLoss = 20,
				}
			}
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",275000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
	},
})