-- Land 9: 3-hit stone

table.insertall(LevelDefs,
{

	["Land9_Sample"] = {
		levelName = "Stone Stairs",
		resource = "GameScreen_Land1",
		introScript = "Land9_Intro",
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy (lowered)
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
				Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StaircaseUp",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

	["StoneWithBurst"] = {
		levelName = "Burst the Stones",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			hasStones = true,
			hasCoverage = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					frequencies = {6,8,18,20,30},
				},
				[2] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					frequencies = {4,10,16,22,28},
				},
				[3] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					frequencies = {2,12,14,24,26},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					patternName = "Scatter3",
				},
				[2] = {
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					patternName = "Scatter1",
				},
				[3] = {
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					patternName = "Scatter2",
				},
				[4] = {
					patternName = "OuterU",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",800000},
				[3] = {"score",950000},
			},
		},
		expectedScore = 100000,
	},

	["TripleDecker"] = {
		levelName = "Triple Decker",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy (lowered)
			hasStones = true,
			hasCoverage = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "DoubleLineLarge",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					--matchRequirement = 2,
					applyMatchRequirement = false,
				},
				[2] = {
					patternName = "3LayerBombs_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 8,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",350000},
				[3] = {"score",450000},
			},
		},
		expectedScore = 100000,
	},

	["FourQuarts"] = {
		levelName = "Four Quarters",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			regularBoard = true,
			gemTypes4 = true,
			hasVines = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Quadrants",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				[2] = {
					patternName = "LittleMissingPattern2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",750000},
			},
		},
	},

	["Landslide"] = {
		levelName = "Landslide",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			treasureChest = true,
			modeSpins3 = true,
			gemTypes4 = true,
			regularBoard = true,
		},
		tricks = {
			{name = Config.World9Tricks_Trick1},
			{name = Config.World9Tricks_Trick2},
			{name = Config.World9Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Slopes",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["BigDiamond"] = {
		levelName = "Big Diamond",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins6 = true,--matched
			gemTypes5 = true,
			largeBoard = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BigDiamond",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				
				[2] = {
					patternName = "CenterRect",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "LargeCorners",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[4] = {
					patternName = "InnerHole_large",
					isPatternSet = false,
					matchRequirement = 7,
					applyMatchRequirement = true,
				},
				
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["SuperStone"] = {
		levelName = "Stone Tiers",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,--6 before Operation Easy (lowered)
			hasStones = true,
			hasCoverage = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			weightOfWildcardPiecesInSlots = 0,
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					frequencies = {1,2,3,4,5,6,7,8},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Striated",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",900000},
				[3] = {"score",2000000},
			},
		},
		expectedScore = 100000,
	},

	["JailStack"] = {
		levelName = "Jail Stack",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins9 = true,--already matched Operation Easy
			largeBoard = true,
			gemTypes4 = true,
			hasCrates = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "IsolateCenterLow", 
				isPatternSet = false,
			},
			--[[
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					frequencies = {3,4,9,10,15,16,21,22},
				},
				[2] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					frequencies = {2,5,8,11,14,17,20,23},
				},
				[3] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					frequencies = {1,6,7,12,13,18,19,24},
				},
			},
			]]
			additionalInitialPatterns = {
				[1] = {
					patternName = "CenterStripLow",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[2] = {
					patternName = "Dungeon4_inside1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[3] = {
					patternName = "Dungeon4_inside2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[4] = {
					patternName = "SteelJail1_bomb",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[5] = {
					patternName = "SideSeeds_bomb",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[6] = {
					patternName = "Row4Center",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["TreasureRow"] = {
		levelName = "Row of Treasure",
		resource = "GameScreen_Land9",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			hasBombs = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = {
				{ 
					patternName = "TopCorners",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyTurnsToLoss = true,
					turnsToLoss = 30,
				},
				{ 
					patternName = "Columns_top",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyTurnsToLoss = true,
					turnsToLoss = 30,
				},
				{ 
					patternName = "TopCenter",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				{
					patternName = "TopShelves",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},

			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",75000},
				[3] = {"score",100000},
			},
		},
		expectedScore = 100000,
	},

	["LotsOBombs"] = {
		levelName = "Bombnanza!",					
		resource = "GameScreen_Land9",		
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			hasCoverage = true,
			hasBombs = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 15,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 10,
					frequencies = {1,2,1,0,1,2,1,0,1,2,1,0,1,2,1,},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Checkers",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 12,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{turnsToLoss = true},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",800000},
			},
		},
	},

	["EdgeVines"] = {
		levelName = "Walled Garden",
		resource = "GameScreen_Land1",
		outtroScript = "Land9_Outtro",
		Features = {
			splashMode = true,
			modeSpins7 = true,--already matched Operation Easy
			largeBoard = true,
			gemTypes4 = true,
			hasVines = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "U_Lining",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				[2] = {
					patternName = "OuterNoTopLarge",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",1000000},
				[3] = {"score",3000000},
			},
		},
	},

	["JailsV"] = {
		levelName = "Jailbreak",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins6 = true,--7 before Operation Easy (lowered)
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
				Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Row4Vee",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Row3Vee",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},

				[3] = {
					patternName = "BelowV",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	["StonePoints"] = {
		levelName = "Stone Shelves",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins7 = true,--9 before Operation Easy (lowered)
			splashMode = true,
			largeBoard = true,
			gemTypes5 = true, 
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "WallsAndShelves",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},			},
		},
		expectedScore = 100000, 
	},

	["FieldOfStones"] = {
		levelName = "Rocky Field",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins5 = true,--7 before Operation Easy (lowered)
			splashMode = true,
			regularBoard = true,
			gemTypes5 = true, 
			hasBarrels = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {0,0,0,1,2,2,3},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Scattered",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
			},
		},
		goals = {
			main = {"getGem",21,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",60000},
				[2] = {"score",100000},
				[3] = {"score",200000},			
			},
		},
		expectedScore = 100000, 
	},

	["GottaCatchEmAll"] = {
		levelName = "Full Coverage",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,--already matched Operation Easy
			hasCoverage = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {0,0,1,1,1,1,1},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "FullBoardSmall",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

	["BigDiamond_side"] = {
		levelName = "Center Jails",
		resource = "GameScreen_Land9",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			gemTypes5 = true,
			largeBoard = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BigDiamond",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},				
				[2] = {
					patternName = "CenterRect",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "InnerHole_large",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",600000},
				[3] = {"score",1400000},
			},
		},
		expectedScore = 100000,
	},

	["GottaCatchEmAll_side"] = {
		levelName = "Catch Them All",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasCoverage = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {0,0,1,1,1,1,1},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "FullBoardSmall",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",800000},
			},
		},
	},

	["EdgeVines_side"] = {
		levelName = "Edge Vines",
		resource = "GameScreen_Land9",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasVines = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "U_Lining",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					--extraHits = 1,
					--applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				[2] = {
					patternName = "AlmostOuterNoTopLarge",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",2500000},
				[3] = {"score",5000000},
			},
		},
	},

	["Land9Side4_side"] = {
		levelName = "The Big Bomb",
		resource = "GameScreen_Land9",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = TricksDefault,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "9-4_Bomb_Inner",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone | CascadePieceSpecial_Valuable,
					matchFlags = 0,
					extraHits = 0,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					
					applyTurnsToLoss = true,
					turnsToLoss = 9,
				},
				{
					patternName = "9-4_Bomb_Middle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone | CascadePieceSpecial_Valuable,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					
					applyTurnsToLoss = true,
					turnsToLoss = 7,
				},
				{
					patternName = "9-4_Bomb_OuterA",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone | CascadePieceSpecial_Valuable,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				{
					patternName = "9-4_Bomb_OuterB",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone | CascadePieceSpecial_Valuable,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecials_Stone | CascadePieceSpecial_Valuable},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1200000},
			},
		},
	},
})