table.insertall(LevelDefs,
{
-- Alternate versions of levels used in game.

	["SimpleCoverage3_original"] = {
		levelName = "Cloud Corners!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins10 = true,
			hasCoverage = true,
			gemTypes5 = true,
			hasMissingSquares = true,
			regularBoard = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "OuterCorners_empty", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "OuterCorners2",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",150000},
				[3] = {"score",300000},
			},
		},
	},

    ["JailBroken"] = {
		levelName = "Jail Broken",
		resource = "GameScreen_Land20",
        introScript = "Land20_JailBroken_Intro",
        outtroScript = "Land20_JailBroken_Outtro",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasChests = true,
            hasMakers = true,
            hasSteel = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalNamedMixes = {
				{
					name = "TreasureMix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 7,
                            newDelay = 5,
                        },
                    },
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
					},
                },
            },
            additionalInitialPatterns = {
				{
					patternName = "JailBroken_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "JailBroken_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
                {
					patternName = "JailBroken_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"TreasureMix"},
				},
                {
					patternName = "JailBroken_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
            endGameProperties = {
				additionalNamedMixes = {
					{
						name = "TreasureMix",
						delay = -1,
					},
				},
			},
		},
		goals = {
            --main = {"finish",true},
			main = {"getGem",100,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
	},

    ["JailBroken2"] = {
		levelName = "Jail Broken",
		resource = "GameScreen_Land20",
        introScript = "Land20_JailBroken_Intro",
        outtroScript = "Land20_JailBroken_Outtro",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasChests = true,
            hasMakers = true,
            hasSteel = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalNamedMixes = {
				{
					name = "TreasureMix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 3,
                        },
                    },
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
                },
            },
            additionalInitialPatterns = {
				{
					patternName = "JailBroken2_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "JailBroken2_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
                {
					patternName = "JailBroken2_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"TreasureMix"},
				},
                {
					patternName = "JailBroken2_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
            endGameProperties = {
				additionalNamedMixes = {
					{
						name = "TreasureMix",
						delay = -1,
					},
				},
			},
		},
		goals = {
            --main = {"finish",true},
			main = {"getGem",20,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["JailBroken3"] = {
		levelName = "Jail Broken",
		resource = "GameScreen_Land20",
        introScript = "Land20_JailBroken_Intro",
        outtroScript = "Land20_JailBroken_Outtro",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes3 = true,
            hasJailedSquares = true,
            hasChests = true,
            hasMakers = true,
            hasSteel = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalNamedMixes = {
				{
					name = "TreasureMix",
					delay = 0,
                    events = {
                        {
                            eventType = "emitCount",
                            count = 10,
                            newDelay = 5,
                        },
                    },
					{ 
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
					},
                },
            },
            additionalInitialPatterns = {
				{
					patternName = "JailBroken_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "JailBroken_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
                {
					patternName = "JailBroken_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"TreasureMix"},
				},
                {
					patternName = "JailBroken_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
            endGameProperties = {
				additionalNamedMixes = {
					{
						name = "TreasureMix",
						delay = -1,
					},
				},
			},
		},
		goals = {
            --main = {"finish",true},
			main = {"getGem",100,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",800000},
				[3] = {"score",1600000},
			},
		},
	},

    ["JailhouseRocks"] = {
		levelName = "Jailhouse Rocks",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasStones = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

                    name = "Orange",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                    weight = 11,
                },
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                },
            },
            reelPieceMix = {
				{
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Vertical Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
			},
		},
		goals = {
            main = {"getGem",2,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",10000},
				[2] = {"score",100000},
				[3] = {"score",1000000},
			},
		},
	},


    ["JailhouseRocks2"] = {
		levelName = "Jailhouse Rocks",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasBarrels = true,
            hasStones = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                },
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    weight = 0,
                },
            },
--[[
            reelPieceMix = {
                {
                    name = "Wild",
                    matchFlags = CascadeMatchFlags_Wildcard,
                    weight = 4,
                },
            },
--]]
            reelPieceMix = {
				{
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Vertical Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
			},
		},
		goals = {
            main = {"getGem",2,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

    ["JailhouseRocks3"] = {
		levelName = "Jailhouse Rocks",
		resource = "GameScreen_Land20",
        --introScript = "Land20_JailhouseRocks_Intro",
        --outtroScript = "Land20_JailhouseRocks_Outtro",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasStones = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

                    name = "Orange",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,

					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                },
            },

            reelPieceMix = {
				{
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 5,
                },
                {
                    name = "Vertical Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 5,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 5,
                },
                {
                    name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
                },
			},
		},
		goals = {
            main = {"getGem",2,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",1400000},
			},
		},
	},

    ["JailhouseRocks4"] = {
		levelName = "Jailhouse Rocks",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
            hasJailedSquares = true,
            hasStones = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

                    name = "Orange",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                    weight = 11,
                },
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                },
            },
            reelPieceMix = {
				{
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Vertical Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
			},
		},
		goals = {
            main = {"getGem",2,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
	},

    ["JailhouseRocks6"] = {
		levelName = "Jailhouse Rocks",
		resource = "GameScreen_Land20",
        --introScript = "Land20_JailhouseRocks_Intro",
        --outtroScript = "Land20_JailhouseRocks_Outtro",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasStones = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

                    name = "Orange",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,

					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                },
            },

            reelPieceMix = {
				{
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Vertical Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
                },
                {
                    name = "1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1,
                },
                {
                    name = "2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1,
                },
                {
                    name = "3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1,
                },
			},
		},
		goals = {
            main = {"getGem",2,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",1400000},
			},
		},
	},

    ["JailhouseRocks7"] = {
		levelName = "Jailhouse Rocks",
		resource = "GameScreen_Land20",
        --introScript = "Land20_JailhouseRocks_Intro",
        --outtroScript = "Land20_JailhouseRocks_Outtro",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
            hasJailedSquares = true,
            hasStones = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "JailhouseRocks_JailsAndOranges",
					isPatternSet = false,

                    name = "Orange",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,

					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                },
            },

            reelPieceMix = {
				{
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Vertical Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Area Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_AreaSplash,
                    weight = 1,
                },
                {
                    name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
                },
                {
                    name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 1,
                },
			},
		},
		goals = {
            main = {"getGem",2,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",1400000},
			},
		},
	},

    ["DoNotOpen"] = {
		levelName = "Do Not Open",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins999 = true,
			regularBoard = true,
			gemTypes3 = true,
			hasBarrelsOfFun = true,
            hasBombs = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
					name = "Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 7,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,8,64},
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["DoNotOpen3"] = {
		levelName = "Do Not Open",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes3 = true,
			hasBarrelsOfFun = true,
            hasBombs = true,
            hasCoverage = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
					name = "Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 7,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,8,64},
				},
			},
            additionalInitialPatterns = {
                {
					patternName = "DoNotOpen_Clouds",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},

            },
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",4000000},
				[3] = {"score",6000000},
			},
		},
	},

    ["DoubleQuarantine"] = {
		levelName = "Double Quarantine",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			regularBoard = true,
			gemTypes6 = true,
            hasJailedSquares = true,
            hasVineGenerators = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "DoubleQuarantine_JailsAndWilds",
					isPatternSet = false,

                    name = "Wildcard",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
                {
					patternName = "DoubleQuarantine_Vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    skinVariant = "VineGrower",
                    applySkinVariant = true,

				},
                {
					patternName = "DoubleQuarantine_Lava",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
                {
					patternName = "DoubleQuarantine_JailsAndWilds",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},
		goals = {
            main = {"finish",true},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
	},

    ["DoubleQuarantine3"] = {
		levelName = "Double Quarantine",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasVineGenerators = true,
            hasCoverage = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "DoubleQuarantine3_JailsAndWilds",
					isPatternSet = false,

                    name = "Wildcard",
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_Wildcard,
					weight = 3,
				},
                {
					patternName = "DoubleQuarantine3_Vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    skinVariant = "VineGrower",
                    applySkinVariant = true,

				},
                {
					patternName = "DoubleQuarantine3_Lava",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
                {
					patternName = "DoubleQuarantine3_JailsAndWilds",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "DoubleQuarantine3_Clouds",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
            main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
	},

    ["DoubleQuarantine4"] = {
		levelName = "Double Quarantine",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasVineGenerators = true,
            hasCoverage = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {

            additionalInitialPatterns = {
                {
					patternName = "DoubleQuarantine_Vines",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    skinVariant = "VineGrower",
                    applySkinVariant = true,

				},
                {
					patternName = "DoubleQuarantine_Lava",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
                {
					patternName = "DoubleQuarantine_JailsAndWilds",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "DoubleQuarantine_Clouds",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
            main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
	},

    ["BehindBars"] = {
		levelName = "Behind Bars",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins3 = true,
			largeBoard = true,
			gemTypes4 = true,
            hasJailedSquares = true,
            hasCoverage = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "BehindBars_Reels",
				isPatternSet = false,
            },

            additionalInitialPatterns = {
                {
					patternName = "BehindBars_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "BehindBars_Clouds",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
            },
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",2000000},
				[2] = {"score",3000000},
				[3] = {"score",6000000},
			},
		},
	},

    ["DoABarrelRoll_Alt"] = {
		levelName = "Do a Barrel Roll!",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins1 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasMissingSquares = true,
		},
		tricks = {
			{name = Config.World4Tricks_Trick1},
			{name = Config.World4Tricks_Trick2},
			{name = Config.World4Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
                    name = "Barrel",
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					weight = 4,

                    applyExtraHits = true,
					extraHits = 1,

					applyMatchFlags = true,
					matchFlags = 0,

				},
			},
            reelPieceMix = {
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 5,
				},
			},
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
--[[
            useMissingSquares = true,
			missingSquares = {
				patternName = "DoABarrelRoll_Missing",
				isPatternSet = false,
			},
--]]
--[[
            additionalRegularPlacements = {
				{
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 7,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
--]]
		},
		goals = {
            main = {"gemsRemain",20,"Single Barrel","Single Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true, extraHits=0},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
	},

    ["JailTrimmers1"] = {
		levelName = "Jail Trimmers",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
            hasMissingSquares = true,
            hasVines = true,
            hasJailedSquares,
            hasMissingReels = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
                    name = "Horizontal Splash 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Horizontal Splash 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Horizontal Splash 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
                {
                    name = "Horizontal Splash 4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 1,
                },
			},
            useMissingReels = true,
            missingReels = {
				patternName = "HedgeTrimmer_Reels",
				isPatternSet = false,
            },
			additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,1,1,1},
				},
			},
            useMissingSquares = true,
			missingSquares = {
				patternName = "JailTrimmer_Missing",
				isPatternSet = false,
			},
            additionalInitialPatterns = {
                {
                    patternName = "JailTrimmer_Vines",
					isPatternSet = false,

                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                },
                {
					patternName = "JailTrimmer_Vines",
					isPatternSet = false,

					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
                {
					patternName = "JailTrimmer_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
            },

		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",1200000},
				[3] = {"score",2000000},
			},
		},
	},

    ["PrisonersDualemma"] = {
		levelName = "Prisoner's Dualemma",
		resource = "GameScreen_Land20",
        outtroScript = "Land20_Outtro",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            spawnGemOnBreak = {
                {
                    name = "Jail Horiz 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 2",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 3",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 4",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 5",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 2",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 3",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 4",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 5",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
			},
            additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,1,1,1,1},
				},
			},
            useMissingReels = true,
			missingReels = {
				patternName = "PrisonersDualemma_Reels",
				isPatternSet = false,
			},
            endGameProperties = {
                spawnGemOnBreak = 
                {
                    {
                        name = "Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
                        weight = 1,
                    },
                },
--[[
                additionalInitialPatterns = {
                    patternName = "SomePatternWithEverything",
                    isPatternSet = false,
                    applyExtraHits = true,
                    extraHits = 0,
                }
--]]
			},
            additionalInitialPatterns = {
                {
                    patternName = "PrisonersDualemma_Clouds",
                    isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
                },
                {
                    patternName = "PrisonersDualemma_Jails",
                    isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
                },
            },

		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["PrisonersDualemma2"] = {
		levelName = "Prisoner's Dualemma",
		resource = "GameScreen_Land20",
        outtroScript = "Land20_Outtro",
		Features = {
			splashMode = true,
			modeSpins13 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
            hasMissingReels = true,
            hasMissingSquares = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            spawnGemOnBreak = {
                {
                    name = "Jail Horiz 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 2",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 3",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 4",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 5",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 2",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 3",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 4",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 5",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
			},
            additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,2,1,2,1},
				},
			},
            useMissingReels = true,
			missingReels = {
				patternName = "PrisonersDualemma_Reels",
				isPatternSet = false,
			},
            useMissingSquares = true,
            missingSquares = {
                patternName = "PrisonersDualemma_Jails",
                isPatternSet = false,
            },
            additionalInitialPatterns = {
                {
                    patternName = "PrisonersDualemma_Clouds",
                    isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
                },
--[[
                {
                    patternName = "PrisonersDualemma_Jails",
                    isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
                },
--]]
            },

		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["PrisonersDualemma3"] = {
		levelName = "Prisoner's Dualemma",
		resource = "GameScreen_Land20",
        outtroScript = "Land20_Outtro",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
            hasLava = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            spawnGemOnBreak = {
                {
                    name = "Jail Horiz 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 2",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 3",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 4",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Horiz 5",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 2",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 3",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 4",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
                {
                    name = "Jail Area 5",
                    specials = CascadePieceSpecials_Jailed +  CascadePieceSpecial_AreaSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
			},
            additionalRegularPlacements = {
				{
                    applyExtraHits = true,
					extraHits = 1,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,

					isGemSpawner = true,
                    frequencies = {1,2,3,4,5},
				},
			},
            useMissingReels = true,
			missingReels = {
				patternName = "PrisonersDualemma_Reels",
				isPatternSet = false,
			},
            endGameProperties = {
                spawnGemOnBreak = 
                {
                    {
                        name = "Wild",
                        matchFlags = CascadeMatchFlags_Wildcard,
                        weight = 1,
                    },
                },
--[[
                additionalInitialPatterns = {
                    patternName = "SomePatternWithEverything",
                    isPatternSet = false,
                    applyExtraHits = true,
                    extraHits = 0,
                }
--]]
			},
            additionalInitialPatterns = {
                {
                    patternName = "PrisonersDualemma_Clouds",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Lava,
                    matchFlags = 0,
                },
                {
                    patternName = "PrisonersDualemma_Jails",
                    isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
                },
            },

		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

	["Battlement1_simple"] = {
		levelName = "Battlement",					
		resource = "GameScreen_Land21",		
        introScript = "Land21_Intro",
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasCrates = true,
			hasStones = true,
			modeSpins6 = true,
			gemTypes4 = true,
			hasMissingSquares = true,
			hasBarrelsOfFun = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Battlement1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "Battlement1_windows",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "Battlement1_walls",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				{
					patternName = "Battlement1_roof",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",650000},
				[3] = {"score",750000},
			},
		},
	},

	["DropIt1_treasureChest"] = {
		levelName = "Drop It",					
		resource = "GameScreen_Land21",		
		Features = {
			splashMode = true,
			hasCoverage = true,
			largeBoard = true,
			hasCrates = true,
			hasStones = true,
			modeSpins5 = true,
			gemTypes5 = true,
			hasMissingSquares = true,
			treasureChest = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "DropIt1", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "CenterReel_Large", 
				isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "DropIt1_pattern1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "DropIt1_pattern2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{ 
					patternName = "DropIt1_chest",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",800000},
			},
		},
	},

	["CrossBoardCoverage1_large"] = {
		levelName = "Island Map",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true,
			hasCoverage = true,
			largeBoard = true,
			gemTypes6 = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "FourCorners", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "FourCorners_pattern",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",1000000},
			},
		},
	},

	["CrateBlockDrop1_large"] = {
		levelName = "On The Beach",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true,
			largeBoard = true,
			treasureChest = true,
			hasCrates = true,
		},
		Properties = {
			--[[
			useMissingSquares = true,
			missingSquares = {
				patternName = "FourCornersSmall", 
				isPatternSet = false,
			},
			--]]
			additionalInitialPatterns = {
				[1] = {
					patternName = "BigCratePattern3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
	["CoverageCrate_LeftSide"] = {
		levelName = "Break The Wall",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true,
			hasCoverage = true,
		},
		Properties = {
			--[[
			useMissingSquares = true,
			missingSquares = {
				patternName = "Sides", 
				isPatternSet = false,
			},
			--]]
			additionalInitialPatterns = { 
				[1] = {
					patternName = "LeftSide",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "LeftSide",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",1000000},
			},
		},
	},

	["BarrelsOfCrazy_score"] = {
		levelName = "Barrels Of Crazy",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 1,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 1,
				},
				{
					name = "Lava",
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
					weight = 1,
				},
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 1,
				},
				{ 
					name = "Treasure",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 1,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Jail",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",3000000},
			},
		},
	},

	["UseItOrLoseIt"] = {
		levelName = "Use It or Lose It",
		resource = "GameScreen_Land22",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasJailedSquares = true,
			hasMakers = true,
			hasBarrels = true,
			hasGemEaters = true,
			hasCoverage = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Maker Mix",
					delay = 0,
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 2,
					},
					{ 
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 3,
					},
					{
						name = "Horizontal Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Area Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Jail 1",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Jail 2",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Jail 3",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Jail 4",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Jail 5",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Maker Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "UseIt_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Maker Mix"},
				},
				{
					patternName = "UseIt_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	["UseItOrLoseIt_alt"] = {
		levelName = "Use It or Lose It",
		resource = "GameScreen_Land22",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasJailedSquares = true,
			hasMakers = true,
			hasBarrels = true,
			hasGemEaters = true,
			hasCoverage = true,
		},
		tricks = World22Tricks,
		boosts = World22Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Maker Mix",
					delay = 0,
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 2,
					},
					{ 
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 6,
					},
					{
						name = "Horizontal Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Horizontal Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Area Splash 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area Splash 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Jail 1",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Jail 2",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Jail 3",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Jail 4",
						specials = CascadePieceSpecials_Jailed,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						cancelSpecials = CascadePieceSpecials_Jailed,
						weight = 1,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Maker Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "UseIt_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Maker Mix"},
				},
				{
					patternName = "PrisonLattice_Missing",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	["LongWayDown"] = {
		levelName = "Long Way Down",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			treasureChest = true,
			hasPortals = true,
		},
		tricks = World24Tricks,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{0,7},{4,0},"",""},
				[2] = {{1,7},{5,0},"PortalEntrance_1_Wide","PortalExit_1_Wide"},
				[3] = {{2,7},{6,0},"",""},
			},
			useMissingReels = true,
			missingReels = {
				patternName = "TowerToTheClouds_Reels", 
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "VerticalStripeCenterLarge", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["LaserWelcome_fixed"] = {
		levelName = "Lasers! Pew Pew!",
		resource = "GameScreen_Land24",	
		Features = {
			modeSpins8 = true, 
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "LaserV1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV1",},
						weight = 1,
					},
				},
				{
					name = "LaserV2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV2",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV1",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserV2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV2",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Short_Help_Match_2_Color_1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV1",},
				},
				{
					patternName = "TopRow4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV2",},
				},
				{
					patternName = "LaserWelcome_pattern_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "MarsStone",
					applySkinVariant = true,
				},
				{
					patternName = "LaserWelcome_pattern_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "MarsSteel",
					applySkinVariant = true,
				},
				{
					patternName = "LaserWelcome_pattern_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "MarsChest",
				},
			},
		},		
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			--main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",75000},
				[3] = {"score",125000},
			},
		},
	},
	["TowerDefense"] = {
        --Stateless switch creates "waves" of obstacles. Get N boulders.
        levelName = "Tower Defense",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasBarrels = true,
            hasBombs = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "Wave 1",
                    patternName = "Line8_large",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyExtraHits = true,
                    addPieces = true,
                },
                {
                    entryName = "Wave 2",
                    patternName = "TowerDefense_Wave2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyExtraHits = true,
                    extraHits = 1,
                    addPieces = true,
                },
                {
                    entryName = "Wave 3",
                    patternName = "TowerDefense_Wave3",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyExtraHits = true,
                    extraHits = 1,
                    applyTurnsToLoss = true,
                    turnsToLoss = 6,
                    addPieces = true,
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle2",
                    delay = 0,
                    {
                        name = "Switch_Toggle3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "Switch1_Toggle",
                        spawnTypes = {"Toggle3"},
                        matchPatterns = {"Wave 2"},
                        weight = 1,
                    },
                },
                {
                    name = "Toggle3",
                    delay = 0,
                    {
                        name = "Switch_Toggle3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "Switch1_Toggle",
                        spawnTypes = {"Toggle2"},
                        matchPatterns = {"Wave 3"},
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "TowerDefense_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applySkinVariant = true,
                    skinVariant = "Switch1_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Wave 1"},
                },
            },
        },
        endGameProperties = {
            {
                name = "Toggle1",
                delay = -1,
            },
        },
        goals = {
            main = {"getGem",21,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,extraHits = 0,},"Break"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",200000},
                [3] = {"score",300000},
            },
        },
    },
})