table.insertall(LevelDefs,
{
	-- Miscellaneous levels not currently used in game.
	-- Includes levels that were in game at one time and were later replaced by a different level.
	-- (Levels replaced by an alternate version of basically the same level go in Levels_alternates.)

	["BurstTeacher"] = {
		levelName = "Burst of Fun",					
		resource = "GameScreen_Land1",			
		Features = {
			modeSpins5 = true,
			splashMode = true,
			regularBoard = true,
			hasMissingSquares = true,
 			gemTypes5 = true,
			hasCrates = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns =
			{
				[1] = {
					patternName = "BurstTeacher_Area",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[2] = {
					patternName = "BurstTeacher_Vert",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = {
					patternName = "BurstTeacher_Horiz",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},

			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",50000},
				[3] = {"score",100000},
			},
		},
	},

	["MissingCells"] = {
		levelName = "Missing Cells",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "LittleMissingPattern2", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",120000},
				[3] = {"score",440000},
			},
		},
	},

	["HolePunch"] = {
		levelName = "Hole Punch",					
		resource = "GameScreen_Land1",		
		------introScript = "Land1_Level7_Intro",
		Features = {
			modeSpins13 = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "HolePunch", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",55000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
	},

	["OrangeGems"] = {
		levelName = "Orange You Ready",					
		resource = "GameScreen_Land1",		
		------introScript = "Land1_Level8_Intro",
		Features = {
			modeSpins13 = true,
			gemTypes6 = true,
		},
		Properties = {
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",45000},
				[2] = {"score",90000},
				[3] = {"score",120000},
			},
		},
	},

	["OrangeMissing"] = {
		levelName = "Orange You Missing?",					
		resource = "GameScreen_Land1",		
		------introScript = "Land1_Level9_Intro",
		Features = {
			modeSpins13 = true,
			gemTypes6 = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "HolePunch_MissingCorners", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",60000},
				[3] = {"score",80000},
			},
		},
	},

	["BigBoard"] = {
		levelName = "Big Board",					
		resource = "GameScreen_Land1",		
		------introScript = "Land1_Level10_Intro",
		Features = {
			modeSpins13 = true,
			largeBoard = true,
		},
		Properties = {
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

	["SimpleCoverageOrange1"] = {
		levelName = "Patch That Hole!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasCoverage = true,
			gemTypes6 = true,
		},
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "SmallStripe1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",100000},
			},
		},
	},

	["SimpleCoverageOrange2"] = {
		levelName = "Up The Mast!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasCoverage = true,
			gemTypes6 = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Castle3", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "SmallSquare1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",100000},
			},
		},
	},

	["SimpleCoverageOrange3"] = {
		levelName = "Sea Monster!",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true,
			--modeSpins8 = true, --NOTE: This is super hard but doable with 5 spins
			hasCoverage = true,
			gemTypes6 = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Castle4", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "SmallSquare3",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",60000},
				[3] = {"score",80000},
			},
		},
	},

	["CoverageCrate_Stairs"] = {
		levelName = "Up The Stairs",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasCoverage = true,
			hasCrates = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "TwoCorners", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Stairs",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Stairs",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",500000},
			},
		},
	},

	["CoverageCrate_UpperLine1"] = {
		levelName = "Walls",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasCoverage = true,
			hasCrates = true,
		},
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "UpperLine3",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "DoubleUpperLine2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},

	["CrateBlockDrop3"] = {
		levelName = "Triple Crate!",				
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true,
			treasureChest = true,
			hasCrates = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "TripleUpperLine2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "LittleBottom1",
					isPatternSet = false,
					clearPieces = true,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},

	["Drop_Empty2"] = {
		levelName = "Break The Wall",					
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins13 = true,
			treasureChest = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Line", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "DoubleLine",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",1000000},
			},
		},
	},

	["TimedGamed1"] = {
		levelName = "Break The Wall",					
		resource = "GameScreen_Land1",		
		Features = {
			mode2SecondBlitz = true,
		},
		Properties = {

		},
		goals = {
			main = {"finished",true,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",1000000},
			},
		},
	},

	["JailCoverage1_large"] = {
		levelName = "Jail Pattern",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins11 = true,
			hasJailedSquares = true,
			hasCoverage = true,
			hasCrates = true,
			largeBoard = true,
			splashMode = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Sides2_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Sides4_large",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},

				[2] = {
					patternName = "Sides4_large",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},

				[3] = {
					patternName = "MiddleLine2_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["JailCoverage2"] = {
		levelName = "Jail Pattern",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins9 = true,
			hasJailedSquares = true,
			hasCoverage = true,
			hasCrates = true,
			splashMode = true,
		},
		Properties = {
			missingSquares = {
				patternName = "Sides1", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "OuterRing",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},

				[2] = {
					patternName = "OuterInnerRing",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},

				[3] = {
					patternName = "InnerRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",1200000}, 
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["JailCoverage2_large"] = {
		levelName = "Big Escape",					
		resource = "GameScreen_Land1",		
		--outtroScript = "Land4_Outtro",
		Features = {
			hasJailedSquares = true,
			hasCoverage = true,
			hasCrates = true,
			largeBoard = true,
			splashMode = true,
			modeSpins11 = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "InnerHole_large", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "OuterRing_large",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},

				[2] = {
					patternName = "OuterInnerRing_large",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},

				[3] = {
					patternName = "InnerRing_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["VinesRemove2"] = {
		levelName = "Jailed Vines",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasVines = true,
			hasJailedSquares = true,
			modeSpins11 = true,
			regularBoard = true,
			gemTypes5 = true, 
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "CenterStagger1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[2] = {
					patternName = "CenterStagger2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = {
					patternName = "CenterStagger3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[4] = {
					patternName = "CenterStagger4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[5] = {
					patternName = "CenterStagger5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[6] = {
					patternName = "InnerSquare",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[7] = {
					patternName = "MiddleSquare",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
		expectedScore = 100000,
	},

	["VinesRemove4"] = {
		levelName = "Earth and Sky",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasMissingSquares= true,
			largeBoard = true,
			hasVines = true,
			modeSpins8 = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "BigCratePattern8", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BottomSeeds1_large",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["Barrels2"] = {
		levelName = "Boulder Oh My",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins8 = true,
			hasCrates = true,
			gemTypes5 = true,
			regularBoard = true,
			hasMissingSquares = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1},
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "UpperWindow", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TopWindow",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "TopShelf",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["Barrels3"] = {
		levelName = "Rainbow Boulders",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			modeSpins8 = true,
            hasCrates = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    frequencies = {1,1,1,1,1,1},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Line6",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "Line7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				[3] = {
					patternName = "Line1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[4] = {
					patternName = "Line2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[5] = {
					patternName = "Line3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[6] = {
					patternName = "Line4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[7] = {
					patternName = "Line5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"getGem",45,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",1200000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelsPattern4"] = {
		levelName = "Big Fall",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasBarrels = true,
			hasCoverage = true,
			largeBoard = true,
			modeSpins13 = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "RacingStripe1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				[2] = {
					patternName = "RacingStripe1_large",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},

	["BombTower2"] = {
		levelName = "Bomb Tower 2",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasBombs = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Tower1_block1",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},

				{
					patternName = "Tower1_block2",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},

				{
					patternName = "Tower1_block3",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
				
				{
					patternName = "Tower1_block4",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
				{
					patternName = "Tower1_block5",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				{
					patternName = "Tower1_block6",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				{
					patternName = "Tower1_block7",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
				{
					patternName = "Tower2_block1",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},

				{
					patternName = "Tower2_block2",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},

				{
					patternName = "Tower2_block3",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
				
				{
					patternName = "Tower2_block4",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
				{
					patternName = "Tower2_block5",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				{
					patternName = "Tower2_block6",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				{
					patternName = "Tower2_block7",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 25,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
		expectedScore = 100000,
	},

	["Land8_Level12"] = {
		levelName = "Vine Pot",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			hasVines = true,
			hasSteel = true,
			hasStones = true,
			largeBoard = true,
			modeSpins10 = true,
			gemTypes5 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "FlowerPot1_seed1",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "FlowerPot1_seed2",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "FlowerPot1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "FlowerPot1_side",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",750000},
				[3] = {"score",1000000},
			},
		},
	},

	["LittleBigSpin"] = {
		levelName = "The Big Spin",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins1 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = {
			{name = Config.World1Tricks_Trick1},
			{name = Config.World1Tricks_Trick2},
			{name = Config.World1Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World1Boosts,
		Properties = {
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1200000},
				[3] = {"score",2500000},
			},
		},
		expectedScore = 100000,
	},

	["GemClearStripes"] = {
		levelName = "3 Boxes",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes5 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "DoubleLineLarge", 
				isPatternSet = false,
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
				reelPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 4,
					},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Purple","Purples",{matchFlags = CascadeMatchFlags_CommonPiece3},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",350000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["GemCollect3"] = {
		levelName = "Mining for Rubies",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_CommonPiece5,
                    frequencies = {0,0,1,0,1,0,1,0,1,0},
				},
				[2] = {
					matchFlags = CascadeMatchFlags_CommonPiece3,
                    frequencies = {0,0,1,0,1,0,1,0,1,0},
				},
				[3] = {
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    frequencies = {0,0,1,0,1,0,1,0,1,0},
				},
				[4] = {
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    frequencies = {0,0,1,0,1,0,1,0,1,0},
				},
			}, 
		},
		goals = {
			main = {"getGem",30,"Red","Reds",{matchFlags = CascadeMatchFlags_CommonPiece4},"Collect"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},

	["Sections_missingSquares"] = {
		levelName = "Sections",					
		resource = "GameScreen_Land17",	
		Features = {
			largeBoard = true, 
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true, 
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Sections", 
				isPatternSet = false,
			},
		},		
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",75000},
				[3] = {"score",125000},
			},
		},
	},

	["TreasureBattle"] = {   -- DAVE NOTE: EXTRA LEVEL
		levelName = "Treasure Battle",
		resource = "GameScreen_Land17",
		Features = {
			splashMode = true,
			modeSpins9 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					frequencies = {3,4,9,10,15,16,21,22},
				},
				[2] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					frequencies = {2,5,8,11,14,17,20,23},
				},
				[3] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					frequencies = {1,6,7,12,13,18,19,24},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Line3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				{
					patternName = "CrateBottomBlock1_sides1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "CrateBottomBlock1_sides2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{
					patternName = "CrateBottomBlock1_middle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				{ 
					patternName = "CrateBottomBlock2_top",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["SuperWildHunt"] = {
		levelName = "Super Wild Hunt",					
		resource = "GameScreen_Land17",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 2,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 2,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 2,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 2,
                },
                {
                    name = "Yellow",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 2,
                },
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 1,
				},
			},

			additionalInitialPatterns = { 
				
			},
			additionalRegularPlacements = {
				{
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {1,1,1,1},
					matchFlags = 15,
					anyOneMatchFlag = true,
				},
			},
		},
		goals = {
			main = {"finish",0,},
			stars = {
				[1] = {"score",1500000},
				[2] = {"score",2000000},
				[3] = {"score",2500000},
			},
		},
	},

    ["MatryoshkaToggle"] = {
		levelName = "Matryoshka Toggle",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins3 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasSteel = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
                    name = "Barrel",
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					weight = 4,

                    applyExtraHits = true,
					extraHits = 1,

					applyMatchFlags = true,
					matchFlags = 0,

				},
			},
            additionalInitialPatterns = {
                {
                    patternName = "Matryoshka_Barrels",
                    isPatternSet = false,

					applyExtraHits = true,
					extraHits = 1,

                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    applyIsGemSpawner = true,
					isGemSpawner = true,

                },
                {
                    patternName = "Matryoshka_Steel",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
                },
            },
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
		},
		goals = {
			main = {"gemsRemain",0,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, extraHits=1},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},

    ["MatryoshkaToggleEvil"] = {
		levelName = "Matryoshka Toggle, Evil Edition",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins3 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasSteel = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
                    name = "Barrel",
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					weight = 4,

                    applyExtraHits = true,
					extraHits = 1,

					applyMatchFlags = true,
					matchFlags = 0,

				},
			},
            additionalInitialPatterns = {
                {
                    patternName = "Matryoshka_Barrels",
                    isPatternSet = false,

					applyExtraHits = true,
					extraHits = 1,

                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    applyIsGemSpawner = true,
					isGemSpawner = true,

                },
                {
                    patternName = "Matryoshka_Steel",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
                },
            },
		},
		goals = {
			main = {"gemsRemain",0,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, extraHits=1},},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1000000},
				[3] = {"score",2000000},
			},
		},
	},


    ["CascadeAttacks"] = {
		levelName = "Cascade Attacks",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins20 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
                    name = "Barrel",
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					weight = 4,

                    applyExtraHits = true,
					extraHits = 1,

					applyMatchFlags = true,
					matchFlags = 0,

				},
			},
            additionalRegularPlacements = {
				{
					name = "Barrel",
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
					weight = 4,

                    applyExtraHits = true,
					extraHits = 1,

					applyMatchFlags = true,
					matchFlags = 0,

				},
			},
            endGameProperties = {
                spawnGemOnBreak = {
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
		},
		goals = {
			main = {"getGem",30,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true, extraHits=0},},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",3500000},
			},
		},
	},

    ["BarrelhouseRocks"] = {
		levelName = "Barrelhouse Rocks",
		resource = "GameScreen_Land20",
        --introScript = "Land20_BarrelhouseRocks_Intro",
        --outtroScript = "Land20_BarrelhouseRocks_Outtro",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasStones = true,
            hasSteel = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
                {
                    name = "Orange",
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                    weight = 1,
                },
			},
            additionalInitialPatterns = {
                {
					patternName = "BarrelhouseRocks_Barrels",
					isPatternSet = false,

					applyExtraHits = true,
					extraHits = 1,

                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    applyIsGemSpawner = true,
					isGemSpawner = true,
				},
                {
					patternName = "BarrelhouseRocks_Steel",
					isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
                {
                    patternName = "JailhouseRocks_Stones",
                    isPatternSet = false,

					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
                },
            },
		},
		goals = {
			main = {"getGem",2,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",200000},
				[3] = {"score",500000},
			},
		},
	},

    ["MultiJailrelBlitz"] = {
		levelName = "Multi-Jailrel Blitz",
		resource = "GameScreen_Land20",
        introScript = "Land20_MultiJailrelBlitz_Intro",
        outtroScript = "Land20_MultiJailrelBlitz_Outtro",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            spawnGemOnBreak = {
                {
                    name = "Super Wild",
                    matchFlags = CascadeMatchFlags_Wildcard,
                    specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                    weight = 8,
                },
			},
            additionalInitialPatterns = {
                {
					patternName = "MultiJailrelBlitz_Jails",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
					patternName = "MultiJailrelBlitz_Barrels",
					isPatternSet = false,

					applyExtraHits = true,
					extraHits = 1,

                    applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
                    applyIsGemSpawner = true,
					isGemSpawner = true,
				},
            },
		},
		goals = {
			main = {"gemsRemain",0,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",1000000},
			},
		},
	},

	["BattleTime1"] = {
		levelName = "Battle Time!",					
		resource = "GameScreen_Land21",		
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasCoverage = true,
			hasCrates = true,
			gemTypes5 = true, 
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Always Amber",
					delay = 0,
					{
						name = "Blue Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyMatchFlags = false,
						cancelSpecials = CascadePieceSpecials_Amber,
						applyCancelSpecials = true,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Amber,
						weight = 1,
					},
					{
						name = "Green Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyMatchFlags = false,
						cancelSpecials = CascadePieceSpecials_Amber,
						applyCancelSpecials = true,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Amber,
						weight = 1,
					},
					{
						name = "Purple Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyMatchFlags = false,
						cancelSpecials = CascadePieceSpecials_Amber,
						applyCancelSpecials = true,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Amber,
						weight = 1,
					},
					{
						name = "Red Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						applyMatchFlags = false,
						cancelSpecials = CascadePieceSpecials_Amber,
						applyCancelSpecials = true,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Amber,
						weight = 1,
					},
					{
						name = "Yellow Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						applyMatchFlags = false,
						cancelSpecials = CascadePieceSpecials_Amber,
						applyCancelSpecials = true,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Amber,
						weight = 1,
					},
					--[[
					delay = 0,
					{
						name = "Always Amber",
						weight = 1,
						applyMatchFlags = false,
						cancelSpecials = CascadePieceSpecials_Amber,
						applyCancelSpecials = true,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Amber,
					},
					--]]
				},
				[2] = {
					name = "Coconuts",
					delay = 0,
					events = { --When there are less than 3 coconuts, make 1 coconut and then stop
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "population",
							count = 3,
							comparator = "less",
							newDelay = 1,
							cooldown = 1,
							gemType = {
								specials = CascadePieceSpecials_Coconut,
							},
						},
					},
					{ 
						name = "Coconut",
						matchFlags = 0,
						specials = CascadePieceSpecials_Coconut,
						weight = 8,
						applyIsGemSpawner = true,
						isGemSpawner = true,
						spawnTypes = {"Always Horizontal Burst"},

					},
				},
				[3] = {
					name = "Always Horizontal Burst",
					delay = 0,
					{
						name = "Blue Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Green Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Purple Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Red Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					{
						name = "Yellow Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					--[[
					{
						name = "Orange Horizontal",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 1,
					},
					--]]
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Maker_TopLeft1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Horizontal Burst"},
				},
				{
					patternName = "Maker_TopRight1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Amber"},
				},
				{
					patternName = "Line_Right1",
					isPatternSet = false,
					applyMatchFlags = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Always Horizontal Burst",
						delay = -1,
					},
					[2] = {
						name = "Always Amber",
						delay = -1,
					},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Amber","Ambers",{specials = CascadePieceSpecials_Amber},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",800000},
			},
		},
	},

	["BombEater"] = {
		levelName = "Bomb Eater",
		resource = "GameScreen_Land22",	
		Features = {
			splashMode = true,
			modeSpins7 = true,
			hasBombs = true,
			hasStones = true,
			hasGemEaters = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = TricksDefault,  
		boosts = World22Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "2RightReels", 
				isPatternSet = false,
            },
			additionalInitialPatterns = {
				{
					patternName = "Tower1_block7",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 30,
				},
				{
					patternName = "CornerSteel_bottomRight",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					applyMatchRequirement = false,
				},
				{
					patternName = "Tower1_block1",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "BombEater_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover},"Defuse"},
			stars = {
				[1] = {"score",75000},
				[2] = {"score",100000},
				[3] = {"score",160000},
			},
		},
		expectedScore = 100000,
	},

	["StoneBarrier"] = {
		levelName = "Stone Barrier",
		resource = "GameScreen_Land24",		
		Features = {
			splashMode = true,
			modeSpins6 = true,
			hasStones = true,
			hasCoverage = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World24Boosts,
		Properties = {
		useMissingSquares = true,
			missingSquares = {
				patternName = "Rows35_large", 
				isPatternSet = false,
            },
			portals = {
				[1] = {{0,1},{0,5},"PortalEntrance_1","PortalExit_1"},
				[2] = {{1,1},{1,5},"PortalEntrance_1","PortalExit_1"},
				[3] = {{2,1},{2,5},"PortalEntrance_1","PortalExit_1"},
				[4] = {{3,1},{3,5},"PortalEntrance_1","PortalExit_1"},
				[5] = {{4,1},{4,5},"PortalEntrance_1","PortalExit_1"},
				[6] = {{5,1},{5,5},"PortalEntrance_1","PortalExit_1"},
				[7] = {{6,1},{6,5},"PortalEntrance_1","PortalExit_1"},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "MiddleLine_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone, skinVariant = "Stone"},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",350000},
				[3] = {"score",450000},
			},
		},
		expectedScore = 100000,
	},

    ["LetItGrow"] = {
		levelName = "Let It Grow",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasIce = true,
            hasVines = true,
            hasMakers = true,
            hasMissingSquares = true,
            hasMissingReels = true,
            hasCoconuts = true,
		},
		Properties = {
            useMissingSquares = true,
			missingSquares = {
				patternName = "LetItGrow_Missing",
				isPatternSet = false,
			},
            useMissingReels = true,
			missingReels = {
				patternName = "LetItGrow_Reels",
				isPatternSet = false,
			},
            additionalNamedMixes = {
                {
                    name = "Coconut Mix",
					{
                        name = "Coconut",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Coconut,
                        applyIsGemSpawner = true,
                        isGemSpawner = true,
                        weight = 1,
                    },
                    {
						name = "1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
                    {
						name = "2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
                    {
						name = "3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
                    {
						name = "4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
                    {
						name = "5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
                },
                {
                    name = "Ice Mix",
                    {
                        name = "Ice 1",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 3,
                    },
                    {
                        name = "Ice 2",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 3,
                    },
                    {
                        name = "Ice 3",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 3,
                    },
                    {
                        name = "Ice 4",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 3,
                    },
                    {
                        name = "Ice 5",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 3,
                    },
                },
			},
            spawnGemOnBreak =
            {
                {
					name = "Vine 1",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Vine 2",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Vine 3",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Vine 4",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
                {
					name = "Vine 5",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 1,
				},
            },
			additionalInitialPatterns = {
				{
					patternName = "LetItGrow_MakersCoconuts",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Coconut Mix",},
					applySkinVariant = true,
					skinVariant = "",
				},
                {
					patternName = "LetItGrow_MakersIce",
					isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Ice Mix",},
					applySkinVariant = true,
					skinVariant = "",
				},
                {
					patternName = "LetItGrow_Steel",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
                {
					patternName = "LetItGrow_Coconuts",
					isPatternSet = false,
                    applyMatchFlags = true,
                    applyPieceSpecials = true,
					matchFlags = 0,
                    specials = CascadePieceSpecials_Coconut,
                    applyIsGemSpawner = true,
                    isGemSpawner = true,
				},
                {
					patternName = "LetItGrow_Ice",
					isPatternSet = false,
                    applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
			},
		},
		goals = {
			main = {"haveGem",7,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",400000},
				[3] = {"score",700000},
			},
		},
	},

	["CreepingChill"] = {
		levelName = "Creeping Chill",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			regularBoard = true,
			gemTypes4 = true,
            hasMissingReels = true,
            hasIce = true,
		},
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "RightReels", 
				isPatternSet = false,
            },
			useMissingSquares = true,
            missingSquares = {
				patternName = "TopRightCorner", 
				isPatternSet = false,
            },

			additionalInitialPatterns = { 
				[1] = {
					patternName = "RightColumn1",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				[2] = {
					patternName = "RightColumn2",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				[3] = {
					patternName = "RightColumn3",
					isPatternSet = false,
					applyPieceSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ice.singular","Ice.plural",{spreadSpecials = CascadePieceSpecials_Ice},},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",1500000},
			},
		},
	},
	["BalloonPumper"] = {
        --Match colored keygems (from board mix) to create balloons. Get N Balloons.
        levelName = "Balloon Pumper",
        resource = "GameScreen_Land29",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins6 = true,
            gemTypes5 = true,

            hasColoredKeyGems = true,
            hasBalloons = true,
        },
        tricks = World29Tricks,
        boosts = World29Boosts,
        Properties = {
            addToBoardPieceMix = {
                {
                    name = "Blue Keys 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeBlueBalloon1"},
                    weight = 0.3,  
                },
                {
                    name = "Green Keys 1",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeGreenBalloon1"},
                    weight = 0.3,  
                },
                {
                    name = "Purple Keys 1",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakePurpleBalloon1"},
                    weight = 0.3,  
                },
                {
                    name = "Red Keys 1",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeRedBalloon1"},
                    weight = 0.3,  
                },
                {
                    name = "Yellow Keys 1",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeYellowBalloon1"},
                    weight = 0.3,  
                },

                -- --set #2
                {
                    name = "Blue Keys 2",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeBlueBalloon2"},
                    weight = 0.3,  
                },
                {
                    name = "Green Keys 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeGreenBalloon2"},
                    weight = 0.3,  
                },
                {
                    name = "Purple Keys 2",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakePurpleBalloon2"},
                    weight = 0.3,  
                },
                {
                    name = "Red Keys 2",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeRedBalloon2"},
                    weight = 0.3,  
                },
                {
                    name = "Yellow Keys 2",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeYellowBalloon2"},
                    weight = 0.3,  
                },

                -- --set #3
                {
                    name = "Blue Keys 3",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeBlueBalloon3"},
                    weight = 0.3,  
                },
                {
                    name = "Green Keys 3",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeGreenBalloon3"},
                    weight = 0.3,  
                },
                {
                    name = "Purple Keys 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakePurpleBalloon3"},
                    weight = 0.3,  
                },
                {
                    name = "Red Keys 3",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeRedBalloon3"},
                    weight = 0.3,  
                },
                {
                    name = "Yellow Keys 3",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_CantCover,
                    applyIcon = true,
                    icon = "Icon_PickAxe",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeYellowBalloon3"},
                    weight = 0.3,  
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "MakeBlueBalloon1",
                    patternName = "MakeItRain_Rand1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    addPieces = true,
                },
                {
                    entryName = "MakeGreenBalloon1",
                    patternName = "MakeItRain_Rand2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    addPieces = true,
                },
                {
                    entryName = "MakePurpleBalloon1",
                    patternName = "MakeItRain_Rand3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    addPieces = true,
                },
                {
                    entryName = "MakeRedBalloon1",
                    patternName = "MakeItRain_Rand4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    addPieces = true,
                },
                {
                    entryName = "MakeYellowBalloon1",
                    patternName = "MakeItRain_Rand5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    addPieces = true,
                },

                --set #2
                {
                    entryName = "MakeBlueBalloon2",
                    patternName = "MakeItRain_Rand3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    addPieces = true,
                },
                {
                    entryName = "MakeGreenBalloon2",
                    patternName = "MakeItRain_Rand4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    addPieces = true,
                },
                {
                    entryName = "MakePurpleBalloon2",
                    patternName = "MakeItRain_Rand5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    addPieces = true,
                },
                {
                    entryName = "MakeRedBalloon2",
                    patternName = "MakeItRain_Rand1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    addPieces = true,
                },
                {
                    entryName = "MakeYellowBalloon2",
                    patternName = "MakeItRain_Rand2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    addPieces = true,
                },

                --set #3
                {
                    entryName = "MakeBlueBalloon3",
                    patternName = "MakeItRain_Rand5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    addPieces = true,
                },
                {
                    entryName = "MakeGreenBalloon3",
                    patternName = "MakeItRain_Rand1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    addPieces = true,
                },
                {
                    entryName = "MakePurpleBalloon3",
                    patternName = "MakeItRain_Rand2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    addPieces = true,
                },
                {
                    entryName = "MakeRedBalloon3",
                    patternName = "MakeItRain_Rand3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    addPieces = true,
                },
                {
                    entryName = "MakeYellowBalloon3",
                    patternName = "MakeItRain_Rand4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    addPieces = true,
                },
            },
        },
        goals = {
            main = {"getGem",15,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
            stars = {
                [1] = {"score",25000},
                [2] = {"score",50000},
                [3] = {"score",75000},
            },
        },
        expectedScore = 100000, 
    },

	["ImpactTremors"] = {
		levelName = "Impact Tremors",					
		resource = "GameScreen_Land29",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			hasMakers = true,
			--largeBoard = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Boulders",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					--extraHits = 1,
					weight = 11,
				},
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 8,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 8,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 8,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 8,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 8,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Keygems",
					delay = 0,
					{
						name = "Wild Keygem 1",
						isPatternSet = false,
						applyMatchFlags = true,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyMatchPatterns = true,
						matchPatterns = {"Left Stomp"},
						matchFlags = CascadeMatchFlags_Wildcard,
						--matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Wild Keygem 2",
						isPatternSet = false,
						applyMatchFlags = true,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyMatchPatterns = true,
						matchPatterns = {"Right Stomp"},
						matchFlags = CascadeMatchFlags_Wildcard,
						--matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Blue Keygem",
						isPatternSet = false,
						applyMatchFlags = true,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyMatchPatterns = true,
						matchPatterns = {"Left Stomp"},
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 0,
					},
					{
						name = "Green Keygem",
						isPatternSet = false,
						applyMatchFlags = true,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyMatchPatterns = true,
						matchPatterns = {"Left Stomp"},
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 0,
					},
					{
						name = "Purple Keygem",
						isPatternSet = false,
						applyMatchFlags = true,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyMatchPatterns = true,
						matchPatterns = {"Right Stomp"},
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 0,
					},
					{
						name = "Red Keygem",
						isPatternSet = false,
						applyMatchFlags = true,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyMatchPatterns = true,
						matchPatterns = {"Right Stomp"},
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 0,
					},
				},
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Left Stomp",
					patternName = "ImpactTremors_leftStomp",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Right Stomp",
					patternName = "ImpactTremors_rightStomp",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "ImpactTremors_leftMaker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Keygems"},
					applyIcon = true,
				},
				[2] = {
					patternName = "ImpactTremors_rightMaker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Keygems"},
					applyIcon = true,
				},
				[3] = {
					patternName = "ImpactTremors_void",
					clearPieces = true,
					isPatternSet = false,
				},
				--[[
				[7] = {
					patternName = "Parfait_redKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Wall"},
				},
				[4] = {
					patternName = "Parfait_leftSwitch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
				},
				--]]
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	["DigDigDig"] = {
		levelName = "Dig Dig Dig",					
		resource = "GameScreen_Land29",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasColoredKeyGems = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Red Wall",
					patternName = "DigDigDig_Wall1",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Remove Blue Wall",
					patternName = "DigDigDig_Wall2",
					isPatternSet = false,
					applyIcon = true,
					clearPieces = true,
				},
			
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "DigDigDig_Wall1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "DigDigDig_Wall2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "DigDigDig_RedKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Wall"},
				},
				[4] = {
					patternName = "DigDigDig_BlueKey",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Wall"},
				},
				[5] = {
					patternName = "DigDigDig_Wall4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
				},
				[6] = {
					patternName = "DigDigDig_Wall5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = false,
					extraHits = 1,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bedrock.singular","Bedrock.plural",{specials = CascadePieceSpecials_Steel,},},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

    --This level was overwritten by BombFalling1 (Land 7)
    ["BombFalling1_alt"] = {
        levelName = "Bomb d'bomb",
        resource = "GameScreen_Land1",      
        Features = {
            splashMode = true,
            modeSpins7 = true,
            hasBombs = true,
            regularBoard = true,
            gemTypes5 = true,
        },
        tricks = TricksDefault,  --was: Tricks_SpinNow,
        boosts = World7Boosts,
        Properties = {
            additionalRegularPlacements = {
                [1] = {
                    matchFlags = 31,
                    anyOneMatchFlag = true,
                    specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                    frequencies = {1,2,3,4,5,6,7,8,9,10},
                },
            },
        },
        goals = {
            main = {"getGem",10,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},"Defuse"},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",100000},
                [3] = {"score",200000},
            },
        },
        expectedScore = 100000,
    },

    ["Land18Side4_side_v2"] = {
		levelName = "Quadruple Mini Checkerboards",
		resource = "GameScreen_Land18",		
		Features = {
			splashMode = true,
			modeSpins999 = true,
			hasChests = true,
			hasMakers = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSteel = true,
			hasFences = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			gemsMoveDiagonally = false,
			reelPieceMix = {
				{
					name = "Rainbow",
					weight = 1,
					matchFlags = CascadeMatchFlags_Wildcard,
				}
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "18-4_Missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "ReelPosition4",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "18-4_MakerA",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,

					applySpawnBelowTypes = true,
					spawnBelowTypes = {"RedAlternating", "GreenAlternating"},
				},
				{
					patternName = "18-4_MakerB1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "18-4_MakerC1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
				},
				{
					patternName = "18-4_MakerD1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
				},
			},
			additionalNamedMixes = {
				{
					name = "RedAlternating",
					delay = 0,
					events = {
						[1] = {
							eventType = "getGem",
							newDelay = 1,
							cooldown = 1,
							gemType = {
							},
						},
						[2] = {
							eventType = "emitCount",
							newDelay = -1,
							count = 1,
							reset = true,
						},
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
				{
					name = "GreenAlternating",
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
				},
				{
					name = "BlueAlternating",
				},
				{
					name = "PurpleAlternating",
				},
			},
		},
		goals = {
			main = {"getGem",16,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",750000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000,
	},

	["HighTideLowTide"] = {
		levelName = "High Tide Low Tide",
		resource = "GameScreen_Land34",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasGemEaters = true,
			hasSteelBoulders = true,
			hasPortals = true,
		},
		tricks = World33Tricks,
		boosts = World33Boosts,
		Properties = {
			additionalNamedPatterns = ExecuteInline(
				function ()
					local namedPatterns = {}

					for i = 1,4 do
						namedPatterns[#namedPatterns+1] = {
							entryName = "HighTide" .. i,
							patternName = "HighTideLowTide_" .. i,
							addPieces = true,
							replacePieces = {"HighTide" .. i},
						}

						namedPatterns[#namedPatterns+1] = {
							entryName = "LowTide" .. i,
							patternName = "HighTideLowTide_" .. i,
							addPieces = true,
							replacePieces = {"LowTide" .. i},
						}
					end

					return namedPatterns
				end
			),
			additionalNamedMixes = ExecuteInline(
				function ()
					local namedMixes = {
						{
							name = "HighTideEvent",
							cooldowns = {1},
							events = {
								{
									eventType = "getGem",
									gemType = {},
									cooldown = 31,
									patterns = {"HighTide1", "HighTide2", "HighTide3", "HighTide4"},
								},
							},
						},
						{
							name = "LowTideEvent",
							cooldowns = {17},
							events = {
								{
									eventType = "getGem",
									gemType = {},
									cooldown = 31,
									patterns = {"LowTide1", "LowTide2", "LowTide3", "LowTide4"},
								},
							},
						}
					}
					
					-- Each row in these weight tables corresponds to the weights in a piece mix
					-- The numbers correspond to the weights of {blue gems, 1 hit stone, 2 hit stone, 3 hit stone}, respectively
					-- The 5th number in the bottom two rows correspond to the weights of the regular gems
					local highTideWeights = {
						{10, 2, 2, 2},
						{5, 2, 2, 1},
						{3, 3, 2, 1, 2},
						{5, 3, 1, 1, 5},
					}
					
					-- The numbers correspond to the weights of {blue gems, 1 hit stone}, respectively
					-- The third number corresponds to the weights of normal gems and/or gems with rings
					local lowTideWeights = {
						{10, 20, 5},
						{5, 10, 20},
						{1, 1, 50},
						{1, 1, 100},
					}

					for i = 1,4 do
						local highTideMix = {
							name = "HighTide" .. i,
							{
								name = "Water",
								matchFlags = CascadeMatchFlags_CommonPiece1,
								weight = highTideWeights[i][1],
							},
							{
								name = "Stone",
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								weight = highTideWeights[i][2],
							},
							{
								name = "Stone2",
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								extraHits = 1,
								weight = highTideWeights[i][3],
							},
							{
								name = "Stone3",
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								extraHits = 2,
								weight = highTideWeights[i][4],
							},
						}
						
						local lowTideMix = {
							name = "LowTide" .. i,
							{
								name = "Water",
								matchFlags = CascadeMatchFlags_CommonPiece1,
								weight = lowTideWeights[i][1],
							},
							{
								name = "Stone",
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								weight = lowTideWeights[i][2],
							},
						}
						
						-- Adding normal gems (and rings) to piece mixes
						if i > 2 then
							AddColorsToPieceMix(highTideMix, {2, 3, 4, 5}, {
								name = "Gem",
								weight = highTideWeights[i][5]
							})

							AddColorsToPieceMix(lowTideMix, {1, 2, 3, 4, 5}, {
								name = "Gem",
								weight = lowTideWeights[i][3]/5
							})
						else
							AddColorsToPieceMix(lowTideMix, {1, 2, 3, 4, 5}, {
								name = "Gem",
								weight = lowTideWeights[i][3]/10
							})
							
							AddColorsToPieceMix(lowTideMix, {1, 2, 3, 4, 5}, {
								name = "Ring",
								weight = lowTideWeights[i][3]/10,
								icon = "Icon_Marked",
							})
						end

						namedMixes[#namedMixes+1] = highTideMix
						namedMixes[#namedMixes+1] = lowTideMix
					end

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "HighTideLowTide_Board",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 7,
				},
				--[[
				{
					patternName = "HighTideLowTide_Maker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"HighTideEvent"},
				},
				{
					patternName = "HighTideLowTide_Maker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"LowTideEvent"},
				},
				--]]
			},
		},
		goals = {
			main = {"getGem", 10, "Ring","Rings", {icon = "Icon_Marked"},},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
	},	

    ["BreachTheHull"] = {
        levelName = "Breach The Hull",
        resource = "GameScreen_Land34",
        Features = {
            largeBoard = true,
            splashMode = true,
            modeSpins4 = true,
            hasStones = true,
            hasCrates = true,
        },
        tricks = World34Tricks,
        boosts = World34Boosts,
        Properties = {
            additionalInitialPatterns = {
                {
                    patternName = "BreachTheHull_GemEater",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyExtraHits = true,
                    extraHits = 2,
                },
                {
                    patternName = "BreachTheHull_Stones",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    patternName = "BreachTheHull_Crates",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Crates,
                    applyMatchFlags = true,
                    matchFlags = 0,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone},},
            stars = {
                [1] = {"score",1000000},
                [2] = {"score",2000000},
                [3] = {"score",3000000},
            },
        },
    },

    ["StoneEater"] = {
        levelName = "Getting Hotter",
        resource = "GameScreen_Land34",
        Features = {
            modeSpins8 = true,
            splashMode = true,
            gemTypes5 = true,
            largeBoard = true,
            hasGemEaters = true,
            hasInedibleGems = true,
            hasSteelBoulders = true,
        },
        tricks = World34Tricks,
        boosts = World34Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "Ice2Inedible",
                    patternName = "TestCoverage2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Inedible_Bar,
                    applySpreadSpecials = true,
                    spreadSpecials = 0,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Inedible_Bar,
                    filter = {
                        cancelSpecials = CascadePieceSpecials_Ice
                    },
                },
                {
                    entryName = "Inedible2Lava",
                    patternName = "TestCoverage2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Lava,
                    applyCancelSpecials = true,
                    cancelSpecials = 0,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    filter = {
                        specials = CascadePieceSpecials_Inedible_Bar,
                    },
                },
            },
            additionalNamedMixes = {
                {
                    name = "Switch",
                    {
                        name = "Switch",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        spawnTypes = {"Switch"},
                        matchPatterns = {"Inedible2Lava", "Ice2Inedible"},
                        skinVariant = "Switch1_Toggle",
                        weight = 1,
                    },
                },
                {
                    name = "StoneMix",
                    {
                        name = "1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        weight = 1,
                    },
                    {
                        name = "2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        extraHits = 1,
                        weight = 1,
                    },
                    {
                        name = "3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        extraHits = 2,
                        weight = 1,
                    },
                    {
                        name = "4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        extraHits = 3,
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "StoneEater_IceMakers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySpreadSpecials = true,
                    spreadSpecials = CascadePieceSpecials_Ice,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySkinVariant = true,
                    skinVariant = "IceMaker",
                },
                {
                    patternName = "StoneEater_IceMakers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                },
                {
                    patternName = "LargeRow_6",
                    isPatternSet = false,
                    applyGemEater = true,
                    gemEater = true,
                },
                {
                    patternName = "Large 7,3",
                    isPatternSet = false,
                    replacePieces = {"Switch"},
                },
            },
        },
        goals = {
            main = {"eatGem", 30, "Lava","Lava", {specials = CascadePieceSpecials_Lava},},
            stars = {
                [1] = {"score",25000},
                [2] = {"score",50000},
                [3] = {"score",75000},
            },
        },
    },

})