local btnShowTodoFeedWidth = 24
local btnShowTodoFeedHeight = 50
local btnShowTodoFeedRotation = 0
local btnShowTodoFeedOffsetX = -(btnShowTodoFeedWidth + btnShowTodoFeedHeight) / 2
if (btnShowTodoFeedRotation == 0) then
    btnShowTodoFeedOffsetX = -btnShowTodoFeedWidth
end


Resources.MapResourceIcon = Resources.Actor:new {
    resource = "Actor",
    class = "MapResourceIcon",
}

Resources.DefaultLevelProperties = Resources.Actor:new {
	resource = "Actor",
	image = "btnLevel.png", --just to get matching size of MainButton
	alpha = 0,
	zorder = 2,
	alignment = "TopLeft",
	alignTo = "TopLeft",
	PathContainer = Resources.Actor:new {
		Path = Resources.Actor:new {
			image = "Path.png",
			alignmentOffset = {39,27},
			alignment = MidBottom,		
			alignTo = TopLeft,	
			rotationAngle = { degrees = 0 },	
			rotationPoint = "MidBottom",
			zorder = -1,
			visible = true,
		},
	},
	
	MainButton = Resources.AppMenuButton:new {
		resource = "AppMenuButton",
		image = "btnLevel.png",
		text = STRINGS("asdf"),
		textAlignmentOffset = {-2,2},
		alpha = 255,
		textWidthLimit = 46,
		font	= Resources.MapButtonFont:new{
			resource = "MapButtonFont",
			fontSize = 32,
		},
		SelectionHighlight = Resources.Actor:new {
			image = "Check.png",
			zorder = -1,
			alignment = TopLeft,		
			alignTo = TopLeft,		
			alignmentOffset = {-12,-12},	
			zorder = 1,
			visible = false,
		},
		Lock = Resources.Actor:new {
			resource = "Actor",
			image = "FeatureLock.png",
			alignment = Center,
			alignTo = MidRight,
			alignmentOffset = {0,0},
		},
		PickAxe = Resources.Actor:new {
			resource = "Actor",
			image = "PickAxe.png",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0,0},
			visible = false,
		},
	},
}

Resources.NoteLabel = Resources.Label:new {
	resource = "Label",
	fgColor = "White",
	alignment = MidTop,
	alignTo = MidBottom,
	alignmentOffset = {4,-70},
	font = Resources.DialogTitleFont:new {
		resource = "DialogTitleFont",
		fontSize = 20,
	},
	fgColor = "Black",
	--shadowColor = "Black",
	--shadowAlpha = 50,
	--shadowOffset = {1,1},
	--lineSpacing = 10,

}

local mapBorder = 10
local mapHeight = 2000 + 500
local mapWidth = 300 -- This should fit 100 levels right now
local landHeight = 400
local landWidth = 280

Resources.LandArea = Resources.Actor:new {
	resource = "Actor",
	color = "White",
	size = {landWidth,landHeight},
	alignment = "BottomLeft",
	alignTo = "BottomLeft",
	visible = true,
	scripts = {"SparkleRandomly"},
	alpha = 125,
	StarsTexture = Resources.Actor:new {
		resource = "Actor",
		image = "StarsTexture.png",
		alpha = 0,
		alignment = "BottomLeft",
		alignTo = "BottomLeft",
		visible = true,
		autoFillParent = true,
	},
	BorderTexture = Resources.Actor:new {
		resource = "Actor",
		image = "BorderTexture.png",
		--alpha = 200,
		alignment = "BottomLeft",
		alignTo = "BottomLeft",
		visible = false,
		autoFillParent = true,
		zorder = 10,
	},
}

Resources.LandArea_tall = Resources.LandArea:new {
	resource = "LandArea",
	size = {landHeight,landWidth},
}

Resources.LandObject = Resources.Actor:new {
	resources = "Actor",
	visible = false,
	scripts = {"SparkleRandomly"},
}

Resources.MapToken = Resources.Actor:new {
	resource = "Actor",
	zorder = 1000,
	
	PlayerPicture = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		image = "PlayerPic_Empty.png",
		defaultImage = "PlayerPic_Empty.png",
		zorder = 2,
		size = {30, 30},
		extraScale = 0.80,
		resizeOnSetImage = false,
		mouseEnabled = false,
		PlayerFrame = Resources.Actor:new {
			image = "FriendFrame_Regular.png",
			zorder = 1,
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {1,4},
		},
	},
	visible = true,
	
}

Resources.PlayerToken = Resources.MapToken:new {
	resource = "MapToken",
	layer = 2,
	CharacterMarker = Resources.CharacterMarker:new {
		resource = "CharacterMarker",
		visible = true,
		zorder = 1,
		alignmentOffset = {5+10,-14},
	},
	Glow = Resources.Actor:new {
		resource = "Actor",
		image = "Glow.png",
		alignment = "Center",
		alignmentOffset = {-5+10,-15},
		zorder = 0,
		scripts = {
			function (self)
				local revolutionsPerSecond = 0.025
				RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
			end,
		},
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		alpha = 100,
		extraScale = 0.75,
	},

	Glow2 = Resources.Actor:new {
		resource = "Actor",
		image = "Glow.png",
		alignment = "Center",
		alignmentOffset = {-5+10,-15},
		zorder = 0,
		scripts = {
			function (self)
				local revolutionsPerSecond = 0.025
				RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
			end,
		},
		--shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		alpha = 50,
		visible = true,
		extraScale = 0.75,
	},	
}

Resources.FriendToken = Resources.MapToken:new {
	resource = "MapToken",

	PlayerPicture = Resources.Actor:new {
		resource = "Actor",
		image = "PlayerPic_Empty.png",
		defaultImage = "FriendPic_Empty.png",
		zorder = 2,
		PlayerFrame = Resources.Actor:new {
			image = "FriendFrame_Regular.png",
			zorder = 1,
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {1,4},
		},
	},
}

Resources.MessagesButton = Resources.Button:new {
	resource = "Button",
	image = "MailIcon_heart.png",
	useFrames = false,
	--[[numMessages = Resources.Label:new {
		resource = "Label",
		text = STRINGS("5"),
		alignmentOffset = {74,25},
		alignment = "Center",
	},--]]
}


Scripts.BackAndForthWiggle = function(actor)
	if(actor:GetTaggedScriptCount("BackAndForthWiggle") > 1) then 
		return
	end
	local speed = 1200
	local amount = 20
	while(true)do
		RotateByAmount(actor,{degrees=-amount/2},speed/2,true)
		RotateByAmount(actor,{degrees=amount},speed,true)
		RotateByAmount(actor,{degrees=-amount/2},speed/2,true)
	end
end

Resources.MapScreen = {
	deviceOrientation = "Portrait",
	screenShouldPromptForPlayerChoice = true,
	color = "Seven_Blue",
	alpha = 0,

    memoryUsageButton = Resources.Button:new {
        resource = "Button",
        text = STRINGS(""),
        image = "",
        alpha = 128,
        color = "White",
        size = {40,40},
        alignment = TopRight,
        layer = 10,
		OnButtonClick = function (self, event)
			if self ~= event.button then 
                return false 
            end
            LogVideoMemoryUsage()
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
        visible = false,
    },

	loadingLayer = Resources.LoadingLayer:new {
		resource = "LoadingLayer",
	},

	-- Use of frame - I use this frame so I can easily slide on off the button while maintaining its default position at (0,0) instead of a random number depending on where frame gets put
	ReturnToSpotButton_Frame = Resources.Actor:new {  
		resource = "Actor",
        extraScale = 0.80,
		image = "Jasper_Locate_Button_flipped.png",
		alpha = 0,
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = Layout{{-43, -120}, iphone5={-43, -120}, ipad={-43, -120}},
		zorder = 20,
		layer = 8,
		zorder = 2,
		visible = true,

		ReturnToSpotButton = Resources.AppButton:new {
			resource = "AppButton",
			image = "Jasper_Locate_Button_flipped.png",
			useFrames = false,
			alignment = "Center",
			zorder = 20,
			layer = 8,
			visible = false,
			position = {0,-50}, -- start off frame
		},
	},



	ButtonsPanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "BottomRight",
		alignmentOffset = Layout{{-34, -200}, iphone5={-34, -200}, ipad={-34, -200}},

        PowerupWheelButton = Resources.AppButton:new {
            resource = "AppButton",
            image = "IconPowerupWheel.png",
            useFrames = false,
            --alignment = "TopLeft",
            alignment = "TopLeft",
            alignmentOffset = {4,40},
            size = {40,40},
            zorder = 20,
            layer = 5,
            visible = false,

            withMessagesButtonPosition = {10+152, 10},
            noMessagesButtonPosition = {10+106, 10},
            withMessagesAndGoldButtonPosition = {10+202, 10},
            noMessagesAndGoldButtonPosition = {10+156, 10},
        },
	},

    TopBar = Resources.TopBar:new {
		resources = "TopBar",
	},

    TopBar_SpecialGems = Resources.TopBar_SpecialGems:new {
		resources = "TopBar_SpecialGems",
	},

	InviteFriendsButton = Resources.AppButton:new {
		resources = "AppButton",
		image = "IconInviteFriends.png",
		useFrames = false,
		alignment = "TopLeft",
		alignmentOffset = {10, 56},
		zorder = 20,
		layer = 5,
		visible = false,

		OnButtonClick = function (self, event)
			if self ~= event.button then
			return false
			else
			self.screen:ShowInviteFriendsDialog()
			return true
			end
		end,

		withMessagesButtonPosition = {10, 102},
		noMessagesButtonPosition = {10, 56},
		withMessagesAndGoldButtonPosition = {10, 152},
		noMessagesAndGoldButtonPosition = {10, 106},
		--scripts = {"BackAndForthWiggle"},
	},

	RingStoreButton = Resources.AppMenuSmallSignButton:new {
		resources = {"AppMenuSmallSignButton", "ConfigKeyAwareView"},
		alignment = "TopRight",
		alignmentOffset = {-4, 6},
		zorder = 20,
		text = STRINGS("Ring Store"),
		layer = 5,
		visible = false,
		configKey = "RingStore_Enabled",
		configKeyAwareProperties = {
			[true] = { visible = true },
			[false] = { visible = false },
			_default = { visible = false },
		},
		OnPostSpawn = function (self)
			Resources.ConfigKeyAwareView.InitConfigKeyAwareView(self)
		end,
	},

	LandMap = Resources.LandMap:new {
		resource = "LandMap",
	},

	DebugKeysButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "DebugKeys.png",
		shortcutKey = "?",
		alignment = "BottomRight",
		alignTo = "BottomRight",
		--alignmentOffset = Layout{{-6, -2}, iphone5={-6, -3+3}, ipad={0, -3+3}},
		--alignmentOffset = {-45,-3},
		alignmentOffset = {-6+20,-50-100},
		zorder = 20,
		visible = IsDebugUIAllowed(),
		layer = 5,
		alpha = 128,
		useFrames = false,
		OnButtonClick = function (self, event)
			if self ~= event.button then
			return false
			else
				local setVisible = not self.parent.NextLevelButton.visible
				self.parent.NextLevelButton.visible = setVisible
				self.parent.PreviousLevelButton.visible = setVisible
				self.parent.RandomizeChallengeButton.visible = setVisible
				self.parent.ClearChallengeButton.visible = setVisible
				self.parent.UnlockLevelsButton.visible = setVisible
			return true
			end
		end,
	},

	NextLevelButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "btnRightArrow.png",
		shortcutKey = "?",
		alignment = "BottomRight",
		alignTo = "BottomRight",
		--alignmentOffset = Layout{{-6, -2}, iphone5={-6, -3+3}, ipad={0, -3+3}},
		--alignmentOffset = {-45,-3},
		alignmentOffset = {-2-50,-100},
		zorder = 20,
		visible = false,--IsDebugUIAllowed(),
		layer = 5,
		alpha = 128,
	},
	
	PreviousLevelButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "btnLeftArrow.png",
		shortcutKey = "?",
		--alignment = "BottomRight",
		--alignmentOffset = {-85,-3},
		alignmentOffset = {-2-50,-50},
		alignment = "BottomRight",
		alignTo = "BottomRight",
		--alignmentOffset = Layout{{-6, -2}, iphone5={-6, -3+3}, ipad={0, -3+3}},
		zorder = 20,
		visible = false,--IsDebugUIAllowed(),
		layer = 5,
		alpha = 128,
	},--[[]]
	
	--[[ZoomInButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "btnZoomIn.png",
		shortcutKey = "?",
		alignment = "BottomRight",
		--alignmentOffset = Layout{{-6, -3+3}, iphone5={-6, -3+3}, ipad={0, -3+3}},
		alignmentOffset = {-5,-5},
		size = {40,40},
		zorder = 20,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			local mapArea = self.parent.mapParent.mapArea
			self.parent.mapParent.mapArea:zoomIn()
			return true
		end,
	},
	
	ZoomOutButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "btnZoomOut.png",
		shortcutKey = "?",
		alignment = "BottomRight",
		alignmentOffset = {-55,-5},
		--alignmentOffset = Layout{{-6, -3+3}, iphone5={-6, -3+3}, ipad={0, -3+3}},
		size = {40,40},
		zorder = 20,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			local mapArea = self.parent.mapParent.mapArea
			self.parent.mapParent.mapArea:zoomOut()
			return true
		end,
	},]]

	HelpButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "HelpButton.png",
		shortcutKey = "?",
		functionKey = 282,--SDLK_F1
		alignment = "BottomRight",
		alignmentOffset = Layout{{-8, -5}, iphone5={-8, -5}, ipad={-8, -5}},
		--size = {40,40},

		zorder = 10,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:ShowHelp()
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 12,
		layer = 5,
		
		useFrames = false,
	},
		
    OptionsButton = Resources.Button:new {
		resource = "Button",
		image = "OptionsButton.png",
		useFrames = false,
		alignment = "BottomLeft",
		alignmentOffset = Layout{{6, -5}, iphone5={6, -5}, ipad={3, -5}},
		layer = 10,

        clickSound			= "CLEEP_B.ogg",

		textColor = "White",
        textAlignmentOffset = {0,-2},
		font = {
			fontName = "fubd____.ttf",
			fontSize = 22,
		},
		textLineSpacing = 4,
		OnButtonClick = function (self, event)
			--if self ~= event.button then return false end
			--self.screen:ShowOptionsDialog()
			--return true
			return false
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 2,
	},

	TodoFeedPanel = Resources.TodoFeedPanel:new{
		resource = "TodoFeedPanel",
        alignment = "MidRight",
		alignmentOffset = {kTodoFeedWidth,0},
        size = {kTodoFeedWidth,0},
	    layer = 1004+1, -- 1004 is topbar
		zorder = 3,
        alpha = 0,

		TaskButton = Resources.AppButton:new{
			resource = "AppButton",
			image = "ToDo_Button.png",
			text = "",
			shortcutKey = "!",
			alignment = "MidLeft",
			alignmentOffset = {btnShowTodoFeedOffsetX-10,2},
			layer = 40, --Under the dialog overlay. This puts it behind the panel, but the panel must be over dialogs to be over the topbar. Ugh.
			useFrames = false,
            rotationAngle = { degrees = btnShowTodoFeedRotation },
			clickSound = "pop3.ogg",
			showing = false,

			OnButtonClick = function (self, event)
				if self ~= event.button then return false end
                self.parent:ShowOrHide()
				return true
			end,

			OnPostSpawn = function (self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,
		},
	},

	MenuButton = Resources.AppButtonSmall_green:new {
		resource = "AppButtonSmall_green",
		text = STRINGS("Menu"),
		alignment = "MidBottom",
		layer = 5,
		alignmentOffset = Layout{{-60, -10+3+11-8+3}, iphone5={-60, -10+3+11-8+3}, ipad={-60, -10+3+11-8+3}, pc={-60, -8}},
		zorder = 2,
		escapeKey = true,
		visible = false,
	},

   JumpButton = Resources.AppButton:new {
		resource = "AppButton",
        extraScale = 0.80,
		--image = "JumpButton.png",
		useFrames = false,
		--alignment = "BottomLeft",
		--alignmentOffset = Layout{{6, -30}, iphone5={6, -30}, ipad={18, -30}},
		--alignment = "MidLeft",
		--alignmentOffset = Layout{{-20, 0}, iphone5={-20, 0}, ipad={-20, 0}},
		alignTo = "MidBottom",
		alignment = "MidBottom",
		alignmentOffset = Layout{{-00, 0}, iphone5={0, 0}, ipad={0, 0}},

		image = "Jump_Map_Button.png",
		alignment = "BottomLeft",
		alignTo = "BottomLeft",
		alignmentOffset = Layout{{-43, -50}, iphone5={-43, -50}, ipad={-43, -50}},

		--[[ MIDDLE
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = Layout{{-46, 120}, iphone5={-46, 120}, ipad={-46, 120}},
		--]]
				
		layer = 8,
		--size = {50,50},

		textColor = "White",
        textAlignmentOffset = {0,-2},
		font = {
			fontName = "fubd____.ttf",
			fontSize = 22,
		},
		textLineSpacing = 4,

		Icon = Resources.Actor:new {
			image = "world.png",
			alignment = "Center",
			alignTo = "MidRight",
			alignmentOffset = {-32,-4},
		},

		OnButtonClick = function (self, event)
			--if self ~= event.button then return false end
			--self.screen:ShowJumpDialog()
			--return true
			return false
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 2,
	},

   JumpQuickQuestButton = Resources.AppButton:new {
		resource = "AppButton",
        extraScale = 0.80,
		--image = "JumpButton.png",
		useFrames = false,
		--alignment = "BottomLeft",
		--alignmentOffset = Layout{{6, -30}, iphone5={6, -30}, ipad={18, -30}},
		--alignment = "MidLeft",
		--alignmentOffset = Layout{{-20, 0}, iphone5={-20, 0}, ipad={-20, 0}},
		alignTo = "MidBottom",
		alignment = "MidBottom",
		alignmentOffset = Layout{{-00, 0}, iphone5={0, 0}, ipad={0, 0}},

		image = "Jump_Map_Button.png",
		alignment = "BottomLeft",
		alignTo = "BottomLeft",
		alignmentOffset = Layout{{-43, -50-60}, iphone5={-43, -50-60}, ipad={-43, -50-60}},
				
		--[[ MIDDLE
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = Layout{{-46, 110}, iphone5={-46, 60}, ipad={-46, 60}},
		--]]

		layer = 8,
		--size = {50,50},

		textColor = "White",
        textAlignmentOffset = {0,-2},
		font = {
			fontName = "fubd____.ttf",
			fontSize = 22,
		},
		textLineSpacing = 4,

		Icon = Resources.Actor:new {
            resource = "Actor",
            --image = QQ_MGR:GetImagePath(true,0.34),
			alignment = "Center",
			alignTo = "MidRight",
			alignmentOffset = {-32,-4},
			--extraScale = 0.34,

            OnPostSpawn = function(self)
                self.image = "Quest_Cup_53.png"--QQ_MGR:GetImagePath(true,0.34)
            end,
		},

		NewMarker = Resources.NewMarker:new {
			resource = "NewMarker",
			visible = false,
			layer = 6,
		},

		OnButtonClick = function (self, event)
			--if self ~= event.button then return false end
			--self.screen:ShowJumpDialog()
			--return true
			return false
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 2,
	},

   JumpDiscoveryButton = Resources.AppButton:new {
		resource = "AppButton",
        extraScale = 0.80,
        extraScale = 0.80,
		--image = "JumpButton.png",
		useFrames = false,
		--alignment = "BottomLeft",
		--alignmentOffset = Layout{{6, -30}, iphone5={6, -30}, ipad={18, -30}},
		--alignment = "MidLeft",
		--alignmentOffset = Layout{{-20, 0}, iphone5={-20, 0}, ipad={-20, 0}},
		alignTo = "MidBottom",
		alignment = "MidBottom",
		alignmentOffset = Layout{{-00, 0}, iphone5={0, 0}, ipad={0, 0}},

		image = "Jump_Map_Button.png",
		alignment = "BottomLeft",
		alignTo = "BottomLeft",
		alignmentOffset = Layout{{-43, -50-120}, iphone5={-43, -50-120}, ipad={-43, -50-120}},
				
		--[[
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = Layout{{-46, 120}, iphone5={-46, 0}, ipad={-46, 0}},
		--]]
		layer = 8,
		--size = {50,50},

		textColor = "White",
        textAlignmentOffset = {0,-2},
		font = {
			fontName = "fubd____.ttf",
			fontSize = 22,
		},
		textLineSpacing = 4,

		Icon = Resources.Actor:new {
			image = "Discover_Icon.png",
			alignment = "Center",
			alignTo = "MidRight",
			alignmentOffset = {-33,-4},
			extraScale = 0.48,
		},

		NewMarker = Resources.NewMarker:new {
			resource = "NewMarker",
			visible = false,
			layer = 9,
		},

		OnButtonClick = function (self, event)
			--if self ~= event.button then return false end
			--self.screen:ShowJumpDialog()
			--return true
			return false
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 2,
	},

	ShopButton = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
        extraScale = 1.10,
		image = "Shop_Button.png",
		text = STRINGS("Shop"),
        textAlignmentOffset = {18,-2},
        textWidthLimit = 50,
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 20,
        },		
        alignment = "MidBottom",
		layer = 8,
		--alignmentOffset = Layout{{-66, 2}, iphone5={-66, 2}, ipad={-70, 2}, pc={0, -8}},
		alignmentOffset = Layout{{-56, -2}, iphone5={-56, -2}, ipad={-66, -2}, pc={0, -4}},
		zorder = 2,

		hgeParticles = {
			class = "hgeParticleLayer",
			zorder = 100,
			tag = "hgeParticles_shopButton",
		},

		SaleTag = Resources.SaleTagVFlip:new {
			resource = "SaleTagVFlip",
			extraScale = 0.75,
			alignment = BottomRight,
			alignTo = TopRight,
			alignmentOffset = {-32, 16},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
		},
	},

    WelcomePackButton = Resources.WelcomePackButton:new {
        resource = "WelcomePackButton",

        scripts = {"WelcomePackButtonGroove"},

        alignment = "MidBottom",
        zorder = 2,
        layer = 5,
        alignmentOffset = {-38,-40},
    },

    GiftPackButton = Resources.GiftPackButton:new {
        resource = "GiftPackButton",

        alignment = "MidBottom",
        zorder = 2,
        layer = 5,
        alignmentOffset = {-38,-40},
    },

    OfferPackButton = Resources.OfferPackButton:new {
        resource = "OfferPackButton",

        alignment = "MidBottom",
        zorder = 2,
        layer = 10,
        alignmentOffset = {-38, -40},
    },

	LabEventButton = Resources.LabEventButton:new {
        resource = "LabEventButton",

        alignment = "MidRight",
		alignTo = "MidRight",
        zorder = 2,
        layer = 10,
        alignmentOffset = {0, -120},
    },

	NewsButton = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
        extraScale = 1.10,
        image = "Today_Button.png",
		text = STRINGS("Today"),
        textAlignmentOffset = {18,-2},
        textWidthLimit = 50,
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 20,
        },		        
        shortcutKey = "n",
		zorder = 20,
		useFrames = false,
		layer = 8,
		alignment = "MidBottom",
		alignTo = "MidBottom",
		--alignmentOffset = Layout{{68, 2}, iphone5={68, 2}, ipad={70, 2}, pc={0, -8}},
		alignmentOffset = Layout{{56+2, -2}, iphone5={56+2, -2}, ipad={66+2, -2}, pc={0, -4}},

		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,

		NewMarker = Resources.NewMarker:new {
			resource = "NewMarker",
            extraScale = 0.8,
            alignmentOffset = {-2, 4},
			visible = false,
			layer = 9,
		},
	},

   AwardButton = Resources.AppButton:new {
		resource = "AppButton",
        extraScale = 0.80,
		useFrames = false,

		image = "Jump_Map_Button_flipped.png",
		alignment = "BottomRight",
		alignTo = "BottomRight",
		alignmentOffset = Layout{{43, -50}, iphone5={43, -50}, ipad={43, -50}},
        zorder = 2,
				
		layer = 8,

		textColor = "White",
        textAlignmentOffset = {0,-2},
		font = {
			fontName = "fubd____.ttf",
			fontSize = 22,
		},
		textLineSpacing = 4,

		Icon = Resources.Actor:new {
            resource = "Actor",
            image = "Awards_Map_Button.png",
			alignment = "Center",
			alignTo = "MidRight",
			alignmentOffset = {-17-42-1,-4},
			--extraScale = 0.34,
		},

		NewMarker = Resources.NewMarker:new {
			resource = "NewMarker",
			visible = false,
            layer = 9,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then 
                return false 
            end
			SwitchToScreen("AwardScreen")
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	RandomizeChallengeButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "RefreshButton.png",
		shortcutKey = "r",
		--alignment = "BottomRight",
		--alignTo = "BottomRight",
		--alignmentOffset = {-2,-100},
		alignment = "BottomRight",
		alignTo = "BottomRight",
		alignmentOffset = {-2-50,-250},
		zorder = 20,
		visible = false,--IsDebugUIAllowed(),
		useFrames = false,
		layer = 5,
		alpha = 128,
	},

	ClearChallengeButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "ResetButton.png",
		shortcutKey = "x",
		--alignment = "BottomRight",
		--alignTo = "BottomRight",
		--alignmentOffset = {-2,-150},
		alignment = "BottomRight",
		alignTo = "BottomRight",
		alignmentOffset = {-2-50,-200},
		zorder = 20,
		visible = false,--IsDebugUIAllowed(),
		useFrames = false,
		layer = 5,
		alpha = 128,
	},
	
	UnlockLevelsButton = Resources.AppButton:new {
		resource = "AppButton",
		image = "btnRoundBlank.png",
		alpha = 50,
		star = Resources.Actor:new {
			resource = "Actor",
			image = "FeatureLock.png",
			alignment = "Center",
			alpha = 96,
		},
		--alignment = "BottomRight",
		--alignTo = "BottomRight",
		--alignmentOffset = {-2,-50},
		alignment = "BottomRight",
		alignTo = "BottomRight",
		alignmentOffset = {-2-50,-150},
		text = "",
		zorder = 20,
		visible = false,--IsDebugUIAllowed(),
		layer = 5,
	},
}

Scripts.Preshow_MapScreen = function(screen)
	--logprint("Preshow_MapScreen")
	screen.RootActor.loadingLayer.visible = false
end

Scripts.Present_MapScreen = function(screen)
	--logprint("Present_MapScreen")
	--SlideOn(LandMap.LandsArea,200,"top","wait")
end

Scripts.Leave_MapScreen = function(screen,leaveReason)
	--Insert animations here.

	if(leaveReason == "Quit") then 
		--logprint("Leave_MapScreen - Do Quit")
		local MenuButton = screen:FindChild("MenuButton",true)
		--MenuButton:AddScript("Jello","Jello")
		--ScriptDelay(100*4)
		ScriptDelay(40)
		screen:DoQuit()
	end

	if(leaveReason == "StartQuestGame") then 
		--logprint("Leave_MapScreen - StartQuestGame")
		screen.RootActor.loadingLayer.visible = true
		ScriptBreak()
		screen:StartGame()
	end

	if(leaveReason == "Challenge") then 
		--logprint("Leave_MapScreen - Challenge")
		screen.RootActor.loadingLayer.visible = true
		ScriptBreak()
		screen:StartDailyChallenge()
	end
end

function table.val_to_str ( v )
  if "string" == type( v ) then
    v = string.gsub( v, "\n", "\\n" )
    if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
      return "'" .. v .. "'"
    end
    return '"' .. string.gsub(v,'"', '\\"' ) .. '"'
  else
    return "table" == type( v ) and table.tostring( v ) or
      tostring( v )
  end
end

function table.key_to_str ( k )
  if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
    return k
  else
    return "[" .. table.val_to_str( k ) .. "]"
  end
end

function table.tostring( tbl )
  local result, done = {}, {}
  for k, v in ipairs( tbl ) do
    table.insert( result, table.val_to_str( v ) )
    done[ k ] = true
  end
  for k, v in pairs( tbl ) do
    if not done[ k ] then
      table.insert( result,
        table.key_to_str( k ) .. "=" .. table.val_to_str( v ) )
    end
  end
  return "{" .. table.concat( result, "," ) .. "}"
end

function table.shallow_copy(t)
  local t2 = {}
  for k,v in pairs(t) do
    t2[k] = v
  end
  return t2
end

Scripts.Preshow_ShowProgressAnimation = function(screen, prevSpot, prevSpotActor, curSpot, curSpotActor)

end

local AddPoints = function(...)
	local newPoint = {x = 0, y = 0}
	for i,v in ipairs(arg) do
		if (v.x == nil) then
			newPoint.x = newPoint.x + v[1]
			newPoint.y = newPoint.y + v[2]
		else
			newPoint.x = newPoint.x + v.x
			newPoint.y = newPoint.y + v.y
		end
	end
	return newPoint
end

local function isGate(progressSpot)
	local GATE_TYPE = 1
	return (progressSpot ~= "nospot" and progressSpot.type == GATE_TYPE)
end

local function isLevel(progressSpot)
	local GATE_TYPE = 0
	return (progressSpot ~= "nospot" and progressSpot.type == GATE_TYPE)
end

Scripts.GetLevelPathLocations = function(self, levelNumber, levelActor)
	local allPathLocations = self:FindChild("LevelPathLocations", true)
	local offsetForParent = levelActor.parent.position
	local pathLocations = table.shallow_copy(allPathLocations.PathLocations[levelNumber])
	for i = 1, #pathLocations do
		pathLocations[i] = AddPoints(pathLocations[i], offsetForParent)
	end
	return pathLocations
end

Scripts.GetGatePathLocations = function(self, gateNumber, gateActor)
	local allPathLocations = self:FindChild("GatePathLocations", true)
	local offsetForParent = gateActor.parent.position
	local pathLocations = table.shallow_copy(allPathLocations.PathLocations[gateNumber])
	for i = 1, #pathLocations do
		pathLocations[i] = AddPoints(pathLocations[i], offsetForParent)
	end
	return pathLocations
end

local GetTokenRestPoint = function(spot, spotActor)
	if(spot == "nospot") then
		local point = AddPoints(spotActor.position, spotActor.parent.position, spotActor.parent.parent.position)
		return point
	end
	if (isGate(spot)) then
		-- local gateOffset = {x = 120, y = 120}
		local gateOffset = JasperGateOffsets[spot.index]
		local point = AddPoints(gateOffset, spotActor.position, spotActor.parent.position)
		return point
	else
		local levelOffset = {x = -40, y = 8}
		local point = AddPoints(levelOffset, spotActor.position, spotActor.parent.position)
		return point
	end
end

local GetStartPathPoint = function(spot, spotActor, isDirtPath)
	if (isDirtPath) then
		local localPoint = {x = 0, y = 0}
		if (isGate(spot)) then
			localPoint = {x = 58, y = 110}
		else
			localPoint = {x = 0, y = 35}
			--logprint(spot.index)
			local offset = Resources.LevelStartPathOffsets[spot.index]
			if offset ~= nil then
				localPoint = AddPoints(localPoint, offset)
			end
		end
		local returnPoint = AddPoints(spotActor.position, spotActor.parent.position, localPoint)
		return returnPoint
	else
		local returnPoint = GetTokenRestPoint(spot, spotActor)
		return returnPoint
	end
end

local GetEndPathPoint = function(spot, spotActor, isDirtPath)
	if (isDirtPath) then
		local localPoint = {x = 0, y = 0}
		if (isGate(spot)) then
			localPoint = {x = 58, y = 110}
		else
			localPoint = {x = 0, y = 60}
			local offset = Resources.LevelEndPathOffsets[spot.index]
			if offset ~= nil then
				localPoint = AddPoints(localPoint, offset)
			end
		end
		local pathEndOffset = spotActor.pathEndOffset
		if pathEndOffset == nil then
			pathEndOffset = {x = 0, y = 0}
		end
		local returnPoint = AddPoints(spotActor.position, spotActor.parent.position, localPoint, pathEndOffset)
		-- Turned off
		local returnPoint = GetTokenRestPoint(spot, spotActor)
		return returnPoint
	else
		local returnPoint = GetTokenRestPoint(spot, spotActor)
		return returnPoint
	end
end

local DissappearToken = function(screen, actor)
	PopOut(actor, {expandTime=50, shrinkTime=100, expandTo={1.25, 1.25}})
end

local ReappearToken = function(screen, actor)
	PopIn(actor, {expandTime=100, shrinkTime=50, expandTo={1.25, 1.25}})
end


local showDirtPath = false
local soilParticles
local bouncingToken

local StopDirtPathAndSoilParticles = function()
	if (soilParticles ~= nil) then
		soilParticles:Pause()
		soilParticles = nil
	end
	showDirtPath = false
end

local WalkLevels = {
	4,
	10,
	84,
	85,
	93,
	94,
	104,
	109,
	138,
	146,
	150,
	154,
	164,
	224,
	246,
	261,
	313,
	329,
	377,
	385,
	388,
	394,
	395,
	511,
	517,
	560,
	561,
	562,
	563,
}

local GetMoveUnderGroundTo = function(spot, spotActor)
	if(spot == "nospot") then
		return true
	end
	if (isGate(spot)) then
		return true
	else
		for index,value in ipairs(WalkLevels) do
			if (spot.index == value) then
				return false
			end
		end
		return true
	end
end

local PlayPathStartSounds = function()
	PlaySound("Cascade_SFX_MatchCoins.ogg")
	PlaySound("gamemachine09.ogg")
end

local PlayPathCompleteSounds = function()
	PlaySound("slot_machine_wheel_stop_01.ogg")
	PlaySound("slot_machine_win_07.ogg")
	PlaySound("pop_sparkle_01.ogg")
	StopSound("gamemachine09.ogg")
end

local MoveTokenToNextSpot = function(screen, prevSpot, prevSpotActor, curSpot, curSpotActor, skipDissapearToken)

	local dirtActor = screen:FindChild("dirtPath", true)
	local playerToken = screen:FindChild("PlayerToken", true)
	local moleActor = playerToken:FindChild("CharacterMarker", true)

	moleActor.rolloverable = false

	local pathLocations = {}
	local startPoint = {}
	local endPoint = {}
	
	if(curSpot == "nospot") then
		local start = GetTokenRestPoint(prevSpot, prevSpotActor)
		local stop = GetTokenRestPoint(curSpot, curSpotActor)
		--logprint("Start at " .. start.y .. " and stop at " .. stop.y)
		--Create an average position between the two on the fly to make path code happy
		pathLocations = { {x = (start.x + stop.x) / 2, y = (start.y + stop.y) / 2} }
		moleActor.levelNumber = prevSpot.index
		moleActor.landNumberForGate = 0
	elseif (isGate(curSpot)) then					--Moving to a gate
		pathLocations = Scripts.GetGatePathLocations(screen, curSpot.index, curSpotActor)
		moleActor.levelNumber = 0
		moleActor.landNumberForGate = curSpot.index
	elseif (isGate(prevSpot)) then				--Moving from a gate
		pathLocations = Scripts.GetLevelPathLocations(screen, curSpot.index, curSpotActor)
		moleActor.levelNumber = curSpot.index
		moleActor.landNumberForGate = 0
	else												--Moving level to level
		pathLocations = Scripts.GetLevelPathLocations(screen, curSpot.index, curSpotActor)
		moleActor.levelNumber = curSpot.index
		moleActor.landNumberForGate = 0
	end

	local moveTimePerPoint = 250
	local moveTime = (#pathLocations * moveTimePerPoint) + 400
	local offset = {x = 0, y = -15}

	local landNumber = prevSpotActor.parent.landNumber
	if (curSpotActor.parent.landNumber == 25) then
		moleActor.image = "Jasper_Map_Space.png"
	elseif (Config.XmasAssets) then
		moleActor.image = "Character_Explorer_xmas.png"
	else
		moleActor.image = "Character_Explorer.png"
	end

	PlayPathStartSounds()
	local isDirtPath = GetMoveUnderGroundTo(curSpot, curSpotActor)
	if (isDirtPath) then
		startPoint = GetStartPathPoint(prevSpot, prevSpotActor, true)
		endPoint = GetEndPathPoint(curSpot, curSpotActor, true)
		
		if (skipDissapearToken ~= true) then
			DissappearToken(screen, playerToken)
		end
		playerToken.position = GetTokenRestPoint(curSpot, curSpotActor)
		AddScriptWithParams(screen, "LeaveDirtPathActors", dirtActor, prevSpotActor, landNumber)
		AddScriptWithParams(screen, "ThrowRandomDirt", dirtActor, landNumber)
		AddScriptWithParams(screen, "DelayedScrollToNextSpot", 200, moveTime, curSpotActor)
		Scripts.MoveAlongPath(screen, dirtActor, startPoint, endPoint, pathLocations, offset, moveTimePerPoint)
		StopDirtPathAndSoilParticles()
		PlayPathCompleteSounds()
		ReappearToken(screen, playerToken)
		ScriptDelay(150)
	else
		local playerPicture = playerToken.PlayerPicture
		DissappearToken(screen, playerPicture)
		startPoint = GetStartPathPoint(prevSpot, prevSpotActor, false)
		startPoint.x = startPoint.x - offset.x
		startPoint.y = startPoint.y - offset.y
		endPoint = GetEndPathPoint(curSpot, curSpotActor, false)
		endPoint.x = endPoint.x - offset.x
		endPoint.y = endPoint.y - offset.y
		AddScriptWithParams(screen, "BounceWhileMoving", playerToken)
		Scripts.MoveAlongPath(screen, playerToken, startPoint, endPoint, pathLocations, offset, moveTimePerPoint)
		bouncingToken = false
		PlayPathCompleteSounds()
		ReappearToken(screen, playerPicture)
		ScriptDelay(150)
	end
	moleActor.rolloverable = true
end

Scripts.DigToFirstLevel = function(screen, prevSpotActor, curSpotActor)
	local nextSpot = {index = 1}
	local prevSpot = {index = 0}

	local playerToken = screen:FindChild("PlayerToken", true)
	local tokenExtraScale = playerToken.extraScale
	tokenExtraScale.x = 0
	tokenExtraScale.y = 0
	playerToken.visible = true
	playerToken.extraScale = tokenExtraScale

	MoveTokenToNextSpot(screen, prevSpot, prevSpotActor, nextSpot, curSpotActor, true)
end

Scripts.ThrowRandomDirt = function(screen, token, landNumber)
	--logprint("Starting ThrowRandomDirt")

	local scrollableArea = screen:FindChild("ScrollableArea", true)
	local targetLayer = scrollableArea.scrollableBackground.hgeParticleLayer

	if (targetLayer == nil) then
		--logprint("Targetlayer is nil")
	end

	local resourceName = "SoilLand" .. landNumber
	local resource = Resources[resourceName]
	if (resource == nil) then
		resource = Resources.SoilLand1
	end

	soilParticles = CreateInstance(resource)

	token:AddChild(soilParticles)
end

local GetDirtPositionForToken = function(tokenPosition, previousSpotActor)
	local position = tokenPosition
	position.x = position.x - previousSpotActor.position.x - previousSpotActor.parent.position.x
	position.y = position.y - previousSpotActor.position.y - previousSpotActor.parent.position.y
	position.y = position.y + 14
	return position
end

local nextDirtZOrder = -1
Scripts.AddDirtToPath = function(screen, token, previousSpotActor, previousTokenPosition, landNumber)
	local resourceName = "DirtLand" .. landNumber
	local dirtResource = Resources[resourceName]
	if (dirtResource == nil) then
		dirtResource = Resources.DirtLand1
	end

	local dirt = CreateInstance(dirtResource)
	local dirtPosition = GetDirtPositionForToken(token.position, previousSpotActor)

	local previousDirtPosition = GetDirtPositionForToken(previousTokenPosition, previousSpotActor)
	local deltaY = previousDirtPosition.y - dirtPosition.y
	local deltaX = previousDirtPosition.x - dirtPosition.x
	local angle = math.atan2(deltaY, deltaX)
	local PI = 3.141592654
	angle = angle - (PI / 2)
	
	dirtPosition.x = dirtPosition.x + previousSpotActor.position.x
	dirtPosition.y = dirtPosition.y + previousSpotActor.position.y

	dirt.position = dirtPosition
	dirt.rotationAngle = {radians = angle}
	dirt.zorder = nextDirtZOrder

	local scrollableArea = screen:FindChild("ScrollableArea", true)
	local spotParent = previousSpotActor.parent
	spotParent.dirtLayer = Resources.Actor:new {
		class = "Actor",
		zorder = 2,
	}
	local dirtLayer = spotParent.dirtLayer
	dirtLayer:AddChild(dirt)

	dirt.extraScale = {.4, .4}
	ScaleTo(dirt, {1.2, 1.2}, 100, true)
	
	if debuggingDirt ~= true then
		ScaleTo(dirt, {.8, .8}, 200, true)
		ScriptDelay(200)
		ScaleTo(dirt, {.2, .2}, 500, false)
		FadeOut(dirt, 500)
	end
end

local distance = function(p1, p2)
	local d = math.sqrt(((p1.x - p2.x) * (p1.x - p2.x)) + ((p1.y - p2.y) * (p1.y - p2.y)))
	return d
end

Scripts.LeaveDirtPathActors = function(screen, token, previousSpotActor, landNumber)
	nextDirtZOrder = -1
	showDirtPath = true
	local distanceForDirt = 5
	local previousPoint = token.position

	while(showDirtPath == true) do
		local currentPoint = token.position
		local distanceMoved = distance(currentPoint, previousPoint)
		if (distanceMoved >= distanceForDirt) then
			
			AddScriptWithParams(screen, "AddDirtToPath", token, previousSpotActor, previousPoint, landNumber)
			previousPoint = currentPoint
			nextDirtZOrder = nextDirtZOrder - 1
		end
		ScriptBreak()
	end
end

Scripts.Present_ShowProgressAnimation = function(screen, prevSpot, prevSpotActor, curSpot, curSpotActor)
	MoveTokenToNextSpot(screen, prevSpot, prevSpotActor, curSpot, curSpotActor, false)

	local type = curSpot.type

	--logprint("Present_ShowProgressAnimation "..type)

	local curActor
	if isLevel(curSpot) then
		curActor = curSpotActor:FindChild("MainButton", true)
	end

	if curActor then
		logprint("Present_ShowProgressAnimation FireParticle")
		curActor:AddScript("JelloLanding_flag","JelloSquare")
		FireParticle(curSpotActor, "StarBurst2")
		FireParticle(curSpotActor, "Shine1")
	end

	ScriptDelay(200)
end

--These are for placing levels in AppMapScreen::OnMouseButtonDown and for showing the test animation in Scripts.TestMoveAlongPath
local nextLevelNumber = 538
currentDebugLand = 33
currentDebugLevel = 403
placingDebugLevel = false
debuggingDirt = false

Scripts.TestMoveAlongPath = function(screen)
	--logprint("TestMoveAlongPath")

	local nextSpot = {index = nextLevelNumber}
	local prevSpot = {index = nextLevelNumber - 1}

	local prevLevel = screen:FindChild(string.format("Level_%s", nextLevelNumber - 1), true)
	local currentLevel = screen:FindChild(string.format("Level_%s",nextLevelNumber), true)

	MoveTokenToNextSpot(screen, prevSpot, prevLevel, nextSpot, currentLevel)
	
	nextLevelNumber = nextLevelNumber + 1
end

Scripts.DelayedScrollToNextSpot = function(screen, delay, moveTime, spotActor)
	ScriptDelay(delay)

	local scrollableArea = screen:FindChild("ScrollableArea", true)
	local dest = spotActor.position
	dest.x = dest.x + spotActor.parent.x
	dest.y = dest.y + spotActor.parent.y
	dest.y = dest.y - (APP.screenSize.y / 2)
	dest.y = dest.y * -1
	Scripts.AnimateToScrollPosition(scrollableArea, dest, moveTime)
end

Scripts.MoveAlongPath = function(screen, actor, startPoint, endPoint, pathPoints, offsetFromPoints, timePerAnimation)
	local firstPathPoint = pathPoints[1]
	local lastPathPoint = pathPoints[#pathPoints]
	local pointBeforeStart = {}
	pointBeforeStart.x = startPoint.x + startPoint.x - firstPathPoint.x
	pointBeforeStart.y = startPoint.y + startPoint.y - firstPathPoint.y
	local pointAfterEnd = {}
	pointAfterEnd.x = endPoint.x + endPoint.x - lastPathPoint.x
	pointAfterEnd.y = endPoint.y + endPoint.y - lastPathPoint.y

	table.insert(pathPoints, 1, startPoint)
	table.insert(pathPoints, endPoint)

	table.insert(pathPoints, 1, pointBeforeStart)
	table.insert(pathPoints, pointAfterEnd)

	--logprint("MoveAlongPath")
	--logprint(SerializeToString(pathPoints))
	Scripts.MoveAlongPathHermite(actor, pathPoints, offsetFromPoints, timePerAnimation)
end

Scripts.MoveAlongPathHermite = function(actor, pathPoints, offsetFromPoints, timePerAnimation)
	local currentIndex = 1
	local totalPoints = #pathPoints
	local totalMoveAnimations = totalPoints - 3
	--local timePerAnimation = totalMoveTime / totalMoveAnimations
	while (currentIndex <= totalMoveAnimations) do
		Scripts.MoveBetweenPointsHermite(actor, pathPoints[currentIndex], pathPoints[currentIndex+ 1], pathPoints[currentIndex + 2], pathPoints[currentIndex + 3], timePerAnimation, offsetFromPoints)
		currentIndex = currentIndex + 1
	end
end


Scripts.BounceWhileMoving = function(screen, actor)
	local direction = -1
	local bounceDistance = -3
	bouncingToken = true
	local currentOffset = 0
	while(bouncingToken) do
		if currentOffset < bounceDistance then
			direction = math.abs(direction)
		elseif currentOffset >= 0 then
			direction = math.abs(direction) * -1
		end
		currentOffset = currentOffset + direction
		local position = actor.position
		position.y = position.y + direction
		actor.position = position
		ScriptBreak()
	end

	local position = actor.position
	position.y = position.y - currentOffset
	actor.position = position
end

--Interpolates from p1 to p2 using Hermite interpolation
Scripts.MoveBetweenPointsHermite = function(actor, p0, p1, p2, p3, moveTime, offset)
	local timePerTick = 10
	local timeRunning = 0
	local currentPoint = {x=0, y=0}
	while (timeRunning < moveTime) do
		local fractionDone = timeRunning / moveTime
		currentPoint.x = HermiteInterpolate(p0.x, p1.x, p2.x, p3.x, fractionDone, 0, 0)
		currentPoint.y = HermiteInterpolate(p0.y, p1.y, p2.y, p3.y, fractionDone, 0, 0)
		currentPoint.x  = currentPoint.x + offset.x
		currentPoint.y = currentPoint.y + offset.y
		actor.position = currentPoint
		ScriptDelay(timePerTick)
		timeRunning = timeRunning + timePerTick
	end

	--Set the actor to the end point of the path
	currentPoint.x = HermiteInterpolate(p0.x, p1.x, p2.x, p3.x, 1, 0, 0)
	currentPoint.y = HermiteInterpolate(p0.y, p1.y, p2.y, p3.y, 1, 0, 0)
	currentPoint.x  = currentPoint.x + offset.x
	currentPoint.y = currentPoint.y + offset.y
	actor.position = currentPoint
end

function HermiteInterpolate(y0, y1, y2, y3, mu, tension, bias)
	local m0
	local m1
	local mu2
	local mu3
	local a0
	local a1
	local a2
	local a3

	mu2 = mu * mu
	mu3 = mu2 * mu
	
	m0  = (y1-y0)*(1+bias)*(1-tension)/2
	m0 = m0 + ((y2-y1)*(1-bias)*(1-tension)/2)
	m1  = (y2-y1)*(1+bias)*(1-tension)/2
	m1 = m1 + ((y3-y2)*(1-bias)*(1-tension)/2)
	a0 =  2*mu3 - 3*mu2 + 1
	a1 =    mu3 - 2*mu2 + mu
	a2 =    mu3 -   mu2
	a3 = -2*mu3 + 3*mu2

	 return(a0*y1+a1*m0+a2*m1+a3*y2)
end

Scripts.MoveMapToRest = function(scrollableMap, screen)
	if (scrollableMap.scrolling == false) then
		local borderSize = 30

		local foreground = scrollableMap:FindChild("foreground", true)
		local foregroundCenter = foreground.center

		local scaleX = scrollableMap.extraScale.x
		local scaleY = scrollableMap.extraScale.y
		foregroundCenter.x = foregroundCenter.x + scrollableMap.x
		foregroundCenter.y = foregroundCenter.y + scrollableMap.y
		local leftEdge = foregroundCenter.x - (foreground.width / 2 * scaleX)
		local rightEdge = foregroundCenter.x + (foreground.width / 2 * scaleX)
		local topEdge = foregroundCenter.y - (foreground.height / 2 * scaleY)
		local bottomEdge = foregroundCenter.y + (foreground.height / 2 * scaleY)

		borderSize = borderSize * scaleX
		local furthestRight = borderSize
		local furthestDown = borderSize
		local furthestLeft = screen.width - borderSize
		local furthestUp = screen.height - borderSize - 50 --The -50 is because of the button bar along the bottom of the screen
	
		local moveVector = {}
		moveVector.x = 0
		moveVector.y = 0

		if (leftEdge > furthestRight and rightEdge < furthestLeft) then
			moveVector.x = (screen.width / 2) - foregroundCenter.x
		elseif (leftEdge > furthestRight) then
			moveVector.x = furthestRight - leftEdge
		elseif (rightEdge < furthestLeft) then
			moveVector.x = furthestLeft - rightEdge
		end

		if (topEdge > furthestDown and bottomEdge < furthestUp) then
			moveVector.y = (screen.height / 2) - foregroundCenter.y
		elseif (topEdge > furthestDown) then 
			moveVector.y = furthestDown - topEdge
		elseif (bottomEdge < furthestUp) then
			moveVector.y = furthestUp - bottomEdge
		end

		local restPoint = scrollableMap.position
		restPoint.x = restPoint.x + moveVector.x
		restPoint.y = restPoint.y + moveVector.y
		SlideAndWait(scrollableMap, restPoint, 200)
	end
end

Scripts.ZoomTo = function(map, target)
	local newScale = target
	newScale = math.max(newScale, map.minScale)
	newScale = math.min(newScale, 1.0)
	ScaleTo(map, {newScale, newScale}, 200, true)
end

Scripts.ZoomBy = function(map, amount)
	local currentScale = map.extraScale.x
	local newScale = currentScale + amount
	newScale = math.max(newScale, map.minScale)
	newScale = math.min(newScale, 1.0)
	ScaleTo(map, {newScale, newScale}, 200, true)
end

Scripts.ZoomSnap = function(map, amount)
	local currentScale = map.extraScale.x
	local newScale = currentScale + amount
	newScale = math.max(newScale, map.minScale)
	newScale = math.min(newScale, 1.0)
	ScaleTo(map, {newScale, newScale}, 0, true)
	local delta1 = math.abs(newScale - map.minScale)
	local delta2 = math.abs(newScale - (map.minScale + 1.0)/2)
	local delta3 = math.abs(newScale - 1.0)
	if (delta1 < delta2 and delta1 < delta3) then
		ScaleTo(map, {map.minScale, map.minScale}, 200, true)
	end
	if (delta2 < delta1 and delta2 < delta3) then
		local scale = (map.minScale + 1.0)/2
		ScaleTo(map, {scale, scale}, 200, true)
	end
	if (delta3 < delta1 and delta3 < delta2) then
		ScaleTo(map, {1.0, 1.0}, 200, true)
	else
		
	end
end


Scripts.Simulate = function(target,sim)
	logprint("--------------------------------------")
	local runNumber = 0
	while(not sim:IsDone()) do
		sim:SimulateOnce()
		runNumber = runNumber + 1
		if(runNumber % 5 == 0) then
			ScriptBreak()
		end
	end
	
	logprint("Done!")

	logprint("Goal Fractions:")
	logprint(sim:GetSuccessFraction(0) .. "    " .. sim:GetSuccessFraction(1) .. "    " .. sim:GetSuccessFraction(2) .. "    " .. sim:GetSuccessFraction(3))
	logprint("\nPercentiles:")

	local percentileList = {
		0,.01,.05,.10,.15,.20,.25,.30,.35,.40,.45,.50,.55,.60,.65,.70,.75,.80,.85,.90,.95,.99,1.0,
	}

	for i, percentile in ipairs(percentileList) do
		logprint(percentile .. "    " .. sim:GetPercentileProgress(0,percentile) .. "     " .. sim:GetPercentileProgress(1,percentile) .. "     " .. sim:GetPercentileProgress(2,percentile) .. "     " .. sim:GetPercentileProgress(3,percentile))
	end

	logprint("--------------------------------------")
	logprint(" ")
	-- NOTE: Jonathan, set this part to what you recommend to set the stars at
	logprint("--------------------------------------")
	logprint("GOAL SETTINGS RECOMMENDED")
	percentile = 0.25
	logprint("Star 1: "..percentile .. "    " .. sim:GetPercentileProgress(0,percentile) .. "     " .. sim:GetPercentileProgress(1,percentile) .. "     " .. sim:GetPercentileProgress(2,percentile) .. "     " .. sim:GetPercentileProgress(3,percentile))
	percentile = 0.5
	logprint("Star 2: "..percentile .. "    " .. sim:GetPercentileProgress(0,percentile) .. "     " .. sim:GetPercentileProgress(1,percentile) .. "     " .. sim:GetPercentileProgress(2,percentile) .. "     " .. sim:GetPercentileProgress(3,percentile))
	percentile = 0.95
	logprint("Star 3: "..percentile .. "    " .. sim:GetPercentileProgress(0,percentile) .. "     " .. sim:GetPercentileProgress(1,percentile) .. "     " .. sim:GetPercentileProgress(2,percentile) .. "     " .. sim:GetPercentileProgress(3,percentile))
	logprint("--------------------------------------")

	sim:Destroy()
end

Scripts.Present_ShowLandUnlockedAnimation = function(screen,prevSpot, prevSpotActor, curSpot, curSpotActor)
	--logprint("Present_ShowLandUnlockedAnimation")
	local Socket_Green
	local Socket_Red
	local Socket_Blue
	if(prevSpotActor)then
		--logprint("prevSpotActor "..prevSpotActor.name)
		--prevSpotActor.visible = true
		--prevSpotActor.Sockets.visible = true
		if(prevSpotActor.Sockets)then
			if (prevSpotActor.Sockets.Socket_Green.visible) then
				Socket_Green = prevSpotActor.Sockets.Socket_Green
			end
			if (prevSpotActor.Sockets.Socket_Red.visible) then
				Socket_Red = prevSpotActor.Sockets.Socket_Red
			end
			if (prevSpotActor.Sockets.Socket_Blue.visible) then
				Socket_Blue = prevSpotActor.Sockets.Socket_Blue
			end
		end
		--prevSpotActor.alpha = 255
	end
	if(curSpotActor)then
		--logprint("curSpotActor "..curSpotActor.name)
	end
	PlaySound("Magic_CrystalBlast7.ogg")
	
	if(Socket_Green)then
		FireParticle(Socket_Green, "Explosion4_green")
		FireParticle(Socket_Green, "Explosion1_green")
		FireParticle(Socket_Green, "SparkBoom1")
		FireParticle(Socket_Green, "StoneBreak4_dark")
		FireParticle(Socket_Green, "BoulderBreak3")
		Socket_Green.filled.visible = false
		Socket_Green.filled_glow.visible = false
	end
	if(Socket_Red)then
		FireParticle(Socket_Red, "Explosion4_red")
		FireParticle(Socket_Red, "Explosion1_red")
		FireParticle(Socket_Red, "SparkBoom1")
		FireParticle(Socket_Red, "StoneBreak4_dark")
		FireParticle(Socket_Red, "BoulderBreak3")
		Socket_Red.filled.visible = false
		Socket_Red.filled_glow.visible = false
	end
	if(Socket_Blue)then
		FireParticle(Socket_Blue, "Explosion4_blue")
		FireParticle(Socket_Blue, "Explosion1_blue")
		FireParticle(Socket_Blue, "SparkBoom1")
		FireParticle(Socket_Blue, "StoneBreak4_dark")
		FireParticle(Socket_Blue, "BoulderBreak3")
		Socket_Blue.filled.visible = false
		Socket_Blue.filled_glow.visible = false
	end
	
    ScriptDelay(500) --Short delay while confetti flies before mole travels
	FadeOut(prevSpotActor,250)
    --PlaySound("Cascade_Cascade.ogg")
    ScriptDelay(500) --Short delay while confetti flies before mole travels
	PlaySound("air_cannon_pressure_release_02.ogg")
    Scripts.Confetti_short(screen)
    ScriptDelay(500) --Short delay while confetti flies before mole travels
end

Scripts.ShowMessagesButton = function(screen)
	local useGold = Config.GoldEnabled

	local buttonsPanel = screen:FindChild("ButtonsPanel",true)

	local messagesButton = buttonsPanel.MessagesButton
	ScaleTo(messagesButton, {1.0, 1.0}, 200, true)
	messagesButton.rolloverable = true
end

Scripts.HideMessagesButton = function(screen)
	local useGold = Config.GoldEnabled
	local buttonsPanel = screen:FindChild("ButtonsPanel",true)

	local messagesButton = buttonsPanel.MessagesButton
	messagesButton.rolloverable = false
	ScaleTo(messagesButton, {0.0, 0.0}, 200, false)
end

Scripts.ShowReturnToSpotButton = function(self)
	local pos = self.position
	pos.x = 0
	local slideTime = 300
	self.visible = true
	self:SlideTo(pos, slideTime)
end

Scripts.HideReturnToSpotButton = function(self)
	local pos = self.position
	pos.x = -50
	local slideTime = 300
	self:SlideTo(pos, slideTime) -- Slide off screen
end

Scripts.Preshow_WorkerFoundAnimation = function(self,buildingActor,oldWorkerCountString,newWorkerCountString, lastWorker)
	buildingActor.workerCount.text = oldWorkerCountString
	buildingActor.upgradeIcon.visible = false
	buildingActor.workerCount.visible = true
	buildingActor.discoverIcon.visible = false
end

Scripts.Present_WorkerFoundAnimation = function(self,buildingActor,oldWorkerCountString,newWorkerCountString, lastWorker)
	--Remember the old scroll position
	local scrollableArea = self:FindChild("ScrollableArea", true)
	local oldScrollPosition = scrollableArea.scrollPosition
	local didScroll = false

	--If the map is not centered on the building, center the map on the building
	if(buildingActor:GetGlobalPoint("MidTop").y < 0 or buildingActor:GetGlobalPoint("MidBottom").y > APP.screenSize.y) then
		didScroll = true
		Scripts.DelayedScrollToNextSpot(self, 0, 1000, buildingActor)
	end
	
	--Update the worker count
	buildingActor.workerCount.text = newWorkerCountString

	--Pop and particle the building
	Pop(buildingActor)
	FireParticle(buildingActor, "StarBurst2")
	FireParticle(buildingActor, "Shine1")
	FireParticle(buildingActor, "StarSpinOut1")
	FireParticle(buildingActor, "StarToss1.bigger.green")
	PlaySound("slot_machine_wheel_stop_01.ogg")
	PlaySound("slot_machine_win_07.ogg")
	PlaySound("pop_sparkle_01.ogg")
	--PlaySound("Mini_Lets_Go.ogg")
	StopSound("gamemachine09.ogg")

	ScriptDelay(1000)
	
	if(lastWorker) then
		FadeOut(buildingActor.workerCount,500)
		Pop(buildingActor.discoverIcon)
	end

	--Scroll back to old position if it's not the last worker

	if(not lastWorker and didScroll) then
		Scripts.AnimateToScrollPosition(scrollableArea, oldScrollPosition, 1000)
	end
end

Scripts.Preshow_BuildingUpgradeAnimation = function(self,buildingActor,upgradeLevel)
	if(upgradeLevel == 1) then
		buildingActor.discoverIcon.visible = false
		buildingActor.progressBar.visible = false
		buildingActor.upgradeIcon.visible = false
	end
	if(upgradeLevel == 3) then
		buildingActor.upgradeIcon.visible = false
	end
end

Scripts.Present_BuildingUpgradeAnimation = function(self,buildingActor,upgradeLevel)
	FireParticle(buildingActor, "StarBurst2")
	FireParticle(buildingActor, "Shine1")
	FireParticle(buildingActor, "StarSpinOut1")
	FireParticle(buildingActor, "StarToss1.bigger.green")
	PlaySound("slot_machine_wheel_stop_01.ogg")
	PlaySound("slot_machine_win_07.ogg")
	PlaySound("pop_sparkle_01.ogg")
	StopSound("gamemachine09.ogg")
	if(upgradeLevel == 1) then
		--The building has just been built. Make a copy of the building with its current properties to overlay over the real building
		buildingActor.fakeCopy = Resources.Building:new{
			resource = "Building",
		}

		--Find property table for building
		local buildingTable
		for unused,building in pairs(Buildings) do
			if(building.name == buildingActor.name) then
				buildingTable = building
			end
		end
		
		buildingActor.fakeCopy:ApplyProperties(buildingTable.basicProperties)
		buildingActor.fakeCopy:ApplyProperties(buildingTable.unfinishedProperties)
		buildingActor.fakeCopy.zorder = 100
		buildingActor.fakeCopy.alignment = NoAlignment
		buildingActor.fakeCopy.position = {0,0}
		
		--Move the building to its new properties underneath
		buildingActor:ApplyProperties(buildingTable.finishedProperties)

		--Fade the copy and destroy
		buildingActor.fakeCopy.progressBar:Destroy()
		buildingActor.fakeCopy.discoverIcon:Destroy()
		FadeOutAndDestroy(buildingActor.fakeCopy,1000)
		ScriptDelay(1000)
		buildingActor.progressBar.visible = true
		CorrectedPop(buildingActor.progressBar)
		buildingActor.upgradeIcon.visible = true
		CorrectedPop(buildingActor.upgradeIcon)
	else
		CorrectedPop(buildingActor)
	end
	ScriptDelay(1000) --Prevent pausing while particles are flying
end

Scripts.GateTapped = function(gate)
	--PlaySound("Chunka.ogg")
end

Scripts.SecretTunnelUnlockAnimation = function(self,secretTunnel)
	--logprintf("secret tunnel unlock\n")
	PlaySound("pop_sparkle_01.ogg")
	secretTunnel:AddScript("JelloLanding_flag","JelloSquare")
	ScriptDelay(100)

	PlaySound("slot_machine_wheel_stop_01.ogg")
	PlaySound("slot_machine_win_07.ogg")
	FireParticle(secretTunnel, "StarBurst2")
	FireParticle(secretTunnel, "Shine1")
	FireParticle(secretTunnel, "StarSpinOut1")
	FireParticle(secretTunnel, "StarToss1.bigger.green")

	StopSound("gamemachine09.ogg")
end

Scripts.Preshow_ProgressingToMissingLand = function(self)
	local playerToken = self:FindChild("PlayerToken", true)
	playerToken.layer = 6 --Over the clouds
end

Scripts.Present_ProgressingToMissingLand = function(self,previousSpot, previousSpotActor, downloadButton)
	--Move to a position to the left of the download button
	downloadButton.visible = true
	CorrectedPop(downloadButton)

	local moleGuyTarget = self:FindChild("MoleGuyTarget",true)
	MoveTokenToNextSpot(self, previousSpot, previousSpotActor, "nospot", moleGuyTarget, false)


end

Scripts.Preshow_WaitingForDownload = function(self)
	local playerToken = self:FindChild("PlayerToken", true)
	playerToken.layer = 6 --Over the clouds
	local moleGuyTarget = self:FindChild("MoleGuyTarget",true)
	local stoppingPoint = GetTokenRestPoint("nospot", moleGuyTarget)
	playerToken.position = stoppingPoint
end

Scripts.Leave_WaitingForDownload = function(self)
	local playerToken = self:FindChild("PlayerToken", true)
	playerToken.layer = 2
end