
local ScreenScaleFactor = 2
local TOP_SCORE_SPACING = 28
local Debug_Alpha = 0 --128

local iPhone5_menu_nudge = 30
--alignmentOffset = {0, APP.screenSize.y * 0.2},

Scripts.AppScoreRowHighlighter = function (self)
	-- Script Settings:
	local fadeTimeInMS = 1500
	local initialDelay = 250
	local brightestAlpha = 192
	local darkestAlpha = 96

	-- Script Body:
	self.alpha = brightestAlpha
	ScriptDelay(initialDelay)
	while true do
		Scripts.Interpolate(self, "alpha", darkestAlpha, fadeTimeInMS)
		Scripts.Interpolate(self, "alpha", brightestAlpha, fadeTimeInMS)
	end
end

Resources.AppScoreRow = Resources.Actor:new {
	resource = "Actor",
	image = "namePanel.png",
	
	ClearValues = function (self)
		self.scoreRowNumber.text = STRINGS("")
		self.playerName.text = STRINGS("")
		self.gameScore.text = STRINGS("")
		self.highlightPanel:KillTaggedScripts("AppScoreRowHighlighter")
		self.highlightPanel.visible = false
	end,
	
	--[[
	SetValues = function (self, values)
		self.gameCenterIcon.visible = (values.isGameCenter == true)
		if values.isGameCenter then
			--self.scoreRowNumber.alignmentOffset = {33, 2}
			self.playerName.alignmentOffset = {45, 2}
		else
			--self.scoreRowNumber.alignmentOffset = {10, 2}
			self.playerName.alignmentOffset = {25, 2}
		end
	end,
	--]]
	
	SetValues = function (self, values)
		self.highlightPanel.visible = (values.isCurrentPlayer == true)
		if values.isCurrentPlayer then
			if not self.highlightPanel:HasTaggedScript("AppScoreRowHighlighter") then
				self.highlightPanel:AddScript("AppScoreRowHighlighter", "")
			end
		else
			self.highlightPanel:KillTaggedScripts("AppScoreRowHighlighter")
		end
	end,

	highlightPanel = Resources.Actor:new {
		resource = "Actor",
		image = "namePanelHighlight.png",
		visible = false,
		zorder = 0,
	},

	gameCenterIcon = Resources.Actor:new {
		resource = "Actor",
		image = "GameCenterButton.png",
		size = {16, 16},
		alignment = "MidLeft",
		alignmentOffset = {25, 1},
		visible = false,
		zorder = 1,
	},

	scoreRowNumber = Resources.Label:new {
		resource = "Label",
		font = {
			fontName = "dabd____.ttf",
			fontSize = 16,
		},
		fgColor = "White",
		shadowColor = "Black",
		shadowOffset = {1,1},
		shadowAlpha = 100,
		widthLimit = 30,
		SetValue = function (self, value)
			self.text = string.format("%s.", tostring(value))
		end,
		alignment = "MidLeft",
		alignmentOffset = {10,0},
		zorder = 1,
	},
	
	playerName = Resources.Label:new {
		resource = "Label",
		font = {
			fontName = "dabd____.ttf",
			fontSize = 16,
		},
		fgColor = "White",
		shadowColor = "Black",
		shadowOffset = {1,1},
		shadowAlpha = 100,
		widthLimit = 200,
		alignment = "MidLeft",
		alignmentOffset = {25,0},
		zorder = 1,
	},
	
	gameScore = Resources.Label:new {
		resource = "Label",
		font = {
			fontName = "dabd____.ttf",
			fontSize = 16,
		},
		fgColor = "White",
		shadowColor = "Black",
		shadowOffset = {1,1},
		shadowAlpha = 100,
		widthLimit = 200,
		SetValue = function (self, value)
			local score = tonumber(value)
			if score then
				self.text = Int2Comma(score)
			else
				self.text = tostring(score)
			end
		end,
		alignment = "MidRight",
		alignmentOffset = {-10,0},
		zorder = 1,
	},
}

function MarkAsNew(item)
	if(item ~= NIL) then
		item.NewMarker = Resources.NewMarker
		if(item.newOffset) then
			item.NewMarker.alignmentOffset = item.newOffset
		end
	end
end

function MarkAsOld(item)
	if(item ~= NIL) then
		if(item.NewMarker ~= NIL) then
			item.NewMarker:Destroy()
		end
	end
end



local playPanel_y_offset = -20
logoTopScoresPanel_y_offset = Layout{20,pc=16+20}
local nudge_bottom_button_y = 1


Scripts.DriftUp = function(target)

	local currentPos	= target.position
	local destPos		= target.position
	
	--logprint("SlideOff:currentPos "..currentPos.x.." "..currentPos.y)
	--logprint("SlideOff:direction "..direction)
	--logprint("SlideOff:target.size.x "..target.size.x)
	--logprint("SlideOff:target.size.y "..target.size.y)

	local duration = 1000
	destPos.y = -75
	
	--logprint("SlideOff:destPos "..destPos.x.." "..destPos.y)

	local pixelsPerSecond = 40
	local position = target.position
	local x = position.x - (destPos.x or destPos[1])
	local y = position.y - (destPos.y or destPos[2])
	local length = math.sqrt((x*x) + (y*y))
	local duration = (length / pixelsPerSecond) * 1000.0
	target.visible = false

	while(true)do
		ScriptDelay(target.driftOrder)
		target.visible = true
		
		FadeOut(target,duration)
		target:SlideTo(destPos, duration)

		ScriptDelay(duration)
		target.position = currentPos
		target.visible = false
	end

end

Scripts.Beat = function(target)

	while(true)do
		Pop(target,{expandTo={1.1, 1.1},expandTime=100, shrinkTime=50})
		ScriptDelay(400-150)
	end

end


Scripts.Groove = function(actor)
	local speed = 50
	local factor = math.random(10,20)
	local amount
	local pick = math.random(0,1)
	if(pick==0)then 
		amount = 0-factor 
	else
		amount = factor
	end

	local expandTo = {1.0, 1.05}
	local expandTime = 200
	local shrinkTime = 200
	local tilt = 6
	local swing = 1

	actor.scalingPoint = {50,118}
	actor.rotationPoint = {50,118}

	local firstTime = 1

	while(true)do
		if(swing==1)then
			doTilt = -tilt
			if(firstTime==1) then 
				RotateByAmount(actor,{degrees=doTilt/2},100,true)
				firstTime = 0
			else
				RotateByAmount(actor,{degrees=doTilt},100,true)
			end
		end

		if(swing==3)then
			doTilt = tilt
			RotateByAmount(actor,{degrees=doTilt},100,true)
		end
		swing = swing + 1
		if(swing==5)then
			swing=1
		end

		actor.extraScale = {1.0, 1.0}
		ScaleTo(actor, expandTo, expandTime)
		ScriptDelay(expandTime)
	
		ScaleTo(actor, {1.0, 1.0}, shrinkTime)
		ScriptDelay(shrinkTime)

		ScriptDelay(0)

	end
	
	--RotateByAmount(actor,{degrees=-amount},speed,true)
	--RotateByAmount(actor,{degrees=amount*2-(amount/2)},speed,true)
	--RotateByAmount(actor,{degrees=-((amount/2)+(amount/4))},speed,true)
	--RotateByAmount(actor,{degrees=(amount/4)*2},speed,true)
	--RotateByAmount(actor,{degrees=-amount/4},speed,true)
	actor.rotation = { degrees = 0 }		
end

Scripts.Bop = function(actor)
	local speed = 50
	local factor = math.random(10,20)
	local amount
	local pick = math.random(0,1)
	if(pick==0)then 
		amount = 0-factor 
	else
		amount = factor
	end

	local expandTo = {1.0, 1.025}
	local expandTime = 200
	local shrinkTime = 400

	actor.scalingPoint = {50,118}

	local firstTime = 1

	while(true)do
		actor.extraScale = {1.0, 1.0}
		ScaleTo(actor, expandTo, expandTime)
		ScriptDelay(expandTime)
	
		ScaleTo(actor, {1.0, 1.0}, shrinkTime)
		ScriptDelay(shrinkTime)

		ScriptDelay(0)

	end
end

Scripts.MorningNight = function(actor)
	while(true)do
		ScriptDelay(5000)
		FadeIn(actor.backgroundImage2,5000)
		ScriptDelay(5000)
		ScriptDelay(5000)
		FadeOut(actor.backgroundImage2,5000)
	end
end

local arcTable = {4.0,6.0,8.0,10.0,-4.0,-6.0,-8.0,-10.0}
Scripts.SpotLight = function(actor)
	local arc = arcTable[math.random(1,#arcTable)]
	local time = math.random(4000,6000)
	while(true)do
		RotateAtSpeed(actor, {degrees=arc/2}, time, true)
		RotateAtSpeed(actor, {degrees=-arc}, time, true)
		RotateAtSpeed(actor, {degrees=arc/2}, time, true)
		arc = arcTable[math.random(1,#arcTable)]
		time = math.random(4000,6000)
	end
end

Resources.SpotLight = Resources.Actor:new {
	resource = "Actor",
	image = "SpotLight.png",
	alignment = "MidBottom",
	alignTo = "MidBottom",
	alignmentOffset = Layout{{50,0},iphone5={50,0},ipad={100,0}},
	--alpha = 150,
	rotationPoint = MidBottom,
	rotationAngle = { degrees = 0 },
	scripts = {"SpotLight"},
	zorder = 2,
}

Scripts.BackgroundStars = function(actor)
	local time = math.random(100,200)
	actor.visible = false
	while(true)do
		--FadeIn(actor,time)
		actor.visible = true
		ScriptDelay(100)
		--FadeOut(actor,time)
		actor.visible = false
		time = math.random(1000,2000)
		ScriptDelay(time)
	end
end

Resources.BackgroundStars = Resources.Actor:new {
	resource = "Actor",
	image = "Starshine.png",
	--color = "Blue",
	--size = {100,100},
	zorder = 1,
	visible = false,
}

local spotLight_x = Layout{100,iphone5=100,ipad=150}
local spotLight_x_offset = 4

local y_nudge = 70

Resources.MenuScreen = {
	deviceOrientation = "Portrait",
	--scripts = {"MorningNight"},

	loadingLayer = Resources.LoadingLayer:new {
		resource = "LoadingLayer",
	},

	TopBar = Resources.TopBar:new {
		resource = "TopBar",
		visible = false,
	},

	OptionsButton = Resources.AppMenuSmallSignButton:new {
		resource = "AppMenuSmallSignButton",
		image = "OptionsButton.png",
		useFrames = false,
		alignment = "BottomLeft",
		alignmentOffset = Layout{{6, -5}, iphone5={6, -5}, ipad={3, -5}},

		textColor = "White",
		textAlignmentOffset = {0,-2},
		font = {
			fontName = "fubd____.ttf",
			fontSize = 22,
		},
		textLineSpacing = 4,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			-- TEST BEAT THIS
			-- self.screen:ShowBeatThisDialog()
			self.screen:ShowOptionsDialog()
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 12,
	},

	backgroundImage = Resources.Actor:new {
		resource = "Actor",
		--image = "menu_background_characters.png",
		--image = "Land2.jpg",
		--image = "menu_background2.png",
		--image = "menu_background7.png",
		image = LandBackgroundTable[1],
		--color = "A_Cascade_Land_MildBlue",
		--color = "White",
		alpha = 0,
		zorder = -4,
		--position = {0,-50},
		--position = {0,0},
		alignment = "Center",
		--scripts = {"SparkleRandomly"},--"SparkRandomly"},


		Bkg_sky = Resources.Actor:new {
			resource = "Actor",
			image = LandBackgroundTable[1],
			--image = LandBackgroundTable[2]",
			--image = LandBackgroundTable[3],
			alignment = "Center",
			zorder = -3,
			scripts = {"SparkleRandomly"},--"SparkRandomly"},

			AndroidGameBackground = Resources.Actor:new {
				resource = "Actor",
				image = LandBackgroundTable[1],
				alignment = "Center",
				alignTo = "Center",
				zorder = 0,
				visible = Layout{false,android=true},
				resizeOnSetImage = true,
			},

			OnPostSpawn = function (self)
				self.AndroidGameBackground.image = self.image
				MatchHeightToScreen(self.AndroidGameBackground)
			end,

		},

        Character_Shadow = Resources.Actor:new {
            resource = "Actor",
            image = "JasperShadow.png",
            zorder = 2,
            alignment = "BottomLeft",
            alignmentOffset = Layout{{35,-35},iphone5={45,-35},ipad={45,-35}},
        },

		Character_GemHold = Resources.Actor:new {
			resource = "Actor",
			--STANDARD
			image = "Jasper_Animate_Menu_BODY.png",
			--image = "Jasper_Animate_Menu_BODY_Xmas.png",
			alignment = "BottomLeft",
			alignmentOffset = Layout{{35,-44},iphone5={45,-44},ipad={45,-44}},
			zorder = 3,
			scripts = {"Groove"},
			eyeLids = Resources.Actor:new {
				resource = "Actor",
				image = "Jasper_Animate_Menu_Eyelids_Closed.png",
				visible = false,
				scripts = {"Blink"},
				zorder = 2,
			},
			eyes = Resources.Actor:new {
				resource = "Actor",
				image = "Jasper_Animate_Menu_EYES.png",
				zorder = 1,
			},
			mouth = Resources.Actor:new {
				resource = "Actor",
				image = "Jasper_Animate_Menu_Mouth_3.png",
				zorder = 1,
				mouthClosed = Resources.Actor:new {
					resource = "Actor",
					image = "Jasper_Animate_Menu_Mouth_1.png",
					scripts = {"HideAndSeek"},
					zorder = 2,
				},
			},
			rightArm = Resources.Actor:new {
				resource = "Actor",
				--STANDARD
				image = "Jasper_Animate_Menu_Right_Arm_Gem-Hold.png",
				--image = "Jasper_Animate_Menu_Right_Arm_Gem-Hold_Xmas.png",
				zorder = 1,
				scripts = {"Groove"},
			},
			leftArm = Resources.Actor:new {
				resource = "Actor",
				--STANDARD
				image = "Jasper_Animate_Menu_Left_Arm_Pick.png",
				zorder = -1,
				--image = "Jasper_Animate_Menu_Left_Arm_Xmas.png",
				--zorder = 2,
				scripts = {"Groove"},
			},
		},

		Radio = Resources.Actor:new {
			resource = "Actor",
			image = "Boombox.png",
			alignment = "MidBottom",
			alignmentOffset = Layout{{-110+40,-60},iphone5={-110,-60},ipad={-110,-60}},
			zorder = 2,
			scripts={"Beat"},
            Shadow = Resources.Actor:new {
                resource = "Actor",
                image = "RadioShadow.png",
                zorder = 2,
                alignment = "BottomLeft",
                alignmentOffset = {-10,10},
            },
			RadioMusicNote1 = Resources.Actor:new {
				resource = "Actor",
				image = "RadioMusicNote.png",
				alignment = "MidTop",
				alignmentOffset = {0,0},
				zorder = 10,
				driftOrder = 0,
				scripts = {"DriftUp"},
			},
			RadioMusicNote2 = Resources.Actor:new {
				resource = "Actor",
				image = "RadioMusicNote.png",
				alignment = "MidTop",
				alignmentOffset = {0,0},
				zorder = 10,
				driftOrder = 400*2,
				scripts = {"DriftUp"},
			},
			RadioMusicNote3 = Resources.Actor:new {
				resource = "Actor",
				image = "RadioMusicNote.png",
				alignment = "MidTop",
				alignmentOffset = {0,0},
				zorder = 10,
				driftOrder = 400*4,
				scripts = {"DriftUp"},
			},
			RadioMusicNote3 = Resources.Actor:new {
				resource = "Actor",
				image = "RadioMusicNote.png",
				alignment = "MidTop",
				alignmentOffset = {0,0},
				zorder = 10,
				driftOrder = 400*6,
				scripts = {"DriftUp"},
			},
		},

		Glow = Resources.Actor:new {
			resource = "Actor",
			image = "Glow.png",
			alignment = "MidBottom",
			alignmentOffset = {-105+60-10,-96+80+10},
			zorder = 1,
			scripts = {
				function (self)
					local revolutionsPerSecond = 0.025
					RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
				end,
			},
			shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
			alpha = 200,
		},

		Glow2 = Resources.Actor:new {
			resource = "Actor",
			image = "Glow.png",
			alignment = "MidBottom",
			alignmentOffset = {-105+60-10,-96+80+10},
			zorder = 1,
			scripts = {
				function (self)
					local revolutionsPerSecond = 0.025
					RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
				end,
			},
			--shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
			alpha = 100,
		},

		

		Sign = Resources.Actor:new{
			resource = "Actor",
			image = "Menu_Banner_welcome.png",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = Layout{{0,60},iphone5={0,60},iphone4={0,76}},
			zorder = 2,

			Signpost = Resources.Actor:new {
				resource = "Actor",
				image = "sign_post.png",
				alignment = "Center",
				alignmentOffset = {0,242-10},
				zorder = 0,
			},

            BackShadow = Resources.Actor:new {
                resource = "Actor",
                image = "PostShadows.png",
                alignment = "MidTop",
                alignmentOffset = {8,75},
                zorder = -1,
                visible = true,
            },

			Flags = Resources.Actor:new {
				resource = "Actor",
				image = "Flags.png",
				alignment = "Center",
				alignmentOffset = Layout{{0,-78},iphone5={0,-105},ipad={0,-78}},
				zorder = -1,
			},

			OnPostSpawn = function (self)
				if (not IsGameInEnglish()) then
					self.image = "Menu_Banner_blank.png"
				end
			end,

            --Accommodate for missing signs
            UpdateSignButtonPositions = function(self)
                
                --determine button offset
                local missingButtonOffset = 0
                if (self.shareButton.visible == false) then
                    missingButtonOffset = missingButtonOffset+45
                end                
                if (self.facebookConnectButton.visible == false) then
                    missingButtonOffset = missingButtonOffset+45
                end

                --reposition buttons
                self.shareButton.alignmentOffset = {5,195+y_nudge-missingButtonOffset}
                self.awardsButton.alignmentOffset = {5,205+y_nudge-missingButtonOffset}
            end,

			shareButton = Resources.AppMenuSmallSignButton:new {
				resource = "AppMenuSmallSignButton",
				--image = "btnRoundShare.png",
				image = "ShareButton_blank.png",
				text = STRINGS("share"),
				textColor = "Cascade_SignTextBrownNew",
				textWidthLimit = 60,
				alignment = "Center",
				alignmentOffset = {5,195+y_nudge}, 
				--rotationAngle = {degrees=4},
				scripts = {"SparkleRandomly"},
				textAlignmentOffset = {-5,0},
				font	= Resources.AppButtonFont:new{
					resource = "AppButtonFont",
					fontSize = 20,
				},

                PostShadow = Resources.Actor:new {
                    resource = "Actor",
                    image = "sign_post_ShadowC.png",
                    alignment = "Center",
                    alignmentOffset = {-2,20},
                    zorder = -1,
                },
                
				OnButtonClick = function (self, event)
  					if self ~= event.button then
						return false
					end
					self.textToShare = STRINGS("AppInviteMessage", "I'm playing Cascade! Wanna join me?")
					if IsString(self.textToShare) then
                        Analytics_MenuShare()
						ShareText(self.textToShare, self)
					end
					return true
				end,

				OnPostSpawn = function (self)
					self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
					EVENT_HUB:AddObserver(EventMap.GURU_SCREENTRANSITION, self)
				end,
		
				UpdateVisibility = function (self)
					self.visible = SOCIAL_MGR_IsAvailable() or CanComposeEMail()
                    self.parent:UpdateSignButtonPositions()
				end,
				OnScreenTransition = function (self, event)
					if self.screen == event.newScreen then
						self:UpdateVisibility()
					end
				end,
				OnWindowEvent = function (self, event)
					if event.eventName == "SDL_WINDOWEVENT_RESTORED" then
						self:UpdateVisibility()
					end
				end,
				zorder = 12,
			},

			BFGRatingButton = Resources.AppMenuSmallSignButton:new {
				resources = {"AppMenuSmallSignButton", "ConfigKeyAwareView"},
				image = "ShareButton_blank.png",
				textColor = "Cascade_SignTextBrownNew",
				text = STRINGS("Rate Now"),
				alignment = "TopLeft",
				alignmentOffset = {36,172+62+y_nudge}, 
				--rotationAngle = {degrees=-8},
				scripts = {"SparkleRandomly"},
				font	= Resources.AppButtonFont:new{
					resource = "AppButtonFont",
					fontSize = 18,
				},
				zorder = 1,
				visible = false,
				configKey = "RateButton_Enabled",
				configKeyAwareProperties = {
					[true] = { visible = true },
					[false] = { visible = false },
					_default = { visible = false },
				},
				propertiesIfButtonDisabledViaBFGSDK = { visible = false },

				OnPostSpawn = function (self)
					Resources.ConfigKeyAwareView.InitConfigKeyAwareView(self)
					self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
					EVENT_HUB:AddObserver(EventMap.GURU_BFG_EVENT, self)
				end,
				
				OnBFGEvent = function (self, event)
					--logprintf("OnBFGEvent: %s\n", SerializeToString(event, true))
					if (self.bfgData.bfgEventType == "RatingAlertClosed") then
						self:UpdateConfigKeyAwareView()
					end
				end,

				OnButtonClick = function (self, event)
					if self ~= event.button then return false end
					if not BIGFISH then
						error("Big Fish SDK support is not compiled in (button = %s)\n", tostring(self))
					else
						BIGFISH:Rating_MainMenuRateApp();
						self:UpdateConfigKeyAwareView()
					end
					return true
				end,
				
				GetPropertiesToApply = function (self)
					local isEnabledViaBFGSDK = (BIGFISH and (BIGFISH:Rating_CanShowMainMenuRateButton() == true))
					if isEnabledViaBFGSDK ~= true then
						return self.propertiesIfButtonDisabledViaBFGSDK
					else
						return Resources.ConfigKeyAwareView.GetPropertiesToApply(self)
					end
				end
			},
	
			awardsButton = Resources.AppMenuSmallSignButton:new {
				resource = "AppMenuSmallSignButton",
				--image = "btnRoundAwards.png",
				image = "AwardsButton.png",
				text = STRINGS(""),
				alignment = "MidBottom",
				alignmentOffset = {5,205+y_nudge}, 
				--rotationAngle = {degrees=4},

                zorder = 12,
				textLineSpacing = 4,

                PostShadow = Resources.Actor:new {
                    resource = "Actor",
                    image = "sign_post_ShadowC.png",
                    alignment = "Center",
                    alignmentOffset = {-7,20},
                    zorder = -1,
                },

				OnButtonClick = function (self, event)
					--logprint("OnButtonClick GoAwards")
					if self ~= event.button then return false end
					self.screen:GoAwards()
					return true
				end,
				OnPostSpawn = function (self)
					self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
					self.visible = true --(Config.enable_all_game_types == true)
				end,
                OnScreenTransition = function (self, event)
                    if self.screen == event.newScreen then
                        self.parent:UpdateSignButtonPositions()
                    end
                end,
                OnWindowEvent = function (self, event)
                    if event.eventName == "SDL_WINDOWEVENT_RESTORED" then
                        self.parent:UpdateSignButtonPositions()
                    end
                end,

			},	

			facebookConnectButton = Resources.AppMenuMediumSignButton:new {
				resources = {"FacebookConnectDecorator"},
				image = "ConnectButton_blank.png",
				
                text = STRINGS("Connect"),
                textWidthLimit = 80,
				textHeightLimit = 30,
				textColor = "Cascade_SignTextBrownNew",
				textAlignmentOffset = {18, 1},
				textDisabledColor = "#383838",
				textWidthLimit = 75,

				alignment = "MidTop",
				alignmentOffset = {2,210+y_nudge},
				zorder = 6,
				analyticsTag = "<screen name>",
				isConnectUI = true,
		
				OnPostSpawn = function (self)
					Resources.FacebookConnectDecorator.InitFacebookConnectDecorator(self)
				end,

                PostShadow = Resources.Actor:new {
                    resource = "Actor",
                    image = "sign_post_ShadowB.png",
                    alignment = "Center",
                    alignmentOffset = {-2,20},
                    zorder = -1,
                },

				facebookIcon = Resources.Actor:new {
					resource = "Actor",
					image = "CFN_Logo_small.png",
					alignment = "MidLeft",
					alignmentOffset = {18, 0},
				},

                --update button state
                UpdateAppearance = function (self)
                    Resources.AuthenticationAwareDecorator.UpdateAppearance(self)
					if(self.parent ~= nil) then --When button is first instantiated, it hasn't been added to parent yet.
						self.parent:UpdateSignButtonPositions()
					end

                    --Re-remove text if necessary
                    if (IsGameInEnglish()) then
                        self.text = ""
                    end
                end,
			},

            --Removed from playQuestButton so it does not animate
            PlayButtonPostShadow = Resources.Actor:new {
                resource = "Actor",
                image = "sign_post_ShadowA.png",
                alignment = "MidTop",
                alignmentOffset = {0,185+y_nudge},
                -- alignmentOffset = {-12,30},
                zorder = 1,
            },
            
			playQuestButton = Resources.AppMenuSignButton:new {
				resources = {"AppMenuSignButton", "AuthenticationAwareDecorator"},
                image = "PlayButton_blank.png",
                enabledImage = "PlayButton_blank.png",
                disabledImage = "PlayButton_EN_disabled.png",
                
                text = STRINGS("Play"),
                textColor = "Cascade_SignTextBrownNew",
                textAlignmentOffset = {-9,-1},

				alignment = "MidTop",
				alignmentOffset = {12,145+y_nudge},
				rotationPoint = MidTop,
				zorder = 1,
				shortcutKey = "p",
				enterKey = true,
				--scripts = {"SparkleRandomly","WiggleLoop"},
                scripts = {"WiggleLoop"},

				
				OnPostSpawn = function (self)
					Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
				end,
				
                --update play button state
				UpdateAppearance = function (self)
					local authStatus = self:GetAuthenticationStatus()
					if authStatus == "Authenticating" then
						self.active = false
						self.image = self.disabledImage
						self:KillTaggedScripts("WiggleLoop")
						self.rotation = { degrees = 0 }
					else
						self.active = true
						self.image = self.enabledImage
						self:AddScript("WiggleLoop","WiggleLoop")
					end
				end,
			},

			StartChallengeButton = Resources.AppButtonMedium:new {
				resource = "AppButtonMedium",
				text = STRINGS("Daily Challenge"),
				alignment = "MidTop",
				alignmentOffset = {10,330},
				textColor = "Cascade_SignTextBrownNew",
				scripts = {"SparkleRandomly"},
				textLineSpacing = 3,
				visible = false,
				CheckMark = Resources.Actor:new {
					resource = "Actor",
					image = "Check.png",
					alignment = TopRight,
					alignmentOffset = {15,-15},
					visible = false,
					zorder = 10,
				},	
				lockMark = Resources.Actor:new {
					resource = "Actor",
					zorder = 5,
					image = "FeatureLock.png",
					alignment = Center,
					alignTo = Center,
					alignmentOffset = {0,-3},
					visible = true,
					zorder = 10,
					darken = Resources.Actor:new {
						resource = "Actor",
						color = "Black",
						size = powerupSize,
						alpha = 150,
						alignment = Center,
						alignTo = Center,
						alignmentOffset = {0,0},
						zorder = -1,
					},
				},
				NewMarker = Resources.NewMarker:new {
					resource = "NewMarker",
					visible = false,
				},

				OnPostSpawn = function (self)
					self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
				end,

			},

		},
	},


	versionInfo = Resources.Label:new {
		resource = "Label",
		text = GetVersionAsString(),
		alignment = "MidBottom",
		alignmentOffset = {0, -9},
		fgColor = "White",
		shadowColor = "Black",
		shadowOffset = {1,1},
		font = {
			fontName = "arial.ttf",
			fontSize = 9,
		},
		visible = false,
	},

	serverNameLabel = Resources.Label:new {
		resources = "Label",
		text = STRINGS(""),
		alignment = "MidBottom",
		alignmentOffset = {0, -9},
		fgColor = "White",
		shadowColor = "Black",
		shadowOffset = {1,1},
		font = {
			fontName = "arial.ttf",
			fontSize = 10,
			fontStyle = FontStyle { "bold" },
		},
		visible = false,
	},

    networkStatusButton = Resources.Button:new {
        resource = "Button",
        image = "",
        visible = IsDebugUIAllowed(),
        alignment = Layout { "TopLeft" },
        alignmentOffset = {2, 2},
        size = {140, 60},

        background = Resources.Actor:new {
            resource = "Actor",
            color = "Black",
            autoFillParent = true,
            visible = false,
            alpha = 160,
        },

        networkStatusLabel = Resources.Label:new {
            resource = "Label",
            zorder = 2,
            text = "",
            alignment = "TopLeft",
            alignmentOffset = {0, 0},
            fgColor = "White",
            shadowColor = "Black",
            textAlignment = "Left",
            font = {
                fontName = "arial.ttf",
                fontSize = 10,
                fontStyle = FontStyle { "bold" },
            },
        },

        OnPostSpawn = function (self)
            self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
            EVENT_HUB:AddObserver(EventMap.GURU_NETWORK_STATUS_CHANGE, self)
            EVENT_HUB:AddObserver(EventMap.GURU_NETWORK_SHELL_STATUS_CHANGE, self)
            self:UpdateText()
        end,

        UpdateText = function (self)
            local statusText = tostring(NetworkStatus_GetStatus())
            if statusText == "AvailableViaWiFiOrLAN" then
                statusText = "Wi-Fi"
            elseif statusText == "AvailableViaCellular" then
                statusText = "Cellular"
            elseif statusText == "NotAvailable" then
                statusText = "Offline"
            else
                statusText = "???"
            end
            local text = "Network: " .. statusText
            self.background.visible = false
            if NetworkShellIsListening then
                if not NetworkShellIsListening() then
                    text = text .. "\nNetwork shell inactive"
                else
                    local urls = NetworkShellGetURLs()
                    text = text .. "\nNetwork shell URLs:"
                    for _,url in ipairs(urls) do
                        text = text .. "\n- " .. url
                    end
                    self.background.visible = true
                end
            end
            self.networkStatusLabel.text = text
        end,

        OnNetworkStatusChange = function (self, event)
            self:UpdateText()
        end,

        OnNetworkShellStatusChange = function (self, event)
            self:UpdateText()
        end,

        OnButtonClick = function (self, event)
            if event.button ~= self then return false end
            if NetworkShellIsListening then
                if NetworkShellIsListening() then
                    NetworkShellStop()
                else
                    NetworkShellStart()
                end
            end
            return true
        end,
    },

	-- BEGIN BFG BUTTONS
	
	BFGMoreGamesButton = Resources.AppMenuSmallSignButton:new {
		resource = "AppMenuSmallSignButton",
		text = STRINGS("More Games"),
		alignment = "MidBottom",
		alignmentOffset = {5, -50},
		scripts = {"SparkleRandomly"},
		OnButtonClick = function (self, event)
			--logprint("OnButtonClick MoreGames")
			if self ~= event.button then return false end
			if not BIGFISH then
				logprintf("Big Fish SDK support is not compiled in (button = %s)\n", tostring(self))
			else
				BIGFISH:ShowMoreGames()
			end
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 2,
		visible = false,
	},
	
	
	BFGTellAFriendButton = Resources.AppMenuSmallSignButton:new {
		resource = "AppMenuSmallSignButton",
		text = STRINGS("Tell A Friend"),
		--alignment = "MidBottom",
		--alignmentOffset = Layout{{100,-50},iphone5={110,-50},ipad = {130,-50}}, -- bottom row
		alignment = "MidTop",
		alignmentOffset = Layout{{-126,190+40},iphone5={-126,320},ipad = {-146,200}}, 
		rotationAngle = {degrees=4},
		scripts = {"SparkleRandomly"},
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			if not BIGFISH then
				logprintf("Big Fish SDK support is not compiled in (button = %s)\n", tostring(self))
			else
				BIGFISH:ShowTellAFriend();
			end
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 1,
		visible = false,
	},
	
	--[[
	-- Per an update from BFG, this isn't needed any more
	BFGSplashNewsletterButton = Resources.Button:new {
		resource = "Button",
		image = "iSplash_blue1-iphone.png",
		alignment = MidBottom,
		alignmentOffset = Layout{{0,-58}, ipad={0,-54}},
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			if not BIGFISH then
				logprintf("Big Fish SDK support is not compiled in (button = %s)\n", tostring(self))
			else
				BIGFISH:ShowSplashNewsletter();
			end
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		visible = false,
	},
	--]]
	
	-- END BFG BUTTONS

	GameCenterButton = Resources.GameCenterButton:new {
		resource = "GameCenterButton",
		image = "btnGameCenterButton_cascade.png",
		alignment = TopLeft,
		alignTo = TopLeft,
		alignmentOffset = Layout{{7, 9}, ipad={6,8}},

		alignment = "BottomRight",
		alignmentOffset = Layout{{-6, -3+nudge_bottom_button_y}, iphone5={-6, -3+nudge_bottom_button_y}, ipad={-3, -3+nudge_bottom_button_y}},

		HandleGameCenterReadyClick = function (self)
			GuruGameCenter_ShowLeaderboard()
			return true
		end,
	},

	ShowFacebookPageButton = Resources.Button:new {
		resource = "Button",
		alignment = TopLeft,
		alignTo = TopLeft,
		alignmentOffset = Layout{{7, 9}, ipad={8,8}, pc={7,9+30}},
		visible = false,
		--size = {30, 30},
		image = "Facebook_Logo_medium.png",

		OnButtonClick = function (self, event)
			if event.button ~= self then
				return
			end
            -- I think config gets stored and doesn't update from the default
            -- And I'm changing this from what it was so am forcing it here:
            Config.AppFacebookURL = "https://www.facebook.com/255393097898012",
			logprint(tostring(Config.AppFacebookURL))
			if IsString(Config.AppFacebookURL) then
				OpenWebPage(Config.AppFacebookURL)
			end
			return true
		end,	
	},

	--[[
	leaderboard = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		--alignmentOffset = {0, 83+logoTopScoresPanel_y_offset},
		--alignmentOffset = {0, APP.screenSize.y * 0.21},
		--alignmentOffset = {0, (UseIPhone5AppAssets() and 119+logoTopScoresPanel_y_offset) or 86+logoTopScoresPanel_y_offset},
		alignmentOffset = Layout{{0,86+logoTopScoresPanel_y_offset}, iphone5={0,112+logoTopScoresPanel_y_offset}, pc={0,40+logoTopScoresPanel_y_offset}}, 
		scripts = {"SparkleRandomly"},
		zorder = 10,
		visible = false,

		topScoreViewManager = Resources.TopScoreViewManager:new {
			--resource = "TopScoreViewManager",
			class = "TopScoreViewManager",
			titleActorName = "topScoreTitle",
			prevButtonName = "prevButton",
			nextButtonName = "nextButton",
			rowNameFormat = "topScoreRow%d",
		},

		topScoreTitle = Resources.Actor:new {
			resource = "Actor",
			image = "namePanel.png",
			alignment = "MidTop",
			alignmentOffset = {0, 10},
			zorder = 1,

			title = Resources.Label:new {
				resource = "Label",
				font = {
					fontName = "dabd____.ttf",
					fontSize = 18,
				},
				fgColor = "White",
				shadowColor = "Black",
				shadowOffset = {1,1},
				shadowAlpha = 100,
				heightLimit = 40,
				widthLimit = 186,
				alignment = "Center",
				alignmentOffset = {0,-2},
				--wrapLimit = 210,
				--aligner = {class="Actor", size={186,40}, color="Green", alpha=128, alignment="Center",},

				SetValue = function (self, value)
					self.text = tostring(value)
				end,
			},
			
			gameCenterIconLeft = Resources.Actor:new {
				resource = "Actor",
				image = "GameCenterButton.png",
				size = {16, 16},
				alignment = "MidLeft",
				alignmentOffset = {31, -1},
			},

			gameCenterIconRight = Resources.Actor:new {
				resource = "Actor",
				image = "GameCenterButton.png",
				size = {16, 16},
				alignment = "MidRight",
				alignmentOffset = {-31, -1},
			},
			
			SetValues = function (self, values)
				self.gameCenterIconLeft.visible = (values.isGameCenter == true)
				self.gameCenterIconRight.visible = (values.isGameCenter == true)
				if values.isGameCenter == true then
					self.title.widthLimit = 180
				else
					self.title.widthLimit = 210
				end
			end,
		},
		
		prevButton = Resources.Button:new {
			resource = "Button",
			text = STRINGS(""),
			alignment = "MidTop",
			alignmentOffset = {-130, 10},
			image = "btnLeftArrow.png",
			--clickUpSound = "Soft Impact 74a.ogg",
			zorder = 2,
		},
		
		nextButton = Resources.Button:new {
			resource = "Button",
			text = STRINGS(""),
			alignment = "MidTop",
			alignmentOffset = {130, 10},
			image = "btnRightArrow.png",
			--clickUpSound = "Soft Impact 74a.ogg",
			zorder = 2,
		},

		topScoreRows = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidTop",
			alignmentOffset = {0, 36},
			topScoreRow1 = Resources.AppScoreRow:new {
				resource = "AppScoreRow",
				alignment = "MidTop",
				alignmentOffset = {0,0},
				zorder = 1,
			},
			topScoreRow2 = Resources.AppScoreRow:new {
				resource = "AppScoreRow",
				alignment = "MidTop",
				alignmentOffset = {0,1*TOP_SCORE_SPACING},
				zorder = 2,
			},
			topScoreRow3 = Resources.AppScoreRow:new {
				resource = "AppScoreRow",
				alignment = "MidTop",
				alignmentOffset = {0,2*TOP_SCORE_SPACING},
				zorder = 3,
			},
			topScoreRow4 = Resources.AppScoreRow:new {
				resource = "AppScoreRow",
				alignment = "MidTop",
				alignmentOffset = {0,3*TOP_SCORE_SPACING},
				zorder = 4,
			},
			topScoreRow5 = Resources.AppScoreRow:new {
				resource = "AppScoreRow",
				alignment = "MidTop",
				alignmentOffset = {0,4*TOP_SCORE_SPACING},
				zorder = 5,
			},
		},
	},
	--]]
	
	--[[ -- OLD PLAY BUTTON
	playGameButton = Resources.AppMenuButton:new {
		resources = {"AppMenuButton", "FacebookConnectDecorator"},
		--resource = "AppMenuButton",--resource = "AppMenuButton",
		text = STRINGS("Arcade"),
		alignment = "MidTop",
		alignmentOffset = Layout{{-60, APP.screenSize.y * 0.59},iphone5={-60, APP.screenSize.y * 0.57},ipad={-60, APP.screenSize.y * 0.57},pc={140,280}},
		--alignmentOffset = Layout{{0, APP.screenSize.y * 0.59},iphone5={0, APP.screenSize.y * 0.57},ipad={0, APP.screenSize.y * 0.57},pc={140,280}},
		scripts = {"SparkleRandomly"},
		visible = false,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			-- REWRITE, IF NEEDED: start a game here
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
		end,
		zorder = 1,
		isConnectUI = true,
		UpdateAppearance = function (self)
			self.lastAuthStatus = Authentication_GetAuthenticationStatus()

			--logprintf("Button, UpdateAppearance: status=<%s>, name=<%s>\n", tostring(self.lastAuthStatus), tostring(self.name))
			if self.lastAuthStatus == "Connecting" then
				self.active = false
			else
				self.active = true
			end
		end,
	},
	--]]
	
	--FriendChallengeButton = Resources.GameCenterButton:new {  --GameCenterButton
	FriendChallengeButton = Resources.AppButton:new {  --GameCenterButton
		--resource = "GameCenterButton",
		resource = "AppButton",
		--image = "btnMenuBig.png",
		clickSound			= "CLEEP_B.ogg",
		textAlignmentOffset = {0,-5},
		textColor = "Black",
		textRolloverColor = "Blue",
        textAlignmentOffset = {0,-5},
		visible = false,

        font	= Resources.AppMenuButtonFont:new{
            resource = "AppMenuButtonFont",
            fontSize = 28,
        },
		text = STRINGS("Friend Challenge"),
        alwaysUseClickOffset = true,
        clickOffset = {0,1},

		disableUnlessGameCenterFeatures = {"GameCenterFeature_ScoreChallenges"},
		alignment = "MidTop",
		alignmentOffset =  Layout{{0, 240+20}, iphone5={0, 290+40}, ipad={0, 250+40},pc={-140,280}},

		scripts = {"SparkleRandomly"},
		textLineSpacing = 3,

		CheckMark = Resources.Actor:new {
			resource = "Actor",
			image = "Check.png",
			alignment = TopRight,
			alignmentOffset = {15,-15},
			visible = false,
			zorder = 10,
		},	
		lockMark = Resources.Actor:new {
			resource = "Actor",
			zorder = 5,
			image = "FeatureLock.png",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0,-3},
			visible = false,
			darken = Resources.Actor:new {
				resource = "Actor",
				color = "Black",
				size = powerupSize,
				alpha = 150,
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {0,0},
				zorder = -1,
			},
		},
		NewMarker = Resources.NewMarker:new {
			resource = "NewMarker",
			visible = false,
		},
		--[[
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			-- REWRITE, IF NEEDED: start a game here
			return true
		end,
		--]]
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 1,

	},
	
	PlayerButton = Resources.AppButton:new {
		resource = "AppButton",
		--image = "btn_blank_small.png",
		size = {450/4,31},
		--Text is player name
		text = STRINGS("Player"),
		textWidthLimit = 180/ScreenScaleFactor,
		alignment = "MidTop",
		alignTo = "MidTop",
		--alignmentOffset = {0, 5},
		--alignmentOffset = {0,(UseIPhone5AppAssets() and 8) or 5},
		--alignmentOffset = Layout{{125,0}, iphone5={0,10}, ipad={0,0}, pc={-200,10}},
		alignmentOffset = {0, -100},  --This becomes visible when gamecenter is on, so I put off screen for now

		--alignment = "MidBottom",
		--alignmentOffset = {55, -10},
		shortcutKey = "N",
		keyTipPosition = {-10,30},
		--scalingPoint = TopRight,

		visible = false,
		
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:ShowPlayerDialog()
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},	

	toptenButton = Resources.AppMenuButton:new {
		resource = "AppMenuButton",
		image = "btnBlankSmall.png",
		text = STRINGS("top"),
		alignment = "MidBottom",
		alignmentOffset = Layout{{134, -55}, iphone5={133, -55},ipad={160, -55}},
		textAlignmentOffset = {0,-3},
        visible = false,

		font	= Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 16,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			local leaderboard = self.screen:FindChild("leaderboard",true)
			if(leaderboard.visible==true)then
				leaderboard.visible = false
			else
				leaderboard.visible = true
			end
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			--self.visible = (Config.enable_all_game_types == true)
            self.visible = false
		end,
		zorder = 1,
	},

	testButton = Resources.AppMenuButton:new {
		resource = "AppMenuButton",
		image = "btnBlankSmall.png",
		text = STRINGS("test"),
		alignment = "MidBottom",
		alignmentOffset = Layout{{-134, -55}, iphone5={-133, -55},ipad={-172, -45}},
		textAlignmentOffset = {0,-3},
        visible = false,

		font	= Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 16,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			if(not self.index)then
				self.index = 1
			end
			--if(self.index==1)then
			--	self.parent.backgroundImage.image = "menu_background2.png"
			--	self.index = self.index + 1
			if(self.index==1)then
				self.parent.backgroundImage.image = "Land1.jpg"
				self.index = self.index + 1
			elseif(self.index==2)then
				self.parent.backgroundImage.image = "Land2.jpg"
				self.index = self.index + 1
			elseif(self.index==3)then
				self.parent.backgroundImage.image = "Land4.jpg"
				self.index = self.index + 1
			elseif(self.index==4)then
				self.parent.backgroundImage.image = "menu_background_quest.png"
				self.index = 1
			end
			return true
		end,

		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			--self.visible = (Config.enable_all_game_types == true)
            self.visible = false
		end,

		zorder = 1,
	},
	
	DebugLanguageButton = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "BottomLeft",
		alignmentOffset = {5, -50},
        textAlignmentOffset = {-2,-4},
		visible = IsDebugUIAllowed(),
	},
	
	HelpButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "HelpButton.png",
		shortcutKey = "?",
		functionKey = 282,--SDLK_F1
		alignment = "BottomRight",
		alignmentOffset = Layout{{-8, -5}, iphone5={-8, -5}, ipad={-8, -5}},
		zorder = 10,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:ShowHelp()
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		zorder = 12,
		useFrames = false,
	},
		
	playOtherGamesButton = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		text = STRINGS("Custom"),
		alignment = "BottomLeft",
		alignmentOffset = {5, -50},
		textAlignmentOffset = {0,-2},
        textRolloverOffset = {0,-1},
		visible = false,

		font = {
			fontName = "fubd____.ttf",
			fontSize = 14,
		},
		textLineSpacing = 4,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:StartCustomGame()
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			self.visible = (Config.enable_all_game_types == true)
		end,
		zorder = 1,
	},

	NextBackgroundButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "btnRightArrow.png",
		shortcutKey = "?",
		alignment = "BottomRight",
		--alignmentOffset = Layout{{-6, -2}, iphone5={-6, -3+3}, ipad={0, -3+3}},
		alignmentOffset = {-5,-3},
		zorder = 20,
		visible = false,
	},
	
	PreviousBackgroundButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "btnLeftArrow.png",
		shortcutKey = "?",
		alignment = "BottomRight",
		alignmentOffset = {-45,-3},
		--alignmentOffset = Layout{{-6, -2}, iphone5={-6, -3+3}, ipad={0, -3+3}},
		zorder = 20,
		visible = false,
	},--[[]]

--[[
	leaderboardButton = Resources.Button:new {
		resource = "Button",
		text = STRINGS("Leaderboards"),
		alignment = "MidTop",
		alignmentOffset = {0, 200},
		fgColor = "White",
		font = {
			fontName = "IT441___.TTF",
			fontSize = 14,
		},
		OnButtonClick = function (self, event)
			if self ~= event.button then
				return false
			end
			GuruGameCenter_ShowLeaderboard("CascadeSlots.MainLeaderboard")
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},
--]]
	
--[[
	debugButton = Resources.Button:new {
		resource = "Button",
		text = STRINGS("Debug Menu"),
		alignment = "MidTop",
		alignmentOffset = {0, 250},
		fgColor = "White",
		font = {
			fontName = "IT441___.TTF",
			fontSize = 14,
		},
		OnButtonClick = function (self, event)
			if self ~= event.button then
				return false
			end
			SwitchToScreen("DebugScreen")
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},
--]]
}

Scripts.UpdateChallenge = function(screen)
	--Set up challenge progress bar
	local challengeButton = screen.RootActor:FindChild("StartChallengeButton",true)
	challengeButton.active = false
	challengeButton.CheckMark.visible = false
	challengeButton.Progress.visible = true
	
	ScriptDelay(550)	 --Allows menu to present first
	
	--While challenge isn't done, update challenge progress bar
	--local progress = screen:GetSimulatorProgress()
	local progress = 0
	while(progress < 1.0) do
		ScriptBreak()
		--screen:TickSimulator()
		--progress = screen:GetSimulatorProgress()
		progress = progress + 0.05
		local goalWidth = challengeButton.Progress.width - 2
		goalWidth = goalWidth * progress
		challengeButton.Progress.ProgressBar.width = goalWidth
	end
	
	challengeButton.Progress.visible = false
	
	PlaySound("Cascade_Chimes.ogg")
	screen:OnSimulatorFinish()
end

Scripts.ChallengeReady = function(screen)
end

Scripts.Refresh_MenuScreen = function(screen,hour,currentLand)
	logprint("Refresh_MenuScreen, current land = " .. currentLand)

    --override currentLand (debug)
    -- currentLand = 24; --DEBUG ONLY

	local bkg = screen:FindChild("Bkg_sky",true)
	local backgroundImageName = LandBackgroundTable[1]
	
	if((currentLand>0)and(currentLand<=#LandBackgroundTable))then
		backgroundImageName = LandBackgroundTable[currentLand]
		MenuScreen_backgroundIndex = currentLand
	end

	--If the background image hasn't been downloaded yet, show the land 1 background.
	if(not HasResourceInfo(backgroundImageName)) then
		backgroundImageName = LandBackgroundTable[1]
	end
	bkg.image = backgroundImageName
	bkg.AndroidGameBackground.image = bkg.image
	MatchHeightToScreen(bkg.AndroidGameBackground)

	-- Tinted menu elements
	local backgroundImage = screen:FindChild("backgroundImage",true)
    local flags = backgroundImage:FindChild("Flags",true)
	if (currentLand == 24 and HasResourceInfo("sign_post_L24.png")) then
        --apply northern lights filters
		backgroundImage.Sign.Signpost.image = "sign_post_L24.png"
		backgroundImage.Sign.awardsButton.image = "AwardsButton_L24.png"
		backgroundImage.Sign.facebookConnectButton.image = "ConnectButton_blank_L24.png"
		backgroundImage.Character_GemHold.image = "Jasper_Menu_BODY_L24.png"
		backgroundImage.Character_GemHold.eyes.visible = false
		backgroundImage.Character_GemHold.mouth.visible = false
		backgroundImage.Character_GemHold.rightArm.image = "Jasper_Menu_Right_Arm_L24.png"
		backgroundImage.Character_GemHold.leftArm.image = "Jasper_Menu_Left_Arm_L24.png"
		backgroundImage.Character_GemHold.leftArm.zorder = -1
		backgroundImage.Radio.image = "Boombox_L24.png"




		if(flags)then
            flags.image = "Flags_L24.png.png"
        end
		backgroundImage.Sign.shareButton.image = "ShareButton_blank_L24.png"

        backgroundImage.Sign.playQuestButton.textColor = "Cascade_SignText_L24"
        backgroundImage.Sign.facebookConnectButton.textColor = "Cascade_SignText_L24"
        backgroundImage.Sign.shareButton.textColor = "Cascade_SignText_L24"

		if (IsGameInEnglish()) then
			backgroundImage.Sign.image = "Menu_Banner_welcome_L24.png"
			backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_EN_L24.png"
            backgroundImage.Sign.shareButton.image = "ShareButton_EN_L24.png"
            backgroundImage.Sign.facebookConnectButton.image = "ConnectButton_EN_L24.png"

            backgroundImage.Sign.playQuestButton.text = ""
            backgroundImage.Sign.shareButton.text = ""
            backgroundImage.Sign.facebookConnectButton.text = ""
		elseif (Language == "ja") then
			backgroundImage.Sign.image = "JAPANESE_Cascade_BANNER_gems_Land24.png"
			backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_blank_L24.png"
		elseif (Language == "ru") then
			backgroundImage.Sign.image = "RUSSIAN_Cascade_BANNER_gems_Land24.png"
			backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_blank_L24.png"
		else
			backgroundImage.Sign.image = "Menu_Banner_blank_L24.png"
			backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_blank_L24.png"
		end

        screen:FindChild("OptionsButton",true).image = "OptionsButton.png"
        screen:FindChild("HelpButton",true).image = "HelpButton.png"
	else
        --apply defaults (blank images & localized text)
        backgroundImage.Sign.image = "Menu_Banner_blank.png"
        backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_blank.png"
		backgroundImage.Sign.Signpost.image = "sign_post.png"
		backgroundImage.Sign.awardsButton.image = "AwardsButton.png"
		backgroundImage.Sign.facebookConnectButton.image = "ConnectButton_blank.png"
		backgroundImage.Character_GemHold.image = "Jasper_Animate_Menu_BODY.png"
		backgroundImage.Character_GemHold.eyes.visible = true
		backgroundImage.Character_GemHold.mouth.visible = true
		backgroundImage.Character_GemHold.rightArm.image = "Jasper_Animate_Menu_Right_Arm_Gem-Hold.png"
		backgroundImage.Character_GemHold.leftArm.image = "Jasper_Animate_Menu_Left_Arm_Pick.png"
		backgroundImage.Character_GemHold.leftArm.zorder = -1
		backgroundImage.Radio.image = "Boombox.png"
		if(flags)then
            flags.image = "Flags.png"
        end
		backgroundImage.Sign.shareButton = "ShareButton_blank.png"
		
        --Specific languages use special graphics
        if (IsGameInEnglish()) then
			backgroundImage.Sign.image = "Menu_Banner_welcome.png"
			backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_EN.png"
            backgroundImage.Sign.playQuestButton.text = ""

            backgroundImage.Sign.facebookConnectButton.image = "ConnectButton_EN.png"
            backgroundImage.Sign.facebookConnectButton.text = ""
            backgroundImage.Sign.shareButton.image = "ShareButton_EN.png"
            backgroundImage.Sign.shareButton.text = ""
		elseif (Language == "ja") then
			backgroundImage.Sign.image = "JAPANESE_Cascade_BANNER_gems.png"
			backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_blank.png"
		elseif (Language == "ru") then
			backgroundImage.Sign.image = "RUSSIAN_Cascade_BANNER_gems.png"
			backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_blank.png"			
		end
	end

    --For 1.6.6 REMOVED CHRISTMAS ASSETS TO CUT APP SIZE
    --Overwrite with CHRISTMAS assets
	-- if (Config.XmasAssets) then
	-- 	backgroundImage.Character_GemHold.image = "Jasper_Animate_Menu_BODY_Xmas.png"
	-- 	backgroundImage.Character_GemHold.eyes.visible = true
	-- 	backgroundImage.Character_GemHold.mouth.visible = true
	-- 	backgroundImage.Character_GemHold.rightArm.image = "Jasper_Animate_Menu_Right_Arm_Gem-Hold_Xmas.png"
	-- 	backgroundImage.Character_GemHold.leftArm.image = "Jasper_Animate_Menu_Left_Arm_Xmas.png"
	-- 	backgroundImage.Character_GemHold.leftArm.zorder = 2
	-- 	backgroundImage.Sign.Signpost.image = "Cascade_Sign_Post_2015_w_Shadows.png"
	-- 	backgroundImage.Sign.Flags.image = "Cascade_Xmas_Lights_top.png"
	-- 	if (IsGameInEnglish()) then
	-- 		backgroundImage.Sign.image = "Cascade_Banner_Xmas_2015.png"
	-- 	else 
	-- 		backgroundImage.Sign.image = "Cascade_Banner_Xmas_2015_blank.png"
	-- 	end
	-- end

    --Overwrite with MARS assets
	if (currentLand == 25) then
		backgroundImage.Character_GemHold.image = "Jasper_Space_small_Body.png"
		backgroundImage.Character_GemHold.eyes.visible = false
		backgroundImage.Character_GemHold.eyeLids.image = "Jasper_Space_small_Eyelid_Full.png"
		backgroundImage.Character_GemHold.mouth.visible = true
		backgroundImage.Character_GemHold.mouth.image = "Jasper_Space_small_Mouth_Oh.png"
		backgroundImage.Character_GemHold.mouth.mouthClosed.image = "Jasper_Space_small_Mouth_Closed.png"
		backgroundImage.Character_GemHold.rightArm.image = "Jasper_Space_small_RightArm.png"
		backgroundImage.Character_GemHold.leftArm.image = "Jasper_Space_Small_LeftArm.png"
		backgroundImage.Character_GemHold.leftArm.zorder = -1
	end

    --Update PLAY button state
    backgroundImage.Sign.playQuestButton:UpdateAppearance()
    -- backgroundImage.Sign.playQuestButton.enabledImage = "PlayButton_blank_L24.png"

	--TEST
	--hour = 24
	--[[
	local Bkg_sky = screen:FindChild("Bkg_sky",true)
	local Bkg_sky_sunrise = screen:FindChild("Bkg_sky_sunrise",true)
	local Bkg_sky_day = screen:FindChild("Bkg_sky_day",true)
	local SpotLight1 = screen:FindChild("SpotLight1",true)
	local SpotLight2 = screen:FindChild("SpotLight2",true)
	local SpotLight3 = screen:FindChild("SpotLight3",true)
	SpotLight1.alpha = 255
	SpotLight2.alpha = 255
	SpotLight3.alpha = 255

	if(hour>=6) and (hour<=17) then
		SpotLight1.alpha = 0
		SpotLight2.alpha = 0
		SpotLight3.alpha = 0
		SpotLight1.visible = false
		SpotLight2.visible = false
		SpotLight3.visible = false
	else
		SpotLight1.visible = true
		SpotLight2.visible = true
		SpotLight3.visible = true
	end

	if(hour==0)then
		Bkg_sky_sunrise.alpha = 42*0
		Bkg_sky_day.alpha = 0
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = false
	elseif(hour==1)then
		Bkg_sky_sunrise.alpha = 42*0
		Bkg_sky_day.alpha = 0
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = false
	elseif(hour==2)then
		Bkg_sky_sunrise.alpha = 42*0
		Bkg_sky_day.alpha = 0
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = false
	elseif(hour==3)then
		Bkg_sky_sunrise.alpha = 42*0
		Bkg_sky_day.alpha = 0
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = false
	elseif(hour==4)then
		Bkg_sky_sunrise.alpha = 42*1
		Bkg_sky_day.alpha = 0
		SpotLight1.alpha = 100
		SpotLight2.alpha = 100
		SpotLight3.alpha = 100
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = false
	elseif(hour==5)then
		Bkg_sky_sunrise.alpha = 42*3
		Bkg_sky_day.alpha = 0
		SpotLight1.alpha = 50
		SpotLight2.alpha = 50
		SpotLight3.alpha = 50
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = false
	elseif(hour==6)then
		Bkg_sky_sunrise.alpha = 255 --42*6
		Bkg_sky_day.alpha = 42*0
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = false
	elseif(hour==7)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 42*3
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = true
	elseif(hour==8)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 42*4
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = true
	elseif(hour==9)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 42*5
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = true
	elseif(hour==10)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 255
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = true
	elseif(hour==11)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 255
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = true
	elseif(hour==12)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 255 -- 42*6
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = true
	elseif(hour==13)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 255
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = true
	elseif(hour==14)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 255
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = true
	elseif(hour==15)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 42*5
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = true
	elseif(hour==16)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 42*4
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = true
	elseif(hour==17)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 42*3
		Bkg_sky.visible = false
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = true
	elseif(hour==18)then
		Bkg_sky_sunrise.alpha = 255
		Bkg_sky_day.alpha = 42*2
		SpotLight1.alpha = 50
		SpotLight2.alpha = 50
		SpotLight3.alpha = 50
	elseif(hour==19)then
		Bkg_sky_sunrise.alpha = 42*5
		Bkg_sky_day.alpha = 42*1
		SpotLight1.alpha = 100
		SpotLight2.alpha = 100
		SpotLight3.alpha = 100
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = true
	elseif(hour==20)then
		Bkg_sky_sunrise.alpha = 42*4
		Bkg_sky_day.alpha = 0
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = false
	elseif(hour==21)then
		Bkg_sky_sunrise.alpha = 42*1
		Bkg_sky_day.alpha = 0
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = true
		Bkg_sky_day.visible = false
	elseif(hour==22)then
		Bkg_sky_sunrise.alpha = 42*0
		Bkg_sky_day.alpha = 0
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = false
	elseif(hour==23)then
		Bkg_sky_sunrise.alpha = 42*0
		Bkg_sky_day.alpha = 0
		Bkg_sky.visible = true
		Bkg_sky_sunrise.visible = false
		Bkg_sky_day.visible = false
	end
	--]]
end

Scripts.Preshow_MenuScreen = function(screen,hour)
	screen.RootActor.loadingLayer.visible = false
	logprint("Preshow_MenuScreen")

	local bkg = screen:FindChild("Bkg_sky",true)
	bkg.image = LandBackgroundTable[1]
	bkg.AndroidGameBackground.image = bkg.image
	MatchHeightToScreen(bkg.AndroidGameBackground)
end

Scripts.Present_MenuScreen = function(screen)
	local Character_GemHold = screen:FindChild("Character_GemHold",true)
	--PlaySound("Move2_up.ogg")
	--TODO: Get mole to slide up
	--SlideOn(Character_GemHold,150,"bottom","wait")
	if(not screen.openingShown) then
		--ScriptDelay(1000)
		--FadeOut(screen.RootActor.splashImage,500)
		screen.openingShown=true
	end
	
    local connectButton = screen:FindChild("facebookConnectButton",true)
end

Scripts.Leave_MenuScreen = function(screen,leaveReason)
	local Character_GemHold = screen:FindChild("Character_GemHold",true)
	--SlideOff(Character_GemHold,150,"bottom","wait")

	if(leaveReason == "GoMap") then 
		local playQuestButton = screen:FindChild("playQuestButton",true)
		if(Character_GemHold)then
			if(Character_GemHold.eyeLids)then
				Character_GemHold.eyeLids.visible = false
			end
		end
		screen.RootActor.loadingLayer.visible = true
		ScriptBreak()
		screen:GoMap()
	end

end

Scripts.BeatenChallenge = function(screen)
	local challengeButton = screen.RootActor.StartChallengeButton
	if(challengeButton ~= nil) then
		challengeButton.CheckMark.visible = false
		ScriptDelay(500) --Let the star transition finish
		challengeButton.CheckMark.visible = true
		Pop(challengeButton.CheckMark)
		FireParticle(challengeButton.CheckMark,"StarBurst_Blue_Small","Center")
		PlaySound("slot_machine_win_19.ogg")
	end
end

Scripts.NewMarkerScript = function(newMarker)
	newMarker.visible = false
	--Wait for star transition to end
	-- ScriptDelay(400)
	--Wait a random amount more time so that not all NEWs show up at once
	--ScriptDelay(math.random(0,1000))
	--Pop in
	if(newMarker.parent:IsGloballyVisible()) then
		ScaleIn(newMarker, {0.0, 0.0}, 200)
		PlaySound("slot_machine_win_23.ogg")
		FireParticle(newMarker,"SparkleBurst1","Center")
		--PlaySound("pop_sparkle_01.ogg")
		Pop(newMarker, newMarker.popAdjustments)
	end
	while(true)do
		ScriptDelay(10000)
		ScriptBreak()
	end

end

Scripts.WiggleLoop = function(actor)
	if(actor:GetTaggedScriptCount("WiggleLoop") > 1) then 
		return
	end
	local speed = 50
	local factor = math.random(5,10)
	local amount
	local pick = math.random(0,1)
	if(pick==0)then 
		amount = 0-factor 
	else
		amount = factor
	end
	ScriptDelay(4000)
	while(true)do
		RotateByAmount(actor,{degrees=-amount},speed,true)
		RotateByAmount(actor,{degrees=amount*2-(amount/2)},speed,true)
		RotateByAmount(actor,{degrees=-((amount/2)+(amount/4))},speed,true)
		RotateByAmount(actor,{degrees=(amount/4)*2},speed,true)
		RotateByAmount(actor,{degrees=-amount/4},speed,true)
		actor.rotation = { degrees = 0 }		
		ScriptDelay(4000)
	end
end

Scripts.QuickWiggleLoop = function(actor)
	if(actor:GetTaggedScriptCount("NoDelayWiggleLoop") > 1) then 
		return
	end
	local speed = 50
	local factor = 10
	local amount = factor
	ScriptDelay(1000)
	while(true)do
		RotateByAmount(actor,{degrees=-amount},speed,true)
		RotateByAmount(actor,{degrees=amount*2-(amount/2)},speed,true)
		RotateByAmount(actor,{degrees=-((amount/2)+(amount/4))},speed,true)
		RotateByAmount(actor,{degrees=(amount/4)*2},speed,true)
		RotateByAmount(actor,{degrees=-amount/4},speed,true)
		actor.rotation = { degrees = 0 }		
		ScriptDelay(3000)
	end
end

Scripts.DelayedWiggleLoop = function(actor)
	actor:KillTaggedScripts("WiggleLoop")
	actor.rotation = { degrees = 0 }
	ScriptDelay(6000)
	actor:AddScript("WiggleLoop","WiggleLoop")
end

Scripts.KillDelayedWiggleLoop = function(actor)
	actor:KillTaggedScripts("WiggleLoop")
	actor.rotation = { degrees = 0 }
end

Scripts.AppMenuScreen_Debug_NextBackground = function(screen)
	local bkg = screen:FindChild("Bkg_sky",true)

	if(MenuScreen_backgroundIndex==0)then
		MenuScreen_backgroundIndex = 1
	end

	if(MenuScreen_backgroundIndex>=#LandBackgroundTable)then
		MenuScreen_backgroundIndex = 1
	else
		MenuScreen_backgroundIndex = MenuScreen_backgroundIndex + 1
	end
		
	bkg.image = LandBackgroundTable[MenuScreen_backgroundIndex]
end

Scripts.AppMenuScreen_Debug_PreviousBackground = function(screen)
	local bkg = screen:FindChild("Bkg_sky",true)

	if(MenuScreen_backgroundIndex==0)then
		MenuScreen_backgroundIndex = 1
	end

	if(MenuScreen_backgroundIndex<=1)then
		MenuScreen_backgroundIndex = #LandBackgroundTable
	else
		MenuScreen_backgroundIndex = MenuScreen_backgroundIndex - 1
	end
		
	bkg.image = LandBackgroundTable[MenuScreen_backgroundIndex]
end