
local Minigame_titleAlignmentOffset = {0,8}
local LargeLong_Dialog_Button_Y = -10
local ScreenScaleFactor = 2
 
Resources.ExplanationLabel = Resources.DialogLabel:new {
	resource = "DialogLabel",
	alignment = Center,
	alignTo = MidTop,
	alignmentOffset = {0,150},
	text = STRINGS(""),
}

Resources.WagerLabel = Resources.DialogLabel:new {
	resource = "DialogLabel",
	alignment = Center,
	alignTo = MidBottom,
	alignmentOffset = {0,-26},
	zorder = 2,
	text = STRINGS(""),
}

Resources.BetCheck = Resources.Actor:new {
	resource = "Actor",
	image = "Check.png",
	alignment = TopRight,
	zorder = 10,
	visible = false,
}

Resources.Minigame = Resources.LargeLongDialog:new {
	resource = "LargeLongDialog",
   
	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y},
		text = STRINGS("Okay"),
		--image = "btnOkay.png", 
		--text = STRINGS(""),		
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
	},
}

Resources.WheelMiniGame = Resources.Minigame:new {
	resource = "Minigame",
	class = "WheelMiniGame",
	name = "WheelMiniGame",
    --title = "ONE MORE SPIN???",
    title = "",

	titlePanel = Resources.Actor:new {
		resource = "Actor",
		image = "titleOneMoreSpin.png",
		alignment = MidTop,
		alignmentOffset = {0, 80},
    },
	
	explanationLabel = Resources.ExplanationLabel,
	
	wheelBackground = Resources.Actor:new {
		resource = "Actor",
		size = {340,400},
		alpha = 0,
		alignment = Center,
		alignmentOffset = {0,50},
		
		ArrowWheel = Resources.Actor:new {
			useFrames = false,
			alignment = MidTop,
			alignmentOffset = {0,60},
			text = STRINGS(""),
			image = "arrowWheel.png",
			frame = 0,
			zorder = 4,
		},
		
		SpinningWheel = Resources.Button:new {
			useFrames = false,
			alignment = Center,
			alignmentOffset = {0,0},
			text = STRINGS(""),
			image = "Wheel.png",
			frame = 0,
		},
	},
	
	centerText = Resources.DialogLabel:new {
		resource = "DialogLabel",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,30},
		text = STRINGS("TEST"),
		wrapLimit = 280,
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		visible = false,
	},
	
	wagerLabel = Resources.WagerLabel,
	
	SpinButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignmentOffset = {-60/ScreenScaleFactor,LargeLong_Dialog_Button_Y},
		text = STRINGS("Spin"),
		--image = "btnOkay.png", 
		--text = STRINGS(""),		
		enterKey = true,
		escapeKey = false,
		shortcutKey = "o",
		--size = DialogButtonSize,
	},	
	
	CancelButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = BottomLeft,
		alignmentOffset = {60/ScreenScaleFactor,LargeLong_Dialog_Button_Y},
		text = STRINGS("CashOut"),
		--image = "btnCancel.png", 
		--text = STRINGS(""),		
		enterKey = false,
		escapeKey = true,
		shortcutKey = "c",
		--size = DialogButtonSize,
	}, 		
}

Scripts.Preshow_PresentMiniGameWheel = function(game,gameScreen)
	local spinningWheel = game.wheelBackground.SpinningWheel
	spinningWheel.active = true
	RotateByAmount(spinningWheel, {degrees=math.random(0,360)}, 0)
	game.okayButton.visible = false
	game.centerText.visible = false
end

Scripts.Present_PresentMiniGameWheel = function(game)
	game.explanationLabel.text = STRINGS("Spin the wheel!")
	game.wagerLabel.text = STRINGS("")
	game.explanationLabel.visible = false
	game.wagerLabel.visible = false
	PlaySound("slot_machine_win_22.ogg")
	LoopSound("slot_machine_spin_loop_02.ogg")
end

Scripts.Leave_PresentMiniGameWheel = function(game)
end




Scripts.Preshow_WaitForUserResponseWheel = function(game)
end

Scripts.Present_WaitForUserResponseWheel = function(game)
	ScriptDelay(500,"dialogTimers")
	local wagerText = "Select the your bet!"
	local screen = game.parent
	game.wagerLabel.text = wagerText
	game.wagerLabel.visible = false
	--PlaySound("Cascade_Doop_1.ogg")
end

Scripts.Leave_WaitForUserResponseWheel = function(game,selectedButton)
	--[[
	selectedButton.betCheck.visible = true
	game.allButton.active = false
	game.halfButton.active = false
	game.quarterButton.active = false
	--]]
	game.wheelBackground.SpinningWheel.active = true
end




Scripts.Preshow_RunTrialWheel = function(game)
end

local spinWheel_speed = 1.2

Scripts.Present_RunTrialWheel = function(game,amount)
	game:KillTaggedScripts("Present_WaitForUserResponseWheel")
	StopSound("slot_machine_spin_loop_02.ogg")
	game.CancelButton.visible = false
	game.SpinButton.visible = false	
	game.wagerLabel.text =	"Touch the wheel to stop it."
	game.wagerLabel.visible = true
	LoopSound("slot_machine_wheel_spin_loop.ogg")
	local spinningWheel = game.wheelBackground.SpinningWheel
	local rotateAcc = 10
	while(rotateAcc > 0)do
		spinningWheel:StopRotation()
		spinningWheel:KillTaggedScripts("SpinWheel")
		AddScriptWithParams(spinningWheel,"SpinWheel",2/rotateAcc)
		rotateAcc = rotateAcc - 1
		ScriptBreak()
	end
	spinningWheel:StopRotation()
	spinningWheel:KillTaggedScripts("SpinWheel")
	local spinFactor = math.random(0,10) / 10  -- vary the speed via 0.0, 0.1 -> 1.0
	spinWheel_speed = 1.0 + spinFactor
	AddScriptWithParams(spinningWheel,"SpinWheel",spinWheel_speed)
end
	
Scripts.Leave_RunTrialWheel = function(game)
	local spinningWheel = game.wheelBackground.SpinningWheel
	spinningWheel.active = false
	game.wagerLabel.visible = false
	local rotateAcc = 1
	while(rotateAcc < 25)do
		spinningWheel:StopRotation()
		spinningWheel:KillTaggedScripts("SpinWheel")
		AddScriptWithParams(spinningWheel,"SpinWheel",spinWheel_speed/rotateAcc)
		rotateAcc = rotateAcc + 1
		ScriptBreak()
	end
	spinningWheel:StopRotation()
	spinningWheel:KillTaggedScripts("SpinWheel")
	game:KillTaggedScripts("Present_RunTrialWheel")
	ScriptBreak()
	local degrees = Angle_GetDegrees(spinningWheel.rotationAngle)
	while(degrees>360)do
		degrees = degrees - 360
	end
	spinningWheel.degrees = degrees
	PlaySound("slot_machine_spin_stop_05.ogg")
	StopSound("slot_machine_wheel_spin_loop.ogg")
end

Scripts.SpinWheel = function(actor,speed)
	RotateAtSpeed(actor, {revolutions=speed})
end

Scripts.Preshow_DisplaySuccessWheel = function(game)
end

Scripts.Present_DisplaySuccessWheel = function(game,winType,addedSpins,percentCost,amount)
	local spinningWheelPosition = game.wheelBackground.center
	spinningWheelPosition.x = spinningWheelPosition.x
	spinningWheelPosition.y = spinningWheelPosition.y-140
	StartParticleEmitterFromFile({targetParticleLayer = game.hgeParticles,file="Sparks1.guru_particle",position=spinningWheelPosition})
	--StopSoundAsMusic("_MiniGameMusicLoop.ogg")
	if(winType=="KARMA")then
		game.centerText.text = STRINGS("Some good karma for you today!\n\n+25% Score!")
		game.centerText.visible = true
		FadeOut(game.wheelBackground,100)
		PlaySound("Cascade_Chimes.ogg")
		PlaySound("slot_machine_spin_04_short.ogg")
	elseif(winType=="1SPIN")then
		PlaySound("Cascade_FreeSpin2.ogg")
	elseif(winType=="PAIDSPIN")then
		PlaySound("soft_lose_02.ogg")
	elseif(winType=="2SPINS")then
		PlaySound("Cascade_RightOn.ogg")
	elseif(winType=="3SPINS")then
		PlaySound("Cascade_Fantastic.ogg")
	elseif(winType=="FORTUNE")then
		PlaySound("slot_machine_win_01.ogg")

		if(percentCost>=0.50)then
			game.centerText.text = Fortunes[math.random(1,#Fortunes)].."\n\n+50% Score!!!!"
		elseif(percentCost>=0.30)then
			game.centerText.text = Fortunes[math.random(1,#Fortunes)].."\n\n+30% Score!!!"
		elseif(percentCost>=0.20)then
			game.centerText.text = Fortunes[math.random(1,#Fortunes)].."\n\n+20% Score!!"
		elseif(percentCost>=0.10)then
			game.centerText.text = Fortunes[math.random(1,#Fortunes)].."\n\n+10% Score!"
		end

		game.centerText.visible = true
		PlaySound("Cascade_Chimes.ogg")
		FadeOut(game.wheelBackground,100)
	end
	game.explanationLabel.text = STRINGS("You won ") .. Int2Comma(amount) .. " points!"
	game.wagerLabel.text = STRINGS("")
end

Scripts.Leave_DisplaySuccessWheel = function(game)
end




Scripts.Preshow_DisplayFailureWheel = function(game)
end

Scripts.Present_DisplayFailureWheel = function(game,winType,addedSpins,percentCost,amount)
	local spinningWheelPosition = game.wheelBackground.center
	spinningWheelPosition.x = spinningWheelPosition.x
	spinningWheelPosition.y = spinningWheelPosition.y-140
	--StartParticleEmitterFromFile({targetParticleLayer = game.hgeParticles,file="FireDisco1.small.guru_particle",position=spinningWheelPosition})
	if(winType=="10TAX")then
		PlaySound("melodic_lose_01.ogg")
	end
	
	local screen = game.parent
	
	--FadeOut(game.wheelBackground.SpinningWheel,1000)		

	--StopSoundAsMusic("_MiniGameMusicLoop.ogg")
	--PlaySound("_MiniGameMusic_Lose_Shorter.ogg")
	
	game.explanationLabel.text = STRINGS("Oh no! You lost ") .. Int2Comma(amount) .. " points!"
	game.wagerLabel.text = STRINGS("")
	
	ScriptDelay(919,"dialogTimers")
end

Scripts.Leave_DisplayFailureWheel = function(game)
end




Scripts.Preshow_CleanupMiniGameWheel = function(game)
end

Scripts.Present_CleanupMiniGameWheel = function(game)
	--game.allButton.visible = false
	--game.halfButton.visible = false
	--game.quarterButton.visible = false
	game.CancelButton.visible = false
	game.SpinButton.visible = false
	game.okayButton.visible = true
	StopSound("slot_machine_spin_loop_02.ogg")
	while true do
		--Wait until destroyed
		ScriptBreak()
	end
end


Scripts.Leave_CleanupMiniGameWheel = function(game)
	StopSound("slot_machine_spin_loop_02.ogg")
end


