kTodoFeedWidth = 232+(232*.10)
local todoFeedItemHeight = 75+(75*.10)-12
local todoBtnHeight = 75+(75*.10)
local todoBtnWidth = 122+(122*.10)
local todoMarginX = 8+(8*.10)
local todoGoldWidth = kTodoFeedWidth - todoBtnWidth - todoMarginX * 3
local todoBtnOffsetX = 0
local todoGoldOffsetX = todoMarginX * 1.25 + todoBtnWidth + 4
local checkboxLength = todoGoldWidth / 4 + todoMarginX / 3

local screenHeight = Layout{500, iphone5=568, ipad=512}

Resources.TodoFeedPanel = Resources.Actor:new{
	resource = "Actor",
	class = "TodoFeedPanel",
	--image = "Dialog_Banner_Large.png",
	size = {kTodoFeedWidth,0},

    contentNode = Resources.Actor:new {
        resource = "Actor",
        class = "ScrollableArea",
        DisplayDimensions = {kTodoFeedWidth,screenHeight},
		horizontalScrollLocked = true,
        SlowFraction = .95,
		stoppingVelocity = 1,
        size = {kTodoFeedWidth,screenHeight},
        alignment = "Center",
        --color = "Red",
        zorder = 21,
    },
}

Resources.TodoSlot = Resources.Actor:new {
    resource = "Actor",
    alignment = "Center",
    size = {checkboxLength*1.18,checkboxLength*1.18},
    resizeOnSetImage = false,
}

Resources.TodoSlot_StarOff = Resources.TodoSlot:new {
    resource = "TodoSlot",
    image = "StarBig_off.png",

    goldSprite = Resources.Actor:new {
        resource = "Actor",
        alignment = "Center",
        size = {checkboxLength*1.60,checkboxLength*1.45},
        image = "Gold_1bar.png",
        resizeOnSetImage = false,
    },
}

Resources.TodoSlot_StarOn = Resources.TodoSlot:new {
    resource = "TodoSlot",
    image = "StarBig_achieved.png",
}

Resources.TodoSlot_QuickQuest = Resources.TodoSlot:new {
    resource = "TodoSlot",
    OnPostSpawn = function (self)
        self.image = QQ_MGR:GetImagePath(false,0.53)
    end,
}

Resources.TodoSlot_DailyChallengeOn = Resources.TodoSlot:new {
    resource = "TodoSlot",
    image = "Medal_big_bronze.png",
}

Resources.TodoSlot_DailyChallengeOff = Resources.TodoSlot:new {
    resource = "TodoSlot",
    image = "Medal_big_off.png",
}

Resources.TodoSlot_Workers = Resources.TodoSlot:new {
    resource = "TodoSlot",
    image = "Land2_Worker.png",
    size = {checkboxLength,checkboxLength},
}

Resources.TodoSlot_HarvestDiscoveries = Resources.TodoSlot:new {
    resource = "TodoSlot",
    image = "Land2_Worker.png",
}

Resources.TodoSlot_BuildDiscoveries = Resources.TodoSlot:new {
    resource = "TodoSlot",
    image = "Land2_Worker.png",
	maxDimensions = {50,50},
}

Resources.TodoSlot_LabEvent = Resources.TodoSlot:new {
    resource = "TodoSlot",
    image = "LabLevelIcon.png",
}

Resources.TodoFeedCheckBox = Resources.Actor:new {

    resource = "Actor",
    size = {checkboxLength,checkboxLength},
}

Resources.TodoFeedRow = Resources.Actor:new{

	resource = "Actor",
    class = "TodoFeedRow",
    size = {kTodoFeedWidth,todoFeedItemHeight},
    --image = "button_bigger_white.png",
    alpha = 0,

	ActionButton = Resources.Button:new {

		resource = "Button",
        image = "TodoButton_Canvas.png",
		--text = STRINGS("Play Current Level"),
		--alignment = "MidLeft",
        --alignmentOffset = {todoBtnOffsetX,0},
		--textColor = "Cascade_DarkBrown",
		--scripts = {"SparkleRandomly"},
		--textLineSpacing = 3,
		zorder = 22,
		visible = true,

        clickSound = "CLEEP_B.ogg",

		useFrames = false,
        textCenterWrap = true,

		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			return false
		end,

        --[[
                tapImage = Resources.Button:new {
            resource = "Button",
            image = "ButtonPlastic_Shop_Short.png",

            alignment = "Center",
            alignmentOffset = {60+todoMarginX-10,-1},

            textWrapLimit = todoBtnWidth-42,
            textHeightLimit = todoBtnHeight - todoMarginX * 5,

            textColor = "Cascade_DarkBrown",
            textShadowColor = "Cascade_White",
            textShadowAlpha = 150,
            textHighlightColor = "Panel_LightBrown",
            textHighlightAlpha = 125,
            textShadowOffset = {1,1},
            textHighlightOffset = {-1,-1},
            font	= Resources.AppButtonFont:new{
                resource = "AppButtonFont",
                fontSize = 24,
            },
            textRolloverColor = "Cascade_DarkBrown",
            rolloverable = false,
        },
        --]]
        
        tapImage = Resources.EndGameDialogBigButton:new {
            resource = "EndGameDialogBigButton",
            image = "ButtonPlastic_Shop_Short.png",

            alignment = "Center",
            alignmentOffset = {60+todoMarginX-10,-1},

            textWidthLimit = todoBtnWidth-42,
            textHeightLimit = todoBtnHeight - todoMarginX * 5,
            
            font = Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 20,
            },
            rolloverable = false,
        },

		title = Resources.Label:new {
			resource = "Label",
			--text = "LEVEL NAME",
			alignment = "Center",
			alignmentOffset = {-60+todoMarginX-12,-16+1},

			fgColor = "Cascade_DarkBrown",
			--shadowColor = "Cascade_White",
			--shadowAlpha = 150,
			--highlightColor = "Panel_LightBrown",
			--highlightAlpha = 125,
			--shadowOffset = {1,1},
			--highlightOffset = {-1,-1},
			font	= Resources.AppButtonFont:new{
				resource = "AppButtonFont",
				fontSize = 18,
			},
			centerWrap = true,
            widthLimit = 130,
		},

        slotsNode = Resources.LayoutBox:new {
            margin = 0,
            isVertical = false,

			resource = "Actor",
			size = {todoGoldWidth,todoBtnHeight},
			--color = "Yellow",
			alignment = "MidLeft",
			alignmentOffset = {(todoMarginX * 3.5)-3,(todoBtnHeight / 2)+10},
        },
	},
}

Scripts.TodoAttract = function(actor)
	if(actor:GetTaggedScriptCount("TodoAttract") > 1) then
		return
	end
	local speed = 120
	local amount = 22
	while(true)do
		--RotateByAmount(actor,{degrees=-amount/2},speed/2,true)
		--RotateByAmount(actor,{degrees=amount},speed,true)
		--RotateByAmount(actor,{degrees=-amount/2},speed/2,true)
		--RotateByAmount(actor,{degrees=-amount/2},speed/2,true)
		--RotateByAmount(actor,{degrees=amount},speed,true)
		--RotateByAmount(actor,{degrees=-amount/2},speed/2,true)
        --ScaleTo(actor,{1.2,0.8},speed,true)
        --ScaleTo(actor,{0.7,1.3},speed/2,true)
        --ScaleTo(actor,{1.1,0.9},speed/2,true)
        --ScaleTo(actor,{1.0,1.0},speed,true)
		ScriptDelay(500)
        --ScaleTo(actor,{0.9,1.1},1000,true)
        --ScaleTo(actor,{1.0,1.0},1000,true)
		ScriptDelay(2000)
        RotateTo(actor,{degrees=-amount},speed,true)
		RotateTo(actor,{degrees=amount},speed/2,true)
		RotateTo(actor,{degrees=-amount/2},speed/2,true)
		RotateTo(actor,{degrees=amount/2},speed/2,true)
		RotateTo(actor,{degrees=-0},speed/2,true)
		ScriptDelay(500)
        --ScaleTo(actor,{0.9,1.1},1000,true)
        --ScaleTo(actor,{1.0,1.0},1000,true)
        ScriptDelay(2000)
	end
end

Scripts.TodoAttractStop = function(actor)
	if(actor:GetTaggedScriptCount("TodoAttractStop") > 1) then
		return
	end
	local speed = 120
    RotateTo(actor,{degrees=-0},speed/2,false)
    ScaleTo(actor,{1.0,1.0},speed/2,false)

end

