Resources.TopBar = Resources.LayoutBox:new {
	resource = "LayoutBox",
	alignment = "MidTop",
	alignTo = "MidTop",
	--TOPBARNOTE1: If changing alignmentOffset be sure to change in ShowTopBarFromDialog script too.
	alignmentOffset = Layout{{6, 25},iphone5={6, 25},ipad={6, 25},androidShort={6,20}},
	size = {APP.screenSize.x,15},
    layer = 1005,
    margin = Layout{10,iphone5=10,ipad=20},
    isVertical = false,

	ignoreGamePause = true,
	
    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 100,
		tag = "hgeParticles_topbar",
    },

	LivesButton = Resources.AppButton:new {
		resource = "AppButton",
		image = "MapPanel_Lives_NoPlus.png",
		useFrames = false,

		AddButton = Resources.Actor:new {
			resource = "Actor",
			image = "AddButton.png",
			alignment = "BottomLeft",
			alignmentOffset = {24,-6},
		},

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			alignment = MidBottom,
			alignTo = MidBottom,
			alignmentOffset = {-44,25},
			extraScale = 0.5,
			rotationAngle = {degrees = 0,},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
		},

		livesAmountLabel = Resources.Label:new {
			resource = "Label",
			text = STRINGS(""),
			font = Resources.AppGameFont:new {
				resource = "AppGameFont",
				fontSize = 25,
			},
			fgColor = "White",
			shadowColor = "Black",
			highlightColor = "Black",
			alignment = "Center",
			alignTo = "MidLeft",
			alignmentOffset = {20,-6},
            widthLimit = 22,
			
			OnPostSpawn = function(self)
				self:Refresh(self)
			end,

			Refresh = function(self)
				local currentLives
				if LIVES_MGR:HasInfiniteLives() then
					currentLives = math.huge
				else
					currentLives = LIVES_MGR:CountAvailableLives()
				end
				local previousLives = self.previousLives or currentLives
				--local maxStandardLives = LIVES_MGR:CountMaxStandardLives()
				--logprintf("currentLives:%s, previousLives:%s, maxStandardLives:%s\n", tostring(currentLives), tostring(previousLives), tostring(maxStandardLives))
					
				if (currentLives == math.huge) then
					self.text = "∞"
				else
					self.text = tostring(currentLives)
				end
					
				if (currentLives > previousLives) then
					AddScriptWithParams(self.parent, "AddLife")
				end

				self.previousLives = currentLives
			end,
			Tick = function (self)
				self:Refresh(self)
			end,

			NumberMarker = Resources.Actor:new {
				image = "NumberMarker.png",
				alignment = "Center",
				alignTo = "Center",
				visible = false,
			},
		},

        LivesButtonIcon = Resources.Actor:new {
			resource = "Actor",
			image = "MapPanel_Lives_NoPlus.png",
			alpha = 0,

			useFrames = false,
				
			Tick = function (self)
				--self.visible = (LIVES_MGR:IsNewLifePending() or LIVES_MGR:HasInfiniteLives())
				self.active = LIVES_MGR:CanPurchaseLives()
					
				self.visible = true
			end,
		
			NextLifeLabel = Resources.Label:new {
				resource = "Label",
				text = STRINGS(""),
				font = Resources.DialogTitleFont:new {
					resource = "DialogTitleFont",
					fontSize = 14,
				},
				fgColor = "Black",
                widthLimit = 40,

				alignment = "MidLeft",
                alignTo = "MidLeft",
				alignmentOffset = {45,-3},
			
				Tick = function (self)
					if LIVES_MGR:HasInfiniteLives() then
						self.text = LIVES_MGR:DescribeTimeToInfiniteLivesEnd()
                        self.font.fontSize = 14
						self.widthLimit = 40
						self.alignmentOffset = {45,-3}
					else
						self.text = LIVES_MGR:DescribeTimeToNextLife()
                        self.font.fontSize = 18
						self.alignmentOffset = {45,-4}
						if (Language == "ja") then
							self.widthLimit = 60
							self.alignmentOffset = {43,-4}
						end
					end

					if(not (LIVES_MGR:IsNewLifePending() or LIVES_MGR:HasInfiniteLives())) then
						self.text = STRINGS("Full")
                        self.font.fontSize = 20
						self.alignmentOffset = {45,-7}
						if (Language == "ja" or Language == "ru") then
							self.widthLimit = 40
							self.alignmentOffset = {45,-4}
						end
					end
				end,
			},
		},
	},

	GoldButton = Resources.AppButton:new {
		resource = "AppButton",
		image = "MapPanel_Gold_NoPlus.png",
		useFrames = false,
		scripts = {"SparkleRandomly_gold"},
        zorder = 2,

		AddButton = Resources.Actor:new {
			resource = "Actor",
			image = "AddButton.png",
			alignment = "BottomLeft",
			alignmentOffset = {30,-6},
		},

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			alignment = MidBottom,
			alignTo = MidBottom,
			alignmentOffset = {-44,25},
			extraScale = 0.5,
			rotationAngle = {degrees = 0,},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
		},

		NewMarker = Resources.ScoreCounter:new {
			resource = "ScoreCounter",

			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {20,-4},

			useCurrency = false,
            useComma = true,
			score = 0,

			labelProperties = {
				resource = "Label",
				fgColor = "Black",
				font	= Resources.DialogTitleFont:new{
					resource = "DialogTitleFont",
					fontSize = 20,
				},
				widthLimit = 40,
            },

			NumberMarker = Resources.Actor:new {
				image = "NumberMarker.png",
				alignment = "Center",
				alignTo = "Center",
				zorder = -1,
				visible = false,
			},
		},
	},

	StarCardRankButton = Resources.AppButton:new {
		resource = "AppButton",
		image = "MapPanel_Stars.png",
		useFrames = false,
		zorder = 3,
		rolloverable = true,

		NewMarker = Resources.ScoreCounter:new {
			resource = "ScoreCounter",

			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {12,-2},

			useCurrency = false,
            useComma = true,
			score = 0,

			labelProperties = {
				resource = "Label",
				fgColor = "Black",
				font	= Resources.DialogTitleFont:new{
					resource = "DialogTitleFont",
					fontSize = 20,
				},
				widthLimit = 40,
            },

			NumberMarker = Resources.Actor:new {
				image = "NumberMarker.png",
				alignment = "Center",
				alignTo = "Center",
				zorder = -1,
				visible = false,
			},
		},
		viewLabel = Resources.Label:new {
			resource = "Label",
			--text = STRINGS("View"),
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 12,
			},
			fgColor = "Cascade_Black",
			widthLimit = 30,
			alignment = "Center",
			alignTo = "TopLeft",
			alignmentOffset = {18,18},
		},
	},
}

Resources.TopBar_HideButtons = {
	class = "LayoutBox",

	LivesButton = {
		class = "Button",
		AddButton = {
			class = "Actor",
			visible = false,
		},
	},
	
	GoldButton = {
		class = "Button",
		AddButton = {
			class = "Actor",
			visible = false,
		},
	},

	StarCardRankButton = {
		class = "Button",
		image = "MapPanel_Stars.png",
		viewLabel = {
			class = "Label",
			visible = false,
		},
	},
}

Resources.TopBar_ShowButtons = {
	class = "LayoutBox",

	LivesButton = {
		class = "Button",
		AddButton = {
			class = "Actor",
			visible = true,
		},
	},
	
	GoldButton = {
		class = "Button",
		AddButton = {
			class = "Actor",
			visible = true,
		},
	},

	StarCardRankButton = {
		class = "Button",
		image = "MapPanel_Stars.png",
		viewLabel = {
			class = "Label",
			visible = true,
		},
	},
}

Scripts.AddLife = function(livesButton)
	if(livesButton:IsGloballyVisible()) then
		PlaySound("coin_magic_06.ogg");
		FireParticle(livesButton,"Shine1","Center")
		FireParticle(livesButton,"StarBurst1.smaller","Center")
		CorrectedPop(livesButton,  {expandTime=250, shrinkTime=100, expandTo={1.25, 1.25}})
	end
end

Scripts.Animate_GettingGold = function(self) --self == newMarker
	logprint("Animate_GettingGold_MapScreen: "..self.name)
	local topBar = self.parent.parent
	local topBarParticles = topBar.hgeParticles
	PlaySound("coin_magic_07.ogg")
	FireParticle(self,"Shine2","Center",topBarParticles)
	FireParticle(self,"StarToss1.smaller","Center",topBarParticles)
	ScriptDelay(500)
	PlaySound("Boxing_Bell2.ogg")
	CorrectedPop(self)
	ScriptDelay(250)
	PlaySound("Cascade_Yeah.ogg")
end

Scripts.Animate_GettingGold_dialog = function(dialog)
	logprint("Animate_GettingGold_dialog: "..dialog.name)
	PlaySound("coin_magic_07.ogg")
	local screen = dialog.screen
	local topBar = screen:FindChild("TopBar",true)
	local newMarker = topBar:FindChild("NewMarker",true)
	FireParticle(newMarker,"Shine2","Center",dialog.hgeParticles)
	FireParticle(newMarker,"StarToss1.smaller","Center",dialog.hgeParticles)
	ScriptDelay(500,"DialogTimers")
	PlaySound("Boxing_Bell2.ogg")
	CorrectedPop(newMarker)
	ScriptDelay(250,"DialogTimers")
	PlaySound("Cascade_Yeah.ogg")
end

Scripts.ShowTopBarFromDialog = function(dialog)
	local screen = dialog.screen
	local topBar = screen:FindChild("TopBar",true)
	if(topBar.visibilityQueue == nil) then
		topBar.visibilityQueue = {}
	end
	if(#topBar.visibilityQueue == 0) then
		topBar:ApplyProperties(Resources.TopBar_HideButtons)
	end
	topBar.visibilityQueue[#topBar.visibilityQueue + 1] = topBar.visible
	if(topBar.visible == false) then
		--HACK: A bit of hack to make sure topBar location doesn't get whacked out TOPBARNOTE1
		topBar.alignmentOffset = Layout{{6, 25},iphone5={6, 25},ipad={6, 25},androidShort={6,20}}
		SlideOn(topBar,DIALOG_SLIDE_SPEED,"top","wait")
	else
	end
end

Scripts.HideTopBarFromDialog = function(dialog)
	local screen = dialog.screen
	local topBar = screen:FindChild("TopBar",true)
	if(topBar.visibilityQueue == nil) then
		logprint("Warning: HideTopBarFromDialog was called when show was never called. If this happens via normal gameplay rather than debug actions, it is a bug.")
		return
	end
	if(topBar.visibilityQueue[#topBar.visibilityQueue] == false and topBar.visible == true) then
		SlideOff(topBar,DIALOG_SLIDE_SPEED/2,"top","wait")
	end
	topBar.visibilityQueue[#topBar.visibilityQueue] = nil
	if(#topBar.visibilityQueue == 0) then
		topBar:ApplyProperties(Resources.TopBar_ShowButtons)
	end
end

Resources.TopBar_SpecialGems = Resources.LayoutBox:new {
	resource = "LayoutBox",
	alignment = "MidTop",
	alignTo = "MidTop",
    alignmentOffset = Layout{{4, 63},iphone5={4, 63},ipad={4, 63}},
	size = {APP.screenSize.x,15},
    layer = 900, --hangs just below the overlay
    margin = Layout{10,iphone5=10,ipad=20},
    isVertical = false,

	ignoreGamePause = true,
	
    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 100,
		tag = "hgeParticles_topbar",
    },

	SpecialGemButton3 = Resources.AppButton:new {
		resource = "AppButton",
		image = "MapPanel_Blank.png",
		useFrames = false,
		zorder = 1,
		visible = false,

		GemTypeContainer = Resources.Actor:new {
			resource = "Actor",
			alpha = 0,
			alignment = Center,
			alignmentOffset = {-28,-3},
			size = {35,35},
			GemTypeImage = Resources.Actor:new {
				resource = "Actor",
				image = "GemSpecialGreen.png",
				alignment = Center,
				autoFillParent = true,
			},
		},

		NewMarker = Resources.ScoreCounter:new {
			resource = "ScoreCounter",

			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {12,-3.5},

			useCurrency = false,
            useComma = true,
			score = 0,

			labelProperties = {
				resource = "Label",
				fgColor = "Black",
				font	= Resources.DialogTitleFont:new{
					resource = "DialogTitleFont",
					fontSize = 20,
				},
				widthLimit = 40,
            },          
			NumberMarker = Resources.Actor:new {
				image = "NumberMarker.png",
				alignment = "Center",
				alignTo = "Center",
				zorder = -1,
				visible = false,
			},     
		},
	},

	SpecialGemButton2 = Resources.AppButton:new {
		resource = "AppButton",
		image = "MapPanel_Blank.png",
		useFrames = false,
		zorder = 2,
		visible = false,

		GemTypeContainer = Resources.Actor:new {
			resource = "Actor",
			alpha = 0,
			alignment = Center,
			alignmentOffset = {-28,-3},
			size = {35,35},
			GemTypeImage = Resources.Actor:new {
				resource = "Actor",
				image = "GemSpecialGreen.png",
				alignment = Center,
				autoFillParent = true,
			},
		},

		NewMarker = Resources.ScoreCounter:new {
			resource = "ScoreCounter",

			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {10,-3.5},

			useCurrency = false,
            useComma = true,
			score = 0,

			labelProperties = {
				resource = "Label",
				fgColor = "Black",
				font	= Resources.DialogTitleFont:new{
					resource = "DialogTitleFont",
					fontSize = 20,
				},
				widthLimit = 40,
            },
			NumberMarker = Resources.Actor:new {
				image = "NumberMarker.png",
				alignment = "Center",
				alignTo = "Center",
				zorder = -1,
				visible = false,
			},
		},
	},

	SpecialGemButton1 = Resources.AppButton:new {
		resource = "AppButton",
		image = "MapPanel_Blank.png",
		useFrames = false,
		zorder = 3,
		visible = false,

		GemTypeContainer = Resources.Actor:new {
			resource = "Actor",
			alpha = 0,
			alignment = Center,
			alignmentOffset = {-28,-3},
			size = {35,35},
			GemTypeImage = Resources.Actor:new {
				resource = "Actor",
				image = "GemSpecialGreen.png",
				alignment = Center,
				autoFillParent = true,
			},
		},

		NewMarker = Resources.ScoreCounter:new {
			resource = "ScoreCounter",

			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {10,-3.5},

			useCurrency = false,
            useComma = true,
			score = 0,

			labelProperties = {
				resource = "Label",
				fgColor = "Black",
				font	= Resources.DialogTitleFont:new{
					resource = "DialogTitleFont",
					fontSize = 20,
				},
				widthLimit = 40,
            },
			NumberMarker = Resources.Actor:new {
				image = "NumberMarker.png",
				alignment = "Center",
				alignTo = "Center",
				zorder = -1,
				visible = false,
			},
		},
	},
}

Scripts.ShowSpecialGemsTopBarFromDialog = function(dialog)
	local screen = dialog.screen
	local topBar = screen:FindChild("TopBar_SpecialGems",true)
	if(topBar.visibilityQueue == nil) then
		topBar.visibilityQueue = {}
	end
	topBar.visibilityQueue[#topBar.visibilityQueue + 1] = topBar.visible
	if(topBar.visible == false) then
		SlideOn(topBar,DIALOG_SLIDE_SPEED,"top","nowait")
	else
	end
end

Scripts.HideSpecialGemsTopBarFromDialog = function(dialog)
	local screen = dialog.screen
	local topBar = screen:FindChild("TopBar_SpecialGems",true)
	if(topBar.visibilityQueue == nil) then
		logprint("Warning: HideTopBarFromDialog was called when show was never called. If this happens via normal gameplay rather than debug actions, it is a bug.")
		return
	end
	if(topBar.visibilityQueue[#topBar.visibilityQueue] == false and topBar.visible == true) then
		SlideOff(topBar,DIALOG_SLIDE_SPEED/2,"top","wait")
	end
	topBar.visibilityQueue[#topBar.visibilityQueue] = nil
end