
local function CycleImageFrames(self, delayInMS, timerGroup)
	while true do
		ScriptDelay(delayInMS, timerGroup)
		local frameCount = self.imageFrameCount
		if frameCount <= 0 then
			error("imageFrameCount was a non-positive number: " .. tostring(frameCount))
		end
		local frame = self.frame
		frame = frame + 1
		if frame >= frameCount then
			frame = 0
		end
		self.frame = frame
	end
end

Scripts.CycleImageFrames_Delay60ms = function (self)
	CycleImageFrames(self, 60, self.timerGroup)
end

Resources.ActivityIndicator_Circles_20x20 = Resources.Actor:new {
	resource = "Actor",
	image = "ActivityIndicator_Circles_20x20.png",
	frame = 0,
	scripts = {
		"CycleImageFrames_Delay60ms",
	},
}
