
local AppURLs = {
	["Solitaire Kingdom Supreme iPhone"] = "http://itunes.apple.com/us/app/solitaire-kingdom-supreme/id463543107?&mt=8",
	["Slingo Supreme HD iPad"] = "http://itunes.apple.com/us/app/slingo-supreme-hd/id409890132?&mt=8",
	["Poker Superstars III iPhone"] = "http://itunes.apple.com/us/app/poker-superstars-iii/id307752576?mt=8",
}

--[[
	GetAppURL
	
	GetAppURL retrieves a web link to more information on an app given a human-readable,
	or app-readable token.  It serves to remember potentially lengthy URLs.
	
	Params:
		name: The full name of an app.
		
	Returns:
		A string representing a web link to the requested app, or nil if no such link
		could be found.
--]]
function GetAppURL(name)
	local appURL = AppURLs[name]
	if not appURL then
		logprintf("GetAppURL, WARNING: Unable to find a URL associated with the name, '%s'\n", tostring(name))
	end
	return appURL
end
