--These are the properties used for the common dialog library in Guru.  
--Override these properties to customize the look of custom dialogs.  



--DialogTitleLabels: 
--These themselves override DialogTitleLabel in Dialogs.lua.  They are
--properties applied to the title labels of specific dialogs.

Resources.EnterNameTitleLabel = {}
Resources.GamePausedTitleLabel = {}
Resources.GamePausedText = {}
Resources.LoadGameTitleLabel = {}
Resources.LoadGameText = Resources.Label:new
{
	font = {resource = "DialogLabelFont"},
}

--Components of specific dialogs:
--These components are called out directly from C++ code.

--From EnterNameAndSkillDialog

Resources.EnterNameLabel = Resources.Label:new
 {
    fgColor = "Black",
    shadowColor = "White",
	font = {resource = "DialogLabelFont"},
	text = "Enter Name:",
	alignment = "MidTop",
	alignTo = "MidTop",
	alignmentOffset = {0,95},
}

Resources.ProfileLabel = Resources.Label:new
{
    fgColor = "Black",
	font = {resource = "DialogLabelFont"},
	
	alignment = "MidBottom",
	alignTo = "MidBottom",
	alignmentOffset = {0,-90},
}


--From game tip dialog

Resources.CommonDialogHeader = Resources.Label:new
{
	name = "Header",
	fgColor = "Black",
	font = 
	{
		resource = "DialogTitleFont",
	},
	alignment = "MidTop",
	alignTo = "MidTop",
	alignmentOffset = {0, 14},
}

Resources.CommonDialogSubHeader = Resources.Label:new
{
	name = "SubHeader",
	fgColor = "White",
	font = 
	{
		resource = "DialogTitleFont",
	},
	text = "Your App's Name Here",
	alignment = "MidTop",
	alignTo = "MidTop",
	alignmentOffset = {0, 48}
}

Resources.GameTipDialog = 
{
	header = Resources.CommonDialogHeader:new
	{
		resources = "CommonDialogHeader",
		text = "Game Tip!",
	},
	subHeader = Resources.CommonDialogSubHeader:new
	{
		resources = "CommonDialogSubHeader",
	},
}

--Credits Dialog

Resources.CreditsDialog = Resources.Dialog:new
{
	alignment = Center,
	image = nil,
	pageContent = Resources.Actor:new
	{
		alignment = MidTop,
		alignTo = MidTop,
		border = Resources.Border:new
		{
			resource	= "Border",
			thickness	= 
			{
				left	= 2,
				right	= 2,
				top		= 2,
				bottom	= 2,
			}
		}
	},
	pages = 
	{
		[1] = Resources.Actor:new
		{
			Title_Label = Resources.Label:new
			{
				alignment = MidTop,
				alignTo = MidTop,
				alignmentOffset = {0, 10},
				fgColor = "White",
				shadowColor = "VeryDarkGray",
				font = 
				{
					resource = "DialogTitleFont",
				},
				text = "credits",
			},
			
			Resources.Label:new
			{
				text = "Place credits here.\n",
				alignment = MidTop,
				alignTo = MidTop,
				alignmentOffset = {x = 0, y = 50, },
				fgColor = "Black",
				font =
				{
					resource = "CreditsLabelFont",
				},
			},
		},
	},
	
	OkayButton = Resources.OkayButton:new {
		resource = "OkayButton",
		alignment = MidBottom,
		alignmentOffset = {0,-50},
		buttonClosesDialog = true,
	},
	
	NextButton = Resources.NextButton:new {
		resource = "NextButton",
		alignment = BottomRight,
		alignmentOffset = {-25,-50},
	},
	
	PrevButton = Resources.PrevButton:new {
		resource = "PrevButton",
		alignment = BottomLeft,
		alignmentOffset = {25,-50},
	},
}

--New Player Wizard

Resources.NewPlayerWizardDefaults = Resources.Dialog:new
{
	resource = "Dialog",
	shaderType = "SHADERTYPE_BLENDCOMBINEDALPHA",
	doSerialize = false,
	name = "SetupNewPlayerWizard",
	class = "SetupNewPlayerWizard",
	image = "bkgDialogLarge.png",
    title = "",
    alignment = "Center",
	pageOrder = 
	{
		"EnterNamePage",
		"ChoosePicturePage",
	},		

	OkayButton = Resources.Button:new
	{
		image = "Button.png",
		text = "Okay",
		font = {resource = "ButtonFont",},
		alignment = "MidBottom",
		alignmentOffset = {125, -50},
		buttonClosesDialog = true,
		shortcutKey = "O",
		enterKey=true,
	},
	
	NextButton = Resources.Button:new
	{
		image = "Button.png",
		text = "Next",
		font = {resource = "ButtonFont",},
		alignment = "MidBottom",
		alignmentOffset = {125, -50},
		shortcutKey = "n",
		useAltShortcutKey=true,
		enterKey=true,
	},
	
	BackButton = Resources.Button:new
	{
		image = "Button.png",
		text = "Back",
		font = {resource = "ButtonFont",},
		alignment = "MidBottom",
		alignmentOffset = {-125, -50},
		shortcutKey = "b",
		useAltShortcutKey=true,
		backspaceKey=true,
	}, 
	 
	CancelButton = Resources.Button:new
	{
		image = "Button.png",
		text = "Cancel",
		font = {resource = "ButtonFont",},
		alignment = "MidBottom",
		alignmentOffset = {-0, -50},
		buttonClosesDialog = true,
		shortcutKey = "c",
		useAltShortcutKey=true,
		escapeKey=true,
	},
	
	pages = Resources.Actor:new
	{
		EnterNamePage = Resources.Actor:new
		{
			welcomeLabel = Resources.Label:new
			{
				font = { resource = "DialogTitleFont" },
				text = "Welcome!",
				alignment = "MidTop",
				alignmentOffset = {0, 112},
			},
				
			signInLabel = Resources.Label:new
			{
				font = { resource = "DialogLabelFont" },
				text = "Please Sign In:",
				alignment = "MidTop",
				alignmentOffset = {0, 243},
			},
			
			enterName = Resources.TextBox:new
			{
				limit = 10,
				boxSize = {170, 37},
				clickSound = "Click6.ogg",
				alignment = "MidTop",
				alignmentOffset = {0, 276},
				image = "sign_in.jpg",
			},
		}, --EnterNamePage

		ChoosePicturePage = Resources.Actor:new
		{
		    alignment = "MidTop",
		    
			pictureTitleLabel = Resources.Label:new
			{
				font =
				{ 
					resource = "DialogTitleFont",
					fontSize = 36,
				},
				text = "Choose Picture",
				alignment = "MidTop",
				alignmentOffset = {0, 92},
			},
			
			pictureSubtitle = Resources.Label:new	
			{
				font = { resource = "DialogLabelFont" },
				text = "Please select your picture",
				alignment = "MidTop",
				alignmentOffset = {0, 160},
			},
			
			loadButton = Resources.Button:new
			{	image = "Button.png",
				font = {resource = "ButtonFont",},
				text = "Load",
				shortcutKey="L",
				alignment = "MidRight",
				alignmentOffset = {-120, 103},
			},
			
			pictureButtons = Resources.RadioButtonGrid:new
			{
				alignment = "Center",
				alignmentOffset = {6,42},
				zorder = 1,
				resource = "PictureButtonGridSize", --Using resources to force this property to be applied before Actors and RadioButtons
				margins = 
				{
					[1] = {0,0}, --Margins
					[2] = {0,0}, --Gutter
				},
				
				radioButtons = 
				{
					[1] = 
					{
						cellPosition = {1,2},
						buttonSpec = Resources.RadioButton:new
						{
							name = "male",
							text = "Male",
							shortcutKey = "m",
							image = "Button.png",
							font = {resource = "ButtonFont",},
							checkBoxPosition = {4,4},
						}
					},
					
					[2] = 
					{
						cellPosition = {2,2},
						buttonSpec = Resources.RadioButton:new
						{
							name = "female",
							text = "Female",
							shortcutKey = "f",
							image = "Button.png",
							font = {resource = "ButtonFont",},
							checkBoxPosition = {4,4},
						}
					},
					
					[3] = 
					{
						cellPosition = {3,2},
						buttonSpec = Resources.RadioButton:new
						{
							name = "custom",
							text = "Custom",
							shortcutKey = "u",
							image = "Button.png",
							font = {resource = "ButtonFont",},
							checkBoxPosition = {4,4},
						}
					},
				},
				actors = 
				{
					[1] = 
					{
						cellPosition = {1,1},
						actorSpec = Resources.Actor:new
						{
							alignment = "Center",
							image = "photoPlayer.male.png",
							size = {78,74},
						},
					},
					
					[2] =
					{
						cellPosition = {2,1},
						actorSpec = Resources.Actor:new
						{
							alignment = "Center",
							image = "photoPlayer.female.png",
							size = {78,74},
						},
					},
					
					[3] = 
					{
						cellPosition = {3,1},
						actorSpec = Resources.Actor:new
						{
							name = "photoContainer",
							image = "custom_background.jpg",
							alignment = "Center",
							children = 
							{
								photoCover = Resources.Actor:new
								{
									image = "custom_cover.png",
								},
								customPhoto = Resources.PlayerPicture:new
								{
									useCustomImage = true,
									alignment = "Center",
									size = {78,74},
								},
							},
						},
					},
				}, --Actors for picture button grid
			}, --Picture Buttons
		}, --Choose Picture Page
	}, --Pages
} --Wizard properties

--This resource is applied because grid must apply the cellSize property in a certain order.

Resources.PictureButtonGridSize =
{
	cellSize = 
	{
		[1] = {3,2}, --# grid dimensions
		[2] = {120,84}, --Size of each grid item
	}, 
}

Resources.SetupNewPlayerWizard = Resources.NewPlayerWizardDefaults:new
{
	resource = "NewPlayerWizardDefaults"
}

Resources.SimpleTextDialog = Resources.Dialog:new
{
	class = "SimpleTextDialog",
	resource = "Dialog",
	image = "bkgDialogLarge.png",
	OkayButton = Resources.OkayButton:new {
		resource = "OkayButton",
		alignment = "MidBottom",
		alignTo = "MidBottom",
		alignmentOffset = {0,-50},
		buttonClosesDialog = true,
	},
	TextLabel = Resources.Label:new {
		resource = "Label",
		alignment = "Center",
		alignTo = "Center",
		font = Resources.DialogLabelFont,
	}
}

Resources.LoadSavedGameDialog = Resources.Dialog:new
{
	class = "LoadSavedGameDialog",
	resource = "Dialog",
    name = "LoadSavedGameDialog",
    
	image = "dlgSquare.png",
    title =  "Load Last Game?",
    
    --Text
    SubTitle = Resources.Label:new {
		resource = "Label",
		text = "Your last game was saved.",
		alignment = MidTop,
		alignTo = MidTop,
		alignmentOffset = {0,80},
    },
    
	ExplanatoryText = Resources.Label:new {
		resource = "Label",
		text = "Would you like to\nRESUME playing or\nbegin a NEW game?",
		alignment = Center,
		alignmentOffset = {0,-10},
	},
    
    --Buttons
    NewGameButton = Resources.OkayButton:new {
		resource = "OkayButton",
		enterKey = false,
		text = "New",
		shortCutkey = "N",
		enterKey = false,
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = {-70,-45},
		buttonClosesDialog = true,
    },
    
    CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		alignment = MidBottom,
		alignTo = MidBottom,
		text = "Cancel",
		alignmentOffset = {60,-45},
		buttonClosesDialog = true,
    },
    ResumeButton = Resources.OkayButton:new {
		resource = "OkayButton",
		text = "Resume",
		shortCutkey = "r",
		enterKey = true,
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = {-70,-90},
    },
}

Resources.ConfirmPlayerDeletionDialog = Resources.Dialog:new
{
	resource = "Dialog",
	class = "ConfirmPlayerDeletionDialog",
	name = "ConfirmPlayerDeletionDialog",
	image = "bkgAreYouSureDlg.png",
	title = "Are you sure\nyou want to delete?",
	titleAlignmentOffset = {0, 30},
	introScriptName = "DefaultDialogIntroScript",
	dialogExitScriptName = "DefaultDialogExitScript",
	
	playerInfo = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignmentOffset = {0, 150},
		
		playerPicture = Resources.PlayerPicture:new {
			resource = "PlayerPicture",
			alignment = "MidTop",
			alignmentOffset = {0, 0},
			goalSize = {78, 78},
		},
		
		playerName = Resources.Label:new {
			resource = "Label",
			alignment = "MidTop",
			alignmentOffset = {0, 85},
			fgColor = "Black",
			text = "",
		},
	},
	
	YesButton = Resources.YesButton:new
	{
		resource	=	"YesButton",
		text		=	"Yes",
		alignment	=	"BottomLeft",
		alignTo		=	"MidBottom",
		alignmentOffset = {10, -30},
		buttonClosesDialog = true,
	},
	
	NoButton = Resources.NoButton:new
	{
		resource	=	"NoButton",
		text		=	"No",
		alignment	=	"BottomRight",
		alignTo		=	"MidBottom",
		alignmentOffset = {-10, -30},
		buttonClosesDialog = true,
	},
}






Resources.OptionsDialog = Resources.Dialog:new {
	resource = "Dialog",
	class = "OptionsDialog",
	title = "Options",
	titleAlignmentOffset = {0,10},
	name = "OptionsDialog",
	image = "bkgDialogLarge.png",
	
	OkayButton = Resources.OkayButton:new {
		resource = "OkayButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,-35},
	},
	
	CreditsButton = Resources.Button:new {
		resource = "Button",
		text = "Credits",
		shortcutKey = "C",
		alignment = BottomRight,
		alignmentOffset = {-32,-35},
	},
	
	
	
	
	
	MusicVolumeTitle = Resources.Label:new {
		resource = "Label",
		font = Resources.DialogLabelFont,
		text = "Music Volume:",
		alignment = MidRight,
		alignTo = Center,
		alignmentOffset = {-10,-100},
	},
	
	MusicVolumeScrollbar = Resources.Scrollbar:new {
		resource = "Scrollbar",
		minValue = 0,
		maxValue = 100,
		value = 0,
		playScrollSound = false,
		alignment = MidLeft,
		alignTo = Center,
		alignmentOffset = {-10,-100},
		
		configProperty = "music_volume",
	},
	
	
	
	
	MasterVolumeTitle = Resources.Label:new {
		resource = "Label",
		font = Resources.DialogLabelFont,
		text = "Master Volume:",
		alignment = MidRight,
		alignTo = Center,
		alignmentOffset = {-10,-150},
	},
	
	MasterVolumeScrollbar = Resources.Scrollbar:new {
		resource = "Scrollbar",
		minValue = 0,
		maxValue = 100,
		value = 0,
		alignment = MidLeft,
		alignTo = Center,
		alignmentOffset = {-10,-150},
		
		configProperty = "sfx_volume",
	},
	
	
	
	DisplayModeTitle =  Resources.Label:new {
		resource = "Label",
		font = Resources.DialogLabelFont,
		text = "Display Mode:",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0, 0},
	},
	
	DisplayModeLabel = Resources.Label:new {
		resource = "Label",
		font = Resources.DialogLabelFont,
		text = "Windowed", --This will get changed by the app
		alignment = MidRight,
		alignTo = Center,
		alignmentOffset = {-10, 40},
	},
	
	DisplayModeButton = Resources.Button:new {
		resource = "Button",
		text = "Change",
		alignment = MidLeft,
		alignTo = Center,
		alignmentOffset = {10, 40},
		
		configProperty = "full_screen",
		configValues = {true,false},
	},
	
	adjustableOptions = {
		--Config name = {
			--Control name = {
				--Control type
				--newValue = properties to apply on taking that value
			--},
		--},
		sfx_volume = {
			MasterVolumeScrollbar = {
				type = "Scrollbar",
			}
		},
		music_volume = {
			MusicVolumeScrollbar = {
				type = "Scrollbar",
			}
		},
		full_screen = {
			DisplayModeLabel = {
				type = "Label",
				["true"] = {text = "Full Screen",}, --These could be STRINGS values
				["false"] = {text = "Windowed",},
			},
		},
	},
}






Resources.AreYouSureQuitDialog = Resources.Dialog:new
{
	resource = "Dialog",
	class = "AreYouSureQuitDialog",
	name = "AreYouSureQuitDialog",
	image = "bkgAreYouSureDlg.png",
	title = "",
	
	saveLabel = Resources.Label:new {
		resource = "Label",
		text = "Are you sure\nyou want to quit?\nYour progress will be saved.",
		alignment = Center,
		alignmentOffset = {10,0},
		fgColor = "Black",
		font = Resources.DialogLabelFont,
	},
	noSaveLabel = Resources.Label:new {
		resource = "Label",
		text = "Are you sure\nyou want to quit?",
		alignment = Center,
		alignmentOffset = {10,0},
		fgColor = "Black",
		font = Resources.DialogLabelFont,
	},
	
	YesButton = Resources.YesButton:new {
		resource	=	"YesButton",
		text		=	"Yes",
		alignment	=	"BottomLeft",
		alignTo		=	"MidBottom",
		alignmentOffset = {10, -30},
		buttonClosesDialog = true,
	},
	
	NoButton = Resources.NoButton:new{
		resource	=	"NoButton",
		text		=	"No",
		alignment	=	"BottomRight",
		alignTo		=	"MidBottom",
		alignmentOffset = {-10, -30},
		buttonClosesDialog = true,
	},
}


Resources.Message = Resources.Actor:new {
	resource = "Actor",
	--image = "messageBackground.png",
	color = "White",
	size = {280,65},
	alpha = 200,
	visible = false,

	checkBox = Resources.CheckBox:new {
		resource = "CheckBox",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = {6,0},
		checked = false,
		frame = 1,
		UpdateVisibility = function (self)
			if (self.checked == true) then   
                self.frame = 1
            else
                self.frame = 0
            end
		end,

		GetChecked = function (self)
			return self.checked
		end,
		SetChecked = function(self, newChecked)
			self.checked = newChecked
			self:UpdateVisibility()
		end,
		OnPostSpawn = function(self)
			self:UpdateVisibility()
		end,
	},

	leftImage = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		image = "PlayerPic_Empty.png",
		defaultImage = "PlayerPic_Empty.png",
		size = {46,46},
		resizeOnSetImage = false,	-- when 'false', this will prevent Actor::SetImage calls from resizing the actor
		alignmentOffset = {43,0},
		PlayerFrame = Resources.Actor:new {
			image = "PlayerFrame.png",
			size = {46,46},
			zorder = 1,
			alignment = "Center",
			alignTo = "Center",
		}
	},

	rightImage = Resources.Actor:new {
		alignment = "MidRight",
		alignTo = "MidRight",
		image = "FriendToken.png",
		size = {46,46},
		resizeOnSetImage = false,	-- when 'false', this will prevent Actor::SetImage calls from resizing the actor
		alignmentOffset = {-8,0},
	},
	
	messageText = Resources.Actor:new {
		resource = "Actor",
		alignmentOffset = {95,3},
		alignment = "TopLeft",
		alignTo = "TopLeft",

		messageTitle = Resources.Label:new {
			resource = "Label",
			text = "No Message Title",
			fgColor = "Black",
			--shadowColor = "Black",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {0,4},
			font = Resources.NoteBubbleFont:new {
				resource = "NoteBubbleFont",
				fontSize = 16,
			},
		},

		messageBody = Resources.Label:new {
			resource = "Label",
			text = "No Message Text",
			alignmentOffset = {0,36},
			--fgColor = "Black",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			font = Resources.NoteBubbleFont:new {
				resource = "NoteBubbleFont",
				fontSize = 14,
			},
		},
	},
}

Resources.MessagesDialog = Resources.Dialog:new {
	resource = "Dialog",
	class = "MessagesDialog",
    name = "MessagesDialog",
	image = "bkgDialogLarge.png",
	size = {300, 460},
    titleText = Resources.Label:new {
		resource = "Label",
		text = "Your Messages",
		alignment = MidTop,
		alignmentOffset = {0, 50},
    },

	ScrollableArea = Resources.Actor:new{
		class = "ScrollableArea",
		horizontalScrollLocked = true,
		alignment = "MidRight",
		alignmentOffset = {-5,0},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		image = "btnClose.Circle.png",
		text = "",
		buttonClosesDialog = true,
	},

	ScrollBar = Resources.Scrollbar:new {
		resource = "Scrollbar",
		minValue = 0,
		maxValue = 100,
		value = 0,
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {110,17},
		rotationAngle = { degrees = 90 },
		zorder = 200,
		rolloverable = false,
		visible = false, --turned off for now
	},

	AcceptButton = Resources.Button:new {
		resource = "Button",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignmentOffset = {-20,-18},
		textAlignmentOffset = {0,0},
		text = "Accept",
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 200,
	},

	CheckAllButton = Resources.Button:new {
		resource = "Button",
		buttonClosesDialog = false,
		alignment = BottomLeft,
		alignmentOffset = {10,-18},
		textAlignmentOffset = {16,0},
		textWidthLimit = 70,
		text = "Check all",
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 200,
		--size = {170,30},

		checkBox = Resources.CheckBox:new {
			resource = "CheckBox",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {6,1},
			rolloverable = false,
			size = {30, 30},
			checked = false,
			frame = 1,

			UpdateVisibility = function (self)
				if (self.checked == true) then   
					self.frame = 1
				else
					self.frame = 0
				end
			end,

			SetChecked = function(self, newChecked)
				self.checked = newChecked
				self:UpdateVisibility()
			end,
			OnPostSpawn = function(self)
				self:UpdateVisibility()
			end,
		},
	},
}

Resources.CouldNotAcceptGiftDialog = Resources.Dialog:new {
	resource = "Dialog",
    name = "CouldNotAcceptGiftDialog",

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		image = "btnClose.Circle.png",
		text = "",
		buttonClosesDialog = true,
	},
}


Resources.PlayerSelectorDialog = Resources.Dialog:new {
	resource = "Dialog",
	class = "PlayerSelectorDialog",
    name = "PlayerSelectorDialog",
	title = "Invite Friends",
	image = "bkgDialogLarge.png",
	size = {300, 460},

	PlayerSelector = Resources.ListBox:new {
		resource = "ListBox",
		alignment = "TopLeft",
		alignmentOffset = {13, 139},
		size = {313,316},
	},

	XButton = Resources.CancelButton:new {
		resource = "CancelButton",
		image = "btnClose.Circle.png",
		text = "",
		buttonClosesDialog = true,
	},

	AcceptButton = Resources.Button:new {
		resource = "Button",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignmentOffset = {-20,-18},
		textAlignmentOffset = {0,0},
		text = "Accept",
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 255,
	},

	CheckAllButton = Resources.Button:new {
		resource = "Button",
		buttonClosesDialog = false,
		alignment = BottomLeft,
		alignmentOffset = {10,-18},
		textAlignmentOffset = {16,0},
		--textWidthLimit = 70,
		text = "Check all",
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 255,
		--size = {170,30},

		checkBox = Resources.CheckBox:new {
			resource = "CheckBox",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {6,1},
			rolloverable = false,
			size = {30, 30},
			checked = false,
			frame = 1,

			UpdateVisibility = function (self)
				if (self.checked == true) then   
					self.frame = 1
				else
					self.frame = 0
				end
			end,

			SetChecked = function(self, newChecked)
				self.checked = newChecked
				self:UpdateVisibility()
			end,
			OnPostSpawn = function(self)
				self:UpdateVisibility()
			end,
		},
	},
}


function ResolveLoginProgressText(key)
	local value
	local valueFormat

	if key == "NewPlayer" then
		value = (PLAYER_MGR and PLAYER_MGR:GetNextRemotePlayerName()) or ""
		if value == PLAYER_MGR:GetDefaultPlayerName() then
			value = nil
		else
			valueFormat = STRINGS("PlayerChoiceDescription_playerNameFormat", " (\"%s\")")
		end
	elseif key == "OldPlayer" then
		value = (PLAYER_MGR and PLAYER_MGR:GetCurrentPlayerName()) or ""
		if value == PLAYER_MGR:GetDefaultPlayerName() then
			value = nil
		else
			valueFormat = STRINGS("PlayerChoiceDescription_playerNameFormat", " (\"%s\")")
		end
	elseif key == "AsOldPlayer" then
		value = (PLAYER_MGR and PLAYER_MGR:GetCurrentPlayerName()) or ""
		if value == PLAYER_MGR:GetDefaultPlayerName() then
			value = nil
		else
			valueFormat = STRINGS("PlayerChoiceDescription_asPlayerNameFormat", " (as \"%s\")")
		end
	end

	--print("ResolveLoginProgressText:", key, "; ", value, "; ", valueFormat, "; ", (PLAYER_MGR and PLAYER_MGR:GetCurrentPlayerName()))
	if value and valueFormat and #value > 0 then
		return string.format(valueFormat, value)
	else
		return ""
	end
end


function LoginProgressText_UpdateAppearance(self)
	local text = ""
	if PLAYER_MGR then
		local currentRemotePlayerID = PLAYER_MGR:GetCurrentRemotePlayerID()
		local nextRemotePlayerID = PLAYER_MGR:GetNextRemotePlayerID()
		if currentRemotePlayerID ~= nextRemotePlayerID then
			if #currentRemotePlayerID == 0 then
				text = self.text_needsLogout
			elseif #nextRemotePlayerID == 0 then
				text = self.text_needsLogin
			else
				text = self.text_needsLogoutThenLogin
			end
		end
	end
	text = string.gsub(text, "${(.-)}", ResolveLoginProgressText)
	self.text = text
end


--[[
	ShowPage - a simple, utility function to work with multi-page actors

	To use:

	1. create a bunch of children in an actor, one per page, each with a name in
       the format, "page_NameOfPage".  Make them all invisible (via
       'visible = false'), except for an optional, default page, which can be left visible.
	   EXTRA SUGGESTION: set 'autoFillParent = true' in each page, in order to
       make the pages the same size as their parent actor

	2. call ShowPage(theActor, "NameOfPage"), whenever a need arises to show a page.
--]]

function ShowPage(actor, pageName)
	if not IsString(pageName) then
		error("'pageName' (2nd arg) must be a string")
	end
	pageName = "page_" .. pageName
	local children = actor.children
	for k,child in pairs(children) do
		local childName = child.name
		if child and (string.find(childName, "page_") == 1) then
			child.visible = (pageName == childName)
		end
	end
end

Resources.CommonLoginProgressDialogParts = {
	class = "LoginProgressDialog",
	name = "LoginProgressDialog",
	ShowPage = ShowPage,
}

Resources.LoginProgressDialog = Resources.Dialog:new {
    class = "LoginProgressDialog",
	resources = {"Dialog", "CommonLoginProgressDialogParts"},
    title = "Connecting",
	image = "bkgDialogLarge.png",
	size = {300, 460},

	introScriptName = "LoginProgressDialogIntro",
	dialogExitScriptName = "LoginProgressDialogExit",

	-- ******************************************************* DEBUG
	-- ******************************************************* DEBUG
	debugDialog = true,
	-- ******************************************************* DEBUG
	-- ******************************************************* DEBUG

	page_authenticating = Resources.Actor:new {
		resource = "Actor",
		autoFillParent = true,
		visible = true,

	    DescLabel = Resources.Label:new {
			resource = "Label",
			alignment =	Center,
			textAlignment = "Center",
			alignTo = Center,
			--alignmentOffset = {0,135},
			text = STRINGS("Logging in..."),
			wrapLimit = 250,
	    },
		
		ActivityIndicator = Resources.Actor:new {
			resource = "Actor",
			image = "ActivityIndicator_Circles_64x64.png",
			alignment = "Center",
			alignmentOffset = {0,84},
			timerGroup = "NonDefault",  -- by setting 'timerGroup' to something besides "default", the activity indicator will work in dialogs that pause GuruEngine's gameplay
			scripts = {
				"CycleImageFrames_Delay60ms",
			},
		},
	},

	page_playerChoice = Resources.Actor:new {
		resource = "Actor",
		autoFillParent = true,
		visible = false,

	    DescLabel = Resources.Label:new {
			resources = {"Label", "AuthenticationAwareDecorator"},

			OnPostSpawn = function (self)
				Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
			end,

			text_needsLogout = STRINGS("PlayerChoiceDescription_needsLogout"),
			text_needsLogin = STRINGS("PlayerChoiceDescription_needsLogin"),
			text_needsLogoutThenLogin = STRINGS("PlayerChoiceDescription_needsLogoutThenLogin"),
			UpdateAppearance = LoginProgressText_UpdateAppearance,

			alignment =	"MidTop",
			alignmentOffset = {0, 100},
			fgColor = "Black",
			font = {
				fontName = "fubd____.ttf",
				fontSize = 20,
			},
			textAlignment = "Center",
			text = "",
			wrapLimit = 270,
	    },

	    SwitchPlayersNowButton = Resources.Button:new {
			resources = {"Button", "AuthenticationAwareDecorator"},

			OnPostSpawn = function (self)
				Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
			end,

			text_needsLogout = STRINGS("Continue Logging In"),
			text_needsLogin = STRINGS("Switch To Local Player"),
			text_needsLogoutThenLogin = STRINGS("Switch To New Player"),
			UpdateAppearance = LoginProgressText_UpdateAppearance,

			--buttonClosesDialog = true,
	    	alignment = "MidBottom",
	    	alignmentOffset = {-70, -25},
			text = STRINGS("Switch To New Player"),
			textWrapLimit = 100,
	    	font = {
				fontName = "fubd____.ttf",
				fontSize = 14,
			},
		},

	    LoginButton = Resources.Button:new {
			resources = {"Button", "AuthenticationAwareDecorator"},

			GetAuthenticationStatus = Authentication_GetBaseLevelAuthenticationStatus,

			connectingText = STRINGS("Connecting"),
			logoutText = STRINGS("Log out"),
			connectText = STRINGS("Login"),
			visibleWhenConnected = false,
			visibleWhenDisconnected = true,
			decoratorCanChangeText = true,

			OnPostSpawn = function (self)
				Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			OnButtonClick = function (self, event)
				if event.button ~= self then
					return
				end
				RaveConnect()
			end,

	    	alignment = "MidBottom",
	    	alignmentOffset = {70, -25},
	    	text = STRINGS("Login"),
	    	font = {
				fontName = "fubd____.ttf",
				fontSize = 16,
			},
		},

	    LogoutButton = Resources.Button:new {
			resources = {"Button", "AuthenticationAwareDecorator"},

			GetAuthenticationStatus = Authentication_GetBaseLevelAuthenticationStatus,

			connectingText = STRINGS("Connecting"),
			logoutText = STRINGS("Log out"),
			connectText = STRINGS("Login"),
			visibleWhenConnected = true,
			visibleWhenDisconnected = false,
			decoratorCanChangeText = true,

			OnPostSpawn = function (self)
				Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			OnButtonClick = function (self, event)
				if event.button ~= self then
					return
				end
				RaveConnect() -- when logged in, this should trigger a logout
			end,

	    	alignment = "MidBottom",
	    	alignmentOffset = {70, -25},
	    	text = STRINGS("Log out"),
	    	font = {
				fontName = "fubd____.ttf",
				fontSize = 16,
			},
		},
	},

	-- CONFIG note: This cancel button can be turned on/off via CONFIG.
	-- For LoginProgressDialogs, the key is "LoginProgressDialog.ShowCancelButton",
	-- and the value is a boolean.
	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		alignment = "TopRight",
		alignmentOffset = {-20, 20},
		image = "btnClose.png",
		text = "",
		buttonClosesDialog = true,
	},
}

Scripts.Preshow_LoginProgressDialog = function(dialog)

end

Scripts.Present_LoginProgressDialog = function(dialog)

end

Scripts.LoginProgressDialogIntro = function (dialog)
	-- HACK: Delay the display of the dialog by one frame, in order to prevent
	-- it from showing in quick, re-authentication scenarios.
	dialog.visible = false
	ScriptBreak()
	if IsLiveObject(dialog) then
		dialog.visible = true
	end
end

Scripts.LoginProgressDialogExit = function (dialog)
	dialog.visible = false
end
