--[[
	Class: Resources.Font
	Description: Base Class for all Resources.Fonts used by scripts
	Properties:
		fontName
		fontSize
		fontIndex
		useAdjustedCharacterSpacing
		characterSpacingAdjustment
--]]
Resources.Font = Resources.Object:new
{
	--
	-- HACK: This resource is duplicated in EngineSpecificCompiledTemplateResources.cpp.
	-- This duplication a quick way to get a performance boost when instantiating a lot of
	-- objects with this resource.
	--
	
	class		= "Font",
	fontName	= "arial.ttf",	-- NOTE: Differs from C++ default of ""
	fontSize	= 16,			-- NOTE: Differs from C++ default of 0
}

-- Standard Resources.Fonts

Resources.ButtonFont = Resources.Font:new(
{
	--
	-- HACK: This resource is duplicated in EngineSpecificCompiledTemplateResources.cpp.
	-- This duplication a quick way to get a performance boost when instantiating a lot of
	-- objects with this resource.
	--
	
	fontName 	= "fubd____.ttf",
	fontSize 	= 22
})

Resources.ButtonFontSmall = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
	fontSize 	= 18
})

Resources.DialogLabelFont = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
	fontSize 	= 26,
})


Resources.CreditsLabelFont = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
	fontSize 	= 26,
})

Resources.DialogTitleFont = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
    fontSize 	= 32,
})

Resources.DialogTitleFont2 = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
    fontSize 	= 42,
})

Resources.GameCompleteTitleFont = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
    fontSize 	= 32,
})

Resources.GameCompleteTextFont = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
    fontSize 	= 26,
})

Resources.LabelFontLight = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
	fontSize 	= 18
})

Resources.LabelFontMedium = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
	fontSize 	= 20
})

Resources.LabelFontLarge = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
	fontSize 	= 24
})

Resources.MainFontLight = Resources.Font:new(
{
	fontName 	= "fult____.ttf",
	fontSize 	= 18,
})

Resources.MainFontMedium = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
	fontSize 	= 36,
})

Resources.CopyrightFont = Resources.Font:new(
{
	fontName 	= "arialn.ttf",
	fontSize 	= 14,
})

Resources.CardDataFont = Resources.Font:new(
{
	fontName 	= "fubd____.ttf",
	fontSize 	= 20,
})

Resources.InfoTextFont = Resources.Font:new(
{
	fontName 	= "arial.ttf",
	fontSize 	= 20,
})

Resources.NoteBubbleFont = Resources.Font:new(
{
	fontName 	= "arial.ttf",
	fontSize 	= 18,
})

Resources.ButtonBubbleFontSmall = Resources.Font:new(
{
	fontName 	= "arial.ttf",
	fontSize 	= 18,
})

Resources.ParseIDFont = Resources.Font:new(
{
	--fontName = "cob_____.ttf",
	--fontName = "OpenSans-Regular.ttf",
	fontName = "Inconsolata.ttf",
	fontSize = 26,
	--fontStyle = FontStyle { "bold" },
})
