
local ScreenScaleFactor = 2

Resources.GameCenterButton = Resources.Button:new {
	resource = "Button",
	class = "GameCenterButton",
	image = "GameCenterButton.png",
	font = Resources.ButtonFont:new {
		resource = "ButtonFont",
		fontSize = 10,
	},
	visible = false,
	alwaysUseClickOffset = true,
}

Resources.GameCenterLeaderboardUpdateButton = Resources.Button:new {
	resource = "Button",
	image = "Button.small.long.png",
	text = STRINGS("Refresh Scores"),
	textIfAvailable = STRINGS("Refresh Scores"),
	textIfLoading = STRINGS("Scores Loading..."),
	textDisabledColor = "#505050",
	textWidthLimit = 88,
	textAlignment = "Center",
	textAlignmentOffset = {12, 0},
	font = Resources.ButtonFont:new {
		resource = "ButtonFont",
		fontSize = 12,
	},
	icon = Resources.Actor:new {
		resource = "Actor",
		image = "GameCenterButton.png",
		size = {20,20},
		alignment = "MidLeft",
		alignmentOffset = {8, 0},
	},
	visible = false,

	activityIndicator = Resources.ActivityIndicator_Circles_20x20:new {
		resource = "ActivityIndicator_Circles_20x20",
		alignment = "MidRight",
		alignmentOffset = {24, 0},
		visible = false,
	},
	
	SetAppearance = function (self, appearance)
		if appearance == "loading" then
			self.text = self.textIfLoading
			self.visible = true
			self.active = false
			self.icon.frame = DefaultButtonFrame_Disabled
			self.activityIndicator.visible = true
		elseif appearance == "ready" then
			self.text = self.textIfAvailable
			self.visible = true
			self.active = true
			self.icon.frame = DefaultButtonFrame_Active
			self.activityIndicator.visible = false
		else
			self.visible = false
		end
	end,
}

Resources.AddGameCenterFriendsButton = Resources.GameCenterButton:new {
	resource = "GameCenterButton",
	image = "Button.small.long.png",
	text = STRINGS("Add Friends"),
	textDisabledColor = "#505050",
	textWidthLimit = 88,
	textAlignment = "Center",
	textAlignmentOffset = {12, 0},
	font = Resources.ButtonFont:new {
		resource = "ButtonFont",
		fontSize = 12,
	},
	icon = Resources.Actor:new {
		resource = "Actor",
		image = "GameCenterButton.png",
		size = {20,20},
		alignment = "MidLeft",
		alignmentOffset = {8, 0},
	},
	visible = false,
	
	HandleGameCenterReadyClick = function (self)
		GuruGameCenter_ShowFriendAddUI()
	end,

	hideUnlessGameCenterFeatures = {"GameCenterFeature_AddFriendUI"},
}


Resources.ChallengeFriendsButton = Resources.GameCenterButton:new {
	resource = "GameCenterButton",
	image = "Button.small.long.png",
	text = STRINGS("Challenge Friends"),
	textDisabledColor = "#505050",
	textWidthLimit = 88,
	textAlignment = "Center",
	textAlignmentOffset = {12, 0},
	font = Resources.ButtonFont:new {
		resource = "ButtonFont",
		fontSize = 12,
	},
	icon = Resources.Actor:new {
		resource = "Actor",
		image = "GameCenterButton.png",
		size = {20,20},
		alignment = "MidLeft",
		alignmentOffset = {8, 0},
	},
	visible = false,
	
	disableUnlessGameCenterFeatures = {"GameCenterFeature_ScoreChallenges"},
}
