
Resources.GiftButtonController = Resources.Actor:new {
	resource = "Actor",
	visible = false,
	checkForRecentGifting = "Gift_FreeLife",
	InitGiftButtonController = function (self)
		self:AddObserver(EventMap.GURU_ACTOR_PARENT_WILL_CHANGE, self)
	end,
	OnActorParentWillChange = function (self, event)
		if event.oldParent then
			event.oldParent:RemoveObserver(EventMap.GURU_BUTTONCLICK, self)
		end
		if event.newParent then
			event.newParent:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end
		self:InnerUpdate()
	end,
	ClearLeaderboardData = function (self)
		self.facebookUserID = nil
		self:InnerUpdate()
	end,
	UpdateWithLeaderboardData = function (self, values)
		--logprintf("UpdateWithLeaderboardData: %s\n", SerializeToString(values))
		self.isCurrentPlayer = values.isCurrentPlayer
		self.facebookUserID = values.facebookUserID
		self.raveUserId = values.raveUserId
		self:InnerUpdate()
	end,
	InnerUpdate = function (self)
		-- HACK-FIX: prevent a crash from occurring on Windows by not
		-- allowing InnerUpdate to run on that platform (where it isn't
		-- currently getting used anyways.
		if IsWindows() then
			return
		end

		if not IsUserdata(self.parent) then
			return
		end
	
		self.parent.visible = ((FACEBOOK) and
							   (IsString(self.facebookUserID)) and
							   (self.isCurrentPlayer == false))
		
		if IsUserdata(self.parent.hasGiftedRecently) then
			local hasBeenGiftedRecently = false
			if IsString(self.checkForRecentGifting) and
			   ((FACEBOOK and IsString(self.facebookUserID)) or
			    (RAVE and IsString(self.raveUserId)))
			then
				hasBeenGiftedRecently = Gifting_HasUserIDBeenGiftedRecently(self.checkForRecentGifting, self.raveUserId)
			end
		
			local isGiftBeingSent = Gifting_IsSendGiftDialogActive()
			self.parent.active = (not hasBeenGiftedRecently) and (not isGiftBeingSent)
			self.parent.hasGiftedRecently.visible = hasBeenGiftedRecently
		end
	end,
	Tick = function (self)
		self:InnerUpdate()
	end,
	OnButtonClick = function (self, event)
		if self.parent ~= event.button then
			return
		end
		if IsFunction(self.OnGiftClick) then
			self:OnGiftClick()
		end
		self:InnerUpdate()
	end,
}
