--[[
GURU KEY MAP
These values are intended to map directly to the ASCII table and 
the key values defined by SDL
--]]
GURUKEY_UNKNOWN			= 0
GURUKEY_FIRST			= 0
GURUKEY_BACKSPACE		= 8
GURUKEY_TAB				= 9
GURUKEY_CLEAR			= 12
GURUKEY_RETURN			= 13
GURUKEY_PAUSE			= 19
GURUKEY_ESCAPE			= 27
GURUKEY_SPACE			= 32
GURUKEY_EXCLAIM			= 33
GURUKEY_QUOTEDBL		= 34
GURUKEY_HASH			= 35
GURUKEY_DOLLAR			= 36
GURUKEY_AMPERSAND		= 38
GURUKEY_QUOTE			= 39
GURUKEY_LEFTPAREN		= 40
GURUKEY_RIGHTPAREN		= 41
GURUKEY_ASTERISK		= 42
GURUKEY_PLUS			= 43
GURUKEY_COMMA			= 44
GURUKEY_MINUS			= 45
GURUKEY_PERIOD			= 46
GURUKEY_SLASH			= 47
GURUKEY_0				= 48
GURUKEY_1				= 49
GURUKEY_2				= 50
GURUKEY_3				= 51
GURUKEY_4				= 52
GURUKEY_5				= 53
GURUKEY_6				= 54
GURUKEY_7				= 55
GURUKEY_8				= 56
GURUKEY_9				= 57
GURUKEY_COLON			= 58
GURUKEY_SEMICOLON		= 59
GURUKEY_LESS			= 60
GURUKEY_EQUALS			= 61
GURUKEY_GREATER			= 62
GURUKEY_QUESTION		= 63
GURUKEY_AT				= 64
GURUKEY_LEFTBRACKET		= 91
GURUKEY_BACKSLASH		= 92
GURUKEY_RIGHTBRACKET	= 93
GURUKEY_CARET			= 94
GURUKEY_UNDERSCORE		= 95
GURUKEY_BACKQUOTE		= 96
GURUKEY_a				= 97
GURUKEY_b				= 98
GURUKEY_c				= 99
GURUKEY_d				= 100
GURUKEY_e				= 101
GURUKEY_f				= 102
GURUKEY_g				= 103
GURUKEY_h				= 104
GURUKEY_i				= 105
GURUKEY_j				= 106
GURUKEY_k				= 107
GURUKEY_l				= 108
GURUKEY_m				= 109
GURUKEY_n				= 110
GURUKEY_o				= 111
GURUKEY_p				= 112
GURUKEY_q				= 113
GURUKEY_r				= 114
GURUKEY_s				= 115
GURUKEY_t				= 116
GURUKEY_u				= 117
GURUKEY_v				= 118
GURUKEY_w				= 119
GURUKEY_x				= 120
GURUKEY_y				= 121
GURUKEY_z				= 122
GURUKEY_DELETE			= 127

-----------------------------
-- KEYPAD
-----------------------------
GURUKEY_KP0				= 256
GURUKEY_KP1				= 257
GURUKEY_KP2				= 258
GURUKEY_KP3				= 259
GURUKEY_KP4				= 260
GURUKEY_KP5				= 261
GURUKEY_KP6				= 262
GURUKEY_KP7				= 263
GURUKEY_KP8				= 264
GURUKEY_KP9				= 265
GURUKEY_KP_PERIOD		= 266
GURUKEY_KP_DIVIDE		= 267
GURUKEY_KP_MULTIPLY		= 268
GURUKEY_KP_MINUS		= 269
GURUKEY_KP_PLUS			= 270
GURUKEY_KP_ENTER		= 271
GURUKEY_KP_EQUALS		= 272

GURUKEY_UP				= 273
GURUKEY_DOWN			= 274
GURUKEY_RIGHT			= 275
GURUKEY_LEFT			= 276
GURUKEY_INSERT			= 277
GURUKEY_HOME			= 278
GURUKEY_END				= 279
GURUKEY_PAGEUP			= 280
GURUKEY_PAGEDOWN		= 281

-----------------------------
-- FUNCTION KEYS
-----------------------------
GURUKEY_F1				= 282
GURUKEY_F2				= 283
GURUKEY_F3				= 284
GURUKEY_F4				= 285
GURUKEY_F5				= 286
GURUKEY_F6				= 287
GURUKEY_F7				= 288
GURUKEY_F8				= 289
GURUKEY_F9				= 290
GURUKEY_F10				= 291
GURUKEY_F11				= 292
GURUKEY_F12				= 293
GURUKEY_F13				= 294
GURUKEY_F14				= 295
GURUKEY_F15				= 296

GURUKEY_NUMLOCK			= 300
GURUKEY_CAPSLOCK		= 301
GURUKEY_SCROLLOCK		= 302
GURUKEY_RSHIFT			= 303
GURUKEY_LSHIFT			= 304
GURUKEY_RCTRL			= 305
GURUKEY_LCTRL			= 306
GURUKEY_RALT			= 307
GURUKEY_LALT			= 308
GURUKEY_RMETA			= 309
GURUKEY_LMETA			= 310
GURUKEY_LWINDOWS		= 311		
GURUKEY_RWINDOWS		= 312		
GURUKEY_MODE			= 313		
GURUKEY_COMPOSE			= 314		

GURUKEY_HELP			= 315
GURUKEY_PRINT			= 316
GURUKEY_SYSREQ			= 317
GURUKEY_BREAK			= 318
GURUKEY_MENU			= 319
GURUKEY_MAC_POWER		= 320
GURUKEY_EURO			= 321
GURUKEY_ATARI_UNDO		= 322
GURUKEY_LAST			= 323	  

GURUKEYMOD_NONE			= 0x0000
GURUKEYMOD_LSHIFT		= 0x0001
GURUKEYMOD_RSHIFT		= 0x0002
GURUKEYMOD_LCTRL		= 0x0040
GURUKEYMOD_RCTRL		= 0x0080
GURUKEYMOD_LALT			= 0x0100
GURUKEYMOD_RALT			= 0x0200
GURUKEYMOD_LMETA		= 0x0400
GURUKEYMOD_RMETA		= 0x0800
GURUKEYMOD_NUM			= 0x1000
GURUKEYMOD_CAPS			= 0x2000
GURUKEYMOD_MODE			= 0x4000
GURUKEYMOD_RESERVED		= 0x8000

GURUKEYMOD_CTRL			= GURUKEYMOD_LCTRL  | GURUKEYMOD_RCTRL
GURUKEYMOD_SHIFT		= GURUKEYMOD_LSHIFT | GURUKEYMOD_RSHIFT
GURUKEYMOD_ALT			= GURUKEYMOD_LALT   | GURUKEYMOD_RALT
GURUKEYMOD_META			= GURUKEYMOD_LMETA  | GURUKEYMOD_RMETA

KeyName =
{
	[GURUKEY_BACKSPACE]		= "Backspace",
	[GURUKEY_TAB]			= "Tab",
	[GURUKEY_CLEAR]			= "Clear",
	[GURUKEY_RETURN]		= "Return",
	[GURUKEY_PAUSE]			= "Pause",
	[GURUKEY_ESCAPE]		= "Escape",
	[GURUKEY_SPACE]			= "Space",
	[GURUKEY_EXCLAIM]		= "!",
	[GURUKEY_QUOTEDBL]		= "\"",
	[GURUKEY_HASH]			= "#",
	[GURUKEY_DOLLAR]		= "$",
	[GURUKEY_AMPERSAND]  	= "&",
	[GURUKEY_QUOTE]			= "'",
	[GURUKEY_LEFTPAREN]		= "(",
	[GURUKEY_RIGHTPAREN] 	= ")",
	[GURUKEY_ASTERISK]		= "*",
	[GURUKEY_PLUS]			= "+",
	[GURUKEY_COMMA]			= ",",
	[GURUKEY_MINUS]			= "-",
	[GURUKEY_PERIOD]		= ".",
	[GURUKEY_SLASH]			= "/",
	[GURUKEY_0] 			= "0",
	[GURUKEY_1] 			= "1",
	[GURUKEY_2] 			= "2",
	[GURUKEY_3] 			= "3",
	[GURUKEY_4] 			= "4",
	[GURUKEY_5] 			= "5",
	[GURUKEY_6] 			= "6",
	[GURUKEY_7] 			= "7",
	[GURUKEY_8] 			= "8",
	[GURUKEY_9] 			= "9",
	[GURUKEY_COLON]			= ":",
	[GURUKEY_SEMICOLON]		= ";",
	[GURUKEY_LESS]			= "<",
	[GURUKEY_EQUALS]		= "=",
	[GURUKEY_GREATER]		= ">",
	[GURUKEY_QUESTION]		= "?",
	[GURUKEY_AT]			= "@",
	[GURUKEY_LEFTBRACKET]	= "[",
	[GURUKEY_BACKSLASH]		= "\\",
	[GURUKEY_RIGHTBRACKET]	= "]",
	[GURUKEY_CARET]			= "^",
	[GURUKEY_UNDERSCORE]	= "_",
	[GURUKEY_BACKQUOTE]		= "`",
	[GURUKEY_a] 			= "a",
	[GURUKEY_b] 			= "b",
	[GURUKEY_c] 			= "c",
	[GURUKEY_d] 			= "d",
	[GURUKEY_e] 			= "e",
	[GURUKEY_f] 			= "f",
	[GURUKEY_g] 			= "g",
	[GURUKEY_h] 			= "h",
	[GURUKEY_i] 			= "i",
	[GURUKEY_j] 			= "j",
	[GURUKEY_k] 			= "k",
	[GURUKEY_l] 			= "l",
	[GURUKEY_m] 			= "m",
	[GURUKEY_n] 			= "n",
	[GURUKEY_o] 			= "o",
	[GURUKEY_p] 			= "p",
	[GURUKEY_q] 			= "q",
	[GURUKEY_r] 			= "r",
	[GURUKEY_s] 			= "s",
	[GURUKEY_t] 			= "t",
	[GURUKEY_u] 			= "u",
	[GURUKEY_v] 			= "v",
	[GURUKEY_w] 			= "w",
	[GURUKEY_x] 			= "x",
	[GURUKEY_y] 			= "y",
	[GURUKEY_z] 			= "z",
	[GURUKEY_DELETE]		= "Delete",

	[GURUKEY_KP0] 			= "0",
	[GURUKEY_KP1] 			= "1",
	[GURUKEY_KP2] 			= "2",
	[GURUKEY_KP3] 			= "3",
	[GURUKEY_KP4] 			= "4",
	[GURUKEY_KP5] 			= "5",
	[GURUKEY_KP6] 			= "6",
	[GURUKEY_KP7] 			= "7",
	[GURUKEY_KP8] 			= "8",
	[GURUKEY_KP9] 			= "9",
	[GURUKEY_KP_PERIOD]		= ".",
	[GURUKEY_KP_DIVIDE]		= "/",
	[GURUKEY_KP_MULTIPLY]	= "*",
	[GURUKEY_KP_MINUS]		= "-",
	[GURUKEY_KP_PLUS]		= "+",
	[GURUKEY_KP_ENTER]		= "Enter",
	[GURUKEY_KP_EQUALS]		= "=",
			
	[GURUKEY_UP]			= "Up",
	[GURUKEY_DOWN]			= "Down",
	[GURUKEY_RIGHT]			= "Right",
	[GURUKEY_LEFT]			= "Left",
	[GURUKEY_DOWN]			= "Down",
	[GURUKEY_INSERT]		= "Insert",
	[GURUKEY_HOME]			= "Home",
	[GURUKEY_END]			= "End",
	[GURUKEY_PAGEUP]		= "Page Up",
	[GURUKEY_PAGEDOWN]		= "Page Down",

	[GURUKEY_F1] 			= "F1",
	[GURUKEY_F2] 			= "F2",
	[GURUKEY_F3] 			= "F3",
	[GURUKEY_F4] 			= "F4",
	[GURUKEY_F5] 			= "F5",
	[GURUKEY_F6] 			= "F6",
	[GURUKEY_F7] 			= "F7",
	[GURUKEY_F8] 			= "F8",
	[GURUKEY_F9] 			= "F9",
	[GURUKEY_F10] 			= "F10",
	[GURUKEY_F11] 			= "F11",
	[GURUKEY_F12] 			= "F12",
	[GURUKEY_F13] 			= "F13",
	[GURUKEY_F14] 			= "F14",
	[GURUKEY_F15] 			= "F15",

	[GURUKEY_NUMLOCK]		= "Num Lock",
	[GURUKEY_CAPSLOCK]		= "Caps Lock",
	[GURUKEY_SCROLLOCK]		= "Scroll Lock",
	[GURUKEY_RSHIFT]		= "Right Shift",
	[GURUKEY_LSHIFT]		= "Left Shift",
	[GURUKEY_RCTRL]			= "Right Ctrl",
	[GURUKEY_LCTRL]			= "Left Ctrl",
	[GURUKEY_RALT]			= "Right Alt",
	[GURUKEY_LALT]			= "Left Alt",
	[GURUKEY_RMETA]			= "Right Meta",
	[GURUKEY_LMETA]			= "Left Meta",
	[GURUKEY_LWINDOWS]		= "Left Windows Key",
	[GURUKEY_RWINDOWS]		= "Right Windows Key",	
	[GURUKEY_MODE]			= "Alt GR",	-- No clue what this refers to but it is in the SDL map so including it here
	[GURUKEY_COMPOSE]		= "Compose",

	[GURUKEY_HELP]			= "Help",
	[GURUKEY_PRINT]			= "Print Screen",
	[GURUKEY_SYSREQ]		= "Sys Req",
	[GURUKEY_BREAK]			= "Break",
	[GURUKEY_MENU]			= "Menu",
	[GURUKEY_MAC_POWER]		= "Power",
	[GURUKEY_EURO]			= "Euro",
	[GURUKEY_ATARI_UNDO]	= "Undo",
}

function GetKeyName(index) return KeyName[index] end