--[[
	LinearFader: Inherits from Actor
		All Actor Properties plus:
			tagTarget
			duration
			destAlpha
--]]
Resources.LinearFader = Resources.Actor:new
{
	resource	= "Actor",
	class		= "LinearFader",
	tagTarget	= true,
	duration	= 1000,
	destAlpha	= 0,
}

function FadeAndWait(target, destAlpha, duration, timerGroup)
	target.fader = nil --This was necessary to cause the old fader to be destroyed rather than simply having its properties erased.
	target.fader = Resources.LinearFader:new{resource = "LinearFader", destAlpha=destAlpha, duration=duration}

	ScriptDelay(duration, timerGroup)
end

function Fade(target, destAlpha, duration)
	target.fader = nil --This was necessary to cause the old fader to be destroyed rather than simply having its properties erased.
	target.fader = Resources.LinearFader:new{resource = "LinearFader", destAlpha=destAlpha, duration=duration}
end
