

Resources.ListBox = Resources.Actor:new {
	resource = "Actor",
	class = "ListBox",
	ScrollableArea = Resources.Actor:new{
		class = "ScrollableArea",
		horizontalScrollLocked = true,
		alignment = "TopLeft",
	},

	ScrollBar = Resources.Scrollbar:new {
		resource = "Scrollbar",
		minValue = 0,
		maxValue = 100,
		value = 0,
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {110,17},
		rotationAngle = { degrees = 90 },
		zorder = 200,
		rolloverable = false,
		visible = false, --turned off for now
	},
}

Resources.ListBoxCheckBox = Resources.Button:new {
	resource = "Button",
	text = "",
	image = "boxCheck.png",
	useFrames = false,
	font = {resource = "ButtonFont",},
	
    clickSound = buttonClickSound,
	
	OnPostSpawn = function (self)
		self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
	end,
}

Resources.ListBoxElement = Resources.Actor:new {
	resource = "Actor",
	image = "messageBackground.png",
	--color = "White",
	size = {280,65},
	alpha = 200,
	visible = false,

	checkBox = Resources.ListBoxCheckBox:new {
		resource = "ListBoxCheckBox",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = {236,0},
		checked = false,
		frame = 1,
		UpdateVisibility = function (self)
			if (self.checked == true) then   
                self.frame = 1
            else
                self.frame = 0
            end
		end,

		GetChecked = function (self)
			return self.checked
		end,
		SetChecked = function(self, newChecked)
			self.checked = newChecked
			self:UpdateVisibility()
		end,
		OnPostSpawn = function(self)
			self:UpdateVisibility()
		end,
	},

	playerPhoto = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		image = "PlayerPic_Empty.png",
		defaultImage = "PlayerPic_Empty.png",
		size = {46,46},
		resizeOnSetImage = false,	-- when 'false', this will prevent Actor::SetImage calls from resizing the actor
		alignmentOffset = {15,0},
		PlayerFrame = Resources.Actor:new {
			image = "PlayerFrame.png",
			size = {46,46},
			zorder = 1,
			alignment = "Center",
			alignTo = "Center",
		}
	},

	otherImage = Resources.Actor:new {
		alignment = "MidRight",
		alignTo = "MidRight",
		image = "FriendToken.png",
		size = {46,46},
		resizeOnSetImage = false,	-- when 'false', this will prevent Actor::SetImage calls from resizing the actor
		alignmentOffset = {-8,0},
	},
	
	elementText = Resources.Actor:new {
		resource = "Actor",
		alignmentOffset = {67,3},
		alignment = "TopLeft",
		alignTo = "TopLeft",

		titleText = Resources.Label:new {
			resource = "Label",
			text = "No Message Title",
			fgColor = "Black",
			--shadowColor = "Black",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {0,4},
			font = Resources.NoteBubbleFont:new {
				resource = "NoteBubbleFont",
				fontSize = 16,
			},
		},

		bodyText = Resources.Label:new {
			resource = "Label",
			text = "No Message Text",
			alignmentOffset = {0,22},
			--fgColor = "Black",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			textAlignment = "MidLeft",
			wrapLimit = 130,
			heightLimit = 33,
			font = Resources.NoteBubbleFont:new {
				resource = "NoteBubbleFont",
				fontSize = 14,
			},
		},
	},
}