function EngineStrings(strings)
	Strings = strings
end

function AppStrings(strings)
	AppSpecificStrings = strings

	Language = GetUserPreferredSupportedLanguageCode()
	--Language = "fr"
	if (Strings[Language] ~= nil) then
		CurrentLanguageStrings = JoinTables(Strings[Language],AppSpecificStrings[Language])
	else
		CurrentLanguageStrings = AppSpecificStrings[Language]
	end

	EnglishLanguageCode = "en"
	EnglishLanguageStrings = JoinTables(Strings[EnglishLanguageCode],AppSpecificStrings[EnglishLanguageCode])
end

function IsGameInEnglish()
	return Language == "en"
end

function STRINGS(key, defaultValue)
	local value = CurrentLanguageStrings[key]
	local englishValue = EnglishLanguageStrings[key]
	if value then
		return value
	elseif defaultValue then
		return defaultValue
	elseif englishValue then
		return englishValue
	else
		return key
	end
end
