--
-- ***********************************************************************
-- ***********************************************************************
--
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
--
-- ***********************************************************************
-- ***********************************************************************
--
-- iOS/iPhone note: Try not edit this file directly to fix layouts!  Doing so
-- is likely to break layouts on other platforms, possibly in difficult-to-see
-- ways.
--
-- Layouts here should be optimized towards desktop usage wherever possible.
--
Resources.TINYFont = Resources.Font:new {
	fontName = "dabd____.ttf",
	fontSize = 14,
}



BUBBLE_POINT_NONE		= 0
BUBBLE_POINT_LEFT		= 1
BUBBLE_POINT_RIGHT		= 2
BUBBLE_POINT_DOWN		= 3
BUBBLE_POINT_UP			= 4
BUBBLE_POINT_VERTICAL	= 5
BUBBLE_POINT_HORIZONTAL	= 6

BUBBLE_ALL_BUTTONS_ON	= 0
BUBBLE_NEXT_BUTTON_OFF	= 1
BUBBLE_BACK_BUTTON_OFF	= 2
BUBBLE_ALL_BUTTONS_OFF	= 3
BUBBLE_OKAY_BUTTON_ON	= 4

local LARGE__NUM_MIDDLE_PIECES = 3
local LARGE__MIDDLE_PIECES_Y_OFFSET = -18

local LARGE__TOP_PIECE_HEIGHT = 42
local LARGE__MIDDLE_PIECE_HEIGHT = 38
local LARGE__BOTTOM_PIECE_HEIGHT = 42

local LARGE__WIDTH = 278

Resources.NoteBubbleLabel = Resources.Label:new
{
	font = {resource = "NoteBubbleFont"},
	showBackground = false,
	shaderType = "SHADERTYPE_BLENDCOMBINEDALPHA",	
}

Resources.NoteBubbleButton = Resources.Button:new
{
	image = "btnPin.png",
	font = 
	{
		resource = "ButtonBubbleFontSmall",
	},
	fgColor = "Black",
	--[[children = {
		{
			class = "Border",
			color = "Black",
		},
	},--]]
}

Resources.NoteBubbleLeftButton = Resources.NoteBubbleButton:new
{
	resource = "NoteBubbleButton",
	alignment = "MidLeft",
	alignmentOffset = {10, -14},  -- WARNING: Limit platform-specific edits to this to platform-specific areas!
	clickSound = "click2.ogg",
}

Resources.NoteBubbleCenterButton = Resources.NoteBubbleButton:new
{
	resource = "NoteBubbleButton",
	alignment = "MidBottom",
	alignmentOffset = {0, -14},  -- WARNING: Limit platform-specific edits to this to platform-specific areas!
	clickSound = "click2.ogg",
}

Resources.NoteBubbleCenterBottomButton = Resources.NoteBubbleButton:new
{
	resource = "NoteBubbleButton",
	alignment = "MidBottom",
	alignmentOffset = {0, -14},  -- WARNING: Limit platform-specific edits to this to platform-specific areas!
	clickSound = "click2.ogg",
}

Resources.NoteBubbleRightButton = Resources.NoteBubbleButton:new
{
	resource = "NoteBubbleButton",
	alignment = "MidRight",
	alignmentOffset = {-10, -14},  -- WARNING: Limit platform-specific edits to this to platform-specific areas!
	clickSound = "click2.ogg",
}

Resources.NoteBubbleButtonSet = Resources.Actor:new
{
	size = {LARGE__WIDTH, 4},
	color = "Green",
	alpha = 0, --64,
	alignment = "MidBottom",
	alignmentOffset = {0, -14},
	children = 
	{
		leftButton = Resources.NoteBubbleLeftButton,
		rightButton = Resources.NoteBubbleRightButton,
	},
	zorder = 5,
}

Resources.NoteBubbleButtonSet0 = Resources.Actor:new
{
	name = "NoteBubbleButtonSet",
	size = {LARGE__WIDTH, 4},
	color = "Green",
	alpha = 0, --64,
	alignment = "MidBottom",
	alignmentOffset = {0, -14},
}

Resources.NoteBubbleButtonSet1 = Resources.Actor:new
{
	name = "NoteBubbleButtonSet",
	size = {LARGE__WIDTH, 4},
	color = "Green",
	alpha = 0, --64,
	alignment = "MidBottom",
	alignmentOffset = {0, -14},
	children = 
	{
		centerButton = Resources.NoteBubbleRightButton,
	},
	zorder = 5,
}

Resources.NoteBubbleButtonSet3 = Resources.Actor:new
{
	name = "NoteBubbleButtonSet",
	size = {LARGE__WIDTH, 4},
	color = "Green",
	alpha = 0, --64,
	alignment = "MidBottom",
	alignmentOffset = {0, -14},
	children = {
		leftButton = Resources.NoteBubbleLeftButton,
		centerButton = Resources.NoteBubbleCenterButton,
		rightButton = Resources.NoteBubbleRightButton,
	},
	zorder = 5,
}

--Notebubble Resources
Resources.NoteBubbleCloseButton = Resources.Button:new {
	resource = "Button",
	image = "btnClose.Circle.png",
	clickSound			= "click2.ogg",
	highlightSound		= "TinyClick.ogg",
	shortcutKey = "x",
	escapeKey = true,
	alignment = "TopRight",
	alignmentOffset = {-8, 10},
	text = "",
	zorder = 6,
}


arrowPointSpan = 10
arrowPointTime = 500

Scripts.PointRight = function (arrow)
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x+arrowPointSpan,currentPosition.y}
	while true do
		SlideAndWait(arrow, adjustPosition, arrowPointTime)
		SlideAndWait(arrow, currentPosition, arrowPointTime)
	end
end

Resources.NoteBubbleArrowRight = Resources.Actor:new {
	resource = "Actor",
	image = "objBubble.White.Arrow.png",
	rotationAngle = { degrees = 0 },
	alignment = "MidRight",
	alignTo = "MidLeft",
	alignmentOffset = {7, 0},
	scripts = {"PointRight"},
	zorder = 3,
}

Scripts.PointLeft = function (arrow)
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x-arrowPointSpan,currentPosition.y}
	while true do
		SlideAndWait(arrow, adjustPosition, arrowPointTime)
		SlideAndWait(arrow, currentPosition, arrowPointTime)
	end
end

Resources.NoteBubbleArrowLeft = Resources.Actor:new {
	resource = "Actor",
	image = "objBubble.White.Arrow.png",
	rotationAngle = { degrees = 180 },
	alignment = "MidLeft",
	alignTo = "MidRight",
	alignmentOffset = {-7, 0},
	scripts = {"PointLeft"},
	zorder = 3,
}

Scripts.PointUp = function (arrow)
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x,currentPosition.y-arrowPointSpan}
	while true do
		SlideAndWait(arrow, adjustPosition, arrowPointTime)
		SlideAndWait(arrow, currentPosition, arrowPointTime)
	end
end

Resources.NoteBubbleArrowTop = Resources.Actor:new {
	resource = "Actor",
	image = "objBubble.White.Arrow.png",
	rotationAngle = { degrees = -90 },
	alignment = "MidTop",
	alignTo = "MidBottom",
	alignmentOffset = {0, -12},
	scripts = {"PointUp"},
	zorder = 3,
}

Scripts.PointDown = function (arrow)
	local currentPosition = arrow.position
	local adjustPosition = {currentPosition.x,currentPosition.y+arrowPointSpan}
	local loopCount = 1
	while true do
		SlideAndWait(arrow, adjustPosition, arrowPointTime)
		SlideAndWait(arrow, currentPosition, arrowPointTime)
	end
end

Resources.NoteBubbleArrowBottom = Resources.Actor:new {
	resource = "Actor",
	image = "objBubble.White.Arrow.png",
	rotationAngle = { degrees = 90 },
	alignment = "MidBottom",
	alignTo = "MidTop",
	alignmentOffset = {0, 12},
	scripts = {"PointDown"},
	zorder = 3,
}


Resources.NoteBubbleMainText = Resources.Label:new {
	resource = "Label",
	font = Resources.NoteBubbleFont:new {
		resource = "NoteBubbleFont",
	},
	fgColor = "Black",
	alignment = "Center",
	alignTo = "Center",
	centerWrap = true,
}

Resources.NoteBubbleMainTextContainer = Resources.Button:new {
	resource = "Button",
	useFrames = false,
	image = "",
	alpha = 0,
	clickOffset = {0,0},
	text = "",
	size = {LARGE__WIDTH - (20), 
		LARGE__TOP_PIECE_HEIGHT
			+ (LARGE__MIDDLE_PIECE_HEIGHT * LARGE__NUM_MIDDLE_PIECES) + LARGE__MIDDLE_PIECES_Y_OFFSET
			+ LARGE__BOTTOM_PIECE_HEIGHT - (20)},
	alignment = "Center",
	zorder = 5,
	MainText = Resources.NoteBubbleMainText,
}

Resources.LargeNoteBubble = Resources.Actor:new{
	class = "NoteBubble",
	zorder = 101,
	cornerMargin = {17,17},
	
	size = {
		LARGE__WIDTH,
		LARGE__TOP_PIECE_HEIGHT
			+ (LARGE__MIDDLE_PIECE_HEIGHT * LARGE__NUM_MIDDLE_PIECES) + LARGE__MIDDLE_PIECES_Y_OFFSET
			+ LARGE__BOTTOM_PIECE_HEIGHT
	},

	body = Resources.Actor:new {
		resource = "Actor",
		size = {
			LARGE__WIDTH,
			LARGE__TOP_PIECE_HEIGHT
				+ (LARGE__MIDDLE_PIECE_HEIGHT * LARGE__NUM_MIDDLE_PIECES) + LARGE__MIDDLE_PIECES_Y_OFFSET
				+ LARGE__BOTTOM_PIECE_HEIGHT
		},
		alpha = 0,

		top = Resources.Actor:new {
			resource = "Actor",
			zorder = 1,
			image = "objBubble.Long.White.Top.png",
		},
		
		middle_pieces = Resources.Actor:new {
			resource = "Actor",
			position = {0, 42},
			alpha = 0,
			
			piece_1 = Resources.Actor:new {
				resource = "Actor",
				image = "objBubble.Long.White.Middle.png",
				position = {0, LARGE__MIDDLE_PIECE_HEIGHT * 0},
			},
			
			piece_2 = Resources.Actor:new {
				resource = "Actor",
				image = "objBubble.Long.White.Middle.png",
				position = {0, LARGE__MIDDLE_PIECE_HEIGHT * 1},
			},
			
			piece_3 = Resources.Actor:new {
				resource = "Actor",
				image = "objBubble.Long.White.Middle.png",
				position = {0, LARGE__MIDDLE_PIECE_HEIGHT * 2},
			},
		},
		
		bottom = Resources.Actor:new {
			resource = "Actor",
			zorder = 1,
			image = "objBubble.Long.White.Bottom.png",
			position = {
				0,
				LARGE__TOP_PIECE_HEIGHT + (LARGE__MIDDLE_PIECE_HEIGHT * LARGE__NUM_MIDDLE_PIECES) + LARGE__MIDDLE_PIECES_Y_OFFSET
			},
		},
	},
	
	BubbleCloseButton = Resources.NoteBubbleCloseButton,
	
	bubbleArrowRightBlocker = Resources.Actor:new {
		resource = "Actor",
		size = {10,35},
		color = "White",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = {7, 0},
		zorder = 4,
	},
	
	bubbleArrowRight = Resources.NoteBubbleArrowRight,
	
	bubbleArrowLeftBlocker = Resources.Actor:new {
		resource = "Actor",
		size = {10,35},
		color = "White",
		alignment = "MidRight",
		alignTo = "MidRight",
		alignmentOffset = {-7, 0},
		zorder = 4,
	},
	
	bubbleArrowLeft = Resources.NoteBubbleArrowLeft,
	
	bubbleArrowTopBlocker = Resources.Actor:new {
		resource = "Actor",
		size = {35,10},
		color = "White",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 7},
		zorder = 4,
	},
	
	bubbleArrowTop = Resources.NoteBubbleArrowTop,
	
	bubbleArrowBottomBlocker = Resources.Actor:new {
		resource = "Actor",
		size = {35,10},
		color = "White",
		alignment = "MidBottom",
		alignTo = "MidBottom",
		alignmentOffset = {0, -7},
		zorder = 4,
	},
	
	bubbleArrowBottom = Resources.NoteBubbleArrowBottom,

	MainTextContainer = Resources.NoteBubbleMainTextContainer,
}









function CanPointOut(params)
	local position, error = GetGlobalAlignmentPoint(params)
	return position ~= nil
end

function PointOutAndWait(noteManager, params)
	--
	-- Setup params using a reasonable set of defaults.
	--

	params = params or {}
	
	local resourceName = params.resourceName or nil
	local direction = params.direction or BUBBLE_POINT_NONE
	local button_states = params.button_states or BUBBLE_ALL_BUTTONS_OFF
	local text = params.text or ""
	logprint("Text = "..text)
	
	local position, error = GetGlobalAlignmentPoint(params)
	if not position then
		logprint(string.format("WARNING: An invalid alignment point was specified.\n\terror = \"%s\"\n\talignmentTarget = \"%s\"",
			error,
			tostring(params.alignmentTarget)))
		return false
	end

	--
	-- Display a note bubble and wait for it to be closed/advanced.
	--

	noteManager.isPointing = true

	noteManager:PointOutWithNext(
		text,
		position,
		direction,
		button_states,
		resourceName)
	
	while noteManager:IsNoteBubbleVisible() do
		ScriptBreak()
	end
	
	noteManager.isPointing = false
	
	return true
end






local DoShowNoteBubble = function (noteManager, params)
	local helpBubbleParams = DeepCopy(params)
	
	local footer = "\n\n"
	if helpBubbleParams.button_states == BUBBLE_ALL_BUTTONS_OFF then
		footer = "\n"
	end
	helpBubbleParams.text = "\n" .. helpBubbleParams.text .. footer
	
	local success = PointOutAndWait(noteManager, helpBubbleParams)
	
	if(success)then
		PlaySound("pop3.ogg")
	end
	
	return success
end

Scripts.PointOutFormatted = function (noteManager, noteHelp, noteSubHelp, spotx, spoty, formatArg)
	logprint("PointOutFormatted "..noteHelp.." "..noteSubHelp)
	local helpBubbleParams = DeepCopy(HelpScripts[noteHelp][noteSubHelp])
	local formatString = helpBubbleParams.text
	
	helpBubbleParams.text = string.format(formatString,formatArg)
	
	if spotx == -1 then
		spot = helpBubbleParams.position
	else
		helpBubbleParams.position = {spotx,spoty}
	end
		
	DoShowNoteBubble(noteManager, helpBubbleParams)
	
	PlaySound("pop3.ogg")
end

Scripts.ShowOneHelpBubble = function (noteManager, noteHelp, noteSubHelp)
	DoShowNoteBubble(noteManager, HelpScripts[noteHelp][noteSubHelp])
end


local AdvanceHelpIndex = function (noteManager, helpIndex, numHelps)
	local loopMe = true
	logprint("AdvanceHelpIndex. Last button pressed = " .. noteManager.lastButtonPressed)
	
	if noteManager.lastButtonPressed == "backButton" then
		helpIndex = helpIndex - 1
	elseif noteManager.lastButtonPressed == "nextButton" or noteManager.lastButtonPressed == "" then
		helpIndex = helpIndex + 1
	elseif noteManager.lastButtonPressed == "closeButton" or noteManager.lastButtonPressed == "okayButton" then
		PlaySound("pop3.ogg")
		loopMe = false
	end
	
	if helpIndex>numHelps then
		helpIndex = 1
		loopMe = false
	elseif helpIndex<1 then
		helpIndex = numHelps
		loopMe = false
	end
	
	return helpIndex, loopMe
end

function IsFirstHelp(helpSource,helpIndex)
	while(true) do
		if(helpIndex <= 1) then
			return true
		end
		local params = DeepCopy(helpSource[helpIndex])
		if(CanPointOut(params)) then
			return false
		else
			helpIndex = helpIndex - 1
		end
	end
end

function IsLastHelp(helpSource,helpIndex)
	local numHelps = table.getn(helpSource)
	while(true) do
		if(helpIndex > numHelps) then
			return true
		end
		local params = DeepCopy(helpSource[helpIndex])
		if(CanPointOut(params)) then
			return false
		else
			helpIndex = helpIndex + 1
		end
	end
end

Scripts.ShowHelpBubbleSequence = function (noteManager, noteHelp, myScreen)
	noteManager.lastButtonPressed = "" --remove garbage from previous bubble loops
	local helpSource
	if IsTable(noteHelp) then
		logprint("ShowHelpBubbleSequence <unnamed>")
		helpSource = noteHelp
	else
		logprint("ShowHelpBubbleSequence "..tostring(noteHelp))
		helpSource = HelpScripts[noteHelp]
	end
	
	local numHelps = table.getn(helpSource)
	local helpIndex = 1
	local loopMe = true
	local errorCount = 0
	
	while loopMe do
		local helpBubbleParams = DeepCopy(helpSource[helpIndex])
		
		if helpBubbleParams.button_states == nil then
			if IsFirstHelp(helpSource,helpIndex - 1) then
				if IsLastHelp(helpSource,helpIndex + 1) then
					helpBubbleParams.button_states = BUBBLE_OKAY_BUTTON_ON
				else
					helpBubbleParams.button_states = BUBBLE_BACK_BUTTON_OFF
				end
			elseif IsLastHelp(helpSource,helpIndex + 1) then
				helpBubbleParams.button_states = BUBBLE_NEXT_BUTTON_OFF
			else
				helpBubbleParams.button_states = BUBBLE_ALL_BUTTONS_ON
			end
		end

		if not DoShowNoteBubble(noteManager, helpBubbleParams) then
			errorCount = errorCount + 1
			if errorCount == numHelps then
				break
			end
		else
			errorCount = 0
		end

		helpIndex, loopMe = AdvanceHelpIndex(noteManager, helpIndex, numHelps)
	end
end

Scripts.PointOutOneThing = function (noteManager, noteHelp, noteSubHelp, spotx, spoty)
	if spotx == -1 then
		spot = HelpScripts[noteHelp][noteSubHelp].position
	else
		HelpScripts[noteHelp][noteSubHelp].position = {spotx,spoty}
	end
	
	DoShowNoteBubble(noteManager, HelpScripts[noteHelp][noteSubHelp])
	
	PlaySound("pop3.ogg")
end

Scripts.PointOutOneThingWithOkay = function (noteManager, noteHelp, noteSubHelp, spotx, spoty)
	if (HelpScripts[noteHelp][noteSubHelp] == nil) then
		logprint("ERROR: Help script: HelpScripts." .. noteHelp .. "." .. noteSubHelp .. "does not exist. Did you spell it wrong?\n")
		return;
	end
	if spotx == -1 then
		spot = HelpScripts[noteHelp][noteSubHelp].position
	else
		HelpScripts[noteHelp][noteSubHelp].position = {spotx,spoty}
	end
	HelpScripts[noteHelp][noteSubHelp].button_states = BUBBLE_OKAY_BUTTON_ON
	
	DoShowNoteBubble(noteManager, HelpScripts[noteHelp][noteSubHelp])
	
	PlaySound("pop3.ogg")
end
