
--[[
	Class: Object 
	Description: Base of all Lua resources
	Properties:
		name
--]]
Resources.Base =
{
	new = function(super, object, name)
		object = object or {}
		setmetatable(object, super)
		super.__index = super

		if name ~= nil then	
			object.name = name 
		end

		return object
	end,

	__tostring = function(object)
		return object.name
	end,
}

--[[
	Class: Object 
	Description: Base Class of all scriptable classes
	Properties:
		name
		class
--]]
Resources.Object = Resources.Base:new
{
	--resource			= "Base",
	class				= "Object",
	scriptEventsActive	= true,
	eventHandlers		= {},
}
