
local function ParticleEditor_GetParticleLayer()
	local screen = CurrentScreen()
	if not screen then
		return
	end
	
	return screen.hgeParticleLayer
end

local function ParticleEditor_GetTargetPS()
	local hgeParticleLayer = ParticleEditor_GetParticleLayer()
	if not hgeParticleLayer then
		return
	end
	
	return hgeParticleLayer.lastPS
end


local function ParticleEditor_SendEffectToEditorApp()
	local hgeParticleLayer = ParticleEditor_GetParticleLayer()
	if not hgeParticleLayer then
		return
	end
	
	hgeParticleLayer:SendLastPSToGuruParticleEditor()
end


function ParticleEditor_HandleEditorAppLaunch()
	ParticleEditor_SendEffectToEditorApp()
end


function ParticleEditor_UpdateEmitter(params)
	local target = ParticleEditor_GetTargetPS()
	if not target then
		return
	end
	
	local particleSystemInfo = target.info

	for k,v in pairs(params) do
		particleSystemInfo[k] = v
	end
end


function ParticleEditor_StartEmitterFromFile(effectName)
	KillAllParticleEmitters()

	local target = StartParticleEmitterFromFile {
		file = effectName,
		position = {200, 300},
	}
	
	ParticleEditor_SendEffectToEditorApp()
end


function ParticleEditor_StartEmitterFromParams(params)
	KillAllParticleEmitters()
	
	-- Start a dummy effect, just to get something going.
	local dummyEffectName = "Default.guru_particle"
	local target = StartParticleEmitterFromFile {
		file = dummyEffectName,
		position = {200, 300},
	}
	
	-- Stop the effect, update the emitter, then restart it.
	target:Stop(true)
	ParticleEditor_UpdateEmitter(params)
	target:Fire()

	ParticleEditor_SendEffectToEditorApp()
end
