
function IsGameGuidInTable(game_guid, game_record_table)
    for i, game_record in ipairs(game_record_table) do
        if game_record.guid == game_guid then
            return true
        end
    end
    
    return false
end


--Default dummy players table.  This would be replaced by app-specifics if
--a specific app wanted to override it.

function CreateDummyPlayersTable()
    local t = {}
    local defaults = 
    {
        { guid=1,	Name="Ben"		},
        { guid=2,	Name="Jon"		},
        { guid=3,	Name="Susan"	},
		{ guid=4,	Name="Val"		},
        { guid=5,	Name="David"	},
    }

    for i = 1, #defaults do
        local p = CreatePlayer(defaults[i])
        t[i] = p
    end

    return t
end

function CreateEngineOptionsTable()
	return {}
end

function CreateOptionsTable()
	local engineDefaults = CreateEngineOptionsTable()

	-- TODO: merge common options into CreateEngineOptionsTable
    local appDefaults = 
    {
		player = 
		{
			selectedPicture = "photoPlayer.female.png",
			customPicture = "photoPlayer.custom.png",
			pictureType = "female",
		},
		game = 
		{
			mode 			= "Standard",
	    },		
    }
	local combinedDefaults = JoinTables(engineDefaults, appDefaults)
    return combinedDefaults
end

function CreateGameModeTable()
	local t  =
	{ 
        Rank = "???",
    }
    return t
end

function CreateGameSaveTable()
    local t = 
    {
		CurrentRound    = 0,
	}
    return t
end

function CreatePlayer(overrides)
    overrides = overrides or {}
    local p = 
    {
        guid		    = overrides.guid or CreatePlayerGuid(),
        Card_Version    = Card_Version,

		Game_Modes = 
		{
			Standard	= CreateGameModeTable(),
		},

		Options = CreateOptionsTable(),
		
		Game_Saves = 
		{
		    Standard	= CreateGameSaveTable(),
		},
    }

    return JoinTables(p, overrides)
end



