--[[
	Class: PlayerPicture
	Parent Class: Actor
	Properties:
		All Actor Properties
		goalSize
--]]

Resources.PlayerPicture = Resources.Actor:new
{
	class		= "PlayerPicture",
	goalSize  = {100,100},
}


-- TODO: merge this into Resources.PlayerPicture
Resources.RemotePlayerPicture = Resources.Actor:new {
	resource = "Actor",

	OnPostSpawn = function (self)
		EVENT_HUB:AddObserver(EventMap.GURU_FRIEND_PHOTOS_UPDATED, self)
	end,
	
	SetPhotoName = function (self, value)
		self.photoName = value
		self:UpdatePhoto()
	end,

	UpdatePhoto = function (self)
		if not IsString(self.photoName) or not RES_MGR:HasResourceInfo(self.photoName) then
			self.image = self.defaultImage or ""
		else
			self.image = self.photoName
		end
	end,
	
	OnFriendPhotosUpdated = function (self)
		if IsString(self.photoName) then
			self:UpdatePhoto()
		end
	end,
}
