
--[[
	Class: DynamicBackground
	Parent Class: Actor
	Properties:
		All Actor Properties
		fadeStep
		imageTable
		fadeTime
--]]
Resources.DynamicBackground = Resources.Actor:new
{
	class		= "DynamicBackground",
	fadeStep	= 10,	-- Step in between ticks of when it does a fade
	imageTable	= {},
	fadeTime	= 100
}

--[[
	ScoreCounter: Inherits from Actor
		All Actor Properties plus:
			labelProperties - properties of delegate Label 
--]]
Resources.ScoreCounter = Resources.Actor:new
{
	class			= "ScoreCounter",
	labelProperties	= Resources.Label:new(),
}

--[[
	Script: Inherits from Object
		All Object Properties plus:
			Delay
--]]
Resources.Script = Resources.Object:new
{
	class	= "Script",
	Delay	= 0,
}
	
--[[
	Scrollbar: Inherits from Actor
		All Actor Properties plus:
			playScrollSound
--]]
Resources.Scrollbar = Resources.Actor:new
{
	class				= "Scrollbar",
	playScrollSound		= true,
}
