--[[
	Tournament: Inherits from Object
		All Object Properties plus:
			players
			tournamentName
			roundRules
			numberOfPlayers
			numberOfRounds
			eliminationPlace
			currentRoundNumber
			isTournamentEnded
			endTournament
--]]
Resources.Tournament = Resources.Object:new
{
	class				= "Tournament",
	players				= {},
	tournamentName		= "Tournament",
	roundRules			= {},
	numberOfPlayers		= 0,
	numberOfRounds		= 0,
	eliminationPlace	= 1,
	currentRoundNumber	= 0,
	isTournamentEnded	= false,
	endTournament		= false,
}
--[[
	TournamentGame: Inherits from Object
		All Object Properties plus:
			numberOfPlayers
			gameNumber
			gameName
			autoAwardPoints
			playerGuids
			standingsAwards
			standingsAchievementsAwards
			playerSelectionCriteria
--]]
Resources.TournamentGame = Resources.Object:new
{
	class						= "TournamentGame",
	numberOfPlayers				= 0,
	gameNumber					= 0,
	gameName					= "TournamentGame",
	autoAwardPoints				= 0,
	playerGuids					= {},
	standingsAwards				= {},
	standingsAchievementsAwards	= {},
	playerSelectionCriteria		= {},
}

--[[
	TournamentPlayer:Inherits from Object
		All Object Properties plus:
			scores
			playerGuid
			m_Name
			isMale
			temporaryScore
			achievementsScore
			eliminationOrder
			currentRoundNumber
			guid
--]]
Resources.TournamentPlayer = Resources.Object:new
{
	class				= "TournamentPlayer",
	scores				= {},
	playerGuid			= 0,
	m_Name				= "Joe Schmoe",
	isMale				= true,
	temporaryScore		= 0,
	achievementsScore	= 0,
	eliminationOrder	= 1,
	currentRoundNumber	= 0,
	guid				= 0,
}

--[[
	TournamentRound: Inherits from Object
		All Object Properties plus:
			playerGuids
			roundName
			roundNumber
			currentGameNumber
			numberOfPlayers
			numberOfWinners
			numberOfGames
			earlyWinScore
			autoPickWinners
			customWinnerChoices
			standingsAchievementsAwards
			customWinnerGuids
			entryPoolGuids
			gameRules
			instantiatedGames
--]]
Resources.TournamentRound = Resources.Object:new
{
	class						= "TournamentRound",
	playerGuids					= {},
	roundName					= "First",
	roundNumber					= 1,
	currentGameNumber			= 0,
	numberOfPlayers				= 0,
	numberOfWinners				= 0,
	numberOfGames				= 0,
	earlyWinScore				= 0,
	autoPickWinners				= true,
	customWinnerChoices			= {},
	standingsAchievementsAwards	= {},
	customWinnerGuids			= {},
	entryPoolGuids				= {},
	gameRules				 	= {},
	instantiatedGames			= {},
}