--Core design idea:
-- The dialog is broken into regions. Tweak the region to tweak the relative positions
-- of objects within the region. I.e. to move all of the names left, move the name region
-- left.
-- Each object within a region is built on a template. I try to keep positional
-- information out of the templates.




--The label that shows if someone's in 1st, 2nd, 3rd place, etc.
Resources.StandingsPlace = Resources.Actor:new 
{
	resource = "Actor",
	image = "RedBox.png",
	StandingsPlaceLabel = Resources.Label:new
	{
		resource = "Label",
		widthLimit = 60,
		alignment = Center,
		alignTo = Center,
		font = Resources.DialogLabelFont,
		fgColor = "White",
		text = "Nth", --placeholder text
	}
}

--The label that gives someone's name.
Resources.StandingsName = Resources.Label:new
{
	resource = "Label",
	--Todo: Width limit
	font = Resources.DialogLabelFont,
	fgColor = "Black",
	text = "Some Guy",
	alignment = "TopLeft",
	alignTo = "TopLeft",
}

Resources.StandingsValue = Resources.Label:new
{
	resource = "Label",
	--Todo: Width limit
	font = Resources.DialogLabelFont,
	fgColor = "Black",
	text = "Some Number of Points",
	alignment = "TopRight",
	alignTo = "TopRight",
}

Resources.StandingsOkayButton = Resources.Button:new
{
	resource = "Button",
	text = "Okay",
	alignment = "MidBottom",
	alignTo = "MidBottom",
	alignmentOffset = {0, 20},
	enterKey=true,
	escapeKey=true,
	shortcutKey="o",
	buttonClosesDialog = true,
}

Resources.StandingsNextButton = Resources.Button:new
{
	resource = "Button",
	text = "Next",
	alignment = "MidBottom",
	alignTo = "MidBottom",
	alignmentOffset = {180, 20},
	shortcutKey="n",
}

Resources.StandingsBackButton = Resources.Button:new
{
	resource = "Button",
	text = "Back",
	alignment = "MidBottom",
	alignTo = "MidBottom",
	alignmentOffset = {-180, 20},
	shortcutKey="b", --sdlk_b
}

Resources.StandingsDialogSubHeader = Resources.Label:new
{
	resource = "Label",
	fgColor = "White",
	font = Resources.DialogLabelFont,
	text = "",
	alignment = "MidTop",
	alignTo = "MidTop",
	alignmentOffset = {0, 37},
}

local line_y = 48 --Separation between lines.

Resources.TournamentStandingsDialog = Resources.Dialog:new
{
    class = "TournamentStandingsDialog",
    image = "bkgStandings.png", --595x399
    titleAlignmentOffset = {0,5},
    
    alignment = "Center",
	alignTo = "Center",
	
	entriesPerPage = 6,
	
	subHeader = Resources.StandingsDialogSubHeader,
	
	PrevButton = Resources.StandingsBackButton,
	NextButton = Resources.StandingsNextButton,
	OkayButton = Resources.StandingsOkayButton,
	
	rankingsArea = Resources.Actor:new {
		resource = "Actor",
		position = {29,83},
		alpha = 0,
		size = {64,6*line_y},
		
		rank1 = Resources.StandingsPlace:new {
			resource = "StandingsPlace",
			position = {0,0*line_y},
		},
		rank2 = Resources.StandingsPlace:new {
			resource = "StandingsPlace",
			position = {0,1*line_y},
		},
		rank3 = Resources.StandingsPlace:new {
			resource = "StandingsPlace",
			position = {0,2*line_y},
		},
		rank4 = Resources.StandingsPlace:new {
			resource = "StandingsPlace",
			position = {0,3*line_y},
		},
		rank5 = Resources.StandingsPlace:new {
			resource = "StandingsPlace",
			position = {0,4*line_y},
		},
		rank6 = Resources.StandingsPlace:new {
			resource = "StandingsPlace",
			position = {0,5*line_y},
		},
	},
	
	namesArea = Resources.Actor:new {
		resource = "Actor",
		position = {29+64+6,83+6},
		size = {247,312},
		alpha = 0,
		
		name1 = Resources.StandingsName:new {
			resource = "StandingsName",
			alignmentOffset = {0,0*line_y},
		},
		name2 = Resources.StandingsName:new {
			resource = "StandingsName",
			alignmentOffset = {0,1*line_y},
		},
		name3 = Resources.StandingsName:new {
			resource = "StandingsName",
			alignmentOffset = {0,2*line_y},
		},
		name4 = Resources.StandingsName:new {
			resource = "StandingsName",
			alignmentOffset = {0,3*line_y},
		},
		name5 = Resources.StandingsName:new {
			resource = "StandingsName",
			alignmentOffset = {0,4*line_y},
		},
		name6 = Resources.StandingsName:new {
			resource = "StandingsName",
			alignmentOffset = {0,5*line_y},
		},
	},
	
	scoresArea = Resources.Actor:new {
		resource = "Actor",
		position = {29+64+6+251,83+6},
		size = {251-50,312},
		alpha = 0,
		
		score1 = Resources.StandingsValue:new {
			resource = "StandingsValue",
			alignmentOffset = {0,0*line_y},
		},
		score2 = Resources.StandingsValue:new {
			resource = "StandingsValue",
			alignmentOffset = {0,1*line_y},
		},
		score3 = Resources.StandingsValue:new {
			resource = "StandingsValue",
			alignmentOffset = {0,2*line_y},
		},
		score4 = Resources.StandingsValue:new {
			resource = "StandingsValue",
			alignmentOffset = {0,3*line_y},
		},
		score5 = Resources.StandingsValue:new {
			resource = "StandingsValue",
			alignmentOffset = {0,4*line_y},
		},
		score6 = Resources.StandingsValue:new {
			resource = "StandingsValue",
			alignmentOffset = {0,5*line_y},
		},
	},
}