
function KillAllParticleEmitters()
	if not Screens.currentScreen then
		logprint("KillAllParticleEmitters(): Couldn't kill all emitters as a screen that they might be displayed on couldn't be found.")
		return
	end

	local targetParticleLayer = Screens.currentScreen:FindChild("hgeParticleLayer", true)
	if not targetParticleLayer then
		logprint("KillAllParticleEmitters(): Couldn't kill all emitters as the current screen doesn't have an hgeParticleLayer attached to it.")
		return
	end
	
	targetParticleLayer:KillAllEmitters()
end


function KillParticleEmitter(emitter)
	if not Screens.currentScreen then
		logprint("KillParticleEmitter(): Couldn't kill an emitter as a screen that it might be displayed on couldn't be found.")
		return
	end

	local targetParticleLayer = Screens.currentScreen:FindChild("hgeParticleLayer", true)
	if not targetParticleLayer then
		logprint("KillParticleEmitter(): Couldn't kill an emitter as the current screen doesn't have an hgeParticleLayer attached to it.")
		return
	end	
	
	targetParticleLayer:KillEmitter(emitter)
end


function StartParticleEmitterFromFile(params)
	if not Screens.currentScreen then
		logprint("StartParticleEmitterFromFile(): Couldn't start an emitter as a screen to display one on couldn't be found.")
		return
	end

	local targetParticleLayer = params.targetParticleLayer or Screens.currentScreen:FindChild("hgeParticleLayer", true)
	if not targetParticleLayer then
		logprint("StartParticleEmitterFromFile(): Couldn't start an emitter as the current screen doesn't have an hgeParticleLayer attached to it.")
		return
	end

	local file = params.file -- or "Default_Effect.guru_particle"
	local position = params.position -- or {targetParticleLayer.width / 2, targetParticleLayer.height / 2}
	
	return targetParticleLayer:StartEmitter(file, position)
end

function FireParticle(actor,particleName,location,particleLayer,alignmentOffset)
	assert(actor, "FireParticle() was passed a nil `actor`.")
	assert(particleName, "FireParticle() was passed a nil `particleName`.")
	local offset = alignmentOffset or {0,0}
	if(location == nil)then
		location = "Center"
	end
	local spot = actor:GetGlobalPoint(location)
	if(particleLayer)then
		spot = particleLayer:GlobalToLocalCoord(actor:GetGlobalPoint(location))
	end
	spot.x = spot.x + offset[1]
	spot.y = spot.y + offset[2]
	local fileName = particleName..".guru_particle"
	return StartParticleEmitterFromFile({file=fileName,position=spot,targetParticleLayer=particleLayer})
end

