
local ScreenScaleFactor = 2
local CascadeEndGameDialog_border_x = 40
local LevelDialogDropDownY = Layout{0, ipad = 2, iphone5=30,pc=-75}
local DialogDropDownY = Layout{-2, ipad = 14, iphone5=30,pc=-75}
local DialogTitleY = 92
local DialogButtonY = -10

local Large_Dialog_Button_Y = -60/ScreenScaleFactor
local LargeLong_Dialog_Button_Y = -20/ScreenScaleFactor
local LargeLonger_Dialog_Button_Y = -60/ScreenScaleFactor+7
local Dialog_Button_Y = -45/ScreenScaleFactor
local Small_Dialog_Button_Y = -52/ScreenScaleFactor-3
local Dialog_Button_X = 100
local Dialog_Button_Right = Dialog_Button_X
local Dialog_Button_Left = -Dialog_Button_X

local toGoAlignment = "MidBottom"
local toGoOffset = {0,-1}
local amountToGoOffset = {0,-1}

DIALOG_SLIDE_SPEED = TICK_INTERVAL*8

if (Language == "fr") then
    toGoAlignment = "MidTop"
    toGoOffset = {0,-5}
    amountToGoOffset = {0,6}
end

function AddTrail_dialog(actor,particleName)
	local particleTrail = CreateInstance {
		name = "particleTrail",
		class = "hgeParticleSystemActor",
		file = particleName,
		alignment = Center,
		targetTag = "hgeParticles_tag",
	}
	actor:AddChild(particleTrail)
	return particleTrail
end

--Dialog templates
Resources.DialogCommon = Resources.Dialog:new {
	resource = "Dialog",
    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 100,
		tag = "hgeParticles_tag",
    },
}

Scripts.ShouldUseArt = function()
	if (Language == "en") then
		return true
	end
	return false
end

Scripts.LocalizedButtonOnAwake = function(self)
	if (Scripts:ShouldUseArt()) then
		self.text = ""
	else
		local blankImageName = string.gsub(self.image, ".png", "_Blank.png")
        -- HACK: If the image isn't found, use an alternate image (fixes CASM-429)
        if RES_MGR and not RES_MGR:HasResourceInfo(blankImageName) then
            logprintf("WARNING in Scripts.LocalizedButtonOnAwake: Unable to find image: \"%s\", using placeholder instead\n", blankImageName)
            blankImageName = "Button_Play_More_big_Blank.png"
        end
		self.image = blankImageName
	end
end

Resources.LargeLongDialog = Resources.DialogCommon:new {
	resource = "DialogCommon",
	title = "",
    class = "Dialog",
	titleAlignmentOffset = {0,85},
	image = "bkgDialogLonger.png",
    alignment = Layout{"Center",android="Center"},
    alignmentOffset = {0,0},
	enableVisibleUnderlay = true,
}

local headerOffset = 60

Resources.LargeLongerDialog = Resources.DialogCommon:new {
	resource = "DialogCommon",
	title = "",
    class = "Dialog",
	titleAlignmentOffset = {0,85},
    alignment = Layout{"MidTop",android="Center"},
    alignTo = Layout{"MidTop",android="Center"},
	image = "DialogGeneric_Large.png",
    alignmentOffset = Layout{{0,DialogDropDownY+(headerOffset/2)},android={0,0}},
	enableVisibleUnderlay = true,
	size = {650/2,970/2-headerOffset},
}

Resources.MidSizedDialog = Resources.DialogCommon:new {
	resource = "DialogCommon",
	title = "",
    class = "Dialog",
	titleAlignmentOffset = {0,85},
	size = {313,380},
    alignment = Layout{"MidTop",android="Center"},
	color = "Cascade_Cyan",
    alignmentOffset = {0,DialogDropDownY},
	enableVisibleUnderlay = true,
}

Resources.BestStamp = Resources.Actor:new {
	resource = "Actor",
	alignTo = MidRight,
	alignment = MidLeft,
	alignmentOffset = {0,-2},
	image = "best.png",
	visible = true,
	--size = {30,30},
}

Scripts.DialogButtonGroove = function(actor)
	local speed = 50
	local factor = math.random(10,20)
	local amount
	local pick = math.random(0,1)
	if(pick==0)then
		amount = 0-factor
	else
		amount = factor
	end

	local expandTo = {1.0, 1.025}
	local expandTime = 200
	local shrinkTime = 200
	local tilt = 2
	local swing = 1

	actor.scalingPoint = {50,118}
	actor.rotationPoint = {50,118}

	local firstTime = 1

	while(true)do
		if(swing==1)then
			doTilt = -tilt
			if(firstTime==1) then
				RotateByAmount(actor,{degrees=doTilt/2},100,true)
				firstTime = 0
			else
				RotateByAmount(actor,{degrees=doTilt},100,true)
			end
		end

		if(swing==3)then
			doTilt = tilt
			RotateByAmount(actor,{degrees=doTilt},100,true)
		end
		swing = swing + 1
		if(swing==5)then
			swing=1
		end

		actor.extraScale = {1.0, 1.0}
		ScaleTo(actor, expandTo, expandTime)
		ScriptDelay(expandTime,"DialogTimers")

		ScaleTo(actor, {1.0, 1.0}, shrinkTime)
		ScriptDelay(shrinkTime,"DialogTimers")

		ScriptDelay(0,"DialogTimers")

	end

	--RotateByAmount(actor,{degrees=-amount},speed,true)
	--RotateByAmount(actor,{degrees=amount*2-(amount/2)},speed,true)
	--RotateByAmount(actor,{degrees=-((amount/2)+(amount/4))},speed,true)
	--RotateByAmount(actor,{degrees=(amount/4)*2},speed,true)
	--RotateByAmount(actor,{degrees=-amount/4},speed,true)
	actor.rotation = { degrees = 0 }
end

Scripts.WelcomePackButtonGroove = function(actor)
	local speed = 50
	local factor = math.random(10,20)
	local amount
	local pick = math.random(0,1)
	if(pick==0)then
		amount = 0-factor
	else
		amount = factor
	end

	local expandTo = {1.0, 1.025}
	local expandTime = 200
	local shrinkTime = 200
	local tilt = 2
	local swing = 1

	actor.scalingPoint = {50,118}
	actor.rotationPoint = {50,118}

	local firstTime = 1

	for i = 1,3 do
		if(swing==1)then
			doTilt = -tilt
			if(firstTime==1) then
				RotateByAmount(actor,{degrees=doTilt/2},100,true)
				firstTime = 0
			else
				RotateByAmount(actor,{degrees=doTilt},100,true)
			end
		end

		if(swing==3)then
			doTilt = tilt
			RotateByAmount(actor,{degrees=doTilt},100,true)
		end
		swing = swing + 1
		if(swing==5)then
			swing=1
		end

		actor.extraScale = {1.0, 1.0}
		ScaleTo(actor, expandTo, expandTime)
		ScriptDelay(expandTime,"DialogTimers")

		ScaleTo(actor, {1.0, 1.0}, shrinkTime)
		ScriptDelay(shrinkTime,"DialogTimers")

		ScriptDelay(0,"DialogTimers")

	end

	--RotateByAmount(actor,{degrees=-amount},speed,true)
	--RotateByAmount(actor,{degrees=amount*2-(amount/2)},speed,true)
	--RotateByAmount(actor,{degrees=-((amount/2)+(amount/4))},speed,true)
	--RotateByAmount(actor,{degrees=(amount/4)*2},speed,true)
	--RotateByAmount(actor,{degrees=-amount/4},speed,true)
	actor.rotation = { degrees = 0 }
end

Resources.DialogButton = Resources.AppButtonSmall:new {
	resource = "AppButtonSmall",
	image = "ButtonPlastic_Small_Orange.png",
	textWidthLimit = 70,
}

Resources.DialogSmallButton = Resources.AppButtonMedium:new {
	resource = "AppButtonMedium",
	image = "ButtonPlastic_Small_Orange.png",

}

Resources.DialogSmallerButton = Resources.AppMenuSmallSignButton:new {
	resource = "AppMenuSmallSignButton",
	image = "ButtonPlastic_Small_Orange.png",
}

Resources.BigDialogButton = Resources.AppButtonLarge:new {
	resource = "AppButtonLarge_green",
}


Resources.AppCheckBox = Resources.Button:new {
	resource = "Button",
	text = STRINGS(""),
	image = "boxCheck.png",
	useFrames = false,
	font = {resource = "ButtonFont",},

    clickSound = buttonClickSound,

	OnPostSpawn = function (self)
		self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
	end,
}

Resources.EndGameDialogButton = Resources.BigDialogButton:new {
	resource = "BigDialogButton",
}

Resources.EndGameDialogBiggerButton = Resources.BigDialogButton:new {
	resource = "BigDialogButton",
	clickOffset = {0,4},
}

Resources.PriceButton = Resources.BigDialogButton:new {
	resource = "BigDialogButton",
	image = "ButtonPlastic_Longer_Green.png",
	buttonClosesDialog = true,
	alignment = MidBottom,
	enterKey = true,
	shortcutKey = "a",
	clickSound = "coin_magic_05.ogg",
	GoldIcon = Resources.Actor:new {
		resource = "Actor",
		visible = false,
		image = "Gold_1bar.png",
		size = {222/2*.7,161/2*.7},
	},

	CrossOut_Price = Resources.AppTitleDialogLabel_bigger:new {
		resource = "AppTitleDialogLabel_bigger",
		text = STRINGS("/"),
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,0},
		visible = false,
		zorder = 10,
		shadowAlpha = 0,
		highlightAlpha = 0,
		alpha = 200,
		extraScale = {1.5,1.2},
		rotationAngle = {degrees = 15,},
	},
    AlteredPrice = Resources.AppTitleDialogLabel_bigger:new {
        resource = "AppTitleDialogLabel_bigger",
        text = STRINGS(""),
        alignment = MidBottom,
        alignTo = MidTop,
        alignmentOffset = {-20,20},
        wrapLimit = 250,
        visible = false,
		rotationAngle = {degrees = -15,},
    },
}

Resources.EndGameDialogBigButton = Resources.AppMenuSmallSignButton:new {
	resource = "AppMenuSmallSignButton",
	image = "ButtonPlastic_Short_Green.png",
    textColor = "Cascade_BrightYellow",
    textHighlightColor = "Cascade_DarkGreen",
    textHighlightAlpha = 255,
    textShadowColor = "Cascade_DarkGreen",
    textShadowOffset = {1, 2},
	font	= Resources.AppButtonFont:new{
		resource = "AppButtonFont",
	},
	textWidthLimit = 175,
}

Resources.BuyNowButton = Resources.EndGameDialogBigButton:new {
    resource = "EndGameDialogBigButton",
    image = "Button_GiftPack_Blank.png",
    text = STRINGS("???"),
    alignment = "MidBottom",
    alignmentOffset = {0, LargeLong_Dialog_Button_Y-40},
    textAlignmentOffset = {0, -15},
	textWidthLimit = 80,
	textColor = "White",
	textShadowColor = "Red",
	textShadowOffset = {1,1},
	textShadowAlpha = 255,
	textHighlightColor = "Red",
	textHighlightOffset = {-1,-1},
	textHighlightAlpha = 255,

    --buttonClosesDialog = true,
	zorder = 2,
    visible = false,

    BuyNow = Resources.AppTitleDialogLabel_big:new {
        resource = "AppTitleDialogLabel_big",
        text = STRINGS("Buy Now!"),
        alignment = Center,
        alignTo = Center,
        alignmentOffset = {0,20},
        wrapLimit = 250,
		fgColor = "White",
		shadowColor = "Red",
		shadowOffset = {1,1},
		shadowAlpha = 255,
		highlightColor = "Red",
		highlightOffset = {-1,-1},
		highlightAlpha = 255,
		font	= Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 32,
		},
    },
}

Resources.AppChallengeFriendsButton = Resources.ChallengeFriendsButton:new {
	resource = "ChallengeFriendsButton",
	--image = "btnChallengeFriend.png",

	--image = "btnMenuBig.png",
    textAlignmentOffset = {0,-5},
	textWidthLimit = 200,
	font	= Resources.AppButtonFont:new{
		resource = "AppButtonFont",
	},
	text = STRINGS("Challenge Friend"),
	icon = Resources.Actor:new {
		resource = "Actor",
		visible = false,
	},
}


local options_x = 0 --31
local options_x2 = 0
local options_x3 = 0
local options_y_offset = -80
local options_y_nudge = -30
local options_y_nudge2 = -20
local options_y_nudge3 = -10

Resources.CancelButton = Resources.DialogButton:new {
	resource = "DialogButton",
	alpha = 255,
	text = STRINGS("cancel"),
	--image = "btnClose.Dialog.png",
	image = "Btn_Exit.png",
	text = STRINGS(""),
	shortcutKey = "C",
	alignment = TopRight,
	alignmentOffset = Layout{{-10,8},iphone5={-10,8},ipad={-10,8}},
	--size = DialogButtonSize,
	buttonClosesDialog = true,
	escapeKey = true,
	zorder = 10,
}


Resources.WelcomePackButton = Resources.AppWhiteButton_small:new {
    resource = "AppWhiteButton_small",
    image = "Welcome_Pack.png",
    visible = false,

    HideButton = Resources.DialogButton:new {
        resource = "DialogButton",
        alpha = 255,
        image = "GiftBox_CloseButton.png",
        text = STRINGS(""),
        alignment = Center,
        --alignmentOffset = {15,-44},
        alignmentOffset = {22,-24},
        zorder = 10,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
                self.screen:StartDialog("WelcomePackAreYouSureYouWantToHideDialog", "WelcomePackAreYouSureYouWantToHideDialog", true)
            return true
        end,

        OnPostSpawn = function(self)
            self.visible = WP_MGR:CanHide()
        end
    },

    timeRemainingPanel = Resources.Actor:new {
        resource = "Actor",
        image = "WhiteButton_small.png",
        alignment = MidBottom,
        alignmentOffset = {0,30},

        timeRemainingLabel = Resources.AppDialogLabel:new {
            resource = "AppDialogLabel",
            alignment = Center,
            alignmentOffset = {-2,-2},
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 19,
            },
            textColor = "Black",

            Tick = function(self)
                self.text = WP_MGR:GetTimeRemainingText()
            end,
        },
    },

    Tick = function(self)
        self.visible = WP_MGR:DoShow()
        if (self.visible and not WP_MGR:HasBeenShown()) then
            WP_MGR:ShowDialog()
        end
    end,

    OnButtonClick = function (self, event)
        if self ~= event.button then return false end
            WP_MGR:ShowDialog()
        return true
    end,
}

Resources.GiftPackButton = Resources.AppWhiteButton_small:new {
    resource = "AppWhiteButton_small",
    image = "Gift_Pack_Yellow.png",
    visible = false,

    HideButton = Resources.DialogButton:new {
        resource = "DialogButton",
        alpha = 255,
        image = "GiftBox_CloseButton.png",
        text = STRINGS(""),
        alignment = Right,
        alignmentOffset = {0,0},
        zorder = 10,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
                self.screen:StartDialog("GiftPackAreYouSureYouWantToHideDialog", "GiftPackAreYouSureYouWantToHideDialog", true)
            return true
        end,

        OnPostSpawn = function(self)
            self.visible = GP_MGR:CanHide()
        end
    },

    timeRemainingPanel = Resources.Actor:new {
        resource = "Actor",
        image = "WhiteButton_small.png",
        alignment = MidBottom,
        alignmentOffset = {0,30},

        timeRemainingLabel = Resources.AppDialogLabel:new {
            resource = "AppDialogLabel",
            alignment = Center,
            alignmentOffset = {-2,-2},
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 19,
            },
            textColor = "Black",

            Tick = function(self)
                self.text = GP_MGR:GetTimeRemainingText()
            end,
        },
    },

    Tick = function(self)
        self.visible = GP_MGR:DoShow()
        if (self.visible and GP_MGR:ShouldShowDialog()) then
            GP_MGR:ShowDialog()
        end
    end,

    OnButtonClick = function (self, event)
        if self ~= event.button then return false end
            GP_MGR:ShowDialog()
        return true
    end,
}

Resources.OfferPackButton = Resources.AppWhiteButton_small:new {
    resource = "AppWhiteButton_small",
    image = "Welcome_Pack.png",
    visible = false,

    timeRemainingPanel = Resources.Actor:new {
        resource = "Actor",
        image = "WhiteButton_small.png",
        zorder = -10,
        alignment = Left,
        alignmentOffset = {35, 5},

        HideButton = Resources.DialogButton:new {
            resource = "DialogButton",
            alpha = 255,
            image = "GiftBox_CloseButton.png",
            text = STRINGS(""),
            alignment = Right,
            alignmentOffset = {10, -12},
            zorder = 10,

            OnButtonClick = function(self, event)
            if self ~= event.button then return false end
            self.screen:StartDialog("OfferPackAreYouSureYouWantToHideDialog",
                "OfferPackAreYouSureYouWantToHideDialog", true)
            return true
            end,

            OnPostSpawn = function(self)
            self.visible = OP_MGR:CanHide()
            end,
        },

        timeRemainingLabel = Resources.AppDialogLabel:new {
            resource = "AppDialogLabel",
            alignment = Center,
            alignmentOffset = {0, -2},
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 19,
            },
            textColor = "Black",
			widthLimit = 75,

            Tick = function(self)
                self.text = OP_MGR:GetTimeRemainingText()
            end,
        },
    },

    OnButtonClick = function(self, event)
        if self ~= event.button then return false end
        OP_MGR:ShowDialog()
        return true
    end,
}

Resources.LabEventButton = Resources.AppWhiteButton_small:new {
    resource = "AppWhiteButton_small",
    image = "LabLevelIcon.png",
    visible = false,

	rankLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {20, -7},
		textColor = "White",
		highlightColor = "Cascade_DarkBlue",
		shadowColor = "Cascade_DarkBlue",
		widthLimit = 55,

		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 20,
		},

		Tick = function(self)
			self.text = LAB_EVENT_MGR:GetRankText()
		end,
	},

	timeRemainingLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {24, 10},
		textColor = "White",
		widthLimit = 48,

		font = Resources.AppGameFont:new {
			resource = "AppGameFont",
			fontSize = 16,
		},

		Tick = function(self)
			self.text = LAB_EVENT_MGR:GetTimeRemainingText(true)
		end,
	},

    OnButtonClick = function(self, event)
        if self ~= event.button then return false end
        LAB_EVENT_MGR:ShowEventDialog()
        return true
    end,
}

Resources.OptionsDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "OptionsDialog",
    title = "",
	name = "OptionsDialog",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    titleText = Resources.AppTitleDialogLabel_UI2:new {
		resource = "AppTitleDialogLabel_UI2",
		text = STRINGS("OPTIONS"),
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	MenuButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y + 5},
		textAlignmentOffset = {0,0},
		text = STRINGS("Menu"),
		enterKey = true,
		shortcutKey = "m",
		visible = true,
	},

	MasterVolumeTitle = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Master Volume"),
		alignment = Center,
		alignmentOffset = {options_x, options_y_offset - 54 + options_y_nudge},
	},

	MasterVolumeScrollbar = Resources.Scrollbar:new {
		resource = "Scrollbar",
		minValue = 0,
		maxValue = 100,
		value = 0,
		alignment = MidRight,
		alignmentOffset = {-38, options_y_offset-24 + options_y_nudge},
		playScrollSound = true,
		clickSound = "Cascade_Doop_1.ogg",
		configProperty = "sfx_volume",
	},

	MusicVolumeTitle = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Music Volume"),
		alignment = Center,
		alignmentOffset = {options_x, 14 + options_y_offset + options_y_nudge},
	},

	MusicVolumeScrollbar = Resources.Scrollbar:new {
		resource = "Scrollbar",
		minValue = 0,
		maxValue = 100,
		value = 0,
		playScrollSound = false,
		alignment = MidRight,
		alignmentOffset = {-38, 14 + options_y_offset+30 + options_y_nudge},
		clickSound = "Cascade_Doop_5.ogg",
		configProperty = "music_volume",
	},

	AllowHintsLabel =  Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Show Hints"),
		alignment = Center,
		alignmentOffset = {0, 54 + options_y_offset+35+options_y_nudge},
		widthLimit = 200,
	},

	AllowHintsCheckBox = Resources.AppCheckBox:new {
		resource = "AppCheckBox",
		shortcutKey = "u",
		alignment = Center,
		alignmentOffset = {-120, 54 + options_y_offset+35+options_y_nudge},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			Config.showHint = not Config.showHint
			if (Config.showHint == true) then
                logprint("showHint == true")
            else
                logprint("showHint == false")
            end
			self:UpdateVisibility()
			return true
		end,
		UpdateVisibility = function (self)
			if (Config.showHint == true) then
                logprint("showHint == true")
                self.frame = 1
            else
                logprint("showHint == false")
                self.frame = 0
            end
		end,
		OnWindowEvent = function (self, event)
			if event.eventName == "SDL_WINDOWEVENT_RESTORED" then
				self:UpdateVisibility()
			end
		end,
		OnPostSpawn = function (self)
			self:UpdateVisibility()
		end,
	},

	ShowCutscenesLabel =  Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("cutscenes always"),
		alignment = MidLeft,
		alignmentOffset = {options_x+130-70, 54 + options_y_offset+(65+40)},
		visible = false,
	},

	ShowCutscenesCheckBox = Resources.AppCheckBox:new {
		resource = "AppCheckBox",
		shortcutKey = "c",
		alignment = Center,
		alignmentOffset = {-50-70, 54 + options_y_offset+(65+40)},
		visible = false,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			Config.showCutScenesAlways = not Config.showCutScenesAlways
			if (Config.showCutScenesAlways == true) then
                logprint("showCutScenesAlways == true")
            else
                logprint("showCutScenesAlways == false")
            end
			self:UpdateVisibility()
			return true
		end,
		UpdateVisibility = function (self)
			if (Config.showCutScenesAlways == true) then
                logprint("showCutScenesAlways == true")
                self.frame = 1
            else
                logprint("showCutScenesAlways == false")
                self.frame = 0
            end
		end,
		OnWindowEvent = function (self, event)
			if event.eventName == "SDL_WINDOWEVENT_RESTORED" then
				self:UpdateVisibility()
			end
		end,
		OnPostSpawn = function (self)
			Config.showCutScenesAlways= true
			self:UpdateVisibility()
		end,
	},

	facebookConnectButton = Resources.AppButtonSmall:new {
		resources = {"AppButtonSmall", "FacebookConnectDecorator"},
		--size = {130, 36},
		text = STRINGS("Connect"),
		logoutText = STRINGS("Manage Account"),	-- HACK: "Logout" functionality in FacebookConnectDecorator is overridden here, in part
		textWidthLimit = 98,
		textAlignmentOffset = {18, 0},
		textDisabledColor = "#383838",
		textColor = "Cascade_DarkBrown",
		textAlignment = "Center",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y - 155+options_y_nudge+30},
		visibleWhenConnected = true,
		isConnectUI = true,

		enableAppearanceUpdates = false,
		visible = false,

		facebookIcon = Resources.Actor:new {
			resource = "Actor",
			image = "CFN_Logo_small.png",
			alignment = "MidLeft",
			alignmentOffset = {18, 0},
		},

		OnPostSpawn = function (self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
			-- DEBUG
			--self.visible = true
		end,

		Connect = function (self, ...)
			local authStatus = self:GetAuthenticationStatus()
			if authStatus == "Ready" then
				-- Override Logout functionality here -- instead, display an
				-- account management UI.
				if not RAVE then
					error("Unable to show account info as 'RAVE' is not available")
				else
					RAVE:ShowAccountInfoScene()
				end
			else
				-- If the user isn't already logged in, do the default 'Connect' button action(s):
				Resources.FacebookConnectDecorator.Connect(self, ...)
			end
		end,
	},

	NotificationsButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Notifications"),
        widthLimit = 180,
		shortcutKey = "N",
		alignment = BottomLeft,
		alignTo = MidBottom,
		alignmentOffset = {-2,LargeLonger_Dialog_Button_Y - 115},
		visible = false,	-- this gets enabled on a screen-by-screen basis
		OnButtonClick = function (self, event)
			logprint("NotificationsButton clicked")
			if self ~= event.button then return false end
				self.screen:StartDialog("NotificationsDialog", "NotificationsDialog", true)
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	ClearPlayerButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Reset Progress"),
        widthLimit = 180,
		shortcutKey = "C",
		alignment = BottomRight,
		alignTo = MidBottom,
		alignmentOffset = {-2,LargeLonger_Dialog_Button_Y - 115},
		visible = false,	-- this gets enabled on a screen-by-screen basis
	},

	ToggleUIButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Show/Hide UI"),
		alignment = BottomRight,
		alignTo = MidBottom,
		alignmentOffset = {65,LargeLonger_Dialog_Button_Y - 115},
		visible = IsDebugUIAllowed(),

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			Config.HideMapUI = not Config.HideMapUI
			return true
		end,
	},

	CreditsButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Credits"),
		shortcutKey = "C",
		alignment = BottomRight,
		alignTo = MidBottom,
		alignmentOffset = {-2,LargeLonger_Dialog_Button_Y - 75},
	},

	SupportButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Support"),
		shortcutKey = "C",
		alignment = BottomLeft,
		alignTo = MidBottom,
		alignmentOffset = {2,LargeLonger_Dialog_Button_Y - 75},
		scripts = {"SparkleRandomly"},
		textLineSpacing = 3,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
			return true
		end,

		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	TermsOfServiceButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Terms of Service"),
		shortcutKey = "C",
		alignment = BottomRight,
		alignTo = MidBottom,
		alignmentOffset = {-2,LargeLonger_Dialog_Button_Y - 35},
		scripts = {"SparkleRandomly"},
		textLineSpacing = 3,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			if BIGFISH then
				BIGFISH:ShowTerms();
			end
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	PrivacyPolicyButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Privacy Policy"),
		shortcutKey = "C",
		alignment = BottomLeft,
		alignTo = MidBottom,
		alignmentOffset = {2,LargeLonger_Dialog_Button_Y - 35},
		scripts = {"SparkleRandomly"},
		textLineSpacing = 3,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			if BIGFISH then
				BIGFISH:ShowPrivacy();
			end
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	CrashTestButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Trigger Crash"),
		shortcutKey = "C",
		alignment = BottomRight,
		alignTo = MidBottom,
		alignmentOffset = {-2,LargeLonger_Dialog_Button_Y + 5},
		scripts = {"SparkleRandomly"},
		textLineSpacing = 3,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	VersionLabelButton = Resources.BigDialogButton:new
	{
		resource	=	"BigDialogButton",
		alignment = BottomRight,
		alignment = BottomRight,
		alignmentOffset = {-20, -11},
		size = {70,20},
		alpha = 0,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
			return true
		end,

		VersionLabel = Resources.Label:new {
			resource = "Label",
			text = STRINGS(""),
			alignment = MidRight,
			alignment = MidRight,
			alignmentOffset = {-4, 5},
			font = Resources.DialogFont:new {
				resource = "DialogFont",
				fontSize = 10,
			},
			fgColor = "Black",

			OnPostSpawn = function (self)
				if not IsFunction(GetVersionAsString) then
					return
				end

				local version = GetVersionAsString()
				local text = string.format(STRINGS("VersionFormat"), tostring(version))
				--LAYOUT
				--local text = "Version 1.5.6 (1036)"
				self.text = text
			end,
		},
	},

	adjustableOptions = {
		--Config name = {
			--Control name = {
				--Control type
				--newValue = properties to apply on taking that value
			--},
		--},
		sfx_volume = {
			MasterVolumeScrollbar = {
				type = "Scrollbar",
			}
		},
		music_volume = {
			MusicVolumeScrollbar = {
				type = "Scrollbar",
			}
		},
	},

	OnPostSpawn = function (self)
	end,
}


Resources.ConfirmPlayerDeletionDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "ConfirmPlayerDeletionDialog",
	name = "ConfirmPlayerDeletionDialog",
	title = "",

	titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Reset Progress"),
        widthLimit = 280,
		alignment = MidTop,
		alignmentOffset = {0, 100},
    },

	TextLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("Player Reset, Description"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,258},
		wrapLimit = 270,
		heightLimit = 150,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 22,
		},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	YesButton = Resources.BigDialogButton:new
	{
		resource	=	"BigDialogButton",
		text		=	STRINGS("Reset"),
		alignment	=	"MidBottom",
		alignmentOffset = {0, -30},
		buttonClosesDialog = true,
	},
}


Resources.EndGameDialogButtons = Resources.Actor:new {
	resource = "Actor",

    shareScoreButton = Resources.DialogSmallerButton:new {
		resource = "DialogSmallerButton",
		image = "ButtonPlastic_Small_Blue.png",
		text = STRINGS("Share"),  -- was brag
		alignment = MidBottom,
		alignmentOffset = {110,-12},
		OnButtonClick = function (self, event)
			if self ~= event.button then
				return false
			end
			if IsString(self.textToShare) then
                Analytics_Brag()
				ShareText(self.textToShare, "EndGame", self)
			end
			return true
		end,
		--scripts = {"JelloLoop"},
	},

    PlayAgainButton = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
		--image = "btnPlayAgain.png",
		text = STRINGS("Play Again!"),
		alignment = "MidBottom",
		alignmentOffset = {0, -52*2},
		buttonClosesDialog = true,
	},

    --[[
	okayButton = Resources.EndGameDialogButton:new {
		resource = "EndGameDialogButton",
		image = "btnMainMenu.png",
		alignment = "MidBottom",
		alignmentOffset = {0, 52},
		buttonClosesDialog = true,
	},
	--]]

	ChallengeFriendsButton = Resources.AppChallengeFriendsButton:new {
		resource = "AppChallengeFriendsButton",
		alignment = "MidBottom",
		alignmentOffset = {0, 0},
	},

	--[[
    RetryButton = Resources.EndGameDialogButton:new {
		resource = "EndGameDialogButton",
		image = "btnRetry.png",
		alignment = "MidBottom",
		alignmentOffset = {0, -52},
		buttonClosesDialog = true,
	},
    --]]
}

Resources.EndGameDialogButtons_Challenge = Resources.Actor:new {
	resource = "Actor",

    shareScoreButton = Resources.DialogSmallerButton:new {
		resource = "DialogSmallerButton",
		--image = "btnShare.png",
		image = "ButtonPlastic_Small_Blue.png",
		text = STRINGS("Share"),  -- was brag
		alignment = MidBottom,
		alignmentOffset = {110,-12},
		OnButtonClick = function (self, event)
			if self ~= event.button then
				return false
			end
			if IsString(self.textToShare) then
                Analytics_Brag()
				ShareText(self.textToShare, "EndGame", self)
			end
			return true
		end,
		--scripts = {"JelloLoop"},
	},

    PlayAgainButton = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
		text = STRINGS("Retry"),
        font	= Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 30,
        },
		image = "ButtonPlastic_Short_Green.png",
		alignment = "MidBottom",
		alignmentOffset = {0, 0},
		textAlignmentOffset = {0,0},
		buttonClosesDialog = true,
		textWidthLimit = 115,
        zorder = 2,
	},

    ButtonBevel = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Small_WoodOutline.png",
        alignment = MidBottom,
        alignTo = Center,
        alignmentOffset = {0,0},
        zorder = 1,
    },
}

local endGameLineSeparation = 31
local endGameFirstLineY = 140
local endGameLabelX = 50
local endGameValueX = -50

--Summarizes the end of the game.
Resources.CascadeEndGameDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    title = "",
    class = "Dialog",
    name = "CascadeEndGameDialog",
    enableVisibleUnderlay = true,

    titlePanel = Resources.Actor:new {
		resource = "Actor",
		image = "titleGameOver.png",
		alignment = MidTop,
		alignmentOffset = {0, 59},
    },

    --Score, front and center. Counts up from 0.
	scoreContainer = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		--alignmentOffset = {0, 186},  -- centered
		alignmentOffset = {0, 160},

		SetScore = function (self, score)
			self.score.text = string.format(STRINGS("EndGameDialog_ScoreFormat"), Int2Comma(score))
		end,

		score = Resources.Label:new {
			resource = "Label",
			fgColor = "Black",
			alignment = "MidTop",
			--alignTo = "MidTop",
			alignmentOffset = {0,0}, --{4,0},
			text = STRINGS(""),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 36,
			},
			shadowColor = "Black",
			shadowAlpha = 100,

			bestStamp = Resources.BestStamp:new {
				resource = "BestStamp",
				visible = false,
			},
		},
	},

    --Score, front and center. Counts up from 0.
	goalScoreContainer = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		--alignmentOffset = {0, 186},  -- centered
		alignmentOffset = {0, 135},

		SetScore = function (self, score)
			self.score.text = string.format(STRINGS("EndGameDialog_GoalScoreFormat"), Int2Comma(score))
		end,

		score = Resources.Label:new {
			resource = "Label",
			fgColor = "Black",
			alignment = "MidTop",
			--alignTo = "MidTop",
			alignmentOffset = {0,0}, --{4,0},
			text = STRINGS("1,000,000"),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 24,
			},
			shadowColor = "Black",
			shadowAlpha = 100,
			visible = true,
		},

		check = Resources.Actor:new {
			resource = "Actor",
			image = "Check.png",
			alignment = TopRight,
			alignTo = TopRight,
			alignmentOffset = {140,0},
			zorder = 10,
			visible = true,
		},

		visible = true,
	},

	ChallengeDialog_TopScoreToday = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = TopLeft,
		alignTo = TopLeft,
		alignmentOffset = {endGameLabelX,endGameFirstLineY + 3 * endGameLineSeparation},
		text = STRINGS("Daily Best:"),
		font = Resources.CascadeEndGameDialogFont:new {
			resource = "CascadeEndGameDialogFont",
			fontSize = 20,
		},
		visible = true,
    },

    dailyBest = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = TopLeft,
		alignTo = TopLeft,
		alignmentOffset = {endGameValueX,endGameFirstLineY + 3 * endGameLineSeparation},
		text = STRINGS("100,000"),
		font = Resources.CascadeEndGameDialogFont:new {
			resource = "CascadeEndGameDialogFont",
			fontSize = 20,
		},
		bestStamp = Resources.BestStamp:new {
			resource = "BestStamp",
			visible = false,
		},
		visible = true,
    },

    personalBestLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = TopLeft,
		alignTo = TopLeft,
		alignmentOffset = {endGameLabelX+20,endGameFirstLineY + 3 * endGameLineSeparation},
		text = STRINGS("Personal Best:"),
		font = Resources.CascadeEndGameDialogFont:new {
			resource = "CascadeEndGameDialogFont",
			fontSize = 20,
		},
		visible = true,
    },

    personalBest = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = TopRight,
		alignTo = TopRight,
		alignmentOffset = {endGameValueX + 22,endGameFirstLineY + 3 * endGameLineSeparation},
		text = STRINGS("100,000"),
		font = Resources.CascadeEndGameDialogFont:new {
			resource = "CascadeEndGameDialogFont",
			fontSize = 20,
		},
        widthLimit = 70,
		bestStamp = Resources.BestStamp:new {
			resource = "BestStamp",
			visible = false,
		},
		visible = true,
    },

	challengeBeatLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = TopLeft,
		alignTo = TopLeft,
		alignmentOffset = {endGameLabelX,endGameFirstLineY + 3 * endGameLineSeparation},
		text = STRINGS("Challenges Beat:"),
		font = Resources.CascadeEndGameDialogFont:new {
			resource = "CascadeEndGameDialogFont",
			fontSize = 20,
		},
		visible = false,
    },

    challengeBeat = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = TopRight,
		alignTo = TopRight,
		alignmentOffset = {endGameValueX,endGameFirstLineY + 3 * endGameLineSeparation},
		text = STRINGS(""),
		font = Resources.CascadeEndGameDialogFont:new {
			resource = "CascadeEndGameDialogFont",
			fontSize = 20,
		},
		--bestStamp = Resources.BestStamp,
		visible = false,
    },

	ButtonCollection = Resources.EndGameDialogButtons:new {
		resource = "EndGameDialogButtons",
		alignment = "MidBottom",
		alignmentOffset = {0, -40},
	},

	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y+4},
		text = STRINGS("Menu"),
		--image = "btnOkay.png",
		--text = STRINGS(""),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
		zorder = 2,
	},

    InitScoreSharing = function (self, textToShare)
		local shouldShowShareScoreButton = SOCIAL_MGR_IsAvailable() and IsString(textToShare) and string.len(textToShare) > 0
		--[[
		logprintf("InitScoreSharing: should show=%s, is avail=%s, textToShare=%s\n",
			tostring(shouldShowShareScoreButton),
			tostring(SOCIAL_MGR_IsAvailable()),
			tostring(textToShare))
		--]]
		if shouldShowShareScoreButton then
			self.ButtonCollection.shareScoreButton.textToShare = textToShare
			self.ButtonCollection.shareScoreButton.visible = true
			--self.menuButton.alignmentOffset = {0, Large_Dialog_Button_Y + 5}
			--self.playAgainButton.alignmentOffset = {-89, Large_Dialog_Button_Y + 5}
		end
	end,

	OnPostSpawn = function (self)
		if self.ButtonCollection then
			--if self.ButtonCollection.RetryButton then
			--	self.ButtonCollection.RetryButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			--end
			if self.ButtonCollection.PlayAgainButton then
				self.ButtonCollection.PlayAgainButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.ButtonCollection.shareScoreButton then
				self.ButtonCollection.shareScoreButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
            --[[
			if self.ButtonCollection.ChallengeFriendsButton then
                self.ButtonCollection.ChallengeFriendsButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
            --]]
			if self.ButtonCollection.okayButton then
				self.ButtonCollection.okayButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
		end
	end,
}

Resources.GoalLabel = Resources.AppDialogSmallLabel:new {
	resource = "AppDialogSmallLabel",
}

Resources.Star = Resources.Actor:new {
	resource = "Actor",
	image = "StarSmall.png",
	size = {30,30},
	resizeOnSetImage = false,
	alignment = TopLeft,
}

Resources.StarButton = Resources.Button:new {
	resource = "Button",
	image = "StarSmall_off.png",
	size = {20,20},
	resizeOnSetImage = false,
	alignment = TopRight,
	alignTo = TopRight,
	useFrames = false,
}

Resources.SmileyButton = Resources.Button:new {
	resource = "Button",
	image = "Smiley3_off.png",
	alignment = TopRight,
	alignTo = TopRight,
	useFrames = false,
}

Resources.StartQuestGameDialogLabel = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	text = STRINGS(""),
	alignment = MidTop                         ,
	alignTo = MidTop,
	alignmentOffset = {0,0},
	fgColor = "Cascade_DarkBrown",
	font = Resources.DialogFont:new {resource = "DialogFont",fontSize = 18,},
}

Resources.StartQuestGameDialogBoldLabel = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	text = STRINGS(""),
	alignment = MidTop,
	alignTo = MidTop,
	alignmentOffset = {0,0},
	fgColor = "Cascade_DarkBrown",
	--highlightColor = "Black",
	--highlightAlpha = 50,
	--shadowColor = "Cascade_White",
	--shadowAlpha = 50,
	font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 20,},
}

Resources.StartQuestGameDialogTitleLabel = Resources.AppTitleDialogLabel:new {
	resource = "AppTitleDialogLabel",
	alignment = MidTop,
	alignTo = MidTop,
	alignmentOffset = {0,0},
	font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 30,},
}


local dialogWidth = 313

local startQuestGamePowerupGoalX_offset = 35
local startQuestGamePowerupGoalY_offset = 10

Resources.PowerupButton = Resources.DialogButton:new {
	resource = "DialogButton",
	image = "Boost_LuckyWilds.png",
	alignment = MidTop,
	alignTo = MidTop,
	useFrames = false,
	size = {20,20},
	resizeOnSetImage = false,
	alpha = 255,
}

Resources.LevelNamePanel = Resources.Actor:new {
	resource = "Actor",
	color = "White",
	size = {dialogWidth,70},
	alpha = 0,
	alignment = MidTop,
	alignTo = MidTop,

	LevelName = Resources.StartQuestGameDialogTitleLabel:new {
		resource = "StartQuestGameDialogTitleLabel",
		text = STRINGS("Good Level Name"),
		alignmentOffset = {0,16},
		widthLimit = 180,
	},

	LevelInfo = Resources.StartQuestGameDialogLabel:new {
		resource = "StartQuestGameDialogLabel",
		text = STRINGS("Level Info"),
		alignmentOffset = {0,55},
		visible = false,
	},

	Powerup7 = Resources.PowerupButton:new {
		resource = "PowerupButton",
		alignmentOffset = {-startQuestGamePowerupGoalX_offset*3,14+startQuestGamePowerupGoalY_offset*2},
		visible = false,
	},
	Powerup5 = Resources.PowerupButton:new {
		resource = "PowerupButton",
		alignmentOffset = {-startQuestGamePowerupGoalX_offset*2,14+startQuestGamePowerupGoalY_offset*2},
		visible = false,
	},
	Powerup3 = Resources.PowerupButton:new {
		resource = "PowerupButton",
		alignmentOffset = {-startQuestGamePowerupGoalX_offset*1,14+startQuestGamePowerupGoalY_offset*2},
		visible = false,
	},
	Powerup1 = Resources.PowerupButton:new {
		resource = "PowerupButton",
		alignmentOffset = {-startQuestGamePowerupGoalX_offset*0,14+startQuestGamePowerupGoalY_offset*2},
		visible = false,
	},
	Powerup2 = Resources.PowerupButton:new {
		resource = "PowerupButton",
		alignmentOffset = {startQuestGamePowerupGoalX_offset*1,14+startQuestGamePowerupGoalY_offset*2},
		visible = false,
	},
	Powerup4 = Resources.PowerupButton:new {
		resource = "PowerupButton",
		alignmentOffset = {startQuestGamePowerupGoalX_offset*2,14+startQuestGamePowerupGoalY_offset*2},
		visible = false,
	},
	Powerup6 = Resources.PowerupButton:new {
		resource = "PowerupButton",
		alignmentOffset = {startQuestGamePowerupGoalX_offset*3,14+startQuestGamePowerupGoalY_offset*2},
		visible = false,
	},
}

--Debug_ChallengeTopScoresArea = true

Resources.TopTenPlayer = Resources.Actor:new {
	resource = "Actor",
	size = {90,90},
	color = "White",
	alpha = 0,

	Leaderboard_Panel = Resources.Actor:new {
		resource = "Actor",
		image = "TopTenPlayer_Panel_1.png",
		alignment = "Center",
		alignTo = "Center",
		zorder = -1,
		OnPostSpawn = function (self)
			--logprint("OnPostSpawn "..self.name)
			self.image = "TopTenPlayer_Panel_"..math.random(1,3)..".png"
		end,
	},

	Picture = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		image = "PlayerPic_Empty.png",
		defaultImage = "PlayerPic_Empty.png",
		alignment = "TopRight",
		alignTo = "TopRight",
		alignmentOffset = {-4,2}, --{-2,2},
		size = {40, 40},
		resizeOnSetImage = false,
		PlayerFrame = Resources.Actor:new {
			image = "PlayerFrame.png",
			size = {40, 40},
			alignment = "Center",
			alignTo = "Center",
			zorder = 1,
		},
	},
	MailButton = Resources.DialogButton:new {
		resource = "DialogButton",
		image = "MailIcon_heart.png",
		useFrames = false,
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,-16},
		size = {34, 34},
		giftButtonController = Resources.GiftButtonController:new {
			resource = "GiftButtonController",
			OnPostSpawn = function (self)
				self:InitGiftButtonController()
			end,
			OnGiftClick = function (self)
				Gifting_TrySendingFreeLife(self.raveUserId or "")
			end,
		},
		hasGiftedRecently = Resources.Actor:new {
			resource = "Actor",
			image = "Check.png",
			alignment = "Center",
			size = {32, 32},
			visible = false,
		},
	},
	Rank = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		font = {
			resource = "DialogLabelFont",
			fontSize = 24,
		},
		alignment = "TopLeft",
		alignTo = "TopLeft",
		text = STRINGS("1"),
		alignmentOffset = {2,-8},
		widthLimit = 20,
		Friend_number1 = Resources.Actor:new {
			resource = "Actor",
			image = "Friend_number3.png",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {1,9},
			zorder = -1,
			visible = true,
		},
	},
	Name = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Player"),
		widthLimit = 82,
		alignment = "Center",
		alignTo = "MidBottom",
		alignmentOffset = {0,-34},
		heightLimit = 36,
		lineSpacing = 4,
		--fgColor = "Cascade_White",
		--shadowColor = "Cascade_Black",
		--shadowAlpha = 200,
		--highlightColor = "Cascade_Black",
		--highlightAlpha = 200,
	},
    --[[ Original Score Font
    	Score = Resources.AppDialogSmallLabel:new {
		resource = "DialogLabelFont",
		text = STRINGS("100,000"),
		widthLimit = 82,
		alignment = "MidBottom",
		alignTo = "MidBottom",
		alignmentOffset = {0,-6},
		alpha = 255,
		zorder = 5,
        font	= Resources.DialogFont:new{
            resource = "DialogFont",
            fontSize = Layout{16,iphone5=18,ipad=18},
        },
    --]]
	Score = Resources.AppDialogSmallLabel:new {
        resource = "AppTitleDialogLabel_small",
        fontSize = 25,
		text = STRINGS("100,000"),
		widthLimit = 82,
		alignment = "MidBottom",
		alignTo = "MidBottom",
		alignmentOffset = {0,-2},
		alpha = 255,
		zorder = 5,
	},

	ClearValues = function (self)
		--logprint("In ClearValues "..self.name)
		self.MailButton.giftButtonController:ClearLeaderboardData()

	end,

	SetValues = function (self, values)
		--logprintf("TopTenPlayer: SetValues: %s\n", SerializeToString(values))

        self.visible = true
        self.MailButton.giftButtonController:UpdateWithLeaderboardData(values)
		self.Name.text = values.playerName or ""
		self.Score.text = (values.gameScore and Int2Comma(values.gameScore)) or ""
		self.Rank.text = (values.scoreRowNumber and Int2Comma(values.scoreRowNumber)) or ""
		self.Picture:SetPhotoName(values.playerPhoto)

		--NOTE: Sort of a hack
		if(self.screen)then
			local topScoresScrollableArea = self.screen:FindChild("TopScoresScrollableArea",true)

			if(topScoresScrollableArea.ListType == "TopTeamsButton" and self.Name.text ~= "") then
				self.Name.text = STRINGS("Team ") .. ExtractFirstName(self.Name.text)
			end
		end
	end,
}

Resources.InviteFriendsPanel = Resources.Actor:new {
    class = "Actor",
	resources = {"Actor", "FacebookConnectDecorator"},
	size = {90,90},
	color = "White",
	alpha = 0,
	visibleWhenConnected = true,
	visibleWhenDisconnected = false,
	visible = false,
	raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
	isConnectUI = true,

	Leaderboard_Panel = Resources.Actor:new {
		resource = "Actor",
		image = "TopTenPlayer_Panel_1.png",
		alignment = "Center",
		alignTo = "Center",
		zorder = -1,
	},
	Text = Resources.AppDialogSmallLabel:new {
		--resource = "DialogLabelFont",
        resource = "AppTitleDialogLabel_small",
        fontSize = 30,
        text = STRINGS("More Players!"),
		widthLimit = 82,
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0,7},
	},
	InviteFriendsButton = Resources.DialogButton:new {
		resource = "DialogButton",
		text = STRINGS("Invite"),
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0,43},
	},

	OnPostSpawn = function (self)
		Resources.FacebookConnectDecorator.InitFacebookConnect(self)
	end,
}

Resources.TopTenPlayer_number1 = Resources.TopTenPlayer:new {
	resource = "TopTenPlayer",
	Rank =  {
		class = "Label",
		Friend_number1 = {
			class = "Actor",
			image = "Friend_number1.png",
		},
	},
}

Resources.TopTenPlayer_number2 = Resources.TopTenPlayer:new {
	resource = "TopTenPlayer",
	Rank =  {
		class = "Label",
		Friend_number1 = {
			class = "Actor",
			image = "Friend_number2.png",
		},
	},
}

Resources.TopScoresScrollableArea = Resources.Actor:new {
	resource = "Actor",
	class = "TopScoresScrollableArea",
	size = {dialogWidth,124},

	SlowFraction = .98,           --NOTE: adding scroll velocity to this caused an engine crash in the past. This crash may have been fixed by David L. within the engine
	stoppingVelocity = 2,

	topScoreViewManager = Resources.TopScoreViewManager:new {
		class = "TopScoreViewManager",
		titleActorName = "",
		prevButtonName = "",
		nextButtonName = "",
		rowNameFormat = "Player%d",

		OnRefreshScores = function (self)
			--logprint("OnRefreshScores\n")
			local numScores = (self.currentList and self.currentList.count) or 0
			if (self.dialog ~= nil and self.parent ~= nil and IsFunction(self.parent.SetNumVisibleScores)) then
				self.parent:SetNumVisibleScores(numScores)
			end


            if (self.dialog ~= nil and IsFunction(self.dialog.SetNumVisibleScores)) then
                self.dialog:SetNumVisibleScores(numScores)
            else
                --logprint("No Dialog SetNumVisibleScores!\n")
            end
		end,
	},

	No1Button = Resources.AppSmallMenuButton:new {
		resource = "AppSmallMenuButton",
		image = "SquareButton.png",
		alignment = Layout{"BottomLeft",ipad="BottomLeft"},
		alignTo = Layout{"TopLeft",ipad="TopLeft"},
		alignmentOffset = Layout{{2,14},ipad={-30,14}},
		text = STRINGS("1"),
		enterKey = true,
		shortcutKey = "o",
		zorder = 100,
		alpha = 255,
		textWidthLimit = 20,
	},

	MeButton = Resources.AppSmallMenuButton:new {
		resource = "AppSmallMenuButton",
		image = "SquareButton.png",
		alignment = BottomRight,
		alignTo = "TopRight",
		alignmentOffset = Layout{{-2,12},ipad={30,12}},
		text = STRINGS("Me"),
		enterKey = true,
		shortcutKey = "o",
		zorder = 100,
		alpha = 255,
		textWidthLimit = 20,
	},

	ScrollableArea = Resources.Actor:new {
		resource = "Actor",
		class = "ScrollableArea",
		DisplayDimensions = {dialogWidth,124},
		color = "White",
		alpha = 0,
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,10},
		verticalScrollLocked = true,
		scrollableBackground = Resources.Actor:new {
			resource = "Actor",
			Player1 = Resources.TopTenPlayer_number1:new {
				resource = "TopTenPlayer_number1",
				alignmentOffset = {140,12},
			},
			Player2 = Resources.TopTenPlayer_number2:new {
				resource = "TopTenPlayer_number2",
				alignmentOffset = {240,12},
			},
			AddFriendsPanel = Resources.InviteFriendsPanel:new {
				resource = "InviteFriendsPanel",
				visibleWhenConnected = true,
				visibleWhenDisconnected = false,
			},
			EndBuffer = Resources.Actor:new {
				resource = "Actor",
				size = {50, 50},
				alignmentOffset = {1195,12},
			},
		},
	},
}

Resources.MyTeamPlayer = Resources.TopTenPlayer:new {
	resource = "TopTenPlayer",
	extraScale = {0.55, 0.55},

	PlusButton = Resources.AppButton:new {
		resource = "AppButton",
		image = "Btn_Plus.png",
		alignment = Center,
		alignTo = Center,
	},


	Picture =  {
		class = "Actor",
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,0},
		size = {40*2, 40*2},
		PlayerFrame = {
			class = "Actor",
			size = {40*2, 40*2},
			alignment = "Center",
			alignTo = "Center",
			zorder = 1,
		},
	},

	MailButton =  {
		class = "Button",
		alignment = "TopRight",
		alignTo = "TopRight",
		alignmentOffset = {4,-8},
		visible = false,
	},
}

Resources.PlusLabel = Resources.AppDialogLabel:new {
	resource = "AppDialogLabel",
	text = STRINGS("+"),
	alignment = "TopLeft",
	alignTo = "TopLeft",
	zorder = 25,
}

Resources.MyTeamScoreArea = Resources.Actor:new {
	resource = "Actor",

	class = "MyTeamScoreArea",
	size = {384,124},

	TeamScore = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0, 30},
		text = STRINGS("My Team Score: a bajillion"),
		zorder = 20,
	},

	Plus1 = Resources.PlusLabel:new {
		resource = "PlusLabel",
		alignmentOffset = {58, 34},
	},
	Plus2 = Resources.PlusLabel:new {
		resource = "PlusLabel",
		alignmentOffset = {121, 34},
	},
	Plus3 = Resources.PlusLabel:new {
		resource = "PlusLabel",
		alignmentOffset = {183, 34},
	},
	Plus4 = Resources.PlusLabel:new {
		resource = "PlusLabel",
		alignmentOffset = {245, 34},
	},

	topScoreViewManager = Resources.TopScoreViewManager:new {
		class = "TopScoreViewManager",
		titleActorName = "",
		prevButtonName = "",
		nextButtonName = "",
		rowNameFormat = "Player%d",

		OnRefreshScores = function (self)
			--logprint("OnRefreshScores\n")
			local numScores = (self.currentList and self.currentList.count) or 0
			if (self.dialog ~= nil and self.parent ~= nil and IsFunction(self.parent.SetNumVisibleScores)) then
				self.parent:SetNumVisibleScores(numScores)
			end
		end,
	},

	IndividualScoresArea = Resources.Actor:new {
		resource = "Actor",
		size = {384,124},
		color = "White",
		alpha = 0,
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {16, 5},

		Player1 = Resources.MyTeamPlayer:new {
			resource = "MyTeamPlayer",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {8, 0},

			zorder = 3,
			visible = true,
		},

		Player2 = Resources.MyTeamPlayer:new {
			resource = "MyTeamPlayer",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {71, 0},
			zorder = 3,
			visible = true,
		},
		Player3 = Resources.MyTeamPlayer:new {
			resource = "MyTeamPlayer",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {133, 0},
			zorder = 3,
			visible = true,
		},
		Player4 = Resources.MyTeamPlayer:new {
			resource = "MyTeamPlayer",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {195, 0},
			zorder = 3,
			visible = true,
		},
		Player5 = Resources.MyTeamPlayer:new {
			resource = "MyTeamPlayer",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {258, 0},
			zorder = 3,
			visible = true,
		},
	},
}

Resources.FacebookConnectArea = Resources.Actor:new {
	resource = "Actor",
	alignment = "MidTop",
	zorder = 30,
	facebookConnectInfo = Resources.DialogLabel:new {
		resources = {"DialogLabel", "FacebookConnectDecorator"},
		font = Resources.DialogFont:new {
			resource = "DialogBoldFont",
			fontSize = 20,
		},
		--text = STRINGS("Join your friends playing Cascade!\nConnect to Cascade!"),
        text = STRINGS("Join your friends playing Cascade!"),
		decoratorCanChangeText = false,
		raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
		isConnectUI = true,
		alignment = "MidTop",
		alignmentOffset = {0,30},
		fgColor = "Cascade_DarkBrown",
		zorder = 1,
            highlightColor = "Cascade_DarkBrown",
            highlightAlpha = 60,
            highlightOffset = {-1,-1},
            shadowColor = "White",
            shadowOffset = {1,1},
            shadowAlpha = 155,
            widthLimit = 320,

		OnPostSpawn = function (self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
			-- TESTTOPTENPLAYERLAYOUT
			if(Debug_ChallengeTopScoresArea)then
				self.visible = false
			end
		end,
	},

	facebookConnectButton = Resources.AppButtonMedium:new {
		resources = {"AppButtonMedium", "FacebookConnectDecorator"},
        extraScale = 1.2,
		text = STRINGS("Connect"),
		textWidthLimit = 100,
		textAlignmentOffset = {14, 0},
		textDisabledColor = "#383838",
		alignment = "MidTop",
		alignmentOffset = {0,60},
		zorder = 1,
		analyticsTag = "scoreboard",
		raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
		isConnectUI = true,

		OnPostSpawn = function (self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
			-- TESTTOPTENPLAYERLAYOUT
			if(Debug_ChallengeTopScoresArea)then
				self.visible = false
			end
		end,

		facebookIcon = Resources.Actor:new {
			resource = "Actor",
			image = "Facebook_Logo_small.png",
			alignment = "MidLeft",
			alignmentOffset = {18, 0},
		},
	},
}

Resources.TopTenPanel = Resources.Actor:new {
	resource = "Actor",
	size = {dialogWidth,107},
	color = "White",
	alpha = 0,
	alignment = Layout{"MidBottom", android = "MidBottom"},
	alignTo = Layout{"MidBottom", android = "MidBottom"},
	alignmentOffset = Layout{{0,20 + headerOffset/2}, ipad = {0,20 + headerOffset/2}, iphone5={0,70 + headerOffset/2}, android = {0, 90 + headerOffset/2}},
	-- NOTE: This is no put into position via the Script so it always stays at bottom of screen

	Panel = Resources.Actor:new {
		resource = "Actor",
		image = "Leaderboard_Panel.png",
		alignment = "Center",
		alignTo = "Center",
		zorder = -1,
	},

	Scores = Resources.Actor:new {
		resources = {"Actor", "FacebookConnectDecorator"},

		visibleWhenConnected = true,
		visibleWhenDisconnected = false,
		raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
		isConnectUI = true,

		OnPostSpawn = function (self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
		end,

		TopScoresScrollableArea = Resources.TopScoresScrollableArea:new {
			resource = "TopScoresScrollableArea",
			size = {dialogWidth,124},
		},
	},

	TopTen = Resources.StartQuestGameDialogLabel:new {
		resource = "StartQuestGameDialogLabel",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		text = STRINGS("Top Scores"),
		textWidthLimit = 70,
		font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 18,	},
		alignmentOffset = {5,6},
		visible = false,
	},

	ClearValues = function (self)
		--logprintf("TopTenPanel: ClearValues\n");
		--self.visible = false
	end,

	SetValues = function (self, values)
		--logprintf("TopTenPanel: SetValues: %s\n\n\n\n", SerializeToString(values))
		--self.visible = true
	end,

	facebookConnectArea = Resources.FacebookConnectArea:new {
		resource = "FacebookConnectArea",
	},
}

Scripts.TopTenPanel_change = function(self)
	PlaySound("CLEEP_B_d7.ogg")
end

Resources.TopScoresButton = Resources.AppSmallMenuButton:new {
	resource = "AppSmallMenuButton",
	image = "Leaderboard_Button_Tab_blue.png",
	alignment = MidBottom,
	alignTo = MidTop,
	alignmentOffset = {-90,21-3},
	text = STRINGS("Top Scores"),
	textWidthLimit = 70,
	textAlignmentOffset = {0,-2},
	useFrames = false,
	zorder = 0,
	textDisabledColor = "Cascade_DarkBrown",
	selectedProperties = {
		image = "Leaderboard_Button_Tab_blue.png",
		zorder = 0,
		alignmentOffset = {-90,21-3},
		active = false,
	},
	deselectedProperties = {
		image = "Leaderboard_Button_Tab_blue.png",
		zorder = -2,
		alignmentOffset = {-90,23-3},
		active = true,
	},
}

Resources.MyTeamButton = Resources.AppSmallMenuButton:new {
	resource = "AppSmallMenuButton",
	image = "Leaderboard_Button_Tab_green.png",
	alignment = MidBottom,
	alignTo = MidTop,
	alignmentOffset = {0,21},
	text = STRINGS("My Team"),
	textAlignmentOffset = {0,2},
	alpha = 255,
	useFrames = false,
	zorder = -2,
	textDisabledColor = "Cascade_DarkBrown",
	textWidthLimit = 70,
	selectedProperties = {
		image = "Leaderboard_Button_Tab_green.png",
		zorder = 0,
		alignmentOffset = {0,18},
		rolloverable = false,
	},
	deselectedProperties = {
		image = "Leaderboard_Button_Tab_green.png",
		zorder = -2,
		alignmentOffset = {0,21},
		rolloverable = true,
	},
}

Resources.TopTeamsButton = Resources.AppSmallMenuButton:new {
	resource = "AppSmallMenuButton",
	color = "White",
	image = "Leaderboard_Button_Tab_red.png",
	alignment = MidBottom,
	alignTo = MidTop,
	alignmentOffset = {90,21},
	text = STRINGS("Top Teams"),
	textWidthLimit = 70,
	textAlignmentOffset = {0,2},
	useFrames = false,
	zorder = -2,
	textDisabledColor = "Cascade_DarkBrown",
	selectedProperties = {
		image = "Leaderboard_Button_Tab_red.png",
		zorder = 0,
		alignmentOffset = {90,20},
		active = false,
		ListType == "TopTeamsButton",
	},
	deselectedProperties = {
		image = "Leaderboard_Button_Tab_red.png",
		zorder = -2,
		alignmentOffset = {90,21},
		active = true,
		ListType == "",
	},
}

Resources.TopTenPanel_Challenge = Resources.Actor:new {
	resource = "Actor",
	size = {dialogWidth,107},
	color = "White",
	alpha = 0,
	alignment = Layout{"MidTop", android = "MidBottom"},
	alignTo = Layout{"MidTop", android = "MidBottom"},
	alignmentOffset = Layout{{0,334 + (headerOffset/2)}, android = {0, 20}, ipad = {0,364}, iphone5={0,392},android = {0, 90 + headerOffset/2}},
	zorder = 20,
	-- NOTE: This is no put into position via the Script so it always stays at bottom of screen

	TopTen = Resources.StartQuestGameDialogLabel:new {
		resource = "StartQuestGameDialogLabel",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		text = STRINGS("Top Scores"),
		textWidthLimit = 70,
		font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 18,	},
		alignmentOffset = {5,6},
		visible = false,
	},

	ChallengeTopScoresArea = Resources.Actor:new {
		resource = "Actor",
		class  = "ChallengeTopScoresArea",
		size = {dialogWidth,124},
		zorder = 20,

		TopScoresButton = Resources.TopScoresButton:new {
			resource = "TopScoresButton",
		},

		MyTeamButton = Resources.MyTeamButton:new {
			resource = "MyTeamButton",
		},

		TopTeamsButton = Resources.TopTeamsButton:new {
			resource = "TopTeamsButton",
		},

		Panel = Resources.Actor:new {
			resource = "Actor",
			image = "Leaderboard_Panel_Blue.png",
			alignment = "Center",
			alignTo = "Center",
			zorder = -1,
		},

		Scores = Resources.Actor:new {
			resources = {"Actor", "FacebookConnectDecorator"},
			zorder = 30,
			visibleWhenConnected = true,
			visibleWhenDisconnected = false,
			raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
			isConnectUI = true,

			OnPostSpawn = function (self)
				Resources.FacebookConnectDecorator.InitFacebookConnect(self)
			end,

			TopScoresScrollableArea = Resources.TopScoresScrollableArea:new {
				resource = "TopScoresScrollableArea",
				size = {dialogWidth,124},
			},
			MyTeamScoreArea = Resources.MyTeamScoreArea:new {
				resource = "MyTeamScoreArea",
				size = {dialogWidth,124},
				alignmentOffset = {100, 0},
				visible = false,
			},
		},
	},

	ClearValues = function (self)
		--logprintf("TopTenPanel: ClearValues\n");
		--self.visible = false
	end,

	SetValues = function (self, values)
		--logprintf("TopTenPanel: SetValues: %s\n\n\n\n", SerializeToString(values))
		--self.visible = true
	end,

	-- Disable Facebook connect UI in order to debug score layout on Windows
	facebookConnectArea = Resources.FacebookConnectArea:new {
		resource = "FacebookConnectArea",
	},
}

local startQuestGameOptionsY = 170
local startQuestGameFirstLineY = 252
local startQuestGameLineSeparation = 36
local startQuestGameLeftAlignment = 15
local startQuestGameRightAlignment = 20
local startQuestGameLeftWidthLimit = 154
local startQuestGameRightWidthLimit = 116

local startQuestGameGoalY = 0
local startQuestGameGoalY_offset = 30

local startQuestGameStarGoalY = 16
local startQuestGameStarGoalY_offset = -11
local startQuestGameStarGoalX_offset = 86


Resources.StarBig = Resources.DialogButton:new {
	resource = "DialogButton",
	alignment = "MidTop",
	alignTo = "MidTop",
	image = "StarBig.png",
	zorder = 2,
	useFrames = false,
	alpha = 255,
}

Resources.StarGoal = Resources.Actor:new {
	resource = "Actor",
	color = "White",
	alpha = 0,
	alignment = MidTop,
	alignTo = MidTop,
	useFrames = false,

	Text = Resources.DialogLabel:new {
		resource = "DialogLabel",
		alignment = TopLeft,
		alignTo = TopLeft,
		alignmentOffset = {40,0},
		font = Resources.DialogFont:new {
			resource = "DialogFont",
			fontSize = 24,
		},
		visible = false,
	},

	Star = Resources.StarBig:new {
		resource = "StarBig",
	},
	FlyingStar = Resources.StarBig:new {
		resource = "StarBig",
		visible = false,
		zorder = 3,
	},
}

Resources.StarWorker = Resources.Actor:new {
	resource = "Actor",
	alignment = Center,
	alignment = BottomRight,
	alignmentOffset = {0,7},
	visible = false,
	zorder = 15,
	size = {70/2,76/2},
	resizeOnSetImage = false,
}

Resources.StarGold = Resources.Actor:new {
	resource = "Actor",
	alignment = MidTop,
	visible = false,
	alignment = "MidTop",
	alignTo = "MidTop",
	alignmentOffset = {0,5},
	zorder = 4,
}

Resources.StarQuickQuestPiece = Resources.Actor:new {
    resource = "Actor",
    visible = false,
    zorder = 5,
    layer = 2500,
    alignment = "MidTop",
    --extraScale = 0.45,

    scripts = {"QuickQuestMapIconGroove"},
    useFrames = false,
    rotationPoint = MidBottom,
    scalingPoint = MidBottom,

    Piece = Resources.Actor:new {
        alignment = Center,
        alignmentOffset = {0,5},
        zorder = 5,

        OnPostSpawn = function (self)
            self.image = QQ_MGR:GetImagePath(false,0.45)
        end,
    },
}

Resources.GoalPanel = Resources.Actor:new {
	resource = "Actor",
	color = "White",
	alpha = 0,
    extraScale = 0.95,
	size = {dialogWidth,130},
	alignment = MidTop,
	alignTo = MidTop,
	alignmentOffset = {0,50},

    ObjectiveBanner = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_LevelLaunchAndEnd_Banner.png",
        alignment = "MidTop",
        alignTo = "MidBottom",
        alignmentOffset = {-3,-29},
        zorder = -1,
        extraScale = 1.05, --Counter scale of parent -_-
    },

	StarGoal1 = Resources.StarGoal:new {
		resource = "StarGoal",
		Text = {class="Label",text = STRINGS("50,000")},
		alignmentOffset = {0+(startQuestGameStarGoalX_offset*-1),startQuestGameStarGoalY+(startQuestGameStarGoalY_offset*0)},

		Star = {
			class = "Button",
			Worker = Resources.StarWorker:new {
				resource = "StarWorker",
			},
            QuickQuestPiece = Resources.StarQuickQuestPiece:new {
                resource = "StarQuickQuestPiece",
            },
		},
		Gold = Resources.StarGold:new {
			resource = "StarGold",
			image = "Gold_1bar.png",
		},
	},
	StarGoal2 = Resources.StarGoal:new {
		resource = "StarGoal",
		Text = {class="Label",text = STRINGS("75,000")},
		alignmentOffset = {0+(startQuestGameStarGoalX_offset*0)+1,startQuestGameStarGoalY+(startQuestGameStarGoalY_offset*1)},

		Star = {
			class = "Button",
			Worker = Resources.StarWorker:new {
				resource = "StarWorker",
			},
            QuickQuestPiece = Resources.StarQuickQuestPiece:new {
                resource = "StarQuickQuestPiece",
            },
		},
		Gold = Resources.StarGold:new {
			resource = "StarGold",
			image = "Gold_3bars.png",
		},
	},
	StarGoal3 = Resources.StarGoal:new {
		resource = "StarGoal",
		Text = {class="Label",text = STRINGS("100,000")},
		alignmentOffset = {0+(startQuestGameStarGoalX_offset*1),startQuestGameStarGoalY+(startQuestGameStarGoalY_offset*0)},

		Star = {
			class = "Button",
			Worker = Resources.StarWorker:new {
				resource = "StarWorker",
			},
            QuickQuestPiece = Resources.StarQuickQuestPiece:new {
                resource = "StarQuickQuestPiece",
            },
		},
		Gold = Resources.StarGold:new {
			resource = "StarGold",
			image = "Gold_5bars.png",
		},
	},

	LevelObjective = Resources.StartQuestGameDialogLabel:new {
		resource = "StartQuestGameDialogLabel",
		text = STRINGS("Level Objective"),
        font = Resources.DialogTitleFont:new {
            resource = "DialogTitleFont",
            fontSize = 24,
        },
        alignmentOffset = {0,108},
		widthLimit = 250,
		fgColor = "White",
		--highlightColor = "Black",
		--highlightAlpha = 50,
		shadowColor = "Black",
		shadowAlpha = 100,
        shadowOffset = {2,2},
		Check = Resources.Actor:new {
			resource = "Actor",
			image = "Check_small.png",
			alignment = MidLeft,
			alignTo = MidRight,
			alignmentOffset = {0,-2},
			zorder = 10,
			visible = false,
		},
		X = Resources.Actor:new {
			resource = "Actor",
			image = "X.png",
			alignment = MidLeft,
			alignTo = MidRight,
			alignmentOffset = {0,0},
			zorder = 10,
			extraScale = 0.75,
			visible = false,
		},
	},

	LevelObjective2 = Resources.StartQuestGameDialogLabel:new {
		resource = "StartQuestGameDialogLabel",
		text = STRINGS(""),
		--font = Resources.DialogFont:new {resource = "DialogFont",fontSize = 22,},
        font = Resources.DialogTitleFont:new {
            resource = "DialogTitleFont",
            fontSize = 22,
        },
        shadowColor = "Black",
		shadowAlpha = 100,
        shadowOffset = {2,2},
		alignmentOffset = {0,133},
		widthLimit = 168,
		fgColor = "White",
		--highlightColor = "Black",
		--highlightAlpha = 50,
		--shadowColor = "Cascade_White",
		--shadowAlpha = 50,
		Check = Resources.Actor:new {
			resource = "Actor",
			image = "Check_small.png",
			alignment = MidLeft,
			alignTo = MidRight,
			alignmentOffset = {0,-2},
			zorder = 10,
			visible = false,
		},
		X = Resources.Actor:new {
			resource = "Actor",
			image = "X.png",
			alignment = MidLeft,
			alignTo = MidRight,
			alignmentOffset = {0,0},
			zorder = 10,
			extraScale = 0.75,
			visible = false,
		},
	},

	Requirement = Resources.Actor:new {
		resource = "Actor",
		alignment = MidTop,
		alignmentOffset = {0,125},
		Text = Resources.StartQuestGameDialogLabel:new {
			resource = "StartQuestGameDialogLabel",
			fgColor = "Cascade_DarkBrown",
			font = Resources.DialogFont:new {resource = "DialogFont",fontSize = 16,	},
			--highlightColor = "Black",
			--highlightAlpha = 50,
			--shadowColor = "Cascade_White",
			--shadowAlpha = 50,
		},
	},
}

Resources.DialogCharacter= Resources.Actor:new {
	resource = "Actor",
	image = "Character_Explorer.png",
	alignment = Center,
	alignTo = TopLeft,
	alignmentOffset = {40,40},
	zorder = 1,
	--scripts = {"Bop"},
	--rotationAngle = { degrees = -10 },
	visible = false,
	--size = {72,72},
	--scripts = {"DialogButtonGroove"},
	Radio = Resources.Actor:new {
		resource = "Actor",
		image = "Boombox.png",
		alignment = "TopRight",
		alignmentOffset = {16,16},
		zorder = -1,
		extraScale = 0.5,
	},
}

Resources.ExtraImage = Resources.Actor:new{
	resource = "Actor",
	image = "",
	zorder = 2,
	visible = true,

	alignment = Center,
	alignTo = Center,
	alignmentOffset = {0,0},
}

--Level End Dialog (Summarizes the end of the game)
Resources.CascadeEndGameDialog_Level = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    title = "",
    class = "CascadeEndGameDialog",
    name = "CascadeEndGameDialog",
    enableVisibleUnderlay = true,
	alpha = 0,

	introScriptName = "SlideOnTwoPanelsDialog_TopBar",
	dialogExitScriptName = "SlideOffTwoPanelsDialog_TopBar",

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogGeneric_Small.png",
		zorder = 11,
		alignment = "Center",
        alignmentOffset = {0,-35},
        extraScale = 0.95,

        DialogInsert = Resources.Actor:new {
            resource = "Actor",
            image = "Dialog_Filler_A.png",
            alignment = "Center",
            alignmentOffset = {0,-5},
        },

		DialogCharacter = Resources.DialogCharacter:new {
			resource = "DialogCharacter",
			zorder = 1,
		},

        LevelNumberPanel = Resources.Actor:new {
            resource = "Actor",
            -- scripts = {"JelloLoop"},
            zorder = 10,
            alignment = TopLeft,
            alignmentOffset = {17,9},
            size = {48,48},

            SpecialGemFlag = Resources.Actor:new {
                resource = "Actor",
                image = "Dialog_SideFlag.png",
                alignment = "TopLeft",
                alignmentOffset = {-3,-8},
                zorder = -1,
            },

            LevelNumber = Resources.StartQuestGameDialogLabel:new {
                resource = "StartQuestGameDialogLabel",
                text = STRINGS("1234"),
                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 30,
                },
                textColor = "Cascade_White",
                shadowColor = "Black",
                shadowOffset = {1,2},
                shadowAlpha = 120,
                alignment = MidTop,
                alignTo = MidTop,
                alignmentOffset = {-5,-3},
				widthLimit = 40,
            },
        },

		LevelNamePanel = Resources.LevelNamePanel:new {
			resource = "LevelNamePanel",
			zorder = 2,
		},


		GoalPanel = Resources.GoalPanel:new {
			resource = "GoalPanel",
			zorder = 2,
		},

		--Score, front and center. Counts up from 0.
		scoreContainer = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidTop",
			alignmentOffset = {0,158+60},

			SetScore = function (self, score)
				self.score.text = string.format(STRINGS("EndGameDialog_ScoreFormat"), Int2Comma(score))
			end,

			score = Resources.StartQuestGameDialogBoldLabel:new {
				resource = "StartQuestGameDialogBoldLabel",
				text = STRINGS("Requirement:\nScore 45,000"),
				font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 36,	},
				bestStamp = Resources.BestStamp:new {
					resource = "BestStamp",
					visible = false,
				},
			},
		},

		--All level goals
		goalScoreContainer = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidTop",
			alignmentOffset = {0, 165-30-5+90},
			size = {260,200},

			mainGoalText = Resources.GoalLabel:new {
				resource = "GoalLabel",
				alignment = TopLeft,
				alignmentOffset = {0,0},
				text = STRINGS("MainGoal"),
			},
			mainProgressText = Resources.GoalLabel:new {
				resource = "GoalLabel",
				alignment = MidRight,
				alignTo = TopRight,
				alignmentOffset = {0,14},
				text = STRINGS("MainProg"),
				widthLimit = 140,
			},

			star1Icon = Resources.Star:new {
				resource = "Star",
				alignmentOffset = {-10, 1*endGameLineSeparation},
				visible = false,
			},
			star1GoalText = Resources.GoalLabel:new {
				resource = "GoalLabel",
				alignment = TopLeft,
				alignmentOffset = {20,1 * endGameLineSeparation},
				text = STRINGS("Star1Goal"),
				visible = false,
			},
			star1ProgressText = Resources.GoalLabel:new {
				resource = "GoalLabel",
				alignment = TopRight,
				alignmentOffset = {0,1 * endGameLineSeparation},
				text = STRINGS("Star1Prog"),
				visible = false,
			},

			star2Icon = Resources.Star:new {
				resource = "Star",
				alignmentOffset = {-10, 2*endGameLineSeparation},
				visible = false,
			},
			star2GoalText = Resources.GoalLabel:new {
				resource = "GoalLabel",
				alignment = TopLeft,
				alignmentOffset = {20,2 * endGameLineSeparation},
				text = STRINGS("Star2Goal"),
				visible = false,
			},
			star2ProgressText = Resources.GoalLabel:new {
				resource = "GoalLabel",
				alignment = TopRight,
				alignmentOffset = {0,2 * endGameLineSeparation},
				text = STRINGS("Star2Prog"),
				visible = false,
			},

			star3Icon = Resources.Star:new {
				resource = "Star",
				alignmentOffset = {-10, 3*endGameLineSeparation},
				visible = false,
			},
			star3GoalText = Resources.GoalLabel:new {
				resource = "GoalLabel",
				alignment = TopLeft,
				alignmentOffset = {20,3 * endGameLineSeparation},
				text = STRINGS("Star3Goal"),
				visible = false,
			},
			star3ProgressText = Resources.GoalLabel:new {
				resource = "GoalLabel",
				alignment = TopRight,
				alignmentOffset = {0,3 * endGameLineSeparation},
				text = STRINGS("Star3Prog"),
				visible = false,
			},

			check = Resources.Actor:new {
				resource = "Actor",
				image = "Check.png",
				alignment = TopRight,
				alignTo = TopRight,
				alignmentOffset = {20,-170},
				zorder = 10,
			},

			X = Resources.Actor:new {
				resource = "Actor",
				image = "X.png",
				alignment = TopRight,
				alignTo = TopRight,
				alignmentOffset = {-30,-198},
				zorder = 10,
				visible = false
			},

		},

		personalBestLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopLeft,
			alignTo = TopLeft,
			alignmentOffset = {40+20,endGameFirstLineY + 5 * endGameLineSeparation - 20},
			text = STRINGS("Challenge Best:"),
			widthLimit = 140,
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 22,
			},
		},

		personalBest = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopLeft,
			alignTo = TopLeft,
			alignmentOffset = {180 + 22,endGameFirstLineY + 5 * endGameLineSeparation - 20},
			text = STRINGS("100,000"),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 22,
			},
            widthLimit = 70,
			bestStamp = Resources.BestStamp:new {
				resource = "BestStamp",
				visible = false,
			},
		},

		rateLevel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0,45-8+65},
			text = STRINGS("Rate Level:"),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
			visible = false,
		},

		rateStar5 = Resources.StarButton:new {
			resource = "StarButton",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0+(20*2),65-8+65},
			rating = "5",
			visible = false,
		},
		rateStar4 = Resources.StarButton:new {
			resource = "StarButton",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0+(20*1),65-8+65},
			rating = "4",
			visible = false,
		},
		rateStar3 = Resources.StarButton:new {
			resource = "StarButton",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0-(20*0),65-8+65},
			rating = "3",
			visible = false,
		},
		rateStar2 = Resources.StarButton:new {
			resource = "StarButton",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0-(20*1),65-8+65},
			rating = "2",
			visible = false,
		},
		rateStar1 = Resources.StarButton:new {
			resource = "StarButton",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0-(20*2),65-8+65},
			rating = "1",
			visible = false,
		},

		ButtonCollection = Resources.EndGameDialogButtons:new {
			resource = "EndGameDialogButtons",
			alignment = "MidBottom",
			alignmentOffset = {0, 0},
			ChallengeFriendsButton = {
				class = "Button",
				disableUnlessGameCenterFeatures = {},
				visible = false,
			},
		},

		EndGameAdvice = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = Center,
			alignTo = MidBottom,
			alignmentOffset = Layout{{0,345},iphone5={0,20},ipad={0,20}}, --NOTE: 345 Turned off on iphone4 for now
			wrapLimit = 320,
			heightLimit = 70,
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 16,
			},
			text = STRINGS("This is some excessively wordy helpful advice that I will program in later. Blah blah blah blah."),
			centerWrap = true,
			fgColor = "White",
			visible = false, -- NOTE: Disabled as I put many tips in start level tip cutscenes
		},

		NextButton = Resources.EndGameDialogBigButton:new {
			resource = "EndGameDialogBigButton",
			image = "ButtonPlastic_Short_Green.png",
			text = STRINGS("Next"),
            font	= Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 40,
            },
			alignment = "MidBottom",
			alignmentOffset = {0, 0},
			textAlignmentOffset = {0,0},
			buttonClosesDialog = true,
			visible = false,
            textWidthLimit = 80,
		},

		MapButton_big = Resources.EndGameDialogBigButton:new {
			resource = "EndGameDialogBigButton",
			image = "ButtonPlastic_Short_Green.png",
			text = STRINGS("Next"),
            font	= Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 40,
            },
			alignment = "MidBottom",
			alignmentOffset = {0, 0},
			textAlignmentOffset = {0,0},
			buttonClosesDialog = true,
			visible = false,
            textWidthLimit = 80,
		},

		RetrySmallButton = Resources.DialogSmallerButton:new {
			resource = "DialogSmallerButton",
			image = "ButtonPlastic_Small_Orange.png",
			buttonClosesDialog = true,
			alignment = MidBottom,
			alignmentOffset = {-110,-12},
			text = STRINGS("Retry"),
			enterKey = true,
			escapeKey = true,
			shortcutKey = "o",
			zorder = 2,
			visible = false,
			textWidthLimit = 65,
		},

		RetryButton = Resources.EndGameDialogBigButton:new {
			resource = "EndGameDialogBigButton",
			image = "ButtonPlastic_Short_Green.png",
			text = STRINGS("Retry"),
            font	= Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 40,
            },
            alignment = "MidBottom",
			alignmentOffset = {0, 0},
			textAlignmentOffset = {0, 0},
			buttonClosesDialog = true,
			visible = false,
			scripts = {"DialogButtonGroove"},
			textWidthLimit = 115,
		},

		MapButton = Resources.DialogSmallerButton:new {
			resource = "DialogSmallerButton",
			image = "ButtonPlastic_Small_Orange.png",
			buttonClosesDialog = true,
			alignment = MidBottom,
			alignmentOffset = {-110,-12},
			text = STRINGS("Map"),
			enterKey = true,
			escapeKey = true,
			shortcutKey = "o",
			zorder = 2,
			visible = false,
		},
		CancelButton = Resources.CancelButton:new {
			resource = "CancelButton",
		},
	},

	TopTenPanel = Resources.TopTenPanel:new {
		resource = "TopTenPanel",
	},

    InitScoreSharing = function (self, textToShare)
		local shouldShowShareScoreButton = SOCIAL_MGR_IsAvailable() and IsString(textToShare) and string.len(textToShare) > 0
		--[[
		logprintf("InitScoreSharing: should show=%s, is avail=%s, textToShare=%s\n",
			tostring(shouldShowShareScoreButton),
			tostring(SOCIAL_MGR_IsAvailable()),
			tostring(textToShare))
		--]]
		if shouldShowShareScoreButton then
			self.MainPanel.ButtonCollection.shareScoreButton.textToShare = textToShare
			self.MainPanel.ButtonCollection.shareScoreButton.visible = true
		end
	end,

	OnPostSpawn = function (self)
		if self.MainPanel.ButtonCollection then
			if self.MainPanel.ButtonCollection.PlayAgainButton then
				self.MainPanel.ButtonCollection.PlayAgainButton.visible = false
			end
			if self.MainPanel.ButtonCollection.shareScoreButton then
				self.MainPanel.ButtonCollection.shareScoreButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.ButtonCollection.okayButton then
				self.MainPanel.ButtonCollection.okayButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end

			if self.MainPanel.RetryButton then
				self.MainPanel.RetryButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.RetrySmallButton then
				self.MainPanel.RetrySmallButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.NextButton then
				self.MainPanel.NextButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.MapButton then
				self.MainPanel.MapButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.MapButton_big then
				self.MainPanel.MapButton_big:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.CancelButton then
				self.MainPanel.CancelButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end

			if self.MainPanel.rateStar1 then
				self.MainPanel.rateStar1:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.rateStar2 then
				self.MainPanel.rateStar2:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.rateStar3 then
				self.MainPanel.rateStar3:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.rateStar4 then
				self.MainPanel.rateStar4:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.rateStar5 then
				self.MainPanel.rateStar5:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end

			if self.MainPanel.GoalPanel.StarGoal1.Star then
				self.MainPanel.GoalPanel.StarGoal1.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.GoalPanel.StarGoal2.Star then
				self.MainPanel.GoalPanel.StarGoal2.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.GoalPanel.StarGoal3.Star then
				self.MainPanel.GoalPanel.StarGoal3.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end

		end
	end,
}

local GameOverAdvice = {
	"One large match is worth more points than several small matches.",
	"Make a tall match with 8 or more gems to make a horizontal burst gem.",
	"Make a wide match with 8 or more gems to make a vertical burst gem.",
	"Make a square match with 8 or more gems to make an area burst gem.",
	"If a burst gem hits another burst gem, it will start a chain reaction.",
	"A basic match with two different burst gems will cause their effects to be combined.",
	"When you get a free spin, you also get a score multiplier.",
	"Your score multiplier drops back down to 1x if you have to spin manually.",
	"The more spins you have left when you finish a level goal, the more bonus points you get.",
	"Match three different colors at once with a wild gem to create a super wild gem.", --10
	"Make a match with a colored gem and a super wild to match every gem on the board of that color.",
	"Plan the order of your moves to maximize your chance of getting a free spin.",
	"Sometimes getting free spins is more important to winning than going straight for the goal.",
	"Match a super wild with a wild gem, and you can match many colors at once-- maybe even the whole board.",
	"Crates are broken when a match takes place in a gem next to them.",
	"When you fling a gem onto the board, the gem it covers is lost and gives no points.",
	"You cannot fling a gem onto a crate.",
	"You break a gem out of jail by making a match through it.",
	"Crates don't fall when the gems under them are broken.",
	"Jailed gems don't fall when the gems under them are broken.", --20
	"You cannot fire a gem onto a jailed gem.",
	"If you cannot reach a gem directly, try hitting it with a burst powerup or super wild.",
	"Treasure chests cannot be matched or covered. Match them by dropping them to the bottom.",
	"If you need a specific gem to beat a level and there aren't any, make a few matches. One might show up.",
	"If there is a horizontal line of crates blocking gems from falling down, break the line first so you don't get stuck.",
	"Stuck on a level? Buy some boosts or tricks to push past.",
	"You always have to beat the one-star goal to advance.",
	"The matches the game shows you are not always the best match.",
	"You can fling a gem onto its own color so long as the match you make has 3 or more gems.",
	"Vines won't grow on any turn you free a vine-covered gem.", --30
	"Bombs won't tick down on any turn you match a gem with a bomb on it.",
	"Can't find that one gem you need? Try to get a free spin so you get another chance.",
	"If you can play every gem in the tray, you get a free spin!",
	"Steel pieces cannot be matched. You have to play around them.",
	"If the spin button isn't visible, that means there are still matches left to play.",
	"If a square is empty, you can play onto it. If the square is completely gone, you cannot.",
	"Darker clouded squares take more matches to clear up.",
	"Clean up vine squares as early as possible. The further vines spread, the harder they are to deal with.",
	"Burst gems spawn on the square you clicked to make the match. Use this to control their placement.",
	"Pieces that drop from the top often have a certain number of turns' delay before the next appears. Use this to control their placement.", --40
}

local setEndGameQuickQuestIcons = function(dialog,stats,doShowQuickQuest,isQuickQuestComplete)
    if (doShowQuickQuest) then
        if (stats.oldStars == 0) then
            dialog.MainPanel.GoalPanel.StarGoal1.Star.QuickQuestPiece.visible = true
        elseif (stats.oldStars == 1) then
            dialog.MainPanel.GoalPanel.StarGoal2.Star.QuickQuestPiece.visible = true
        else
            dialog.MainPanel.GoalPanel.StarGoal3.Star.QuickQuestPiece.visible = true
        end
    end



    if (isQuickQuestComplete) then
        dialog.MainPanel.GoalPanel.StarGoal1.Star.QuickQuestPiece.Piece.image = QQ_MGR:GetImagePath(true,0.45)
        dialog.MainPanel.GoalPanel.StarGoal2.Star.QuickQuestPiece.Piece.image = QQ_MGR:GetImagePath(true,0.45)
        dialog.MainPanel.GoalPanel.StarGoal3.Star.QuickQuestPiece.Piece.image = QQ_MGR:GetImagePath(true,0.45)
    end

end

Scripts.Preshow_GameOverDialog_Level = function(dialog,gameScreen,stats,debugAutoWin,doShowQuickQuest,isQuickQuestComplete)
	local score = stats.score
	local goalScore = stats.goalScore

	local GameOverAdviceIndex = math.random(#GameOverAdvice)
	--NOTE: EndGameAdvice disabled
	--dialog.MainPanel.EndGameAdvice.text = GameOverAdvice[GameOverAdviceIndex]

	--TEST
	--goalScore = 1000

	local levelBeat = (stats.mainCompletion and stats.star1Completion)

	if (levelBeat) then  --Start with neutral
		dialog.MainPanel.DialogCharacter.image = "Character_Explorer_Sad3.png"
	else
		dialog.MainPanel.DialogCharacter.image = "Character_Explorer_Sad3.png"
	end

	-- Set things to not visible
	dialog.MainPanel.scoreContainer.score.bestStamp.visible = false
	dialog.MainPanel.goalScoreContainer.check.visible = false
	dialog.MainPanel.goalScoreContainer.X.visible = false

	--Set all values except score
	--These are set to -1 at start
	if(stats.oldDailyTop<0)then
		stats.oldDailyTop = 0
	end
	if(stats.oldPersonalBest<0)then
		stats.oldPersonalBest = 0
	end
	if(dialog.MainPanel.dailyBest) then
		dialog.MainPanel.dailyBest.text = Int2Comma(stats.oldDailyTop)
	end
	if(dialog.MainPanel.personalBest) then
		dialog.MainPanel.personalBest.text = Int2Comma(stats.oldPersonalBest)
	end

	--dialog.MainPanel.scoreContainer:SetScore(0)
	dialog.MainPanel.scoreContainer:SetScore(score)

	dialog.MainPanel.personalBestLabel.text = STRINGS("Level Best:")
	dialog.MainPanel.personalBest.bestStamp.visible = false

	local goalContainer = dialog.MainPanel.goalScoreContainer
	goalContainer.mainGoalText.text = stats.mainGoalText
	goalContainer.mainGoalText.visible = false
	goalContainer.mainProgressText.text = stats.mainProgressText
	if(stats.mainCompletion) then
		goalContainer.mainProgressText.fgColor = "Cascade_DarkPink"
	else
		goalContainer.mainProgressText.fgColor = "Cascade_LightGreen"
	end
	goalContainer.mainProgressText.visible = false

	goalContainer.star1Icon.image = "StarBig_off.png"
	goalContainer.star1ProgressText.text = stats.star1ProgressText
	goalContainer.star1ProgressText.visible = false -- not used right now
	goalContainer.star1GoalText.text = stats.star1GoalText

	goalContainer.star2Icon.image = "StarBig_off.png"
	goalContainer.star2ProgressText.text = stats.star2ProgressText
	goalContainer.star2ProgressText.visible = false
	goalContainer.star2GoalText.text = stats.star2GoalText

	goalContainer.star3Icon.image = "StarBig_off.png"
	goalContainer.star3ProgressText.text = stats.star3ProgressText
	goalContainer.star3ProgressText.visible = false
	goalContainer.star3GoalText.text = stats.star3GoalText

	dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "StarBig_off.png"
	dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "StarBig_off.png"
	dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "StarBig_off.png"

	-- DEBUG
	--[[
	stats.oldStars = 0
	stats.newStars = 3
	stats.star1Completion = true
	stats.star2Completion = true
	stats.star3Completion = true
	stats.mainCompletion = true
	--]]

	-- Turn on stars that are already acquired
	if(stats.oldStars >= 1)then
		dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "StarBig_achieved.png"
		dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker.image = ""
		dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker.visible = false
	end
	if(stats.oldStars >= 2)then
		dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "StarBig_achieved.png"
		dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker.image = ""
		dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker.visible = false
	end
	if(stats.oldStars >= 3)then
		dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "StarBig_achieved.png"
		dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker.image = ""
		dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker.visible = false
	end
	if(dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker.image ~= "") then
		dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker.visible = true
	end
	if(dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker.image ~= "") then
		dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker.visible = true
	end
	if(dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker.image ~= "") then
		dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker.visible = true
	end

    setEndGameQuickQuestIcons(dialog,stats,doShowQuickQuest,isQuickQuestComplete)


	local useGold = Config.GoldEnabled
	if(useGold) then
		for i = 1,3 do
			if(stats.oldStars < i) then
				dialog.MainPanel.GoalPanel["StarGoal" .. i].Gold.visible = true
			end
		end
	end

	dialog.MainPanel.GoalPanel.LevelObjective.text = stats.mainGoalText
	dialog.MainPanel.GoalPanel.LevelObjective2.text = string.format(STRINGS("ScoreGoalFmtLua"),stats.star1GoalText)
	dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star1GoalText
	dialog.MainPanel.GoalPanel.Requirement.visible = false

	local LevelNamePanel = dialog:FindChild("LevelNamePanel",true)
	LevelNamePanel.LevelName.text = stats.levelName

    --Show level # if applicable
    local numberPanel = dialog:FindChild("LevelNumberPanel",true)
    numberPanel.visible = false
	if(stats.hiddenLevel ~= true) then
        --logprint(stats.levelNumber)
        numberPanel.visible = true
        numberPanel.LevelNumber.text = stats.levelNumber
	end

	--LevelNamePanel.LevelObjective.text = stats.goalText

	for i=1,7 do
		local powerupName = "Powerup"..i
		local powerup = LevelNamePanel[powerupName]
		powerup.visible = false
	end

	dialog.MainPanel.GoalPanel.Requirement.alignmentOffset = {0,125-30}

	local levelBeat = (stats.mainCompletion and stats.star1Completion) or debugAutoWin
	if (levelBeat) then
		--NOTE: With NEXT enabled
		--dialog.MainPanel.NextButton.visible = true
		dialog.MainPanel.MapButton_big.visible = true
		dialog.MainPanel.NextButton.visible = false
		dialog.MainPanel.RetrySmallButton.visible = true
	else
		dialog.MainPanel.RetryButton.visible = true
		dialog.MainPanel.MapButton.visible = true
	end

end

Scripts.Present_GameOverDialog_Level = function(dialog,gameScreen,stats)
	local goalContainer = dialog.MainPanel.goalScoreContainer
	local score = stats.score
	local goalScore = stats.goalScore
	local levelBeat = (stats.mainCompletion and stats.star1Completion)

	dialog.MainPanel.scoreContainer:SetScore(score)

	-- Display prompts for Apptentive and/or push-notification
	-- registration, as appropriate:
	--
	-- This will be delayed by a bit, in a way that doesn't otherwise affect the
	-- the game-over sequence.
	AddScriptWithParams(dialog, function ()
		ScriptDelay(500, "DialogTimers")
		if (levelBeat) then
			local triggerName = "BeatLevel"..tostring(stats.currentLevel)
			if (APPTENTIVE) then
				APPTENTIVE:LogSignificantEventAndShowRatingFlowIfConditionsAreMet(triggerName)
			end
			if (USER_NOTIFICATIONS) then
				USER_NOTIFICATIONS:PromptForUserNotificationRegistration(triggerName)
			end
			RatingsPromptDialog_ShowIfConditionsAreMet(triggerName)
		end
	end)

	--logprint("Present_GameOverDialog_Level: score:"..stats.score.." goalScore:"..stats.goalScore)
	--TEST
	--goalScore = 1000
	--score = 126000

	--Give time for it to come down
	ScriptDelay(500,"DialogTimers")

	local topBar = dialog.screen:FindChild("TopBar",true)

	local useGold = Config.GoldEnabled
	local awardGold1 = stats.star1Completion and stats.oldStars < 1 and stats.mainCompletion
	local awardGold2 = stats.star2Completion and stats.oldStars < 2 and stats.mainCompletion
	local awardGold3 = stats.star3Completion and stats.oldStars < 3 and stats.mainCompletion

	local starDelta = stats.newStars - stats.oldStars
	if(stats.hiddenLevel == true) then
		starDelta = 0
	end
	stats.currentStars = stats.currentStars - starDelta
	topBar.StarCardRankButton.NewMarker:SetScore(stats.currentStars,true)
	if(useGold) then
		topBar.GoldButton.NewMarker:SetScore(stats.oldGold,true)
	end

	local goldAnimationSpeed = 250

	-- Fly gold...

	--stats.star1Completion = true
	if(stats.star1Completion) then
		dialog.MainPanel.GoalPanel.Requirement.Text.visible = false -- turned off
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star2GoalText
		dialog.MainPanel.GoalPanel.StarGoal1.Star.alpha = 255
		dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "StarBig.png"
		--StarBig@2x
		PlaySound("pop_sparkle_01.ogg")
		PlaySound("slot_machine_win_05.ogg")
		FireParticle(dialog.MainPanel.GoalPanel.StarGoal1.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
		Pop(dialog.MainPanel.GoalPanel.StarGoal1.Star)
		ScaleOut(dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker,{0.0,0.0},goldAnimationSpeed,false)
		--dialog.MainPanel.GoalPanel.StarGoal1.Star:AddScript("JelloSquare","Star")
		dialog.MainPanel.GoalPanel.StarGoal1.Star:AddScript("SparkleLoop","Star")
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star2GoalText
		if(useGold and stats.oldStars < 1 and stats.mainCompletion) then
			local treasureDest = topBar.globalPosition
			treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal1.Gold.size.x/2
			treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal1.Gold.size.y/2

			local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal1.Gold,"GoldSparkleTrail1")

			PlaySound("coin_magic_03.ogg")
			PlaySound("swish05.ogg")
			dialog.MainPanel.GoalPanel.StarGoal1.Gold.layer = 2020
			ScaleOut(dialog.MainPanel.GoalPanel.StarGoal1.Gold,{0.25,0.25},goldAnimationSpeed,false)
			Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal1.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
			stats.oldGold = stats.oldGold + Config.GoldAward_Star1
			topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
			dialog.MainPanel.GoalPanel.StarGoal1.Gold.alpha = 0  -- so the actor disappears but the particle child trail is still visible
			PlaySound("coin_magic_06.ogg")
			FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
			trail:Pause()
			topBar:AddScript("Animate_UpAndDown","")
			CorrectedPop(topBar.GoldButton.NewMarker)
			ScriptDelay(150)
		else
			dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "StarBig_achieved.png"
			ScriptDelay(500)
		end
	end
	--stats.star2Completion = true
	if(stats.star2Completion) then
		dialog.MainPanel.GoalPanel.Requirement.Text.visible = false -- turned off
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star3GoalText
		dialog.MainPanel.GoalPanel.StarGoal2.Star.alpha = 255
		dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "StarBig.png"
		PlaySound("pop_sparkle_01.ogg")
		PlaySound("slot_machine_win_06.ogg")
		FireParticle(dialog.MainPanel.GoalPanel.StarGoal2.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
		Pop(dialog.MainPanel.GoalPanel.StarGoal2.Star)
		ScaleOut(dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker,{0.0,0.0},goldAnimationSpeed,false)
		dialog.MainPanel.GoalPanel.StarGoal2.Star:AddScript("JelloSquare","Star")
		dialog.MainPanel.GoalPanel.StarGoal2.Star:AddScript("SparkleLoop","Star")
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star3GoalText
		if(useGold and stats.oldStars < 2 and stats.mainCompletion) then
			local treasureDest = topBar.globalPosition
			treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal2.Gold.size.x/2
			treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal2.Gold.size.y/2

			local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal2.Gold,"GoldSparkleTrail1")

			PlaySound("coin_magic_03_2.ogg")
			PlaySound("swish05.ogg")
			dialog.MainPanel.GoalPanel.StarGoal2.Gold.layer = 2020
			ScaleOut(dialog.MainPanel.GoalPanel.StarGoal2.Gold,{0.25,0.25},goldAnimationSpeed,false)
			Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal2.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
			stats.oldGold = stats.oldGold + Config.GoldAward_Star2
			topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
			dialog.MainPanel.GoalPanel.StarGoal2.Gold.alpha = 0
			PlaySound("coin_magic_06.ogg")
			FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow","Center",dialog.hgeParticles)
			trail:Pause()
			topBar:AddScript("Animate_UpAndDown","")
			CorrectedPop(topBar.GoldButton.NewMarker)
			ScriptDelay(150)
		else
			dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "StarBig_achieved.png"
			ScriptDelay(500)
		end
	end
	--stats.star3Completion = true
	if(stats.star3Completion) then
		dialog.MainPanel.GoalPanel.Requirement.Text.visible = false -- turned off
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("")
		dialog.MainPanel.GoalPanel.StarGoal3.Star.alpha = 255
		dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "StarBig.png"
		PlaySound("pop_sparkle_01.ogg")
		PlaySound("slot_machine_win_03.ogg")
		FireParticle(dialog.MainPanel.GoalPanel.StarGoal3.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
		Pop(dialog.MainPanel.GoalPanel.StarGoal3.Star)
		ScaleOut(dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker,{0.0,0.0},goldAnimationSpeed,false)
		dialog.MainPanel.GoalPanel.StarGoal3.Star:AddScript("JelloSquare","Star")
		dialog.MainPanel.GoalPanel.StarGoal3.Star:AddScript("SparkleLoop","Star")
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("")
		if(useGold and stats.oldStars < 3 and stats.mainCompletion) then
			local treasureDest = topBar.globalPosition
			treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal3.Gold.size.x/2
			treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal3.Gold.size.y/2

			local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal3.Gold,"GoldSparkleTrail1")

			PlaySound("coin_magic_03_7.ogg")
			PlaySound("swish05.ogg")
			dialog.MainPanel.GoalPanel.StarGoal3.Gold.layer = 2020
			ScaleOut(dialog.MainPanel.GoalPanel.StarGoal3.Gold,{0.25,0.25},goldAnimationSpeed,false)
			Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal3.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
			stats.oldGold = stats.oldGold + Config.GoldAward_Star3
			topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
			dialog.MainPanel.GoalPanel.StarGoal3.Gold.alpha = 0
			PlaySound("coin_magic_06.ogg")
			FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow.more","Center",dialog.hgeParticles)
			trail:Pause()
			topBar:AddScript("Animate_UpAndDown","")
			CorrectedPop(topBar.GoldButton.NewMarker)
			ScriptDelay(150)
		else
			dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "StarBig_achieved.png"
			ScriptDelay(500)
		end
	end


	-- Fly stars...
	--stats.star1Completion = true
	--stats.oldStars = 0
	if(useGold)then
		if(stats.star1Completion) then
			if(stats.oldStars < 1 and stats.mainCompletion) then
				local StarCardRankButton = topBar:FindChild("StarCardRankButton",true)
				local starGoal = dialog.MainPanel.GoalPanel.StarGoal1
				local star = starGoal.Star
				local flyingStar =starGoal.FlyingStar

				flyingStar.visible = true
				star.image = "StarBig_achieved.png"
				local treasureDest = StarCardRankButton.globalPosition
				treasureDest.x = treasureDest.x + StarCardRankButton.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal1.Star.size.x/2
				treasureDest.y = treasureDest.y + StarCardRankButton.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal1.Star.size.y/2

				local trail = AddTrail_dialog(flyingStar,"GoldSparkleTrail1")

				PlaySound("coin_magic_05.ogg")
				PlaySound("swish05.ogg")

				flyingStar.layer = 2020
				RotateOut(flyingStar, {revolutions=1.0},goldAnimationSpeed,false)
				ScaleOut(flyingStar,{0.25,0.25},goldAnimationSpeed,false)
				if(stats.hiddenLevel ~= true) then
					Scripts.Interpolate(flyingStar, "globalPosition", treasureDest, goldAnimationSpeed)
					stats.currentStars = stats.currentStars + 1
					topBar.StarCardRankButton.NewMarker:SetScore(stats.currentStars,false)
					flyingStar.alpha  = 0  -- so the actor disappears but the particle child trail is still visible
					PlaySound("slot_machine_win_07.ogg")
					FireParticle(StarCardRankButton,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
					trail:Pause()
					topBar:AddScript("Animate_UpAndDown","")
					CorrectedPop(topBar.StarCardRankButton.NewMarker)
				else
					trail:Pause()
					flyingStar.alpha = 0
					ScriptDelay(350)
				end
				ScriptDelay(150)
			else
				--ScriptDelay(500)
			end
		end
		if(stats.star2Completion) then
			if(stats.oldStars < 2 and stats.mainCompletion) then
				local StarCardRankButton = topBar:FindChild("StarCardRankButton",true)
				local starGoal = dialog.MainPanel.GoalPanel.StarGoal2
				local star = starGoal.Star
				local flyingStar =starGoal.FlyingStar

				flyingStar.visible = true
				star.image = "StarBig_achieved.png"
				local treasureDest = StarCardRankButton.globalPosition
				treasureDest.x = treasureDest.x + StarCardRankButton.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal2.Star.size.x/2
				treasureDest.y = treasureDest.y + StarCardRankButton.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal2.Star.size.y/2

				local trail = AddTrail_dialog(flyingStar,"GoldSparkleTrail1")

				PlaySound("coin_magic_05_2.ogg")
				PlaySound("swish05.ogg")

				flyingStar.layer = 2020
				RotateOut(flyingStar, {revolutions=1.0},goldAnimationSpeed,false)
				ScaleOut(flyingStar,{0.25,0.25},goldAnimationSpeed,false)
				if(stats.hiddenLevel ~= true) then
					Scripts.Interpolate(flyingStar, "globalPosition", treasureDest, goldAnimationSpeed)
					stats.currentStars = stats.currentStars + 1
					topBar.StarCardRankButton.NewMarker:SetScore(stats.currentStars,false)
					flyingStar.alpha  = 0  -- so the actor disappears but the particle child trail is still visible
					PlaySound("slot_machine_win_07.ogg")
					FireParticle(StarCardRankButton,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
					trail:Pause()
					topBar:AddScript("Animate_UpAndDown","")
					CorrectedPop(topBar.StarCardRankButton.NewMarker)
				else
					trail:Pause()
					flyingStar.alpha = 0
					ScriptDelay(350)
				end
				ScriptDelay(150)
			else
				--ScriptDelay(500)
			end
		end
		if(stats.star3Completion) then
			if(stats.oldStars < 3 and stats.mainCompletion) then
				local StarCardRankButton = topBar:FindChild("StarCardRankButton",true)
				local starGoal = dialog.MainPanel.GoalPanel.StarGoal3
				local star = starGoal.Star
				local flyingStar =starGoal.FlyingStar

				flyingStar.visible = true
				star.image = "StarBig_achieved.png"
				local treasureDest = StarCardRankButton.globalPosition
				treasureDest.x = treasureDest.x + StarCardRankButton.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal3.Star.size.x/2
				treasureDest.y = treasureDest.y + StarCardRankButton.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal3.Star.size.y/2

				local trail = AddTrail_dialog(flyingStar,"GoldSparkleTrail1")

				PlaySound("coin_magic_05_7.ogg")
				PlaySound("swish05.ogg")

				flyingStar.layer = 2020
				RotateOut(flyingStar, {revolutions=1.0},goldAnimationSpeed,false)
				ScaleOut(flyingStar,{0.25,0.25},goldAnimationSpeed,false)
				if(stats.hiddenLevel ~= true) then
					Scripts.Interpolate(flyingStar, "globalPosition", treasureDest, goldAnimationSpeed)
					stats.currentStars = stats.currentStars + 1
					topBar.StarCardRankButton.NewMarker:SetScore(stats.currentStars,false)
					flyingStar.alpha  = 0  -- so the actor disappears but the particle child trail is still visible
					PlaySound("slot_machine_win_07.ogg")
					FireParticle(StarCardRankButton,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
					trail:Pause()
					topBar:AddScript("Animate_UpAndDown","")
					CorrectedPop(topBar.StarCardRankButton.NewMarker)
				else
					trail:Pause()
					flyingStar.alpha = 0
					ScriptDelay(350)
				end
				ScriptDelay(150)
			else
				--ScriptDelay(500)
			end
		end
	end

	if(stats.mainCompletion)then
		PlaySound("BlingBling.ogg")
		dialog.MainPanel.GoalPanel.LevelObjective.Check.visible = true
		Pop(dialog.MainPanel.GoalPanel.LevelObjective.Check)
	else
		PlaySound("OING_A.ogg")
		dialog.MainPanel.GoalPanel.LevelObjective.X.visible = true
		Pop(dialog.MainPanel.GoalPanel.LevelObjective.X)
	end

	if(stats.star1Completion)then
		PlaySound("BlingBling.ogg")
		dialog.MainPanel.GoalPanel.LevelObjective2.Check.visible = true
		Pop(dialog.MainPanel.GoalPanel.LevelObjective2.Check)
	else
		PlaySound("OING_A.ogg")
		dialog.MainPanel.GoalPanel.LevelObjective2.X.visible = true
		Pop(dialog.MainPanel.GoalPanel.LevelObjective2.X)
	end

	local levelBeat = (stats.mainCompletion and stats.star1Completion)
	local scoreBeaten = false
	if(levelBeat)then
        scoreBeaten = true
		PlaySound("Magic_SpeedPickup.ogg")
		FadeIn(dialog.MainPanel.goalScoreContainer.check,500)
		ScaleIn(dialog.MainPanel.goalScoreContainer.check,{2.0,2.0},500,true)
		StopSound("Magic_SpeedPickup.ogg")
		PlaySound("Magic_Respawn38.ogg")
        FireParticle(dialog.MainPanel.goalScoreContainer.check,"StarToss1.smaller","Center",dialog.MainPanel.hgeParticles)
        FireParticle(dialog.MainPanel.goalScoreContainer.check,"SparkleBurst1","Center",dialog.MainPanel.hgeParticles)
		FireParticle(dialog.MainPanel.goalScoreContainer.check,"Shine2","Center",dialog.MainPanel.hgeParticles)
		Pop(dialog.MainPanel.goalScoreContainer.check)
		ScriptDelay(50)
		StartParticleEmitterFromFile({targetParticleLayer = dialog.MainPanel.hgeParticles,file="Sparks1.guru_particle",position=dialog.MainPanel.goalScoreContainer.position})
		PlaySound("slot_machine_spin_04_short.ogg")
		ScriptDelay(1300)
		PlaySound("slot_machine_win_19.ogg")
	end

	--logprint("All best score: " .. stats.oldTopScore .. " This game: " .. score)

	--logprint(">> stats.score "..stats.score)
	--logprint("Daily best score: " .. stats.oldDailyTop .. " This game: " .. stats.score)
	local personalBest = false
	if(stats.score > stats.oldPersonalBest)then
		scoreBeaten = true
		personalBest = true
		dialog.MainPanel.personalBest.text = Int2Comma(stats.score)
		dialog.MainPanel.personalBest.bestStamp.image = "best.png"
		PlaySound("pop_sparkle_01.ogg")
		FireParticle(dialog.MainPanel.personalBest.bestStamp,"StarBurst_Blue_Small","Center",dialog.MainPanel.hgeParticles)
		Pop(dialog.MainPanel.personalBest.bestStamp)
		ScriptDelay(150)
		if(levelBeat)then
			PlaySound("Cascade_Boom.ogg")
			ScriptDelay(300)
		end
	end

	--TEST
	--levelBeat = false
	if(levelBeat)then
		--logprint("Level beat")
		PlaySound("slot_machine_win_24.ogg")
		dialog.MainPanel.DialogCharacter.image = "Character_Explorer.png"
		ScriptDelay(1000)
		-- Play sound based on how much they beat their previous best
		local scoreBeatenByAmount = 1.0
		scoreBeatenByAmount = (score / goalScore)

		--logprint("goalScore "..goalScore)
		--logprint("scoreBeatenByAmount "..scoreBeatenByAmount)
		if(personalBest)then
			PlaySound("Cascade_RightOn.ogg")
		elseif(scoreBeatenByAmount>=4.0)then
			PlaySound("Cascade_Outrageous.ogg")
		elseif(scoreBeatenByAmount>=3.0)then
			PlaySound("Cascade_Amazing.ogg")
		elseif(scoreBeatenByAmount>=2.0)then
			PlaySound("Cascade_Fantastic.ogg")
		elseif(scoreBeatenByAmount>=1)then
			PlaySound("Cascade_Awesome.ogg")
		end
	else
		--logprint("Level not beat")
		dialog.MainPanel.DialogCharacter.image = "Character_Explorer_sad1.png"
		PlaySound("soft_lose_02.ogg")
		if(stats.mainCompletion and not stats.star1Completion)then
			dialog.MainPanel.goalScoreContainer.zorder = 100
			dialog.MainPanel.goalScoreContainer.X.alignmentOffset = {-55,-57}
			dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Need Star: ")..stats.star1GoalText
		end
		--Turned off X
		--FadeIn(dialog.MainPanel.goalScoreContainer.X,500)
		--ScaleIn(dialog.MainPanel.goalScoreContainer.X,{2.0,2.0},500,true)
		local starDropSpeed = 500
		ScriptDelay(500)

		local lostStar1 = stats.star1Completion and stats.oldStars < 1 and not levelBeat
		local lostStar2 = stats.star2Completion and stats.oldStars < 2 and not levelBeat
		local lostStar3 = stats.star3Completion and stats.oldStars < 3 and not levelBeat

		if(lostStar1 or lostStar2 or lostStar3)then
			PlaySound("sci_fi_lose_02.ogg")
		end

		if(lostStar1) then
			--logprint("Star 1 completed and taken away")
			dialog.MainPanel.GoalPanel.StarGoal1.Star.FakeStar = {
				class = "Actor",
				image = "StarBig.png",
				layer = 2000,
			}
			if(stats.oldStars >= 1)then
				dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "StarBig_achieved.png"
			else
				dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "StarBig_off.png"
			end
			RotateOut(dialog.MainPanel.GoalPanel.StarGoal1.Star.FakeStar, {revolutions=0.25},starDropSpeed,false)
			SlideOff(dialog.MainPanel.GoalPanel.StarGoal1.Star.FakeStar,starDropSpeed,"bottom","nowait")
			droppedStar = true
		end
		if(lostStar2) then
			dialog.MainPanel.GoalPanel.StarGoal2.Star.FakeStar = {
				class = "Actor",
				image = "StarBig.png",
				layer = 2000,
			}
			if(stats.oldStars >= 2)then
				dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "StarBig_achieved.png"
			else
				dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "StarBig_off.png"
			end
			RotateOut(dialog.MainPanel.GoalPanel.StarGoal1.Star.FakeStar, {revolutions=-0.25},starDropSpeed,false)
			SlideOff(dialog.MainPanel.GoalPanel.StarGoal2.Star.FakeStar,starDropSpeed,"bottom","nowait")
			droppedStar = true
		end
		if(lostStar3) then
			dialog.MainPanel.GoalPanel.StarGoal3.Star.FakeStar = {
				class = "Actor",
				image = "StarBig.png",
				layer = 2000,
			}
			if(stats.oldStars >= 3)then
				dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "StarBig_achieved.png"
			else
				dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "StarBig_off.png"
			end
			RotateOut(dialog.MainPanel.GoalPanel.StarGoal1.Star.FakeStar, {revolutions=0.15},starDropSpeed,false)
			SlideOff(dialog.MainPanel.GoalPanel.StarGoal3.Star.FakeStar,starDropSpeed,"bottom","nowait")
			droppedStar = true
		end
		ScriptDelay(750)
		if(dialog.MainPanel.GoalPanel.StarGoal1.Star.FakeStar ~= nil) then
			dialog.MainPanel.GoalPanel.StarGoal1.Star.FakeStar:Destroy()
		end
		if(dialog.MainPanel.GoalPanel.StarGoal2.Star.FakeStar ~= nil) then
			dialog.MainPanel.GoalPanel.StarGoal2.Star.FakeStar:Destroy()
		end
		if(dialog.MainPanel.GoalPanel.StarGoal3.Star.FakeStar ~= nil) then
			dialog.MainPanel.GoalPanel.StarGoal3.Star.FakeStar:Destroy()
		end
		PlaySound("Cascade_Aw.ogg")
	end

    ScriptDelay(500)
	LoopSoundAsMusic("Cascade_GameOverMusic.mp3")

	if (levelBeat) then
		dialog.MainPanel.NextButton:AddScript("DialogButtonGroove","DialogButtonGroove")
		dialog.MainPanel.MapButton_big:AddScript("DialogButtonGroove","DialogButtonGroove")
		dialog.MainPanel.DialogCharacter:AddScript("DialogButtonGroove","DialogButtonGroove")
	end
end

Scripts.Preshow_GameOverDialog_LabEvent = function(dialog,gameScreen,stats,debugAutoWin)
	local score = stats.score
	local goalScore = stats.goalScore

	local GameOverAdviceIndex = math.random(#GameOverAdvice)
	--NOTE: EndGameAdvice disabled
	--dialog.MainPanel.EndGameAdvice.text = GameOverAdvice[GameOverAdviceIndex]

	--TEST
	--goalScore = 1000

	local levelBeat = (stats.mainCompletion and stats.star1Completion)

	if (levelBeat) then  --Start with neutral
		dialog.MainPanel.DialogCharacter.image = "Character_Explorer_Sad3.png"
	else
		dialog.MainPanel.DialogCharacter.image = "Character_Explorer_Sad3.png"
	end

	-- Set things to not visible
	dialog.MainPanel.scoreContainer.score.bestStamp.visible = false
	dialog.MainPanel.goalScoreContainer.check.visible = false
	dialog.MainPanel.goalScoreContainer.X.visible = false

	--Set all values except score
	--These are set to -1 at start
	if(stats.oldDailyTop<0)then
		stats.oldDailyTop = 0
	end
	if(stats.oldPersonalBest<0)then
		stats.oldPersonalBest = 0
	end
	if(dialog.MainPanel.dailyBest) then
		dialog.MainPanel.dailyBest.text = Int2Comma(stats.oldDailyTop)
	end
	if(dialog.MainPanel.personalBest) then
		dialog.MainPanel.personalBest.text = Int2Comma(stats.oldPersonalBest)
	end

	--dialog.MainPanel.scoreContainer:SetScore(0)
	dialog.MainPanel.scoreContainer:SetScore(score)

	dialog.MainPanel.personalBestLabel.text = STRINGS("Level Best:")
	dialog.MainPanel.personalBest.bestStamp.visible = false

	local goalContainer = dialog.MainPanel.goalScoreContainer
	goalContainer.mainGoalText.text = stats.mainGoalText
	goalContainer.mainGoalText.visible = false
	goalContainer.mainProgressText.text = stats.mainProgressText
	if(stats.mainCompletion) then
		goalContainer.mainProgressText.fgColor = "Cascade_DarkPink"
	else
		goalContainer.mainProgressText.fgColor = "Cascade_LightGreen"
	end
	goalContainer.mainProgressText.visible = false

	goalContainer.star1Icon.image = "LabLevel_Flask_Slot.png"
	goalContainer.star1ProgressText.text = stats.star1ProgressText
	goalContainer.star1ProgressText.visible = false -- not used right now
	goalContainer.star1GoalText.text = stats.star1GoalText

	goalContainer.star2Icon.image = "LabLevel_Flask_Slot.png"
	goalContainer.star2ProgressText.text = stats.star2ProgressText
	goalContainer.star2ProgressText.visible = false
	goalContainer.star2GoalText.text = stats.star2GoalText

	goalContainer.star3Icon.image = "LabLevel_Flask_Slot.png"
	goalContainer.star3ProgressText.text = stats.star3ProgressText
	goalContainer.star3ProgressText.visible = false
	goalContainer.star3GoalText.text = stats.star3GoalText

	dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "LabLevel_Flask_Slot.png"
	dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "LabLevel_Flask_Slot.png"
	dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "LabLevel_Flask_Slot.png"

	-- DEBUG
	--[[
	stats.oldStars = 0
	stats.newStars = 3
	stats.star1Completion = true
	stats.star2Completion = true
	stats.star3Completion = true
	stats.mainCompletion = true
	--]]

	-- Turn on stars that are already acquired
	if(stats.oldStars >= 1)then
		dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "LabLevel_Flask_1.png"
		dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker.image = ""
		dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker.visible = false
	end
	if(stats.oldStars >= 2)then
		dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "LabLevel_Flask_2.png"
		dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker.image = ""
		dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker.visible = false
	end
	if(stats.oldStars >= 3)then
		dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "LabLevel_Flask_3.png"
		dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker.image = ""
		dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker.visible = false
	end
	if(dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker.image ~= "") then
		dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker.visible = true
	end
	if(dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker.image ~= "") then
		dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker.visible = true
	end
	if(dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker.image ~= "") then
		dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker.visible = true
	end

	local useGold = Config.GoldEnabled
	if(useGold) then
		for i = 1,3 do
			if(stats.oldStars < i) then
				dialog.MainPanel.GoalPanel["StarGoal" .. i].Gold.visible = true
			end
		end
	end

	dialog.MainPanel.GoalPanel.LevelObjective.text = stats.mainGoalText
	dialog.MainPanel.GoalPanel.LevelObjective2.text = string.format(STRINGS("ScoreGoalFmtLua"),stats.star1GoalText)
	dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star1GoalText
	dialog.MainPanel.GoalPanel.Requirement.visible = false

	local LevelNamePanel = dialog:FindChild("LevelNamePanel",true)
	--logprint(stats.levelNumber)
	LevelNamePanel.LevelName.text = stats.levelName

	--Show level # if applicable
    local numberPanel = dialog:FindChild("LevelNumberPanel",true)
    numberPanel.visible = false
	if(stats.hiddenLevel ~= true) then
        --logprint(stats.levelNumber)
        numberPanel.visible = true
        numberPanel.LevelNumber.text = stats.levelNumber
	end

	--LevelNamePanel.LevelObjective.text = stats.goalText

	for i=1,7 do
		local powerupName = "Powerup"..i
		local powerup = LevelNamePanel[powerupName]
		powerup.visible = false
	end

	dialog.MainPanel.GoalPanel.Requirement.alignmentOffset = {0,125-30}

	if (LAB_EVENT_MGR:GetTimeRemainingText(false) == "00:00:00") then
		dialog.MainPanel.MapButton_big.visible = true
	else
		dialog.MainPanel.RetryButton.visible = true
		dialog.MainPanel.MapButton.visible = true
	end
end

Scripts.Present_GameOverDialog_LabEvent = function(dialog,gameScreen,stats)
	local goalContainer = dialog.MainPanel.goalScoreContainer
	local score = stats.score
	local goalScore = stats.goalScore
	local levelBeat = (stats.mainCompletion and stats.star1Completion)

	dialog.MainPanel.scoreContainer:SetScore(score)

	-- Display prompts for Apptentive and/or push-notification
	-- registration, as appropriate:
	--
	-- This will be delayed by a bit, in a way that doesn't otherwise affect the
	-- the game-over sequence.
	AddScriptWithParams(dialog, function ()
		ScriptDelay(500, "DialogTimers")
		if (levelBeat) then
			local triggerName = "BeatLevel"..tostring(stats.currentLevel)
			if (APPTENTIVE) then
				APPTENTIVE:LogSignificantEventAndShowRatingFlowIfConditionsAreMet(triggerName)
			end
			if (USER_NOTIFICATIONS) then
				USER_NOTIFICATIONS:PromptForUserNotificationRegistration(triggerName)
			end
			RatingsPromptDialog_ShowIfConditionsAreMet(triggerName)
		end
	end)

	--logprint("Present_GameOverDialog_Level: score:"..stats.score.." goalScore:"..stats.goalScore)
	--TEST
	--goalScore = 1000
	--score = 126000

	--Give time for it to come down
	ScriptDelay(500,"DialogTimers")

	local topBar = dialog.screen:FindChild("TopBar",true)

	local useGold = Config.GoldEnabled
	local awardGold1 = stats.star1Completion and stats.oldStars < 1 and stats.mainCompletion
	local awardGold2 = stats.star2Completion and stats.oldStars < 2 and stats.mainCompletion
	local awardGold3 = stats.star3Completion and stats.oldStars < 3 and stats.mainCompletion

	local starDelta = stats.newStars - stats.oldStars
	if(stats.hiddenLevel == true) then
		starDelta = 0
	end
	stats.currentStars = stats.currentStars - starDelta
	topBar.StarCardRankButton.NewMarker:SetScore(stats.currentStars,true)
	if(useGold) then
		topBar.GoldButton.NewMarker:SetScore(stats.oldGold,true)
	end

	local goldAnimationSpeed = 250

	-- Fly gold...

	--stats.star1Completion = true
	if(stats.star1Completion) then
		dialog.MainPanel.GoalPanel.Requirement.Text.visible = false -- turned off
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star2GoalText
		dialog.MainPanel.GoalPanel.StarGoal1.Star.alpha = 255
		dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "LabLevel_Flask_1.png"
		--StarBig@2x
		PlaySound("pop_sparkle_01.ogg")
		PlaySound("slot_machine_win_05.ogg")
		FireParticle(dialog.MainPanel.GoalPanel.StarGoal1.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
		Pop(dialog.MainPanel.GoalPanel.StarGoal1.Star)
		ScaleOut(dialog.MainPanel.GoalPanel.StarGoal1.Star.Worker,{0.0,0.0},goldAnimationSpeed,false)
		dialog.MainPanel.GoalPanel.StarGoal1.Star:AddScript("JelloSquare","Star")
		dialog.MainPanel.GoalPanel.StarGoal1.Star:AddScript("SparkleLoop","Star")
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star2GoalText
		if(useGold and stats.oldStars < 1 and stats.mainCompletion) then
			local treasureDest = topBar.globalPosition
			treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal1.Gold.size.x/2
			treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal1.Gold.size.y/2

			local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal1.Gold,"GoldSparkleTrail1")

			PlaySound("coin_magic_03.ogg")
			PlaySound("swish05.ogg")
			dialog.MainPanel.GoalPanel.StarGoal1.Gold.layer = 2020
			ScaleOut(dialog.MainPanel.GoalPanel.StarGoal1.Gold,{0.25,0.25},goldAnimationSpeed,false)
			Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal1.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
			stats.oldGold = stats.oldGold + Config.GoldAward_Star1
			topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
			dialog.MainPanel.GoalPanel.StarGoal1.Gold.alpha = 0  -- so the actor disappears but the particle child trail is still visible
			PlaySound("coin_magic_06.ogg")
			FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
			trail:Pause()
			topBar:AddScript("Animate_UpAndDown","")
			CorrectedPop(topBar.GoldButton.NewMarker)
			ScriptDelay(150)
		else
			dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "LabLevel_Flask_1.png"
			ScriptDelay(500)
		end
	end
	--stats.star2Completion = true
	if(stats.star2Completion) then
		dialog.MainPanel.GoalPanel.Requirement.Text.visible = false -- turned off
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star3GoalText
		dialog.MainPanel.GoalPanel.StarGoal2.Star.alpha = 255
		dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "LabLevel_Flask_2.png"
		PlaySound("pop_sparkle_01.ogg")
		PlaySound("slot_machine_win_06.ogg")
		FireParticle(dialog.MainPanel.GoalPanel.StarGoal2.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
		Pop(dialog.MainPanel.GoalPanel.StarGoal2.Star)
		ScaleOut(dialog.MainPanel.GoalPanel.StarGoal2.Star.Worker,{0.0,0.0},goldAnimationSpeed,false)
		dialog.MainPanel.GoalPanel.StarGoal2.Star:AddScript("JelloSquare","Star")
		dialog.MainPanel.GoalPanel.StarGoal2.Star:AddScript("SparkleLoop","Star")
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star3GoalText
		if(useGold and stats.oldStars < 2 and stats.mainCompletion) then
			local treasureDest = topBar.globalPosition
			treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal2.Gold.size.x/2
			treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal2.Gold.size.y/2

			local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal2.Gold,"GoldSparkleTrail1")

			PlaySound("coin_magic_03_2.ogg")
			PlaySound("swish05.ogg")
			dialog.MainPanel.GoalPanel.StarGoal2.Gold.layer = 2020
			ScaleOut(dialog.MainPanel.GoalPanel.StarGoal2.Gold,{0.25,0.25},goldAnimationSpeed,false)
			Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal2.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
			stats.oldGold = stats.oldGold + Config.GoldAward_Star2
			topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
			dialog.MainPanel.GoalPanel.StarGoal2.Gold.alpha = 0
			PlaySound("coin_magic_06.ogg")
			FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow","Center",dialog.hgeParticles)
			trail:Pause()
			topBar:AddScript("Animate_UpAndDown","")
			CorrectedPop(topBar.GoldButton.NewMarker)
			ScriptDelay(150)
		else
			dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "LabLevel_Flask_2.png"
			ScriptDelay(500)
		end
	end
	--stats.star3Completion = true
	if(stats.star3Completion) then
		dialog.MainPanel.GoalPanel.Requirement.Text.visible = false -- turned off
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("")
		dialog.MainPanel.GoalPanel.StarGoal3.Star.alpha = 255
		dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "LabLevel_Flask_3.png"
		PlaySound("pop_sparkle_01.ogg")
		PlaySound("slot_machine_win_03.ogg")
		FireParticle(dialog.MainPanel.GoalPanel.StarGoal3.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
		Pop(dialog.MainPanel.GoalPanel.StarGoal3.Star)
		ScaleOut(dialog.MainPanel.GoalPanel.StarGoal3.Star.Worker,{0.0,0.0},goldAnimationSpeed,false)
		dialog.MainPanel.GoalPanel.StarGoal3.Star:AddScript("JelloSquare","Star")
		dialog.MainPanel.GoalPanel.StarGoal3.Star:AddScript("SparkleLoop","Star")
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("")
		if(useGold and stats.oldStars < 3 and stats.mainCompletion) then
			local treasureDest = topBar.globalPosition
			treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal3.Gold.size.x/2
			treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal3.Gold.size.y/2

			local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal3.Gold,"GoldSparkleTrail1")

			PlaySound("coin_magic_03_7.ogg")
			PlaySound("swish05.ogg")
			dialog.MainPanel.GoalPanel.StarGoal3.Gold.layer = 2020
			ScaleOut(dialog.MainPanel.GoalPanel.StarGoal3.Gold,{0.25,0.25},goldAnimationSpeed,false)
			Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal3.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
			stats.oldGold = stats.oldGold + Config.GoldAward_Star3
			topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
			dialog.MainPanel.GoalPanel.StarGoal3.Gold.alpha = 0
			PlaySound("coin_magic_06.ogg")
			FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow.more","Center",dialog.hgeParticles)
			trail:Pause()
			topBar:AddScript("Animate_UpAndDown","")
			CorrectedPop(topBar.GoldButton.NewMarker)
			ScriptDelay(150)
		else
			dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "LabLevel_Flask_3.png"
			ScriptDelay(500)
		end
	end

	if(stats.mainCompletion)then
		PlaySound("BlingBling.ogg")
		dialog.MainPanel.GoalPanel.LevelObjective.Check.visible = true
		Pop(dialog.MainPanel.GoalPanel.LevelObjective.Check)
	else
		PlaySound("OING_A.ogg")
		dialog.MainPanel.GoalPanel.LevelObjective.X.visible = true
		Pop(dialog.MainPanel.GoalPanel.LevelObjective.X)
	end

	if(stats.star1Completion)then
		PlaySound("BlingBling.ogg")
		dialog.MainPanel.GoalPanel.LevelObjective2.Check.visible = true
		Pop(dialog.MainPanel.GoalPanel.LevelObjective2.Check)
	else
		PlaySound("OING_A.ogg")
		dialog.MainPanel.GoalPanel.LevelObjective2.X.visible = true
		Pop(dialog.MainPanel.GoalPanel.LevelObjective2.X)
	end

	local levelBeat = (stats.mainCompletion and stats.star1Completion)
	local scoreBeaten = false
	if(levelBeat)then
        scoreBeaten = true
		PlaySound("Magic_SpeedPickup.ogg")
		FadeIn(dialog.MainPanel.goalScoreContainer.check,500)
		ScaleIn(dialog.MainPanel.goalScoreContainer.check,{2.0,2.0},500,true)
		StopSound("Magic_SpeedPickup.ogg")
		PlaySound("Magic_Respawn38.ogg")
        FireParticle(dialog.MainPanel.goalScoreContainer.check,"StarToss1.smaller","Center",dialog.MainPanel.hgeParticles)
        FireParticle(dialog.MainPanel.goalScoreContainer.check,"SparkleBurst1","Center",dialog.MainPanel.hgeParticles)
		FireParticle(dialog.MainPanel.goalScoreContainer.check,"Shine2","Center",dialog.MainPanel.hgeParticles)
		Pop(dialog.MainPanel.goalScoreContainer.check)
		ScriptDelay(50)
		StartParticleEmitterFromFile({targetParticleLayer = dialog.MainPanel.hgeParticles,file="Sparks1.guru_particle",position=dialog.MainPanel.goalScoreContainer.position})
		PlaySound("slot_machine_spin_04_short.ogg")
		ScriptDelay(1300)
		PlaySound("slot_machine_win_19.ogg")
	end

	--logprint("All best score: " .. stats.oldTopScore .. " This game: " .. score)

	--logprint(">> stats.score "..stats.score)
	--logprint("Daily best score: " .. stats.oldDailyTop .. " This game: " .. stats.score)
	local personalBest = false
	if(stats.score > stats.oldPersonalBest)then
		scoreBeaten = true
		personalBest = true
		dialog.MainPanel.personalBest.text = Int2Comma(stats.score)
		dialog.MainPanel.personalBest.bestStamp.image = "best.png"
		PlaySound("pop_sparkle_01.ogg")
		FireParticle(dialog.MainPanel.personalBest.bestStamp,"StarBurst_Blue_Small","Center",dialog.MainPanel.hgeParticles)
		Pop(dialog.MainPanel.personalBest.bestStamp)
		ScriptDelay(150)
		if(levelBeat)then
			PlaySound("Cascade_Boom.ogg")
			ScriptDelay(300)
		end
	end

	--TEST
	--levelBeat = false
	if(levelBeat)then
		--logprint("Level beat")
		PlaySound("slot_machine_win_24.ogg")
		dialog.MainPanel.DialogCharacter.image = "Character_Explorer.png"
		ScriptDelay(1000)
		-- Play sound based on how much they beat their previous best
		local scoreBeatenByAmount = 1.0
		scoreBeatenByAmount = (score / goalScore)

		--logprint("goalScore "..goalScore)
		--logprint("scoreBeatenByAmount "..scoreBeatenByAmount)
		if(personalBest)then
			PlaySound("Cascade_RightOn.ogg")
		elseif(scoreBeatenByAmount>=4.0)then
			PlaySound("Cascade_Outrageous.ogg")
		elseif(scoreBeatenByAmount>=3.0)then
			PlaySound("Cascade_Amazing.ogg")
		elseif(scoreBeatenByAmount>=2.0)then
			PlaySound("Cascade_Fantastic.ogg")
		elseif(scoreBeatenByAmount>=1)then
			PlaySound("Cascade_Awesome.ogg")
		end
	else
		--logprint("Level not beat")
		dialog.MainPanel.DialogCharacter.image = "Character_Explorer_sad1.png"
		PlaySound("soft_lose_02.ogg")
		if(stats.mainCompletion and not stats.star1Completion)then
			dialog.MainPanel.goalScoreContainer.zorder = 100
			dialog.MainPanel.goalScoreContainer.X.alignmentOffset = {-55,-57}
			dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Need Star: ")..stats.star1GoalText
		end
		--Turned off X
		--FadeIn(dialog.MainPanel.goalScoreContainer.X,500)
		--ScaleIn(dialog.MainPanel.goalScoreContainer.X,{2.0,2.0},500,true)
		local starDropSpeed = 500
		ScriptDelay(500)

		local lostStar1 = stats.star1Completion and stats.oldStars < 1 and not levelBeat
		local lostStar2 = stats.star2Completion and stats.oldStars < 2 and not levelBeat
		local lostStar3 = stats.star3Completion and stats.oldStars < 3 and not levelBeat

		if(lostStar1 or lostStar2 or lostStar3)then
			PlaySound("sci_fi_lose_02.ogg")
		end

		PlaySound("Cascade_Aw.ogg")
	end

    ScriptDelay(500)
	LoopSoundAsMusic("Cascade_GameOverMusic.mp3")

	if (LAB_EVENT_MGR:GetTimeRemainingText(false) == "00:00:00") then
		dialog.MainPanel.MapButton_big:AddScript("DialogButtonGroove","DialogButtonGroove")
	else
		dialog.MainPanel.RetryButton:AddScript("DialogButtonGroove","DialogButtonGroove")
	end
end

Scripts.Preshow_GameOverDialog = function(dialog,gameScreen,isChallengeGame,stats,doShowQuickQuest,isQuickQuestComplete)
	local score = stats.score
	local goalScore = stats.goalScore

	-- Set things to not visible
	dialog.MainPanel.scoreContainer.score.bestStamp.visible = false
	dialog.MainPanel.goalScoreContainer.check.visible = false
	dialog.MainPanel.goalScoreContainer.X.visible = false

	--Set all values except score
	--These are set to -1 at start
	if(stats.oldDailyTop<0)then
		stats.oldDailyTop = 0
	end
	if(stats.oldPersonalBest<0)then
		stats.oldPersonalBest = 0
	end
	if(dialog.MainPanel.dailyBest) then
		dialog.MainPanel.dailyBest.text = Int2Comma(stats.oldDailyTop)
		dialog.MainPanel.dailyBest.bestStamp.visible = false
	end
	if(dialog.MainPanel.personalBest) then
		dialog.MainPanel.personalBest.text = Int2Comma(stats.oldPersonalBest)
		dialog.MainPanel.personalBest.bestStamp.visible = false
	end

	dialog.MainPanel.scoreContainer:SetScore(0)

	if(isChallengeGame)then


	-- DEBUG
	--[[
	stats.oldStars = 0
	stats.newStars = 3
	stats.star1Completion = true
	stats.star2Completion = true
	stats.star3Completion = true
	stats.mainCompletion = true
	--]]

		local goalContainer = dialog.MainPanel.goalScoreContainer
		goalContainer:SetScore(goalScore)

		if(stats.numberOfChallengesBeaten > stats.numberOfChallengesBeatenPrevious)then
			dialog.MainPanel.challengeBeat.text = Int2Comma(stats.numberOfChallengesBeatenPrevious)
		else
			dialog.MainPanel.challengeBeat.text = Int2Comma(stats.numberOfChallengesBeaten)
		end

		dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "Medal_big_off.png"
		dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "Medal_big_off.png"
		dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "Medal_big_off.png"
		dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star1GoalText
		dialog.MainPanel.GoalPanel.Requirement.visible = false -- Turned off for now

		local useGold = Config.GoldEnabled
		if(useGold) then
			for i = 1,3 do
				if(stats.oldStars < i) then
					dialog.MainPanel.GoalPanel["StarGoal" .. i].Gold.visible = true
				end
			end
		end
	else
		dialog.MainPanel.goalScoreContainer.visible = true
		dialog.MainPanel.goalScoreContainer.check.visible = false
		dialog.MainPanel.goalScoreContainer.score.text = STRINGS("Your Score:")
	end
end

Scripts.Present_GameOverDialog = function(dialog,gameScreen,isChallengeGame,stats)
	local score = stats.score
	local goalScore = stats.goalScore
	--logprint("Present_GameOverDialog: score:"..stats.score.." goalScore:"..stats.goalScore)
	--TEST
	--goalScore = 1000

	--Give time for it to come down
	ScriptDelay(500,"DialogTimers")

	--local discoBallFX = gameScreen:FindChild("discoBallFX",true)
	--discoBallFX.visible = true

	local tickSteps = 50
	local sfxIndex = 1
	local scoreContainer = dialog:FindChild("scoreContainer",true)
	for i = 1,tickSteps do
		local scoreFraction = score/tickSteps * i
		local scoreAmount = math.floor(scoreFraction)
		scoreContainer:SetScore(scoreAmount)
		if(step == 1) then
			if(scoreAmount ~= 0) then
				PlaySound("Cascade_Doop_"..sfxIndex..".ogg")
			end
		else
			if(scoreAmount ~= math.floor(score/tickSteps * (i-1))) then
				PlaySound("Cascade_Doop_"..sfxIndex..".ogg")
			end
		end
		sfxIndex = sfxIndex + 1
		if(sfxIndex==5)then sfxIndex = 1 end
		ScriptDelay(32)
	end

	local topBar = dialog.screen:FindChild("TopBar",true)

	local scoreBeaten = false
	if(isChallengeGame)then
		ScriptDelay(150)

		local useGold = Config.GoldEnabled
		local awardGold1 = stats.star1Completion and stats.oldStars < 1
		local awardGold2 = stats.star2Completion and stats.oldStars < 2
		local awardGold3 = stats.star3Completion and stats.oldStars < 3

		local starDelta = stats.newStars - stats.oldStars
		stats.currentStars = stats.currentStars - starDelta
		topBar.StarCardRankButton.NewMarker:SetScore(stats.currentStars,true)
		if(useGold) then
			topBar.GoldButton.NewMarker:SetScore(stats.oldGold,true)
		end

		local goldAnimationSpeed = 250

		--stats.star1Completion = true
		if(stats.star1Completion) then
			dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star2GoalText
			dialog.MainPanel.GoalPanel.StarGoal1.Star.alpha = 255
			dialog.MainPanel.GoalPanel.StarGoal1.Star.image = "Medal_big_bronze.png"
			--StarBig@2x
			PlaySound("pop_sparkle_01.ogg")
			PlaySound("slot_machine_win_05.ogg")
			FireParticle(dialog.MainPanel.GoalPanel.StarGoal1.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
			Pop(dialog.MainPanel.GoalPanel.StarGoal1.Star)
			dialog.MainPanel.GoalPanel.StarGoal1.Star:AddScript("JelloSquare","Star")
			dialog.MainPanel.GoalPanel.StarGoal1.Star:AddScript("SparkleLoop","Star")
			dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star2GoalText
			if(awardGold1) then
				local treasureDest = topBar.globalPosition
				treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal1.Gold.size.x/2
				treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal1.Gold.size.y/2

				local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal1.Gold,"GoldSparkleTrail1")
				PlaySound("coin_magic_03.ogg")
				PlaySound("swish05.ogg")
				dialog.MainPanel.GoalPanel.StarGoal1.Gold.zorder = 12
				Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal1.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
				stats.oldGold = stats.oldGold + Config.GoldAward_Challenge_Star1
				topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
				dialog.MainPanel.GoalPanel.StarGoal1.Gold.alpha  = 0  -- so the actor disappears but the particle child trail is still visible
				PlaySound("coin_magic_06.ogg")
				FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
				trail:Pause()
				topBar:AddScript("Animate_UpAndDown","")
				ScriptDelay(500)
			else
				ScriptDelay(500)
			end
		end

		--stats.star2Completion = true
		if(stats.star2Completion) then
			dialog.MainPanel.GoalPanel.Requirement.Text.visible = false -- turned off
			dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star3GoalText
			dialog.MainPanel.GoalPanel.StarGoal2.Star.alpha = 255
			dialog.MainPanel.GoalPanel.StarGoal2.Star.image = "Medal_big_silver.png"
			PlaySound("pop_sparkle_01.ogg")
			PlaySound("slot_machine_win_06.ogg")
			FireParticle(dialog.MainPanel.GoalPanel.StarGoal2.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
			Pop(dialog.MainPanel.GoalPanel.StarGoal2.Star)
			dialog.MainPanel.GoalPanel.StarGoal2.Star:AddScript("JelloSquare","Star")
			dialog.MainPanel.GoalPanel.StarGoal2.Star:AddScript("SparkleLoop","Star")
			dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("Next Star: ")..stats.star3GoalText
			if(awardGold2) then
				local treasureDest = topBar.globalPosition
				treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal2.Gold.size.x/2
				treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal2.Gold.size.y/2

				local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal2.Gold,"GoldSparkleTrail1")

				PlaySound("coin_magic_03_2.ogg")
				PlaySound("swish05.ogg")
				dialog.MainPanel.GoalPanel.StarGoal2.Gold.zorder = 12
				ScaleOut(dialog.MainPanel.GoalPanel.StarGoal2.Gold,{0.25,0.25},goldAnimationSpeed,false)
				Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal2.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
				stats.oldGold = stats.oldGold + Config.GoldAward_Challenge_Star2
				topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
				dialog.MainPanel.GoalPanel.StarGoal2.Gold.alpha = 0
				PlaySound("coin_magic_06.ogg")
				FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow","Center",dialog.hgeParticles)
				trail:Pause()
				topBar:AddScript("Animate_UpAndDown","")
				ScriptDelay(500)
			else
				ScriptDelay(500)
			end
		end
		--stats.star3Completion = true
		if(stats.star3Completion) then
			dialog.MainPanel.GoalPanel.Requirement.Text.visible = false -- turned off
			dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("")
			dialog.MainPanel.GoalPanel.StarGoal3.Star.alpha = 255
			dialog.MainPanel.GoalPanel.StarGoal3.Star.image = "Medal_big_gold.png"
			PlaySound("pop_sparkle_01.ogg")
			PlaySound("slot_machine_win_03.ogg")
			FireParticle(dialog.MainPanel.GoalPanel.StarGoal3.Star,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
			Pop(dialog.MainPanel.GoalPanel.StarGoal3.Star)
			dialog.MainPanel.GoalPanel.StarGoal3.Star:AddScript("JelloSquare","Star")
			dialog.MainPanel.GoalPanel.StarGoal3.Star:AddScript("SparkleLoop","Star")
			dialog.MainPanel.GoalPanel.Requirement.Text.text = STRINGS("")
			if(awardGold3) then
				local treasureDest = topBar.globalPosition
				treasureDest.x = treasureDest.x + topBar.size.x/2 - dialog.MainPanel.GoalPanel.StarGoal3.Gold.size.x/2
				treasureDest.y = treasureDest.y + topBar.size.y/2 - dialog.MainPanel.GoalPanel.StarGoal3.Gold.size.y/2

				local trail = AddTrail_dialog(dialog.MainPanel.GoalPanel.StarGoal3.Gold,"GoldSparkleTrail1")

				PlaySound("coin_magic_03_7.ogg")
				PlaySound("swish05.ogg")
				dialog.MainPanel.GoalPanel.StarGoal3.Gold.zorder = 12
				ScaleOut(dialog.MainPanel.GoalPanel.StarGoal3.Gold,{0.25,0.25},goldAnimationSpeed,false)
				Scripts.Interpolate(dialog.MainPanel.GoalPanel.StarGoal3.Gold, "globalPosition", treasureDest, goldAnimationSpeed)
				stats.oldGold = stats.oldGold + Config.GoldAward_Challenge_Star3
				topBar.GoldButton.NewMarker:SetScore(stats.oldGold,false)
				dialog.MainPanel.GoalPanel.StarGoal3.Gold.alpha = 0
				PlaySound("coin_magic_06.ogg")
				FireParticle(topBar.GoldButton.NewMarker,"StarToss1.bigger.yellow.more","Center",dialog.hgeParticles)
				trail:Pause()
				topBar:AddScript("Animate_UpAndDown","")
				ScriptDelay(500)
			else
				ScriptDelay(500)
			end
		end

		if(useGold) then
			if(awardGold1)then
				dialog.MainPanel.GoalPanel.StarGoal1.Gold.visible = false
			end
			if(awardGold2)then
				dialog.MainPanel.GoalPanel.StarGoal2.Gold.visible = false
			end
			if(awardGold3)then
				dialog.MainPanel.GoalPanel.StarGoal3.Gold.visible = false
			end
		end

		local goalScoreContainer = dialog:FindChild("goalScoreContainer",true)

		if(score>=goalScore)then
            scoreBeaten = true
			PlaySound("Magic_SpeedPickup.ogg")
			FadeIn(goalScoreContainer.check,500)
			ScaleIn(goalScoreContainer.check,{2.0,2.0},500,true)
			StopSound("Magic_SpeedPickup.ogg")
			PlaySound("Magic_Respawn38.ogg")
            FireParticle(goalScoreContainer.check,"StarToss1.smaller","Center",dialog.hgeParticles)
            FireParticle(goalScoreContainer.check,"SparkleBurst1","Center",dialog.hgeParticles)
			FireParticle(goalScoreContainer.check,"Shine2","Center",dialog.hgeParticles)
			Pop(goalScoreContainer.check)
			ScriptDelay(50)
			StartParticleEmitterFromFile({targetParticleLayer = dialog.hgeParticles,file="Sparks1.guru_particle",position=goalScoreContainer.position})
			PlaySound("slot_machine_spin_04_short.ogg")
			ScriptDelay(1300)
			PlaySound("slot_machine_win_19.ogg")
			ScriptDelay(300)
			PlaySound("Cascade_Boom.ogg")
		end
	end

	if((not isChallengeGame))then
		if(stats.mainCompletion)then
			PlaySound("BlingBling.ogg")
			dialog.MainPanel.GoalPanel.LevelObjective.Check.visible = true
			Pop(dialog.MainPanel.GoalPanel.LevelObjective.Check)
		else
			PlaySound("OING_A.ogg")
			dialog.MainPanel.GoalPanel.LevelObjective.X.visible = true
			Pop(dialog.MainPanel.GoalPanel.LevelObjective.X)
		end
	end

	--logprint("All best score: " .. stats.oldTopScore .. " This game: " .. score)

	--logprint(">> stats.score "..stats.score)
	--logprint("Daily best score: " .. stats.oldDailyTop .. " This game: " .. stats.score)
	local dailyBest = false
	if(stats.score > stats.oldDailyTop)then
		scoreBeaten = true
		dailyBest = true
		dialog.MainPanel.dailyBest.text = Int2Comma(stats.score)
		dialog.MainPanel.dailyBest.bestStamp.image = "dailybest.png"
		PlaySound("pop_sparkle_01.ogg")
		FireParticle(dialog.MainPanel.dailyBest.bestStamp,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
		Pop(dialog.MainPanel.dailyBest.bestStamp)
	end

	if((not isChallengeGame))then
		--logprint("Personal best score: " .. stats.oldPersonalBest .. " This game: " .. stats.score)
		local personalBest = false
		if(stats.score > stats.oldPersonalBest)then
			scoreBeaten = true
			personalBest = true
			dialog.MainPanel.personalBest.text = Int2Comma(stats.score)
			dialog.MainPanel.personalBest.bestStamp.image = "mybest.png"
			--dialog.personalBest.bestStamp.size = {52/ScreenScaleFactor,50/ScreenScaleFactor}
			PlaySound("pop_sparkle_01.ogg")
			FireParticle(dialog.MainPanel.personalBest.bestStamp,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
			Pop(dialog.MainPanel.personalBest.bestStamp)
		end
	end

	if(isChallengeGame)then
		local numberOfChallengesBeatenPrevious = stats.numberOfChallengesBeatenPrevious
		local numberOfChallengesBeaten = stats.numberOfChallengesBeaten
		--logprint("numberOfChallengesBeatenPrevious "..numberOfChallengesBeatenPrevious.."numberOfChallengesBeaten "..numberOfChallengesBeaten)
		if(numberOfChallengesBeaten > numberOfChallengesBeatenPrevious)then
			dialog.MainPanel.challengeBeat.text = Int2Comma(numberOfChallengesBeaten)
			PlaySound("pop_sparkle_01.ogg")
			FireParticle(dialog.MainPanel.challengeBeat,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
			Pop(dialog.MainPanel.challengeBeat)
		end
	end

	if(scoreBeaten)then
		PlaySound("slot_machine_win_24.ogg")
		ScriptDelay(1000)
		-- Play sound based on how much they beat their previous best

		local scoreBeatenByAmount = 1.0
		if(isChallengeGame)then
			--logprint("score "..score)
			--logprint("goalScore "..goalScore)
			scoreBeatenByAmount = (score / goalScore)
		elseif(stats.oldDailyTop)then
			--logprint("score "..score)
			--logprint("stats.oldDailyTop "..stats.oldDailyTop)
			scoreBeatenByAmount = (score / stats.oldDailyTop)
		end

		--logprint("goalScore "..goalScore)
		--logprint("scoreBeatenByAmount "..scoreBeatenByAmount)
		if(scoreBeatenByAmount>=3.0)then
			PlaySound("Cascade_Outrageous.ogg")
		elseif(scoreBeatenByAmount>=2.5)then
			PlaySound("Cascade_Amazing.ogg")
		elseif(scoreBeatenByAmount>=2)then
			PlaySound("Cascade_Fantastic.ogg")
		elseif(scoreBeatenByAmount>=1.5)then
			PlaySound("Cascade_Awesome.ogg")
		elseif(scoreBeatenByAmount>=1)then
			PlaySound("Cascade_RightOn.ogg")
		end
	else
		if(isChallengeGame)then
			PlaySound("soft_lose_02.ogg")
			ScriptDelay(1000)
			PlaySound("Cascade_Aw.ogg")
		end
	end

    ScriptDelay(500)
	LoopSoundAsMusic("Cascade_GameOverMusic.mp3")
end


--
-- Drops a dialog from the top of the screen.
--
Scripts.DropDialog = function (dialog)
	local originalPosition = dialog.position
	-- Show the dialog
	dialog.visible = true

	-- Place the dialog just above the screen
	local height = dialog.size.y
	dialog.position = {originalPosition.x, -height}
    dialog:UploadImagesToVidmem()
	--ScriptDelay(150,"DialogTimers") -- Give some time to see if this fixes hitch

	-- Slide it downwards
	SlideAndWait(dialog, {originalPosition.x, originalPosition.y + 10}, DIALOG_SLIDE_SPEED)
	--PlaySound("Start Button Appears 69a.ogg")
	SlideAndWait(dialog, originalPosition, DIALOG_SLIDE_SPEED/2)
	--PlaySound("Start Button Appears 69b.ogg")

    if IsFunction(dialog.ShowOrHideOnScreenKeyboard) then
        dialog.allowOnScreenKeyboard = true
        dialog:ShowOrHideOnScreenKeyboard()
    end
end

Scripts.SlideUpDialog_TopBar = function(dialog)
	dialog:AddScript("ShowTopBarFromDialog","ShowTopBarFromDialog")
	--Scripts.ShowTopBarFromDialog(dialog)
	Scripts.SlideUpDialog(dialog)
end

Scripts.DropDialog_TopBar = function(dialog)
	dialog:AddScript("ShowTopBarFromDialog","ShowTopBarFromDialog")
	--Scripts.ShowTopBarFromDialog(dialog)
	Scripts.DropDialog(dialog)
end

Scripts.DropDialog_TopBar_SpecialGems = function(dialog)
	Scripts.ShowSpecialGemsTopBarFromDialog(dialog)
	Scripts.DropDialog(dialog)
end

--
-- Drops a dialog from the top of the screen.
--
Scripts.SlideDownIntroDialog = function (dialog)
	local originalPosition = dialog.position
	-- Show the dialog
	dialog.visible = true

	-- Place the dialog just above the screen
	local height = dialog.size.y
	dialog.position = {originalPosition.x, -height}
    dialog:UploadImagesToVidmem()
	--ScriptDelay(150,"DialogTimers") -- Give some time to see if this fixes hitch

	SlideAndWait(dialog, {originalPosition.x, originalPosition.y + 10}, DIALOG_SLIDE_SPEED)
	SlideAndWait(dialog, originalPosition, DIALOG_SLIDE_SPEED/2)

	if IsFunction(dialog.ShowOrHideOnScreenKeyboard) then
        dialog.allowOnScreenKeyboard = true
        dialog:ShowOrHideOnScreenKeyboard()
    end
end

--
-- Drops a dialog from the top of the screen.
--
Scripts.SlideDownIntroDialog_TopBar = function (dialog)
	dialog:AddScript("ShowTopBarFromDialog","ShowTopBarFromDialog")
	--Scripts.ShowTopBarFromDialog(dialog)
	Scripts.SlideDownIntroDialog(dialog)
end

Scripts.SlideUpDialog = function (dialog)
	local originalPosition = dialog.position
	-- Show the dialog
	dialog.visible = true

	-- Place the dialog just below the screen
	local screen = CurrentScreen()
	local screen_bottom = screen.size.y
	local height = dialog.size.y
	dialog.position = {originalPosition.x, screen_bottom}
    dialog:UploadImagesToVidmem()
	--ScriptDelay(150,"DialogTimers") -- Give some time to see if this fixes hitch

	SlideAndWait(dialog, {originalPosition.x, originalPosition.y - 10},DIALOG_SLIDE_SPEED)
	SlideAndWait(dialog, originalPosition, DIALOG_SLIDE_SPEED/2)

    if IsFunction(dialog.ShowOrHideOnScreenKeyboard) then
        dialog.allowOnScreenKeyboard = true
        dialog:ShowOrHideOnScreenKeyboard()
    end
end

Scripts.SlideFromRightDialog = function (dialog)
	local originalPosition = dialog.position
	-- Show the dialog
	dialog.visible = true

	-- Place the dialog just to left of the screen
	local height = dialog.size.y
	local width = dialog.size.x
	dialog.position = {width*2, originalPosition.y}
    dialog:UploadImagesToVidmem()
	--ScriptDelay(150,"DialogTimers") -- Give some time to see if this fixes hitch

	SlideAndWait(dialog, {originalPosition.x - 10, originalPosition.y}, DIALOG_SLIDE_SPEED)
	SlideAndWait(dialog, originalPosition, DIALOG_SLIDE_SPEED/2)

    if IsFunction(dialog.ShowOrHideOnScreenKeyboard) then
        dialog.allowOnScreenKeyboard = true
        dialog:ShowOrHideOnScreenKeyboard()
    end
end

Scripts.SlideFromLeftDialog = function (dialog)
	local originalPosition = dialog.position
	-- Show the dialog
	dialog.visible = true

	-- Place the dialog just to left of the screen
	local height = dialog.size.y
	local width = dialog.size.x
	dialog.position = {-width*2, originalPosition.y}
    dialog:UploadImagesToVidmem()
	--ScriptDelay(150,"DialogTimers") -- Give some time to see if this fixes hitch

	SlideAndWait(dialog, {originalPosition.x + 10, originalPosition.y}, DIALOG_SLIDE_SPEED)
	SlideAndWait(dialog, originalPosition, DIALOG_SLIDE_SPEED/2)

    if IsFunction(dialog.ShowOrHideOnScreenKeyboard) then
        dialog.allowOnScreenKeyboard = true
        dialog:ShowOrHideOnScreenKeyboard()
    end
end

Scripts.SlideOnTwoPanelsDialog = function (dialog)
	local MainPanel_originalPosition = dialog.MainPanel.position
	local TopTenPanel_originalPosition = dialog.TopTenPanel.position

	-- Place the dialog just above the screen
	local height = dialog.size.y
	local screen = CurrentScreen()
	local screen_bottom = screen.size.y

	-- Adjust manually to handle screen sizes, converting local to global
	local TopTenPanel_globalPosition = TopTenPanel_originalPosition
	TopTenPanel_globalPosition.y = screen_bottom - (dialog.TopTenPanel.size.y)
	local newLocal = dialog:GlobalToLocalCoord(TopTenPanel_globalPosition)
	TopTenPanel_originalPosition.y = newLocal.y

	dialog.MainPanel.position = {MainPanel_originalPosition.x, -height}
	dialog.TopTenPanel.position = {TopTenPanel_originalPosition.x, screen_bottom}

    dialog:UploadImagesToVidmem()
	-- Give some time to see if this fixes hitch
	ScriptDelay(150,"DialogTimers")

	-- Show the dialog
	dialog.visible = true

	local duration = DIALOG_SLIDE_SPEED
	dialog.MainPanel:SlideTo(MainPanel_originalPosition, duration)
	dialog.TopTenPanel:SlideTo(TopTenPanel_originalPosition, duration)
	ScriptDelay(duration,"DialogTimers")

    if IsFunction(dialog.ShowOrHideOnScreenKeyboard) then
        dialog.allowOnScreenKeyboard = true
        dialog:ShowOrHideOnScreenKeyboard()
    end
end

Scripts.SlideOnTwoPanelsDialog_TopBar = function (dialog)
	Scripts.SlideOnTwoPanelsDialog(dialog)
	--Scripts.ShowTopBarFromDialog(dialog)
	dialog:AddScript("ShowTopBarFromDialog","ShowTopBarFromDialog")
end

-- Bind DropDialog to DefaultDialogIntroScript
Scripts.DefaultDialogIntroScript = "SlideUpDialog"

--
-- RaiseDialog script
--
-- Raises a dialog to the top of the screen, where it is then destroyed.
--
Scripts.RaiseDialog = function (dialog)
	local height = dialog.size.y
	local position = dialog.position
	--SlideAndWait(dialog, {position.x, position.y + 10}, DIALOG_SLIDE_SPEED/2)
	SlideAndWait(dialog, {position.x, -height}, DIALOG_SLIDE_SPEED/2)
end

Scripts.RaiseDownDialog = function (dialog)
	local height = dialog.size.y
	local position = dialog.position
	local screen = CurrentScreen()
	local screen_bottom = screen.size.y
	--SlideAndWait(dialog, {position.x, position.y - 10}, DIALOG_SLIDE_SPEED/2)
	SlideAndWait(dialog, {position.x, screen_bottom}, DIALOG_SLIDE_SPEED/2)
end

Scripts.RaiseDownDialog_TopBar = function(dialog)
	dialog:AddScript("HideTopBarFromDialog","HideTopBarFromDialog")
	--Scripts.HideTopBarFromDialog(dialog)
	Scripts.RaiseDownDialog(dialog)
end

Scripts.RaiseDialog_TopBar = function(dialog)
	dialog:AddScript("HideTopBarFromDialog","HideTopBarFromDialog")
	--Scripts.HideTopBarFromDialog(dialog)
	Scripts.RaiseDialog(dialog)
end

Scripts.RaiseDialog_TopBar_SpecialGems = function(dialog)
	dialog:AddScript("HideSpecialGemsTopBarFromDialog","HideSpecialGemsTopBarFromDialog")
	--Scripts.HideSpecialGemsTopBarFromDialog(dialog)
	Scripts.RaiseDialog(dialog)
end

Scripts.SlideOffIntroDialog = function (dialog)
	local height = dialog.size.y
	local position = dialog.position
	SlideAndWait(dialog, {position.x, -height}, DIALOG_SLIDE_SPEED/2)
end

Scripts.SlideOffIntroDialog_TopBar = function (dialog)
	dialog:AddScript("HideTopBarFromDialog","HideTopBarFromDialog")
	--Scripts.HideTopBarFromDialog(dialog)
	Scripts.SlideOffIntroDialog(dialog)
end

Scripts.SlideDownDialog = function (dialog)
	local height = dialog.size.y
	local position = dialog.position
	local screen = CurrentScreen()
	local screen_bottom = screen.size.y
	SlideAndWait(dialog, {position.x, screen_bottom}, DIALOG_SLIDE_SPEED)
end

Scripts.SlideOffLeftDialog = function (dialog)
	local height = dialog.size.y
	local width = dialog.size.x
	local position = dialog.position
	local screen = CurrentScreen()
	local screen_right = screen.size.x
	SlideAndWait(dialog, {screen_right, position.y}, DIALOG_SLIDE_SPEED/2)
end

Scripts.SlideOffRightDialog = function (dialog)
	local height = dialog.size.y
	local width = dialog.size.x
	local position = dialog.position
	SlideAndWait(dialog, {-width, position.y}, DIALOG_SLIDE_SPEED/2)
end

Scripts.SlideDownDialogFreePowerup = function (dialog)
	local height = dialog.size.y
	local position = dialog.position

	local powerupImage = dialog.PowerupImage
	local screen = dialog.parent
	local otherDialog = screen.StartQuestGameDialog

	if(otherDialog ~= nil) then
		powerupImage.parent:RemoveChild(powerupImage)
		otherDialog:AddChild(powerupImage)
		powerupImage.layer = 2020
		otherDialog:AddScript("BoostAcquired","BoostAcquired")
	else
		--I think I'm a trick.
		powerupImage.parent:RemoveChild(powerupImage)
		powerupImage.powerupName = dialog.powerupName
		screen:AddChild(powerupImage)
		powerupImage.layer = 2020
		screen:AddScript("TrickAcquired","TrickAcquired")
		--Attach to screen.
	end
	local screen = CurrentScreen()
	local screen_bottom = screen.size.y
	SlideAndWait(dialog, {position.x, screen_bottom}, DIALOG_SLIDE_SPEED)
end

Scripts.BoostAcquired = function(dialog)
	local boostPanel = dialog.MainPanel.BoostPanel
	local flyingBoost = dialog.PowerupImage

	local acquiredBoost
	--Determine which boost was just acquired
	for boostNumber = 1,3 do
		local consideredBoost = boostPanel["Boost" .. boostNumber]
		if(consideredBoost.image == flyingBoost.image) then
			acquiredBoost = consideredBoost
		end
	end

	acquiredBoost.visible = false

	PlaySound("slot_machine_jackpot_win_loop.ogg")
	--ScriptDelay(500,"dialogTimers")
	Scripts.Interpolate(flyingBoost, "globalPosition", acquiredBoost.globalPosition, 500)
	flyingBoost:Destroy()
	acquiredBoost.visible = true
	StopSound("slot_machine_jackpot_win_loop.ogg")
	PlaySound("slot_machine_jackpot_win_hit1.ogg")
	FireParticle(acquiredBoost,"StarToss1.smaller","Center",dialog.hgeParticles)
	FireParticle(acquiredBoost,"SparkleBurst1","Center",dialog.hgeParticles)
	FireParticle(acquiredBoost,"Shine2","Center",dialog.hgeParticles)
	Pop(acquiredBoost)
end

Scripts.TrickAcquired = function(screen)
	local trickPanel = screen:FindChild("TrickPanel",true)
	local flyingTrick = screen.PowerupImage

	flyingTrick:KillAllScripts() --gets rid of dance

	local acquiredTrick
	--Determine which boost was just acquired
	for trickNumber = 1,3 do
		local consideredTrick = trickPanel["Trick" .. trickNumber .. "Container"].Trick
		if(consideredTrick.trickName == flyingTrick.powerupName) then
			acquiredTrick = consideredTrick
		end
	end

	acquiredTrick.visible = false

	PlaySound("slot_machine_jackpot_win_loop.ogg")
	--ScriptDelay(500,"dialogTimers")

	local slideDestination = acquiredTrick.globalPosition
	local sizeDifference = {x = flyingTrick.size.x - acquiredTrick.size.x, y = flyingTrick.size.y - acquiredTrick.size.y}
	slideDestination.x = slideDestination.x - sizeDifference.x/2
	slideDestination.y = slideDestination.y - sizeDifference.y/2

	ScaleOut(flyingTrick,{0.5,0.5},500,"nowait")
	Scripts.Interpolate(flyingTrick, "globalPosition", slideDestination, 500)
	acquiredTrick.visible = true
	flyingTrick:Destroy()
	StopSound("slot_machine_jackpot_win_loop.ogg")
	PlaySound("slot_machine_jackpot_win_hit1.ogg")
	FireParticle(acquiredTrick,"StarToss1.smaller","Center")
	FireParticle(acquiredTrick,"SparkleBurst1","Center")
	FireParticle(acquiredTrick,"Shine2","Center")
	Pop(acquiredTrick)
end

Scripts.SlideOffTwoPanelsDialog = function (dialog)
	local height = dialog.size.y
	local MainPanel_originalPosition = dialog.MainPanel.position
	local TopTenPanel_originalPosition = dialog.TopTenPanel.position

	local duration = DIALOG_SLIDE_SPEED/2
	local screen = CurrentScreen()
	local screen_bottom = screen.size.y
	dialog.MainPanel:SlideTo( {MainPanel_originalPosition.x, -height-50}, duration)
	dialog.TopTenPanel:SlideTo( {TopTenPanel_originalPosition.x, screen_bottom}, duration)
	ScriptDelay(duration*2,"DialogTimers")
end

Scripts.SlideOffTwoPanelsDialog_TopBar = function (dialog)
	dialog:AddScript("HideTopBarFromDialog","HideTopBarFromDialog")
	--Scripts.HideTopBarFromDialog(dialog)
	Scripts.SlideOffTwoPanelsDialog(dialog)
	--ScriptDelay(DIALOG_SLIDE_SPEED,"DialogTimers")

end

Scripts.SlideUpFromBottomDialog = function (dialog)
	--PlaySound("swish05.ogg")
	PlaySound("slot_machine_spin_stop_10.ogg")
	local originalPosition = dialog.position

	-- Place the dialog just below the screen
	local height = dialog.size.y
	dialog.position = {originalPosition.x, originalPosition.y+height}

	-- Show the dialog
	dialog.visible = true

	-- Slide it upwards
	SlideAndWait(dialog, {originalPosition.x, originalPosition.y}, 150)
	--PlaySound("Start Button Appears 69a.ogg")
	--PlaySound("slot_machine_spin_stop_10.ogg")
	--PlaySound("Click6.ogg")

	SlideAndWait(dialog, {originalPosition.x, originalPosition.y + 4}, 50)
	--PlaySound("Start Button Appears 69b.ogg")

    if IsFunction(dialog.ShowOrHideOnScreenKeyboard) then
        dialog.allowOnScreenKeyboard = true
        dialog:ShowOrHideOnScreenKeyboard()
    end
end

Scripts.SlideDownFromBottomDialog = function (dialog)
	PlaySound("swish10.ogg")
	local originalPosition = dialog.position

	-- Place the dialog just below the screen
	local height = dialog.size.y

	-- Show the dialog
	dialog.visible = true

	-- Slide it downwards
	SlideAndWait(dialog, {originalPosition.x, originalPosition.y-4}, 50)
	--PlaySound("Start Button Appears 69a.ogg")
	SlideAndWait(dialog, {originalPosition.x, originalPosition.y+height}, 100)
	--PlaySound("Start Button Appears 69b.ogg")

end

-- Bind RaiseDialog to DefaultDialogExitScript
Scripts.DefaultDialogExitScript = "SlideDownDialog"



Resources.CreditTextLabel = Resources.AppDialogLabel:new
{
	resource = "AppDialogLabel",
	alignment = Center,
	alignTo = Center,
	alignmentOffset = {x = 0, y = 100, },
	widthLimit = 250,
	font	= Resources.DialogFont:new{
		resource = "DialogFont",
		fontSize = 22,
	},
}

Resources.CreditsDialog = Resources.LargeLongerDialog:new
{
	resource = "LargeLongerDialog",
	image = "DialogGeneric_Large.png",
	title = "",
    titleText = Resources.AppTitleDialogLabel:new {
    	resource = "AppTitleDialogLabel",
    	text = STRINGS("CREDITS"),
    	alignment = MidTop,
    	alignmentOffset = {0, 50},
    },
	pageContent = Resources.Actor:new
	{
		alignment = MidTop,
		alignTo = MidTop,
		alignmentOffset = {0,-100},
	},
	pages =
	{
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Designed And Directed By\nDavid Walls"),
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Executive Producer\nScott Balaban"),
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("ProgrammerCredits"),
				textAlignment = MidLeft,
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Android Developer\nEmmanuel Marty"),
				textAlignment = MidLeft,
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Producer\nMark Janecka\n\nProduct Manager\nDiana Hsu\n\nProduct Marketing Manager\nAshley Davidson"),
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Art\n\nRon Crabb\nSandie Chun\nSoi Che\nMichelle Martins\nLou Catanzaro"),
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Sound & Music\n\nSean Hoffman"),
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Funkitron QA\n\nPhelan Wolfendon\n\nLord GEK"),
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("QAPart1"),
                heightLimit = 250,
				alignmentOffset = {0, 110},
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("QAPart2"),
                heightLimit = 250,
				alignmentOffset = {0, 110},
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Special Thanks To:\n\nDan Rose\nValerie Walls\nSusan Ludwig\nVern Ludwig\nTamar Wallace\nJohn Kniespeck"),
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("Special Thanks To:\n\nJessica Sachs\nChris Williams\nPaul Thelen"),
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("AcknowledgementsDescription", "Portions of this app may\nutilize various open-source\nsoftware libraries.\n\nMany thanks go out\nto the authors\nof these libraries!"),
			},
			acknowledgementsButton = Resources.AppButtonMediumSmall:new {
				resource = "AppButtonMediumSmall",
				alignment = MidBottom,
				alignmentOffset = {0,0},
				text = STRINGS("Acknowledgements"),
				OnPostSpawn = function (self)
					self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
				end,
				OnButtonClick = function (self, event)
					if event.button ~= self then
						return
					end
					OpenWebPage("guru:LibraryLicenses")
				end,
			},
		},
		Resources.Actor:new
		{
			mainText = Resources.CreditTextLabel:new
			{
				resource = "CreditTextLabel",
				text = STRINGS("CopyrightText"),
                heightLimit = 250,
				alignmentOffset = {0,110},
			},
		},
	},

	--[[
	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y},
		text = STRINGS("Okay"),
		--image = "btnOkay.png",
		--text = STRINGS(""),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
		zorder = 2,
	},
	--]]

	OkayButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	NextButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = BottomRight,
		alignmentOffset = {-15,LargeLonger_Dialog_Button_Y},
		text = STRINGS("next"),
		--image = "btnNext.png",
		--text = STRINGS(""),
		shortcutKey = "N",
        textWidthLimit = 80,
	},

	PrevButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = BottomLeft,
		alignmentOffset = {15,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Prev"),
		--image = "btnPrev.png",
		--text = STRINGS(""),
		shortcutKey = "P",
	},
}


local slotFieldTop = 175
local slotOffset = 16
local leftSlotRequirementsOffset = 0
local rightSlotRequirementsOffset = 5
local fieldSlotRequirementSpacing = 25

Resources.PlayerStatDialogLabel = Resources.DialogLabel:new {
	resource = "DialogLabel",
	font = Resources.DialogFont:new {
		resource = "DialogFont",
		fontSize = 20,
	},
	alignTo = MidTop,
	visible = false,
}

Resources.LeftPlayerStatDialogLabel = Resources.PlayerStatDialogLabel:new {
	resource = "PlayerStatDialogLabel",
	text = STRINGS("RightSide"),
	alignment = MidRight,
	--aligner = {class="Actor", size={144, 20}, color="Green", alpha=128, alignment=MidRight,},
	widthLimit = 165,
}

Resources.RightPlayerStatDialogLabel = Resources.PlayerStatDialogLabel:new {
	resource = "PlayerStatDialogLabel",
	text = STRINGS("LeftSide"),
	alignment = MidLeft,
	--aligner = {class="Actor", size={144, 20}, color="Green", alpha=128, alignment=MidLeft,},
	widthLimit = 120,
}

Resources.PlayerDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "PlayerDialog",
	--title = "PLAYER STATS",
	title = "",
    name = "PlayerDialog",

    titlePanel = Resources.Actor:new {
		resource = "Actor",
		image = "titlePlayerStats.png",
		alignment = MidTop,
		alignmentOffset = {0, 80},
    },

    fieldNames = {
		{ "bestPlay", "Commodities" },
		{ "bestMultiplier", "Commodities" },
		{ "totalScore", "Commodities" },
		{ "matches", "Commodities" },
		{ "gems", "Commodities" },
		{ "diamonds", "Commodities" },
		{ "superWilds", "Commodities" },
		{ "keys", "Commodities" },
		{ "games", "Commodities" },
		{ "challenges", "Achievements" },
		--{ "levels", "Achievements" },
    },

	playerName = Resources.PlayerStatDialogLabel:new {
		resource = "PlayerStatDialogLabel",
		alignment = MidTop,
		alignmentOffset = {0, 160-30},
		text = STRINGS("Player"),
		visible = true,
		font = Resources.DialogFont:new {
			resource = "DialogFont",
			fontSize = 25,
		},
    },

	leftLabel1 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 0*fieldSlotRequirementSpacing},
    },

    rightLabel1 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 0*fieldSlotRequirementSpacing},
    },

	leftLabel2 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 1*fieldSlotRequirementSpacing},
    },

    rightLabel2 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 1*fieldSlotRequirementSpacing},
    },

	leftLabel3 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 2*fieldSlotRequirementSpacing},
    },

    rightLabel3 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 2*fieldSlotRequirementSpacing},
    },

	leftLabel4 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 3*fieldSlotRequirementSpacing},
    },

    rightLabel4 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 3*fieldSlotRequirementSpacing},
    },

	leftLabel5 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 4*fieldSlotRequirementSpacing},
    },

    rightLabel5 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 4*fieldSlotRequirementSpacing},
    },

	leftLabel6 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 5*fieldSlotRequirementSpacing},
    },

    rightLabel6 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 5*fieldSlotRequirementSpacing},
    },

	leftLabel7 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 6*fieldSlotRequirementSpacing},
    },

    rightLabel7 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 6*fieldSlotRequirementSpacing},
    },

	leftLabel8 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 7*fieldSlotRequirementSpacing},
    },

    rightLabel8 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 7*fieldSlotRequirementSpacing},
    },

	leftLabel9 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 8*fieldSlotRequirementSpacing},
    },

    rightLabel9 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 8*fieldSlotRequirementSpacing},
    },

	leftLabel10 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 9*fieldSlotRequirementSpacing},
    },

    rightLabel10 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 9*fieldSlotRequirementSpacing},
    },

	leftLabel11 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 10*fieldSlotRequirementSpacing},
    },

    rightLabel11 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 10*fieldSlotRequirementSpacing},
    },

	leftLabel12 = Resources.LeftPlayerStatDialogLabel:new {
		resource = "LeftPlayerStatDialogLabel",
		alignmentOffset = {leftSlotRequirementsOffset, slotFieldTop + 11*fieldSlotRequirementSpacing},
    },

    rightLabel12 = Resources.RightPlayerStatDialogLabel:new {
		resource = "RightPlayerStatDialogLabel",
		alignmentOffset = {rightSlotRequirementsOffset, slotFieldTop + 11*fieldSlotRequirementSpacing},
    },

	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignmentOffset = {-60/ScreenScaleFactor,LargeLong_Dialog_Button_Y},
		text = STRINGS("Okay"),
		--image = "btnOkay.png",
		--text = STRINGS(""),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
	},

	EditButton = Resources.DialogButton:new {
		resource = "DialogButton",
		text = STRINGS("Edit"),
		--image = "btnCredits.png",
		--text = STRINGS(""),
		shortcutKey = "C",
		alignment = BottomLeft,
		alignmentOffset = {60/ScreenScaleFactor,LargeLong_Dialog_Button_Y},
		--size = DialogButtonSize,
	},

	ResetPlayerButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = "TopRight",
		alignmentOffset = {-2, 132},
		text = STRINGS("demo reset"),
		visible = not IsAppDistributionPublicRelease(),
		font = Resources.AppButtonFont:new {
			resource = "AppButtonFont",
		},
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
		OnButtonClick = function (self, event)
			if event.button ~= self then
				return
			end

			-- Clear 'seen' values for the current player:
			for k,v in pairs(Players.current[1].Options) do
				if StringEndsWith(k, ".shown") then
					--logprintf("Clearing Player 'seen': '%s'\n", k)
					Players.current[1].Options[k] = nil
				end
			end

			-- Play a sound to indicate success:
			PlaySound("gametip.ogg")

			-- All done!
			return true
		end,
	},
}

Resources.InputLabel = Resources.DialogLabel:new {
	resource = "DialogLabel",
	fgColor = "Black",
	font = Resources.DialogFont:new{
		resource = "DialogFont",
		fontSize = 34,
	},
}

Resources.EditPlayerDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "EditPlayerDialog",
	title = "",
	name = "EditPlayerDialog",

    titlePanel = Resources.Actor:new {
		resource = "Actor",
		image = "titleWelcome.png",
		alignment = MidTop,
		alignmentOffset = {0, 80},
    },

	playerName = Resources.PlayerStatDialogLabel:new {
		resource = "PlayerStatDialogLabel",
		alignment = MidTop,
		alignmentOffset = {0, 160-20},
		text = STRINGS("Player"),
		visible = true,
		font = Resources.DialogFont:new {
			resource = "DialogFont",
			fontSize = 24,
		},
		visible = false,
    },

	signInLabel  = Resources.PlayerStatDialogLabel:new {
		resource = "PlayerStatDialogLabel",
		text = STRINGS("Please Sign In:"),
		alignment = "MidTop",
		alignmentOffset = {0, 400/ScreenScaleFactor},
		visible = true,
	},

	enterName = Resources.TextBox:new
	{
		limit = 16,
		boxSize = {180, 42},
		size = Layout {{180, 42}, ipad_half={90,21}},
		clickSound = "Click6.ogg",
		alignment = "MidTop",
		alignmentOffset = {0, 500/ScreenScaleFactor},
		alpha = 0,
		iBeamColor = "Black",
		labelProperties = "InputLabel",
		extraScale = Layout {1, ipad_half=0.5},
		background = {
			class = "Actor",
			zorder = -1,
			image = "textBox.png",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0,0},
			visible = true,
		},
	},

	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignmentOffset = {-60/ScreenScaleFactor,LargeLong_Dialog_Button_Y},
		text = STRINGS("Okay"),
		--image = "btnOkay.png",
		--text = STRINGS(""),
		enterKey = true,
		escapeKey = false,
		shortcutKey = "o",
		--size = DialogButtonSize,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}



Scripts.Preshow_AwardDialog = function(dialog)
	--dialog.awardImage.size = {130/ScreenScaleFactor,130/ScreenScaleFactor}
	--dialog.awardImage2.size = {130/ScreenScaleFactor,130/ScreenScaleFactor}
	--dialog.Text.alignmentOffset = {0,300}
	dialog.awardImage.visible = false
end


Scripts.Present_AwardDialog = function(dialog)


	PlaySound("Magic_SpeedPickup.ogg")
	FadeIn(dialog.awardImage,1200+100+50)
	ScaleIn(dialog.awardImage,{2.0,2.0},1200,false)
	RotateIn(dialog.awardImage,{revolutions=-0.25},1200,true)
	StopSound("Magic_SpeedPickup.ogg")
	PlaySound("Hit_KickPad2.ogg")
	PlaySound("Hit_MetalRobotPunch1.ogg")
	Pop(dialog.awardImage,{expandTo={1.1, 1.1},expandTime=100, shrinkTime=50})
	ScriptDelay(100)

	PlaySound("slot_machine_win_19.ogg")
	FireParticle(dialog.awardImage2,"StarToss1.smaller","Center",dialog.hgeParticles)
	FireParticle(dialog.awardImage2,"SparkleBurst1","Center",dialog.hgeParticles)
	FireParticle(dialog.awardImage2,"Shine2","Center",dialog.hgeParticles)

    ScriptDelay(500)
	PlaySound("slot_machine_win_24.ogg")

	PlaySound("crowd_indoor_cheer_02.ogg")

end

Resources.AwardDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "AwardDialog",
    title = "",
	--color = "Cascade_DarkPink",

    hgeParticles = {
		class = "hgeParticleLayer",
		position = {(578-800)/2,15},
		zorder = 10,
    },

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		--fgColor = "White",
		text = STRINGS("Right On!"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

	awardName = Resources.AppDialogBoldLabel:new { -- this is where my bug is!
		resource = "AppDialogBoldLabel",
		--fgColor = "White",
		wrapLimit = 295,
		text = STRINGS("AwardName"),
		textAlignment = "Center",
		alignment = MidTop,
		alignTo = MidTop,
		alignmentOffset = {0,90},--100
		visible = true,
	},

	awardImage = {
		class = "Actor",
		alignment = "MidTop",
		alignmentOffset = {0,145},
		shaderType = "SHADERTYPE_BLENDCOMBINEDALPHA",
		nameLabel = Resources.AwardNameLabel:new {
			resource = "AwardNameLabel",
		},
		zorder = 5,
		--size = {130/ScreenScaleFactor,130/ScreenScaleFactor},
	},
	awardImage2 = {
		class = "Actor",
		alignment = "MidTop",
		alignmentOffset = {0,145},
		shaderType = "SHADERTYPE_BLENDCOMBINEDALPHA",
		nameLabel = Resources.AwardNameLabel:new {
			resource = "AwardNameLabel",
		},
		--size = {130/ScreenScaleFactor,130/ScreenScaleFactor},
		visible = false
	},
	myText  = Resources.AppDialogBoldLabel:new {

        resource = "AppDialogBoldLabel",
		--fgColor = "White",
        wrapLimit = 200,
        heightLimit = 70,
		textAlignment = "Center",
		alignment = MidTop,
		alignTo = MidTop,
		alignmentOffset = {0,250},
		visible = true,
	},

	Status = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		--fgColor = "White",
		wrapLimit = 250,
		text = STRINGS("Insert real status text here"),
		textAlignment = "Center",
		alignment = "MidBottom",
		alignTo = "MidBottom",
		alignmentOffset = {0,-65},
	},
	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		--textColor = "White",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		--image = "btnOkay.png",
		--text = STRINGS(""),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
		zorder = 2,
	},
}


Resources.TipsDialog = Resources.LargeLongerDialog:new {
	name = "TipsDialog",
	resource = "LargeLongerDialog",
    title = "Game Tips",


    MainLabel = Resources.DialogTitleLabel:new {
		resource = "DialogTitleLabel",
		alignment = MidTop,
		textAlignment = "Center",
		alignTo = MidTop,
		alignmentOffset = {0,140},
		text = STRINGS("Want me to teach you\nhow to play Cascade?"),
		wrapLimit = 300,
    },

    YesButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = MidBottom,
		alignmentOffset = {Dialog_Button_Right,Dialog_Button_Y},
		text = STRINGS("Yes"),
		buttonClosesDialog = true,
		enterKey = true,
		shortcutKey = "Y",
    },

    NoButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = MidBottom,
		alignmentOffset = {Dialog_Button_Left,Dialog_Button_Y},
		text = STRINGS("No"),
		buttonClosesDialog = true,
		escapeKey = true,
		shortcutKey = "N",
    },

}

Resources.CascadeGameTipsDialog = Resources.LargeLongerDialog:new {
	class = "CascadeGameTipsDialog",
	name = "CascadeGameTipsDialog",
	resource = "LargeLongerDialog",
    title = "",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

	DialogCharacter = Resources.DialogCharacter:new {
		resource = "DialogCharacter",
		zorder = 1,
		alignTo = MidTop,
		alignmentOffset = {0,40},
		visible = true,
	},

	titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("OPTIONS"),
		alignment = MidTop,
		alignmentOffset = {0, 80},
		widthLimit = 290,
		wrapLimit = 290,
		heightLimit = 50,
    },

	equalText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("OPTIONS"),
		alignment = Center,
		alignmentOffset = {45, 0},
		text = STRINGS("="),
		visible = false,
    },

	titlePanel = Resources.Actor:new {
		resource = "Actor",
		alignment = MidTop,
		alignmentOffset = {0, 80},
		visible = false,
    },

    TipImage = Resources.Actor:new {
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,0},
		zorder = 1,
		extraScale = .75,
    },

    DescLabel = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		alignment =	Center,
		textAlignment = "Center",
		alignTo = Center,
		alignmentOffset = {0,120},
		text = STRINGS(""),
		wrapLimit = 290,
		heightLimit = 70,
    },

	DescLabelLeft = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		alignment =	Center,
		textAlignment = "Center",
		alignTo = Center,
		alignmentOffset = {-83,135},
		text = STRINGS(""),
		wrapLimit = 290,
    },

	DescLabelRight = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		alignment =	Center,
		textAlignment = "Center",
		alignTo = Center,
		alignmentOffset = {83,135},
		text = STRINGS(""),
		wrapLimit = 290,
    },

    SkipButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = {0,Dialog_Button_Y+10},
		text = STRINGS("Done"),
		buttonClosesDialog = true,
		escapeKey = true,
		shortcutKey = "O",
    },

     PreviousButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = {Dialog_Button_Left,Dialog_Button_Y+10},
		text = STRINGS("Prev"),
		shortcutKey = "P",
		visible = false,
    },

    NextButton = Resources.DialogButton:new {
		resource = "DialogButton",
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = {Dialog_Button_Right,Dialog_Button_Y+10},
		text = STRINGS("Next"),
		shortcutKey = "N",
        textWidthLimit = 80,
    },

	ImageHolder = Resources.Actor:new{
		resource = "Actor",
	}
}


Scripts.Preshow_PresentCascadeGameTips = function(game)
	local screen = game.parent
	--local logic = screen.logic

	local gameTips = DeepCopy(GameTipScripts[game.gameTips])
	--[[
	for package in pairs(UnlockList) do
		if(logic.features:HasPackage(package) and package ~= "Specials" and package ~= "ExtraSpecials")then
			local feature = UnlockList[package]
			local packageTip = {image = feature.image,
								text = feature.description,
								title = feature.singularName,}
			table.insert(gameTips,packageTip)
		elseif(logic.features:HasPackage(package) and (package == "Specials" or package == "ExtraSpecials"))then
			local packageTip = {image = "SpecialTip.png",
								text = STRINGS("Special pieces like the one above you cannot move, and you must find its counterpart to remove it for points!"),
								title = "Special Pieces",}
			table.insert(gameTips,packageTip)
		end
	end
	--]]

	game.tips = gameTips
	local gameTip = game.tips[game.index]
	game.TipImage.image = gameTip.image
	game.TipImage.size = gameTip.size
	game.TipImage.alignmentOffset = gameTip.alignmentOffset or {0,0}
	game.TipImage.zorder = 1
	game.DescLabel.text = gameTip.text or ""
	game.DescLabelLeft.text = gameTip.textLeft or ""
	game.DescLabelRight.text = gameTip.textRight or ""
	game.titleText.text = gameTip.title
	game.titlePanel.visible = false
	game.equalText.visible = gameTip.equals or false
	if(gameTip.titleImage)then
		game.titlePanel.image=gameTip.titleImage
		game.titlePanel.visible = true
		game.title = ""
	end
	if(gameTip.extraImages)then
		for key, item in pairs(gameTip.extraImages) do
			imageName = "image" .. key
			game.ImageHolder[imageName] = Resources.ExtraImage:new{
				resource = "ExtraImage",
				image = item.image,
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = item.alignmentOffset,
			}
			if (item.zorder) then
				game.ImageHolder[imageName].zorder = item.zorder
			end
			if (item.size) then
				game.ImageHolder[imageName].size = item.size
			end
		end
	end
end

Scripts.Present_PresentCascadeGameTips = function(game)
end

Scripts.Leave_PresentCascadeGameTips = function(game)
end


Scripts.Preshow_WaitForUserResponseCascadeGameTips = function(game)
end

Scripts.Present_WaitForUserResponseCascadeGameTips = function(game)
end

Scripts.Leave_WaitForUserResponseCascadeGameTips = function(game)
end




Scripts.Preshow_PreviousGameTip = function(game)
	game.index = game.index - 1
	if(game.index < 1)then
		game.index = 1
		game.PreviousButton.visible = false
	else
		local gameTip = game.tips[game.index]
		game.TipImage.image = gameTip.image
		game.TipImage.size = gameTip.size
		game.TipImage.alignmentOffset = gameTip.alignmentOffset or {0,0}
		game.DescLabel.text = gameTip.text or ""
		game.DescLabelLeft.text = gameTip.textLeft or ""
		game.DescLabelRight.text = gameTip.textRight or ""
		game.titleText.text = gameTip.title
		game.equalText.visible = gameTip.equals or false
		game.titlePanel.visible = false
		if(gameTip.titleImage)then
			game.titlePanel.image=gameTip.titleImage
			game.titlePanel.visible = true
			game.title = ""
		end

		game.NextButton.visible = true
		game.DialogCharacter.visible = true
		if(game.index == 1)then
			game.PreviousButton.visible = false
		end

		game.ImageHolder:DestroyAllChildren()
		if(gameTip.extraImages)then
			for key, item in pairs(gameTip.extraImages) do
				imageName = "image" .. key
				game.ImageHolder[imageName] = Resources.ExtraImage:new{
					resource = "ExtraImage",
					image = item.image,
					alignment = "Center",
					alignTo = "Center",
					alignmentOffset = item.alignmentOffset,
				}
				if (item.zorder) then
					game.ImageHolder[imageName].zorder = item.zorder
				end
				if (item.size) then
					game.ImageHolder[imageName].size = item.size
				end
			end
		end
	end
end

Scripts.Present_PreviousGameTip = function(game)
end

Scripts.Leave_PreviousGameTip = function(game)
end





Scripts.Preshow_NextGameTip = function(game)
	game.index = game.index + 1
	if(game.index > #game.tips)then
		game.index = #game.tips
		game.NextButton.visible = false
	else
		local gameTip = game.tips[game.index]
		game.TipImage.image = gameTip.image
		game.TipImage.size = gameTip.size
		game.TipImage.alignmentOffset = gameTip.alignmentOffset or {0,0}
		game.DescLabel.text = gameTip.text or ""
		game.DescLabelLeft.text = gameTip.textLeft or ""
		game.DescLabelRight.text = gameTip.textRight or ""
		game.titleText.text = gameTip.title
		game.equalText.visible = gameTip.equals or false
		game.titlePanel.visible = false
		if(gameTip.titleImage)then
			game.titlePanel.image=gameTip.titleImage
			game.titlePanel.visible = true
			game.title = ""
		end

		game.PreviousButton.visible = true
		if(game.index == #game.tips)then
			game.NextButton.visible = false
			game.DialogCharacter.visible = false
		end

		game.ImageHolder:DestroyAllChildren()
		if(gameTip.extraImages)then
			for key, item in pairs(gameTip.extraImages) do
				imageName = "image" .. key
				game.ImageHolder[imageName] = Resources.ExtraImage:new{
					resource = "ExtraImage",
					image = item.image,
					alignment = "Center",
					alignTo = "Center",
					alignmentOffset = item.alignmentOffset,
				}
				if (item.zorder) then
					game.ImageHolder[imageName].zorder = item.zorder
				end
				if (item.size) then
					game.ImageHolder[imageName].size = item.size
				end
			end
		end
	end
end

Scripts.Present_NextGameTip = function(game)
end

Scripts.Leave_NextGameTip = function(game)
end



Scripts.Preshow_CleanupDialogCascadeGameTips = function(game)
end

Scripts.Present_CleanupDialogCascadeGameTips = function(game)
end

Scripts.Leave_CleanupDialogCascadeGameTips = function(game)
end

Resources.QuestBoost = Resources.DialogButton:new {
    resource = "DialogButton",
    image = "Boost.png",
    alpha = 100,
    text = STRINGS(""),
    alignment = MidTop,
    alignTo = MidTop,
	zorder = 2,
    CheckMark = Resources.Actor:new {
        image = "Check.png",
        alignment = Center,
        alignTo = Center,
        alignmentOffset = {5,-5},
        visible = false,
        extraScale = 1.60,

    },
    QuantityLabel = Resources.AppDialogSmallLabel:new {
        resource = "AppDialogSmallLabel",
        alignTo = Center,
        rotationAngle = { degrees = 20 },
        alignment = Center,
        alignmentOffset = {32,20},
        --textColor = {188,107,13},
        textColor = "Cascade_DarkBrown",

            font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 18,},
		widthLimit = 30,
        extraScale = 1.1,
        --scripts = {"Groove"},

        NumberMarker = Resources.Actor:new {
			image = "Dialog_BoostCounterArrow.png",
			alignment = Center,
            alignmentOffset = {0,2},
			alignTo = Center,
			zorder = -1,
		},
        visible = false,
    },
	SaleTag = Resources.SaleTag:new {
		resource = "SaleTag",
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = {-10,10},
        extraScale = 0.75,
        --rotationAngle = {degrees = 15,},
		visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
	},
}

Scripts.ChallengeDialog_TimeLeft_Update = function(self)
	local keepRunning = true
	while (keepRunning) do
		local hour = GetCurrentHourLocal()
		local min = GetCurrentMinuteLocal()
		local sec = GetCurrentSecondLocal()
		hour = 23-hour
		min = 59-min
		sec = 59-sec
		if((hour == 0) and (min == 0) and (sec == 0))then
			keepRunning = false
			self.visible = false
		end
		if(sec<10)then sec = "0"..sec end
		if(min<10)then min = "0"..min end
		local time = hour..":"..min..":"..sec
		self.text = STRINGS("Ends in ")..time
		ScriptDelay(950,"dialogTimers")
	end
end

local BottomCharacter_Alignment = {0,200}
local ChallengeYOffset = 75

--Daily Challenge Level Start Dialog
Resources.ChallengeDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "ChallengeDialog",
	alpha = 0,

	introScriptName = "SlideOnTwoPanelsDialog_TopBar",
	dialogExitScriptName = "SlideOffTwoPanelsDialog_TopBar",

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogGeneric_Small.png",
		zorder = 1,
		alignment = "MidTop",
		alignmentOffset = Layout{{0,0},iphone5={0,0},ipad={0,-13},android={0,-20}},
        extraScale = Layout{1.0, ipad=0.95,},

        DialogInsert = Resources.Actor:new {
            resource = "Actor",
            image = "Dialog_Filler_A.png",
            alignment = "Center",
            alignmentOffset = {0,-5},
        },

		titleText = Resources.AppTitleDialogLabel_smaller:new {
			resource = "AppTitleDialogLabel_smaller",
			text = STRINGS("Today's Challenge"),
			alignment = MidTop,
            widthLimit = 180,
			alignmentOffset = {0, 20},
		},

		ChallengeDialog_TimeLeft = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			text = STRINGS("Ends in 11:25"),
			textAlignment = "Center",
            alignment = "MidBottom",
			alignmentOffset = {0, -70},
			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontSize = 20,
			},
			scripts = {"ChallengeDialog_TimeLeft_Update"},
		},

        ScorePanel = Resources.Actor:new {
            resource = "Actor",
            alignment = "MidTop",
            alignmentOffset = {0, 60},

            scoreText = Resources.AppDialogBoldLabel:new {
                resource = "AppDialogBoldLabel",
                text = STRINGS("Score:"),
                textAlignment = "Center",
                alignment = "MidTop",
                alignTo = "MidTop",
                alignmentOffset = {0, 0},
                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 18,
                },
            },

            ChallengeDialog_ScoreText = Resources.AppDialogBoldLabel:new {
                resource = "AppDialogBoldLabel",
                text = "10,000,000",
                textAlignment = "Center",
                alignment = "MidTop",
                alignTo = "MidTop",
                alignmentOffset = {0, 18},
                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 34,
                },
            },

            withText = Resources.AppDialogBoldLabel:new {
                resource = "AppDialogBoldLabel",
                text = STRINGS("With:"),
                textAlignment = "Center",
                alignment = "MidTop",
                alignTo = "MidTop",
                alignmentOffset = {0, 58},
                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 18,
                },
            },

            ChallengeDialog_CheckMark = Resources.Actor:new {
                resource = "Actor",
                zorder = 5,
                image = "Check.png",
                textAlignment = "Center",
                alignment = "Center",
                alignTo = "Center",
                alignmentOffset = {75,40},
            },
        },

        ObjectiveBanner = Resources.Actor:new {
            resource = "Actor",
            image = "Dialog_LevelLaunchAndEnd_Banner.png",
            alignment = "MidTop",
            alignTo = "Center",
            alignmentOffset = {-3,-52},
            zorder = 2,
        },

        ChallengeDialog_FeaturesPanel = Resources.Actor:new {
            resource = "Actor",
            color = "White",
            alpha = 0,
            alignment = MidTop,
            alignmentOffset = {0, 170},
            zorder = 2,
        },

        topScoreTodayNode = Resources.Actor:new {
            resource = "Actor",
            alignment = TopLeft,
            alignmentOffset = {30,80+ChallengeYOffset-100+20+85},
            visible = false,

            ChallengeDialog_TopScoreToday = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = TopLeft,
                alignmentOffset = {0,0},
                text = STRINGS("Today's Best:"),
                font = Resources.CascadeEndGameDialogFont:new {
                    resource = "CascadeEndGameDialogFont",
                    fontSize = 20,
                },
				widthLimit = 170,
            },

            ChallengeDialog_ChallengeStatus = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = TopRight,
                alignmentOffset = {240,0},
                text = STRINGS(""),
                font = Resources.CascadeEndGameDialogFont:new {
                    resource = "CascadeEndGameDialogFont",
                    fontSize = 20,
                },
                --bestStamp = Resources.BestStamp,
                visible = true,
				widthLimit = 70,
            },
        },

        challengeBeatNode = Resources.Actor:new {
            resource = "Actor",
            alignment = TopLeft,
            alignmentOffset = {30,80+ChallengeYOffset-100+20+105},
            visible = false,

            challengeBeatLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = TopLeft,
                alignmentOffset = {0,0},
                text = STRINGS("Challenges Beat:"),
                font = Resources.CascadeEndGameDialogFont:new {
                    resource = "CascadeEndGameDialogFont",
                    fontSize = 20,
                },
            },

            challengeBeat = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = TopRight,
                alignmentOffset = {240,0},
                text = STRINGS(""),
                font = Resources.CascadeEndGameDialogFont:new {
                    resource = "CascadeEndGameDialogFont",
                    fontSize = 20,
                },
            },

        },

        challengeStreakNode = Resources.Actor:new {
            resource = "Actor",
            alignment = TopLeft,
            alignmentOffset = {30,80+ChallengeYOffset-100+20+105},
            visible = false,

            challengeStreakPreNumberLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = TopLeft,
                alignmentOffset = {0,0},
                text = STRINGS("Current Streak: "),
                font = Resources.CascadeEndGameDialogFont:new {
                    resource = "CascadeEndGameDialogFont",
                    fontSize = 20,
                },
            },

            challengeStreakNumberLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = Top,
                alignmentOffset = {180,0},
                text = STRINGS(""),
                font = Resources.CascadeEndGameDialogFont:new {
                    resource = "CascadeEndGameDialogFont",
                    fontSize = 20,
                },
            },
        },

		BoostPanel = Resources.Actor:new {
			resource = "Actor",
			color = "White",
			size = {dialogWidth,80},
			alpha = 0,
			alignment = MidTop,
			alignTo = MidTop,
			alignmentOffset = {0,180},
            visible = Config.PayToWinChallenge,
            extraScale = 0.8,
            zorder = 3,

			SelectBoostsLabel = Resources.AppTitleDialogLabel:new {
				resource = "AppTitleDialogLabel",
				text = STRINGS("Select Boosts"),
				alignment = MidTop,
				alignTo = MidTop,
				alignmentOffset = {0,startQuestGameGoalY+(startQuestGameGoalY_offset*0)+15},
				font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 22,	},
				zorder = 1,
				heightLimit = 25,
			},
			Boost1 = Resources.QuestBoost:new {
				resource = "QuestBoost",
                alignmentOffset = {-80,35},
            },
			Boost2 = Resources.QuestBoost:new {
				resource = "QuestBoost",
                alignmentOffset = {0,35},
			},
			Boost3 = Resources.QuestBoost:new {
				resource = "QuestBoost",
				alignmentOffset = {80,35},
            },
		},

-- Challenge Play Button
		OkayButton = Resources.EndGameDialogBigButton:new {
			resource = "EndGameDialogBigButton",
			--image = "Button_Green.png",
            image = "ButtonPlastic_Long_Green.png",
			buttonClosesDialog = true,
			alignment = MidBottom,
			alignmentOffset = Layout{{0,-6},iphone5={0,-6},ipad={0,-6}},
            text = STRINGS("Play"),
            textWidthLimit = 150,
            font = Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 40,
            },				enterKey = true,
			shortcutKey = "p",
			zorder = 2,
            extraScale = 0.88,
			--scripts = {"SparkleLoop"},
			--scripts = {"DialogButtonGroove"},
		},

        ButtonBevel = Resources.Actor:new {
            resource = "Actor",
            image = "ButtonPlastic_Long_WoodOutline.png",
            alignment = MidBottom,
			alignmentOffset = Layout{{0,-6},iphone5={0,-6},ipad={0,-6}},
            zorder = 1,
            extraScale = 0.88,
        },

        CancelButton = Resources.CancelButton:new {
			resource = "CancelButton",
            --image = "ButtonCloseWax.png",
            --alignmentOffset = Layout{{-6,75},iphone5={-6,75},ipad={-6,75}},
		},
	},

	TopTenPanel = Resources.TopTenPanel_Challenge:new {
		resource = "TopTenPanel_Challenge",
		zorder = 20,
        --alignmentOffset = {0,-30},
	},
}

--Daily Challenge END!!!!!

Resources.ChallengeFeatureIcon = Resources.DialogButton:new {
    resource = "DialogButton",
    image = "FeatureIcon_Spins.png",
    alignment = "Center",
    alignTo = "Center",

    QuantityLabel = Resources.AppDialogSmallLabel:new {
        resource = "AppDialogSmallLabel",
        alignTo = Center,
        alignment = Center,
        alignmentOffset = {14, 14},
        widthLimit = 20,
        extraScale = 0.75,

        NumberMarker = Resources.Actor:new {
            image = "NumberMarker.png",
            alignment = Center,
            alignTo = Center,
            zorder = -1,
        },
        visible = false,
    },
}

Scripts.Preshow_ChallengeDialog = function(dialog,screen)
	local characters = dialog:FindChild("Characters",true)
	characterNames = {"Bear","Marmot","Otter","Lemur","Fox","Jaguar"}
	local characterPicked = math.random(1,#characterNames)
	--characters[characterNames[characterPicked]].visible = true

	dialog.MainPanel.OkayButton:AddObserver(EventMap.GURU_BUTTONCLICK, screen)
	dialog.MainPanel.CancelButton:AddObserver(EventMap.GURU_BUTTONCLICK, screen)
end


Scripts.Present_ChallengeDialog = function(dialog)

end




local ShareYOffset = 140
Resources.ShareDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "Dialog",
	--title = STRINGS("Play Challenge"),
    name = "ShareDialog",

	title="Share Cascade!",
	--[[
	titlePanel = Resources.Actor:new {
		resource = "Actor",
		image = "titleTodayChallenge.png",
		alignment = MidTop,
		alignmentOffset = {0, 80},
    },
	--]]

	 shareAddFriend = Resources.EndGameDialogButton:new {
		resource = "EndGameDialogButton",
		image = "shareAddFriend.png",
		alignment = "MidTop",
		alignmentOffset = {0, ShareYOffset+52*0},
		--buttonClosesDialog = true,
	},
	--[[
	 shareGameCenter = Resources.EndGameDialogButton:new {
		resource = "EndGameDialogButton",
		image = "shareGameCenter.png",
		alignment = "MidTop",
		alignmentOffset = {0, ShareYOffset+52*1},
		buttonClosesDialog = true,
	},
	--]]

	 shareFacebook = Resources.EndGameDialogButton:new {
		resource = "EndGameDialogButton",
		image = "shareFacebook.png",
		alignment = "MidTop",
		alignmentOffset = {0, ShareYOffset+52*2},
		--buttonClosesDialog = true,
	},

	shareTwitter = Resources.EndGameDialogButton:new {
		resource = "EndGameDialogButton",
		image = "shareTwitter.png",
		alignment = "MidTop",
		alignmentOffset = {0, ShareYOffset+52*3},
		--buttonClosesDialog = true,
	},

	 shareEmail = Resources.EndGameDialogButton:new {
		resource = "EndGameDialogButton",
		image = "shareEmail.png",
		alignment = "MidTop",
		alignmentOffset = {0, ShareYOffset+52*1},
		--buttonClosesDialog = true,
	},

	 shareGift = Resources.EndGameDialogButton:new {
		resource = "EndGameDialogButton",
		image = "shareGift.png",
		alignment = "MidTop",
		alignmentOffset = {0, ShareYOffset+52*4},
		--buttonClosesDialog = true,
	},

	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {-0/ScreenScaleFactor,LargeLong_Dialog_Button_Y},
		text = STRINGS("Okay"),
		--image = "btnOkay.png",
		--text = STRINGS(""),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
	},
}

Resources.BeatThisDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "BeatThisDialog",
    name = "BeatThisDialog",

	--title="Beat This!",
	title="",

	titlePanel = Resources.Actor:new {
		resource = "Actor",
		image = "titleBeatThis.png",
		alignment = MidTop,
		alignmentOffset = {0, 80},
    },

	ChallengeTitle = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS(""),
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		widthLimit = 285,
		alignment = MidTop,
		alignmentOffset = {0, 150},
	},

	PlayerImage = Resources.Actor:new {
		resource = "Actor",
		image = "ThePlayer.png",
		alignTo = MidTop,
		alignment = Center,
		size = {64, 64},
		alignmentOffset = {-115, 235},
	},

	ChallengeText = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS(""),
		wrapLimit = 220,
		alignTo = MidTop,
		alignment = Center,
		alignmentOffset = {30, 235},
	},

	ChallengeMessage = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS(""),
		font = {
			fontName = "Qlassik_TB.TTF",
			fontSize = 18,
			fontStyle = FontStyle { "italic", "bold" },
		},
		fgColor = "#FFFF30",
		textAlignment = "Center",
		wrapLimit = 285,
		heightLimit = 70,
		alignTo = MidTop,
		alignment = Center,
		alignmentOffset = {0, 310},
	},

	PlayNowButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0, -55},
		--text = STRINGS("Play Now"),
		image = "btnPlayNow.png",
		text = STRINGS(""),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
	},

	MaybeLaterButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {-110/ScreenScaleFactor,LargeLong_Dialog_Button_Y},
		text = STRINGS("Later"),
		--image = "btnOkay.png",
		--text = STRINGS(""),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
	},
	DeclineButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {110/ScreenScaleFactor,LargeLong_Dialog_Button_Y},
		text = STRINGS("Decline"),
		--image = "btnOkay.png",
		--text = STRINGS(""),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		--size = DialogButtonSize,
	},
}



Resources.LoadSavedGameDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "AppLoadSavedGameDialog",
    name = "LoadSavedGameDialog",

	titlePanel = Resources.Actor:new {
		resource = "Actor",
		image = "titleContinueGame.png",
		alignment = MidTop,
		alignmentOffset = {0, 80},
    },

	SubTitle = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS("Continue your saved game?"),
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0, 196},
		wrapLimit = 270,
	},

	ExplanatoryText = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS(""),
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		--widthLimit = 285,
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0, 307},
		wrapLimit = 270,
		heightLimit = 115,
		aligner = {class="Actor", size={270,115}, color="Green", alignment = "Center", alpha = 192, visible = false},
	},

	ResumeButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {-75, -30},
		--image = "btnYes.png",
		text = STRINGS("Yes"),
		enterKey = true,
		shortcutKey = "y",
	},

	NewGameButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {75, -30},
		--image = "btnNo.png",
		text = STRINGS("No"),
		escapeKey = true,
		shortcutKey = "n",
	},
}



local Debug_Alpha = 0


-- Base resource for an individual button representing a value of a configurable options.
--
-- This must be used in conjunction with Resources.MenuOptionGroup.
--
-- Each subclassed resource must implement the following methods: ApplyToConfig
-- and UpdateFromConfig.
--
Resources.MenuOptionButton = Resources.RadioButton:new {
	resource = "RadioButton",

	-- Configuable Stuff:
	--image = "Button.small.png",
	useFrames = false,
	font = {
		fontName = "IT441___.TTF",
		fontSize = 20,
	},
	fgColor = "Black",
	Offset = {0,0},
	highlightedImageTint = "#00FFFF",
	highlightedTextShadowColor = "White",
	plainImageTint = "Gray",
	plainTextShadowColor = "Gray",

	-- Hide the GuruEngine-provided checkbox:
	box = Resources.Actor:new {
		resource = "Actor",
		size = {0,0},
		alpha = 0,
	},

	-- Make sure image tinting works:
	--enableImageTinting = true,

	-- Initialization stuff:
	OnPostSpawn = function (self)
		-- Make sure the check box view gets updated after the button spawns,
		-- just in case its parent actor doesn't do it themselves.
		if IsFunction(self.UpdateCheckBoxView) then
			self:UpdateCheckBoxView()
		end
	end,

	--
	-- Check Box State/Data Management
	--
	_checkBoxState = false,

	setCheckBoxState = function (self, state)
		--logprint("setCheckBoxState("..tostring(self)..", "..tostring(state)..")")
		self._checkBoxState = state
		if IsFunction(self.UpdateCheckBoxView) then
			self:UpdateCheckBoxView()
		end
	end,

	getCheckBoxState = function (self)
		--logprint("getCheckBoxState("..tostring(self)..") == "..tostring(self._checkBoxState))
		return self._checkBoxState
	end,

	--
	-- Check Box View Management
	--
	UpdateCheckBoxView = function (self)
		if self.baseImageName then
			if self.checkBoxState == true then
				self.image = self.baseImageName .. "2.png"
			else
				self.image = self.baseImageName .. "1.png"
			end
		else
			self.enableImageTinting = true
			local oldImage = self.image
			if self.checkBoxState == true then
				self.color = self.highlightedImageTint or "White"
				self.textShadowColor = self.highlightedTextShadowColor or "Black"
			else
				self.color = self.plainImageTint or "White"
				self.textShadowColor = self.plainTextShadowColor or "Black"
			end
			self.image = oldImage
		end
	end,

	--
	-- Event Handling
	--
	OnButtonClick = function (self, event)
		if event.button ~= self then
			return
		end

		--logprint("button click, self="..tostring(self))

		if self.parent and IsFunction(self.parent.UpdateToConfig) then
			self.parent:UpdateToConfig()
		end

		return true
	end,
}

-- The base resource for groups of buttons representing configurable options
Resources.MenuOptionGroup = Resources.Actor:new {
	resource = "Actor",
	tag = "ButtonSet",

	UpdateFromConfig = function (self)
		--logprint("UpdateFromConfig, self="..tostring(self))
		self.buttonA:UpdateFromConfig()
		self.buttonB:UpdateFromConfig()
	end,

	UpdateToConfig = function (self)
		--logprint("UpdateToConfig, self="..tostring(self))

		-- Make sure we don't get stuck in an infinite loop of
		-- Config updates.
		if self.is_updating_config == true then
			--logprint("... ignoring config update")
			return
		end
		self.is_updating_config = true

		--logprint("... self.buttonA.checkBoxState="..tostring(self.buttonA.checkBoxState))
		--logprint("... self.buttonB.checkBoxState="..tostring(self.buttonB.checkBoxState))

		-- Update the state of the engine's Config database.
		if self.buttonA.checkBoxState == true then
			self.buttonA:ApplyToConfig()
		elseif self.buttonB.checkBoxState == true then
			self.buttonB:ApplyToConfig()
		end

		-- Allow further config updates to occur.
		self.is_updating_config = false
	end,

	OnPostSpawn = function (self)
		--logprint("OnPostSpawn, self="..tostring(self))
		self:UpdateFromConfig()
	end,
}

local startGameOptionsY = 170
local startGameFirstLineY = 252
local startGameLineSeparation = 36
local startGameLeftAlignment = 15
local startGameRightAlignment = 20
local startGameLeftWidthLimit = 154
local startGameRightWidthLimit = 116

Scripts.Preshow_StartGameDialog = function(dialog,stats)

	--TEST
	--goalScore = 1000

	--Set all values except score
	--These are set to -1 at start
	if(stats.oldDailyTop<0)then
		stats.oldDailyTop = 0
	end
	if(stats.oldPersonalBest<0)then
		stats.oldPersonalBest = 0
	end
	dialog.dailyBest.text = Int2Comma(stats.oldDailyTop)
	dialog.personalBest.text = Int2Comma(stats.oldPersonalBest)

	-- Save the parent dialog to call Update() from buttons
	local buttonA = dialog:FindChild("buttonA",true)
	local buttonB = dialog:FindChild("buttonB",true)
	buttonA.dialog = dialog
	buttonB.dialog = dialog
end

--Tap FX when hitting Boost

Scripts.ShowBoostTitle = function(boost,boostName,boostIndex)
	--Clean up previous instance
	if(boost.boostTitle ~= nil) then
		boost:DestroyChild(boost.boostTitle)
	end
	boost.boostTitle = Resources.AppDialogSmallLabel:new {
        resource = "AppDialogSmallLabel",
        alignment = Center,
        alignmentOffset = {0,-40},
		text = STRINGS(boostName),
        font	= Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 26,
		},
		fgColor = "Cascade_CheckGreen_dark",
		shadowColor = "Cascade_DarkBrown",
		shadowAlpha = 255,
		shadowOffset = {2,2},
		highlightColor = "Cascade_DarkBrown",
		highlightAlpha = 255,
		highlightOffset = {-1,-1},
		--color = "White",
		zorder = 100,
    }
	if(boostIndex==1)then
		PlaySound("slot_machine_bet_01.ogg")
	elseif(boostIndex==2)then
		PlaySound("slot_machine_bet_02.ogg")
	else
		PlaySound("slot_machine_bet_03.ogg")
	end
	local destPos = {boost.boostTitle.position.x,boost.boostTitle.position.y-50}
	boost.boostTitle:SlideTo(destPos, 2000)
	ScriptDelay(500,"DialogTimers")
	FadeOutAndDestroy(boost.boostTitle,1500)
end

Scripts.ShowFeatureIconTitle = function(actor,featureName)
    --Clean up previous instance
    if(actor.featureLabel ~= nil) then
        actor:DestroyChild(actor.featureLabel)
    end
    actor.featureLabel = Resources.AppDialogSmallLabel:new {
        resource = "AppDialogSmallLabel",
        alignment = Center,
        alignmentOffset = {0,-40},
        text = STRINGS(featureName),
        font    = Resources.DialogTitleFont:new{
            resource = "DialogTitleFont",
            fontSize = 26,
        },
        fgColor = "Cascade_CheckGreen_dark",
        shadowColor = "Cascade_DarkBrown",
        shadowAlpha = 255,
        shadowOffset = {2,2},
        highlightColor = "Cascade_DarkBrown",
        highlightAlpha = 255,
        highlightOffset = {-1,-1},
        --color = "White",
        zorder = 100,
    }
    PlaySound("slot_machine_bet_01.ogg")
    local destPos = {actor.featureLabel.position.x,actor.featureLabel.position.y-50}
    actor.featureLabel:SlideTo(destPos, 2000)
    ScriptDelay(500,"DialogTimers")
    FadeOutAndDestroy(actor.featureLabel,1500)
end

--Level Launch Dialog
Resources.StartQuestGameDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "StartQuestGameDialog",
    name = "StartQuestGameDialog",
	color = "Cascade_Cyan",
    alpha = 0,
	title = "",

	introScriptName = "SlideOnTwoPanelsDialog_TopBar",
	dialogExitScriptName = "SlideOffTwoPanelsDialog_TopBar",

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogGeneric_Small.png",
		alignment = "Center",
        alignmentOffset = {0,-35},
        extraScale = 0.95,

        DialogInsert = Resources.Actor:new {
            resource = "Actor",
            image = "Dialog_Filler_A.png",
            alignment = "Center",
            alignmentOffset = {0,-5},
        },

        LevelNumberPanel = Resources.Actor:new {
            resource = "Actor",
            --scripts = {"JelloLoop"},
            zorder = 10,
            alignment = TopLeft,
            alignmentOffset = {17,9},
            size = {48,48},

            SpecialGemFlag = Resources.Actor:new {
                resource = "Actor",
                image = "Dialog_SideFlag.png",
                alignment = "TopLeft",
                alignmentOffset = {-3,-8},
                zorder = -1,
            },

            LevelNumber = Resources.StartQuestGameDialogLabel:new {
                resource = "StartQuestGameDialogLabel",
                text = STRINGS("1234"),
                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 22,
                },
                textColor = "Cascade_White",
                shadowColor = "Black",
                shadowOffset = {1,2},
                shadowAlpha = 120,
                alignment = MidTop,
                alignTo = MidTop,
                alignmentOffset = {-5,-5},
            },

            SpecialGemPanel = Resources.Actor:new {
                resource = "Actor",
                alpha = 0,
                zorder = 10,
                color = "Blue",
                alignment = Center,
                alignmentOffset = {0,1},
                size = {48,48},
                extraScale = 0.5,
                visible = false, --Set to true in PRESHOW if 1+ special gems
                SetOf3 = Resources.Actor:new {
                    resource = "Actor",
                    alpha = 0,
                    alignment = Center,
                    size = {40,40},
                    visible = false,

                    gemHolder1 = Resources.Actor:new {
                        resource = "Actor",
                        alignment = Center,
                        size = {35,35},
                        alpha = 100,
                        zorder = 1,
                        alignmentOffset = {-30,0},
                        gemImage = Resources.Actor:new {
                            resource = "Actor",
                            image = "GemSpecialGreen_Small_Empty.png",
                        },
                    },
                    gemHolder2 = Resources.Actor:new {
                        resource = "Actor",
                        alignment = Center,
                        size = {35,35},
                        alpha = 0,
                        zorder = 2,
                        alignmentOffset = {0,0},
                        gemImage = Resources.Actor:new {
                            resource = "Actor",
                            image = "GemSpecialBlue_Small_Empty.png",
                        },
                    },
                    gemHolder3 = Resources.Actor:new {
                        resource = "Actor",
                        alignment = Center,
                        size = {35,35},
                        alpha = 0,
                        zorder = 3,
                        alignmentOffset = {28,0},
                        gemImage = Resources.Actor:new {
                            resource = "Actor",
                            image = "GemSpecialRed_Small_Empty.png",
                        },
                    },
                },
                specialGemMultiplier = Resources.GameLabelChunkier:new {
                    resource = "GameLabelChunkier",
                    alignment = "Center",
                    alignTo = "MidBottom",
                    alignmentOffset = {-5,16},
                    extraScale = 2.0,
                    widthLimit = 20,
                    zorder = 4,
                    font	= Resources.DialogBoldFont:new{
                        resource = "DialogBoldFont",
                        fontSize = 14,
                    },
                    QuantityLabel_background = Resources.Actor:new {
                        image = "NumberMarker_Small.png",
                        alignment = "Center",
                        alignTo = "Center",
                        alignmentOffset = {1,1},
                        zorder = -1,
                    },
                },
            },

        },


		DialogCharacter = Resources.DialogCharacter:new {
			resource = "DialogCharacter",
			zorder = 1,
			visible = false,
		},

		LevelNamePanel = Resources.LevelNamePanel:new {
			resource = "LevelNamePanel",
			zorder = 2,
		},

		GoalPanel = Resources.GoalPanel:new {
			resource = "GoalPanel",
			zorder = 2,
		},

		BoostPanel = Resources.Actor:new {
			resource = "Actor",
			color = "White",
			size = {dialogWidth,80},
			alpha = 0,
            zorder = 3,
			alignment = MidTop,
			alignTo = MidTop,
			alignmentOffset = {0,193},
			Goal = Resources.AppTitleDialogLabel:new {
				resource = "AppTitleDialogLabel",
				text = STRINGS("Select Boosts"),
				alignment = MidTop,
				alignTo = MidTop,
				alignmentOffset = {0,startQuestGameGoalY+(startQuestGameGoalY_offset*0)+18},
				font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 16,	},
				zorder = 1,
			},
			Boost1 = Resources.QuestBoost:new {
				resource = "QuestBoost",
                alignmentOffset = {-80,32},
            },
			Boost2 = Resources.QuestBoost:new {
				resource = "QuestBoost",
                alignmentOffset = {0,32},
			},
			Boost3 = Resources.QuestBoost:new {
				resource = "QuestBoost",
				alignmentOffset = {80,32},
            },
		},

        -- Level Launch Play Button
		OkayButton = Resources.EndGameDialogBigButton:new {
			resource = "EndGameDialogBigButton",
			--image = "Button_Green.png",
            image = "ButtonPlastic_Long_Green.png",
            scripts = {"SparkleLoop"},
			buttonClosesDialog = true,
			alignment = MidBottom,
			alignmentOffset = Layout{{0,-6},iphone5={0,-6},ipad={0,-6}},
            text = STRINGS("Play"),
            textWidthLimit = 150,
            font	= Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 40,
            },
			enterKey = true,
			shortcutKey = "p",
			zorder = 2,
            extraScale = 0.88,
			--scripts = {"SparkleLoop"},
			--scripts = {"DialogButtonGroove"},
		},

        ButtonBevel = Resources.Actor:new {
            resource = "Actor",
            image = "ButtonPlastic_Long_WoodOutline.png",
            alignment = MidBottom,
			alignmentOffset = Layout{{0,-6},iphone5={0,-6},ipad={0,-6}},
            zorder = 1,
            extraScale = 0.88,
        },

		CancelButton = Resources.CancelButton:new {
			resource = "CancelButton",
		},
	},
	TopTenPanel = Resources.TopTenPanel:new {
		resource = "TopTenPanel",
	},
}

Scripts.GetPowerupImage = function(powerup)
	if(powerup == "crates" or powerup == "hasCrates")then
		return "PowerupCrates.png"
	end
	if(powerup=="easyDiamonds")then
		return "PowerupEasyDiamonds.png"
	end
	if(powerup=="jailedSquares" or powerup == "hasJailedSquares")then
		return "PowerupJailedSquares.png"
	end
	if(powerup=="LuckyWilds")then
		return "Boost_LuckyWilds.png"
	end
	if(powerup=="easyDiamonds")then
		return "PowerupEasyDiamonds.png"
	end
	if(powerup=="missingSquares" or powerup == "hasMissingSquares")then
		return "PowerupMissingSquares.png"
	end
	if(powerup=="gemTypes6")then
		return "PowerupOrangeGems.png"
	end
	if(powerup=="largeBoard")then
		return "PowerupLargeBoard.png"
	end

	if(powerup=="modeSpins1")then return "PowerupSpin1.png" end
	if(powerup=="modeSpins2")then return "PowerupSpin2.png" end
	if(powerup=="modeSpins3")then return "PowerupSpin3.png" end
	if(powerup=="modeSpins4")then return "PowerupSpin4.png" end
	if(powerup=="modeSpins5")then return "PowerupSpin5.png" end
	if(powerup=="modeSpins6")then return "PowerupSpin6.png" end
	if(powerup=="modeSpins7")then return "PowerupSpin7.png" end
	if(powerup=="modeSpins8")then return "PowerupSpin8.png" end
	if(powerup=="modeSpins9")then return "PowerupSpin9.png" end
	if(powerup=="modeSpins10")then return "PowerupSpin10.png" end
	if(powerup=="modeSpins11")then return "PowerupSpin11.png" end
	if(powerup=="modeSpins12")then return "PowerupSpin12.png" end
	if(powerup=="modeSpins13")then return "PowerupSpin13.png" end
	if(powerup=="modeSpins14")then return "PowerupSpin14.png" end
	if(powerup=="modeSpins15")then return "PowerupSpin15.png" end
	if(powerup=="modeSpins16")then return "PowerupSpin16.png" end
	if(powerup=="modeSpins17")then return "PowerupSpin17.png" end
	if(powerup=="modeSpins18")then return "PowerupSpin18.png" end
	if(powerup=="modeSpins19")then return "PowerupSpin19.png" end

	if(powerup=="modeSpins20")then
		return "PowerupSpin20.png"
	end

	if(powerup=="coverage" or powerup=="hasCoverage")then
		return "PowerupCoverage.png"
	end
	if(powerup=="treasureChest" or powerup == "hasChests")then
		return "PowerupTreasureChest.png"
	end
	if(powerup=="hasVines")then
		return "PowerupVines.png"
	end
	if(powerup=="hasBarrels")then
		return "PowerupBarrels.png"
	end
	if(powerup=="hasDiamondMode")then
		return "PowerupEasyDiamonds.png"
	end
	if(powerup=="hasSteel")then
		return "PowerupSteel.png"
	end
	if(powerup=="hasStones")then
		return "PowerupStones.png"
	end
	if(powerup=="hasBombs")then
		return "PowerupBombs.png"
	end

	return ""
end

Scripts.Preshow_StartQuestGameDialog = function(dialog,currentLevel, numStars, doShowQuickQuest)

    -- Get number of gems
	local numberOfSpecialGems = 0
	for gemType = 1,20 do
		local configKey = "PlaceSpecialGem_Level" .. currentLevel .. "_" .. gemType
		local placeGem = Config[configKey]
		if(placeGem ~= nil and placeGem ~= "") then
			numberOfSpecialGems = numberOfSpecialGems + 1
		end
	end

    --Show/hide special gem panel
    local specialGemPanel = dialog:FindChild("SpecialGemPanel",true)
    specialGemPanel.visible = numberOfSpecialGems > 0

    -- Set special gem images
    if (numberOfSpecialGems>0) then
        local specialGemSet = specialGemPanel["SetOf3"]
        specialGemSet.visible = true

        local currentGemIndex = 0
        for gemType = 1,20 do
            local configKey = "PlaceSpecialGem_Level" .. currentLevel .. "_" .. gemType
            local placeGem = Config[configKey]
            if(placeGem ~= nil and placeGem ~= "") then
                --get the correct gemHolder index
                if(gemType == 2) then
                    currentGemIndex = 1 --green in slot #1
                elseif(gemType == 1) then
                    currentGemIndex = 2 --blue in slot #2
                else
                    currentGemIndex = 3 --red in slot #3
                end

                --set gem image
                local gemImage = specialGemSet["gemHolder" .. currentGemIndex]["gemImage"]
                gemImage.image = "Gem" .. placeGem .. "_Small.png"
                gemImage.visible = true
                gemImage:AddScript("SparkleLoop","SpecialGem")
            end
        end
    else
        --If there are no special gems, increase the size of the Level Number
        local numberPanel = dialog:FindChild("LevelNumber",true)
        numberPanel.fontSize = 30
        numberPanel.alignmentOffset = {-5, -3}
    end

	-- Set multiplier
	local specialGemMultiplier = specialGemPanel.specialGemMultiplier
	specialGemMultiplier.visible = false
	if(numberOfSpecialGems > 0) then
		local configKey = "MultiplySpecialGem_Level" .. currentLevel
		local multiplyGem = Config[configKey]
		if(not IsNumber(multiplyGem)) then
			multiplyGem = 1
		end
		if(multiplyGem > 1) then
			specialGemMultiplier.text = Int2Comma(multiplyGem) .. STRINGS("X")
			specialGemMultiplier.visible = true
		end
		local shiftFactor = (3 - numberOfSpecialGems) * 10
	end

	local LevelNamePanel = dialog:FindChild("LevelNamePanel",true)

    for i=1,7 do
		local powerupName = "Powerup"..i
		local powerup = LevelNamePanel[powerupName]
		powerup.visible = false
	end

	local powerup_index = 1
	local levelFeatures = GameLevel_GetNamedFeatureList(currentLevel)

	--Set stars that haven't been achieved to gray
	local useGold = Config.GoldEnabled

	for i=1,3 do
		local starName = "StarGoal" .. i
		local GoalPanel = dialog:FindChild("GoalPanel",true)
		local star = GoalPanel[starName]
		local goldRewardName = "GoldAward_Star" .. i
		local showGold = useGold and Config[goldRewardName] > 0
		if (i > numStars) then
			star.Star.image = "StarBig_off.png"
			if(showGold) then
				star.Gold.visible = true
				star.Star.Worker.visible = true
			end

            if (doShowQuickQuest and i == numStars + 1) then
                star.Star.QuickQuestPiece.visible = true
            end
		else
			star.image = "StarBig_achieved.png"
			star.visible = true
			star.Star.Worker.visible = false

            if (doShowQuickQuest and i == 3) then
                star.Star.QuickQuestPiece.visible = true
            end
		end
	end

	dialog.MainPanel.GoalPanel.Requirement.alignmentOffset = {0,95}
end

Scripts.Preshow_StartSideLevelDialog = function(dialog,landNumber,levelIndex,numStars,doShowQuickQuest,isLabEventGame)

    --Hide the # for hidden levels
    local numberPanel = dialog:FindChild("LevelNumber",true)
    numberPanel.visible = landNumber ~= 1

	-- Get number of gems
	local numberOfSpecialGems = 0
	for gemType = 1,20 do
		local configKey = "PlaceSpecialGem_SideLevel"..landNumber.."_"..levelIndex.."_" .. gemType
		local placeGem = Config[configKey]
		if(placeGem ~= nil and placeGem ~= "") then
			numberOfSpecialGems = numberOfSpecialGems + 1
		end
	end

    --Hide special gem panel
    local specialGemPanel = dialog:FindChild("SpecialGemPanel",true)
    specialGemPanel.visible = numberOfSpecialGems > 0

	--set special gem images
    if (numberOfSpecialGems>0) then
        local specialGemSet = specialGemPanel["SetOf3"]
        specialGemSet.visible = true

        local currentGemIndex = 0
        -- Set images
        for gemType = 1,20 do
            local configKey = "PlaceSpecialGem_SideLevel"..landNumber.."_"..levelIndex.."_" .. gemType
            local placeGem = Config[configKey]
            if(placeGem ~= nil and placeGem ~= "") then
                --get the correct gemHolder index
                if(gemType == 2) then
                    currentGemIndex = 1 --placed red special in slot #3
                elseif(gemType == 1) then
                    currentGemIndex = 2
                else
                    currentGemIndex = 3
                end

                --set gem image
                local gemImage = specialGemSet["gemHolder" .. currentGemIndex]["gemImage"]
                gemImage.image = "Gem" .. placeGem .. "_Small.png"
                gemImage.visible = true
                gemImage:AddScript("SparkleLoop","SpecialGem")
            end
        end
    else
        --If there are no special gems, increase the size of the Level Number
        numberPanel.fontSize = 30
        numberPanel.alignmentOffset = {-5, -3}
    end

	-- Set multiplier
	local specialGemMultiplier = specialGemPanel.specialGemMultiplier
	specialGemMultiplier.visible = false
	if(numberOfSpecialGems > 0) then
		local configKey = "MultiplySpecialGem_SideLevel"..landNumber.."_"..levelIndex
		local multiplyGem = Config[configKey]
		if(not IsNumber(multiplyGem)) then
			multiplyGem = 1
		end
		if(multiplyGem > 1) then
			specialGemMultiplier.text = Int2Comma(multiplyGem) .. STRINGS("X")
			specialGemMultiplier.visible = true
		end
		local shiftFactor = (3 - numberOfSpecialGems) * 10
	end

	--logprint("Preshow_StartQuestGameDialog: "..landNumber--"-"..levelIndex.."\n")

	local LevelNamePanel = dialog:FindChild("LevelNamePanel",true)

	for i=1,7 do
		local powerupName = "Powerup"..i
		local powerup = LevelNamePanel[powerupName]
		powerup.visible = false
	end

	local powerup_index = 1
	local levelFeatures = GameLevel_GetSideLevelFeatureList(landNumber,levelIndex)

	--Set stars that haven't been achieved to gray
	local useGold = Config.GoldEnabled

	for i=1,3 do
		local starName = "StarGoal" .. i
		local GoalPanel = dialog:FindChild("GoalPanel",true)
		local star = GoalPanel[starName]
		local goldRewardName = "GoldAward_Star" .. i
		local showGold = useGold and Config[goldRewardName] > 0
		if (i > numStars) then
			if (isLabEventGame) then
				star.Star.image = "LabLevel_Flask_Slot.png"
			else
				star.Star.image = "StarBig_off.png"
			end
			if(showGold) then
				star.Gold.visible = true
			end

            if (doShowQuickQuest and i == numStars + 1) then
                star.Star.QuickQuestPiece.visible = true
            end
		else
			if (isLabEventGame) then
				if (i == 1) then
					star.Star.image = "LabLevel_Flask_1.png"
				elseif (i == 2) then
					star.Star.image = "LabLevel_Flask_2.png"
				elseif (i == 3) then
					star.Star.image = "LabLevel_Flask_3.png"
				end
			else
				star.Star.image = "StarBig_achieved.png"
			end

            if (doShowQuickQuest and i == 3) then
                star.Star.QuickQuestPiece.visible = true
            end
		end
	end

	dialog.MainPanel.GoalPanel.Requirement.alignmentOffset = {0,95}
end

Resources.LivesDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "LivesDialog",
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

local onOffImg = "OnOffSwitchBackground_Blank.png"
local isNotOnOffEn = true
if Language == "en" then
    onOffImg = "OnOffSwitchBackground.png"
    isNotOnOffEn = false
end

Resources.OnOffSwitch = Resources.Actor:new {
	resource = "Actor",
	class = "OnOffSwitch",
	image = onOffImg,

    Off = Resources.AppTitleDialogLabel:new {
        resource = "AppTitleDialogLabel",
        text = STRINGS("Off"),
        alignment = Center,
        alignmentOffset = {-21,0},
        visible = isNotOnOffEn,
        fontSize = 19,
        zorder = 1,
		widthLimit = 30,
    },

    On = Resources.AppTitleDialogLabel:new {
        resource = "AppTitleDialogLabel",
        text = STRINGS("On"),
        alignment = Center,
        alignmentOffset = {22,0},
        visible = isNotOnOffEn,
        fontSize = 19,
        zorder = 1,
		widthLimit = 30,
		textColor = "Panel_LightBrown",
		shadowColor = "Black",
    },


	Switch = Resources.Actor:new {
		resource = "Actor",
		image = "OnOffSwitchForeground.png",
        zorder = 2,
	},

}

Resources.NoMoreLivesDialog = Resources.LivesDialog:new {
	class = "NoMoreLivesDialog",
	resource = "LivesDialog",
    name = "NoMoreLivesDialog",
	title = "",

	OnPostSpawn = function (self)
		local allowLocalNotifications = (CONFIG:RetrieveConstObject("LocalNotifications_AllowedForFullLives") == true)
		self.GetNotificationSwitch.visible = allowLocalNotifications
		self.GetNotificationLabel.visible = allowLocalNotifications
	end,

	Tick = function (self)
		if (LIVES_MGR:HasLives()) then
			self.screen:StopDialog("NoMoreLivesDialog")
		end
	end,

	titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("No More Lives"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

	Heart = Resources.Actor:new {
		image = "Heart_noMore.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,100},
		scripts = {"SqueezeSquareLoop"},
	},

	TextLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("Time To Next Life:"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,170},
        heightLimit = 30,
	},

	TimeToNextLife = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		text = STRINGS(""),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,200},
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		pointPanel = Resources.Actor:new{
			image = "GamePanel_ScoreMeter_Banner.png",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0,0},
		},
		Tick = function (self)
			self.text = LIVES_MGR:DescribeTimeToAnyLives()
		end,
	},

	GetNotificationSwitch = Resources.OnOffSwitch:new {
		resource = "OnOffSwitch",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0, 264},
		switchedOn = true,
		Switch = Resources.Actor:new {
			resource = "Actor",
			image = "OnOffSwitchForeground.png",
		},
		visible = false,
		OnPostSpawn = function (self)
			CONFIG:AttachObserver(self, "LocalNotifications_PlayerEnabledForFullLives")
			self.switchedOn = (CONFIG:RetrieveBoolean("LocalNotifications_PlayerEnabledForFullLives", true) == true)
			self:AddObserver(EventMap.GURU_VALUECHANGE, self)
		end,
		OnConfigUpdate = function (self, event)
			if (event.configData.key == "LocalNotifications_PlayerEnabledForFullLives") then
				self.switchedOn = event.configData.value
			end
			WriteConfig()
		end,
		OnValueChange = function (self, event)
			CONFIG:Store("LocalNotifications_PlayerEnabledForFullLives", (self.switchedOn == true))
		end,
	},

	GetNotificationLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("Notifications"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,234},
		widthLimit = 100,
		--heightLimit = 50,
		visible = false,
	},

    AskFriendsButton = Resources.Actor:new {
        resource = "Actor",
        visible = false,
    },
--[[
	AskFriendsButton = Resources.AppMenuBigButton_arrow_facebook:new {
		resources = {"AppMenuBigButton_arrow_facebook", "AuthenticationAwareDecorator"},
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-60},
		text = STRINGS("Ask Friends"),
		shortcutKey = "a",
        textWidthLimit = 150,

		-- AuthenticationAwareDecorator settings:
		visibleWhenConnected = true,
		visibleWhenDisconnected = false,
		raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
		isConnectUI = true,

		OnPostSpawn = function (self)
			-- Initialize AuthenticationAwareDecorator:
			Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
		end,

		OnButtonClick = function (self, event)
			if self ~= event.button then
				return false
			end
			Gifting_RequestLivesFromFriends()
			return true
		end,
	},
--]]

	MoreLivesNowButton = Resources.AppMenuBigButton_arrow_heart:new {
		resource = "AppMenuBigButton_arrow_heart",
		--buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("More Lives Now"),
		shortcutKey = "m",
        textWidthLimit = 144,

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			zorder = 100,
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {70,37},

			OnPostSpawn = function (self)
				self.visible = ShouldShowTagSaleDialog() or (CONFIG:RetrieveConst("DebugSaleTags") == true)
			end,
		},
		GoldIcon = Resources.Actor:new {
			resource = "Actor",
			visible = false,
			image = "Gold_1bar.png",
			size = {222/2*.85,161/2*.85},
		},

		BundleItemsTag = Resources.BundleItemsTag:new {
			resource = "BundleItemsTag",
			alignment = MidTop,
			alignTo = MidBottom,
			alignmentOffset = {70+30,-20},
            zorder = 11,
            rotationAngle = {degrees = 20,},
		},
	},
}

Scripts.Preshow_NoMoreLivesDialog = function(dialog,stats)


end

Scripts.Present_NoMoreLivesDialog = function(dialog,stats)


end

local NotificationSwitch_nudge_y = -50
Resources.NotificationsDialog = Resources.LivesDialog:new {
	class = "NotificationsDialog",
	resource = "LivesDialog",
    name = "NotificationsDialog",
	title = "",
	--color = "Cascade_DarkPink",

	OnPostSpawn = function (self)
		local allowLocalNotifications = (CONFIG:RetrieveConstObject("LocalNotifications_AllowedForFullLives") == true)
		self.GetNotificationSwitch.visible = allowLocalNotifications
		self.GetNotificationLabel.visible = allowLocalNotifications
	end,

	titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Notifications"),
        widthLimit = 180,
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },


	GetNotificationSwitch = Resources.OnOffSwitch:new {
		resource = "OnOffSwitch",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0, 264+NotificationSwitch_nudge_y},
		switchedOn = true,
		Switch = Resources.Actor:new {
			resource = "Actor",
			image = "OnOffSwitchForeground.png",
		},
		visible = false,
		OnPostSpawn = function (self)
			CONFIG:AttachObserver(self, "LocalNotifications_PlayerEnabledForFullLives")
			self.switchedOn = (CONFIG:RetrieveBoolean("LocalNotifications_PlayerEnabledForFullLives", true) == true)
			self:AddObserver(EventMap.GURU_VALUECHANGE, self)
		end,
		OnConfigUpdate = function (self, event)
			if (event.configData.key == "LocalNotifications_PlayerEnabledForFullLives") then
				self.switchedOn = event.configData.value
			end
			WriteConfig()
		end,
		OnValueChange = function (self, event)
			CONFIG:Store("LocalNotifications_PlayerEnabledForFullLives", (self.switchedOn == true))
		end,
	},

	GetNotificationLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Get Lives Notification"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,313+NotificationSwitch_nudge_y},
		wrapLimit = 260,
		heightLimit = 50,
		visible = false,
	},
}

Scripts.Preshow_NotificationsDialog = function(dialog)


end

Scripts.Present_NotificationsDialog = function(dialog)


end

Resources.AskFriendsDialog = Resources.LivesDialog:new {
	resource = "LivesDialog",
    name = "AskFriendsDialog",
	title = "",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Ask Friends"),
		alignment = MidTop,
		alignmentOffset = {0, 50},
    },

	FriendPic1 = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		image = "FriendPic_Empty.png",
		defaultImage = "FriendPic_Empty.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {-90,175},
		size = {60, 60},
		resizeOnSetImage = false,
		PlayerFrame = Resources.Actor:new {
			image = "PlayerFrame.png",
			size = {60, 60},
			alignment = "Center",
			alignTo = "Center",
			zorder = 1,
		},
		checkMark = Resources.Actor:new {
			resource = "Actor",
			image = "Check.png",
			size = {48, 37},
			resizeOnSetImage = false,
			visible = false,
			alignTo = "TopRight",
			alignment = "Center",
		},
	},

	FriendPic2 = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		image = "FriendPic_Empty.png",
		defaultImage = "FriendPic_Empty.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,175},
		size = {60, 60},
		resizeOnSetImage = false,
		PlayerFrame = Resources.Actor:new {
			image = "PlayerFrame.png",
			size = {60, 60},
			alignment = "Center",
			alignTo = "Center",
			zorder = 1,
		},
		checkMark = Resources.Actor:new {
			resource = "Actor",
			image = "Check.png",
			size = {48, 37},
			resizeOnSetImage = false,
			visible = false,
			alignTo = "TopRight",
			alignment = "Center",
		},
	},

	FriendPic3 = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		image = "FriendPic_Empty.png",
		defaultImage = "FriendPic_Empty.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {90,175},
		size = {60, 60},
		resizeOnSetImage = false,
		PlayerFrame = Resources.Actor:new {
			image = "PlayerFrame.png",
			size = {60, 60},
			alignment = "Center",
			alignTo = "Center",
			zorder = 1,
		},
		checkMark = Resources.Actor:new {
			resource = "Actor",
			image = "Check.png",
			size = {48, 37},
			resizeOnSetImage = false,
			visible = false,
			alignTo = "TopRight",
			alignment = "Center",
		},
	},

	--[[
	FacebookLogo_big = Resources.Actor:new {
		image = "FacebookLogo_big.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,200},
	},
	--]]

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("Get More Lives Text"),
	},

	AskFriendsButton = Resources.BigDialogButton:new {
		resources = {"BigDialogButton", "AuthenticationAwareDecorator"},
		buttonClosesDialog = false,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-50},
		text = STRINGS("Ask Friends"),
		enterKey = true,
		shortcutKey = "a",

		-- AuthenticationAwareDecorator settings:
		visibleWhenConnected = true,
		visibleWhenDisconnected = false,
		raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
		isConnectUI = true,

		OnPostSpawn = function (self)
			-- Initialize AuthenticationAwareDecorator:
			Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
		end,
	},

	facebookConnectButton = Resources.BigDialogButton:new {
		resources = {"BigDialogButton", "FacebookConnectDecorator"},
		buttonClosesDialog = false,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-50},
		textAlignmentOffset = {14, 0},
		textWidthLimit = 140,
		enterKey = true,
		shortcutKey = "a",
		raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
		isConnectUI = true,

		facebookIcon = Resources.Actor:new {
			resource = "Actor",
			image = "Facebook_Logo_small.png",
			alignment = "MidLeft",
			alignmentOffset = {18, 0},
		},

		OnPostSpawn = function (self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
		end,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Scripts.Preshow_AskFriendsDialog = function(dialog,stats)


end

Scripts.Present_AskFriendsDialog = function(dialog,stats)


end

Resources.MoreLivesNowDialog = Resources.LivesDialog:new {
	resource = "LivesDialog",
    name = "AskFriendsDialog",
	title = "",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("More Hearts Now"),
		alignment = MidTop,
		alignmentOffset = {0, 70},
    },

	Heart_add = Resources.Actor:new {
		image = "Heart_add.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,200},
		scripts = {"HeartBeatLoop_dialog"},
	},

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("Purchase Lives"),
	},

	PriceButton = Resources.PriceButton:new {
		resource = "PriceButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-50},
		enterKey = true,
		shortcutKey = "a",
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Scripts.Preshow_MoreLivesNowDialog = function(dialog,stats)


end

Scripts.Present_MoreLivesNowDialog = function(dialog,stats)


end

--Get More Lives Dialog

Resources.GetMoreLivesDialog = Resources.LivesDialog:new {
	resource = "LivesDialog",
	class = "GetMoreLivesDialog",
    name = "GetMoreLivesDialog",
	title = "",

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-8},
    },

	titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Get More Lives"),
		alignment = MidTop,
		alignmentOffset = {0, 100-70},
		widthLimit = 205,
    },

	Heart = Resources.Actor:new {
		image = "Heart_add.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,200-70},
		scripts = {"HeartBeatLoop_dialog"},
	},

	TextLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("Time To Next Life"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,268-70},
		widthLimit = 290,
		Tick = function (self)
			self.visible = LIVES_MGR:IsNewLifePending()
		end,
	},

	TimeToNextLife = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		text = STRINGS(""),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,310-70},
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		pointPanel = Resources.Actor:new{
			image = "GamePanel_ScoreMeter_Banner.png",
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0,0},
		},
		Tick = function (self)
			self.visible = LIVES_MGR:IsNewLifePending()
			self.text = LIVES_MGR:DescribeTimeToNextLife()
		end,
	},

    AskFriendsButton = Resources.Actor:new {
        resource = "Actor",
        visible = false,
    },
--[[
	AskFriendsButton = Resources.AppMenuBigButton_arrow_facebook:new {
		resources = {"AppMenuBigButton_arrow_facebook", "AuthenticationAwareDecorator"},
		--buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-80},
		text = STRINGS("Ask Friends"),
		shortcutKey = "a",
        textWidthLimit = 150,

		-- AuthenticationAwareDecorator settings:
		visibleWhenConnected = true,
		visibleWhenDisconnected = false,
		raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
		isConnectUI = true,

		OnPostSpawn = function (self)
			-- Initialize AuthenticationAwareDecorator:
			Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
		end,

		OnButtonClick = function (self, event)
			if self ~= event.button then
				return false
			end
			Gifting_RequestLivesFromFriends()
			return true
		end,
	},
--]]

	MoreLivesNowButton = Resources.AppMenuBigButton_arrow_heart:new {
		resource = "AppMenuBigButton_arrow_heart",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-20},
		text = STRINGS("More Lives Now"),
		shortcutKey = "m",
        textWidthLimit = 144,

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			zorder = 100,
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {70,37},

			OnPostSpawn = function (self)
				self.visible = ShouldShowTagSaleDialog() or (CONFIG:RetrieveConst("DebugSaleTags") == true)
			end,
		},

		GoldIcon = Resources.Actor:new {
			resource = "Actor",
			visible = false,
			image = "Gold_1bar.png",
			size = {222/2*.85,161/2*.85},
		},

		BundleItemsTag = Resources.BundleItemsTag:new {
			resource = "BundleItemsTag",
			alignment = MidTop,
			alignTo = MidBottom,
			alignmentOffset = {70+30,-20},
            zorder = 11,
            rotationAngle = {degrees = 20,},
		},
	},
}

Scripts.Preshow_GetMoreLivesDialog = function(dialog,stats)


end

Scripts.Present_GetMoreLivesDialog = function(dialog,stats)


end

local UnlockMoreLevelsDialog_panel_y_offset = 30

Resources.UnlockMoreLevelsDialog = Resources.LivesDialog:new {
	resource = "LivesDialog",
    name = "UnlockMoreLevelsDialog",
	image = "DialogGeneric_Small.png",
	alignmentOffset = Layout{{0,80},android={0,0}},
	title = "",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Open Next Land"),
		alignment = MidTop,
		widthLimit = 215,
		alignmentOffset = {-10, 15},
    },

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("Use the amount of Special Gems required to unlock this gate!"),
		alignTo = MidTop,
		alignmentOffset = {0,85},
		heightLimit = 65,
	},

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,50},
        size = {250,240},
    },

	GemTypeContainer1 = Resources.Actor:new {
		resource = "Actor",
		alpha = 0,
		alignment = Center,
		alignmentOffset = {-80, -60+UnlockMoreLevelsDialog_panel_y_offset},
		size = {60,60},
		zorder = 1,
		GemTypeImage1 = Resources.Actor:new {
			resource = "Actor",
			image = "GemSpecialGreen.png",
			alignment = Center,
			autoFillParent = true,
		},
	},

	QuantityLabel1 = Resources.AppTitleDialogLabel:new {
        resource = "AppTitleDialogLabel",
        alignment = Center,
        alignmentOffset = {-80,-15+UnlockMoreLevelsDialog_panel_y_offset},
        widthLimit = 50,
		zorder = 1,
		CheckBox = Resources.Actor:new {
			resource = "Actor",
			alignment = MidRight,
			alignTo = MidLeft,
			image = "X.png",
		},
	},

	GemTypeContainer2 = Resources.Actor:new {
		resource = "Actor",
		alpha = 0,
		alignment = Center,
		alignmentOffset = {0, -60+UnlockMoreLevelsDialog_panel_y_offset},
		size = {60,60},
		zorder = 1,
		GemTypeImage2 = Resources.Actor:new {
			resource = "Actor",
			image = "GemSpecialGreen.png",
			alignment = Center,
			autoFillParent = true,
		},
	},

	QuantityLabel2 = Resources.AppTitleDialogLabel:new {
        resource = "AppTitleDialogLabel",
        alignment = Center,
        alignmentOffset = {0,-15+UnlockMoreLevelsDialog_panel_y_offset},
        widthLimit = 50,
		zorder = 1,
		CheckBox = Resources.Actor:new {
			resource = "Actor",
			alignment = MidRight,
			alignTo = MidLeft,
			image = "X.png",
		},
	},

	GemTypeContainer3 = Resources.Actor:new {
		resource = "Actor",
		alpha = 0,
		alignment = Center,
		alignmentOffset = {80, -60+UnlockMoreLevelsDialog_panel_y_offset},
		size = {60,60},
		zorder = 1,
		GemTypeImage3 = Resources.Actor:new {
			resource = "Actor",
			image = "GemSpecialGreen.png",
			alignment = Center,
			autoFillParent = true,
		},
	},

	QuantityLabel3 = Resources.AppTitleDialogLabel:new {
        resource = "AppTitleDialogLabel",
        alignment = Center,
        alignmentOffset = {80,-15+UnlockMoreLevelsDialog_panel_y_offset},
        widthLimit = 50,
		zorder = 1,
		CheckBox = Resources.Actor:new {
			resource = "Actor",
			alignment = MidRight,
			alignTo = MidLeft,
			image = "X.png",
		},
	},

	BeatLevelLabel = Resources.AppTitleDialogLabel_UI2:new {
        resource = "AppTitleDialogLabel_UI2",
        alignment = Center,
        alignmentOffset = {0,15+UnlockMoreLevelsDialog_panel_y_offset},
        widthLimit = 150,
		zorder = 1,
		text = "",
		CheckBox = Resources.Actor:new {
			resource = "Actor",
			alignment = MidRight,
			alignTo = MidLeft,
			image = "X.png",
		},
	},

	PaySpecialsButton = Resources.BigDialogButton:new {
		resource = "BigDialogButton",
		image = "ButtonPlastic_Longer_Green.png",
        zorder = 2,
		buttonClosesDialog = false,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-20},
		text = STRINGS("Use Specials"),
		enterKey = true,
		shortcutKey = "p",
	},

	AskFriendsButton = Resources.BigDialogButton:new {
		resource = "BigDialogButton",
		image = "ButtonPlastic_Longer_Green.png",
        zorder = 2,
		buttonClosesDialog = false,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-75},
		text = STRINGS("Ask Friends"),
		enterKey = true,
		shortcutKey = "a",
        visible = false,
	},

	UnlockNowButton = Resources.BigDialogButton:new {
		resource = "BigDialogButton",
		image = "ButtonPlastic_Longer_Green.png",
        zorder = 2,
		buttonClosesDialog = false,
		alignment = MidBottom,
        alignmentOffset = {0,LargeLong_Dialog_Button_Y-10},
		text = STRINGS("Bypass"),
		shortcutKey = "u",
	},
--Open Gate Description

	TextLabel_bottom = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("Collect Special Gems by playing Levels or by collecting Explorers and activating Discoveries."),
		alignTo = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-50},
            font	= Resources.MapButtonFont:new{
                resource = "DialogFont",
                fontSize = 20,
            },
        heightLimit = 70,
		wrapLimit = 240,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Scripts.Update_UnlockMoreLevelsDialog = function(dialog)

	-- Center things based on what gems on are the dialog
    local count = 0;
	if(dialog.QuantityLabel1.visible)then count = count+1 end
	if(dialog.QuantityLabel2.visible)then count = count+1 end
	if(dialog.QuantityLabel3.visible)then count = count+1 end
	if(count==1)then
		--Move all 3 to the middle
		dialog.GemTypeContainer1.alignmentOffset = dialog.GemTypeContainer2.alignmentOffset
		dialog.QuantityLabel1.alignmentOffset = dialog.QuantityLabel2.alignmentOffset
		dialog.GemTypeContainer3.alignmentOffset = dialog.GemTypeContainer2.alignmentOffset
		dialog.QuantityLabel3.alignmentOffset = dialog.QuantityLabel2.alignmentOffset
	end
	if(count==2)then
		if(dialog.QuantityLabel1.visible and dialog.QuantityLabel2.visible)then
			dialog.GemTypeContainer1.alignmentOffset = {-80/2,dialog.GemTypeContainer1.alignmentOffset.y}
			dialog.QuantityLabel1.alignmentOffset =  {-80/2,dialog.QuantityLabel1.alignmentOffset.y}
			dialog.GemTypeContainer2.alignmentOffset = {80/2,dialog.GemTypeContainer2.alignmentOffset.y}
			dialog.QuantityLabel2.alignmentOffset =  {80/2,dialog.QuantityLabel2.alignmentOffset.y}
		end
		if(dialog.QuantityLabel2.visible and dialog.QuantityLabel3.visible)then
			dialog.GemTypeContainer2.alignmentOffset = {-80/2,dialog.GemTypeContainer2.alignmentOffset.y}
			dialog.QuantityLabel2.alignmentOffset =  {-80/2,dialog.QuantityLabel2.alignmentOffset.y}
			dialog.GemTypeContainer3.alignmentOffset = {80/2,dialog.GemTypeContainer3.alignmentOffset.y}
			dialog.QuantityLabel3.alignmentOffset =  {80/2,dialog.QuantityLabel3.alignmentOffset.y}
		end
		if(dialog.QuantityLabel1.visible and dialog.QuantityLabel3.visible)then
			dialog.GemTypeContainer1.alignmentOffset = {-80/2,dialog.GemTypeContainer1.alignmentOffset.y}
			dialog.QuantityLabel1.alignmentOffset =  {-80/2,dialog.QuantityLabel1.alignmentOffset.y}
			dialog.GemTypeContainer3.alignmentOffset = {80/2,dialog.GemTypeContainer3.alignmentOffset.y}
			dialog.QuantityLabel3.alignmentOffset =  {80/2,dialog.QuantityLabel3.alignmentOffset.y}
		end
	end

end

Scripts.Preshow_UnlockMoreLevelsDialog = function(dialog,stats)


end

Scripts.Present_UnlockMoreLevelsDialog = function(dialog,stats)


end

Resources.UnlockNowDialog = Resources.LivesDialog:new {
	resource = "LivesDialog",
    name = "AskFriendsDialog",
	title = STRINGS("Unlock Now"),

	Passes = Resources.Actor:new {
		image = "Passes.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,200},
		scripts = {"DialogButtonGroove"},
	},

	TextLabel = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS("Purchase Levels"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,290},
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		wrapLimit = 250,
	},

	PriceButton = Resources.PriceButton:new {
		resource = "PriceButton",
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-50},
		text = STRINGS("$0.99"),
	},

	CancelButton = Resources.DialogButton:new {
		resource = "DialogButton",
		text = STRINGS("Back"),
		shortcutKey = "B",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y},
		escapeKey = true,
		buttonClosesDialog = true,
	},
}

Scripts.Preshow_UnlockNowDialog = function(dialog,stats)


end

Scripts.Present_UnlockNowDialog = function(dialog,stats)


end

Resources.AskFriendsDialog_levels = Resources.LivesDialog:new {
	resource = "LivesDialog",
    name = "AskFriendsDialog_levels",
	title = STRINGS("Ask Friends"),

	Friend1 = Resources.Actor:new {
		image = "Friend_big.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {100,200},
	},

	Friend2 = Resources.Actor:new {
		image = "Friend_big.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,200},
	},

	Friend3 = Resources.Actor:new {
		image = "Friend_big.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {-100,200},
	},

	TextLabel = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS("Ask Friends For Land"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,280},
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		wrapLimit = 250,
	},

	AskFriendsButton = Resources.AppMenuBigButton:new {
		resource = "AppMenuBigButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-50},
		text = STRINGS("Ask Friends"),
		enterKey = true,
		shortcutKey = "a",
	},

	CancelButton = Resources.DialogButton:new {
		resource = "DialogButton",
		text = STRINGS("Back"),
		shortcutKey = "B",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y},
		escapeKey = true,
		buttonClosesDialog = true,
	},
}

Scripts.Preshow_AskFriendsDialog_levels = function(dialog,stats)


end

Scripts.Present_AskFriendsDialog_levels = function(dialog,stats)


end



--Summarizes the end of the game.
Resources.RingStoreDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "RingStoreDialog",
	class = "RingStoreDialog",

	title = "",
	titleAlignmentOffset = {0,40},

	titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Ring Store"),
		alignment = MidTop,
		alignmentOffset = {0, 50},
    },

	extraLifeButton = Resources.AppMenuBiggerButton:new {
		resource = "AppMenuBiggerButton",
		alignment = "Center",
		alignmentOffset = {0,0},
		zorder = 20,
		text = STRINGS("Extra Life"),
        alpha = 255,

		CheckMark = Resources.Actor:new{
			resource = "Actor",
			image = "Check.png",
			alignment = TopRight,
			alignmentOffset = {15,-15},
			visible = false,
			zorder = 10,
		},

		boughtProperties = {
			CheckMark = {
				class = "Actor",
				visible = true,
			},
			active = false,
		},
		notBoughtProperties = {
			CheckMark = {
				class = "Actor",
				visible = false,
			},
			active = true,
		},
		buyableProperties = {
		},
		notBuyableProperties = {
		},
        activeProperties = {
        },
        inactiveProperties = {
        },
	},

	cascadeVisionButton = Resources.AppMenuBiggerButton:new {
		resource = "AppMenuBiggerButton",
		alignment = "Center",
		alignmentOffset = {0,-100},
		zorder = 20,
		text = STRINGS("Cascade Vision"),
        alpha = 255,

		CheckMark = Resources.Actor:new{
			resource = "Actor",
			image = "Check.png",
			alignment = TopRight,
			alignmentOffset = {15,-15},
			visible = false,
			zorder = 10,
		},

		boughtProperties = {
			CheckMark = {
				class = "Actor",
				visible = true,
			},
		},
		notBoughtProperties = {
			CheckMark = {
				class = "Actor",
				visible = false,
			},
		},
		buyableProperties = {
		},
		notBuyableProperties = {
		},
        activeProperties = {
			CheckMark = {
				class = "Actor",
                alpha = 255,
			},
        },
        inactiveProperties = {
			CheckMark = {
				class = "Actor",
                alpha = 128,
			},
        },
	},
	--[[
	OkayButton = Resources.AppMenuButton:new {
		resource = "AppMenuButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		textAlignmentOffset = {0,0},
		enterKey = true,
		shortcutKey = "o",
	},
	--]]

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Resources.BuyPowerupDialog = Resources.LargeLongerDialog:new {

	class = "BuyPowerupDialog",
	resource = "LargeLongerDialog",
    name = "BuyPowerupDialog",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Get Powerup"),
		alignment = MidTop,
		alignmentOffset = {0, 35-20},
		widthLimit = 220, -- <---- went from 200 to 220
    },

	BundleItemsTag = Resources.BundleItemsTag:new {
		resource = "BundleItemsTag",
		alignment = MidTop,
		alignmentOffset = {20, 215},
		zorder = 5,
        rotationAngle = {degrees = 15,},
		visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
	},

	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-45},
        PurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("test text"),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {0,0},
            wrapLimit = 250,
			CrossOut = Resources.AppTitleDialogLabel_bigger:new {
				resource = "AppTitleDialogLabel_bigger",
				text = STRINGS("/"),
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {0,0},
				visible = false,
				zorder = 10,
				shadowAlpha = 0,
				highlightAlpha = 0,
				alpha = 200,
				extraScale = {1.5,1.2},
				rotationAngle = {degrees = 15,},
			},
        },

        SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_bigger:new {
            resource = "AppTitleDialogLabel_bigger",
            text = STRINGS(""),
            textColor = "Red",
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {10,40},
            wrapLimit = 250,
            visible = false,
			rotationAngle = {degrees = 5,},
        },
	},

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("This powerup does something cool!"),
		alignmentOffset = {0,320-headerOffset},
        heightLimit = 60,
		centerWrap = true,
	},

	ProgressLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Using Gold..."),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-80},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
	},

	CancelledLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no money was spent."),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-80},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
        heightLimit = 40,
	},

	CancelledLabel_Gold = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no gold was spent."),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-80},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
        heightLimit = 40,
	},

    PriceButton = Resources.PriceButton:new {
        resource = "PriceButton",
        image = "ButtonPlastic_Long_Green.png",
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-20},
        text = STRINGS("$0.99"),

        textColor = "Cascade_BrightYellow",
        textHighlightColor = "Cascade_DarkGreen",
        textHighlightAlpha = 255,
        textShadowColor = "Cascade_DarkGreen",
        textShadowOffset = {1, 2},

        --extraScale = 0.75,
        textWidthLimit = 70,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Resources.QuantityMedal = Resources.Actor:new {
	resource = "Actor",
	image = "NumberMarker_big.png",
	alignTo = MidLeft,
	alignment = Center,
	alignmentOffset = {10,4},
	zorder = 2,
	PurchaseQuantityLabel = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		text = "",
		zorder = 0,
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {-2,-3},
		widthLimit = 40,
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 38,
		},
	},
	CrossOut = Resources.AppTitleDialogLabel_bigger:new {
		resource = "AppTitleDialogLabel_bigger",
		text = STRINGS("/"),
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {-2,-3},
		visible = false,
		shadowAlpha = 0,
		highlightAlpha = 0,
		alpha = 200,
		extraScale = {1.5,1.2},
		rotationAngle = {degrees = 15,},
	},
	SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS(""),
		alignment = Center,
		alignTo = BottomRight,
		alignmentOffset = {-2,-3},
		wrapLimit = 250,
		visible = false,
		zorder = 1,
		rotationAngle = {degrees = 5,},
	},
	visible = false,
}

Resources.QuantityMedal_bronze = Resources.QuantityMedal:new {
	resource = "QuantityMedal",
	image = "Number_Marker_bronze.png",
	PurchaseQuantityLabel = {
		class = "Label",
		widthLimit = 20,
		text = "3",
	},
}

Resources.QuantityMedal_silver = Resources.QuantityMedal:new {
	resource = "QuantityMedal",
	image = "Number_Marker_silver.png",
	PurchaseQuantityLabel = {
		class = "Label",
		widthLimit = 28,
		text = "5",
	},
}

Resources.QuantityMedal_gold = Resources.QuantityMedal:new {
	resource = "QuantityMedal",
	image = "Number_Marker_gold.png",
	PurchaseQuantityLabel = {
		class = "Label",
		text = "10",
	},
}

--Secondary Shop Dialog Buttons

Resources.PriceButton_New = Resources.AppButtonSmall:new {
	resource = "AppButtonSmall",
	image = "ButtonPlastic_Shop_Long.png",
	buttonClosesDialog = true,
	alignment = "Center",
	alignmentOffset = {70,-3},
	enterKey = true,
	shortcutKey = "a",
	clickSound = "coin_magic_05.ogg",
	textAlignmentOffset = {-20,0},

        textColor = "Cascade_BrightYellow",
        textHighlightColor = "Cascade_DarkGreen",
        textHighlightAlpha = 255,
        textShadowColor = "Cascade_DarkGreen",
        textShadowOffset = {1, 2},

	GoldIcon = Resources.Actor:new {
		resource = "Actor",
		visible = false,
		image = "Gold_1bar.png",
		size = {222/2*.7,161/2*.7},
	},

	CrossOut_Price = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("/"),
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {-20,0},
		visible = false,
		zorder = 10,
		shadowAlpha = 0,
		highlightAlpha = 0,
		alpha = 200,
		extraScale = {1.5,1.2},
		rotationAngle = {degrees = 25,},
	},
    AlteredPrice = Resources.AppTitleDialogLabel_small:new {
        resource = "AppTitleDialogLabel_small",
        text = STRINGS(""),
        alignment = MidBottom,
        alignTo = MidTop,
        alignmentOffset = {-20,20},
        wrapLimit = 250,
        visible = false,
		rotationAngle = {degrees = -15,},
    },
}

Resources.QuantityGroup = Resources.Actor:new {
	resource = "Actor",
	size = {60,60},
	color = "Blue",
	alpha = 0,
	alignTo = MidLeft,
	alignment = MidLeft,
	alignmentOffset = {64,-2},
	zorder = 2,
	PurchaseQuantityLabel = Resources.AppTitleDialogLabel_UI2:new {
		resource = "AppTitleDialogLabel_UI2",
		text = "",
		zorder = 0,
		alignment = MidLeft,
		alignTo = MidLeft,
		alignmentOffset = {0,0},
		widthLimit = 100,
		font = Resources.DialogTitleFont:new {
			resource = "DialogTitleFont",
			fontSize = 32,
		},
	},
	CrossOut = Resources.AppTitleDialogLabel_big:new {
		resource = "AppTitleDialogLabel_big",
		text = STRINGS("/"),
		alignment = MidLeft,
		alignTo = MidLeft,
		alignmentOffset = {4,0},
		visible = false,
		shadowAlpha = 0,
		highlightAlpha = 0,
		alpha = 200,
		extraScale = {1.5,1.2},
		rotationAngle = {degrees = 15,},
		zorder = 2,
	},
	SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_UI2:new {
		resource = "AppTitleDialogLabel_UI2",
		text = STRINGS(""),
		alignment = Center,
		alignTo = BottomRight,
		alignmentOffset = {-12,-14},
		visible = false,
		zorder = 1,
		rotationAngle = {degrees = 5,},
		widthLimit = 100,
		fgColor = "Cascade_Canvas_Red",
		shadowAlpha = 100,
		highlightAlpha = 100,
		font = Resources.DialogTitleFont:new {
			resource = "DialogTitleFont",
			fontSize = 34,
		},
	},
	visible = false,
}

Resources.BuyPowerupDialog_MultiplePricePoints = Resources.LargeLongerDialog:new {
	class = "BuyPowerupDialog",
	resource = "LargeLongerDialog",
    name = "BuyPowerupDialog",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    titleText = Resources.AppTitleDialogLabel_UI2_bigger:new {
		resource = "AppTitleDialogLabel_UI2_bigger",
		text = STRINGS("Get Powerup!"),
		widthLimit = 200,
		visible = true,
    },

	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-50-65-(headerOffset/2)+10},
		zorder = 1,

        PurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("test text"),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {0,0},
            wrapLimit = 250,
			CrossOut = Resources.AppTitleDialogLabel_bigger:new {
				resource = "AppTitleDialogLabel_bigger",
				text = STRINGS("/"),
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {0,0},
				visible = false,
				zorder = 10,
				shadowAlpha = 0,
				highlightAlpha = 0,
				alpha = 200,
				extraScale = {1.5,1.2},
				rotationAngle = {degrees = 15,},
			},
        },

		BundleItemsTag = Resources.BundleItemsTag:new {
			resource = "BundleItemsTag",
			alignment = MidLeft,
			alignTo = MidRight,
			alignmentOffset = {-22,10},
			zorder = 5,
	        rotationAngle = {degrees = 15,},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
		},

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			zorder = 5,
			alignment = MidRight,
			alignTo = MidLeft,
			alignmentOffset = {30,17},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
		},

        SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_bigger:new {
            resource = "AppTitleDialogLabel_bigger",
            text = STRINGS(""),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {10,40},
            wrapLimit = 250,
            visible = false,
			rotationAngle = {degrees = 5,},
        },

		scripts = {"DialogButtonGroove"},
	},

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("This powerup does something cool!"),
		alignmentOffset = {0,320-115-(headerOffset)-2},
		wrapLimit = 250,
		heightLimit = 60,
		centerWrap = true,
	},

	ProgressLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Using Gold..."),
		alignment = MidTop,
		alignmentOffset = {0,320-115-(headerOffset)-2},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
		centerWrap = true,
	},

	CancelledLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no money was spent."),
		alignment = MidTop,
		alignmentOffset = {0,320-115-(headerOffset)-2},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
		centerWrap = true,
	},

	CancelledLabel_Gold = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no gold was spent."),
		alignment = MidTop,
		alignmentOffset = {0,320-115-(headerOffset)-2},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
		centerWrap = true,
        heightLimit = 40,
	},

	Panel = Resources.Actor:new {
		resource = "Actor",
		image = "Dialog_Banner.png",
		zorder = 1,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-85-65-10},
		alignment = MidBottom,
		Icon = Resources.Actor:new {
			resource = "Actor",
			image = "Boost_SpinSaver.png",
			alignment = "MidLeft",
			size = {220/2/2.0,220/2/2.0},
			alignmentOffset = {8,-3},
			resizeOnSetImage = false,
		},
		PriceButton = Resources.PriceButton_New:new {
            zorder = 2,
			resource = "PriceButton_New",
			text = STRINGS("$0.99"),
			DescriptionTag = Resources.PlainTag:new {
				resource = "PlainTag",
				text = {
					class = "Label",
					text = STRINGS("Good"),
				},
			},
		},
        DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Shop_Long_WoodOutline.png",
		alignmentOffset = {-8,-2},
		alignment = Right,
        zorder = 1,
        },
		PurchaseQuantityMedal = Resources.QuantityGroup:new {
			resource = "QuantityGroup",
		},
	},

	Panel_better = Resources.Actor:new {
		resource = "Actor",
		image = "Dialog_Banner.png",
		zorder = 1,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-85},
		alignment = MidBottom,
		Icon_better = Resources.Actor:new {
			resource = "Actor",
			image = "Boost_SpinSaver.png",
			alignment = "MidLeft",
			size = {220/2/2.0,220/2/2.0},
			alignmentOffset = {8,-3},
			resizeOnSetImage = false,
		},
		PriceButton_better = Resources.PriceButton_New:new {
            zorder = 2,
			resource = "PriceButton_New",
			text = STRINGS("$0.99"),
			DescriptionTag = Resources.PlainTag:new {
				resource = "PlainTag",
				text = {
					class = "Label",
					text = STRINGS("Better"),
				},
			},
		},
        DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Shop_Long_WoodOutline.png",
		alignmentOffset = {-8,-2},
		alignment = Right,
        zorder = 1,
        },

		PurchaseQuantityMedal = Resources.QuantityGroup:new {
			resource = "QuantityGroup",
		},
	},

	Panel_best = Resources.Actor:new {
		resource = "Actor",
		image = "Dialog_Banner.png",
		zorder = 1,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-20+10},
		alignment = MidBottom,
		Icon_best = Resources.Actor:new {
			resource = "Actor",
			image = "Boost_SpinSaver.png",
			alignment = "MidLeft",
			size = {220/2/2.0,220/2/2.0},
			alignmentOffset = {8,-3},
			resizeOnSetImage = false,
		},
		PriceButton_best = Resources.PriceButton_New:new {
            zorder = 2,
			resource = "PriceButton_New",
			text = STRINGS("$0.99"),
			DescriptionTag = Resources.PlainTag:new {
				resource = "PlainTag",
				text = {
					class = "Label",
					text = STRINGS("Best"),
				},
			},
		},
        DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Shop_Long_WoodOutline.png",
		alignmentOffset = {-8,-2},
		alignment = Right,
        zorder = 1,
        },

		PurchaseQuantityMedal = Resources.QuantityGroup:new {
			resource = "QuantityGroup",
		},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Resources.BuyPowerupDialog_MultiplePricePointsForLives = Resources.LargeLongerDialog:new {
	class = "BuyPowerupDialog",
	resource = "LargeLongerDialog",
    name = "BuyPowerupDialog",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    titleText = Resources.AppTitleDialogLabel_UI2:new {
		resource = "AppTitleDialogLabel_UI2",
		text = STRINGS("Get Powerup"),
		widthLimit = 200,
		visible = false,
    },

    titleText_alt = Resources.AppTitleDialogLabel_UI2_bigger:new {
		resource = "AppTitleDialogLabel_UI2_bigger",
		text = STRINGS("Get Lives!"),
		wrapLimit = 250,
        heightLimit = 60,
		visible = true,
    },

	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
		alignment = MidTop,
		alignTo = MidTop,
		--alignmentOffset = {0,-50-65-30+10},
        alignmentOffset = {0, 40},
		zorder = 2,

        PurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("test text"),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {0,0},
            wrapLimit = 250,
			CrossOut = Resources.AppTitleDialogLabel_bigger:new {
				resource = "AppTitleDialogLabel_bigger",
				text = STRINGS("/"),
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {0,0},
				visible = false,
				zorder = 10,
				shadowAlpha = 0,
				highlightAlpha = 0,
				alpha = 200,
				extraScale = {1.5,1.2},
				rotationAngle = {degrees = 15,},
			},
        },

        BundleItemsTag = Resources.BundleItemsTag:new {
			resource = "BundleItemsTag",
			alignment = MidLeft,
			alignTo = MidRight,
			alignmentOffset = {-45,10},
			zorder = 5,
	        rotationAngle = {degrees = 15,},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
		},

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			zorder = 5,
			alignment = MidRight,
			alignTo = MidLeft,
			alignmentOffset = {30,17},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
		},

        SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_bigger:new {
            resource = "AppTitleDialogLabel_bigger",
            text = STRINGS(""),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {10,40},
            wrapLimit = 250,
            visible = false,
			rotationAngle = {degrees = 5,},
        },

		scripts = {"DialogButtonGroove"},
	},

        PowerUpShadow = Resources.Actor:new {
        resource = "Actor",
        image = "PowerUpShadow.png",
        alignment = MidTop,
        alignTo = MidTop,
        alignmentOffset = {0, 75},
		zorder = 1,
    },


	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("This powerup does something cool!"),
		alignmentOffset = {0,320-115-(headerOffset)-2},
		wrapLimit = 250,
		heightLimit = 60,
		centerWrap = true,
	},

	ProgressLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Using Gold..."),
		alignment = MidTop,
		alignmentOffset = {0,320-115-(headerOffset)-2},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
	},

	CancelledLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no money was spent."),
		alignment = MidTop,
		alignmentOffset = {0,320-115-(headerOffset)-2},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
	},

	CancelledLabel_Gold = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no gold was spent."),
		alignment = MidTop,
		alignmentOffset = {0,320-115-(headerOffset)-2},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
        heightLimit = 40,
	},

	Panel = Resources.Actor:new {
		resource = "Actor",
		image = "Dialog_Banner.png",
		zorder = 1,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-85-65-10},
		alignment = MidBottom,
		TextLabel = Resources.AppTitleDialogLabel_UI2:new {
			resource = "AppTitleDialogLabel_UI2",
			text = STRINGS("This powerup does something cool!"),
			--wrapLimit = 300,
			alignment = "Center",
			alignmentOffset = {-90,-2},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 28,
			},
			visible = false,
		},
		TextLabel_callout = Resources.AppTitleDialogLabel_UI2:new {
			resource = "AppTitleDialogLabel_UI2",
			text = STRINGS("REFILL"),
			widthLimit = 80,
			alignment = "Center",
			alignmentOffset = {-38,-2},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 28,
			},
		},
		Icon_heart = Resources.Actor:new {
			resource = "Actor",
			image = "Heart.png",
			alignment = "MidLeft",
			size = {220/2/2.0,220/2/2.0},
            resizeOnSetImage = false,
			alignmentOffset = {8,-2},
			livesAmountLabel = Resources.Label:new {
				resource = "Label",
				text = STRINGS("5"),
				font = Resources.DialogTitleFont:new {
					resource = "DialogTitleFont",
					fontSize = 24,
				},
				fgColor = "White",
				shadowColor = "Black",
				highlightColor = "Black",
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = {0,0},
			},
		},
		PriceButton = Resources.PriceButton_New:new {
            zorder = 2,
			resource = "PriceButton_New",
			alignment = "Center",
			alignmentOffset = {72,-2},
			text = STRINGS("$0.99"),
			DescriptionTag = Resources.PlainTag:new {
				resource = "PlainTag",
				text = {
					class = "Label",
					text = STRINGS("Good"),
				},
			},
			PurchaseQuantityMedal = Resources.QuantityMedal_bronze:new {
				resource = "QuantityMedal_bronze",
				visible = false,
			},
		},
        DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Shop_Long_WoodOutline.png",
		alignmentOffset = {-8,-2},
		alignment = Right,
        zorder = 1,
        },
	},

	Panel_better = Resources.Actor:new {
		resource = "Actor",
		image = "Dialog_Banner.png",
		zorder = 1,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-85},
		alignment = MidBottom,
		TextLabel_callout_better = Resources.AppTitleDialogLabel_UI2:new {
			resource = "AppTitleDialogLabel_UI2",
			text = STRINGS("REFILL\nPLUS MORE!"),
			--wrapLimit = 300,
			widthLimit = 80,
			alignment = "Center",
			alignmentOffset = {-38,-2},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 24,
			},
		},
		Icon_heart = Resources.Actor:new {
			resource = "Actor",
			image = "Heart.png",
			alignment = "MidLeft",
			size = {220/2/1.8,220/2/1.8},
            resizeOnSetImage = false,
			alignmentOffset = {4,-2},
			livesAmountLabel = Resources.Label:new {
				resource = "Label",
				text = STRINGS("11"),
				font = Resources.DialogTitleFont:new {
					resource = "DialogTitleFont",
					fontSize = 24,
				},
				fgColor = "White",
				shadowColor = "Black",
				highlightColor = "Black",
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = {0,0},
			},
		},
		PriceButton_better = Resources.PriceButton_New:new {
            zorder = 2,
			resource = "PriceButton_New",
			alignment = "Center",
			alignmentOffset = {72,-2},
			text = STRINGS("$0.99"),
			DescriptionTag = Resources.PlainTag:new {
				resource = "PlainTag",
				text = {
					class = "Label",
					text = STRINGS("Good"),
				},
			},
			PurchaseQuantityMedal = Resources.QuantityMedal_bronze:new {
				resource = "QuantityMedal_bronze",
				visible = false,
			},
		},
        DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Shop_Long_WoodOutline.png",
		alignmentOffset = {-8,-2},
		alignment = Right,
        zorder = 1,
        },
    },

	Panel_best = Resources.Actor:new {
		resource = "Actor",
		image = "Dialog_Banner.png",
		zorder = 1,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-20+10},
		alignment = MidBottom,
		TextLabel_callout_best = Resources.AppTitleDialogLabel_UI2:new {
			resource = "AppTitleDialogLabel_UI2",
			text = STRINGS("INFINITE\nFOR 2 HRS!"),
			widthLimit = 80,
			alignment = "Center",
			alignmentOffset = {-34,-2},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 26,
			},
		},
		Icon_heart = Resources.Actor:new {
			resource = "Actor",
			image = "Heart_infinity.png",
			alignment = "MidLeft",
			size = {220/2/1.6,220/2/1.6},
            resizeOnSetImage = false,
			alignmentOffset = {0,-2},
			livesAmountLabel = Resources.Label:new {
				resource = "Label",
				text = "",
				font = Resources.DialogTitleFont:new {
					resource = "DialogTitleFont",
					fontSize = 24,
				},
				fgColor = "White",
				shadowColor = "Black",
				highlightColor = "Black",
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = {0,0},
			},
		},
		PriceButton_best = Resources.PriceButton_New:new {
            zorder = 2,
			resource = "PriceButton_New",
			alignment = "Center",
			alignmentOffset = {72,-2},
			text = STRINGS("$0.99"),
			DescriptionTag = Resources.PlainTag:new {
				resource = "PlainTag",
				text = {
					class = "Label",
					text = STRINGS("Good"),
				},
			},
			PurchaseQuantityMedal = Resources.QuantityMedal_bronze:new {
				resource = "QuantityMedal_bronze",
			},
		},
        DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Shop_Long_WoodOutline.png",
		alignmentOffset = {-8,-2},
		alignment = Right,
        zorder = 1,
        },
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Resources.BuyPowerupDialog_MultiplePricePointsForInfiniteLives = Resources.LargeLongerDialog:new {
	class = "BuyPowerupDialog",
	resource = "BuyPowerupDialog_MultiplePricePointsForLives",

    titleText_alt = {
        class = "override",
        text = STRINGS("Get Infinite Lives!"),
        heightLimit = 30,
		alignmentOffset = {-15,10},
    },

    Panel_better = {
        class = "override",
        Icon_heart = {
            class = "override",
            image = "Heart_infinity.png",
            livesAmountLabel = {
                class = "override",
                visible = false,
            },
        },
    },

    Panel = {
        class = "override",
        Icon_heart = {
            class = "override",
            image = "Heart_infinity.png",
            livesAmountLabel = {
                class = "override",
                visible = false,
            },
        },
    },
}



Resources.BottomDialog = Resources.DialogCommon:new {
	resource = "DialogCommon",
	title = "",
    class = "Dialog",
	titleAlignmentOffset = {0,85},
    alignment = MidBottom,
    alignmentOffset = {0,0},
	enableVisibleUnderlay = false,

	image = "Leaderboard_Panel.png",

	introScriptName = "SlideUpFromBottomDialog",
	dialogExitScriptName = "SlideDownFromBottomDialog",
}

Resources.UsePowerupDialog = Resources.BottomDialog:new {
	class = "UsePowerupDialog",
	resource = "BottomDialog",
    name = "UsePowerupDialog",

    titleText = Resources.AppDialogBoldLabel_small:new {
		resource = "AppDialogBoldLabel_small",
		text = STRINGS("Use Powerup"),
		alignment = MidTop,
		alignmentOffset = {0, 6},
    },

	PowerupImage = Resources.AppButton:new {
		resource = "AppButton",
		image = "Boost_SpinSaver.png",
		alignment = MidLeft,
		alignTo = MidLeft,
		alignmentOffset = {20,4},
		alignmentOffset = Layout{{34,4},iphone5={34,4},ipad={20,4}},
		scripts = {"DialogButtonGroove"},
	},

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("This powerup does something cool!"),
		alignment = MidTop,
		alignTo = MidTop,
		alignmentOffset = {0,0},
		visible = false,
	},

	NumRemainingLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("22 Left!"),
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = Layout{{0,-3},iphone5={0,-3},ipad={0,-5}},
	},

	Use1Button = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-10},
		text = STRINGS("Use 1"),
		enterKey = true,
		shortcutKey = "a",
		textWidthLimit = 115,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		alignmentOffset = Layout{{-34,10},iphone5={-34,10},ipad={-12,10}},
	},

	HelpButton = Resources.AppButton:new{
		resource = "AppButton",
		image = "HelpButton.png",
		shortcutKey = "?",
		functionKey = 282,--SDLK_F1
		alignment = "BottomRight",
		alignmentOffset = Layout{{-34,-5},iphone5={-34,-5},ipad={-12,-5}},
		zorder = 12,
		useFrames = false,
	},
}

Scripts.DelayedShowFreePowerupDialog = function(screen,powerupName,quantity,delay)
	ScriptDelay(delay,"DialogTimers")
	local freePowerupDialog = screen:StartDialog("FreePowerupDialog","FreePowerupDialog",false)
	freePowerupDialog:SetPowerupName(powerupName,quantity)
end

Resources.FreePowerupDialog = Resources.LargeLongerDialog:new {
	class = "FreePowerupDialog",
	resource = "LargeLongerDialog",
    name = "FreePowerupDialog",
	dialogExitScriptName = "SlideDownDialogFreePowerup",

    fakeTitle = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Free Trick!"),
		alignment = MidTop,
		alignmentOffset = {0, 50},
        widthLimit = 175,
    },

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Powerup name!"),
		alignment = MidTop,
		alignmentOffset = {0, 100},
        widthLimit = 200,
    },

	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-20},
        PurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("test text"),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {0,0},
            wrapLimit = 250,
            visible = true,
        },
		scripts = {"DialogButtonGroove"},
	},

	TextLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("This powerup does something cool!"),
		alignment = MidTop,
		alignTo = Center,
		alignmentOffset = {0,20},
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		wrapLimit = 260,
		heightLimit = 125,
	},

    okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-10},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Scripts.ExcitedBoost = function(actor)
	--[[
	while(true) do
        --Pop(boost)
		local time = 100
		CorrectedPop(boost,  {expandTime=time, shrinkTime=time, expandTo={1.25, 1.0}})
		CorrectedPop(boost,  {expandTime=time, shrinkTime=time, expandTo={1.0, 1.15}})
		CorrectedPop(boost,  {expandTime=time, shrinkTime=time, expandTo={1.10, 1.0}})
		CorrectedPop(boost,  {expandTime=time, shrinkTime=time, expandTo={1.0, 1.05}})
		ScriptDelay(1000)
    end
	--]]
	local speed = 50
	local factor = math.random(10,20)
	local amount
	local pick = math.random(0,1)
	if(pick==0)then
		amount = 0-factor
	else
		amount = factor
	end

	local expandTo = {1.0, 1.025}
	local expandTime = 200
	local shrinkTime = 200
	local tilt = 2
	local swing = 1

	actor.scalingPoint = {50,118}
	actor.rotationPoint = {50,118}

	local firstTime = 1

	while(true)do
		if(swing==1)then
			doTilt = -tilt
			if(firstTime==1) then
				RotateByAmount(actor,{degrees=doTilt/2},100,true)
				firstTime = 0
			else
				RotateByAmount(actor,{degrees=doTilt},100,true)
			end
		end

		if(swing==3)then
			doTilt = tilt
			RotateByAmount(actor,{degrees=doTilt},100,true)
		end
		swing = swing + 1
		if(swing==5)then
			swing=1
		end

		actor.extraScale = {1.0, 1.0}
		ScaleTo(actor, expandTo, expandTime)
		ScriptDelay(expandTime,"DialogTimers")

		ScaleTo(actor, {1.0, 1.0}, shrinkTime)
		ScriptDelay(shrinkTime,"DialogTimers")

		ScriptDelay(0,"DialogTimers")

	end

	--RotateByAmount(actor,{degrees=-amount},speed,true)
	--RotateByAmount(actor,{degrees=amount*2-(amount/2)},speed,true)
	--RotateByAmount(actor,{degrees=-((amount/2)+(amount/4))},speed,true)
	--RotateByAmount(actor,{degrees=(amount/4)*2},speed,true)
	--RotateByAmount(actor,{degrees=-amount/4},speed,true)
	actor.rotation = { degrees = 0 }
end

Scripts.CleanupExcitedBoost = function(boost)
    StopScaling(boost)
    boost.extraScale = 1.0
	boost.rotation = { degrees = 0 }
end

Scripts.FreeBoost = function(boost)
	while(true) do
        --Pop(boost)
		local time = 100
		CorrectedPop(boost,  {expandTime=time, shrinkTime=time, expandTo={1.25, 1.0}})
		CorrectedPop(boost,  {expandTime=time, shrinkTime=time, expandTo={1.0, 1.15}})
		CorrectedPop(boost,  {expandTime=time, shrinkTime=time, expandTo={1.10, 1.0}})
		CorrectedPop(boost,  {expandTime=time, shrinkTime=time, expandTo={1.0, 1.05}})
		ScriptDelay(10000)
    end
end

Scripts.CleanupFreeBoost = function(boost)
    StopScaling(boost)
    boost.extraScale = 1.0
end

Resources.RateLevelDialog = Resources.LargeLongerDialog:new {
	class = "RateLevelDialog",
	resource = "LargeLongerDialog",
    name = "RateLevelDialog",
	title = "Tag Level",
	TextLabel = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS("Tag this level..."),
		alignment = MidTop,
		alignTo = MidTop,
		alignmentOffset = {0,140},
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		wrapLimit = 250,
	},
	--[[ BUG: When I put the buttons in a group like this, buttonClosesDialog does not work
	ButtonGroup = Resources.Actor:new {
		color = "Blue",
		alpha = 25,
		alignment = "Center",
		alignmentOffset = {0,75},
		size = {100,200},
		--]]

		Love = Resources.AppMenuButton:new {
			resource = "AppMenuButton",
			alignment = "Center",
			alignmentOffset = {0,-100+75},
			zorder = 20,
			text = STRINGS("Love!"),
			buttonClosesDialog = true,
			rating = "Love",
			CheckMark = Resources.Actor:new{
				resource = "Actor",
				image = "Check.png",
				alignment = TopRight,
				alignmentOffset = {15,-15},
				visible = false,
				zorder = 10,
			},
		},

		Like = Resources.AppMenuButton:new {
			resource = "AppMenuButton",
			alignment = "Center",
			alignmentOffset = {0,-50+75},
			zorder = 20,
			text = STRINGS("Like!"),
			buttonClosesDialog = true,
			rating = "Like",
			CheckMark = Resources.Actor:new{
				resource = "Actor",
				image = "Check.png",
				alignment = TopRight,
				alignmentOffset = {15,-15},
				visible = false,
				zorder = 10,
			},
		},

		TooEasy = Resources.AppMenuButton:new {
			resource = "AppMenuButton",
			alignment = "Center",
			alignmentOffset = {0,0+75},
			zorder = 20,
			text = STRINGS("Too Easy!"),
			buttonClosesDialog = true,
			rating = "TooEasy",
			CheckMark = Resources.Actor:new{
				resource = "Actor",
				image = "Check.png",
				alignment = TopRight,
				alignmentOffset = {15,-15},
				visible = false,
				zorder = 10,
			},
		},

		TooHard = Resources.AppMenuButton:new {
			resource = "AppMenuButton",
			alignment = "Center",
			alignmentOffset = {0,50+75},
			zorder = 20,
			text = STRINGS("Too Hard!"),
			buttonClosesDialog = true,
			rating = "TooHard",
			CheckMark = Resources.Actor:new{
				resource = "Actor",
				image = "Check.png",
				alignment = TopRight,
				alignmentOffset = {15,-15},
				visible = false,
				zorder = 10,
			},
		},

		NotFun = Resources.AppMenuButton:new {
			resource = "AppMenuButton",
			alignment = "Center",
			alignmentOffset = {0,100+75},
			zorder = 20,
			text = STRINGS("Not Fun!"),
			buttonClosesDialog = true,
			rating = "NotFun",
			CheckMark = Resources.Actor:new{
				resource = "Actor",
				image = "Check.png",
				alignment = TopRight,
				alignmentOffset = {15,-15},
				visible = false,
				zorder = 10,
			},
		},
	--},
	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}



Resources.PowerupUnlockedDialog = Resources.LargeLongerDialog:new {
	class = "PowerupUnlockedDialog",
	resource = "LargeLongerDialog",
    name = "PowerupUnlockedDialog",
	--title = "Boost  Unlocked",

    titleText = Resources.AppTitleDialogLabel_UI2:new {
		resource = "AppTitleDialogLabel_UI2",
		text = STRINGS("Boost Unlocked!"),
    },

	PowerupName = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Name goes here!"),
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-85-30-16},
		--fgColor = "Black",
		wrapLimit = 240,
		heightLimit = 50,
	},
	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-50},
		scripts = {"DialogButtonGroove"},
	},
	TextLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("This powerup does something cool!"),
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,80},
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		wrapLimit = 250,
        heightLimit = 70,
		--lineSpacing = 10,
	},
	PriceButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		buttonClosesDialog = true,
		enterKey = true,
		shortcutKey = "o",
	},
	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Resources.ChallengeUnlockedDialog = Resources.LargeLongerDialog:new {
	class = "Dialog",
	resource = "LargeLongerDialog",
    name = "ChallengeUnlockedDialog",

    titleText = Resources.AppTitleDialogLabel_UI2:new {
		resource = "AppTitleDialogLabel_UI2",
		text = STRINGS("New Mode!"),
    },

	PowerupName = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Daily Challenge!"),
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-85-30},
		--fgColor = "Black",
		wrapLimit = 250,
		heightLimit = 50,
	},
	StartChallengeButton = Resources.AppButtonMedium:new {
		resource = "AppButtonMedium",
		text = STRINGS("Daily Challenge"),
		textColor = "Cascade_SignTextBrown",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-50},
		rolloverable = false,
	},
	TextLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Puts together a randomly generated level every day. Compete with your friends for the best score!"),
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,80},
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		wrapLimit = 250,
	},
	OkayButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		buttonClosesDialog = true,
		enterKey = true,
		shortcutKey = "o",
	},
	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Scripts.Preshow_RateLevelDialog = function(dialog)


end

Scripts.Present_RateLevelDialog = function(dialog)


end

Scripts.RateLevel = function(dialog,star)
    --logprint("RateLevel "..star)

	local rateStar1=dialog:FindChild("rateStar1",true)
	local rateStar2=dialog:FindChild("rateStar2",true)
	local rateStar3=dialog:FindChild("rateStar3",true)
	local rateStar4=dialog:FindChild("rateStar4",true)
	local rateStar5=dialog:FindChild("rateStar5",true)

	local saveSize = rateStar5.size

	rateStar5.image = "StarSmall_off.png"
	rateStar4.image = "StarSmall_off.png"
	rateStar3.image = "StarSmall_off.png"
	rateStar2.image = "StarSmall_off.png"
	rateStar1.image = "StarSmall_off.png"

	if(star=="5")then
		rateStar5.image = "StarSmall.png"
		rateStar4.image = "StarSmall.png"
		rateStar3.image = "StarSmall.png"
		rateStar2.image = "StarSmall.png"
		rateStar1.image = "StarSmall.png"
	end
	if(star=="4")then
		rateStar4.image = "StarSmall.png"
		rateStar3.image = "StarSmall.png"
		rateStar2.image = "StarSmall.png"
		rateStar1.image = "StarSmall.png"
	end
	if(star=="3")then
		rateStar3.image = "StarSmall.png"
		rateStar2.image = "StarSmall.png"
		rateStar1.image = "StarSmall.png"
	end
	if(star=="2")then
		rateStar2.image = "StarSmall.png"
		rateStar1.image = "StarSmall.png"
	end
	if(star=="1")then
		rateStar1.image = "StarSmall.png"
	end

	rateStar5.size = saveSize
	rateStar4.size = saveSize
	rateStar3.size = saveSize
	rateStar2.size = saveSize
	rateStar1.size = saveSize
end

Resources.Message = Resources.Actor:new {
	resource = "Actor",
	image = "Dialog_Banner.png",
	--color = "White",
	--size = {280,65},
	--alpha = 200,
	visible = false,

	checkBox = Resources.AppCheckBox:new {
		resource = "AppCheckBox",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = {6,0},
		checked = false,
		frame = 1,
		UpdateVisibility = function (self)
			if (self.checked == true) then
                self.frame = 1
            else
                self.frame = 0
            end
		end,

		GetChecked = function (self)
			return self.checked
		end,
		SetChecked = function(self, newChecked)
			self.checked = newChecked
			self:UpdateVisibility()
		end,
		OnPostSpawn = function(self)
			self:UpdateVisibility()
		end,
	},

	leftImage = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		image = "PlayerPic_Empty.png",
		defaultImage = "PlayerPic_Empty.png",
		size = {46,46},
		resizeOnSetImage = false,	-- when 'false', this will prevent Actor::SetImage calls from resizing the actor
		alignmentOffset = {43,0},
		PlayerFrame = Resources.Actor:new {
			image = "PlayerFrame.png",
			size = {46,46},
			zorder = 1,
			alignment = "Center",
			alignTo = "Center",
		}
	},

	rightImage = Resources.Actor:new {
		alignment = "MidRight",
		alignTo = "MidRight",
		image = "FriendToken.png",
		size = {46,46},
		resizeOnSetImage = false,	-- when 'false', this will prevent Actor::SetImage calls from resizing the actor
		alignmentOffset = {-8,0},
	},

	messageText = Resources.Actor:new {
		resource = "Actor",
		alignmentOffset = {95,3},
		alignment = "TopLeft",
		alignTo = "TopLeft",

		messageTitle = Resources.Label:new {
			resource = "Label",
			text = STRINGS("No Message Title"),
			fgColor = "Black",
			--shadowColor = "Black",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {0,4},
			font = Resources.NoteBubbleFont:new {
				resource = "NoteBubbleFont",
				fontSize = 16,
			},
		},

		messageBody = Resources.Label:new {
			resource = "Label",
			text = STRINGS("No Message Text"),
			alignmentOffset = {0,22},
			--fgColor = "Black",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			textAlignment = "MidLeft",
			wrapLimit = 130,
			heightLimit = 33,
			font = Resources.NoteBubbleFont:new {
				resource = "NoteBubbleFont",
				fontSize = 14,
			},
		},
	},
}

Resources.FriendsStuckDialog = Resources.MessagesDialog:new {
	resource = "MessagesDialog",
    titleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Help Friends"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

	subTitleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Your friends need help!"),
		alignment = MidTop,
		alignmentOffset = {0, 50},
		font = Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 20,
		},
    },

	ScrollableArea = {
		class = "ScrollableArea",
		DisplayDimensions = {313, 346-headerOffset},
		alignmentOffset = {0,50+30},
		--color = "Blue",
		--alpha = 128,
	},
}

Resources.MessagesDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "MessagesDialog",
    name = "MessagesDialog",

    titleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Your Messages"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },


	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
        DisplayDimensions = {313, 372-headerOffset},
		horizontalScrollLocked = true,
		alignment = "MidTop",
		alignmentOffset = {0,50},
		SlowFraction = .95,
		stoppingVelocity = 1,
		--color = "Blue",
		--alpha = 128,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	ScrollBar = Resources.Scrollbar:new {
		resource = "Scrollbar",
		minValue = 0,
		maxValue = 100,
		value = 0,
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {110,17},
		rotationAngle = { degrees = 90 },
		zorder = 200,
		rolloverable = false,
		visible = false, --turned off for now
	},

	AcceptButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignmentOffset = {-20,LargeLonger_Dialog_Button_Y + 5},
		textAlignmentOffset = {0,0},
		text = STRINGS("Accept"),
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 255,
	},

	CheckAllButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		buttonClosesDialog = false,
		alignment = BottomLeft,
		alignmentOffset = {20,LargeLonger_Dialog_Button_Y + 5},
		textAlignmentOffset = {12,0},
		textWidthLimit = 90,
		text = STRINGS("Check all"),
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 255,
		--size = {170,30},

		checkBox = Resources.AppCheckBox:new {
			resource = "AppCheckBox",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {6,1},
			rolloverable = false,
			size = {30, 30},
			checked = false,
			frame = 1,

			UpdateVisibility = function (self)
				if (self.checked == true) then
					self.frame = 1
				else
					self.frame = 0
				end
			end,

			SetChecked = function(self, newChecked)
				self.checked = newChecked
				self:UpdateVisibility()
			end,
			OnPostSpawn = function(self)
				self:UpdateVisibility()
			end,
		},
	},
}

--Login Welcome Dialog
Resources.LoginPromptDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "LoginPromptDialog",
    title = "",
	name = "LoginPromptDialog",

        DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-35},
        size = {250,245},
    },

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Welcome!"),
		alignment = MidTop,
		alignmentOffset = {-15, 10},
		widthLimit = 230,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	character = Resources.Actor:new {
		resource = "Actor",
		image = "Character_GemHold.png",
		alignment = "MidTop",
		alignmentOffset = {0,60},
		scripts = {"DialogButtonGroove"},
	},

	text = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("LoginPromptText"),
		alignment = "MidTop",
		alignmentOffset = {0,190},
		heightLimit = 110,
		widthLimit = 250,
	},

	noThanksButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		text = STRINGS("No thanks"),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-35+30},
		buttonClosesDialog = true,
		OnPostSpawn = function (self)
			logprint("SPAWN NO THANKS, 1")
		end,
	},

	facebookConnectButton = Resources.AppButtonSmall:new {
		resources = {"AppButtonSmall", "FacebookConnectDecorator"},
        zorder = 1,
		--size = {130, 36},
		text = STRINGS("Connect"),
		textWidthLimit = 90,
		textAlignmentOffset = {14, 0},
		textDisabledColor = "#383838",
		textColor = "Cascade_DarkBrown",
		textAlignment = "Center",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-85+30},
		visibleWhenConnected = true,
		isConnectUI = true,

		enableAppearanceUpdates = false,
		visible = true,

		facebookIcon = Resources.Actor:new {
			resource = "Actor",
			image = "CFN_Logo_small.png",
			alignment = "MidLeft",
			alignmentOffset = {18, 0},
		},

		OnPostSpawn = function (self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
		end,
	},
}

Scripts.Preshow_LoginPromptDialog = function(dialog)
	--logprint("Preshow_LoginPromptDialog")
end

Scripts.Present_LoginPromptDialog = function(dialog)
	--logprint("Present_LoginPromptDialog")
end



Resources.LoginRepromptDialog = Resources.LoginPromptDialog:new {
	resource = "LoginPromptDialog",
	name = "LoginRepromptDialog",

	titleText = {
		class = "override",
		text = STRINGS("Welcome Back!"),
        widthLimit = 222,
	},

	text = {
		class = "override",
		text = STRINGS("It looks like you've\nbeen logged out.\n\nLog back in\nto see your progress!"),
	},

	noThanksButton = {
		class = "override",
		clearsLastAcceptedRaveUserID = true,	-- HACK: see LoginRepromptDialog::OnDialogStopped for details
	},
}

Scripts.Preshow_LoginRepromptDialog = function(dialog)
	Scripts.Preshow_LoginPromptDialog(dialog)
end

Scripts.Present_LoginRepromptDialog = function(dialog)
	Scripts.Present_LoginPromptDialog(dialog)
end

--Daily Challenge Intro Dialog
Resources.WelcomeToDailyChallengeDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "WelcomeToDailyChallengeDialog",
    title = "",
	name = "WelcomeToDailyChallengeDialog",

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
    },

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("The Daily Challenge!"),
		alignment = MidTop,
		alignmentOffset = {0,10},
        widthLimit = 210,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	character = Resources.Actor:new {
		resource = "Actor",
		image = "Character_GemHold.png",
		alignment = "Center",
		alignmentOffset = {0,-115},
		scripts = {"DialogButtonGroove"},
        extraScale = 0.90,
	},

	text = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
        font	= Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 18,
		},
		text = STRINGS("Come back every day\nfor a brand new game!\n\nConnect to your friends to see\nwho has the best daily score.\n\nYour Team is made of your\ntop 5 scoring friends.\nCan you get the best Team score?"),
		alignment = "Center",
		alignmentOffset = {0,35},
        heightLimit = 180,
		widthLimit = 280,
	},

	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
        extraScale = 1.25,

	},
}

Resources.WelcomeToDailyChallengeDialog_GooglePlay = Resources.WelcomeToDailyChallengeDialog:new {
	resource = "WelcomeToDailyChallengeDialog",
    titleText = {
		class = "Label",
		text = STRINGS("The Google Play Daily Challenge!"),
	},
	text = {
		class = "Label",
		text = STRINGS("Come back every day\nfor a brand new game!\n\nConnect to your Google Play friends\nto see who has the best daily score."),
	},
}

Scripts.Preshow_WelcomeToDailyChallengeDialog = function(dialog)
	--logprint("Preshow_WelcomeToDailyChallengeDialog")
end

Scripts.Present_WelcomeToDailyChallengeDialog = function(dialog)
	--logprint("Present_WelcomeToDailyChallengeDialog")
end

Resources.ThanksForConnectingDialog = Resources.LoginPromptDialog:new {
	resource = "LoginPromptDialog",

    titleText = {
		class = "override",
		text = STRINGS("Excellent!"),
    },

	text = {
		class = "override",
		text = STRINGS("You are now connected\nto the Cascade Network!\nAll game progress\nwill be synchronized\nwith your account."),
	},

	noThanksButton = {
		class = "override",
		visible = false,
	},

	thanksButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		text = STRINGS("Thanks!"),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-35+30},
		buttonClosesDialog = true,
	},

	facebookConnectButton =  {
		class = "override",
		visible = false,
	},
}

--Debug_PowerupWheel = true

Scripts.Preshow_ThanksForConnectingDialog = function(dialog)
	--logprint("Preshow_ThanksForConnectingDialog")
end

Scripts.Present_ThanksForConnectingDialog = function(dialog)
	--logprint("Present_ThanksForConnectingDialog")
end

Resources.AllCharacters = Resources.Actor:new {
	resource = "Actor",
	alignment = "TopLeft",
	alignTo = "TopLeft",
	zorder = 3,
	Jaguar = Resources.Actor:new {
		resource = "Actor",
		image = "Jaguar.png",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {230, 340},
		zorder = 3,
		visible = true,
	},
	--[[
	Bat = Resources.Actor:new {
		resource = "Actor",
		image = "Bat.png",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {238, 33},
		zorder = 3,
		visible = false,
		extraScale = {-1, 1},
	},
	Bear = Resources.Actor:new {
		resource = "Actor",
		image = "Bear.png",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {190, 250},
		zorder = 3,
		visible = false,
		extraScale = {0.5, 0.5},
	},
	Fox = Resources.Actor:new {
		resource = "Actor",
		image = "Fox.png",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {235, 340},
		zorder = 3,
		visible = false,
	},
	Lemur = Resources.Actor:new {
		resource = "Actor",
		image = "Lemur.png",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {250, 340},
		zorder = 3,
		visible = false,
	},
	Marmot = Resources.Actor:new {
		resource = "Actor",
		image = "Marmot.png",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {250, 340},
		zorder = 3,
		visible = false,
	},
	Otter = Resources.Actor:new {
		resource = "Actor",
		image = "Otter.png",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {220, 290},
		zorder = 3,
		visible = false,
		extraScale = {-1, 1},
	},
	--]]
}

Scripts.PowerupWheelDialog_TimeLeft_Update = function(self)
	local keepRunning = true
	while (keepRunning) do
		--[[local hour = GetCurrentLocalHour()
		local min = GetCurrentLocalMinute()
		local sec = GetCurrentLocalSecond()
		hour = 23-hour
		min = 59-min
		sec = 59-sec
		if((hour == 0) and (min == 0) and (sec == 0))then
			keepRunning = false
			self.visible = false
		end
		if(sec<10)then sec = "0"..sec end
		if(min<10)then min = "0"..min end
		local time = hour..":"..min..":"..sec]]
		self.text = self.parent:GetTimeToNextSpinString()
		ScriptDelay(950,"dialogTimers")
	end
end

Resources.NewMarker = Resources.NotificationCircle:new {
	resource = "NotificationCircle",
	zorder = 25,
	layer = 2,
	visible = false,
}


Resources.PowerupWheelDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "PowerupWheelDialog",
	name = "PowerupWheelDialog",
	enableVisibleUnderlay = true,

	hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 5,
    },

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("The Daily Spin!"),
		alignment = MidTop,
		alignmentOffset = {-10, 10},
        heightLimit = 65,
		widthLimit = 240,
    },

	timeToSpinText = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Time Until Next Spin: "),
		alignment = MidTop,
		alignmentOffset = {0, 85},
		zorder = 10,
		visible = false,
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 18,
		},
		scripts = {"PowerupWheelDialog_TimeLeft_Update"},
        widthLimit = 280,
	},

	XButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	StopButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		text = STRINGS("Start!"),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y+5},
		buttonClosesDialog = true,
		zorder = 2,
	},

	Characters = Resources.AllCharacters:new {
		resource = "AllCharacters",
	},

	WheelBumpers = Resources.Actor:new {
		resource = "Actor",
		image = "WheelBumpers.png",
		zorder = 3,
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,18},
		rotationAngle = {degrees = 20},
	},

	WheelCover = Resources.Actor:new {
		resource = "Actor",
		image = "WheelCover.png",
		visible = false,
		zorder = 4,
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,18},
	},

	Wheel = Resources.Button:new {
		resource = "Button",
		useFrames = false,
		image = "Wheel.png",
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,18},
		zorder = 1,
		rotationAngle = {degrees = 20},


		PowerupSlot1 = Resources.Actor:new {
			resource = "Actor",
			rotationAngle = {degrees = 22,},
		},

		PowerupSlot2 = Resources.Actor:new {
			resource = "Actor",
			rotationAngle = {degrees = 67,},
		},

		PowerupSlot3 = Resources.Actor:new {
			resource = "Actor",
			rotationAngle = {degrees = 112,},
		},

		PowerupSlot4 = Resources.Actor:new {
			resource = "Actor",
			rotationAngle = {degrees = 157,},
		},

		PowerupSlot5 = Resources.Actor:new {
			resource = "Actor",
			rotationAngle = {degrees = 202,},
		},

		PowerupSlot6 = Resources.Actor:new {
			resource = "Actor",
			image = "Boost_WildBoard.png",
			rotationAngle = {degrees = 247,},
		},

		PowerupSlot7 = Resources.Actor:new {
			resource = "Actor",
			rotationAngle = {degrees = 292,},
		},

		PowerupSlot8 = Resources.Actor:new {
			resource = "Actor",
			rotationAngle = {degrees = 337,},
		},
	},

	PowerupWon = Resources.Button:new {
		resource = "Button",
		useFrames = false,
		image = "",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0, 15},
		extraScale = {0.0, 0.0},
		zorder = 6,
        rolloverable = false,
		PowerupImage = Resources.Actor:new {
			resource = "Actor",
			alignment = Center,
			alignTo = Center,
			--image = "Trick_MakeWild_big.png",
            image = "",
		},
		PowerupText = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			alignment = Center,
			alignTo = Center,
			text = STRINGS("Pack of Free Spins"),
			fgColor = "Cascade_White",
			highlightColor = "Cascade_DarkBrown",
			highlightOffset = {-1,-1},
			highlightAlpha = 50,
			shadowColor = "Cascade_DarkBrown",
			alignmentOffset = {0, -60},
			widthLimit = 180,
		},
	},

	WheelText = Resources.AppTitleDialogLabel:new {
		font	= Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 26,
		},
		resource = "AppTitleDialogLabel",
		alignment = Center,
		alignTo = Center,
		text = STRINGS("Come back later for another spin!"),
		fgColor = "Cascade_White",
		highlightColor = "Cascade_DarkBrown",
		highlightOffset = {-1,-1},
		highlightAlpha = 50,
		alignmentOffset = {0, 18},
		shadowColor = "Cascade_DarkBrown",
		wrapLimit = 220,
		zorder = 6,
		visible = false,
	},

	WheelPin = Resources.Actor:new {
		resource = "Actor",
		image = "wheelPin.png",
		alignment = "Center",
		alignTo = "MidTop",
		alignmentOffset = {0,90},
		zorder = 2,
	},

	facebookConnectButton = Resources.AppButtonSmall:new {
		resources = {"AppButtonSmall", "FacebookConnectDecorator"},
		--size = {130, 36},
		text = STRINGS("Connect"),
		textWidthLimit = 90,
		textAlignmentOffset = {14, 0},
		textDisabledColor = "#383838",
		textColor = "Cascade_DarkBrown",
		textAlignment = "Center",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y+5},
		visibleWhenConnected = true,
		isConnectUI = true,

		enableAppearanceUpdates = false,
		visible = false,

		facebookIcon = Resources.Actor:new {
			resource = "Actor",
			image = "CFN_Logo_small.png",
			alignment = "MidLeft",
			alignmentOffset = {18, 0},
		},

		OnPostSpawn = function (self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
		end,
	},
}

local function distance ( x1, y1, x2, y2 )
  local dx = x1 - x2
  local dy = y1 - y2
  return math.sqrt ( dx * dx + dy * dy )
end

local function rotatePointByDegrees(point, degrees)

	local rad = math.rad(degrees)
	local cos = math.cos(rad)
	local sin = math.sin(rad)

	local newX = (point.x * cos) - (point.y * sin)
	local newY = (point.x * sin) + (point.y * cos)

	local newPoint = {x=newX, y=newY}
	return newPoint
end

local bumperPositions = {
	{x=273, y=26},
	{x=446, y=96},
	{x=520, y=272},
	{x=446, y=443},
	{x=272, y=514},
	{x=99, y=443},
	{x=27, y=269},
	{x=99, y=95}
}

local function IntersectsBumperAtRotation(pinActor, wheelActor, bumperIndex, pinRotation)
	local wheelDegrees = Angle_GetDegrees(wheelActor.rotationAngle)
	wheelDegrees = wheelDegrees % 360

	local bumperPos = bumperPositions[bumperIndex]
	local point = {x=bumperPos.x / 2, y=bumperPos.y / 2}
	point.x = point.x - 136
	point.y = point.y - 136
	local bumperPosition = rotatePointByDegrees(point, wheelDegrees)

	local pinOffset = {}
	pinOffset.x = 0
	pinOffset.y = pinActor.position.y - wheelActor.center.y + 8
	--pinOffset.y = pinActor.position.y - wheelActor.position.y + (wheelActor.height / 2)
	--logprint(pinOffset.y)

	local bumperRadius = 4
	local pinRadius = 12

	local pinPosition = {x=10, y=35}
	pinPosition.y = pinPosition.y - 8

	pinDegrees = pinRotation % 360
	pinPosition = rotatePointByDegrees(pinPosition, pinRotation)

	pinPosition.y = pinPosition.y + pinOffset.y

	local distance = distance(pinPosition.x, pinPosition.y, bumperPosition.x, bumperPosition.y)
	--logprint(distance)

	if (distance < (pinRadius + bumperRadius)) then
		if (pinPosition.x > bumperPosition.x) then
			return true
		else
			--logprint("Distance " .. distance)
			--logprint(pinPosition.x .. ", " .. bumperPosition.x)
			return false
		end
	else
		return false
	end
end

local function IntersectsBumper(pinActor, wheelActor, bumperIndex)
	local pinDegrees = Angle_GetDegrees(pinActor.rotationAngle)
	return IntersectsBumperAtRotation(pinActor, wheelActor, bumperIndex, pinDegrees)
end

local lastBumperHit = -1

local HandleBumpers = function(dialog, pinActor, wheelActor)
	pinActor.rotationPoint = {8,8}
	local pinVelocity = 0
	local delay = 10
	local intersectsABumper = false
	local bumperHit = -1

	local nearBumper = false

	local pinDegrees = Angle_GetDegrees(pinActor.rotationAngle)
	pinDegrees = pinDegrees % 360

	local numBumpers = #bumperPositions
	for i = 1, numBumpers do
		local intersects = IntersectsBumper(pinActor, wheelActor, i)
		local checkDegrees = pinDegrees + 1
		if (intersects) then
			--logprint("Intersects " .. i)
			intersectsABumper = true
			bumperHit = i
		elseif IntersectsBumperAtRotation(pinActor, wheelActor, i, checkDegrees) then
			nearBumper = true
			intersectsABumper = true
			bumperHit = i
			--logprint("intersects check")
		end

	end

	if (nearBumper == true) then			--Do nothing if its close to the bumper
		--logprint("Checkdegrees hit")
		dialog.PinOnBumper = true
		dialog.BumperHit = bumperHit
	else
		while (pinDegrees > 180) do
			pinDegrees = pinDegrees - 360
		end
		local interpolateAmount = .8
		pinDegrees = pinDegrees * interpolateAmount

		pinActor.rotationAngle = { degrees = pinDegrees }

		if (bumperHit > 0) then
			--logprint(bumperHit)

			while (IntersectsBumper(pinActor, wheelActor, bumperHit)) do
				pinDegrees = pinDegrees - .5
				pinActor.rotationAngle = { degrees = pinDegrees }
			end

			if (bumperHit ~= lastBumperHit) then
				lastBumperHit = bumperHit
				PlaySound("Click1.ogg")
			end

			dialog.PinOnBumper = true
			dialog.BumperHit = bumperHit
		else
			dialog.PinOnBumper = false
		end
	end
	ScriptBreak()
end

local RotateWheelByAmount = function(dialog, wheelActor, wheelSpeed)
	wheelActor.wheelSpeed = wheelSpeed
	local newDegrees = Angle_GetDegrees(wheelActor.rotationAngle)
	local wheelBumpers = dialog:FindChild("WheelBumpers",true)
	local wheelPin = dialog:FindChild("WheelPin",true)

	local stepsPerTick = 2
	local fractionSpeed = wheelSpeed / 2

	for i = 0, stepsPerTick - 1 do
		newDegrees = newDegrees + fractionSpeed
		wheelActor.rotationAngle = { degrees = newDegrees }
		wheelBumpers.rotationAngle = { degrees = newDegrees }
		HandleBumpers(dialog, wheelPin, wheelActor)
	end

	ScriptBreak()
end

local wheelSpeed
Scripts.PowerupWheelBeginSpinning = function(dialog, spinningWheel)--,wheelSpeed)

    --spinningWheel:StopRotation()
	--spinningWheel:KillTaggedScripts("SpinWheel")
	--ScriptBreak()
	StopSound("slot_machine_wheel_spin_loop.ogg")

	LoopSound("slot_machine_wheel_spin_loop.ogg")

	local minWheelSpeed = 16
	local maxWheelSpeed = 20
	wheelSpeed = math.random(minWheelSpeed,maxWheelSpeed)
	--wheelSpeed = maxWheelSpeed

	spinningWheel.wheelSpeed = wheelSpeed

	local wheelBumpers = dialog:FindChild("WheelBumpers",true)
	wheelBumpers.rotationPoint = spinningWheel.rotationPoint

	while true do
		RotateWheelByAmount(dialog, spinningWheel, wheelSpeed)
	end
end

Scripts.PowerupWheelBeginStopping = function(dialog, spinningWheel)
	PlaySound("slot_machine_bet_01.ogg")
	dialog:KillTaggedScripts("Present_RunTrialWheel")
	dialog:KillTaggedScripts("SpinWheelAnimation")
	spinningWheel.active = false
	local minSteps = 25
	local maxSteps = 75
	local totalSteps = math.random(minSteps, maxSteps)
	--totalSteps = maxSteps
	local rotateAcc = 1
	local sliceIndex_last = -1
	while(rotateAcc < totalSteps)do
		local currentSpeed = wheelSpeed * (1 - (rotateAcc / totalSteps))
		RotateWheelByAmount(dialog, spinningWheel, currentSpeed)
		rotateAcc = rotateAcc + 1
		ScriptBreak()
	end
	spinningWheel:StopRotation()
	spinningWheel:KillTaggedScripts("SpinWheel")
	ScriptBreak()
	local degrees = Angle_GetDegrees(spinningWheel.rotationAngle)
	dialog.finishDegrees = degrees
	PlaySound("slot_machine_spin_stop_05.ogg")
	StopSound("slot_machine_wheel_spin_loop.ogg")
end

Scripts.PowerupWheelCancelSpin = function(dialog, spinningWheel)
	StopSound("slot_machine_wheel_spin_loop.ogg")
	spinningWheel:StopRotation()
end

--Tap FX when Winning Powerup?

Scripts.ShowPowerupWon = function(dialog, spinningWheel, powerupImage, powerupText)
    --logprintf("showing powerup won???\n")
	--ScriptDelay(500,"DialogTimers")
    dialog.PowerupWon.PowerupImage.image = powerupImage
	dialog.PowerupWon.PowerupText.text = powerupText
	dialog.WheelCover.visible = true
	--dialog.WheelBumpers.visible = false
	dialog.PowerupWon.rolloverable = true
	PlaySound("slot_machine_spin_04_short.ogg")
	ScaleTo(dialog.PowerupWon, {1.0, 1.0}, 100)
	ScriptDelay(1200,"DialogTimers")
	PlaySound("pop_sparkle_01.ogg")
	FireParticle(dialog.PowerupWon,"ConfettiPowerupWheel","Center",dialog.hgeParticles)
	Pop(dialog.PowerupWon,{expandTime=100, shrinkTime=50})
	PlaySound("air_cannon_pressure_release_02.ogg")
	dialog.PowerupWon.PowerupImage:AddScript("DialogButtonGroove","DialogButtonGroove")
end

-- Welcome to Star Cards Dialog

Resources.WelcomeToStarCardRankDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "WelcomeToStarCardRankDialog",
    title = "",
	name = "WelcomeToStarCardRankDialog",
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-5},
    },

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Welcome To\nStar Cards!"),
		alignment = MidTop,
		alignmentOffset = {0, 20},
		widthLimit = 285,
        heightLimit = 60,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	character = Resources.Actor:new {
		resource = "Actor",
		image = "Character_GemHold.png",
		alignment = "Center",
		alignmentOffset = {0,-70},
		scripts = {"DialogButtonGroove"},
	},

	text = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("Welcome to Star Cards!\n Every star you get goes towards leveling you up to a better Star Card.\nEach new Star Card gets you a great new VIP reward!"),
		alignment = "Center",
		alignmentOffset = {0,50},
		wrapLimit = 200,
        heightLimit = 140,
	},

	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
        extraScale = 1.25,
	},
}

Scripts.Preshow_WelcomeToStarCardRankDialog = function(dialog)
	--logprint("Preshow_WelcomeToStarCardRankDialog")
end

Scripts.Present_WelcomeToStarCardRankDialog = function(dialog)
	--logprint("Present_WelcomeToStarCardRankDialog")
end


Resources.StarRankCard = Resources.Actor:new {
	resource = "Actor",
	size = {220,130},
	color = "Blue",
	alpha = 0,
	visible = false,

	backCover = Resources.Actor:new{
		resource = "Actor",
		image = "StarCardBack.png",
		zorder = 4,
		visible = false,
		alignment = MidRight,
		alignTo = MidRight,
		requirementTitle = Resources.AppTitleDialogLabel_smaller:new {
			resource = "AppTitleDialogLabel_smaller",
			text = STRINGS("Star Card"),
			fgColor = "RON_Cascade_Gold",
			shadowColor = "RON_Cascade_DarkBlue",
			shadowOffset = {2,2},
			shadowAlpha = 255,
			highlightColor = "RON_Cascade_DarkBlue",
			highlightOffset = {-1,-1},
			highlightAlpha = 255,
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0,0},
			--alpha = 200,
		},
		background_shadow = Resources.Actor:new{
			resource = "Actor",
			size = {225,135},
			autoFillParent = false,
			image = "StarCard_frame.png",
			alignment = TopLeft,
			alignTo = TopLeft,
			zorder = 2,
			visible = true,
		},

		index = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("1"),
			fgColor = "RON_Cascade_DarkBlue",
			shadowColor = "Black",
			shadowOffset = {2,2},
			shadowAlpha = 0,
			highlightColor = "Cascade_DarkBrown",
			highlightOffset = {-1,-1},
			highlightAlpha = 0,
			alignment = "Center",
			alignTo = "TopRight",
			alignmentOffset = {-14,14},
			widthLimit = 30,
			--alpha = 200,
		},
		--This is duplicated here in case I want to change the look of it
		backCover_requirementPanel = Resources.Actor:new {
			resource = "Actor",
			color = "White",
			alpha = 0,
			size = {80,20},
			alignment = BottomLeft,
			alignTo= BottomLeft,
			alignmentOffset = {0,-12},
			backCover_requirementTitle = Resources.AppDialogTinyLabel:new {
				resource = "AppDialogTinyLabel",
				text = STRINGS("Required"),
				alignment = "MidRight",
				fgColor = "White",
				shadowColor = "RON_Cascade_DarkBlue",
				highlightColor = "RON_Cascade_DarkBlue",
				alignment = "MidLeft",
				alignTo = "MidLeft",
				alignmentOffset = {40,10},
			},
			backCover_starIcon = Resources.Actor:new {
				resource = "Actor",
				image = "StarSmall.png",
				alignment = "MidLeft",
				alignTo = "MidLeft",
				alignmentOffset = {5,0},
				size = {40,40},
				backCover_requirementValue = Resources.AppDialogTinyLabel:new {
					resource = "AppDialogTinyLabel",
					text = STRINGS(""),
					alignment = "Center",
					alignTo = "Center",
					alignmentOffset = {0,0},
					widthLimit = 20,
				},
			},
		},
	},

	background = Resources.Actor:new{
		resource = "Actor",
		size = {220,130},
		--alpha = 200,
		zorder = -1,
		image = "Land1_6.jpg",
		resizeOnSetImage = true,
		alignment = MidRight,
		alignTo = MidRight,

		background_white = Resources.Actor:new{
			resource = "Actor",
			autoFillParent = true,
			color = "White",
			zorder = 1,
			alpha = 150,
		},
		background_tint = Resources.Actor:new{
			resource = "Actor",
			autoFillParent = true,
			color = "Purple",
			zorder = 2,
			alpha = 50,
		},
		background_shadow = Resources.Actor:new{
			resource = "Actor",
			size = {225,135},
			autoFillParent = false,
			image = "StarCard_frame.png",
			alignment = TopLeft,
			alignTo = TopLeft,
			zorder = 2,
			visible = true,
		},
	},

	--[[ NOTE: WIP cropping
	cropActor = Resources.Actor:new {
		resource = "Actor",
		image = "StarRankCardBackground_crop.png",
		--size = {280,65*2},
		--alpha = 200,
		zorder = 1,
		visible = false,

		alignment = MidRight,
		alignTo = MidRight,
	},
	--]]

	mainPanel = Resources.Actor:new {
		resource = "Actor",
		alpha = 0,
		size = {220,130},
		alignment = MidRight,
		alignTo = MidRight,

		checkBox = Resources.Actor:new {
			resource = "Actor",
			image = "Check.png",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {-8,-6},
			zorder = 2,
		},

		Medal = Resources.Actor:new {
			resource = "Actor",
			image = "Friend_number1.png",
			alignment = "TopLeft",
			alignTo = "TopLeft",
			alignmentOffset = {100,0},
			zorder = 1,
		},

		rankTitle = Resources.AppDialogLabel_small:new {
			resource = "AppDialogLabel_small",
			text = STRINGS(""),
			textAlignment = "Center",
			alignmentOffset = {0,6},
			alignment = "MidTop",
			alignTo = "MidTop",
			widthLimit = 190,
		},

		rewardPanel = Resources.Actor:new {
			resource = "Actor",
			alignmentOffset = {-10,0+5},
			alignment = "Center",
			alignTo = "Center",
			size = {160,60},
			color = "Black",
			alpha = 0,

			rewardTitle = Resources.AppDialogDataLabel_smaller:new {
				resource = "AppDialogDataLabel_smaller",
				text = STRINGS(""),
				alignmentOffset = {10,-32},
				alignment = "Center",
				alignTo = "Center",
				textAlignment = "Center",
				widthLimit = 215,
				heightLimit = 33,
			},

			rewardIcon = Resources.Button:new {
				resource = "Button",
				useFrames = false,
				image = StarRewards[StarRank[1].reward].image,
				alignmentOffset = {10,6},
				alignment = "MidLeft",
				alignTo = "MidLeft",
				size = {220/4,220/4},
				resizeOnSetImage = false,
			},

			rewardText = Resources.AppDialogTinyLabel:new {
				resource = "AppDialogTinyLabel",
				text = STRINGS(""),
				alignmentOffset = {-40,4},
				alignment = "Center",
				alignTo = "MidRight",
				textAlignment = "Center",
				wrapLimit = 100,
				heightLimit = 50,
			},
		},

		requirementPanel = Resources.Actor:new {
			resource = "Actor",
			color = "White",
			alpha = 0,
			size = {80,20},
			alignment = BottomRight,
			alignTo= BottomRight,
			alignmentOffset = {-20,-12},
			requirementTitle = Resources.AppDialogTinyLabel:new {
				resource = "AppDialogTinyLabel",
				text = STRINGS("Requires:"),
				alignment = "MidRight",
				alignTo = "MidRight",
				alignmentOffset = {-22,2},
			},
			starIcon = Resources.Actor:new {
				resource = "Actor",
				image = "StarSmall.png",
				alignment = "MidRight",
				alignTo = "MidRight",
				alignmentOffset = {18,0},
				size = {40,40},
				requirementValue = Resources.AppDialogTinyLabel:new {
					resource = "AppDialogTinyLabel",
					text = STRINGS(""),
					alignment = "Center",
					alignTo = "Center",
					alignmentOffset = {0,0},
					widthLimit = 20,
				},
			},
		},

		PlayerPicture = Resources.RemotePlayerPicture:new {
			resource = "RemotePlayerPicture",
			alignment = "MidRight",
			alignTo = "MidRight",
			image = "PlayerPic_Empty.png",
			defaultImage = "PlayerPic_Empty.png",
			size = {46,46},
			resizeOnSetImage = false,	-- when 'false', this will prevent Actor::SetImage calls from resizing the actor
			alignmentOffset = {-10,0+5},
			PlayerFrame = Resources.Actor:new {
				image = "PlayerFrame.png",
				size = {46,46},
				zorder = 1,
				alignment = "Center",
				alignTo = "Center",
			},
			visible = false,
		},

		FriendImage = Resources.Actor:new {
			resource = "Actor",
			alignment = "BottomLeft",
			alignTo = "BottomLeft",
			image = "PlayerPic_Empty.png",
			size = {46/2,46/2},
			resizeOnSetImage = false,	-- when 'false', this will prevent Actor::SetImage calls from resizing the actor
			alignmentOffset = {15,-10+5},
			visible = false,
		},
	},
}

Resources.StarRankCardWithMeter = Resources.StarRankCard:new {
	resource = "StarRankCard",
	size = {280,130},
	StarColumn = Resources.Actor:new {
		resource = "Actor",
		size = {50,130},
		alignment = MidLeft,

		Star1 = {
			class = "Actor",
			image = "StarBlueBig.png",
			alignment = MidTop,
			alignmentOffset = {0,-4},
			requirementLabel = Resources.AppDialogTinyLabel:new {
				resource = "AppDialogTinyLabel",
				text = STRINGS(""),
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = amountToGoOffset,
				fgColor = "DarkBlue",
				togoLabel = Resources.AppDialogTinyLabel:new {
					resource = "AppDialogTinyLabel",
					text = STRINGS("TO GO"),
					alignment = "MidTop",
					alignTo = toGoAlignment,
					alignmentOffset = toGoOffset,
					fgColor = "DarkBlue",
					font	= Resources.DialogFont:new{
						resource = "DialogFont",
						fontSize = 8,
					},
				},
			},


		},
		Star2 = {
			class = "Actor",
			image = "StarBlueSmall.png",
			alignment = MidTop,
			alignmentOffset = {0,38},
		},
		Star3 = {
			class = "Actor",
			image = "StarBlueSmall.png",
			alignment = MidTop,
			alignmentOffset = {0,60},
		},
		Star4 = {
			class = "Actor",
			image = "StarBlueSmall.png",
			alignment = MidTop,
			alignmentOffset = {0,82},
		},
		Star5 = {
			class = "Actor",
			image = "StarBlueSmall.png",
			alignment = MidTop,
			alignmentOffset = {0,104},
		},
	},
}
--Star Card Dialog
Resources.StarCardRankDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "StarCardRankDialog",
	name = "StarCardRankDialog",
	enableVisibleUnderlay = true,
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

	hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 5,
    },

    titleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Star Cards"),
		alignment = MidTop,
		alignmentOffset = {4, 12},
		widthLimit = 212,
    },

	StarsIcon = Resources.Actor:new {
		resource = "Actor",
		image = "StarBig.png",
		alignment = "TopLeft",
		--alignmentOffset = {8, 0},
        alignmentOffset = {16, -2},
		size = {60, 60},
		zorder = 20,
        scripts = {"SparkleRandomly_gold"},

		numStars = Resources.Label:new {
			resource = "Label",
			text = STRINGS("10"),
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0,1},
			fgColor = "Black",
			--shadowColor = "Black",
			zorder = 2,
			widthLimit = 38,
			font = Resources.AppGameFont:new {
				resource = "AppGameFont",
				fontSize = 20,
			},
		},
		visible = true,
	},

	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
		DisplayDimensions = {313, 416-headerOffset},
		horizontalScrollLocked = true,
		alignment = "MidRight",
		alignmentOffset = {-5,15},
		SlowFraction = .95,
		stoppingVelocity = 1,
	},

	XButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	--[[
	StarRankCard = Resources.StarRankCard:new {
		resource = "StarRankCard",
		visible = true,
		alignment = "Center",
	},
	--]]
}

Scripts.Preshow_StarRankCard = function(card,index,stars)
	--logprint("Preshow_StarRankCard "..index.." stars: "..stars)
	--stars = 251

	-- Figure out rank
	local rank = 0
	if(stars >= StarRank[#StarRank].requirement)then
		rank = #StarRank
	else
		for i=1,#StarRank-1 do
			if(stars >= StarRank[i].requirement and stars < StarRank[i+1].requirement)then
				rank = i
			end
		end
	end

	local starColumn = card:FindChild("StarColumn",true)
	if(starColumn ~= nil) then
		--Determine the progress fraction for this card
		local completionFraction = 0
		if(rank >= index) then
			completionFraction = 1
		end
		if(index == rank + 1) then
			local lowerRequirement = 0
			if(rank > 0) then
				lowerRequirement = StarRank[rank].requirement
			end
			local upperRequirement = StarRank[rank+1].requirement
			local progress = stars - lowerRequirement
			local delta = upperRequirement - lowerRequirement
			completionFraction = progress/delta
		end
		if(completionFraction >= 0.2) then
			starColumn.Star5.image = "StarBlueSmallFilled.png"
		else
			starColumn.Star5.image = "StarBlueSmall.png"
		end
		if(completionFraction >= 0.4) then
			starColumn.Star4.image = "StarBlueSmallFilled.png"
		else
			starColumn.Star4.image = "StarBlueSmall.png"
		end
		if(completionFraction >= 0.6) then
			starColumn.Star3.image = "StarBlueSmallFilled.png"
		else
			starColumn.Star3.image = "StarBlueSmall.png"
		end
		if(completionFraction >= 0.8) then
			starColumn.Star2.image = "StarBlueSmallFilled.png"
		else
			starColumn.Star2.image = "StarBlueSmall.png"
		end
		if(completionFraction >= 1.0) then
			starColumn.Star1.image = "StarBlueBigFilled.png"
			starColumn.Star1.requirementLabel.visible = false
		else
			starColumn.Star1.image = "StarBlueBig.png"
			starColumn.Star1.requirementLabel.visible = false
			if(index == rank + 1) then
				starColumn.Star1.requirementLabel.visible = true
				starColumn.Star1.requirementLabel.text = Int2Comma(StarRank[index].requirement - stars)
			end
		end
	end

	local rankTitle = card:FindChild("rankTitle",true)
	rankTitle.text = StarRank[index].name

	local rewardTitle = card:FindChild("rewardTitle",true)
	rewardTitle.text = string.format(STRINGS("RewardFMT"),StarRewards[StarRank[index].reward].name)

	local rewardIcon = card:FindChild("rewardIcon",true)
	rewardIcon.image = StarRewards[StarRank[index].reward].image

	local rewardText = card:FindChild("rewardText",true)
	rewardText.text = StarRewards[StarRank[index].reward].description

	local requirementValue = card:FindChild("requirementValue",true)
	requirementValue.text = tostring(StarRank[index].requirement)

	local checkBox = card:FindChild("checkBox",true)
	checkBox.visible = (index<=rank)

	local medal = card:FindChild("Medal",true)
	medal.visible = (index==rank)
	medal.visible = false

	local playerPicture = card:FindChild("PlayerPicture",true)
	if(index==rank)then
		playerPicture.visible = (index==rank)
		local playerPhoto = Authentication_GetCurrentPlayerPhotoName()
		playerPicture:SetPhotoName(playerPhoto)
	end
	playerPicture.visible = false

	card.visible = true

	card.background.image = StarRank[index].cardImage
	card.background.size = {220,130}
	card.background.background_tint.color = StarRank[index].cardColor
	local backCover_requirementValue = card:FindChild("backCover_requirementValue",true)
	backCover_requirementValue.text = tostring(StarRank[index].requirement)
	card.backCover.index.text = tostring(index)

	--TODO: Dave
	--local rewardClass = StarRewards[StarRank[index].reward].rewardClass
	--logprint("Preshow_StarRankCard rewardClass: "..rewardClass)

	-- Put back on if not acquired yet
	if(index>rank)then
		card.backCover.visible = true
		card.background.visible = false
	else
		card.backCover.visible = false
		card.background.visible = true
		local requirementPanel = card:FindChild("requirementPanel",true)
		--requirementPanel.visible = false
	end

end

Scripts.Preshow_StarRankDialog = function(dialog,stars)
	--logprint("Preshow_StarRankDialog "..stars)
	--stars = 251

	local numStars = dialog:FindChild("numStars",true)
	numStars.text = STRINGS("")..stars
end

Scripts.Present_StarRankDialog = function(dialog,stars,numberOfRanks)
	--stars = 251
	local rank = 1
	if(stars >= StarRank[#StarRank].requirement)then
		rank = #StarRank
	else
		for i=1,#StarRank-1 do
			if(stars >= StarRank[i].requirement and stars < StarRank[i+1].requirement)then
				rank = i
			end
		end
	end
	--logprint("rank = "..rank)
	--local indexPosition = numberOfRanks - rank + 1
	local indexPosition = numberOfRanks - 2
	--logprint("indexPosition = "..indexPosition)
	local scrollableArea = dialog:FindChild("ScrollableArea",true)
	local dest = {}
	dest.x = 0
	dest.y = -(65+10)*2*(indexPosition) - 0 --   --card height * rank
	--logprint("dest.y = "..dest.y)
	--ScriptDelay(250,"DialogTimers")
	Scripts.AnimateToScrollPosition(scrollableArea, dest, 1)
end

--End of Game Dialog
Resources.QuestCompleteDialog = Resources.LargeLongerDialog:new
{
	resource = "LargeLongerDialog",
	name = "QuestCompleteDialog",
	image = "DialogGeneric_Large.png",

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-5},
    },

    titleText = Resources.AppTitleDialogLabel:new {
    	resource = "AppTitleDialogLabel",
    	--text = STRINGS("More To Come"),
        text = STRINGS("CONGRATULATIONS!"),
    	alignment = MidTop,
    	alignmentOffset = {-10, 23},
		widthLimit = 220,
    },

	DialogCharacter = Resources.DialogCharacter:new {
		resource = "DialogCharacter",
		zorder = 1,
	},

	mainText = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("MapEndText"),
		wrapLimit = 295,
		centerWrap = true,
		heightLimit = 260,
		alignment = Center,
        alignmentOffset = {0,-5},

	},

	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
        extraScale = 1.2,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

local CascadeEndGameDialog_Challenge_yoffset = -60

--Daily Challenge Level End Dialog
Resources.CascadeEndGameDialog_Challenge = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    title = "",
    class = "CascadeEndGameDialog",
    name = "CascadeEndGameDialog",
    enableVisibleUnderlay = true,
	alpha = 0,

	introScriptName = "SlideOnTwoPanelsDialog_TopBar",
	dialogExitScriptName = "SlideOffTwoPanelsDialog_TopBar",

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogGeneric_Small.png",
        extraScale = 0.95,
        alignmentOffset = {0,-15},

        DialogInsert = Resources.Actor:new {
            resource = "Actor",
            image = "Dialog_Filler_A.png",
            alignment = "Center",
            alignmentOffset = {0,-5},
        },

		DialogCharacter = Resources.DialogCharacter:new {
			resource = "DialogCharacter",
			zorder = 1,
		},

		TitleLabel = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("Challenge Over"),
    		alignment = MidTop,
			alignmentOffset = {-10, 15},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize 	= 30
			},
            zorder = 2,
			widthLimit = 220,
		},

		goalScoreContainer = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidTop",
			alignmentOffset = {0, 170},
            zorder = 2,

			SetScore = function (self, score)
				self.score.text = string.format(STRINGS("EndGameDialog_GoalScoreFormat"), Int2Comma(score))
			end,

			score = Resources.StartQuestGameDialogLabel:new {
				resource = "StartQuestGameDialogLabel",
				--fgColor = "Cascade_DarkBrown",
                fgColor = "Cascade_White",
				alignment = "MidTop",
				alignmentOffset = {0,-15},
				text = STRINGS("1,000,000"),
				font = Resources.DialogFont:new {resource = "DialogFont",fontSize = 22,},
				widthLimit = 180,
			},

			check = Resources.Actor:new {
				resource = "Actor",
				image = "Check.png",
				alignment = TopRight,
				alignmentOffset = {140,0},
				zorder = 10,
				visible = false,

			},

			X = Resources.Actor:new {
				resource = "Actor",
				image = "X.png",
				alignment = TopRight,
				alignTo = TopRight,
				alignmentOffset = {-10,-172},
				zorder = 10,
				visible = false
			},
		},

		GoalPanel = Resources.GoalPanel:new {
			resource = "GoalPanel",
			zorder = 2,
			LevelObjective = {
				class = "Label",
				visible = false,
			},
			Requirement = {
				class = "Actor",
				alignmentOffset = {0,105},
			},
		},

		scoreContainer = Resources.Actor:new {
			resource = "Actor",
			zorder = 2,
			alignment = "MidTop",
			alignmentOffset = {0,170},

			SetScore = function (self, score)
				self.score.text = string.format(STRINGS("EndGameDialog_ScoreFormat"), Int2Comma(score))
			end,

			score = Resources.StartQuestGameDialogBoldLabel:new {
				fgColor = "Cascade_White",
                resource = "StartQuestGameDialogBoldLabel",
				text = STRINGS("Requirement:\nScore 45,000"),
				font = Resources.DialogBoldFont:new {resource = "DialogBoldFont",fontSize = 35,	},
				bestStamp = Resources.BestStamp,
			},
		},

		ChallengeDialog_TopScoreToday = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopLeft,
			alignmentOffset = {30,endGameFirstLineY + 5 * endGameLineSeparation - 45},
			text = STRINGS("Today's Best:"),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
			widthLimit = 170,
		},

		dailyBest = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopRight,
			alignmentOffset = {-50,endGameFirstLineY + 5 * endGameLineSeparation - 45},
			text = STRINGS(""),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
			bestStamp = Resources.BestStamp,
			visible = true,
			widthLimit = 75,
		},

		challengeBeatLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopLeft,
			alignmentOffset = {30,endGameFirstLineY + 5 * endGameLineSeparation - 20},
			text = STRINGS("Challenges Beat:"),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
			widthLimit = 200,
		},

		challengeBeat = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = TopRight,
			alignmentOffset = {-50,endGameFirstLineY + 5 * endGameLineSeparation - 20},
			text = STRINGS(""),
			font = Resources.CascadeEndGameDialogFont:new {
				resource = "CascadeEndGameDialogFont",
				fontSize = 20,
			},
			widthLimit = 80,
		},

		ButtonCollection = Resources.EndGameDialogButtons_Challenge:new {
			resource = "EndGameDialogButtons_Challenge",
			alignment = "MidBottom",
			alignmentOffset = {0, 0},
		},

		CancelButton = Resources.CancelButton:new {
			resource = "CancelButton",
		},

		okayButton = Resources.DialogSmallerButton:new {
			resource = "DialogSmallerButton",
			image = "ButtonPlastic_Small_Orange.png",
			buttonClosesDialog = true,
			alignment = MidBottom,
			alignmentOffset = {-110,-12},
			text = STRINGS("Map"),
			enterKey = true,
			escapeKey = true,
			shortcutKey = "o",
			zorder = 2,
			visible = true,
		},
	},

	TopTenPanel = Resources.TopTenPanel_Challenge:new {
		resource = "TopTenPanel_Challenge",
		zorder = 2,
	},

    InitScoreSharing = function (self, textToShare)
		local shouldShowShareScoreButton = SOCIAL_MGR_IsAvailable() and IsString(textToShare) and string.len(textToShare) > 0
		--[[
		logprintf("InitScoreSharing: should show=%s, is avail=%s, textToShare=%s\n",
			tostring(shouldShowShareScoreButton),
			tostring(SOCIAL_MGR_IsAvailable()),
			tostring(textToShare))
		--]]
		if shouldShowShareScoreButton then
			self.MainPanel.ButtonCollection.shareScoreButton.textToShare = textToShare
			self.MainPanel.ButtonCollection.shareScoreButton.visible = true
		end
	end,

	OnPostSpawn = function (self)
		if self.MainPanel.ButtonCollection then
			if self.MainPanel.ButtonCollection.PlayAgainButton then
				self.MainPanel.ButtonCollection.PlayAgainButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.ButtonCollection.shareScoreButton then
				self.MainPanel.ButtonCollection.shareScoreButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.okayButton then
				self.MainPanel.okayButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.CancelButton then
				self.MainPanel.CancelButton:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.GoalPanel.StarGoal1.Star then
				self.MainPanel.GoalPanel.StarGoal1.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.GoalPanel.StarGoal2.Star then
				self.MainPanel.GoalPanel.StarGoal2.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
			if self.MainPanel.GoalPanel.StarGoal3.Star then
				self.MainPanel.GoalPanel.StarGoal3.Star:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end
		end
	end,
}

Resources.InviteFriendsDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "InviteFriendsDialog",
    name = "InviteFriendsDialog",
	title = "",

	TextLine1 = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Don't Play Alone"),
		alignment = MidTop,
		alignmentOffset = {0, 100 - (headerOffset/2)},
        widthLimit = 250,
    },

	TextLine2 = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("Invite Your Friends!"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,268 - (headerOffset/2)},
        font	= Resources.DialogBoldFont:new{
            resource = "DialogBoldFont",
            fontSize = 28,
        },
	},

	--[[notConnectedText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Connect to the internet\nto log in and play\nwith friends!"),
		alignment = MidTop,
		alignmentOffset = {0, 100},
    },]]

	Picture = Resources.RemotePlayerPicture:new {
		resource = "RemotePlayerPicture",
		image = "PlayerPic_Empty.png",
		defaultImage = "PlayerPic_Empty.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,200 - (headerOffset/2)},
		size = {46, 46},
		resizeOnSetImage = false,
		PlayerFrame = Resources.Actor:new {
			image = "PlayerFrame.png",
			size = {46, 46},
			zorder = 1,
			alignment = "Center",
			alignTo = "Center",
		}
	},

	XButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	InviteFriendsButton = Resources.AppMenuBigButton_arrow_genericsocial:new {
		resource = "AppMenuBigButton_arrow_genericsocial",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-80},
		text = STRINGS("Invite Friends"),
		shortcutKey = "a",
	},

	ConnectButton = Resources.AppButtonSmall:new {
		resources = {"AppButtonSmall", "FacebookConnectDecorator"},
		--size = {130, 36},
		text = STRINGS("Connect"),
		textWidthLimit = 90,
		textAlignmentOffset = {14, 0},
		textDisabledColor = "#383838",
		textColor = "Cascade_DarkBrown",
		textAlignment = "Center",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-80},
		visibleWhenConnected = true,
		raveLoginType = "Facebook",		-- ... makes this control require Facebook connectivity to be considered logged-in
		isConnectUI = true,

		enableAppearanceUpdates = false,
		visible = true,

		facebookIcon = Resources.Actor:new {
			resource = "Actor",
			image = "Facebook_Logo_small.png",
			alignment = "MidLeft",
			alignmentOffset = {18, 0},
		},

		OnPostSpawn = function (self)
			Resources.FacebookConnectDecorator.InitFacebookConnect(self)
		end,
	},
}

Resources.PlayerSelectorDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "PlayerSelectorDialog",
    name = "PlayerSelectorDialog",
	title = "Invite Friends",

	PlayerSelector = Resources.ListBox:new {
		resource = "ListBox",
		alignment = "TopLeft",
		alignmentOffset = {13, 139},
		size = {313,316},
	},

	XButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	AcceptButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignmentOffset = {-20,LargeLonger_Dialog_Button_Y + 5},
		textAlignmentOffset = {0,0},
		text = STRINGS("Accept"),
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 255,
	},

	CheckAllButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		buttonClosesDialog = false,
		alignment = BottomLeft,
		alignmentOffset = {20,LargeLonger_Dialog_Button_Y + 5},
		textAlignmentOffset = {12,0},
		textWidthLimit = 90,
		text = STRINGS("Check all"),
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 255,
		--size = {170,30},

		checkBox = Resources.AppCheckBox:new {
			resource = "AppCheckBox",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {6,1},
			rolloverable = false,
			size = {30, 30},
			checked = false,
			frame = 1,

			UpdateVisibility = function (self)
				if (self.checked == true) then
					self.frame = 1
				else
					self.frame = 0
				end
			end,

			SetChecked = function(self, newChecked)
				self.checked = newChecked
				self:UpdateVisibility()
			end,
			OnPostSpawn = function(self)
				self:UpdateVisibility()
			end,
		},
	},
}

Scripts.FloatText= function(actor,text)
	--Clean up previous instance
	if(actor.floatText ~= nil) then
		actor:DestroyChild(actor.floatText)
	end
	actor.floatText = Resources.AppDialogSmallLabel:new {
        resource = "AppDialogSmallLabel",
        alignment = Center,
        alignmentOffset = {0,0},
		fgColor = "Cascade_CheckGreen_dark",
		shadowColor = "Black",
		shadowAlpha = 255,
		shadowOffset = {1,1},
		highlightColor = "Cascade_CheckGreen_highlight",
		highlightAlpha = 0,
		highlightOffset = {-1,-1},
		--color = "White",
		zorder = 100,
		layer = 2002,
    }
	local destPos = {actor.floatText.position.x,actor.floatText.position.y-50}
	PlaySound("slot_machine_win_03.ogg")
	actor.floatText:SlideTo(destPos, 2000)
	ScriptDelay(1000,"DialogTimers")
	FadeOutAndDestroy(actor.floatText,1500)
end

--Tap FX when hitting Stars in Launch Dialog

Scripts.FloatStarText = function(actor,text)
	--Clean up previous instance
	if(actor.floatText ~= nil) then
		actor:DestroyChild(actor.floatText)
	end
	actor.floatText = Resources.AppDialogSmallLabel:new {
        resource = "AppDialogSmallLabel",
        alignment = Center,
        alignmentOffset = {0,0},
		text = text,
        font	= Resources.DialogTitleFont:new{
        resource = "DialogTitleFont",
        fontSize = 20,
        },
        fgColor = "Cascade_CheckGreen_dark",
		shadowColor = "Cascade_DarkBrown",
		shadowAlpha = 150,
		shadowOffset = {2,2},
		highlightColor = "Cascade_DarkBrown",
		highlightAlpha = 255,
		highlightOffset = {-1,-1},
		zorder = 100,
		layer = 2002,
    }
	local destPos = {actor.floatText.position.x,actor.floatText.position.y-50}
	PlaySound("slot_machine_win_03.ogg")
	actor.floatText:SlideTo(destPos, 2000)
	ScriptDelay(1000,"DialogTimers")
	FadeOutAndDestroy(actor.floatText,1500)
end

Resources.TechSupportDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "TechSupportDialog",
	class = "TechSupportDialog",
	--title = "Customer Service",
	--image = "DialogGeneric_Small.png",
	XButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	Title = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("NEED SOME HELP?"),
		alignment = MidTop,
		alignmentOffset = {-15, 14},
		widthLimit = 250,
		font	= Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 30,
		},
    },

	Jasper_Customer_Support = Resources.Actor:new {
		resource = "Actor",
		image = "Jasper_Customer_Support@2x.png",
		alignment = "MidTop",
		extraScale = 0.68,
		alignmentOffset = {0,20},
	},

	SupportButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		text = STRINGS("Contact Support"),
		--image = "btnCredits.png",
		--text = STRINGS(""),
		shortcutKey = "S",
		alignment = MidTop,
		textWidthLimit = 140,
		alignmentOffset = {0, 172},
		--size = DialogButtonSize,
		scripts = {"SparkleRandomly"},
		textLineSpacing = 3,
		OnButtonClick = function (self, event)
			logprint("Support clicked")
			if self ~= event.button then return false end
			if BIGFISH then
				BIGFISH:ShowSupport(Language);
			end
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	DescriptionOfUserName = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Cascade User ID:"),
		alignment = MidTop,
		alignmentOffset = {0, 225},
		widthLimit = 300,
		font	= Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 30,
		},
		zorder = 100,
    },

	ParseUserName = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("No User ID"),
		noUserIDText = STRINGS("No User ID"),
		--text = "abCdeF0123",
		alignment = MidTop,
		alignmentOffset = {0, 256},
		widthLimit = 280,
		font = Resources.ParseIDFont:new {
			resource = "ParseIDFont",
		},
	},

	CopyButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		alignment = MidTop,
		alignmentOffset = {0, 285},
		text = STRINGS("Copy to Clipboard"),
		textWidthLimit = 140,
		enterKey = true,
		shortcutKey = "o",
		zorder = 2,
		alpha = 255,
		visible = true,
	},

	SendDataButton = Resources.AppButtonSmall:new {
		resource = "AppButtonSmall",
		alignment = MidTop,
		alignmentOffset = {0, 355},
		text = STRINGS("Send Diagnostics"),
		textWidthLimit = 140,
		shortcutKey = "d",
		zorder = 2,
		alpha = 255,

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:StartDialog("SendAppDiagnosticsDialog", "SendAppDiagnosticsDialog", true)
			return true
		end,

		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},
}


--Debug_PageName = "PromptingForSend"
--Debug_PageName = "SendingInfo"
--Debug_PageName = "InfoSent"
--Debug_PageName = "InfoFailedToSend"

Resources.SendAppDiagnosticsDialog = Resources.LargeLongerDialog:new {
	class = "SendAppDiagnosticsDialog",
	resource = "LargeLongerDialog",
    name = "SendAppDiagnosticsDialog",

	XButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	Jasper_Customer_Support = Resources.Actor:new {
		resource = "Actor",
		image = "Jasper_Customer_Support@2x.png",
		alignment = "MidTop",
		extraScale = 0.68,
		alignmentOffset = {0,20},
	},

	page_PromptingForSend = {
		class = "Actor",
		autoFillParent = true,
		visible = true,

		Title = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("NEED SOME HELP?"),
			alignment = MidTop,
			alignmentOffset = {-15, 14},
			widthLimit = 250,
			font	= Resources.DialogTitleFont:new{
				resource = "DialogTitleFont",
				fontSize = 30,
			},
	    },

		DescriptionLabel = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("Send us the current state of your game to help us diagnose any issue you may have."),
			alignment = MidTop,
			alignmentOffset = {0, 190},
			wrapLimit = 260,
            heightLimit = 80,
			--[[
			font = {
				--fontName = "cob_____.ttf",
	            fontName = "OpenSans-Regular.ttf",
				fontSize = 26,
			},
			--]]
	    },

		SendInfoButtonA = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			alignment = MidTop,
			alignmentOffset = {0, 260},
			text = STRINGS("Send Diagnostics"),
			shortcutKey = "Y",
		},

		NoThanksButton = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			text = STRINGS("No thanks"),
			shortcutKey = "N",
			alignment = MidTop,
			textWidthLimit = 125,
			alignmentOffset = {0, 340},
			buttonClosesDialog = true,

			OnPostSpawn = function (self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			OnButtonClick = function (self, event)
				if self ~= event.button then return end
				if self.dialog and self.screen then
					self.screen:StopDialog(self.dialog)
				end
			end,
		},
	},

	page_SendingInfo = {
		class = "Actor",
		autoFillParent = true,
		visible = false,

		Title = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("Sending Diagnostics..."),
			alignment = MidTop,
			alignmentOffset = {0, 14},
			widthLimit = 210,
			font	= Resources.DialogTitleFont:new{
				resource = "DialogTitleFont",
				fontSize = 28,
			},
	    },

		DescriptionLabel = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("Please wait..."),
			alignment = MidTop,
			alignmentOffset = {0, 200},
			wrapLimit = 260,
		},

		ActivityIndicator = Resources.Actor:new {
			resource = "Actor",
			image = "ActivityIndicator_Circles_64x64.png",
			alignment = "MidTop",
			alignmentOffset = {0,260},
			timerGroup = "NonDefault",  -- by setting 'timerGroup' to something besides "default", the activity indicator will work in dialogs that pause GuruEngine's gameplay
			scripts = {
				"CycleImageFrames_Delay60ms",
			},
		},
	},

	page_InfoSent = {
		class = "Actor",
		autoFillParent = true,
		visible = false,

		Title = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("Diagnostics Sent!"),
			alignment = MidTop,
			alignmentOffset = {-15, 14},
			widthLimit = 250,
			font	= Resources.DialogTitleFont:new{
				resource = "DialogTitleFont",
				fontSize = 30,
			},
	    },

		DescriptionLabel = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("We got it! Thanks!"),
			--text = STRINGS("We got it! Thanks! Now contact by tapping Okay and then the Contact Support button."),
			alignment = MidTop,
			alignmentOffset = {0, 175},
			wrapLimit = 260,
		},

		DescriptionOfUploadID = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("Upload ID:"),
			alignment = MidTop,
			alignmentOffset = {0, 215},
			textWidthLimit = 50,
			font	= Resources.DialogTitleFont:new{
				resource = "DialogTitleFont",
				fontSize = 30,
			},
			zorder = 100,
	    },

		UploadIDLabel = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("No ID"),
			alignment = MidTop,
			alignmentOffset = {0, 245},
			widthLimit = 280,
			font = Resources.ParseIDFont:new {
				resource = "ParseIDFont",
			},
		},

		CopyButton = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			alignment = MidTop,
			alignmentOffset = {0, 275},
			text = STRINGS("Copy to Clipboard"),
			enterKey = true,
			shortcutKey = "o",
			zorder = 2,
			alpha = 255,
		},

		OkayButton = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			text = STRINGS("OK"),
			enterKey = true,
			alignment = MidTop,
			textWidthLimit = 125,
			alignmentOffset = {0, 345},
			buttonClosesDialog = true,

			OnPostSpawn = function (self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			OnButtonClick = function (self, event)
				if self ~= event.button then return end
				if self.dialog and self.screen then
					self.screen:StopDialog(self.dialog)
				end
			end,
		},
	},

	page_InfoFailedToSend = {
		class = "Actor",
		autoFillParent = true,
		visible = false,

		Title = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("Could not send!"),
			alignment = MidTop,
			alignmentOffset = {0, 14},
			textWidthLimit = 50,
			font	= Resources.DialogTitleFont:new{
				resource = "DialogTitleFont",
				fontSize = 30,
			},
	    },

		FailureDescriptionLabel = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("SendAppDiagnostics_ErrorDefault", "Oops!\nSomething went wrong.\nPlease try again."),
			alignment = Center,
			alignTo = MidTop,
			alignmentOffset = {0, 215},
			wrapLimit = 280,
	    },

		SendInfoButtonB = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			alignment = MidTop,
			alignmentOffset = {0, 260},
			text = STRINGS("Send Diagnostics"),
			shortcutKey = "Y",
		},

		NoThanksButton = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			text = STRINGS("No thanks"),
			shortcutKey = "N",
			alignment = MidTop,
			textWidthLimit = 125,
			alignmentOffset = {0, 340},
			buttonClosesDialog = true,

			OnPostSpawn = function (self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			OnButtonClick = function (self, event)
				if self ~= event.button then return end
				if self.dialog and self.screen then
					self.screen:StopDialog(self.dialog)
				end
			end,
		},
	},
}


Scripts.Preshow_YesterdaysChallengeDialog = function(dialog,newToday)

	-- test
	-- newToday = false

	local makeVisible = false
	if(newToday)then
		makeVisible = false
	else
		makeVisible = true
	end

	dialog.MainPanel.ChallengeDialog_ResultsText1.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText2.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText3.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText4.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText_winner.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText_winner_picture.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText_winner_score.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_ResultsText_congrats.visible = makeVisible
	dialog.MainPanel.ChallengeDialog_LoadingText.visible = false
	dialog.TopTenPanel.visible = makeVisible
end

Scripts.Present_YesterdaysChallengeDialog = function(dialog,newToday)

	-- test
	-- newToday = false

	if(newToday)then
		dialog.TopTenPanel.visible = false
		local delay = 500
		PlaySound("slot_machine_spin_loop_02.ogg")
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_bet_13.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText1.visible = true
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_bet_14.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText2.visible = true
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_bet_15.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText3.visible = true
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_bet_16.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText4.visible = true
		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("slot_machine_spin_stop_05.ogg")
		StopSound("slot_machine_spin_loop_02.ogg")
		PlaySound("slot_machine_bet_all_03.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText_winner.visible = true
		dialog.MainPanel.ChallengeDialog_ResultsText_winner_picture.visible = true
		dialog.MainPanel.ChallengeDialog_ResultsText_winner_score.visible = true
		PlaySound("pop_sparkle_01.ogg")
		FireParticle(dialog.MainPanel.ChallengeDialog_ResultsText_winner,"StarToss1.smaller","Center",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.ChallengeDialog_ResultsText_winner,"SparkleBurst1","Center",dialog.hgeParticles)
		CorrectedPop(dialog.MainPanel.ChallengeDialog_ResultsText_winner,{expandTo={1.1, 1.1},expandTime=100, shrinkTime=50})
		ScriptDelay(delay,"DialogTimers")
		PlaySound("slot_machine_spin_04_short.ogg")
		FireParticle(dialog.MainPanel.ChallengeDialog_ResultsText_winner_score,"Shine2","Center",dialog.hgeParticles)

		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("air_cannon_pressure_release_02.ogg")
		FireParticle(dialog.MainPanel.titleText,"Confetti1_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti2_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti3_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti4_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti5_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog.MainPanel.titleText,"Confetti6_normal_shape_short","MidTop",dialog.hgeParticles)
		PlaySound("crowd_indoor_cheer_02.ogg")
		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("slot_machine_win_08.ogg")
		dialog.MainPanel.ChallengeDialog_ResultsText_congrats.text = STRINGS("RIGHT ON!")
		dialog.MainPanel.ChallengeDialog_ResultsText_congrats.visible = true
		SlideOn(dialog.TopTenPanel,150,"bottom","wait")
	end
end

Scripts.Leave_YesterdaysChallengeDialog = function(screen)
	StopSound("slot_machine_spin_loop_02.ogg")
end


Resources.YesterdaysChallengeDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "YesterdaysChallengeDialog",
	alpha = 0,
	--alignmentOffset = {0,LevelDialogDropDownY},

	introScriptName = "SlideOnTwoPanelsDialog",
	dialogExitScriptName = "SlideOffTwoPanelsDialog",

	MainPanel = Resources.Actor:new {
		resource = "Actor",
		image = "DialogGeneric_Small.png",
		zorder = 1,
		titleText = Resources.AppTitleDialogLabel_smaller:new {
			resource = "AppTitleDialogLabel_smaller",
			text = STRINGS("Challenge Results"),
			alignment = MidTop,
			alignmentOffset = {-10, 14},
            widthLimit = 222,
		},

		ChallengeDialog_ResultsText1 = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("And the winner..."),
			textAlignment = "Center",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,80+ChallengeYOffset-100},
			visible = false,
		},

		ChallengeDialog_ResultsText2 = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("of yesterday's..."),
			textAlignment = "Center",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,80+ChallengeYOffset-75},
			visible = false,
		},

		ChallengeDialog_ResultsText3 = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("Cascade Daily Challenge..."),
			textAlignment = "Center",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,80+ChallengeYOffset-50},
			visible = false,
		},

		ChallengeDialog_ResultsText4 = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			text = STRINGS("was..."),
			textAlignment = "Center",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0,80+ChallengeYOffset-25},
			visible = false,
		},

		ChallengeDialog_ResultsText_winner = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS("No Results Yet..."),
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			widthLimit = 300,
			alignmentOffset = {0,5},
			visible = false,
		},

		ChallengeDialog_ResultsText_winner_picture = Resources.RemotePlayerPicture:new {
			resource = "RemotePlayerPicture",
			image = "PlayerPic_Empty.png",
			defaultImage = "PlayerPic_Empty.png",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0, 40},
			size = {40, 40},
			resizeOnSetImage = false,
			PlayerFrame = Resources.Actor:new {
				image = "PlayerFrame.png",
				size = {40, 40},
				alignment = "Center",
				alignTo = "Center",
				zorder = 1,
			},
		},

		ChallengeDialog_ResultsText_winner_score = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS(""),
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			widthLimit = 300,
			alignmentOffset = {0,80},
			visible = false,
		},

		ChallengeDialog_ResultsText_congrats = Resources.AppDialogBoldLabel:new {
			resource = "AppDialogBoldLabel",
			text = STRINGS(""),
			textAlignment = "Center",
			alignment = "Center",
			alignTo = "Center",
			widthLimit = 300,
			alignmentOffset = {0,110},
			visible = false,
		},

		ChallengeDialog_LoadingText = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			text = STRINGS("Loading Yesterday's Challenge..."),
			textAlignment = "Center",
			wrapLimit = 260,
			heightLimit = 110,
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0,0},
			font = Resources.DialogFont:new{
				resource = "DialogFont",
				fontSize = 24,
			},
			visible = true,
		},

		shareScoreButton = Resources.DialogSmallerButton:new {
			resource = "DialogSmallerButton",
			--image = "btnShare.png",
			text = STRINGS("Share"),
			alignment = MidBottom,
			alignmentOffset = {0,-12},
			OnButtonClick = function (self, event)
				if self ~= event.button then
					return false
				end
				local shareText = self.dialog:GetShareText()
				if IsString(shareText) and shareText ~= "" then
                    Analytics_Brag()
					ShareText(shareText, "ChallengeResults", self)
				end
				return true
			end,
			--scripts = {"JelloLoop"},
		},


		CancelButton = Resources.CancelButton:new {
			resource = "CancelButton",
		},
	},

	TopTenPanel = Resources.TopTenPanel_Challenge:new {
		resource = "TopTenPanel_Challenge",
		zorder = 2,
		visible = false,
	},
}



Resources.LoginProgressDialog = Resources.LargeLongerDialog:new {
	class = "LoginProgressDialog",
	name = "LoginProgressDialog",
	resources = {"LargeLongerDialog", "CommonLoginProgressDialogParts"},
    title = "",
	image = "DialogGeneric_Small.png",

    -- Make login progress dialogs appear and disappear as quickly as possible.
	introScriptName = "LoginProgressDialogIntro",
	dialogExitScriptName = "LoginProgressDialogExit",

	--debugDialog = true,

	DialogCharacter = Resources.DialogCharacter:new {
		resource = "DialogCharacter",
		zorder = 1,
		alignTo = MidTop,
		alignmentOffset = {0,40},
	},

	page_authenticating = Resources.Actor:new {
		resource = "Actor",
		autoFillParent = true,
		visible = true,

		titleText = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("LoginProgressDialog.Title"), --"Connecting",
			alignment = MidTop,
			alignmentOffset = {0, 80},
			widthLimit = 250,
	    },

	    DescLabel = Resources.AppDialogSmallLabel:new {
			resource = "AppDialogSmallLabel",
			alignment =	Center,
			textAlignment = "Center",
			alignTo = Center,
			font	= Resources.DialogFont:new{
	    		resource = "DialogFont",
	    		fontSize = 22,
	    		fontStyle = FontStyle { "bold" },
	    	},
			--alignmentOffset = {0,135},
			text = STRINGS("LoginProgressDialog.Body"), --"Logging in to the\nCascade Network...",
			wrapLimit = 250,
			heightLimit = 40,
	    },

		ActivityIndicator = Resources.Actor:new {
			resource = "Actor",
			image = "ActivityIndicator_Circles_64x64.png",
			alignment = "Center",
			alignmentOffset = {0,84},
			timerGroup = "NonDefault",  -- by setting 'timerGroup' to something besides "default", the activity indicator will work in dialogs that pause GuruEngine's gameplay
			scripts = {
				"CycleImageFrames_Delay60ms",
			},
		},
	},

	page_playerChoice = Resources.Actor:new {
		resource = "Actor",
		autoFillParent = true,
		visible = false,

		titleText = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("LoginProgressDialog.Title"), --"Connecting",
			alignment = MidTop,
			alignmentOffset = {0, 30},
			widthLimit = 250,
	    },

	    DescLabel = Resources.AppDialogSmallLabel:new {
			resources = {"AppDialogSmallLabel", "AuthenticationAwareDecorator"},

			OnPostSpawn = function (self)
				Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
			end,

			text_needsLogout = STRINGS("PlayerChoiceDescription_needsLogout"),
			text_needsLogin = STRINGS("PlayerChoiceDescription_needsLogin"),
			text_needsLogoutThenLogin = STRINGS("PlayerChoiceDescription_needsLogoutThenLogin"),
			UpdateAppearance = LoginProgressText_UpdateAppearance,
			--UpdateAppearance = function () end,

			alignment =	"MidTop",
			alignmentOffset = {0, 90},
			fgColor = "Black",
			textAlignment = "Center",
			text = "",
			--text = STRINGS("PlayerChoiceDescription_needsLogout"),
			wrapLimit = 250,
			heightLimit = 225,
	    },

	    SwitchPlayersNowButton = Resources.Button:new {
			resources = {"AppButtonMediumSmall", "AuthenticationAwareDecorator"},

			OnPostSpawn = function (self)
				Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
			end,

			text_needsLogout = STRINGS("Continue Logging In"),
			text_needsLogin = STRINGS("Switch To Local Player"),
			text_needsLogoutThenLogin = STRINGS("Switch To New Player"),
			UpdateAppearance = LoginProgressText_UpdateAppearance,
			--UpdateAppearance = function () end,

	    	alignment = "MidBottom",
	    	alignmentOffset = {-70, -25},
			text = STRINGS("Switch To New Player"),
			textWrapLimit = 126,
			textHeightLimit = 30,
		},

	    LoginButton = Resources.Button:new {
			resources = {"AppButtonMediumSmall", "AuthenticationAwareDecorator"},

			GetAuthenticationStatus = Authentication_GetBaseLevelAuthenticationStatus,

			connectingText = STRINGS("Connecting"),
			logoutText = STRINGS("Log out"),
			connectText = STRINGS("Login"),
			visibleWhenConnected = false,
			visibleWhenDisconnected = true,
			decoratorCanChangeText = true,

			OnPostSpawn = function (self)
				Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			OnButtonClick = function (self, event)
				if event.button ~= self then
					return
				end
				RaveConnect()
			end,

	    	alignment = "MidBottom",
	    	alignmentOffset = {70, -25},
	    	text = STRINGS("Login"),
			textWrapLimit = 126,
			textHeightLimit = 30,
		},

	    LogoutButton = Resources.Button:new {
			resources = {"AppButtonMediumSmall", "AuthenticationAwareDecorator"},

			GetAuthenticationStatus = Authentication_GetBaseLevelAuthenticationStatus,

			connectingText = STRINGS("Connecting"),
			logoutText = STRINGS("Log out"),
			connectText = STRINGS("Login"),
			visibleWhenConnected = true,
			visibleWhenDisconnected = false,
			decoratorCanChangeText = true,

			OnPostSpawn = function (self)
				Resources.AuthenticationAwareDecorator.InitAuthenticationAwareDecorator(self)
				self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
			end,

			OnButtonClick = function (self, event)
				if event.button ~= self then
					return
				end
				RaveConnect() -- when logged in, this should trigger a logout
			end,

	    	alignment = "MidBottom",
	    	alignmentOffset = {70, -25},
	    	text = STRINGS("Log out"),
			textWrapLimit = 126,
			textHeightLimit = 30,
		},
	},

	-- CONFIG note: This cancel button can be turned on/off via CONFIG.
	-- For LoginProgressDialogs, the key is "LoginProgressDialog.ShowCancelButton",
	-- and the value is a boolean.
	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		buttonClosesDialog = true,
	},

    LogDebugInfoButton = Resources.Button:new {
        resource = "Button",
        text = "log debug\ninfo",
        font = {
            fontName = "arial.ttf",
            fontSize = 20,
        },
        image = "SmallWhiteButton.png",
        alpha = 100,
        textWidthLimit = 50,
        alignment = "TopLeft",
        alignmentOffset = {14, 10},
        visible = false,
    },
}

Scripts.Preshow_LoginProgressDialog = function(dialog)

end

Scripts.Present_LoginProgressDialog = function(dialog)

end

Resources.RatingsPromptDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "RatingsPromptDialog",
    name = "RatingsPromptDialog",

	Monkey = Resources.Actor:new {
		resource = "Actor",
		image = "Monkey.png",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {185, 390},
		zorder = 3,
		visible = true,
	},

	HavingFunPanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		visible = true,

		PlayerFeedbackText = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS("Player Feedback"),
			alignmentOffset = {0, 50},
		},

		HavingFunText = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS("Having Fun?"),
            widthLimit = 200,
			alignmentOffset = {0, 120},
		},

		Hearts = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0, 165},
			Heart1 = Resources.Actor:new {
				resource = "Actor",
				alignment = "MidTop",
				alignTo = "MidTop",
				image = "StarSmall.png",
				alignmentOffset = {-80, 0},
				--extraScale = {.35, .35},
			},
			Heart2 = Resources.Actor:new {
				resource = "Actor",
				alignment = "MidTop",
				alignTo = "MidTop",
				image = "StarSmall.png",
				alignmentOffset = {-40, 0},
				--extraScale = {.35, .35},
			},
			Heart3 = Resources.Actor:new {
				resource = "Actor",
				alignment = "MidTop",
				alignTo = "MidTop",
				image = "StarSmall.png",
				alignmentOffset = {0, 0},
				--extraScale = {.35, .35},
			},
			Heart4 = Resources.Actor:new {
				resource = "Actor",
				alignment = "MidTop",
				alignTo = "MidTop",
				image = "StarSmall.png",
				alignmentOffset = {40, 0},
				--extraScale = {.35, .35},
			},
			Heart5 = Resources.Actor:new {
				resource = "Actor",
				alignment = "MidTop",
				alignTo = "MidTop",
				image = "StarSmall.png",
				alignmentOffset = {80, 0},
				--extraScale = {.35, .35},
			},
		},

		YesButton = Resources.DialogButton:new {
			resource = "DialogButton",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS("Yes"),
			alignmentOffset = {-50, 250},
		},

		NoButton = Resources.DialogButton:new {
			resource = "DialogButton",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS("No"),
			alignmentOffset = {50, 250},
		},
	},

	ThanksPanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		visible = false,

		ThanksText = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS("Thanks!"),
			alignmentOffset = {0, 50},
		},

		RateUsText = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS("Rate us on the App Store"),
			alignmentOffset = {0, 310},
			font	= Resources.DialogFont:new{
				resource = "DialogFont",
				fontSize = 18,
			},
		},

		RateUsButton = Resources.BigDialogButton:new {
			resource = "BigDialogButton",
			alignment = "MidTop",
			alignTo = "MidTop",
			image = "ButtonPlastic_Longer_Green.png",
			text = STRINGS("Be a Hero"),
			alignmentOffset = {0, 330},
			buttonClosesDialog = true,
		},
	},

	SorryPanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		visible = false,

		SorryText = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS("Sorry to hear that"),
			alignmentOffset = {0, 50},
			widthLimit = 270,
		},

		ContactUsText = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			alignment = "MidBottom",
			alignTo = "MidBottom",
			text = GetLocalizedString("RatingsPromptDialog_ContactUsText", STRINGS("Please take a moment to let us know\nyour thoughts on the game.\nYour help is appreciated!")),
			wrapLimit = 280,
			alignmentOffset = {0, 340},
			font	= Resources.DialogFont:new{
				resource = "DialogFont",
				fontSize = 18,
			},
		},

		GetHelpButton = Resources.BigDialogButton:new {
			resource = "BigDialogButton",
			image = "ButtonPlastic_Longer_Green.png",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = GetLocalizedString("RatingsPromptDialog_GetHelpButton", STRINGS("Help Us")),
			alignmentOffset = {0, 345},
			buttonClosesDialog = true,
		},
	},

	GiftOverlay = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		visible = false,

		GiftTextTop = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS(""), -- Set via code; example:"Here's a free Hammer",
			alignmentOffset = {0, 133},
		},

		GiftTextBottom = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS("for letting us know."),
			alignmentOffset = {0, 249},
		},

		GiftImage = Resources.Actor:new {
			resource = "Actor",
			image = "Trick_Hammer_big.png",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0, 159},
		},
	},

	XButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Resources.ThanksForBuyingDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "ThanksForBuyingDialog",
    title = "",
	name = "ThanksForBuyingDialog",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Big Thanks!"),
		alignment = MidTop,
		alignmentOffset = {0, 50},
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	character = Resources.Actor:new {
		resource = "Actor",
		image = "Character_GemHold.png",
		alignment = "Center",
		alignmentOffset = {0,-90},
		scripts = {"DialogButtonGroove"},
	},

	text = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("Thank you for supporting Cascade!"),
		alignment = "Center",
		alignmentOffset = {0,0},
	},

	GiftOverlay = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0,140},
		visible = true,

		GiftTextTop = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS(""), -- Set via code; example:"Here's a free Hammer",
			alignmentOffset = {0, 133},
		},

		GiftTextBottom = Resources.AppDialogDataLabel:new {
			resource = "AppDialogDataLabel",
			alignment = "MidTop",
			alignTo = "MidTop",
			text = STRINGS(""),
			alignmentOffset = {0, 249},
		},

		GiftImage = Resources.Actor:new {
			resource = "Actor",
			image = "Trick_Hammer_big.png",
			alignment = "MidTop",
			alignTo = "MidTop",
			alignmentOffset = {0, 159},
		},
	},

	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
	},
}

Scripts.Preshow_ThanksForBuyingDialog = function(dialog)
	--logprint("Preshow_ThanksForBuyingDialog")
end

Scripts.Present_ThanksForBuyingDialog = function(dialog)
	--logprint("Present_ThanksForBuyingDialog")

	PlaySound("Boxing_Bell2.ogg")
	ScriptDelay(500,"DialogTimers")

	PlaySound("slot_machine_win_03.ogg")
	PlaySound("air_cannon_pressure_release_02.ogg")
	FireParticle(dialog,"Confetti1_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti2_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti3_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti4_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti5_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti6_normal_shape_short","MidTop",dialog.hgeParticles)
	PlaySound("crowd_indoor_cheer_02.ogg")
end

Resources.BuyPowerupDialog_Store = Resources.LargeLongerDialog:new {
	class = "BuyPowerupDialog",
	resource = "LargeLongerDialog",
    name = "BuyPowerupDialog_Store",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

	topTitleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Daily Deals"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
        wrapLimit = 160,
    },

	text = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("Welcome to the Cascade Store!"),
		alignment = "MidTop",
		alignmentOffset = {0,75},
		visible = false,
	},

	DailySpinPanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0,60-16},
		visible = true,
		--color = "White",
		--size = {280,110},
		--alpha = 100,
		image = "Canvas_Small.png",

		dailySpinHeader = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("The Daily Spin!"),
			alignment = MidTop,
			alignmentOffset = {0, 22},
			fgColor = "Cascade_Canvas_Blue",
            widthLimit = 180,
            heightLimit = 40,
		},
	},

	DailySpinButton = Resources.BigDialogButton:new
	{
		resource	=	"BigDialogButton",
		text		=	STRINGS("Spin"),
		alignment	=	"MidTop",
		alignmentOffset = {0, 75+42-16},
		buttonClosesDialog = true,
		zorder = 1,
	},

	StorePanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0,190-16},
		visible = true,
		size = {588/2,(577/2)-headerOffset+10},
		--color = "White",
		--size = {280,275},
		--zorder = 0,
		--alpha = 100,
		image = "Canvas_Large.png",
	},

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Get Powerup"),
		alignment = MidTop,
		alignmentOffset = {0, 215-16-10},
		widthLimit = 160,
		zorder = 1,
		fgColor = "Cascade_Canvas_Blue",
    },

	BundleItemsTag = Resources.BundleItemsTag:new {
		resource = "BundleItemsTag",
		alignment = MidTop,
		alignmentOffset = {75, 260-16},
		zorder = 5,
        rotationAngle = {degrees = 15,},
		zorder = 1,
		visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
	},

	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {-75,60},
		zorder = 1,
		quantitySaleProperties = {
			alignmentOffset = {-60,60-8},
		},
        PurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("test text"),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {0,0},
            wrapLimit = 250,
			fgColor = "Cascade_Canvas_Red",
			CrossOut = Resources.AppTitleDialogLabel:new {
				resource = "AppTitleDialogLabel",
				text = STRINGS("/"),
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {0,0},
				visible = false,
				zorder = 10,
				shadowAlpha = 0,
				highlightAlpha = 0,
				alpha = 200,
				extraScale = {1.5,1.2},
				rotationAngle = {degrees = 15,},
			},
        },

        SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_bigger:new {
            resource = "AppTitleDialogLabel_bigger",
            text = STRINGS(""),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {60,0},
            wrapLimit = 250,
            visible = false,
			fgColor = "Cascade_Canvas_Red",
			rotationAngle = {degrees = 5,},
        },

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			visible = true,
			alignment = MidRight,
			alignTo = Center,
			alignmentOffset = {-10,10},
		},

		scripts = {"DialogButtonGroove"},
	},

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("This powerup does something cool!"),
		alignmentOffset = {0,365-38},
		heightLimit = 50,
		zorder = 1,
	},

	ProgressLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Using Gold..."),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-45-38},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
		zorder = 1,
	},

	CancelledLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no money was spent."),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-45-38},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 18,
		},
		wrapLimit = 250,
		visible = false,
		zorder = 1,
	},

	CancelledLabel_Gold = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no gold was spent."),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-45-38},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 18,
		},
		wrapLimit = 250,
		visible = false,
		zorder = 1,
        heightLimit = 40,
	},

	PriceButton = Resources.PriceButton:new {
		resource = "PriceButton",
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-32+22},
		text = STRINGS("$0.99"),
		zorder = 2,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Scripts.Preshow_StoreDialog = function(dialog)
	logprint("Preshow_StoreDialog")
end

Scripts.Present_StoreDialog = function(dialog)
	logprint("Present_StoreDialog")
end

Scripts.Preshow_StarCardWonDialog = function(dialog)
	dialog.StarRankCard.mainPanel.checkBox.visible = false
	dialog.StarRankCard.backCover.visible = true
	dialog.StarRankCard.background.visible = false
	dialog.OkayButton.visible = false
end


Scripts.Present_StarCardWonDialog = function(dialog)
	PlaySound("slot_machine_spin_04_short.ogg")

	ScriptDelay(1300)

	PlaySound("Cascade_SFX_Match.ogg")

	ScriptDelay(300)

	PlaySound("card_deal01_fast.ogg")
	ScaleOut(dialog.StarRankCard,{1.0,0.0},50,true)
	dialog.StarRankCard.backCover.visible = false
	dialog.StarRankCard.background.visible = true
	ScaleIn(dialog.StarRankCard,{1.0,0.0},50,true)

    ScriptDelay(300)

	ScaleIn(dialog.StarRankCard.mainPanel.checkBox,{2.0,2.0},300,true)
	PlaySound("slot_machine_bet_01.ogg")
	FireParticle(dialog.StarRankCard.mainPanel.checkBox,"StarToss1.smaller","Center",dialog.hgeParticles)
	FireParticle(dialog.StarRankCard.mainPanel.checkBox,"SparkleBurst1","Center",dialog.hgeParticles)
	FireParticle(dialog.StarRankCard.mainPanel.checkBox,"Shine2","Center",dialog.hgeParticles)
	Pop(dialog.StarRankCard.mainPanel.checkBox)

	PlaySound("crowd_indoor_cheer_02.ogg")
	dialog.OkayButton.visible = true
end

Resources.StarCardWonDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "StarCardWonDialog",
    title = "",

    hgeParticles = {
		class = "hgeParticleLayer",
		position = {(578-800)/2,15},
		zorder = 10,
    },

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("New Star Card!"),
		alignment = MidTop,
		alignmentOffset = {0, 50},
		widthLimit = 285,
    },

	StarRankCard = Resources.StarRankCard:new {
		resource = "StarRankCard",
		alignment = Center,
	},

	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
	},
}

Resources.WelcomeToGoldDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "WelcomeToGoldDialog",
	class = "WelcomeToGoldDialog",
    title = "",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("New!"),
		alignment = MidTop,
		alignmentOffset = {0,15},
		widthLimit = 285,
        fontSize = 72,
        shadowColor = "Cascade_White",
        shadowAlpha = 255,
        highlightColor = "Cascade_White",
        highlightAlpha = 255,
        shadowOffset = {2,2},
        highlightOffset = {-2,-2},
        zorder = 2,
    },

    titleSubText = Resources.AppTitleDialogLabel:new {
        resource = "AppTitleDialogLabel",
        text = STRINGS("Cascade Gold!"),
		alignment = MidTop,
		alignmentOffset = {0,80},
		widthLimit = 285,
        zorder = 1,
        shadowColor = "Cascade_White",
        shadowAlpha = 255,
        highlightColor = "Cascade_White",
        highlightAlpha = 255,
        shadowOffset = {2,2},
        highlightOffset = {-2,-2},
        zorder = 2,
    },

	topText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("x free bars!"),
		alignment = "Center",
		alignmentOffset = {0,40},
		wrapLimit = 250,
        zorder = 2,
        heightLimit = 40,
	},

    Glow = Resources.Actor:new {
		resource = "Actor",
		image = "Glow.png",
		alignment = "Center",
		alignmentOffset = {0,-30},
		zorder = 0,
		scripts = {
			function (self)
				local revolutionsPerSecond = 0.025
                ScaleTo(self,{1.0,1.0},1.0,true)
                ScaleTo(self,{1.75,1.75},1.0,true)
				RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
			end,
		},
		shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		alpha = 200,
		extraScale = 1.75,
	},

	Glow2 = Resources.Actor:new {
		resource = "Actor",
		image = "Glow.png",
		alignment = "Center",
		alignmentOffset = {0,-30},
		zorder = 0,
		scripts = {
			function (self)
				local revolutionsPerSecond = 0.015
				RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
			end,

            function(self)
                local delay = 222.0
                while (true) do
                    ScaleTo(self,{0.8,0.8},delay,true)
                    ScaleTo(self,{1.75,1.75},delay,true)
                end
            end,
		},
		--shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
		alpha = 100,
		visible = true,
		extraScale = 1.75,
	},

	GoldBarsImage = Resources.Actor:new {
		resource = "Actor",
		alignment = Center,
		image = "Gold_5bars_big.png",
        alignmentOffset = {0,-30},
        --size = {250,200},

        hgeParticles = {
            class = "hgeParticleLayer",
            --position = {(578-800)/2,15},
            zorder = 10,
        },
        zorder = 1,

        scripts = {       },
	},

	text = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("Use Cascade Gold to buy Lives, Spins, Tricks and Boosts!"),
		alignment = "Center",
		alignmentOffset = {0,170},
		wrapLimit = 250,
        heightLimit = 50,
	},

	OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
        image = "ButtonPlastic_Huge_Green.png",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y-45},
		text = STRINGS("Get it!"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
        textWidthLimit = 150,
        textHeightLimit = 40,
        widthLimit = 150,
		clickSound = "coin_magic_03.ogg",

		font	= Resources.DialogTitleFont_bigger:new{
			resource = "DialogTitleFont_bigger",
		},
        OnPostSpawn = function (self)

        end,

        scripts = { "JelloLoop"   },
	},
}

Resources.GoldPackageView = Resources.Actor:new {
	resource = "Actor",
	image = "Dialog_Banner.png",
	--size = {280,65},
	--alpha = 200,
	visible = true,

    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
    },

	goldImage = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		image = "Gold_5bars.png",
		alignmentOffset = {-5,0},
		--scripts = {"SparkleRandomly_gold"},
	},

	Shop_BestValue_Outline = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "Center",
		image = "Shop_BestValue_Outline.png",
		alignmentOffset = {0,0},
		visible = false,
		bestValueLabel = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("Best Value!"),
			alignment = "Center",
			alignTo = "MidTop",
			fgColor = "White",
			highlightColor = "Red",
			highlightAlpha = 155,
			highlightOffset = {-1,-1},
			shadowColor = "Red",
			shadowOffset = {1,1},
			shadowAlpha = 155,
			alignmentOffset = {0,4},
			widthLimit = 140,
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 22,
			},
		},
	},

	-- SALE Tag
	-- Note: If you make this visible be sure to turn off Shop_BestValue_Outline
	-- Maybe make it handle visible event and make Shop_BestValue_Outline not visible if this is visible
	SaleTag = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "Center",
		image = "Shop_BestValue_Outline.png",
		alignmentOffset = {0,0},
		visible = false,
		bestValueLabel = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("Sale!"),
			alignment = "Center",
			alignTo = "MidTop",
			fgColor = "White",
			highlightColor = "Red",
			highlightAlpha = 155,
			highlightOffset = {-1,-1},
			shadowColor = "Red",
			shadowOffset = {1,1},
			shadowAlpha = 155,
			alignmentOffset = {90,6},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 22,
			},
		},
	},

	QuantityLabel = Resources.AppTitleDialogLabel_smaller:new {
		resource = "AppTitleDialogLabel_smaller",
		text = STRINGS("No Message Title"),
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,0},
		visible = true,
		widthLimit = 80,

		quantitySaleProperties = {
			alignmentOffset = {0,-20},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 22,
			},
		},

		--GOLD CROSSOUTS
		CrossOut = Resources.AppTitleDialogLabel:new {
			resource = "AppTitleDialogLabel",
			text = STRINGS("/"),
			alignment = Center,
			alignTo = Center,
			alignmentOffset = {0,0},
			visible = false,
			zorder = 10,
			shadowAlpha = 0,
			highlightAlpha = 0,
			alpha = 150,
			extraScale = {1.5,1.2},
			rotationAngle = {degrees = 25,},
			visible = false,
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 32,
			},
		},
	},

	--GOLD CROSSOUTS
    SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = "2000",
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,10},
		visible = false,
		zorder = 1,
		fgColor = "Cascade_Gold",
		shadowColor = "Black",
		shadowAlpha = 255,
		shadowOffset = {2,2},
		highlightColor = "Black",
		visible = false,
	},
--Gold Shop Button
	PriceButton = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
		image = "ButtonPlastic_Small_Green.png",
		buttonClosesDialog = true,
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {-10,0},
		text = STRINGS("$0.99"),
		clickSound = "coin_magic_03.ogg",
		textWidthLimit = 66,
		zorder = 2,

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			zorder = 11,
			alignment = MidRight,
			alignTo = MidLeft,
			alignmentOffset = {45,26},
			extraScale = 0.72,
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),

			localizedLabel = Resources.Label:new {
		        class = "override",
		        font	= Resources.DialogBoldFont:new{
		            resource = "DialogBoldFont",
		            fontSize = 30,
		        },
		    },
		},
	},

    ButtonBevel = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Small_WoodOutline.png",
        alignment = MidRight,
        alignTo = MidRight,
        alignmentOffset = {-10,0},
        zorder = 1,
    },

}

Scripts.Preshow_GoldPackageView = function(view,price,goldAmount,packageName,isSale)
	local goldImage = view:FindChild("goldImage",true)
	goldImage.image = PowerupDialogImages[packageName]

	local quantityLabel = view:FindChild("QuantityLabel",true)
	quantityLabel.text = Int2Comma(goldAmount)

	local PriceButton = view:FindChild("PriceButton",true)
	PriceButton.text = price
	if (price == "") then
		PriceButton.text = STRINGS("Offline")
		PriceButton.active = false
	else
		PriceButton.active = true
	end

	view.name = packageName
	--logprint(view.name)

	if ((goldAmount>2000 and goldAmount<5000)) then
		view.Shop_BestValue_Outline.visible = true
		view.Shop_BestValue_Outline.bestValueLabel.text = STRINGS("Great Deal!")
	elseif ((goldAmount>10000)) then
		view.Shop_BestValue_Outline.visible = true
	end

	local saleTag = view:FindChild("SaleTag",true)
	local shop_BestValue_Outline = view:FindChild("Shop_BestValue_Outline",true)
	if(isSale)then
		if(saleTag) then
			saleTag.visible = true
		end
		if(shop_BestValue_Outline)then
			shop_BestValue_Outline.visible = false
		end
	else
		if(saleTag) then
			saleTag.visible = false
		end
	end
end

Scripts.Preshow_WelcomeToGoldDialog = function(dialog,gold)
	--logprint("Preshow_WelcomeToGoldDialog gold: "..gold)
end

Scripts.Present_WelcomeToGoldDialog = function(dialog,gold)

		local delay = 400

		PlaySound("slot_machine_win_02.ogg")
		FireParticle(dialog.GoldBarsImage,"Shine2","Center",dialog.hgeParticles)
		FireParticle(dialog.GoldBarsImage,"GoldSparkle1","Center",dialog.hgeParticles)

		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("air_cannon_pressure_release_02.ogg")
		FireParticle(dialog,"Confetti1_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti2_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti3_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti4_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti5_normal_shape_short","MidTop",dialog.hgeParticles)
		FireParticle(dialog,"Confetti6_normal_shape_short","MidTop",dialog.hgeParticles)
		PlaySound("crowd_indoor_cheer_02.ogg")
		ScriptDelay(delay*2,"DialogTimers")
		PlaySound("slot_machine_win_01.ogg")

end

Scripts.Preshow_GoldDialog = function(dialog,gold,stars)
end

Scripts.Present_GoldDialog = function(dialog,gold)
	for i = 1,6 do
		local packageName = "GoldPackage"..i
		local goldPackageView = dialog:FindChild(packageName,true)
		local goldImage = goldPackageView:FindChild("goldImage",true)
		FireParticle(goldImage,"GoldSparkle1","Center",goldPackageView.hgeParticles)
		ScriptDelay(math.random(30,1000),"DialogTimers")
	end
end

Resources.GoldDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "GoldDialog",
	name = "GoldDialog",
    title = "",
	enableVisibleUnderlay = true,
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
    },

    titleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Gold Mine"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
		DisplayDimensions = {313, 416-headerOffset},
		horizontalScrollLocked = true,
		alignment = "MidRight",
		alignmentOffset = {-5,15},
		SlowFraction = .95,
		stoppingVelocity = 1,
	},

	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
		visible = false,
	},
}

Resources.GoldDialog_WithMessage = Resources.GoldDialog:new {
	resource = "GoldDialog",

	titleText = Resources.AppTitleDialogLabel_UI2:new {
		resource = "AppTitleDialogLabel_UI2",
		text = STRINGS("Gold Mine"),
    },

	MessageLabel = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0, 50},
		wrapLimit = 200,
		heightLimit = 50,
    },

	ScrollableArea = {
		class = "ScrollableArea",
		DisplayDimensions = {313, 346-headerOffset+30},
		alignmentOffset = {-5,50-30},
	},
}

--In Game Skinned Confirmation Dialog

Resources.ConfirmGoldPurchaseDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "ConfirmGoldPurchaseDialog",
	name = "ConfirmGoldPurchaseDialog",
	title = "",

    PowerUpShadow = Resources.Actor:new {
        resource = "Actor",
        image = "PowerUpShadow.png",
        alignment = "Center",
        alignmentOffset = {0,-45},
		zorder = 2,
    },

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-20},
        size = {250,280},
    },

	titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Confirm Purchase"),
		alignment = MidTop,
		alignmentOffset = {0, 15},
		widthLimit = 210,
    },

	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
        zorder = 3,
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-75},
		maxDimensions = {150,150},
        PurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("test text"),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {0,0},
            wrapLimit = 250,
			CrossOut = Resources.AppTitleDialogLabel_bigger:new {
				resource = "AppTitleDialogLabel_bigger",
				text = STRINGS("/"),
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {0,0},
				visible = false,
				zorder = 10,
				shadowAlpha = 0,
				highlightAlpha = 0,
				alpha = 200,
				extraScale = {1.5,1.2},
				rotationAngle = {degrees = 15,},
			},
        },

        SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_big:new {
            resource = "AppTitleDialogLabel_big",
            text = STRINGS(""),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {10,40},
            wrapLimit = 250,
            visible = false,
			rotationAngle = {degrees = 5,},
            textColor = "Red",
        },

		scripts = {"DialogButtonGroove"},
	},

	ConfirmationLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = Center,
		alignTo = MidTop,
		--alignmentOffset = {0,225},
        alignmentOffset = {0,240},
		wrapLimit = 200,
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 25,
		},
        heightLimit = 80,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	DontShowAgainLabel =  Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Don't Show Again"),
            font	= Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 20,
            },
		alignment = MidBottom,
		alignmentOffset = {15, -105},
        heightLimit = 30,
		widthLimit = 170,
	},

	DontShowAgainCheckBox = Resources.AppCheckBox:new {
		resource = "AppCheckBox",
		shortcutKey = "u",
		alignment = MidBottom,
		alignmentOffset = {-90, -100},

		OnButtonClick = function (self, event)
			local seen = HasSeen("HideGoldConfirmation","HideGoldConfirmation")
			if (not seen) then
                self.frame = 1
				SetSeen("HideGoldConfirmation","HideGoldConfirmation",true)
            else
                self.frame = 0
				SetSeen("HideGoldConfirmation","HideGoldConfirmation",false)
            end
			return true
		end,

		OnPostSpawn = function(self)
			local firstTimeShown = not HasSeen("HideGoldConfirmation","HideGoldConfirmationDefault")
			if(firstTimeShown) then
				SetSeen("HideGoldConfirmation","HideGoldConfirmation",true)
				SetSeen("HideGoldConfirmation","HideGoldConfirmationDefault",true)
                self.frame = 1
			end
		end
	},

	YesButton = Resources.BigDialogButton:new {
		resource	=	"BigDialogButton",
		text		=	STRINGS("Yes"),

        textColor = "Cascade_BrightYellow",
        textHighlightColor = "Cascade_DarkGreen",
        textHighlightAlpha = 255,
        textShadowColor = "Cascade_DarkGreen",
        textShadowOffset = {1, 2},

		alignment	=	"MidBottom",
		alignmentOffset = {0, -20},
		buttonClosesDialog = true,
        image = "ButtonPlastic_Long_Green.png",
        zorder = 2,
	},

    ButtonBevel = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Long_WoodOutline.png",
        alignment = MidBottom,
		alignmentOffset = {0, -20},
        zorder = 1,
    },
}


Resources.ShopItemProductView = Resources.Actor:new {
	resource = "Actor",
	image = "Dialog_Banner_Large.png",
	--size = {280,65},
	--alpha = 200,
	visible = true,

    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
    },

	ShopItemImage = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "TopRight",
		image = "Gold_5bars.png",
		alignmentOffset = {-6-46,0+46},
		--scripts = {"SparkleRandomly_ShopItem"},

		QuantityLabel = Resources.ScoreCounter:new {
			resource = "ScoreCounter",

			alignment = "BottomRight",
			alignTo = "BottomRight",
			alignmentOffset = {-10,-10},

			useCurrency = false,
            useComma = true,
			score = 0,
			visible = false,

			labelProperties = {
				resource = "Label",
				fgColor = "Black",
				font	= Resources.AppGameFont:new{
					resource = "AppGameFont",
					fontSize = 18,
				},
				widthLimit = 22,
            },

			QuantityLabel_background = Resources.Actor:new {
				image = "NumberMarker.png",
				alignment = "Center",
				alignTo = "Center",
				zorder = -1,
			},
		},
	},

	ShopItemName = Resources.AppTitleDialogLabel_smaller:new {
		resource = "AppTitleDialogLabel_smaller",
		text = STRINGS("ShopItemName"),
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {10,6},
        widthLimit = 170,
	},

	ShopItemDescription = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("This powerup does something cool!"),
		alignmentOffset = {10,12},
		alignment = "MidLeft",
		alignTo = "MidLeft",
		wrapLimit = 180,
		textAlignment = "Left",
        --widthLimit = 180,
        heightLimit = 60,
	},

	ShopItemQuantity = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("No Message Title"),
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,0},
		visible = false,
	},

    -- Main Shop CTA Button

	PriceButton = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
		image = "ButtonPlastic_Small_Green.png",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignTo = BottomRight,
		alignmentOffset = {-10,-10},
		text = STRINGS("$0.99"),
            font = Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 25,
            },
		clickSound = "coin_magic_03.ogg",
        textWidthLimit = 65,
        zorder = 2,

        SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			extraScale = 0.8,
			alignment = Center,
			alignTo = MidBottom,
			alignmentOffset = {-62, -8},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
			localizedLabel = {
				class = "override",
                font = Resources.MapButtonFont:new{
                    resource = "MapButtonFont",
                    fontSize = 25,
                },
			},
		},
	},
            ButtonBevel = Resources.Actor:new {
            resource = "Actor",
            image = "ButtonPlastic_Small_WoodOutline.png",
            alignment = BottomRight,
            alignTo = BottomRight,
            alignmentOffset = {-10,-10},
            zorder = 1,
        },

}

Scripts.Preshow_ShopItemProductView = function(view,price,ShopItemAmount,productName,descriptionText,productFullName,isSale)

	--logprint("Preshow_ShopItemProductView "..view.name.." "..productName.." "..price.." "..PowerupDialogImages[productName].." Quantity="..ShopItemAmount)

	local ShopItemImage = view:FindChild("ShopItemImage",true)
	ShopItemImage.image = PowerupDialogImages[productName]

	local ShopItemQuantity = view:FindChild("ShopItemQuantity",true)
	ShopItemQuantity.text = Int2Comma(ShopItemAmount)

	local ShopItemName = view:FindChild("ShopItemName",true)
	ShopItemName.text = productFullName

	local ShopItemDescription = view:FindChild("ShopItemDescription",true)
	ShopItemDescription.text = descriptionText

	local PriceButton = view:FindChild("PriceButton",true)
	PriceButton.text = price
	view.name = productName
	--logprint(view.name)

	local saleTag = view:FindChild("SaleTag",true)
	if(isSale)then
		if(saleTag) then
			saleTag.visible = true
		end
	else
		if(saleTag) then
			saleTag.visible = false
		end
	end
end

Scripts.Preshow_ShopDialog = function(dialog,gold)
	--logprint("Preshow_ShopDialog ShopItem: "..gold)
end

Scripts.Present_ShopDialog = function(dialog,gold)
	for i = 1,Config.NumberOfShopItemProducts do
		local configName = "ShopItemProduct"..i
		--logprint(configName)
		local productName = Config[configName]
		--logprint(productName)
		local ShopItemProductView = dialog:FindChild(productName,true)
		if(ShopItemProductView)then
			local ShopItemImage = ShopItemProductView:FindChild("ShopItemImage",true)
			if(ShopItemImage)then
				FireParticle(ShopItemImage,"GoldSparkle1","Center",ShopItemProductView.hgeParticles)
				ScriptDelay(math.random(30,1000),"DialogTimers")
			end
		end
	end
end

Resources.ShopDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "ShopDialog",
	name = "ShopDialog",
    title = "",
	enableVisibleUnderlay = true,

	introScriptName = "SlideUpDialog_TopBar",
	dialogExitScriptName = "RaiseDownDialog_TopBar",

    titleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Cascade Shop"),
		alignment = MidTop,
		alignmentOffset = {-15, 10},
		widthLimit = 250,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
		DisplayDimensions = {313, 416-headerOffset},
		horizontalScrollLocked = true,
		alignment = "MidRight",
		alignmentOffset = {-5,15},
		SlowFraction = .95,
		stoppingVelocity = 1,
	},

	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
		visible = false,
	},
}

---------------
-- News Feed --
---------------

Resources.NewsDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "NewsDialog",
	name = "NewsDialog",
    title = "",
	enableVisibleUnderlay = true,

	introScriptName = "SlideUpDialog_TopBar",
	dialogExitScriptName = "RaiseDownDialog_TopBar",

    titleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Cascade Today"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
        widthLimit = 220,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
		DisplayDimensions = {313, 416-headerOffset},
		horizontalScrollLocked = true,
		alignment = "MidRight",
		alignmentOffset = {-5,15},
		SlowFraction = .95,
		stoppingVelocity = 1,
	},

	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
		visible = false,
	},
}

Resources.NewsItem_UnreadIcon = Resources.Actor:new {
    resource = "Actor",
    image = "NewsFeedUnreadBubble.png",
    alignment = "TopLeft",
    alignmentOffset = {6,6-2},
    size = {10,10},
    zorder = 1,
}

Resources.NewsItem = Resources.Actor:new {
	resource = "Actor",
	image = "Dialog_Banner_Large.png",

	imageSprite = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "TopRight",
        alignmentOffset = {-8-46,6+42},
		--width_KeepAspectRatio = 80,
		--size = {80,80},
        --resizeOnSetImage = false,
	},

	titleLabel = Resources.AppTitleDialogLabel_smaller:new {
		resource = "AppTitleDialogLabel_smaller",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {16,6},
        --wrapLimit = 180-16,
        heightLimit = 50,
		widthLimit = 164,
	},

	descriptionLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		alignmentOffset = {10,12},
		alignment = "MidLeft",
		alignTo = "MidLeft",
		wrapLimit = 175,
		textAlignment = "Left",
        heightLimit = 65,
	},
--Main Action Button to Today Dialog

	actionButton = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
		image = "ButtonPlastic_Small_Green.png",
		buttonClosesDialog = true,
		alignment = BottomRight,
		alignTo = BottomRight,
		alignmentOffset = {-10,-10},
        textWidthLimit = 70,
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 20,
        },
        zorder = 2,

	},

    ButtonBevel = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Small_WoodOutline.png",
		alignment = BottomRight,
		alignTo = BottomRight,
		alignmentOffset = {-10,-10},
        zorder = 1,
    },

    dismissButton = Resources.DialogSmallButton:new {
		resource = "DialogSmallButton",
		image = "Btn_Exit_smaller.png",
		buttonClosesDialog = false,
		alignment = TopRight,
		alignTo = TopRight,
		alignmentOffset = {0,0},
        uid = "",
		zorder = 1,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            NF_MGR:HideFeedItem(self.uid,true)
            return true
        end,
	},

}

Resources.QuickQuestRewardsNode = Resources.Actor:new {

    bkg = Resources.Actor:new {

        descriptionLabel = Resources.AppDialogLabel:new {
            resource = "AppDialogLabel",
            alignment = MidTop,
            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 24,
            },
            textAlignment = "Center",
            alignmentOffset = {0,5},
            shadowColor = "White",
            --shadowOffset = {1,1},
            text = STRINGS("Prizes"),

        },

        resource = "Actor",
        image = "Canvas_Small.png",
        alignment = "Center",
    },

    layout = Resources.LayoutBox:new {
        resource = "LayoutBox",
        margin = 10,
        isVertical = false,

        OnPostSpawn = function(self)
            local numRewards = QQ_MGR:GetNumRewardsToDisplay() - 1
            for i = 0,numRewards do
                local rewardName = QQ_MGR:GetRewardNameForIndex(i)
                local rewardImageName = PowerupDialogImages[rewardName]
                local rewardAmount = QQ_MGR:GetRewardAmountAsStringForIndex(i)

                local rewardResource = Resources.Actor:new {
                    resource = "Actor",
                    image = rewardImageName,
                    extraScale = 0.85,

                    amountBadge = Resources.Actor:new {
                        image = "NumberMarker.png",
                        alignment = Center,
                        alignmentOffset = {32,22},
                        extraScale = 1.5,

                        amountLabel = Resources.AppDialogLabel:new {
                            resource = "AppDialogLabel",
                            alignment = Center,
                            font = Resources.DialogBoldFont:new{
                                resource = "DialogBoldFont",
                                fontSize = 24,
                            },
                            widthLimit = 20,
                            heightLimit = 20,
                            text = rewardAmount,
                        },

                    },

                }

                self:AddChild(CreateInstance(rewardResource))
            end
        end,
    },
}

Resources.NewsItem_QuickQuest = Resources.NewsItem:new {
    resource = "NewsItem",

    OnPostSpawn = function (self)

        local diff = 10
        self.descriptionLabel.heightLimit = self.descriptionLabel.heightLimit + diff
        self.size = {self.size.x,self.size.y + diff}
        self.descriptionLabel.alignmentOffset = {10,-10}

        local imageSpriteChild = Resources.Actor:new {
            resource = "Actor",
            image = QQ_MGR:GetImagePath(false,0.75),
            alignment = Center,
            --extraScale = 0.75,
            scalingPoint = MidTop,
        }
        self.imageSprite:AddChild(CreateInstance(imageSpriteChild))
        self.titleLabel.text = STRINGS("Quick Quest")
		local numLevelsTotal = QQ_MGR:GetNumLevelsTotal()
        local grailSingularOrPlural = STRINGS("gold cups")
        if (numLevelsTotal == 1) then
            grailSingularOrPlural = STRINGS("gold cup")
        end
        local descriptionText = string.format(STRINGS("QuickQuestDescriptionFMT3"),numLevelsTotal,grailSingularOrPlural);
        self.descriptionLabel.text = descriptionText
		self.descriptionLabel.heightLimit = 70
		self.descriptionLabel.alignmentOffset = {12,-10}
        self.actionButton.action = "Play Random Quick Quest Level"
        self.actionButton.text = STRINGS("Play")

        local timeRemaining = Resources.Actor:new {
            size = {88,30},
            alignment = Center,
            alignmentOffset = {0,32},

            timeRemainingLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = Center,
				widthLimit = 75,
                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 22,
                },
                textColor = "Cascade_DarkBrown",
				widthLimit = 80,

                Tick = function(self)
                    self.text = QQ_MGR:GetTimeRemainingAsString()
                end,
            },
        }

        self.imageSprite:AddChild(CreateInstance(timeRemaining))

        self.rewardsNode = Resources.QuickQuestRewardsNode:new {
            extraScale = 0.55,
            resource = "QuickQuestRewardsNode",
            alignment = self.descriptionLabel.alignment,
            alignmentOffset = {self.descriptionLabel.alignmentOffset.x+73,self.descriptionLabel.alignmentOffset.y+60},
            OnPostSpawn = function(self)
                self.bkg.image = ""
                self.bkg.descriptionLabel.text = ""
            end,
        }

	end,
}

Resources.NewsItem_PlayLevel_StarPanel = Resources.Actor:new {
	--resource = "Actor",
	color = "White",
	alpha = 0,
	size = {dialogWidth,130},
	--alignment = MidTop,
	--alignTo = MidTop,
	--alignmentOffset = {0,0},
	--zorder = 2,
	resizeOnSetImage = false,

	StarGoal1 = Resources.StarGoal:new {
		resource = "StarGoal",
		Text = {class="Label",text = STRINGS("50,000")},
		alignmentOffset = {0+(startQuestGameStarGoalX_offset*-1),startQuestGameStarGoalY+(startQuestGameStarGoalY_offset*0)},

		Star = {
			class = "Button",
			Worker = Resources.StarWorker:new {
				resource = "StarWorker",
			},
            QuickQuestPiece = Resources.StarQuickQuestPiece:new {
                resource = "StarQuickQuestPiece",
            },
		},
		Gold = Resources.StarGold:new {
			resource = "StarGold",
			image = "Gold_1bar.png",
            scripts = {"SparkleLoop"},
		},
	},
	StarGoal2 = Resources.StarGoal:new {
		resource = "StarGoal",
		Text = {class="Label",text = STRINGS("75,000")},
		alignmentOffset = {0+(startQuestGameStarGoalX_offset*0)+1,startQuestGameStarGoalY+(startQuestGameStarGoalY_offset*1)},

		Star = {
			class = "Button",
			Worker = Resources.StarWorker:new {
				resource = "StarWorker",
			},
            QuickQuestPiece = Resources.StarQuickQuestPiece:new {
                resource = "StarQuickQuestPiece",
            },
		},
		Gold = Resources.StarGold:new {
			resource = "StarGold",
			image = "Gold_3bars.png",
            scripts = {"SparkleLoop"},
		},
	},
	StarGoal3 = Resources.StarGoal:new {
		resource = "StarGoal",
		Text = {class="Label",text = STRINGS("100,000")},
		alignmentOffset = {0+(startQuestGameStarGoalX_offset*1),startQuestGameStarGoalY+(startQuestGameStarGoalY_offset*0)},

		Star = {
			class = "Button",
			Worker = Resources.StarWorker:new {
				resource = "StarWorker",
			},
            QuickQuestPiece = Resources.StarQuickQuestPiece:new {
                resource = "StarQuickQuestPiece",
            },
		},
		Gold = Resources.StarGold:new {
			resource = "StarGold",
			image = "Gold_5bars.png",
            scripts = {"SparkleLoop"},
		},
	},

}

Resources.NewsItem_PlayLevel = Resources.Actor:new {
	resource = "NewsItem",

	rewardsNode = Resources.NewsItem_PlayLevel_StarPanel:new {
		resource = "NewsItem_PlayLevel_StarPanel",
		extraScale = 0.55,
		OnPostSpawn = function(self)
			self.StarGoal1.Star.active = false
			self.StarGoal2.Star.active = false
			self.StarGoal3.Star.active = false
			self.StarGoal1.Star.image = "StarBig_off.png" --"StarBig_achieved.png"
			self.StarGoal2.Star.image = "StarBig_off.png" --"StarBig_achieved.png"
			self.StarGoal3.Star.image = "StarBig_off.png" --"StarBig_achieved.png"
			self.StarGoal1.Gold.visible = true
			self.StarGoal2.Gold.visible = true
			self.StarGoal3.Gold.visible = true
		end,
	},

	OnPostSpawn = function (self)
        local diff = 20
        self.descriptionLabel.heightLimit = self.descriptionLabel.heightLimit + diff
        self.size = {self.size.x,self.size.y + diff}
        self.descriptionLabel.alignmentOffset = {10,-15}

        self.rewardsNode = {
			class = "Actor",
            alignment = self.descriptionLabel.alignment,
            alignmentOffset = {self.descriptionLabel.alignmentOffset.x-70,self.descriptionLabel.alignmentOffset.y+60},
        }
	end,
}

Resources.NewsItem_WelcomePack = Resources.NewsItem:new {
    resource = "NewsItem",

    OnPostSpawn = function (self)

        self.imageSprite.image = "Welcome_Pack.png"
        self.descriptionLabel.text = STRINGS("WelcomePackNewsFeedDescription")
        self.titleLabel.text = WP_MGR:GetTitleText()
        self.actionButton.action = "Welcome Pack"
        self.actionButton.text = STRINGS("View")

        local timeRemaining = Resources.Actor:new {
            size = {88,30},
            alignment = Center,
            alignmentOffset = {0,32},

            timeRemainingLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = Center,
                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 22,
                },
                textColor = "Cascade_DarkBrown",

                Tick = function(self)
                    self.text = WP_MGR:GetTimeRemainingText()
                end,
            },
        }

        self.imageSprite:AddChild(CreateInstance(timeRemaining))

	end,
}

Resources.NewsItem_GiftPack = Resources.NewsItem:new {
    resource = "NewsItem",

    OnPostSpawn = function (self)

        self.imageSprite.image = "Gift_Pack_Yellow.png"
        self.descriptionLabel.text = STRINGS("GiftPackNewsFeedDescription")
        self.titleLabel.text = STRINGS("Power Pack")
        self.actionButton.action = "Gift Pack"
        self.actionButton.text = STRINGS("View")

        local timeRemaining = Resources.Actor:new {
            size = {88,30},
            alignment = Center,
            alignmentOffset = {0,32},

            timeRemainingLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = Center,
                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 22,
                },
                textColor = "Cascade_DarkBrown",

                Tick = function(self)
                    self.text = GP_MGR:GetTimeRemainingText()
                end,
            },
        }

        self.imageSprite:AddChild(CreateInstance(timeRemaining))

	end,
}

Resources.NewsItem_OfferPack = Resources.NewsItem:new {
    resource = "NewsItem",

    OnPostSpawn = function(self)
        self.imageSprite.image = OP_MGR:GetButtonImage()
        self.descriptionLabel.text = STRINGS("GiftPackNewsFeedDescription")
        self.titleLabel.text = STRINGS(OP_MGR:GetTitleText())
        self.actionButton.action = "Offer Pack"
        self.actionButton.text = STRINGS("View")

        local timeRemaining = Resources.Actor:new {
            size = {88, 30},
            alignment = Center,
            alignmentOffset = {0, 32},

            timeRemainingLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = Center,

                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 22,
                },

                textColor = "Cascade_DarkBrown",
				widthLimit = 77,

                Tick = function(self)
                    self.text = OP_MGR:GetTimeRemainingText()
                end,
            },
        }

        self.imageSprite:AddChild(CreateInstance(timeRemaining))
    end,
}

Resources.NewsItem_DailyChallengePlay = Resources.NewsItem:new {
    resource = "NewsItem",

    OnPostSpawn = function (self)
        self.imageSprite.image = "Medal_big_gold.png"
        self.titleLabel.text = STRINGS("Daily Challenge")
        self.descriptionLabel.text = GetDailyChallengeDescriptionText()
        self.actionButton.action = "Daily Challenge"
        self.actionButton.text = STRINGS("Play")
	end,
}

Resources.NewsItem_DailyChallengeResults = Resources.NewsItem:new {
    resource = "NewsItem",

    OnPostSpawn = function (self)
        self.imageSprite.image = "Medal_big_gold.png"
        self.titleLabel.text = STRINGS("Challenge Results")
        self.descriptionLabel.text = STRINGS("Here are the results from yesterday's Daily Challenge. Did you win?")
        self.actionButton.action = "Challenge Results"
        self.actionButton.text = STRINGS("View")
	end,
}

Resources.NewsItem_DailyDeal = Resources.Actor:new {
    resource = "NewsItem",

    bundleTag = Resources.Actor:new {
        resource = "Actor",
        image = "SaleTag_BLANK_02.png",
        alignment = "TopRight",
        alignmentOffset = {-12,22},

        scripts = {"SaleTag_Lights"},
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3,-1},
            showHighlight = false,
            font	= Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 20,
            },
            text = STRINGS("Sale!"),
            rotationAngle = { degrees = -10 },
			widthLimit = 55,
        },
    },

    OnPostSpawn = function (self)
        self.titleLabel.text = STRINGS("Daily Deal")
        self.descriptionLabel.text = GetDailyDealDescriptionText()
        self.actionButton.action = "Daily Deal"
        self.actionButton.text = STRINGS("Get")
	end,
}

Resources.NewsItem_FriendsStuck = Resources.Actor:new {
    resource = "NewsItem",

    OnPostSpawn = function (self)
        self.imageSprite.image = "HelpFriendIcon.png"
        self.titleLabel.text = STRINGS("Help Friends")
        self.descriptionLabel.text = STRINGS("Help out your friends!")
        self.actionButton.action = "Friends Stuck"
        self.actionButton.text = STRINGS("Help")
	end,
}

Resources.NewsItem_LabEvent = Resources.NewsItem:new {
    resource = "NewsItem",

	imageSprite = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "TopRight",
        alignmentOffset = {-8-46, 42},

		rankPanel = Resources.Actor:new {
			resource = "Actor",
			image = "WhiteButton_small.png",
			alignment = Center,
			alignmentOffset = {0, 0},
			extraScale = 0.70,

			rankLabel = Resources.AppDialogLabel:new {
				resource = "AppDialogLabel",
				alignment = Center,
				alignmentOffset = {-2, -2},
				widthLimit = 72,
				textColor = "Cascade_DarkBrown",

				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontSize = 22,
				},
			},
		},
	},

    OnPostSpawn = function(self)
        self.imageSprite.image = LAB_EVENT_MGR:GetIconImage()
		self.imageSprite.rankPanel.rankLabel.text = LAB_EVENT_MGR:GetRankText()
        self.descriptionLabel.text = LAB_EVENT_MGR:GetNFDescriptionText()
        self.titleLabel.text = STRINGS("LEVEL LAB!");
        self.actionButton.action = "Play Lab Event"
        self.actionButton.text = STRINGS("Play")

        local timeRemaining = Resources.Actor:new {
            size = {88, 30},
            alignment = Center,
            alignmentOffset = {0, 38},

            timeRemainingLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = Center,
				textColor = "Cascade_DarkBrown",

                font = Resources.DialogBoldFont:new {
                    resource = "DialogBoldFont",
                    fontSize = 22,
                },

                Tick = function(self)
                    self.text = LAB_EVENT_MGR:GetTimeRemainingText(false)
                end,
            },
        }

        self.imageSprite:AddChild(CreateInstance(timeRemaining))
    end,
}

-------------------------
-- Daily Spin Redirect --
-------------------------

Resources.DailySpinRedirectDialog = Resources.LargeLongerDialog:new {
    resource = "LargeLongerDialog",
    name = "DailySpinRedirectDialog",

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

    TextLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("The Daily Spin has been moved into the new Today menu!"),
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,168},
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 22,
		},
	},

    OkayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
        image = "ButtonPlastic_Small_Green.png",
		alignment = Bottom,
        alignmentOffset = {0,-48},
		text = STRINGS("Let's go!"),
	},
}

----------------
-- Daily Deal --
----------------

Resources.DailyDealDialog = Resources.LargeLongerDialog:new {
	class = "BuyPowerupDialog",
	resource = "LargeLongerDialog",
    name = "DailyDealDialog",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

	topTitleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Daily Deal"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
        widthLimit = 160,
    },

	text = Resources.AppDialogDataLabel:new {
		resource = "AppDialogDataLabel",
		text = STRINGS("Welcome to the Cascade Store!"),
		alignment = "MidTop",
		alignmentOffset = {0,75},
		visible = false,
	},

	StorePanel = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "MidTop",
		alignmentOffset = {2,190},
		visible = true,
		size = {588/2,(577/2)-headerOffset+10},
		--color = "White",
		--size = {280,275},
		--zorder = 0,
		--alpha = 100,
		image = "Canvas_Large.png",

        PowerupImage = Resources.Actor:new {
            image = "Boost_SpinSaver.png",
            alignment = Center,
            alignTo = Center,
            alignmentOffset = {-75,0},
            zorder = 1,
            quantitySaleProperties = {
                alignmentOffset = {-60,0},
            },
            PurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
                resource = "AppTitleDialogLabel",
                text = STRINGS("test text"),
                alignment = MidLeft,
                alignTo = MidRight,
                alignmentOffset = {0,0},
                wrapLimit = 250,
                fgColor = "Cascade_Canvas_Red",
                CrossOut = Resources.AppTitleDialogLabel:new {
                    resource = "AppTitleDialogLabel",
                    text = STRINGS("/"),
                    alignment = Center,
                    alignTo = Center,
                    alignmentOffset = {0,0},
                    visible = false,
                    zorder = 10,
                    shadowAlpha = 0,
                    highlightAlpha = 0,
                    alpha = 200,
                    extraScale = {1.5,1.2},
                    rotationAngle = {degrees = 15,},
                },
            },

            SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_bigger:new {
                resource = "AppTitleDialogLabel_bigger",
                text = STRINGS(""),
                alignment = MidLeft,
                alignTo = MidRight,
                alignmentOffset = {60,0},
                wrapLimit = 250,
                visible = false,
                fgColor = "Cascade_Canvas_Red",
                rotationAngle = {degrees = 5,},
            },

            SaleTag = Resources.SaleTag:new {
                resource = "SaleTag",
                visible = true,
                alignment = MidRight,
                alignTo = Center,
                alignmentOffset = {-10,10},
            },

            scripts = {"DialogButtonGroove"},
        },

        TextLabel = Resources.TextLabel:new {
            resource = "TextLabel",
            text = STRINGS("This powerup does something cool!"),
            alignment = Center,
            alignmentOffset = {0,222-38},
            heightLimit = 50,
            zorder = 1,
        },

        titleText = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("Today's Deal"),
            alignment = Center,
            alignmentOffset = {0, -85},
            widthLimit = 160,
            zorder = 1,
            fgColor = "Cascade_Canvas_Blue",
        },

	},
--[[
    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Today's Deal"),
		alignment = Center,
		alignmentOffset = {0, 215-16-10},
		widthLimit = 160,
		zorder = 1,
		fgColor = "Cascade_Canvas_Blue",
    },
--]]

	BundleItemsTag = Resources.BundleItemsTag:new {
		resource = "BundleItemsTag",
		alignment = Center,
		alignmentOffset = {85, -30},
		zorder = 5,
        rotationAngle = {degrees = 25,},
		zorder = 1,
	},

--[[
	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {-75,60},
		zorder = 1,
		quantitySaleProperties = {
			alignmentOffset = {-60,60-8},
		},
        PurchaseQuantityLabel = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("test text"),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {0,0},
            wrapLimit = 250,
			fgColor = "Cascade_Canvas_Red",
			CrossOut = Resources.AppTitleDialogLabel:new {
				resource = "AppTitleDialogLabel",
				text = STRINGS("/"),
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {0,0},
				visible = false,
				zorder = 10,
				shadowAlpha = 0,
				highlightAlpha = 0,
				alpha = 200,
				extraScale = {1.5,1.2},
				rotationAngle = {degrees = 15,},
			},
        },

        SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_bigger:new {
            resource = "AppTitleDialogLabel_bigger",
            text = STRINGS(""),
            alignment = MidLeft,
            alignTo = MidRight,
            alignmentOffset = {60,0},
            wrapLimit = 250,
            visible = false,
			fgColor = "Cascade_Canvas_Red",
			rotationAngle = {degrees = 5,},
        },

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			visible = true,
			alignment = MidRight,
			alignTo = Center,
			alignmentOffset = {-10,10},
		},

		scripts = {"DialogButtonGroove"},
	},

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("This powerup does something cool!"),
        alignment = Center,
		alignmentOffset = {0,365-38},
		heightLimit = 50,
		zorder = 1,
	},
--]]

	ProgressLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Using Gold..."),
		alignment = Center,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-45-38+20},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
		zorder = 1,
	},

	CancelledLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no money was spent."),
		alignment = Center,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-45-38+18},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 18,
		},
		wrapLimit = 250,
		visible = false,
		zorder = 1,
	},

	CancelledLabel_Gold = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no gold was spent."),
		alignment = Center,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-45-38+18},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 18,
		},
		wrapLimit = 250,
		visible = false,
		zorder = 1,
        heightLimit = 40,
	},

	PriceButton = Resources.PriceButton:new {
		resource = "PriceButton",
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-32+22},
		text = STRINGS("$0.99"),
		zorder = 2,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Scripts.Preshow_ClaimDialog = function(dialog, stats)
	local screen = dialog.screen
	local topBar = screen:FindChild("TopBar_SpecialGems",true)
	local gemIndex = 1
    local gemCount = 0

	if(Config.Map_ShowAllSpecialGems or Config.Map_ShowSpecialGemsWhenEncountered) then
		--Set up dialog gem counts
		for gemName, amount in pairs(stats.newSpecialGems) do
			local gemImage = "Gem" .. gemName .. ".png"

			local gemTypeContainer = dialog["GemTypeContainer" .. gemIndex]
			gemTypeContainer.GemTypeImage.image = gemImage

			local difference = amount - stats.oldSpecialGems[gemName]

			local quantityLabel = dialog["QuantityLabel" .. gemIndex]
			quantityLabel:SetScore(difference,true)
			quantityLabel.newQuantity = amount
			quantityLabel.visible = true

			gemIndex = gemIndex + 1
            gemCount = gemCount + 1
		end

		--Hide unused dialog gem counts
		for hideIndex = gemIndex, 3 do
			local gemTypeContainer = dialog["GemTypeContainer" .. hideIndex]
			gemTypeContainer.visible = false
			local quantityLabel = dialog["QuantityLabel" .. gemIndex]
			quantityLabel.visible = false
		end

		gemIndex = 1
		--Set up topbar gem counts
		local allGemTypes = {"SpecialRed","SpecialBlue","SpecialGreen"}
		for unused,gemName in pairs(allGemTypes) do
			local gemImage = "Gem" .. gemName .. ".png"
			local specialGemButton = topBar["SpecialGemButton" .. gemIndex]
			specialGemButton.GemTypeContainer.GemTypeImage.image = gemImage
			specialGemButton.visible = true
			if(stats.oldSpecialGems[gemName] ~= nil) then
				specialGemButton.NewMarker:SetScore(stats.oldSpecialGems[gemName],true)
			else
				specialGemButton.NewMarker:SetScore(stats.allSpecialGems[gemName],true)
			end
			if(Config.Map_ShowSpecialGemsWhenEncountered and not HasSeen("SpecialGems",gemName)) then
				specialGemButton.visible = false
			end

			gemIndex = gemIndex + 1
		end
	else
		for gemName, amount in pairs(stats.newSpecialGems) do
			local gemImage = "Gem" .. gemName .. ".png"
			local specialGemButton = topBar["SpecialGemButton" .. gemIndex]
			specialGemButton.GemTypeContainer.GemTypeImage.image = gemImage

			local gemTypeContainer = dialog["GemTypeContainer" .. gemIndex]
			gemTypeContainer.GemTypeImage.image = gemImage
			specialGemButton.visible = true
			specialGemButton.NewMarker:SetScore(stats.oldSpecialGems[gemName],true)

			local difference = amount - stats.oldSpecialGems[gemName]

			local quantityLabel = dialog["QuantityLabel" .. gemIndex]
			quantityLabel:SetScore(difference,false) --STRINGS("X") .. " " .. Int2Comma(difference)
			quantityLabel.newQuantity = amount
			quantityLabel.visible = true

			gemIndex = gemIndex + 1
            gemCount = gemCount + 1
		end

		--Hide excess gem types in dialog and topbar
		for hideIndex = gemIndex, 3 do
			local specialGemButton = topBar["SpecialGemButton" .. hideIndex]
			specialGemButton.visible = false
			local gemTypeContainer = dialog["GemTypeContainer" .. hideIndex]
			gemTypeContainer.visible = false
			local quantityLabel = dialog["QuantityLabel" .. gemIndex]
			quantityLabel.visible = false
		end
	end

    --determine worker Y
    local workerY = LargeLong_Dialog_Button_Y-70
    if(gemCount == 0) then
        workerY = LargeLong_Dialog_Button_Y-165
    elseif(gemCount < 3) then
        workerY = LargeLong_Dialog_Button_Y-100
    end

    --place workers
    local workers = stats.workers
	if(#workers > 0) then
		for workerIndex = 1,#workers do
			local actorName = "Worker" .. workerIndex
			local workerActor = dialog[actorName]
			workerActor.visible = true
			workerActor.image = workers[workerIndex]
			workerActor.SuperMatchGemDecoration = Resources.SuperMatchGemDecoration
            workerActor.alignmentOffset = {workerActor.alignmentOffset.x, workerY}

            if(gemCount == 0) then
                workerActor.extraScale = 2.0
            end
		end
	end
end

--Claim Dialog

Resources.ClaimDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	image = "DialogGeneric_Small.png",
	title = "",
    alignmentOffset = Layout{{0,50},android={0,0}},

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-5},
        size = {250,200},
    },


	introScriptName = "DropDialog_TopBar_SpecialGems",
	dialogExitScriptName = "RaiseDialog_TopBar_SpecialGems",

    titleText = Resources.AppTitleDialogLabel:new {
        resource = "AppTitleDialogLabel",
        text = STRINGS("Found!"),
		alignment = MidTop,
		alignmentOffset = {0,30},
        zorder = 1,

    },

	GemTypeContainer1 = Resources.Actor:new {
		resource = "Actor",
		alpha = 0,
		alignment = MidLeft,
		alignmentOffset = {86, -75},
		size = {50,50},
		GemTypeImage = Resources.Actor:new {
			resource = "Actor",
			image = "GemSpecialGreen.png",
			alignment = Center,
			autoFillParent = true,
        zorder = 1,

		},
	},


	QuantityLabel1 = Resources.ScoreCounter:new {
		resource = "ScoreCounter",
        zorder = 1,

		alignment = MidLeft,
        alignmentOffset = {160,-75},

		useCurrency = false,
        useComma = true,
		score = 0,

		labelProperties = {
			resource = "AppTitleDialogLabel",
			wrapLimit = 250,
        },

		visible = false,
	},

	GemTypeContainer2 = Resources.Actor:new {
		resource = "Actor",
        zorder = 1,
		alpha = 0,
		alignment = MidLeft,
		alignmentOffset = {86, -20},
		size = {50,50},
		GemTypeImage = Resources.Actor:new {
			resource = "Actor",
			image = "GemSpecialGreen.png",
			alignment = Center,
			autoFillParent = true,
		},
	},

	QuantityLabel2 = Resources.ScoreCounter:new {
		resource = "ScoreCounter",
        zorder = 1,

        alignment = MidLeft,
        alignmentOffset = {160,-20},

		useCurrency = false,
        useComma = true,
		score = 0,

		labelProperties = {
			resource = "AppTitleDialogLabel",
			wrapLimit = 250,
        },

		visible = false,
	},

	GemTypeContainer3 = Resources.Actor:new {
		resource = "Actor",
        zorder = 1,

		alpha = 0,
		alignment = MidLeft,
		alignmentOffset = {86, 35},
		size = {50,50},
		GemTypeImage = Resources.Actor:new {
			resource = "Actor",
			image = "GemSpecialGreen.png",
			alignment = Center,
			autoFillParent = true,
		},
	},

	QuantityLabel3 = Resources.ScoreCounter:new {
		resource = "ScoreCounter",
        zorder = 1,

        alignment = MidLeft,
        alignmentOffset = {160,35},

		useCurrency = false,
        useComma = true,
		score = 0,

		labelProperties = {
			resource = "AppTitleDialogLabel",
			wrapLimit = 250,
        },

		visible = false,
	},

	Worker1 = Resources.Actor:new {
		resource = "Actor",
        zorder = 1,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-70},
		visible = false,
		zorder = 5,
		size = {40,40},
		resizeOnSetImage = false,
	},
	Worker2 = Resources.Actor:new {
		resource = "Actor",
        zorder = 1,
		alignment = MidBottom,
		alignmentOffset = {-50,LargeLong_Dialog_Button_Y-70},
		visible = false,
		zorder = 5,
		size = {40,40},
		resizeOnSetImage = false,
	},
	Worker3 = Resources.Actor:new {
		resource = "Actor",
        zorder = 1,
		alignment = MidBottom,
		alignmentOffset = {50,LargeLong_Dialog_Button_Y-70},
		visible = false,
		zorder = 5,
		size = {40,40},
		resizeOnSetImage = false,
	},

	claimButton = Resources.BigDialogButton:new {
		resource = "BigDialogButton",
        zorder = 1,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-10},
		text = STRINGS("Claim"),
        textColor = "Cascade_BrightYellow",
        textHighlightColor = "Cascade_DarkGreen",
        textHighlightAlpha = 255,
        textShadowColor = "Cascade_DarkGreen",
        textShadowOffset = {1, 2},
		enterKey = true,
		escapeKey = true,
		shortcutKey = "c",
		image = "ButtonPlastic_Longer_Green.png",
		clickSound = "coin_magic_05.ogg",

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end

			self.parent:AddScript("DoClaim","DoClaim")
			self.visible = false
			return true
		end,
		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},
}

Scripts.DoClaim = function(dialog)
	local goldAnimationSpeed = 250
	local screen = dialog.screen
	local topBar = screen:FindChild("TopBar_SpecialGems",true)
	PlaySound("slot_machine_win_19.ogg")
	if(Config.Map_ShowAllSpecialGems or Config.Map_ShowSpecialGemsWhenEncountered) then
		for gemIndex = 1,3 do
			--Fly the main icon up to the topbar
			local specialGemButton
			local gemTypeContainer = dialog["GemTypeContainer" .. gemIndex]
			for topBarIndex = 1,3 do
				--Find which topbar button corresponds to this gem type
				specialGemButton = topBar["SpecialGemButton" .. topBarIndex]
				if(specialGemButton.GemTypeContainer.GemTypeImage.image == gemTypeContainer.GemTypeImage.image) then
					break
				end
			end
			local quantityLabel = dialog["QuantityLabel" .. gemIndex]
			if(IsNumber(quantityLabel.newQuantity)) then
				local specialDestination = specialGemButton.globalPosition
				specialDestination.x = specialDestination.x + specialGemButton.size.x/2 - gemTypeContainer.size.x/2
				specialDestination.y = specialDestination.y + specialGemButton.size.y/2 - gemTypeContainer.size.y/2

				local trail = AddTrail_dialog(gemTypeContainer,"GoldSparkleTrail1")

				PlaySound("coin_magic_03.ogg")
				PlaySound("swish05.ogg")
				gemTypeContainer.layer = 2020
				quantityLabel:SetScore(0,false)
				ScaleOut(quantityLabel,{0.0,0.0},goldAnimationSpeed,false)
				ScaleOut(gemTypeContainer,{0.25,0.25},goldAnimationSpeed,false)
				Scripts.Interpolate(gemTypeContainer, "globalPosition", specialDestination, goldAnimationSpeed)
				specialGemButton.NewMarker:SetScore(quantityLabel.newQuantity,false)
				gemTypeContainer.GemTypeImage.alpha = 0  -- so the actor disappears but the particle child trail is still visible
				PlaySound("coin_magic_06.ogg")
				FireParticle(specialGemButton.NewMarker,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
				trail:Pause()
				topBar:AddScript("Animate_UpAndDown","")
				CorrectedPop(specialGemButton.NewMarker)
			end
		end
	else
		for gemIndex = 1,3 do
			--Fly the main icon up to the topbar
			local specialGemButton = topBar["SpecialGemButton" .. gemIndex]
			local gemTypeContainer = dialog["GemTypeContainer" .. gemIndex]
			local quantityLabel = dialog["QuantityLabel" .. gemIndex]
			if(IsNumber(quantityLabel.newQuantity)) then
				local specialDestination = specialGemButton.globalPosition
				specialDestination.x = specialDestination.x + specialGemButton.size.x/2 - gemTypeContainer.size.x/2
				specialDestination.y = specialDestination.y + specialGemButton.size.y/2 - gemTypeContainer.size.y/2

				local trail = AddTrail_dialog(gemTypeContainer,"GoldSparkleTrail1")

				PlaySound("coin_magic_03.ogg")
				PlaySound("swish05.ogg")
				gemTypeContainer.layer = 2020
				quantityLabel:SetScore(0,false)
				ScaleOut(quantityLabel,{0.0,0.0},goldAnimationSpeed,false)
				ScaleOut(gemTypeContainer,{0.25,0.25},goldAnimationSpeed,false)
				Scripts.Interpolate(gemTypeContainer, "globalPosition", specialDestination, goldAnimationSpeed)
				specialGemButton.NewMarker:SetScore(quantityLabel.newQuantity,false)
				gemTypeContainer.GemTypeImage.alpha = 0  -- so the actor disappears but the particle child trail is still visible
				PlaySound("coin_magic_06.ogg")
				FireParticle(specialGemButton.NewMarker,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
				trail:Pause()
				topBar:AddScript("Animate_UpAndDown","")
				CorrectedPop(specialGemButton.NewMarker)
			end
		end
	end
	for workerIndex = 1,3 do
		local actorName = "Worker" .. workerIndex
		local workerActor = dialog[actorName]
		if(workerActor.visible) then
			PlaySound("coin_magic_03.ogg")
			PlaySound("swish05.ogg")
			CorrectedPop(workerActor)
			ScaleOut(workerActor,{0.0,0.0},goldAnimationSpeed,true)
		end
	end
	dialog.screen:StopDialog("ClaimDialog")
end

Scripts.HideLater = function(actor)
	ScriptDelay(1000,"dialogTimers")
	actor.visible = false
end



Resources.JumpGateView = Resources.Actor:new {
	resource = "Actor",
	image = "Dialog_Banner.png",
	--size = {280,65},
	--alpha = 200,
	visible = true,

    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
    },

	JumpImage = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		image = "JumpGate_1_open_small.png",
		alignmentOffset = {5,-2},
		size = {65,65},
		resizeOnSetImage = false,
		--scripts = {"SparkleRandomly_Jump"},

		Flag_Gold = Resources.Actor:new {
			resource = "Actor",
			alignment = "BottomLeft",
			alignTo = "BottomLeft",
			image = "Flag_Gold.png",
			visible = true,
			alignmentOffset = {-10,10},
			extraScale = 0.5,
		},
	},

	LandNumber = Resources.AppTitleDialogLabel_smaller:new {
		resource = "AppTitleDialogLabel_smaller",
		text = STRINGS("Land 1"),
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {-16,-22},
		visible = true,
        widthLimit = 125,
		font	= Resources.DialogTitleFont_smaller:new{
			resource = "DialogTitleFont_smaller",
			fontSize = 22,
		},
	},

	LandName = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		text = STRINGS("Land Title"),
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {-16,0},
		visible = true,
        widthLimit = 125,
	},

	Levels = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		text = STRINGS("100-115"),
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {-16,18},
		visible = true,
        widthLimit = 125,
	},

	--[[
	Land_Outline = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "Center",
		image = "Shop_BestValue_Outline.png",
		alignmentOffset = {0,0},
		visible = false,
		bestValueLabel = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("Current"),
			alignment = "Center",
			alignTo = "MidTop",
			fgColor = "White",
			highlightColor = "Red",
			highlightAlpha = 155,
			highlightOffset = {-1,-1},
			shadowColor = "Red",
			shadowOffset = {1,1},
			shadowAlpha = 155,
			alignmentOffset = {0,4},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 22,
			},
		},
	},
	--]]

	JumpGateButton = Resources.EndGameDialogBigButton :new {
		resource = "EndGameDialogBigButton",
		image = "ButtonPlastic_Small_Green.png",
		buttonClosesDialog = true,
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {-10,0},
		text = STRINGS("Jump"),
                textWidthLimit = 50,
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 25,
        },
		--clickSound = "coin_magic_03.ogg",
		zorder = 1,
	},

	GoldBars0Star = Resources.Actor:new {
		resource = "Actor",
		image = "Gold_1bar_small.png",
		alignment = "Center",
		alignTo = "MidBottom",
		alignmentOffset = {-26-90,-10-8},
		zorder = 4,
		--extraScale = 0.25,
		visible = true,
	},
	GoldBars1Star = Resources.Actor:new {
		resource = "Actor",
		image = "Gold_3bars_small.png",
		alignment = "Center",
		alignTo = "MidBottom",
		alignmentOffset = {-16-90,-5-8},
		zorder = 4,
		--extraScale = 0.35,
		visible = true,
	},
	GoldBars2Star = Resources.Actor:new {
		resource = "Actor",
		image = "Gold_5bars_small.png",
		alignment = "Center",
		alignTo = "MidBottom",
		alignmentOffset = {-4-90,-14-8},
		zorder = 4,
		--extraScale = 0.35,
		visible = true,
	},


}

Scripts.Preshow_JumpGateView = function(view,gateName,index,opened,haveAllStars)
	--logprint("Preshow_JumpGateView "..index.." "..gateName)
	local jumpImage = view:FindChild("JumpImage",true)
	local flag_Gold = view:FindChild("Flag_Gold",true)

	local jumpImageName = "JumpGate_"..index.."_open_small.png"
	local jumpImageName_closed = "JumpGate_"..index.."_closed_small.png"
	if(opened)then
		jumpImage.image = jumpImageName
	else
		jumpImage.image = jumpImageName_closed
	end

	if(haveAllStars)then
		view.image = "Dialog_Banner_gold.png"
		flag_Gold.visible = true
	else
		flag_Gold.visible = false
	end

	local landNumberLabel = view:FindChild("LandNumber",true)
	landNumberLabel.text = STRINGS("Land").." "..index

	local land = Lands:GetLand(index)
	local landNameLabel = view:FindChild("LandName",true)
	landNameLabel.text = land.landName

	local firstLevelNumber = Lands:GetFirstLevelNumberForLandNumber(index)
	local levelsLabel = view:FindChild("Levels",true)
	local levelAmount = 15
	if ((index == 1) or (index == 2)) then
		levelAmount = 10
	elseif (index >= 28) then
		levelAmount = 25
	end
	local levelsText = firstLevelNumber .."-"..firstLevelNumber+levelAmount-1
	levelsLabel.text = levelsText

	--local PriceButton = view:FindChild("PriceButton",true)
	--PriceButton.text = price
	--view.name = GateName
	--logprint(view.name)
end

Scripts.Preshow_JumpDialog = function(dialog)
end

Scripts.Present_JumpDialog = function(dialog,land,numberOfLands)
	--[[
	for i = 1,6 do
		local GateName = "JumpGate"..i
		local JumpGateView = dialog:FindChild(GateName,true)
		local JumpImage = JumpGateView:FindChild("JumpImage",true)
		FireParticle(JumpImage,"JumpSparkle1","Center",JumpGateView.hgeParticles)
		ScriptDelay(math.random(30,1000),"DialogTimers")
	end
	--]]

	--logprint("Present_JumpDialog "..land.." "..numberOfLands)
	--local numberOfLands = 21
	--local land = 10+2

	local indexPosition = numberOfLands - land
	local scrollableArea = dialog:FindChild("ScrollableArea",true)
	local dest = {}
	dest.x = 0
	dest.y = -(65+10)*(indexPosition-0) - 1 --   --card height * rank
	Scripts.AnimateToScrollPosition(scrollableArea, dest, 1)
end

Resources.JumpDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "JumpDialog",
	name = "JumpDialog",
    title = "",
	enableVisibleUnderlay = true,
    introScriptName = "SlideFromLeftDialog",
    dialogExitScriptName = "SlideOffRightDialog",

    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
    },

    titleText = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Jump Gates"),
		alignment = MidTop,
		alignmentOffset = {-15, 10},
		widthLimit = 250,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
		DisplayDimensions = {313, 416-headerOffset},
		horizontalScrollLocked = true,
		alignment = "MidRight",
		alignmentOffset = {-5,15},
		SlowFraction = .95,
		stoppingVelocity = 1,
	},

	okayButton = Resources.DialogButton:new {
		resource = "DialogButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y},
		text = STRINGS("Okay"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
		visible = false,
	},
}

local BuyBuildingDialog_yoffset = 90

--Claim Discoveries Dialog

Resources.BuyBuildingDialog = Resources.LargeLongerDialog:new {
	class = "BuyBuildingDialog",
	resource = "LargeLongerDialog",
    name = "BuyBuildingDialog",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-14},
        size = {250,280},
    },


    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Upgrade Discovery"), --NOTE: This value is overriden in code.
		alignment = MidTop,
		alignmentOffset = {0, 15},
		widthLimit = 210,
    },

	PowerupImage = Resources.Actor:new {
		image = "Land3_Discovery_1.png",
		alignment = Center,
		alignTo = MidTop,
		alignmentOffset = {0,120},
		maxDimensions = {200,100},
	},

	gemHolder = Resources.Actor:new {
		resource = "Actor",
		alignment = MidTop,
		alignmentOffset = {0, 80+BuyBuildingDialog_yoffset},
		size = {40,40},
		alpha = 100,
		gemImage = Resources.Actor:new {
			resource = "Actor",
			autoFillParent = true,
			image = "GemSpecialGreen.png",
		},
	},

	changeGemTypeButton = Resources.AppButton:new {
		resource = "AppButton",
		image = "button_mediumsmall_white@2x.png",
		useFrames = false,
		text = STRINGS("Change..."),
		alignment = MidTop,
		alignmentOffset = {25, 80+BuyBuildingDialog_yoffset},
		visible = false,
	},

	perHourLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Generated Per Hour"),
		alignment = MidTop,
		alignmentOffset = {0, 130+BuyBuildingDialog_yoffset},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		widthLimit = 160,
	},

	perHourAmount = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = MidTop,
		alignmentOffset = {0, 180-25+BuyBuildingDialog_yoffset},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		widthLimit = 160,
	},

	maximumLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Maximum Amount"),
		alignment = MidTop,
		alignmentOffset = {0, 230-(25*2)+BuyBuildingDialog_yoffset},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		widthLimit = 160,
	},

	maximumAmount = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = MidTop,
		alignmentOffset = {0, 280-(25*3)+BuyBuildingDialog_yoffset},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		widthLimit = 160,
	},

	ProgressLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Using Gold..."),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-40},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
	},

	CancelledLabel_Gold = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Your purchase has been canceled and no gold was spent."),
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-40},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
        heightLimit = 40,
	},

    --Discovery Price Button
	PriceButton = Resources.PriceButton:new {
		resource = "PriceButton",
		image = "ButtonPlastic_Long_Green.png",
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-10},
		buttonClosesDialog = false,
		text = STRINGS("$0.99"),
        textColor = "Cascade_BrightYellow",
        textHighlightColor = "Cascade_DarkGreen",
        textHighlightAlpha = 255,
        textShadowColor = "Cascade_DarkGreen",
        textShadowOffset = {1, 2},
        zorder = 2,

		SaleTag = Resources.SaleTag:new {
			resource = "SaleTag",
			zorder = 11,
			alignment = MidRight,
			alignTo = MidLeft,
			alignmentOffset = {45,26},
			extraScale = 0.72,
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),

			localizedLabel = Resources.Label:new {
		        class = "override",
		        font	= Resources.DialogBoldFont:new{
		            resource = "DialogBoldFont",
		            fontSize = 30,
		        },
		    },
		},
	},

    ButtonBevel = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Long_WoodOutline.png",
        alignment = MidBottom,
        alignTo = MidBottom,
        alignmentOffset = {0,-20},
        zorder = 1,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Resources.DailyChallengeStreakRewardDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	name = "DailyChallengeStreakRewardDialog",

    explanationText = Resources.Label:new {
        resource = "Label",
        font = Resources.DialogFont:new {
            resource = "DialogFont",
            fontSize = 10,
        },
        fgColor = "Black",
    },

    claimButton = Resources.BigDialogButton:new {
		resource = "BigDialogButton",
		alignment = MidBottom,
		alignmentOffset = {0,LargeLong_Dialog_Button_Y-10},
		text = STRINGS("Claim"),
		enterKey = true,
		escapeKey = true,
		shortcutKey = "c",
		image = "ButtonPlastic_Longer_Green.png",
		clickSound = "coin_magic_05.ogg",
        buttonClosesDialog = true,
    },
}
--QuickQuest Dialog
Resources.QuickQuestDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    class = "Dialog",
    name = "QuickQuestDialog",

    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
    },

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Quick Quest!"),
		alignment = MidTop,
		alignmentOffset = {0, 15},
		widthLimit = 210,
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 60,
		},
    },

    timeRemainingLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = MidTop,
		alignmentOffset = {0,58},
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		widthLimit = 270,
        shadowColor = "White",
		shadowAlpha = 0,
	},

    character = Resources.Actor:new {
        resource = "Actor",
        extraScale = 1.35,
        image = "Lemur.png",
        alignment = BottomRight,
		zorder = 10,
        alignmentOffset = Layout{{20,100},ipad={65,110},iphone4={20,130},iphone5={20,130}},
    },

    descriptionLabel = Resources.AppDialogLabel:new {
        resource = "AppDialogLabel",
        alignment = Center,
        alignmentOffset = {0,-23},
        font = Resources.DialogFont:new{
            resource = "DialogFont",
            fontSize = 24,
        },
        wrapLimit = 200,
        heightLimit = 75,
        textAlignment = "Center",
        --visible = false,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
        name = "CancelButton",
	},

    --Quick Quest Play Button
    NextButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Long_Green.png",
        scripts = {"SparkleLoop"},
        text = STRINGS("Play!"),
        zorder = 2,

        textWidthLimit = 80,
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 35,
        },

        alignment = "MidBottom",
        alignmentOffset = {0,-24},

        OnPostSpawn = function(self)
            self:AddObserver(EventMap.GURU_BUTTONCLICK, self)

            if (QQ_MGR:IsComplete()) then
                self.text = STRINGS("Next")
            end
        end,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            local player = PLAYER_MGR:GetCurrentPlayer(1)
            self.screen:StopDialog(self.parent)

            if (not QQ_MGR:IsComplete()) then
                QQ_MGR:SetPlayerToNextIncompleteLevel()
                local isSideLevel = QQ_MGR:IsSideLevelNextIncomplete()
                player:ShowPlayLevelDialog(isSideLevel)
            end

            return true
        end,
    },

            ButtonBevel = Resources.Actor:new {
            resource = "Actor",
            image = "ButtonPlastic_Long_WoodOutline.png",
            alignment = "MidBottom",
            alignmentOffset = {0,-24},
            zorder = 1,
            --extraScale = 0.88,
        },


    setUp = function(self)

        if (self.iconsNode) then
        	local destroyMe = self.iconsNode
            destroyMe:RemoveFromParent()
            destroyMe:Destroy()
        end

        self.iconsNode = Resources.LayoutBox:new {
            margin = -20,
            isVertical = false,
            alignment = Center,
            alignmentOffset = {0,-96},
            --extraScale = 0.80,
        }

        if (self.rewardsNode) then
        	local destroyMe = self.rewardsNode
            destroyMe:RemoveFromParent()
            destroyMe:Destroy()
        end

        self.rewardsNode = Resources.QuickQuestRewardsNode:new {
            resources = "QuickQuestRewardsNode",
            extraScale = 0.75,
            alignment = MidBottom,
            alignmentOffset = {0,-143},
        }


        local numLevelsComplete = QQ_MGR:GetNumLevelsComplete()
        local numLevelsTotal = QQ_MGR:GetNumLevelsTotal()

        local descriptionText = ""
        if (QQ_MGR:IsComplete()) then
            descriptionText = STRINGS("QuickQuestWinFMT2")
            self.timeRemainingLabel.visible = false
        else
            local numLevelsTotal = QQ_MGR:GetNumLevelsTotal()
            local grailSingularOrPlural = STRINGS("gold cups")
            if (numLevelsTotal == 1) then
                grailSingularOrPlural = STRINGS("gold cup")
            end
            descriptionText = string.format(STRINGS("QuickQuestDescriptionFMT3"),numLevelsTotal,grailSingularOrPlural)
        end
        self.descriptionLabel.text = descriptionText

        local N = numLevelsTotal
        local iconActors = {}

        for i = 1,N do

            local icon = Resources.Button:new {
                resource = "Button",
                image = QQ_MGR:GetImagePath(false,1.0),
                alignment = "Center",

                OnPostSpawn = function(self)
                    self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
                end,
            }

            local dialogue = self
            local startLevel = function(self,event)
                if self ~= event.button then return false end
                local player = PLAYER_MGR:GetCurrentPlayer(1)
                QQ_MGR:SetPlayerToLevelForIndex(i-1)
                self.screen:StopDialog(dialogue)
                local isSideLevel = QQ_MGR:IsSideLevelForIndex(i-1)
                player:ShowPlayLevelDialog(isSideLevel)
                return true
            end

            icon.OnButtonClick = startLevel

--[[
            if (QQ_MGR:IsLevelCompleteForIndex(i-1)) then
                icon.image = QQ_MGR:GetImagePath(true,1.0)
            end
--]]

            local buttonLabel = Resources.AppDialogLabel:new {
                resource = "AppDialogLabel",
                alignment = "Center",
                alignmentOffset = {0,-10},
                font = Resources.DialogBoldFont:new{
                    resource = "DialogBoldFont",
                    fontSize = 30,
                },
                wrapLimit = 50,
                heightLimit = 35,
                text = string.format(STRINGS("Level\n%s"),QQ_MGR:GetLevelNumberAsStringForIndex(i-1)),
                textColor = "White",
                shadowColor = "Black",
                shadowOffset = {2,2},
                shadowAlpha = 155,
            }

            icon.levelLabel = buttonLabel

            local iconActor = CreateInstance(icon)
            self.iconsNode:AddChild(iconActor)

            iconActors[i] = iconActor

        end

        --DEBUG
		--if (true) then
        if (QQ_MGR:IsComplete()) then

            local dialog = self

            Scripts.AnimIconActor = function(self,delay,isLast,index)
                ScriptDelay(delay, "DialogTimers")
                self.image = QQ_MGR:GetImagePath(true,1.0)
                ScaleIn(self,{2.0,2.0},delay)

				if(index==1)then
					PlaySound("coin_magic_03.ogg")
                elseif (index == 2) then
					PlaySound("coin_magic_03_2.ogg")
                elseif (index == 3) then
					PlaySound("coin_magic_03_7.ogg")
                elseif (index == 4) then
					PlaySound("coin_magic_03.ogg")
                else
					PlaySound("coin_magic_03_7.ogg")
				end

                FireParticle(self,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)

                if (isLast) then

                    ScriptDelay(500,"DialogTimers")
                    PlaySound("pop3.ogg")
                    PlaySound("slot_machine_win_05.ogg")
                    FireParticle(dialog.rewardsNode,"StarBurst_Blue_Small","Center",dialog.hgeParticles)
                    Pop(dialog.rewardsNode)

                    ScriptDelay(250,"DialogTimers")
                    PlaySound("magicwand.ogg")
                    PlaySound("air_cannon_pressure_release_02.ogg")
                    FireParticle(dialog.titleText,"Confetti1_normal_shape_short","MidTop",dialog.hgeParticles)
                    FireParticle(dialog.titleText,"Confetti2_normal_shape_short","MidTop",dialog.hgeParticles)
                    FireParticle(dialog.titleText,"Confetti3_normal_shape_short","MidTop",dialog.hgeParticles)
                    FireParticle(dialog.titleText,"Confetti4_normal_shape_short","MidTop",dialog.hgeParticles)
                    FireParticle(dialog.titleText,"Confetti5_normal_shape_short","MidTop",dialog.hgeParticles)
                    FireParticle(dialog.titleText,"Confetti6_normal_shape_short","MidTop",dialog.hgeParticles)
                    PlaySound("crowd_indoor_cheer_02.ogg")
                end
            end

			PlaySound("slot_machine_win_21.ogg")
            local delayDelta = 250
            local delay = 750
            for i = 1, N do
                delay = delay + delayDelta
                local iconActor = iconActors[i]
                AddScriptWithParams(iconActor,"AnimIconActor",delay,i==N,i)

                if (QQ_MGR:GetAnimationInIndex() ~= i-1) then
                    iconActor.image = QQ_MGR:GetImagePath(true,1.0)
                end
            end
        else

            local dialog = self
            Scripts.AnimIconActor = function(self)
                ScriptDelay(500, "DialogTimers")
                ScaleIn(self,{2.0,2.0},500)
                self.image = QQ_MGR:GetImagePath(true,1.0)
                PlaySound("coin_magic_03.ogg")
                FireParticle(self,"StarToss1.bigger.yellow.less","Center",dialog.hgeParticles)
            end

            for i = 1, N do

                local iconActor = iconActors[i]

                if (QQ_MGR:GetAnimationInIndex() == i-1) then

                    if (QQ_MGR:IsLevelCompleteForIndex(i-1)) then
                        AddScriptWithParams(iconActor,"AnimIconActor")
                    end

                    QQ_MGR:SetAnimationInIndex(-1)
                elseif (QQ_MGR:IsLevelCompleteForIndex(i-1)) then
                    iconActor.image = QQ_MGR:GetImagePath(true,1.0)
                end
            end

        end

    end,

    OnPostSpawn = function(self)
        self.setUp(self)
    end,

    Tick = function(self)
        local timeRemainingText = QQ_MGR:GetTimeRemainingAsString()
        self.timeRemainingLabel.text = string.format("%s%s",STRINGS("Ends in "),timeRemainingText)

        if (QQ_MGR:ResetIfAppropriate()) then
            self.setUp(self)
        end
    end,
}

Resources.StreakView = Resources.Actor:new {
	resource = "Actor",
	image = "Dialog_Banner.png",
	--size = {280,65},
	--alpha = 200,
	visible = true,

    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
    },

	JumpImage = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		image = "Icon_Lives.png",
		alignmentOffset = {5,-2},
		size = {220/2/1.5,180/2/1.5},
		resizeOnSetImage = false,
		--scripts = {"SparkleRandomly_Jump"},
	},

	DayNumber = Resources.AppTitleDialogLabel_smaller:new {
		resource = "AppTitleDialogLabel_smaller",
		text = STRINGS("Day 1"),
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,-12},
		visible = true,
        widthLimit = 125,
	},

	TimeToPlay = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		text = STRINGS("9:51:44"),
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0,12},
		visible = true,
        widthLimit = 125,
	},

	Medal = Resources.Actor:new {
		resource = "Actor",
		image = "Medal_big_gold.png",
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {-10,0},
		size = {170/2/1.5,170/2/1.5},
		resizeOnSetImage = false,
		visible = false,
	},

	Check = Resources.Actor:new {
		resource = "Actor",
		image = "Check.png",
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {-10,0},
		size = {170/2/1.5,170/2/1.5},
		resizeOnSetImage = false,
		visible = false,
	},

	Lock = Resources.Actor:new {
		resource = "Actor",
		image = "FeatureLock.png",
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {-10,0},
		size = {170/2/1.5,170/2/1.5},
		resizeOnSetImage = false,
		visible = false,
	},

	--[[
	Land_Outline = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "Center",
		image = "Shop_BestValue_Outline.png",
		alignmentOffset = {0,0},
		visible = false,
		bestValueLabel = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("Current"),
			alignment = "Center",
			alignTo = "MidTop",
			fgColor = "White",
			highlightColor = "Red",
			highlightAlpha = 155,
			highlightOffset = {-1,-1},
			shadowColor = "Red",
			shadowOffset = {1,1},
			shadowAlpha = 155,
			alignmentOffset = {0,4},
			font = Resources.DialogTitleFont:new {
				resource = "DialogTitleFont",
				fontSize = 22,
			},
		},
	},
	--]]

	StreakButton = Resources.DialogSmallButton:new {
		resource = "DialogSmallButton",
		image = "ButtonPlastic_Small_Green.png",
		buttonClosesDialog = true,
		alignment = MidRight,
		alignTo = MidRight,
		alignmentOffset = {-10,0},
		text = STRINGS("Jump"),
		--clickSound = "coin_magic_03.ogg",
		zorder = 1,
        textWidthLimit = 65,
		visible = false,
	},

}

Scripts.Preshow_StreakView = function(view,gateName,index,currentDay,medalNumber)
	--logprint("Preshow_StreakView "..index.." "..gateName)

	currentDay = 1

	local dayNumber = view:FindChild("DayNumber",true)
	local timeToPlay = view:FindChild("TimeToPlay",true)
	local check = view:FindChild("Check",true)
	local medal = view:FindChild("Medal",true)
	local lock = view:FindChild("Lock",true)

	dayNumber.text = STRINGS("Day").." "..index

	if(currentDay == index) then
		check.visible = true
		medal.visible = false
		lock.visible = false
		timeToPlay.visible = true
	else
		lock.visible = true
		medal.visible = false
		check.visible = false
		timeToPlay.visible = false
	end

	if(medalNumber>0)then
		medal.visible = true
		check.visible = false
		lock.visible = false
		timeToPlay.visible = false
		if(medal==1)then
			medal.image = "Medal_big_gold.png"
		elseif(medal==2)then
			medal.image = "Medal_big_silver.png"
		elseif(medal==3)then
			medal.image = "Medal_big_bronze.png"
		end
	end

end

Scripts.Preshow_StreakDialog = function(dialog)
end

Scripts.Present_StreakDialog = function(dialog,currentDailyChallenge,numberOfDailyChallenges)
	--[[
	for i = 1,6 do
		local GateName = "Streak"..i
		local StreakView = dialog:FindChild(GateName,true)
		local JumpImage = StreakView:FindChild("JumpImage",true)
		FireParticle(JumpImage,"JumpSparkle1","Center",StreakView.hgeParticles)
		ScriptDelay(math.random(30,1000),"DialogTimers")
	end
	--]]

	logprint("Present_StreakDialog "..currentDailyChallenge.." "..numberOfDailyChallenges)
	--local numberOfLands = 21
	--local land = 10+2

	local indexPosition = numberOfDailyChallenges - currentDailyChallenge
	local scrollableArea = dialog:FindChild("ScrollableArea",true)
	local dest = {}
	dest.x = 0
	dest.y = (65+10)*(currentDailyChallenge) - 1 --   --card height * rank
	Scripts.AnimateToScrollPosition(scrollableArea, dest, 1)
end

Resources.StreakDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "StreakDialog",
	name = "StreakDialog",
    title = "",
	enableVisibleUnderlay = true,
    introScriptName = "SlideFromRightDialog",
    dialogExitScriptName = "SlideOffLeftDialog",

    hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
    },

    titleText = Resources.AppTitleDialogLabel_smaller:new {
		resource = "AppTitleDialogLabel_smaller",
		text = STRINGS("Daily Challenge"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

	TextLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("Come back every day for\nincreasingly better rewards!"),
		alignment = MidTop,
		alignTo = MidTop,
		alignmentOffset = {0,40},
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 18,
		},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
		DisplayDimensions = {313, 416-headerOffset-90},
		horizontalScrollLocked = true,
		alignment = "MidRight",
		alignmentOffset = {-5,5},
		SlowFraction = .95,
		stoppingVelocity = 1,
	},

	okayButton = Resources.EndGameDialogBigButton:new {
		resource = "EndGameDialogBigButton",
		buttonClosesDialog = true,
		alignment = MidBottom,
		alignmentOffset = {0,LargeLonger_Dialog_Button_Y+10},
		text = STRINGS("Play"),
		image = "ButtonPlastic_Long_Green.png",
		enterKey = true,
		escapeKey = true,
		shortcutKey = "o",
		zorder = 2,
		visible = true,
	},
}

Resources.CouldNotAcceptGiftDialog = Resources.LargeLongerDialog:new {
    name = "CouldNotAcceptGiftDialog",
	resource = "LargeLongerDialog",

    titleLabel = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Whoops"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("We couldn't get your gift for you because you're not connected to the Internet. Please connect and try again."),
		alignment = Center,
		alignTo = Center,
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 18,
		},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},
}

Resources.WelcomePackDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "WelcomePackDialog",
	--image = "Dialog_GiftPack_Blank.png",
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    titleLabel = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		alignment = MidTop,
		alignmentOffset = {0, 10},
		visible = false,
    },

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidTop,
        alignmentOffset = {0,66-10},
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		visible = false,
	},

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignmentOffset = {0,-135},
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},
	},

    strike = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignmentOffset = {0,-130},
        text = "/",
		wrapLimit = 270,
		alpha = 220,
		extraScale = {1.5,1.1},
		rotationAngle = {degrees = 25,},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 40,
		},
        visible = false,
	},

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignmentOffset = {0,-70},
		widthLimit = 270,
		zorder = 2,
	},

    character = Resources.Actor:new {
        resource = "Actor",
        image = "Mouse.png",
        alignment = BottomRight,
        alignmentOffset = Layout{{10,32}, iphone5={10,87}, ipad={10,50}, pc={10,32}},

		visible = false,

        OnPostSpawn = function(self)

            Scripts.SlideOnMouse = function(self)

                local originalPosition = self.position

                local height = self.parent.size.y
                local screen = CurrentScreen()
                local screen_bottom = height + screen.size.y
                self.position = {originalPosition.x, screen_bottom}

                local duration = DIALOG_SLIDE_SPEED

                self:SlideTo(originalPosition, duration)
            end

            AddScriptWithParams(self,"SlideOnMouse")

        end
    },

    gold = Resources.Actor:new {
        resource = "Actor",
        image = "Gold_1bag_big.png",
        alignment = Center,
        alignmentOffset = {0,0},
        --extraScale = 1.4,
        visible = true,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
        buttonClosesDialog = false,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end
	},

    GetButton = Resources.BuyNowButton:new {
        resource = "BuyNowButton",

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            WP_MGR:Purchase()
            self.parent.CloseDialog(self.parent)

            return true
        end,
    },

    saleTag = Resources.SunTag:new {
        resource = "SunTag",
        visible = true,
		alignment = Center,
		alignTo = TopLeft,
		alignmentOffset = {65,65},

        OnPostSpawn = function(self)
            local percentOff = CONFIG:RetrieveInteger("WelcomePack_PercentOff",0)
            if (percentOff <= 0) then
                self.visible = false
            else
                self.localizedLabel.text = string.format(STRINGS("WelcomePackPriceSaleMoreFMT"),percentOff)
            end
        end,
    },

    NoThanksButton = Resources.DialogSmallButton:new {
        text = STRINGS("No thanks"),
        resource = "DialogSmallButton",
        image = "ButtonPlastic_Short_Orange.png",
        --buttonClosesDialog = true,
        alignment = MidBottom,
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-10},
        --extraScale = 0.75,

		visible = false,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end
    },

    CloseDialog = function(self)

        self.screen:StopDialog(self)

        Scripts.SlideOffMouse = function(self)

            local height = self.parent.size.y
            local screen = CurrentScreen()
            local screen_bottom = height + screen.size.y
            local newPosition = {self.position.x, screen_bottom}

            local duration = DIALOG_SLIDE_SPEED * 0.5

            self:SlideTo(newPosition, duration)
        end

        AddScriptWithParams(self.character,"SlideOffMouse")
    end,

    OnPostSpawn = function(self)

        self.hasShownFullText = false

        local descriptionText = STRINGS("Make sure you're connected to the Internet in order to see this great deal on gold!")
        self.descriptionLabel.text = descriptionText
		self.descriptionLabel.visible = true

        self.NoThanksButton.text = STRINGS("Okay")
		self.NoThanksButton.visible = true

		self.saleTag.visible = false

    end,

    Tick = function(self)

        if (not self.hasShownFullText) then
            local priceText = WP_MGR:GetPriceText()
            if (priceText ~= "") then
                self.hasShownFullText = true

                self.NoThanksButton.text = STRINGS("No thanks")
				self.NoThanksButton.visible = false
                self.GetButton.visible = true
                self.visible = true

				self.saleTag.visible = true

                local descriptionText = STRINGS("You must be new!\nCheck out this great deal!")
                self.descriptionLabel.text = descriptionText
				self.descriptionLabel.visible = false

                self.GetButton.text = priceText

                local amountOldText = WP_MGR:GetAmountOldText()
                local amountNewText = WP_MGR:GetAmountNewText()

                if (amountOldText ~= amountNewText) then

--[[
                    local amountOldTextNew = ""
                    for i = 1, #amountOldText do
                        local c = amountOldText:sub(i,i)
                        amountOldTextNew = amountOldTextNew .. "[strikethroughcharacter]" .. c
                    end
                    amountOldText = amountOldTextNew
--]]

                    self.amountLabelNew.text = string.format(STRINGS("WelcomePackAmountLabelNewFMT"),amountNewText)
                    self.strike.visible = true
                else
                    self.amountLabelNew.visible = false
                    self.strike.visible = false
                end

                self.amountLabelOld.text = string.format(STRINGS("WelcomePackAmountLabelOldFMT"),amountOldText)

                local titleText = WP_MGR:GetTitleText()
                self.titleLabel.text = titleText

            end
        end

    end,
}

--Are You Sure Dialog 1

Resources.WelcomePackAreYouSureYouWantToHideDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "WelcomePackAreYouSureYouWantToHideDialog",
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-5},
    },

    titleLabel = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Woah!"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

    character = Resources.Actor:new {
        resource = "Actor",
        image = "Mouse.png",
        alignment = BottomRight,
        alignmentOffset = Layout{{20,32}, iphone5={20,87}, ipad={20,50}, pc={20,32}},

		visible = false,

        OnPostSpawn = function(self)

            Scripts.SlideOnMouse = function(self)

                local originalPosition = self.position

                local height = self.parent.size.y
                local screen = CurrentScreen()
                local screen_bottom = height + screen.size.y
                self.position = {originalPosition.x, screen_bottom}

                local duration = DIALOG_SLIDE_SPEED

                self:SlideTo(originalPosition, duration)
            end

            AddScriptWithParams(self,"SlideOnMouse")

        end
    },

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = Center,
        text = STRINGS("Are you sure you want to hide this deal? (You can still access it from the Today dialog)"),
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 22,
		},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
        buttonClosesDialog = false,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end
	},

    YesButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Short_Green.png",
        text = STRINGS("Yes"),
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 40,
        },
        alignment = "MidBottom",
        alignmentOffset = {-74, -24},
        textWidthLimit = 100,        alignment = "MidBottom",
        alignmentOffset = {-74,-54},

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            WP_MGR:Hide()
            self.parent.CloseDialog(self.parent)

            return true
        end,
    },

    NoButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Short_Green.png",
        text = STRINGS("No"),
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 40,
        },        alignment = "MidBottom",
        alignmentOffset = {-74, -24},
        textWidthLimit = 100,
        alignment = "MidBottom",
        alignmentOffset = {74,-54},

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end,
    },

    CloseDialog = function(self)

        self.screen:StopDialog(self)

        Scripts.SlideOffMouse = function(self)

            local height = self.parent.size.y
            local screen = CurrentScreen()
            local screen_bottom = height + screen.size.y
            local newPosition = {self.position.x, screen_bottom}

            local duration = DIALOG_SLIDE_SPEED * 0.5

            self:SlideTo(newPosition, duration)
        end

        AddScriptWithParams(self.character,"SlideOffMouse")
    end,
}

--Are You Sure Dialog 2

Resources.GiftPackAreYouSureYouWantToHideDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "GiftPackAreYouSureYouWantToHideDialog",
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-5},
    },


    titleLabel = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Woah!"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

    character = Resources.Actor:new {
        resource = "Actor",
        image = "Mouse.png",
        alignment = BottomRight,
        alignmentOffset = Layout{{20,32}, iphone5={20,87}, ipad={20,50}, pc={20,32}},

		visible = false,

        OnPostSpawn = function(self)

            Scripts.SlideOnMouse = function(self)

                local originalPosition = self.position

                local height = self.parent.size.y
                local screen = CurrentScreen()
                local screen_bottom = height + screen.size.y
                self.position = {originalPosition.x, screen_bottom}

                local duration = DIALOG_SLIDE_SPEED

                self:SlideTo(originalPosition, duration)
            end

            AddScriptWithParams(self,"SlideOnMouse")

        end
    },

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = Center,
        text = STRINGS("Are you sure you want to hide this deal? (You can still access it from the Today dialog)"),
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 22,
		},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
        buttonClosesDialog = false,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end
	},

    YesButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Short_Green.png",
        text = STRINGS("Yes"),
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 40,
        },        alignment = "MidBottom",
        alignmentOffset = {-74, -24},
        textWidthLimit = 100,
        alignment = "MidBottom",
        alignmentOffset = {-74,-54},
        --buttonClosesDialog = true,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            GP_MGR:Hide()
            self.parent.CloseDialog(self.parent)

            return true
        end,
    },

    NoButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Short_Green.png",
        text = STRINGS("No"),
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 40,
        },        alignment = "MidBottom",
        alignmentOffset = {-74, -24},
        textWidthLimit = 100,
        alignment = "MidBottom",
        alignmentOffset = {74,-54},

        --buttonClosesDialog = true,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end,
    },

    CloseDialog = function(self)

        self.screen:StopDialog(self)

        Scripts.SlideOffMouse = function(self)

            local height = self.parent.size.y
            local screen = CurrentScreen()
            local screen_bottom = height + screen.size.y
            local newPosition = {self.position.x, screen_bottom}

            local duration = DIALOG_SLIDE_SPEED * 0.5

            self:SlideTo(newPosition, duration)
        end

        AddScriptWithParams(self.character,"SlideOffMouse")
    end,
}

--Are You Sure Dialog Hide Offer Pack

Resources.OfferPackAreYouSureYouWantToHideDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "OfferPackAreYouSureYouWantToHideDialog",
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

        DialogInsert = Resources.Actor:new {
            resource = "Actor",
            image = "Dialog_Filler_A.png",
            alignment = "Center",
            alignmentOffset = {0,-5},
        },

    titleLabel = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		text = STRINGS("Woah!"),
		alignment = MidTop,
		alignmentOffset = {0, 10},
    },

	Jasper_Customer_Support = Resources.Actor:new {
		resource = "Actor",
		image = "Jasper_Customer_Support@2x.png",
		alignment = "MidTop",
		extraScale = 0.68,
		alignmentOffset = {0,20},
	},

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
        zorder = 2,
		alignment = Center,
        alignmentOffset = {0,35},
        text = STRINGS("Are you sure you want to hide this deal?\n\n(You can still access it from the Today dialog)"),
		wrapLimit = 220,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 20,
		},

	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",

        OnButtonClick = function(self, event)
            if self ~= event.button then return false end
            self.parent.CloseDialog(self.parent)
            return true
        end
	},

    YesButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Short_Green.png",
        text = STRINGS("Yes"),
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 40,
        },        alignment = "MidBottom",
        alignmentOffset = {-74, -24},
        textWidthLimit = 100,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            OP_MGR:Hide()
            self.parent.CloseDialog(self.parent)
            return true
        end,
    },

    NoButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "ButtonPlastic_Short_Green.png",
        text = STRINGS("No"),
        font = Resources.MapButtonFont:new{
            resource = "MapButtonFont",
            fontSize = 40,
        },        alignment = "MidBottom",
        alignmentOffset = {74, -24},
        textWidthLimit = 100,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            self.parent.CloseDialog(self.parent)
            return true
        end,
    },

    CloseDialog = function(self)
        self.screen:StopDialog(self)
    end,
}

--DigSpot Dialogs

Resources.GoldDialog_DigSpot = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "GoldDialog_DigSpot",
	name = "GoldDialog_DigSpot",
	image = "DialogScroll.png",
	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

	DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0, -5},
        size = {250, 225},
    },
    
    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
        zorder = 5,
		text = STRINGS("You found gold!"),
		alignment = MidTop,
		alignmentOffset = {0, 45},
		wrapLimit = 220,
		heightLimit = 50,

		font = Resources.MapButtonFont:new{
			resource = "MapButtonFont",
			fontSize = 35,
		},
    },

	GoldImage = Resources.Actor:new {
		image = "Gold_5bars_big.png",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0, -55},
        scripts = {"DialogButtonGroove", "SparkleLoop"},

		Glow = Resources.Actor:new {
			resource = "Actor",
			image = "Glow.png",
			alignment = "Center",
			zorder = -1,
			scripts = {
				function (self)
					local revolutionsPerSecond = 0.025
					RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
				end,
			},
			shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
			alpha = 200,
		},

		Glow2 = Resources.Actor:new {
			resource = "Actor",
			image = "Glow.png",
			alignment = "Center",
			zorder = -1,
			scripts = {
				function (self)
					local revolutionsPerSecond = 0.025
					RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
				end,
			},
			alpha = 100,
		},
	},

	AmountLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = "20",
		textColor = "Red",
		alignment = Center,
		alignmentOffset = {0, 15},
        widthLimit = 125,
		zorder = 2,
		
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 44,
		},
	},

	TextLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		text = STRINGS("Watch a video to double your gold?"),
		alignment = Center,
		alignmentOffset = {0, 70},
        wrapLimit = 250,
		heightLimit = 60,
		
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 24,
		},
	},

	WoodBevel1 = Resources.Actor:new {
		resource = "Actor",
		image = "ButtonPlastic_Short_Green.png",
		alignment = MidBottom,
		alignmentOffset = {-75, LargeLong_Dialog_Button_Y-5},
		
		NoButton = Resources.DialogButton:new {
			resource = "DialogButton",
			image = "ButtonPlastic_Short_Green.png",
			alignment = Center,
			text = "Collect 20",
			textColor = "Cascade_BrightYellow",
			textHighlightColor = "Cascade_DarkGreen",
			textHighlightAlpha = 255,
			textShadowColor = "Cascade_DarkGreen",
			textShadowOffset = {1, 2},
			textWidthLimit = 125,

			OnButtonClick = function(self,event)
				if self ~= event.button then return false end
				DIG_SPOT_MGR:CollectGold()
				self.parent.parent.CloseDialog(self.parent.parent)
				return true
			end, 
		},
	},

	TextLabel2 = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		text = STRINGS("Watch Video"),
		alignment = MidBottom,
		alignTo = MidBottom,
		alignmentOffset = {75, LargeLonger_Dialog_Button_Y-50},
        widthLimit = 125,

		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 22,
		},
	},

	WoodBevel2 = Resources.Actor:new {
		resource = "Actor",
		image = "ButtonPlastic_Short_Green.png",
		alignment = MidBottom,
		alignmentOffset = {75, LargeLong_Dialog_Button_Y-5},
		
		YesButton = Resources.DialogButton:new {
			resource = "DialogButton",
			image = "ButtonPlastic_Short_Green.png",
			alignment = Center,
			text = "Collect 40",
			textColor = "Cascade_BrightYellow",
			textHighlightColor = "Cascade_DarkGreen",
			textHighlightAlpha = 255,
			textShadowColor = "Cascade_DarkGreen",
			textShadowOffset = {1, 2},
			textWidthLimit = 125,

			OnButtonClick = function(self,event)
				if self ~= event.button then return false end
				DIG_SPOT_MGR:ShowRV()
				self.parent.parent.CloseDialog(self.parent.parent)
				return true
			end,
		},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		alignmentOffset = {-10, 20},
        image = "ButtonCloseWax.png",
        extraScale= 1.2,

		OnButtonClick = function(self,event)
			if self ~= event.button then return false end
			DIG_SPOT_MGR:CollectGold()
			self.parent.CloseDialog(self.parent)
			return true
		end,
	},
}

Resources.BuyPowerupDialog_DigSpot = Resources.LargeLongerDialog:new {

	class = "BuyPowerupDialog_DigSpot",
	resource = "LargeLongerDialog",
    name = "BuyPowerupDialog_DigSpot",
	image = "DialogScroll.png",
	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    DialogInsert = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_Filler_A.png",
        alignment = "Center",
        alignmentOffset = {0,-20},
        size = {250,190},
    },

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
        zorder = 5,
		text = STRINGS("Get Powerup"),
            font	= Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 35,
                heightLimit = 60,
            },
		alignment = MidTop,
		alignmentOffset = {-10, 40-20},
		widthLimit = 220,
    },

	PowerupImage = Resources.Actor:new {
		image = "Boost_SpinSaver.png",
		alignment = Center,
		alignTo = Center,
		alignmentOffset = {0,-70},
        scripts = {"DialogButtonGroove"},

		BundleItemsTag = Resources.BundleItemsTag:new {
			resource = "BundleItemsTag",
			alignment = MidLeft,
			alignTo = MidRight,
			alignmentOffset = {-22,10},
			zorder = 5,
	        rotationAngle = {degrees = 15,},
			visible = (CONFIG:RetrieveConst("DebugSaleTags") == true),
		},

        PurchaseQuantityLabel = Resources.AppTitleDialogLabel_small:new {
            resource = "AppTitleDialogLabel_small",
            text = STRINGS("test text"),
            alignment = Center,
            alignTo = MidBottom,
            alignmentOffset = {0, 20},
            wrapLimit = 250,
			CrossOut = Resources.AppTitleDialogLabel_big:new {
				resource = "AppTitleDialogLabel_big",
				text = STRINGS("/"),
				alignment = Center,
				alignTo = Center,
				alignmentOffset = {0,0},
				visible = false,
				zorder = 10,
				shadowAlpha = 0,
				highlightAlpha = 0,
				alpha = 200,
				extraScale = {1.5,1.2},
				rotationAngle = {degrees = 15,},
			},
        },

        SalePurchaseQuantityLabel = Resources.AppTitleDialogLabel_big:new {
            resource = "AppTitleDialogLabel_big",
            text = STRINGS(""),
            textColor = "Red",
            alignment = MidLeft,
            alignTo = MidBottom,
            alignmentOffset = {15, 35},
            widthLimit = 70,
            visible = false,
			rotationAngle = {degrees = 5,},
        },

		Glow = Resources.Actor:new {
			resource = "Actor",
			image = "Glow.png",
			alignment = "Center",
			--alignmentOffset = {-105+60-10,-96+80+10},
			zorder = -1,
			scripts = {
				function (self)
					local revolutionsPerSecond = 0.025
					RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
				end,
			},
			shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
			alpha = 200,
		},

		Glow2 = Resources.Actor:new {
			resource = "Actor",
			image = "Glow.png",
			alignment = "Center",
			--alignmentOffset = {-105+60-10,-96+80+10},
			zorder = -1,
			scripts = {
				function (self)
					local revolutionsPerSecond = 0.025
					RotateAtSpeed(self, {revolutions=revolutionsPerSecond})
				end,
			},
			--shaderType = "SHADERTYPE_ADDITIVEALPHABLEND",
			alpha = 100,
		},


	},

	TextLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("This powerup does something cool!"),
		alignmentOffset = {0,320-headerOffset},
        heightLimit = 60,
		centerWrap = true,
	},

	ProgressLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("Purchase in progress..."),
		alignmentOffset = {0,320-headerOffset},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
	},

	CancelledLabel = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("Your purchase has been canceled and no money was spent."),
		alignmentOffset = {0,320-headerOffset},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
        heightLimit = 40,
	},

	CancelledLabel_Gold = Resources.TextLabel:new {
		resource = "TextLabel",
		text = STRINGS("Your purchase has been canceled and no gold was spent."),
		alignmentOffset = {0,320-headerOffset},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 24,
		},
		wrapLimit = 250,
		visible = false,
        heightLimit = 40,
	},

    PriceButton = Resources.PriceButton:new {
        resource = "PriceButton",
        image = "ButtonPlastic_Long_Green.png",
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-60},
        text = STRINGS("$0.99"),
        textColor = "Cascade_BrightYellow",
        textHighlightColor = "Cascade_DarkGreen",
        textHighlightAlpha = 255,
        textShadowColor = "Cascade_DarkGreen",
        textShadowOffset = {1, 2},
        textWidthLimit = 70,
        zorder = 2,
    },

    WoodBevel = Resources.Actor:new {
        resource = "Actor",
        image = "ButtonPlastic_Long_WoodOutline.png",
        alignment = MidBottom,
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-60},
        zorder = 1,
    },

    NoThanksButton = Resources.DialogSmallButton:new {
        text = STRINGS("No thanks"),
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 18,
		},
        resource = "DialogSmallButton",
        image = "ButtonPlastic_Small_Orange.png",
        buttonClosesDialog = true,
        alignment = MidBottom,
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-15},
		textWidthLimit = 75,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		alignmentOffset = {-10, 20},
        image = "ButtonCloseWax.png",
        extraScale= 1.2,
	},
}

Resources.BuyPowerupDialog_GiftPack = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "BuyPowerupDialog",
	--image = "Dialog_GiftPack_Blank.png",

	class = "BuyPowerupDialog_GiftPack",


    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    titleLabel = Resources.AppTitleDialogLabel_small:new {
		resource = "AppTitleDialogLabel_small",
		alignment = MidTop,
		alignmentOffset = {0, 10},
		visible = false,
    },

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidTop,
        alignmentOffset = {0,66-10},
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		visible = false,
	},

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignmentOffset = {0,-135},
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},
	},

    strike = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignmentOffset = {0,-130},
        text = "/",
		wrapLimit = 270,
		alpha = 220,
		extraScale = {1.5,1.1},
		rotationAngle = {degrees = 25,},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 40,
		},
        visible = false,
	},

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignmentOffset = {0,-70},
		widthLimit = 270,
		zorder = 2,
	},

    character = Resources.Actor:new {
        resource = "Actor",
        image = "Mouse.png",
        alignment = BottomRight,
        alignmentOffset = Layout{{20,32}, iphone5={20,87}, ipad={20,50}, pc={20,32}},

		visible = false,

        OnPostSpawn = function(self)

            Scripts.SlideOnMouse = function(self)

                local originalPosition = self.position

                local height = self.parent.size.y
                local screen = CurrentScreen()
                local screen_bottom = height + screen.size.y
                self.position = {originalPosition.x, screen_bottom}

                local duration = DIALOG_SLIDE_SPEED

                self:SlideTo(originalPosition, duration)
            end

            AddScriptWithParams(self,"SlideOnMouse")

        end
    },

    gold = Resources.Actor:new {
        resource = "Actor",
        image = "Gold_1bag_big.png",
        alignment = Center,
        alignmentOffset = {6,4},
        --extraScale = 1.4,
        visible = true,
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
        buttonClosesDialog = false,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end
	},

	GetButton = Resources.BuyNowButton:new {
	    resource = "BuyNowButton",

	    OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            GP_MGR:Purchase()
            self.parent.CloseDialog(self.parent)

            return true
        end,
    },

    saleTag = Resources.SunTag:new {
        resource = "SunTag",
        visible = true,
		alignment = Center,
		alignTo = TopLeft,
		alignmentOffset = {65,65},

        OnPostSpawn = function(self)
            local percentOff = CONFIG:RetrieveInteger("WelcomePack_PercentOff",0)
            if (percentOff <= 0) then
                self.visible = false
            else
                self.localizedLabel.text = string.format(STRINGS("WelcomePackPriceSaleMoreFMT"),percentOff)
            end
        end,
    },

    NoThanksButton = Resources.DialogSmallButton:new {
        text = STRINGS("No thanks"),
        resource = "DialogSmallButton",
        image = "ButtonPlastic_Short_Orange.png",
        --buttonClosesDialog = true,
        alignment = MidBottom,
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-10},
        --extraScale = 0.75,

		visible = false,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end

            self.parent.CloseDialog(self.parent)

            return true
        end
    },

    CloseDialog = function(self)

        self.screen:StopDialog(self)

        Scripts.SlideOffMouse = function(self)

            local height = self.parent.size.y
            local screen = CurrentScreen()
            local screen_bottom = height + screen.size.y
            local newPosition = {self.position.x, screen_bottom}

            local duration = DIALOG_SLIDE_SPEED * 0.5

            self:SlideTo(newPosition, duration)
        end

        AddScriptWithParams(self.character,"SlideOffMouse")
    end,

    OnPostSpawn = function(self)

        self.hasShownFullText = false

        local descriptionText = STRINGS("Make sure you're connected to the Internet in order to see this great deal on gold!")
        self.descriptionLabel.text = descriptionText
		self.descriptionLabel.visible = true

        self.NoThanksButton.text = STRINGS("Okay")
		self.NoThanksButton.visible = true

		self.saleTag.visible = false

    end,

    Tick = function(self)

        if (not self.hasShownFullText) then
            local priceText = GP_MGR:GetPriceText()
            if (priceText ~= "") then
                self.hasShownFullText = true

                self.NoThanksButton.text = STRINGS("No thanks")
				self.NoThanksButton.visible = false
                self.GetButton.visible = true
                self.visible = true

				self.saleTag.visible = true

                local descriptionText = STRINGS("Player appreciation time!\nCheck out this great deal!")
                self.descriptionLabel.text = descriptionText
				self.descriptionLabel.visible = false

                self.GetButton.text = priceText

                local amountOldText = GP_MGR:GetAmountOldText()
                local amountNewText = GP_MGR:GetAmountNewText()

                if (amountOldText ~= amountNewText) then

--[[
                    local amountOldTextNew = ""
                    for i = 1, #amountOldText do
                        local c = amountOldText:sub(i,i)
                        amountOldTextNew = amountOldTextNew .. "[strikethroughcharacter]" .. c
                    end
                    amountOldText = amountOldTextNew
--]]

                    self.amountLabelNew.text = string.format(STRINGS("GiftPackAmountLabelNewFMT"),amountNewText)
                    self.strike.visible = true
                else
                    self.amountLabelNew.visible = false
                    self.strike.visible = false
                end

                self.amountLabelOld.text = string.format(STRINGS("GiftPackAmountLabelOldFMT"),amountOldText)

                local titleText = GP_MGR:GetTitleText()
                self.titleLabel.text = titleText

            end
        end

    end,
}

Resources.OfferPackDialogA = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "OfferPackDialogA",
	image = "DialogWelcomePack_TemplateA_Back.png",
	class = "OfferPackDialog",

    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    --titleLabel = Resources.AppTitleDialogLabel_small:new {
	--	resource = "AppTitleDialogLabel_small",
	--	alignment = MidTop,
	--	alignmentOffset = {0, 10},
	--	visible = false,
    --},

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidTop,
        alignmentOffset = {0, 66-10},
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		visible = false,
	},

    NoThanksButton = Resources.DialogSmallButton:new {
        resource = "DialogSmallButton",
        image = "ButtonPlastic_Short_Orange.png",
        alignment = MidBottom,
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-10},
        widthLimit = 125,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            self.parent.CloseDialog(self.parent)
            return true
        end
    },

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignTo = Top,
        alignmentOffset = {0, 155},
		wrapLimit = 270,
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-10, 0},
            text = "/",
            wrapLimit = 270,
            alpha = 240,
            extraScale = {1.5, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Top,
        alignmentOffset = {0, 90},
		widthLimit = 270,
		zorder = 2,

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 110,
        },
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            self.parent.CloseDialog(self.parent)
            return true
        end
	},

    GetButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Dialog_GiftPack_TemplateA_BuyButton.png",
        text = STRINGS("???"),
        alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, -15},
        textAlignmentOffset = {0, -15},
        textColor = "White",
        textShadowColor = "Red",
        textShadowOffset = {1, 1},
        textShadowAlpha = 255,
        textHighlightColor = "Red",
        textHighlightOffset = {-1, -1},
        textHighlightAlpha = 255,
        zorder = 2,
        visible = false,
        textWidthLimit = 150,
        font = Resources.AppButtonFont:new {
            resource = "DialogTitleFont",
        },

        BuyNow = Resources.AppTitleDialogLabel_big:new {
            resource = "AppTitleDialogLabel_big",
            text = STRINGS("Buy Now!"),
            alignment = Center,
            alignTo = Center,
            alignmentOffset = {0, 20},
            widthLimit = 150,
            fgColor = "White",
            shadowColor = "Red",
            shadowOffset = {1, 1},
            shadowAlpha = 255,
            highlightColor = "Red",
            highlightOffset = {-1, -1},
            highlightAlpha = 255,
            font = Resources.DialogTitleFont:new{
                resource = "DialogTitleFont",
                fontSize = 32,
            },
        },

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            OP_MGR:Purchase()
            self.parent.CloseDialog(self.parent)
            return true
        end
    },

    saleTag = Resources.SunTag:new {
        resource = "SunTag",
        alignment = Center,
		alignTo = BottomLeft,
		alignmentOffset = {70, -75},
    },

    speechBubble = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_GiftPack_Bubble01.png",
        zorder = 1,

        alignment = Center,
        alignTo = Center,
        alignmentOffset = {-10, 70},
        visible = false,
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3, -5},
            showHighlight = false,
            font = Resources.DialogBoldFont:new{
                resource = "CutsceneBubbleFont",
                fontSize = 18,
            },
            text = STRINGS("Just for you!"),
            widthLimit = 90,
            heightLimit = 50,
        },
    },

    CloseDialog = function(self)
        self.screen:StopDialog(self)
    end,

    OnPostSpawn = function(self)
        self.hasShownFullText = false

        local descriptionText = STRINGS("Make sure you're connected to the Internet in order to see this great deal on gold!")
        self.descriptionLabel.text = descriptionText
		self.descriptionLabel.visible = true

        self.NoThanksButton.text = STRINGS("Okay")
		self.NoThanksButton.visible = true

		self.saleTag.visible = false
    end,

    Tick = function(self)
        if (not self.hasShownFullText) then
            local priceText = OP_MGR:GetPriceText()
            if (priceText ~= "") then
                self.hasShownFullText = true

                self.visible = true
                self.NoThanksButton.visible = false
                self.descriptionLabel.visible = false

                local percentMore = OP_MGR:GetPercentMore();
                if (percentMore <= 0) then
                    self.saleTag.visible = false
                else
                    self.saleTag.localizedLabel.text = string.format(STRINGS("GiftPackPriceSaleMoreFMT"), percentMore)
                    self.saleTag.visible = true
                end

                self.speechBubble.visible = true

                self.GetButton.visible = true
                self.GetButton.text = priceText

                local amountOldText = OP_MGR:GetAmountOldText()
                local amountNewText = OP_MGR:GetAmountNewText()

                self.amountLabelNew.text = string.format(STRINGS("GiftPackAmountLabelNewFMT"), amountNewText)

                self.amountLabelOld.text = string.format(STRINGS("GiftPackAmountLabelOldFMT"), amountOldText)
                self.amountLabelOld.visible = true

                --Title text is currently not being displayed, so this code is irrelevant. If title text is desired
                --in future, uncomment the following.
                --local titleText = STRINGS(OP_MGR:GetTitleText())
                --self.titleLabel.text = titleText
                --self.titleLable.visible = true
            end
        end
    end,
}

Resources.OfferPackDialogA_OfferPack_01 = Resources.OfferPackDialogA:new {
	resource = "OfferPackDialogA",
    name = "OfferPackDialogA_OfferPack_01",
	image = "DialogWelcomePack_TemplateA_Back.png",
}

Resources.OfferPackDialogA_OfferPack_02 = Resources.OfferPackDialogA:new {
	resource = "OfferPackDialogA",
    name = "OfferPackDialogA_OfferPack_02",
	image = "DialogFirstTimeSpender_TemplateA_Back.png",
}

Resources.OfferPackDialogA_OfferPack_03 = Resources.OfferPackDialogA:new {
	resource = "OfferPackDialogA",
    name = "OfferPackDialogA_OfferPack_03",
	image = "DialogLapsedMedium_TemplateA_Back.png",

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignTo = Top,
        alignmentOffset = {0, 155},
		wrapLimit = 270,
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-15, 0},
            text = "/",
            wrapLimit = 270,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},
}

Resources.OfferPackDialogA_OfferPack_04 = Resources.OfferPackDialogA:new {
	resource = "OfferPackDialogA",
    name = "OfferPackDialogA_OfferPack_04",
	image = "DialogLapsedLarge_TemplateA_Back.png",

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignTo = Top,
        alignmentOffset = {0, 155},
		wrapLimit = 270,
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-17, 0},
            text = "/",
            wrapLimit = 270,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Top,
        alignmentOffset = {0, 90},
		widthLimit = 270,
		zorder = 2,
        highlightColor = "Cascade_MediumBrown",
        shadowColor = "Cascade_MediumBrown",

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 110,
        },
	},

    speechBubble = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_GiftPack_Bubble02.png",
        zorder = 1,

        alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, 60},
        visible = false,
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3, -5},
            showHighlight = false,
            font = Resources.DialogBoldFont:new{
                resource = "CutsceneBubbleFont",
                fontSize = 18,
            },
            text = STRINGS("Just for you!"),
            widthLimit = 90,
            heightLimit = 50,
        },
    },
}

Resources.OfferPackDialogA_OfferPack_05 = Resources.OfferPackDialogA:new {
	resource = "OfferPackDialogA",
    name = "OfferPackDialogA_OfferPack_05",
	image = "DialogLapsedLarge_TemplateA_Back.png",

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignTo = Top,
        alignmentOffset = {0, 155},
		wrapLimit = 270,
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-17, 0},
            text = "/",
            wrapLimit = 270,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Top,
        alignmentOffset = {0, 90},
		widthLimit = 270,
		zorder = 2,
        highlightColor = "Cascade_MediumBrown",
        shadowColor = "Cascade_MediumBrown",

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 110,
        },
	},

    speechBubble = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_GiftPack_Bubble02.png",
        zorder = 1,

        alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, 60},
        visible = false,
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3, -5},
            showHighlight = false,
            font = Resources.DialogBoldFont:new{
                resource = "CutsceneBubbleFont",
                fontSize = 18,
            },
            text = STRINGS("Just for you!"),
            widthLimit = 90,
            heightLimit = 50,
        },
    },
}

Resources.OfferPackDialogB = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "OfferPackDialogB",
	image = "DialogWelcomePack_TemplateB_Back.png",
	class = "OfferPackDialog",

    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    --titleLabel = Resources.AppTitleDialogLabel_small:new {
	--	resource = "AppTitleDialogLabel_small",
	--	alignment = MidTop,
	--	alignmentOffset = {0, 10},
	--	visible = false,
    --},

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidTop,
        alignmentOffset = {0, 105},
		wrapLimit = 225,
        rotationAngle = {degrees = -4,},
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		visible = false,
	},

    NoThanksButton = Resources.DialogSmallButton:new {
        resource = "DialogSmallButton",
        image = "ButtonPlastic_Short_Orange.png",
        alignment = MidBottom,
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-10},
        widthLimit = 125,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            self.parent.CloseDialog(self.parent)
            return true
        end
    },

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignTo = Top,
        alignmentOffset = {0, 157},
		wrapLimit = 225,
        rotationAngle = {degrees = -4,},
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-10, 0},
            text = "/",
            wrapLimit = 225,
            alpha = 240,
            extraScale = {1.5, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Top,
        alignmentOffset = {0, 95},
		widthLimit = 225,
		zorder = 2,
        rotationAngle = {degrees = -4,},
        highlightColor = "Cascade_DarkBrown",
        shadowColor = "Cascade_DarkBrown",

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 66,
        },
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            self.parent.CloseDialog(self.parent)
            return true
        end
	},

    PriceText = Resources.AppTitleDialogLabel_big:new {
        resource = "AppTitleDialogLabel_big",
        text = STRINGS("???"),
        alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, -30},
        wrapLimit = 225,
        fgColor = "White",
        shadowColor = "Cascade_DarkBrown",
        shadowOffset = {1, 1},
        shadowAlpha = 255,
        highlightColor = "Cascade_DarkBrown",
        highlightOffset = {-1, -1},
        highlightAlpha = 255,
        rotationAngle = {degrees = -4,},
        font = Resources.DialogTitleFont:new{
            resource = "DialogTitleFont",
            fontSize = 50,
        },
        visible = false,
    },

    GetButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Dialog_GiftPack_TemplateB_BuyButton.png",
        text = STRINGS("Buy Now!"),
        alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, 25},
        textAlignmentOffset = {0, 0},
        textWidthLimit = 125,
        textColor = "Cascade_DarkBrown",
        textShadowColor = "White",
        textShadowOffset = {1, 1},
        textShadowAlpha = 255,
        textHighlightColor = "White",
        textHighlightOffset = {-1, -1},
        textHighlightAlpha = 255,
        zorder = 2,
        visible = false,
        font = Resources.DialogTitleFont:new {
            resource = "DialogTitleFont",
            fontSize = 32,
        },

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            OP_MGR:Purchase()
            self.parent.CloseDialog(self.parent)
            return true
        end
    },

    saleTag = Resources.SunTag:new {
        resource = "SunTag",
        alignment = Center,
		alignTo = BottomLeft,
		alignmentOffset = {65, -70},
        zorder = 2,
    },

    speechBubble = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_GiftPack_Bubble01.png",
        zorder = 1,

        alignment = Center,
        alignTo = Center,
        alignmentOffset = {-20, 85},
        visible = false,
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3, -5},
            showHighlight = false,
            font = Resources.DialogBoldFont:new{
                resource = "CutsceneBubbleFont",
                fontSize = 18,
            },
            text = STRINGS("Just for you!"),
            widthLimit = 90,
            heightLimit = 50,
        },
    },

    CloseDialog = function(self)
        self.screen:StopDialog(self)
    end,

    OnPostSpawn = function(self)
        self.hasShownFullText = false

        local descriptionText = STRINGS("Make sure you're connected to the Internet in order to see this great deal on gold!")
        self.descriptionLabel.text = descriptionText
		self.descriptionLabel.visible = true

        self.NoThanksButton.text = STRINGS("Okay")
		self.NoThanksButton.visible = true

		self.saleTag.visible = false
    end,

    Tick = function(self)
        if (not self.hasShownFullText) then
            local priceText = OP_MGR:GetPriceText()
            if (priceText ~= "") then
                self.hasShownFullText = true

                self.visible = true
                self.NoThanksButton.visible = false
                self.descriptionLabel.visible = false

                local percentMore = OP_MGR:GetPercentMore();
                if (percentMore <= 0) then
                    self.saleTag.visible = false
                else
                    self.saleTag.localizedLabel.text = string.format(STRINGS("GiftPackPriceSaleMoreFMT"), percentMore)
                    self.saleTag.visible = true
                end

                self.speechBubble.visible = true

                self.GetButton.visible = true

                self.PriceText.text = priceText
                self.PriceText.visible = true

                local amountOldText = OP_MGR:GetAmountOldText()
                local amountNewText = OP_MGR:GetAmountNewText()

                self.amountLabelNew.text = string.format(STRINGS("GiftPackAmountLabelNewFMT"), amountNewText)
                self.amountLabelOld.text = string.format(STRINGS("GiftPackAmountLabelOldFMT"), amountOldText)
                self.amountLabelOld.visible = true

                --Title text is currently not being displayed, so this code is irrelevant. If title text is desired
                --in future, uncomment the following.
                --local titleText = STRINGS(OP_MGR:GetTitleText())
                --self.titleLabel.text = titleText
                --self.titleLable.visible = true
            end
        end
    end,
}

Resources.OfferPackDialogB_OfferPack_01 = Resources.OfferPackDialogB:new {
	resource = "OfferPackDialogB",
    name = "OfferPackDialogB_OfferPack_01",
	image = "DialogWelcomePack_TemplateB_Back.png",
}

Resources.OfferPackDialogB_OfferPack_02 = Resources.OfferPackDialogB:new {
	resource = "OfferPackDialogB",
    name = "OfferPackDialogB_OfferPack_02",
	image = "DialogFirstTimeSpender_TemplateB_Back.png",

    speechBubble = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_GiftPack_Bubble02.png",
        zorder = 1,

        alignment = Center,
        alignTo = Center,
        alignmentOffset = {4, 102},
        visible = false,
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3, -5},
            showHighlight = false,
            font = Resources.DialogBoldFont:new{
                resource = "CutsceneBubbleFont",
                fontSize = 18,
            },
            text = STRINGS("Just for you!"),
            widthLimit = 90,
            heightLimit = 50,
        },
    },
}

Resources.OfferPackDialogB_OfferPack_03 = Resources.OfferPackDialogB:new {
	resource = "OfferPackDialogB",
    name = "OfferPackDialogB_OfferPack_03",
	image = "DialogLapsedMedium_TemplateB_Back.png",

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Top,
        alignmentOffset = {0, 95},
		widthLimit = 225,
		zorder = 2,
        rotationAngle = {degrees = -4,},
        highlightColor = "Cascade_DarkBrown",
        shadowColor = "Cascade_DarkBrown",

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 62,
        },
	},

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignTo = Top,
        alignmentOffset = {0, 157},
		wrapLimit = 225,
        rotationAngle = {degrees = -4,},
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-15, 0},
            text = "/",
            wrapLimit = 225,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    speechBubble = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_GiftPack_Bubble01.png",
        zorder = 1,

        alignment = Center,
        alignTo = Center,
        alignmentOffset = {2, 85},
        visible = false,
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3, -5},
            showHighlight = false,
            font = Resources.DialogBoldFont:new{
                resource = "CutsceneBubbleFont",
                fontSize = 18,
            },
            text = STRINGS("Just for you!"),
            widthLimit = 90,
            heightLimit = 50,
        },
    },
}

Resources.OfferPackDialogB_OfferPack_04 = Resources.OfferPackDialogB:new {
	resource = "OfferPackDialogB",
    name = "OfferPackDialogB_OfferPack_04",
	image = "DialogLapsedLarge_TemplateB_Back.png",

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Top,
        alignmentOffset = {0, 95},
		widthLimit = 225,
		zorder = 2,
        rotationAngle = {degrees = -4,},
        highlightColor = "Cascade_DarkBrown",
        shadowColor = "Cascade_DarkBrown",

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 60,
        },
	},

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignTo = Top,
        alignmentOffset = {0, 157},
		wrapLimit = 225,
        rotationAngle = {degrees = -4,},
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-17, 0},
            text = "/",
            wrapLimit = 225,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    speechBubble = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_GiftPack_Bubble01.png",
        zorder = 1,

        alignment = Center,
        alignTo = Center,
        alignmentOffset = {2, 85},
        visible = false,
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3, -5},
            showHighlight = false,
            font = Resources.DialogBoldFont:new{
                resource = "CutsceneBubbleFont",
                fontSize = 18,
            },
            text = STRINGS("Just for you!"),
            widthLimit = 90,
            heightLimit = 50,
        },
    },
}

Resources.OfferPackDialogB_OfferPack_05 = Resources.OfferPackDialogB:new {
	resource = "OfferPackDialogB",
    name = "OfferPackDialogB_OfferPack_05",
	image = "DialogLapsedLarge_TemplateB_Back.png",

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Top,
        alignmentOffset = {0, 95},
		widthLimit = 225,
		zorder = 2,
        rotationAngle = {degrees = -4,},
        highlightColor = "Cascade_DarkBrown",
        shadowColor = "Cascade_DarkBrown",

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 60,
        },
	},

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidBottom,
        alignTo = Top,
        alignmentOffset = {0, 157},
		wrapLimit = 225,
        rotationAngle = {degrees = -4,},
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-17, 0},
            text = "/",
            wrapLimit = 225,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    speechBubble = Resources.Actor:new {
        resource = "Actor",
        image = "Dialog_GiftPack_Bubble01.png",
        zorder = 1,

        alignment = Center,
        alignTo = Center,
        alignmentOffset = {2, 85},
        visible = false,
        localizedLabel = Resources.Label:new {
            resource = "Label",
            alignment = Center,
            alignTo = Center,
            fgColor = "Cascade_DarkBrown",
            shadowAlpha = 0,
            alpha = 255,
            alignmentOffset = {-3, -5},
            showHighlight = false,
            font = Resources.DialogBoldFont:new{
                resource = "CutsceneBubbleFont",
                fontSize = 18,
            },
            text = STRINGS("Just for you!"),
            widthLimit = 90,
            heightLimit = 50,
        },
    },
}

Resources.OfferPackDialogC = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "OfferPackDialogC",
	image = "DialogWelcomePack_TemplateC_Back.png",
	class = "OfferPackDialog",

    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

    --titleLabel = Resources.AppTitleDialogLabel_small:new {
	--	resource = "AppTitleDialogLabel_small",
	--	alignment = MidTop,
	--	alignmentOffset = {0, 10},
	--	visible = false,
    --},

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidTop,
        alignmentOffset = {0, 66-10},
		wrapLimit = 270,
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		visible = false,
	},

    NoThanksButton = Resources.DialogSmallButton:new {
        resource = "DialogSmallButton",
        image = "ButtonPlastic_Short_Orange.png",
        alignment = MidBottom,
        alignmentOffset = {0, LargeLong_Dialog_Button_Y-10},
        widthLimit = 125,

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            self.parent.CloseDialog(self.parent)
            return true
        end
    },

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, -5},
		wrapLimit = 270,
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-10, 0},
            text = "/",
            wrapLimit = 270,
            alpha = 240,
            extraScale = {1.5, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, -55},
		widthLimit = 270,
		zorder = 2,

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 110,
        },
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            self.parent.CloseDialog(self.parent)
            return true
        end
	},

    PriceText = Resources.AppTitleDialogLabel_big:new {
        resource = "AppTitleDialogLabel_big",
        text = STRINGS("???"),
        alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, 35},
        wrapLimit = 270,
        fgColor = "Cascade_Gold",
        shadowColor = "Cascade_DarkBrown",
        shadowOffset = {1, 1},
        shadowAlpha = 255,
        highlightColor = "Cascade_DarkBrown",
        highlightOffset = {-1, -1},
        highlightAlpha = 255,
        font = Resources.DialogTitleFont:new{
            resource = "DialogTitleFont",
            fontSize = 50,
        },
        visible = false,
    },

    GetButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Dialog_GiftPack_TemplateA_BuyButton.png",
        text = STRINGS("Buy Now!"),
        alignment = MidBottom,
        alignTo = Bottom,
        alignmentOffset = {0, 2},
        textAlignmentOffset = {0, 0},
        textWidthLimit = 150,
        textColor = "White",
        textShadowColor = "Red",
        textShadowOffset = {1, 1},
        textShadowAlpha = 255,
        textHighlightColor = "Red",
        textHighlightOffset = {-1, -1},
        textHighlightAlpha = 255,
        zorder = 2,
        visible = false,
        font = Resources.AppButtonFont:new {
            resource = "DialogTitleFont",
        },

        gold = Resources.Actor:new {
            resource = "Actor",
            image = "Gold_1bag_big.png",
            alignment = MidBottom,
            alignTo = Top,
            alignmentOffset = {4, 30},
            visible = true,
        },

        OnButtonClick = function(self,event)
            if self ~= event.button then return false end
            OP_MGR:Purchase()
            self.parent.CloseDialog(self.parent)
            return true
        end
    },

    saleTag = Resources.SunTag:new {
        resource = "SunTag",
        alignment = Center,
		alignTo = TopLeft,
		alignmentOffset = {66, 62},
    },

    CloseDialog = function(self)
        self.screen:StopDialog(self)
    end,

    OnPostSpawn = function(self)
        self.hasShownFullText = false

        local descriptionText = STRINGS("Make sure you're connected to the Internet in order to see this great deal on gold!")
        self.descriptionLabel.text = descriptionText
		self.descriptionLabel.visible = true

        self.NoThanksButton.text = STRINGS("Okay")
		self.NoThanksButton.visible = true

		self.saleTag.visible = false
    end,

    Tick = function(self)
        if (not self.hasShownFullText) then
            local priceText = OP_MGR:GetPriceText()
            if (priceText ~= "") then
                self.hasShownFullText = true

                self.visible = true
                self.NoThanksButton.visible = false
                self.descriptionLabel.visible = false

                local percentMore = OP_MGR:GetPercentMore();
                if (percentMore <= 0) then
                    self.saleTag.visible = false
                else
                    self.saleTag.localizedLabel.text = string.format(STRINGS("GiftPackPriceSaleMoreFMT"), percentMore)
                    self.saleTag.visible = true
                end

                self.GetButton.visible = true

                self.PriceText.text = priceText
                self.PriceText.visible = true

                local amountOldText = OP_MGR:GetAmountOldText()
                local amountNewText = OP_MGR:GetAmountNewText()

                self.amountLabelNew.text = string.format(STRINGS("GiftPackAmountLabelNewFMT"), amountNewText)
                self.amountLabelOld.text = string.format(STRINGS("GiftPackAmountLabelOldFMT"), amountOldText)
                self.amountLabelOld.visible = true

                --Title text is currently not being displayed, so this code is irrelevant. If title text is desired
                --in future, uncomment the following.
                --local titleText = STRINGS(OP_MGR:GetTitleText())
                --self.titleLabel.text = titleText
                --self.titleLable.visible = true
            end
        end
    end,
}

Resources.OfferPackDialogC_OfferPack_01 = Resources.OfferPackDialogC:new {
	resource = "OfferPackDialogC",
    name = "OfferPackDialogC_OfferPack_01",
	image = "DialogWelcomePack_TemplateC_Back.png",
}

Resources.OfferPackDialogC_OfferPack_02 = Resources.OfferPackDialogC:new {
	resource = "OfferPackDialogC",
    name = "OfferPackDialogC_OfferPack_02",
	image = "DialogFirstTimeSpender_TemplateC_Back.png",

    amountLabelNew = Resources.AppDialogBigBoldLabel_white:new {
		resource = "AppDialogBigBoldLabel_white",
		alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, -55},
		widthLimit = 270,
		zorder = 2,
        highlightColor = "Cascade_Pink",
        shadowColor = "Cascade_Pink",

        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
            fontSize = 110,
        },
	},

    PriceText = Resources.AppTitleDialogLabel_big:new {
        resource = "AppTitleDialogLabel_big",
        text = STRINGS("???"),
        alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, 35},
        wrapLimit = 270,
        fgColor = "Cascade_Gold",
        shadowColor = "Cascade_Pink",
        shadowOffset = {1, 1},
        shadowAlpha = 255,
        highlightColor = "Cascade_Pink",
        highlightOffset = {-1, -1},
        highlightAlpha = 255,
        font = Resources.DialogTitleFont:new{
            resource = "DialogTitleFont",
            fontSize = 50,
        },
        visible = false,
    },
}

Resources.OfferPackDialogC_OfferPack_03 = Resources.OfferPackDialogC:new {
	resource = "OfferPackDialogC",
    name = "OfferPackDialogC_OfferPack_03",
	image = "DialogLapsedMedium_TemplateC_Back.png",

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidTop,
        alignmentOffset = {0, 66-10},
		wrapLimit = 270,
        fgColor = "White",
        shadowColor = "Cascade_DarkBrown",
        highlightColor = "Cascade_DarkBrown",

		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		visible = false,
	},

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, -5},
		wrapLimit = 270,
        fgColor = "White",
        shadowColor = "Cascade_DarkBrown",
        highlightColor = "Cascade_DarkBrown",
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-15, 0},
            text = "/",
            fgColor = "White",
            wrapLimit = 270,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    saleTag = Resources.MoonTag:new {
        resource = "MoonTag",
        alignment = Center,
		alignTo = TopLeft,
		alignmentOffset = {66, 62},
    },
}

Resources.OfferPackDialogC_OfferPack_04 = Resources.OfferPackDialogC:new {
	resource = "OfferPackDialogC",
    name = "OfferPackDialogC_OfferPack_04",
	image = "DialogLapsedLarge_TemplateC_Back.png",

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidTop,
        alignmentOffset = {0, 66-10},
		wrapLimit = 270,
        fgColor = "White",
        shadowColor = "Cascade_DarkBrown",
        highlightColor = "Cascade_DarkBrown",

		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		visible = false,
	},

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, -5},
		wrapLimit = 270,
        fgColor = "White",
        shadowColor = "Cascade_DarkBrown",
        highlightColor = "Cascade_DarkBrown",
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-17, 0},
            text = "/",
            fgColor = "White",
            wrapLimit = 270,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    saleTag = Resources.MoonTag:new {
        resource = "MoonTag",
        alignment = Center,
		alignTo = TopLeft,
		alignmentOffset = {66, 62},
    },
}

Resources.OfferPackDialogC_OfferPack_05 = Resources.OfferPackDialogC:new {
	resource = "OfferPackDialogC",
    name = "OfferPackDialogC_OfferPack_05",
	image = "DialogLapsedLarge_TemplateC_Back.png",

    descriptionLabel = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = MidTop,
        alignmentOffset = {0, 66-10},
		wrapLimit = 270,
        fgColor = "White",
        shadowColor = "Cascade_DarkBrown",
        highlightColor = "Cascade_DarkBrown",

		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontSize = 22,
		},
		visible = false,
	},

    amountLabelOld = Resources.AppDialogBoldLabel:new {
		resource = "AppDialogBoldLabel",
		alignment = Center,
        alignTo = Center,
        alignmentOffset = {0, -5},
		wrapLimit = 270,
        fgColor = "White",
        shadowColor = "Cascade_DarkBrown",
        highlightColor = "Cascade_DarkBrown",
        visible = false,

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontSize = 32,
		},

        strike = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Right,
            alignTo = Right,
            alignmentOffset = {-17, 0},
            text = "/",
            fgColor = "White",
            wrapLimit = 270,
            alpha = 240,
            extraScale = {2, 1.1},
            rotationAngle = {degrees = 25,},
            zorder = 3,

            font = Resources.DialogBoldFont:new{
                resource = "DialogBoldFont",
                fontSize = 40,
            },
        },
	},

    saleTag = Resources.MoonTag:new {
        resource = "MoonTag",
        alignment = Center,
		alignTo = TopLeft,
		alignmentOffset = {66, 62},
    },
}

Scripts.Preshow_BuyPowerupDialog_GiftPack = function(dialog,packageName)
	logprint("Preshow_BuyPowerupDialog_GiftPack")
	local saleTag = dialog:FindChild("saleTag",true)
	local percentOffConfig = "GiftPack_PercentOff_"..packageName
	local percentOff = CONFIG:RetrieveInteger(percentOffConfig,0)
	logprint(packageName)
	logprint(percentOffConfig)
	if (percentOff <= 0) then
		saleTag.visible = false
	else
		saleTag.localizedLabel.text = string.format(STRINGS("GiftPackPriceSaleMoreFMT"),percentOff)
		saleTag.visible = true
	end
end

Resources.AprilFoolsFixDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "AprilFoolsFixDialog",
    class = "AprilFoolsFixDialog",
    introScriptName = "SlideDownIntroDialog_TopBar",
    dialogExitScriptName = "SlideOffIntroDialog_TopBar",

	Jasper_Customer_Support = Resources.Actor:new {
		resource = "Actor",
		image = "Jasper_Customer_Support@2x.png",
		alignment = "MidTop",
		extraScale = 0.50,
		alignmentOffset = {0,10},
	},

    page_PromptToFixPositive = {
		class = "Actor",
		autoFillParent = true,
		visible = false,

		Title = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("Oops!"),
			alignment = MidTop,
			alignmentOffset = {0, 10},
	    },

        DescriptionLabel = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Center,
            alignmentOffset = {0, 0},
            alignTo = Center,
            text = STRINGS("AprilFoolsFixMessagePositiveBalance"),
            wrapLimit = 270,
            heightLimit = 130,
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 18,
            },
        },

		FixMeButtonPositive = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			alignment = Center,
            alignTo = MidBottom,
			alignmentOffset = {0, -100},
			text = STRINGS("Fix Me"),
		},

		SupportButton = Resources.AppButtonLarge:new {
            resource = "AppButtonLarge",
            text = STRINGS("Support"),
            alignment = Center,
            alignTo = MidBottom,
            alignmentOffset = {0, -45},
            textWidthLimit = 125,
            extraScale = 0.75,

            OnButtonClick = function(self, event)
                if self ~= event.button then return false end
                self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
                return true
            end,
        },
	},

    page_PromptToFixNegative = {
		class = "Actor",
		autoFillParent = true,
		visible = false,

		Title = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("Oops!"),
			alignment = MidTop,
			alignmentOffset = {0, 10},
	    },

        DescriptionLabel = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Center,
            alignmentOffset = {0, 0},
            alignTo = Center,
            text = STRINGS("AprilFoolsFixMessageNegativeBalance"),
            wrapLimit = 270,
            heightLimit = 130,
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 18,
            },
        },

		FixMeButtonNegative = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			alignment = Center,
            alignTo = MidBottom,
			alignmentOffset = {0, -100},
			text = STRINGS("Fix Me"),
		},

		SupportButton = Resources.AppButtonLarge:new {
            resource = "AppButtonLarge",
            text = STRINGS("Support"),
            alignment = Center,
            alignTo = MidBottom,
            alignmentOffset = {0, -45},
            textWidthLimit = 125,
            extraScale = 0.75,

            OnButtonClick = function(self, event)
                if self ~= event.button then return false end
                self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
                return true
            end,
        },
	},

	page_FixSuccessPositive = {
		class = "Actor",
		autoFillParent = true,
		visible = false,

		Title = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("All Fixed!"),
			alignment = MidTop,
			alignmentOffset = {0, 10},
	    },

        DescriptionLabel = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Center,
            alignmentOffset = {0, 10},
            text = STRINGS("AprilFoolsSuccessMessagePositiveBalance"),
            wrapLimit = 270,
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 18,
            },
        },

		OkayButton = Resources.AppButtonLarge:new {
			resource = "AppButtonLarge",
			alignment = Center,
            alignTo = MidBottom,
			alignmentOffset = {0, -100},
			text = STRINGS("Okay"),

            OnButtonClick = function(self, event)
                if self ~= event.button then return false end
                if self.dialog and self.screen then
					self.screen:StopDialog(self.dialog)
				end
                return true
            end,
		},

		SupportButton = Resources.AppButtonLarge:new {
            resource = "AppButtonLarge",
            text = STRINGS("Support"),
            alignment = Center,
            alignTo = MidBottom,
            alignmentOffset = {0, -45},
            textWidthLimit = 125,
            extraScale = 0.75,

            OnButtonClick = function(self, event)
                if self ~= event.button then return false end
                self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
                return true
            end,
        },
	},

    page_FixSuccessNegative = {
		class = "Actor",
		autoFillParent = true,
		visible = false,

		Title = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("All Fixed!"),
			alignment = MidTop,
			alignmentOffset = {0, 10},
	    },

        DescriptionLabel = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Center,
            alignmentOffset = {0, 10},
            text = STRINGS("AprilFoolsSuccessMessageNegativeBalance"),
            wrapLimit = 270,
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 18,
            },
        },

        FreeGoldButton = Resources.EndGameDialogBigButton:new {
			resource = "EndGameDialogBigButton",
            image = "ButtonPlastic_Long_Green.png",
			alignment = Center,
            alignTo = MidBottom,
			alignmentOffset = {0, -100},
			text = STRINGS("Get Free Gold"),
            textWidthLimit = 150,

            OnButtonClick = function(self, event)
                if self ~= event.button then return false end
                if self.dialog and self.screen then
					self.screen:StopDialog(self.dialog)
				end
                return true
            end,
		},

		SupportButton = Resources.AppButtonLarge:new {
            resource = "AppButtonLarge",
            text = STRINGS("Support"),
            alignment = Center,
            alignTo = MidBottom,
            alignmentOffset = {0, -45},
            textWidthLimit = 125,
            extraScale = 0.75,

            OnButtonClick = function(self, event)
                if self ~= event.button then return false end
                self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
                return true
            end,
        },
	},

    page_FixFail = {
		class = "Actor",
		autoFillParent = true,
		visible = false,

		Title = Resources.AppTitleDialogLabel_small:new {
			resource = "AppTitleDialogLabel_small",
			text = STRINGS("Oops!"),
			alignment = MidTop,
			alignmentOffset = {0, 10},
	    },

        DescriptionLabel = Resources.AppDialogBoldLabel:new {
            resource = "AppDialogBoldLabel",
            alignment = Center,
            alignmentOffset = {0, 10},
            text = STRINGS("AprilFoolsFailMessage"),
            wrapLimit = 270,
            font = Resources.DialogBoldFont:new {
                resource = "DialogBoldFont",
                fontSize = 18,
            },
        },

		SupportButton = Resources.AppButtonLarge:new {
            resource = "AppButtonLarge",
            text = STRINGS("Support"),
            alignment = Center,
            alignTo = MidBottom,
            alignmentOffset = {0, -45},
            textWidthLimit = 125,
            extraScale = 0.75,

            OnButtonClick = function(self, event)
                if self ~= event.button then return false end
                self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
                if self.dialog and self.screen then
					self.screen:StopDialog(self.dialog)
				end
                return true
            end,
        },
	},
}


Resources.DownloadProgressDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "DownloadProgressDialog",
    title = "",
	name = "DownloadProgressDialog",
	image = "DialogGeneric_Small.png",

	introScriptName = "DropDialog",
	dialogExitScriptName = "RaiseDialog",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Download Progress"),
		widthLimit = 270,
		alignment = MidTop,
		alignmentOffset = {0,50},
    },

    StatusLabel = Resources.AppDialogBoldLabel:new {
        resource = "AppDialogBoldLabel",
        alignment = Center,
        alignmentOffset = {0, 10},
        text = STRINGS("Downloading..."),
        wrapLimit = 270,
		heightLimit = 150,
        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
        },
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	SupportButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Support"),
		shortcutKey = "C",
		alignment = MidBottom,
		alignmentOffset = {0,-45},
		textLineSpacing = 3,
		visible = false,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
			self.screen:StopDialog(self.parent)
			return true
		end,

		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	ProgressBar = Resources.Actor:new {
		class = "Actor",
		image = "",
		alpha = 255,
		color = "White",
		size = {90 + 4 + 4, 10 + 4},
		maximumWidth = 90 + 4,
		alignment = MidBottom,
		alignmentOffset = {0,-50},

		barBacking = Resources.Actor:new {
			class = "Actor",
			alignment = MidLeft,
			alignmentOffset = {2,0},
			size = {90 + 4,10},
			image = "",
			color = "Black",
			zorder = 1,
		},

		barFilling = Resources.Actor:new {
			class = "Actor",
			alignment = MidLeft,
			alignmentOffset = {2,0},
			size = {50,10},
			image = "",
			color = "Green",
			zorder = 2,
		},
	},
}

Resources.DownloadProgressDialog_Spontaneous = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "DownloadProgressDialog",
    title = "",
	name = "DownloadProgressDialog",
	image = "DialogGeneric_Small.png",

	introScriptName = "DropDialog",
	dialogExitScriptName = "RaiseDialog",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = STRINGS("Download Progress"),
		widthLimit = 270,
		alignment = MidTop,
		alignmentOffset = {0,50},
    },

	subtitleText = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = STRINGS("We've got some fun new content for you."),
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
		alignment = MidTop,
		alignmentOffset = {0, 110},
		wrapLimit = 270,
		fgColor = "Black",
	},

	alternateErrorText = STRINGS("SpontaneousDownload_AlternateErrorText"),

    StatusLabel = Resources.AppDialogBoldLabel:new {
        resource = "AppDialogBoldLabel",
        alignment = Center,
        alignmentOffset = {0, 10},
        text = STRINGS("Downloading..."),
        wrapLimit = 270,
		heightLimit = 150,
        font = Resources.DialogBoldFont:new {
            resource = "DialogBoldFont",
        },
    },

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	SupportButton = Resources.AppButtonMediumSmall:new {
		resource = "AppButtonMediumSmall",
		text = STRINGS("Support"),
		shortcutKey = "C",
		alignment = MidBottom,
		alignmentOffset = {0,-45},
		textLineSpacing = 3,
		visible = false,
		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			self.screen:StartDialog("TechSupportDialog", "TechSupportDialog", true)
			self.screen:StopDialog(self.parent)
			return true
		end,

		OnPostSpawn = function (self)
			self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
		end,
	},

	ProgressBar = Resources.Actor:new {
		class = "Actor",
		image = "",
		alpha = 255,
		color = "White",
		size = {90 + 4 + 4, 10 + 4},
		maximumWidth = 90 + 4,
		alignment = MidBottom,
		alignmentOffset = {0,-50},

		barBacking = Resources.Actor:new {
			class = "Actor",
			alignment = MidLeft,
			alignmentOffset = {2,0},
			size = {90 + 4,10},
			image = "",
			color = "Black",
			zorder = 1,
		},

		barFilling = Resources.Actor:new {
			class = "Actor",
			alignment = MidLeft,
			alignmentOffset = {2,0},
			size = {50,10},
			image = "",
			color = "Green",
			zorder = 2,
		},
	},
}

local languageVerticalOffset = 40
local languageHorizontalOffset = 40

Resources.DebugLanguageDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
	class = "DebugLanguageDialog",
    title = "",
	name = "DebugLanguageDialog",

	maxNumberOfLanguages = 15,

	introScriptName = "DropDialog",
	dialogExitScriptName = "RaiseDialog",

    titleText = Resources.AppTitleDialogLabel:new {
		resource = "AppTitleDialogLabel",
		text = "Debug Choose Language",
		widthLimit = 210,
		alignment = MidTop,
		alignmentOffset = {0,20},
    },

	CurrentLanguageLabel = Resources.DialogLabel:new {
		resource = "DialogLabel",
		text = "",
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
        fgColor = "Black",
		alignment = MidTop,
		alignmentOffset = {0, 60},
		wrapLimit = 270,
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
	},

	Language1 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {-1 * languageHorizontalOffset, -2 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language2 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {0 * languageHorizontalOffset, -2 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language3 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {1 * languageHorizontalOffset, -2 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},

	Language4 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {-1 * languageHorizontalOffset, -1 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language5 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {0 * languageHorizontalOffset, -1 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language6 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {1 * languageHorizontalOffset, -1 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},

	Language7 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {-1 * languageHorizontalOffset, 0 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language8 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {0 * languageHorizontalOffset, 0 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language9 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {1 * languageHorizontalOffset, 0 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},

	Language10 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {-1 * languageHorizontalOffset, 1 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language11 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {0 * languageHorizontalOffset, 1 * languageVerticalOffset},
		buttonClosesDialog = true,
	},
	Language12 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {1 * languageHorizontalOffset, 1 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},


	Language13 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {-1 * languageHorizontalOffset, 2 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language14 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {0 * languageHorizontalOffset, 2 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
	Language15 = Resources.Button:new {
		resource = "Button",
		image = "btnBlankSmall.png",
		alignment = "Center",
		alignmentOffset = {1 * languageHorizontalOffset, 2 * languageVerticalOffset},
		buttonClosesDialog = true,
        textAlignmentOffset = {-2,-4},
	},
}

Resources.UpgradeRequiredPrompt = Resources.Dialog:new {
    resource = "Dialog",
    autoFillParent = true,
    title = "",
    alignment = "Center",
    introScriptName = "",
    name = "UpgradeRequiredPrompt",
    rolloverable = true,
    OnDialogStart = function (self)
        local LAYER_DIALOG = 1005
        self.layer = LAYER_DIALOG + 1
        self.zorder = LAYER_DIALOG + 1
    end,
    background = Resources.Actor:new {
        resource = "Actor",
        zorder = -1,
        image = "Bkg_sky.jpg",
    },
    upgradeDialog = Resources.LargeLongerDialog:new {
        resource = "LargeLongerDialog",
        alignment = Layout{"MidTop",android="Center"},
        alignmentOffset = Layout{{0, 50},android={0,0}},
        extraScale = Layout{1.0, iphone=0.85,},

        DialogInsert = Resources.Actor:new {
            resource = "Actor",
            image = "Dialog_Filler_A.png",
            alignment = "Center",
            alignmentOffset = {0,30},
            size = {250,180},
        },

        logoBanner = Resources.Actor:new {
            resource = "Actor",
            image = "logoBanner.png",
            alignment = "MidTop",
            alignmentOffset = {0,-50},
        },

        TitleLabel = Resources.AppTitleDialogLabel:new {
            resource = "AppTitleDialogLabel",
            text = STRINGS("GAME UPDATE"),
            alignment = Center,
            alignmentOffset = {0,-10},
            font = Resources.DialogTitleFont:new {
                resource = "DialogTitleFont",
                fontSize    = 40
            },
            zorder = 2,
        },

        text = Resources.AppDialogDataLabel:new {
            resource = "AppDialogDataLabel",
            font    = Resources.DialogFont:new{
                resource = "DialogFont",
                fontSize = 22,
            },
            text = STRINGS("DOWNLOAD NOW TO PLAY\nALL THE NEW CONTENT\nAND FEATURES!"),
            alignment = "Center",
            alignmentOffset = {0,60},
            heightLimit = 180,
            widthLimit = 250,
            zorder = 1,
        },

        --Forced Updated GET IT button

        updateButton = Resources.AppButtonSmall:new {
            resource = "AppButtonSmall",
            scripts = {"SparkleLoop"},
            alignment = "MidBottom",
            alignmentOffset = {0, -25},
            text = "Get it!",

            font	= Resources.MapButtonFont:new{
                resource = "MapButtonFont",
                fontSize = 40,
            },

            image = "ButtonPlastic_Long_Green.png",
            zorder = 1,

            textColor = "Cascade_BrightYellow",
            textHighlightColor = "Cascade_DarkGreen",
            textHighlightAlpha = 255,
            textShadowColor = "Cascade_DarkGreen",
            textShadowOffset = {1, 2},

            OnPostSpawn = function (self)
                self:AddObserver(EventMap.GURU_BUTTONCLICK, self)
            end,
            OnButtonClick = function (self, event)
                if self ~= event.button then return false end
                local url = GetAppStoreURL()
                OpenWebPage(url)
            end,
        },

        ButtonBevel = Resources.Actor:new {
            resource = "Actor",
            image = "ButtonPlastic_Long_WoodOutline.png",
            alignment = "MidBottom",
            alignmentOffset = {0, -25},
            zorder = 0,
        },
    },
}

Resources.WelcomeToLabEventsDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "WelcomeToLabEventsDialog",
	image = "Dialog_LabLevel.png",
    
	introScriptName = "DropDialog",
	dialogExitScriptName = "RaiseDialog",

	Banner = Resources.Actor:new {
		resource = "Actor",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {20, 5},
		image = "Dialog_LabLevel_Flag.png",
	},

    TextLabel1 = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Welcome to the"),
		alignment = MidTop,
		alignmentOffset = {0, 35},
		widthLimit = 180,
		textColor = "White",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 24,
		},
    },

	TextLabel2 = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("CASCADE"),
		alignment = MidTop,
		alignmentOffset = {0, 60},
		widthLimit = 180,
		textColor = "White",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 50,
		},
    },

	TextLabel2b = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("LEVEL LAB!"),
		alignment = MidTop,
		alignmentOffset = {0, 100},
		widthLimit = 180,
		textColor = "White",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 50,
		},
    },

	TextLabel3 = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("Join us in the Lab to:"),
		alignment = MidTop,
		alignmentOffset = {0, 145},
		widthLimit = 240,
		textColor = "White",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 24,
		},
    },

	TextLabel4 = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("-Play exclusive new levels!"),
		alignment = MidTop,
		alignmentOffset = {0, 175},
		widthLimit = 240,
		textColor = "Cascade_GreyBlue",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 16,
		},
    },

	TextLabel5 = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("-Compete against other players!"),
		alignment = MidTop,
		alignmentOffset = {0, 195},
		wrapLimit = 240,
		heightLimit = 40,
		textColor = "Cascade_PaleGold",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 16,
		},
    },

	TextLabel6 = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("-Win BIG prizes!"),
		alignment = MidTop,
		alignmentOffset = {0, 235},
		widthLimit = 240,
		textColor = "Cascade_GreyBlue",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 16,
		},
    },

	TextLabel7 = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("So put on your lab coat and get playing!"),
		alignment = MidTop,
		alignmentOffset = {0, 260},
		wrapLimit = 240,
		heightLimit = 50,
		textColor = "White",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 24,
		},
    },

	Jasper = Resources.Actor:new {
		resource = "Actor",
		alignment = "BottomLeft",
		alignTo = "BottomLeft",
		alignmentOffset = {-35, 5},
		image = "JasperLabcoat.png",
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		image = "Dialog_LabLevel_CloseButton.png",
		alignmentOffset = {-10, 6},
	},
	
    PlayButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Button_LabLevelPlay.png",
        text = STRINGS("Okay!"),
        alignment = "MidBottom",
        alignmentOffset = {0, -22},
        textWidthLimit = 120,
		textColor = "Cascade_BrightYellow",
		textHighlightColor = "Cascade_DarkGreen",
		textHighlightAlpha = 255,
		textShadowColor = "Cascade_DarkGreen",
		textShadowOffset = {1, 3},
		
		font = Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 44,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			LAB_EVENT_MGR:ShowEventDialog()
			if self.dialog and self.screen then
				self.screen:StopDialog(self.dialog)
			end
			return true
		end,
    },
}

Resources.LabEventLeaderboardArea = Resources.Actor:new {
	resource = "Actor",
	class = "LabEventLeaderboardArea",
	size = {237, 0},

	HighlightBackground = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		image = "Dialog_Highlight.png",
		visible = false,
	},

	LoadingLabel = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		alignment = "MidTop",
		alignTo = "Center",
		alignmentOffset = {0, 25},
		widthLimit = 175,
		textColor = "White",
		shadowColor = "Black",
		shadowAlpha = 150,
		shadowOffset = {1, 1},
		text = STRINGS("Loading"),
		
		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
	},
}

Resources.LabEventLeaderboardRow = Resources.Actor:new {
	resource = "Actor",
	size = {237, 20};

	RankLabel = Resources.AppDialogSmallLabel:new {
        resource = "AppDialogSmallLabel",
        alignTo = "MidLeft",
        alignment = "MidLeft",
        alignmentOffset = {5, 0},
		widthLimit = 50,
		textColor = "Cascade_GreyBlue",
		shadowColor = "Black",
		shadowAlpha = 150,
		shadowOffset = {1, 1},
    },

	NameLabel = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
        alignTo = "MidLeft",
        alignment = "MidLeft",
        alignmentOffset = {60, 0},
		widthLimit = 80,
		textColor = "Cascade_GreyBlue",
		shadowColor = "Black",
		shadowAlpha = 150,
		shadowOffset = {1, 1},
	},

	ScoreLabel = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
        alignTo = "MidRight",
        alignment = "MidRight",
        alignmentOffset = {-5, 0},
		widthLimit = 80,
		textColor = "Cascade_GreyBlue",
		shadowColor = "Black",
		shadowAlpha = 150,
		shadowOffset = {1, 1},
	},
}

Resources.LabEventMiniLeaderboardRow = Resources.LabEventLeaderboardRow:new {
	resource = "LabEventLeaderboardRow",
	alignment = "MidTop",
	alignTo = "MidTop",

	ScoreLabel = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
        alignTo = "MidRight",
        alignment = "MidRight",
        alignmentOffset = {-12, 0},
		widthLimit = 80,
		textColor = "Cascade_GreyBlue",
		shadowColor = "Black",
		shadowAlpha = 150,
		shadowOffset = {1, 1},
	},

	TierIcon = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidLeft",
		alignTo = "MidRight",
		alignmentOffset = {-12, 0},
		image = "TierBadge_Gold.png",
		visible = false,

		TierLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = Center,
			alignmentOffset = {-1, -1},
			widthLimit = 30,
			textColor = "Black",
			text = "1",

			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontSize = 18,
			},
		},
	},
}

Resources.LabEventIntroDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "LabEventIntroDialog",
	class = "LabEventIntroDialog",
	image = "Dialog_LabLevel.png",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

	Banner = Resources.Actor:new {
		resource = "Actor",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {20, 5},
		image = "Dialog_LabLevel_Flag.png",
	},

    TitleText = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("LEVEL LAB!"),
		alignment = MidTop,
		alignmentOffset = {0, 26},
		widthLimit = 180,
		textColor = "White",
		
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 45,
		},
    },

	ErasedBackground = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 68},
		image = "Banner_Objectives.png",

		DescriptionLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = Center,
			alignmentOffset = {0, -12},
			widthLimit = 242,
			textColor = "White",
			shadowColor = "Cascade_DarkBlue",
			shadowOffset = {1, 2},	

			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontSize = 28,
			},
		},

		TimeRemainingLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = Center,
			alignmentOffset = {0, 14},
			widthLimit = 242,
			textColor = "White",
			shadowColor = "Cascade_DarkBlue",
			shadowOffset = {1, 2},

			font = Resources.DialogBoldFont:new {
				resource = "DialogBoldFont",
				fontSize = 20,
			},
				
			Tick = function(self)
				local timeRemainingText = LAB_EVENT_MGR:GetTimeRemainingText(true)
				self.text = string.format("%s%s", STRINGS("Ends in "), timeRemainingText)
			end,
		},
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		image = "Dialog_LabLevel_CloseButton.png",
		alignmentOffset = {-10, 6},
	},

	PrizesButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Button_Prize.png",
        text = STRINGS("PRIZES"),
        alignment = "Center",
		alignTo = "Center",
        alignmentOffset = {0, -46},
        textWidthLimit = 80,
		textAlignmentOffset = {-28, -2},
		textColor = "White",
		textHighlightColor = "Cascade_DarkBlue",
		textHighlightAlpha = 255,
		textShadowColor = "Cascade_DarkBlue",
		textShadowOffset = {1, 3},
		visible = false,

		font = Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 44,
		},

		PrizeIcon = Resources.Actor:new {
			resource = "Actor",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {47, -2},
			image = "Prize_Gold.png",
		},

		PrizeQuantityCircle = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidLeft",
			alignTo = "MidRight",
			alignmentOffset = {-30, 10},
			image = "LabLevel_Circle.png",

			PrizeQuantityLabel = Resources.AppDialogLabel:new {
				resource = "AppDialogLabel",
				alignment = Center,
				alignmentOffset = {0, 0},
				font = Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontSize = 16,
				},
				widthLimit = 20,
				textColor = "Black",
				text = "000",
			},
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			LAB_EVENT_MGR:ShowPrizeDialog()
			return true
		end,
    },

	LeadersButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Button_Leader.png",
        text = STRINGS("LEADERS"),
        alignment = "Center",
		alignTo = "Center",
        alignmentOffset = {0, 7},
        textWidthLimit = 75,
		textColor = "White",
		textHighlightColor = "Cascade_DarkBlue",
		textHighlightAlpha = 255,
		textShadowColor = "Cascade_DarkBlue",
		textShadowOffset = {1, 3},
		visible = false,

		font = Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 44,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			LAB_EVENT_MGR:ShowLeaderboardDialog(false)
			return true
		end,
    },

	LeaderboardArea = Resources.LabEventLeaderboardArea:new {
		resource = "LabEventLeaderboardArea",
		alignment = "MidTop",
		alignTo = "Center",
		alignmentOffset = {0, 28},
		visible = false,
	},

    PlayButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Button_LabLevelPlay.png",
        text = STRINGS("Play"),
        alignment = "MidBottom",
        alignmentOffset = {0, -22},
        textWidthLimit = 120,
		textColor = "Cascade_BrightYellow",
		textHighlightColor = "Cascade_DarkGreen",
		textHighlightAlpha = 255,
		textShadowColor = "Cascade_DarkGreen",
		textShadowOffset = {1, 3},
		visible = false,

		font = Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 44,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			LAB_EVENT_MGR:PlayEventGame()
			if self.dialog and self.screen then
				self.screen:StopDialog(self.dialog)
			end
			return true
		end,
    },

	MessageLabel = Resources.AppDialogSmallLabel:new {
		resource = "AppDialogSmallLabel",
		alignment = "MidTop",
		alignTo = "Center",
		alignmentOffset = {0, 0},
		wrapLimit = 175,
		heightLimit = 125,
		textColor = "White",
		shadowColor = "Black",
		shadowAlpha = 150,
		shadowOffset = {1, 1},
		text = STRINGS("Log in to compete in Level Lab events and win big prizes!");
		visible = false,

		font = Resources.DialogFont:new{
			resource = "DialogFont",
			fontSize = 24,
		},
	},

	ConnectButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Button_LabLevelPlay.png",
        text = STRINGS("Log In"),
        alignment = "MidBottom",
        alignmentOffset = {0, -22},
        textWidthLimit = 120,
		textColor = "Cascade_BrightYellow",
		textHighlightColor = "Cascade_DarkGreen",
		textHighlightAlpha = 255,
		textShadowColor = "Cascade_DarkGreen",
		textShadowOffset = {1, 3},
		visible = false,

		font = Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 44,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			LAB_EVENT_MGR:LogIn()
			if self.dialog and self.screen then
				self.screen:StopDialog(self.dialog)
			end
			return true
		end,
    },

	OnPostSpawn = function(self)
		self.ErasedBackground.DescriptionLabel.text = LAB_EVENT_MGR:GetMetricDescriptionText(false)
	end,
}

Scripts.Present_LabEventIntroDialog = function (dialog)
    PlaySound("carnival_game_win_ding_08.ogg")
end

Resources.LabEventClaimDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "LabEventClaimDialog",
	image = "Dialog_LabLevel.png",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    Banner = Resources.Actor:new {
		resource = "Actor",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {20, 5},
		image = "Dialog_LabLevel_Flag.png",
	},

    TitleText = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("LEVEL LAB!"),
		alignment = "MidTop",
		alignmentOffset = {0, 26},
		widthLimit = 180,
		textColor = "White",

        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 45,
		},
    },

    DescriptionLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = "MidTop",
		alignmentOffset = {0, 70},
		widthLimit = 242,
		textColor = "White",
		
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 20,
		},
	},

	LoadingLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0, -25},
		wrapLimit = 242,
		textColor = "White",
		text = STRINGS("Loading"),

		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 24,
		},
	},

	ProgressBox = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {12, 105},
		image = "LabLevelClaim_SmallLine.png",
		visible = false,

		ProgressCounter = Resources.ScoreCounter:new {
			resource = "ScoreCounter",
			alignment = "MidRight",
			alignTo = "MidRight",
			alignmentOffset = {-15, 0},

			useCurrency = false,
			useComma = true,
			score = 0,

			labelProperties = {
				resource = "AppDialogLabel",
				widthLimit = 125,
				textColor = "White",

				font = Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontName = "KGBrokenVesselsSketch.ttf",
					fontSize = 30,
				},
			}
		},

		ProgressIcon = Resources.Actor:new {
			resource = "Actor",
			alignment = "Center",
			alignTo = "MidLeft",
			alignmentOffset = {0, 0},
			image = "Goal_Score.png",
		},
	},

	ErrorLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 185},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 24,
		},
		wrapLimit = 242,
		textColor = "White",
		text = STRINGS("Oops! We couldn't post your score. Don't worry, we'll try again later!"),
		visible = false,
	},

	LeaderboardBox = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 185},
		image = "LabLevelClaim_LargeLine.png",
		visible = false,

		PrizeActor = Resources.Actor:new {
			resource = "Actor",
			alignment = "Center",
			alignTo = "MidTop",
			alignmentOffset = {0, 21},
			image = "PrizeBadgeLarge_Gold.png",
			visible = false,

			PrizeIcon = Resources.Actor:new {
				resource = "Actor",
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = {-1, -1},
				image = "Prize_Gold.png",
				visible = false,
			},

			PrizeQuantityCircle = Resources.Actor:new {
				resource = "Actor",
				alignment = "MidLeft",
				alignTo = "MidRight",
				alignmentOffset = {-30, 10},
				image = "LabLevel_Circle.png",
				zorder = 2,
				visible = false,

				PrizeQuantityLabel = Resources.AppDialogLabel:new {
					resource = "AppDialogLabel",
					alignment = Center,
					alignmentOffset = {0, 0},
					font = Resources.DialogBoldFont:new{
						resource = "DialogBoldFont",
						fontSize = 16,
					},
					widthLimit = 20,
					textColor = "Black",
					text = "000",
				},
			},
		},

		RankTextLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {15, 5},
			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontName = "KGBrokenVesselsSketch.ttf",
				fontSize = 24,
			},
			widthLimit = 65,
			textColor = "White",
			text = STRINGS("Rank"),
			visible = false,
		},

		RankLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = "MidRight",
			alignTo = "MidRight",
			alignmentOffset = {-15, 5},
			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontName = "KGBrokenVesselsSketch.ttf",
				fontSize = 24,
			},
			widthLimit = 115,
			textColor = "White",
			text = "#258790",
			visible = false,
		},

		ScoreTextLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {15, 35},
			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontName = "KGBrokenVesselsSketch.ttf",
				fontSize = 24,
			},
			widthLimit = 65,
			textColor = "White",
			text = STRINGS("Score"),
			visible = false,
		},

		ScoreCounter = Resources.ScoreCounter:new {
			resource = "ScoreCounter",
			alignment = "MidRight",
			alignTo = "MidRight",
			alignmentOffset = {-15, 35},
			visible = false,

			useCurrency = false,
			useComma = true,
			score = 0,

			labelProperties = {
				resource = "AppDialogLabel",
				widthLimit = 115,
				textColor = "White",

				font = Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontName = "KGBrokenVesselsSketch.ttf",
					fontSize = 24,
				},
			}
		},
	},

	OKButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Button_LabLevelPlay.png",
        text = STRINGS("Okay!"),
        alignment = "MidBottom",
        alignmentOffset = {0, -22},
        textWidthLimit = 120,
		textColor = "Cascade_BrightYellow",
		textHighlightColor = "Cascade_DarkGreen",
		textHighlightAlpha = 255,
		textShadowColor = "Cascade_DarkGreen",
		textShadowOffset = {1, 3},

		font = Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 44,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			if self.dialog and self.screen then
				self.screen:StopDialog(self.dialog)
			end
			return true
		end,
    },

	OnPostSpawn = function(self)
		self.DescriptionLabel.text = LAB_EVENT_MGR:GetMetricDescriptionText(false)
	end,
}

Scripts.Present_LabEventClaimDialog = function (dialog, postResult, metric, progress, tier, consumable, amount, rank, score, oldScore)

    PlaySound("carnival_game_win_ding_06.ogg")

    ScriptDelay(500, "DialogTimers")
	local loadingLabel = dialog:FindChild("LoadingLabel", true)

	if (postResult == "success") or (postResult == "error") then
		loadingLabel.visible = false

		local progressBox = dialog:FindChild("ProgressBox", true)
		progressBox.visible = true
		local progressIcon = progressBox:FindChild("ProgressIcon", true)
		progressIcon.image = LabEventMetricImages[metric]

        PlaySound("swish10.ogg")
		FadeIn(progressBox, 150)
		ScaleIn(progressBox, {1.5, 1.5}, 150, false)
		ScriptDelay(100, "DialogTimers")
        PlaySound("card_deal01_fast.ogg")

		ScriptDelay(250, "DialogTimers");
		local progressCounter = progressBox:FindChild("ProgressCounter", true)
		progressCounter:SetScore(progress, false)

		PlaySound("carnival_game_win_ding_01.ogg")
		ScriptDelay(500, "DialogTimers")
		PlaySound("carnival_game_win_ding_02.ogg")
		CorrectedPop(progressCounter)
		ScriptDelay(250, "DialogTimers")

		if (postResult == "success") then
			local leaderboardBox = dialog:FindChild("LeaderboardBox", true)
			
			local prizeActor = leaderboardBox:FindChild("PrizeActor", true)
			if (tier == 1) then
				prizeActor.image = "PrizeBadgeLarge_Gold.png"
			elseif (tier == 2) then
				prizeActor.image = "PrizeBadgeLarge_Silver.png"
			elseif (tier == 3) then
				prizeActor.image = "PrizeBadgeLarge_Bronze.png"
			else
				prizeActor.image = "Badge_TryAgain.png"
			end

			local prizeIcon = prizeActor:FindChild("PrizeIcon", true)
			prizeIcon.image = PowerupDialogImages[string.format("%s_prize", consumable)]
			
			local quantityLabel = prizeActor:FindChild("PrizeQuantityLabel", true)
			quantityLabel.text = Int2Comma(amount)
			
			local rankTextLabel = leaderboardBox:FindChild("RankTextLabel", true)

			local rankLabel = leaderboardBox:FindChild("RankLabel", true)
			rankLabel.text = string.format("#%s", Int2Comma(rank))

			local scoreTextLabel = leaderboardBox:FindChild("ScoreTextLabel", true)
			
			local scoreCounter = leaderboardBox:FindChild("ScoreCounter", true)
			scoreCounter:SetScore(oldScore, true)

			if (tier == 1) then
				PlaySound("carnival_game_win_ding_09.ogg")
			elseif (tier == 2) then
				PlaySound("carnival_game_win_ding_07.ogg")
			elseif (tier == 3) then
				PlaySound("carnival_game_win_ding_05.ogg")
			end

            PlaySound("swish10.ogg")
			if (tier > 0) then
				FadeIn(leaderboardBox, 250)
			else
				FadeInNoChildren(leaderboardBox, 250)
				FadeInNoChildren(prizeActor, 250)
				FadeIn(rankTextLabel, 250)
				FadeIn(rankLabel, 250)
				FadeIn(scoreTextLabel, 250)
				FadeIn(scoreCounter, 250)
			end
			ScaleIn(leaderboardBox, {1.5, 1.5}, 250, false)
			ScriptDelay(200, "DialogTimers")
            PlaySound("card_deal01_fast.ogg")

			ScriptDelay(250, "DialogTimers");

			if (score > oldScore) then
				scoreCounter:SetScore(score, false)
				PlaySound("carnival_game_win_ding_01.ogg")
				ScriptDelay(500, "DialogTimers")
				PlaySound("carnival_game_win_ding_02.ogg")
				CorrectedPop(scoreCounter)
				ScriptDelay(250, "DialogTimers")
			end

			if (tier == 1) then
				PlaySound("air_cannon_pressure_release_02.ogg")
				FireParticle(dialog.TitleText,"Confetti1_normal_shape_short","MidTop",dialog.hgeParticles)
				FireParticle(dialog.TitleText,"Confetti2_normal_shape_short","MidTop",dialog.hgeParticles)
				FireParticle(dialog.TitleText,"Confetti3_normal_shape_short","MidTop",dialog.hgeParticles)
				FireParticle(dialog.TitleText,"Confetti4_normal_shape_short","MidTop",dialog.hgeParticles)
				FireParticle(dialog.TitleText,"Confetti5_normal_shape_short","MidTop",dialog.hgeParticles)
				FireParticle(dialog.TitleText,"Confetti6_normal_shape_short","MidTop",dialog.hgeParticles)
			end
		elseif (postResult == "error") then
			local errorLabel = dialog:FindChild("ErrorLabel", true)
			errorLabel.visible = true
		end
	elseif (postResult == "eventOver") then
		loadingLabel.text = STRINGS("Sorry! We couldn't post your score because the event has ended.")
	elseif (postResult == "noProgress") then
		loadingLabel.text = STRINGS("You didn't score any points towards the event. Give it another shot!")
	elseif (postResult == "lost") then
		loadingLabel.text = STRINGS("Complete level to enter score on leaderboard.")
	end
	--ScriptDelay(750, "DialogTimers")
    --PlaySound("carnival_game_win_ding_09.ogg")
end

Resources.LabEventResultsDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "LabEventResultsDialog",
	class = "LabEventResultsDialog",
	image = "Dialog_LabLevelLong.png",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    Banner = Resources.Actor:new {
		resource = "Actor",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {20, 5},
		image = "Dialog_LabLevel_Flag.png",
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		image = "Dialog_LabLevel_CloseButton.png",
		alignmentOffset = {-10, 6},
		visible = false,
	},

    TitleText = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("LEVEL LAB!"),
		alignment = "MidTop",
		alignmentOffset = {0, 26},
		widthLimit = 180,
		textColor = "White",
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 45,
		},
    },

	DescriptionLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = "MidTop",
		alignmentOffset = {0, 70},
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 20,
		},
		widthLimit = 242,
		textColor = "White",
	},

	WinnerBackground = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 90},
		image = "Dialog_LabLevel_Erased.png",
		visible = false,

		ResultLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = Center,
			alignmentOffset = {0, 0},
			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontName = "KGBrokenVesselsSketch.ttf",
				fontSize = 45,
			},
			widthLimit = 242,
			textColor = "White",
			text = STRINGS("WINNER!!!");
			visible = false,
		},
	},

	LoserBackground = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 90},
		image = "Dialog_LabLevel_ErasedBig.png",
		visible = false,

		ResultLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignment = Center,
			alignmentOffset = {0, 0},
			font = Resources.DialogBoldFont:new{
				resource = "DialogBoldFont",
				fontName = "KGBrokenVesselsSketch.ttf",
				fontSize = 35,
			},
			wrapLimit = 235,
			textColor = "White",
			text = STRINGS("Try Again Next Time!");
			visible = false,
		},
	},

	ClaimButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Button_Winner_Tier3.png",
        text = STRINGS("Claim"),
        alignment = "Center",
		alignTo = "Center",
        alignmentOffset = {0, -8},
        textWidthLimit = 110,
		textColor = "Cascade_BrightYellow",
		textHighlightColor = "Cascade_DarkGreen",
		textHighlightAlpha = 255,
		textShadowColor = "Cascade_DarkGreen",
		textShadowOffset = {1, 3},
		textAlignmentOffset = {0, 27},
		visible = false,
		zorder = 2,

		hgeParticles = {
			class = "hgeParticleLayer",
			zorder = 10,
		},

		font = Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 44,
		},

		PrizeIcon = Resources.Actor:new {
			resource = "Actor",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {-3, -24},
			image = "Prize_Gold.png",
		},

		PrizeQuantityCircle = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidLeft",
			alignTo = "Center",
			alignmentOffset = {6, -13},
			image = "LabLevel_Circle.png",

			PrizeQuantityLabel = Resources.AppDialogLabel:new {
				resource = "AppDialogLabel",
				alignment = Center,
				alignmentOffset = {0, 0},
				font = Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontSize = 16,
				},
				widthLimit = 20,
				textColor = "Black",
				text = "000",
			},
		},
    },

	EmptyPrizeActor = Resources.Actor:new {
        resource = "Actor",
        image = "Badge_TryAgain.png",
        alignment = "Center",
		alignTo = "Center",
        alignmentOffset = {0, 10},
        visible = false,
		zorder = 2,
	},

	LeadersButton = Resources.EndGameDialogBigButton:new {
        resource = "EndGameDialogBigButton",
        image = "Button_Leader.png",
        text = STRINGS("LEADERS"),
        alignment = "Center",
		alignTo = "Center",
        alignmentOffset = {0, 75},
        textWidthLimit = 75,
		textColor = "White",
		textHighlightColor = "Cascade_DarkBlue",
		textHighlightAlpha = 255,
		textShadowColor = "Cascade_DarkBlue",
		textShadowOffset = {1, 3},

		font = Resources.AppButtonFont:new{
			resource = "AppButtonFont",
			fontSize = 44,
		},

		OnButtonClick = function (self, event)
			if self ~= event.button then return false end
			LAB_EVENT_MGR:ShowLeaderboardDialog(true)
			return true
		end,
    },

	LeaderboardArea = Resources.LabEventLeaderboardArea:new {
		resource = "LabEventLeaderboardArea",
		alignment = "MidTop",
		alignTo = "Center",
		alignmentOffset = {0, 94},
	},

	OnPostSpawn = function(self)
		self.DescriptionLabel.text = LAB_EVENT_MGR:GetMetricDescriptionText(true)
	end,
}

Scripts.Present_LabEventResultsDialog = function (dialog, didWin, tier, consumable, amount)
    PlaySound("carnival_game_win_ding_11.ogg")
	ScriptDelay(500, "DialogTimers")
	if (didWin) then
		local winnerBackground = dialog:FindChild("WinnerBackground", true)
		winnerBackground.visible = true

		ScriptDelay(250, "DialogTimers")

        local winnerLabel = winnerBackground:FindChild("ResultLabel", true)
		winnerLabel.visible = true

		PlaySound("swish10.ogg")
        FadeIn(winnerLabel, 150)
		ScaleIn(winnerLabel, {1.5, 1.5}, 150, false)
		ScriptDelay(100, "DialogTimers")
        PlaySound("card_deal01_fast.ogg")

		ScriptDelay(500, "DialogTimers")

		local claimButton = dialog:FindChild("ClaimButton", true)
		if (tier == 1) then
			claimButton.image = "Button_Winner_Tier1.png"
		elseif (tier == 2) then
			claimButton.image = "Button_Winner_Tier2.png"
		else
			claimButton.image = "Button_Winner_Tier3.png"
		end

		local prizeIcon = claimButton:FindChild("PrizeIcon", true)
		prizeIcon.image = PowerupDialogImages[string.format("%s_prize", consumable)]

		local quantityLabel = claimButton:FindChild("PrizeQuantityLabel", true)
		quantityLabel.text = Int2Comma(amount)

		if (tier == 1) then
			PlaySound("carnival_game_win_ding_09.ogg")
		elseif (tier == 2) then
			PlaySound("carnival_game_win_ding_07.ogg")
		elseif (tier == 3) then
			PlaySound("carnival_game_win_ding_05.ogg")
		end

		claimButton.visible = true
		CorrectedPop(claimButton)

        PlaySound("card_deal01_fast.ogg")

		FireParticle(claimButton, "StarToss1.bigger.yellow", "Center", claimButton.hgeParticles)
		FireParticle(claimButton, "SparkleBurst1", "Center", claimButton.hgeParticles)
		FireParticle(claimButton, "Shine1", "Center", claimButton.hgeParticles)

		--ScriptDelay(500, "DialogTimers")
        --PlaySound("carnival_game_win_ding_12.ogg")
	else
		local cancelButton = dialog:FindChild("CancelButton", true)
		cancelButton.visible = true

		local loserBackground = dialog:FindChild("LoserBackground", true)
		loserBackground.visible = true

		ScriptDelay(500, "DialogTimers")

		local loserLabel = loserBackground:FindChild("ResultLabel", true)
		loserLabel.visible = true
        PlaySound("swish10.ogg")
		FadeIn(loserLabel, 150)
		ScaleIn(loserLabel, {1.5, 1.5}, 150, false)
		ScriptDelay(100, "DialogTimers")
        PlaySound("card_deal01_fast.ogg")
		ScriptDelay(100, "DialogTimers")

		ScriptDelay(250, "DialogTimers")
		PlaySound("Cascade_Aw.ogg")

		local emptyPrize = dialog:FindChild("EmptyPrizeActor", true)
		emptyPrize.visible = true
		FadeIn(emptyPrize, 250)
	end
end

Resources.LabEventPrizeRow = Resources.Actor:new {
	resource = "Actor",
	image = "LabLevelClaim_SmallLine.png",

	PrizeActor = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "MidLeft",
		alignmentOffset = {0, 0},
		image = "PrizeBadgeLarge_Gold.png",

		PrizeIcon = Resources.Actor:new {
			resource = "Actor",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {-1, -1},
			image = "Prize_Gold.png",
		},

		PrizeQuantityCircle = Resources.Actor:new {
			resource = "Actor",
			alignment = "MidLeft",
			alignTo = "MidRight",
			alignmentOffset = {-30, 10},
			image = "LabLevel_Circle.png",
			zorder = 2,

			PrizeQuantityLabel = Resources.AppDialogLabel:new {
				resource = "AppDialogLabel",
				alignment = Center,
				alignmentOffset = {0, 0},
				font = Resources.DialogBoldFont:new{
					resource = "DialogBoldFont",
					fontSize = 16,
				},
				widthLimit = 20,
				textColor = "Black",
				text = "000",
			},
		},
	},

	TierLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = {40, -12},
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 20,
		},
		widthLimit = 130,
		textColor = "White",
	},

	RanksLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = "MidLeft",
		alignTo = "MidLeft",
		alignmentOffset = {40, 12},
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 20,
		},
		widthLimit = 130,
		textColor = "White",
	},
}

Resources.LabEventPrizeDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "LabEventPrizeDialog",
	class = "LabEventPrizeDialog",
	image = "Dialog_LabLevelLong.png",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    Banner = Resources.Actor:new {
		resource = "Actor",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {20, 5},
		image = "Dialog_LabLevel_Flag.png",
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		image = "Dialog_LabLevel_CloseButton.png",
		alignmentOffset = {-10, 6},
	},

    TitleText = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("PRIZES"),
		alignment = "MidTop",
		alignmentOffset = {0, 26},
		widthLimit = 180,
		textColor = "White",
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 45,
		},
    },

	TimeRemainingLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = "MidTop",
		alignmentOffset = {0, 75},
		font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 20,
		},
		widthLimit = 242,
		textColor = "White",

		Tick = function(self)
			local timeRemainingText = LAB_EVENT_MGR:GetTimeRemainingText(false)
			self.text = string.format("%s%s", STRINGS("Awarded in "), timeRemainingText)
		end,
	},

	UnrankedBackground = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 160},
		visible = false,

		EmptyPrizeActor = Resources.Actor:new {
			resource = "Actor",
			image = "Badge_TryAgain.png",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0, -20},
			zorder = 2,
		},

		MessageLabel = Resources.AppDialogLabel:new {
			resource = "AppDialogLabel",
			alignTo = "Center",
			alignment = "Center",
			alignmentOffset = {0, 30},
			wrapLimit = 210,
			heightLimit = 40,
			textColor = "White",
			text = STRINGS("Unranked");

			font = Resources.DialogBoldFont:new {
				resource = "DialogBoldFont",
				fontName = "KGBrokenVesselsSketch.ttf",
				fontSize = 20,
			},
		},
	},

	RankedBackground = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {0, 102},
		image = "Dialog_LabLevel_ErasedBig02.png",
		visible = false,

		PrizeActor = Resources.Actor:new {
			resource = "Actor",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0, -20},
			image = "PrizeBadgeLarge_Gold.png",

			PrizeIcon = Resources.Actor:new {
				resource = "Actor",
				alignment = "Center",
				alignTo = "Center",
				alignmentOffset = {-1, -1},
				image = "Prize_Gold.png",
			},

			PrizeQuantityCircle = Resources.Actor:new {
				resource = "Actor",
				alignment = "MidLeft",
				alignTo = "MidRight",
				alignmentOffset = {-30, 10},
				image = "LabLevel_Circle.png",
				zorder = 2,

				PrizeQuantityLabel = Resources.AppDialogLabel:new {
					resource = "AppDialogLabel",
					alignment = Center,
					alignmentOffset = {0, 0},
					font = Resources.DialogBoldFont:new{
						resource = "DialogBoldFont",
						fontSize = 16,
					},
					widthLimit = 20,
					textColor = "Black",
					text = "000",
				},
			},
		},

		LeaderboardRow = Resources.LabEventLeaderboardRow:new {
			resource = "LabEventLeaderboardRow",
			alignment = "Center",
			alignTo = "Center",
			alignmentOffset = {0, 30},
			size = {237, 20};

			RankLabel = Resources.AppDialogLabel:new {
				resource = "AppDialogLabel",
				alignTo = "MidLeft",
				alignment = "MidLeft",
				alignmentOffset = {5, 0},
				widthLimit = 50,
				textColor = "White",
				shadowAlpha = 0,

				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontName = "KGBrokenVesselsSketch.ttf",
					fontSize = 20,
				},
			},

			NameLabel = Resources.AppDialogLabel:new {
				resource = "AppDialogLabel",
				alignTo = "MidLeft",
				alignment = "MidLeft",
				alignmentOffset = {60, 0},
				widthLimit = 80,
				textColor = "White",
				shadowAlpha = 0,

				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontName = "KGBrokenVesselsSketch.ttf",
					fontSize = 20,
				},
			},

			ScoreLabel = Resources.AppDialogLabel:new {
				resource = "AppDialogLabel",
				alignTo = "MidRight",
				alignment = "MidRight",
				alignmentOffset = {-5, 0},
				widthLimit = 80,
				textColor = "White",
				shadowAlpha = 0,

				font = Resources.DialogBoldFont:new {
					resource = "DialogBoldFont",
					fontName = "KGBrokenVesselsSketch.ttf",
					fontSize = 20,
				},
			},
		},
	},

	topScrollBorder = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0, -5},
		image = "LabLevel_ScrollLine.png",
		zorder = 2,
	},

	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
        DisplayDimensions = {237, 175},
		horizontalScrollLocked = true,
		alignment = "MidTop",
		alignTo = "Center",
		alignmentOffset = {0, -5},
		SlowFraction = .95,
		stoppingVelocity = 1,
	},

	bottomScrollBorder = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0, 170},
		image = "LabLevel_ScrollLine.png",
		zorder = 2,
	},
}

Resources.LabEventLeaderboardDialog = Resources.LargeLongerDialog:new {
	resource = "LargeLongerDialog",
    name = "LabEventLeaderboardDialog",
	class = "LabEventLeaderboardDialog",
	image = "Dialog_LabLevelLong.png",

	introScriptName = "DropDialog_TopBar",
	dialogExitScriptName = "RaiseDialog_TopBar",

    Banner = Resources.Actor:new {
		resource = "Actor",
		alignment = "TopLeft",
		alignTo = "TopLeft",
		alignmentOffset = {20, 5},
		image = "Dialog_LabLevel_Flag.png",
	},

	CancelButton = Resources.CancelButton:new {
		resource = "CancelButton",
		image = "Dialog_LabLevel_CloseButton.png",
		alignmentOffset = {-10, 6},
	},

    TitleText = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		text = STRINGS("LEADERS"),
		alignment = "MidTop",
		alignmentOffset = {0, 26},
		widthLimit = 180,
		textColor = "White",
        font = Resources.DialogBoldFont:new {
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 45,
		},
    },

	ButtonArea = Resources.Actor:new {
		resource = "Actor",
		alignment = "MidTop",
		alignTo = "MidTop",
		alignmentOffset = {-4, 78},
		size = {237, 40},

		Tier1Button = Resources.AppButtonSmall:new {
			resource = "AppButtonSmall",
			image = "Button_Tier1.png",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {0, 0},
			checked = true,
			frame = 1,
			textWidthLimit = 40,
			textColor = "Cascade_DarkBrown",
			textHighlightColor = "White",
			textHighlightAlpha = 255,
			textShadowColor = "White",
			textShadowAlpha = 255,

			font = Resources.AppButtonFont:new{
				resource = "AppButtonFont",
				fontSize = 18,
			},

			UpdateVisibility = function (self)
				if (self.checked == true) then
					self.frame = 1
					self.textHighlightColor = "Cascade_LighterTan"
					self.textShadowColor = "Cascade_LighterTan"
					self.textAlignmentOffset = {0, 3}
				else
					self.frame = 0
					self.textHighlightColor = "White"
					self.textShadowColor = "White"
					self.textAlignmentOffset = {0, 1}
				end
			end,

			GetChecked = function (self)
				return self.checked
			end,

			SetChecked = function(self, newChecked)
				self.checked = newChecked
				self:UpdateVisibility()
			end,

			OnPostSpawn = function(self)
				self:UpdateVisibility()
			end,
		},

		Tier2Button = Resources.AppButtonSmall:new {
			resource = "AppButtonSmall",
			image = "Button_Tier2.png",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {60, 0},
			checked = false,
			frame = 0,
			textWidthLimit = 40,
			textColor = "Cascade_DarkBrown",
			textHighlightColor = "White",
			textHighlightAlpha = 255,
			textShadowColor = "White",
			textShadowAlpha = 255,

			font = Resources.AppButtonFont:new{
				resource = "AppButtonFont",
				fontSize = 18,
			},

			UpdateVisibility = function (self)
				if (self.checked == true) then
					self.frame = 1
					self.textHighlightColor = "Cascade_MediumGrey"
					self.textShadowColor = "Cascade_MediumGrey"
					self.textAlignmentOffset = {0, 3}
				else
					self.frame = 0
					self.textHighlightColor = "White"
					self.textShadowColor = "White"
					self.textAlignmentOffset = {0, 1}
				end
			end,

			GetChecked = function (self)
				return self.checked
			end,

			SetChecked = function(self, newChecked)
				self.checked = newChecked
				self:UpdateVisibility()
			end,

			OnPostSpawn = function(self)
				self:UpdateVisibility()
			end,
		},

		Tier3Button = Resources.AppButtonSmall:new {
			resource = "AppButtonSmall",
			image = "Button_Tier3.png",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {120, 0},
			checked = false,
			frame = 0,
			textWidthLimit = 40,
			textColor = "Cascade_DarkBrown",
			textHighlightColor = "White",
			textHighlightAlpha = 255,
			textShadowColor = "White",
			textShadowAlpha = 255,

			font = Resources.AppButtonFont:new{
				resource = "AppButtonFont",
				fontSize = 18,
			},

			UpdateVisibility = function (self)
				if (self.checked == true) then
					self.frame = 1
					self.textHighlightColor = "Cascade_LighterTan"
					self.textShadowColor = "Cascade_LighterTan"
					self.textAlignmentOffset = {0, 3}
				else
					self.frame = 0
					self.textHighlightColor = "White"
					self.textShadowColor = "White"
					self.textAlignmentOffset = {0, 1}
				end
			end,

			GetChecked = function (self)
				return self.checked
			end,

			SetChecked = function(self, newChecked)
				self.checked = newChecked
				self:UpdateVisibility()
			end,

			OnPostSpawn = function(self)
				self:UpdateVisibility()
			end,
		},

		MeButton = Resources.AppButtonSmall:new {
			resource = "AppButtonSmall",
			image = "Button_Me.png",
			alignment = "MidLeft",
			alignTo = "MidLeft",
			alignmentOffset = {180, 0},
			text = STRINGS("Me!"),
			textWidthLimit = 40,
			textColor = "Cascade_DarkBrown",
			textHighlightColor = "White",
			textHighlightAlpha = 255,
			textShadowColor = "White",
			textShadowAlpha = 255,
			textAlignmentOffset = {0, 1},
			
			font = Resources.AppButtonFont:new{
				resource = "AppButtonFont",
				fontSize = 18,
			},
		},
	},

	topScrollBorder = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0, -100},
		image = "LabLevel_ScrollLine.png",
		zorder = 2,
	},

	ScrollableArea = Resources.Actor:new {
		class = "ScrollableArea",
        DisplayDimensions = {237, 270},
		horizontalScrollLocked = true,
		alignment = "MidTop",
		alignTo = "Center",
		alignmentOffset = {0, -100},
		SlowFraction = .95,
		stoppingVelocity = 1,
	},

	HighlightBackground = Resources.Actor:new {
		resource = "Actor",
		image = "Dialog_Highlight.png",
		visible = false;
	},

	LoadingLabel = Resources.AppDialogLabel:new {
		resource = "AppDialogLabel",
		alignment = "MidTop",
		alignTo = "Center",
		alignmentOffset = {0, 0},
		font = Resources.DialogBoldFont:new{
			resource = "DialogBoldFont",
			fontName = "KGBrokenVesselsSketch.ttf",
			fontSize = 24,
		},
		wrapLimit = 225,
		textColor = "White",
		text = STRINGS("Loading"),
	},

	bottomScrollBorder = Resources.Actor:new {
		resource = "Actor",
		alignment = "Center",
		alignTo = "Center",
		alignmentOffset = {0, 170},
		image = "LabLevel_ScrollLine.png",
		zorder = 2,
	},
}

Resources.Level500Dialog = {
	class = "Dialog",
	image = "Dialog_Level500.png",
	name = "Level500Dialog",

	hgeParticles = {
		class = "hgeParticleLayer",
		zorder = 10,
	},

	CancelButton = Resources.CancelButton,

	youMadeItLabel = Resources.Label:new {
		resource = "Label",
		text = STRINGS("Hurrah! You made it to level"),
		font = Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 48,
		},
		widthLimit = 225,
		fgColor = "White",
		shadowColor = "Cascade_DarkBlue",
		shadowOffset = {2,2},
		highlightColor = "Cascade_DarkBlue",
		highlightOffset = {-2,-2},
		alignment = MidTop,
		alignmentOffset = {0,40},
	},


	fiveHundredLevel = Resources.Label:new {
		resource = "Label",
		text = STRINGS("500!"),
		font = Resources.DialogTitleFont:new{
			resource = "DialogTitleFont",
			fontSize = 164,
		},
		widthLimit = 210,
		fgColor = "White",
		shadowColor = "Cascade_DarkBlue",
		shadowOffset = {3,3},
		highlightColor = "Cascade_DarkBlue",
		highlightOffset = {-3,-3},
		alignment = MidTop,
		alignmentOffset = {0,54},
	},
}


Scripts.Present_Level500Dialog = function(dialog)
	PlaySound("slot_machine_win_02.ogg")
	ScriptDelay(500,"DialogTimers")
	PlaySound("air_cannon_pressure_release_02.ogg")
	FireParticle(dialog,"Confetti1_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti2_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti3_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti4_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti5_normal_shape_short","MidTop",dialog.hgeParticles)
	FireParticle(dialog,"Confetti6_normal_shape_short","MidTop",dialog.hgeParticles)
	PlaySound("crowd_indoor_cheer_02.ogg")
end