--Normal Board: 6x7
--Big Board: 7x8

PatternSetNames = {
	"PatternSet_Few",
	"PatternSet_Some",
	"PatternSet_Lots",
	"PatternSet_PatternMode",
	"EmptyPatterns",
}

EmptyPatterns = {
	BigBoardSubset = {
		dimensions = {7,8},
		patterns = {
			[1] = "BigEmptyPattern",
		},
	},
	NormalBoardSubset = {
		dimensions = {6,7},
		patterns = {
			[1] = "LittleEmptyPattern",
		},
	},
}

PatternSet_Few = {
	BigBoardSubset = {
		dimensions = {7,8},
		patterns = {
			[1] = "PatternFew_Small_1",
			[2] = "LittleMissingPattern1",
			[3] = "BigCratePattern4",
			[4] = "BigMissingPattern7",
			[5] = "InnerHole_large",
			[6] = "FourCornersSmall",
			[7] = "UnderFloors1_large",
			[8] = "UnderFloors2_large",
			[9] = "BottomJail1_Center_large",
			[10] = "SidePattern_Center_large",
			[11] = "BigCastle2_windows",
			[12] = "AAroundBottomSideCorners_inner",
			[13] = "Dungeon1_jails",
			[14] = "Dungeon2_sky3",
			[15] = "Dungeon2_floor1",
			[16] = "Dungeon2_bombs3",
			[17] = "Dungeon2_bombs4",
			[18] = "Dungeon4_cover1",
			[19] = "Dungeon4_cover2",
			[20] = "Dungeon5_inside2",
			[21] = "Dungeon5_jail1",
			[22] = "RandomSteel1",
			[23] = "Pile1_top",
			[24] = "TopFunnel3_Color1",
			[25] = "TopFunnel3_Color2",
			[26] = "TopFunnel3_Color3",
			[27] = "TopFunnel3_Color4",
			[28] = "TopFunnel3_Color5",
			[29] = "SteelJail1_Colors2",
			[30] = "SteelJail1_Colors3",
			[31] = "Silo1_seed",
			[32] = "FourTreasures",
			[33] = "CenterStrip",
			[34] = "Staggered",
			[35] = "CenterStripLow",
			[36] = "3LayerBombs_Large",
			[37] = "PatternFew_Large_2",
			[38] = "PatternFew_Large_3",
			[39] = "PatternFew_Large_4",
			[40] = "PatternFew_Large_5",
			[41] = "PatternFew_Large_6",
			[42] = "PatternFew_Large_7",
			[43] = "PatternFew_Large_8",
			[44] = "PatternFew_Large_9",
			[45] = "PatternFew_Large_10",
			[46] = "PatternFew_Large_11",
			[47] = "PatternFew_Large_12",
			[48] = "PatternFew_Large_13",
			[49] = "PatternFew_Large_14",
			[50] = "PatternFew_Large_15",

			--Large
		},
	},
	NormalBoardSubset = {
		dimensions = {6,7},
		patterns = {
			[1] = "PatternFew_Large_1",
			[2] = "BigMissingPattern1",
			[3] = "LittleMissingPattern2",
			[4] = "MissingSides1",
			[5] = "MissingSides1_spots1",
			[6] = "MissingSides1_spots2",
			[7] = "OuterCorners_empty",
			[8] = "StaircaseUp_empty",
			[9] = "InnerSquare",
			[10] = "InnerHole",
			[11] = "OuterRing_topleftcorner",
			[12] = "OuterRing_toprightcorner",
			[13] = "OuterRing_bottomleftcorner",
			[14] = "OuterRing_bottomrightcorner",
			[15] = "MissingOuterCorners",
			[16] = "AroundBottomCorners",
			[17] = "AroundTopCorners",
			[18] = "FourSpots1",
			[19] = "Columns_bottom",
			[20] = "Spots1",
			[21] = "UpperWindow",
			[22] = "BottomRightCorner",
			[23] = "SideSpots1",
			[24] = "TopBottomSpots1",
			[25] = "Wedge1_row5",
			[26] = "BombPattern1_top",
			[27] = "BombPattern1_middle",
			[28] = "TopFunnel2",
			[29] = "BottomSeeds1",
			[30] = "BombCell2",
			[31] = "BombCell1A",
			[32] = "Pile1_middle",
			[33] = "RandomPositions",
			[34] = "CenterStagger1",
			[35] = "CenterStagger2",
			[36] = "CenterStagger3",
			[37] = "CenterStagger4",
			[38] = "CenterStagger5",
			[39] = "LeftPairs1",
			[40] = "LeftPairs2",
			[41] = "LeftPairs3",
			[42] = "RightPairs1",
			[43] = "RightPairs2",
			[44] = "RightPairs3",
			[45] = "Help_Match1",
			[46] = "Help_Match2",
			[47] = "Help_Match4",
			[48] = "Help_Match4_SecondColor",
			[49] = "SixMatches_Match1",
			[50] = "SixMatches_Match2",
			[51] = "SixMatches_Match3",
			[52] = "SixMatches_Match4",
			[53] = "SixMatches_Match5",
			[54] = "SixMatches_Match6",

			--Normal
		},
	},
}

PatternSet_Some = {
	BigBoardSubset = {
		dimensions = {7,8},
		patterns = {
			[1] = "BigMissingPattern1",
			[2] = "Holes_BigMissingPattern",
			[3] = "BigCratePattern5",
			[4] = "BigMissingPattern2",
			[5] = "BigMissingPattern3",
			[6] = "BigMissingPattern4",
			[7] = "BigMissingPattern5",
			[8] = "BigMissingPattern6",
			[9] = "BigMissingPattern7",
			[10] = "InnerRing_large",
			[11] = "BigCastle1",
			[12] = "Spots2",
			[13] = "FourCorners",
			[14] = "Sides4_large",
			[15] = "NumberSign_large",
			[16] = "BottomPileTop1_large",
			[17] = "SidePattern_large",
			[18] = "LeftShelf1",
			[19] = "LeftShelf2",
			[20] = "LeftShelf3",
			[21] = "Steps1_large",
			[22] = "Shelves1_top",
			[23] = "Shelves1_bottom",
			[24] = "Pillars1_top",
			[25] = "BigCastle2_door",
			[26] = "Dungeon1_door",
			[27] = "Dungeon2_sky1",
			[28] = "Dungeon2_sky2",
			[29] = "Dungeon2_sky3",
			[30] = "Dungeon4_jail1",
			[31] = "Dungeon5_cover1",
			[32] = "Dungeon5_cover2",
			[33] = "SteelTestStone",
			[34] = "SteelTestCrates",
			[35] = "BombCell1",
			[36] = "Flow1",
			[37] = "Flow1_inner",
			[38] = "Flow1_inner2",
			[39] = "TopFunnel3",
			[40] = "TopFunnel3_top",
			[41] = "TopFunnel3_bottom",
			[42] = "Grid1",
			[43] = "Grid1_side",
			[44] = "FlowerPot1",
			[45] = "FlowerPot1_side",
			[46] = "SideSeeds_shelf",
			[47] = "SideSeeds_shelf2",
			[48] = "TopSlots",
			[49] = "DiagonalStripes_Large",
			[50] = "NotTopCorners_large",
			--Large
		},
	},
	NormalBoardSubset = {
		dimensions = {6,7},
		patterns = {
			[1] = "LittleMissingPattern3",
			[2] = "LittleMissingPattern4",
			[3] = "LittleMissingPattern5",
			[4] = "LittleCratePattern6",
			[5] = "LittleMissingPattern6",
			[6] = "FourBlocks",
			[7] = "OuterCorners",
			[8] = "OuterRing_sides",
			[9] = "MiddleSquare",
			[10] = "Inner_I",
			[11] = "OuterRing_bottom",
			[12] = "OuterBlock_topleftcorner",
			[13] = "OuterBlock_toprightcorner",
			[14] = "OuterBlock_bottomleftcorner",
			[15] = "OuterBlock_bottomrightcorner",
			[16] = "MiddleRing_top",
			[17] = "MiddleRing_bottom",
			[18] = "EightSpots1",
			[19] = "Columns_middles",
			[20] = "Castle2",
			[21] = "Castle3",
			[22] = "StripesAndColumns_alt1",
			[23] = "SmallStripe1",
			[24] = "FourCorners_small",
			[25] = "TopShelf",
			[26] = "TopFrame1",
			[27] = "LowerLine2",
			[28] = "Blocks1_large",
			[29] = "Blocks2_large",
			[30] = "CrateBlockers1",
			[31] = "NotchPattern1_reverse",
			[32] = "ButterflyPattern1",
			[33] = "ButterflyPattern1_reverse",
			[34] = "Sides4",
			[35] = "Blocks4",
			[36] = "InverseLine1",
			[37] = "SidePattern",
			[38] = "BottomCenterCover1",
			[39] = "BottomCenterSides2",
			[40] = "AroundBottomSideCorners",
			[41] = "AroundSides",
			[42] = "AroundSides_topbottom",
			[43] = "Wedge1",
			[44] = "Wedge1_row2",
			[45] = "Wedge1_row3",
			[46] = "Ledge1_row1",
			[47] = "Ledge1_row2",
			[48] = "Ledge1_row3",
			[49] = "Ledge1_row4",
			[50] = "BombVines1_cover",
			--Normal
		},
	},
}

PatternSet_Lots = {
	BigBoardSubset = {
		dimensions = {7,8},
		patterns = {
			[1] = "BigCratePattern3",
			[2] = "BigMissingPattern4",
			[3] = "BigMissingPattern5",
			[4] = "BigMissingPattern6",
			[5] = "BigCratePattern7",
			[6] = "Columns",
			[7] = "FourCorners",
			[8] = "MiddleLine2_large",
			[9] = "BottomPile1_large",
			[10] = "Floors1_large",
			[11] = "BottomJail1_large",
			[12] = "BottomJail1_Cover_large",
			[13] = "VineBattle1",
			[14] = "Shelves1",
			[15] = "Pillars1",
			[16] = "Dungeon1",
			[17] = "Dungeon2",
			[18] = "BombPattern1_crate",
			[19] = "Dungeon4_jail1",
			[20] = "SteelTestSteel",
			[21] = "TopFunnel3",
			[22] = "OutsideTriangles_Large",
			[23] = "DiagonalStripes_Large",
			[24] = "IsolateSidesLarge",
			[25] = "NotTopCorners_large",
			[26] = "BigDiamond",
			[27] = "CenterRect",
			[28] = "Striated",
			[29] = "U_Lining",
			[30] = "OuterNoTopLarge",
			[31] = "WallsAndShelves",
			[32] = "Chained",
			[33] = "PatternMany_Large1",
			[34] = "PatternMany_Large2",
			[35] = "PatternMany_Large3",
			[36] = "PatternMany_Large4",
			[37] = "PatternMany_Large5",
			[38] = "PatternMany_Large6",
			[39] = "PatternMany_Large7",
			[40] = "PatternMany_Large8",
			[41] = "PatternMany_Large9",
			[42] = "PatternMany_Large10",
			[43] = "PatternMany_Large11",
			[44] = "PatternMany_Large12",
			[45] = "PatternMany_Large13",
			[46] = "PatternMany_Large14",
			[47] = "PatternMany_Large15",
			[48] = "PatternMany_Large16",
			[49] = "PatternMany_Large17",
			[50] = "PatternMany_Large18",
			--Big
		},
	},
	NormalBoardSubset = {
		dimensions = {6,7},
		patterns = {
			[1] = "LittleCratePattern4",
			[2] = "LittleCratePattern5",
			[3] = "LittleCratePattern6",
			[4] = "FourBlocks",
			[5] = "OuterCorners2",
			[6] = "StaircaseUp",
			[7] = "OuterRing_noTop",
			[8] = "MiddleRing",
			[9] = "SimpleSquare",
			[10] = "Web",
			[11] = "Columns",
			[12] = "StripesAndColumns_corners",
			[13] = "SmallStripeWithLine",
			[14] = "SmallStripe2",
			[15] = "Castle4",
			[16] = "RightSide",
			[17] = "Stairs",
			[18] = "MiddleLine",
			[19] = "Blocks1",
			[20] = "CrateBlockers2",
			[21] = "Blocks3",
			[22] = "InverseStair1",
			[23] = "DumbBellPattern",
			[24] = "BarrierTestHorizontal",
			[25] = "BarrierTestPattern",
			[26] = "TopLine1",
			[27] = "StonePillars1",
			[28] = "BombCell2_stone",
			[29] = "Spout1",
			[30] = "BigTopCorners",
			[31] = "Intro_BigMatchSetup",
			[32] = "MultiColorSetup_Color2",
			[33] = "MultiColorSetup_Color3",
			[34] = "Quadrants",
			[35] = "Slopes",
			[36] = "BelowV",
			[37] = "PatternMany_Small1",
			[38] = "PatternMany_Small2",
			[39] = "PatternMany_Small3",
			[40] = "PatternMany_Small4",
			[41] = "PatternMany_Small5",
			[42] = "PatternMany_Small6",
			[43] = "PatternMany_Small7",
			[44] = "PatternMany_Small8",
			[45] = "PatternMany_Small9",
			[46] = "PatternMany_Small10",
			[47] = "PatternMany_Small11",
			[48] = "PatternMany_Small12",
			[49] = "PatternMany_Small13",
			[50] = "PatternMany_Small14",
			--Small
		},
	},
}

PatternSet_PatternMode = {
	BigBoardSubset = {
		dimensions = {7,8},
		patterns = {
			[1] = "BigCratePattern1",
			[2] = "BigCratePattern6",
			[3] = "BigCoverage1",
			[4] = "OuterRing_large",
			[5] = "OuterInnerRing_large",
			[6] = "BigStripes1",
			[7] = "FourCorners_pattern",
			[8] = "Stripes1",
			[9] = "RightShelves1",
			[10] = "RacingStripe1_large",
			[11] = "TopBlock1_large",
			[12] = "Steps1Top_large",
			[13] = "Pile1_large",
			[14] = "SteelJail1_top",
			[15] = "Silo1",
			[16] = "IsolateSidesLarge",
			[17] = "BigThreeNearBottomRows",
			[18] = "U_Lining",
			[19] = "WallsAndShelves",
			[20] = "PatternMode_Large1",
			[21] = "PatternMode_Large2",
			[22] = "PatternMode_Large3",
			[23] = "PatternMode_Large4",
			[24] = "PatternMode_Large5",
			[25] = "PatternMode_Large6",
			[26] = "PatternMode_Large7",
			[27] = "PatternMode_Large8",
			[28] = "PatternMode_Large9",
			[29] = "PatternMode_Large10",
			[30] = "PatternMode_Large11",
			[31] = "PatternMode_Large12",
			[32] = "PatternMode_Large13",
			[33] = "PatternMode_Large14",
			[34] = "PatternMode_Large15",
			[35] = "PatternMode_Large16",
			[36] = "PatternMode_Large17",
			[37] = "PatternMode_Large18",
			[38] = "PatternMode_Large19",
			[39] = "PatternMode_Large20",
			[40] = "PatternMode_Large21",
			[41] = "PatternMode_Large22",
			[42] = "PatternMode_Large23",
			[43] = "PatternMode_Large24",
			[44] = "PatternMode_Large25",
			[45] = "PatternMode_Large26",
			[46] = "PatternMode_Large27",
			[47] = "PatternMode_Large28",
			[48] = "PatternMode_Large29",
			[49] = "PatternMode_Large30",
			[50] = "PatternMode_Large31",
		},
	},
	NormalBoardSubset = {
		dimensions = {6,7},
		patterns = {
			[1] = "LittleCratePattern1",
			[2] = "LittleCratePattern2",
			[3] = "LittleCoverage1",
			[4] = "OuterRing",
			[5] = "OuterRing_noBottom",
			[6] = "MiddleRing",
			[7] = "LittleCratePattern7",
			[8] = "TheWall",
			[9] = "Walls",
			[10] = "Stripes",
			[11] = "Columns",
			[12] = "Columns2",
			[13] = "StripesAndColumns",
			[14] = "SmallSquare3",
			[15] = "FourCorners_pattern_small",
			[16] = "LeftSide",
			[17] = "TripleUpperLine2",
			[18] = "TopAndBottom1",
			[19] = "OuterInnerRing",
			[20] = "InverseStair1",
			[21] = "Poles1",
			[22] = "Poles2",
			[23] = "Stripe1",
			[24] = "Canyon1",
			[25] = "Canyon3",
			[26] = "TopBlock1",
			[27] = "BombPattern1",
			[28] = "Spider1",
			[29] = "FullBoardSmall",
			[30] = "Checkers",
			[31] = "OuterU",
			[32] = "PatternMode_Small1",
			[33] = "PatternMode_Small2",
			[34] = "PatternMode_Small3",
			[35] = "PatternMode_Small4",
			[36] = "PatternMode_Small5",
			[37] = "PatternMode_Small6",
			[38] = "PatternMode_Small7",
			[39] = "PatternMode_Small8",
			[40] = "PatternMode_Small9",
			[41] = "PatternMode_Small10",
			[42] = "PatternMode_Small11",
			[43] = "PatternMode_Small12",
			[44] = "PatternMode_Small13",
			[45] = "PatternMode_Small14",
			[46] = "PatternMode_Small15",
			[47] = "PatternMode_Small16",
			[48] = "PatternMode_Small17",
			[49] = "PatternMode_Small18",
			[50] = "PatternMode_Small19",
		},
	},
}

Patterns = {
	{
		name = "ReelPosition1",
		filledCells = {
			"X     ",
		},
	},
	{
		name = "ReelPosition2",
		filledCells = {
			" X    ",
		},
	},
	{
		name = "ReelPosition3",
		filledCells = {
			"  X   ",
		},
	},
	{
		name = "ReelPosition4",
		filledCells = {
			"   X  ",
		},
	},
	{
		name = "ReelPosition5",
		filledCells = {
			"    X ",
		},
	},
	{
		name = "ReelPosition6",
		filledCells = {
			"     X",
		},
	},
	{
		name = "ReelPosition7",
		filledCells = {
			"      X",
		},
	},
	{
		name = "ReelPosition1,2",
		filledCells = {
			"XX     ",
		},
	},
	{
		name = "ReelPosition1,7",
		filledCells = {
			"X     X",
		},
	},
	{
		name = "TestPattern1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
		},
	},
	{
		name = "BigCratePattern1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "Bottom3_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "LittleCratePattern1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "BigMissingPattern1",
		filledCells = {
			"       ",
			" X   X ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"X  X  X",
		},
	},
	{
		name = "LittleMissingPattern1",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "LittleCratePattern2",
		filledCells = {
			"   XXX",
			"   XXX",
			"   XXX",
			"   XXX",
			"   XXX",
			"   XXX",
			"   XXX",
		},
	},
	{
		name = "Holes_BigMissingPattern",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"X X X X",
		},
	},
	{
		name = "LittleCratePattern3",
		filledCells = {
			"X    X",
			"XX  XX",
			" XXXX ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "LittleCratePattern4",
		filledCells = {
			"XX  XX",
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"XXXXXX",
		},
	},
	{
		name = "BigCratePattern2",
		filledCells = {
			"X     X",
			"XX   XX",
			" XX XX ",
			"  XXX  ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigCratePattern3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "BigCratePattern4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "BigCratePattern5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "BigCratePattern6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "LittleCratePattern5",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "LittleCratePattern6",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
		},
	},
	{
		name = "LittleMissingPattern2",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "MissingSides1",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"      ",
			"X    X",
			"      ",
			"      ",
		},
	},
	{
		name = "MissingSides1_spots1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MissingSides1_spots2",
		filledCells = {
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
		},
	},
	{
		name = "LittleMissingPattern3",
		filledCells = {
			" XXXX ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXX ",
		},
	},
	{
		name = "LittleMissingPattern4",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			" XXXX ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "LittleMissingPattern5",
		filledCells = {
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "LittleMissingPattern6",
		filledCells = {
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
		},
	},
	{
		name = "BigMissingPattern2",
		filledCells = {
			"XX   XX",
			"XX   XX",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
		},
	},
	{
		name = "BigMissingPattern3",
		filledCells = {
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
		},
	},
	{
		name = "BigMissingPattern4",
		filledCells = {
			"       ",
			"       ",
			" XXXXX ",
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigMissingPattern5",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigMissingPattern6",
		filledCells = {
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "BigMissingPattern7",
		filledCells = {
			"XX   XX",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
		},
	},
	{
		name = "BigCoverage1",
		filledCells = {
			"XXXXXXX",
			"XXX XXX",
			"XX   XX",
			"X  X  X",
			"X  X  X",
			"XX   XX",
			"XXX XXX",
			"XXXXXXX",
		},
	},
	{
		name = "LittleCoverage1",
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XX  XX",
			"X    X",
			"XX  XX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "OuterRing",
		filledCells = {
			"XXXXXX",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"XXXXXX",
		},
	},
	{
		name = "FourBlocks",
		filledCells = {
			"XX  XX",
			"XX  XX",
			"      ", 
			"      ", 
			"XX  XX",
			"XX  XX",
			"      ", 
		},
	},
	{
		name = "OuterCorners",
		filledCells = {
			"XX  XX",
			"X    X",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
		},
	},
	{
		name = "OuterCorners2",
		filledCells = {
			"XX  XX",
			"X    X",
			"X    X",
			"      ",
			"X    X",
			"X    X",
			"XX  XX",
		},
	},
	{
		name = "OuterCorners_empty",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XX  XX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "OuterCorners_empty_less",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "StaircaseUp",
		filledCells = {
			"     X",
			"    XX",
			"   XX ",
			"  XX  ",
			" XX   ",
			"XX    ",
			"X     ",
		},
	},
	{
		name = "StaircaseDown",
		filledCells = {
			"X     ",
			"XX    ",
			" XX   ",
			"  XX  ",
			"   XX ",
			"    XX",
			"     X",
		},
	},
	{
		name = "EasyPatternTester",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "StaircaseUp_empty",
		filledCells = {
			"XX     ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"     X",
			"    XX",
		},
	},
	{
		name = "OuterRing_noBottom",
		filledCells = {
			"XXXXXX",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"      ",
		},
	},
	{
		name = "OuterRing_noTop",
		filledCells = {
			"      ",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"XXXXXX",
		},
	},
	{
		name = "Breakin Color1",
		filledCells = {
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "Breakin Color2",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			"      ",
			"      ",
			"     X",
			" X    ",
		},
	},
	{
		name = "Breakin Color3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X     ",
			"     X",
			"      ",
			"  X   ",
		},
	},
	{
		name = "Breakin Color4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"     X",
			"X     ",
			"      ",
			"   X  ",
		},
	},
	{
		name = "Breakin Color5",
		filledCells = {
			"      ",
			"      ",
			"     X",
			"      ",
			"      ",
			"X     ",
			"    X ",
		},
	},
	{
		name = "OuterRing_sides",
		filledCells = {
			"      ",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"      ",
		},
	},	
	{
		name = "OuterRing_large",
		filledCells = {
			"XXXXXXX",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "OuterRing_large_noTop",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "OuterInnerRing_large",
		filledCells = {
			"XXXXXXX",
			"X     X",
			"X XXX X",
			"X X X X",
			"X X X X",
			"X XXX X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "InnerHole_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MiddleRing",
		filledCells = {
			"      ",
			" XXXX ",
			" X  X ",
			" X  X ",
			" X  X ",
			" XXXX ",
			"      ",
		},
	},
	{
		name = "MiddleRing_large",
		filledCells = {
			"       ",
			" XXXXX ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "MiddleSquare",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			" X  X ",
			" XXXX ",
			"      ",
			"      ",
		},
	},
	{
		name = "InnerSquare",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "InnerRing",
		filledCells = {
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "Inner_I",
		filledCells = {
			"      ",
			" XXXX ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			" XXXX ",
			"      ",
		},
	},
	{
		name = "SimpleSquare",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			"      ",
			"      ",
		},
	},
	{
		name = "InnerRing_large",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
			"  X X  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "InnerHole",
		filledCells = {
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BigCratePattern7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigCratePattern8",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigCratePattern9",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigCratePattern10",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Rows35_large",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LittleCratePattern7",
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "TheWall",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "TestCoverage",
		filledCells = {
			" XXX XX",
			"XXXX XX",
			" XXX XX",
			"XXXX XX",
			" XXX XX",
			"XXXX XX",
			" XXX XX",
			"XXXX X ",
		},
	},
		{
		name = "TestCoverage2",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
		{
		name = "TestCoverageMid",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "OuterRing_top",
		filledCells = {
			"XXXXXX",
			"X    X",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "OuterRing_bottom",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"X    X",
			"XXXXXX",
		},
	},
	{
		name = "OuterRing_topleftcorner",
		filledCells = {
			"XXX   ",
			"X     ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "OuterRing_toprightcorner",
		filledCells = {
			"   XXX",
			"     X",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "OuterRing_bottomleftcorner",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			"X     ",
			"XXX   ",
		},
	},
	{
		name = "OuterRing_bottomrightcorner",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"     X",
			"   XXX",
		},
	},
	{
		name = "OuterBlock_middle_Phelan",
		filledCells = {
			"		",
			"		",
			"  XXX  ",
			"  X X  ",
			"  XXX  ",
			"		",
			"		",
		},
	},
	{
		name = "OuterBlock_midcenter_Phelan",
		filledCells = {
			"		",
			"		",
			"		",
			"   X   ",
			"		",
			"		",
			"		",
		},
	},
	{
		name = "OuterBlock_topleftcorner",
		filledCells = {
			"XXX   ",
			"X X   ",
			"XXX   ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "OuterBlock_topleftcorner_middle",
		filledCells = {
			"      ",
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "OuterBlock_toprightcorner",
		filledCells = {
			"   XXX",
			"   X X",
			"   XXX",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "OuterBlock_bottomleftcorner",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXX   ",
			"X X   ",
			"XXX   ",
		},
	},
	{
		name = "OuterBlock_bottomrightcorner",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"   XXX",
			"   X X",
			"   XXX",
		},
	},
	{
		name = "OuterBlock_bottomrightcorner_middle",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
			"      ",
		},
	},
	{
		name = "MiddleRing_top",
		filledCells = {
			"      ",
			" XXXX ",
			" X  X ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MiddleRing_bottom",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" X  X ",
			" XXXX ",
			"      ",
		},
	},
	{
		name = "Ring_middle",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XX  XX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Walls",
		filledCells = {
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"XX  XX",
		},
	},
	{
		name = "HolePunch",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "HolePunch_MissingCorners",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "MissingCorners",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},	
	{
		name = "MissingCorners2",
		filledCells = {
			"XX  XX",
			"X    X",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
		},
	},	

	{
		name = "MissingOuterCorners",
		filledCells = {
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
		},
	},
	{
		name = "MissingInnerCorners",
		filledCells = {
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "Web",
		filledCells = {
			"X    X",
			" X  X ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			" X  X ",
			"X    X",
		},
	},
	{
		name = "BottomCorners",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "BottomCorners_large",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     X",
		},
	},
	{
		name = "AroundBottomCorners",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
			" X  X ",
		},
	},
	{
		name = "AroundBottomCorners_large",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX   XX",
			" X   X ",
		},
	},
	{
		name = "TopCorners",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "AroundTopCorners",
		filledCells = {
			" X  X ",
			"XX  XX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",

		},
	},
	{
		name = "FourSpots1",
		filledCells = {
			" X  X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
		},
	},	
	{
		name = "EightSpots1",
		filledCells = {
			" X  X ",
			" X  X ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
			"      ",
		},
	},	
	{
		name = "EightSpots1_less",
		filledCells = {
			" X  X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
		},
	},
	{
		name = "FourSpots2",
		filledCells = {
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
		},
	},	
	{
		name = "Stripes",
		filledCells = {
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "Columns",
		filledCells = {
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
		},
	},
	{
		name = "Columns_top",
		filledCells = {
			" X  X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Columns_topmiddlebottom",
		filledCells = {
			" X  X ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			" X  X ",
		},
	},
	{
		name = "Columns_middle",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Columns_middles",
		filledCells = {
			"      ",
			" X  X ",
			" X  X ",
			"      ",
			" X  X ",
			" X  X ",
			"      ",
		},
	},
	{
		name = "Columns_bottom",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X  X ",
			" X  X ",
		},
	},
	{
		name = "Columns2",
		filledCells = {
			"X    X ",
			"X    X ",
			"X    X ",
			"X    X ",
			"X    X ",
			"X    X ",
			"X    X ",
		},
	},
	{
		name = "Castle1",
		filledCells = {
			"X XX X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Castle2",
		filledCells = {
			"X XX X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X XX X",
		},
	},
	{
		name = "Castle3",
		filledCells = {
			"X XX X",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "StripesAndColumns",
		filledCells = {
			" X  X ",
			"XXXXXX",
			" X  X ",
			"XXXXXX",
			" X  X ",
			"XXXXXX",
			" X  X ",
		},
	},
	{
		name = "StripesAndColumns_corners",
		filledCells = {
			" X  X ",
			"XX  XX",
			"      ",
			"XX  XX",
			"     ",
			"XX  XX",
			" X  X ",
		},
	},
	{
		name = "StripesAndColumns_alt1",
		filledCells = {
			" X  X ",
			"X    X",
			"      ",
			"X    X",
			"      ",
			"X    X",
			" X  X ",
		},
	},
	{
		name = "DoubleBoulders_Color1",
		filledCells = {
			"X     ",
			"  X   ",
			"   X X",
			"    X ",
			"     X",
			"      ",
			"X     ",
		},
	},
	{
		name = "DoubleBoulders_Color2",
		filledCells = {
			"  X   ",
			"    X ",
			"  X   ",
			"X     ",
			" X    ",
			"  X   ",
			"   X  ",
		},
	},
	{
		name = "DoubleBoulders_Color3",
		filledCells = {
			"   X  ",
			"      ",
			"X     ",
			"  X   ",
			"  X   ",
			" X    ",
			"  X   ",
		},
	},
	{
		name = "DoubleBoulders_Color4",
		filledCells = {
			"     X",
			"   X  ",
			" X    ",
			"   X  ",
			"X     ",
			"   X  ",
			"      ",
		},
	},
	{
		name = "DoubleBoulders_Color5",
		filledCells = {
			"      ",
			" X    ",
			"    X ",
			" X    ",
			"   XX ",
			"    X ",
			"     X",
		},
	},
	{
		name = "StripesAndColumns_alt2",
		filledCells = {
			"      ",
			" X  X ",
			"      ",
			" X  X ",
			"      ",
			" X  X ",
			"      ",
		},
	},
	{
		name = "SmallStripe1",
		filledCells = {
			"      ",
			"      ",
			" X  X ",
			" X  X ",
			" X  X ",
			"      ",
			"      ",
		},
	},
	{
		name = "SmallStripeWithLine",
		filledCells = {
			"      ",
			"      ",
			" X  X ",
			"XXXXXX",
			" X  X ",
			"      ",
			"      ",
		},
	},
	{
		name = "SmallStripe2",
		filledCells = {
			"      ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			"      ",
		},
	},
	{
		name = "SmallSquare1",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			" X  X ",
			" XXXX ",
			"      ",
			"      ",
		},
	},
	{
		name = "Castle3",
		filledCells = {
			"X XX X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X  X ",
		},
	},
	{
		name = "SmallSquare3",
		filledCells = {
			"      ",
			" X  X ",
			"XXXXXX",
			"X XX X",
			"XXXXXX",
			"X    X",
			"      ",
		},
	},
	{
		name = "Castle4",
		filledCells = {
			"X XX X",
			"X    X",
			"      ",
			"      ",
			"      ",
			" X  X ",
			" X  X ",
		},
	},
	{
		name = "BigCastle1",
		filledCells = {
			"X X X X",
			"       ",
			"       ",
			"  X X   ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigStripes1",
		filledCells = {
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "Spots1",
		filledCells = {
			"      ",
			" X    ",
			"    X ",
			" X    ",
			"    X ",
			" X    ",
			"      ",
		},
	},
	{
		name = "Spots2",
		filledCells = {
			"   X  ",
			"  X   ",
			"X    X",
			"   X  ",
			"  X   ",
			"    X ",
			" X    ",
		},
	},
	{
		name = "FourCorners",
		filledCells = {
			"XX   XX",
			"XX   XX",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
		},
	},
	{
		name = "FourCorners_pattern",
		filledCells = {
			"  XXX  ",
			"  XXX  ",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "FourCornersSmall",
		filledCells = {
			"X  X  X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X  X  X",
		},
	},
	{
		name = "FourCorners_pattern_small",
		filledCells = {
			"  XX  ",
			"  XX  ",
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"  XX  ",
			"  XX  ",
		},
	},
	{
		name = "FourCorners_small",
		filledCells = {
			"XX  XX",
			"XX  XX",
			"       ",
			"       ",
			"       ",
			"XX  XX",
			"XX  XX",
		},
	},
	{
		name = "CrateBottomBlock1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "CrateBottomBlock2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "CrateBottomBlock2_top",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "CrateBottomBlock1_sides1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "CrateBottomBlock1_sides2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X  X ",
		},
	},
	{
		name = "CrateBottomBlock1_middle",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "CrateBottomBlock3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "CrateBottomBlock4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "TopShelf",
		filledCells = {
			" XXXX ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopShelf_large",
		filledCells = {
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopWindow",
		filledCells = {
			"      ",
			" XXXX ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "UpperWindow",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "RightSide",
		filledCells = {
			"    XX",
			"    XX",
			"    XX",
			"    XX",
			"    XX",
			"    XX",
			"    XX",
		},
	},
	{
		name = "LeftSide",
		filledCells = {
			"XXX   ",
			"XXX   ",
			"XXX   ",
			"XXX   ",
			"XXX   ",
			"XXX   ",
			"XXX   ",
		},
	},
	{
		name = "Stairs",
		filledCells = {
			"     XX",
			"    XX ",
			"   XX  ",
			"  XX   ",
			" XX    ",
			"XX    ",
		},
	},
	{
		name = "BottomRightCorner",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"    XX",
		},
	},
	{
		name = "TopRightCorner",
		filledCells = {
			"    XX",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TestPatternPhe",
		filledCells = {
			"    X  ",
			"    X  ",
			"    X  ",
			"    X  ",
			"    X  ",
			"    X  ",
			"    X  ",
			"    X  ",

		},
	},
	{
		name = "TwoCorners",
		filledCells = {
			"XX    ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"     X",
			"    XX",
		},
	},
	{
		name = "Frame",
		filledCells = {
			"XX  XX",
			"X    X",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
		},
	},
	{
		name = "Line",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "DoubleLine",
		filledCells = {
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
		},
	},
	{
		name = "DoubleLineLarge",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
		},
	},
	{
		name = "UpperLine1",
		filledCells = {
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "UpperLine1_hole",
		filledCells = {
			"XX  XX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopFrame1",
		filledCells = {
			"XX  XX",
			"X    X",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "UpperLine2",
		filledCells = {
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "UpperLine3",
		filledCells = {
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MiddleLine",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MiddleLine_large",
		filledCells = {
			"       ",
			"       ",
			"       ", 
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MiddleLine2_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LowerLine3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
		},
	},
	{
		name = "LowerLine2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "LowerLine1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "DoubleUpperLine2",
		filledCells = {
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "DoubleUpperLine2_large",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},

	{
		name = "TripleUpperLine2",
		filledCells = {
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
		},
	},

	{
		name = "Blocks1",
		filledCells = {
			"XX    ",
			"XX    ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"    XX",
			"    XX",
		},
	},

	{
		name = "Blocks1_large",
		filledCells = {
			"      ",
			" XX   ",
			" XX   ",
			"      ",
			"      ",
			"    XX",
			"    XX",
		},
	},

	{
		name = "Blocks2_large",
		filledCells = {
			"      ",
			"    XX",
			"    XX",
			"      ",
			"      ",
			" XX   ",
			" XX   ",
		},
	},

	{
		name = "CrateBlockers1",
		filledCells = {
			"      ",
			"      ",
			"X XX X",
			"      ",
			" X  X ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "EmptySpots1",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "CrateBlockers2",
		filledCells = {
			" X  X ",
			" X  X ",
			" X  X ",
			"      ",
			" X  X ",
			" X  X ",
			" X  X ",
		},
	},
	{
		name = "NotchPattern1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXX ",
			"X    X",
		},
	},
	{
		name = "NotchPattern1_reverse",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			" XXXX ",
			"      ",
		},
	},
	{
		name = "ButterflyPattern1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			" XXXX ",
			"X    X",
		},
	},
	{
		name = "ButterflyPattern1_reverse",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" XXXX ",
			"X    X",
			" XXXX ",
		},
	},
	{
		name = "LittleBottom2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "TopV1",
		filledCells = {
			" XXXX ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "LittleBottom1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "AboveLittleBottom1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "AboveAboveLittleBottom1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
		},
	},
	{
		name = "LittleBottom3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "LittleBottom12",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
			"      ",
		},
	},

	{
		name = "Sides1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Sides2_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			"X     X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Sides3",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"X    X",
			"X    X",
			"      ",
			"      ",
		},
	},
	{
		name = "Sides3_large",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Sides4",
		filledCells = {
			"X    X",
			"X    X",
			"X    X",
			"      ",
			"X    X",
			"X    X",
			"X    X",
		},
	},
	{
		name = "Sides4_large",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"       ",
			"       ",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	{
		name = "SideSpots1",
		filledCells = {
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
		},
	},
	{
		name = "TopAndBottom1",
		filledCells = {
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},

	{
		name = "Blocks3",
		filledCells = {
			"      ",
			"      ",
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"      ",
			"      ",
		},
	},
	{
		name = "TopBottomSpots1",
		filledCells = {
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "Blocks4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
			"XX  XX",
		},
	},
	{
		name = "OuterInnerRing",
		filledCells = {
			"XXXXXX",
			"X    X",
			"X XX X",
			"X XX X",
			"X XX X",
			"X    X",
			"XXXXXX",
		},
	},
	{
		name = "InverseStair1",
		filledCells = {
			"XXXXX ",
			"XXXX  ",
			"XXX   ",
			"XX    ",
			"X     ",
			"      ",
			"      ",
		},
	},
	{
		name = "InverseStairLower",
		filledCells = {
			"      ",
			"      ",
			"XXXX  ",
			"XXX   ",
			"XX    ",
			"X     ",
			"      ",
		},
	},
	{
		name = "InverseStairMini",
		filledCells = {
			"      ",
			"XXX   ",
			"XX    ",
			"X     ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "TopRow23",
		filledCells = {
			" XX   ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopRow4",
		filledCells = {
			"   X  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopRow5",
		filledCells = {
			"    X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "InverseLine1",
		filledCells = {
			"      ",
			"    X ",
			"   X  ",
			"  X   ",
			" X    ",
			"X     ",
			"      ",
		},
	},
	{
		name = "InverseLine2",
		filledCells = {
			"      ",
			"   X  ",
			"  X   ",
			" X    ",
			"X     ",
			"      ",
			"      ",
		},
	},
	{
		name = "Poles1",
		filledCells = {
			"      ",
			"X     ",
			"X     ",
			"X X   ",
			"X X   ",
			"X X X ",
			"X X X ",
		},
	},
	{
		name = "Poles2",
		filledCells = {
			"      ",
			"     X",
			"     X",
			"   X X",
			"   X X",
			" X X X",
			" X X X",
		},
	},
    {
        name = "Poles3_large",
        filledCells = {
            "       ",
            "       ",
            "    X  ",
            "X   X  ",
            "X   X X",
            "X   X X",
            "X X X X",
            "X X X X",
        },
    },
    {
        name = "Poles3tops_large",
        filledCells = {
            "       ",
            "    X  ",
            "X      ",
            "      X",
            "       ",
            "  X    ",
            "       ",
        },
    },
	{
		name = "BottomTopRows",
		filledCells = {
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "BottomTopRows_large",
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "NumberSign_large",
		filledCells = {
			"X  X  X",
			"       ",
			"       ",
			"X     X",
			"X     X",
			"       ",
			"       ",
			"X  X  X",
		},
	},
	{
		name = "CornerSides",
		filledCells = {
			"X     X",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"X     X",
		},
	},
	{
		name = "SinglePoint",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   X  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "LittleEmptyPattern",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BigEmptyPattern",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SidePattern",
		filledCells = {
			"      ",
			"      ",
			"XX  XX",
			" X  X ",
			"XX  XX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "DumbBellPattern",
		filledCells = {
			"      ",
			"      ",
			"XX  XX",
			" XXXX ",
			"XX  XX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "InnerSidePattern",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TwoBoards_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BottomSeeds1_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "BottomPile1_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			" XXXXX ",
			"XXXXXXX",
		},
	},
	{
		name = "BottomPileTop1_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			" X   X ",
			"X     X",
			"       ",
		},
	},
	{
		name = "Floors1_large",
		filledCells = {
			"XXXX   ",
			"       ",
			"   XXXX",
			"       ",
			"XXXX   ",
			"       ",
			"   XXXX",
			"       ",
		},
	},
	{
		name = "UnderFloors1_large",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"      X",
			"       ",
			"X      ",
			"       ",
			"      X",
		},
	},
	{
		name = "UnderFloors2_large",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"      X",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "BottomJail1_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX XXX",
			"X X X X",
			"XXX XXX",
		},
	},
	{
		name = "BottomJail1_Cover_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "BottomJail1_Center_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "SidePattern_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XX   XX",
			" X   X ",
			"XX   XX",
			"       ",
			"       ",
		},
	},
	{
		name = "SidePattern_Center_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X    X ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineBattle1",
		filledCells = {
			"       ",
			"    X  ",
			"X   X  ",
			"X X X X",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},	
	},
	{
		name = "VineBattleSmaller",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			"X X X ",
			"X XXX ",
			"XXXXXX",
			"XXXXXX",
		},	
	},
	{
		name = "Stripes1",
		filledCells = {
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
		},	
	},
	{
		name = "WaffleIron_Missing",
		filledCells = {
			"XXXXXXX",
			"       ",
			" X X X ",
			"       ",
			" X X X ",
			"       ",
			" X X X ",
			"       ",
		},	
	},
	{
		name = "WaffleIron_Pattern",
		filledCells = {
			"       ",
			"XXXXXXX",
			"X X X X",
			"XXXXXXX",
			"X X X X",
			"XXXXXXX",
			"X X X X",
			"XXXXXXX",
		},	
	},
	{
		name = "LeftShelf1",
		filledCells = {
			"XXXXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},	
	},
	{
		name = "LeftShelf2",
		filledCells = {
			"       ",
			"XXXXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},	
	},
	{
		name = "LeftShelf3",
		filledCells = {
			"       ",
			"       ",
			"XXXXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},	
	},
	{
		name = "RightShelves1",
		filledCells = {
			" XXXXXX",
			"       ",
			" XXXXXX",
			"       ",
			" XXXXXX",
			"       ",
			" XXXXXX",
			"       ",
		},	
	},
	{
		name = "BottomCenter1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X XX X",
		},	
	},
	{
		name = "BottomCenterCover1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			" X  X ",
		},	
	},
	{
		name = "BottomCenterSides1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"X    X",
		},	
	},
	{
		name = "BottomCenterSides2",
		filledCells = {
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"      ",
			"      ",

		},	
	},
	{
		name = "Line1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "Line2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "Line3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
		},
	},
	{
		name = "TestLine3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"    XX",
			"      ",
			"      ",
		},
	},
	{
		name = "Line4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Line5",
		filledCells = {
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Line6",
		filledCells = {
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Line7",
		filledCells = {
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Stripe1",
		filledCells = {
			" XXXX ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
		},
	},
	{
		name = "RacingStripe1_large",
		filledCells = {
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
		},
	},
	{
		name = "Canyon1",
		filledCells = {
			"      ",
			"X    X",
			"X    X",
			"XX  XX",
			"XX  XX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "Canyon2",
		filledCells = {
			"X    X",
			"X    X",
			"XX  XX",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Canyon3",
		filledCells = {
			"X    X",
			"X    X",
			"XX  XX",
			"XXXXXX",
			" XXXX ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "Canyon4",
		filledCells = {
			"X    X",
			"X    X",
			"XX  XX",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopBlock1",
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Top3Rows",
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopBlock1_large",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigBoulder_Color1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX     ",
			"       ",
			"  XX   ",
		},
	},
	{
		name = "BigBoulder_Color2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"X     X",
			"X      ",
		},
	},
	{
		name = "BigBoulder_Color3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XX    ",
			"     XX",
		},
	},
	{
		name = "BigBoulder_Color4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XX X ",
			"     X ",
			"       ",
		},
	},
	{
		name = "BigBoulder_Color5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"   XX  ",
			" X  X  ",
		},
	},
	{
		name = "Line1_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "Line2_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "Line3_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
		},
	},
	{
		name = "Line4_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Line5_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Line6_large",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Line7_large",
		filledCells = {
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Line8_large",
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VerticalBursts_missing",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "Steps1_large",
		filledCells = {
			"       ",
			"       ",
			"XX     ",
			"  X    ",
			"   X   ",
			"    X  ",
			"     XX",
			"       ",
		},
	},
	{
		name = "Steps1",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			" X    ",
			"  X   ",
			"   X  ",
			"    X ",
		},
	},
	{
		name = "Steps1Top_large",
		filledCells = {
			"       ",
			"XXXXXXX",
			"  XXXXX",
			"   XXXX",
			"    XXX",
			"     XX",
			"       ",
			"       ",
		},
	},
	{
		name = "Steps1Top",
		filledCells = {
			"      ",
			"XXXXXX",
			" XXXXX",
			"  XXXX",
			"   XXX",
			"    XX",
			"     X",
		},
	},
	{
		name = "Pile1_large",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   X  ",
			"  XXX  ",
			" XXXXX ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "Pile1_regular",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  XX  ",
			" XXXX ",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "Shelves1_top",
		filledCells = {
			"     XX",
			"       ",
			"XXX    ",
			"       ",
			"    XXX",
			"       ",
			"XX     ",
			"       ",
		},
	},
	{
		name = "Shelves1_bottom",
		filledCells = {
			"       ",
			"     XX",
			"       ",
			"XXX    ",
			"       ",
			"    XXX",
			"       ",
			"XX     ",
		},
	},
	{
		name = "Shelves1",
		filledCells = {
			"     XX",
			"     XX",
			"XXX    ",
			"XXX    ",
			"    XXX",
			"    XXX",
			"XX     ",
			"XX     ",
		},
	},
	{
		name = "Pillars1",
		filledCells = {
			" XX XX ",
			" XX XX ",
			" XX XX ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pillars1_top",
		filledCells = {
			" XX XX ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pillars1_bottom",
		filledCells = {
			"       ",
			"       ",
			" XX XX ",
			" XX XX ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigCastle2",
		filledCells = {
			"XX X XX",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigCastle2_door",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "BigCastle2_door_alt",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
			"  X X  ",
		},
	},
	{
		name = "BigCastle2_windows",
		filledCells = {
			"  X X  ",
			"       ",
			"  X X  ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AroundTopSideCorners",
		filledCells = {
			"XX  XX",
			" X  X ",
			"XX  XX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",

		},
	},
	{
		name = "AroundTopSideCorners_inner",
		filledCells = {
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",

		},
	},
	{
		name = "AroundBottomSideCorners",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
			" X  X ",
			"XX  XX",
		},
	},
	{
		name = "AAroundBottomSideCorners_inner",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",

		},
	},
	{
		name = "AroundSides",
		filledCells = {
			"      ",
			"      ",
			"XX  XX",
			" X  X ",
			"XX  XX",
			"      ",
			"      ",

		},
	},
	{
		name = "AroundSides_inner",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",

		},
	},
	{
		name = "AroundSides_topbottom",
		filledCells = {
			"      ",
			"      ",
			"XX  XX",
			"      ",
			"XX  XX",
			"      ",
			"      ",

		},
	},
	{
		name = "AroundSides_middle",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",

		},
	},
	{
		name = "Dungeon1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX X X",
			"X   XXX",
			"XXX   X",
			"X X XXX",
		},
	},
	{
		name = "Dungeon1_door",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			"       ",
			"  X    ",
			"    X ",
			"  X    ",
		},
	},
	{
		name = "Dungeon1_bomb1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon1_bomb2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon1_bomb3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
		},
	},
	{
		name = "Dungeon1_bomb4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "Dungeon1_jails",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "Tower1_block1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
		},
	},
	{
		name = "Tower1_block2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"      ",
		},
	},
	{
		name = "Tower1_block3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower1_block4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"     X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower1_block5",
		filledCells = {
			"      ",
			"      ",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower1_block6",
		filledCells = {
			"      ",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower1_block7",
		filledCells = {
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower2_block1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
		},
	},
	{
		name = "Tower2_block2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			"      ",
		},
	},
	{
		name = "Tower2_block3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower2_block4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X     ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower2_block5",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower2_block6",
		filledCells = {
			"      ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Tower2_block7",
		filledCells = {
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Wedge1",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			"  X   ",
			"   X  ",
			"    X ",
			"     X",
		},
	},
	{
		name = "Wedge1_row2",
		filledCells = {
			"      ",
			" X    ",
			"  X   ",
			"   X  ",
			"    X ",
			"     X",
			"      ",
		},
	},
	{
		name = "Wedge1_row3",
		filledCells = {
			" X    ",
			"  X   ",
			"   X  ",
			"    X ",
			"     X",
			"      ",
			"      ",
		},
	},
	{
		name = "Wedge1_row4",
		filledCells = {
			"  X   ",
			"   X  ",
			"    X ",
			"     X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Wedge1_row5",
		filledCells = {
			"   X  ",
			"    X ",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "Ledge1_row1",
		filledCells = {
			"XXX   ",
			"XXX   ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "Ledge1_row2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   XXX",
			"   XXX",
			"      ",
			"      ",
		},
	},

	{
		name = "Ledge1_row3",
		filledCells = {
			"      ",
			"      ",
			"XXX   ",
			"      ",
			"      ",
			"   XXX",
			"      ",
		},
	},

	{
		name = "Ledge1_row4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXX   ",
			"      ",
			"      ",
			"   XXX",
		},
	},
	{
		name = "Dungeon2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"XX X XX",
			" XXXXX ",
			" X   X ",
		},
	},
	{
		name = "Dungeon2_roof",
		filledCells = {
			"       ",
			"   X   ",
			"  XXX ",
			" XXXXX  ",
			"XX   XX",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon2_sky1",
		filledCells = {
			"XX     ",
			"XX     ",
			"XX     ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon2_sky2",
		filledCells = {
			"     XX",
			"     XX",
			"     XX",
			"      X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon2_sky3",
		filledCells = {
			"  XXX  ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon2_floor1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
		},
	},
	{
		name = "Dungeon2_bombs1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},
	{
		name = "Dungeon2_bombs2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "Dungeon2_bombs3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon2_bombs4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon2_bombs5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
		},
	},
	{
		name = "BombPattern1",
		filledCells = {
			"X X X ",
			"X X X ",
			"X X X ",
			"X X X ",
			"X X X ",
			"X X X ",
			"X X X ",
		},
	},

	{
		name = "BombPattern1_top",
		filledCells = {
			"X X X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BombPattern1_middle",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X X X ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BombPattern1_crate",
		filledCells = {
			"      ",
			"X X X ",
			"X X X ",
			"      ",
			"X X X ",
			"X X X ",
			"      ",
		},
	},
	{
		name = "BombVines1_cover",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"X    X",
		},
	},
	{
		name = "BombVines1_inner1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
		},
	},
	{
		name = "BombVines1_inner2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
		},
	},
	{
		name = "BombVines1_inner3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  X   ",
		},
	},
	{
		name = "BombVines1_inner4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
		},
	},
	{
		name = "Dungeon4_cover1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"  XXX  ",
		},
	},
	{
		name = "Dungeon4_inside1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "Dungeon4_cover2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon4_inside2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon4_jail1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "Dungeon5_cover1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX XXX",
			"X X X X",
		},
	},
    {
		name = "Dungeon5_inside1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
		},
	},
	{
		name = "Dungeon5_cover2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX XXX",
			"X X X X",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon5_inside2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "Dungeon5_jail1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "VerticalCenterLine",
		filledCells = {
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
		},
	},
	{
		name = "BarrierTestVertical",
		filledCells = {
			"      ",
			"      ",
			"X   X ",
			"X   X ",
			"X   X ",
			"      ",
			"      ",
		},
	},
	{
		name = "BarrierTestHorizontal",
		filledCells = {
			"XX  XX",
			"      ",
			"  XX  ",
			"  XX  ",
			"      ",
			"XX  XX",
			"      ",
		},
	},
	{
		name = "BarrierTestPattern",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			"      ",
			"      ",
		},
	},
	{
		name = "SteelTestSteel",
		filledCells = {
			" XXXXX ",
			"  XXX  ",
			"   X   ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
			"X     X",
		},
	},
	{
		name = "SteelTestStone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
			"  X X  ",
			" X   X ",
		},
	},
	{
		name = "SteelTestCrates",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
			"  X X  ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "TopAndBottomCorners1",
		filledCells = {
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "V_Bottom2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "V_Bottom1",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopFunnel1",
		filledCells = {
			"XX  XX",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopLine1",
		filledCells = {
			"      ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
		},
	},
	{
		name = "TopFunnel2",
		filledCells = {
			"X XXX  ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StonePillars1",
		filledCells = {
			"      ",
			"X     ",
			"X  X  ",
			"X  X  ",
			"X  X  ",
			"X  X  ",
			"X  X  ",
		},
	},
	{
		name = "SteelSides1",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"X    X",
			"X    X",
			"      ",
			"      ",

		},
	},
	{
		name = "SteelSides2",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"XX  XX",
			"X    X",
			"      ",

		},
	},
	{
		name = "Window1",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			"      ",
			"      ",

		},
	},
	{
		name = "Spider1",
		filledCells = {
			"X    X",
			"X    X",
			" XXXX ",
			"  XX  ",
			" XXXX ",
			"X    X",
			"X    X",

		},
	},
	{
		name = "BottomSeeds1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"X XX X",
		},
	},
	{
		name = "SteelBottom1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
			" X  X ",
		},
	},
	{
		name = "RandomSteel1",
		filledCells = {
			"       ",
			"X    X ",
			"       ",
			"  X    ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombCell1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
			"  X X  ",
			"       ",
		},
	},
	{
		name = "BombCell1_bomb",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombCell1_barrel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "BombCell1_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXXX",
		},
	},
	{
		name = "BombCell2",
		filledCells = {
			"      ",
			"      ",
			" X  X ",
			"      ",
			" X  X ",
			"      ",
			"      ",
		},
	},
	{
		name = "BombCell2_bomb",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BombCell2_stone",
		filledCells = {
			"      ",
			"      ",
			"X XX X",
			"X XX X",
			"X XX X",
			"      ",
			"      ",
		},
	},
	{
		name = "BombCell1A",
		filledCells = {
			"      ",
			"  X   ",
			"  X   ",
			"      ",
			"  X   ",
			"  X   ",
			"      ",
		},
	},
	{
		name = "BombCell1A_bomb",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BombCell1A_stone",
		filledCells = {
			"      ",
			"      ",
			" X X  ",
			" X X  ",
			" X X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "Spout1",
		filledCells = {
			"XXX XXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pile1_top",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pile1_middle",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pile1_bottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
		{
		name = "Pile1_bottom_narrow",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			" XXXXX ",
		},
	},
	{
		name = "Flow1",
		filledCells = {
			"X      ",
			"      X",
			"     XX",
			"      X",
			"X      ",
			"XX     ",
			"X     X",
			"     XX",
		},
	},
	{
		name = "Flow1_inner",
		filledCells = {
			" X     ",
			"  X    ",
			"   X   ",
			"    X  ",
			"   X   ",
			"    X  ",
			"   X   ",
			"    X  ",
		},
	},
	{
		name = "Flow1_inner2",
		filledCells = {
			"    X  ",
			"   X   ",
			"  X    ",
			" X     ",
			"  X    ",
			"   X   ",
			"  X    ",
			"   X   ",
		},
	},
	{
		name = "TopFunnel3",
		filledCells = {
			"X X X X",
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopFunnel3_top",
		filledCells = {
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"X X X X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopFunnel3_bottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"X X X X",
		},
	},
	{
		name = "TopFunnel3_Color1",
		filledCells = {
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"     X ",
			"     X ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "TopFunnel3_Color2",
		filledCells = {
			"     X ",
			"     X ",
			" X     ",
			" X     ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopFunnel3_Color3",
		filledCells = {
			"       ",
			"       ",
			"     X ",
			"     X ",
			" X     ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopFunnel3_Color4",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"     X ",
			"     X ",
		},
	},
	{
		name = "TopFunnel3_Color5",
		filledCells = {
			" X     ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "SteelJail1",
		filledCells = {
			"       ",
			"       ",
			" X X X ",
			"       ",
			"  X X  ",
			"       ",
			" X X X ",
			"       ",
		},
	},
	{
		name = "SteelJail1_top",
		filledCells = {
			"       ",
			" XXXXX ",
			"  X X  ",
			" XXXXX ",
			" X   X ",
			" XXXXX ",
			"  X X  ",
			" XXXXX ",
		},
	},
	{
		name = "SteelJail1_bomb",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SteelJail1_Colors1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "SteelJail1_Colors2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"  X    ",
			"       ",
			"       ",
		},
	},
	{
		name = "SteelJail1_Colors3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Grid1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X X X X",
			"       ",
			"X X X X",
			"       ",
			"       ",
		},
	},
	{
		name = "Grid1_side",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X X X ",
			" X   X ",
			" X X X ",
			"       ",
			"       ",
		},
	},
	{
		name = "Grid1_seeds",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "FlowerPot1",
		filledCells = {
			"XX   XX",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			" X X X ",
		},
	},
	{
		name = "FlowerPot1_side",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"X     X",
		},
	},
	{
		name = "FlowerPot1_seed1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "FlowerPot1_seed2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "Silo1",
		filledCells = {
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "Silo1_seed",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "Silo1_top",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
		},
	},
	{
		name = "SideSeeds",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"       ",
		},
	},
	{
		name = "SideSeeds_shelf",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "SideSeeds_shelf2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"  X X  ",
			"XXX XXX",
		},
	},
	{
		name = "SideSeeds_bomb",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
		{
		name = "SideSeeds_bomb_side",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "TopSlots",
		filledCells = {
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
		},
	},
	{
		name = "TopSlots_seed",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "OutsideTriangles_Large",
		filledCells = {
			"XXXX   ",
			"XXX    ",
			"XX     ",
			"X      ",
			"      X",
			"     XX",
			"    XXX",
			"   XXXX",
		},
	},
	{
		name = "DiagonalStripes_Large",
		filledCells = {
			"    X  ",
			"   X   ",
			"  X    ",
			" X    X",
			"X    X ",
			"    X  ",
			"   X   ",
			"  X    ",
		},
	},
	{
		name = "LittleMiddle",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
			"      ",
			"      ",
		},
	},
	{
		name = "IsolateCorners",
		filledCells = {
			" X  X ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"X    X",
			" X  X ",
		},
	},
	{
		name = "FourBins",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			" X X X ",
		},
	},
	{
		name = "FourTreasures",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"       ",
		},
	},
	{
		name = "Row6Evens_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row7Evens_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			"       ",
		},
	},
	{
		name = "Row8Evens_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "Row8Odds_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "Bin1_Bottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "Bin2_Bottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "Bin3_Bottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "Bin4_Bottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "LittleMiddle",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
			"      ",
			"      ",
		},
	},
	{
		name = "BigTopCorners",
		filledCells = {
			"XXXXXX",
			"XX  XX",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "RandomPositions",
		filledCells = {
			" X  X ",
			"  X   ",
			" X    ",
			"     X",
			"X  X  ",
			"X    X",
			"  X   ",
		},
	},
	{
		name = "RandomPositions_less",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"     X",
			"X  X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "FullBoardSmall",
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "FullBoardLarge",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "CenterStagger1",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			"  X   ",
			"   X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "CenterStagger2",
		filledCells = {
			"      ",
			"      ",
			"  X   ",
			"   X  ",
			"    X ",
			"      ",
			"      ",
		},
	},
	{
		name = "CenterStagger3",
		filledCells = {
			"      ",
			"      ",
			"   X  ",
			"    X ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "CenterStagger4",
		filledCells = {
			"      ",
			"      ",
			"    X ",
			"      ",
			" X    ",
			"      ",
			"      ",
		},
	},
	{
		name = "CenterStagger5",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X    ",
			"  X   ",
			"      ",
			"      ",
		},
	},
	{
		name = "IsolateSidesLarge",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "TopCorners_large",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "NotTopCorners_large",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	{
		name = "LeftPairs1",
		filledCells = {
			"X     ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "LeftPairs2",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			"X     ",
			"X     ",
			"      ",
			"      ",
		},
	},
	{
		name = "LeftPairs3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			"X     ",
		},
	},
	{
		name = "RightPairs1",
		filledCells = {
			"     X",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "RightPairs2",
		filledCells = {
			"      ",
			"      ",
			"     X",
			"     X",
			"     X",
			"      ",
			"      ",
		},
	},
	{
		name = "RightPairs3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"     X",
		},
	},
	{
		name = "BoulderStripe",
		filledCells = {
			"     X  ",
			"     X ",
			"     X  ",
			"     X  ",
			"     X  ",
			"     X  ",
			"     X  ",
			"     X  ",
		},
	},
		{
		name = "BoulderStripe2",
		filledCells = {
			"     X  ",
			"     X ",
			"     X  ",
			"        ",
			"     X  ",
			"     X  ",
			"     X  ",
			"     X  ",
		},
	},
	{
		name = "BigThreeNearBottomRows",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "BigBottomColumn1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "BigBottomColumn2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "BigBottomColumn3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "BigBottomColumn4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "BigBottomColumn5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "BigBottomColumn6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
		},
	},
	{
		name = "BigBottomColumn7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "Help_Match1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X X   ",
			"      ",
		},
	},
	{
		name = "Help_Match2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   X  ",
			"   X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "Help_Match3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"    X ",
			"    X ",
			" XXXX ",
			"      ",
		},
	},
	{
		name = "Help_Match3_Exception",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   X  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Help_Match4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X    ",
			" X    ",
			" X    ",
			"      ",
		},
	},
	{
		name = "Help_Match4_SecondColor",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
			"   X  ",
			"      ",
		},
	},
	{
		name = "FullGame_Match1",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			"XXX   ",
			"  X   ",
			"      ",
			"      ",
		},
	},
	{
		name = "FullGame_Match2",
		filledCells = {
			"      ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"      ",
		},
	},
	{
		name = "SixMatches_Match1",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			"      ",
			"X     ",
			"      ",
			"      ",
		},
	},
	{
		name = "SixMatches_Match2",
		filledCells = {
			"      ",
			" X    ",
			" X    ",
			" X    ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SixMatches_Match3",
		filledCells = {
			"  X   ",
			"  X   ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SixMatches_Match4",
		filledCells = {
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SixMatches_Match5",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
			"      ",
			"    X ",
		},
	},
	{
		name = "SixMatches_Match6",
		filledCells = {
			"      ",
			"     X",
			"     X",
			"      ",
			"     X",
			"      ",
			"      ",
		},
	},
	{
		name = "Intro_BigMatchSetup",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"     X",
			"XXX  X",
			"XXXX X",
			"      ",
		},
	},
	{
		name = "Intro_SplashTarget",
		filledCells = {
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
			"      ",
			"      ",
			"   X  ",
		},
	},
	{
		name = "MultiColorSetup_Color1",
		filledCells = {
			"XX    ",
			"    XX",
			"      ",
			"    X ",
			"      ",
			"     X",
			"    XX",
		},
	},
	{
		name = "MultiColorSetup_Color2",
		filledCells = {
			"  XX  ",
			"      ",
			"X     ",
			"  XX X",
			"X  X  ",
			"    X ",
			"      ",
		},
	},
	{
		name = "MultiColorSetup_Color3",
		filledCells = {
			"    X ",
			"      ",
			" XX   ",
			"      ",
			" XX X ",
			"    XX",
			"XX    ",
		},
	},
	{
		name = "MultiColorSetup_Color4",
		filledCells = {
			"     X",
			"X     ",
			"   XX ",
			"      ",
			"     X",
			"  X   ",
			"  XX  ",
		},
	},
	{
		name = "MultiColorSetup_Color5",
		filledCells = {
			"      ",
			" XXX  ",
			"     X",
			"XX    ",
			"      ",
			"XX X  ",
			"      ",
		},
	},
	{
		name = "CandyMixingSetup_BlueCorner",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"   XXX",
			"   XXX",
			"   XXX",
		},
	},
	{
		name = "CandyMixingSetup_BlueShieldTop",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   XXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "CandyMixingSetup_BlueShieldLeft",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  X   ",
			"  X   ",
			"  X   ",
		},
	},
	{
		name = "CandyMixingSetup_ExistingVertical",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
		},
	},
	{
		name = "AreaSetup_Match1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"     X",
			"      ",
		},
	},
	{
		name = "AreaSetup_Match2",
		filledCells = {
			"      ",
			"      ",
			"     X",
			"    XX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "AreaSetup_MustNotMatch",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
			"    XX",
		},
	},
	{
		name = "Row2Mids",
		filledCells = {
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	
	{
		name = "Row6Mids",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
		},
	},

	{
		name = "Quadrants",
		filledCells = {
			"   X  ",
			"   X  ",
			"   X  ",
			"XXXXXX",
			"  X   ",
			"  X   ",
			"  X   ",
		},
	},
	{
		name = "Quadrants_large",
		filledCells = {
			"   X   ",
			"   X   ",
			"   X   ",
			"   XXXX",
			"XXXX   ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},

	{
		name = "CornerBoxes",
		filledCells = {
			"    XX",
			"    XX",
			"    XX",
			"      ",
			"XX    ",
			"XX    ",
			"XX    ",
		},
	},

	{
		name = "CornerBox_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    XXX",
			"    XXX",
			"    XXX",
		},
	},
	{
		name = "CornerBoxBorders_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"    XXX",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "Slopes",
		filledCells = {
			"X   XX",
			" XX   ",
			"   X  ",
			"XX  XX",
			"  X   ",
			"   XX ",
			"XX   X",
		},
	},
	{
		name = "BigDiamond",
		filledCells = {
			"   X   ",
			"  X X  ",
			" X   X ",
			"X     X",
			"X     X",
			" X   X ",
			"  X X  ",
			"   X   ",
		},
	},
	{
		name = "LargeCorners",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "LargeOppositeCorners",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "TopLeftCorner",
		filledCells = {
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "CenterRect",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},

	{
		name = "Striated",
		filledCells = {
			"       ",
			"XX   XX",
			"  XXX  ",
			"XX   XX",
			"  XXX  ",
			"XX   XX",
			"  XXX  ",
			"       ",
		},
	},

	{
		name = "IsolateCenter",
		filledCells = {
			"       ",
			"   X   ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"   X   ",
			"       ",
		},
	},

	{
		name = "CenterStrip",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
		},
	},

	{
		name = "TopShelves",
		filledCells = {
			"      ",
			"XX  XX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "TopEnds",
		filledCells = {
			"XX  XX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopCenter",
		filledCells = {
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Checkers",
		filledCells = {
			"X X X ",
			" X X X",
			"X X X ",
			" X X X",
			"X X X ",
			" X X X",
			"X X X ",
		},
	},
	{
		name = "Checkers2",
		filledCells = {
			" X X X",
			"X X X ",
			" X X X",
			"X X X ",
			" X X X",
			"X X X ",
			" X X X",
		},
	},
	{
		name = "Staggered",
		filledCells = {
			" X  X  ",
			"       ",
			"  X  X ",
			"       ",
			" X  X  ",
			"       ",
			"  X  X ",
			"       ",
		},
	},

	{
		name = "U_Lining",
		filledCells = {

			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" XXXXX ",
			"       ",
		},
	},

	{
		name = "OuterNoTopLarge",
		filledCells = {

			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
		},
	},
    {
		name = "AlmostOuterNoTopLarge",
		filledCells = {

			"X     X",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
		},
	},
	{
		name = "OuterNoTopLarge_LavaPattern",
		filledCells = {

			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "U_Lining No Corners",
		filledCells = {

			" X   X ",
			"       ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "Umlaut Large",
		filledCells = {

			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row3Vee",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "Row4Vee",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "BelowV",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
			"XXXXXX",
		},
	},
	{
		name = "WallsAndShelves",
		filledCells = {

			"X     X",
			"X     X",
			"XXX XXX",
			"X     X",
			"X     X",
			"XXX XXX",
			"X     X",
			"X     X",
		},
	},
	
	{
		name = "Scattered",
		filledCells = {
			"X  X  ",
			"X   X ",
			"  X   ",
			" X   X",
			"   X  ",
			" X   X",
			"X  X  ",
		},
	},

	{
		name = "IsolateCenterLow",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
		},
	},

	{
		name = "CenterStripLow",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "CenterStripLow6",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "Row4Center",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "3LayerBombs_Large",
		filledCells = {
			"       ",
			"  X X  ",
			"       ",
			"  X X  ",
			"X     X",
			"       ",
			"  X X  ",
			"       ",
		},
	},

	{
		name = "Row4CenterAndSides",
		filledCells = {
			"       ",
			"       ",
			"XX   XX",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row6CenterAndSides",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row2Center3",
		filledCells = {
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row4Center3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row8Center3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
		},
	},
	{
		name = "LowerCorners",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
		},
	},
	{
		name = "OuterU",
		filledCells = {
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"XXXXXX",
		},
	},
	{
		name = "Scatter1",
		filledCells = {
			"      ",
			" X    ",
			"      ",
			"    X ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Scatter2",
		filledCells = {
			"      ",
			"   X  ",
			"      ",
			"      ",
			"      ",
			" X    ",
			"      ",
		},
	},
	{
		name = "Scatter3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"   X  ",
			"      ",
		},
	},
	{
		name = "Chained",
		filledCells = {
			" X   X ",
			" X   X ",
			"  XXX  ",
			" X   X ",
			" X   X ",
			"  XXX  ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "BottomCheckers",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X X X",
			"X X X ",
		},
	},
	{
		name = "SideCols",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	{
		name = "SideCols_small",
		filledCells = {
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
		},
	},
	{
		name = "MidCols",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},

	{
		name = "FourJails",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"       ",
			"       ",
		},
	},

	{
		name = "LowCols",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"X X X X",
		},
	},

	{
		name = "Lattice",
		filledCells = {
			"      ",
			" X  X ",
			"      ",
			" X  X ",
			"      ",
			" X  X ",
			"      ",
		},
	},
	{
		name = "PatternFew_Small_1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"X    X",
			"      ",
			"      ",
		},
	},
	{
		name = "PatternFew_Large_1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X  X  X",
			"X     X",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_2",
		filledCells = {
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_3",
		filledCells = {
			"       ",
			"       ",
			"  X    ",
			" X     ",
			"    X  ",
			"     X ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_4",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"X      ",
			"  X X  ",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" XX    ",
			"    XX ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_6",
		filledCells = {
			"       ",
			"   XX  ",
			"   XX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_8",
		filledCells = {
			"       ",
			"       ",
			" X     ",
			" X   X ",
			" X     ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_9",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X    ",
			"   XX  ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_10",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"    X  ",
			"  XX   ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_11",
		filledCells = {
			"       ",
			"       ",
			" X   X ",
			"X     X",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_12",
		filledCells = {
			"       ",
			"X X X  ",
			"       ",
			"    X  ",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_13",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"   X   ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_14",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternFew_Large_15",
		filledCells = {
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "PatternMany_Large1",
		filledCells = {
			" XX  X ",
			"   XX  ",
			"  X  X ",
			"   XX  ",
			"  X  X ",
			" X  X  ",
			"  XX   ",
			" X  XX ",
		},
	},
	{
		name = "PatternMany_Large2",
		filledCells = {
			"       ",
			"  XXX  ",
			"  X X  ",
			"XX   XX",
			"X     X",
			"XX   XX",
			"  X X  ",
			"  XXX  ",
		},
	},
	{
		name = "PatternMany_Large3",
		filledCells = {
			" X   X ",
			"X     X",
			" X   X ",
			"  XXX  ",
			"  XXX  ",
			" X   X ",
			"X     X",
			" X   X ",
		},
	},
	{
		name = "PatternMany_Large4",
		filledCells = {
			"       ",
			"XX X XX",
			"       ",
			"  X X  ",
			"       ",
			"X  X  X",
			" X   X ",
			"  X X  ",
		},
	},
	{
		name = "PatternMany_Large5",
		filledCells = {
			" X   X ",
			" X   X ",
			" X X X ",
			"   X   ",
			" X X X ",
			" X   X ",
			" X X X ",
			"   X   ",
		},
	},
	{
		name = "PatternMany_Large6",
		filledCells = {
			" X    X",
			"XX X   ",
			"   XX  ",
			"       ",
			"   XX  ",
			" X  X  ",
			" XX   X",
			"     XX",
		},
	},
	{
		name = "PatternMany_Large7",
		filledCells = {
			"     X ",
			"    XXX",
			"       ",
			" X  XXX",
			"XXX  X ",
			"       ",
			"XXX    ",
			" X     ",
		},
	},
	{
		name = "PatternMany_Large8",
		filledCells = {
			"X      ",
			" X     ",
			"  XXX  ",
			"X    X ",
			" X    X",
			"  XXX  ",
			"     X ",
			"      X",
		},
	},
	{
		name = "PatternMany_Large9",
		filledCells = {
			"       ",
			"      X",
			"      X",
			"     XX",
			"     XX",
			"    XXX",
			"    XXX",
			"   XXXX",
		},
	},
	{
		name = "PatternMany_Large10",
		filledCells = {
			"       ",
			"  XXX  ",
			" XXX   ",
			" XXX   ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternMany_Large11",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			" XXXXX ",
			"  XXX  ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "PatternMany_Large12",
		filledCells = {
			"X      ",
			"XX     ",
			" XX    ",
			"  XX  X",
			"     XX",
			"    XX ",
			"   XX  ",
			"  XX   ",
		},
	},
	{
		name = "PatternMany_Large13",
		filledCells = {
			"  XXX  ",
			" X   X ",
			"     X ",
			"    X  ",
			"   X   ",
			"   X   ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "PatternMany_Large14",
		filledCells = {
			" X X   ",
			" X X   ",
			" X  XX ",
			" X    X",
			"  XX  X",
			"    X X",
			"    X X",
			"    X X",
		},
	},
	{
		name = "PatternMany_Large15",
		filledCells = {
			"     XX",
			"     XX",
			"   XX  ",
			"   XX  ",
			" XX    ",
			" XX    ",
			"X     X",
			"X     X",
		},
	},
	{
		name = "PatternMany_Large16",
		filledCells = {
			"  XXX  ",
			" X   X ",
			"X    X ",
			" XX X  ",
			"   X X ",
			"  X   X",
			"  X   X",
			"  XXXX ",
		},
	},
	{
		name = "PatternMany_Large17",
		filledCells = {
			"     XX",
			"  XX  X",
			"    X  ",
			"   XX  ",
			"    X  ",
			"  XX   ",
			"     XX",
			"     X ",
		},
	},
	{
		name = "PatternMany_Large18",
		filledCells = {
			"       ",
			" XX  XX",
			" XX  XX",
			"       ",
			"XX XX  ",
			"XX XX  ",
			"       ",
			"  X  XX",
		},
	},
	{
		name = "PatternMany_Small1",
		filledCells = {
			"      ",
			"   XX ",
			"  XX  ",
			"XX    ",
			" XX XX",
			"   XX ",
			"  XX  ",
		},
	},
	{
		name = "PatternMany_Small2",
		filledCells = {
			"XX  XX",
			"      ",
			"XX  XX",
			"      ",
			"XX  XX",
			"      ",
			"XX  XX",
		},
	},
	{
		name = "PatternMany_Small3",
		filledCells = {
			"X    X",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			"X    X",
		},
	},
	{
		name = "PatternMany_Small4",
		filledCells = {
			"      ",
			"   XXX",
			"XXX   ",
			"   XXX",
			"XXX   ",
			"   XXX",
			"      ",
		},
	},
	{
		name = "PatternMany_Small5",
		filledCells = {
			"    X ",
			"X  X  ",
			" X    ",
			"  X   ",
			"   X  ",
			" X  X ",
			"X    X",
		},
	},
	{
		name = "PatternMany_Small6",
		filledCells = {
			"      ",
			"XXX   ",
			"XXX   ",
			"      ",
			"      ",
			"XXX   ",
			"XXX   ",
		},
	},
	{
		name = "PatternMany_Small7",
		filledCells = {
			"   X X",
			"    X ",
			"   X X",
			"    X ",
			"   X X",
			"    X ",
			"   X X",
		},
	},
	{
		name = "PatternMany_Small8",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			"X    X",
			" XXXX ",
			"X    X",
			" XXXX ",
		},
	},
	{
		name = "PatternMany_Small9",
		filledCells = {
			"X    X",
			"XX  XX",
			" X  X ",
			"      ",
			"X    X",
			"XX  XX",
			" X  X ",
		},
	},
	{
		name = "PatternMany_Small10",
		filledCells = {
			"   XX ",
			" XX   ",
			"   XX ",
			" XX   ",
			"   XX ",
			" XX   ",
			"   XX ",
		},
	},
	{
		name = "PatternMany_Small11",
		filledCells = {
			"  X   ",
			"  X   ",
			" X X X",
			" X X X",
			" X X X",
			"X   X ",
			"X   X ",
		},
	},
	{
		name = "PatternMany_Small12",
		filledCells = {
			" X  X ",
			"X  X X",
			" XX  X",
			"    X ",
			" XXX  ",
			"X    X",
			" XXXX ",
		},
	},
	{
		name = "PatternMany_Small13",
		filledCells = {
			"      ",
			"      ",
			"X XXX ",
			"X X X ",
			"X   X ",
			"XXXXX ",
			"      ",
		},
	},
	{
		name = "PatternMany_Small14",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"X XX X",
			"X    X",
			"X XX X",
			"X    X",
		},
	},
	{
		name = "PatternMode_Large1",
		filledCells = {
			"XXX X  ",
			"  X XXX",
			"XXX   X",
			"X X XXX",
			"X   X  ",
			"XXXXX X",
			" X    X",
			" XXXXXX",
		},
	},
	{
		name = "PatternMode_Large2",
		filledCells = {
			"XXX XXX",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"XXX XXX",
		},
	},
	{
		name = "PatternMode_Large3",
		filledCells = {
			"       ",
			"X      ",
			"XXX    ",
			"XXXXX  ",
			"XXXXXXX",
			" XXXXXX",
			"   XXXX",
			"     XX",
		},
	},
	{
		name = "PatternMode_Large4",
		filledCells = {
			" XXXXX ",
			"X     X",
			"X  X  X",
			"X X X X",
			"X X X X",
			"X  X  X",
			"X     X",
			" XXXXX ",
		},
	},
	{
		name = "PatternMode_Large5",
		filledCells = {
			"  XX  X",
			" XX  XX",
			"XX  XX ",
			"X  XX  ",
			"  XX  X",
			" XX  XX",
			"XX  XX ",
			"X  XX  ",
		},
	},
	{
		name = "PatternMode_Large6",
		filledCells = {
			"XXX XXX",
			"  X X  ",
			"XXX XXX",
			"X     X",
			"XXX XXX",
			"  X X  ",
			"XXX XXX",
			"X     X",
		},
	},
	{
		name = "PatternMode_Large7",
		filledCells = {
			"   X   ",
			"   X   ",
			"  XXX  ",
			"  XXX  ",
			" XXXXX ",
			" XXXXX ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "PatternMode_Large8",
		filledCells = {
			"XX   XX",
			"XX   XX",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"XX   XX",
			"XX   XX",
		},
	},
	{
		name = "PatternMode_Large9",
		filledCells = {
			"XXXXXXX",
			"X X X X",
			"XXXXXXX",
			"X X X X",
			"XXXXXXX",
			"X X X X",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "PatternMode_Large10",
		filledCells = {
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
			"XXXXXXX",
		},
	},
	{
		name = "PatternMode_Large11",
		filledCells = {
			" X    X",
			" XX  XX",
			"  XXXX ",
			"X  XX  ",
			"XX  XX ",
			" XXXX  ",
			"  XX  X",
			"   XXXX",
		},
	},
	{
		name = "PatternMode_Large12",
		filledCells = {
			"       ",
			"XXXXXX ",
			"       ",
			" XXXXXX",
			"       ",
			"XXXXXX ",
			"       ",
			" XXXXXX",
		},
	},
	{
		name = "PatternMode_Large13",
		filledCells = {
			"XXXXXXX",
			"   X   ",
			"XXXXXXX",
			"       ",
			"XXX XXX",
			"X   X  ",
			"X XXX X",
			"       ",
		},
	},
	{
		name = "PatternMode_Large14",
		filledCells = {
			"XXX    ",
			"  XXX  ",
			"    XXX",
			"XX    X",
			" XXX   ",
			"   XXX ",
			"X    XX",
			"XXX    ",
		},
	},
	{
		name = "PatternMode_Large15",
		filledCells = {
			"    XXX",
			"    XXX",
			"   XXX ",
			"   XXX ",
			"  XXX  ",
			"  XXX  ",
			" XXX   ",
			" XXX   ",
		},
	},
	{
		name = "PatternMode_Large16",
		filledCells = {
			"   X   ",
			"   X   ",
			"   X   ",
			"XXXXXXX",
			" XXXXX ",
			"  XXX ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "PatternMode_Large17",
		filledCells = {
			"X   X X",
			"X   X X",
			"X X   X",
			"X X   X",
			"  X X  ",
			"  X X  ",
			"X   X X",
			"X   X X",
		},
	},
	{
		name = "PatternMode_Large18",
		filledCells = {
			" X X X ",
			"X X X X",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"X X X X",
			" X X X ",
		},
	},
	{
		name = "PatternMode_Large19",
		filledCells = {
			"XX X XX",
			"XX X XX",
			"   X   ",
			"XXXXXXX",
			"XXXXXXX",
			"   X   ",
			"XX X XX",
			"XX X XX",
		},
	},
	{
		name = "PatternMode_Large20",
		filledCells = {
			"XXX XXX",
			"XXX    ",
			"XXX XXX",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "PatternMode_Large21",
		filledCells = {
			" X   X ",
			"XXX XXX",
			" X   X ",
			"   X   ",
			"   X   ",
			" X   X ",
			"XXX XXX",
			" X   X ",
		},
	},
	{
		name = "PatternMode_Large22",
		filledCells = {
			"XXX X  ",
			"  X XXX",
			"XXX X  ",
			"  X XXX",
			"XXX X  ",
			"  X XXX",
			"XXX X  ",
			"  X XXX",
		},
	},
	{
		name = "PatternMode_Large23",
		filledCells = {
			" XX    ",
			" XXXXX ",
			" XXXXX ",
			"    XX ",
			" XXXXX ",
			" XXXXX ",
			" XX    ",
			" XXXXX ",
		},
	},
	{
		name = "PatternMode_Large24",
		filledCells = {
			"  XX  X",
			"XX  XX ",
			"  XX  X",
			"XX  XX ",
			"  XX  X",
			"XX  XX ",
			"  XX  X",
			"XX  XX ",
		},
	},
	{
		name = "PatternMode_Large25",
		filledCells = {
			"XX  XX ",
			"XX  XX ",
			"  XX  X",
			"  XX  X",
			"XX  XX ",
			"XX  XX ",
			"  XX  X",
			"  XX  X",
		},
	},
	{
		name = "PatternMode_Large26",
		filledCells = {
			"XXXXX  ",
			"     X ",
			" XXX  X",
			"X   X X",
			"X X X X",
			"X  X  X",
			" X   X ",
			"  XXX  ",
		},
	},
	{
		name = "PatternMode_Large27",
		filledCells = {
			"XXXXXXX",
			"X      ",
			"X XXXXX",
			"X X   X",
			"X X X X",
			"X XXX X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "PatternMode_Large28",
		filledCells = {
			"XX   XX",
			"XXX XXX",
			" XXXXX ",
			"  XXX  ",
			" XXXXX ",
			"XXX XXX",
			"XX   XX",
			"       ",
		},
	},
	{
		name = "PatternMode_Large29",
		filledCells = {
			" XX XX ",
			"X  X  X",
			" XX XX ",
			"X  X  X",
			" XX XX ",
			"X  X  X",
			" XX XX ",
			"X  X  X",
		},
	},
	{
		name = "PatternMode_Large30",
		filledCells = {
			"XX   XX",
			" XX XX ",
			"  XXX  ",
			"X  X  X",
			"XX   XX",
			" XX XX ",
			"  XXX  ",
			"X  X  X",
		},
	},
	{
		name = "PatternMode_Large31",
		filledCells = {
			"   X   ",
			"  XXX  ",
			" XX XX ",
			"XX   XX",
			"XX   XX",
			" XX XX ",
			"  XXX  ",
			"   X   ",
		},
	},
	{
		name = "PatternMode_Small1",
		filledCells = {
			"XXX X ",
			"  X X ",
			"XXX X ",
			"  XXXX",
			"XXX X ",
			"  X X ",
			"XXX X ",
		},
	},
	{
		name = "PatternMode_Small2",
		filledCells = {
			" XXXX ",
			"XX  XX",
			"X    X",
			"X XX X",
			"X    X",
			"XX  XX",
			" XXX ",
		},
	},
	{
		name = "PatternMode_Small3",
		filledCells = {
			"XX  XX",
			" XXXX ",
			"XX  XX",
			" XXXX ",
			"XX  XX",
			" XXXX ",
			"XX  XX",
		},
	},
	{
		name = "PatternMode_Small4",
		filledCells = {
			"XXXXXX",
			"X    X",
			"XXX   ",
			"  XX  ",
			"   XXX",
			"X    X",
			"XXXXXX",
		},
	},
	{
		name = "PatternMode_Small5",
		filledCells = {
			" X  X ",
			"XXXXXX",
			" X  X ",
			" X  X ",
			" X  X ",
			"XXXXXX",
			" X  X ",
		},
	},
	{
		name = "PatternMode_Small6",
		filledCells = {
			"XXX   ",
			"X XXX ",
			"X   XX",
			"X    X",
			"X   XX",
			"X XXX ",
			"XXX   ",
		},
	},
	{
		name = "PatternMode_Small7",
		filledCells = {
			"X XX  ",
			"X   X ",
			"XXX  X",
			"  X  X",
			"XXX  X",
			"X   X ",
			"X XX  ",
		},
	},
	{
		name = "PatternMode_Small8",
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "PatternMode_Small9",
		filledCells = {
			"    XX",
			"   XXX",
			"  XXX ",
			" XXX  ",
			"XXX   ",
			"XX    ",
			"X     ",
		},
	},
	{
		name = "PatternMode_Small10",
		filledCells = {
			"      ",
			" XXXX ",
			"  XX  ",
			"XXXXXX",
			"  XX  ",
			" XXXX ",
			"      ",
		},
	},
	{
		name = "PatternMode_Small11",
		filledCells = {
			" X XXX",
			" X    ",
			" XXXX ",
			"    X ",
			" XXXX ",
			" X    ",
			" X XXX",
		},
	},
	{
		name = "PatternMode_Small12",
		filledCells = {
			"XX  XX",
			"XX  XX",
			"  XX  ",
			"XX  XX",
			"  XX  ",
			"XX  XX",
			"XX  XX",
		},
	},
	{
		name = "PatternMode_Small13",
		filledCells = {
			"XXXXXX",
			"X    X",
			"X XX X",
			"  XX  ",
			"X XX X",
			"X    X",
			"XXXXXX",
		},
	},
	{
		name = "PatternMode_Small14",
		filledCells = {
			" XX   ",
			"X XX  ",
			"XX XX ",
			" XX XX",
			"  XX X",
			"   XX ",
			"    XX",
		},
	},
	{
		name = "PatternMode_Small15",
		filledCells = {
			"X XX X",
			"XXXXXX",
			"X    X",
			"X    X",
			"X    X",
			" X  X ",
			"  XX  ",
		},
	},
	{
		name = "PatternMode_Small16",
		filledCells = {
			"  XX  ",
			"XX  XX",
			"  XX  ",
			"X XX X",
			"  XX  ",
			"XX  XX",
			"  XX  ",
		},
	},
	{
		name = "PatternMode_Small17",
		filledCells = {
			" XXXX ",
			"X    X",
			" XXXX ",
			"X    X",
			" XXXX ",
			"X    X",
			" XXXX ",
		},
	},
	{
		name = "PatternMode_Small18",
		filledCells = {
			"XX  XX",
			" XX  X",
			"  XX  ",
			" XX  X",
			"XX  XX",
			" XX  X",
			"  XX  ",
		},
	},
	{
		name = "PatternMode_Small19",
		filledCells = {
			"      ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			"      ",
		},
	},

	{
		name = "VineLoops",
		filledCells = {
			" X   X ",
			"XX   XX",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			" XXXXX ",
			"X X X X",
		},
	},

	{
		name = "EdgeBombs",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			" X X X ",
		},
	},

	{
		name = "BottomChecks2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X X X ",
			" X X X",
		},
	},
	{
		name = "BottomChecks3Rows",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" X X X",
			"X X X ",
			" X X X",
		},
	},
	{
		name = "BottomChecks3Rows2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X X X ",
			" X X X",
			"X X X ",
		},
	},
	{
		name = "BottomChecks4Rows_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
		},
	},
	{
		name = "BottomChecks4Rows2_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
		},
	},
	{
		name = "BottomChecksLeft",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			"X X   ",
			" X X  ",
			"  X X ",
			"   X  ",
		},
	},
	{
		name = "BottomChecksLeft2",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			" X    ",
			"X X   ",
			" X X  ",
			"  X X ",
		},
	},
	{
		name = "SplitFall_fences",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			" X   X ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "SplitFall_steel",
		filledCells = {
			"       ",
			"       ",
			" X   X ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SplitFall_eater",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopCornerSlant",
		filledCells = {
			"XX X XX",
			"XX   XX",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LeftColumn1",
		filledCells = {
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
		},
	},

	{
		name = "LeftColumn2",
		filledCells = {
			" X    ",
			" X    ",
			" X    ",
			" X    ",
			" X    ",
			" X    ",
			" X    ",
		},
	},

	{
		name = "LeftColumnLarge",
		filledCells = {
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},
	{
		name = "LeftColumn2Large",
		filledCells = {
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},
    {
        name = "RightColumn2Large",
        filledCells = {
            "     X ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
        },
    },

	{
		name = "RightColumnLarge",
		filledCells = {
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
		},
	},

	{
		name = "RightColumn1",
		filledCells = {
			"     X",
			"     X",
			"     X",
			"     X",
			"     X",
			"     X",
			"     X",
		},
	},
	{
		name = "RightColumn2",
		filledCells = {
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
		},
	},
	{
		name = "RightColumn3",
		filledCells = {
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
		},
	},
	{
		name = "Volcano",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"XX   XX",
			"XXX XXX",
			"XXX XXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "Volcano_less",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"XX   XX",
			"XXX XXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "Targets_Blank",
		filledCells = {
			"       ",
			"      X",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"      X",
			"       ",
		},
	},
	{
		name = "Targets_Targets",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"      X",
			"      X",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "DoubleBreakout_Everything",
		filledCells = {
			"   XXX",
			"X   X ",
			"XX    ",
			"X    X",
			"    XX",
			" X   X",
			"XXX   ",
		},
	},
	{
		name = "AmmoJails1",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			" X     ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "AmmoJails2",
		filledCells = {
			"       ",
			"       ",
			" X     ",
			"       ",
			"       X",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "AmmoJails3",
		filledCells = {
			"       ",
			"       ",
			"     X ",
			"       ",
			"X  X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AmmoJails4",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"     X ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "AmmoJails5",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "AmmoBombs1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "AmmoBombs2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"      X",
		},
	},
	{
		name = "AmmoBombs3",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "AmmoBombs4",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AmmoBombs5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AmmoBoard",
		filledCells = {
			"       ",
			" X   X ",
			"       ",
			" X   X ",
			"       ",
			" X   X ",
			"       ",
			" X   X ",
		},
	},
	{
		name = "ExplodingLava_Empty",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "ExplodingLava_Lava",
		filledCells = {
			"       ",
			"       ",
			" X   X ",
			" XXXXX ",
			" XXXXX ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "VinesCorners",
		filledCells = {
			"XXX XXX",
			"XX   XX",
			"X     X",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
			"XXX XXX",
		},
	},
	{
		name = "WildJungle1",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"     X ",
			" X X   ",
		},
	},
	{
		name = "WildJungle2",
		filledCells = {
			"     X ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"X   X  ",
		},
	},
	{
		name = "WildJungle3",
		filledCells = {
			" X    X",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			" X     ",
			"     X ",
		},
	},
	{
		name = "WildJungle4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"X      ",
			"  X X  ",
			"      X",
		},
	},
	{
		name = "WildJungle5",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"       ",
			"X      ",
			"       ",
			"X     X",
			"  X    ",
		},
	},
	{
		name = "WildJungle6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Deforestation1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X    X ",
			"  X    ",
			"     X ",
		},
	},
	{
		name = "Deforestation2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"      X",
			"X      ",
		},
	},
	{
		name = "Deforestation3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"   X   ",
			"    X X",
		},
	},
	{
		name = "Deforestation4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X    X ",
			" X X   ",
		},
	},
	{
		name = "Deforestation5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X  X  ",
			"  X    ",
		},
	},
	{
		name = "Terraforming",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XX   XX",
			"XXX XXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "MissingCenterReels",
		filledCells = {
			"  XX  ",
		},
	},
	{
		name = "Reels67",
		filledCells = {
			"     XX",
		},
	},
	{
		name = "Reels567",
		filledCells = {
			"    XXX",
		},
	},
	{
		name = "RubeReels",
		filledCells = {
			"X    XX",
		},
	},
	{
		name = "MissingReel1",
		filledCells = {
			"X     ",
		},
	},
	{
		name = "LavaBombs",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
			"XXXXXX",
			"      ",
		},
	},
    {
		name = "InsideCorners_Large",
		filledCells = {
			"       ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
    {
		name = "VerticalStripeCenterLarge",
		filledCells = {
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
    {
		name = "CenterReel_Large",
		filledCells = {
			"   X   ",
		},
	},
    {
		name = "CenterStripe_Reels",
		filledCells = {
			"  XX  ",
		},
	},
	 {
		name = "2LeftReels",
		filledCells = {
			"XX    ",
		},
	},
	{
		name = "2RightReels",
		filledCells = {
			"    XX",
		},
	},
    {
		name = "RightReels",
		filledCells = {
			"   XXX",
		},
	},
	{
		name = "PheReels",
		filledCells = {
			"X   X  ",
		},
	},
    {
		name = "LeftReels",
		filledCells = {
			"XXX",
		},
	},
    {
		name = "EdgeReels",
		filledCells = {
			"X    X",
		},
	},
    {
		name = "EdgeReels_Large",
		filledCells = {
			"X     X",
		},
	},
	{
		name = "EdgeAndCenter_large",
		filledCells = {
			"X  X  X",
		},
	},
	{
		name = "Reels26_Large",
		filledCells = {
			"X     X",
		},
	},
    {
		name = "HalfReelsLarge",
		filledCells = {
			" X X X ",
		},
	},
    {
		name = "HalfReelsChestsLarge",
		filledCells = {
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombColumn Walls",
		filledCells = {
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
		},
	},
	{
		name = "BombColumn Bomb1",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombColumn Bomb2",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombColumn Bomb3",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombColumn Bomb4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombColumn Bomb5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombColumn Bomb6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombColumn Bomb7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "BombColumn Bomb8",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "Row5Center",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
		},
	},

	{
		name = "Row6Center",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
		},
	},

	{
		name = "BottomBox",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXX ",
			" XXXX ",
		},
	},
	{
		name = "SideCrates",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
			"X    X",
			"X    X",
		},
	},
	{
		name = "BurstReels",
		filledCells = {
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"X    X",
			"XX  XX",
			"XX  XX",
			"XX  XX",
		},
	},
	{
		name = "BurstReels_Color1",
		filledCells = {
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "BurstReels_Color2",
		filledCells = {
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "BurstReels_Color3",
		filledCells = {
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BurstReels_Color4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BurstReels_Color5",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "Border",
		filledCells = {
			"XXXXXX",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"XXXXXX",
		},
	},
	{
		name = "Pinwheel_large",
		filledCells = {
			"     X ",
			"XXX  X ",
			"     X ",
			"       ",
			"       ",
			" X     ",
			" X  XXX",
			" X     ",
		},
	},

	{
		name = "PinwheelSides_large",
		filledCells = {
			" XX    ",
			"      X",
			"      X",
			"       ",
			"       ",
			"X      ",
			"X      ",
			"    XX ",
		},
	},
	{
		name = "Propeller_large",
		filledCells = {
			" X     ",
			" X  XXX",
			" X     ",
			"       ",
			"       ",
			" X     ",
			" X  XXX",
			" X     ",
		},
	},

	{
		name = "PropellerSides_large",
		filledCells = {
			"    XX ",
			"X      ",
			"X      ",
			"       ",
			"       ",
			"X      ",
			"X      ",
			"    XX ",
		},
	},

	{
		name = "CenterStripe",
		filledCells = {
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
		},
	},
    {
		name = "SnakePresent",
		filledCells = {
			"XXXXX X",
			"X     X",
			"XX XXXX",
			" X X   ",
			"XX XXXX",
			"X     X",
			"X XXX X",
			"XXX XXX",
		},
	},
    {
		name = "SnakeMissing",
		filledCells = {
			"     X ",
			" XXXXX ",
			"  X    ",
			"X X XXX",
			"  X    ",
			" XXXXX ",
			" X   X ",
			"   X   ",
		},
	},
    {
		name = "Pyramid",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			" XXXXX ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	    {
		name = "Pyramid_side",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			" XXXX ",
			"XXXXXX",
		},
	},
    {
		name = "Pyramid_Color1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"  X    ",
			" X     ",
			"X   X  ",
		},
	},
    {
		name = "Pyramid_Color2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"   X   ",
			"  X    ",
			" X   X ",
		},
	},
    {
		name = "Pyramid_Color3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"    X  ",
			"   X   ",
			"  X    ",
		},
	},
    {
		name = "Pyramid_Color4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"     X ",
			"    X  ",
			"   X   ",
		},
	},
    {
		name = "Pyramid_Color5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"X    X ",
			"    X  ",
		},
	},
    {
		name = "StepByStep_Chests",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "StepByStep_Crates",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "StepByStep_Barrels",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
    {
		name = "StepByStep_TripleStones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"X     X",
			" X   X ",
			"  X X  ",
		},
	},
    {
		name = "StepByStep_Jails",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
		},
	},
    {
		name = "StepByStep_Absent",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "StepByStep_Steel",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Columns_Reels",
		filledCells = {
			"  X X  ",
		},
	},
    {
		name = "Breakout_VinesAndPattern",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
    {
		name = "Breakout_Lava",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
		},
	},
    {
		name = "Breakout_Boulders",
		filledCells = {
			" X   X ",
			" X   X ",
			"X     X",
			"       ",
			"       ",
			"X     X",
			" X   X ",
			"  X X  ",
		},
	},
    {
		name = "Breakout_Jails",
		filledCells = {
			"       ",
			"       ",
			" X   X ",
			"X     X",
			"X     X",
			" X   X ",
			"  X X  ",
			"   X   ",
		},
	},
    {
		name = "Breakout_TripleStones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X   X ",
			" X   X ",
			"  X X  ",
			"   X   ",
			"       ",
		},
	},
    {
		name = "Breakout_Crates",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "StemTide_Missing",
		filledCells = {
			"       ",
			"       ",
			"XXX    ",
			"       ",
			" XX    ",
			"   X   ",
			"XX X   ",
			"   X   ",
		},
	},
	{
		name = "StemTide_Stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StemTide_VineGenerator",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "StemTide_Jail",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"       ",
			"      X",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "StemTide_Splash1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "StemTide_Splash2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "StemTide_Splash3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StemTide_Jail1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "StemTide_Jail2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Deforestation_VineGenerator",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"X     X",
			"        ",
			"       ",
		},
	},

	{
		name = "Col6_large",
		filledCells = {
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
		},
	},
	{
		name = "Col7_large",
		filledCells = {
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
		},
	},
	{
		name = "SidesAlt",
		filledCells = {
			"       ",
			"X      ",
			"      X",
			"X      ",
			"      X",
			"X      ",
			"      X",
			"X      ",
		},
	},

	{
		name = "MidColsAlt",
		filledCells = {
			" X   X ",
			"     X ",
			" X     ",
			"     X ",
			" X     ",
			"     X ",
			" X     ",
			"     X ",
		},
	},
	{
		name = "SidesBottomShifted",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			" X   X ",
		},
	},

	{
		name = "Top2MinusRight",
		filledCells = {
			"XXXXX ",
			"XXXXX ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "ScatterNoBottom",
		filledCells = {
			" X  X ",
			"X    X",
			"   X  ",
			" X    ",
			"  X  X",
			"X   X ",
			"      ",
		},
	},
	{
		name = "ScatterNoBottom2",
		filledCells = {
			"     X",
			"X     ",
			"   X  ",
			"  X   ",
			"    X ",
			" X    ",
			"      ",
		},
	},
	{
		name = "BlankTopCols",
		filledCells = {
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},	
	},
	{
		name = "CoconutCols",
		filledCells = {
			"       ",
			"X X X X",
			"       ",
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
		},	
	},
	{
		name = "StoneCols",
		filledCells = {
			"X X X X",
			"       ",
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},	
	},
	{
		name = "Tree1",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			" X X X ",
			"  XXX  ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "Tree2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			" X X X ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "Tree2_hanging",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRock",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRock_space",
		filledCells = {
			"  X X  ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "EdgeReels_leftSide",
		filledCells = {
			"XX     ",
		},
	},
	{
		name = "EdgeReels_left3",
		filledCells = {
			"XXX    ",
		},
	},
	{
		name = "BuriedTreasure_LeftColumn_side",
		filledCells = {
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},

	{
	name = "BuriedTreasure_LeftColumn_top",
		filledCells = {
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
	name = "BuriedTreasure_LeftColumn_bottom",
		filledCells = {
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},
	{
		name = "SkyTop_empty",
		filledCells = {
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "SkyTop_pattern",
		filledCells = {
			"XXXXXX",
		},
	},
	{
		name = "SkyTop_blockers",
		filledCells = {
			"      ",
			"      ",
			"XX  XX",
			"X    X",
		},
	},
	{
		name = "SkyTop_blockers1",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"      ",
		},
	},
	{
		name = "SkyTop_blockers2",
		filledCells = {
			"      ",
			"      ",
			" X  X ",
			"X    X",
		},
	},
	{
		name = "SkyTop_blockers3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},	
	{
		name = "SkyTop_blockers4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},

	{
		name = "SkyTop_side_empty",
		filledCells = {
			"X     X",
			" XXXXX ",
			" X   X ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SkyTop_side_blockers",
		filledCells = {
			"       ",
			"       ",
			"  X X ",
			" X   X ",
			"X     X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SkyTop_side_pattern",
		filledCells = {
			" XXXXX ",
			"X     X",
			"X     X",
		},
	},
	{
		name = "BadCoconut_drop1",
		filledCells = {
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BadCoconut_bottom1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXX ",
			"X    X",
		},
	},
	{
		name = "BadCoconut_pattern1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXX ",
		},
	},
	{
		name = "CoconutVersesLava_pattern1",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			"XX    ",
			"XXX   ",
			"XXXX  ",
			"XXXXX ",
		},
	},

	{
		name = "CoconutVersesLava_stone1",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			" X    ",
			"  X   ",
			"   X  ",
			"    X ",
		},
	},
	{
		name = "CoconutVersesLava_stone2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X     ",
			" X    ",
			"  X   ",
			"   X  ",
		},
	},
	{
		name = "CoconutVersesLava_stone3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			" X    ",
			"  X   ",
		},
	},
	{
		name = "CoconutVersesLava_stone4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			" X    ",
		},
	},

	{
		name = "CoconutVersesLava_lava1",
		filledCells = {
			"      ",
			"      ",
			"     ",
			"    ",
			"      ",
			"      ",
			"X ",
		},
	},
	{
		name = "Short_Help_Match_1_Color_1",
		filledCells = {
			"      ",
			"   X  ",
			"   XX ",
			"    X ",
			"      ",
			"X X   ",
			"    XX",
		},
	},
	{
		name = "Short_Help_Match_1_Color_2",
		filledCells = {
			"  X X ",
			"X     ",
			"     X",
			"   X X",
			"   X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_1_Color_3",
		filledCells = {
			"XX    ",
			"  X   ",
			"X     ",
			"      ",
			" XX   ",
			"   XX ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_1_Color_4",
		filledCells = {
			"   X X",
			"      ",
			"      ",
			"X X   ",
			"X     ",
			"     X",
			"XX X  ",
		},
	},
	{
		name = "Short_Help_Match_1_Color_5",
		filledCells = {
			"      ",
			" X  XX",
			" XX   ",
			" X    ",
			"    XX",
			" X    ",
			"  X   ",
		},
	},
	{
		name = "Short_Help_Match_2_Color_1",
		filledCells = {
			"  X   ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_2_Color_2",
		filledCells = {
			"XX    ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_3_Color_1",
		filledCells = {
			"   XX ",
			"   X  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_4_Color_1",
		filledCells = {
			"  X   ",
			"   X  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_4_Color_2",
		filledCells = {
			" X    ",
			"    X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_4_Color_3",
		filledCells = {
			"    X ",
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_4_Color_4",
		filledCells = {
			"   X  ",
			"      ",
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_5_Color_1",
		filledCells = {
			"   X  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_5_Color_2",
		filledCells = {
			" X    ",
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Match_5_Color_3",
		filledCells = {
			"  X X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Short_Help_Level2_Color1",
		filledCells = {
			"    X ",
			"      ",
			"      ",
			"     X",
			"XXX  X",
			"XXXX X",
			"      ",
		},
	},
	{
		name = "Short_Help_Level2_Color2",
		filledCells = {
			"   X  ",
			" X X  ",
			" X X  ",
			"   X  ",
			"   X  ",
			"      ",
			"   X  ",
		},
	},
	{
		name = "Short_Help_Level2_Color3",
		filledCells = {
			"  X   ",
			"  X X ",
			"      ",
			" XX   ",
			"    X ",
			"    X ",
			" X    ",
		},
	},
	{
		name = "Short_Help_Level2_Color4",
		filledCells = {
			" X    ",
			"X    X",
			"  X XX",
			"      ",
			"   X  ",
			"      ",
			"  X X ",
		},
	},
	{
		name = "Short_Help_Level2_Color5",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			"X   X ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "Short_Help_BurstTeacher_Color1",
		filledCells = {
			" XXXXX ",
			"  XXX  ",
			" X     ",
			"X      ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Color2",
		filledCells = {
			"       ",
			"       ",
			"  XX   ",
			"       ",
			"   XX  ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Color3",
		filledCells = {
			"       ",
			"       ",
			"    XXX",
			" X  X X",
			"      X",
			"      X",
			"  X    ",
			"       ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Color4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X X ",
			"       ",
			"   XXX ",
			"    XX ",
			"   XXX ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Color5",
		filledCells = {
			"       ",
			" X   X ",
			"X      ",
			"       ",
			"     X ",
			"  X    ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Step2_Color1",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Step2_Color2",
		filledCells = {
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Step2_Color4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Step3_Color4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Step4_Color3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    X X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Short_Help_BurstTeacher_Step4_Color2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "BigBoxWithSlits",
		filledCells = {
			" X   X ",
			" XXXXX ",
			" X   X ",
			" XXXXX ",
			" X   X ",
			" XXXXX ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "Row7Center3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "Row5Center3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row3Center3",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row1Center3",
		filledCells = {
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OuterTube",
		filledCells = {
			"       ",
			" XXXXX ",
			"       ",
			" X   X ",
			" X   X ",
			"       ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "CornerAngle",
		filledCells = {
			"       ",
			"       ",
			"XXXXX  ",
			"    X  ",
			"    X  ",
			"    X  ",
			"    X  ",
			"    X  ",
		},
	},
	{
		name = "CornerAngleSmall",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXX   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "CornerBox",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXX   ",
			"XXXX   ",
			"XXXX   ",
			"XXXX   ",
			"XXXX   ",
		},
	},
	{
		name = "LittleCornerBox",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX    ",
			"XXX    ",
			"XXX    ",
			"XXX    ",
		},
	},

	{
		name = "Col7_odds",
		filledCells = {
			"      X",
			"       ",
			"      X",
			"       ",
			"      X",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "Col7_evens",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"      X",
			"       ",
			"      X",
			"       ",
			"      X",
		},
	},
	{
		name = "Col7_amber",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
		},
	},
	{
		name = "Col7_boulders",
		filledCells = {
			"      X",
			"      X",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Checkers_Amber",
		filledCells = {
			"       ",
			"       ",
			" X   X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
		},
	},
	{
		name = "Checkers_Crates",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"       ",
			"X     X",
			" X X X ",
			"  X X  ",
			" X X X ",
		},
	},
	{
		name = "Checkers_Jails",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X   X ",
			"  X X  ",
			"       ",
			"X     X",
			"       ",
		},
	},
	{
		name = "SWBO_Amber",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
		},
	},
	{
		name = "SWBO_Oranges",
		filledCells = {
			"     X",
			" X    ",
			"    X ",
			"  X   ",
			"   X  ",
			"X     ",
			" X  X ",
		},
	},
	{
		name = "TimedExcavation_Vines",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "TimedExcavation_TripleStones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
		},
	},
	{
		name = "TimedExcavation_Jails",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			" X   X ",
		},
	},
	{
		name = "TimedExcavation_Boulders",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			" X   X ",
			"X     X",
		},
	},
	{
		name = "TimedExcavation_Amber",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			" X   X ",
			"X     X",
			"       ",
		},
	},
	{
		name = "TimedExcavation_Crates",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			" X   X ",
			"X     X",
			"       ",
			"       ",
		},
	},
	{
		name = "Middle5Stripes",
		filledCells = {
			" XXXXX ",
			"       ",
			" XXXXX ",
			"       ",
			" XXXXX ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Middle5Stripes2",
		filledCells = {
			"       ",
			" XXXXX ",
			"       ",
			" XXXXX ",
			"       ",
			" XXXXX ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "CoconutKnockdown",
		filledCells = {
			" X X  ",
			"X    X",
			"  X X ",
			"X     ",
			"   XX ",
			" X    ",
			"      ",
		},
	},
	{
		name = "AmberRainbow_Amber",
		filledCells = {
			"       ",
			"       ",
			"  XX  X",
			" XX  XX",
			"XX  XX ",
			"X  XX  ",
			"  XX  X",
			" XX  XX",
		},
	},
	{
		name = "AmberRainbow_Jails",
		filledCells = {
			"       ",
			"       ",
			"XX  XX ",
			"X  XX  ",
			"  XX  X",
			" XX  XX",
			"XX  XX ",
			"X  XX  ",
		},
	},
	{
		name = "AmberRainbow_Color1",
		filledCells = {
			"X     X",
			" X     ",
			"  X    ",
			"   X   ",
			"    X  ",
			"     X ",
			"X     X",
			" X     ",
		},
	},
	{
		name = "AmberRainbow_Color2",
		filledCells = {
			"     X ",
			"X     X",
			" X     ",
			"  X    ",
			"   X   ",
			"    X  ",
			"     X ",
			"X     X",
		},
	},
	{
		name = "AmberRainbow_Color3",
		filledCells = {
			"    X  ",
			"     X ",
			"X     X",
			" X     ",
			"  X    ",
			"   X   ",
			"    X  ",
			"     X ",
		},
	},
	{
		name = "AmberRainbow_Color4",
		filledCells = {
			"   X   ",
			"    X  ",
			"     X ",
			"X     X",
			" X     ",
			"  X    ",
			"   X   ",
			"    X  ",
		},
	},
	{
		name = "AmberRainbow_Color5",
		filledCells = {
			"  X    ",
			"   X   ",
			"    X  ",
			"     X ",
			"X     X",
			" X     ",
			"  X    ",
			"   X   ",
		},
	},
	{
		name = "AmberRainbow_Color6",
		filledCells = {
			" X     ",
			"  X    ",
			"   X   ",
			"    X  ",
			"     X ",
			"X     X",
			" X     ",
			"  X    ",
		},
	},
	{
		name = "CornersAndMid_Boulders",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "CornersAndMid_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"  X X  ",
			"       ",
		},
	},
	{
		name = "CornersAndMid_Missing",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
		},
	},
	{
		name = "CornersAndMid_Amber",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "CornersAndMid_AreaAmber",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BlockDivided",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
		},
	},
	{
		name = "AmberBombsB1",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "AmberBombsB2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
		},
	},
	{
		name = "AmberBombsR1",
		filledCells = {
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "AmberBombsR2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "AmberBombsG",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
		},
	},
	{
		name = "AmberBombsY",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "AmberBombsP",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BorderColor1",
		filledCells = {
			" X     ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "BorderColor2",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "BorderColor3",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"    X  ",
		},
	},
	{
		name = "BorderColor4",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X    X ",
		},
	},
	{
		name = "BorderColor5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "Corral",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			" X   X ",
			" X   X ",
			" X   X ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "CorralCenter",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "AboveBottomCorner",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "InnerL",
		filledCells = {
			"       ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "Sections",
		filledCells = {
			"XXX    ",
			"XXX    ",
			"XXX    ",
			"XXX    ",
			"    XXX",
			"    XXX",
			"    XXX",
			"    XXX",
		},
	},
	{
		name = "Sections_ALT",
		filledCells = {
			"       ",
			"XXX    ",
			"XXX    ",
			"XXX    ",
			"    XXX",
			"    XXX",
			"    XXX",
			"       ",
		},
	},
	{
		name = "Slanted",
		filledCells = {
			"XXXX   ",
			"XXX    ",
			"XX     ",
			"X      ",
			"      X",
			"     XX",
			"    XXX",
			"   XXXX",
		},
	},
	{
		name = "Slanted_TopWedge",
		filledCells = {
			"XXXX   ",
			"XXX    ",
			"XX     ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Slanted_BottomWedge",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"     XX",
			"    XXX",
			"   XXXX",
		},
	},
	{
		name = "Slanted_BottomWedge_top",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"     X ",
			"    X  ",
			"       ",
		},
	},
	{
		name = "Slanted_BottomWedge_inner",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"     XX",
			"   XXXX",
		},
	},
	{
		name = "Slanted_BottomWedge_cover",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"     X ",
			"    X  ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "FenceTube",
		filledCells = {
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
		},
	},
	{
		name = "FenceTube_top",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FenceTube_bottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "FenceTube_middle",
		filledCells = {
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "MissingMiddleLargeReels",
		filledCells = {
			"  XXX  ",
		},
	},
	{
		name = "SideTubes",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "RubeMachine_piece1",
		filledCells = {
			"       ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			"     X ",
		},
	},
	{
		name = "RubeMachine_piece2",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "RubeMachine_gem1",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeMachine_gem2",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeMachine_gem3",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeMachine_gem4",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeMachine_gem5",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
		},
	},
	{
		name = "RubeMachine_leftcol",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},
	{
		name = "RubeMachine_missing",
		filledCells = {
			" XXXXX ",
		},
	},
	{
		name = "MissingLargeSideReels",
		filledCells = {
			"XX   XX",
		},
	},
	{
		name = "PatternVille",
		filledCells = {
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
		},
	},
	{
		name = "PatternVille_1",
		filledCells = {
			"X     ",
			"      ",
			"X     ",
			"      ",
			"X     ",
			"      ",
			"X     ",
		},
	},
	{
		name = "PatternVille_2",
		filledCells = {
			"      ",
			" X    ",
			"      ",
			" X    ",
			"      ",
			" X    ",
			"      ",
		},
	},
	{
		name = "PatternVille_3",
		filledCells = {
			"  X   ",
			"      ",
			"  X   ",
			"      ",
			"  X   ",
			"      ",
			"  X   ",
			"      ",
		},
	},
	{
		name = "PatternVille_4",
		filledCells = {
			"      ",
			"   X  ",
			"      ",
			"   X  ",
			"      ",
			"   X  ",
			"      ",
		},
	},
	{
		name = "PatternVille_5",
		filledCells = {
			"    X ",
			"      ",
			"    X ",
			"      ",
			"    X ",
			"      ",
			"    X ",
			"      ",
		},
	},
	{
		name = "PatternVille_6",
		filledCells = {
			"      ",
			"     X",
			"      ",
			"     X",
			"      ",
			"     X",
			"      ",
		},
	},
	{
		name = "CornerSteel_topLeft",
		filledCells = {
			" X    ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "CornerSteel_topRight",
		filledCells = {
			"    X ",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "CornerSteel_bottomLeft",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			" X    ",
		},
	},
	{
		name = "CornerSteel_bottomRight",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"    X ",
		},
	},
	{
		name = "CornerSteel_topLeft_inside",
		filledCells = {
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "CornerSteel_topRight_inside",
		filledCells = {
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "CornerSteel_bottomLeft_inside",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
		},
	},
	{
		name = "CornerSteel_bottomRight_inside",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
		},
	},
	{
		name = "Barrel",
		filledCells = {
			"  XXX  ",
			" X   X ",
			"X  X  X",
			"X X X X",
			"X X X X",
			"X  X  X",
			" X   X ",
			"  XXX  ",
		},
	},
	{
		name = "BurstChests_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X  X  X",
			"       ",
			"       ",
		},
	},
	{
		name = "BurstChests_PatternMid",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "BurstChests_PatternOutside",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"X     X",
		},
	},
	{
		name = "OrangeChute_blanks",
		filledCells = {
			" X     ",
			" X     ",
			" XXXXX ",
			" X     ",
			" X     ",
			" XXXXX ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "CrazyMakers",
		filledCells = {
			"X X X X",
			"       ",
			" X X X ",
			"       ",
			"X X X X",
			"       ",
			" X X X ",
			"       ",
		},
	},
	{
		name = "MakerTest4_Steel",
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"X X    ",
			"  X    ",
			"  X    ",
			"  X    ",
		},
	},
	{
		name = "MakerTest4_Maker",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerTest4_Clear",
		filledCells = {
			"       ",
			"XXXXXXX",
			" XXXXXX",
			"XXXXXXX",
			" X XXXX",
			"XX XXXX",
			"XX XXXX",
			"XX X   ",
		},
	},
	{
		name = "MakerTest4_Blue",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    XXX",
		},
	},

	{
		name = "RubeMakersH",
		filledCells = {
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeMakersV",
		filledCells = {
			"      X",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeMakersA",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeMakersRegular",
		filledCells = {
			"       ",
			"       ",
			"   XX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeSteel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"     X ",
			"     X ",
			" X   X ",
			"     X ",
			"     X ",
		},
	},
	{
		name = "RubeChest",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubeFences",
		filledCells = {
			"       ",
			"       ",
			" X     ",
			" X     ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "RubeStone",
		filledCells = {
			"       ",
			"  XXXX ",
			"       ",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
		},
	},
	{
		name = "RubeMissing",
		filledCells = {
			"X XXXX ",
			"X      ",
			"  X  X ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubePlaceV",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"X      ",
			" X     ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubePlaceH",
		filledCells = {
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RubePlaceA",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			" X     ",
			"       ",
		},
	},
	{
		name = "BombChutes",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ChuteBombs",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ChuteBombsMissing",
		filledCells = {
			" X   X ",
			" X   X ",
			"X     X",
			"       ",
			"  X X  ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "Leftcol_1mod3",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "Leftcol_2mod3",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "AmberPatternMissing",
		filledCells = {
			" X     ",
			" X     ",
			"XX     ",
			" X     ",
			" X     ",
			"XX     ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "Stripes Steel",
		filledCells = {
			"       ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
		},
	},
	{
		name = "MissingSides456",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"X    X",
			"X    X",
			"      ",
		},
	},
	{
		name = "SidesRow3",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "WhackARed Makers",
		filledCells = {
			"    X  ",
			"X      ",
			"  X   X",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "WhackARed Red",
		filledCells = {
			"       ",
			"    X  ",
			"X   X  ",
			"X X   X",
			"  X   X",
			"   X   ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "PowerCombined Makers",
		filledCells = {
			" X   X",
			"   X  ",
			"X     ",
			"    X ",
			"  X   ",
			"      ",
			"      ",
		},
	},
	{
		name = "Cols35Punch",
		filledCells = {
			"       ",
			"  X    ",
			"    X  ",
			"  X    ",
			"    X  ",
			"  X    ",
			"    X  ",
			"  X    ",
		},
	},
	{
		name = "SideFrame",
		filledCells = {
			"XX  XX",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"XX  XX",
		},
	},
	{
		name = "EvenMids",
		filledCells = {
			"      ",
			"  XX  ",
			"      ",
			"  XX  ",
			"      ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "OddMids",
		filledCells = {
			"  XX  ",
			"      ",
			"  XX  ",
			"      ",
			"  XX  ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "SideLocks",
		filledCells = {
			" X   X",
			"X   X ",
			" X   X",
			"X   X ",
			" X   X",
			"X   X ",
			" X   X",
		},
	},
	{
		name = "SideBarrels",
		filledCells = {
			"X     ",
			"     X",
			"X     ",
			"     X",
			"X     ",
			"     X",
			"X     ",
		},
	},
	{
		name = "GrowingSpace",
		filledCells = {
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "GrowingSpace_Color1",
		filledCells = {
			"  XX   ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GrowingSpace_Color2",
		filledCells = {
			"       ",
			"   X   ",
			"  XX   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GrowingSpace_Color3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GrowingSpace_Color4",
		filledCells = {
			"    X  ",
			"    X  ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PandorasLocks_Vines",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX     ",
			"XX     ",
		},
	},
	{
		name = "PandorasLocks_Lava",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     XX",
			"     XX",
		},
	},
	{
		name = "PandorasLocks_BoulderMaker",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PandorasLocks_BombMakers",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PandorasLocks_Locks",
		filledCells = {
			"       ",
			"   X   ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"  X X  ",
		},
	},
	{
		name = "PandorasLocks_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"       ",
			"       ",
		},
	},
	{
		name = "Dispensers_MakeChestAndLock",
		filledCells = {
			"   X   ", 
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",
		},
	},
	{
		name = "Dispensers_MakeStoneAndWild1",
		filledCells = {
			"    X  ", 
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",
		},
	},
	{
		name = "Dispensers_MakeStoneAndWild2",
		filledCells = {
			"  X    ", 
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",
		},
	},
	{
		name = "Dispensers_MakeWideVertical1",
		filledCells = {
			"       ", 
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			" X     ",  
			"       ",   
			"       ",
		},
	},
	{
		name = "Dispensers_MakeWideVertical2",
		filledCells = {
			"       ", 
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"     X ",  
			"       ",   
			"       ",
		},
	},
	{
		name = "Dispensers_Missing",
		filledCells = {
			"       ", 
			" X   X ",  
			" X X X ",   
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",
		},
	},
	{
		name = "Dispensers_Fence",
		filledCells = {
			"       ", 
			"       ",  
			"  X X  ",   
			"       ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",
		},
	},
	{
		name = "Dispensers_Locks",
		filledCells = {
			"       ", 
			"   X   ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",  
			" X   X ",   
			"       ",
		},
	},
	{
		name = "Dispensers_Stones",
		filledCells = {
			"       ", 
			"  X X  ",  
			"       ",   
			"       ",  
			"       ",   
			"       ",  
			"       ",  
			"       ",
		},
	},
	{
		name = "FaultLine_Locks",
		filledCells = {
			"       ", 
			"       ",  
			"  X X  ",   
			"       ",  
			" X   X ",   
			"       ",  
			"  X X  ", 
			"       ",
		},
	},
	{
		name = "StackedCs",
		filledCells = {
			"       ", 
			"XXX XXX",  
			"X     X",   
			"XXX XXX",    
			"       ",   
			"XXX XXX",    
			"X     X",   
			"XXX XXX",
		},
	},
	{
		name = "AmberLocks_locks",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"X XX X",
		},
	},
	{
		name = "AmberLocks_amber",
		filledCells = {
			" X  X ",
			"XX  XX",
			"XX  XX",
			" X  X ",
			"XX  XX",
			"XXXXXX",
			" X  X ",
		},
	},
	{
		name = "ZigzagChecks",
		filledCells = {
			"  X X ",
			" X X  ",
			"X X   ",
			" X X  ",
			"  X X ",
			"   X X",
			"  X X ",
		},
	},
	{
		name = "BarrelChecks",
		filledCells = {
			"   X  ",
			"  X   ",
			" X    ",
			"  X   ",
			"   X  ",
			"    X ",
			"   X  ",
		},
	},
	{
		name = "ZigzagRows",
		filledCells = {
			"      ",
			"X X X ",
			" X X X",
			"      ",
			"X X X ",
			" X X X",
			"      ",
		},
	},
	{
		name = "MiddleZig",
		filledCells = {
			"      ",
			"      ",
			"X X X ",
			" X X X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BottomZig",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X X X",
			"X X X ",
		},
	},
	{
		name = "ZigzagRows2",
		filledCells = {
			"      ",
			"XX  XX",
			"  XX  ",
			"      ",
			"XX  XX",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "XPattern",
		filledCells = {
			"X    X",
			" X  X ",
			"  XX  ",
			" X  X ",
			"  XX  ",
			" X  X ",
			"X    X",
		},
	},
	{
		name = "Help_Level7_Pattern3",
		filledCells = {
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Help_Level9_Pattern1",
		filledCells = {
			"     X",
			"   X X",
			"X  X  ",
			"X     ",
			"X     ",
			"      ",
			"      ",
		},
	},
	{
		name = "Help_Level9_Pattern2",
		filledCells = {
			"    X ",
			"    X ",
			"    XX",
			"  X   ",
			" XX   ",
			"XX    ",
			"      ",
		},
	},
	{
		name = "Help_Level9_Pattern3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
			"   X  ",
			"XX X  ",
		},
	},
	{
		name = "Help_Level9_Pattern4",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			" X XX ",
			"    X ",
			"    X ",
			"  X   ",
		},
	},
	{
		name = "Help_Level9_Pattern5",
		filledCells = {
			"  XX X",
			" XX  X",
			"  X   ",
			"  X  X",
			"     X",
			"  X   ",
			"      ",
		},
	},
	{
		name = "Help_Level14_Pattern1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
			"    X ",
			"    XX",
		},
	},
	{
		name = "Help_Level14_Pattern2",
		filledCells = {
			"    XX",
			"    X ",
			" X  X ",
			" X    ",
			"      ",
			"  X   ",
			"  XX  ",
		},
	},
	{
		name = "Help_Level14_Pattern3",
		filledCells = {
			"XX    ",
			" X    ",
			"      ",
			"  X X ",
			"  X   ",
			"      ",
			"      ",
		},
	},
	{
		name = "Help_Level14_Pattern4",
		filledCells = {
			"      ",
			"   X  ",
			"  XX  ",
			"   X  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Help_Level14_Pattern5",
		filledCells = {
			"  XX  ",
			"  X   ",
			"      ",
			"      ",
			" X X  ",
			" X X  ",
			"XX    ",
		},
	},
	{
		name = "Help_Level17_Color1",
		filledCells = {
			"       ",
			"   X   ",
			"   XX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Help_Level17_VerticalBurst",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Help_Level17_HorizontalBurst",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Help_Level17_AreaBurst",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Help_Level22_Chest",
		filledCells = {
			"  X   ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Help_Level22_Color1",
		filledCells = {
			"      ",
			"      ",
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
		},
	},
	{
		name = "Help_Level22_Color2",
		filledCells = {
			" X    ",
			"      ",
			"      ",
			" X    ",
			" X    ",
			"      ",
			"      ",
		},
	},
	{
		name = "Help_Level22_Color3",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			"      ",
			"      ",
			" X X  ",
			"   X  ",
		},
	},
	{
		name = "Help_Level22_Color4",
		filledCells = {
			"   X  ",
			"      ",
			"      ",
			"      ",
			"   X  ",
			"      ",
			" X    ",
		},
	},
	{
		name = "Help_Level22_Color5",
		filledCells = {
			"      ",
			"      ",
			"   X  ",
			"   X  ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "JailBroken_Jails",
		filledCells = {
            "       ",
			"       ",
			"    XX ",
			" X   X ",
			"     X ",
			" X X X ",
			"       ",
			"       ",
		},
	},
    {
		name = "JailBroken_Chests",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "JailBroken_Makers",
		filledCells = {
            "       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "JailBroken_Steel",
		filledCells = {
            "       ",
			"       ",
			" X X   ",
			"       ",
			" X     ",
			"  X    ",
			"       ",
			"       ",
		},
	},
    {
		name = "JailBroken2_Jails",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X X X ",
			"       ",

		},
	},
    {
		name = "JailBroken2_Chests",
		filledCells = {
			"       ",
            "       ",
			"       ",
			"       ",
			"  XXX  ",
			"   XX  ",
			"    X  ",
			"       ",
		},
	},
    {
		name = "JailBroken4_Chests",
		filledCells = {
			"       ",
            "       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "JailBroken2_Makers",
		filledCells = {
			"       ",
            "       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "JailBroken2_Steel",
		filledCells = {
			"       ",
            "       ",
			"       ",
			"   XX  ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
    {
		name = "JailhouseRocks_JailsAndOranges",
		filledCells = {
            "       ",
            "       ",
			" XXX   ",
			" X XXX ",
			" XXX X ",
			"  XXXX ",
			"    X  ",
			"       ",
		},
	},
    {
		name = "JailhouseRocks_Stones",
		filledCells = {
            "       ",
            "       ",
			"       ",
			"  X    ",
			"    X  ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "Matryoshka_Barrels",
		filledCells = {
            "       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
		},
	},
    {
		name = "Matryoshka_Steel",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
    {
		name = "DoubleQuarantine_JailsAndWilds",
		filledCells = {
            "      ",
			"      ",
			"  XX  ",
			" X  X ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
    {
		name = "DoubleQuarantine_Lava",
		filledCells = {
            "      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "DoubleQuarantine_Vines",
		filledCells = {
            "      ",
			"      ",
			"      ",
			"   X  ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "DoubleQuarantine_Clouds",
		filledCells = {
            "XX  XX",
			"X    X",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
		},
	},
    {
		name = "DoNotOpen_Clouds",
		filledCells = {
            " XXXX ",
			"  XXXX",
			"XXXX  ",
			"  XXXX",
			"XXXX  ",
			"  XXXX",
			" XXXX ",
		},
	},
    {
		name = "BehindBars_Reels",
		filledCells = {
			"XX   XX",
		},
	},
    {
		name = "BehindBars_Jails",
		filledCells = {
            " X   X ",
			" X     ",
			"     X ",
			" X   X ",
			" X     ",
			"     X ",
			" X   X ",
			" X     ",
		},
	},
    {
		name = "BehindBars_Clouds",
		filledCells = {
            "X     X",
			"X      ",
			"      X",
			"X     X",
			"X      ",
			"      X",
			"X     X",
			"X      ",
		},
	},
    {
		name = "BehindBars2_Jails",
		filledCells = {
            "       ",
			" X   X ",
			"     X ",
			" X     ",
			" X     ",
			"     X ",
			" X   X ",
			"       ",
		},
	},
    {
		name = "BehindBars2_2xClouds",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"X      ",
			"X      ",
			"      X",
			"X     X",
			"X     X",
		},
	},
    {
		name = "BehindBars2_1xClouds",
		filledCells = {
            "       ",
			"X     X",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "BehindBars2_Missing",
		filledCells = {
            "XX   XX",
			"       ",
			"XX     ",
			"     XX",
			"     XX",
			"XX     ",
			"       ",
			" X   X ",
		},
	},
    {
		name = "HedgeTrimmer_Reels",
		filledCells = {
			"XX    X",
		},
	},
    {
		name = "HedgeTrimmer_Vines",
		filledCells = {
            "       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},
    {
		name = "HedgeTrimmer_Color1",
		filledCells = {
            "       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
    {
		name = "HedgeTrimmer_Color2",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "HedgeTrimmer_Color3",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
		},
	},
    {
		name = "HedgeTrimmer_Color4",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
    {
		name = "HedgeTrimmer_Steel",
		filledCells = {
            "       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "HedgeTrimmer_Missing",
		filledCells = {
            "XX     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},
    {
		name = "DoubleQuarantine3_JailsAndWilds",
		filledCells = {
            "       ",
			"       ",
			"  XXX  ",
			" X   X ",
			"  XXX  ",
			"       ",
			"       ",
            "       ",
		},
	},
    {
		name = "DoubleQuarantine3_Lava",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "DoubleQuarantine3_Vines",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
            "       ",
			"       ",
		},
	},
    {
		name = "DoubleQuarantine3_Clouds",
		filledCells = {
            "XX   XX",
			"X     X",
			"       ",
			"       ",
            "       ",
			"       ",
			"X     X",
			"XX   XX",
		},
	},
    {
		name = "BarrelhouseRocks_Barrels",
		filledCells = {
            "       ",
            "       ",
			" XXX   ",
			" X XXX ",
			" XXX X ",
			"   XXX ",
			"       ",
			"       ",
		},
	},
    {
		name = "JailhouseRocks_Stones",
		filledCells = {
            "       ",
            "       ",
			"       ",
			"  X    ",
			"    X  ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "BarrelhouseRocks_Steel",
		filledCells = {
            "       ",
            "       ",
			"       ",
			"       ",
			"       ",
			" XX    ",
			"  XXXX ",
			"       ",
		},
	},
    {
		name = "JailTrimmer_Missing",
		filledCells = {
            "XX     ",
			"XX     ",
			"XX     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "JailTrimmer_Jails",
		filledCells = {
            "       ",
			"       ",
			"       ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},
    {
		name = "JailTrimmer_Vines",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},
    {
		name = "MultiJailrelBlitz_Jails",
		filledCells = {
            "       ",
            "   X   ",
			" XXXXX ",
			" X X X ",
			" XXXXX ",
			"   X   ",
			"       ",
			"       ",
		},
	},
    {
		name = "MultiJailrelBlitz_Barrels",
		filledCells = {
            "       ",
            "       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "PrisonLattice_Reels",
		filledCells = {
			"X  X  X",
		},
	},
    {
		name = "PrisonLattice_Missing",
		filledCells = {
            "       ",
            "X  X  X",
			"       ",
			"X  X  X",
			"       ",
			"X  X  X",
			"       ",
			"X  X  X",
		},
	},
    {
		name = "PrisonLattice_Clouds",
		filledCells = {
            "       ",
            " XX XX ",
			"XXXXXXX",
			" XX XX ",
			"XXXXXXX",
			" XX XX ",
			"       ",
			"       ",
		},
	},
    {
		name = "PrisonersDualemma_Clouds",
		filledCells = {
			"       ",
            "       ",
            "       ",
			"       ",
			"X     X",
			"X     X",
			"       ",
			"       ",
		},
	},
    {
		name = "PrisonersDualemma_Jails",
		filledCells = {
			"       ",
            "       ",
            "       ",
			"X     X",
			" X   X ",
			" X   X ",
			"X     X",
			"       ",
		},
	},
     {
		name = "PrisonersDualemma_Reels",
		filledCells = {
			"X     X",
		},
	},
    {
		name = "ItTakesTwo_Jails",
		filledCells = {
			"      ",
			"  XX  ",
			" X  X ",
			"    X ",
			"   X  ",
			"  X   ",
            " XXXX ",
		},
	},
	{
		name = "BurstTeacher_Area",
		filledCells = {
			"      ",
			"      ",
			"XXX   ",
			"XXX   ",
			"XXX   ",
			"      ",
            "      ",
		},
	},
	{
		name = "BurstTeacher_Vert",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXX  ",
            "XXXX  ",
		},
	},
	{
		name = "BurstTeacher_Horiz",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"    XX",
			"    XX",
			"    XX",
            "    XX",
		},
	},
    {
		name = "DoABarrelRoll_Missing",
		filledCells = {
            "X  X X", 
            "      ",
            "  X   ", 
            "      ", 
            "   X  ", 
            "      ", 
            "  XX  ",
		},
	},
	{
		name = "JailedBurst Test Jail",
		filledCells = {
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "JailedBurst Test AreaBurst",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "JailedBurst Test VerticalBurst",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "JailedBurst Test Connector",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"  X    ",
			"       ",
			"       ",
		},
	},
    {
		name = "BarrelledTreasure_Chests",
		filledCells = {
            "X     X",
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "BarrelledTreasure_Steel",
		filledCells = {
            "       ",
            "       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			" X X   ",
			"       ",
		},
	},
    {
		name = "BarrelledTreasure_Barrels",
		filledCells = {
            "       ",
            "      X",
			"X     X",
			"X      ",
			"      X",
			"X     X",
			"X      ",
			"       ",
		},
	},
    {
		name = "BarrelledTreasure2_Missing",
		filledCells = {
            "X     X",
            "       ",
			" X   X ",
			"       ",
			"   X   ",
			"X     X",
			"X     X",
			"X X X X",
		},
	},
    {
		name = "BarrelledTreasure_Missing",
		filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "X X X X",
            "       ",
            " X X X ",
            "   X   ",
		},
	},
    {
		name = "BarrelledTreasure_Reels",
		filledCells = {
            "X     X",
		},
	},
    {
		name = "DoubleBarrelSlotGun_Makers",
		filledCells = {
            "  XX  ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
		},
	},
    {
		name = "DoubleBarrelSlotGun_Jails",
		filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "X    X",
            "XXXXXX",
		},
	},
    {
		name = "DoubleBarrelSlotGun_Missing",
		filledCells = {
            "XX  XX",
            "X    X",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
		},
	},
    {
		name = "DoubleBarrelSlotGun_Reels",
		filledCells = {
            "X    X",
		},
	},
    {
		name = "DoubleBarrelSlotGun_Steel",
		filledCells = {
            "      ",
            " X  X ",
            "X    X",
            "      ",
            "      ",
            "      ",
            "      ",
		},
	},
    {
		name = "CrossedLines",
		filledCells = {
            "X     ",
            " X   X",
            "  X X ",
            "   X  ",
            "  X X ",
            " X   X",
			"X     ",
		},
	},

	{
		name = "XSingleJails",
		filledCells = {
            "X     ",
            "     X",
            "      ",
            "   X  ",
            "      ",
            "     X",
			"X     ",
		},
	},

	{
		name = "XDoubleJails",
		filledCells = {
            "      ",
            " X    ",
            "  X X ",
            "      ",
            "  X X ",
            " X    ",
			"      ",
		},
	},
    
    {
        name = "BombDungeon1_side_barriers",
        filledCells = {
            " X   X ",
            "XX   XX",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    
    {
        name = "BombDungeon1_side_bombs",
        filledCells = {
            "X     X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },

-------------------------
--- LAND 21, Dave Patterns -------
-------------------------

	{
		name = "Battlement1",
		filledCells = {
			"XXX XXX",
			"XX   XX",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",

		},
	},
	{
		name = "Battlement1_walls",
		filledCells = {
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"       ",

		},
	},
	{
		name = "Battlement1_walls2_b",
		filledCells = {
			"   X   ",
			"       ",
			"X     X",
			"       ",
			"       ",

		},
	},
	{
		name = "Battlement1_walls2_a",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			"X X X X",
			"       ",
			"       ",

		},
	},
	{
		name = "Battlement1_windows",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			" X X X ",
			"       ",
			"       ",
		},
	},
	{
		name = "Battlement1_roof",
		filledCells = {
			"   X   ",
			"  X X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Battlement1_roof2",
		filledCells = {
			"   X   ",
			"  X X  ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "DropIt1",
		filledCells = {
			"  XXX  ",
			"  X X  ",
			"  XXX  ",
			"       ",
			"       ",

		},
	},
	{
		name = "DropIt1_pattern1",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"   X    ",
			"        ",
			"   X    ",
			"        ",
			"   X    ",

		},
	},
	{
		name = "DropIt1_test",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",

		},
	},
	{
		name = "DropIt1_pattern2",	
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "DropIt1_pattern_tower1",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"   X    ",
			"        ",
			"        ",
			"        ",
			"        ",
		},
	},
	{
		name = "DropIt1_pattern_tower2",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"        ",
			"   X    ",
			"        ",
			"        ",
			"        ",
		},
	},
	{
		name = "DropIt1_pattern_tower3",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"   X    ",
			"        ",
			"        ",
		},
	},
	{
		name = "DropIt1_pattern_tower4",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"   X    ",
			"        ",
		},
	},
	{
		name = "DropIt1_pattern_tower5",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"   X    ",
		},
	},
	{
		name = "DropIt1_chest",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},

	{
		name = "Maker_TopLeft1",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "Maker_TopRight1_large",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "Maker_TopRight1",
		filledCells = {
			"     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "Maker_Center1",
		filledCells = {
			"  XX   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "Line_Right1",
		filledCells = {
			"      ",
			"     X",
			"     X",
			"     X",
			"     X",
			"     X",
			"     X",
		},
	},

	{
		name = "Battle_Board1",
		filledCells = {
			" X  X ",
			" X  X",
			" X  X",
			" X  X",
			" X  X",
			" X  X",
			" X  X",
		},
	},

	{
		name = "HashTag1",
		filledCells = {
			" X  X ",
			"XXXXXX",
			" X  X",
			" X  X",
			" X  X",
			"XXXXXX",
			" X  X",
		},
	},

-------------------------
--- LAND 21, Zach Patterns -------
-------------------------

    {
		name = "Quarry_Stones",
		filledCells = {
			"      ",
			"X X X ",
			" X   X",
			"      ",
			"X   X ",
			" X X X",
			"      ",
		},
	},

    {
		name = "Sand_Missing",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			"X     X",
			"       ",
			"       ",
            "       ",
		},
	},
    {
		name = "Sand_Steel",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			" X   X ",
			"       ",
			"       ",
			"       ",
            "       ",
		},
	},
    {
		name = "Sand_Boulders",
		filledCells = {
			"X     X",
			" X X X ",
			"  X X  ",
			"   X   ",
			"       ",
			"       ",
			"       ",
            "       ",
		},
	},
    {
		name = "Sand_Bombs",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
            "       ",
		},
	},
    {
		name = "Sand_Makers",
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
            "       ",
		},
	},
    {
		name = "Sand_Reels",
		filledCells = {
			"X     X",
		},
	},
     {
		name = "Spider_Missing",
		filledCells = {
			"X     X",
			"       ",
			"X     X",
			"       ",
			" X   X ",
			" X   X ",
			" X   X ",
            "       ",
		},
	},
    {
		name = "Spider_Vines",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
            "      X",
		},
	},
    {
		name = "Spider_Lava",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
            "X      ",
		},
	},
    {
		name = "Spider_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
            " X   X ",
		},
	},
    {
		name = "Spider_Reels",
		filledCells = {
			"X     X",
		},
	},

    {
		name = "BurningBush_Reels",
		filledCells = {
			"XX     ",
		},
	},
    {
		name = "BurningBush_Lava",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
            "X      ",
            "       ",
		},
	},
    {
		name = "BurningBush_VineGenerators",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
            "       ",
			"X      ",
		},
	},
    {
		name = "BurningBush_Vines",
		filledCells = {
            "       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"       ",
            "       ",
		},
	},
    {
		name = "BurningBush_Makers",
		filledCells = {
            "   X X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "BurningBush_Missing",
		filledCells = {
            "XX     ",
			"XX     ",
			" X     ",
			" X     ",
			" X     ",
			" X  X  ",
			" X     ",
            " X     ",
		},
	},

    {
		name = "MakerOfBoulders_Makers",
		filledCells = {
            "    X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
            "      ",
 		},
	},

    {
		name = "MakerOfBoulders_Boulders",
		filledCells = {
            "      ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
            "    X ",
 		},
	},

    {
		name = "MakerOfBoulders_Lava",
		filledCells = {
            "      ",
			"      ",
			"      ",
			"     X",
			"     X",
			"     X",
            "      ",
 		},
	},

    {
		name = "MakerOfBoulders_Steel",
		filledCells = {
            "     X",
			"     X",
			"     X",
			"      ",
			"      ",
			"      ",
            "     X",
 		},
	},

    {
		name = "MakerOfBoulders_Reels",
		filledCells = {
            "    XX",
 		},
	},

    {
		name = "ColorWheel_Missing",
		filledCells = {
            "X    X",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
            "X    X",
 		},
	},

    {
		name = "ColorWheel_Reels",
		filledCells = {
            "X    X",
 		},
	},

	-------------------------
--- LAND 21, Naomi Patterns -------
	-------------------------
    {
		name = "FrameCorners",
		filledCells = {
            "XX   XX",
            "XX   XX",
            "X     X",
            "       ",
            "       ",
            "       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VerticalHits_makers",
		filledCells = {
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
			"       ",
			"       ",
		},
	},
    {
		name = "VerticalHits_missing",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "VerticalHits_fences",
		filledCells = {
            "       ",
            "       ",
            "  X X  ",
            " X   X ",
            "       ",
            "       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VerticalHits_side_fences",
		filledCells = {
            "       ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
            "       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PictureFrame_pattern",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "PyramidDrop_Crates",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			" X   X ",
			"X     X",
			"       ",
		},
	},
	{
		name = "PyramidDrop_Stones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			" XX XX ",
			"XXXXXXX",
		},
	},
	{
		name = "PyramidDrop_Chest",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "JailPairs_Color1",
		filledCells = {
			"X X    ",
			"       ",
			"     X ",
			"       ",
			"     X ",
			" X     ",
			"       ",
			" X     ",
		},
	},
	{
		name = "JailPairs_Color2",
		filledCells = {
			"       ",
			" X X   ",
			"       ",
			"    X X",
			"       ",
			"       ",
			"    X X",
			"       ",
		},
	},
	{
		name = "JailPairs_Color3",
		filledCells = {
			"    X X",
			"X      ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
		},
	},
	{
		name = "JailPairs_Color4",
		filledCells = {
			"       ",
			"    X X",
			"       ",
			"       ",
			" X X   ",
			"      X",
			"       ",
			"      X",
		},
	},
	{
		name = "JailPairs_Color5",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"X X    ",
			" X X   ",
			"       ",
		},
	},
	{
		name = "BottomRow_Spot1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
		},
	},
	{
		name = "BottomRow_Spot2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
		},
	},
	{
		name = "BottomRow_Spot3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  X   ",
		},
	},
	{
		name = "BottomRow_Spot4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
		},
	},
	{
		name = "BottomRow_Spot5",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
		},
	},
	{
		name = "BottomRow_Spot6",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
		},
	},
	{
		name = "EmptyColumns_Missing",
		filledCells = {
			" X  X ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "EmptyColumns_Pattern",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
		},
	},

--------------------
-- Land 22: Jonathan
--------------------

	{
		name = "AutoTrimmer_GemEaters",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"       ",
			" X   X ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "BadBarrels_Pattern",
		filledCells = {
			"       ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
		},
	},
	{
		name = "PatternEater_Pattern",
		filledCells = {
			"XX   X",
			"X   XX",
			"XX   X",
			"X   XX",
			"XX   X",
			"X   XX",
			"XX   X",
		},
	},
	{
		name = "PatternEater_GemEaters",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
		},
	},
	{
		name = "TopRow_Column1_Large",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow_Column2_Large",
		filledCells = {
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow_Column3_Large",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow_Column4_Large",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow_Column5_Large",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow_Column6_Large",
		filledCells = {
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow_Column7_Large",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
--------------------
-- Land 22: Naomi
--------------------

	{
		name = "BombEater_steel",
		filledCells = {
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"      ",
			"      ",
		},
	},

	{
		name = "UseIt_makers",
		filledCells = {
            "  X X  ",
			"       ",
			" X   X ",
			"       ",
			" X   X ",
			"       ",
			"  X X  ",
			"       ",
		},
	},

	{
		name = "UseIt_eaters",
		filledCells = {
			"       ",
			"  X X  ",
			"       ",
			" X   X ",
			"       ",
			" X   X ",
			"       ",
			"  X X  ",
		},
	},

	{
		name = "TopCols",
		filledCells = {
			"X    X",
			"X    X",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "BottomCols",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"X    X",
			"X    X",
		},
	},

	{
		name = "BottomHole",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
		},
	},

	{
		name = "BurstTraps_eaters",
		filledCells = {
            "       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"  X X  ",
			"XX   XX",
		},
	},

	{
		name = "OrangeEaters_missing",
		filledCells = {
			"XX   XX",
			" X   X ",
			"       ",
			" X   X ",
			"       ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "OrangeEaters_orange1",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OrangeEaters_orange2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OrangeEaters_orange3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
		},
	},
	{
		name = "OrangeEaters_stone",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
		},
	},
	{
		name = "UseItOrLoseIt_Pattern",
		filledCells = {
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},
	{
		name = "UseItOrLoseIt_Missing",
		filledCells = {
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "UseItOrLoseIt_Makers",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "UseItOrLoseIt_Eaters",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"     X ",
		},
	},
	{
		name = "UseItOrLoseIt_Fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},

-------------------------
--- LAND 23, Jonathan ---
-------------------------

	--Box 1: Has horizontal wide burst. Broken by breaking it. 1 hit.
	--Box 2: Has wide vertical burst. Broken by being hit by box 1. 1 hit.
	--Box 3: Has wide horizontal burst. Broken by being hit by box 2. 1 hit.
	--Box 4: Has wide vertical burst. Broken by being hit by box 3. 1 hit.
	--Box 5: Has wide horizontal burst. Broken by being hit by box 4. 2 hits. (Has been hit by box 2).
	--Box 6: Has wide vertical burst. Broken by being hit by box 5. 3 hits (Has been hit by box 1, 2).
	--Box 7: Has wide horizontal burst. Broken by being hit by box 6. 3 hits. (Has been hit by box 2, 3).
	--Box 8: Superwild, used for endgame sequence. 3 hits. (Has been hit by box 3,4)

	--Each undetonated box must be activated by players making a burst or superwild combo. Let's do 4 colors to make that more likely.

	--[[
	{
		name = "BoxSpiral",
		filledCells = {
			"8E   E7",
			"4E  E3E",
			"E    E ",
			"       ",
			"       ",
			"     E ",
			"E1  E2E",
			"5E   E6",
		},
	},
	]]--

	
	{
		name = "BoxSpiral_Empty",
		filledCells = {
			" X   X ",
			" X  X  ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"X   X X",
			" X   X ",
		},
	},
	{
		name = "BoxSpiral_Fences",
		filledCells = {
			"       ",
			"      X",
			"X    XX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BoxSpiral_Box1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
		},
	},
	{
		name = "BoxSpiral_Box2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
		},
	},
	{
		name = "BoxSpiral_Box3",
		filledCells = {
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BoxSpiral_Box4",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BoxSpiral_Box5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "BoxSpiral_Box6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "BoxSpiral_Box7",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BoxSpiral_Box8",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	
	{
		name = "Regifting_1Hit",
		filledCells = {
			"       ",
			"  X    ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "Regifting_2Hit",
		filledCells = {
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"   X  X",
			"      X",
			"       ",
		},
	},
	{
		name = "Regifting_3Hit",
		filledCells = {
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"X      ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "LockedLava_Lava",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
			"XXXXXX",
		},
	},
	{
		name = "LockedLava_Locks",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "LockBox_Gifts3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			" X   X ",
		},
	},
	{
		name = "LockBox_Gifts2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			" XX XX ",
			"X     X",
		},
	},
	{
		name = "LockBox_Gifts1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			" XX XX ",
			"X     X",
			"       ",
			"       ",
		},
	},
	{
		name = "UpAndDownAgain_Gifts1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "UpAndDownAgain_Gifts2",
		filledCells = {
			"       ",
			"       ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "UpAndDownAgain_Gifts3",
		filledCells = {
			" XX XX ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

-------------------------
--- LAND 23, Naomi ------
-------------------------
	{
		name = "Border1",
		filledCells = {
			"X     ",
			"     X",
			"X     ",
			"     X",
			"X     ",
			"     X",
			"X X X ",
		},
	},
	{
		name = "Border2",
		filledCells = {
			"     X",
			"X     ",
			"     X",
			"X     ",
			"     X",
			"X     ",
			" X X X",
		},
	},
	{
		name = "LeftNoTopNoBottom",
		filledCells = {
			"      ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"      ",
		},
	},
    {
		name = "ColorSpout_eaters",
		filledCells = {
			" X    ",
			"XX    ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"      ",
		},
	},
	{
		name = "ColorSpout_stone",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			" X    ",
			" X    ",
			" X    ",
			"X     ",
		},
	},
    {
		name = "ColorSpout_reels",
		filledCells = {
			"XX    ",
		},
	},
	{
		name = "JugHoles",
		filledCells = {
			"       ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "JugHandles",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XX   XX",
		},
	},

	{
		name = "Reels26",
		filledCells = {
			" X   X ",
		},
	},

	{
		name = "Plumbing_makers",
		filledCells = {
            "  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TowerRaid_missing",
		filledCells = {
            "       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "TowerRaid_eaters",
		filledCells = {
            "       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TowerRaid_stone",
		filledCells = {
            "       ",
			"       ",
			"  X X  ",
			"       ",
			"  X X  ",
			"   X   ",
			"  X X  ",
			"  XXX  ",
		},
	},
	{
		name = "TowerRaid_fences",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TowerRaid_bomb",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TowerRaid_chest",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
		},
	},
-------------------------
--- LAND 23, Zach -------
-------------------------

    {
		name = "AirDrop_Gifts",
		filledCells = {
			"       ",
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "AirDrop_MakersGems",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "AirDrop_MakersGifts",
		filledCells = {
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "AirDrop_Clouds",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			" XXXXX ",
		},
	},

    {
		name = "TowerToTheClouds_Makers",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "TowerToTheClouds_Gifts",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "TowerToTheClouds_Reels",
		filledCells = {
			"   X   ",
		},
	},
	
	{
		name = "Bug_TestPattern1",
		filledCells = {
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Bug_TestPattern2",
		filledCells = {
			"  X   ",
			"  X   ",
			" XX   ",
			"XX    ",
			"XX    ",
			"      ",
			"      ",
		},
	},
	{
		name = "Domino_fences",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"    X  ",
			"   X X ",
			"    X  ",
			"     X ",
			"       ",
		},
	},
	{
		name = "Domino_steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"    X  ",
		},
	},
	{
		name = "Domino_makerV",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Domino_makerH",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Domino_makerA",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Domino_chest",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "Domino_stone",
		filledCells = {
			"       ",
			"      X",
			"    X X",
			"       ",
			"      X",
			"     X ",
			"       ",
			"     XX",
		},
	},
	{
		name = "Domino_horiz",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Domino_missing",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"    X  ",
			"       ",
		},
	},
	{
		name = "FillTheTank_makers",
		filledCells = {
			"       ",
			"       ",
			"X  X  X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FillTheTank_crates",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X  X  X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "PortalEntrance_1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},

	{
		name = "PortalExit_1",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "Portal_topLeft",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "Portal_topRight",
		filledCells = {
			"     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "Portal_bottomLeft",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X",
		},
	},

	-- Over and Over

	{
		name = "OverAndOver_topLeft",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "OverAndOver_topRight",
		filledCells = {
			"      X",
			"      X",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "OverAndOver_bottomLeft",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
		},
	},

	{
		name = "OverAndOver_topMiddle",
		filledCells = {
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "OverAndOver_bottomMiddle",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"           ",
			"   X",
			"   X",
		},
	},

    -- OverAndOver_side

    {
		name = "OverAndOver_side_topLeft",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},

	{
		name = "OverAndOver_side_topRight",
		filledCells = {
			"      X",
			"      X",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "OverAndOver_side_bottomLeft",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
		},
	},

	{
		name = "OverAndOver_side_topMiddle",
		filledCells = {
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "OverAndOver_side_bottomMiddle",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
		},
	},
	
	-- TwoTowers
	{
		name = "TwoTowers_middle",
		filledCells = {
			"XXXX ",
			"   X ",
			"   X ",
			"   X ",
			"   X ",
			"   X ",
			"   X  ",
			"   XXXX ",
		},
	},

    {
		name = "TwoTowers_Reels",
		filledCells = {
			"   X   ",
		},
	},

	{
		name = "TwoTowers_pattern",
		filledCells = {
			"      X",
			"     XX",
			"    XXX",
			"    XXX",
			"XXX    ",
			"XXX    ",
			"XX     ",
			"X     ",
		},
	},

	{
		name = "TwoTowers_steel",
		filledCells = {
			"    XX ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			" XX    ",
		},
	},
	{
		name = "NarrowSpout_steel",
		filledCells = {
			"       ",
			"X     X", 
			" X   X ",
			"  X X  ",
			" X   X ",
			"X     X", 
			"       ",
			"       ",
		},
	},
	{
		name = "NarrowSpout_missing",
		filledCells = {
			"       ",
			"       ",
			"X     X", 
			"XX   XX",
			"X     X", 
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "NarrowSpout_pattern",
		filledCells = {
			"XXXXXXX",
			" XXXXX ",
			"  XXX  ",
			"   X   ",
			"  XXX  ",
			" XXXXX ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "NarrowSpout_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"  X X  ",
			" X X X ",
			"  X X  ",
		},
	},
	{
		name = "PitsOfDoom_eaters",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X X X ",
			"       ",
			"X X X",
			"       ",
		},
	},
    {
		name = "SplitLevel_side_pattern",
		filledCells = {
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",

		},
	},
	{
		name = "HalfReels_side_pattern",
		filledCells = {
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
		},
	},
	{
		name = "VineGrowerTest_pattern",
		filledCells = {
			"      ",
			"X    X",
			"XX  XX",
			" XXXX ",
			"XX  XX",
			"X    X",
		},
	},
	{
		name = "CoconutTest_side_pattern",
		filledCells = {
			"XXXXXX",
			"      ",
		},
	},

	{
		name = "AmberTest_side_pattern1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "AmberTest_side_pattern2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "AmberTest_side_pattern3",
		filledCells = {
			"      ",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "Checkers_side_amber",
		filledCells = {
			"       ",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			"       ",
		},
	},
	{
		name = "Checkers_side_crates",
		filledCells = {
			"       ",
			"X X X X",
			" X X X ",
			"X     X",
			" X   X ",
			"X X X X",
			" X X X ",
			"       ",
		},
	},
	{
		name = "AmberPool_side_amber",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"XX   XX",
			"XX   XX",
			"X     X",
			"       ",
			"       ",
		},
	},
	{
		name = "AmberPool_side_crates",
		filledCells = {
			"       ",
			"X     X",
			" X   X ",
			"       ",
			"       ",
			" X   X ",
			"X     X",
			"       ",
		},
	},
	{
		name = "AmberPool_side_stones",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerIntro_side_missing",
		filledCells = {
			"X X X X",
			"X X X X",
			"X X X X",
		},
	},
	{
		name = "MakerIntro_side_pattern1",
		filledCells = {
			" X   X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerIntro_side_pattern2",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LockTest_side_pattern1",
		filledCells = {
			"      ",
			" X X X",
			"X X X ",
			" X X X ",
			"X X X ",
			" X X X",
			"      ",
		},
	},
    {
		name = "ItTakesTwo_side_pattern1",
		filledCells = {
			"X    X",
			"XX  XX",
			"XXXXXX",
			"XX  XX",
			"X    X",
            "X    X",
		},
	},

{
		name = "Battlement1_side",
		filledCells = {
			" XXXXX",
			"  XXX",
			"  X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",

		},
	},
	{
		name = "Battlement1_side_walls",
		filledCells = {
			"X     X",
			"X     X",
			"       ",

		},
	},
	{
		name = "Battlement1_side_walls2_b",
		filledCells = {
			"       ",
			" X   X",
			"   X    ",
			"       ",

		},
	},
	{
		name = "Battlement1_side_walls2_a",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"X X X X",

		},
	},
	{
		name = "Battlement1_side_windows",
		filledCells = {
			"       ",
			"       ",
			" X   X  ",
			" X X X  ",
			"   X   ",
			"      ",
			"      ",
			"       ",
			"       ",
		},
	},
	{
		name = "Battlement1_side_roof2",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PatternEater_side_Pattern",
		filledCells = {
			" XXXX",
			" XXXX",
			" XXXX",
			" XXXX",
			" XXXX",
			" XXXX",
		},
	},
	{
		name = "PatternEater_side_GemEaters",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXX ",
		},
	},
    {
		name = "CenterStripe_Reels_side",
		filledCells = {
			"X    X",
		},
	},
	{
		name = "SideBarrels_side",
		filledCells = {
			"  X     ",
			"   X",
			"  X     ",
			"   X",
			"  X     ",
			"   X",
			"  X     ",
		},
	},
	{
		name = "CenterStripe_side",
		filledCells = {
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
		},
	},

	{
		name = "Portal_topLeft_side",
		filledCells = {
			"  X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "Portal_topRight_side",
		filledCells = {
			"   X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "Portal_bottomLeft_side",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X",
		},
	},

	{
		name = "YayPortal_side_missing",
		filledCells = {
			"XX  XX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X    X",
		},
	},
	{
		name = "CornerBlocks_vines",
		filledCells = {
			"X      ",
			"X      ",
			"X   XXX",
			"XXX    ",
			"    XXX",
			"XXX   X",
			"      X",
			"      X",
		},
	},
	
	--Land 25
	{
		name = "RightColumn2_Large",
		filledCells = {
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
		},
	},
	{
		name = "LeftColumn_Spot1_Large",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LeftColumn_Spot2_Large",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LeftColumn_Spot3_Large",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LeftColumn_Spot4_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LeftColumn_Spot5_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LeftColumn_Spot6_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
		},
	},
	{
		name = "LeftColumn_Spot7_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "LeftColumn_Spot8_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "LockTumblers_Missing",
		filledCells = {
			"       ",
			"      X",
			"      X",
			"     XX",
			"       ",
			"     XX",
			"      X",
			"      X",
		},
	},
	{
		name = "LockTumblers_Laser",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LockTumblers_Steel",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LockTumblers_Boulders",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LockTumblers_Pattern",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
		},
	},

    -- Begin: Zach Laser Patterns
    {
		name = "SeekAndDestroy_Reels",
		filledCells = {
			"X     X",
		},
	},
    {
		name = "SeekAndDestroy_Missing",
		filledCells = {

			"X     X",
			"X     X",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			" XX XX ",
		},
	},
    {
		name = "SeekAndDestroy_LasersH",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
    {
		name = "SeekAndDestroy_LasersV",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "SeekAndDestroy_Clouds",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
    {
		name = "SeekAndDestroy_Eaters",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},
    {
		name = "SeekAndDestroy_Steel",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
    {
		name = "LaserSusan_Reels",
		filledCells = {
			"X     X",
		},
	},
    {
		name = "LaserSusan_Missing",
		filledCells = {

			"XX   XX",
			"X  X  X",
			"X     X",
			"       ",
			" X   X ",
			"       ",
			"X  X  X",
			"XX   XX",
		},
	},
    {
		name = "LaserSusan_VineGenerators",
		filledCells = {

			"  X X  ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
			"  X X  ",
		},
	},
    {
		name = "LaserSusan_Steel",
		filledCells = {

			"  X X  ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
			"  X X  ",
		},
	},
    {
		name = "LaserSusan_Lasers",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserSusan_Clouds",
		filledCells = {

			"   X   ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"   X   ",
		},
	},
    {
		name = "MoltenCore_Lava",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
    {
		name = "MoltenCore_Reels",
		filledCells = {
			"X     X",
		},
	},
    {
		name = "MoltenCore_Lasers",
		filledCells = {

			"       ",
			"     X ",
			"       ",
			" X     ",
			"       ",
			"     X ",
			"       ",
			"       ",
		},
	},
    {
		name = "MoltenCore_Makers",
		filledCells = {

			"X      ",
			"       ",
			"      X",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "MoltenCore_Steel",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"  X X  ",
		},
	},
    {
		name = "LaseTheRainbow_Lasers",
		filledCells = {

			"      ",
			" X  X ",
			" X  X ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "LaseTheRainbow_Steel",
		filledCells = {

			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "LaseTheRainbow_Stones",
		filledCells = {

			"      ",
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "LaseTheRainbow_Boulders",
		filledCells = {

			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "LaseTheRainbow_Makers",
		filledCells = {

			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "LaseTheRainbow_Eaters",
		filledCells = {

			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
		},
	},
    {
		name = "LaserWall_Laser1",
		filledCells = {

			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserWall_Laser2",
		filledCells = {

			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserWall_Laser3",
		filledCells = {

			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserWall_Laser4",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserWall_Laser5",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserWall_Laser6",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserWall_Laser7",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
    {
		name = "LaserWall_Laser8",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	 {
		name = "LaserWall_Phe",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
    {
		name = "LaserWall_Reels",
		filledCells = {

			"     XX",
		},
	},
    {
		name = "ImpossibleBlast_Reels",
		filledCells = {

			"   X   ",
		},
	},
    {
		name = "ImpossibleBlast_Eaters",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
		},
	},
    {
		name = "ImpossibleBlast_Makers",
		filledCells = {

			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "ImpossibleBlast_Lasers",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"  X X  ",
		},
	},
    {
		name = "LockTumblers_Eaters",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LockTumblers_Makers",
		filledCells = {

			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "WildLasers_Fences",
		filledCells = {
			"    X  ",
			"   X X ",
			"   XX  ",
			"  X X  ",
			"  X X  ",
			"  XX   ",
			" X X   ",
			"  X    ",
		},
	},
    {
		name = "LaserDispenser_Reels",
		filledCells = {
			"X     X",
		},
	},

    -- End: Zach Laser Patterns


    {
		name = "WildLasers_Targets",
		filledCells = {
			"       ",
			"    X  ",
			"       ",
			"   X   ",
			"   X   ",
			"       ",
			"  X    ",
			"       ",
		},
	},
    {
		name = "WildLasers_HorizontalLasers",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
    {
		name = "WildLasers_HorizontalLasers_Colored",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "WildLasers_VerticalLasers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X      ",
			"      X",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LengthyLaser_Vertical_0",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LengthyLaser_Vertical_1",
		filledCells = {
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
    {
		name = "LengthyLaser_Vertical_2",
		filledCells = {
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
		},
	},
    {
		name = "LengthyLaser_Vertical_3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
    {
		name = "LengthyLaser_Horizontal_1",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
    {
		name = "LengthyLaser_Horizontal_2",
		filledCells = {
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
		},
	},
    {
		name = "LengthyLaser_Horizontal_3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    X  ",
			"   X   ",
			"  X    ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserDispenser_LeftMaker",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserDispenser_RightMaker",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserDispenser_Steel",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
		name = "LaserDispenser_HorizontalBursts",
		filledCells = {
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"   X   ",
		},
	},
    {
		name = "PewPew_HorizontalBursts",
		filledCells = {
			"X     ",
			"     X",
			"      ",
			"      ",
			"      ",
			"X     ",
			"     X",
		},
	},
    {
		name = "PewPew_VerticalBursts",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
		name = "RandomStones_Stones",
		filledCells = {
			"       ",
			" XX XX ",
			"       ",
			"   X   ",
			"       ",
			" XX XX ",
			"       ",
			"   X   ",
		},
	},

	-- Begin: Dave Laser Patterns

	{
		name = "LaserWelcome_pattern1",
		filledCells = {
			"  XX  ",
		},
	},

	{
		name = "LaserWelcome_pattern_steel",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" X  X ",
			" X  X ",
			" X  X ",
		},
	},

	{
		name = "LaserWelcome_pattern_stone",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
		},
	},

	{
		name = "LaserWelcome_pattern_chest",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	
	{
		name = "LaserWelcome_side_pattern1",
		filledCells = {
			"X  X  X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "LaserWelcome_side_pattern_steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XX XX ",
			" XX XX ",
			" XX XX ",
		},
	},

	{
		name = "LaserWelcome_side_pattern_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X  X  X",
			"X  X  X",
			"X  X  X",
		},
	},

	{
		name = "LaserWelcome_side_pattern_chest",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X  X  X",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "LaserLab_pattern1",
		filledCells = {
			"   X  ",
		},
	},

	{
		name = "LaserLab2_pattern2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
		},
	},

	{
		name = "LaserLab_pattern3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
		},
	},

	{
		name = "LaserLab_pattern_laser2",
		filledCells = {
			"      ",
			" X   X ",
		},
	},

	{
		name = "LaserLab_pattern2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
		},
	},

	{
		name = "LaserLab_pattern_laser3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
			"      ",
			"     X  ",
		},
	},

	{
		name = "LaserLab_pattern_steel",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
			"      ",
		},
	},

	{
		name = "LaserLab_pattern_steel2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXX XXX",
			"   X  ",
			"      ",
		},
	},

	{
		name = "LaserLab_pattern_steel3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXXX",
			"      ",
			"      ",
		},
	},

	{
		name = "LaserLab_pattern_stone",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXX XXX",
		},
	},

	{
		name = "LaserLab_pattern_stone3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X XXXXX",
			"      ",
			"XXXXX X",
		},
	},

	{
		name = "LaserLab_pattern_chest",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXX XXX",
			"      ",
		},
	},

	{
		name = "LaserLab_pattern_chest3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXXX",
			"      ",
		},
	},

	{
		name = "LaserLab_pattern_crates",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
			"      ",
			"      ",
		},
	},

	{
		name = "LaserLab_pattern_crates4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXXX",
			"XXX XXX",
			"XXXXXXX",
			"      ",
			"      ",
		},
	},

	{
		name = "LaserLab_pattern_crates2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXX XXX",
			"XXX XXX",
			"       ",
			"      ",
			"      ",
		},
	},

	{
		name = "LaserLab_pattern_crates3",
		filledCells = {
			"      ",
			"      ",
			"XXX XXX",
			"XXX XXX",
			"       ",
			"       ",
			"      ",
			"      ",
		},
	},

	-- End: Dave Laser Patterns

	-- Begin: Michael Land 25 Patterns

	{
		name = "OlympusMons_lava",
		filledCells = {
			"  X X  ",
			" XX XX ",
			"XX   XX",
			"XX   XX",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},

	{
		name = "OlympusMons_missing",
		filledCells = {
			"XX   XX",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "OlympusMons_core",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "OlympusMons_reels",
		filledCells = {
			"X     X",
		},
	},

	--End Michael Land 25 patterns

	{
		name = "SpaceInvaders_lasers",
		filledCells = {
            "       ",
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
		},
	},
	{
		name = "SpaceInvaders_boulders",
		filledCells = {
			"X X X X",
            "       ",
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SpaceInvaders_missing",
		filledCells = {
			" X X X ",
            "X X X X",
            "       ",
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LightReflect_fences",
		filledCells = {
			"       ",
            "X     X",
            "       ",
			"       ",
			"       ",
			"       ",
			"X XXX X",
			" X   X ",
		},
	},
	{
		name = "LightReflect_steel",
		filledCells = {
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},


    {
		name = "RockFall_side_Line4_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RockFall_side_Line5_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RockFall_side_Line6_large",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RockFall_side_Line7_large",
		filledCells = {
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "TowerToTheClouds_side_Makers",
		filledCells = {
			"   X   ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "TowerToTheClouds_side_Gifts",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "TowerToTheClouds_side_Reels",
		filledCells = {
			"   X   ",
		},
	},

    {
		name = "UpAndDownAgain_side_Gifts1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "UpAndDownAgain_side_Gifts2",
		filledCells = {
			"       ",
			"       ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "UpAndDownAgain_side_Gifts3",
		filledCells = {
			"       ",
			" XX XX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "OrangeEaters_side_missing",
		filledCells = {
			"XX   XX",
			" X   X ",
			"       ",
			" X   X ",
			"       ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "OrangeEaters_side_orange1",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OrangeEaters_side_orange2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OrangeEaters_side_orange3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
		},
	},
	{
		name = "OrangeEaters_side_stone",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
		},
	},

    {
		name = "OrangeEaters_side_eaters",
		filledCells = {
			"   X   ",
			" X X X ",
			" X   X ",
			"   X   ",
			"  X X  ",
			"   X   ",
			" X   X ",
			"X X X X",
		},
	},

    {
		name = "HalfAndHalf_side_Lava",
		filledCells = {
			"X     ",
			"X     ",
			"X     ",
			"      ",
			"     X",
			"     X",
			"     X",
		},
	},

	{
		name = "HalfAndHalf_side_Vines",
		filledCells = {
			"     X",
			"     X",
			"     X",
			"      ",
			"X     ",
			"X     ",
			"X     ",
		},
	},

    {
		name = "PictureFrame_side_pattern",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},

    {
        name = "PictureFrame_side_lava",
		filledCells = {
			"       ",
			"       ",
			" X   X ",
			" X   X ",
			"       ",
			"X     X",
			"       ",
			" X   X ",
		},
    },

    {
        name = "DoNotOpen2_side_Clouds",
		filledCells = {
			" X X   ",
			"  X    ",
			" X X   ",
			"   X   ",
			"  XXX  ",
			" XXXXX ",
			" XXXXX ",
			"  XXX  ",
		},
    },

    {
        name = "LockedGarden_side_LavaMakers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
    },
    {
        name = "LockedGarden_side_Stones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			" X   X ",
		},
    },
    {
        name = "LockedChests_side_Missing",
		filledCells = {
			"      ",
			"      ",
            "      ",
			" X X  ",
			"      ",
			"      ",
			"      ",
		},
    },
    {
        name = "LockedChests_side_Locks",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X X X ",
			" X X X",
			"      ",
			"      ",
		},
    },
    {
        name = "OrangeChute_side_LavaMakers",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
            "       ",
		},
    },
    {
        name = "OrangeChute_side_Missing",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X     ",
			" X     ",
			" X XXX ",
			" X     ",
			" X     ",
		},
    },
	{
		name = "HalfHalfHalf_eaters",
		filledCells = {
			" X  X ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
		},
	},

	{
        name = "BackAndForth_LaserV",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"X      ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
    },
	{
        name = "BackAndForth_LaserH",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"      X",
			"       ",
			"X      ",
			"       ",
			"X      ",
		},
    },
	{
        name = "BackAndForth_steel",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
		},
    },
	{
        name = "BackAndForth_fences",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"X      ",
			"     X ",
		},
    },
	{
		name = "CenterStripeOdds",
		filledCells = {
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "CenterStripeEvens",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "LittleX",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			"   X   ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ShootingGallery_missing",
		filledCells = {
			" XX    ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "ShootingGallery_laser6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
		},
	},
	{
		name = "ShootingGallery_laser7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "FirstFrost_missing",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "FirstFrost_ice",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X XX X",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "Cooler_chests",
		filledCells = {
			"      ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "TripleSpreader_vines",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
		},
	},
	{
		name = "TripleSpreader_lava",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXX ",
			" X  X ",
			" X  X ",
		},
	},
	{
		name = "TripleSpreader_ice",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"X    X",
			"X    X",
			"X    X",
		},
	},

	--LAND 26 MICHAEL PATTERNS

	{
		name = "StainedGlass_ice",
		filledCells = {
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
			"  X X  ",
			"  X X  ",
		},
	},

	{
		name = "Snowflake_ice",
		filledCells = {
			" X   X ",
            "  X X  ",
            "X XXX X",
            " XX XX ",
            "X XXX X",
            "  X X  ",
			" X   X ",
			"       ",
		},
	},

	{
		name = "GlacialPace_ice",
		filledCells = {
			"       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "Icebox_ice",
		filledCells = {
			"       ",
			"     X ",
			"     XX",
			"     XX",
			"     XX",
			"     XX",
			"     XX",
			"     XX",
		},
	},
	{
		name = "Icebox_steel",
		filledCells = {
			"    XXX",
			"      X",
			"       ",
			"       ",
			"    X  ",
			"    X  ",
			"    X  ",
			"    X  ",
		},
	},
	{
		name = "Icebox_vines",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     XX",
			"     XX",
			"     XX",
		},
	},
	{
		name = "Icebox_lock",
			filledCells = {
			"       ",
			"    X  ",
			"    X  ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TropicalIce_pattern",
			filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "IceCap_ice",
			filledCells = {
			"       ",
			" XX XX ",
			"X     X",
			"       ",
			"       ",
			"X     X",
			" XX XX ",
			"       ",
		},
	},
	{
		name = "Cryolock_clear",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"XX   XX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "Cryolock_lock",
			filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Cryolock_steel",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Cryolock_missing",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Cryolock_makers",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Cryolock_reels",
			filledCells = {
			"X     X",
		},
	},

	--END LAND 26 MICHAEL PATTERNS

    --land 26 zach patterns

    {
		name = "FreezerBurn_MakersLava",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
		},
	},

    {
		name = "FreezerBurn_MakersIce",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
		},
	},

    {
		name = "FreezerBurn_Missing",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
			" X   X ",
			"   XX  ",
			"       ",
		},
	},

    {
		name = "FreezerBurn_Lava",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"XXXXX X",
		},
	},

    {
		name = "FreezerBurn_Ice",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
		},
	},

    {
		name = "FreezerBurn_Reels",
			filledCells = {
			"X     X",
		},
	},

    {
		name = "LetItGrow_Missing",
			filledCells = {
			"  X X  ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
		},
	},

    {
		name = "LetItGrow_Steel",
			filledCells = {
			"       ",
            "       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "LetItGrow_Reels",
			filledCells = {
			"X     X",
		},
	},

    {
		name = "LetItGrow_Ice",
			filledCells = {
			"       ",
			"XX   XX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "LetItGrow_MakersCoconuts",
			filledCells = {
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "LetItGrow_MakersIce",
			filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "LetItGrow_Coconuts",
			filledCells = {
			"       ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

    {
		name = "AnInconvenientTrough_Ice",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},

    {
		name = "AnInconvenientTrough_Eaters",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			"  X X  ",
			"       ",
		},
	},

    {
		name = "AnInconvenientTrough_Missing",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			"X X X X",
			"       ",
			"       ",
		},
	},

    {
		name = "AnInconvenientTrough_MakersIce",
			filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},

    {
		name = "IceChest_Ice",
			filledCells = {
			"      ",
			"      ",
			"      ",
			" X  X ",
			" X  X ",
			"      ",
			"      ",
		},
	},

    {
		name = "IceChest_Steel",
			filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"X    X",
			"      ",
			"      ",
		},
	},

    --end land 26 zach patterns
	{
		name = "FloatOn_stone",
		filledCells = {
			"X      ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FloatOn_missing",
		filledCells = {
			"       ",
			"       ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "FloatOn_clear",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},

	{
		name = "CoconutForever_coconuts",
		filledCells = {
			"       ",
			"X      ",
			"   X   ",
			" X     ",
			"    X  ",
			"  X    ",
			"     X ",
			"       ",
		},
	},
	{
		name = "Column3_large",
		filledCells = {
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
		},
	},
	{
		name = "BalloonBelt_Missing",
		filledCells = {
			"       ",
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
			"  X    ",
		},
	},
	{
		name = "BalloonBelt_FlippedMaker",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BalloonBelt_eaters",
		filledCells = {
			"      ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
		},
	},
	{
		name = "BalloonBelt_Balloons",
		filledCells = {
			"      ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
		},
	},
	{
		name = "BalloonBelt_Steel",
		filledCells = {
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BalloonBelt_boulders",
		filledCells = {
			"       ",
			" X     ",
			" X     ",
			"       ",
			" X     ",
			" X     ",
			"       ",
			" X     ",
		},
	},
	{
		name = "BalloonBelt_horiz",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			" X     ",
			"       ",
		},
	},
	{
		name = "Meltdown_ice",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X     ",
			"     X ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Meltdown_missing",
		filledCells = {
			"       ",
			" X   X ",
			" X   X ",
			"  X  X ",
			" X  X  ",
			" X   X ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "RowSides3_large",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RowSides5_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RowSides7_large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},
	{
		name = "Fountain_fences",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "ClearTheAir_orange",
		filledCells = {
			"       ",
			"       ",
			"   X X ",
			"  X X  ",
			"   X X ",
			"  X X  ",
			"   X X ",
			"  X X  ",
		},
	},
	{
		name = "ClearTheAir_missing",
		filledCells = {
			"X      ",
			"X      ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			"X      ",
			"X      ",
		},
	},
	{
		name = "ClearTheAir_eaters",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"       ",
			"       ",
		},
	},
	{
		name = "DuelingMakers_missing",
		filledCells = {
			"XX     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			"XX     ",
		},
	},
	{
		name = "DuelingMakers_stone",
		filledCells = {
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"       ",
		},
	},
	{
		name = "BombChest2_Chest1",
		filledCells = {
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombChest2_Chest2",
		filledCells = {
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombChest2_Chest3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombChest2_Chest4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombChest2_Chest5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "BombChest2_Chest6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "BombChest2_Chest7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BombChest2_Laser",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BalloonWall_Makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "BalloonWall_Pattern",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "BalloonWall_Balloons",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	--begin land 27 michael patterns
	{
		name = "ParadiseRises_house",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			" XXXXX ",
			" XX XX ",
			"       ",
		},
	},
	{
		name = "ParadiseRises_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
		},
	},
	{
		name = "HeliumTank_steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
		},
	},
	{
		name = "HeliumTank_balloons",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
		},
	},
	{
		name = "HeliumTank_lock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HeliumTank_chests",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "LaserDarts_missing",
		filledCells = {
			"    X X",
			"    XX ",
			"    X X",
			"    XX ",
			"    X X",
			"    XX ",
			"    X X",
			"    XX ",
		},
	},
	{
		name = "LaserDarts_balloons",
		filledCells = {
			"     X ",
			"      X",
			"     X ",
			"      X",
			"     X ",
			"      X",
			"     X ",
			"      X",
		},
	},
	{
		name = "LaserDarts_lasers",
		filledCells = {
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},
	{
		name = "LaserDarts_lasers1",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LaserDarts_lasers2",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "LaserDarts_lasers3",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "LaserDarts_lasers4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "LaserDarts_reels",
		filledCells = {
			"   XXXX",
		},
	},
	{
		name = "Amulet_lasers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "Amulet_stones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "Amulet_fences",
		filledCells = {
			"X     X",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"   X   ",
			"X  X  X",
			"XX   XX",
			" X   X ",
		},
	},
	--end land 27 michael patterns
	{
		name = "MakerPortalTest1_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"X X X X",
			"X X X X",
			"X X X X",
		},
	},
	{
		name = "MakerPortalTest1_Makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "MakerPortalTest1_Clear",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "MakerPortalTest2_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XX X XX",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
		},
	},
	{
		name = "MakerPortalTest2_Makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest2_Clear",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
		},
	},
	{
		name = "MakerPortalTest3_Steel",
		filledCells = {
			" XXXXX ",
			" X X X ",
			" X X X ",
			" X X X ",
			"XX X XX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest3_Makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest3_Clear",
		filledCells = {
			"X     X",
			"X X X X",
			"X X X X",
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest4_Steel",
		filledCells = {
			" XXXXX ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			"XX X XX",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest4_Makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest4_Clear",
		filledCells = {
			"X     X",
			"X X X X",
			"X X X X",
			"X X X X",
			"X X X X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest5_Steel",
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest5_Makers",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerPortalTest5_Clear",
		filledCells = {
			"       ",
			"XXXXXXX",
			"XXX XXX",
			"XXX XXX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SteelGlassTest_Treasure",
		filledCells = {
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SteelGlassTest_SteelGlass",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},

	--Mission levels begin

	{
		name = "PompeiiOne_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X   ",
			"XXXXX  ",
			"XXXXXXX",
		},
	},

	{
		name = "PompeiiFive_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X   ",
			"XXXXX  ",
			"XXXXXX ",
		},
	},
	{
		name = "PompeiiFive_lava",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XX     ",
			"XXXX   ",
			"X X X  ",
			"     X ",
			"      X",
		},
	},


	--Mission levels end

	--Begin Michael Lin land 28 levels

	{
		name = "Cornerstone_glass",
		filledCells = {
			" X  X ",
			"XX  XX",
			"      ",
			"      ",
			"      ",
			"XX  XX",
			" X  X ",
		},
	},
	{
		name = "Cornerstone_stone",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
		},
	},
	{
		name = "BalloonTube_glass",
		filledCells = {
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "BalloonTube_balloon",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"      ",
		},

	},
	{
		name = "BalloonTube_stone",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "BalloonTube_steel",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
		},
	},
	{
		name = "BalloonTube_reels",
		filledCells = {
			"  XX  ",
		},
	},
	{
		name = "BalloonStand_makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "BalloonStand_glass",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "BalloonStand_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
		},
	},
	{
		name = "BalloonStand_fences",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
	name = "StuckBalloons_glass",
		filledCells = {
			"XXX XXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StuckBalloons_laserH",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StuckBalloons_laserV",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      ",
			"   X   ",
		},
	},
	{
		name = "StuckBalloons_makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX XXX",
		},
	},
	{
		name = "Oven_lava",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "Oven_glass",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "Oven_fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Oven_reels",
		filledCells = {
			"  XXX  ",
		},
	},
	{
		name = "Passersby_glass",
		filledCells = {
			"      ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "Passersby_makers",
		filledCells = {
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Passersby_eaters",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "Passersby_reels",
		filledCells = {
			"  XX  ",
		},
	},
	{
		name = "PictureFrame2_pattern",
		filledCells = {
			"       ",
			" XXXXX ",
			" XXXXX ",
			" XXXXX ",
			" XXXXX ",
			" XXXXX ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "RoomForRed_glass",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "Conservatory_glass",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			"XXXXXX",
			" XXXX ",
			"      ",
			"      ",
		},
	},
	{
		name = "Conservatory_vines",
		filledCells = {
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "DelayedGratification2_glass",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"       ",
		},
	},
	{
		name = "DelayedGratification2_missing",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			" X   X ",
		},
	},
	{
		name = "DelayedGratification2_makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	--End Michael Lin land 28 levels

	{
		name = "PermanentSwitchTest_Stones",
		filledCells = {
			"      ",
			"      ",
			" XXX  ",
			" X X  ",
			" XXX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "PermanentSwitchTest_Switch",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "PermanentSwitchTest_Maker",
		filledCells = {
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MultiSwitchTest_Maker1",
		filledCells = {
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MultiSwitchTest_Maker2",
		filledCells = {
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MultiSwitchTest_Stones",
		filledCells = {
			"      ",
			"      ",
			" XXX  ",
			" X X  ",
			" X X  ",
			" XXX  ",
			"      ",
		},
	},
	{
		name = "MultiSwitchTest_Switch1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MultiSwitchTest_Switch2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
		},
	},
	{
		name = "WindowRows_Glass",
		filledCells = {
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "HiddenCloud_Glass",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Windowbox_Glass",
		filledCells = {
			"        ",
			"        ",
			"  XXXX  ",
			"  XXXX  ",
			"  XXXX  ",
			"  XXXX  ",
			"        ",
			"        ",
		},
	},
	{
		name = "NoTouchTreasure_Glass",
		filledCells = {
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "NoTouchTreasure_Treasure",
		filledCells = {
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "UnstableBalloons_UpwardMakers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "UnstableBalloons_Makers",
		filledCells = {
			"X  X  X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "UnstableBalloons_Balloons",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			" X X X ",
			"       ",
		},
	},
	{
		name = "UnstableBalloons_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"X X X X",
		},
	},
	{
		name = "BlockedBounce_Lasers",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BlockedBounce_CoconutBalloons",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "BlockedBounce_Glass",
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "GlassHalfEmpty_Steel",
		filledCells = {
			"       ",
			"       ",
			" XXXXX ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GlassHalfEmpty_Glass",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GlassHalfEmpty_NormalGems",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"X     X",
			"X     X",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "InCaseOfEmergency_Glass",
		filledCells = {
			"      ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "InCaseOfEmergency_Gifts",
		filledCells = {
			"      ",
			"  XX  ",
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TopCenterBlock",
		filledCells = {
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GlassHouse",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			" XXXXX ",
			" XX XX ",
			" XX XX ",
		},
	},
	{
		name = "DelayedGratification_makers",
		filledCells = {
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "DelayedGratification_glass",
		filledCells = {
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "DelayedGratification_missing",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LockedCabinet_Locks",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	{
		name = "UpArrowNegativeSpace",
		filledCells = {
			"XXX XXX",
			"XX   XX",
			"X     X",
			"       ",
			"XX   XX",
			"XX   XX",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "Antigrav_makers",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},
    {
        name = "Letter_R",
        filledCells = {
            "XXXXXXX",
            "X    XX",
            "X  X  X",
            "X     X",
            "X    XX",
            "X  X  X",
            "X  X  X",
            "X  X  X",
        },
    },
    {
        name = "Trench01",
        filledCells = {
            "XX   XX",
            "XX   XX",
            "XX   XX",
            "XX   XX",
            "XX   XX",
            "XX   XX",
            "XXX XXX",
            "       ",
        },
    },
    {
        name = "Trench02",
        filledCells = {
            "X     X",
            "X     X",
            "X     X",
            "X     X",
            "XX   XX",
            " X   X ",
            " X   X ",
            " XX XX ",
        },
    },
    {
        name = "Trench02-2",
        filledCells = {
            "X     X",
            "X     X",
            "X     X",
            "XX   XX",
            "XX   XX",
            " X   X ",
            " X   X ",
            " X   X ",
        },
    },
    {
        name = "Columns_LargeMiddle2",
        filledCells = {
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
        },
    },
    {
        name = "SmallColumns_Edges",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X     X",
            "X     X",
            "X     X",
        },
    },
    {
        name = "Column_LargeMiddle",
        filledCells = {
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
        },
    },

	{
		name = "WindowLab1_Glass",
		filledCells = {
			"XX    XX",
			"XX    XX",
			"        ",
		},
	},

	{
		name = "WindowLab1_Glass1",
		filledCells = {
			"        ",
			"        ",
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"        ",
		},
	},

	{
		name = "WindowLab1_Glass2",
		filledCells = {
            "       ",
            "       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
			"       ",
            "       ",
		},
	},

	{
		name = "WindowLab1_Glass3",
		filledCells = {
			"       ",
            "       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
            "       ",
            "       ",
		},
	},

	{
		name = "WindowLab1_Treasure1",
		filledCells = {
			"XX  XX",
			"XX  XX",
			"        ",
		},
	},

	{
		name = "WindowLab1_Treasure2",
		filledCells = {
			"       ",
            "XX   XX",
		},
	},

	{
		name = "WindowLab1_Treasure3",
		filledCells = {
			"       ",
            "XX   XX",
		},
	},

	{
		name = "WindowLab1_Stones1",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"XX  XX",
			"        ",
		},
	},

	{
		name = "WindowLab1_Stones2",
		filledCells = {
			"       ",
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
		},
	},

	{
		name = "WindowLab1_Stones3",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"XX  XX",
			"        ",
		},
	},

	{
		name = "WindowLab1_Jailed1",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"  XX    ",
			"        ",
		},
	},

	{
		name = "WindowLab1_Jailed3",
		filledCells = {
			"       ",
            "       ",
			"XX   XX",
			"XX   XX",
			"       ",
            "       ",
            "       ",
            "       ",
		},
	},

	{
		name = "WindowLab1_Crates1",
		filledCells = {
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"        ",
			"XXXXXX",
		},
	},

	{
		name = "WindowLab1_Crates2",
		filledCells = {
			"       ",
            "       ",
			"XX   XX",
			"XX   XX",
			"       ",
            "       ",
            "       ",
            "       ",
		},
	},
	
	{
		name = "WindowLab1_Crates3",
		filledCells = {
			"       ",
            "       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
		},
	},	

    {
        name = "Scatter_RockGarden1",
        filledCells = {
            "   X   ",
            " X     ",
            "     X ",
            "  X    ",
            "X      ",
            "      X",
            "       ",
            "    X  ",
        },
    },
    {
        name = "Scatter_RockGarden2",
        filledCells = {
            "X      ",
            "      X",
            "       ",
            "    X  ",
            "  X    ",
            "     X ",
            "   X   ",
            " X     ",
        },
    },
    {
        name = "Scatter_RockGarden3",
        filledCells = {
            "X  X   ",
            " X    X",
            "     X ",
            "  X X  ",
            "X X    ",
            "     X ",
            "   X  X",
            " X  X  ",
        },
    },

    {
        name = "Single_8-4",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "Single_4-4",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BottomSpikes",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "   X   ",
            "   X   ",
            "XXX XXX",
        },
    },
    {
        name = "InvertedTetris_Bottom1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X X  ",
            " XX XX ",
            "       ",
        },
    },

    {
        name = "EmptyFlowers",
        filledCells = {
            " XXX   ",
            " X X   ",
            " XXX   ",
            "       ",
            "    XXX",
            "XXX X X",
            "X X XXX",
            "XXX    ",
        },
    },
    {
        name = "FlowerBuds",
        filledCells = {
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "     X ",
            " X     ",
            "       ",
        },
    },
    {
        name = "FlowerPetals",
        filledCells = {
            " X X   ",
            "       ",
            " X X   ",
            "    X X",
            "       ",
            "X X X X",
            "       ",
            "X X    ",
        },
    },
    {
        name = "LinkTest_Link1",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "X    X",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "LinkTest_Link2",
        filledCells = {
            "  X   ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "   X  ",
        },
    },
    {
        name = "LinkTest_Link3",
        filledCells = {
            "      ",
            "      ",
            " X  X ",
            "      ",
            "      ",
            "  X   ",
            "      ",
        },
    },
	--Michael land 29 levels
	{
		name = "DunkTank_gemisteel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "DunkTank_chest",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "DunkTank_steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X X    ",
			"X X    ",
			"X X    ",
			"X X    ",
		},
	},
	{
		name = "DunkTank_void",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "DunkTank_keygem",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
		},
	},
	{
		name = "DunkTank_missing",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    XXX",
			"    X X",
			"    X X",
		},
	},
	{
		name = "DunkTank_fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
		},
	},
	{
		name = "DunkTank_fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
		},
	},
	{
		name = "Parfait_greenGemisteel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Parfait_blueGemisteel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Parfait_redGemisteel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "Parfait_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
		},
	},
	{
		name = "Parfait_glass",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "Parfait_greenKey",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Parfait_blueKey",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "Parfait_redKey",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "ImpactTremors_leftKey",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
		},
	},
	{
		name = "ImpactTremors_rightKey",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
		},
	},
	{
		name = "ImpactTremors_leftMaker",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
			"      ",
		},
	},
	{
		name = "ImpactTremors_rightMaker",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
			"      ",
		},
	},
	{
		name = "ImpactTremors_leftStomp",
		filledCells = {
			" XX   ",
			" X XX ",
			"X XX  ",
			" XX   ",
			" X    ",
			"      ",
			"      ",
		},
	},
	{
		name = "ImpactTremors_rightStomp",
		filledCells = {
			"   XX ",
			" XX X ",
			"  XX X",
			"   XX ",
			"    X ",
			"      ",
			"      ",
		},
	},
	{
		name = "ImpactTremors_void",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X  X ",
		},
	},
	{
		name = "TwoWorlds_switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TwoWorlds_easySteel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "TwoWorlds_hardSteel",
		filledCells = {
			"       ",
			"       ",
			" X   X ",
			" X   X ",
			" XX XX ",
			" XX XX ",
			" XX XX ",
			"       ",
		},
	},
	
	{
		name = "DugTooDeep_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
		},
	},
	{
		name = "DugTooDeep_lava",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X  ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "DugTooDeep_amber",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
			"XX   XX",
		},
	},
	{
		name = "DugTooDeep_fences",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "CoalVein_crates",
		filledCells = {
			"      ",
			"      ",
			"XXXXXX",
			" X  X ",
			"X    X",
			"X    X",
			"X    X",
		},
	},
	{
		name = "CoalVein_stone",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			" X X  ",
			"  X X ",
			" X  X ",
		},
	},
	{
		name = "CoalVein_boulders",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   X  ",
			"  X   ",
			"   X  ",
			"  XX  ",
		},
	},
	{
		name = "PickYourNose_steel",
		filledCells = {
			" X     ",
			" X     ",
			"  X    ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PickYourNose_lowerGemisteel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XX     ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PickYourNose_upperGemisteel",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PickYourNose_keygem",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "PickYourNose_fences",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     XX",
			"     X ",
		},
	},
	{
		name = "PickYourNose_coconut",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PickYourNose_chest",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Hypobaric_steel",
		filledCells = {
			"  XXX  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Tripmining_steel",
		filledCells = {
			"  XXX  ",
			"  X X  ",
			"  X X  ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Hypobaric_bluePick",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
		},
	},
	{
		name = "Hypobaric_blueRock",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Tripmining_blueRock",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"   X   ",
		},
	},
	{
		name = "Hypobaric_greenPick",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "Hypobaric_greenRock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Tripmining_greenRock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"  X    ",
			" X     ",
		},
	},
	{
		name = "Hypobaric_redPick",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "Hypobaric_redRock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Hypobaric_orangePick",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Hypobaric_orangeRock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"     X ",
		},
	},
	{
		name = "Hypobaric_giftBox",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "TimeToBlast_bombs1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXX   ",
			"  X   ",
			"  X   ",
		},
	},
	{
		name = "TimeToBlast_bombs2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX    ",
			" X    ",
		},
	},
	{
		name = "TimeToBlast_bombs3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
		},
	},
	{
		name = "TimeToBlast_blueRock",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X     ",
			"   X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "TimeToBlast_redRock",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X    ",
			"      ",
			"   X  ",
			"      ",
		},
	},
	{
		name = "TimeToBlast_purpleRock",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
			"   X  ",
		},
	},
	{
		name = "TimeToBlast_greenRock",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   X  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TimeToBlast_bluePick",
		filledCells = {
			"    X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TimeToBlast_redPick",
		filledCells = {
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TimeToBlast_greenPick",
		filledCells = {
			"      ",
			"      ",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TimeToBlast_purplePick",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"      ",
		},
	},
	{
		name = "PayDirt_crates",
		filledCells = {
			"      ",
			"      ",
			"XXXXXX",
			" X  X ",
			"X    X",
			"X    X",
			"X    X",
		},
	},
	{
		name = "PayDirt_chests",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "PayDirt_gold",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			" X X  ",
			"  X X ",
			" X  X ",
		},
	},
	{
		name = "PayDirt_boulders",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"   X  ",
			"  X X ",
			" X X  ",
			"  XX  ",
		},
	},
	{
		name = "FillTheVoid_maker1",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FillTheVoid_maker2",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FillTheVoid_maker3",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FillTheVoid_pattern",
		filledCells = {
			"       ",
			" XXXXX ",
			"  XXX  ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FillTheVoid_switch1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "FillTheVoid_switch2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "FillTheVoid_switch3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "FillTheVoid_steel",
		filledCells = {
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "TargetLocked_steel",
		filledCells = {
			"     XX",
			"     X ",
			"       ",
			"       ",
			" XX XX ",
			"       ",
			"       ",
			"     XX",
		},
	},
	{
		name = "TargetLocked_fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"      X",
			"     X ",
			"       ",
		},
	},
	{
		name = "TargetLocked_clear",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXX ",
			" XX X  ",
			"XXX X  ",
		},
	},
	{
		name = "TargetLocked_lockMaker",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TargetLocked_switch1",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TargetLocked_switch2",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TargetLocked_laserMaker",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TargetLocked_lock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "TargetLocked_laserH",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "TargetLocked_laserV",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "TargetLocked_pattern",
		filledCells = {
			"       ",
			"      X",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TargetLocked_reels",
		filledCells = {
			"     XX",
		},
	},
	{
		name = "TwoDays_ice",
		filledCells = {
			--"       ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" XXXXX",
			" XXXXX",
		},
	},
	{
		name = "TwoDays_maker",
		filledCells = {
			--"       ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX    ",
			"      ",
			"      ",
		},
	},
	{
		name = "TwoDays_switch",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
		},
	},
	{
		name = "TwoDays_pattern",
		filledCells = {
			--"       ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			" XXXXX",
		},
	},

	{
		name = "OffRamp_steel",
		filledCells = {
			"     X ",
			"     X ",
			"    XX ",
			"       ",
			"    X  ",
			"   XX  ",
			"   X X ",
			"   XXX ",
		},
	},
	{
		name = "OffRamp_eater",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
		},
	},
	{
		name = "OffRamp_fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OffRamp_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OffRamp_maker",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OffRamp_switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OffRamp_void",
		filledCells = {
			"       ",
			"      X",
			"      X",
			"     X ",
			"     XX",
			"     XX",
			"    X X",
			"      X",
		},
	},
	{
		name = "OffRamp_reels",
		filledCells = {
			"    XXX",
		},
	},
	{
		name = "WabbitSeason_duckMaker",
		filledCells = {
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "WabbitSeason_eaters",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"     X ",
			"       ",
		},
	},
	{
		name = "WabbitSeason_wabbitMaker",
		filledCells = {
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "WabbitSeason_elmerSwitch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "WabbitSeason_squares",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "WabbitSeason_reels",
		filledCells = {
			"X     X",
		},
	},
	{
		name = "ReverseReverse_topMakers",
		filledCells = {
			"XXXXX ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "ReverseReverse_bottomMakers",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "ReverseReverse_switch",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"     X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "TheCreature_maker1",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TheCreature_maker2",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TheCreature_maker3",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TheCreature_steel",
		filledCells = {
			" X   X ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TheCreature_stone",
		filledCells = {
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TheCreature_leftLaser",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TheCreature_lasers",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TheCreature_switch1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "TheCreature_switch2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "TheCreature_switch3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	--end Michael land 32 levels
    {
        name = "PatternGemTest_Stones",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "  XX  ",
            "      ",
            "      ",
        },
    },
    {
        name = "PatternGemTest_Chests",
        filledCells = {
            "      ",
            " X  X ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "PatternGemTest_Makers",
        filledCells = {
            "      ",
            "      ",
            "  XX  ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "PatternGemTest_Patterned",
        filledCells = {
            "      ",
            "      ",
            "XX  XX",
            " XXXX ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "KeyGemTest_RedWall",
        filledCells = {
            "    X  ", 
            "    X  ",
            "    X  ", 
            "     XX",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "KeyGemTest_BlueWall",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "XX     ",
            "XXX    ",
            "X X    ",
            "XXX    ",
        },
    },
    {
        name = "KeyGemTest_RedKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
        },
    },
    {
        name = "KeyGemTest_BlueKey",
        filledCells = {
            "       ",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "KeyGemTest_Stone",
        filledCells = {
            "     XX",
            "     X ",
            "     XX",
            "       ",
            "       ",
            "       ",
            "     X ",
            "    X X",
        },
    },
    {
        name = "GoldBarTest_Gold1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "GoldBarTest_Gold2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "       ",
            "       ",
        },
    },
    {
        name = "GoldBarTest_Gold3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
        },
    },
    {
        name = "TreasureDispenser_Maker1",
        filledCells = {
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureDispenser_Maker2",
        filledCells = {
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureDispenser_Switch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureDispenser_Switch2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "CurtainCutter_Boulders",
        filledCells = {
            "       ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
        },
    },
    {
        name = "CurtainCutter_Maker",
        filledCells = {
            "     X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "CurtainCutter_MissingReels",
        filledCells = {
            "     XX",
        },
    },
    {
        name = "CurtainCutter_Pattern",
        filledCells = {
            "       ",
            "      X",
            "      X",
            "      X",
            "      X",
            "      X",
            "      X",
            "      X",
        },
    },
    {
        name = "CurtainCutter_Switch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "LongRise_Missing",
        filledCells = {
            "       ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
        },
    },
    {
        name = "LongRise_Laser",
        filledCells = {
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "LongRise_Treasure",
        filledCells = {
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "LongRise_TreasureBalloons",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "    XX ",
        },
    },
    {
        name = "LongRise_Steel",
        filledCells = {
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
	{
		name = "BadSwitches_pattern",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XX  XX",
			" XXXX ",
			"XX  XX",
			"      ",
		},
	},
	{
		name = "SwitchSequence_on",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X   X",
			"       ",
			"       ",
			"       ",
			"X   X  ",
		},
	},
	{
		name = "SwitchSequence_off",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X   X  ",
			"       ",
			"       ",
			"       ",
			"  X   X",
		},
	},


    {
        name = "PrisonBreak_RedWall",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
            " X     ",
        },
    },
    {
        name = "PrisonBreak_BlueWall",
        filledCells = {
            "       ",
            "  X    ",
            " X X   ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "PrisonBreak_GreenWall",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
            "     X ",
            "      X",
        },
    },
    {
        name = "PrisonBreak_YellowWall",
        filledCells = {
            "     X ",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },

    {
        name = "PrisonBreak_RedKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            
        },
    },
    {
        name = "PrisonBreak_BlueKey",
        filledCells = {
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "PrisonBreak_GreenKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
    {
        name = "PrisonBreak_YellowKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
            "       ",
        },
    },
    {
        name = "PrisonBreak_Jails",
        filledCells = {
            "       ",
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
	{
        name = "PrisonBreak_KeyJails",
        filledCells = {
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
            "X      ",
        },
    },
    {
        name = "SteelDig_Makers",
        filledCells = {
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "SteelDig_Squares",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
        },
    },
    {
        name = "SteelDig_Stones",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            " X  X  ",
            "  X X  ",
            "   X  X",
            "X     X",
        },
    },
    {
        name = "SteelDig_BlueSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X     X",
            "    X  ",
            " X     ",
        },
    },
    {
        name = "SteelDig_GreenSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "  X  X ",
            " X     ",
            "  X    ",
            "       ",
        },
    },
    {
        name = "SteelDig_PurpleSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "X     X",
            "   X   ",
            "       ",
            "     X ",
        },
    },
    {
        name = "SteelDig_RedSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
            " X     ",
            "  X X  ",
        },
    },
    {
        name = "SteelDig_YellowSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "X    X ",
            "   X   ",
        },
    },
    {
        name = "SwitchClicker_Switches",
        filledCells = {
            "   X   ",
            "X      ",
            "       ",
            " X     ",
            "     X ",
            "       ",
            "      X",
            "   X   ",
        },
    },
    {
        name = "SwitchClicker_Missing",
        filledCells = {
            "  X    ",
            "       ",
            "       ",
            "  X  X ",
            " X  X  ",
            "       ",
            "       ",
            "    X  ",
        },
    },
    {
        name = "MoveTheBlocker_Steel1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "XXX    ",
            "XXX    ",
            "XXX    ",
            "       ",
            "       ",
        },
    },
    {
        name = "MoveTheBlocker_Steel2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "    XXX",
            "    XXX",
            "    XXX",
            "       ",
            "       ",
        },
    },
    {
        name = "MoveTheBlocker_Pattern",
        filledCells = {
            "       ",
            "       ",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "       ",
        },
    },
    {
        name = "MoveTheBlocker_Switch",
        filledCells = {
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RotatingLasers_Lasers",
        filledCells = {
            "X  X  ",
            "     X",
            " X    ",
            "    X ",
            "  X    ",
            "X    X",
            "  X   ",
        },
    },
    {
        name = "ControlRoom_BoulderSwitch",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
        },
    },
    {
        name = "ControlRoom_StoneSwitch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ControlRoom_StoneSwitch2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ControlRoom_GoodSwitch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ControlRoom_GoodSwitch2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "    X  ",
            "       ",
            "       ",
            "       ",
        },
    },


    {
        name = "ControlRoom_ChestSpawn1",
        filledCells = {
            "     X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ControlRoom_ChestSpawn2",
        filledCells = {
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ControlRoom_BoulderSpawn",
        filledCells = {
            "X     X",
            "  X X  ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ControlRoom_StoneSpawn1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     XX",
            "     XX",
        },
    },
    {
        name = "ControlRoom_StoneSpawn2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XX     ",
            "XX     ",
        },
    },
    {
        name = "Clearance_Maker",
        filledCells = {
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "Clearance_Switch1",
        filledCells = {
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "Clearance_Switch2",
        filledCells = {
            "       ",
            "       ",
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "Clearance_Switch3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "LaserJail_Jails",
        filledCells = {
            "       ",
            "       ",
            "X     X",
            " X XXX ",
            "XXX  XX",
            "X XXXX ",
            " X X XX",
            "X X X  ",
        },
    },
    {
        name = "LaserJail_HorizontalLasers",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "X      ",
            "   X   ", 
            "      X",
            "    X  ",
            " X     ",
        },
    },
    {
        name = "LaserJail_VerticalLasers",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "      X",
            "    X  ",
            " X     ",
            "X      ",
            "   X   ",
        },
    },
    {
        name = "LaserJail_Blue",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "      X",
            "       ",
            "       ",
            "    X  ",
            "       ",
        },
    },
    {
        name = "LaserJail_Green",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
            "      X",
            "       ",
            "       ",
        },
    },
    {
        name = "LaserJail_Purple",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "    X  ",
            "       ",
            "       ",
            " X     ",
        },
    },
    {
        name = "LaserJail_Red",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "LaserJail_Yellow",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
            "       ",
            "       ",
        },
    },
    {
        name = "LaserJail_Orange",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
        },
    },
    {
        name = "DefusingSwitch_Switches",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "X    X",
        },
    },
    {
        name = "Contingency_Switch",
        filledCells = {
            "X     X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TasteTheRainbow_Reels",
        filledCells = {
            "X    X",
        },
    },
    {
        name = "TasteTheRainbow_Missing",
        filledCells = {
            "  X   ",
            "      ",
            "      ",
            "X    X",
            "      ",
            "      ",
            "   X  ",
        },
    },
    {
        name = "TasteTheRainbow_Switch1",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "     X",
        },
    },
    {
        name = "TasteTheRainbow_Switch2",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "X     ",
        },
    },
    {
        name = "TasteTheRainbow_Switch3",
        filledCells = {
            "     X",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "TasteTheRainbow_Switch4",
        filledCells = {
            "X     ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "OrangeFactory_Reels",
        filledCells = {
            "X    X",
        },
    },
    {
        name = "OrangeFactory_Missing",
        filledCells = {
            "      ",
            "X    X",
            "      ",
            "      ",
            "      ",
            "X    X",
            "      ",
        },
    },
    {
        name = "OrangeFactory_Switch1",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "     X",
        },
    },
    {
        name = "OrangeFactory_Switch2",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "X     ",
        },
    },
    {
        name = "OrangeFactory_Switch3",
        filledCells = {
            "     X",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "OrangeFactory_Switch4",
        filledCells = {
            "X     ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },

    {
        name = "MakeItRain_Rand1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X     X",
        },
    },
    {
        name = "MakeItRain_Rand2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X   X ",
        },
    },
    {
        name = "MakeItRain_Rand3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X X  ",
        },
    },
    {
        name = "MakeItRain_Rand4",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "MakeItRain_Rand5",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
        },
    },

    {
        name = "SwitchSequence2_Switch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "SwitchSequence2_Switch2",
        filledCells = {
            "       ",
            "       ",
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "SwitchSequence2_Switch3",
        filledCells = {
            "       ",
            "       ",
            "     X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "SwitchSequence2_Switch4",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
            "       ",
        },
    },
    {
        name = "SwitchSequence2_Switch5",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
            "       ",
        },
    },
    {
        name = "SwitchSequence2_Wall1",
        filledCells = {
            "       ",
            " X     ",
            "X X    ",
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "SwitchSequence2_Wall2",
        filledCells = {
            "       ",
            "     X ",
            "    X X",
            "     X ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "SwitchSequence2_Wall3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
            "    X X",
            "     X ",
        },
    },
    {
        name = "SwitchSequence2_Wall4",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
            "X X    ",
            " X     ",
        },
    },
    {
        name = "SwitchSequence2_Wall5",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "  X X  ",
            "   X   ",
            "       ",
            "       ",
        },
    },
    {
        name = "ScrollingBursts_Maker",
        filledCells = {
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ScrollingBursts_Missing",
        filledCells = {
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ScrollingBursts_GemEater",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "ScrollingBursts_Pattern",
        filledCells = {
            " XXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "       ",
        },
    },
	{
		name = "LostKeys_steel1",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LostKeys_steel2",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "LostKeys_steel3",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "LostKeys_steel4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
     {
        name = "AirLock_Switch1",
        filledCells = {
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "AirLock_Switch2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "AirLock_Switch3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
            "       ",
        },
    },
    {
        name = "AirLock_Makers",
        filledCells = {
            " XX XX ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },

    {
        name = "TowerDefense_Switch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "TowerDefense_Wave2",
        filledCells = {
            "X X X X",
            " X X X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TowerDefense_Wave3",
        filledCells = {
            "X     X",
            " X   X ",
            "  X X  ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TowerDefense2_GoSwitch",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "TowerDefense2_StopSwitch",
        filledCells = {
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TowerDefense2_Wave1",
        filledCells = {
            "X X X X",
            " X X X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TowerDefense2_Wave2",
        filledCells = {
            " X   X ",
            "  X X  ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TowerDefense2_Wave3a",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXX XXX",
        },
    },
    {
        name = "TowerDefense2_Wave3b",
        filledCells = {
            "X X X X",
            " X X X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TowerDefense2_Wave3c",
        filledCells = {
            " X   X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },

    {
        name = "TowerDefense2_Defender1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X   X ",
            "       ",
            "       ",
        },
    },
    {
        name = "TowerDefense2_Defender2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "X     X",
            "       ",
            "       ",
        },
    },

    {
        name = "Teleporter_Switch1",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "  X   ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "Teleporter_Switch2",
        filledCells = {
            "      ",
            "     X",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "Teleporter_Switch3",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            " X    ",
        },
    },
    {
        name = "Teleporter_Switch4",
        filledCells = {
            "      ",
            "X     ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "Teleporter_Switch5",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "    X ",
            "      ",
        },
    },


    {
        name = "Teleporter_Switch6",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "X     ",
            "      ",
        },
    },
    {
        name = "Teleporter_Switch7",
        filledCells = {
            "      ",
            "   X  ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "Teleporter_Switch8",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "X     ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "Teleporter_Switch9",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "     X",
        },
    },
    {
        name = "Teleporter_Switch10",
        filledCells = {
            "      ",
            "      ",
            "     X",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },

	{
		name = "Crabgrass_vines1",
		filledCells = {
			"      ",
			" X    ",
			"      ",
			"      ",
			"      ",
			"    X ",
			"      ",
		},
	},

	{
		name = "Crabgrass_vines2",
		filledCells = {
			"      ",
			"    X ",
			"      ",
			"      ",
			"      ",
			" X    ",
			"      ",
		},
	},
	{
		name = "Crabgrass_pattern",
		filledCells = {
			"      ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			" XXXX ",
			"      ",
		},
	},
    {
        name = "Binary_Steel",
        filledCells = {
            "      ",
            "X    X",
            "      ",
            "      ",
            "      ",
            "X     ",
            "    X ",
        },
    },
    {
        name = "Binary_Switch1",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "     X",
        },
    },
    {
        name = "Binary_Switch2",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "X     ",
        },
    },
    {
        name = "Binary_Switch3",
        filledCells = {
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "Binary_Switch4",
        filledCells = {
            "     X",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "Binary_Gate1",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "     X",
            "      ",
        },
    },
    {
        name = "Binary_Gate2",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            " X    ",
        },
    },
    {
        name = "Binary_Gate3",
        filledCells = {
            " X    ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "Binary_Gate4",
        filledCells = {
            "    X ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
        },
    },
    {
        name = "SkeetShooting_Reels",
        filledCells = {
            "     XX",
        },
    },
    {
        name = "SkeetShooting_Eaters",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
            "      X",
        },
    },
    {
        name = "SkeetShooting_Maker",
        filledCells = {
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "SkeetShooting_Switch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
    {
        name = "SkeetShooting_Switch2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "SkeetShooting_Burst1",
        filledCells = {
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "SkeetShooting_Burst2",
        filledCells = {
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "LavaDam_Reels",
        filledCells = {
            "XX     ", 
        },
    },
    {
        name = "LavaDam_Missing",
        filledCells = {
            "XXXXX  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "LavaDam_Makers",
        filledCells = {
            "     XX",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "LavaDam_Lava",
        filledCells = {
            "X      ",
            "X      ",
            "X      ",
            "X      ",
            "X      ",
            "X      ",
            "X      ",
            "X      ",
        },
    },
    {
        name = "LavaDam_BlueSteel",
        filledCells = {
            " X     ",
            "       ",
            "       ",
            "       ",
            " X     ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "LavaDam_GreenSteel",
        filledCells = {
            "       ",
            " X     ",
            "       ",
            "       ",
            "       ",
            " X     ",
            "       ",
            "       ",
        },
    },
    {
        name = "LavaDam_PurpleSteel",
        filledCells = {
            "       ",
            "       ",
            " X     ",
            "       ",
            "       ",
            "       ",
            " X     ",
            "       ",
        },
    },
    {
        name = "LavaDam_RedSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            " X     ",
            "       ",
            "       ",
            "       ",
            " X     ",
        },
    },
    {
        name = "JungleTrap_Makers",
        filledCells = {
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "JungleTrap_Coverage",
        filledCells = {
            "       ",
            "X     X",
            " X   X ",
            "X     X",
            "       ",
            "       ",
            "XXXXXXX",
            " XX XX ",
        },
    },
    {
        name = "JungleTrap_VineGrowers",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X  X  X",
        },
    },
    {
        name = "JungleTrap_Vines",
        filledCells = {
            "       ",
            "       ",
            "X     X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "JungleTrap_BlueSteel",
        filledCells = {
            "       ",
            "X      ",
            " X     ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "JungleTrap_GreenSteel",
        filledCells = {
            "       ",
            "      X",
            "     X ",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "JungleTrap_PurpleSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XX     ",
            " X     ",
        },
    },
    {
        name = "JungleTrap_RedSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     XX",
            "     X ",
        },
    },
    {
        name = "JungleTrap_YellowSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  XXX  ",
            "  X X  ",
        },
    },
    {
        name = "JungleTrap_BlueKey",
        filledCells = {
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "JungleTrap_GreenKey",
        filledCells = {
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "JungleTrap_PurpleKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "JungleTrap_RedKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "JungleTrap_YellowKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
        },
    },

	-- Dave Land 29 Patterns BEGIN

	{
        name = "DigDigDig_Wall1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
        },
    },

	{
        name = "DigDigDig_Wall2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "       ",
        },
    },

	{
        name = "DigDigDig_Wall3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "       ",
            "       ",
        },
    },

	{
        name = "DigDigDig_Wall4",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "       ",
            "       ",
            "       ",
        },
    },
	{
        name = "DigDigDig_Wall5",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "       ",
            "       ",
            "       ",
        },
    },

    {
        name = "DigDigDig_RedKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X ",
    
        },
    },
    {
        name = "DigDigDig_BlueKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",

        },
    },
	{
        name = "DigDigDig2_RedKey",
        filledCells = {
            "      X",
    
        },
    },
    {
        name = "DigDigDig2_GreenKey",
        filledCells = {
            "X",

        },
    },
    {
        name = "DigDigDig2_BlueKey",
        filledCells = {
            "    X ",
		},
    },
    {
        name = "DigDigDig2_YellowKey",
        filledCells = {
            "  X ",
    
        },
    },

	{
        name = "SideCut_Treasures",
        filledCells = {
            "XX",
    
        },
    },

	{
        name = "SideCut_SideRow1",
        filledCells = {
            "      ",
            "XX",
        },
    },

	{
        name = "SideCut_SideRow2",
        filledCells = {
            "      ",
            "      ",
            "XX",
        },
    },

	{
        name = "SideCut_SideRow3",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "XX",
        },
    },

	{
        name = "SideCut_SideRow4",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "XX",
        },
    },

	{
        name = "SideCut_RedKey",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            " X",
        },
    },

	{
        name = "SideCut_BlueKey",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "X",
        },
    },

	{
        name = "SideCut_GreenKey",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            " X",
        },
    },

	{
        name = "SideCut_PurpleKey",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "X",
        },
    },

	{
        name = "SideCut_Steel",
        filledCells = {
            "  X  ",
        },
    },

	{
        name = "SideCut_Fence",
        filledCells = {
            "      ",
            "  X  ",
            "  X  ",
            "  X  ",
            "  X  ",
            "  X  ",
            "  X  ",
        },
    },

	{
        name = "SideCut_Crates",
        filledCells = {
            "      ",
            "      ",
            "      ",
            "      ",
            "      ",
            "   XXX",
            "   XXX",
        },
    },

	{
        name = "SideCut_Missing",
        filledCells = {
            "  X  ",
            "  X  ",
            "  X  ",
            "  X  ",
            "  X  ",
            "  X  ",
            "  X  ",
        },
    },

    {
        name = "ReleaseTheBurst_Key",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Vines",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Stone1",
        filledCells = {
            "       ",
            "       ",
            "   X   ",
            "   X   ",
            " XX XX ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Stone2",
        filledCells = {
            "       ",
            "   X   ",
            "  X X  ",
            " X   X ",
            "X     X",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Bedrock",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "XXX XXX",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Burst1",
        filledCells = {
			" X   X ",
            "       ",
            "X     X",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Burst2",
        filledCells = {
            "       ",
            "X     X",
			" X   X ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Burst3",
        filledCells = {
            "X     X ",
            " X   X ",
            "      ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Windows",
        filledCells = {
            "XX   XX",
            "XX   XX",
            "XX   XX",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Steel",
        filledCells = {
            "  X X ",
            "  X X ",
            "  X X ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "ReleaseTheBurst_Pattern",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "XXX XXX",
            "XX   XX",
            "X     X",
        },
    },


	-- Dave Land 29 Patterns END

    {
        name = "RockCity_Reels",
        filledCells = {
            "X  X  X",
        },
    },
    {
        name = "RockCity_Chests",
        filledCells = {            
            "X  X  X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RockCity_Stones",
        filledCells = {
            "       ",
            "X  X  X",
            "       ",
            "       ",
            "X  X  X",
            "       ",
            "       ",
            "X  X  X",
        },
    },
    {
        name = "RockCity_GreenKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
        },
    },
    {
        name = "RockCity_PurpleKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
        },
    },
    {
        name = "RockCity_RedKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "    X  ",
        },
    },
    {
        name = "RockCity_YellowKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
        },
    },
    {
        name = "RockCity_GreenSteel",
        filledCells = {
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "   X   ",
            "      X",
            "       ",
        },
    },
    {
        name = "RockCity_PurpleSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "X     X",
            "       ",
            "       ",
        },
    },
    {
        name = "RockCity_RedSteel",
        filledCells = {
            "       ",
            "       ",
            "      X",
            "X      ",
            "       ",
            "       ",
            "   X   ",
            "       ",
        },
    },
    {
        name = "RockCity_YellowSteel",
        filledCells = {
            "       ",
            "       ",
            "   X   ",
            "      X",
            "       ",
            "       ",
            "X      ",
            "       ",
        },
    },
	{
		name = "TopRow1",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow3",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow5",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TopRow7",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row2_1",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row2_3",
		filledCells = {
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row2_5",
		filledCells = {
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Row2_7",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
    {
        name = "Stratum_Missing",
        filledCells = {
            "XXXXXXX",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "       ",
        },
    },
    {
        name = "Stratum_BlueKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
    {
        name = "Stratum_GreenKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
        },
    },
    {
        name = "Stratum_PurpleKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "    X  ",
        },
    },
    {
        name = "Stratum_RedKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "Stratum_BlueSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
        },
    },
    {
        name = "Stratum_GreenSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "Stratum_PurpleSteel",
        filledCells = {
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "Stratum_RedSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
        },
    },
    {
        name = "Stratum_BlueKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
    {
        name = "Stratum_GreenKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
        },
    },
    {
        name = "Stratum_PurpleKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "    X  ",
        },
    },
    {
        name = "Stratum_RedKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "Stratum_BlueSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
        },
    },
    {
        name = "Stratum_GreenSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "Stratum_PurpleSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
        },
    },
    {
        name = "Stratum_RedSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
        },
    },
    {
        name = "BlockedPlumbing_Makers0",
        filledCells = {
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_Makers1",
        filledCells = {
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_Makers2",
        filledCells = {
            " X   X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_Makers3",
        filledCells = {
            "X     X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_BlueKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "BlockedPlumbing_GreenKey",
        filledCells = {
            "       ",
            "       ",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_PurpleKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "BlockedPlumbing_RedKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
    {
        name = "BlockedPlumbing_YellowKey",
        filledCells = {
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_OrangeKey",
        filledCells = {
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_BlueSteel",
        filledCells = {
            "       ",
            " X     ",
            " X     ",
            "XX     ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_GreenSteel",
        filledCells = {
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_PurpleSteel",
        filledCells = {
            "       ",
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_RedSteel",
        filledCells = {
            "       ",
            "     X ",
            "     X ",
            "     XX",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_YellowSteel",
        filledCells = {
            "       ",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BlockedPlumbing_OrangeSteel",
        filledCells = {
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonParty_Key",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonParty_Vines",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonParty_Stone1",
        filledCells = {
            "       ",
            "       ",
            "   X   ",
            "   X   ",
            " XX XX ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonParty_Stone2",
        filledCells = {
            "       ",
            "   X   ",
            "  X X  ",
            " X   X ",
            "X     X",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "AxeWarp_Glass",
        filledCells = {
            "    XXX",
            "     XX",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "AxeWarp_Stones",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
            "X      ",
            "X  X   ",
            "   X   ",
        },
    },
    {
        name = "AxeWarp_BlueKey",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
    {
        name = "AxeWarp_GreenKey",
        filledCells = {
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "AxeWarp_PurpleKey",
        filledCells = {
            "     X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "AxeWarp_RedKey",
        filledCells = {
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "AxeWarp_BlueSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "AxeWarp_GreenSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
        },
    },
    {
        name = "AxeWarp_PurpleSteel",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "AxeWarp_RedSteel",
        filledCells = {
            "   X   ",
            "   XX  ",
            "    XX ",
            "     XX",
            "      X",
            "       ",
            "       ",
            "       ",
        },
    },
	{
		name = "PickaxePopup_purple",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  X  X",
			"      ",
		},
	},
	{
		name = "PickaxePopup_red",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X  X  ",
			"      ",
		},
	},
	{
		name = "PickaxePopup_blue",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
			"      ",
		},
	},
	{
		name = "PickaxePopup_green",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
			"      ",
		},
	},
	{
		name = "CrowdedLab_Impossible",
		filledCells = {  
			"       ",   
			"       ",
			"       ",
			"   X   ",
			"       ", 
			"       ", 
			"  X X  ", 
			"X     X",  
		},
	},
	{
		name = "CrowdedLab_Color1",
		filledCells = {  
			" XX    ",   
			"  XX   ",
			"       ",  
			"       ",  
			"       ",  
			"       ",  
			"       ",  
			"     X ",  
		},
	},
	{
		name = "CrowdedLab_Color2",
		filledCells = {  
			"     X ",  
			"     X ",  
			"  XX   ",
			"       ",  
			"       ",  
			"       ",  
			"X     X",  
			"       ",  
		},
	},
	{
		name = "CrowdedLab_Color3",
		filledCells = {  
			"       ",   
			"    X  ",
			"    XX ",
			" X     ",  
			"X      ",  
			"       ",  
			"       ",  
			"       ",   
		},
	},
	{
		name = "CrowdedLab_Color4",
		filledCells = {  
			"   XX  ",   
			" X     ",  
			" X     ",  
			"       ",  
			"       ",  
			"       ",  
			"       ",  
			"       ",   
		},
	},
	{
		name = "CrowdedLab_Bedrock1",
		filledCells = {  
			"       ",  
			"       ",  
			"       ",  
			"       ",   
			"  XXX  ",
			"       ",  
			"       ",  
			"       ",   
		},
	},
	{
		name = "CrowdedLab_Bedrock2",
		filledCells = {  
			"       ",  
			"       ",   
			"       ",   
			"       ",  
			"       ",   
			"    XXX",
			"       ",  
			"       ",   
		},
	},
	{
		name = "CrowdedLab_Bedrock3",
		filledCells = {  
			"       ",  
			"       ",   
			"       ",   
			"       ",  
			"       ",   
			"XXX    ",
			"       ",  
			"       ",   
		},
	},
	{
		name = "CrowdedLab_Bedrock4",
		filledCells = {  
			"       ",   
			"       ",  
			"       ", 
			"       ",   
			"       ",  
			"       ", 
			"       ", 
			"  XXX  ",  
		},
	},
	{
		name = "CrowdedLab_Key1",
		filledCells = {  
			"       ", 
			"      X",
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "CrowdedLab_Key2",
		filledCells = {  
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			" X     ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "CrowdedLab_Key3",
		filledCells = {  
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"   X   ",
			"       ", 
			"       ", 
		},
	},
	{
		name = "CrowdedLab_Key4",
		filledCells = {  
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			" X     ",  
		},
	},
	{
		name = "CrowdedLab_Stone",
		filledCells = {  
			"       ",   
			"X      ",
			"       ",
			"X X X X",
			"     X ",
			"       ",
			" X X X ",
			"       ",
		},
	},
	{
		name = "CrowdedLab_Jail",
		filledCells = {  
			"X     X",   
			"       ",
			"X     X",
			" X   X ",
			"X     X", 
			"       ", 
			"X     X",
			"     X ",  
		},
	},
	{
		name = "CrowdedLab_Coverage",
		filledCells = {  
			"XX   XX",   
			"XX   XX",
			"XX   XX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
    {
        name = "CrowdedLab3_Stone2",
        filledCells = {  
            "       ",   
            "X      ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "CrowdedLab3_Stone3",
        filledCells = {  
            "       ",   
            "       ",
            "       ",
            "X     X",
            "     X ",
            "       ",
            " X X X ",
            "       ",
        },
    },
    {
        name = "CrowdedLab3_Jail2",
        filledCells = {  
            "X     X",   
            "       ",
            "X     X",
            "       ",   
            "       ",
            "       ",   
            "       ",
            "       ",  
        },
    },
    {
        name = "CrowdedLab3_Jail3",
        filledCells = {  
            "       ",   
            "       ",
            "       ",
            " X   X ",
            "X     X", 
            "       ", 
            "X     X",
            "     X ",  
        },
    },
    {
        name = "BalloonLab1_makers",
        filledCells = {  
            "       ", 
            "X     X", 
            "       ", 
            "       ", 
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab1_balloons",
        filledCells = {  
            " XXXXX ", 
            " XXXXX ", 
            "  XXX  ", 
            "   X   ", 
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab1_clear",
        filledCells = {  
            "       ", 
            "       ", 
            " X   X ", 
            "  X X  ", 
            "   X   ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab2_balloons0",
        filledCells = {  
            "  X    ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonLab2_balloons1",
        filledCells = {  
            "    X  ",
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonLab2_balloons2",
        filledCells = {  
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonLab2_balloons3",
        filledCells = {  
            "       ",
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonLab2_balloons4",
        filledCells = {  
            "   X   ",
            "     X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BalloonLab2_makers",
        filledCells = {  
            "       ", 
            "X     X", 
            "       ", 
            "       ", 
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab2_missing",
        filledCells = {  
            "       ", 
            "       ", 
            " XXXXX ", 
            "       ",  
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab2_steel",
        filledCells = {  
            "XX   XX", 
            "       ", 
            "       ",  
            "       ", 
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab3_balloons1",
        filledCells = {  
            "       ",
            " X   X ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X   X ",
            " X   X ",
        },
    },
    {
        name = "BalloonLab3_balloons2",
        filledCells = {  
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
            "       ",
        },
    },
    {
        name = "BalloonLab3_balloons3",
        filledCells = {  
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
        },
    },
    {
        name = "BalloonLab3_balloons4",
        filledCells = {  
            "       ",
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "    X  ",
            "       ",
        },
    },
    {
        name = "BalloonLab3_makers",
        filledCells = {  
            "       ", 
            "       ", 
            "X     X", 
            "       ", 
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab3_missing",
        filledCells = {  
            "       ", 
            "       ",
            "       ", 
            " XXXXX ",
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab3_steel",
        filledCells = {  
            "XXXXXXX", 
            "X     X", 
            "       ",  
            "       ", 
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab3_crates",
        filledCells = {  
            "       ",  
            "       ", 
            "       ",  
            "       ", 
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab3_Boulders",
        filledCells = {  
            "       ",
            "       ",
            " XXXXX ",  
            "       ", 
            "       ", 
            "       ",
            "       ", 
            "       ", 
        },
    },
    {
        name = "BalloonLab3_Lava",
        filledCells = {  
            "       ",
            "       ",  
            "       ", 
            "       ", 
            "       ",
            "       ", 
            "       ",
            "  XXX  ", 
        },
    },

	--begin Michael Lock Lab patterns

	{
		name = "LockLab1_locks",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XX  XX",
			"      ",
			"XXXXXX",
			" X  X ",
		},
	},
	{
		name = "LockLab1_steel",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X XX X",
		},
	},
	{
		name = "LockLab1_clouds",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
		},
	},
	{
		name = "LockLab1_void",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
		},
	},
	{
		name = "LockLab2_locks",
		filledCells = {
			"       ",
			"       ",
			" XXXXX ",
			"       ",
			"       ",
			" XXXXX ",
			"       ",
			"       ",
		},
	},
	{
		name = "LockLab2_steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			"X     X",
			"       ",
			"X     X",
			"X     X",
		},
	},
	{
		name = "LockLab2_clouds",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"   X   ",
			"       ",
			"  XXX  ",
			"   X   ",
		},
	},
	{
		name = "LockLab2_void",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"   X   ",
			"       ",
			"  XXX  ",
			"   X   ",
		},
	},
	{
		name = "LockLab2_steel",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"X     X",
			"       ",
			"       ",
			"X     X",
			"X     X",
		},
	},
	{
		name = "LockLab2_clouds",
		filledCells = {
			"       ",
			"       ",
			" XXXXX ",
			"  XXX  ",
			"   X   ",
			" XXXXX ",
			"  XXX  ",
			"   X   ",
		},
	},
	{
		name = "LockLab3_locks",
		filledCells = {
			"       ",
			"       ",
			"XXX XXX",
			"       ",
			"XXX XXX",
			"       ",
			"XXX XXX",
			"       ",
		},
	},
	{
		name = "LockLab3_steel",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "LockLab3_void",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
			"       ",
			"XXXXXXX",
		},
	},
	--end Michael Lock Lab patterns
	
	{
		name = "FlickeringWall_Maker",
		filledCells = {     
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FlickeringWall_Boulders",
		filledCells = {    
			"       ", 
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
			"      X",
		},
	},
	{
		name = "FlickeringWall_Switch",
		filledCells = {     
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},

	--begin Michael land 30 levels
	{
		name = "Metamorphosis_clouds",
		filledCells = {  
			" XXXXX ",   
			" X X X ",
			"X XXX X",
			"XXXXXXX",
			"XXXXXXX",
			" X X X ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_switch",
		filledCells = {  
			"       ",   
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "Metamorphosis_caterpillar",
		filledCells = {  
			"       ",   
			"       ",
			"       ",
			"  XXX  ",
			" XXXXX ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_cocoon",
		filledCells = {  
			" XXXXX ",   
			"   X   ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_cocoonLeaf",
		filledCells = {  
			" XXXXX ",   
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_cocoonBody",
		filledCells = {  
			"       ",   
			"   X   ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_butterfly",
		filledCells = {     
			" X X X ",
			"X XXX X",
			"X  X  X",
			"X XXX X",
			" X X X ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_butterflyWings",
		filledCells = {     
			" X   X ",
			"X X X X",
			"X     X",
			"X X X X",
			" X   X ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_butterflyBody",
		filledCells = {     
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_butterflyBottom",
		filledCells = {     
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Metamorphosis_stone",
		filledCells = {     
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
		},
	},




	--end Michael land 30 levels

	{
		name = "RaceTheClock_steel1",
		filledCells = {
			"   X   ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"X     X",
			"       ",
			"   X   ",
		},
	},
	{
		name = "RaceTheClock_steel2",
		filledCells = {
			"       ",
			" X   X ",
			"       ",
			"X     X",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_Switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb1",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb2",
		filledCells = {
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb3",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "RaceTheClock_bomb8",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb9",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb10",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb11",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RaceTheClock_bomb12",
		filledCells = {
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
        name = "LaserToggle_missing",
        filledCells = {
            " X     ",
            " X     ",
            " X     ",
            " X     ",
            "     X ",
            "     X ",
            "     X ",
            "     X ",
        },
    },
	{
        name = "LaserToggle_boulder",
        filledCells = {
            "       ",
            "X      ",
            "X      ",
            "X      ",
            "      X",
            "      X",
            "      X",
            "      X",
        },
    },
	{
        name = "LaserToggle_fences",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "      X",
            "X      ",
            "       ",
            "       ",
            "       ",
        },
    },
	{
        name = "BreakerBox_fences",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X     X",
            " X   X ",
        },
    },
	{
        name = "BreakerBox_pickaxeGreen",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
        },
    },
	{
        name = "BreakerBox_pickaxeRed",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
    },
	{
        name = "BreakerBox_pickaxeBlue",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
	{
        name = "BreakerBox_pickaxePurple",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
	{
        name = "BreakerBox_bedrockRed",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "  X X  ",
            "       ",
        },
    },
	{
        name = "BreakerBox_bedrockBlue",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
	{
        name = "BreakerBox_bedrockGreen",
        filledCells = {
            " X     ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "X      ",
            " X     ",
            "  X    ",
        },
    },
	{
        name = "BreakerBox_bedrockPurple",
        filledCells = {
            "     X ",
            "      X",
            "       ",
            "       ",
            "       ",
            "      X",
            "     X ",
            "    X  ",
        },
    },
	{
		name = "ReplenishingBedrock",
        filledCells = {
            "CaaabcB", --1,2,3 = walls
            " 111bb ", 
            " cc222 ", --A,B,C = key vendors
            "  333  ", --a,b,c = makers to refresh walls
            "   A   ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_Wall1",
        filledCells = {
            "       ",
            " XXX   ", 
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_Wall2",
        filledCells = {
            "       ",
            "       ",
            "   XXX ", 
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_Wall3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "  XXX  ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_KeyMaker1",
        filledCells = {
            "       ", 
            "       ", 
            "       ", 
            "       ", 
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_KeyMaker2",
        filledCells = {
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_KeyMaker3",
        filledCells = {
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_WallMaker1",
        filledCells = {
            " XXX   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_WallMaker2",
        filledCells = {
            "    X  ",
            "    XX ", 
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
		name = "ReplenishingBedrock_WallMaker3",
        filledCells = {
            "     X ",
            "       ",
            " XX    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
	},
	{
        name = "AxeChase_bedrockBlue",
        filledCells = {
            "       ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
	{
        name = "AxeChase_bedrockGreen",
        filledCells = {
            "       ",
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
	{
        name = "AxeChase_bedrockPurple",
        filledCells = {
            "       ",
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
	{
        name = "AxeChase_bedrockRed",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
        },
    },
    {
        name = "EmergencyEscape_Treasure",
        filledCells = {
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "EmergencyEscape_switch",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "EmergencyEscape_steel",
        filledCells = {
            "  X X  ",
            "  XXX  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "EmergencyEscape_stone",
        filledCells = {
            "       ",
            "       ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "X  X  X",
            " X X X ",
        },
    },
    {
        name = "EmergencyEscape_bombCorners",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X     X",
        },
    },
    {
        name = "EmergencyEscape_bombs1",
        filledCells = {
            "X     X",
            "       ",
            "       ",
            "       ",
            "       ",
            "X     X",
            "       ",
            "       ",
        },
    },
    {
        name = "EmergencyEscape_bombs2",
        filledCells = {
            "       ",
            " X   X ",
            "       ",
            "       ",
            " X   X ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "EmergencyEscape_bombs3",
        filledCells = {
            "       ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "GravitySwapper_switch",
        filledCells = {
            "       ",
            "       ",
            "       ",
            " X   X ",
            "       ",
            "   X   ",
            "       ",
            "       ",
        },
    },
    {
        name = "GravitySwapper_balloonChests",
        filledCells = {
            "X X X X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },

    {
        name = "VinesPattern1_side_vines",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "  X X  ",
            " X X X ",
            "X X X X",
        },
    },
    {
        name = "VinesPattern1_side_stones",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "  X X  ",
            " X X X ",
            "X X X X",
            " X X X ",
        },
    },
    {
        name = "VinesPattern1_side_pattern",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "  XXX  ",
            " XXXXX ",
            "XXXXXXX",
            "XXXXXXX",
        },
    },
    
    -- Begin Brendan Treasure Lab patterns
    {
        name = "TreasureLab1_Cells",
        filledCells = {
            "XXX XXX",
            "X X X X",
            "XX   XX",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureLab1_CellDoors",
        filledCells = {
            "       ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureLab1_Chests",
        filledCells = {
            "       ",
            " X   X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureLab2_Cells",
        filledCells = {
            "XXX XXX",
            "X X X X",
            "X X X X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureLab2_CellDoors",
        filledCells = {
            "       ",
            "       ",
            " X   X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureLab3_Cells",
        filledCells = {
            "XXX XXX",
            "X X X X",
            "XX   XX",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TreasureLab3_CellDoors",
        filledCells = {
            "       ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    -- End Brendan Treasure Lab patterns
	{
		name = "Col6_large_1",
		filledCells = {
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Col6_large_2up",
		filledCells = {
			"     X ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Col6_large_3up",
		filledCells = {
			"     X ",
			"     X ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Col6_large_4up",
		filledCells = {
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Col6_large_5up",
		filledCells = {
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Col6_large_6up",
		filledCells = {
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"       ",
			"       ",
		},
	},
	{
		name = "Col6_large_7up",
		filledCells = {
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"       ",
		},
	},
	{
		name = "SquishyPattern_Pattern",
		filledCells = {
			"X XX X",
			" X  X ",
			"X XX X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SquishyPattern_Glass",
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SquishyPattern_Crates",
		filledCells = {
			" X  X ",
			"X XX X",
			" X  X ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
    {
        name = "GarbagePile_Boulders",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "    X  ",
            "       ",
            "   X   ",
            "       ",
            "X      ",
        },
    },
    {
        name = "GarbagePile_Coconuts",
        filledCells = {
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "    X  ",
            "       ",
        },
    },
    {
        name = "GarbagePile_Gifts",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X   X",
        },
    },
    {
        name = "GarbagePile_Vines",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X  X   ",
            "       ",
        },
    },
    {
        name = "GarbagePile_Lava",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X  X  ",
        },
    },
    {
        name = "GarbagePile_Balloons",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
            "     X ",
        },
    },
    {
        name = "GarbagePile_Crates",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "      X",
            "       ",
            " X   X ",
            "       ",
        },
    },
    {
        name = "GarbagePile_Treasure",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
            "       ",
            "       ",
        },
    },
    {
        name = "GarbagePile_Stone",
        filledCells = {
            "       ",
            "   X   ",
            "       ",
            "       ",
            "   X   ",
            "X   X X",
            "       ",
            "       ",
        },
    },
    {
        name = "GarbagePile_Barrels",
        filledCells = {
            "   X   ",
            "       ",
            "       ",
            "       ",
            "X   X  ",
            "       ",
            "      X",
            "   X   ",
        },
    },
	{
		name = "PandorasLocks2_Marked",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X", 
			"X     X",
			"       ",
			"XX   XX",
			"X XXX X",
		},
	},
	{
		name = "PandorasLocks2_Steel",
		filledCells = {
			"       ", 
			"       ", 
			"X     X", 
			"       ", 
			"       ", 
			"XX   XX", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PandorasLocks2_Locks",
		filledCells = {
			"       ", 
			"   X   ", 
			"       ", 
			" X   X ",
			" X   X ",
			"       ", 
			"  XXX  ",
			" X   X ",
		},
	},
	{
		name = "PandorasLocks2_Ice",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ",
			"       ", 
			"       ", 
			"     XX", 
			"      X", 
		},
	},
	{
		name = "PandorasLocks2_Lava",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"XX     ", 
			"X      ", 
		},
	},
	{
		name = "PandorasLocks2_Vines",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"X     X",  
			"X     X",  
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PandorasLocks2_Barrels",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"  XXX  ",
		},
	},
	{
		name = "PandorasLocks2_Maker",
		filledCells = {
			"   X   ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ",
		},
	},
	{
		name = "RingChase_Marked",
		filledCells = {
			"  XX  ", 
			" X  X ", 
			"X    X", 
			"X    X", 
			"X    X", 
			" X  X ", 
			"  XX  ", 
		},
	},
	{
		name = "RingChase_NotMarked",
		filledCells = {
			"XX  XX", 
			"X XX X", 
			" XXXX ", 
			" XXXX ", 
			" XXXX ", 
			"X XX X", 
			"XX  XX", 
		},
	},
	{
		name = "RingSearch_Crates",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			"       ", 
			"       ", 
			"       ", 
			"   X   ", 
			"  XXX  ", 
		},
	},
	{
		name = "RingSearch_Marked",
		filledCells = {
			"      X", 
			"       ", 
			"      X", 
			" X     ", 
			"   X  X", 
			"       ", 
			"   X   ", 
			"  XXX  ", 
		},
	},
	{
		name = "RingSearch_Stones",
		filledCells = {
			"       ", 
			"       ",  
			"       ", 
			"  XXX  ",  
			"       ",  
			"X X X X", 
			" X   X ", 
			"X     X", 
		},
	},
	{
		name = "RingSearch_Jailed",
		filledCells = {
			"X      ", 
			"      X", 
			"X      ", 
			"X      ", 
			"    X  ", 
			"     X ", 
			"X      ", 
			" X   X ", 
		},
	},
	{
		name = "RingSearch_Key1",
		filledCells = {
			"       ",  
			"X      ", 
			"       ",  
			"       ",  
			"       ",  
			"       ",  
			"       ",  
			"       ",  
		},
	},
	{
		name = "RingSearch_Key2",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			" X     ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "RingSearch_Key3",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"      X", 
			"       ", 
		},
	},
	{
		name = "RingSearch_Wall1",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"XXX    ",  
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "RingSearch_Wall2",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"     XX", 
			"     X ",  
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "RingSearch_Wall3",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"   X   ", 
			"  X X  ", 
			"       ", 
		},
	},
	{
		name = "RingSearch_Color1",
		filledCells = {
			"  XX   ", 
			"  X   X", 
			"       ", 
			"X      ", 
			"       ", 
			"       ", 
			"       ", 
			"     X ", 
		},
	},
	{
		name = "RingSearch_Color2",
		filledCells = {
			"X      ", 
			"       ", 
			"  XX   ", 
			" X     ", 
			"      X", 
			"       ", 
			"X      ", 
			"       ", 
		},
	},
	{
		name = "RingSearch_Color3",
		filledCells = {
			"       ", 
			"   XX  ", 
			"X   X X", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			" X     ", 
		},
	},
	{
		name = "RingSearch_Color4",
		filledCells = {
			"   XX  ",  
			"       ", 
			"       ", 
			"       ", 
			"    X  ",  
			"     X ", 
			"       ", 
			"       ", 
		},
	},
    {
        name = "RingStamper_Reels",
        filledCells = {
            "XX    X",
        },
    },
    {
        name = "RingStamper_Missing",
        filledCells = {
            "XX     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XX     ",
        },
    },
    {
        name = "RingStamper_Maker",
        filledCells = {
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RingStamper_Steel",
        filledCells = {
            "       ",
            "XX     ",
            " X     ",
            " X     ",
            " X     ",
            " X     ",
            "XX     ",
            "       ",
        },
    },
    {
        name = "RingStamper_Eaters",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "RingStamper_Switch",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
        },
    },
    {
        name = "RingStamper_Targets",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "Bobbing_Balloons",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X X X X",
        },
    },
    {
        name = "Bobbing_ColorBarrels",
        filledCells = {
            " X   X ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RingChase_side_Eaters",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "XXXXXXX",
        },
    },
	{
		name = "QuickThaw_IceBombs",
		filledCells = {
			"       ",  
			"   X   ", 
			"       ", 
			"       ", 
			"       ",  
			" X   X ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "QuickThaw_Makers",
		filledCells = {
			"       ",  
			"       ", 
			"       ", 
			"       ", 
			"       ",  
			"       ", 
			"       ", 
			"  XXX  ", 
		},
	},
    {
        name = "RainDance_VineGenerators",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "RingMaker_MakerA",
        filledCells = {
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RingMaker_MakerB",
        filledCells = {
            "     X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RingMaker_BlockerA",
        filledCells = {
            "       ",
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RingMaker_BlockerB",
        filledCells = {
            "       ",
            "     X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RingMaker_Switch",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "RingMaker_Steel",
        filledCells = {
            "X XXX X",
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
	{
		name = "SafesTest_Safe1",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SafesTest_Safe2",
		filledCells = {
			"      ",
			"      ",
			"    X ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

    {
        name = "RainbowStripe_Rings",
        filledCells = {
            "       ",
            "       ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
        },
    },
    {
        name = "RainbowStripe_Boulders",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
            "  X X  ",
        },
    },
    {
        name = "RainbowStripe_Maker",
        filledCells = {
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_Blue",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_Green",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_Purple",
        filledCells = {
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_Red",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "RainbowStripe_Yellow",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_Orange",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
        },
    },
	
    {
        name = "PunchClockVillain_Switch",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
        },
    },
    {
        name = "PunchClockVillain_Stones",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "  X X  ",
            "   X   ",
        },
    },
    {
        name = "PunchClockVillain_Bombs1",
        filledCells = {
            "      X",
            "  X    ",
            "       ",
            "    X  ",
            "X      ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "PunchClockVillain_Ice1",
        filledCells = {
            "       ",
            "   X   ",
            "  XXX  ",
            "   X   ",
            "X     X",
            "XX   XX",
            "X     X",
            "       ",
        },
    },
    {
        name = "PunchClockVillain_Lava1",
        filledCells = {
            "    X  ",
            " X     ",
            "     X ",
            "  X    ",
            "    X  ",
            " X     ",
            "       ",
            "       ",
        },
    },
    {
        name = "PunchClockVillain_Vines1",
        filledCells = {
            "       ",
            " X   X ",
            "   X   ",
            "       ",
            "       ",
            "X     X",
            "       ",
            "       ",
        },
    },
    {
        name = "PunchClockVillain_Crates1",
        filledCells = {
            "  XXX  ",
            "  XXX  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "PunchClockVillain_Stones1",
        filledCells = {
            " X   X ",
            " X   X ",
            "  XXX  ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "PunchClockVillain_Barrels1",
        filledCells = {
            "X     X",
            " X   X ",
            "       ",
            "X  X  X",
            "       ",
            "       ",
            "       ",
            "X     X",
        },
    },
    {
        name = "PunchClockVillain_BombChests1",
        filledCells = {
            "XXX XXX",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "PunchClockVillain_Chests1",
        filledCells = {
            " XX XX ",
            "X     X",
            " XX XX ",
            "       ",
            " X   X ",
            "X     X",
            "       ",
            "       ",
        },
    },
    {
        name = "GiftWrapping_Gifts",
        filledCells = {
            "X     X", 
            "  X X  ", 
            "       ", 
            "X     X", 
            "       ", 
            "X     X",  
            "       ", 
            " X X X ",
        },
    },
    {
        name = "GiftWrapping_Switch",
        filledCells = {
            "       ", 
            "       ", 
            "       ", 
            "       ", 
            "   X   ", 
            "       ", 
            "       ", 
            "       ",
        },
    },
    {
        name = "GiftWrapping_Targets",
        filledCells = {
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXX XXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
        },
    },
    {
        name = "GiftWrapping_Blue",
        filledCells = {
            "       ", 
            "       ", 
            "       ", 
            "XXXXXXX", 
            "       ", 
            "       ", 
            "       ", 
            " XXXXX ",
        },
    },
    {
        name = "GiftWrapping_Green",
        filledCells = {
            "       ", 
            "       ", 
            "XXXXXXX", 
            "       ", 
            "       ", 
            "       ", 
            "XXXXXXX", 
            "       ",
        },
    },
    {
        name = "GiftWrapping_Purple",
        filledCells = {
            "       ", 
            "XXXXXXX", 
            "       ", 
            "       ", 
            "       ", 
            "XXXXXXX", 
            "       ",
            "       ",
        },
    },
    {
        name = "GiftWrapping_Red",
        filledCells = {
            " XXXXX ",
            "       ", 
            "       ",
            "       ", 
            "XXXXXXX", 
            "       ", 
            "       ", 
            "       ",
        },
    },

	-- Begin Michael Land 31 levels
	{
		name = "JewelryShop_steel",
		filledCells = {
			"       ", 
			"       ", 
			"X     X", 
			"       ", 
			"       ", 
			"X     X", 
			"       ", 
			"XXX XXX",
		},
	},
	{
		name = "JewelryShop_pattern",
		filledCells = {
			"       ", 
			"       ", 
			"  X X  ", 
			"       ", 
			" X X X ", 
			"       ", 
			"X     X", 
			"       ",
		},
	},
	{
		name = "PharaohsTreasure_rings",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"   X   ",
		},
	},
	{
		name = "PharaohsTreasure_crates",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"  X X  ",
		},
	},
	{
		name = "PharaohsTreasure_switch",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"   X   ", 
			"       ",
		},
	},
	{
		name = "PharaohsTreasure_amber",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"   X   ", 
			"  X X  ", 
			" X   X ",
		},
	},
	{
		name = "PharaohsTreasure_stone",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"   X   ", 
			"  X X  ", 
			" X   X ", 
			"X     X",
		},
	},
	{
		name = "FreeRefills_cup1",
		filledCells = {
			" XX   ", 
			" XX   ", 
			" XX   ", 
			" XX   ", 
			"      ", 
			"      ", 
			"      ", 
		},
	},
	{
		name = "FreeRefills_cup2",
		filledCells = {
			"   XX ", 
			"   XX ", 
			"   XX ", 
			"   XX ", 
			"      ", 
			"      ", 
			"      ", 
		},
	},
	{
		name = "FreeRefills_switches1",
		filledCells = {
			"      ", 
			"      ", 
			"X     ", 
			"      ", 
			"      ", 
			"      ", 
			"      ", 
		},
	},
	{
		name = "FreeRefills_switches2",
		filledCells = {
			"      ", 
			"      ", 
			"     X", 
			"      ", 
			"      ", 
			"      ", 
			"      ", 
		},
	},
	{
		name = "SayWhen_switches",
		filledCells = {
			"      ", 
			"     X", 
			"      ", 
			"      ", 
			"      ", 
			"      ", 
			"      ", 
		},
	},
	{
		name = "SayWhen_clear",
		filledCells = {
			"      ", 
			"      ", 
			"      ", 
			"      ", 
			"      ", 
			"      ", 
			"      ", 
		},
	},
	{
		name = "SayWhen_rings",
		filledCells = {
			"      ", 
			"      ", 
			"      ", 
			"XX    ", 
			"XX    ", 
			"XX    ", 
			"      ", 
		},
	},
	{
		name = "SayWhen_glass",
		filledCells = {
			"      ", 
			"      ", 
			"      ", 
			"  X   ", 
			"  X   ", 
			"  X   ", 
			"XX    ", 
		},
	},
	{
		name = "MountDoom_rings",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"X     X",
			"       ",
			"       ",
			" X   X ",
			"XX   XX",
			"X  X  X",
		},
	},
	{
		name = "MountDoom_lava",
		filledCells = {
			"   X   ",
			"   X   ",
			"  XXX  ",
			"  XXX  ",
			" XXXXX ",
			" XXXXX ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "MountDoom_stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
		},
	},
	-- End Michael Land 31 levels
    {
        name = "GarbagePile_side_switch",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
    {
        name = "GarbagePile_side_maker",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "    X  ",
        },
    },
    {
        name = "GarbagePile_side_burst",
        filledCells = {
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Amber",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
            "XX XX X",
            "    X  ",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Gifts",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
        },
    },
    {
        name = "GarbagePile_side_Ice",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "GarbagePile_side_Lava",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
        },
    },
    {
        name = "GarbagePile_side_Balloons",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
            "  X    ",
        },
    },
    {
        name = "GarbagePile_side_Crates",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X  X",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Treasure",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Stone1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Stone2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "  X    ",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Stone3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "GarbagePile_side_Blue",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X  X  ",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Green",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
            "    X  ",
            "       ",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Purple",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
            "       ",
            "  X    ",
        },
    },
    {
        name = "GarbagePile_side_Red",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X    X",
            "       ",
            "       ",
        },
    },
    {
        name = "GarbagePile_side_Yellow",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
        },
    },
	{
		name = "RecoveringPattern_Pattern",
		filledCells = {
			"       ", 
			" XXXXX ", 
			"   X   ", 
			" XXXXX ", 
			"   X   ", 
			" XXXXX ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "RecoveringPattern_Makers",
		filledCells = {
			" XXXXX ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
    {
        name = "RainbowStripe_side_Rings",
        filledCells = {
            "       ",
            "       ",
            "X  X  X",
            "X  X  X",
            "X  X  X",
            "X  X  X",
            "X  X  X",
            "X  X  X",
        },
    },
    {
        name = "RainbowStripe_side_Blue",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "X  X  X",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_side_Green",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "X  X  X",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_side_Purple",
        filledCells = {
            "       ",
            "       ",
            "X  X  X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_side_Red",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X  X  X",
        },
    },
    {
        name = "RainbowStripe_side_Yellow",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X  X  X",
            "       ",
            "       ",
        },
    },
    {
        name = "RainbowStripe_side_Orange",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X  X  X",
            "       ",
        },
    },
	{
		name = "TopHalf_Big",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerFloor_maker1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerFloor_maker2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "MakerFloor_maker3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
		},
	},
	{
		name = "8x7_Column1",
		filledCells = {
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
			"X      ",
		},
	},
	{
		name = "8x7_Column2",
		filledCells = {
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "8x7_Sides",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},

	{
		name = "9-4_Bomb_Inner",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},

	},
	{
		name = "9-4_Bomb_Middle",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "9-4_Bomb_OuterA",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			" X   X ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "9-4_Bomb_OuterB",
		filledCells = {
			"       ",
			"  X X  ",
			" X   X ",
			"       ",
			" X   X ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "10-4_Checkerboard",
		filledCells = {
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
		},
	},
	{
		name = "10-4_Blue",
		filledCells = {
			"     X ",
			"  X   X",
			" X     ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X    ",
		},
	},
	{
		name = "10-4_Green",
		filledCells = {
			" X     ",
			"X      ",
			"     X ",
			"      X",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "10-4_Purple",
		filledCells = {
			"       ",
			"    X  ",
			"       ",
			"X X    ",
			"       ",
			"       ",
			"     X ",
			"    X X",
		},
	},
	{
		name = "10-4_Red",
		filledCells = { 
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			" X   X ",
			"  X   X",
			"       ",
			"       ",
		},
	},
	{
		name = "10-4_Yellow",
		filledCells = { 
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"X   X  ",
			" X     ",
			"X      ",
		},
	},
	{
		name = "WhatsInTheBox_Barrels",
		filledCells = {
			"   X  ", 
			"      ", 
			" X    ", 
			"    X ", 
			"  X   ", 
			"     X", 
			"X     ", 
		},
	},
	{
		name = "11-4_Steel",
		filledCells = {
			"       ",
			"   X   ",
			"  X X  ",
			" X   X ",
			"X     X",
			"       ",
			"X XXX X",
			"       ",
		}
	},
	{
		name = "11-4_Lava",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		}
	},
	{
		name = "11-4_Jail",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			" X   X ",
		}
	},
	{
		name = "11-4_Blue",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"X X X X",
		}
	},
	{
		name = "11-4_Green",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
		}
	},
	{
		name = "13-4_Treasure",
		filledCells = {
			"   X   ",
		}
	},
	{
		name = "13-4_Rocks",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"  X X  ",
			"   X   ",
			"  X X  ",
			"  XXX  ",
		},
	},
	{
		name = "13-4_Orange",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "14-4_Reel",
		filledCells = {
			"XX   XX",
		}	
	},
	{
		name = "14-4_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
		}
	},
	{
		name = "14-4_Rocks",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
		}
	},
	{
		name = "14-4_Rainbow",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"       ",
		}
	},
	{
		name = "14-4_VineGen",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		}
	},
	{
		name = "BottomRow_Spot1_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "BottomRow_Spot2_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "BottomRow_Spot3_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "BottomRow_Spot4_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "BottomRow_Spot5_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "BottomRow_Spot6_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
		},
	},
	{
		name = "BottomRow_Spot7_Large",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "15-4_Vines",
		filledCells = {
			" XXXXX ",
			"XXXX XX",
			"XX XX X",
			"XXXXXXX",
		}
	},
	{
		name = "15-4_Coconuts",
		filledCells = {
			"X     X",
			"    X  ",
			"  X  X ",
		}
	},
	{
		name = "17-4_Reel",
		filledCells = {
			"XXX    ",
		}
	},
	{
		name = "17-4_Steel",
		filledCells = {
			"XXX    ",
			"  X    ",
			"  X    ",
			"       ",
			"  X    ",
			" XX    ",
			" XX    ",
			"       ",
		}
	},
	{
		name = "17-4_VineGen",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
		}
	},
	{
		name = "17-4_Fence",
		filledCells = {
			"       ",
			"X      ",
			"X      ",
			"X X    ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		}
	},
	{
		name = "17-4_Boss",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		}
	},
	{
		name = "17-4_Weapon",
		filledCells = {
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		}
	},
	{
		name = "17-4_Hp1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		}
	},
	{
		name = "17-4_Hp2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		}
	},
	{
		name = "17-4_Hp3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		}
	},
	{
		name = "17-4_Hp4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
		}
	},
	{
		name = "17-4_Hp5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
		}
	},
	{
		name = "17-4_Hp6",
		filledCells = {
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		}
	},
	{
		name = "18-4_Steel",
		filledCells = {
			"   X   ",
		},
	},
	{
		name = "18-4_Orange",
		filledCells = {
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "18-4_Yellow",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "18-4_Missing",
		filledCells = {
			"  X X  ",
			"       ",
			"  X X  ",
			"       ",
			"  X X  ",
			"       ",
			"  X X  ",
			"       ",
		},
	},
	{
		name = "18-4_Reel",
		filledCells = {
			"  XXX  ",
		},
	},

	{
		name = "SideShooter_Reel",
		filledCells = {
			"     XX",
		},
	},
	{
		name = "SideShooter_Fence",
		filledCells = {
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
		},
	},
	{
		name = "CombiLockSteel",
		filledCells = {
			"X  X  X",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "CombiLockSafe",
		filledCells = {
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "CombiLockWindows",
		filledCells = {
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "CombiLockLaser",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
		},
	},
	{
		name = "12RedBlue_Fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "12RedBlue_Barrel1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "12RedBlue_Barrel2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "12RedBlue_Barrel3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X X    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "12RedBlue_Barrel4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    X X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "IceLab_Type1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	--ICE LAB
	{
		name = "IceLab_Type2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX XXX",
			" XX XX ",
			"  XXX  ",
		},
	},
	{
		name = "IceLab_Type3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
		},
	},

	{
		name = "IceLab2_Type1",
		filledCells = {
			" X   X ",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XXXXXXX",
			"X XXX X",
			"       ",
		},
	},

	{
		name = "IceLab2_Type2",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"       ",
		},
	},

	{
		name = "IceLab2_Type4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},

	{
		name = "IceLab2_Type5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			" XX XX ",
		},
	},
	{
		name = "IceLab2_Type6",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			"       ",
			"       ",
		},
	},

	{
		name = "IceLab2_Type7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	
	{
		name ="IceLab2_Maker",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "IceLab2_Reel",
		filledCells = {
			"XX   XX",
		},
	},
	{
		name = "IceLab3_Ice",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX XX X",
			"XXXXX X",
			"XX XXXX",
		},
	},
	{
		name = "IceLab3_Type1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXX X",
			"XX XXXX",
		},
	},
	{
		name = "IceLab3_LaserH",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"  X    ",
		},
	},
	{
		name = "IceLab3_LaserV",
		filledCells = {
			"       ",
			"     X ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "IceLab3_Fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X  X ",
			"       ",
			"       ",
		},
	},
	{
		name = "IceLab3_IceMaker",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX XX X",
			"       ",
			"       ",
		},
	},
	{
		name = "RainbowSwitch_Switches",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "RainbowSwitch_InitialWilds",
		filledCells = {
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
			"   X   ",
			"X     X",
			"       ",
		},
	},
	{
		name = "Grinch_BedrockA",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X  ",
			"       ",
			"  X X X",
			"       ",
		},
	},
	{
		name = "Grinch_BedrockB",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			"       ",
			" X X X ",
			"       ",
		},
	},
	{
		name = "Grinch_Presents",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"X      ",
			"X      ",
			"       ",
		},
	},
	{
		name = "Large 0,0",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 0,1",
		filledCells = {
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 0,2",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 0,3",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 0,4",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 0,5",
		filledCells = {
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 0,6",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 1,0",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 1,1",
		filledCells = {
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 1,2",
		filledCells = {
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 1,3",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 1,4",
		filledCells = {
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 1,5",
		filledCells = {
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 1,6",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 2,0",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 2,1",
		filledCells = {
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 2,2",
		filledCells = {
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 2,3",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 2,4",
		filledCells = {
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 2,5",
		filledCells = {
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 2,6",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 3,0",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 3,1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 3,2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 3,3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 3,4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 3,5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 3,6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 4,0",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 4,1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 4,2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 4,3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 4,4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 4,5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 4,6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 5,0",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 5,1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 5,2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 5,3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 5,4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 5,5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 5,6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "Large 6,0",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "Large 6,1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
		},
	},
	{
		name = "Large 6,2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "Large 6,3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "Large 6,4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
		},
	},
	{
		name = "Large 6,5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
		},
	},
	{
		name = "Large 6,6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "Large 7,0",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "Large 7,1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "Large 7,2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "Large 7,3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "Large 7,4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "Large 7,5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
		},
	},
	{
		name = "Large 7,6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "DangerousChoice_Switch1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "DangerousChoice_Switch2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "DangerousChoice_Switch3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "DangerousChoice_Maker1",
		filledCells = {
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "DangerousChoice_Maker2",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "DangerousChoice_Maker3",
		filledCells = {
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "CallforBackup_Vines",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"  XXX  ", 
			"XXX XXX",  
			"X XXX X",
			"XXX XXX",  
			"X XXX X",
		},
	},
	{
		name = "CallforBackup_Missing",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			" X   X ",
			"   X   ",
			" X   X ",
		},
	},
	{
		name = "CallforBackup_Switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "CallforBackup_Maker",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "CallforBackup_Superwild",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PowerUp_Crates",
		filledCells = {
			"X     X", 
			"X     X", 
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PowerUp_Missing",
		filledCells = {
			" X   X ", 
			" X   X ", 
			"X     X", 
			"X     X", 
			"X     X", 
			"X     X", 
			"X     X", 
			"X     X", 
		},
	},

	-- Begin Daniel's patterns

	{
		name = "LightsOut_Makers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
		},
	},
	{
		name = "LightsOut_SwitchesOn",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X XX  X",
			"       ",
			"       ",
			"       ",
		},
	},
		{
		name = "LightsOut_SwitchesOff",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X  XX ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LightsOut_Locks",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LightsOut_GemEaters",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FilterMachine_Reel",
		filledCells = {
			"XX    ",
		},
	},
	{
		name = "FilterMachine_Steel",
		filledCells = {
			"X     ",
			"X     ",
			"X XXX ",
			" XX   ",
			" X    ",
			" X    ",
			"XX    ",
		},
	},
	{
		name = "FilterMachine_Eaters",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			"X     ",
			"      ",
		},
	},
	
	{
		name = "RainbowCycle_Makers",
		filledCells = {
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "RainbowCycle_Lasers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
		},
	},

	{
		name = "ColorSwap_LeftMakers",
		filledCells = {
			"XXX    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "ColorSwap_RightMakers",
		filledCells = {
			"    XXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "ColorSwap_Reel",
		filledCells = {
			"   X   ",
		}
	},

	{
		name = "ColorSwap_Missing",
		filledCells = {
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
		}
	},

	{
		name = "ColorSwap_Switches",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
		}
	},

	{
		name = "ColorSwap_Blue",
		filledCells = {
			"       ",
			"X      ",
			" X     ",
			"  X    ",
			"X      ",
			" X     ",
			"  X    ",
			"X      ",
		}
	},

	{
		name = "ColorSwap_Green",
		filledCells = {
			"       ",
			"  X    ",
			"X      ",
			" X     ",
			"  X    ",
			"X      ",
			" X     ",
			"  X    ",
		}
	},

	{
		name = "ColorSwap_Purple",
		filledCells = {
			"       ",
			" X     ",
			"  X    ",
			"X      ",
			" X     ",
			"  X    ",
			"X      ",
			"       ",
		}
	},
	
	{
		name = "ColorSwap_Red",
		filledCells = {
			"       ",
			"      X",
			"     X ",
			"    X  ",
			"      X",
			"     X ",
			"    X  ",
			"      X",
		}
	},

	{
		name = "ColorSwap_Yellow",
		filledCells = {
			"       ",
			"    X  ",
			"      X",
			"     X ",
			"    X  ",
			"      X",
			"     X ",
			"    X  ",
		}
	},
	
	{
		name = "ColorSwap_Orange",
		filledCells = {
			"       ",
			"     X ",
			"    X  ",
			"      X",
			"     X ",
			"    X  ",
			"      X",
			"       ",
		}
	},

	{
		name = "ColorSwap_Clear",
		filledCells = {
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
			"XXX XXX",
		},
	},

	{
		name = "HiddenSafe_Steel",
		filledCells = {
			"   X   ",
			"   X   ",
			"   X   ",
			"   X X ",
			"       ",
			"XXXX   ",
			" X X   ",
			"       ",
		},
	},

	{
		name = "HiddenSafe_Fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   XX X",
			"       ",
			"       ",
			" X X   ",
		},
	},

	{
		name = "HiddenSafe_Stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"X      ",
		},
	},

	{
		name = "HiddenSafe_Clear",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    XXX",
			"    XXX",
			"    X X",
		},
	},
	
	{
		name = "SafeBombs_Missing",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
			"XXX XXX",
		},
	},

	{
		name = "SafeBombs_Bombs",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
			"  X X  ",
			"   X   ",
		},
	},
	
	{
		name = "SafeBombs_SafeA",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
			"  X X  ",
			"   X   ",
			"       ",
		},
	},

	{
		name = "SafeBombs_SafeB",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X   X ",
			"  X X  ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeBombs_SafeC",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "ShrinkingSafes_SafeLayer1",
		filledCells = {
			"       ",
			"       ",
			" XXXXX ",
			" X   X ",
			" X   X ",
			" X   X ",
			" XXXXX ",
			"       ",
		},
	},
	
	{
		name = "ShrinkingSafes_SafeLayer2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "ShrinkingSafes_SafeLayer2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeBelt_1A",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X    ",
			" X X   ",
			"  X    ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeBelt_1B",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    X  ",
			"   X X ",
			"    X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "SmallRow_0",
		filledCells = {
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "SmallRow_1",
		filledCells = {
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SmallRow_2",
		filledCells = {
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},

	{
		name = "SmallRow_3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SmallRow_4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
		},
	},

	{
		name = "SmallRow_5",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "SmallRow_6", 
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "LargeRow_0", 
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LargeRow_1", 
		filledCells = {
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LargeRow_2", 
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LargeRow_3", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LargeRow_4", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LargeRow_5", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
		},
	},
	{
		name = "LargeRow_6", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "LargeRow_7", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},

	{
		name = "FavoriteLetter_R", 
		filledCells = {
			"       ",
			"XXXXXX ",
			"X    XX",
			"X XXX X",
			"X    XX",
			"X XX XX",
			"X XXX X",
			"XXX XXX",
		},
	},

	{
		name = "JammingMachine_GemEater1", 
		filledCells = {
			"       ",
			"   X   ",
			"  X X  ",
			" X   X ",
			"X     X",
			" X   X ",
			"  X X  ",
			"   X   ",
		},
	},
	{
		name = "JammingMachine_GemEater2", 
		filledCells = {
			"       ",
			"X     X",
			"   X   ",
			"  X X  ",
			" X   X ",
			"  X X  ",
			"   X   ",
			"X     X",
		},
	},
	{
		name = "JammingMachine_GemEater3", 
		filledCells = {
			"       ",
			" X   X ",
			"X     X",
			"   X   ",
			"  X X  ",
			"   X   ",
			"X     X",
			" X   X ",
		},
	},
	{
		name = "JammingMachine_GemEater4", 
		filledCells = {
			"       ",
			"  X X  ",
			" X   X ",
			"X     X",
			"       ",
			"X     X",
			" X   X ",
			"  X X  ",
		},
	},

	{
		name = "HighTideLowTide_1", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			"XXXXXXX",
			"XXXXXXX",
		},
	},

	{
		name = "HighTideLowTide_2", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X X X X",
			"XXXXXXX",
			"X X X X",
			"       ",
			"       ",
		},
	},

	{
		name = "HighTideLowTide_3", 
		filledCells = {
			"       ",
			" X   X ",
			"XXXXXXX",
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "HighTideLowTide_4", 
		filledCells = {
			"XXXXXXX",
			"X XXX X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "HighTideLowTide_Board", 
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	{
		name = "HighTideLowTide_Maker1", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
		},
	},
	{
		name = "HighTideLowTide_Maker2", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
		},
	},

	{
		name = "Large_CheckerA", 
		filledCells = {
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
		},
	},

	{
		name = "Large_CheckerB", 
		filledCells = {
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
			"X X X X",
			" X X X ",
		},
	},

	{
		name = "StoneEater_IceMakers", 
		filledCells = {
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StoneEater_TopGemEaters", 
		filledCells = {
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StoneEater_BottomGemEaters", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX XXX",
		},
	},

	{
		name = "PirateBattle_GemEaters", 
		filledCells = {
			"       ",
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"       ",
		},
	},
	{
		name = "PirateBattle_Steel", 
		filledCells = {
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
		},
	},
	{
		name = "PirateBattle_DownMakers", 
		filledCells = {
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PirateBattle_UpMakers", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "PirateBattle_Reels", 
		filledCells = {
			" X X X ",
		},
	},
	{
		name = "PirateBattle_BalloonColumns", 
		filledCells = {
			"       ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			"       ",
		},
	},

	{
		name = "LavaPiper_Steel", 
		filledCells = {
			" X   X ",
			" X   X ",
			" X     ",
			"     X ",
			" X     ",
			"     X ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "LavaPiper_NoMatch1", 
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "LavaPiper_Reel", 
		filledCells = {
			"XX   XX",
		},
	},
	{
		name = "LavaPiper_Window", 
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
		},
	},

	{
		name = "Minilab1_Missing",
		filledCells = {
			"XXXXXXX",
			"XXXXXXX",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"XXXXXXX",
		},
	},
	{
		name = "Minilab1_Maker1",
		filledCells = {
			"       ",
			"       ",
			"XXX    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Minilab1_Maker2",
		filledCells = {
			"       ",
			"       ",
			"    XXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	{
		name = "Minilab2_Missing",
		filledCells = {
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "Minilab2_Maker1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Minilab2_Maker2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"    XXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Minilab2_Maker3",
		filledCells = {
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	
	{
		name = "Minilab3_Missing",
		filledCells = {
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "Minilab3_Maker1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Minilab3_Maker2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"    XXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Minilab3_Maker3",
		filledCells = {
			"XXX    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Minilab3_Maker4",
		filledCells = {
			"    XXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	-- End Daniel's Patterns
	{
		name = "RingForService_Makers",
		filledCells = {
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RingForService_Switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "SkyScraper_Stone",
		filledCells = {
			"   X   ", 
			"   X   ", 
			"  X X  ",
			"  X X  ",
			"  X X  ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "SkyScraper_TripleStone",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "SkyScraper_Glass",
		filledCells = {
			"       ", 
			"   X   ", 
			"       ",
			"  XXX  ",
			"       ",
			" XXXXX ",
			"       ",
			" XXXXX ",
		},
	},
	{
		name = "SkyScraper_Pattern",
		filledCells = {
			"   X   ", 
			"   X   ", 
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			" XXXXX ",
			" XXXXX ",
			" XXXXX ",
		},
	},
	{
		name = "RailroadTracks_Stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X X X ",
			" X X X ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RailroadTracks_TripleStone",
		filledCells = {
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
		},
	},
	{
		name = "RailroadTracks_Glass",
		filledCells = {
			"       ", 
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RailroadTracks_Pattern",
		filledCells = {
			"       ", 
			"       ", 
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"       ", 
			"       ", 
		},
	},
	{
		name = "PickaxeFactory_Maker",
		filledCells = {
			"       ", 
			"      X", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PickaxeFactory_PrimarySwitch",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"X      ", 
		},
	},
	{
		name = "PickaxeFactory_Bedrock1",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"X      ", 
			" X     ", 
			"X      ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PickaxeFactory_Bedrock2",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"      X", 
			"     X ", 
		},
	},
	{
		name = "PickaxeFactory_Bedrock3",
		filledCells = {
			"     X ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PickaxeFactory_Bedrock4",
		filledCells = {
			" X X   ", 
			"  X    ",  
			"       ",
			"       ",
			"       ",
			"       ",
			"       ", 
			"       ",
		},
	},
	{
		name = "PickaxeFactory_Bedrock5",
		filledCells = {
			"       ", 
			"       ", 
			"    X  ",  
			"   X X ", 
			"    X  ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PickaxeFactory_SecondarySwitch1",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"X      ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PickaxeFactory_SecondarySwitch2",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"      X", 
		},
	},
	{
		name = "PickaxeFactory_SecondarySwitch3",
		filledCells = {
			"      X", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PickaxeFactory_SecondarySwitch4",
		filledCells = {
			"  X    ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "PickaxeFactory_SecondarySwitch5",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"    X  ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "IceLab_Type1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
			"XXXXXXX",
		},
	},
	--ICE LAB
	{
		name = "IceLab_Type2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX XXX",
			" XX XX ",
			"  XXX  ",
		},
	},
	{
		name = "IceLab_Type3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
		},
	},

	{
		name = "IceLab2_Type1",
		filledCells = {
			" X   X ",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XX   XX",
			"XXXXXXX",
			"X XXX X",
			"       ",
		},
	},

	{
		name = "IceLab2_Type2",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"       ",
		},
	},

	{
		name = "IceLab2_Type4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},

	{
		name = "IceLab2_Type5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			" XX XX ",
		},
	},
	{
		name = "IceLab2_Type6",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			"       ",
			"       ",
		},
	},

	{
		name = "IceLab2_Type7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	
	{
		name ="IceLab2_Maker",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "IceLab2_Reel",
		filledCells = {
			"XX   XX",
		},
	},
	{
		name = "IceLab3_Ice",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX XX X",
			"XXXXX X",
			"XX XXXX",
		},
	},
	{
		name = "IceLab3_Type1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXX X",
			"XX XXXX",
		},
	},
	{
		name = "IceLab3_LaserH",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"  X    ",
		},
	},
	{
		name = "IceLab3_LaserV",
		filledCells = {
			"       ",
			"     X ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "IceLab3_Fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X  X ",
			"       ",
			"       ",
		},
	},
	{
		name = "IceLab3_IceMaker",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX XX X",
			"       ",
			"       ",
		},
	},
	{
		name = "AmberLab1_Cloudy",
		filledCells = {
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
		},
	},
	{
		name = "AmberLab1_Stone",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "AmberLab1_Amber",
		filledCells = {
			" XXXX ",
			"  XX  ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
			"XXXXXX",
		},
	},
	{
		name = "AmberLab2_Cloudy",
		filledCells = {
			"  XXX  ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
		},
	},
	{
		name = "AmberLab2_Stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AmberLab2_Jails",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "AmberLab2_Amber",
		filledCells = {
			" XXXXX ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
			"XXXXXXX",
		},
	},
	{
		name = "AmberLab3_Stone",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "AmberLab3_JailsBlue",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "AmberLab3_JailsPurple",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "AmberLab3_JailsRed",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"    X  ",
			"       ",
		},
	},
	{
		name = "AmberLab3_JailsYellow",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "AmberLab3_AmberBlue",
		filledCells = {
			" X     ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"X      ",
			" X     ",
			"     X ",
		},
	},
	{
		name = "AmberLab3_AmberGreen",
		filledCells = {
			"     X ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"   X  X",
		},
	},
	{
		name = "AmberLab3_AmberPurple",
		filledCells = {
			"   X   ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"X      ",
		},
	},
	{
		name = "AmberLab3_AmberRed",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"  X    ",
		},
	},
	{
		name = "AmberLab3_AmberYellow",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			" X  X  ",
		},
	},
	-- Burst Lab patterns
	{
		name = "BurstLab_StripesOut",
		filledCells = {
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "BurstLab_StripesIn",
		filledCells = {
			"      ",
			" XXXX ",
			"      ",
			" XXXX ",
			"      ",
			" XXXX ",
			"      ",
		},
	},
	{
		name = "BurstMissingCorners",
		filledCells = {
			"XX  XX",
			"X    X",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
		},
	},
	{
		name = "MissingOuter2",
		filledCells = {
			"X    X",
		},
	},
	{
		name = "OutsidesOfDiamond",
		filledCells = {
			"      ",
			" X  X ",
			"X    X",
			"X    X",
			"XX  XX",
			" X  X ",
			"      ",
		},
	},
	{
		name = "BurstLab_SideStripes",
		filledCells ={
			"XX    ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"     X",
			"    XX",
		},
	},
	{
		name = "BurstLabBig_MissingSquares",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "BurstLabBig_MissingReels",
		filledCells = {
			"XX   XX",
		},
	},
	{
		name = "BurstLabBig_Patterns",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	{
		name = "BurstLabBig_Stones",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	-- End BurstLab patterns

	--Begin LavaLab Patterns
	{
		name = "LavaLab1_Crates",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			"  X   ",
			"   X  ",
			"    X ",
			"      ",
		},
	},
	{
		name = "LavaLab1_Lava",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X     ",
			"XX   ",
			"XXX   ",
			"XXXX  ",
		},
	},
	{
		name = "LavaLab2_Stones",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"      ",
			"      ",
		},
	},
	{
		name = "LavaLab2_Lava",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XX    ",
			" XX   ",
			"X XX  ",
			"XXXX  ",
		},
	},
	{
		name = "LavaLab2_Bombs",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			" X    ",
			"      ",
		},
	},
	{
		name = "LavaLab3_Stones",
		filledCells = {
			"       ",
			"       ",
			"  X    ",
			"   X   ",
			"    X  ",
			"     X ",
			"       ",
			"       ",
		},
	},
	{
		name = "LavaLab3_Lava",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"XX     ",
			"X X    ",
			"XX X   ",
			"XXX X  ",
			"XXXXXX ",
		},
	},
	{
		name = "LavaLab3_Bombs",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"  X    ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "LavaLab3_Maker",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	--End LavaLab Patterns
	--Bomb Lab patterns
	{
		name = "BombLab1_JailedBombs",
		filledCells = {
			"       ",
			"   X   ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "BombLab2_Bombs",
		filledCells = {
			"       ",
			" X     ",
			"   X   ",
			"   X   ",
			"       ",
			"  X  X ",
			"    X  ",
			"      X",
		},
	},
	{
		name = "BombLab2_GemEaters",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "BombLab2_Makers",
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	--End Bomb Lab Patterns
	--Gem Eater Lab patterns
	{
		name = "GemEaterLab1_GemEaters",
		filledCells = {
			"X X X ",
			"      ",
			" X X X",
			"      ",
			"X X X ",
			"      ",
			" X X X",
		},
	},
	{
		name = "GemEaterLab2_Fences",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"X    X",
			"      ",
			"      ",
		},
	},
	{
		name = "GemEaterLab2_GemEaters",
		filledCells = {
			"      ",
			"      ",
			" X  X ",
			"      ",
			"  XX  ",
			" X  X ",
			"      ",
		},
	},
	{
		name = "GemEaterLab2_Steel",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "GemEaterLab3_GemEaters",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
		},
	},
	{
		name = "GemEaterLab3_Makers",
		filledCells = {
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "GemEaterLab3_Stones",
		filledCells = {
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
			" X  X ",
		},
	},
	{
		name = "GemEaterLab3_ThickStones",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"X    X",
		}
	},
	--End Gem Eater Lab patterns
	--Begin Four Elements patterns
	{
		name = "FourElementsLab1_Lava",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			"XX    ",
		},
	},
		{
		name = "FourElementsLab1_Ice",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
			"    XX",
		},
	},
	{
		name = "FourElementsLab1_Balloons",
		filledCells = {
			"      ",
			"      ",
			"XX  XX",
			"XX  XX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "FourElementsLab2_Boulders",
		filledCells = {
			"XX  XX",
			"XX  XX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "FourElementsLab2_Lava",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXX   ",
			"XXX   ",
		},
	},
	{
		name = "FourElementsLab2_Ice",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"   XXX",
			"   XXX",
		},
	},
	{
		name = "FourElementsLab2_Balloons",
		filledCells = {
			"      ",
			"      ",
			"XX  XX",
			"XX  XX",
			"XX  XX",
			"      ",
			"      ",
		},
	},
	{
		name = "FourElementsLab3_Boulders",
		filledCells = {
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "FourElementsLab3_Lava",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" XX   ",
			" XX   ",
			" XX   ",
		},
	},
	{
		name = "FourElementsLab3_Ice",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"   XX ",
			"   XX ",
			"   XX ",
		},
	},
	{
		name = "FourElementsLab3_Balloons",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"X    X",
			"X    X",
			"X    X",
			"      ",
		},
	},
	--End Four Elements patterns
	--Begin Hole Lab Patterns
		{
		name = "HoleLab1_Missing",
		filledCells = {
			"XXXXXXX",
			"X     X",
			"       ",
			"  X X  ",
			"       ",
			"  X X  ",
			"       ",
			"X     X",
		},
	},
	{
		name = "HoleLab1_Cloudy",
		filledCells = {
			"       ",
			" XX XX ",
			"X     X",
			"X  X  X",
			"  X X  ",
			"X  X  X",
			"X     X",
			" XX XX ",
		},
	},
	{
		name = "HoleLab2_Missing",
		filledCells = {
			"XXXXXXX",
			"X X   X",
			"       ",
			"  X X X",
			"       ",
			"X X X  ",
			"       ",
			"X   X X",
		},
	},
	{
		name = "HoleLab2_Cloudy",
		filledCells = {
			"       ",
			" X XXX ",
			"XX   XX",
			"X  X   ",
			"X XXX X",
			"   X  X",
			"XX   XX",
			" XXX X ",
		},
	},
	{
		name = "HoleLab3_Missing",
		filledCells = {
			"XXXXXXX",
			"X X X X",
			"       ",
			"X X X X",
			"       ",
			"X X X X",
			"       ",
			"X X X X",
		},
	},
	{
		name = "HoleLab3_Cloudy",
		filledCells = {
			"       ",
			" X X X ",
			"XXXXXXX",
			" X X X ",
			"XXXXXXX",
			" X X X ",
			"XXXXXXX",
			" X X X ",
		},
	},
	{
		name = "HoleLab3_MissingReels",
		filledCells = {
			"  X X  ",
		},
	},
	--End Hole Lab patterns
	--Coconut Lab patterns
	{
		name = "CoconutLab1_Coconut",
		filledCells = {
			"      ",
			" X    ",
			"    X ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "CoconutLab3_Coconut",
		filledCells = {
			"      ",
			" X    ",
			"    X ",
			"   X  ",
			"      ",
			"      ",
		},
	},
	--End Coconut Lab Patterns
	{
		name = "DucksInARow_Left1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
		},
	},
	{
		name = "DucksInARow_Left2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" XX   ",
			"      ",
		},
	},
	{
		name = "DucksInARow_Left3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXX   ",
		},
	},
	{
		name = "DucksInARow_Right1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "DucksInARow_Right2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"   XX ",
			"      ",
		},
	},
	{
		name = "DucksInARow_Right3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"   XXX",
		},
	},
	{
		name = "PandorasSwitches_pattern2",
		filledCells = {
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "PandorasSwitches_pattern",
		filledCells = {
			"       ",
			" X   X ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
		},
	},
	--Begin Randi Land 33
	{
		name = "CodenameRainbow_Safe",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	
	},
	{
		name = "CodenameRainbow_MissingSquares",
		filledCells = {
			"XXXXXXX",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "CodenameRainbow_MissingReels",
		filledCells = {
			"X     X",
		},
	},
	{
		name = "GatheringSupplies_BlueBedrock",
		filledCells = 
		{
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
		},
	},
	{
		name = "GatheringSupplies_BlueSafe",
		filledCells = {
			"      ",
			"      ",
			"    X ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "GatheringSupplies_GreenSafe",
		filledCells = {
			"  X   ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "GatheringSupplies_GreenBedrock",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			" X    ",
		},
	},
	{
		name = "GatheringSupplies_PurpleSafe",
		filledCells = {
			"      ",
			"      ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "GatheringSupplies_PurpleBedrock",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"     X",
		},
	},
	{
		name = "GatheringSupplies_RedSafe",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
		},
	},
	{
		name = "GatheringSupplies_RedBedrock",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe1",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe2",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe3",
		filledCells= {
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe4",
		filledCells = {
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},	
	},
	{
		name = "GatheringSuppliesNew_Safe5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe8",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe9",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "GatheringSuppliesNew_Safe10",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "HatchingAPlan_Makers",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Chests",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Fences",
		filledCells = {
			"       ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
			" X     ",
		},
	},
	{
		name = "HatchingAPlan_MissingReels",
		filledCells = {
			"XX     ",
		},
	},
	{
		name ="HatchingAPlan_Tier1Safe1",
		filledCells={
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier1Safe2",
		filledCells={
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier1Safe3",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier1Safe4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier2Safe1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier2Safe2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier2Safe3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier2Safe4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier2Safe5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier3Safe1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "HatchingAPlan_Tier3Safe2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},

	{
		name = "StepByStepByStep_Tier1Jail",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XX  XX",
		},
	},
	{
		name = "StepByStepByStep_Tier2Jail",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  XX  ",
		},
	},
	{
		name = "StepByStepByStep_Safe3",
		filledCells = {
			"      ",
			"      ",
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "StepByStepByStep_Safe4",
		filledCells = {
			"      ",
			"      ",
			"    X ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "StepByStepByStep_Safe5",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"  X   ",
			"      ",
			"      ",
		},
	},
	{
		name = "StepByStepByStep_Safe6",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"   X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "AtBay_Vines",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_Lava",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX     ",
			"XX     ",
		},
	},
	{
		name = "AtBay_Ice",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     XX",
			"     XX",
		},
	},
	{
		name = "AtBay_VineSafe1",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_VineSafe2",
		filledCells = {
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_VineSafe3",
		filledCells = {
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_VineSafe4",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_VineSafe5",
		filledCells = {
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_VineSafe6",
		filledCells = {
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_VineSafe7",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_LavaSafe1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_LavaSafe2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_LavaSafe3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_LavaSafe4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "AtBay_LavaSafe5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "AtBay_IceSafe1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "AtBay_IceSafe2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
		}, 
	},
	{
		name = "AtBay_IceSafe3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_IceSafe4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
		},
	},
	{
		name = "AtBay_IceSafe5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	{
		name = "SurpriseParole_StonesTopRow",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SurpriseParole_Locks",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			"X     X",
			"X X X X",
		},
	},
	{
		name = "SurpriseParole_Stones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			" X   X ",
		},
	},
	{
		name = "SurpriseParole_Safe",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	--End Randi Land 33
	--Begin Brooke land 33
	{
		name = "StrongArm_Safe1",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StrongArm_Safe2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StrongArm_Safe3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "StrongArm_Stones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			" XX XX ",
			"       ",
			"XX   XX",
		},
	},
	{
		name = "StrongArm_Stones3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"   X   ",
			"       ",
			"  XXX  ",
		},
	},
	{
		name = "StrongArm_Jails",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			" XX XX ",
			"       ",
		},
	},
	{
		name = "StrongArm_Cloudy",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			"  XXX  ",
			" XXXXX ",
			" XXXXX ",
			"XXXXXXX",
		},
	},
	{
		name = "Trespasser_Fence",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Trespasser_Steel",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	{
		name = "Trespasser_Locks",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X X X ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
		},
	},
	{
		name = "Trespasser_GemEaters",
		filledCells = {
			"       ",
			"       ",
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "Hustle_Missing",
		filledCells = {
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	{
		name = "Hustle_Steel",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X     ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "Hustle_Locks",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
			"  XXX  ",
		},
	},
	{
		name = "Hustle_GemEaters",
		filledCells = {
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Hustle_Stones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Hustle_Switch1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeInside_Missing",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "SafeInside_Steel",
		filledCells = {
			"XX   XX",
			"X     X",
			"       ",
			"       ",
			"       ",
			"X     X",
			"XX   XX",
			"       ",
		},
	},
	{
		name = "SafeInside_Safe1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeInside_Safe2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeInside_Pickaxe",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeInside_BedrockRed",
		filledCells = {
			"       ",
			"       ",
			"X      ",
			"X      ",
			"X      ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeInside_BedrockPurple",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "SafeInside_BedrockBlue",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"      X",
			"      X",
			"       ",
			"       ",
			"       ",
		},
	},
	--end Brooke land 33
	--Begin Josh Land 33
	{
		name = "SafeTreasure_Safes",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SafeTreasure_Chests",
		filledCells = {
			"      ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "DangerSafes_Safes",
		filledCells = {
			"       ",
			" X X X ",
			"       ",
			"  X X  ",
			"       ",
			"X  X  X",
			"       ",
			"       ",
		},
	},
	{
		name = "LaserField_Jails",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},
	{
		name = "LaserField_MissingSquares",
		filledCells = {
			" X   X ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "LaserField_Safe1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
		},
	},
	{
		name = "LaserField_Safe2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LaserField_Safe3",
		filledCells = {
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LaserField_Steel",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			"       ",
			"X     X",
			"X     X",
			"       ",
			"X     X",
		},
	},
	{
		name = "LaserField_MissingReels",
		filledCells = {
			"X     X",
		},
	},
	{
		name = "JungleSafes_Safes",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"       ",
		},
	},
	{
		name = "JungleSafes_Vines",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
			" X X X ",
			"XXXXXXX",
		},
	},
	{
		name = "GreatEscape_Fences",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
		},
	},
	{
		name = "GreatEscape_Makers1",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "GreatEscape_MissingReel",
		filledCells = {
			"XX   XX",
		},
	},
	{
		name = "GreatEscape_Rings",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
		},
	},
	{
		name = "BigHeist_Safe",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "BigHeist_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXX   ",
			"   X   ",
			"   X   ",
			"  XXXXX",
			"  X X  ",
		},
	},
	{
		name = "BigHeist_Switch1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
		},
	},
	{
		name = "BigHeist_Switch2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "BigHeist_Switch3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigHeist_RemoveSteel1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     XX",
			"       ",
		},
	},
	{
		name = "BigHeist_RemoveSteel2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
		},
	},
	{
		name = "BigHeist_RemoveSteel3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXXX   ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigHeist_Locks",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"    XX ",
			"     X ",
			"XX     ",
			"X      ",
		},
	},
	{
		name = "BigHeist_Jails1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"    XXX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigHeist_Jails2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"XXX    ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "BigHeist_Clear",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX    ",
			"XXX    ",
			"       ",
			"     X ",
		},
	},
	
	--End Josh Land 33
	--begin Jonathan land 33
	{
		name = "LaserProof_Lasers",
		filledCells = {
			"       ",
			" X     ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
		},
	},
	{
		name = "LaserProof_Safes",
		filledCells = {
			"       ",
			"     X ",
			"     X ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
		},
	},
	{
		name = "LaserProof_Steel",
		filledCells = {
			"     XX",
			"       ",
			"       ",
			"     XX",
			"X     X",
			"XX     ",
			"       ",
			"XX     ",
		},
	},
	{
		name = "LaserProof_Stones",
		filledCells = {
			"       ",
			"      X",
			"      X",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "RemoteSafe_Safe",
		filledCells = {
			"X     X", 
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RemoteSafe_Missing",
		filledCells = {
			" X   X ", 
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "RemoteSafe_Switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{
		name = "RemoteSafe_Maker",
		filledCells = {
			"   X   ", 
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},

	--end Jonathan land 33
    --begin Roh Land 33
    {
        name = "BigStruggle_Safe1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
            "       ",
        },
    },
    {
        name = "BigStruggle_Safe2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
            "       ",
        },
    },
    {
        name = "BigStruggle_Safe3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "    X  ",
            "       ",
        },
    },
    {
        name = "BigStruggle_Safe4",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
        },
    },
    {
        name = "BigStruggle_Switch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "BigStruggle_Form1",
        filledCells = {
            "       ",
            "       ",
            "X X X X",
            "XXXXXXX",
            "XXXXXXX",
            "XXX XXX",
            "XX   XX",
            "XXX XXX",
        },
    },
    {
        name = "BigStruggle_Form2",
        filledCells = {
            "XXX XXX",
            "X X X X",
            "XX   XX",
            "       ",
            "   X   ",
            "  X X  ",
            " X   X ",
            "  X X  ",
        },
    },
    {
        name = "BigStruggle_Form2_Eyes",
        filledCells = {
            "       ",
            " X   X ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "BigStruggle_Form3",
        filledCells = {
            " XXXXX ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            " X   X ",
            " X   X ",
            " X   X ",
        },
    },
    {
        name = "BigStruggle_Form3_Eyes",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
        },
    },
    {
        name = "BigStruggle_Clear",
        filledCells = {
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXX XXX",
            "XX   XX",
            "XXX XXX",
        },
    },
    {
        name = "TripWire_Safe1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "TripWire_Switch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "     X ",
        },
    },
    {
        name = "TripWire_Switch2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
        },
    },
    {
        name = "TripWire_Switch3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "    X  ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TripWire_Switch4",
        filledCells = {
            "       ",
            "       ",
            "X      ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TripWire_Switch5",
        filledCells = {
            "      X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "TripWire_Switch6",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
            "       ",
            "       ",
        },
    },
    {
        name = "TripWire_ColorBarrels",
        filledCells = {
            "      X",
            "X      ",
            "       ",
            "   X   ",
            "      X",
            "  X    ",
            "       ",
            "       ",
        },
    },
    {
        name = "TripWire_Lava",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "  X    ",
            " XXX   ",
            "  X    ",
            "       ",
        },
    },
    {
        name = "TripWire_Amber",
        filledCells = {
            "       ",
            "    X  ",
            "   XXX ",
            "  XXXXX",
            "   XXX ",
            "    X  ",
            "       ",
            "       ",
        },
    },
    {
        name = "TripeWire_StoneWalls",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "XXXXXXX",
            "       ",
        },
    },
    --End Roh Land 33
	--Begin Michael Land 33
	{
        name = "CutToTheChase_reels",
        filledCells = {
            "   X   ",
        },
    },
	{
        name = "CutToTheChase_stones",
        filledCells = {
            "       ",
            "       ",
            "     X ",
            "       ",
            "       ",
            " X     ",
            "       ",
            "       ",
        },
    },
	{
        name = "CutToTheChase_steel",
        filledCells = {
            "       ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
            "   X   ",
        },
    },
	{
        name = "CutToTheChase_ice",
        filledCells = {
            "       ",
            "       ",
            " X     ",
            " X     ",
            "       ",
            "     X ",
            "     X ",
            "       ",
        },
    },
	{
        name = "CutToTheChase_safe",
        filledCells = {
            "       ",
            " X     ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
	--End Michael Land 33
	--Begin Randi Land 34 
	{
		name = "Turnover_GemEaters",
		filledCells = {
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
			"XXXXXX",
		},
	},
	{
		name = "EmptyTheTraps_GemEaters",
		filledCells = {
			"   X   ",
			" X   X ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"  X X  ",
			"   X   ",
		},
	},
	{
		name = "EmptyTheTraps_Switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "EmptyTheTraps_InitialInedibles",
		filledCells = {
			" X X X ",
			" X   X ",
			"X     X",
			"X     X",
			"       ",
			" X   X ",
			"  XXX  ",
			"   X   ",
		},
	},
	{
		name = "BreachTheHull_GemEater",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "BreachTheHull_Stones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			" XX XX ",
		},
	},
	{
		name = "BreachTheHull_Crates",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			" XXXXX ",
			"XX   XX",
			"X     X",
		},
	},
	{
		name = "PlunderingRings_GemEater1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" XXXX ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "PlunderingRings_GemEater2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "DropTheAnchor_switch",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "DropTheAnchor_stage1",
		filledCells = {
			"   X   ",
			"  X X  ",
			"   X   ",
			"   X   ",
			"   X   ",
			"X  X  X",
			" X X X ",
			"  XXX  ",
		},
	},
	{
		name = "DropTheAnchor_removeStage1",
		filledCells = {
			"   X   ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
			"  X X  ",
		},
	},
	{
		name = "DropTheAnchor_stage2",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			"   X   ",
			"   X   ",
			"   X   ",
			"X  X  X",
			" X X X ",
		},
	},
	{
		name = "DropTheAnchor_removeStage2",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"X     X",
			" X   X ",
		},
	},
	{
		name = "DropTheAnchor_stage3",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"   X   ",
			"   X   ",
			"   X   ",
			"X  X  X",
		},
	},
	{
		name = "DropTheAnchor_removeStage3",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "DropTheAnchor_stage4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "DropTheAnchor_removeStage4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "DropTheAnchor_stage5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "DropTheAnchor_removeStage5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "DropTheAnchor_stage6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"   X   ",
		},
	},
	{
		name = "DropTheAnchor_removeStage6",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
			"       ",
		},
	},
	{
		name = "DropTheAnchor_stage7",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"  X X  ",
		},
	},
	{
		name = "DropTheAnchor_stage8",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "DropTheAnchor_stage9",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "DropTheAnchor_AreaBurst",
		filledCells = {
			"  X X  ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LavaLevel_GemEater",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "LavaLevel_Lava",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "LavaLevel_Switch1",
		filledCells = {
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "LavaLevel_Switch2",
		filledCells = {
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "LavaLevel_Boulders1",
		filledCells = {
			"  X   ",
			"      ",
			"     X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "LavaLevel_Boulders2",
		filledCells = {
			"   X  ",
			"      ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	--End Randi Land 34
	--Brooke Land 34
	{
		name = "SharkBait_GemEaters1",
		filledCells = {
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "SharkBait_GemEaters2",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "SharkBait_GemEaters3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
			"      ",
		},
	},
	{
		name = "SharkBait_Stones1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			" X  X ",
			"  XX  ",
		},
	},
	{
		name = "SharkBait_Stones2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X    X",
			"XX  XX",
		},
	},
	{
		name = "FeedingTime_Missing",
		filledCells = {
			"X     X",
			"       ",
			" XX XX ",
			"   X   ",
			"       ",
			"X     X",
			"X     X",
			"XX   XX",
		},
	},
	{
		name = "FeedingTime_GemEaters1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "FeedingTime_GemEaters2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "FeedingTime_InedibleGems",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"  X X  ",
			"  X X  ",
			"       ",
		},
	},
	{
		name = "Goldfishing_Maker",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			"      ",
		},
	},
	{
		name = "Goldfishing_Reels",
		filledCells = {
			"X     ",
		},
	},
	{
		name = "Goldfishing_Missing",
		filledCells = {
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"XXXXXX",
			"      ",
			"      ",
		},
	},
	{
		name = "Goldfishing_Laser1",
		filledCells = {
			"  X   ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Goldfishing_Laser2",
		filledCells = {
			"    X ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "Goldfishing_Oranges",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"  X X ",
			"      ",
		},
	},
	{
		name = "FaultySieve_Steel",
		filledCells = {
			" X X X ",
			"X X X X",
			" X X X ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "FaultySieve_Eaters",
		filledCells = {
			"X X X X",
			" X X X ",
			"X X X X",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	--End Brooke Land 34

	--3 gem eaters that are all on different periods-- 2, 3, 5 turns. 
	{ 
		name = "Timing_Maker",
		filledCells = {
			"     X ", 
			"       ",  
			"       ",  
			"       ",  
			"       ",  
			"       ",  
			"       ",  
			"       ",  
		},
	},
	{ 
		name = "Timing_Steel",
		filledCells = {
			"    X X",
			"    X X",
			"    XX ",
			"    X  ",
			"    XX ",
			"    X  ",
			"    XX ",
			"    X  ",
		},
	},
	{ 
		name = "Timing_BasicGemEaters",
		filledCells = {
			"       ",
			"     X ",
			"       ",
			"     X ",
			"       ",
			"     X ",
			"       ",
			"     X ",
		},
	},
	{ 
		name = "Timing_StaggeredEater1",
		filledCells = {
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{ 
		name = "Timing_StaggeredEater2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
		},
	},
	{ 
		name = "Timing_StaggeredEater3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{ 
		name = "Timing_StaggeredMaker1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{ 
		name = "Timing_StaggeredMaker2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	{ 
		name = "Timing_StaggeredMaker3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},
	{ 
		name = "Timing_Switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	--Begin Josh Land 34
	{
		name = "CannonBall_Makers",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "CannonBall_GemEaters",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
		},
	},
	{
		name = "HungryChest_GemEaters",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},
	{
		name = "HungryChest_Fences",
		filledCells = {
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "HungryChest_MissingReel",
		filledCells = {
			"XX   XX",
		},
	},
	{
		name = "HungryChest_SteelGems",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"       ",
		},
	},
	{
		name = "HungryChest_Steel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XXXXXXX",
		},
	},
	{
		name = "XSpot_AmberTreasure",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "XSpot_BluePickaxeBarrel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "XSpot_BlueBedRock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XXX  ",
			"  X X  ",
			"  XXX  ",
			"       ",
			"       ",
		},
	},
	{
		name = "XSpot_RedPickaxeBarrel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "XSpot_RedBedRock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X     ",
			"X      ",
		},
	},
	{
		name = "XSpot_GreenPickaxeBarrel",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "XSpot_GreenBedRock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     X ",
			"      X",
		},
	},
	{
		name = "XSpot_PurplePickaxeBarrel",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "XSpot_PurpleBedRock",
		filledCells = {
			"       ",
			"X     X",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "XSpot_Crates",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"XX   XX",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "XSpot_Stones",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
			"XX   XX",
			"       ",
			"       ",
		},
	},
	{
		name = "XSpot_Boulders",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"XXX XXX",
		},
	},
	{
		name = "XSpot_Clear",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "ClearPath_Vines",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			" X X X ",
			"  X X  ",
			" X X X ",
			"  X X  ",
			"       ",
		},
	},
	{
		name = "ClearPath_SteelBoulders",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"  X X  ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "ClearPath_GemEaters",
		filledCells = {
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SaveTheBooty_Makers1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "SaveTheBooty_Makers2",
		filledCells = {
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SaveTheBooty_Balloons",
		filledCells = { 
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
			"       ",
		},
	},
	{
		name = "SaveTheBooty_MissingSquares",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
			"X     X",
			"       ",
		},
	},
	{
		name = "SaveTheBooty_GemEaters1",
		filledCells = {
			"       ", 
			"X     X", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "SaveTheBooty_GemEaters2",
		filledCells = {
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			"       ", 
			" X   X ", 
		},
	},
	{
		name = "SaveTheBooty_GemEaters3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  XXX  ",
		},
	},
	{
		name = "SaveTheBooty_GemEaters4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SaveTheBooty_GemEaters5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
			"       ",
		},
	},
	{
		name = "SaveTheBooty_Oranges",
		filledCells = {
			"       ", 
			"X     X", 
			"       ", 
			"      X", 
			"       ", 
			"X      ", 
			"       ", 
			"       ", 
		},
	},
	{
		name = "SaveTheBooty_Bursts",
		filledCells = {
			"       ",
			"       ",
			"     X ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
		}
	},
	{
		name = "SaveTheBooty_MissingReels",
		filledCells = {
			"XX   XX",
		},
	},
	{
		name = "SaveTheBooty_Steel",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TidalWave_GemEaters1",
		filledCells = {
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
			"X     ",
		},
	}, 
	{
		name = "TidalWave_GemEaters2",
		filledCells = {
			" X    ",
			" X    ",
			" X    ",
			" X    ",
			" X    ",
			" X    ",
			" X    ",
		},
	},
	{
		name = "TidalWave_GemEaters3",
		filledCells = {
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
			"  X   ",
		},
	},
	{
		name = "TidalWave_GemEaters4",
		filledCells = {
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
			"   X  ",
		},
	},
	{
		name = "TidalWave_GemEaters5",
		filledCells = {
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
		},
	},
	{
		name = "TidalWave_GemEaters6",
		filledCells = {
			"     X",
			"     X",
			"     X",
			"     X",
			"     X",
			"     X",
			"     X",
		},
	},
	{
		name = "TidalWave_Makers",
		filledCells = {
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "DavyJones_GemEaters1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X X X ",
			" X X X",
		},
	},
	{
		name = "DavyJones_GemEaters2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X X X ",
			"      ",
		},
	},
	{
		name = "DavyJones_GemEaters3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" X X X",
			"      ",
			"      ",
		},
	},
	{
		name = "DavyJones_ArmouredGems",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			" X X X",
			"X X X ",
			" X X X",
		},
	},
	{
		name = "RisingTide_GemEaters1",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
		},
	},
	{
		name = "RisingTide_GemEaters2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
		},
	},
	{
		name = "RisingTide_GemEaters3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
		},
	},
	{
		name = "RisingTide_GemEaters4",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "RisingTide_GemEaters5",
		filledCells = {
			"      ",
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "RisingTide_GemEaters6",
		filledCells = {
			"      ",
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "RisingTide_GemEaters7",
		filledCells = {
			"XXXXXX",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	--End Josh Land 34
    --Begin Roh Land 34
    {
        name = "CuckoooForCoconuts_Eater1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
        },
    },
    {
        name = "CuckoooForCoconuts_Eater2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "       ",
        },
    },
    {
        name = "CuckoooForCoconuts_Switch1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "X      ",
        },
    },
    {
        name = "CuckoooForCoconuts_Switch2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "      X",
        },
    },
    {
        name = "CuckoooForCoconuts_CoconutTarget",
        filledCells = {
            "       ",
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "CuckoooForCoconuts_InedibleTarget",
        filledCells = {
            "   X   ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    --End Roh Land 34

	-- Begin Vine Lab Patterns : Ari
	--Vine Lab 1
	{
		name = "VineLab1_Boulders",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
			"X X X X",
		},
	},

	{
		name = "VineLab1_MultiHitStones",
		filledCells = {
			"       ",
			"       ",
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab1_Missing",
		filledCells = {
			"       ",
			"       ",
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab1_Walls",
		filledCells = {
			"       ",
			"       ",
			"X X X X",
			"X X X X",
			"X X X X",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab1_Vines",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X X X ",
			"       ",
			" X X X ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "VineLab1_ColorBlock",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X X X ",
			" X X X ",
			"XXXXXXX",
			"XXXXXXX",
			"       ",
		},
	},
	{
		name = "VineLab1_ColorBottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},
	--Vine Lab 2
	{
		name = "Spiral_Big",
		filledCells = {
			"XXXXXXX",
			"      X",
			"XXXXX X",
			"X   X X",
			"X X X X",
			"X XXX X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "InverseSpiral_Big",
		filledCells = {
			"       ",
			"XXXXXX ",
			"     X ",
			" XXX X ",
			" X X X ",
			" X   X ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "OpenSpiral_Big",
		filledCells = {
			"       ",
			"       ",
			" XXX   ",
			"X   X  ",
			"X X X X",
			"X XXX X",
			"X     X",
			"XXXXXXX",
		},
	},
	{
		name = "PartialInverseSpiral_Big_Vines",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" XXX   ",
			" X     ",
			" X     ",
			" X     ",
			"       ",
		},
	},
	{
		name = "PartialInverseSpiral_Big_1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"  XX   ",
			"   X   ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "PartialInverseSpiral_Big_2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X     ",
			" X     ",
			" X     ",
			"       ",
			"       ",
		},
	},
	{
		name = "PartialInverseSpiral_Big_3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			"       ",
		},
	},
	{
		name = "PartialInverseSpiral_Big_4",
		filledCells = {
			"       ",
			"       ",
			"     X ",
			"     X ",
			"     X ",
			"     X ",
			"       ",
			"       ",
		},
	},
	{
		name = "BottomHalfOpenSpiral_Big",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"      X",
			"X     X",
			" XXXXX ",
		},
	},
	{
		name = "TopHalfOpenSpiral_Big",
		filledCells = {
			"       ",
			"       ",
			" XXX   ",
			"X   X  ",
			"X X X  ",
			"X  X   ",
			"       ",
			"       ",
		},
	},
	{
		name = "SpiralLocks_Big",
		filledCells = {
			"       ",
			"       ",
			"X   X X",
			"      X",
			"       ",
			"  X X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Spiral_LastVines",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},

	--Vine Lab 3
	{
		name = "VineLab3_BedRockBottom",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X X X ",
		},
	},

	{
		name = "VineLab3_VineRoof",
		filledCells = {
			"       ",
			"XX   XX",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab3_StartingBoulders",
		filledCells = {
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab3_StartingStones",
		filledCells = {
			"       ",
			"       ",
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockLid1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockLid2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockLid3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockLid4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockAxe1",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockAxe2",
		filledCells = {
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockAxe3",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockAxe4",
		filledCells = {
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "VineLab3_BedRockPrize1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "VineLab3_BedRockPrize2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "VineLab3_BedRockPrize3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "VineLab3_BedRockPrize4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
		},
	},



	-- End Vine Lab Patterns: Ari
	-- Begin Yellow Lab patterns
	{
		name = "YellowLab2_missing",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"  X X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "YellowLab2_stone",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"  XXX  ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "YellowLab2_laserH",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "YellowLab2_laserV",
		filledCells = {
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
		},
	},
	-- End Yellow Lab patterns
	--Begin Safe Lab patterns
	{
		name = "SafeLab1_Safes",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "SafeLab1_Ice",
		filledCells = {
			" XX XX ",
			"XXX XXX",
			"XXX XXX",
			"       ",
			"       ",
			"XXX XXX",
			"XXX XXX",
			" XX XX ",
		},
	},
	{
		name = "SafeLab3_Steel",
		filledCells = {
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
		},
	},
	{
		name = "SafeLab3_Clear",
		filledCells = {
			"       ",
			" X   X ",
			"XX   XX",
			"       ",
			"       ",
			"XX   XX",
			" X   X ",
			"       ",
		},
	},
	{
		name = "SafeLab3_Danger1",
		filledCells = {
			"       ",
			" X     ",
			"XX     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeLab3_Danger2",
		filledCells = {
			"       ",
			"     X ",
			"     XX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "SafeLab3_Danger3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"     XX",
			"     X ",
			"       ",
		},
	},
	{
		name = "SafeLab3_Danger4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX     ",
			" X     ",
			"       ",
		},
	},
	{
		name = "SafeLab3_Switches",
		filledCells = {
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
		},
	},
	{
		name = "SafeLab3_Safes",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},
	--Josh Land 35 Patterns Begin
	{
		name = "ReachForStars_Link1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"X      ",
			"       ",
			"       ",
			"X      ",
		},
	},
	{
		name = "ReachForStars_Link2",
		filledCells = {
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X    ",
		},
	},
	{
		name = "ReachForStars_Link3",
		filledCells = {
			"    X  ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"    X  ",
		},
	},
	{
		name = "TreasureStar_JailedLink1",
		filledCells = {
			"       ",
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TreasureStar_JailedLink2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "TreasureStar_Link1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X X X X",
			"       ",
			"       ",
		},
	},
	{
		name = "TreasureStar_Link2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",		
			"       ",
			"       ",
			" X X X ",
		},
	},
	{
		name = "TreasureStar_Treasure",
		filledCells = {
			"X X X X",
			"       ",
			" X X X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ObserveStars_Link1",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "ObserveStars_Link2",
		filledCells = {
			"       ",
			"       ",
			"  X    ",
			"       ",
			"     X ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "ObserveStars_Link3",
		filledCells = {
			"       ",
			"       ",
			"    X  ",
			"       ",
			" X     ",
			"       ",
			"    X  ",
			"       ",
		},
	},
	{
		name = "ObserveStars_MissingSquares",
		filledCells = {
			"XXXXXXX",
			"XX   XX",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"XX   XX",
		},
	},
	{
		name = "IceStar_Link1",
		filledCells = {
			"      ",
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "IceStar_Link2",
		filledCells = {
			"      ",
			"  X   ",
			"      ",
			"      ",
			"   X  ",
			"      ",
			"      ",
		},
	},
	{
		name = "IceStar_Link3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
			" X    ",
			"      ",
		},
	},
	{
		name = "IceStar_Ice",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			"XXXXX ",
			" XX  X",
			"X XXXX",
			"XXX XX",
		},
	},
	{
		name = "IceStar_IceGenerator",
		filledCells = {
			"      ",
			"X     ",
			"      ",
			"     X",
			"X     ",
			"      ",
			"   X  ",
		},
	},
	{
		name = "Pandora_Link1",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pandora_Link2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"   X   ",
		},
	},
	{
		name = "Pandora_Link3",
		filledCells = {
			"       ",
			"      X",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pandora_Link4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"    X  ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pandora_LavaMakers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pandora_VineMakers",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
		},
	},
	{
		name = "Pandora_IceMakers",
		filledCells = {
			"X      ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "Pandora_BombMakers",
		filledCells = {
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "LittleDipper_Clouds",
		filledCells = {
			"X      ",
			"X      ",
			" X     ",
			" XX    ",
			"   XXXX",
			"   XXXX",
			"    XX ",
			"       ",
		},
	},
	{
		name = "Pulsar_Link1",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			"       ",
			"       ",
			"X     X",
			"       ",
		},
	},
	{
		name = "Pulsar_MissingSquares",
		filledCells = {
			"       ",
			"       ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"       ",
			"  X X  ",
		},
	},
	{
		name = "Pulsar_Fences",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
		},
	},
	{
		name = "Pulsar_Steel",
		filledCells = {
			" X   XX",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
		},
	},
	{
		name = "Pulsar_Ice",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			" XXXXX ",
			" XXXXX ",
			"  XXX  ",
			"       ",
		},
	},
	{
		name = "Pulsar_Gems",
		filledCells = {
			"       ",
			"X     X",
			"       ",
			"       ",
			" XXXXX ",
			" XXXXX ",
			"X XXX X",
			"       ",
		},
	},
	{
		name = "ConstellationChooser_Steel",
		filledCells = {
			"   X   ",
			"   X   ",
			"   X   ",
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ConstellationChooser_Steel2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"    XXX",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ConstellationChooser_Steel3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"   X   ",
			"   X   ",
		},
	},
	{
		name = "ConstellationChooser_Steel4",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"XXX    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ConstellationChooser_Link1",
		filledCells = {
			"     X ",
			"  X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ConstellationChooser_Switch",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ConstellationChooser_Link2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			" X     ",
			"       ",
			"       ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "ConstellationChooser_Link3",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			" X   X ",
			"       ",
			"       ",
		},
	},
	{
		name = "ConstellationChooser_Link4",
		filledCells = {
			"       ",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"      X",
			"       ",
			"       ",
		},
	},
	--Josh Land 35 Patterns End
	--Begin Brooke's levels
	{
		name = "DwarfStars_Link1",
		filledCells = {
			"      ",
			"   X  ",
			"  X   ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "DwarfStars_Link2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  X   ",
			"    X ",
			"      ",
			"      ",
		},
	},
	{
		name = "DwarfStars_Link3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"    X ",
			" X    ",
		},
	},
	{
		name = "DwarfStars_Yellows",
		filledCells = {
			"      ",
			"  X X ",
			" X    ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "StarBeast_Link1",
		filledCells = {
			"       ",
			"       ",
			"  X X  ",
			" X   X ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StarBeast_Link2",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"      X",
			"      X",
			"    X  ",
			"       ",
		},
	},
	{
		name = "StarBeast_Link3",
		filledCells = {
			"       ",
			"X      ",
			"XX     ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StarBeast_Link4",
		filledCells = {
			"       ",
			"      X",
			"     XX",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StarBeast_Link5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"X      ",
			"  X    ",
			"       ",
		},
	},
	{
		name = "StarBeast_Amber",
		filledCells = {
			"X     X",
			" XX XX ",
			"   X   ",
			"       ",
			" X   X ",
			" X   X ",
			"XX   XX",
			" X   X ",
		},
	},
	{
		name = "MoltenGeyser_Missing",
		filledCells = {
			"XX    ",
			"X     ",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "MoltenGeyser_Stones",
		filledCells = {
			"      ",
			"      ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
			"    X ",
		},
	},
	--End Brooke's levels
	--Begin Randi Land 35 levels
	{
		name = "BreakThrough_Link1",
		filledCells = {
			"      ",
			"X    X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "BreakThrough_Link2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
		},
	},	
	{
		name = "BreakThrough_Link3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"X     ",
			"      ",
			"     X",
		},
	},
	{
		name = "BreakThrough_Stone",
		filledCells = {
			"      ",
			"      ",
			" XXXX ",
			"      ",
			" X  X ",
			" XXXX ",
			"      ",
		},
	},
	{
		name = "BreakThrough_Boulders",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
			"      ",
			"      ",
		},
	},
	{
		name = "ShootingStars_Link1",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"X      ",
			"      X",
			"X      ",
			"       ",
		},
	},
	{
		name = "ShootingStars_Link2",
		filledCells = {
			"   X   ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"   X   ",
		},
	},
	{
		name = "ShootingStars_Link3",
		filledCells = {
			"       ",
			"X      ",
			"       ",
			"      X",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "ImpossibleLink_MissingSquares",
		filledCells = {
			" XXXXX ",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			"X     X",
			" XXXXX ",
		},
	},
	{
		name = "Superheated_Link1",
		filledCells = {
			"  X   ",
			"      ",
			"     X",
			"X     ",
			"      ",
			"   X  ",
			"      ",
		},	    
	},
	{
		name = "Superheated_Link2",
		filledCells = {
			"      ",
			" X  X ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
		},
	},
	{
		name = "Superheated_Link3",
		filledCells = {
			"   X  ",
			"      ",
			"X     ",
			"     X",
			"      ",
			"  X   ",
			"      ",
		},
	},
	{
		name = "Superheated_Lava",
		filledCells = {
			"      ",
			"      ",
			"  XX  ",
			"  XX  ",
			"X    X",
			"XX  XX",
			"      ",
		},
	},
	{
		name = "DoubleTake_Link1",
		filledCells = {
			"      ",
			"  X  X",
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "DoubleTake_Link2",
		filledCells = {
			"      ",
			"      ",
			"      ",
			" X  X ",
			"      ",
			"      ",
			"      ",
		},
	},
	{
		name = "DoubleTake_Link3",
		filledCells = {
			"      ",
			"      ",
			"      ",
			"      ",
			"      ",
			"X  X  ",
			"      ",
		},
	},
	{
		name = "RingsOfSaturn_Rings",
		filledCells = {
			"XXXXXXX",
			"X     X",
			"X     X",
			"X     X",
			"XXXXXXX",
			"       ",
			"       ",
			"       ",
		},
	},
	-- End Randi 35 levels
   
    --Begin Roh 35 levels
    {
        name = "PyramidLinks_Link1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "   X   ",
            "   X   ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "PyramidLinks_Link2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "  X X  ",
            "       ",
            "       ",
        },
    },
    {
        name = "PyramidLinks_Link3",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            " X   X ",
            "       ",
        },
    },
    {
        name = "PyramidLinks_Stone1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "  X X  ",
            " X   X ",
        },
    },
    {
        name = "PyramidLinks_Stone2",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "   X   ",
            "  XXX  ",
        },
    },
    {
        name = "PyramidLinks_Sky",
        filledCells = {
            "XXXXXXX",
            "XXXXXXX",
            "XXXXXXX",
            "XXX XXX",
            "XXX XXX",
            "XX   XX",
            "X     X",
            "       ",
        },
    },
    {
        name = "StarryNight_Link1",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            " X     ",
            "X X    ",
            " X     ",
            "       ",
        },
    },
    {
        name = "StarryNight_Link2",
        filledCells = {
            "    X X",
            "       ",
            "    X X",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "StarryNight_Link3",
        filledCells = {
            "X      ",
            " X     ",
            "  X    ",
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
        },
    },
    {
        name = "StarryNight_Link4",
        filledCells = {
            "       ",
            "       ",
            "       ",
            "       ",
            "       ",
            "    X X",
            "       ",
            "     X ",
        },
    },
    --End Roh 35 levels
	--Begin Michael 35 levels
	{
		name = "StarCrossedLovers_Link1",
		filledCells = {
			" X     ",
			"X X    ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StarCrossedLovers_Link2",
		filledCells = {
			"     X ",
			"    X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StarCrossedLovers_Link3",
		filledCells = {
			"       ",
			"       ",
			"X X    ",
			"       ",
			"  X    ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StarCrossedLovers_Link4",
		filledCells = {
			"       ",
			"       ",
			"    X X",
			"       ",
			"    X  ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "StarCrossedLovers_Link5",
		filledCells = {
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"  X X  ",
			"       ",
			"   X   ",
		},
	},

	--End Michael 35 levels
	--Begin Josh 37 levels
	{
		name = "Treasurerang_Steel",
		filledCells = {
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
			" X X X ",
		},
	},
	{
		name = "Treasurerang_Makers",
		filledCells = {
			"X X X X",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OpalBarrel_Barrels",
		filledCells = {
			"       ",
			" XXXXX ",
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OpalBarrel_Fences",
		filledCells = {
			"       ",
			"X     X",
			"X     X",
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	{
		name = "OpalBarrel_Makers",
		filledCells = {
			" XXXXX ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
			"       ",
		},
	},
	--End Josh 37 Levels
}