table.insertall(LevelDefs,
{
	["PompeiiFive"] = {
		levelName = "Escape!",
		hidden = true,				
		resource = "GameScreen_LabLevel",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "PompeiiFive_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "PompeiiFive_lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				}
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",250000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000, 
	},

	["LaserLab"] = {
		levelName = "Laser Lab",
		resource = "GameScreen_LabLevel",
		hidden = true,					
		Features = {
			largeBoard = true,
			modeSpins4 = true, 
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaserLab_pattern1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
				{
					patternName = "LaserLab_pattern2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "LaserLab_pattern_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					--skinVariant = "MarsStone",
					--applySkinVariant = true,
				},
				{
					patternName = "LaserLab_pattern_crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "LaserLab_pattern_steel",
					isPatternSet = false,

                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Fence,
                    matchFlags = 0,
--[[
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					--skinVariant = "MarsSteel",
					--applySkinVariant = true,
--]]
				},
				{
					patternName = "LaserLab_pattern_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
					--applySkinVariant = true,
					--skinVariant = "MarsChest",
				},
			},
		},		
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			--main = {"finish",true,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",300000},
			},
		},
	},

	["LaserLab2"] = {
		levelName = "Laser Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,					
		Features = {
			largeBoard = true,
			modeSpins5 = true, 
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			gemsMoveDiagonally = false,
			additionalNamedMixes = {
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaserLab2_pattern2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
				{
					patternName = "LaserLab_pattern2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "LaserLab_pattern_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					--skinVariant = "MarsStone",
					--applySkinVariant = true,
				},
				{
					patternName = "LaserLab_pattern_crates2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "LaserLab_pattern_steel2",
					isPatternSet = false,

                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Fence,
                    matchFlags = 0,
--[[
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					--skinVariant = "MarsSteel",
					--applySkinVariant = true,
--]]
				},
				{
					patternName = "LaserLab_pattern_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
					--applySkinVariant = true,
					--skinVariant = "MarsChest",
				},
			},
		},		
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			--main = {"finish",true,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
	},

	["LaserLab3"] = {
		levelName = "Laser Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,					
		Features = {
			largeBoard = true,
			modeSpins5 = true, 
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaserLab_pattern_laser2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
				{
					patternName = "LaserLab_pattern_laser3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "LaserLab_pattern_stone3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					--skinVariant = "MarsStone",
					--applySkinVariant = true,
				},
				{
					patternName = "LaserLab_pattern_crates3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
				},
				{
					patternName = "LaserLab_pattern_steel3",
					isPatternSet = false,

                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Fence,
                    matchFlags = 0,
--[[
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					--skinVariant = "MarsSteel",
					--applySkinVariant = true,
--]]
				},
				{
					patternName = "LaserLab_pattern_chest3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
					--applySkinVariant = true,
					--skinVariant = "MarsChest",
				},
			},
		},		
		goals = {
			main = {"getGem",7,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			--main = {"finish",true,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["LaserLab4"] = {
		levelName = "Laser Lab 4",
		resource = "GameScreen_LabLevel",
		hidden = true,					
		Features = {
			largeBoard = true,
			modeSpins4 = true, 
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LaserLab_pattern3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
				{
					patternName = "LaserLab_pattern2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "LaserLab_pattern_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					--skinVariant = "MarsStone",
					--applySkinVariant = true,
				},
				{
					patternName = "LaserLab_pattern_crates4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "LaserLab_pattern_steel",
					isPatternSet = false,

                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Fence,
                    matchFlags = 0,
--[[
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					--skinVariant = "MarsSteel",
					--applySkinVariant = true,
--]]
				},
				{
					patternName = "LaserLab_pattern_chest",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
					--applySkinVariant = true,
					--skinVariant = "MarsChest",
				},
			},
		},		
		goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			--main = {"finish",true,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},

	["WindowLab1"] = {
		levelName = "Window Lab 1",	
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			hasSteelGlass = true,
			hasTreasure = true,
			--hasStones = true,
            --hasJailedSquares = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useMissingReels = true,
			--[[
			missingReels = {
				patternName = "MissingMiddleLargeReels",
				isPatternSet = false,
			},
			--]]
			useSteelGlass = true,
			steelGlass = {
				patternName = "WindowLab1_Glass1",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "WindowLab1_Treasure1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				--[[
				{
					patternName = "WindowLab1_Stones1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					--skinVariant = "MarsStone",
					--applySkinVariant = true,
				},
				{
					patternName = "WindowLab1_Crates1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "WindowLab1_Jailed1",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
				--]]
			},
		},
		goals = {
			main = {"getGem",8,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",150000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, 
	},

	["WindowLab2"] = {
		levelName = "Window Lab 2",	
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
            largeBoard = true,

			hasSteelGlass = true,
			hasTreasure = true,
			hasStones = true,
            hasJailedSquares = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useMissingReels = true,
			--[[
			missingReels = {
				patternName = "MissingMiddleLargeReels",
				isPatternSet = false,
			},
			--]]
			useSteelGlass = true,
			steelGlass = {
				patternName = "WindowLab1_Glass2",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "WindowLab1_Treasure2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				---[[
				{
					patternName = "WindowLab1_Stones2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					--skinVariant = "MarsStone",
					--applySkinVariant = true,
				},
				--]]
				{
					patternName = "WindowLab1_Crates2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				--[[
				{
					patternName = "WindowLab1_Jailed1",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
				--]]
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, 
	},

	["WindowLab3"] = {
		levelName = "Window Lab 3",	
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
            largeBoard = true,

			hasSteelGlass = true,
			hasTreasure = true,
			hasStones = true,
            hasJailedSquares = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			useMissingReels = true,
			--[[
			missingReels = {
				patternName = "MissingMiddleLargeReels",
				isPatternSet = false,
			},
			--]]
			useSteelGlass = true,
			steelGlass = {
				patternName = "WindowLab1_Glass3",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "WindowLab1_Treasure3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				--[[
				{
					patternName = "WindowLab1_Stones3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					--skinVariant = "MarsStone",
					--applySkinVariant = true,
				},
				--]]
				{
					patternName = "WindowLab1_Crates3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "WindowLab1_Jailed3",
					isPatternSet = false,

					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					-- applyExtraHits = true,
					-- extraHits = 1,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",450000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, 
	},
	["CrowdedLab1"] = {
		levelName = "Crowded Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasStones = true,
			hasBarrels = true,
			hasCoverage = true,
			hasColoredKeyGems = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large", --MissingLargeSideReels
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Key Mix 2",
					delay = 0,
					{
						name = "Key 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 2"},
					},
				},
				[2] = {
					name = "Key Mix 3",
					delay = 0,
					{
						name = "Key 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 3"},
					},
				},
			},
            additionalNamedPatterns = {
                [1] = {
                    entryName = "Remove Wall 2",
                    patternName = "CrowdedLab_Bedrock2",
                    isPatternSet = false,
                    clearPieces = true,
                },
                [2] = {
                    entryName = "Remove Wall 3",
                    patternName = "CrowdedLab_Bedrock3",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
			additionalInitialPatterns = { 
				{
                    patternName = "CrowdedLab_Bedrock1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Crates,
                },
				{
                    patternName = "CrowdedLab_Bedrock2",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
				{
                    patternName = "CrowdedLab_Bedrock3",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
				{
                    patternName = "CrowdedLab_Bedrock4",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Crates,
                },
                {
                    patternName = "CrowdedLab_Key1",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "CrowdedLab_Key2",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 2"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
                {
                    patternName = "CrowdedLab_Key3",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 3"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
                {
                    patternName = "CrowdedLab_Key4",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
                {
                    patternName = "CrowdedLab_Stone",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "CrowdedLab_Jail",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
                {
                    patternName = "CrowdedLab_Impossible",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
                {
                    patternName = "CrowdedLab_Coverage",
                    isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
                {
                    patternName = "CrowdedLab_Color1",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
                {
                    patternName = "CrowdedLab_Color2",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
                {
                    patternName = "CrowdedLab_Color3",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
                {
                    patternName = "CrowdedLab_Color4",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",1200000},
				[3] = {"score",1500000},
			},
		},
	},
	["CrowdedLab2"] = {
		levelName = "Crowded Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasStones = true,
			hasBarrels = true,
			hasCoverage = true,
			hasColoredKeyGems = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large", --MissingLargeSideReels
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Key Mix 2",
					delay = 0,
					{
						name = "Key 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 2"},
					},
				},
				[2] = {
					name = "Key Mix 3",
					delay = 0,
					{
						name = "Key 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 3"},
					},
				},
				[3] = {
					name = "Key Mix 4",
					delay = 0,
					{
						name = "Key 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 4"},
					},
				},
			},
            additionalNamedPatterns = {
                [1] = {
                    entryName = "Remove Wall 2",
                    patternName = "CrowdedLab_Bedrock2",
                    isPatternSet = false,
                    clearPieces = true,
                },
                [2] = {
                    entryName = "Remove Wall 3",
                    patternName = "CrowdedLab_Bedrock3",
                    isPatternSet = false,
                    clearPieces = true,
                },
                [3] = {
                    entryName = "Remove Wall 4",
                    patternName = "CrowdedLab_Bedrock4",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
			additionalInitialPatterns = { 
				{
                    patternName = "CrowdedLab_Bedrock1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Crates,
                },
				{
                    patternName = "CrowdedLab_Bedrock2",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
				{
                    patternName = "CrowdedLab_Bedrock3",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
				{
                    patternName = "CrowdedLab_Bedrock4",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "CrowdedLab_Key1",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "CrowdedLab_Key2",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 2"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
                {
                    patternName = "CrowdedLab_Key3",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 3"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
                {
                    patternName = "CrowdedLab_Key4",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 4"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
                {
                    patternName = "CrowdedLab_Stone",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
				},
                {
                    patternName = "CrowdedLab_Jail",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
                {
                    patternName = "CrowdedLab_Impossible",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
                {
                    patternName = "CrowdedLab_Coverage",
                    isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
                {
                    patternName = "CrowdedLab_Color1",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
                {
                    patternName = "CrowdedLab_Color2",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
                {
                    patternName = "CrowdedLab_Color3",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
                {
                    patternName = "CrowdedLab_Color4",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2500000},
				[3] = {"score",4000000},
			},
		},
	},
	["CrowdedLab3"] = {
		levelName = "Crowded Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasStones = true,
			hasBarrels = true,
			hasCoverage = true,
			hasColoredKeyGems = true,
		},
		tricks = World29Tricks,
		boosts = World29Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large", --MissingLargeSideReels
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Key Mix 1",
					delay = 0,
					{
						name = "Key 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 1"},
					},
				},
				[2] = {
					name = "Key Mix 2",
					delay = 0,
					{
						name = "Key 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 2"},
					},
				},
				[3] = {
					name = "Key Mix 3",
					delay = 0,
					{
						name = "Key 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 3"},
					},
				},
				[4] = {
					name = "Key Mix 4",
					delay = 0,
					{
						name = "Key 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_PickAxe",
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 4"},
					},
				},
			},
            additionalNamedPatterns = {
                [1] = {
                    entryName = "Remove Wall 1",
                    patternName = "CrowdedLab_Bedrock1",
                    isPatternSet = false,
                    clearPieces = true,
                },
                [2] = {
                    entryName = "Remove Wall 2",
                    patternName = "CrowdedLab_Bedrock2",
                    isPatternSet = false,
                    clearPieces = true,
                },
                [3] = {
                    entryName = "Remove Wall 3",
                    patternName = "CrowdedLab_Bedrock3",
                    isPatternSet = false,
                    clearPieces = true,
                },
                [4] = {
                    entryName = "Remove Wall 4",
                    patternName = "CrowdedLab_Bedrock4",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
			additionalInitialPatterns = { 
				{
                    patternName = "CrowdedLab_Bedrock1",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemBlue",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
				{
                    patternName = "CrowdedLab_Bedrock2",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemGreen",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
				{
                    patternName = "CrowdedLab_Bedrock3",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemPurple",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
				{
                    patternName = "CrowdedLab_Bedrock4",
                    isPatternSet = false,
                    applyIcon = true,
                    icon = "Icon_GemRed",
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
                },
                {
                    patternName = "CrowdedLab_Key1",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 1"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
                {
                    patternName = "CrowdedLab_Key2",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 2"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
                {
                    patternName = "CrowdedLab_Key3",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 3"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
                {
                    patternName = "CrowdedLab_Key4",
                    isPatternSet = false,
					specials = CascadePieceSpecials_ColorBarrels,
					applyPieceSpecials = true,
					applySkinVariant = true,
					skinVariant = "ColorBarrel",
					applySpawnTypes = true,
					spawnTypes = {"Key Mix 4"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
                {
                    patternName = "CrowdedLab3_Stone2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    patternName = "CrowdedLab3_Stone3",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
				},
                {
                    patternName = "CrowdedLab3_Jail2",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
                {
                    patternName = "CrowdedLab3_Jail3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    patternName = "CrowdedLab_Impossible",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
                {
                    patternName = "CrowdedLab_Coverage",
                    isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
                {
                    patternName = "CrowdedLab_Color1",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
                {
                    patternName = "CrowdedLab_Color2",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
                {
                    patternName = "CrowdedLab_Color3",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
                {
                    patternName = "CrowdedLab_Color4",
                    isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2500000},
				[3] = {"score",4000000},
			},
		},
	},

    ["BalloonLab1"] = {
        levelName = "Balloon Lab 1", 
		resource = "GameScreen_LabLevel",
        hidden = true,
        Features = {
            splashMode = true,
            modeSpins5 = true,
            gemTypes5 = true,
            largeBoard = true,

            hasBalloons = true,
            hasMakers = true,
        },
        tricks = World1Tricks,
        boosts = World1Boosts,
        Properties = {
            additionalNamedMixes = {
                {
                    name = "5 Color Mix",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                    {
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "BalloonLab1_clear",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    patternName = "BalloonLab1_balloons",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {
                    patternName = "BalloonLab1_makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"5 Color Mix"},
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",500000},
                [3] = {"score",750000},
            },
        },
    },

    ["BalloonLab2"] = {
        levelName = "Balloon Lab 2", 
		resource = "GameScreen_LabLevel",
        hidden = true,
        Features = {
            splashMode = true,
            modeSpins5 = true,
            gemTypes4 = true,
            largeBoard = true,

            hasBalloons = true,
            hasMakers = true,
            hasSteel = true,
        },
        tricks = World1Tricks,
        boosts = World1Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "BalloonLab2_missing",
                isPatternSet = false,
            },
            additionalNamedMixes = {
                {
                    name = "4 Color Mix",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "BalloonLab2_makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"4 Color Mix"},
                },
                {
                    patternName = "BalloonLab2_steel",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                },

                --Balloons
                {
                    patternName = "BalloonLab2_balloons0",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {   
                    patternName = "BalloonLab2_balloons1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {   
                    patternName = "BalloonLab2_balloons2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {   
                    patternName = "BalloonLab2_balloons3",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {   
                    patternName = "BalloonLab2_balloons4",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",250000},
                [3] = {"score",500000},
            },
        },
    },

    ["BalloonLab3"] = {
        levelName = "Balloon Lab 3", 
		resource = "GameScreen_LabLevel",
        hidden = true,
        Features = {
            splashMode = true,
            modeSpins10 = true,
            gemTypes4 = true,
            largeBoard = true,

            hasBalloons = true,
            hasMakers = true,
            hasSteel = true,
            hasLava = true,
            hasBarrels = true,
        },
        tricks = World1Tricks,
        boosts = World1Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "BalloonLab3_missing",
                isPatternSet = false,
            },
            additionalNamedMixes = {
                {
                    name = "4 Color Mix",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "BalloonLab3_steel",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                },
                {
                    patternName = "BalloonLab3_crates",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Crates,
                },
                {
                    patternName = "BalloonLab3_makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"4 Color Mix"},
                },
                {
                    patternName = "BalloonLab3_Boulders",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                },
                {
                    patternName = "BalloonLab3_Lava",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Lava,
                    matchFlags = 0,
                },

                --ballooons
                {   
                    patternName = "BalloonLab3_balloons1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {   
                    patternName = "BalloonLab3_balloons2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {   
                    patternName = "BalloonLab3_balloons3",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
                {   
                    patternName = "BalloonLab3_balloons4",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",200000},
                [3] = {"score",400000},
            },
        },
    },

	--Lock Lab Levels

	["LockLab1"] = {
		levelName = "Lock Lab 1",			
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			regularBoard = true,
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			hasLocks = true,
			hasSteel = true,
			hasCoverage = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "LockLab1_locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "LockLab1_steel",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "LockLab1_clouds",
					--clearPieces = true,
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[4] = {
					patternName = "LockLab1_void",
					clearPieces = true,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
	},

	["LockLab2"] = {
		levelName = "Lock Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			largeBoard = true,
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			hasLocks = true,
			hasSteel = true,
			hasCoverage = true,
			hasMissingReels = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels_Large",
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "LockLab2_locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "LockLab2_steel",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "LockLab2_clouds",
					--clearPieces = true,
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[4] = {
					patternName = "LockLab2_void",
					clearPieces = true,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",300000},
				[3] = {"score",450000},
			},
		},
	},
	["LockLab3"] = {
		levelName = "Lock Lab 3",			
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			largeBoard = true,
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			hasLocks = true,
			hasSteel = true,
			hasCoverage = true,
		},
		tricks = World19Tricks,
		boosts = World19Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "LockLab3_locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "LockLab3_steel",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "LockLab3_void",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},		
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",1100000},
				[3] = {"score",3000000},
			},
		},
	},
	
    ["TreasureLab1"] = {
		levelName = "Treasure Lab 1",		
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
            largeBoard = true,
			modeSpins3 = true,
			gemTypes4 = true,
            hasChests = true,
			hasJailedSquares = true,
			hasSteel = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "TreasureLab1_Cells",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[2] = {
					patternName = "TreasureLab1_CellDoors",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed,
				},
				[3] = {
					patternName = "TreasureLab1_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
                    applyMatchFlags = true,
                    matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",10000},
				[2] = {"score",30000},
				[3] = {"score",60000},
			},
		},
	},
        
    ["TreasureLab2"] = {
		levelName = "Treasure Lab 2",		
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
            largeBoard = true,
			modeSpins4 = true,
			gemTypes5 = true,
            hasChests = true,
			hasCrates = true,
			hasSteel = true,
            hasBombs = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "TreasureLab2_Cells",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[2] = {
					patternName = "TreasureLab2_CellDoors",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
                    applyMatchFlags = true,
					matchFlags = 0,
				},
				[3] = {
					patternName = "TreasureLab1_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyTurnsToLoss = true,
                    turnsToLoss = 20,
				},
			},
		},		
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",60000},
				[3] = {"score",150000},
			},
		},
	},
        
    ["TreasureLab3"] = {
		levelName = "Treasure Lab 3",					
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
            largeBoard = true,
			modeSpins8 = true,
			gemTypes6 = true,
            hasChests = true,
			hasJailedSquares = true,
			hasSteel = true,
            hasPortals = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
            portals = {
                [1] = {{2,7},{6,3},"PortalEntrance_1","PortalExit_1"},
                [2] = {{4,7},{0,3},"PortalEntrance_1","PortalExit_1"},
            },
			additionalInitialPatterns = { 
				[1] = {
					patternName = "TreasureLab3_Cells",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[2] = {
					patternName = "TreasureLab3_CellDoors",
                    isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed,
				},
				[3] = {
					patternName = "TreasureLab1_Chests",
					isPatternSet = false,
					applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
                    applyMatchFlags = true,
                    matchFlags = 0,
				},
			},
		},		
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",500000},
				[3] = {"score",850000},
			},
		},
	},

    --ICE LAB LEVELS
	["IceLab1"] = {
	    levelName = "The Ice Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true, 
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins8 = true, 
	        gemTypes5 = true,
	
	        hasCoverage = true,
			hasIce = true,
	    },
	    tricks = World1Tricks,
	    boosts = World1Boosts,
	    Properties = {
	        additionalInitialPatterns = { 
				--ICE
	            {
	                patternName = "IceLab_Type1",
	                isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
	            },
				{
					patternName = "IceLab_Type3",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel + CascadePieceSpecial_CantCover,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "IceMaker",
				},
				{
					--necessary to set up ice makers correctly
					patternName = "IceLab_Type3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				--Cloudy Blocks
				{
					patternName = "IceLab_Type2",
					isPatternSet = false,
					matchRequirement =2,
					applyMatchRequirement = true,
				},
	        },
	    },      
	    goals = {
	        main = {"patterns", 0,},
	        stars = {
	            [1] = {"score",100000},
	            [2] = {"score",600000},
	            [3] = {"score",1250000},
	        },
	    },
	},
	["IceLab2"] = {
	    levelName = "The Ice Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins8 = true, 
	        gemTypes4 = true,
	
	        hasCoverage = true,
			hasIce = true,
			hasFences = true,
			hasLasers = true,
			hasMakers = true,
			hasMissingReels = true,
	    },
	    tricks = World25Tricks,
	    boosts = World25Boosts,
	    Properties = {
			useMissingReels = true,
			missingReels = { 
				patternName = "IceLab2_Reel",
				isPatternSet = false,
			},

			additionalNamedMixes = {
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},

				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 2,
					},
				},
				{
					name = "Maker Mix",
					delay = 0,
					{
						name = "BlueGem",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 6,
					},
					{
						name = "Green Gem",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 6,
					},
					{
						name = "PurpleGem",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 6,
					},
					{
						name = "Red Gem",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 6,
					},
					{
						name = "Wild Gem",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 3,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},

				},
			},
	        additionalInitialPatterns = { 
				--ICE
	            {
	                patternName = "IceLab2_Type1",
	                isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
	            },
				--ICE Makers
				{
					patternName = "IceLab2_Type6",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel + CascadePieceSpecial_CantCover,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "IceMaker",
				},
				{
					--necessary to set up ice makers correctly
					patternName = "IceLab2_Type6",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				--Makers
				{
					patternName = "IceLab2_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Maker Mix"},
				},
				--Cloudy Blocks
				{
					patternName = "IceLab2_Type2",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement =2,
				},
				--Fences
				{
					patternName = "IceLab2_Type5",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Laser
				{
					patternName = "IceLab2_Type4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "IceLab2_Type7",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
	        },
	    },      

	    goals = {
	        main = {"patterns", 0,},
	        stars = {
	            [1] = {"score",250000},
	            [2] = {"score",700000},
	            [3] = {"score",1500000},
	        },
	    },
	},
	["IceLab3"] = {
	    levelName = "The Ice Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins8 = true, 
	        gemTypes5 = true,
	
	        hasCoverage = true,
			hasIce = true,
			hasMakers = true,
			hasLasers = true,
			hasBombs = true,
			hasFences = true,
			hasBarrels = true,
	    },
	    tricks = World25Tricks,
	    boosts = World25Boosts,
	    Properties = {

			additionalNamedMixes = {
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},

				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
					{
						name = "Laser5",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 2,
					},
				},
				{
					name = "Bomb Maker Mix",
					events = {
						[1] = {
							eventType = "emitCount",
							count = 2,
							newDelay = 6,
							reset = true,
						},
					},
					delay = 1,
					{
						name = "blue bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss =12,
						weight = 6,
					},
					{
						name = "Green bomb",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss =12,
						weight = 6,
					},
					{
						name = "Purple bomb",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss =12,
						weight = 6,
					},
					{
						name = "Red bomb",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss =12,
						weight = 6,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},

				},
			},
	        additionalInitialPatterns = { 
				--ICE
	            {
	                patternName = "IceLab3_Ice",
	                isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
	            },
				--ICE Makers
				{
					patternName = "IceLab3_IceMaker",
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel + CascadePieceSpecial_CantCover,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "IceMaker",
				},
				{
					--necessary to set up ice makers correctly
					patternName = "IceLab3_IceMaker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				--Makers
				{
					patternName = "IceLab2_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Maker Mix"},
				},
				--Cloudy Blocks
				{
					patternName = "IceLab3_Type1",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement =3,
				},
				--Boulders
	 		 	{
	 		 		patternName = "IceLab3_Type1",
	 		 		isPatternSet = false,
	 		 		applyPieceSpecials = true,
	 		 		specials = CascadePieceSpecials_Barrels,
	 		 		applyMatchFlags = true,
	 		 		matchFlags = 0,
	 		 	},
				--Fences
				{
					patternName = "IceLab3_Fence",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Laser
				{
					patternName = "IceLab3_LaserH",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "IceLab3_LaserV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
	        },
	    },      

	    goals = {
	        main = {"patterns", 0,},
	        stars = {
	            [1] = {"score",600000},
	            [2] = {"score",800000},
	            [3] = {"score",1000000},
	        },
	    },
	},
	--End Ice Lab Levels

	--Amber Lab Levels
	["AmberLab1"] = {
		levelName = "Amber Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true,	 
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins5 = true, 
			gemTypes4 = true,

			hasCoverage = true,
			hasAmber = true,
			hasStones = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns = { 
				--Pattern
				{
					patternName = "AmberLab1_Cloudy",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				--Stone
				{
					patternName = "AmberLab1_Stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true, 
					skinVariant = "Stone",
				},
				--Amber
				{
					patternName = "AmberLab1_Amber",
					isPatternSet = false,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyCancelSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyPieceSpecials = true,
				},
			},
		},      
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["AmberLab2"] = {
		levelName = "Amber Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins6 = true, 
			gemTypes5 = true,

			hasCoverage = true,
			hasAmber = true,
			hasStones = true,
			hasJailedSquares = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns = { 
				--Pattern
				{
					patternName = "AmberLab2_Cloudy",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				--Stone
				{
					patternName = "AmberLab2_Stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true, 
					skinVariant = "Stone",
				},
				--Jails
				{
					patternName = "AmberLab2_Jails",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
				},
				--Amber
				{
					patternName = "AmberLab2_Amber",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
				},
			},
		},      
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",90000},
				[2] = {"score",230000},
				[3] = {"score",500000},
			},
		},
	},
	["AmberLab3"] = {
		levelName = "Amber Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins6 = true, 
			gemTypes5 = true,

			hasCoverage = true,
			hasAmber = true,
			hasStones = true,
			hasJailedSquares = true,
			hasBarrelsOfFun = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns = { 
				--Pattern
				{
					patternName = "AmberLab2_Cloudy",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				--Stone
				{
					patternName = "AmberLab3_Stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true, 
					skinVariant = "Stone",
				},
				--Jails
				{
					patternName = "AmberLab3_JailsBlue",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applySpawnTypes = true,
					spawnTypes = {},
				},
				{
					patternName = "AmberLab3_JailsPurple",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applySpawnTypes = true,
					spawnTypes = {},
				},
				{
					patternName = "AmberLab3_JailsRed",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applySpawnTypes = true,
					spawnTypes = {},
				},
				{
					patternName = "AmberLab3_JailsYellow",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applySpawnTypes = true,
					spawnTypes = {},
				},
				--Amber
				{
					patternName = "AmberLab3_AmberBlue",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applySpawnTypes = true,
					spawnTypes = {},
				},
				{
					patternName = "AmberLab3_AmberGreen",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applySpawnTypes = true,
					spawnTypes = {},
				},	
				{
					patternName = "AmberLab3_AmberPurple",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applySpawnTypes = true,
					spawnTypes = {},
				},	
				{
					patternName = "AmberLab3_AmberRed",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applySpawnTypes = true,
					spawnTypes = {},
				},	
				{
					patternName = "AmberLab3_AmberYellow",
					isPatternSet = false,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Amber,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Amber,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applySpawnTypes = true,
					spawnTypes = {},
				},			
			},
	
			addToBoardPieceMix = {
				{
					name = "FunBarrel",
					matchFlags = 0,
					weight = 2,
					isGemSpawner = true,
					specials = CascadePieceSpecials_Barrels,
				},
			},
			spawnGemOnBreak = 
			{
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash + CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber,
					weight = 1,
				},
			},
		},      
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000},
			},
		},
	},
	--End Amber Lab Levels
	--Burst Reel Lab Levels
	["BurstReelLab1"] = {
		levelName = "Burst Reel Lab 1",
        hidden = true,
		resource = "GameScreen_LabLevel",
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins5 = true, 
			gemTypes4 = true,

			hasMissingSquares = true,
			hasCoverage = true,
			hasStones = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingSquares = true,
				missingSquares={
					patternName = "BurstLab_StripesIn",
					isPatternSet = false,
				},
			additionalInitialPatterns = { 
				[1]={
					patternName = "BurstLab_StripesOut",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				
			},
			multiplyReelPieceMix = {
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 1.5,
				},
			},
			addToReelPieceMix = {
				{
					name = "hBlue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "hGreen",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11,
				},
				{
					name = "hPurple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11, 
				},
				{	
					name = "hRed",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 11, 
				},
			},

		},
	    
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",110000},
				[2] = {"score",180000},
				[3] = {"score",225000},
			},
		},
	},
	["BurstReelLab2"]={
		levelName = "Burst Reel Lab 2",
		hidden = true,
		resource = "GameScreen_LabLevel",
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins5 = true,
			gemTypes4 = true,

			hasMissingSquares = true,
			hasMissingReels = true,
			hasCoverage = true,
			hasStones = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares= {
				patternName = "BurstMissingCorners",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "MissingOuter2",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1]={
					patternName = "OutsidesOfDiamond",
					isPatternSet = false,
					matchRequirement =2,
					applyMatchRequirement = true,
				},
				[2]={
					patternName ="OutsidesOfDiamond",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant ="Stone",
				},
			},
			overrideReelPieceMix= {
				{
					name = "hBlue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 10,
				},
				{
					name = "hGreen",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 10,
				},
				{
					name = "hPurple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 10,
				},
				{
					name = "hRed",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 10,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",350000},
				[3] = {"score",5000000},
			},
		},
	},
	["BurstReelLab3"] = {
		levelName = "Burst Reel Lab 3",
        hidden = true,
		resource = "GameScreen_LabLevel",
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins6 = true, 
			gemTypes4 = true,

			hasMissingSquares = true,
			hasMissingReels = true,
			hasCoverage = true,
			hasBarrels = true,
			
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingSquares = true,
				missingSquares={
					patternName = "BurstLabBig_MissingSquares",
					isPatternSet = false,
				},
			useMissingReels = true,
				missingReels ={
					patternName ="BurstLabBig_MissingReels",
					isPatternSet = false,
				},

			additionalInitialPatterns = { 
				[1]={
					patternName = "BurstLabBig_Patterns",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[2]={
					patternName = "BurstLabBig_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits =1,
					applySkinVariant = true,
					skinVariant ="Stone",
					
				},
			},
			overrideReelPieceMix = {
				{
					name = "hBlue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 13,
				},
				{
					name = "hGreen",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 13,
				},
				{
					name = "hPurple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 13, 
				},
				{	
					name = "hRed",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 13, 
				},
			},

		},
	    
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1800000},
				[3] = {"score",2800000},
			},
		},
	},
--End Burst Reel Lab levels
--Begin Lava Lab Levels
	["LavaLab1"] = {
		levelName = "Lava Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true, 
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins6 = true, 
			gemTypes5 = true,

			hasCrates = true,
			hasLava = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			--Missing Squares
			useMissingSquares = true,
			missingSquares = {
				patternName = "TopCorners", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				--Crates
				{
					patternName = "LavaLab2_Crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Lava
				{
					patternName = "LavaLab1_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},		
		},
		goals = {
			main = {"gemsRemain", 0, "Lava", "Lava", {specials = CascadePieceSpecials_Lava,}, "Remove",},
			stars = {
				[1] = {"score",60000},
				[2] = {"score",140000},
				[3] = {"score",300000},
			},
		},
	},

	["LavaLab2"] = {
		levelName = "Lava Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true, 
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins6 = true, 
			gemTypes5 = true,

			hasCrates = true,
			hasBombs = true,
			hasLava = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			--Missing Squares
			useMissingSquares = true,
			missingSquares = {
				patternName = "TopCorners", 
				isPatternSet = false,
			},

			additionalInitialPatterns = { 
				--Stone
				{
					patternName = "LavaLab1_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				--Bombs
				{
					patternName = "LavaLab2_Bombs",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 15,
				},
				--Lava
				{
					patternName = "LavaLab2_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},		
		},
		goals = {
			main = {"gemsRemain", 0, "Lava", "Lava", {specials = CascadePieceSpecials_Lava,}, "Remove",},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",300000},
				[3] = {"score",600000},
			},
		},
	},

	["LavaLab3"] = {
		levelName = "Lava Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true, 
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins8 = true, 
			gemTypes5 = true,

			hasCrates = true,
			hasBombs = true,
			hasLava = true,
			hasMakers = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			--Missing Squares
			useMissingSquares = true,
			missingSquares = {
				patternName = "TopCorners_large", 
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "Bomb Mix",
					delay = 0,
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 8,
					},
					{
						name = "Bomb1",
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						turnsToLoss = 10,
						weight = 8,
					},
					{
						name = "Bomb2",
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						turnsToLoss = 10,
						weight = 8,
					},
					{
						name = "Bomb3",
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						turnsToLoss = 10,
						weight = 8,
					},
					{
						name = "Bomb4",
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						turnsToLoss = 10,
						weight = 8,
					},
					{
						name = "Bomb5",
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						turnsToLoss = 10,
						weight = 8,
					},
				},
			},
			additionalInitialPatterns = { 
				--Stone
				{
					patternName = "LavaLab3_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				--Bombs
				{
					patternName = "LavaLab3_Bombs",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
				},
				--Lava
				{
					patternName = "LavaLab3_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Maker
				{
					patternName = "LavaLab3_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix"},
				},
			},	
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Bomb Mix",
						delay = -1,
					},
				},
			},	
		},
		goals = {
			main = {"gemsRemain", 0, "Lava", "Lava", {specials = CascadePieceSpecials_Lava,}, "Remove",},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",350000},
			},
		},
	},
--End Lava Lab Levels
--Bomb Lab Levels
	["BombLab1"] = {
	    levelName = "Da Bomb Lab",
		resource = "GameScreen_LabLevel",
		hidden = true,
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins3 = true, 
	        gemTypes4 = true,

	        hasBombs = true,
			hasJailedSquares = true,
	    },
	    tricks = World1Tricks,
	    boosts = World1Boosts,
	    Properties = {
	        additionalInitialPatterns = { 
	            --Bombs
				{
	                patternName = "BombLab1_JailedBombs",
	                isPatternSet = false,
	                applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
	                turnsToLoss = 25,
	            },
				--jails
				{
					patternName ="BombLab1_JailedBombs",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed - CascadePieceSpecial_CantCover,
				},
	        },
	    },      
	    goals = {
	        main = {"gemsRemain",0,"Bomb", "Bombs", {turnsToLoss = true,}, "Defuse"},
	        stars = {
	            [1] = {"score",140000},
	            [2] = {"score",700000},
	            [3] = {"score",1800000},
	        },
	    },
	},
	["BombLab2"] = {
	    levelName = "Da Bomb Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins4 = true, 
	        gemTypes5 = true,
	
	        hasCoverage = true,
			hasBombs  = true,
			hasMakers = true,
			hasPortals = true,
	    },
	    tricks = World1Tricks,
	    boosts = World1Boosts,
	    Properties = {
			gemsMoveDiagonally = false,
			additionalNamedMixes = {
				{
					name = "Bomb Mix",
					events = {
						[1] = {
							eventType = "population",
							comparator = "less",
							count = 8,
							newDelay = 0,
							gemType = {
								turnsToLoss = true,
							},
						},
						[2] = {
							eventType = "population",
							comparator = "greater",
							count = 8,
							newDelay = -1,
							gemType = {
								turnsToLoss = true,
							},
						}, 
						[3] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = true,
						}, 
					},
					delay = -1,
					{
						name= "Blue Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Green Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Purple Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Red Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Yellow Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
				},
				{
					name = "Gem Mix",
					delay = 0,
					{
						name = "Blue Gem",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 6,
					},
					{
						name = "Green Gem",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 6,
					},
					{
						name = "Purple Gem",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 6,
					},
					{
						name = "Red Gem",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 6,
					},
					{
						name = "Yellow Gem",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 6,
					},
					{
						name = "Wild Gem",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 1,
					},
				},
			},
			--Portals
			portals = {
				[1] = {{0,7}, {2,1}, "PortalEntrance_1", "PortalExit_1"},
				--[2] = {{1,7}, {5,0}, "PortalEntrance_1", "PortalExit_1"},
				[3] = {{2,7}, {6,2}, "PortalEntrance_1", "PortalExit_1"},
				--[4] = {{3,7}, {1,3}, "PortalEntrance_1", "PortalExit_1"},
				[5] = {{4,7}, {3,0}, "PortalEntrance_1", "PortalExit_1"},
				--[6] = {{5,7}, {0,0}, "PortalEntrance_1", "PortalExit_1"},
				[7] = {{6,7}, {4,2}, "PortalEntrance_1", "PortalExit_1"},
			},
	        additionalInitialPatterns = { 
	            --Bombs
				{
	                patternName = "BombLab2_Bombs",
	                isPatternSet = false,
	                applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
	                turnsToLoss = 10,
	            },
				--Bomb makers
				{
					patternName = "BombLab2_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix", "Gem Mix",},
				},
	        },
	    },      
	    goals = {
	        main = {"getGem", 30,"Bomb", "Bombs", {turnsToLoss = true,}, "Defuse"},
	        stars = {
	            [1] = {"score",290000},
	            [2] = {"score",1000000},
	            [3] = {"score",3250000},
	        },
	    },
	},
	["BombLab3"] = {
	    levelName = "Da Bomb Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins4 = true, 
	        gemTypes5 = true,
	
	        hasCoverage = true,
			hasBombs = true,
			hasMakers = true,
			hasChests = true,
			hasBarrels = true,
	    },
	    tricks = World1Tricks,
	    boosts = World1Boosts,
	    Properties = {
			additionalNamedMixes = {
				{
					name = "Bomb Mix",
					events = {
						[1] = {
							eventType = "population",
							comparator = "less",
							count = 8,
							newDelay = 0,
							gemType = {
								turnsToLoss = true,
							},
						},
						[2] = {
							eventType = "population",
							comparator = "greater",
							count = 8,
							newDelay = -1,
							gemType = {
								turnsToLoss = true,
							},
						}, 
						[3] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = true,
						}, 
					},
					delay = -1,
					{
						name= "Blue Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Green Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Purple Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Red Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Yellow Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 12,
						weight = 6,
					},
					{
						name = "Treasure Bomb",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						turnsToLoss = 15,
						weight = 4,
					},
					{
						name = "Boulder Bomb",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						turnsToLoss = 5,
						weight = 3,
					},
				},
				{
					name = "Gem Mix",
					delay = 0,
					{
						name = "Blue Gem",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 6,
					},
					{
						name = "Green Gem",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 6,
					},
					{
						name = "Purple Gem",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 6,
					},
					{
						name = "Red Gem",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 6,
					},
					{
						name = "Yellow Gem",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 6,
					},
					{
						name = "Wild Gem",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 1,
					},
				},
			},
	        additionalInitialPatterns = { 
	            --Bombs
				{
	                patternName = "BombLab2_Bombs",
	                isPatternSet = false,
	                applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
	                turnsToLoss = 10,
	            },
				--Bomb makers
				{
					patternName = "BombLab2_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix", "Gem Mix",},
				},
	        },
	    },      
	    goals = {
	        main = {"getGem", 30,"Bomb", "Bombs", {turnsToLoss = true,}, "Defuse"},
	        stars = {
	            [1] = {"score",180000},
	            [2] = {"score",850000},
	            [3] = {"score",1000000},
	        },
	    },
	},
	--End Bomb Lab Levels
	--Gem Eater Lab Levels	
	["GemEaterLab1"] = {
		levelName = "Gem Eater Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true,	 
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins4 = true, 
			gemTypes4 = true,

			hasGemEaters = true,
			hasBarrels = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			addToBoardPieceMix={
				{
				name = "Boulders",
				matchFlags = 0,
				specials = CascadePieceSpecials_Barrels,
				applyExtraHits = true,
				extraHits =1,
				weight = 5,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "GemEaterLab1_GemEaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
			},
			
		},
		goals = {
			main = {"getGem",16,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels, extraHits = 0,}, "Break"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",400000},
				[3] = {"score",650000},
			},
		},
	},
	["GemEaterLab2"] = {
		levelName = "Gem Eater Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,	 
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins6 = true, 
			gemTypes4 = true,

			hasGemEaters = true,
			hasBarrels = true,
			hasSteel = true,
			hasFences = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			addToBoardPieceMix={
				{
				name = "Boulders",
				matchFlags = 0,
				specials = CascadePieceSpecials_Barrels,
				applyExtraHits = true,
				extraHits =1,
				weight = 6,
				},
			},
			additionalInitialPatterns = { 
				[1] ={
					patternName = "GemEaterLab2_GemEaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				[2] = {
					patternName = "GemEaterLab2_Fences",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,

				},
				[3]= {
					patternName = "GemEaterLab2_Steel",
					isPatternSet= false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",13,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels, extraHits = 0,}, "Break"},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",150000},
				[3] = {"score",260000},
			},
		},
	},
	["GemEaterLab3"] = {
		levelName = "Gem Eater Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,	 
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins6 = true, 
			gemTypes4 = true,

			hasMakers = true,
			hasGemEaters = true,
			hasBarrels = true,
			hasStones = true,
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "GemEaterLab3_GemEaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				{
					patternName = "GemEaterLab3_Stones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "GemEaterLab3_ThickStones",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 3,
				},
				{
					patternName = "GemEaterLab3_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"MakerMix"},
				
				},
			},
			additionalNamedMixes={
				{
					name = "MakerMix",
					delay = 0,
					{
						name = "Boulders",
						specials = CascadePieceSpecials_Barrels,
						weight = 2,
						applyExtraHits = true,
					extraHits = 1,
					},
					{
						name = "Blue",
						matchFlags= CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "MakerMix",
						delay = -1,
					},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels, extraHits = 0,}, "Break"},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",750000},
			},
		},
	},
	--End Gem Eater Lab Levels
	--Begin Four Elements levels
	["FourElementsLab1"] = {
		levelName = "Four Elements Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins7 = true, 
			gemTypes5 = true,

			hasBarrels = true,
			hasIce = true,
			hasLava = true,
			hasBalloons = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalRegularPlacements = {
				--Boulders
				{
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					frequencies = {1, 1, 1},
					inactiveForInitialPlacement = true,
				},
			},
			additionalInitialPatterns = { 
				--Ice
				{
					patternName = "FourElementsLab1_Ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				--Lava
				{
					patternName = "FourElementsLab1_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Balloons
				{
					patternName = "FourElementsLab1_Balloons",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
			},
		},      
		goals = {
			main = {"getGem", 15, "Boulder", "Boulders", {specials = CascadePieceSpecials_Barrels}, "Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",100000},
				[3] = {"score",200000},
			},
		},
	},

	["FourElementsLab2"] = {
		levelName = "Four Elements Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins9 = true, 
			gemTypes5 = true,

			hasBarrels = true,
			hasIce = true,
			hasLava = true,
			hasBalloons = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalRegularPlacements = {
				--Boulders
				{
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					frequencies = {1, 1, 1},
					inactiveForInitialPlacement = true,
					--extraHits = 1,
				},
			},
			additionalInitialPatterns = { 
				--Boulders
				{
					patternName = "FourElementsLab2_Boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Ice
				{
					patternName = "FourElementsLab2_Ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				--Lava
				{
					patternName = "FourElementsLab2_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Balloons
				{
					patternName = "FourElementsLab2_Balloons",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
			},
		},      
		goals = {
			main = {"getGem", 17, "Boulder", "Boulders", {specials = CascadePieceSpecials_Barrels}, "Break"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
	},

	["FourElementsLab3"] = {
		levelName = "Four Elements Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins8 = true, 
			gemTypes5 = true,

			hasBarrels = true,
			hasIce = true,
			hasLava = true,
			hasBalloons = true,
			hasMakers = true,
			hasMissingReels = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			--Missing Reels
			useMissingReels = true,
			missingReels = {
				patternName = "EdgeReels", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				--Boulder Makers
				{
					patternName = "TopCorners",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulder Mix"},
				},
				--Balloon Makers
				{
					--makes above itself - FallUp
					patternName = "BottomCorners",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel + CascadePieceSpecial_FallUp,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon Mix"},
				},				
				--Ice
				{
					patternName = "FourElementsLab3_Ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				--Lava
				{
					patternName = "FourElementsLab3_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--Balloons
				{
					patternName = "FourElementsLab3_Balloons",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Balloon,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon,
				},
				--Boulders
				{
					patternName = "FourElementsLab3_Boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
			additionalNamedMixes = {
				{
					name = "Boulder Mix",
					delay = 0,
					{
						name = "Boulder",
						specials = CascadePieceSpecials_Barrels,
						weight = 6,
					},
				},
				{
					name = "Balloon Mix",
					delay = 0,
					{
						name = "Blue Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 6,
					},
					{
						name = "Green Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 6,
					},
					{
						name = "Purple Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 6,
					},
					{
						name = "Red Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 6,
					},
					{
						name = "Yellow Balloon",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
						weight = 6,
					},
				},
			}, 
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Boulder Mix",
						delay = -1,
					},
					{
						name = "Balloon Mix",
						delay = -1,
					},
				},
			},
		},  
		goals = {
			main = {"getGem", 20, "Boulder", "Boulders", {specials = CascadePieceSpecials_Barrels}, "Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},
	--End Four Elements levels
	--Begin Hole Lab Levels
	["HoleLab1"] = {
		levelName = "Hole Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true,   
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins4 = true, 
			gemTypes3 = true,

			hasCoverage = true,
			hasMissingSquares = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			--Missing Squares
			useMissingSquares = true,
			missingSquares = 
			{
					patternName = "HoleLab1_Missing", 
					isPatternSet = false,
			},
			additionalInitialPatterns = { 
				--Cloudy
				{
					patternName = "HoleLab1_Cloudy",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
			multiplyReelPieceMix = {
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 0.3,
				},
			},
		},      
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",600000},
				[3] = {"score",1000000},
			},
		},
	},

	["HoleLab2"] = {
		levelName = "Hole Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,  
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins4 = true, 
			gemTypes3 = true,

			hasCoverage = true,
			hasMissingSquares = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			--Missing Squares
			useMissingSquares = true,
			missingSquares = 
			{
					patternName = "HoleLab2_Missing", 
					isPatternSet = false,
			},
			additionalInitialPatterns = { 
				--Cloudy
				{
					patternName = "HoleLab2_Cloudy",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
			multiplyReelPieceMix = {
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 0.3,
				},
			},
		},      
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["HoleLab3"] = {
		levelName = "Hole Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins8 = true, 
			gemTypes3 = true,

			hasCoverage = true,
			hasMissingSquares = true,
			hasMissingReels = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			--Missing Squares
			useMissingSquares = true,
			missingSquares = 
			{
					patternName = "HoleLab3_Missing", 
					isPatternSet = false,
			},
			--Missing Reels
			useMissingReels = true,
			missingReels = {
				patternName = "HoleLab3_MissingReels", 
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				--Cloudy
				{
					patternName = "HoleLab3_Cloudy",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
			multiplyReelPieceMix = {
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 0.2,
				},
			},
		},      
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",350000},
				[3] = {"score",500000},
			},
		},
	},
	--End Hole Lab levels
	--Coconut Lab Levels
	["CoconutLab1"] = {
		levelName = "Coconut Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins6 = true,
			gemTypes4 = true,

			hasCoconuts = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			spawnGemOnBreak = {
				{
					name = "Blue Area Gem",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 10,
				},
				{
					name = "Green Horizon Gem",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 10,
				},
				{
					name = "Purple vertical Gem",
					matchFlags = CascadeMatchFlags_CommonPiece3, 
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 10,
				},
				{
					name = "Red Gem",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 10,
				}
			},
			additionalInitialPatterns = 
			{
				{
					patternName = "CoconutLab1_Coconut",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner =true,
					isGemSpawner = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					isGemSpawner = true,
					frequencies = {1, 2, 4, 5, 9, 12}, --# at i refers to how many turns game should wait before adding another Coconut if i Coconuts are already on the board
				},
			},
		},
		goals = {
			main = {"getGem", 12, "Coconut", "Coconuts", {specials = CascadePieceSpecials_Coconut,}, "Break"},
			stars = {
				[1] = {"score", 200000},
				[2] = {"score", 1000000},
				[3] = {"score", 2000000},
			},
		},
	},
	["CoconutLab2"] = {
		levelName = "Coconut Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins7 = true,
			gemTypes4 = true,

			hasCoconuts = true,
			hasIce = true,
			hasBombs = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
					{
						
						name = "Blue ICE",
						spreadSpecials = CascadePieceSpecials_Ice,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green Ice",
						spreadSpecials = CascadePieceSpecials_Ice,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple Ice",
						spreadSpecials = CascadePieceSpecials_Ice,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red Ice",
						spreadSpecials = CascadePieceSpecials_Ice,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
			},
			additionalInitialPatterns = 
			{
				{
					patternName = "CoconutLab1_Coconut",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Coconut,
					applyTurnsToLoss = true,
					turnsToLoss = 22,
					applyIsGemSpawner =true,
					isGemSpawner = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyTurnsToLoss = true,
					turnsToLoss = 22,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					frequencies = {1, 2, 3, 4, 8, 10}, --# at i refers to how many turns game should wait before adding another Coconut if i Coconuts are already on the board
				},
			},
		},
		goals = {
			main = {"getGem", 8, "Coconut Bomb", "Coconut Bombs", {specials = CascadePieceSpecials_Coconut, turnsToLoss = true,}, "Defuse"},
			stars = {
				[1] = {"score", 400000},
				[2] = {"score", 500000},
				[3] = {"score", 600000},
			},
		},
	},
	["CoconutLab3"] = {
		levelName = "Coconut Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			regularBoard = true,
			splashMode = true,
			modeSpins5 = true,
			gemTypes4 = true,

			hasCoconuts = true,
			hasIce = true,
			hasVines = true,
			hasLava = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
					{
						name = "Wild Vines",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 4,
					},
					{
						name = "Wild ICE",
						spreadSpecials = CascadePieceSpecials_Ice,
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 4,
					},
					{
						name = "Lava",
						specials = CascadePieceSpecials_Lava,
						matchFlags = 0,
						weight = 4,
					},
			},
			additionalInitialPatterns = 
			{
				{
					patternName = "CoconutLab3_Coconut",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner =true,
					isGemSpawner = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					frequencies = {1, 2, 3, 4, 8, 10}, --# at i refers to how many turns game should wait before adding another Coconut if i Coconuts are already on the board
				},
			},
		},
		goals = {
			main = {"getGem", 14, "Coconut", "Coconuts", {specials = CascadePieceSpecials_Coconut,}, "Open"},
			stars = {
				[1] = {"score", 300000},
				[2] = {"score", 600000},
				[3] = {"score", 1000000},
			},
		},
	},
	--Coconut Lab Level End

	
	--Begin Daniel Lab Levels
	
	["Minilab1"] = {
		levelName = "Double Trouble",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins4 = true,
			gemTypes3 = true,

			hasIce = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasMakers = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Minilab1_Missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "ReelPosition4",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					normalMix = { name = "NormalMix" }
					AddColorsToPieceMix(normalMix, {1, 2, 3}, {
						name = "Gem",
						weight = 30,
					})
					AddColorsToPieceMix(normalMix, {7},{
						name = "Wilds",
						weight = 10,
					})
					AddColorsToPieceMix(normalMix, {1, 2, 3, 7}, {
						name = "HBurst",
						specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_AreaSplash,
						weight = 1,
					})

					iceMix = {
						name = "IceMix",
						delay = 0,
						events = {
							{
								eventType = "population",
								comparator = "less",
								count = 1,
								gemType = {
									cancelSpecials = CascadePieceSpecials_Ice,
								},
								newDelay = 0,
							},
							{
								eventType = "emitCount",
								count = 1,
								reset = true,
								newDelay = -1,
							},
						}
					}
					AddColorsToPieceMix(iceMix, {1, 2, 3}, {
						name = "Ice",
						spreadSpecials = CascadePieceSpecials_Ice,
						cancelSpecials = CascadePieceSpecials_Ice,
					})

					vineMix = {
						name = "VineMix",
						delay = 0,
						events = {
							{
								eventType = "population",
								comparator = "less",
								count = 1,
								gemType = {
									cancelSpecials = CascadePieceSpecials_Vines,
								},
								newDelay = 0,
							},
							{
								eventType = "emitCount",
								count = 1,
								reset = true,
								newDelay = -1,
							},
						}
					}
					AddColorsToPieceMix(vineMix, {1, 2, 3}, {
						name = "Vines",
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
					})

					namedMixes = {
						normalMix, iceMix, vineMix
					}

					--logprint(SerializeToString(namedMixes))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "Minilab1_Maker1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"IceMix", "NormalMix"}
				},
				{
					patternName = "Minilab1_Maker2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"VineMix", "NormalMix"}
				},
			},
		},
		goals = {
			main = {"finish"},
			stars = {
				[1] = {"score", 100000},
				[2] = {"score", 150000},
				[3] = {"score", 200000},
			},
		},
	},

	
	["Minilab2"] = {
		levelName = "Triple Trouble",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins6 = true,
			gemTypes3 = true,

			hasIce = true,
			hasVines = true,
			hasLava = true,
			hasMakers = true,
			hasMissingSquares = true,

		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Minilab2_Missing",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					normalMix = { name = "NormalMix" }
					AddColorsToPieceMix(normalMix, {1, 2, 3, 7}, {
						name = "Gem",
						weight = 30,
					})
					AddColorsToPieceMix(normalMix, {1, 2, 3, 7}, {
						name = "HBurst",
						specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_AreaSplash,
					})
					AddColorsToPieceMix(normalMix, {1, 2, 3, 7}, {
						name = "VBurst",
						specials = CascadePieceSpecial_VerticalSplash | CascadePieceSpecial_AreaSplash,
					})

					iceMix = {
						name = "IceMix",
						delay = 0,
						events = {
							{
								eventType = "population",
								comparator = "less",
								count = 1,
								gemType = {
									cancelSpecials = CascadePieceSpecials_Ice,
								},
								newDelay = 0,
							},
							{
								eventType = "emitCount",
								count = 1,
								reset = true,
								newDelay = -1,
							},
						}
					}
					AddColorsToPieceMix(iceMix, {1, 2, 3}, {
						name = "Ice",
						spreadSpecials = CascadePieceSpecials_Ice,
						cancelSpecials = CascadePieceSpecials_Ice,
					})

					
					vineMix = {
						name = "VineMix",
						delay = 0,
						events = {
							{
								eventType = "population",
								comparator = "less",
								count = 1,
								gemType = {
									cancelSpecials = CascadePieceSpecials_Vines,
								},
								newDelay = 0,
							},
							{
								eventType = "emitCount",
								count = 1,
								reset = true,
								newDelay = -1,
							},
						}
					}
					AddColorsToPieceMix(vineMix, {1, 2, 3}, {
						name = "Ice",
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
					})

					namedMixes = {
						normalMix, iceMix, vineMix,
						{
							name = "LavaMix",
							delay = 0,
							events = {
								{
									eventType = "population",
									comparator = "less",
									count = 1,
									gemType = {
										specials = CascadePieceSpecials_Lava,
									},
									newDelay = 0,
								},
								{
									eventType = "emitCount",
									count = 1,
									reset = true,
									newDelay = -1,
								},
							},
							{
								name = "Lava",
								specials = CascadePieceSpecials_Lava,
								matchFlags = 0,
								weight = 1,
							}
						}
					}

					--logprint(SerializeToString(namedMixes))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "Minilab2_Maker1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"IceMix", "NormalMix"}
				},
				{
					patternName = "Minilab2_Maker2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"VineMix", "NormalMix"}
				},
				{
					patternName = "Minilab2_Maker3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"LavaMix", "NormalMix"}
				},
			},
			endGameProperties = {
				additionalNamedMixes = ExecuteInline(
					function ()
						normalMix = { name = "NormalMix" }
						AddColorsToPieceMix(normalMix, {1, 2, 3, 7}, {
							name = "Gem",
							weight = 10,
						})

						return {normalMix}
					end
				),
			},
		},
		goals = {
			main = {"finish"},
			stars = {
				[1] = {"score", 150000},
				[2] = {"score", 175000},
				[3] = {"score", 210000},
			},
		},
	},

	
	["Minilab3"] = {
		levelName = "Quadruple Trouble",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins4 = true,
			gemTypes3 = true,

			hasIce = true,
			hasVines = true,
			hasLava = true,
			hasBombs = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasMakers = true,

		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "Minilab3_Missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "ReelPosition4",
				isPatternSet = false,
			},
			additionalNamedMixes = ExecuteInline(
				function ()
					normalMix = { name = "NormalMix" }
					AddColorsToPieceMix(normalMix, {1, 2, 3, 7}, {
						name = "Gem",
						weight = 30,
					})
					AddColorsToPieceMix(normalMix, {1, 2, 3, 7}, {
						name = "HBurst",
						specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_AreaSplash,
					})

					bombMix = { 
						name = "BombMix",
						delay = 0,
						events = {
							{
								eventType = "population",
								comparator = "less",
								count = 4,
								gemType = {
									turnsToLoss = true,
								},
								newDelay = 0,
							},
							{
								eventType = "emitCount",
								count = 2,
								reset = true,
								newDelay = -1,
							},
						} 
					}
					AddColorsToPieceMix(bombMix, {1, 2, 3, 7}, {
						name = "Gem",
						weight = 15,
					})
					AddColorsToPieceMix(bombMix, {1, 2, 3, 7}, {
						name = "Bomb",
						turnsToLoss = 10,
						specials = CascadePieceSpecial_CantCover | CascadePieceSpecial_Valuable,
						weight = 15,
					})
					AddColorsToPieceMix(bombMix, {1, 2, 3, 7}, {
						name = "HBurst",
						specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_AreaSplash,
					})

					iceMix = {
						name = "IceMix",
						delay = 0,
						events = {
							{
								eventType = "population",
								comparator = "less",
								count = 1,
								gemType = {
									cancelSpecials = CascadePieceSpecials_Ice,
								},
								newDelay = 0,
							},
							{
								eventType = "emitCount",
								count = 1,
								reset = true,
								newDelay = -1,
							},
						}
					}
					AddColorsToPieceMix(iceMix, {1, 2, 3}, {
						name = "Ice",
						spreadSpecials = CascadePieceSpecials_Ice,
						cancelSpecials = CascadePieceSpecials_Ice,
					})

					
					vineMix = {
						name = "VineMix",
						delay = 0,
						events = {
							{
								eventType = "population",
								comparator = "less",
								count = 1,
								gemType = {
									cancelSpecials = CascadePieceSpecials_Vines,
								},
								newDelay = 0,
							},
							{
								eventType = "emitCount",
								count = 1,
								reset = true,
								newDelay = -1,
							},
						}
					}
					AddColorsToPieceMix(vineMix, {1, 2, 3}, {
						name = "Ice",
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
					})

					namedMixes = {
						normalMix, iceMix, vineMix, bombMix,
						{
							name = "LavaMix",
							delay = 0,
							events = {
								{
									eventType = "population",
									comparator = "less",
									count = 1,
									gemType = {
										specials = CascadePieceSpecials_Lava,
									},
									newDelay = 0,
								},
								{
									eventType = "emitCount",
									count = 1,
									reset = true,
									newDelay = -1,
								},
							},
							{
								name = "Lava",
								specials = CascadePieceSpecials_Lava,
								matchFlags = 0,
								weight = 1,
							}
						}
					}

					--logprint(SerializeToString(namedMixes))

					return namedMixes
				end
			),
			additionalInitialPatterns = {
				{
					patternName = "Minilab3_Maker1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"IceMix", "NormalMix"}
				},
				{
					patternName = "Minilab3_Maker2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"BombMix", "NormalMix"}
				},
				{
					patternName = "Minilab3_Maker3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"LavaMix", "NormalMix"}
				},
				{
					patternName = "Minilab3_Maker4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"VineMix", "NormalMix"}
				},
			},
			endGameProperties = {
				additionalNamedMixes = ExecuteInline(
					function ()
						normalMix = { name = "NormalMix" }
						AddColorsToPieceMix(normalMix, {1, 2, 3, 7}, {
							name = "Gem",
							weight = 10,
						})

						bombMix = { name = "BombMix" }
						AddColorsToPieceMix(bombMix, {1, 2, 3, 7}, {
							name = "Gem",
							weight = 10,
						})

						return {normalMix, bombMix}
					end
				),
			},
		},
		goals = {
			main = {"finish"},
			stars = {
				[1] = {"score", 550000},
				[2] = {"score", 750000},
				[3] = {"score", 1000000},
			},
		},
	},

	
	["BonusLab1"] = {
		levelName = "Bonus Lab 1",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Wilds",
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 1,
					},
					cooldowns = {0, -1, -1, -1},
					events = {
						{
							eventType = "emitCount",
							count = 6,
							newDelay = -1,
							reset = true,
							setCooldowns = {0, 1, -1, -1},
						},
						{ -- Spin 1
							eventType = "spin",
							setCooldowns = {0, -1, 1, -1},
						},
						{ -- Spin 2
							eventType = "spin",
							setCooldowns = {0, -1, -1, 1},
						},
						{ -- Spin 3
							eventType = "spin",
							setCooldowns = {0, -1, -1, -1},
							newDelay = 0,
						},
					},
				},
			},
			reelMixes = {"Wilds", "ReelDefaultMix"},
		},
		goals = {
			main = {"finish"},
			stars = {
				[1] = {"score",225000},
				[2] = {"score",275000},
				[3] = {"score",350000},
			},
		},
	},

	
	["BonusLab2"] = {
		levelName = "Bonus Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes6 = true,
			largeBoard = true,
			hasOrangeGems = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Wilds",
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 1,
					},
					cooldowns = {0, -1, -1, -1, -1},
					events = {
						{
							eventType = "emitCount",
							count = 7,
							newDelay = -1,
							reset = true,
							setCooldowns = {0, 1, -1, -1, -1},
						},
						{ -- Spin 1
							eventType = "spin",
							setCooldowns = {0, -1, 1, -1, -1},
						},
						{ -- Spin 2
							eventType = "spin",
							setCooldowns = {0, -1, -1, 1, -1},
						},
						{ -- Spin 3
							eventType = "spin",
							setCooldowns = {0, -1, -1, -1, 1},
						},
						{ -- Spin 4
							eventType = "spin",
							setCooldowns = {0, -1, -1, -1, -1},
							newDelay = 0,
						},
					},
				},
			},
			reelMixes = {"Wilds", "ReelDefaultMix"},
		},
		goals = {
			main = {"finish"},
			stars = {
				[1] = {"score",560000},
				[2] = {"score",600000},
				[3] = {"score",725000},
			},
		},
	},
	
	["BonusLab3"] = {
		levelName = "Bonus Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasMissingSquares = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "BonusLab3_Missing",
				isPatternSet = false,
			},
			additionalNamedMixes = {
				{
					name = "Wilds",
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 1,
					},
					cooldowns = {0, -1, -1, -1, -1},
					events = {
						{
							eventType = "emitCount",
							count = 7,
							newDelay = -1,
							reset = true,
							setCooldowns = {0, 1, -1, -1, -1},
						},
						{ -- Spin 1
							eventType = "spin",
							setCooldowns = {0, -1, 1, -1, -1},
						},
						{ -- Spin 2
							eventType = "spin",
							setCooldowns = {0, -1, -1, 1, -1},
						},
						{ -- Spin 3
							eventType = "spin",
							setCooldowns = {0, -1, -1, -1, 1},
						},
						{ -- Spin 4
							eventType = "spin",
							setCooldowns = {0, -1, -1, -1, -1},
							newDelay = 0,
						},
					},
				},
			},
			reelMixes = {"Wilds", "ReelDefaultMix"},
		},
		goals = {
			main = {"finish"},
			stars = {
				[1] = {"score",215000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	--End Daniel Lab Levels

	--Barrel Labs
	["BarrelLab1"] = {
		levelName = "Lockbox",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
            reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Blue 2",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple 2",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red 2",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow 2",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 10,
				},
			},
			spawnGemOnBreak = {
				{ 
					name = "lock",
					matchFlags = 0,
					specials = CascadePieceSpecials_Lock,
					weight = 3,
				},
				{
					name = "Treasure 1",
					specials = CascadePieceSpecials_Treasure,
					weight = 3,
				},
				{
					name = "Treasure 2",
					specials = CascadePieceSpecials_Treasure,
					weight = 3,
				},
				{
					name = "Treasure 3",
					specials = CascadePieceSpecials_Treasure,
					weight = 3,
				},
				{
					name = "Treasure 4",
					specials = CascadePieceSpecials_Treasure,
					weight = 3,
				},
			},
		},
		goals = {
			main = {"getGem",7,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",250000},
			},
		},
	},

	["BarrelLab2"] = {
		levelName = "Falling Stars",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
            hasMissingReels = true,
            hasCoverage = true,
			hasLasers = true,
			hasMissingSquares = true, 
			hasBarrelsOfFun = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			 reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Blue 2",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple 2",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red 2",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow 2",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 10,
				},
			},
			spawnGemOnBreak = {
				{ 
					name = "Boulder",
					applyExtraHits = true,
					extraHits = 1,
					specials = CascadePieceSpecials_Barrels,
					weight = 10,
				},
				{
					name = "Treasure 1",
					specials = CascadePieceSpecials_Treasure,
					weight = 5,
				},
				{
					name = "Treasure 2",
					specials = CascadePieceSpecials_Treasure,
					weight = 6,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 5,
				},
				{
					name = "Jail 1",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
				{
					name = "Jail 2",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 2,
				},
			},
		additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
					useMissingReels = true,
					missingReels = {
					patternName = "PheReels", 
					isPatternSet = false,
            },
					useMissingSquares = true,
					missingSquares = {
					patternName = "TestPatternPhe", 
					isPatternSet = false,
			},
			additionalNamedMixes = {
               [1] = {
					name = "Laser1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser1",},
						weight = 1,
					},
				},
				[2] = {
					name = "Laser2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser2",},
						weight = 1,
					},
				},
				[3] = {
					name = "Laser3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser3",},
						weight = 1,
					},
				},
				[4] = {
					name = "Laser4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser4",},
						weight = 1,
					},
				},
				[5] = {
					name = "Laser5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser5",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Laser1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[2] = {
						name = "Laser2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[3] = {
						name = "Laser3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[4] = {
						name = "Laser4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[5] = {
						name = "Laser5",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser5",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LaserWall_Laser1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser1",},
				},
				[2] = {
					patternName = "LaserWall_Laser3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
				[3] = {
					patternName = "LaserWall_Laser5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser5",},
				},
				[4] = {
					patternName = "LaserWall_Laser7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
				},
				[5] = {
					patternName = "TestLevel_Lasers2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
			},
		},		
	goals = {
			main = {"getGem",6,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",1150000},
				[3] = {"score",1300000},
			},
		},
	},

	["BarrelLab3"] = {
		levelName = "Molten Glass",
		resource = "GameScreen_LabLevel",
		hidden = true,		
		Features = {
			splashMode = true,
			hasVines = true,
			hasStones = true,
			modeSpins10 = true, --9 before Operation Easy
			largeBoard = true,
			gemTypes5 = true, 
			hasSteelGlass = true,
			hasBarrelsOfFun = true
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World5Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "Windowbox_Glass",
				isPatternSet = false,
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
				},
				{
					name = "Blue 2",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple 2",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red 2",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Yellow 2",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 10,
				},
			},
			spawnGemOnBreak = {
				{
					name = "Vines 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					weight = 1,
				},
				{
					name = "Treasure 1",
					specials = CascadePieceSpecials_Treasure,
					weight = 3,
				},
				{
					name = "Treasure 2",
					specials = CascadePieceSpecials_Treasure,
					weight = 3,
				},
				{
					name = "Treasure 3",
					specials = CascadePieceSpecials_Treasure,
					weight = 3,
				},
				{
					name = "Lava 1",
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
					weight = 12,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Laser1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser1",},
						weight = 1,
					},
				},
				[2] = {
					name = "Laser2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser2",},
						weight = 1,
					},
				},
				[3] = {
					name = "Laser3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser3",},
						weight = 1,
					},
				},
				[4] = {
					name = "Laser4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser4",},
						weight = 1,
					},
				},
				[5] = {
					name = "Laser5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser5",},
						weight = 1,
					},
				},
			},
		endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Laser1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[2] = {
						name = "Laser2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[3] = {
						name = "Laser3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[4] = {
						name = "Laser4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[5] = {
						name = "Laser5",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser5",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LaserWall_Laser1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser1",},
				},
				[2] = {
					patternName = "LaserWall_Laser3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
				[3] = {
					patternName = "LaserWall_Laser5",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser5",},
				},
				[4] = {
					patternName = "LaserWall_Laser7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
				},
				[5] = {
					patternName = "OuterBlock_midcenter_Phelan",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
				[6] = {
					patternName = "OuterBlock_middle_Phelan",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},		
		goals = {
			main = {"getGem",7,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",850000},
				[3] = {"score",1000000},
			},
		},
	},
	--End Barrel Labs


	--Staff pick event copies
	["Continuation_Copy"] = {
		levelName = "The Biggest Spin",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
			modeSpins1 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = {
			{name = Config.World4Tricks_Trick1},
			{name = Config.World4Tricks_Trick2},
			{name = Config.World4Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World4Boosts,
		Properties = {
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",4000000},
			},
		},
		expectedScore = 100000,
	},
	
	["ShootingGallery_Copy"] = {
		levelName = "Shooting Gallery",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasMakers = true,
			hasBarrels = true,
			hasGemEaters = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "ShootingGallery_missing", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "EdgeReels_left3", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "Laser1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser1",},
						weight = 1,
					},
				},
				[2] = {
					name = "Laser2",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser2",},
						weight = 1,
					},
				},
				[3] = {
					name = "Laser3",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser3",},
						weight = 1,
					},
				},
				[4] = {
					name = "Laser4",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser4",},
						weight = 1,
					},
				},
				[5] = {
					name = "Laser5",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Laser5",},
						weight = 1,
					},
				},
				[6] = {
					name = "Always Barrel",
					delay = 0,
					{
						name = "Barrel",
						weight = 3,
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						spawnTypes = {"Always Orange",},
					},
				},
				[7] = {
					name = "Always Orange",
					delay = 0,
					{
						name = "Normal Gem 6",
						weight = 11,
						matchFlags = CascadeMatchFlags_CommonPiece6,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Laser1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser1",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[2] = {
						name = "Laser2",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser2",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[3] = {
						name = "Laser3",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser3",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[4] = {
						name = "Laser4",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser4",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[5] = {
						name = "Laser5",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser5",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "BuriedTreasure_LeftColumn_bottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"Always Orange"},
				},
				{
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Barrel"},
				},
				{
					patternName = "Spider_Lava",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "JailedBurst Test Jail",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
				},
				{
					patternName = "JailBroken_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
				{
					patternName = "JailBroken2_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser4",},
				},
				{
					patternName = "JailedBurst Test VerticalBurst",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece5,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser5",},
				},
				{
					patternName = "ShootingGallery_laser6",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser1",},
				},
				{
					patternName = "ShootingGallery_laser7",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser2",},
				},
				{
					patternName = "FlowerPot1_seed1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"Laser3",},
				},
			},
		},
		goals = {
			main = {"getGem",5,"Orange","Oranges",{matchFlags = CascadeMatchFlags_CommonPiece6},"Destroy"},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
	},

	["Rube2_Copy"] = {
		levelName = "Goldberg's Revenge",
		hidden = true,
		resource = "GameScreen_LabLevel",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasChests = true,
			hasStones = true,
			hasMakers = true,
			hasFences = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasSteel = true,
		},
		tricks = World18Tricks,
		boosts = World18Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "RubeMissing", 
				isPatternSet = false,
			},
			useMissingReels = true,
            missingReels = {
				patternName = "RubeReels", 
				isPatternSet = false,
            },
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Vertical",
						delay = -1,
					},
					[2] = {
						name = "Horizontal",
						delay = -1,
					},
					[3] = {
						name = "Area Burst",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Vertical",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
				},
				[2] = {
					name = "Horizontal",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
				},
				[3] = {
					name = "Area Burst",
					delay = 0,
					{
						name = "Blue Burst",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Green Burst",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Purple Burst",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
					{
						name = "Red Burst",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
				},
				[4] = {
					name = "Regular Mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "RubeMakersRegular",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix"},
				},
				[2] = {
					patternName = "RubeMakersA",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Area Burst"},
				},
				[3] = {
					patternName = "RubeMakersH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Horizontal"},
				},
				[4] = {
					patternName = "RubeMakersV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Vertical"},
				},
				[5] = {
					patternName = "RubeSteel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[6] = { 
					patternName = "RubeChest",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				[7] = {
					patternName = "RubeStone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[8] = {
					patternName = "RubeFences",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				[9] = {
					patternName = "RubePlaceH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
				[10] = {
					patternName = "RubePlaceV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_VerticalSplash,
				},
				[11] = {
					patternName = "RubePlaceA",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_AreaSplash,
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",700000},
				[3] = {"score",1000000},
			},
		},
	},
	
	["Land15Side4_side_Copy"] = {
		levelName = "Coconut Canopy",		
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			modeSpins7 = true,
			gemTypes5 = true,
			splashMode = true,
			largeBoard = true,
			hasCoconuts = true,
			hasVines = true,
		},
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "15-4_Vines",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,

					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
				{
					patternName = "15-4_Coconuts",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Coconut,

					applyMatchFlags = true,
					matchFlags = 0,

					applySpawnTypes = true,
					spawnTypes = {"CoconutDrop"},
				},
			},
			additionalNamedMixes = {
				{
					name = "CoconutDrop",
					{
						name = "VSplash",
						weight = 1,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash,
					},
				},
			},
		},
		goals = {
			main = {"getGem",5,"Coconut","Coconuts",{specials = CascadePieceSpecials_Coconut},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",275000},
				[3] = {"score",700000},
			},
		},
	},

	["WaffleIron_Copy"] = {
		levelName = "Waffle Iron",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			hasMissingSquares = true,
			gemTypes3 = true,
			hasCoverage = true,
		},
		tricks = World6Tricks,
		boosts = World6Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "WaffleIron_Missing", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "WaffleIron_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 4,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",500000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000,
	},

	["TrickLevel_Copy"] = {
		levelName = "Deceptively Hard",
		resource = "GameScreen_LabLevel",
		hidden = true,
		introScript = "Land6_Tip2",
		Features = {
			splashMode = true,
			modeSpins2 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasCoverage = true,
		},
		tricks = {
			{name = Config.World6Tricks_Trick1},
			{name = Config.World6Tricks_Trick2},
			{name = Config.World6Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World7Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = { --A single, easily-accessed tile to end the level.
					patternName = "Silo1_seed",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",2000000},
				[2] = {"score",3000000},
				[3] = {"score",4000000},
			},
		},
		expectedScore = 100000,
	},
	["FillTheTank_Copy"] = {
		levelName = "Fill the Tank",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			splashMode = true,
			modeSpins9 = true,
			hasCoverage = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSteel = true,
			hasCrates = true,
			hasMakers = true,
		},
		tricks = TricksDefault,  --was: Tricks_SpinNow,
		boosts = World24Boosts,
		Properties = {
			portals = {
				[1] = {{0,3},{0,5},"PortalEntrance_1","PortalExit_1"},
				[2] = {{6,3},{6,5},"PortalEntrance_1","PortalExit_1"},
				[3] = {{3,3},{3,5},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Gem-Crate Mix",
					delay = 0,
					{ 
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 1,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2.5,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2.5,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2.5,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2.5,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "FillTheTank_makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Gem-Crate Mix"},
				},
				{
					patternName = "FillTheTank_crates",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				{
					patternName = "BigCratePattern9",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				{
					patternName = "Bottom3_large",
					clearPieces = true,
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000,
	},

	--BEGIN VineLab1
	["VineLab1"] = {
	    levelName = "Weed Wackier", 
	    resource = "GameScreen_LabLevel",
		hidden = true,
	    Features = {
	        largeBoard = true,
	        splashMode = true,
	        modeSpins4 = true, 
	        gemTypes3 = true,
	
	        hasVines = true,
			hasStones = true, 
	    },
	    tricks = World1Tricks,
	    boosts = World1Boosts,
	    Properties = {
		useMissingSquares = true,
		missingSquares = {
	                patternName = "VineLab1_Missing",
	                isPatternSet = false,
	            },
	        additionalInitialPatterns = { 
				[1] = {
					patternName = "VineLab1_ColorBlock",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
	
				[2] = {
					patternName = "VineLab1_ColorBottom",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
	
				
				[3] = {
					patternName = "VineLab1_Boulders",
					isPatternSet = false,
						
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
				},
				[4] = {
					patternName = "VineLab1_MultiHitStones",
					isPatternSet = false,
						
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
				},
				[5] = {
					patternName = "VineLab1_Vines", 
	                isPatternSet = false, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
				[6] = {
					patternName = "Large 7,1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[7] = {
					patternName = "Large 7,3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[8] = {
					patternName = "Large 7,5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[9] = {
						patternName = "VineLab1_Walls",
						isPatternSet = false,
						
						applyPieceSpecials = true,
						applyMatchFlags = true,
						specials = CascadePieceSpecials_Steel,
						matchFlags = 0,
					},
	        },
	    },      
	    goals = {
	        main = {"gemsRemain",0,"Vine","Vines",{specials = CascadePieceSpecials_Vines},},
	        stars = {
	            [1] = {"score",70000},
	            [2] = {"score",80000},
	            [3] = {"score",100000},
	        },
	    },
	},
	--END VineLab1

	--BEGIN VineLab2
	["VineLab2"] = { 
		levelName = "Twist of Fate", 
		resource = "GameScreen_LabLevel", 
		hidden = true,
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins7 = true,
			gemTypes4 = true, 

			hasVines = true,
			hasColoredKeyGems = true,
			hasBedrock = true,
			hasStones = true,
			hasLocks = true,
         
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
		
				additionalNamedPatterns = {
					[1] = {
						entryName = "Remove Bottom Spiral",
						patternName = "BottomHalfOpenSpiral_Big",
						isPatternSet = false,
						clearPieces = true,
					},
					[2] = {
						entryName = "Remove Top Spiral",
						patternName = "TopHalfOpenSpiral_Big",
						isPatternSet = false,
						clearPieces = true,
					},
			
				},
			
        
			additionalInitialPatterns = { 
				[1] = { 
					patternName = "TopHalfOpenSpiral_Big",
						isPatternSet = false,
						applyIcon = true,
						icon = "Icon_GemBlue",
						applyMatchFlags = true,
						matchFlags = 0,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "BedRock",
						applySkinVariant = true,
				},
				[2] = {
					patternName = "PartialInverseSpiral_Big_Vines", 
					isPatternSet = false, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
				[3] = {
					patternName = "BottomHalfOpenSpiral_Big", 
					isPatternSet = false, 
					applyMatchFlags = false,
					applyPieceSpecials = true,
					applyCancelSpecials = true,
				
				},

				[4] = {
					patternName = "PartialInverseSpiral_Big_1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[5] = {
					patternName = "PartialInverseSpiral_Big_2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[6] = {
					patternName = "PartialInverseSpiral_Big_3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[7] = {
					patternName = "PartialInverseSpiral_Big_4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[8] = {
						patternName = "BottomHalfOpenSpiral_Big",
						isPatternSet = false,
						applyIcon = true,
						icon = "Icon_GemBlue",
						applyMatchFlags = true,
						matchFlags = 0,
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "BedRock",
						applySkinVariant = true,
					},
				[9] = {
						patternName = "Large 4,3",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyMatchPatterns = true,
						matchPatterns = {"Remove Bottom Spiral", "Remove Top Spiral"},
					
					},
				[10] = {
					patternName = "SpiralLocks_Big", 
					isPatternSet = false, 
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					extraHits = 1,
					applyExtraHits = true,
					matchFlags = 0,

				},
				[11] = {
					patternName = "Spiral_LastVines", 
					isPatternSet = false, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
			},
				addToReelPieceMix = {
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard, 
						weight = 2,  
					},

				}

		},      
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{specials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",550000},
				[3] = {"score",925000},
			},
		},
	},
	--END VineLab2

	--BEGIN VineLab3
	["VineLab3"] = { 
		levelName = "Blooming Entombing",
		resource = "GameScreen_LabLevel",
		hidden = true,
		Features = {
			largeBoard = true,
			splashMode = true,
			modeSpins7 = true, 
			gemTypes5 = true,

			hasVines = true,
			hasBarrels = true,
			hasStones = true,
			hasBedrock = true,
			hasColoredKeyGems = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			addToBoardPieceMix = {
				{
					name = "Blue BurstH",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = .25,
				},
				{
					name = "Green BurstH",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = .25,
				},
				{
					name = "Purple BurstH",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = .25,
				},
				{
					name = "Red BurstH",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = .25,
				},
				{
					name = "Yellow BurstH",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = .25,
				},
				{
					name = "Blue BurstV",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = .25,
				},
				{
					name = "Green BurstV",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = .25,
				},
				{
					name = "Purple BurstV",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = .25,
				},
				{
					name = "Red BurstV",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = .25,
				},
				{
					name = "Yellow BurstV",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = .25,
				},
				{
					name = "Blue BurstA",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = .25,
				},
				{
					name = "Green BurstA",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = .25,
				},
				{
					name = "Purple BurstA",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = .25,
				},
				{
					name = "Red BurstA",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = .25,
				},
				{
					name = "Yellow BurstA",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = .25,
				},
			},
			additionalNamedPatterns = {
					[1] = {
						entryName = "Bottom Bedrock",
						patternName = "VineLab3_BedRockBottom",
						isPatternSet = false,
						clearPieces = true,
					},
					[2] = {
						entryName = "Lid1",
						patternName = "VineLab3_BedRockLid1",
						isPatternSet = false,
						clearPieces = true,
					},
					[3] = {
						entryName = "Lid2",
						patternName = "VineLab3_BedRockLid2",
						isPatternSet = false,
						clearPieces = true,
					},
					[4] = {
						entryName = "Lid3",
						patternName = "VineLab3_BedRockLid3",
						isPatternSet = false,
						clearPieces = true,
					},
					[5] = {
						entryName = "Lid4",
						patternName = "VineLab3_BedRockLid4",
						isPatternSet = false,
						clearPieces = true,
					},

			
				},
			
		
			additionalInitialPatterns = { 
				[1] = {
					patternName = "VineLab3_BedRockBottom",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemYellow",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},

				[2] = {
					patternName = "VineLab3_VineRoof",
					isPatternSet = false, 
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},

			
				[3] = {
					patternName = "VineLab3_StartingBoulders",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Barrels,
					matchFlags = 0,
				},
				[4] = {
					patternName = "VineLab3_BedRockLid1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[5] = {
					patternName = "VineLab3_BedRockLid2", 
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[6] = {
					patternName = "VineLab3_BedRockLid3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[7] = {
					patternName = "VineLab3_BedRockLid4",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[8] = {
						patternName = "VineLab3_BedRockAxe1",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyMatchPatterns = true,
						matchPatterns = {"Lid1"},
					},
				[9] = {
						patternName = "VineLab3_BedRockAxe2",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyMatchPatterns = true,
						matchPatterns = {"Lid2"},
					},
				[10] = {
						patternName = "VineLab3_BedRockAxe3",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyMatchPatterns = true,
						matchPatterns = {"Lid3"},
					},
				[11] = {
						patternName = "VineLab3_BedRockAxe4",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyMatchPatterns = true,
						matchPatterns = {"Lid4"},
					},
			
				[12] = {
						patternName = "VineLab3_BedRockPrize1",
						isPatternSet = false,
						matchFlags = CascadeMatchFlags_Wildcard,
						applyMatchFlags = true,
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					},
				[13] = {
						patternName = "VineLab3_BedRockPrize2",
						isPatternSet = false, 
						applyPieceSpecials = true,
						specials = CascadePieceSpecials_Vines,
						applyCancelSpecials = true,
						cancelSpecials = CascadePieceSpecials_Vines,
					},
				[14] = {
						patternName = "VineLab3_BedRockPrize3",
						isPatternSet = false,	
						applyPieceSpecials = true,
						applyMatchFlags = true,
						specials = CascadePieceSpecials_Barrels,
						matchFlags = 0,
					},
				[15] = {
					
						patternName = "VineLab3_BedRockPrize4",
						isPatternSet = false,
						applyMatchFlags = true,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						applyPieceSpecials = true,
						specials = CascadePieceSpecial_CantCover,
						applyIcon = true,
						icon = "Icon_PickAxe",
						applyMatchPatterns = true,
						matchPatterns = {"Bottom Bedrock"},
					},
				[16] = {
					patternName = "VineLab3_StartingStones",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
				},

			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					frequencies = {1,1,1},
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Blue BurstH",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = .25,
					},
					{
						name = "Green BurstH",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = .25,
					},
					{
						name = "Purple BurstH",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = .25,
					},
					{
						name = "Red BurstH",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = .25,
					},
					{
						name = "Yellow BurstH",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = .25,
					},
				},
			},
		},      
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{specials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",750000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},
	--END VineLab3
	--Begin Yellow Lab
	["YellowLab1"] = {
		levelName = "Mellow Yellow",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
			hasPatternGems = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			 reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Mix"},
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Mix"},
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Mix"},
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Mix"},
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Ring Mix"},
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					spawnTypes = {"Yellow Mix"},
					weight = 13,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
			additionalNamedMixes = {
				{
					name = "Ring Mix",
                    delay = 0,
					{
                        name = "BlueMarked",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 2,
                        icon = "Icon_Marked",
                    },
                    {
                        name = "GreenMarked",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 2,
                        icon = "Icon_Marked",
                    },
                    {
                        name = "PurpleMarked",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 2,
                        icon = "Icon_Marked",
                    },
                    {
                        name = "RedMarked",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 2,
                        icon = "Icon_Marked",
                    },
				},
				{
					name = "Yellow Mix",
                    delay = 0,
					{
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 5,
                    },
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 1,
					},
				},
			},
		},		
	goals = {
			main = {"getGem",10,"Ring","Rings",{icon = "Icon_Marked",},"Collect"},
			stars = {
				[1] = {"score",2000000},
				[2] = {"score",4000000},
				[3] = {"score",6000000},
			},
		},
	},
	["YellowLab2"] = {
		levelName = "Laser Lemon",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMissingSquares = true, 
			hasBarrelsOfFun = true,
			hasLasers = true,
			hasStones = true,
			hasBombs = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "YellowLab2_missing", 
				isPatternSet = false,
			},
			reelPieceMix = {
				{
					name = "Blue Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Mix"},
				},
				{
					name = "Green Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Mix"},
				},
				{
					name = "Purple Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Mix"},
				},
				{
					name = "Red Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Mix"},
				},
				{
					name = "Yellow Barrel",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_ColorBarrels,
					isGemSpawner = true,
					weight = 13,
					spawnTypes = {"Yellow Bomb Mix"},
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 4,
				},
			},
			additionalNamedMixes = {
				{
					name = "Yellow Mix",
                    delay = 0,
					{
                        name = "Yellow",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 5,
                    },
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 1,
					},
				},
				{
					name = "Yellow Bomb Mix",
                    delay = 0,
					{
                        name = "Yellow Bomb",
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 5,
                    },
				},
				{
					name = "LaserV",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
				{
					name = "LaserH",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "YellowLab2_laserV",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				{
					patternName = "YellowLab2_laserH",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				{
					patternName = "YellowLab2_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 3,
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV",},
							weight = 1,
							skinVariant = "LaserV",
						},
					},
					{
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "LaserH",
						},
					},
				},
			},
		},		
		goals = {
			main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone,},},
			stars = {
				[1] = {"score",2000000},
				[2] = {"score",4000000},
				[3] = {"score",6000000},
			},
		},
	},
	--End Yellow Lab
	--Begin Safe Lab
	["SafeLab1"] = {
		levelName = "Safe in the Lab",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes4 = true,

			hasSafes =true, 
			hasIce = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			multiplyReelPieceMix = {
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 1.4,
				},
			},
			additionalNamedMixes = ExecuteInline(
					function()
				
					local exampleNamedMixes = {
						{
							name = "IceMix",
							{
								name = "BlueIce",
								matchFlags = CascadeMatchFlags_CommonPiece1,
								spreadSpecials = CascadePieceSpecials_Ice,
								cancelSpecials = CascadePieceSpecials_Ice,
								weight = 1,
							},
							{
								name = "GreenIce",
								matchFlags = CascadeMatchFlags_CommonPiece2,
								spreadSpecials = CascadePieceSpecials_Ice,
								cancelSpecials = CascadePieceSpecials_Ice,
								weight = 1,
							},
							{
								name = "PurpleIce",
								matchFlags = CascadeMatchFlags_CommonPiece3,
								spreadSpecials = CascadePieceSpecials_Ice,
								cancelSpecials = CascadePieceSpecials_Ice,
								weight = 1,
							},
							{
								name = "RedIce",
								matchFlags = CascadeMatchFlags_CommonPiece4,
								spreadSpecials = CascadePieceSpecials_Ice,
								cancelSpecials = CascadePieceSpecials_Ice,
								weight = 1,
							},
							--Uncomment if you want yellow gems in ice mix
							--{
							--	name = "YellowIce",
							--	matchFlags = CascadeMatchFlags_CommonPiece5,
							--	spreadSpecials = CascadePieceSpecials_Ice,
							--	cancelSpecials = CascadePieceSpecials_Ice,
							--	weight = 1,
							--},
						},
					}
				
					table.insertall(exampleNamedMixes, MakeRandomSafe({{1,2,3,4}, {1,2,3,4}}, "IceSafes", "IceMix"))
					return exampleNamedMixes
					end
			),
			additionalInitialPatterns = { 
				--Safes
				{
					patternName = "SafeLab1_Safes", 
					isPatternSet = false,
					replacePieces = {"IceSafes_Step0"},
				},
				--Ice
				{
					patternName = "SafeLab1_Ice",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Ice,
				},
			},

		},		
	goals = {
			main = {"getGem", 4, "Safe", "Safes", {specials = CascadePieceSpecials_Safe|CascadePieceSpecial_Valuable}, "Open"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",1000000},
			},
		},
	},
	["SafeLab2"] = {
		levelName = "Safe in the Lab 2",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,

			--hasAmber = true,
			hasOrangeGems =true,
			hasIce =true,
			hasVines = true,
			hasBalloons = true,
			hasBombs = true,
			hasLava = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline(
					function()
				
					local exampleNamedMixes = {
						{
							name = "DangerMix",
							{
								name = "BlueIce",
								matchFlags = CascadeMatchFlags_CommonPiece1,
								spreadSpecials = CascadePieceSpecials_Ice,
								cancelSpecials = CascadePieceSpecials_Ice,
								weight = 1,
							},
							{
								name = "GreenVines",
								matchFlags = CascadeMatchFlags_CommonPiece2,
								specials = CascadePieceSpecials_Vines, 
								cancelSpecials = CascadePieceSpecials_Vines,
								weight = 1,
							},
							{
								name = "PurpleBombs",
								matchFlags = CascadeMatchFlags_CommonPiece3,
								specials =  CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
								turnsToLoss = 13,
								weight = 1,
							},
							{
								name = "RedLava",
								matchFlags = 0,
								specials = CascadePieceSpecials_Lava,
								weight = 1,
							},
							--use if yellow gems are in mix
							{
								name = "YellowBalloon",
								matchFlags = CascadeMatchFlags_CommonPiece5,
								specials = CascadePieceSpecials_Balloon,
								cancelSpecials = CascadePieceSpecials_Balloon,
								weight = 1,
							},
							--USE if orange gems are in mix
							--{
							--	name = "OrangeAmber",
							--	matchFlags = CascadeMatchFlags_CommonPiece6,
							--	specials = CascadePieceSpecials_Amber,
							--	cancelSpecials = CascadePieceSpecials_Amber,
							--	weight = 1,
							--},
						},
					}
				
					table.insertall(exampleNamedMixes, MakeRandomSafe({{1,2,3,4,5},{1,2,3,4,5},}, "SurpiseSafes", "DangerMix"))
					return exampleNamedMixes
					end
			),
			addToReelPieceMix ={
				{
					name = "Safe1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"SurpiseSafes_Step1_1"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 2,
				},
				{
					name = "Safe2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"SurpiseSafes_Step1_2"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 2,
				},
				{
					name = "Safe3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"SurpiseSafes_Step1_3"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 2,
				},
				{
					name = "Safe4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"SurpiseSafes_Step1_4"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 2,
				},
				{
					name = "Safe5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_Safe,
					spawnTypes = {"SurpiseSafes_Step1_5"},
					weight = 5,
                    applyTotalSpawns = true,
                    totalSpawns = 2,
				},
				--{
				--	name = "Safe6",
				--	matchFlags = CascadeMatchFlags_CommonPiece6,
				--	specials = CascadePieceSpecials_Safe,
				--	spawnTypes = {"SurpiseSafes_Step1_6"},
				--	weight = 5,
                --   applyTotalSpawns = true,
                --  totalSpawns = 2,
				--},
			},

		},		
	goals = {
			main = {"getGem", 10, "Safe", "Safes", {specials = CascadePieceSpecials_Safe|CascadePieceSpecial_Valuable}, "Open"},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",800000},
				[3] = {"score",1000000},
			},
		},
	},
	["SafeLab3"] = {
		levelName = "Safe in the Lab 3",
		resource = "GameScreen_LabLevel",
		hidden = true,	
		Features = {
			splashMode = true,
			modeSpins8 = true,
			largeBoard = true,
			gemTypes4 = true,

			hasIce = true,
			hasBombs = true,
			hasVines = true,
			hasLava = true,
			hasSwitches = true,
			hasSteel = true,
			hasSafes = true,
		},
		tricks = World17Tricks,
		boosts = World17Boosts,
		Properties = {
			additionalNamedPatterns = {
				{
					entryName = "Clear",
                    patternName = "SafeLab3_Clear",
                    isPatternSet = false,
                    clearPieces = true,
				},
				{
					entryName = "ClearSwitch",
					patternName = "SafeLab3_Switches",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Switch1",
					patternName = "SafeLab3_Switches",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
					applySpawnTypes = true,
					spawnTypes = {"SwitchMix1"},
					applyMatchPatterns = true,
					matchPatterns = {"Clear", "ClearSwitch", "Switch2" , "Lava3", "Ice4", "Vines1", "Bomb2"},
					addPieces = true,
				},
				{
					entryName = "Switch2",
					patternName = "SafeLab3_Switches",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
					applySpawnTypes = true,
					spawnTypes = {"SwitchMix2"},
					applyMatchPatterns = true,
					matchPatterns = {"Clear", "ClearSwitch", "Switch3", "Lava4", "Ice1", "Vines2", "Bomb3"},
					addPieces = true,
				},
				{
					entryName = "Switch3",
					patternName = "SafeLab3_Switches",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
					applySpawnTypes = true,
					spawnTypes = {"SwitchMix3"},
					applyMatchPatterns = true,
					matchPatterns = {"Clear", "ClearSwitch", "Switch4" , "Lava1", "Ice2", "Vines3", "Bomb4"},
					addPieces = true,
				},
				{
					entryName = "Switch4",
					patternName = "SafeLab3_Switches",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
					applySpawnTypes = true,
					spawnTypes = {"SwitchMix4"},
					applyMatchPatterns = true,
					matchPatterns = {"Clear", "ClearSwitch", "Switch1" , "Lava2", "Ice3", "Vines4", "Bomb1"},
					addPieces = true,
				},
				{
					entryName = "Lava1",
					patternName = "SafeLab3_Danger1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
                    addPieces = true,
				},
				{
					entryName = "Lava2",
					patternName = "SafeLab3_Danger2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
                    addPieces = true,
				},
				{
					entryName = "Lava3",
					patternName = "SafeLab3_Danger3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
                    addPieces = true,
				},
				{
					entryName = "Lava4",
					patternName = "SafeLab3_Danger4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
                    addPieces = true,
				},
				{
					entryName = "Ice1",
					patternName = "SafeLab3_Danger1",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    addPieces = true,
				},
				{
					entryName = "Ice2",
					patternName = "SafeLab3_Danger2",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    addPieces = true,
				},
				{
					entryName = "Ice3",
					patternName = "SafeLab3_Danger3",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    addPieces = true,
				},
				{
					entryName = "Ice4",
					patternName = "SafeLab3_Danger4",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
                    addPieces = true,
				},
				{
					entryName = "Vines1",
					patternName = "SafeLab3_Danger1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    addPieces = true,
				},
				{
					entryName = "Vines2",
					patternName = "SafeLab3_Danger2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    addPieces = true,
				},
				{
					entryName = "Vines3",
					patternName = "SafeLab3_Danger3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    addPieces = true,
				},
				{
					entryName = "Vines4",
					patternName = "SafeLab3_Danger4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
                    addPieces = true,
				},
				{
					entryName = "Bomb1",
					patternName = "SafeLab3_Danger1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					addPieces = true,
				},
				{
					entryName = "Bomb2",
					patternName = "SafeLab3_Danger2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					addPieces = true,
				},
				{
					entryName = "Bomb3",
					patternName = "SafeLab3_Danger3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					addPieces = true,
				},
				{
					entryName = "Bomb4",
					patternName = "SafeLab3_Danger4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
					addPieces = true,
				},
			},
			additionalNamedMixes = ExecuteInline(
					function()
				
					local exampleNamedMixes = {
						{
							name = "SuperWildsMix",
							delay = 0,
							{
								name = "Super Wild",
								matchFlags = CascadeMatchFlags_Wildcard,
								specials =CascadePieceSpecial_ClearKeyColorOnMatch,
								weight = 1,
							},
						},
						{
							name = "SwitchMix1",
							delay = 0,
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Off",
								spawnTypes = {"SwitchMix2"},
								matchPatterns = {"Clear", "ClearSwitch", "Switch2" , "Lava3", "Ice4", "Vines1", "Bomb2"},
								weight = 1,
							},
						},
						{
							name = "SwitchMix2",
							delay = 0,
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Off",
								spawnTypes = {"SwitchMix3"},
								matchPatterns = {"Clear", "ClearSwitch", "Switch3", "Lava4", "Ice1", "Vines2", "Bomb3"},
								weight = 1,
							},
						},
						{
							name = "SwitchMix3",
							delay = 0,
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Off",
								spawnTypes = {"SwitchMix4"},
								matchPatterns = {"Clear", "ClearSwitch", "Switch4" , "Lava1", "Ice2", "Vines3", "Bomb4"},
								weight = 1,
							},
						},
						{
							name = "SwitchMix4",
							delay = 0,
							{
								matchFlags = 0,
								specials = CascadePieceSpecials_Stone,
								skinVariant = "Switch1_Off",
								spawnTypes = {"SwitchMix1"},
								matchPatterns = {"Clear", "ClearSwitch", "Switch1" , "Lava2", "Ice3", "Vines4", "Bomb1"},
								weight = 1,
							},
						},
					}
				
					table.insertall(exampleNamedMixes, MakeRandomSafe({{1,2,3,4}, {1,2,3,4}, {1,2,3,4},}, "SurpiseSafes", "SuperWildsMix"))
					return exampleNamedMixes
					end
			),
			additionalInitialPatterns = {
				--Safes
				{
					patternName = "SafeLab3_Safes",
					isPatternSet = false,
					replacePieces = {"SurpiseSafes_Step0"},
				},
				--Switches
				{
					patternName = "SafeLab3_Switches",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
					applySpawnTypes = true,
					spawnTypes = {"SwitchMix1"},
					applyMatchPatterns = true,
					matchPatterns = {"Clear", "ClearSwitch", "Switch1", "Lava2", "Ice3", "Vines4", "Bomb1"},
				},
				--steel
				{
					patternName = "SafeLab3_Steel",
					isPatternSet = false,
					applyMatchFlags = true, 
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				--Lava
				{
					patternName = "SafeLab3_Danger1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				--ICE
				{
					patternName = "SafeLab3_Danger2",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				--Vines
				{
					patternName = "SafeLab3_Danger3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				--Bombs
				{
					patternName = "SafeLab3_Danger4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials =  true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
			},

		},		
	goals = {
			main = {"getGem", 4, "Safe", "Safes", {specials = CascadePieceSpecials_Safe|CascadePieceSpecial_Valuable}, "Open"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",600000},
			},
		},
	},
--End Safe Lab
})