-- Land 30: switches without makers

table.insertall(LevelDefs,
{

--Jonathan levels begin
	["LongRise"] = {
		levelName = "Long Rise",					
		Features = {
			modeSpins8 = true,
			splashMode = true,
			largeBoard = true,
			gemTypes4 = true,
			hasBalloons = true,
			hasChests = true,
			hasLasers = true,
			hasMissingSquares = true,
			hasMissingReels = true,
			hasPortals = true,
			hasSteel = true,
		},
		tricks = World28Tricks,
		boosts = World28Boosts,
		Properties = {
			portals = {
				[1] = {{0,7},{4,1},"PortalEntrance_1","PortalExit_1"},
				[2] = {{1,7},{5,0},"PortalEntrance_1","PortalExit_1"},
				[3] = {{2,7},{6,0},"PortalEntrance_1","PortalExit_1"},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "LongRise_Missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "CenterReel_Large",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LongRise_TreasureBalloons",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure_Balloon,
					applyAugmentSpecials = true,
					augmentSpecials = CascadePieceSpecial_SplashImmune,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[2] = {
					patternName = "LongRise_Laser",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"LaserH"},
					applySkinVariant = true,
					skinVariant = "DungeonLaserH",
				},
				[3] = {
					patternName = "LongRise_Treasure",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[4] = {
					patternName = "LongRise_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
			},
			additionalNamedMixes = {
				{
					name = "LaserH",
					delay = 0,
					{
						name = "LaserH 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
						skinVariant = "DungeonLaserH",
					},
					{
						name = "LaserH 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
						skinVariant = "DungeonLaserH",
					},
					{
						name = "LaserH 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
						skinVariant = "DungeonLaserH",
					},
					{
						name = "LaserH 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
						skinVariant = "DungeonLaserH",
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "LaserH",
						delay = 0,
						{
							name = "LaserH 1",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "DungeonLaserH",
						},
						{
							name = "LaserH 2",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "DungeonLaserH",
						},
						{
							name = "LaserH 3",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "DungeonLaserH",
						},
						{
							name = "LaserH 4",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH",},
							weight = 1,
							skinVariant = "DungeonLaserH",
						},
					},
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure, cancelSpecials = 0,},"Drop",},
			stars = {
				[1] = {"score",350000},
				[2] = {"score",650000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
--Jonathan levels end

	["SwitchSequence"] = {
		levelName = "Switch Sequence",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSwitches = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff1"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						spawnTypes = {"TurnOn1"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "SwitchSequence_on",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_On",
				},
				{
					patternName = "SwitchSequence_off",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "TurnOff1",
						delay = 0,
						{
							name = "Switch_On1",
							matchFlags = 0,
							specials = CascadePieceSpecials_Steel,
							skinVariant = "DungeonSwitch_On",
							weight = 1,
						},
					},
				},
			},
		},
		goals = {
			main = {"haveGem",8,"Switch","Switches",{skinVariant = "DungeonSwitch_On"},"Turn on"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",350000},
				[3] = {"score",700000},
			},
		},
	},

	["SwitchClicker"] = {
		levelName = "Switch Clicker",
		introScript = "Land30_Intro",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSwitches = true,
			hasMissingSquares = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Toggle",
						spawnTypes = {"Toggle1"},
						weight = 1,
					},
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "SwitchClicker_Missing",
				isPatternSet = false,
			},
			additionalInitialPatterns = { 
				{
					patternName = "SwitchClicker_Switches",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Toggle",
				},
			},
		},
		goals = {
			main = {"getGem",30,"Switch","Switches",{skinVariant = "DungeonSwitch_Toggle"},"Flip"},
			stars = {
				[1] = {"score",35000},
				[2] = {"score",50000},
				[3] = {"score",55000},
			},
		},
	},
	["MoveTheBlocker"] = {
		levelName = "Move the Blocker",
		introScript = "Land30_Tip1",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSwitches = true,
			hasSteel = true,
			hasCoverage = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "TurnOnLeftSteel",
					patternName = "MoveTheBlocker_Steel1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[2] = {
					entryName = "ClearLeftSteel",
					patternName = "MoveTheBlocker_Steel1",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "TurnOnRightSteel",
					patternName = "MoveTheBlocker_Steel2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[4] = {
					entryName = "ClearRightSteel",
					patternName = "MoveTheBlocker_Steel2",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"ClearRightSteel","TurnOnLeftSteel"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"ClearLeftSteel","TurnOnRightSteel"},
						spawnTypes = {"TurnOn1"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "MoveTheBlocker_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"ClearLeftSteel","TurnOnRightSteel"},
				},
				{
					patternName = "MoveTheBlocker_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				{
					patternName = "MoveTheBlocker_Steel1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},
	["DefusingSwitch"] = {
		levelName = "Reset Switch",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasSwitches = true,
			hasBombs = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			addToBoardPieceMix = {
                {
                    name = "Bomb 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 3,
                },
                {
                    name = "Bomb 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 3,
                },
                {
                    name = "Bomb 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 3,
                },
                {
                    name = "Bomb 4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 3,
                },
                {
                    name = "Bomb 5",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 1.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 3,
                },
                {
                    name = "Bomb 1a",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 0.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 4,
                },
                {
                    name = "Bomb 2a",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 0.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 4,
                },
                {
                    name = "Bomb 3a",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 0.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 4,
                },
                {
                    name = "Bomb 4a",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 0.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 4,
                },
                {
                    name = "Bomb 5a",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 0.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 4,
                },
            },
			additionalNamedPatterns = {
				[1] = {
					entryName = "Reload All Bombs",
					patternName = "FullBoardSmall",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 6,
					filter = {
						turnsToLoss = true,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Toggle",
						spawnTypes = {"Toggle1"},
						weight = 1,
						matchPatterns = {"Reload All Bombs",},
					},
				},
			},
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2, 
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2, 
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2, 
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2, 
					},
					{
						name = "Gem 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2, 
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "DefusingSwitch_Switches",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Reload All Bombs",},
					applyTurnsToLoss = true,
					turnsToLoss = -1,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Bomb","Bombs",{turnsToLoss = true,},"Match"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},
	["Binary"] = {
		levelName = "Binary",
		introScript = "Land30_Binary",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasSwitches = true,
			hasSteel = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			--On flip, a switch unflips all lower switches.
            --On unflip, a switch does nothing directly.
			
			--Each gate listens for all the switches lower than it. 
			--If they are all on, the gate opens.
			--If they are not all on, the gate closes.

			--If I make spawners with events that manipulate gate state
			--and I set the spawnBelowTypes of switches to be those spawners
			--The animation will mark those switches as the source of the gates moving.

			--The events that manipulate gate state will use population events to listen for switch state.
			--Because you can make compound gem types for population events (using the goal format) I can
			--count up how many of a specific switch subset are turned on.

			--No invisible data or other whackiness needed. Nice and direct!

			--For the sake of elegance, I will do all 4 switches in this way, 
			--even though it is not necessary for switch 0. 
			--So switches will only manipulate other switches directly. 
			--Gate state will always be derived from switch state via events.

			additionalNamedPatterns = {
				[1] = {
					entryName = "TurnOnGate1",
					patternName = "Binary_Gate1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[2] = {
					entryName = "TurnOnGate2",
					patternName = "Binary_Gate2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[3] = {
					entryName = "TurnOffGate2",
					patternName = "Binary_Gate2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = 0,
					applySkinVariant = true,
					skinVariant = "Default",
				},
				[4] = {
					entryName = "TurnOffSwitch1",
					patternName = "Binary_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
				},
				[5] = {
					entryName = "TurnOnGate3",
					patternName = "Binary_Gate3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[6] = {
					entryName = "TurnOffGate3",
					patternName = "Binary_Gate3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = 0,
					applySkinVariant = true,
					skinVariant = "Default",
				},
				[7] = {
					entryName = "TurnOffSwitch2",
					patternName = "Binary_Switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffSwitch1"},
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
				},
				[8] = {
					entryName = "TurnOnGate4",
					patternName = "Binary_Gate4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[9] = {
					entryName = "TurnOffGate4",
					patternName = "Binary_Gate4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyPieceSpecials = true,
					specials = 0,
					applySkinVariant = true,
					skinVariant = "Default",
				},
				[10] = {
					entryName = "TurnOffSwitch3",
					patternName = "Binary_Switch3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffSwitch2","TurnOffSwitch1",},
					applySpawnTypes = true,
					spawnTypes = {"TurnOn3"},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {},
						weight = 1,
						spawnBelowTypes = {"Gate 2 Control","Gate 3 Control","Gate 4 Control",},
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"TurnOffSwitch0"},
						weight = 1,
						spawnBelowTypes = {"Gate 2 Control","Gate 3 Control","Gate 4 Control",},
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {},
						weight = 1,
						spawnBelowTypes = {"Gate 3 Control","Gate 4 Control",},
					},
				},
				[4] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"TurnOffSwitch1","TurnOffSwitch0"},
						spawnTypes = {"TurnOn2"},
						weight = 1,
						spawnBelowTypes = {"Gate 3 Control","Gate 4 Control",},
					},
				},
				[5] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff3"},
						matchPatterns = {},
						weight = 1,
						spawnBelowTypes = {"Gate 4 Control",},
					},
				},
				[6] = {
					name = "TurnOff3",
					delay = 0,
					{
						name = "Switch_Off3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						spawnTypes = {"TurnOn3"},
						matchPatterns = {"TurnOffSwitch2","TurnOffSwitch1","TurnOffSwitch0"},
						weight = 1,
						spawnBelowTypes = {"Gate 4 Control",},
					},
				},
				[7] = {
					name = "TurnOn4",
					delay = 0,
					{
						name = "Switch_On4",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff4"},
						matchPatterns = {"",},
						weight = 1,
					},
				},
				[8] = {
					name = "TurnOff4",
					delay = 0,
					{
						name = "Switch_Off4",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"TurnOffSwitch3","TurnOffSwitch2","TurnOffSwitch1","TurnOffSwitch0"},
						spawnTypes = {"TurnOn4"},
						weight = 1,
					},
				},
				[9] = {
					name = "Gate 2 Control",
					delay = -1,
					cooldowns = {0,-1},
					events = {
						{
							eventType = "population",
							newDelay = -1,
							count = 1,
							comparator = "equals",
							setCooldowns = {-1,0},
							gemType = {
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff1"},
								},
							},
							patterns = {"TurnOffGate2"},
						},
						{
							eventType = "population",
							newDelay = -1,
							count = 1,
							comparator = "less",
							setCooldowns = {0,-1},
							gemType = {
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff1"},
								},
							},
							patterns = {"TurnOnGate2"},
						},
					},
				},
				[10] = {
					name = "Gate 3 Control",
					delay = -1,
					cooldowns = {0,-1},
					events = {
						{
							eventType = "population",
							newDelay = -1,
							count = 2,
							comparator = "equals",
							setCooldowns = {-1,0},
							gemType = {
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff1"},
								},
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff2"},
								},
							},
							patterns = {"TurnOffGate3"},
						},
						{
							eventType = "population",
							newDelay = -1,
							count = 2,
							comparator = "less",
							setCooldowns = {0,-1},
							gemType = {
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff1"},
								},
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff2"},
								},
							},
							patterns = {"TurnOnGate3"},
						},
					},
				},
				[11] = {
					name = "Gate 4 Control",
					delay = -1,
					cooldowns = {0,-1},
					events = {
						{
							eventType = "population",
							newDelay = -1,
							count = 3,
							comparator = "equals",
							setCooldowns = {-1,0},
							gemType = {
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff1"},
								},
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff2"},
								},
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff3"},
								},
							},
							patterns = {"TurnOffGate4"},
						},
						{
							eventType = "population",
							newDelay = -1,
							count = 3,
							comparator = "less",
							setCooldowns = {0,-1},
							gemType = {
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff1"},
								},
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff2"},
								},
								{
									skinVariant = "DungeonSwitch_On",
									spawnTypes = {"TurnOff3"},
								},
							},
							patterns = {"TurnOnGate4"},
						},
					},
				},
			},
			
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Gate 1 Control",
						delay = -1,
					},
					[2] = {
						name = "Gate 2 Control",
						delay = -1,
					},
					[3] = {
						name = "Gate 3 Control",
						delay = -1,
					},
					[4] = {
						name = "Gate 4 Control",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Binary_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				{
					patternName = "Binary_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					spawnBelowTypes = {"Gate 2 Control","Gate 3 Control","Gate 4 Control",},
				},
				{
					patternName = "Binary_Switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffSwitch1","TurnOffSwitch0",},
					spawnBelowTypes = {"Gate 3 Control","Gate 4 Control",},
				},
				{
					patternName = "Binary_Switch3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn3"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffSwitch2","TurnOffSwitch1","TurnOffSwitch0",},
					spawnBelowTypes = {"Gate 4 Control",},
				},
				{
					patternName = "Binary_Switch4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn4"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffSwitch3","TurnOffSwitch2","TurnOffSwitch1",},
				},
				{
					patternName = "Binary_Gate2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				{
					patternName = "Binary_Gate3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				{
					patternName = "Binary_Gate4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"haveGem",4,"Switch","Switches",{skinVariant = "DungeonSwitch_On"},"Turn on"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",275000},
				[3] = {"score",350000},
			},
		},
	},

	--begin Michael land 30 levels
	["TwoWorlds"] = {
		levelName = "Two Worlds",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSwitches = true,
			hasSteel = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "TurnOnEasy",
					patternName = "TwoWorlds_easySteel",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[2] = {
					entryName = "TurnOffEasy",
					patternName = "TwoWorlds_easySteel",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "TurnOnHard",
					patternName = "TwoWorlds_hardSteel",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[4] = {
					entryName = "TurnOffHard",
					patternName = "TwoWorlds_hardSteel",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"TurnOnHard","TurnOffEasy",},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"TurnOnEasy","TurnOffHard",},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "TwoWorlds_switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffHard","TurnOnEasy",},
				},
				{
					patternName = "TwoWorlds_hardSteel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",400000},
			},
		},
	},
	["Metamorphosis"] = {
		levelName = "Metamorphosis",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasSwitches = true,
			hasSteel = true,
			hasMissingReels = true,
			hasChests = true,
			hasStones = true,
			hasFences = true,
			hasAmber = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "CenterReel_Large", 
                isPatternSet = false,
            },
			additionalNamedPatterns = {
				[1] = {
					entryName = "TurnOnCaterpillar",
					patternName = "Metamorphosis_caterpillar",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[2] = {
					entryName = "TurnOffCaterpillar",
					patternName = "Metamorphosis_caterpillar",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "TurnOnCocoon1",
					patternName = "Metamorphosis_cocoonLeaf",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[4] = {
					entryName = "TurnOnCocoon2",
					patternName = "Metamorphosis_cocoonBody",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[5] = {
					entryName = "TurnOffCocoon1",
					patternName = "Metamorphosis_cocoonLeaf",
					isPatternSet = false,
					clearPieces = true,
				},
				[6] = {
					entryName = "TurnOffCocoon2",
					patternName = "Metamorphosis_cocoonBody",
					isPatternSet = false,
					clearPieces = true,
				},
				[7] = {
					entryName = "TurnOnButterfly1",
					patternName = "Metamorphosis_butterflyWings",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[8] = {
					entryName = "TurnOnButterfly2",
					patternName = "Metamorphosis_butterflyBody",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure | CascadePieceSpecials_Amber,
					cancelSpecials = CascadePieceSpecials_Amber_treasure,
					applyCancelSpecials = true,
				},
				[9] = {
					entryName = "TurnOnButterfly3",
					patternName = "Metamorphosis_butterflyBottom",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[10] = {
					entryName = "TurnOnStone1",
					patternName = "Metamorphosis_stone",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[11] = {
					entryName = "TurnOnStone2",
					patternName = "Metamorphosis_stone",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[12] = {
					entryName = "TurnOnStone3",
					patternName = "Metamorphosis_butterfly",
					isPatternSet = false,
					addPieces = true,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[13] = {
					entryName = "TurnOffSwitch",
					patternName = "Metamorphosis_switch",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn0",
					delay = 0,
					{
						name = "Switch_On0",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"TurnOnCaterpillar","TurnOnStone1",},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						spawnTypes = {"TurnOn2"},
						matchPatterns = {"TurnOffCaterpillar","TurnOnCocoon1","TurnOnCocoon2","TurnOnStone2",},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						--spawnTypes = {"TurnOn3"},
						matchPatterns = {"TurnOffCocoon1","TurnOffCocoon2","TurnOffSwitch","TurnOnButterfly1","TurnOnButterfly2",},
						weight = 1,
					},
				},
				
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Metamorphosis_switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffCaterpillar","TurnOnCocoon1","TurnOnCocoon2","TurnOnStone2",},
				},
				[2] = {
					patternName = "Metamorphosis_caterpillar",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "Metamorphosis_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					skinVariant = "Stone",
				},
			},
		},
		goals = {
			main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	--end Michael land 30 levels

	["Crabgrass"] = {
		levelName = "Crabgrass",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasSwitches = true,
			hasSteel = true,
			hasCoverage = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "TurnOnLeftSteel",
					patternName = "Crabgrass_vines1",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
				},
				[2] = {
					entryName = "ClearLeftSteel",
					patternName = "Crabgrass_vines1",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "TurnOnRightSteel",
					patternName = "Crabgrass_vines2",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
				},
				[4] = {
					entryName = "ClearRightSteel",
					patternName = "Crabgrass_vines2",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"ClearRightSteel","TurnOnLeftSteel"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"ClearLeftSteel","TurnOnRightSteel"},
						spawnTypes = {"TurnOn1"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "MoveTheBlocker_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"ClearLeftSteel","TurnOnRightSteel"},
				},
				{
					patternName = "Crabgrass_pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 3,
				},
				{
					patternName = "Crabgrass_vines1",
					isPatternSet = false,
					specials = CascadePieceSpecials_VineGenerator,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",900000},
			},
		},
	},
	["SafetyCage"] = {
        levelName = "Safety Cage",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins4 = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasStones = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "TurnOnWall1",
                    patternName = "SwitchSequence2_Wall1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					addPieces = true,
                },
                {
                    entryName = "TurnOffWall1",
                    patternName = "SwitchSequence2_Wall1",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall2",
                    patternName = "SwitchSequence2_Wall2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					addPieces = true,
                },
                {
                    entryName = "TurnOffWall2",
                    patternName = "SwitchSequence2_Wall2",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall3",
                    patternName = "SwitchSequence2_Wall3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					addPieces = true,
                },
                {
                    entryName = "TurnOffWall3",
                    patternName = "SwitchSequence2_Wall3",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall4",
                    patternName = "SwitchSequence2_Wall4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					addPieces = true,
                },
                {
                    entryName = "TurnOffWall4",
                    patternName = "SwitchSequence2_Wall4",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall5",
                    patternName = "SwitchSequence2_Wall5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
					addPieces = true,
                },
                {
                    entryName = "TurnOffWall5",
                    patternName = "SwitchSequence2_Wall5",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalNamedMixes = {
                --switch 1
                {
                    name = "TurnOn1",
                    delay = 0,
                    {
                        name = "Switch_On1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff1"},
                        matchPatterns = {"TurnOffWall1",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff1",
                    delay = 0,
                    {
                        name = "Switch_Off1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn1"},
                        matchPatterns = {"TurnOnWall1",},
                        weight = 1,
                    },
                },

                --switch 2
                {
                    name = "TurnOn2",
                    delay = 0,
                    {
                        name = "Switch_On2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff2"},
                        matchPatterns = {"TurnOffWall2",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff2",
                    delay = 0,
                    {
                        name = "Switch_Off2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn2"},
                        matchPatterns = {"TurnOnWall2",},
                        weight = 1,
                    },
                },

                --switch 3
                {
                    name = "TurnOn3",
                    delay = 0,
                    {
                        name = "Switch_On3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff3"},
                        matchPatterns = {"TurnOffWall3",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff3",
                    delay = 0,
                    {
                        name = "Switch_Off3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn3"},
                        matchPatterns = {"TurnOnWall3",},
                        weight = 1,
                    },
                },

                --switch 4
                {
                    name = "TurnOn4",
                    delay = 0,
                    {
                        name = "Switch_On4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff4"},
                        matchPatterns = {"TurnOffWall4",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff4",
                    delay = 0,
                    {
                        name = "Switch_Off4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn4"},
                        matchPatterns = {"TurnOnWall4",},
                        weight = 1,
                    },
                },

                 --switch 5
                {
                    name = "TurnOn5",
                    delay = 0,
                    {
                        name = "Switch_On5",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff5"},
                        matchPatterns = {"TurnOffWall5",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff5",
                    delay = 0,
                    {
                        name = "Switch_Off5",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn5"},
                        matchPatterns = {"TurnOnWall5",},
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "SwitchSequence2_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall1",},
                },
                {
                    patternName = "SwitchSequence2_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn2"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall2",},
                },
                {
                    patternName = "SwitchSequence2_Switch3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn3"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall3",},
                },
                {
                    patternName = "SwitchSequence2_Switch4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn4"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall4",},
                },
                {
                    patternName = "SwitchSequence2_Switch5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn5"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall5",},
                },
            },
        },
        goals = {
            main = {"haveGem",5,"Switch","Switches",{skinVariant = "DungeonSwitch_On"},"Turn on"},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",200000},
                [3] = {"score",500000},
            },
        },
    },

	["Clearance"] = {
		levelName = "Secret Walls",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSwitches = true,
			hasSteel = true,
			hasChests = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "TurnOnWall1",
					patternName = "Line3_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[2] = {
					entryName = "TurnOffWall1",
					patternName = "Line3_large",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "TurnOnWall2",
					patternName = "Line2_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[4] = {
					entryName = "TurnOffWall2",
					patternName = "Line2_large",
					isPatternSet = false,
					clearPieces = true,
				},
				[5] = {
					entryName = "TurnOnWall3",
					patternName = "Line1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[6] = {
					entryName = "TurnOffWall3",
					patternName = "Line1_large",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"TurnOffWall1",},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"TurnOnWall1",},
						spawnTypes = {"TurnOn1"},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"TurnOffWall2",},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"TurnOnWall2",},
						spawnTypes = {"TurnOn2"},
						weight = 1,
					},
				},
				[5] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff3"},
						matchPatterns = {"TurnOffWall3",},
						weight = 1,
					},
				},
				[6] = {
					name = "TurnOff3",
					delay = 0,
					{
						name = "Switch_Off3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"TurnOnWall3",},
						spawnTypes = {"TurnOn3"},
						weight = 1,
					},
				},
				[7] = {
					name = "One Chest Always",
					delay = 0,
					{
						name = "Chest",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
					cooldowns = {1,0},
					events = {
						[1] = {
							eventType = "population",
							count = 1,
							newDelay = 1,
							cooldown = 1,
							comparator = "less",
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "Clearance_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffWall1",},
				},
				{
					patternName = "Clearance_Switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff2"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffWall2",},
				},
				{
					patternName = "Clearance_Switch3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff3"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"TurnOffWall3",},
				},
				{
					patternName = "Clearance_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"One Chest Always",},
				},
				{
					patternName = "Line1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				{
					patternName = "Line2_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				{
					patternName = "Line3_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
			},
            endGameProperties = {
                additionalNamedMixes = {
                    {
                        name = "One Chest Always",
                        delay = -1,
                    },
                },
            },
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop"},
			stars = {
				[1] = {"score",250000},
				[2] = {"score",400000},
				[3] = {"score",1000000},
			},
		},
	},

    --Matching a stateless switch turns a wall of steel into a wall of fences.
    --3 turns later, the wall closes back up.
    --Horizontal bursts in piece mix.
    --Match boulders from a maker in the column on right.
    ["FlickeringWall_Updated"] = {
        levelName = "Flickering Wall",
        Features = {
            splashMode = true,
            modeSpins5 = true,
            largeBoard = true,
            gemTypes5 = true,

            hasMissingReels = true,
            hasBarrels = true,
            hasSteel = true,
            hasFences = true,
            hasSwitches = true,
            hasMakers = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "Reels67", 
                isPatternSet = false,
            },
            additionalNamedPatterns = {
                {
                    entryName = "MakeWallFences",
                    patternName = "Col6_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Fence,
                    applyIcon = true,
                    icon = "Icon_Blank1",
                    applySkinVariant = true,
                    skinVariant = "Fence",
                },
                {
                    entryName = "MakeWallSteel",
                    patternName = "Col6_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
				{
                    entryName = "SetCountdown7",
                    patternName = "Col6_large_1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
				{
                    entryName = "SetCountdown6",
                    patternName = "Col6_large_2up",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
                {
                    entryName = "SetCountdown5",
                    patternName = "Col6_large_3up",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
				{
                    entryName = "SetCountdown4",
                    patternName = "Col6_large_4up",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
                {
                    entryName = "SetCountdown3",
                    patternName = "Col6_large_5up",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
                {
                    entryName = "SetCountdown2",
                    patternName = "Col6_large_6up",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
                {
                    entryName = "SetCountdown1",
                    patternName = "Col6_large_7up",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
            },
            additionalNamedMixes = {
                {
                    name = "Event Pattern Driver",
                    delay = -1,
                    {
                        name = "Barrels",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        isGemSpawner = true,
                        weight = 2,
                    },
					cooldowns = {0,-1,-1,-1,-1,-1,-1,-1,-1},
                    events = { --Reverse order so they don't chain
						[1] = {
                            eventType = "getGem",
                            newDelay = -1,
                            gemType = {
                                {
                                    skinVariant = "DungeonSwitch_Toggle",
                                },
                            },
							setCooldowns = {0,8,7,6,5,4,3,2,1},
                        },
                        [2] = {
                            eventType = "population",
                            newDelay = -1,
                            count = 7,
                            comparator = "equals",
                            gemType = {
                                {
                                    skinVariant = "DungeonSteel",
                                },
                            },
                            patterns = {"MakeWallSteel"},
							cooldown = -1,
                        },
                        [3] = {
                            eventType = "population",
                            newDelay = -1,
                            count = 6,
                            comparator = "equals",
                            gemType = {
                                {
                                    skinVariant = "DungeonSteel",
                                },
                            },
                            patterns = {"SetCountdown1"},
							cooldown = -1,
                        },
						[4] = {
                            eventType = "population",
                            newDelay = -1,
                            count = 5,
                            comparator = "equals",
                            gemType = {
                                {
                                    skinVariant = "DungeonSteel",
                                },
                            },
                            patterns = {"SetCountdown2"},
							cooldown = -1,
                        },
						[5] = {
                            eventType = "population",
                            newDelay = -1,
                            count = 4,
                            comparator = "equals",
                            gemType = {
                                {
                                    skinVariant = "DungeonSteel",
                                },
                            },
                            patterns = {"SetCountdown3"},
							cooldown = -1,
                        },
                        [6] = {
                            eventType = "population",
                            newDelay = -1,
                            count = 3,
                            comparator = "equals",
                            gemType = {
                                {
                                    skinVariant = "DungeonSteel",
                                },
                            },
                            patterns = {"SetCountdown4"},
							cooldown = -1,
                        },
						[7] = {
                            eventType = "population",
                            newDelay = -1,
                            count = 2,
                            comparator = "equals",
                            gemType = {
                                {
                                    skinVariant = "DungeonSteel",
                                },
                            },
                            patterns = {"SetCountdown5"},
							cooldown = -1,
                        },
						[8] = {
                            eventType = "population",
                            newDelay = -1,
                            count = 1,
                            comparator = "equals",
                            gemType = {
                                {
                                    skinVariant = "DungeonSteel",
                                },
                            },
                            patterns = {"SetCountdown6"},
							cooldown = -1,
                        },
						[9] = {
                            eventType = "population",
                            newDelay = -1,
                            count = 1,
                            comparator = "greater",
                            gemType = {
                                {
                                    icon = "Icon_Blank1",
                                },
                            },
                            patterns = {"SetCountdown7"},
							cooldown = -1,
                        },
                    },
                },
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"MakeWallFences"},
                        weight = 1,
                    },
                },
                {
                    name = "Make Boulders",
                    delay = 0,
                    {
                        name = "Boulders",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        weight = 2,
                    },
                },
            },
            addToBoardPieceMix = {
                {
                    name = "HorizontalBurst1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 2,
                },
                {
                    name = "HorizontalBurst2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 2,
                },
                {
                    name = "HorizontalBurst3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 2,
                },
                {
                    name = "HorizontalBurst4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 2,
                },
                {
                    name = "HorizontalBurst5",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 2,
                },
            },
            endGameProperties = {
                boardPieceMix = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 11,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 11,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 11,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 11,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 11,
					},
				},
            },
            additionalInitialPatterns = { 
                {
                    patternName = "FlickeringWall_Maker",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Make Boulders"},
                },
                {
                    patternName = "FlickeringWall_Boulders",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyMatchFlags = true,
                    matchFlags = 0,
                },
                {
                    patternName = "Col6_large",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Event Pattern Driver"}, --Prevents sounds when the wall changes itself
                    applySkinVariant = true,
                    skinVariant = "DungeonSteel",
                },
                {
                    patternName = "FlickeringWall_Switch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeWallFences"},
                },
            },
        },
        goals = {
            main = {"getGem",20,"Boulders","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
            stars = {
                [1] = {"score",200000},
                [2] = {"score",300000},
                [3] = {"score",600000},
            },
        },
    },


    --Begin Roh levels
    ["AirLock"] = {
        levelName = "Lower Dungeon",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes4 = true,

            hasSteel = true,
            hasSwitches = true,
            hasMakers = true,
            hasChests = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "TurnOnWall1",
                    patternName = "Line5_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
                },
                {
                    entryName = "TurnOffWall1",
                    patternName = "Line5_large",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall2",
                    patternName = "Line3_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
                },
                {
                    entryName = "TurnOffWall2",
                    patternName = "Line3_large",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall3",
                    patternName = "Line1_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
                },
                {
                    entryName = "TurnOffWall3",
                    patternName = "Line1_large",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalNamedMixes = {
                {
                    name = "No Chests",
                    delay = 0,
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
				},
				{
                    name = "Sometimes Chests",
                    delay = 0,
					events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 12,
                            reset = true,
                        },
						[2] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
                                specials = CascadePieceSpecials_Treasure,
                            },
                        },
                    },
                    { 
                        name = "Treasure",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Treasure,
                        weight = 1,
                    },
                },

                --switch 1
                {
                    name = "TurnOn1",
                    delay = 0,
                    {
                        name = "Switch_On1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff1"},
                        matchPatterns = {"TurnOffWall1",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff1",
                    delay = 0,
                    {
                        name = "Switch_Off1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn1"},
                        matchPatterns = {"TurnOnWall1",},
                        weight = 1,
                    },
                },

                --switch 2
                {
                    name = "TurnOn2",
                    delay = 0,
                    {
                        name = "Switch_On2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff2"},
                        matchPatterns = {"TurnOffWall2",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff2",
                    delay = 0,
                    {
                        name = "Switch_Off2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn2"},
                        matchPatterns = {"TurnOnWall2",},
                        weight = 1,
                    },
                },

                --switch 3
                {
                    name = "TurnOn3",
                    delay = 0,
                    {
                        name = "Switch_On3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff3"},
                        matchPatterns = {"TurnOffWall3",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff3",
                    delay = 0,
                    {
                        name = "Switch_Off3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn3"},
                        matchPatterns = {"TurnOnWall3",},
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "AirLock_Makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Sometimes Chests", "No Chests"},
                },

                {
                    patternName = "AirLock_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOff1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_On",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOffWall1",},
                },
                {
                    patternName = "Line5_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
                },

                {
                    patternName = "AirLock_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOff2"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_On",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOffWall2",},
                },
                {
                    patternName = "Line3_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
                },

                {
                    patternName = "AirLock_Switch3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOff3"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_On",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOffWall3",},
                },
                {
                    patternName = "Line1_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Steel,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",125000},
                [3] = {"score",150000},
            },
        },
    },
	["SkeetShooting"] = {
        levelName = "Skeet Shooting",
        Features = {
            splashMode = true,
            modeSpins8 = true,
            largeBoard = true,
            gemTypes5 = true,

            hasMissingReels = true,
            hasMissingSquares = true,
            hasMakers = true,
            hasGemEaters = true,

            hasBarrelsOfFun = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "RightColumn2Large", 
                isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
                patternName = "SkeetShooting_Reels", 
                isPatternSet = false,
            },
            spawnGemOnBreak = 
            {
                {
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 3,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 3,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 3,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 3,
                },
                {
                    name = "Blue Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Green Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Purple Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Red Vertical",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_VerticalSplash,
                    weight = 1,
                },
                {
                    name = "Super Wild",
                    matchFlags = CascadeMatchFlags_Wildcard,
                    specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                    weight = 1,
                },
            },
			endGameProperties = {
				spawnGemOnBreak = {
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 3,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 3,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 3,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 3,
					},
				},
			},
            additionalNamedPatterns = {
                {
                    entryName = "MakeBurst1",
                    patternName = "SkeetShooting_Burst1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    addPieces = true,
                },
                {
                    entryName = "MakeBurst2",
                    patternName = "SkeetShooting_Burst1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    addPieces = true,
                },
                {
                    entryName = "MakeBurst3",
                    patternName = "SkeetShooting_Burst1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    addPieces = true,
                },
                {
                    entryName = "MakeBurst4",
                    patternName = "SkeetShooting_Burst1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    addPieces = true,
                },
                {
                    entryName = "MakeBurst5",
                    patternName = "SkeetShooting_Burst2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    addPieces = true,
                },
                {
                    entryName = "MakeBurst6",
                    patternName = "SkeetShooting_Burst2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    addPieces = true,
                },
                {
                    entryName = "MakeBurst7",
                    patternName = "SkeetShooting_Burst2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    addPieces = true,
                },
                {
                    entryName = "MakeBurst8",
                    patternName = "SkeetShooting_Burst2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    addPieces = true,
                },
            },
            additionalNamedMixes = {
                {
                    name = "Some Barrels",
                    delay = 0,
                    {
                        name = "Barrels",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        isGemSpawner = true,
                        weight = 2,
                    },
                    {
                        name = "Blue",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 1,
                    },
                    {
                        name = "Green",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 1,
                    },
                    {
                        name = "Purple",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 1,
                    },
                    {
                        name = "Red",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 1,
                    },
                },
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"MakeBurst1"},
                        weight = 1,
                    },
                    {
                        name = "Switch_Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"MakeBurst2"},
                        weight = 1,
                    },
                    {
                        name = "Switch_Toggle3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        -- matchPatterns = {"MakeBurst1a","MakeBurst1b"},
                        matchPatterns = {"MakeBurst3"},
                        weight = 1,
                    },
                    {
                        name = "Switch_Toggle4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"MakeBurst4"},
                        weight = 1,
                    },
                },
                {
                    name = "Toggle2",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        matchPatterns = {"MakeBurst5"},
                        weight = 1,
                    },
                    {
                        name = "Switch_Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        matchPatterns = {"MakeBurst6"},
                        weight = 1,
                    },
                    {
                        name = "Switch_Toggle3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        matchPatterns = {"MakeBurst7"},
                        weight = 1,
                    },
                    {
                        name = "Switch_Toggle4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        matchPatterns = {"MakeBurst8"},
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "SkeetShooting_Maker",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"Some Barrels"},
                },
                {
                    patternName = "SkeetShooting_Eaters",
                    isPatternSet = false,
                    gemEater = true,
                    applyGemEater = true,
                },

                --Switches
                {
                    patternName = "SkeetShooting_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    -- matchPatterns = {"MakeBurst1a","MakeBurst1b"},
                    matchPatterns = {"MakeBurst1"},
                },
                {
                    patternName = "SkeetShooting_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeBurst6"},
                },
            },
        },
        goals = {
            main = {"getGem",10,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},"Break"},
            stars = {
                [1] = {"score",200000},
                [2] = {"score",500000},
                [3] = {"score",1000000},
            },
        },
    },
    ["TowerDefense2"] = {
        --Stateless switches creates "waves" of obstacles. Get N boulders.
        levelName = "Tower Defense",
        Features = {
            splashMode = true,
            modeSpins6 = true,
            largeBoard = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasBoulders = true,
            hasBombs = true,
            hasLava = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            additionalNamedPatterns = {
                --Wave Patterns
                {
                    entryName = "Wave 1",
                    patternName = "TowerDefense2_Wave1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyExtraHits = true,
                    addPieces = true,
                },
                {
                    entryName = "Wave 2",
                    patternName = "TowerDefense2_Wave2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyTurnsToLoss = true,
                    turnsToLoss = 4,
                    addPieces = true,
                },
                {
                    entryName = "Wave 3a",
                    patternName = "TowerDefense2_Wave3a",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Lava,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
                },
                {
                    entryName = "Wave 3b",
                    patternName = "TowerDefense2_Wave3b",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyExtraHits = true,
                    extraHits = 1,
                    addPieces = true,
                },
                {
                    entryName = "Wave 3c",
                    patternName = "TowerDefense2_Wave3c",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    applyExtraHits = true,
                    extraHits = 1,
                    applyTurnsToLoss = true,
                    turnsToLoss = 10,
                    addPieces = true,
                },

                --Reinforcement Patterns (UNUSED)
                -- {
                --     entryName = "Reinforcement1",
                --     patternName = "TowerDefense2_Defender1",
                --     isPatternSet = false,
                --     applyMatchFlags = true,
                --     matchFlags = CascadeMatchFlags_Wildcard,
                --     addPieces = true,
                -- },
                -- {
                --     entryName = "Reinforcement2",
                --     patternName = "TowerDefense2_Defender2",
                --     isPatternSet = false,
                --     applyMatchFlags = true,
                --     matchFlags = CascadeMatchFlags_CommonPiece2,
                --     -- matchFlags = 31,
                --     -- anyOneMatchFlag = true,
                --     applyPieceSpecials = true,
                --     specials = CascadePieceSpecial_BlockSplash,
                --     addPieces = true,
                -- },
                --End UNUSED

                --Switch Patterns
                {
                    entryName = "stopSwitch1",
                    patternName = "TowerDefense2_StopSwitch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"goSwitch2"},
                    addPieces = true,
                },
                {
                    entryName = "goSwitch2",
                    patternName = "TowerDefense2_GoSwitch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Wave 2","stopSwitch2"},
                    addPieces = true,
                },
                {
                    entryName = "stopSwitch2",
                    patternName = "TowerDefense2_StopSwitch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"goSwitch3"},
                    addPieces = true,
                },
                {
                    entryName = "goSwitch3",
                    patternName = "TowerDefense2_GoSwitch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Wave 3a","Wave 3b","Wave 3c","stopSwitch1"},
                    addPieces = true,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "TowerDefense2_GoSwitch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Wave 1","stopSwitch1"},
                },
            },
        },
        goals = {
            main = {"getGem",25,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,extraHits = 0,},"Break"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",300000},
                [3] = {"score",500000},
            },
        },
    },
    ["ControlRoom"] = {
        --Clusters of stateless switches. Good switches create chests, Bad switches create obstacles. Get N chests.
        levelName = "Control Room",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins9 = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasChests = true,
            hasBarrels = true,
            hasStones = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            additionalNamedPatterns = {
                --makes a chest inside of a barrel
                {
                    entryName = "MakeChest1",
                    patternName = "ControlRoom_ChestSpawn1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
                    addPieces = true,
                },
                {
                    entryName = "MakeChest2",
                    patternName = "ControlRoom_ChestSpawn2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
                    addPieces = true,
                },
                {
                    entryName = "MakeBoulders",
                    patternName = "ControlRoom_BoulderSpawn",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0;
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                    addPieces = true,
                },
                {
                    entryName = "MakeStones1",
                    patternName = "ControlRoom_StoneSpawn1",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    addPieces = true,
                },
                {
                    entryName = "MakeStones2",
                    patternName = "ControlRoom_StoneSpawn2",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    addPieces = true,
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        matchPatterns = {"MakeChest1"},
                        weight = 1,
                    },
                },
                {
                    name = "Toggle2",
                    delay = 0,
                    {
                        name = "Switch_Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        matchPatterns = {"MakeChest2"},
                        weight = 1,
                    },
                },

                {
                    name = "Toggle3",
                    delay = 0,
                    {
                        name = "Switch_Toggle3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle3"},
                        matchPatterns = {"MakeBoulders"},
                        weight = 1,
                    },
                },
                {
                    name = "Toggle4",
                    delay = 0,
                    {
                        name = "Switch_Toggle4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle4"},
                        matchPatterns = {"MakeStones1"},
                        weight = 1,
                    },
                },
                {
                    name = "Toggle5",
                    delay = 0,
                    {
                        name = "Switch_Toggle5",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle5"},
                        matchPatterns = {"MakeStones2"},
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "ControlRoom_GoodSwitch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeChest1"},
                },
                {
                    patternName = "ControlRoom_GoodSwitch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeChest2"},
                },

                {
                    patternName = "ControlRoom_BoulderSwitch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle3"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeBoulders"},
                },
                {
                    patternName = "ControlRoom_StoneSwitch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle4"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeStones1"},
                },
                {
                    patternName = "ControlRoom_StoneSwitch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle5"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeStones2"},
                },
            },
        },
        endGameProperties = {
            {
                name = "Toggle1",
                delay = -1,
            },
            {
                name = "Toggle2",
                delay = -1,
            },
            {
                name = "Toggle3",
                delay = -1,
            },
            {
                name = "Toggle4",
                delay = -1,
            },
            {
                name = "Toggle5",
                delay = -1,
            },
        },
        goals = {
            main = {"getGem",8,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
            stars = {
                [1] = {"score",50000},
                [2] = {"score",100000},
                [3] = {"score",250000},
            },
        },
    },
    ["SwitchSequence2"] = {
        --Get 6 switches to the ON position - each switch surrounds the next with stones.
        levelName = "Circle of Protection",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins5 = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasStones = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "TurnOnWall1",
                    patternName = "SwitchSequence2_Wall1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
					applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    entryName = "TurnOffWall1",
                    patternName = "SwitchSequence2_Wall1",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall2",
                    patternName = "SwitchSequence2_Wall2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
					applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    entryName = "TurnOffWall2",
                    patternName = "SwitchSequence2_Wall2",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall3",
                    patternName = "SwitchSequence2_Wall3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
					applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    entryName = "TurnOffWall3",
                    patternName = "SwitchSequence2_Wall3",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall4",
                    patternName = "SwitchSequence2_Wall4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    addPieces = true,
					applyExtraHits = true,
                    extraHits = 1,
                },
                {
                    entryName = "TurnOffWall4",
                    patternName = "SwitchSequence2_Wall4",
                    isPatternSet = false,
                    clearPieces = true,
                },
                {
                    entryName = "TurnOnWall5",
                    patternName = "SwitchSequence2_Wall5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyExtraHits = true,
                    extraHits = 1,
                    addPieces = true,
                },
                {
                    entryName = "TurnOffWall5",
                    patternName = "SwitchSequence2_Wall5",
                    isPatternSet = false,
                    clearPieces = true,
                },
            },
            additionalNamedMixes = {
                --switch 1
                {
                    name = "TurnOn1",
                    delay = 0,
                    {
                        name = "Switch_On1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff1"},
                        matchPatterns = {"TurnOffWall1",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff1",
                    delay = 0,
                    {
                        name = "Switch_Off1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn1"},
                        matchPatterns = {"TurnOnWall1",},
                        weight = 1,
                    },
                },

                --switch 2
                {
                    name = "TurnOn2",
                    delay = 0,
                    {
                        name = "Switch_On2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff2"},
                        matchPatterns = {"TurnOffWall2",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff2",
                    delay = 0,
                    {
                        name = "Switch_Off2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn2"},
                        matchPatterns = {"TurnOnWall2",},
                        weight = 1,
                    },
                },

                --switch 3
                {
                    name = "TurnOn3",
                    delay = 0,
                    {
                        name = "Switch_On3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff3"},
                        matchPatterns = {"TurnOffWall3",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff3",
                    delay = 0,
                    {
                        name = "Switch_Off3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn3"},
                        matchPatterns = {"TurnOnWall3",},
                        weight = 1,
                    },
                },

                --switch 4
                {
                    name = "TurnOn4",
                    delay = 0,
                    {
                        name = "Switch_On4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff4"},
                        matchPatterns = {"TurnOffWall4",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff4",
                    delay = 0,
                    {
                        name = "Switch_Off4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn4"},
                        matchPatterns = {"TurnOnWall4",},
                        weight = 1,
                    },
                },

                 --switch 5
                {
                    name = "TurnOn5",
                    delay = 0,
                    {
                        name = "Switch_On5",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff5"},
                        matchPatterns = {"TurnOffWall5",},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff5",
                    delay = 0,
                    {
                        name = "Switch_Off5",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"TurnOn5"},
                        matchPatterns = {"TurnOnWall5",},
                        weight = 1,
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "SwitchSequence2_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall1",},
                },
                {
                    patternName = "SwitchSequence2_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn2"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall2",},
                },
                {
                    patternName = "SwitchSequence2_Switch3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn3"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall3",},
                },
                {
                    patternName = "SwitchSequence2_Switch4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn4"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall4",},
                },
                {
                    patternName = "SwitchSequence2_Switch5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn5"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"TurnOnWall5",},
                },
            },
        },
        goals = {
            main = {"haveGem",5,"Switch","Switches",{skinVariant = "DungeonSwitch_On"},"Turn on"},
            stars = {
                [1] = {"score",25000},
                [2] = {"score",50000},
                [3] = {"score",100000},
            },
        },
    },
    ["Teleporter"] = {
        --Two switches "teleport" around the board each time they are matched. Flip N Switches.
        levelName = "Teleporter",
        Features = {
            splashMode = true,
            regularBoard = true,
            modeSpins5 = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasBarrels = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            addToBoardPieceMix = {
                {
                    name = "Boulders",
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Barrels,
                    weight = 5,
                },
            },
            additionalNamedPatterns = {
                --Cycle #1
                {
                    entryName = "Switch1",
                    patternName = "Teleporter_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch2"},
                    addPieces = true,
                },
                {
                    entryName = "Switch2",
                    patternName = "Teleporter_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch3"},
                    addPieces = true,
                },
                {
                    entryName = "Switch3",
                    patternName = "Teleporter_Switch3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch4"},
                    addPieces = true,
                },
                {
                    entryName = "Switch4",
                    patternName = "Teleporter_Switch4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch5"},
                    addPieces = true,
                },
                {
                    entryName = "Switch5",
                    patternName = "Teleporter_Switch5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch1"},
                    addPieces = true,
                },

                --Cycle #2
                {
                    entryName = "Switch6",
                    patternName = "Teleporter_Switch6",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch7"},
                    addPieces = true,
                },
                {
                    entryName = "Switch7",
                    patternName = "Teleporter_Switch7",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch8"},
                    addPieces = true,
                },
                {
                    entryName = "Switch8",
                    patternName = "Teleporter_Switch8",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch9"},
                    addPieces = true,
                },
                {
                    entryName = "Switch9",
                    patternName = "Teleporter_Switch9",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch10"},
                    addPieces = true,
                },
                {
                    entryName = "Switch10",
                    patternName = "Teleporter_Switch10",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch6"},
                    addPieces = true,
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "Teleporter_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch2"},
                },
                {
                    patternName = "Teleporter_Switch5",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Switch6"},
                },
            },
        },
        goals = {
            main = {"getGem",20,"Switch","Switches",{skinVariant = "DungeonSwitch_Toggle"},"Flip"},
            stars = {
                [1] = {"score",70000},
                [2] = {"score",100000},
                [3] = {"score",200000},
            },
        },
    },
    ["OrangeFactory"] = {
        levelName = "Midas Touch",
        -- introScript = "Land30_MidasTouch",
        Features = {
            splashMode = true,
            regularBoard = true,
            modeSpins7 = true,
            gemTypes4 = true,

            hasSwitches = true,
            hasMissingSquares = true,
            hasMissingReels = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "OrangeFactory_Reels",
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "OrangeFactory_Missing",
                isPatternSet = false,
            },
            reelPieceMix = {
                {
                    name = "Blue",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 1,
                },
                {
                    name = "Green",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 1,
                },
                {
                    name = "Purple",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 1,
                },
                {
                    name = "Red",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 1,
                },
                {
                    name = "Orange",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 1.5,
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "BlueTarget",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                    },
                },
                {
                    entryName = "GreenTarget",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                    },
                },
                {
                    entryName = "PurpleTarget",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                    },
                },
                {
                    entryName = "RedTarget",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                    },
                },
                {
                    entryName = "YellowTarget",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                    },
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        weight = 1,
                        matchPatterns = {"BlueTarget"},
                    },
                },
                {
                    name = "Toggle2",
                    delay = 0,
                    {
                        name = "Switch_Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        weight = 1,
                        matchPatterns = {"GreenTarget"},
                    },
                },
                {
                    name = "Toggle3",
                    delay = 0,
                    {
                        name = "Switch_Toggle3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle3"},
                        weight = 1,
                        matchPatterns = {"PurpleTarget"},
                    },
                },
                {
                    name = "Toggle4",
                    delay = 0,
                    {
                        name = "Switch_Toggle4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle4"},
                        weight = 1,
                        matchPatterns = {"RedTarget"},
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "OrangeFactory_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"BlueTarget"},
                },
                {
                    patternName = "OrangeFactory_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"GreenTarget"},
                },
                {
                    patternName = "OrangeFactory_Switch3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle3"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"PurpleTarget"},
                },
                {
                    patternName = "OrangeFactory_Switch4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle4"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"RedTarget"},
                },
            },
        },
        goals = {
            main = {"getGem",125,"Yellow","Yellows",{matchFlags = CascadeMatchFlags_CommonPiece5},"Collect"},
            stars = {
                [1] = {"score",300000},
                [2] = {"score",450000},
                [3] = {"score",600000},
            },
        },
    },
    ["TasteTheRainbow"] = {
        levelName = "Rainbow Bridge",
        -- introScript = "Land30_RainbowBridge",
        Features = {
            splashMode = true,
            regularBoard = true,
            modeSpins1 = true,
            gemTypes4 = true,

            hasSwitches = true,
        },
        tricks = {
            {name = Config.World30Tricks_Trick1},
            {name = Config.World30Tricks_Trick2},
            {name = Config.World30Tricks_Trick3},
            {name = Config.TricksDefault_Trick2_OneMoreSpin},
        },
        boosts = World30Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "BlueGreen",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                    },
                },
                {
                    entryName = "GreenPurple",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                    },
                },
                {
                    entryName = "PurpleRed",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                    },
                },
                {
                    entryName = "RedBlue",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    filter = {
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                    },
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        weight = 1,
                        matchPatterns = {"BlueGreen"},
                    },
                },
                {
                    name = "Toggle2",
                    delay = 0,
                    {
                        name = "Switch_Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle2"},
                        weight = 1,
                        matchPatterns = {"GreenPurple"},
                    },
                },
                {
                    name = "Toggle3",
                    delay = 0,
                    {
                        name = "Switch_Toggle3",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle3"},
                        weight = 1,
                        matchPatterns = {"PurpleRed"},
                    },
                },
                {
                    name = "Toggle4",
                    delay = 0,
                    {
                        name = "Switch_Toggle4",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle4"},
                        weight = 1,
                        matchPatterns = {"RedBlue"},
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "TasteTheRainbow_Switch1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"BlueGreen"},
                },
                {
                    patternName = "TasteTheRainbow_Switch2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle2"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"GreenPurple"},
                },
                {
                    patternName = "TasteTheRainbow_Switch3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle3"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"PurpleRed"},
                },
                {
                    patternName = "TasteTheRainbow_Switch4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle4"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"RedBlue"},
                },
            },
        },
        goals = {
            main = {"finish",true},
            stars = {
                [1] = {"score",500000},
                [2] = {"score",750000},
                [3] = {"score",1000000},
            },
        },
    },
    ["EmergencyEscape"] = {
        levelName = "Dungeon Trap",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins6 = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasStones = true,
            hasBombs = true,
            hasSteel = true,
            hasChests = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "CenterReel_Large",
                isPatternSet = false,
            },
            additionalNamedPatterns = {
                {
                    entryName = "ClearSteel",
                    patternName = "EmergencyEscape_steel",
                    isPatternSet = false,
                    clearPieces = true,
                    filter = {
                        specials = CascadePieceSpecials_Steel,
                    },
                },
                {
                    entryName = "MakeStone",
                    patternName = "EmergencyEscape_stone",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Stone,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyExtraHits = true,
                    extraHits = 2,
                    addPieces = true,
                },
                {
                    entryName = "MakeBombCorners",
                    patternName = "EmergencyEscape_bombCorners",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_Barrels,
                    applyTurnsToLoss = true,
                    turnsToLoss = 16,
                    addPieces = true,
                },
                {
                    entryName = "MakeBombs1",
                    patternName = "EmergencyEscape_bombs1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyTurnsToLoss = true,
                    turnsToLoss = 11,
                    addPieces = true,
                },
                {
                    entryName = "MakeBombs2",
                    patternName = "EmergencyEscape_bombs2",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyTurnsToLoss = true,
                    turnsToLoss = 9,
                    addPieces = true,
                },
                {
                    entryName = "MakeBombs3",
                    patternName = "EmergencyEscape_bombs3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecial_CantCover,
                    applyTurnsToLoss = true,
                    turnsToLoss = 7,
                    addPieces = true,
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "EmergencyEscape_Treasure",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
                    applyMatchFlags = true,
                    matchFlags = 0,
                },
                {
                    patternName = "EmergencyEscape_switch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"MakeStone","ClearSteel","MakeBombCorners","MakeBombCorners","MakeBombs1","MakeBombs2","MakeBombs3"},
                },
                {
                    patternName = "EmergencyEscape_steel",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
                },
            },
        },
        goals = {
            main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",200000},
                [3] = {"score",300000},
            },
        },
    },
    ["GravitySwapper"] = {
        levelName = "Magic Chests",
        introScript = "Land30_MagicChests",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins7 = true,
            gemTypes5 = true,

            hasSwitches = true,
            hasBalloons = true,
            hasChests = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            additionalNamedPatterns = {
                {
                    entryName = "PopBalloons",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure,
                    applyAugmentSpecials = true,
                    augmentSpecials = 0,
                    applyCancelSpecials = true,
                    cancelSpecials = 0,
                    filter = {
                        specials = CascadePieceSpecials_Treasure_Balloon,
                    },
                },
                {
                    entryName = "Balloonify",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure_Balloon,
                    applyAugmentSpecials = true,
                    augmentSpecials = CascadePieceSpecial_SplashImmune,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
                    filter = {
                        specials = CascadePieceSpecials_Treasure,
                    },
                },
            },
            additionalNamedMixes = {
                {
                    name = "OnSwitch",
                    delay = 0,
                    {
                        name = "Switch_Toggle2",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"OffSwitch"},
                        weight = 1,
                        matchPatterns = {},
                        applySpawnBelowTypes = true,
                        spawnBelowTypes = {"PopController"},
                    },
                },
                {
                    name = "OffSwitch",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        spawnTypes = {"OnSwitch"},
                        weight = 1,
                        matchPatterns = {"Balloonify","TurnOnSwitches"},
                        applySpawnBelowTypes = true,
                        spawnBelowTypes = {"PopController"},
                    },
                },
                {
                    name = "PopController",
                    delay = -1,
                    events = {
                        {
                            eventType = "population",
                            newDelay = -1,
                            count = 2,
                            comparator = "greater",
                            gemType = {
                                {
                                    skinVariant = "DungeonSwitch_Off",
                                },
                            },
                            patterns = {"PopBalloons","TurnOffSwitches"},
                        },
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "GravitySwapper_switch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_On",
                    applySpawnTypes = true,
                    spawnTypes = {"OffSwitch"},
                    applyMatchPatterns = true,
                    matchPatterns = {},
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"PopController"},
                },
                {
                    patternName = "GravitySwapper_balloonChests",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Treasure_Balloon,
                    applyAugmentSpecials = true,
                    augmentSpecials = CascadePieceSpecial_SplashImmune,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon_Obstacle,
                },
            },
        },
        goals = {
            main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop"},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",500000},
                [3] = {"score",750000},
            },
        },
    },
    --End Roh Levels




    --SIDE LEVELS
    ["DefusingSwitch_side"] = {
        levelName = "Ballista",
        Features = {
            splashMode = true,
            largeBoard = true,
            modeSpins8 = true,
            gemTypes5 = true,
            treasureChest = true,

            hasSwitches = true,
            hasBombs = true,
            hasChests = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            addToBoardPieceMix = {
                {
                    name = "Bomb 1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    weight = 2.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                },
                {
                    name = "Bomb 2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    weight = 2.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                },
                {
                    name = "Bomb 3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    weight = 2.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                },
                {
                    name = "Bomb 4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    weight = 2.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                },
                {
                    name = "Bomb 5",
                    matchFlags = CascadeMatchFlags_CommonPiece5,
                    weight = 2.5, 
                    specials = CascadePieceSpecial_CantCover,
                    turnsToLoss = 10,
                },
            },
            additionalNamedPatterns = {
                {
                    entryName = "Clear All Bombs",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    clearPieces = true,
                    filter = {
                        turnsToLoss = true,
                    },
                },
                {
                    entryName = "Clear All Chests",
                    patternName = "FullBoardLarge",
                    isPatternSet = false,
                    clearPieces = true,
                    filter = {
                        specials = CascadePieceSpecials_Treasure,
                    },
                },
            },
            additionalNamedMixes = {
                {
                    name = "Toggle1",
                    delay = 0,
                    {
                        name = "Switch_Toggle1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Toggle",
                        spawnTypes = {"Toggle1"},
                        weight = 1,
                        matchPatterns = {"Clear All Bombs","Clear All Chests"},
                    },
                },
            },
            endGameProperties = {
                boardPieceMix = {
                    {
                        name = "Gem 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 2, 
                    },
                    {
                        name = "Gem 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 2, 
                    },
                    {
                        name = "Gem 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 2, 
                    },
                    {
                        name = "Gem 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 2, 
                    },
                    {
                        name = "Gem 5",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 2, 
                    },
                },
            },
            additionalInitialPatterns = { 
                {
                    patternName = "Contingency_Switch",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"Toggle1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Toggle",
                    applyMatchPatterns = true,
                    matchPatterns = {"Clear All Bombs","Clear All Chests"},
                    applyTurnsToLoss = true,
                    turnsToLoss = -1,
                },
            },
        },
        goals = {
            main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure, cancelSpecials = 0,},"Drop",},
            stars = {
                [1] = {"score",300000},
                [2] = {"score",600000},
                [3] = {"score",950000},
            },
        },
    },
	["RaceTheClock"] = {
		levelName = "Race the Clock",
		introScript = "Land30_RaceTheClock",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasSwitches = true,
			hasSteel = true,
			hasBombs = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "TurnOnSteel2",
					patternName = "RaceTheClock_steel2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[2] = {
					entryName = "ClearSteel2",
					patternName = "RaceTheClock_steel2",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "TurnOnSteel1",
					patternName = "RaceTheClock_steel1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				[4] = {
					entryName = "ClearSteel1",
					patternName = "RaceTheClock_steel1",
					isPatternSet = false,
					clearPieces = true,
				},
				[5] = {
					entryName = "TurnOnBomb1",
					patternName = "RaceTheClock_bomb1",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[6] = {
					entryName = "TurnOnBomb2",
					patternName = "RaceTheClock_bomb2",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[7] = {
					entryName = "TurnOnBomb3",
					patternName = "RaceTheClock_bomb3",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[8] = {
					entryName = "TurnOnBomb4",
					patternName = "RaceTheClock_bomb4",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[9] = {
					entryName = "TurnOnBomb5",
					patternName = "RaceTheClock_bomb5",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[10] = {
					entryName = "TurnOnBomb6",
					patternName = "RaceTheClock_bomb6",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[11] = {
					entryName = "TurnOnBomb7",
					patternName = "RaceTheClock_bomb7",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[12] = {
					entryName = "TurnOnBomb8",
					patternName = "RaceTheClock_bomb8",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[13] = {
					entryName = "TurnOnBomb9",
					patternName = "RaceTheClock_bomb9",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[14] = {
					entryName = "TurnOnBomb10",
					patternName = "RaceTheClock_bomb10",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[15] = {
					entryName = "TurnOnBomb11",
					patternName = "RaceTheClock_bomb11",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[16] = {
					entryName = "TurnOnBomb12",
					patternName = "RaceTheClock_bomb12",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
				},
				[17] = {
					entryName = "ClearAllBombs",
					patternName = "FullBoardLarge",
					isPatternSet = false,
					applyTurnsToLoss = true,
					turnsToLoss = -1,
					filter = {
						turnsToLoss = true,
					},
				},
			},
			additionalNamedMixes = {
					[1] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel1","TurnOnBomb1"},
						spawnTypes = {"TurnOn1"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel2","TurnOnBomb2"},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel1","TurnOnBomb3"},
						spawnTypes = {"TurnOn2"},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff3"},
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel2","TurnOnBomb4"},
						weight = 1,
					},
				},
				[5] = {
					name = "TurnOff3",
					delay = 0,
					{
						name = "Switch_Off3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel1","TurnOnBomb5"},
						spawnTypes = {"TurnOn3"},
						weight = 1,
					},
				},
				[6] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff4"},
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel2","TurnOnBomb6"},
						weight = 1,
					},
				},
				[7] = {
					name = "TurnOff4",
					delay = 0,
					{
						name = "Switch_Off4",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel1","TurnOnBomb7"},
						spawnTypes = {"TurnOn4"},
						weight = 1,
					},
				},
				[8] = {
					name = "TurnOn4",
					delay = 0,
					{
						name = "Switch_On4",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff5"},
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel2","TurnOnBomb8"},
						weight = 1,
					},
				},
				[9] = {
					name = "TurnOff5",
					delay = 0,
					{
						name = "Switch_Off5",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel1","TurnOnBomb9"},
						spawnTypes = {"TurnOn5"},
						weight = 1,
					},
				},
				[10] = {
					name = "TurnOn5",
					delay = 0,
					{
						name = "Switch_On5",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff6"},
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel2","TurnOnBomb10"},
						weight = 1,
					},
				},
				[11] = {
					name = "TurnOff6",
					delay = 0,
					{
						name = "Switch_Off6",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel1","TurnOnBomb11"},
						spawnTypes = {"TurnOn6"},
						weight = 1,
					},
				},
				[12] = {
					name = "TurnOn6",
					delay = 0,
					{
						name = "Switch_On6",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel2","TurnOnBomb12"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "RaceTheClock_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff2"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"ClearSteel1","ClearSteel2","ClearAllBombs","TurnOnSteel2","TurnOnBomb2"},
				},
				{
					patternName = "RaceTheClock_steel1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
				{
					patternName = "RaceTheClock_bomb1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
					skinVariant = "DungeonSteel",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",115000},
				[2] = {"score",150000},
				[3] = {"score",200000},
			},
		},
	},

	["LaserToggle"] = {
        levelName = "Laser Toggle",
		outtroScript = "Land30_Outtro",                 
        Features = {
            modeSpins10 = true,
            splashMode = true,
            largeBoard = true,
            gemTypes5 = true,
            hasChests = true,
            hasLasers = true,
            hasMissingSquares = true,
            hasPortals = true,
            hasBarrels = true,
            hasMakers = true,
            hasFences = true,
        },
        tricks = World30Tricks,
        boosts = World30Boosts,
        Properties = {
            portals = {
                [1] = {{0,3},{6,4},"PortalEntrance_1","PortalExit_1"},
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "LaserToggle_missing",
                isPatternSet = false,
            },
            additionalNamedPatterns = {
                {
                    entryName = "LeftLaserH",
                    patternName = "HedgeTrimmer_Color4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                    applySpawnTypes = true,
                    spawnTypes = {"LaserH"},
					applySkinVariant = true,
					skinVariant = "DungeonLaserH",
                },
                {
                    entryName = "LeftLaserV",
                    patternName = "HedgeTrimmer_Color4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
                    applySpawnTypes = true,
                    spawnTypes = {"LaserV"},
					applySkinVariant = true,
					skinVariant = "DungeonLaserV",
                },
                {
                    entryName = "RightLaserH",
                    patternName = "RubeChest",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                    applySpawnTypes = true,
                    spawnTypes = {"LaserH"},
					applySkinVariant = true,
					skinVariant = "DungeonLaserH",
                },
                {
                    entryName = "RightLaserV",
                    patternName = "RubeChest",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
                    applySpawnTypes = true,
                    spawnTypes = {"LaserV"},
					applySkinVariant = true,
					skinVariant = "DungeonLaserV",
                },
            },
            additionalInitialPatterns = {
                {
                    patternName = "HedgeTrimmer_Color4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
                    applySpawnTypes = true,
                    spawnTypes = {"LaserV"},
					applySkinVariant = true,
					skinVariant = "DungeonLaserV",
                },
                {
                    patternName = "RubeChest",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                    applySpawnTypes = true,
                    spawnTypes = {"LaserH"},
					applySkinVariant = true,
					skinVariant = "DungeonLaserH",
                },
                {
                    patternName = "LaserToggle_fences",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Fence,
                },
                {
                    patternName = "CornerSteel_topLeft_inside",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Steel,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applySpawnBelowTypes = true,
                    spawnBelowTypes = {"ChestAlternator","BoulderAlternator"},
                    -- spawnBelowTypes = {"Always Chests","Always Boulder"},
                },
                {
                    patternName = "LaserToggle_boulder",
                    isPatternSet = false,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Barrels,
                },
                {
                    patternName = "Row4Center",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Stone,
                    applySpawnTypes = true,
                    spawnTypes = {"TurnOn1"},
                    applySkinVariant = true,
                    skinVariant = "DungeonSwitch_Off",
                    applyMatchPatterns = true,
                    matchPatterns = {"LeftLaserH","RightLaserV"},
                },
            },
            additionalNamedMixes = {
                {
                    name = "TurnOn1",
                    delay = 0,
                    {
                        name = "Switch_On1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_On",
                        spawnTypes = {"TurnOff1"},
                        matchPatterns = {"LeftLaserV","RightLaserH"},
                        weight = 1,
                    },
                },
                {
                    name = "TurnOff1",
                    delay = 0,
                    {
                        name = "Switch_Off1",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Stone,
                        skinVariant = "DungeonSwitch_Off",
                        matchPatterns = {"LeftLaserH","RightLaserV"},
                        spawnTypes = {"TurnOn1"},
                        weight = 1,
                    },
                },
                {
                    name = "LaserH",
                    delay = 0,
                    {
                        name = "LaserH 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"LaserH",},
                        weight = 1,
						skinVariant = "DungeonLaserH",
                    },
                    {
                        name = "LaserH 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"LaserH",},
                        weight = 1,
						skinVariant = "DungeonLaserH",
                    },
                    {
                        name = "LaserH 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"LaserH",},
                        weight = 1,
						skinVariant = "DungeonLaserH",
                    },
                    {
                        name = "LaserH 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"LaserH",},
                        weight = 1,
						skinVariant = "DungeonLaserH",
                    },
                    {
                        name = "LaserH 5",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
                        spawnTypes = {"LaserH",},
                        weight = 1,
						skinVariant = "DungeonLaserH",
                    },
                },
                {
                    name = "LaserV",
                    delay = 0,
                    {
                        name = "LaserV 1",
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
                        spawnTypes = {"LaserV",},
                        weight = 1,
						skinVariant = "DungeonLaserV",
                    },
                    {
                        name = "LaserV 2",
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
                        spawnTypes = {"LaserV",},
                        weight = 1,
						skinVariant = "DungeonLaserV",
                    },
                    {
                        name = "LaserV 3",
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
                        spawnTypes = {"LaserV",},
                        weight = 1,
						skinVariant = "DungeonLaserV",
                    },
                    {
                        name = "LaserV 4",
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
                        spawnTypes = {"LaserV",},
                        weight = 1,
						skinVariant = "DungeonLaserV",
                    },
                    {
                        name = "LaserV 5",
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
                        spawnTypes = {"LaserV",},
                        weight = 1,
						skinVariant = "DungeonLaserV",
                    },
                },
                {
                    name = "ChestAlternator",
                    delay = 0,
                    shuffle = false,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = -1,
                            reset = false,
                        },
                        [2] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 0,
                            targetMix = "BoulderAlternator",
                            reset = true,
                        },
                    },
                    {
                        name = "Treasure",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Treasure,
                        weight = 1,
                    },
                },
                {
                    name = "BoulderAlternator",
                    delay = -1,
                    events = {
                        [1] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = -1,
                            reset = false,
                        },
                        [2] = {
                            eventType = "emitCount",
                            count = 1,
                            newDelay = 0,
                            targetMix = "ChestAlternator",
                            reset = true,
                        },
                    },
                    {
                        name = "Boulder",
                        matchFlags = 0,
                        specials = CascadePieceSpecials_Barrels,
                        weight = 1,
                    },
                },
            },
            endGameProperties = {
                additionalNamedMixes = {
                    {
                        name = "LaserH",
                        delay = 0,
                        {
                            name = "LaserH 1",
                            matchFlags = CascadeMatchFlags_CommonPiece1,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserH",
							spawnTypes = {"LaserH",},
                        },
                        {
                            name = "LaserH 2",
                            matchFlags = CascadeMatchFlags_CommonPiece2,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserH",
							spawnTypes = {"LaserH",},
                        },
                        {
                            name = "LaserH 3",
                            matchFlags = CascadeMatchFlags_CommonPiece3,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserH",
							spawnTypes = {"LaserH",},
                        },
                        {
                            name = "LaserH 4",
                            matchFlags = CascadeMatchFlags_CommonPiece4,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserH",
							spawnTypes = {"LaserH",},
                        },
                        {
                            name = "LaserH 5",
                            matchFlags = CascadeMatchFlags_CommonPiece5,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserH",
							spawnTypes = {"LaserH",},
                        },
                    },
                    {
                        name = "LaserV",
                        delay = 0,
                        {
                            name = "LaserV 1",
                            matchFlags = CascadeMatchFlags_CommonPiece1,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
							skinVariant = "DungeonLaserV",
							spawnTypes = {"LaserV",},
                        },
                        {
                            name = "LaserV 2",
                            matchFlags = CascadeMatchFlags_CommonPiece2,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserV",
							spawnTypes = {"LaserV",},
                        },
                        {
                            name = "LaserV 3",
                            matchFlags = CascadeMatchFlags_CommonPiece3,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserV",
							spawnTypes = {"LaserV",},
                        },
                        {
                            name = "LaserV 4",
                            matchFlags = CascadeMatchFlags_CommonPiece4,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserV",
							spawnTypes = {"LaserV",},
                        },
                        {
                            name = "LaserV 5",
                            matchFlags = CascadeMatchFlags_CommonPiece5,
                            specials = CascadePieceSpecials_Laser,
                            weight = 1,
                            skinVariant = "DungeonLaserV",
							spawnTypes = {"LaserV",},
                        },
                    },
                    {
                        name = "TurnOn1",
                        delay = 0,
                        {
                            name = "Switch_On1",
                            matchFlags = 0,
                            specials = CascadePieceSpecials_Stone,
                            skinVariant = "DungeonSwitch_On",
                            weight = 1,
							spawnTypes = {"TurnOn1",},
                        },
                    },
                    {
                        name = "TurnOff1",
                        delay = 0,
                        {
                            name = "Switch_Off1",
                            matchFlags = 0,
                            specials = CascadePieceSpecials_Stone,
                            skinVariant = "DungeonSwitch_Off",
                            weight = 1,
							spawnTypes = {"TurnOff1",},
                        },
                    },
                },
            },
        },
        goals = {
            main = {"getGem",5,"Chest","Chests",{specials = CascadePieceSpecials_Treasure, cancelSpecials = 0,},"Drop",},
            stars = {
                [1] = {"score",100000},
                [2] = {"score",400000},
                [3] = {"score",650000},
            },
        },
        expectedScore = 100000, 
    },
	["BombColumns"] = {
		levelName = "Ticking Towers",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes3 = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			hasBombs = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
                patternName = "Columns_Reels",
                isPatternSet = false,
            },
            useMissingSquares = true,
            missingSquares = {
                patternName = "BombColumn Walls",
                isPatternSet = false,
            },
            addToBoardPieceMix = {
                {
					name = "Bomb 1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 7,
					weight = 4,
				},
				{
					name = "Bomb 2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 7,
					weight = 4,
				},
				{
					name = "Bomb 3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 7,
					weight = 4,
				},
            },
			endGameProperties = {
				boardPieceMix = {
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2, 
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2, 
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2, 
					},
				},
			},
		},
		goals = {
			main = {"getGem",35,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,},"Defuse"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},
	["BreakerBox"] = {
		levelName = "Breaker Box",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasColoredKeyGems = true,
			hasSwitches = true,
			hasFences = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Remove Green Wall",
					patternName = "BreakerBox_bedrockGreen",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Remove Blue Wall",
					patternName = "BreakerBox_bedrockBlue",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "Remove Red Wall",
					patternName = "BreakerBox_bedrockRed",
					isPatternSet = false,
					clearPieces = true,
				},
				[4] = {
					entryName = "Remove Purple Wall",
					patternName = "BreakerBox_bedrockPurple",
					isPatternSet = false,
					clearPieces = true,
				},
				[5] = {
					entryName = "LeftFenceOff",
					patternName = "PrisonBreak_RedWall",
					isPatternSet = false,
					clearPieces = true,
				},
				[6] = {
					entryName = "LeftFenceOn",
					patternName = "PrisonBreak_RedWall",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					addPieces = true,
				},
				[7] = {
					entryName = "RightFenceOff",
					patternName = "Hypobaric_orangeRock",
					isPatternSet = false,
					clearPieces = true,
				},
				[8] = {
					entryName = "RightFenceOn",
					patternName = "Hypobaric_orangeRock",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
					addPieces = true,
				},
			},
			additionalNamedMixes = {
				{
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"LeftFenceOn"},
						weight = 1,
					},
				},
				{
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"LeftFenceOff"},
						spawnTypes = {"TurnOn1"},
						weight = 1,
					},
				},
				{
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"RightFenceOn"},
						weight = 1,
					},
				},
				{
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "DungeonSwitch_Off",
						matchPatterns = {"RightFenceOff"},
						spawnTypes = {"TurnOn2"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BreakerBox_bedrockBlue",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[2] = {
					patternName = "BreakerBox_bedrockGreen",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "BreakerBox_bedrockRed",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[4] = {
					patternName = "BreakerBox_pickaxeGreen",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Green Wall"},
				},
				[5] = {
					patternName = "BreakerBox_pickaxeBlue",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Blue Wall"},
				},
				[6] = {
					patternName = "BreakerBox_pickaxeRed",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Red Wall"},
				},
				[7] = {
					patternName = "BreakerBox_bedrockPurple",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				[8] = {
					patternName = "BreakerBox_fences",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,
				},
				[9] = {
					patternName = "BreakerBox_pickaxePurple",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyIcon = true,
					icon = "Icon_PickAxe",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
					applyMatchPatterns = true,
					matchPatterns = {"Remove Purple Wall"},
				},
				[10] = {
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"LeftFenceOff"},
				},
				[11] = {
					patternName = "TopRow_Column7_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "DungeonSwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"RightFenceOff"},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bedrock.singular","Bedrock.plural",{specials = CascadePieceSpecials_Steel,},},
            stars = {
				[1] = {"score",200000},
				[2] = {"score",400000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000, 
	},

	["AxeChase"] = {
		levelName = "Axe Chase",
		Features = {
			splashMode = true,
			modeSpins4 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasGemEaters = true,
			hasColoredKeyGems = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Blue Key Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
						[2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece1,
                                icon = "Icon_PickAxe",
                            },
                        },
						[3] = {
                            eventType = "population",
                            count = 3,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
						[4] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece1,
                                icon = "Icon_PickAxe",
                            },
                        },
						[5] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
								icon = "Icon_GemBlue",
                            },
                        },
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"BlueSteel"},
					},
				},
				[2] = {
					name = "Green Key Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
						[2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece2,
                                icon = "Icon_PickAxe",
                            },
                        },
						[3] = {
                            eventType = "population",
                            count = 3,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
						[4] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece2,
                                icon = "Icon_PickAxe",
                            },
                        },
						[5] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
								icon = "Icon_GemGreen",
                            },
                        },
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"GreenSteel"},
					},
				},
				[3] = {
					name = "Purple Key Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
						[2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece3,
                                icon = "Icon_PickAxe",
                            },
                        },
						[3] = {
                            eventType = "population",
                            count = 3,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
						[4] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece3,
                                icon = "Icon_PickAxe",
                            },
                        },
						[5] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
								icon = "Icon_GemPurple",
                            },
                        },
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"PurpleSteel"},
					},
				},
				[4] = {
					name = "Red Key Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
						[2] = {
                            eventType = "population",
                            count = 0,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece4,
                                icon = "Icon_PickAxe",
                            },
                        },
						[3] = {
                            eventType = "population",
                            count = 3,
                            comparator = "greater",
                            newDelay = -1,
                            gemType = {
                                icon = "Icon_PickAxe",
                            },
                        },
						[4] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = 0,
                            gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece4,
                                icon = "Icon_PickAxe",
                            },
                        },
						[5] = {
                            eventType = "population",
                            count = 1,
                            comparator = "less",
                            newDelay = -1,
                            gemType = {
								icon = "Icon_GemRed",
                            },
                        },
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"RedSteel"},
					},
				},
				[5] = {
					name = "4 Color Mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalNamedPatterns = {
				{
                    entryName = "BlueSteel",
                    patternName = "AxeChase_bedrockBlue",
                    isPatternSet = false,
					clearPieces = true,
                },
				{
                    entryName = "GreenSteel",
                    patternName = "AxeChase_bedrockGreen",
                    isPatternSet = false,
					clearPieces = true,
                },
				{
                    entryName = "PurpleSteel",
                    patternName = "AxeChase_bedrockPurple",
                    isPatternSet = false,
					clearPieces = true,
                },
				{
                    entryName = "RedSteel",
                    patternName = "AxeChase_bedrockRed",
                    isPatternSet = false,
					clearPieces = true,
                },
			},
			additionalInitialPatterns = { 
				{
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Blue Key Mix","4 Color Mix"},
				},
				{
					patternName = "TreasureDispenser_Maker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Green Key Mix","4 Color Mix"},
				},
				{
					patternName = "FillTheVoid_maker3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Purple Key Mix","4 Color Mix"},
				},
				{
					patternName = "PrisonBreak_BlueKey",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Red Key Mix","4 Color Mix"},
				},
				{
					patternName = "SpaceInvaders_lasers",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				{
					patternName = "AxeChase_bedrockBlue",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "AxeChase_bedrockGreen",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "AxeChase_bedrockPurple",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},{
					patternName = "AxeChase_bedrockRed",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_GemRed",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					skinVariant = "BedRock",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bedrock.singular","Bedrock.plural",{specials = CascadePieceSpecials_Steel,skinVariant = "BedRock",},},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",150000},
				[3] = {"score",250000},
			},
		},
	},

	["FlameRetardant"] = {
		levelName = "Flame Retardant",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasLava = true,
			hasBoulders = true,
			hasMakers = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Make Lava",
					delay = 0,
					{
						name = "Lava",
						matchFlags = 0,
						specials = CascadePieceSpecials_Lava,
						weight = 1,
					},
				},
			},
			addToBoardPieceMix = {
				{
					name = "Double Boulders",
					extraHits = 1,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 7,
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "BigCratePattern4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Lava",},
				},
				{
					patternName = "Line2_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 0,
				},
				{
					patternName = "Line3_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},
		goals = {
			main = {"getGem",22,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,extraHits = 0,},},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",120000},
				[3] = {"score",250000},
			},
		},
	},
	["ReplenishingBedrock"] = {
		--[[
            "CaaabcB", --1,2,3 = walls
            " 111bb ", 
            " cc222 ", --A,B,C = key vendors
            "  333  ", --a,b,c = makers to refresh walls
            "   A   ",
            "       ",
            "       ",
            "       ",
		]]--
		levelName = "Replenishing Bedrock",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes6 = true,
			hasMakers = true,
			hasColoredKeyGems = true,
			hasPortals = true,
		},
		tricks = World30Tricks,
		boosts = World30Boosts,
		Properties = {
			portals = {
				[1] = {{4,0},{3,2},"PortalEntrance_1","PortalExit_1"},
				[2] = {{5,0},{3,3},"PortalEntrance_1","PortalExit_1"},
				[3] = {{1,2},{4,3},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
				{
					name = "Normal Mix",
					delay = 0,
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Gem 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
					{
						name = "Gem 6",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				{
					name = "Make Wall 1",
					delay = -1,
					{
						name = "Wall 1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						icon = "Icon_GemBlue",
						skinVariant = "BedRock",
						weight = 1,
					},
					events = {
						{
							eventType = "population",
							count = 3,
							comparator = "less",
							newDelay = 3,
							setCooldowns = {-1,0},
							gemType = {
								icon = "Icon_GemBlue",
							},
						},
						{
						
							eventType = "population",
							count = 2,
							comparator = "greater",
							newDelay = -1,
							setCooldowns = {0,0},
							gemType = {
								icon = "Icon_GemBlue",
							},
						},
						{
							eventType = "emitCount",
							count = 3,
							newDelay = -1,
						},
					},
				},
				{
					name = "Make Wall 2",
					delay = -1,
					{
						name = "Wall 2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						icon = "Icon_GemGreen",
						skinVariant = "BedRock",
						weight = 1,
					},
					events = {
						{
							eventType = "population",
							count = 3,
							comparator = "less",
							newDelay = 3,
							setCooldowns = {-1,0},
							gemType = {
								icon = "Icon_GemGreen",
							},
						},
						{
						
							eventType = "population",
							count = 2,
							comparator = "greater",
							newDelay = -1,
							setCooldowns = {0,0},
							gemType = {
								icon = "Icon_GemGreen",
							},
						},
						{
							eventType = "emitCount",
							count = 3,
							newDelay = -1,
						},
					},
				},
				{
					name = "Make Wall 3",
					delay = -1,
					{
						name = "Wall 3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						icon = "Icon_GemPurple",
						skinVariant = "BedRock",
						weight = 1,
					},
					events = {
						{
							eventType = "population",
							count = 3,
							comparator = "less",
							newDelay = 3,
							setCooldowns = {-1,0},
							gemType = {
								icon = "Icon_GemPurple",
							},
						},
						{
						
							eventType = "population",
							count = 2,
							comparator = "greater",
							newDelay = -1,
							setCooldowns = {0,0},
							gemType = {
								icon = "Icon_GemPurple",
							},
						},
						{
							eventType = "emitCount",
							count = 3,
							newDelay = -1,
						},
					},
				},
				{
					name = "Make Key 1",
					delay = 3,
					{
						name = "Key 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"Clear Wall 1",},
						weight = 1,
					},
					events = {
						{
							eventType = "population",
							count = 1,
							comparator = "less",
							newDelay = -1,
							setCooldowns = {0,0},
							gemType = {
								icon = "Icon_GemBlue",
							},
						},
						{
						
							eventType = "population",
							count = 0,
							comparator = "greater",
							newDelay = 2,
							setCooldowns = {0,-1},
							gemType = {
								icon = "Icon_GemBlue",
							},
						},
						{
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
					},
				},
				{
					name = "Make Key 2",
					delay = 3,
					{
						name = "Key 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"Clear Wall 2",},
						weight = 1,
					},
					events = {
						{
							eventType = "population",
							count = 1,
							comparator = "less",
							newDelay = -1,
							setCooldowns = {0,0},
							gemType = {
								icon = "Icon_GemGreen",
							},
						},
						{
						
							eventType = "population",
							count = 0,
							comparator = "greater",
							newDelay = 2,
							setCooldowns = {0,-1},
							gemType = {
								icon = "Icon_GemGreen",
							},
						},
						{
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
					},
				},
				{
					name = "Make Key 3",
					delay = 3,
					{
						name = "Key 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover,
						icon = "Icon_PickAxe",
						matchPatterns = {"Clear Wall 3",},
						weight = 1,
					},
					events = {
						{
							eventType = "population",
							count = 1,
							comparator = "less",
							newDelay = -1,
							setCooldowns = {0,0},
							gemType = {
								icon = "Icon_GemPurple",
							},
						},
						{
						
							eventType = "population",
							count = 0,
							comparator = "greater",
							newDelay = 2,
							setCooldowns = {0,-1},
							gemType = {
								icon = "Icon_GemPurple",
							},
						},
						{
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
					},
				},
			},
			additionalNamedPatterns = {
				{
					entryName = "Clear Wall 1",
					patternName = "FullBoardLarge",
					isPatternSet = false,
					clearPieces = true,
					filter = {
						icon = "Icon_GemBlue",
					},
				},
				{
					entryName = "Clear Wall 2",
					patternName = "FullBoardLarge",
					isPatternSet = false,
					clearPieces = true,
					filter = {
						icon = "Icon_GemGreen",
					},
				},
				{
					entryName = "Clear Wall 3",
					patternName = "FullBoardLarge",
					isPatternSet = false,
					clearPieces = true,
					filter = {
						icon = "Icon_GemPurple",
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Make Wall 1",
						delay = -1,
					},
					[2] = {
						name = "Make Wall 2",
						delay = -1,
					},
					[3] = {
						name = "Make Wall 3",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "ReplenishingBedrock_WallMaker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Wall 1","Normal Mix",},
				},
				{
					patternName = "ReplenishingBedrock_WallMaker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Wall 2","Normal Mix",},
				},
				{
					patternName = "ReplenishingBedrock_WallMaker3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Wall 3","Normal Mix",},
				},
				{
					patternName = "ReplenishingBedrock_KeyMaker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Key 1","Normal Mix",},
				},
				{
					patternName = "ReplenishingBedrock_KeyMaker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Key 2","Normal Mix",},
				},
				{
					patternName = "ReplenishingBedrock_KeyMaker3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Key 3","Normal Mix",},
				},
				{
					patternName = "ReplenishingBedrock_Wall1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applyIcon = true,
					icon = "Icon_GemBlue",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				{
					patternName = "ReplenishingBedrock_Wall2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				{
					patternName = "ReplenishingBedrock_Wall3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Bedrock.singular","Bedrock.plural",{skinVariant = "BedRock",},},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",100000},
				[3] = {"score",150000},
			},
		},
	},
})