-- Land 32: switches with makers




table.insertall(LevelDefs,
{
	["DucksinaRow"] = {
		levelName = "Ducks in a Row",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			hasSwitches = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch1_On",
						spawnTypes = {"TurnOff1"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch1_Off",
						spawnTypes = {"TurnOn1"},
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "population",
							newDelay = 0,
							count = 2,
							comparator = "equals",
							gemType = {
								skinVariant = "WhimsySwitch1_On",
							},
							patterns = {"Clear Row 1 Left","Clear Row 1 Right"},
						},
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch2_On",
						spawnTypes = {"TurnOff2"},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch2_Off",
						spawnTypes = {"TurnOn2"},
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "population",
							newDelay = 0,
							count = 4,
							comparator = "equals",
							gemType = {
								skinVariant = "WhimsySwitch2_On",
							},
							patterns = {"Clear Row 2 Left","Clear Row 2 Right"},
						},
					},
				},
				[5] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch3_On",
						spawnTypes = {"TurnOff3"},
						weight = 1,
					},
				},
				[6] = {
					name = "TurnOff3",
					delay = 0,
					{
						name = "Switch_Off3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch3_Off",
						spawnTypes = {"TurnOn3"},
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "population",
							newDelay = 0,
							count = 6,
							comparator = "equals",
							gemType = {
								skinVariant = "WhimsySwitch3_On",
							},
							patterns = {"Clear Row 3 Left","Clear Row 3 Right"},
						},
					},
				},
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Clear Row 1 Left",
					patternName = "DucksInARow_Left1",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					entryName = "Clear Row 1 Right",
					patternName = "DucksInARow_Right1",
					isPatternSet = false,
					clearPieces = true,
				},
				[3] = {
					entryName = "Clear Row 2 Left",
					patternName = "DucksInARow_Left2",
					isPatternSet = false,
					clearPieces = true,
				},
				[4] = {
					entryName = "Clear Row 2 Right",
					patternName = "DucksInARow_Right2",
					isPatternSet = false,
					clearPieces = true,
				},
				[5] = {
					entryName = "Clear Row 3 Left",
					patternName = "DucksInARow_Left3",
					isPatternSet = false,
					clearPieces = true,
				},
				[6] = {
					entryName = "Clear Row 3 Right",
					patternName = "DucksInARow_Right3",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "DucksInARow_Left1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch1_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
				},
				[2] = {
					entryName = "Clear Row 1 Right",
					patternName = "DucksInARow_Right1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch1_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
				},
				[3] = {
					entryName = "Clear Row 2 Left",
					patternName = "DucksInARow_Left2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch2_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
				},
				[4] = {
					entryName = "Clear Row 2 Right",
					patternName = "DucksInARow_Right2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch2_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
				},
				[5] = {
					entryName = "Clear Row 3 Left",
					patternName = "DucksInARow_Left3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch3_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOn3"},
				},
				[6] = {
					entryName = "Clear Row 3 Right",
					patternName = "DucksInARow_Right3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch3_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOn3"},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Switch","Switches",{specials = CascadePieceSpecials_Stone,},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",700000},
				[3] = {"score",1100000},
			},
		},
		expectedScore = 100000, 
	},

--begin Michael levels

	["FillTheVoid"] = {
		levelName = "Fill The Void",
		introScript = "Land32_Tip3",					
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			hasMakers = true,
			hasSteel = true,
			largeBoard = true,
			hasSwitches = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch1_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker Icon Off 1"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch1_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker Icon On 1"},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch2_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"Set Maker Icon Off 2"},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch2_Off",
						spawnTypes = {"TurnOn2"},
						matchPatterns = {"Set Maker Icon On 2"},
						weight = 1,
					},
				},
				[5] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch3_On",
						spawnTypes = {"TurnOff3"},
						matchPatterns = {"Set Maker Icon Off 3"},
						weight = 1,
					},
				},
				[6] = {
					name = "TurnOff3",
					delay = 0,
					{
						name = "Switch_Off3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch3_Off",
						spawnTypes = {"TurnOn3"},
						matchPatterns = {"Set Maker Icon On 3"},
						weight = 1,
					},
				},
				[7] = {
					name = "Regular Mix 1",
					delay = -1,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							--cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch1_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							--cooldown = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch1_On",
							},
						},
					},
				},
				[8] = {
					name = "Regular Mix 2",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							--cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch2_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							--cooldown = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch2_On",
							},
						},
					},
				},
				[9] = {
					name = "Regular Mix 3",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							--cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch3_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							--cooldown = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch3_On",
							},
						},
					},
				},
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On 1",
					patternName = "FillTheVoid_maker1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker Icon Off 1",
					patternName = "FillTheVoid_maker1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					entryName = "Set Maker Icon On 2",
					patternName = "FillTheVoid_maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[4] = {
					entryName = "Set Maker Icon Off 2",
					patternName = "FillTheVoid_maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[5] = {
					entryName = "Set Maker Icon On 3",
					patternName = "FillTheVoid_maker3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[6] = {
					entryName = "Set Maker Icon Off 3",
					patternName = "FillTheVoid_maker3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "FillTheVoid_maker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix 1"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "FillTheVoid_maker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix 2"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					patternName = "FillTheVoid_maker3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix 3"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[4] = {
					patternName = "FillTheVoid_switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch1_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 1"},
				},
				[5] = {
					patternName = "FillTheVoid_switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch2_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 2"},
				},
				[6] = {
					patternName = "FillTheVoid_switch3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn3"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch3_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 3"},
				},
				[7] = {
					patternName = "FillTheVoid_pattern",
					isPatternSet = false,
					clearPieces = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[8] = {
					patternName = "FillTheVoid_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "WhimsySteel",
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",30000},
				[2] = {"score",100000},
				[3] = {"score",250000},
			},
		},
		expectedScore = 100000, 
	},

	--Isolated lock, maker(s) nearby to produce wild gems to match it with, lock is blocking a
	--laser that is aimed towards a set of stone blocks (or worse, spreaders)
	["TargetLocked"] = {
		levelName = "Target Locked",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			hasSteel = true,
			hasLasers = true,
			hasLocks = true,
			hasStones = true,
			hasMissingReels = true,
			largeBoard = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "TargetLocked_reels",
                isPatternSet = false,
            },
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On 1",
					patternName = "TargetLocked_laserMaker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker Icon On 2",
					patternName = "TargetLocked_lockMaker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				}
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "WhimsySwitch1_On",
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "WhimsySwitch2_On",
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch3_On",
						weight = 1,
					},
				},
				[4] = {
					name = "Regular Mix 1",
					delay = -1,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					--[[
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
					--]]
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch1_On",
							},
						},
					},
				},
				[5] = {
					name = "Wild Mix 1",
					delay = -1,
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 3,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch2_On",
							},
						},
					},
				},
				--[[
				[6] = {
					name = "Orange Mix",
					delay = 0,
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 2,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							--cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch3_On",
							},
						},
					},
				},
				--]]
				[6] = {
					name = "LaserH 1",
					delay = 0,
					{
						name = "Laser Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 1",},
                        skinVariant = "WhimsyLaserH",
						weight = 2,
					},
					{
						name = "Laser 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 1",},
                        skinVariant = "WhimsyLaserH",
						weight = 1,
					},
					{
						name = "Laser 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 1",},
                        skinVariant = "WhimsyLaserH",
						weight = 1,
					},
					{
						name = "Laser 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 1",},
                        skinVariant = "WhimsyLaserH",
						weight = 1,
					},
					{
						name = "Laser 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH 1",},
                        skinVariant = "WhimsyLaserH",
						weight = 1,
					},
				},
				[7] = {
					name = "LaserV 1",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV 1",},
                        skinVariant = "WhimsyLaserV",
						weight = 1,
					},
				},
				[8] = {
					name = "ReplaceLocks",
					delay = 0,
					{
						name = "Lock",
						matchFlags = 0,
						specials = CascadePieceSpecials_Lock,
						weight = 1,
					},
					events = {
						{
							eventType = "population",
							comparator = "less",
							gemType = {specials = CascadePieceSpecials_Lock},
							count = 1,
							newDelay = 2,
							cooldown = 3,
						},
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "LaserH 1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserH 1",},
							weight = 1,
							skinVariant = "WhimsyLaserH",
						},
					},
					[2] = {
						name = "LaserV 1",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece6,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"LaserV 1",},
							weight = 1,
							skinVariant = "WhimsyLaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TargetLocked_lockMaker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Wild Mix 1"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "TargetLocked_laserMaker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix 1"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					patternName = "TargetLocked_switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch1_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 1"},
				},
				[4] = {
					patternName = "TargetLocked_switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch2_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 2"},
				},
				[5] = {
					patternName = "TargetLocked_lock",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[6] = {
					patternName = "TargetLocked_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsySteel",
				},
				[7] = {
					patternName = "TargetLocked_laserH",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH 1",},
					applySkinVariant = true,
                    skinVariant = "WhimsyLaserH",
				},
				[8] = {
					patternName = "TargetLocked_laserV",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece6,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV 1",},
					applySkinVariant = true,
                    skinVariant = "WhimsyLaserV",
				},
				[9] = {
					patternName = "TargetLocked_pattern",
					isPatternSet = false,
                    applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 3,
					applyExtraHits = true,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[10] = {
					patternName = "TargetLocked_clear",
					clearPieces = true,
					isPatternSet = false,
					--matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[11] = {
					patternName = "TargetLocked_fence",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				[12] = {
					patternName = "Large 7,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_FlippedMaker,
					matchFlags = 0,

					applySpawnBelowTypes = true,
					spawnBelowTypes = {"ReplaceLocks"},
					applySkinVariant = true,
					skinVariant = "WhimsyFlippedMaker",
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",600000},
			},
		},
		expectedScore = 100000, 
	},

	["TwoDays"] = {
		levelName = "Two Days From Today",					
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			hasSteel = true,
			hasSwitches = true,
			hasIce = true,

			regularBoard = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
			--Shows whether makers are on or off
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "TwoDays_maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "TwoDays_maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
			},
			additionalNamedMixes = {
			--switches spawning switches
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker 1 Icon Off"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker 1 Icon On"},
						weight = 1,
					},
				},
				[3] = {
                    name = "Ice Mix",
					delay = -1,
                    {
                        name = "Ice 1",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece1,
                        weight = 3,
                    },
                    {
                        name = "Ice 2",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece2,
                        weight = 3,
                    },
                    {
                        name = "Ice 3",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece3,
                        weight = 3,
                    },
                    {
                        name = "Ice 4",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece4,
                        weight = 3,
                    },
                    {
                        name = "Ice 5",
                        spreadSpecials = CascadePieceSpecials_Ice,
                        matchFlags = CascadeMatchFlags_CommonPiece5,
                        weight = 0,
                    },
					events = {
						[1] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
                },
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TwoDays_maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Ice Mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "TwoDays_switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon On"},
				},
				[3] = {
					patternName = "TwoDays_ice",
					isPatternSet = false,
                    applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				[4] = {
					patternName = "TwoDays_pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",900000},
			},
		},
		expectedScore = 100000, 
	},
	["OffRamp"] = {
		levelName = "Off-Ramp",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			hasSteel = true,
			hasStones = true,
			hasMissingReels = true,
			hasFences = true,
			largeBoard = true,
			hasGemEaters = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			useMissingReels = true,
		    missingReels = {
				patternName = "OffRamp_reels",
				isPatternSet = false,
            },
			addToBoardPieceMix = {
                {
                    name = "HorizontalBurst1",
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.4,
                },
                {
                    name = "HorizontalBurst2",
                    matchFlags = CascadeMatchFlags_CommonPiece2,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.4,
                },
                {
                    name = "HorizontalBurst3",
                    matchFlags = CascadeMatchFlags_CommonPiece3,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.4,
                },
                {
                    name = "HorizontalBurst4",
                    matchFlags = CascadeMatchFlags_CommonPiece4,
                    specials = CascadePieceSpecial_HorizontalSplash,
                    weight = 0.4,
                },
            },
			additionalNamedPatterns = {
			--Shows whether makers are on or off
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "OffRamp_maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "OffRamp_maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
			},
			--switches spawning switches
			additionalNamedMixes = {
				[1] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Toggle",
						spawnTypes = {"Toggle1"},
						matchPatterns = {"Set Maker 1 Icon On"},
						weight = 1,
					},
				},
				[2] = {
                    name = "Chest Mix",
					delay = -1,
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
                    },
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							patterns = {"Set Maker 1 Icon Off"},
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								skinVariant = "WhimsySwitch_Toggle",
							},
						},
					},
                },
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "OffRamp_maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Chest Mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "OffRamp_switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon On"},
				},
				[3] = {
					patternName = "OffRamp_eater",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				[4] = {
					patternName = "OffRamp_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsySteel",
				},
				[5] = {
					patternName = "OffRamp_fence",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Fence,
					matchFlags = 0,
				},
				[6] = {
					patternName = "OffRamp_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				
				[7] = {
					patternName = "OffRamp_void",
					isPatternSet = false,
					clearPieces  = true,
				},
				
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",350000},
				[3] = {"score",550000},
			},
		},
		expectedScore = 100000, 
	},
	--Switch in the middle switches between left maker (bombs) and right maker (orange gems, occasional chests, two eaters at the bottom)
	--Switch is Elmer, left maker is Daffy waiting to explode, right is Bugs chewing a carrot
	["WabbitSeason"] = {
		levelName = "Wabbit Season",
		introScript = "Land32_Tip5",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			hasSwitches = true,
			hasGemEaters = true,
			hasChests = true,
			hasBombs = true,
			hasMissingReels = true,
			hasMissingSquares = true,
			largeBoard = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "WabbitSeason_reels",
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "WabbitSeason_squares",
				isPatternSet = false,
			},
			additionalNamedPatterns = {
			--Shows whether makers are on or off
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "WabbitSeason_duckMaker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "WabbitSeason_duckMaker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
				[3] = {
					entryName = "Set Maker 2 Icon On",
					patternName = "WabbitSeason_wabbitMaker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[4] = {
					entryName = "Set Maker 2 Icon Off",
					patternName = "WabbitSeason_wabbitMaker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			--switches spawning switches
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker 1 Icon Off", "Set Maker 2 Icon On",},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker 1 Icon On","Set Maker 2 Icon Off",},
						weight = 1,
					},
				},
				[3] = {
                    name = "Duck Mix",
					delay = -1,
                    {
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1.5,
					},
					--[[
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 1.5,
					},
					--]]
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
                },
				[4] = {
                    name = "Wabbit Mix",
					delay = -1,
                    {
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
                    },
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 5,
					},
					events = {
					--[[
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
					--]]
						[1] = {
							eventType = "population",
							count = 1,
							newDelay = 0,
							--setCooldowns = {0,-1,0},
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = -1,
							--setCooldowns = {0,0,-1},
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
                },
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "WabbitSeason_duckMaker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Duck Mix"},
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "WabbitSeason_wabbitMaker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Wabbit Mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					patternName = "WabbitSeason_elmerSwitch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon Off", "Set Maker 2 Icon On",},
				},
				[4] = {
					patternName = "WabbitSeason_eaters",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
				--[[
				[6] = {
					patternName = "OffRamp_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[7] = {
					patternName = "OffRamp_void",
					isPatternSet = false,
					clearPieces  = true,
				},
				--]]
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Duck Mix",
						delay = -1,
					},
					{
						name = "Wabbit Mix",
						delay = -1,
					},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",500000},
				[3] = {"score",675000},
			},
		},
		expectedScore = 100000, 
	},
	["ReverseReverse"] = {
		levelName = "Reverse Reverse",					
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			hasBalloons = true,
			regularBoard = true,
			hasSwitches = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker Icon Off 1", "Set Maker Icon On 2",},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker Icon On 1", "Set Maker Icon Off 2",},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"Set Maker Icon Off 2"},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn2"},
						matchPatterns = {"Set Maker Icon On 2"},
						weight = 1,
					},
				},
				[5] = {
					name = "Regular Mix",
					delay = -1,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					--[[
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 0,
					},
					--]]
					events = {
						[1] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							--cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							--cooldown = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
				},
				[6] = {
					name = "Balloon Mix",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 2",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 3",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Balloon 4",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					--[[
					{
						name = "Balloon 5",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Balloon,
						cancelSpecials = CascadePieceSpecials_Balloon,
					},
					--]]
					events = {
					--Comment this emitCount out in order to make the upwards makers spew out balloons
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = -1,
							--cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = 0,
							--cooldown = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
				},
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On 1",
					patternName = "ReverseReverse_topMakers",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker Icon Off 1",
					patternName = "ReverseReverse_topMakers",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					entryName = "Set Maker Icon On 2",
					patternName = "ReverseReverse_bottomMakers",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyFlippedMaker",
				},
				[4] = {
					entryName = "Set Maker Icon Off 2",
					patternName = "ReverseReverse_bottomMakers",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyFlippedMaker",
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "ReverseReverse_bottomMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Balloon Mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyFlippedMaker",
				},
				[2] = {
					patternName = "ReverseReverse_topMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular Mix"},
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[5] = {
					patternName = "ReverseReverse_switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon Off 1", "Set Maker Icon On 2",},
				},
			},
		},
		goals = {
			main = {"getGem",10,"Balloon","Balloons",{cancelSpecials = CascadePieceSpecials_Balloon},"Pop"},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",150000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, 
	},
	--throw switches! fire lasers! mad science, mwahahaha!
	["TheCreature"] = {
		levelName = "The Creature",					
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes5 = true,
			hasMakers = true,
			hasSteel = true,
			hasBarrels = true,
			hasStones = true,
			largeBoard = true,
			hasSwitches = true,
			hasBombs = true,
			hasLasers = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch1_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker Icon Off 1"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch1_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker Icon On 1"},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch2_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"Set Maker Icon Off 2"},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch2_Off",
						spawnTypes = {"TurnOn2"},
						matchPatterns = {"Set Maker Icon On 2"},
						weight = 1,
					},
				},
				[5] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch3_On",
						spawnTypes = {"TurnOff3"},
						matchPatterns = {"Set Maker Icon Off 3"},
						weight = 1,
					},
				},
				[6] = {
					name = "TurnOff3",
					delay = 0,
					{
						name = "Switch_Off3",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch3_Off",
						spawnTypes = {"TurnOn3"},
						matchPatterns = {"Set Maker Icon On 3"},
						weight = 1,
					},
				},
				[7] = {
					name = "Bomb Mix 1",
					delay = -1,
                    {
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 0,
					},
					{
						name = "Bomb Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
						turnsToLoss = 6,
						weight = 10,
					},
					events = {
						[1] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch1_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch1_On",
							},
						},
					},
				},
				[8] = {
					name = "Bomb Mix 2",
					delay = -1,
                    {
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 6,
						weight = 0,
					},
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 0,
					},
					{
						name = "Bomb Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
						turnsToLoss = 6,
						weight = 10,
					},
					events = {
						[1] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch2_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch2_On",
							},
						},
					},
				},
				[9] = {
					name = "Bomb Mix 3",
					delay = -1,
                    {
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 10,
						weight = 0,
					},
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 8,
						weight = 0,
					},
					{
						name = "Bomb Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,
						turnsToLoss = 6,
						weight = 10,
					},
					events = {
						[1] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch3_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch3_On",
							},
						},
					},
				},
				[10] = {
					name = "Horizontal Color Changing Laser",
					delay = 0,
					{
						name = "Laser1",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"Horizontal Color Changing Laser",},
						skinVariant = "WhimsyLaserH",
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Horizontal Color Changing Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Horizontal Color Changing Laser",},
							skinVariant = "WhimsyLaserH",
							weight = 1,
						},
					},
				},
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On 1",
					patternName = "TheCreature_maker1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker Icon Off 1",
					patternName = "TheCreature_maker1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					entryName = "Set Maker Icon On 2",
					patternName = "TheCreature_maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[4] = {
					entryName = "Set Maker Icon Off 2",
					patternName = "TheCreature_maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[5] = {
					entryName = "Set Maker Icon On 3",
					patternName = "TheCreature_maker3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[6] = {
					entryName = "Set Maker Icon Off 3",
					patternName = "TheCreature_maker3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TheCreature_maker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix 1"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "TheCreature_maker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix 2"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					patternName = "TheCreature_maker3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix 3"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[4] = {
					patternName = "TheCreature_switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch1_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 1"},
				},
				[5] = {
					patternName = "TheCreature_switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch2_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 2"},
				},
				[6] = {
					patternName = "TheCreature_switch3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn3"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch3_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 3"},
				},
				[7] = {
					patternName = "TheCreature_steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "WhimsySteel",
					matchFlags = 0,
				},
				[8] = {
					patternName = "TheCreature_lasers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					applySpawnTypes = true,
					spawnTypes = {"Horizontal Color Changing Laser",},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applySkinVariant = true,
					skinVariant = "WhimsyLaserH",
				},
				[9] = {
					patternName = "TheCreature_stone",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					--extraHits = 2,
					--applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",15,"Bomb","Bombs",{specials = CascadePieceSpecial_Valuable + CascadePieceSpecials_Barrels,},"Defuse"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",400000},
				[3] = {"score",650000},
			},
		},
		expectedScore = 100000, 
	},
--end Michael levels

--Jonathan levels begin
	["TreasureDispenser"] = {
		levelName = "Treasure Dispenser",					
		introScript = "Land32_Intro",		
		Features = {
			modeSpins9 = true,
			splashMode = true,
			gemTypes5 = true,
			hasMakers = true,
			hasChests = true,
			largeBoard = true,
			hasSwitches = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "TreasureDispenser_Maker1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "TreasureDispenser_Maker1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					entryName = "Set Maker 2 Icon On",
					patternName = "TreasureDispenser_Maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[4] = {
					entryName = "Set Maker 2 Icon Off",
					patternName = "TreasureDispenser_Maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Toggle",
						spawnTypes = {"Toggle1"},
						matchPatterns = {"Set Maker 1 Icon On"},
						weight = 1,
					},
				},
				[2] = {
					name = "Toggle2",
					delay = 0,
					{
						name = "Toggle2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Toggle",
						spawnTypes = {"Toggle2"},
						matchPatterns = {"Set Maker 2 Icon On"},
						weight = 1,
					},
				},
				[3] = {
					name = "Treasure Mix 1",
					delay = -1,
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							patterns = {"Set Maker 1 Icon Off"},
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								matchPatterns = {"Set Maker 1 Icon On"},
							},
						},
					},
				},
				[4] = {
					name = "Treasure Mix 2",
					delay = -1,
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 2,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							patterns = {"Set Maker 2 Icon Off"},
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								matchPatterns = {"Set Maker 2 Icon On"},
							},
						},
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TreasureDispenser_Maker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Treasure Mix 1"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "TreasureDispenser_Maker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Treasure Mix 2"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					patternName = "TreasureDispenser_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon On"},
				},
				[4] = {
					patternName = "TreasureDispenser_Switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle2"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 2 Icon On"},
				},
			},
		},
		goals = {
			main = {"getGem",13,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",80000},
				[2] = {"score",400000},
				[3] = {"score",850000},
			},
		},
		expectedScore = 100000, 
	},
	["CurtainCutter"] = {
		levelName = "Curtain Cutter",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes5 = true,
			hasMakers = true,
			hasBoulders = true,
			hasMissingReels = true,
			largeBoard = true,
			hasSwitches = true,
			hasCoverage = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "CurtainCutter_MissingReels",
				isPatternSet = false,
			},
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "CurtainCutter_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "CurtainCutter_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker 1 Icon Off"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker 1 Icon On"},
						weight = 1,
					},
				},
				[3] = {
					name = "Boulders",
					delay = -1,
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 2,
					},
					events = {
						[1] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "CurtainCutter_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulders"},
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "CurtainCutter_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon Off"},
				},
				[3] = {
					patternName = "CurtainCutter_Boulders",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
				[4] = {
					patternName = "CurtainCutter_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",450000},
				[2] = {"score",1500000},
				[3] = {"score",29000000},
			},
		},
		expectedScore = 100000, 
	},
--Jonathan levels end

	["BadSwitches"] = {
		levelName = "Bad Switches",	
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			hasMakers = true,
			regularBoard = true,
			hasSwitches = true,
			hasCoverage = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "Help_Level7_Pattern3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix 1"},
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "Help_Level7_Pattern3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
				},
				[3] = {
					entryName = "Set Maker 2 Icon On",
					patternName = "TreasureDispenser_Maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix 2"},
				},
				[4] = {
					entryName = "Set Maker 2 Icon Off",
					patternName = "TreasureDispenser_Maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker 1 Icon Off"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker 1 Icon On"},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"Set Maker 2 Icon Off"},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn2"},
						matchPatterns = {"Set Maker 2 Icon On"},
						weight = 1,
					},
				},
				[5] = {
					name = "Bomb Mix 1",
					delay = -1,
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							setCooldowns = {0,-1,0},
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							setCooldowns = {0,0,-1},
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
				},
				[6] = {
					name = "Bomb Mix 2",
					delay = 0,
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 15,
						weight = 1.5,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							setCooldowns = {0,-1,0},
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							setCooldowns  = {0,0,-1},
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
				},
				[7] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1.5,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1.5,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1.5,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1.5,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1.5,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Bomb Mix 1",
						delay = -1,
					},
					[2] = {
						name = "Bomb Mix 2",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Help_Level7_Pattern3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "TreasureDispenser_Maker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					patternName = "TreasureDispenser_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon On"},
				},
				[4] = {
					patternName = "Dungeon1_bomb1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 2 Icon On"},
				},
				[5] = {
					patternName = "BadSwitches_pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 3,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",400000},
			},
		},
		expectedScore = 100000, 
	},

	["PandorasSwitches"] = {
		levelName = "Pandora's Switches",	
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			largeBoard = true,
			hasSwitches = true,
			hasCoverage = true,
			hasVines = true,
			hasBombs = true,
			hasLava = true,
			hasIce = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "TopLeftCorner",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix 1", "Normal Mix"},
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "TopLeftCorner",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
				},
				[3] = {
					entryName = "Set Maker 2 Icon On",
					patternName = "TopRow7",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Mix 2", "Normal Mix"},
				},
				[4] = {
					entryName = "Set Maker 2 Icon Off",
					patternName = "TopRow7",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
				},
				[5] = {
					entryName = "Set Maker 3 Icon On",
					patternName = "Large 1,3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Ice mix"},
				},
				[6] = {
					entryName = "Set Maker 3 Icon Off",
					patternName = "Large 1,3",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
				},
				[7] = {
					entryName = "Set Maker 4 Icon On",
					patternName = "Large 4,0",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Vine mix"},
				},
				[8] = {
					entryName = "Set Maker 4 Icon Off",
					patternName = "Large 4,0",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
				},
				[9] = {
					entryName = "Set Maker 5 Icon On",
					patternName = "Large 4,6",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Lava mix"},
				},
				[10] = {
					entryName = "Set Maker 5 Icon Off",
					patternName = "Large 4,6",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker 1 Icon On"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker 1 Icon Off"},
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"Set Maker 2 Icon On"},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off2",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOn2"},
						matchPatterns = {"Set Maker 2 Icon Off"},
						weight = 1,
					},
				},
				[5] = {
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOff3"},
						matchPatterns = {"Set Maker 3 Icon On"},
						weight = 1,
					},
				},
				[6] = {
					name = "TurnOff3",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOn3"},
						matchPatterns = {"Set Maker 3 Icon Off"},
						weight = 1,
					},
				},
				[7] = {
					name = "TurnOn4",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOff4"},
						matchPatterns = {"Set Maker 4 Icon On"},
						weight = 1,
					},
				},
				[8] = {
					name = "TurnOff4",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOn4"},
						matchPatterns = {"Set Maker 4 Icon Off"},
						weight = 1,
					},
				},
				[9] = {
					name = "TurnOn5",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOff5"},
						matchPatterns = {"Set Maker 5 Icon On"},
						weight = 1,
					},
				},
				[10] = {
					name = "TurnOff5",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOn5"},
						matchPatterns = {"Set Maker 5 Icon Off"},
						weight = 1,
					},
				},
				[11] = {
					name = "Bomb Mix 1",
					delay = -1,
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},
					--[[
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},]]
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 3,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							setCooldowns = {0,-1,0},
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							setCooldowns = {0,0,-1},
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
				},
				[12] = {
					name = "Bomb Mix 2",
					delay = 0,
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},
					--[[
					{
						name = "Bomb 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 25,
						weight = 1.5,
					},]]
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 3,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							setCooldowns = {0,-1,0},
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							setCooldowns  = {0,0,-1},
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
				},
				[13] = {
					name = "Normal mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1.5,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1.5,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1.5,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1.5,
					},
					--[[
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1.5,
					},]]
				},
				[14] = {
					name = "Ice mix", -- "Ice mix" is the mix that comes out of the top maker
					delay = 0,
					{
						name = "Blue Vine",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1.5,
					},
					{
						name = "Green Vine",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1.5,
					},
					{
						name = "Purple Vine",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1.5,
					},
					{
						name = "Red Vine",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1.5,
					},
					--[[
					{
						name = "Yellow Vine",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1.5,
					},]]
				},
				[15] = {
					name = "Vine mix", -- "Vine mix" is the mix that comes out of the left maker
					delay = 0,
					{
						name = "Blue Ice",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},
					{
						name = "Green Ice",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},
					{
						name = "Purple Ice",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},
					{
						name = "Red Ice",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},
					--[[
					{
						name = "Yellow Ice",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1.5,
					},]]
				},
				[16] = {
					name = "Lava mix",
					delay = 0,
					{
						name = "Lava",
						specials = CascadePieceSpecials_Lava,
						matchFlags = 0,
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Bomb Mix 1",
						delay = -1,
					},
					[2] = {
						name = "Bomb Mix 2",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TopLeftCorner",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "TopRow7",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					patternName = "Large 1,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[4] = {
					patternName = "Large 4,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[5] = {
					patternName = "Large 4,6",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Normal mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[6] = {
					patternName = "Large 1,2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon On"},
				},
				[7] = {
					patternName = "Large 1,4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff2"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 2 Icon On"},
				},
				[8] = {
					patternName = "Large 0,3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff3"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 3 Icon On"},
				},
				[9] = {
					patternName = "Large 7,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff4"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 4 Icon On"},
				},
				[10] = {
					patternName = "Large 7,6",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff5"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 5 Icon On"},
				},
				[11] = {
					patternName = "PandorasSwitches_pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
				[12] = {
					patternName = "PandorasSwitches_pattern2",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000, 
	},

	["MatchForMore"] = {
		levelName = "Match for More",
		introScript = "Land32_Tip4",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasCoverage = true,
			hasSwitches = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On",
					patternName = "Line8_large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					entryName = "Set Maker Icon Off",
					patternName = "Line8_large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Scarce Mix",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 18,
							newDelay = -1,
							reset = true,
							patterns = {"Set Maker Icon Off"},
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								skinVariant = "WhimsySwitch_Toggle",
							},
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
				[2] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Toggle",
						spawnTypes = {"Toggle1"},
						matchPatterns = {"Set Maker Icon On"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Line8_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Scarce Mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "Line7_large",
					isPatternSet = false,
					clearPieces = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "Line1_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On"},
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",250000},
				[3] = {"score",400000},
			},
		},
	},
	["RainbowSwitch"] = {
		levelName = "Rainbow Switch",
		introScript = "Land32_Tip2",
		resource = "GameScreen_Land32",
		Features = {
			splashMode = true,
			modeSpins1 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasSwitches = true,
		},
		tricks = {
			{name = Config.World32Tricks_Trick1},
			{name = Config.World32Tricks_Trick2},
			{name = Config.World32Tricks_Trick3},
			{name = Config.TricksDefault_Trick2_OneMoreSpin},
		},
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On",
					patternName = "Line8_large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker Icon Off",
					patternName = "Line8_large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Make a Wild",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
							reset = true,
							patterns = {"Set Maker Icon Off"},
						},
						[3] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								skinVariant = "WhimsySwitch_Toggle",
							},
						},
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 2,
					},
				},
				[2] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Toggle",
						spawnTypes = {"Toggle1"},
						matchPatterns = {"Set Maker Icon On"},
						weight = 1,
					},
				},
				[3] = {
					name = "Normal Mix",
					{
						name = "Gem1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Gem2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Gem3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Gem4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
					{
						name = "Gem5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Line8_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make a Wild","Normal Mix",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "RainbowSwitch_Switches",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On"},
				},
				[3] = {
					patternName = "RainbowSwitch_InitialWilds",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",600000},
				[3] = {"score",1500000},
			},
		},
	},

	--Dangerous choice: 3 makers spam out a mix of bombs with different timers on different objects.
	--Switches control which makers are on.
	--Match bombs to win
	["DangerousChoice"] = {
		levelName = "Dangerous Choice",
		outtroScript = "Land32_Outtro",
		resource = "GameScreen_Land32",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMakers = true,
			hasSwitches = true,
			hasBombs = true,
			hasBoulders = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon 1 On",
					patternName = "DangerousChoice_Maker1",
					isPatternSet = false,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bombs",},
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker Icon 1 Off",
					patternName = "DangerousChoice_Maker1",
					isPatternSet = false,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
				[3] = {
					entryName = "Set Maker Icon 2 On",
					patternName = "DangerousChoice_Maker2",
					isPatternSet = false,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bombs",},
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[4] = {
					entryName = "Set Maker Icon 2 Off",
					patternName = "DangerousChoice_Maker2",
					isPatternSet = false,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
				[5] = {
					entryName = "Set Maker Icon 3 On",
					patternName = "DangerousChoice_Maker3",
					isPatternSet = false,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bombs",},
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[6] = {
					entryName = "Set Maker Icon 3 Off",
					patternName = "DangerousChoice_Maker3",
					isPatternSet = false,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			additionalNamedMixes = {
				{
					name = "Bombs",
					{
						name = "Bomb 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					},
					{
						name = "Bomb 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					},
					{
						name = "Bomb 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					},
					{
						name = "Bomb 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					},
					{
						name = "Boulder Bomb",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						turnsToLoss = 5,
						weight = 1,
					},
					{
						name = "Double Boulder Bomb",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						extraHits = 1,
						turnsToLoss = 5,
						weight = 1,
					},
				},
				{
					name = "Regular",
					{
						name = "Gem 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 2,
					},
					{
						name = "Gem 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 2,
					},
					{
						name = "Gem 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 2,
					},
					{
						name = "Gem 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 2,
					},
				},
				{
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker Icon 1 Off"},
						weight = 1,
					},
				},
				{
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker Icon 1 On"},
						weight = 1,
					},
				},
				{
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff2"},
						matchPatterns = {"Set Maker Icon 2 Off"},
						weight = 1,
					},
				},
				{
					name = "TurnOff2",
					delay = 0,
					{
						name = "Switch_Off",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn2"},
						matchPatterns = {"Set Maker Icon 2 On"},
						weight = 1,
					},
				},
				{
					name = "TurnOn3",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff3"},
						matchPatterns = {"Set Maker Icon 3 Off"},
						weight = 1,
					},
				},
				{
					name = "TurnOff3",
					delay = 0,
					{
						name = "Switch_Off",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn3"},
						matchPatterns = {"Set Maker Icon 3 On"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "DangerousChoice_Maker1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "DangerousChoice_Switch1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon 1 On"},
				},
				[3] = {
					patternName = "DangerousChoice_Maker2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[4] = {
					patternName = "DangerousChoice_Switch2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon 2 On"},
				},
				[5] = {
					patternName = "DangerousChoice_Maker3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Regular",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[6] = {
					patternName = "DangerousChoice_Switch3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn3"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon 3 On"},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Bombs",
						{
							name = "Gem 1",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							weight = 2,
						},
						{
							name = "Gem 2",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							weight = 2,
						},
						{
							name = "Gem 3",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							weight = 2,
						},
						{
							name = "Gem 4",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							weight = 2,
						},
					},
				},
			},
		},
		goals = {
			main = {"getGem",50,"Bomb","Bombs",{turnsToLoss = true, extraHits = 0,},"Defuse"},
			stars = {
				[1] = {"score",175000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
	},

	["CallforBackup"] = {
		levelName = "Call for Backup",
		resource = "GameScreen_Land32",
		Features = {
			splashMode = true,
			modeSpins6 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasMakers = true,
			hasSwitches = true,
			hasVines = true,
			hasMissingSquares = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On",
					patternName = "CallforBackup_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker Icon Off",
					patternName = "CallforBackup_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Make a Super Wild",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
							patterns = {"Set Maker Icon Off"},
						},
						[2] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								skinVariant = "WhimsySwitch_Toggle",
							},
						},
					},
					{
						name = "Super Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 2,
					},
				},
				[2] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Toggle",
						spawnTypes = {"Toggle1"},
						matchPatterns = {"Set Maker Icon On"},
						weight = 1,
					},
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "CallforBackup_Missing",
				isPatternSet = false,
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Make a Super Wild",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CallforBackup_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make a Super Wild",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "CallforBackup_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On"},
				},
				[3] = {
					patternName = "CallforBackup_Superwild",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
				},
				[4] = {
					patternName = "CallforBackup_Vines",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",260000},
				[2] = {"score",500000},
				[3] = {"score",950000},
			},
		},
	},
	
	["12RedBlue"] = {
		levelName = "One, Two, Red, Blue",					
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasSteel = true,
			hasFences = true,
			hasBarrelsOfFun = true,
			hasPortals = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Steel",
					{
						name = "Steel",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						weight = 1,
						applySkinVariant = true,
						skinVariant = "WhimsySteel",
					},
				},
				{
					name = "SpawnRedBarrel",
					{
						name = "RedBarrel",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"Steel"},
						weight = 1,
					},
				},
				{
					name = "SpawnBlueBarrel",
					{
						name = "BlueBarrel",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"Steel"},
						weight = 1,
					},
				},
				{
					name = "SpawnGreenBarrel",
					{
						name = "BlueBarrel",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"Steel"},
						weight = 1,
					},
				},
				{
					name = "SpawnRedSpawner",
					{
						name = "SpawnRed",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"SpawnRedBarrel"},
						weight = 1,
					},
				},
				{
					name = "SpawnBlueSpawner",
					{
						name = "SpawnBlue",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"SpawnBlueBarrel"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "12RedBlue_Fence",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Fence,

					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "12RedBlue_Barrel1",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,

					applySpawnTypes = true,
					spawnTypes = {"Steel"},
				},
				{
					patternName = "12RedBlue_Barrel2",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,

					applySpawnTypes = true,
					spawnTypes = {"SpawnGreenBarrel"},
				},
				{
					patternName = "12RedBlue_Barrel3",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,

					applySpawnTypes = true,
					spawnTypes = {"SpawnRedSpawner"},
				},
				{
					patternName = "12RedBlue_Barrel4",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_ColorBarrels,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,

					applySpawnTypes = true,
					spawnTypes = {"SpawnBlueSpawner"},
				},
			},
			boardPieceMix = {
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 11,
				},
			},
			reelPieceMix = {
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 11,
				},
				{
					name = "Orange",
					matchFlags = CascadeMatchFlags_CommonPiece6,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 5,
				},
			},
			portals = {
				{{0,2},{1,5},"PortalEntrance_1","PortalExit_1"},
				{{1,2},{2,5},"PortalEntrance_1","PortalExit_1"},
				{{2,2},{3,5},"PortalEntrance_1","PortalExit_1"},
				{{3,2},{4,5},"PortalEntrance_1","PortalExit_1"},
				{{4,2},{5,5},"PortalEntrance_1","PortalExit_1"},
				{{5,2},{6,5},"PortalEntrance_1","PortalExit_1"},
				{{6,2},{0,5},"PortalEntrance_1","PortalExit_1"},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Barrel","Barrels",{specials = CascadePieceSpecials_ColorBarrels},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",900000},
				[3] = {"score",1650000},
			},
		},
		expectedScore = 100000, 
	},

	["DoubleAct"] = {
		levelName = "Double Act",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins4 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			regularBoard = true,
			hasSwitches = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
			--Shows whether makers are on or off
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "TopRow_Column2_Large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "TopRow_Column2_Large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
				[3] = {
					entryName = "Set Maker 2 Icon On",
					patternName = "TopRow_Column5_Large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[4] = {
					entryName = "Set Maker 2 Icon Off",
					patternName = "TopRow_Column5_Large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			--switches spawning switches
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker 1 Icon Off", "Set Maker 2 Icon On",},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker 1 Icon On","Set Maker 2 Icon Off",},
						weight = 1,
					},
				},
				[3] = {
                    name = "Horizontal Mix",
					delay = -1,
                    {
						name = "Horizontal 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Horizontal 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Horizontal 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Horizontal 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					--[[
					{
						name = "Horizontal 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_HorizontalSplash,
						weight = 2,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
					]]
					events = {
						--[[
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						]]
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
                },
				[4] = {
                    name = "Vertical Mix",
					delay = -1,
                    {
						name = "Vertical 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Vertical 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Vertical 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Vertical 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					--[[
					{
						name = "Vertical 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
					]]
					events = {
						[1] = {
							eventType = "population",
							count = 1,
							newDelay = 0,
							--setCooldowns = {0,-1,0},
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = -1,
							--setCooldowns = {0,0,-1},
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
                },
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Horizontal Mix",
						delay = -1,
					},
					[2] = {
						name = "Vertical Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TopRow_Column2_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Horizontal Mix"},
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "TopRow_Column5_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Vertical Mix"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[3] = {
					patternName = "Large 0,2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon Off", "Set Maker 2 Icon On",},
				},
			},
		},
		goals = {
			main = {"getGem",6,"Combo Burst","Combo Bursts",
					{
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash +  CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,},
					},
					"Make",
				},
			stars = {
				[1] = {"score",400000},
				[2] = {"score",600000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000, 
	},
	
	["SnoozeButton"] = {
		levelName = "Snooze Button",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			hasMakers = true,
			largeBoard = true,
			hasBombs = true,
			hasSwitches = true,
			hasPatternGems = true,
			hasMissingReels = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
                patternName = "ReelPosition4",
                isPatternSet = false,
            },
			additionalNamedPatterns = {
			--Shows whether makers are on or off
				[1] = {
					entryName = "Set Maker 1 Icon On",
					patternName = "TopRow_Column4_Large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker 1 Icon Off",
					patternName = "TopRow_Column4_Large",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			--switches spawning switches
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker 1 Icon Off",},
						weight = 1,
						turnsToLoss = 10,
					},
				},
				[2] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker 1 Icon On",},
						weight = 1,
						turnsToLoss = -1,
					},
				},
				[3] = {
                    name = "Ring Mix",
					delay = -1,
                    {
						name = "Ring 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						icon = "Icon_Marked",
						weight = 2,
					},
					{
						name = "Ring 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_Marked",
						weight = 2,
					},
					{
						name = "Ring 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_Marked",
						weight = 2,
					},
					{
						name = "Ring 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_Marked",
						weight = 2,
					},
					{
						name = "Vertical 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},					
					events = {
						[1] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
					},
                },
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Ring Mix",
						delay = -1,
					},
					[2] = {
						name = "TurnOn1",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "TopRow_Column4_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Ring Mix"},
					applyIcon = true,
					icon = "Icon_Maker_On",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "Single_8-4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOff1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_On",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker 1 Icon Off",},
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
			},
		},
		goals = {
			main = {"getGem",20,"Ring","Rings",{icon = "Icon_Marked",},"Collect",},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",700000},
				[3] = {"score",800000},
			},
		},
		expectedScore = 100000, 
	},
	
	["Grinch"] = {
		levelName = "Stealing Christmas",					
		Features = {
			modeSpins3 = true,
			splashMode = true,
			gemTypes3 = true,
			largeBoard = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				{
					entryName = "RemoveTree1",
					patternName = "Large 4,5",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree2",
					patternName = "Large 4,4",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree3",
					patternName = "Large 4,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree4",
					patternName = "Large 4,2",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree5",
					patternName = "Large 4,1",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree6",
					patternName = "Large 4,0",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree7",
					patternName = "Large 6,1",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree8",
					patternName = "Large 6,2",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree9",
					patternName = "Large 6,3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree10",
					patternName = "Large 6,4",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree11",
					patternName = "Large 6,5",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RemoveTree12",
					patternName = "Large 6,6",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalNamedMixes = {
				{
					name = "Present",
					{
						name = "Present",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Grinch_BedrockA",
					isPatternSet = false,
					
					applyIcon = true,
					icon = "Icon_GemGreen",

					applyMatchFlags = true,
					matchFlags = 0,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,

					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "Grinch_BedrockB",
					isPatternSet = false,
					
					applyIcon = true,
					icon = "Icon_SpecialGemRed",

					applyMatchFlags = true,
					matchFlags = 0,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,

					skinVariant = "BedRock",
					applySkinVariant = true,
				},
				{
					patternName = "Large 5,6",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree1"},
				},
				{
					patternName = "Large 5,5",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree2"},
				},
				{
					patternName = "Large 5,4",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree3"},
				},
				{
					patternName = "Large 5,3",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree4"},
				},
				{
					patternName = "Large 5,2",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree5"},
				},
				{
					patternName = "Large 5,1",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree6"},
				},
				{
					patternName = "Large 7,0",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree7"},
				},
				{
					patternName = "Large 7,1",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree8"},
				},
				{
					patternName = "Large 7,2",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree9"},
				},
				{
					patternName = "Large 7,3",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree10"},
				},
				{
					patternName = "Large 7,4",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree11"},
				},
				{
					patternName = "Large 7,5",
					isPatternSet = false,

					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,

					applyIcon = true,
					icon = "Icon_PickAxe",

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,

					applyMatchPatterns = true,
					matchPatterns = {"RemoveTree12"},

					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				{
					patternName = "Large 7,6",
					isPatternSet = false,
					
					applyMatchFlags = true,
					matchFlags = 0,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,

					applySpawnTypes = true,
					spawnTypes = {"Present"},

					applyExtraHits = true,
					extraHits = 2,
				},
				{
					patternName = "Grinch_Presents",
					isPatternSet = false,
					
					applyMatchFlags = true,
					matchFlags = 0,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,

					applySpawnTypes = true,
					spawnTypes = {"Present"},

					applyExtraHits = true,
					extraHits = 2,
				},
			},
			boardPieceMix = {
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Gold",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 1,
				},
			},
			reelPieceMix = {
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 2.06,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 2.07,
				},
				{
					name = "Gold",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 2.07,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = .8,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Gift","Gifts",{specials = CascadePieceSpecials_Stone},"Steal"},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",2000000},
				[3] = {"score",3000000},
			},
		},
		expectedScore = 100000, 
	},
	
	["PowerUp"] = {
		levelName = "Power Up",					
		introScript = "Land32_Tip1",				
		resource = "GameScreen_Land32",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasCrates = true,
			hasCoconuts = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Burst Mix",
					{
						name = "Vertical1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical5",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 2,
					},
					{
						name = "Area1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 1,
					},
					{
						name = "Area5",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_AreaSplash,
						weight = 2,
					},
				},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "PowerUp_Missing",
				isPatternSet = false,
			},
			useMissingReels = true,
			missingReels = {
				patternName = "ReelPosition1,7",
				isPatternSet = false,
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Burst Mix",
						delay = -1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "PowerUp_Crates",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					applySpawnTypes = true,
					spawnTypes = {},
				},
			},
			addToBoardPieceMix = {
				{
					name = "Coconut",
					matchFlags = 0,
					specials = CascadePieceSpecials_Coconut,
					spawnTypes = {"Burst Mix"},
					weight = 3,
				},
			},
		},
		goals = {
			main = {"getGem",4,"Crate","Crates",{specials = CascadePieceSpecials_Crates},"Break"},
			stars = {
				[1] = {"score",600000},
				[2] = {"score",900000},
				[3] = {"score",1600000},
			},
		},
		expectedScore = 100000, 
	},
	
	["SkyScraper"] = {
		levelName = "Skyscraper",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasStones = true,
			hasSteelGlass = true,
			hasCoverage = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "SkyScraper_Glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "SkyScraper_Stone",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "SkyScraper_TripleStone",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
				},
				{
					patternName = "SkyScraper_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1500000},
				[3] = {"score",2700000},
			},
		},
		expectedScore = 100000, 
	},
	
	["RailroadTracks"] = {
		levelName = "Railroad Tracks",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasStones = true,
			hasSteelGlass = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "RailroadTracks_Glass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				{
					patternName = "RailroadTracks_Stone",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
				},
				{
					patternName = "RailroadTracks_TripleStone",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "RailroadTracks_Pattern",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 2,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",140000},
				[2] = {"score",500000},
				[3] = {"score",1000000},
			},
		},
		expectedScore = 100000, 
	},
	
	["PickaxeFactory"] = {
		levelName = "Pickaxe Factory",					
		resource = "GameScreen_Land32",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasBedrock = true,
			hasMakers = true,
			hasSwitches = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				{
					entryName = "Reset Primary Switch",
					patternName = "PickaxeFactory_PrimarySwitch",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Maker Light On"},
					applySpawnTypes = true,
					spawnTypes = {"TurnOnMain",},
				},
				{
					entryName = "Maker Light On",
					patternName = "PickaxeFactory_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				{
					entryName = "Maker Light Off",
					patternName = "PickaxeFactory_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
				{
					entryName = "Remove Wall 1",
					patternName = "PickaxeFactory_Bedrock1",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Enable Secondary Switch 1",
					patternName = "PickaxeFactory_SecondarySwitch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
				},
				{
					entryName = "Remove Wall 2",
					patternName = "PickaxeFactory_Bedrock2",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Enable Secondary Switch 2",
					patternName = "PickaxeFactory_SecondarySwitch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
				},
				{
					entryName = "Remove Wall 3",
					patternName = "PickaxeFactory_Bedrock3",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Enable Secondary Switch 3",
					patternName = "PickaxeFactory_SecondarySwitch3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
				},
				{
					entryName = "Remove Wall 4",
					patternName = "PickaxeFactory_Bedrock4",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Enable Secondary Switch 4",
					patternName = "PickaxeFactory_SecondarySwitch4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
				},
				{
					entryName = "Remove Wall 5",
					patternName = "PickaxeFactory_Bedrock5",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Enable Secondary Switch 5",
					patternName = "PickaxeFactory_SecondarySwitch5",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
				},
			},
			additionalNamedMixes = {
				{
					name = "TurnOnMain",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "WhimsySwitch_On",
						weight = 1,
					},
				},
				{
					name = "TurnOnSecondary",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "WhimsySwitch_On",
						weight = 1,
					},
				},
				{
					name = "Dispense Pickaxe 1",
					delay = -1,
					{
						name = "Switch_On",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = { "Remove Wall 1","Enable Secondary Switch 1",},
						icon = "Icon_PickAxe",
						weight = 1,
					},
					cooldowns = {0,0},
					events = {
						{ --Only ever emit one
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							--And turn off permanently afterwards
							setCooldowns = {[1] = -1,[2] = -1,},
							patterns = {"Maker Light Off"},
						},
						{ --Emit when the main switch is hit
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								spawnTypes = {"TurnOnMain"},
							},
						},
					},
				},
				{
					name = "Dispense Pickaxe 2",
					delay = -1,
					{
						name = "Switch_On",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = {"Remove Wall 2","Enable Secondary Switch 2",},
						icon = "Icon_PickAxe",
						weight = 1,
					},
					cooldowns = {0,-1,0},
					events = {
						{ --Only ever emit one
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							--And turn off permanently afterwards
							setCooldowns = {[1] = -1,[2] = -1,[3] = -1},
							patterns = {"Maker Light Off"},
						},
						{ --Emit when the main switch is hit
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								spawnTypes = {"TurnOnMain"},
							},
						},
						{ --We can activate once wall 1 is gone
							eventType = "population",
                            count = 0,
                            comparator = "equals",
							newDelay = -1,
							setCooldowns = {[1] = 0, [2] = 0, [3] = -1},
							gemType = {
								icon = "Icon_SpecialGemBlue",
								specials = CascadePieceSpecials_Steel,
							},
						},
					},
				},
				{
					name = "Dispense Pickaxe 3",
					delay = -1,
					{
						name = "Switch_On",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = { "Remove Wall 5","Enable Secondary Switch 5",},
						icon = "Icon_PickAxe",
						weight = 1,
					},
					cooldowns = {0,-1,0},
					events = {
						{ --Only ever emit one
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							--And turn off permanently afterwards
							setCooldowns = {[1] = -1,[2] = -1,[3] = -1},
							patterns = {"Maker Light Off"},
						},
						{ --Emit when the main switch is hit
							eventType = "getGem",
							count = 1,
							newDelay = 0,
							gemType = {
								spawnTypes = {"TurnOnMain"},
							},
						},
						{ --We can activate once wall 2 is gone
							eventType = "population",
                            count = 0,
                            comparator = "equals",
							newDelay = -1,
							setCooldowns = {[1] = 0, [2] = 0, [3] = -1},
							gemType = {
								icon = "Icon_GemGreen",
								specials = CascadePieceSpecials_Steel,
							},
						},
					},
				},
				{
					name = "Dispense Pickaxe 4",
					delay = -1,
					{
						name = "Switch_On",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = { "Remove Wall 3","Enable Secondary Switch 3",},
						icon = "Icon_PickAxe",
						weight = 1,
					},
					cooldowns = {0,-1,0},
					events = {
						{ --Only ever emit one
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							--And turn off permanently afterwards
							setCooldowns = {[1] = -1,[2] = -1,[3] = -1},
							patterns = {"Maker Light Off"},
						},
						{ --Emit when the main switch is hit
							eventType = "getGem",
							count = 1,
							newDelay = 0,
							gemType = {
								spawnTypes = {"TurnOnMain"},
							},
						},
						{ --We can activate once wall 3 is gone
							eventType = "population",
                            count = 0,
                            comparator = "equals",
							newDelay = -1,
							setCooldowns = {[1] = 0, [2] = 0, [3] = -1},
							gemType = {
								icon = "Icon_GemYellow",
								specials = CascadePieceSpecials_Steel,
							},
						},
					},
				},
				{
					name = "Dispense Pickaxe 5",
					delay = -1,
					{
						name = "Switch_On",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_CantCover,
						matchPatterns = { "Remove Wall 4","Enable Secondary Switch 4",},
						icon = "Icon_PickAxe",
						weight = 1,
					},
					cooldowns = {0,-1,0},
					events = {
						{ --Only ever emit one
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							--And turn off permanently afterwards
							setCooldowns = {[1] = -1,[2] = -1,[3] = -1},
							patterns = {"Maker Light Off"},
						},
						{ --Emit when the main switch is hit
							eventType = "getGem",
							count = 1,
							newDelay = 0,
							gemType = {
								spawnTypes = {"TurnOnMain"},
							},
						},
						{ --We can activate once wall 4 is gone
							eventType = "population",
                            count = 0,
                            comparator = "equals",
							newDelay = -1,
							setCooldowns = {[1] = 0, [2] = 0, [3] = -1},
							gemType = {
								icon = "Icon_GemPurple",
								specials = CascadePieceSpecials_Steel,
							},
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "PickaxeFactory_Maker",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Dispense Pickaxe 1","Dispense Pickaxe 2","Dispense Pickaxe 3","Dispense Pickaxe 4","Dispense Pickaxe 5",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
				{
					patternName = "PickaxeFactory_PrimarySwitch",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOnMain",},
					applyMatchPatterns = true,
					matchPatterns = {"Maker Light On"},
				},
				{
					patternName = "PickaxeFactory_SecondarySwitch1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOnSecondary",},
					applyMatchPatterns = true,
					matchPatterns = {"Reset Primary Switch"},
				},
				{
					patternName = "PickaxeFactory_SecondarySwitch2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOnSecondary",},
					applyMatchPatterns = true,
					matchPatterns = {"Reset Primary Switch"},
				},
				{
					patternName = "PickaxeFactory_SecondarySwitch3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOnSecondary",},
					applyMatchPatterns = true,
					matchPatterns = {"Reset Primary Switch"},
				},
				{
					patternName = "PickaxeFactory_SecondarySwitch4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOnSecondary",},
					applyMatchPatterns = true,
					matchPatterns = {"Reset Primary Switch"},
				},
				{
					patternName = "PickaxeFactory_SecondarySwitch5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applySpawnTypes = true,
					spawnTypes = {"TurnOnSecondary",},
					applyMatchPatterns = true,
					matchPatterns = {"Reset Primary Switch"},
				},
				{
					patternName = "PickaxeFactory_Bedrock1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_SpecialGemBlue",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				{
					patternName = "PickaxeFactory_Bedrock2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemGreen",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				{
					patternName = "PickaxeFactory_Bedrock3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemPurple",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				{
					patternName = "PickaxeFactory_Bedrock4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_SpecialGemRed",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
				{
					patternName = "PickaxeFactory_Bedrock5",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyIcon = true,
					icon = "Icon_GemYellow",
					applySkinVariant = true,
					skinVariant = "BedRock",
				},
			},
		},
		goals = {
			main = {"haveGem",6,"Switch","Switches",{skinVariant = "WhimsySwitch_On"}, "Turn on"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000, 
	},

	--Ring For Service:
	--A switch changes whether makers put out rings on easy-to-match stuff or hard-to-match stuff.
	--Get N rings.

	["RingForService"] = {
		levelName = "Ring for Service",
		resource = "GameScreen_Land32",
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			gemTypes4 = true,
			hasMakers = true,
			hasSwitches = true,
			hasBoulders = true,
			hasBarrelsOfFun = true,
			hasLava = true,
			hasVines = true,
			hasIce = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon 1 On",
					patternName = "RingForService_Makers",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker Icon 1 Off",
					patternName = "RingForService_Makers",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "Good Mix",
						delay = -1,
					},
					[2] = {
						name = "Bad Mix",
						delay = -1,
					},
					[3] = {
						name = "Vines",
						delay = -1,
					},
					[4] = {
						name = "Lava",
						delay = -1,
					},
					[5] = {
						name = "Ice",
						delay = -1,
					},
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Good Mix",
					delay = -1,
					events = {
						[1] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								skinVariant = "WhimsySwitch_Off",
							},
						},
						[2] = {
							eventType = "getGem",
							newDelay = -1,
							targetMix = "Bad Mix",
							gemType = {
								skinVariant = "WhimsySwitch_Off",
							},
						},
						[3] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
	--Good mix: Wilds, superwilds, single-hit boulders, vertical bursts, one per 2 turns
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						icon = "Icon_Marked",
						weight = 4,
					},
					{
						name = "SuperWild",
						matchFlags = CascadeMatchFlags_Wildcard,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 4,
					},
					--[[
					{
						name = "Boulder",
						matchFlags = 0,
						icon = "Icon_Marked",
						specials = CascadePieceSpecials_Barrels,
						weight = 4,
					},]]
					{
						name = "Vertical Burst 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Burst 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Burst 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
					{
						name = "Vertical Burst 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_VerticalSplash,
						weight = 1,
					},
				},
				[2] = {
					name = "Bad Mix",
					delay = 0,
					events = {
						[1] = {
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[2] = {
							eventType = "getGem",
							newDelay = -1,
							targetMix = "Good Mix",
							gemType = {
								skinVariant = "WhimsySwitch_On",
							},
						},
						[3] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
	--Bad mix: Double barrel with vines, coconut with lava, Double boulder with bomb, Color barrel with ice, 2 per turn
					{
						name = "Double Barrel with Vines",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						spawnTypes = {"Vines"},
						icon = "Icon_Marked",
						extraHits = 1,
						weight = 4,
					},
					{
						name = "Coconuts with lava",
						matchFlags = 0,
						specials = CascadePieceSpecials_Coconut,
						spawnTypes = {"Lava"},
						icon = "Icon_Marked",
						weight = 4,
					},
					{
						name = "Double boulder with bomb",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						extraHits = 1,
						turnsToLoss = 12,
						icon = "Icon_Marked",
						weight = 4,
					},
					{
						name = "Color barrel with ice 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"Ice"},
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Color barrel with ice 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"Ice"},
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Color barrel with ice 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"Ice"},
						icon = "Icon_Marked",
						weight = 1,
					},
					{
						name = "Color barrel with ice 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_ColorBarrels,
						spawnTypes = {"Ice"},
						icon = "Icon_Marked",
						weight = 1,
					},
				},
				[3] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_On",
						spawnTypes = {"TurnOff1"},
						matchPatterns = {"Set Maker Icon 1 Off"},
						weight = 1,
					},
				},
				[4] = {
					name = "TurnOff1",
					delay = 0,
					{
						name = "Switch_Off",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "WhimsySwitch_Off",
						spawnTypes = {"TurnOn1"},
						matchPatterns = {"Set Maker Icon 1 On"},
						weight = 1,
					},
				},
				[5] = {
					name = "Vines",
					delay = 0,
					{
						name = "Vines 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Vines 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Vines 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
					{
						name = "Vines 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Vines,
						cancelSpecials = CascadePieceSpecials_Vines,
						weight = 1,
					},
				},
				[6] = {
					name = "Lava",
					delay = 0,
					{
						name = "Lava",
						matchFlags = 0,
						specials = CascadePieceSpecials_Lava,
						weight = 1,
					},
				},
				[7] = {
					name = "Ice",
					delay = 0,
					{
						name = "Ice 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1,
					},
					{
						name = "Ice 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1,
					},
					{
						name = "Ice 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1,
					},
					{
						name = "Ice 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						spreadSpecials = CascadePieceSpecials_Ice,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "RingForService_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Good Mix","Bad Mix",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				[2] = {
					patternName = "RingForService_Switch",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon 1 On"},
				},
			},
		},
		goals = {
			main = {"getGem",50,"Ring","Rings",{icon = "Icon_Marked", extraHits = 0,},"Collect"},
			stars = {
				[1] = {"score",1000000},
				[2] = {"score",1500000},
				[3] = {"score",2000000},
			},
		},
	},



	["LightsOut"] = {
		levelName = "Lights Out",					
		Features = {
			modeSpins3 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasSwitches = true,
			hasMakers = true,
			hasGemEaters = true,
			hasLocks = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				{
					entryName = "locks",
					patternName = "LightsOut_Locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
					addPieces = true,
				},
			},
			additionalNamedMixes = {
				{
					name = "boardMix",
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
				{
					name = "switchOn",
					{
						name = "Switch",
						specials = CascadePieceSpecials_Stone,
						matchFlags = 0,
						spawnTypes = {"switchOff"},
						skinVariant = "WhimsySwitch_On",
						weight = 1,
					},
				},
				{
					name = "switchOff",
					{
						name = "Switch",
						specials = CascadePieceSpecials_Stone,
						matchFlags = 0,
						spawnTypes = {"switchOn"},
						skinVariant = "WhimsySwitch_Off",
						weight = 1,
					},
				},
				{
					name = "replaceLocks",
					delay = -1,
					events = {
						{
							eventType = "getGem",
							newDelay = -1,
							patterns = {"locks"},
						},
					},
				},
			},
			endGameProperties = {
				--Prevent lights from flipping back on
				
				additionalNamedMixes = {
					{
						name = "switchOn",
						{
							name = "Switch",
							specials = CascadePieceSpecials_Stone,
							matchFlags = 0,
							spawnTypes = {"switchOn"},
							skinVariant = "WhimsySwitch_Off",
							weight = 1,
						},
					},
					{
						name = "switchOff",
						{
							name = "Switch",
							specials = CascadePieceSpecials_Stone,
							matchFlags = 0,
							spawnTypes = {"switchOn"},
							skinVariant = "WhimsySwitch_Off",
							weight = 1,
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "LightsOut_Makers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"boardMix"},
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
				},
				{
					patternName = "LightsOut_Locks",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lock,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "LightsOut_SwitchesOn",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"switchOff"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_On",
				},
				{
					patternName = "LightsOut_SwitchesOff",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"switchOn"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Off",
				},
				{
					patternName = "LightsOut_GemEaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
			},
			reelPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 5,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 5,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 5,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 5,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			portals = {
				{{0,7},{1,0},"PortalEntrance_1","PortalExit_1"},
				{{1,7},{2,0},"PortalEntrance_1","PortalExit_1"},
				{{2,7},{3,0},"PortalEntrance_1","PortalExit_1"},
				{{3,7},{4,0},"PortalEntrance_1","PortalExit_1"},
				{{4,7},{5,0},"PortalEntrance_1","PortalExit_1"},
				{{5,7},{6,0},"PortalEntrance_1","PortalExit_1"},
				{{6,7},{0,0},"PortalEntrance_1","PortalExit_1"},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Light","Lights",{skinVariant = "WhimsySwitch_On"}, "Turn off"},
			stars = {
				[1] = {"score",125000},
				[2] = {"score",250000},
				[3] = {"score",450000},
			},
		},
		expectedScore = 100000, 
	},

	["FilterMachine"] = {
		levelName = "Filt-O-Tron 5000",					
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasSteel = true,
			hasBombs = true,
			hasChests = true,
			hasSwitches = true,
			hasGemEaters = true,
			hasMakers = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = {
				{
					entryName = "LeftOn",
					patternName = "Large 3,0",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = false,
					applySkinVariant = true,
					skinVariant = "WhimsySteel",
					addPieces = true,
				},
				{
					entryName = "RightOn",
					patternName = "Large 3,2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applyTurnsToLoss = false,
					applySkinVariant = true,
					skinVariant = "WhimsySteel",
					addPieces = true,
				},
				{
					entryName = "LeftOff",
					patternName = "Large 3,0",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "RightOff",
					patternName = "Large 3,2",
					isPatternSet = false,
					clearPieces = true,
				},
			},
			additionalNamedMixes = {
				{
					name = "BombsAndChests",
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 3,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 3,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 3,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 3,
					},
					{
						name = "Blue_Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					},
					{
						name = "Green_Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					},
					{
						name = "Purple_Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					},
					{
						name = "Red_Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 5,
						weight = 2,
					},
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 6,
					},
				},
				{
					name = "SwitchL",
					{
						name = "Switch",
						specials = CascadePieceSpecials_Stone,
						matchFlags = 0,
						spawnTypes = {"SwitchR"},
						skinVariant = "WhimsySwitch_Toggle",
						matchPatterns = {"LeftOff", "LeftOn", "RightOff"},
						weight = 1,
					}
				},
				{
					name = "SwitchR",
					{
						name = "Switch",
						specials = CascadePieceSpecials_Stone,
						matchFlags = 0,
						spawnTypes = {"SwitchL"},
						skinVariant = "WhimsySwitch_Toggle",
						matchPatterns = {"RightOff", "RightOn", "LeftOff"},
						weight = 1,
					}
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "FilterMachine_Steel",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					
					applySkinVariant = true,
					skinVariant = "WhimsySteel",

					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "Large 0,1",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,

					applySpawnBelowTypes = true,
					spawnBelowTypes = {"BombsAndChests"},
					
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",

					applyMatchFlags = true,
					matchFlags = 0,
				},
				{
					patternName = "FilterMachine_Eaters",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
				},
				{
					patternName = "Large 6,5",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"SwitchR"},
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"LeftOn", "RightOff"},
				}
			},
			useMissingReels = true,
			missingReels = {
				patternName = "FilterMachine_Reel",
				isPatternSet = false,
			},
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "BombsAndChests",
						delay = -1,
					},
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure}, "Drop",},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",200000},
				[3] = {"score",575000},
			},
		},
		expectedScore = 100000, 
	},
	
	["ColorSwap"] = {
		levelName = "The Switcheroo",
		resource = "GameScreen_Land32",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes6 = true,
			largeBoard = true,
			hasSwitches = true,
			hasMakers = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			useMissingReels = true,
			missingReels = {
				patternName = "ColorSwap_Reel",
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "ColorSwap_Missing",
				isPatternSet = false,
			},
			additionalNamedPatterns = {
				{
					entryName = "Clear",
					patternName = "ColorSwap_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
				{
					entryName = "Left 1",
					patternName = "ColorSwap_LeftMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Colors 1"},
					addPieces = true,
				},
				{
					entryName = "Left 2",
					patternName = "ColorSwap_LeftMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Colors 2"},
					addPieces = true,
				},
				{
					entryName = "Right 1",
					patternName = "ColorSwap_RightMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Colors 1"},
					addPieces = true,
				},
				{
					entryName = "Right 2",
					patternName = "ColorSwap_RightMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Colors 2"},
					addPieces = true,
				},
				{
					entryName = "Switch 1",
					patternName = "ColorSwap_Switches",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"Switch"},
					applyMatchPatterns = true,
					matchPatterns = {"Clear", "Left 2", "Right 1", "Switch 2"},
					addPieces = true,
				},
				{
					entryName = "Switch 2",
					patternName = "ColorSwap_Switches",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"Switch"},
					applyMatchPatterns = true,
					matchPatterns = {"Clear", "Left 1", "Right 2", "Switch 1"},
					addPieces = true,
				},
			},
			additionalNamedMixes = {
				{
					name = "Colors 1",
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
				},
				{
					name = "Colors 2",
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						weight = 1,
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				{
					name = "Switch",
					{
						name = "Switch",
						specials = CascadePieceSpecials_Stone,
						matchFlags = 0,
						skinVariant = "WhimsySwitch_On",
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "ColorSwap_LeftMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Colors 1"},
				},
				{
					patternName = "ColorSwap_RightMakers",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsyMaker",
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Colors 2"},
				},
				{
					patternName = "ColorSwap_Switches",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySkinVariant = true,
					skinVariant = "WhimsySwitch_Toggle",
					applySpawnTypes = true,
					spawnTypes = {"Switch"},
					applyMatchPatterns = true,
					matchPatterns = {"Clear", "Left 2", "Right 1", "Switch 2"},
				},
				{
					patternName = "ColorSwap_Blue",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				{
					patternName = "ColorSwap_Green",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				{
					patternName = "ColorSwap_Purple",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				{
					patternName = "ColorSwap_Red",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				{
					patternName = "ColorSwap_Yellow",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				{
					patternName = "ColorSwap_Orange",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece6,
				},
			},
		},
		goals = {
			main = {"getGem",25,"Switch","Switches",{specials = CascadePieceSpecials_Stone},"Toggle"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000, 
	},
})

-- Begin RainbowCycle Code

local rainbowCycle_Colors = {"Red", "Orange", "Yellow", "Green", "Blue", "Purple"}
local rainbowCycle_Flags = {
	CascadeMatchFlags_CommonPiece4,
	CascadeMatchFlags_CommonPiece6,
	CascadeMatchFlags_CommonPiece5,
	CascadeMatchFlags_CommonPiece2,
	CascadeMatchFlags_CommonPiece1,
	CascadeMatchFlags_CommonPiece3,
}

local function rainbowCycle_namedPatterns()
	local namedPatterns = {}

	-- Create a named pattern for each color of maker
	for i = 1,6 do
		local colorName = rainbowCycle_Colors[i]
		local iconName = "Icon_Gem"
		if i == 1 or i == 4 then
			iconName = "Icon_SpecialGem"
		end
		namedPatterns[#namedPatterns + 1] = {
			entryName = colorName,
			patternName = "RainbowCycle_Makers",
			isPatternSet = false,
			applyPieceSpecials = true,
			specials = CascadePieceSpecials_Steel,
			applyMatchFlags = true,
			matchFlags = 0,
			applySpawnBelowTypes = true,
			spawnBelowTypes = {colorName},
			applySkinVariant = true,
			skinVariant = "WhimsyMaker",
			applyIcon = true,
			icon = iconName .. colorName,
		}
	end

	return namedPatterns
end

local function rainbowCycle_namedMixes()
	local namedMixes = {}
	
	for i = 1,6 do
		local colorName = rainbowCycle_Colors[i]
		local matchFlag = rainbowCycle_Flags[i]
		
		-- Create the maker piece mix for each color
		namedMixes[#namedMixes + 1] = {
			name = colorName,
			{
				name = colorName,
				matchFlags = matchFlag,
				weight = 5,
			},
			{
				name = colorName .. "Burst",
				matchFlags = matchFlag,
				specials = CascadePieceSpecial_AreaSplash,
				weight = 1,
			},
		}

		local nextColorName = rainbowCycle_Colors[i % 6 + 1]

		-- Create the switch piece mix for each color
		namedMixes[#namedMixes + 1] = {
			name = colorName .. "Switch",
			{
				name = colorName,
				matchFlags = 0,
				specials = CascadePieceSpecials_Stone,
				spawnTypes = {nextColorName .. "Switch"},
				matchPatterns = {colorName},
				skinVariant = "WhimsySwitch_Toggle",
				weight = 1,
			},
		}
	end

	-- Create the laser piece mix
	namedMixes[#namedMixes + 1] = {
		name = "Laser",
		{
			name = "Laser",
			matchFlags = CascadeMatchFlags_Wildcard,
			specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
			spawnTypes = {"Laser"},
			skinVariant = "WhimsyLaserH",
			weight = 1,
		},
	}

	return namedMixes
end

local function rainbowCycle_initialPatterns()
	local initialPatterns = {}
	
	initialPatterns[#initialPatterns + 1] = {
		patternName = "RainbowCycle_Makers",
		isPatternSet = false,
		applyPieceSpecials = true,
		specials = CascadePieceSpecials_Steel,
		applyMatchFlags = true,
		matchFlags = 0,
		applySpawnBelowTypes = true,
		spawnBelowTypes = {"Red"},
		applySkinVariant = true,
		skinVariant = "WhimsyMaker",
		applyIcon = true,
		icon = "Icon_SpecialGemRed",
	}

	initialPatterns[#initialPatterns + 1] = {
		patternName = "Large 7,3",
		isPatternSet = false,
		applyPieceSpecials = true,
		specials = CascadePieceSpecials_Stone,
		applyMatchFlags = true,
		matchFlags = 0,
		applySpawnTypes = true,
		spawnTypes = {"YellowSwitch"},
		applyMatchPatterns = true,
		matchPatterns = {"Orange"},
		applySkinVariant = true,
		skinVariant = "WhimsySwitch_Toggle",
	}

	initialPatterns[#initialPatterns + 1] = {
		patternName = "RainbowCycle_Lasers",
		isPatternSet = false,
		applyPieceSpecials = true,
		specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
		applyMatchFlags = true,
		matchFlags = CascadeMatchFlags_Wildcard,
		applySpawnTypes = true,
		spawnTypes = {"Laser"},
		applySkinVariant = true,
		skinVariant = "WhimsyLaserH",
	}

	return initialPatterns
end

local function rainbowCycle_portals()
	local portals = {}

	-- These portals make gems travel diagonally down to the right
	for x = 0,6 do
		for y = 1, 5 do
			portals[#portals + 1] = {{x, y}, {(x+1) % 7, y+1}, "PortalEntrance_1","PortalExit_1"}
		end
	end

	return portals
end
	
table.insertall(LevelDefs, {
	["RainbowCycle"] = {
		levelName = "Rainbow Twister",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes6 = true,
			largeBoard = true,
			hasSwitches = true,
			hasMakers = true,
			hasPortals = true,
			hasLasers = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedPatterns = rainbowCycle_namedPatterns(),
			additionalNamedMixes = rainbowCycle_namedMixes(),
			additionalInitialPatterns = rainbowCycle_initialPatterns(),
			portals = rainbowCycle_portals(),
			endGameProperties = {
				additionalNamedMixes = {
					{
						name = "Laser",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_Wildcard,
							specials = CascadePieceSpecials_Laser,
							spawnTypes = {"Laser",},
							skinVariant = "WhimsyLaserH",
							weight = 1,
						},
					},
					{
						name = "Blue",
						{
							name = "Blue",
							matchFlags = CascadeMatchFlags_CommonPiece1,
							weight = 5,
						},
					},
					{
						name = "Green",
						{
							name = "Green",
							matchFlags = CascadeMatchFlags_CommonPiece2,
							weight = 5,
						},
					},
					{
						name = "Purple",
						{
							name = "Purple",
							matchFlags = CascadeMatchFlags_CommonPiece3,
							weight = 5,
						},
					},
					{
						name = "Red",
						{
							name = "Red",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							weight = 5,
						},
					},
					{
						name = "Yellow",
						{
							name = "Yellow",
							matchFlags = CascadeMatchFlags_CommonPiece5,
							weight = 5,
						},
					},
					{
						name = "Orange",
						{
							name = "Orange",
							matchFlags = CascadeMatchFlags_CommonPiece6,
							weight = 5,
						},
					},
				},
			},
		},
		goals = {
			main = {"getGem",40,"Switch","Switches",{specials = CascadePieceSpecials_Stone},"Flip"},
			stars = {
				[1] = {"score",1500000},
				[2] = {"score",2500000},
				[3] = {"score",4000000},
			},
		},
		expectedScore = 100000, 
	},
})

-- End Rainbow Cycle

-- Begin ThingsThatYouSee Code
local thingsThatYouSee_Colors = {"Blue", "Green", "Purple", "Red", "Yellow", "Wild"}
local thingsThatYouSee_Flags = {CascadeMatchFlags_CommonPiece1, CascadeMatchFlags_CommonPiece2, CascadeMatchFlags_CommonPiece3, CascadeMatchFlags_CommonPiece4, CascadeMatchFlags_CommonPiece5, CascadeMatchFlags_Wildcard}

local function thingsThatYouSee_BarrelMixes()
	-- deep copy function, taken from https://gist.github.com/MihailJP/3931841
	local function clone (t)
		if type(t) ~= "table" then return t end
		local meta = getmetatable(t)
		local target = {}
		for k, v in pairs(t) do
			if type(v) == "table" then
				target[k] = clone(v)
			else
				target[k] = v
			end
		end
		setmetatable(target, meta)
		return target
	end
	
	-- helper function that adds all colors of a gem to the piece mix
	-- colorFreq and wildFreq is the ratio of non-wild to wild pieces
	-- this assumes that the last element of the color and flags tables (above) corresponds to wilds
	local function addAllColorsToMix(pieceMix, uncoloredMixElement, colorFreq, wildFreq)
		for i = 1, #thingsThatYouSee_Colors do
			local mixElementCopy = clone(uncoloredMixElement)
			mixElementCopy.name = mixElementCopy.name .. thingsThatYouSee_Colors[i]
			mixElementCopy.matchFlags = thingsThatYouSee_Flags[i]
			
			if i == #thingsThatYouSee_Colors then mixElementCopy.weight = wildFreq
			else mixElementCopy.weight = colorFreq / (#thingsThatYouSee_Colors - 1) end

			pieceMix[#pieceMix + 1] = mixElementCopy
		end
	end
	
	namedMixes = {}
	
	greatSpawnMix = {
		name = "GreatSpawn",
		events = {
			{
				eventType = "emitCount",
				count = 5,
				newDelay = -1,
			},
		},
		{
			name = "Stone",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			weight = 2,
		},
		{
			name = "Stone2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 1,
			weight = 1,
		},
		{
			name = "Present",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"OkayBonus"},
			weight = 1,
		},
		{
			name = "Present2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"OkayBonus"},
			extraHits = 1,
			weight = 1,
		},
		{
			name = "Coconut",
			matchFlags = 0,
			specials = CascadePieceSpecials_Coconut,
			spawnTypes = {"OkayBonus"},
			weight = 2,
		},
		{
			name = "BarrelOfFun",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			spawnTypes = {"OkayBonus"},
			weight = 2,
		},
		{
			name = "Boulder",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			weight = 2,
		},
		{
			name = "Boulder2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			extraHits = 1,
			weight = 2,
		},
		{
			name = "Treasure",
			matchFlags = 0,
			specials = CascadePieceSpecials_Treasure,
			weight = 2,
		},
		{
			name = "Lock",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lock,
			weight = 1,
		},
		{
			name = "HVABurst_WildSuper",
			matchFlags = CascadeMatchFlags_Wildcard,
			specials = CascadePieceSpecial_ClearKeyColorOnMatch | CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash,
			weight = 1,
		},
	}
	
	addAllColorsToMix(greatSpawnMix, {name = "Amber_", specials = CascadePieceSpecials_Amber, cancelSpecials = CascadePieceSpecials_Amber}, 1, .25)
	addAllColorsToMix(greatSpawnMix, {name = "Balloon_", specials = CascadePieceSpecials_Balloon, cancelSpecials = CascadePieceSpecials_Balloon}, 1, .25)
	addAllColorsToMix(greatSpawnMix, {name = "Bomb_", specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover, turnsToLoss = 10}, 1, .25)
	addAllColorsToMix(greatSpawnMix, {name = "HVABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, 5, 2)
	addAllColorsToMix(greatSpawnMix, {name = "HABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash}, 6, 3)
	addAllColorsToMix(greatSpawnMix, {name = "VABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash}, 6, 3)
	addAllColorsToMix(greatSpawnMix, {name = "HVBurst_", specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, 8, 4)
	
	namedMixes[#namedMixes + 1] = greatSpawnMix

	goodSpawnMix = {
		name = "GoodSpawn",
		events = {
			{
				eventType = "emitCount",
				count = 10,
				newDelay = -1,
			},
		},
		{
			name = "Stone",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			weight = 2,
		},
		{
			name = "Stone2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 1,
			weight = 1,
		},
		{
			name = "Present",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"OkayBonus"},
			weight = 1,
		},
		{
			name = "Present2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"OkayBonus"},
			extraHits = 1,
			weight = 1,
		},
		{
			name = "Coconut",
			matchFlags = 0,
			specials = CascadePieceSpecials_Coconut,
			spawnTypes = {"OkayBonus"},
			weight = 2,
		},
		{
			name = "BarrelOfFun",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			spawnTypes = {"OkayBonus"},
			weight = 2,
		},
		{
			name = "Boulder",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			weight = 2,
		},
		{
			name = "Boulder2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			extraHits = 1,
			weight = 2,
		},
		{
			name = "Treasure",
			matchFlags = 0,
			specials = CascadePieceSpecials_Treasure,
			weight = 2,
		},
		{
			name = "Lock",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lock,
			weight = 1,
		},
		{
			name = "Lava",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lava,
			weight = 1,
		},
	}

	addAllColorsToMix(goodSpawnMix, {name = "Vines_", specials = CascadePieceSpecials_Vines, cancelSpecials = CascadePieceSpecials_Vines}, 1, .25)
	addAllColorsToMix(goodSpawnMix, {name = "Ice_", spreadSpecials = CascadePieceSpecials_Ice}, 1, .25)
	addAllColorsToMix(goodSpawnMix, {name = "Amber_", specials = CascadePieceSpecials_Amber, cancelSpecials = CascadePieceSpecials_Amber}, 1, .25)
	addAllColorsToMix(goodSpawnMix, {name = "Balloon_", specials = CascadePieceSpecials_Balloon, cancelSpecials = CascadePieceSpecials_Balloon}, 1, .25)
	addAllColorsToMix(greatSpawnMix, {name = "Bomb_", specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover, turnsToLoss = 10}, 1, .25)
	addAllColorsToMix(goodSpawnMix, {name = "HVABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, 3, 1)
	addAllColorsToMix(goodSpawnMix, {name = "HABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash}, 4, 2)
	addAllColorsToMix(goodSpawnMix, {name = "VABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash}, 4, 2)
	addAllColorsToMix(goodSpawnMix, {name = "HVBurst_", specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, 5, 3)
	addAllColorsToMix(goodSpawnMix, {name = "HBurst_", specials = CascadePieceSpecial_HorizontalSplash}, 12, 4)
	addAllColorsToMix(goodSpawnMix, {name = "VBurst_", specials = CascadePieceSpecial_VerticalSplash}, 12, 4)
	addAllColorsToMix(goodSpawnMix, {name = "ABurst_", specials = CascadePieceSpecial_AreaSplash}, 12, 4)

	namedMixes[#namedMixes + 1] = goodSpawnMix

	okaySpawnMix = {
		name = "OkaySpawn",
		events = {
			{
				eventType = "emitCount",
				count = 15,
				newDelay = -1,
			},
		},
		{
			name = "Stone",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			weight = 7,
		},
		{
			name = "Stone2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 1,
			weight = 4,
		},
		{
			name = "Present",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"OkayBonus"},
			weight = 7,
		},
		{
			name = "Present2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"OkayBonus"},
			extraHits = 1,
			weight = 4,
		},
		{
			name = "Coconut",
			matchFlags = 0,
			specials = CascadePieceSpecials_Coconut,
			spawnTypes = {"OkayBonus"},
			weight = 7,
		},
		{
			name = "BarrelOfFun",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			spawnTypes = {"OkayBonus"},
			weight = 7,
		},
		{
			name = "Boulder",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			weight = 7,
		},
		{
			name = "Boulder2",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			extraHits = 1,
			weight = 7,
		},
		{
			name = "Treasure",
			matchFlags = 0,
			specials = CascadePieceSpecials_Treasure,
			weight = 7,
		},
		{
			name = "Lock",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lock,
			weight = 2,
		},
		{
			name = "Lava",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lava,
			weight = 2,
		},
	}

	addAllColorsToMix(okaySpawnMix, {name = "Vines_", specials = CascadePieceSpecials_Vines, cancelSpecials = CascadePieceSpecials_Vines}, 1, .25)
	addAllColorsToMix(okaySpawnMix, {name = "Ice_", spreadSpecials = CascadePieceSpecials_Ice}, 1, .25)
	addAllColorsToMix(okaySpawnMix, {name = "Balloon_", specials = CascadePieceSpecials_Balloon, cancelSpecials = CascadePieceSpecials_Balloon}, 1, .25)
	addAllColorsToMix(okaySpawnMix, {name = "Bomb_", specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover, turnsToLoss = 10}, 1, .25)
	addAllColorsToMix(okaySpawnMix, {name = "Amber_", specials = CascadePieceSpecials_Amber, cancelSpecials = CascadePieceSpecials_Amber}, 7, 3)
	addAllColorsToMix(okaySpawnMix, {name = "HVABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, 1, .25)
	addAllColorsToMix(okaySpawnMix, {name = "HABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash}, 1, .25)
	addAllColorsToMix(okaySpawnMix, {name = "VABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash}, 1, .25)
	addAllColorsToMix(okaySpawnMix, {name = "HVBurst_", specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, 1, .25)
	addAllColorsToMix(okaySpawnMix, {name = "HBurst_", specials = CascadePieceSpecial_HorizontalSplash}, 4, 2)
	addAllColorsToMix(okaySpawnMix, {name = "VBurst_", specials = CascadePieceSpecial_VerticalSplash}, 4, 2)
	addAllColorsToMix(okaySpawnMix, {name = "ABurst_", specials = CascadePieceSpecial_AreaSplash}, 4, 2)

	namedMixes[#namedMixes + 1] = okaySpawnMix

	badSpawnMix = {
		name = "BadSpawn",
		events = {
			{
				eventType = "emitCount",
				count = 20,
				newDelay = -1,
			},
		},
		{
			name = "Stone3",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 2,
			weight = 5,
		},
		{
			name = "Stone4",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 3,
			weight = 5,
		},
		{
			name = "Present3",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"BadBonus"},
			extraHits = 2,
			weight = 5,
		},
		{
			name = "Coconut",
			matchFlags = 0,
			specials = CascadePieceSpecials_Coconut,
			spawnTypes = {"BadBonus"},
			weight = 5,
		},
		{
			name = "BarrelOfFun",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			spawnTypes = {"BadBonus"},
			weight = 5,
		},
		{
			name = "Treasure",
			matchFlags = 0,
			specials = CascadePieceSpecials_Treasure,
			weight = 5,
		},
		{
			name = "Lock",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lock,
			weight = 5,
		},
		{
			name = "Lava",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lava,
			weight = 3,
		},
	}

	addAllColorsToMix(badSpawnMix, {name = "Vines_", specials = CascadePieceSpecials_Vines, cancelSpecials = CascadePieceSpecials_Vines}, 2, .25)
	addAllColorsToMix(badSpawnMix, {name = "Ice_", spreadSpecials = CascadePieceSpecials_Ice}, 2, .25)
	addAllColorsToMix(badSpawnMix, {name = "Amber_", specials = CascadePieceSpecials_Amber, cancelSpecials = CascadePieceSpecials_Amber}, 4, .25)
	addAllColorsToMix(badSpawnMix, {name = "Balloon_", specials = CascadePieceSpecials_Balloon, cancelSpecials = CascadePieceSpecials_Balloon}, 4, .25)
	addAllColorsToMix(badSpawnMix, {name = "Bomb_", specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover, turnsToLoss = 10}, 4, 1)
	addAllColorsToMix(badSpawnMix, {name = "HVABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, .5, .125)
	addAllColorsToMix(badSpawnMix, {name = "HABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash}, .5, .125)
	addAllColorsToMix(badSpawnMix, {name = "VABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash}, .5, .125)
	addAllColorsToMix(badSpawnMix, {name = "HVBurst_", specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, .5, .125)
	addAllColorsToMix(badSpawnMix, {name = "HBurst_", specials = CascadePieceSpecial_HorizontalSplash}, 2, .5)
	addAllColorsToMix(badSpawnMix, {name = "VBurst_", specials = CascadePieceSpecial_VerticalSplash}, 2, .5)
	addAllColorsToMix(badSpawnMix, {name = "ABurst_", specials = CascadePieceSpecial_AreaSplash}, 2, .5)
	
	namedMixes[#namedMixes + 1] = badSpawnMix

	terribleSpawnMix = {
		name = "TerribleSpawn",
		events = {
			{
				eventType = "emitCount",
				count = 25,
				newDelay = -1,
			},
		},
		{
			name = "Stone3",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 2,
			weight = 5,
		},
		{
			name = "Stone4",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 3,
			weight = 5,
		},
		{
			name = "Present3",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"BadBonus"},
			extraHits = 2,
			weight = 5,
		},
		{
			name = "Coconut",
			matchFlags = 0,
			specials = CascadePieceSpecials_Coconut,
			spawnTypes = {"BadBonus"},
			weight = 5,
		},
		{
			name = "BarrelOfFun",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			spawnTypes = {"BadBonus"},
			weight = 5,
		},
		{
			name = "Treasure",
			matchFlags = 0,
			specials = CascadePieceSpecials_Treasure,
			weight = 5,
		},
		{
			name = "Lock",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lock,
			weight = 5,
		},
		{
			name = "Lava",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lava,
			weight = 5,
		},
	}
	addAllColorsToMix(terribleSpawnMix, {name = "Vines_", specials = CascadePieceSpecials_Vines, cancelSpecials = CascadePieceSpecials_Vines}, 4, .25)
	addAllColorsToMix(terribleSpawnMix, {name = "Ice_", spreadSpecials = CascadePieceSpecials_Ice}, 4, .25)
	addAllColorsToMix(terribleSpawnMix, {name = "Bomb_", specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover, turnsToLoss = 10}, 4, .25)
	addAllColorsToMix(terribleSpawnMix, {name = "Amber_", specials = CascadePieceSpecials_Amber, cancelSpecials = CascadePieceSpecials_Amber}, 4, .25)
	addAllColorsToMix(terribleSpawnMix, {name = "Balloon_", specials = CascadePieceSpecials_Balloon, cancelSpecials = CascadePieceSpecials_Balloon}, 4, .25)
	addAllColorsToMix(terribleSpawnMix, {name = "HABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash}, .25, .0625)
	addAllColorsToMix(terribleSpawnMix, {name = "VABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash}, .25, .0625)
	addAllColorsToMix(terribleSpawnMix, {name = "HVBurst_", specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, .25, .0625)
	addAllColorsToMix(terribleSpawnMix, {name = "HBurst_", specials = CascadePieceSpecial_HorizontalSplash}, 1, .25)
	addAllColorsToMix(terribleSpawnMix, {name = "VBurst_", specials = CascadePieceSpecial_VerticalSplash}, 1, .25)
	addAllColorsToMix(terribleSpawnMix, {name = "ABurst_", specials = CascadePieceSpecial_AreaSplash}, 1, .25)
	
	namedMixes[#namedMixes + 1] = terribleSpawnMix

	lastSpawnMix = {
		name = "LastSpawn",
		{
			name = "Stone3",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 2,
			weight = 5,
		},
		{
			name = "Stone4",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			extraHits = 3,
			weight = 5,
		},
		{
			name = "Present3",
			matchFlags = 0,
			specials = CascadePieceSpecials_Stone,
			spawnTypes = {"BadBonus"},
			extraHits = 2,
			weight = 5,
		},
		{
			name = "Coconut",
			matchFlags = 0,
			specials = CascadePieceSpecials_Coconut,
			spawnTypes = {"BadBonus"},
			weight = 10,
		},
		{
			name = "BarrelOfFun",
			matchFlags = 0,
			specials = CascadePieceSpecials_Barrels,
			spawnTypes = {"BadBonus"},
			weight = 5,
		},
		{
			name = "Treasure",
			matchFlags = 0,
			specials = CascadePieceSpecials_Treasure,
			weight = 10,
		},
		{
			name = "Lock",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lock,
			weight = 10,
		},
		{
			name = "Lava",
			matchFlags = 0,
			specials = CascadePieceSpecials_Lava,
			weight = 20,
		},
	}
	addAllColorsToMix(lastSpawnMix, {name = "Vines_", specials = CascadePieceSpecials_Vines, cancelSpecials = CascadePieceSpecials_Vines}, 16, .25)
	addAllColorsToMix(lastSpawnMix, {name = "Ice_", spreadSpecials = CascadePieceSpecials_Ice}, 16, .25)
	addAllColorsToMix(lastSpawnMix, {name = "Bomb_", specials = CascadePieceSpecial_Valuable | CascadePieceSpecial_CantCover, turnsToLoss = 10}, 16, .25)
	addAllColorsToMix(lastSpawnMix, {name = "Amber_", specials = CascadePieceSpecials_Amber, cancelSpecials = CascadePieceSpecials_Amber}, 4, .25)
	addAllColorsToMix(lastSpawnMix, {name = "Balloon_", specials = CascadePieceSpecials_Balloon, cancelSpecials = CascadePieceSpecials_Balloon}, 4, .25)
	addAllColorsToMix(lastSpawnMix, {name = "HABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash}, .25, .0625)
	addAllColorsToMix(lastSpawnMix, {name = "VABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash}, .25, .0625)
	addAllColorsToMix(lastSpawnMix, {name = "HVBurst_", specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, .25, .0625)
	addAllColorsToMix(lastSpawnMix, {name = "HBurst_", specials = CascadePieceSpecial_HorizontalSplash}, 1, .25)
	addAllColorsToMix(lastSpawnMix, {name = "VBurst_", specials = CascadePieceSpecial_VerticalSplash}, 1, .25)
	addAllColorsToMix(lastSpawnMix, {name = "ABurst_", specials = CascadePieceSpecial_AreaSplash}, 1, .25)
	
	namedMixes[#namedMixes + 1] = lastSpawnMix
	
	okayBonusMix = {
		name = "OkayBonus",
	}

	addAllColorsToMix(okayBonusMix, {name = "HVABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, 3, 1)
	addAllColorsToMix(okayBonusMix, {name = "HABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_HorizontalSplash}, 4, 1)
	addAllColorsToMix(okayBonusMix, {name = "VABurst_", specials = CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash}, 4, 1)
	addAllColorsToMix(okayBonusMix, {name = "HVBurst_", specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_VerticalSplash}, 5, 2)
	addAllColorsToMix(okayBonusMix, {name = "HBurst_", specials = CascadePieceSpecial_HorizontalSplash}, 12, 3)
	addAllColorsToMix(okayBonusMix, {name = "VBurst_", specials = CascadePieceSpecial_VerticalSplash}, 12, 3)
	addAllColorsToMix(okayBonusMix, {name = "ABurst_", specials = CascadePieceSpecial_AreaSplash}, 12, 3)
	
	namedMixes[#namedMixes + 1] = okayBonusMix

	badBonusMix = {
		name = "BadBonus",
	}
	addAllColorsToMix(badBonusMix, {name = "HBurst_", specials = CascadePieceSpecial_HorizontalSplash}, 4, 1)
	addAllColorsToMix(badBonusMix, {name = "VBurst_", specials = CascadePieceSpecial_VerticalSplash}, 4, 1)
	addAllColorsToMix(badBonusMix, {name = "ABurst_", specials = CascadePieceSpecial_AreaSplash}, 4, 1)

	namedMixes[#namedMixes + 1] = badBonusMix
	--logprint(SerializeToString(terribleSpawnMix))

	return namedMixes
end

table.insertall(LevelDefs, {
	["ThingsThatYouSee"] = {
		levelName = "Kitchen Sink",					
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			
			hasChests = true,
			hasBarrelsOfFun = true,
			hasBarrels = true,
			hasLocks = true,
			hasStones = true,
			hasLava = true,
			hasVines = true,
			hasAmber = true,
			hasIce = true,
			hasBombs = true,
			hasBalloons = true,
			hasCoconuts = true,
			hasGiftBoxes = true,
		},
		tricks = World32Tricks,
		boosts = World32Boosts,
		Properties = {
			additionalNamedMixes = thingsThatYouSee_BarrelMixes(),
			addToBoardPieceMix = {
				{
					name = "Colored Barrel",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecials_ColorBarrels,
					spawnTypes = {"GreatSpawn", "GoodSpawn", "OkaySpawn", "BadSpawn", "TerribleSpawn", "LastSpawn"},
					weight = 16,
				},
			},
			endGameProperties = {
				multiplyBoardPieceMix = {
					{
						name = "Colored Barrel",
						weight = 0,
					},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",2500000},
				[2] = {"score",2800000},
				[3] = {"score",5000000},
			},
		},
		expectedScore = 100000, 
	},
})

-- End ThingsThatYouSee