table.insertall(LevelDefs,
{

-- Levels created for testing purposes (demoing a new mechanic, sample/ placeholder levels created to hold a spot, etc.)
-- May include some mechanics not yet used in game

	["EasyTestLevel"] = {
		levelName = "EasyTestLevel",
		resource = "GameScreen_Land1",		
		--introScript = "Land1_Level6_Intro",
		Features = {
			splashMode = true,
			modeSpins1 = true,
			hasCoverage = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "TestPattern1",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100},
				[2] = {"score",200},
				[3] = {"score",300},
			},
		},
	},

	["FirstScore"] = {
		levelName = "First Score",
		resource = "GameScreen_Land1",		
		--levelMusic = "GameMusic_"..MusicOrder[1][1],
		Features = {
			splashMode = true,
			modeSpins8 = true,
		},
		Properties = {
		},

		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",10000},
				[2] = {"score",20000},
				[3] = {"score",30000},
			},
		},
		expectedScore = 10000,
	},

	["GemEaterTest"] = {
		levelName = "Gem Eater Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "LittleMissingPattern5",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["OrGoalTest"] = {
		levelName = "Make Bursts!",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			gemTypes4 = true,
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Scatter3",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_HorizontalSplash,
					patternName = "Scatter3",
				},
				[2] = {
					patternName = "Scatter3",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					patternName = "Scatter1",
				},
				[3] = {
					patternName = "Scatter3",
					isPatternSet = false,
					applyPieceSpecials = true,
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					patternName = "Scatter2",
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Burst","Bursts",
					{
						{specials = CascadePieceSpecial_HorizontalSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_HorizontalSplash + CascadePieceSpecial_VerticalSplash +  CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_VerticalSplash,},
						{specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,},
						{specials = CascadePieceSpecial_AreaSplash,},
					},
				},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",95000},
				[3] = {"score",150000},
			},
		},
	},

	["BasicJails"] = {
		levelName = "Jails",					
		resource = "GameScreen_Land2",		
		Features = {
			hasJailedSquares = true,
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "CrossedLines",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["SplashTest"] = {
		levelName = "Splash Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["VinesTest"] = {
		levelName = "Vines Test",
		resource = "GameScreen_Land1",		
		--introScript = "Land8_Intro",
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "SinglePoint",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["StoneTest"] = {
		levelName = "Stone Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",12,"Stone","Stones",{specials = CascadePieceSpecials_Crates, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["BoulderTest"] = {
		levelName = "Boulder Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "OuterRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"getGem",22,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["BombTest"] = {
		levelName = "Bomb Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleMissingPattern6",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
			},
		},
		goals = {
			main = {"finish", true},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["RecurringBombTest"] = {
		levelName = "Recurring Bomb Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 11,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
		},
		goals = {
			main = {"finish", true},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["BarrierTest"] = {
		levelName = "Barrier Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BarrierTestHorizontal",
					isPatternSet = false,

					applyBarriersToBottomEdge = true,
				},
				[2] = {
					patternName = "BarrierTestVertical",
					isPatternSet = false,

					applyBarriersToRightEdge = true,
				},
				[3] = {
					patternName = "BarrierTestPattern",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["SteelTest"] = {
		levelName = "Steel Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			hasCrates = true,
			hasStones = true,
			treasureChest = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "SteelTestSteel",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[2] = {
					patternName = "SteelTestStone",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "SteelTestCrates",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["GoldTest"] = {
		levelName = "Gold Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins8 = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Grid1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Gold,
					matchFlags = 0,
					applyMatchSizeRequirement = true,
					matchSizeRequirement = 8,
				},
				[2] = {
					patternName = "Grid1_seeds",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Gold,
					matchFlags = 0,
					applyMatchSizeRequirement = true,
					matchSizeRequirement = 12,
				},
			},
		},
		goals = {
			main = {"getGem",9,"Gold Bar","Gold Bars",{specials = CascadePieceSpecials_Gold},"Get"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	
	["SplashTest"] = {
		levelName = "Splash Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["VinesTest"] = {
		levelName = "Vines Test",
		resource = "GameScreen_Land1",		
		--introScript = "Land8_Intro",
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "SinglePoint",
					isPatternSet = false,
					specials = CascadePieceSpecials_Vines,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Vines,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Vine","Vines",{cancelSpecials = CascadePieceSpecials_Vines},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["StoneTest"] = {
		levelName = "Stone Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
			},
		},
		goals = {
			main = {"getGem",12,"Stone","Stones",{specials = CascadePieceSpecials_Crates, skinVariant = "Stone", extraHits = 0,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["BoulderTest"] = {
		levelName = "Boulder Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "OuterRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
				},
			},
		},
		goals = {
			main = {"getGem",22,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["BombTest"] = {
		levelName = "Bomb Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleMissingPattern6",
					isPatternSet = false,

					applyPieceSpecials = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 10,
				},
			},
		},
		goals = {
			main = {"finish", true},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["RecurringBombTest"] = {
		levelName = "Recurring Bomb Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 31,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					turnsToLoss = 11,
					frequencies = {1,2,3,4,5,6,7,8,9,10},
				},
			},
		},
		goals = {
			main = {"finish", true},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["BarrierTest"] = {
		levelName = "Barrier Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BarrierTestHorizontal",
					isPatternSet = false,

					applyBarriersToBottomEdge = true,
				},
				[2] = {
					patternName = "BarrierTestVertical",
					isPatternSet = false,

					applyBarriersToRightEdge = true,
				},
				[3] = {
					patternName = "BarrierTestPattern",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["SteelTest"] = {
		levelName = "Steel Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			hasCrates = true,
			hasStones = true,
			treasureChest = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "SteelTestSteel",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},
				[2] = {
					patternName = "SteelTestStone",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
				},
				[3] = {
					patternName = "SteelTestCrates",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	["GoldTest"] = {
		levelName = "Gold Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins8 = true,
		},
		tricks = World8Tricks,
		boosts = World8Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Grid1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Gold,
					matchFlags = 0,
					applyMatchSizeRequirement = true,
					matchSizeRequirement = 8,
				},
				[2] = {
					patternName = "Grid1_seeds",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Gold,
					matchFlags = 0,
					applyMatchSizeRequirement = true,
					matchSizeRequirement = 12,
				},
			},
		},
		goals = {
			main = {"getGem",9,"Gold Bar","Gold Bars",{specials = CascadePieceSpecials_Gold},"Get"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},
	
	["LavaTest"] = {
		levelName = "Lava Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			largeBoard = true,
			modeSpins8 = true,
		},
		tricks = World10Tricks,
		boosts = World10Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "BigCratePattern4",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
				},
				
			},
		},
		goals = {
			main = {"gemsRemain",0,"Lava","Lava",{specials = CascadePieceSpecials_Lava},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["BarrelSuperwildTest"] = {
		levelName = "Barrel Example 2",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelBurstTest"] = {
		levelName = "Barrel Example 3",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

		["BarrelLavaTest"] = {
		levelName = "Barrel Example 4",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Lava",
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelBoulderTest"] = {
		levelName = "Barrel Example 5",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 1,
					isGemSpawner = false,
				},
				{ 
					name = "Double Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 1,
					applyExtraHits = true,
					extraHits = 1,
					isGemSpawner = false,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelVineTest"] = {
		levelName = "Barrel Example 6",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Vine 1",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Vine 2",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Vine 3",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Vine 4",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelBombsAndVines"] = {
		levelName = "Barrel Example 11",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Vine 1",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Vine 2",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Vine 3",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Vine 4",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{
					name = "Bomb 1",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Bomb 2",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Bomb 3",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Bomb 4",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 5,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},

			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},


	["BarrelTreasureTest"] = {
		levelName = "Barrel Example 7",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{ 
					name = "Treasure",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelJailTest"] = {
		levelName = "Barrel Example 8",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Jail 1",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
				{
					name = "Jail 2",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
				{
					name = "Jail 3",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
				{
					name = "Jail 4",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelBombTest"] = {
		levelName = "Barrel Example 9",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Bomb 1",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 1,
				},
				{
					name = "Bomb 2",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Bomb 3",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 1,
				},
				{
					name = "Bomb 4",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelStoneTest"] = {
		levelName = "Barrel Example 10",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Stone",
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 1,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["BarrelTest"] = {
		levelName = "Barrels of Fun",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 11,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 11,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 11,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 11,
				},
				{
					name = "Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					weight = 11,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 1,
				},
				{
					name = "Lava",
					specials = CascadePieceSpecials_Lava,
					matchFlags = 0,
					weight = 1,
				},
				{ 
					name = "Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 1,
				},
				{ 
					name = "Treasure",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					weight = 1,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Jail",
					specials = CascadePieceSpecials_Jailed,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					cancelSpecials = CascadePieceSpecials_Jailed,
					weight = 1,
				},
				{
					name = "Vine",
					specials = CascadePieceSpecials_Vines,
					cancelSpecials = CascadePieceSpecials_Vines,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 1,
				},
				{
					name = "Bomb",
					specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
					applyTurnsToLoss = true,
					turnsToLoss = 20,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 1,
				},
				{ 
					name = "Double Boulder",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					weight = 1,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					name = "Crate",
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					weight = 1,
				},
				{
					name = "Stone",
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					--extraHits = 2,
					--applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					weight = 1,
				},
			},
			additionalInitialPatterns = { 
				{ --Barrels
					patternName = "StaircaseUp",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},
	
	["HammerTest"] = {
		levelName = "Hammertime",
		resource = "GameScreen_Land1",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = Tricks_Hammer,
		boosts = World9Boosts,
		Properties = {
			additionalInitialPatterns = { 
				{
					patternName = "Line",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				{ 
					patternName = "UpperLine1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				{
					patternName = "TopAndBottomCorners1",
					isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Steel,
					matchFlags = 0,
				},

			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["Land12_Sample"] = {
		levelName = "Placeholder Level",
		resource = "GameScreen_Land1",
		--introScript = "Land12_Intro",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World12Tricks,
		boosts = World12Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StaircaseUp",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

	["MissingReelTest"] = {
		levelName = "Missing Reel Test",
		resource = "GameScreen_Land1",
		--introScript = "Land13_Intro",
		Features = {
			splashMode = true,
			modeSpins8 = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
            useMissingReels = true,
            missingReels = {
				patternName = "MissingCenterReels", 
				isPatternSet = false,
            },
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

	["Land_13_Placeholder"] = {
		levelName = "Placeholder Level",
		resource = "GameScreen_Land1",
		--introScript = "Land13_Intro",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World13Tricks,
		boosts = World13Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "StaircaseUp",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",700000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
	},

	["ColoredBarrelTest"] = {
		levelName = "Barrels of Fun",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Blue Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 8,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
					matchFlags = 31,
					anyOneMatchFlag = true,
				},
			},
		},
		goals = {
			main = {"getGem",30,"Barrel","Barrels",{specials = CascadePieceSpecials_ColorBarrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["WildBarrelTest"] = {
		levelName = "Superwild Barrels",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Green Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Purple Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Red Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Yellow Horizontal",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Blue Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Green Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Purple Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Red Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Yellow Vertical",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 8,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_ColorBarrels,
					isGemSpawner = true,
                    frequencies = {1,1,0,1,0,1,2,2},
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
				},
			},
		},
		goals = {
			main = {"getGem",30,"Barrel","Barrels",{specials = CascadePieceSpecials_ColorBarrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["NamedBarrelTest"] = {
		levelName = "Named Barrel Test",
		resource = "GameScreen_Land12",
		introScript = "Land12_Intro",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Always Superwild",
					{
						name = "Superwild",
						weight = 1,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					},
				},
				[2] = {
					name = "Always Bomb",
					{
						name = "Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "OuterRing_toprightcorner",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"Always Bomb"},
				},
				[2] = {
					patternName = "OuterRing_bottomleftcorner",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Barrels,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnTypes = true,
					spawnTypes = {"Always Superwild"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["MakerTest"] = {
		levelName = "Maker test",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Always Superwild",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Superwild",
						weight = 1,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					},
				},
				[2] = {
					name = "Always Bomb",
					delay = 0,
					events = { --Alternate making 1 and 2 gems every 2 turns.
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 2,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 3,
							newDelay = 2,
							reset = true,
						},
					},
					{
						name = "Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CornerSteel_topLeft_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Bomb"},
				},
				[2] = {
					patternName = "CornerSteel_topRight_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Superwild"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["MakerTest2"] = {
		levelName = "Maker test",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Always Bomb",
					delay = 0,
					{
						name = "Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecial_Valuable + CascadePieceSpecial_CantCover,
						turnsToLoss = 20,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Columns_topmiddlebottom",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Bomb"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["MakerTest7"] = {
		levelName = "Alternating Maker test",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Red Alternator",
					delay = 0,
					shuffle = false,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Blue Alternator",
							reset = true,
						},
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
				[2] = {
					name = "Blue Alternator",
					delay = -1,
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = false,
						},
						[2] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 0,
							targetMix = "Red Alternator",
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CornerSteel_topRight_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Red Alternator","Blue Alternator",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["MakerTest8"] = {
		levelName = "Multi-hit Maker test",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Boulders 3 hits to stop",
					delay = 0,
					shuffle = false,
					cooldowns = {-1,-1,0,0},
					events = {
						--Boulder hit events must be in reverse order, or they'll all execute in one match.
						[1] = { --Third and subsequent boulder hits
							eventType = "getGem",
							newDelay = 1,
							gemType = {
								specials = CascadePieceSpecials_Barrels,
							},
							--Postpone 4, which should only be allowed to run when boulders aren't hit.
							setCooldowns = {
								[4] = 1,
							},
						},
						[2] = { --Second boulder hit
							eventType = "getGem",
							gemType = {
								specials = CascadePieceSpecials_Barrels,
							},
							--Enable third hit. Disable self. Postpone 4.
							setCooldowns = {
								[1] = 0,
								[2] = -1,
								[4] = 1,
							},
						},
						[3] = { --First boulder hit
							eventType = "getGem",
							gemType = {
								specials = CascadePieceSpecials_Barrels,
							},
							--Enable 2. Disable self. Postpone 4.
							setCooldowns = {
								[2] = 0,
								[3] = -1,
								[4] = 1,
							},
						},
						[4] = {  --Reset trigger
							--Boulder hits disable this. If this is hit, a boulder wasn't matched. reset boulder cooldowns and start boulders dropping in.
							eventType = "getGem",
							newDelay = 0,
							gemType = {
							},
							--Enable 1st hit. Disable 2nd. Disable 3rd.
							setCooldowns = {
								[1] = -1,
								[2] = -1,
								[3] = 0,
							},
						},
					},
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "CornerSteel_topRight_inside",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulders 3 hits to stop",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["MakerTest3"] = {
		levelName = "Maker test 3",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Always Crate",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Crates,
						weight = 1,
					},
				},
				[2] = {
					name = "Always Boulder",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Crate",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Row2Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Crate","Always Boulder",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["MakerTest4"] = {
		levelName = "Maker test 4",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Always Blue",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 4,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "MakerTest4_Steel",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
				},
				[2] = {
					patternName = "MakerTest4_Maker",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Blue"},
				},
				[3] = {
					patternName = "MakerTest4_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
				[4] = {
					patternName = "MakerTest4_Blue",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["MakerTest5"] = {
		levelName = "Maker test 5",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Treasure Chest",
					delay = 0,
					events = { --When there are no chests, make 1 chest and then stop
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							reset = true,
						},
						[2] = {
							eventType = "population",
							count = 1,
							comparator = "less",
							newDelay = 1,
							cooldown = 1,
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
						},
					},
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Row2Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Treasure Chest"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["MakerTest6"] = {
		levelName = "Maker test 6",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Boulder Wall",
					delay = 0,
					events = { --Pause for a turn if you match a boulder
						[1] = {
							eventType = "getGem",
							newDelay = 1,
							gemType = {
								specials = CascadePieceSpecials_Barrels,
							},
						},
					},
					{
						name = "Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Row2Center3",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Boulder Wall"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["ColorDuplication"] = {
		levelName = "Color Duplication",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Copy Blue",
					delay = 0,
					events = {
						[1] = { --Turn off this mix any turn that's not my color
							eventType = "getGem",
							newDelay = -1,
							gemType = {
							},
						},
						[2] = { --Turn on this mix any turn that's my color
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece1,
							},
						},
					},
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
				},
				[2] = {
					name = "Copy Green",
					delay = 0,
					events = {
						[1] = { --Turn off this mix any turn that's not my color
							eventType = "getGem",
							newDelay = -1,
							gemType = {
							},
						},
						[2] = { --Turn on this mix any turn that's my color
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece2,
							},
						},
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
				},
				[3] = {
					name = "Copy Red",
					delay = 0,
					events = {
						[1] = { --Turn off this mix any turn that's not my color
							eventType = "getGem",
							newDelay = -1,
							gemType = {
							},
						},
						[2] = { --Turn on this mix any turn that's my color
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece3,
							},
						},
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
				},
				[4] = {
					name = "Copy Purple",
					delay = 0,
					events = {
						[1] = { --Turn off this mix any turn that's not my color
							eventType = "getGem",
							newDelay = -1,
							gemType = {
							},
						},
						[2] = { --Turn on this mix any turn that's my color
							eventType = "getGem",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece4,
							},
						},
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "UpperLine1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Copy Blue","Copy Green","Copy Red","Copy Purple",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["ChestTrap"] = {
		levelName = "Chest Trap",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			largeBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Bomb Maker",
					delay = -1,
					events = {
						[1] = { --Turn on this mix when a treasure chest is matched
							eventType = "getGem",
							newDelay = 0,
							cooldown = 3,
							gemType = {
								specials = CascadePieceSpecials_Treasure,
							},
						},
						[2] = { --First Bomb
							eventType = "emitCount",
							newDelay = 1,
							count = 1,
							reset = false,
						},
						[3] = { --Second Bomb
							eventType = "emitCount",
							newDelay = 1,
							count = 2,
							reset = false,
						},
						[4] = { --Third Bomb turns off the maker
							eventType = "emitCount",
							newDelay = -1,
							count = 3,
							reset = true,
						},
					},
					{
						name = "Blue Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Bombs,
						turnsToLoss = 10,
						weight = 1,
					},
					{
						name = "Red Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Bombs,
						turnsToLoss = 10,
						weight = 1,
					},
					{
						name = "Green Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Bombs,
						turnsToLoss = 10,
						weight = 1,
					},
					{
						name = "Purple Bomb",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Bombs,
						turnsToLoss = 10,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "Short_Help_Match_2_Color_1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Bomb Maker",},
				},
				[2] = {
					patternName = "TopRow4",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
					applyMatchFlags = true,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["Always4Orange"] = {
		levelName = "Always 4 Orange",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Add 4 Orange",
					delay = -1,
					events = {
						[1] = { --When there's no oranges, start making.
							eventType = "population",
							count = 0,
							comparator = "equals",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece6,
							},
						},
						[2] = { --Stop when you've made 4.
							eventType = "emitCount",
							count = 4,
							newDelay = -1,
						},
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[2] = {
					name = "Add 3 Orange",
					delay = -1,
					events = {
						[1] = { --When there's no oranges, start making.
							eventType = "population",
							count = 1,
							comparator = "equals",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece6,
							},
						},
						[2] = { --Stop when you've made 3.
							eventType = "emitCount",
							count = 3,
							newDelay = -1,
						},
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[3] = {
					name = "Add 2 Orange",
					delay = -1,
					events = {
						[1] = { --When there's no oranges, start making.
							eventType = "population",
							count = 2,
							comparator = "equals",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece6,
							},
						},
						[2] = { --Stop when you've made 3.
							eventType = "emitCount",
							count = 2,
							newDelay = -1,
						},
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[4] = {
					name = "Add 1 Orange",
					delay = -1,
					events = {
						[1] = { --When there's no oranges, start making.
							eventType = "population",
							count = 3,
							comparator = "equals",
							newDelay = 0,
							gemType = {
								matchFlags = CascadeMatchFlags_CommonPiece6,
							},
						},
						[2] = { --Stop when you've made 3.
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
					},
					{
						name = "Orange",
						matchFlags = CascadeMatchFlags_CommonPiece6,
						weight = 1,
					},
				},
				[5] = {
					name = "Normal 4 color mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "UpperLine1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Add 4 Orange","Add 3 Orange","Add 2 Orange","Add 1 Orange","Normal 4 color mix",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},
	["Morphing Maker"] = {
		levelName = "Morphing Maker",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Red Mix",
					delay = 0,
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
					},
				},
				[2] = {
					name = "Blue Mix",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
				},
				[3] = {
					name = "Make Red Maker",
					delay = 0,
					{
						name = "Red Maker",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Make Blue Maker",},
						spawnBelowTypes = {"Red Mix",},
						weight = 1,
					},
				},
				[4] = {
					name = "Make Blue Maker",
					delay = 0,
					{
						name = "Blue Maker",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Make Red Maker",},
						spawnBelowTypes = {"Blue Mix",},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "UpperLine1",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					applySpawnTypes = true,
					spawnTypes = {"Make Red Maker",},
					spawnBelowTypes = {"Blue Mix",},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",300000},
				[2] = {"score",500000},
				[3] = {"score",700000},
			},
		},
	},

	["MultiJailTest"] = {
		levelName = "Multi-Hit Jails",					
		resource = "GameScreen_Land16",
		Features = {
			hasJailedSquares = true,
			modeSpins6 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
		},
		tricks = World4Tricks,
		boosts = World4Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleBottom2",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},
		goals = {
			main = {"getGem",12,"Jail","Jails",{specials = CascadePieceSpecials_Jailed, extraHits = 0},"Break"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

    ["DoubleJailTest"] = {
		levelName = "Double Jail Test",
		resource = "GameScreen_Land20",
		Features = {
			splashMode = true,
			modeSpins10 = true,
			largeBoard = true,
			gemTypes5 = true,
			hasBarrelsOfFun = true,
            hasJailedSquares = true,
		},
		tricks = World20Tricks,
		boosts = World20Boosts,
		Properties = {
            spawnGemOnBreak = {
                {
                    name = "Jail Horiz 1",
                    specials = CascadePieceSpecials_Jailed + CascadePieceSpecial_HorizontalSplash,
                    matchFlags = CascadeMatchFlags_CommonPiece1,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyExtraHits = true,
                    extraHits = 1,
                    weight = 2,
                },
			},
            additionalInitialPatterns = {
                {
                    patternName = "PrisonersDualemma_Clouds",
                    isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
                },
                {
                    patternName = "JailedBurst Test Jail",
                    isPatternSet = false,
					
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyExtraHits = true,
					extraHits = 1,
                },
                {
                    patternName = "JailedBurst Test AreaBurst",
                    isPatternSet = false,
					
					specials = CascadePieceSpecial_AreaSplash,
					applyPieceSpecials = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
                },
                {
                    patternName = "JailedBurst Test Connector",
                    isPatternSet = false,
					
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
                },
                {
                    patternName = "JailedBurst Test VerticalBurst",
                    isPatternSet = false,
					
					specials = CascadePieceSpecial_VerticalSplash,
					applyPieceSpecials = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyMatchFlags = true,
                },
            },

		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",400000},
			},
		},
	},

	["PatternMatcher"] = {
		levelName = "Pattern Matcher",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			hasCoverage = true,
		},
		Properties = {
			additionalInitialPatterns = { --Most cells require 1 match to uncover
				[1] = {
					patternName = "OuterRing",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",300000},
			},
		},
	},

	["TwoLines"] = {
		levelName = "Two Lines",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			hasCoverage = true,
			gemTypes6 = true,
		},
		Properties = {
			additionalInitialPatterns = { --Most cells require 1 match to uncover
				[1] = {
					patternName = "LittleCratePattern7",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",150000},
				[3] = {"score",300000},
			},
		},
	},
	["Crates!"] = {
		levelName = "Crates!",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			hasCrates = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "InnerHole", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleCratePattern1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true,},	
			stars = {
				[1] = {"score", 100000},
				[2] = {"score", 125000},
				[3] = {"score", 150000}, --SimData[1]["AverageTreasuresFound"]
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},
	["CratePattern"] = {
		levelName = "Crate Pattern",					
		resource = "GameScreen_Land1",		
		Features = {
			hasCrates = true,
			hasCoverage = true,
			modeSpins8 = true,
		},
		Properties = {
			useMissingSquares = true,
			additionalInitialPatterns = {
				[1] = {
					patternName = "MiddleRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "InnerRing",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
				[3] = {
					patternName = "MiddleRing",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},	
			stars = {
				[1] = {"score", 100000},
				[2] = {"score", 125000},
				[3] = {"score", 150000}, --SimData[1]["AverageTreasuresFound"]
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},

	["GemJail"] = {
		levelName = "Gem Jail",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			hasJailedSquares = true,
		},
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleCratePattern1",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"getGem",18,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",300000}, --SimData[1]["AverageTreasuresFound"]
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},
	["CrateJump"] = {
		levelName = "Crate Jump",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			largeBoard = true,
			gemTypes6 = true,
			--coverage = true,
			hasCrates = true,
		},
		Properties = {
			useMissingSquares = true,
			missingSquares = {
				patternName = "BigCratePattern8", 
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "BigCratePattern9",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[2] = {
					patternName = "BigCratePattern10",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"finish",true,},	
			stars = {
				[1] = {"score",100000},
				[2] = {"score",150000},
				[3] = {"score",200000}, --SimData[1]["AverageTreasuresFound"]
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},
	["Temple"] = {
		levelName = "Temple",					
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			largeBoard = true,
			gemTypes6 = true,
			hasCoverage = true,
		},
		Properties = {
			additionalInitialPatterns = { --Most cells require 1 match to uncover
				[1] = {
					patternName = "BigCoverage1",
					isPatternSet = false,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},

		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",200000},
				[2] = {"score",300000},
				[3] = {"score",400000}, --SimData[1]["AverageTreasuresFound"]
			},
		},
		expectedScore = 100000, --Uncomment to override expected high score calculations.
	},
	["LetMeOut"] = {
		levelName =  "Let Me Out",
		resource = "GameScreen_Land1",		
		Features = {
			hasCrates = true,
			hasCoverage = true,
			hasJailedSquares = true,
			modeSpins8 = true,
			gemTypes6 = true,
		},
		Properties = {
			additionalInitialPatterns = { --Three patterns apply specific gems here.
				[1] = { --Outer ring of Blue
					patternName = "OuterRing_top",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[2] = { --Middle ring of green
					patternName = "MiddleRing_top",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = { --Inner ring of crates
					patternName = "InnerRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
				[4] = { --Outer ring of Blue
					patternName = "OuterRing_bottom",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
				},
				[5] = { --Middle ring of green
					patternName = "MiddleRing_bottom",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece5,
				},
				[6] = { --Middle ring of green
					patternName = "Ring_middle",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
				},
				[7] = {
					patternName = "MiddleRing",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
				[8] = { --Inner ring of coverage
					patternName = "InnerRing",
					isPatternSet = false,
					matchRequirement = 3,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",50000},
				[2] = {"score",80000},
				[3] = {"score",100000},
			},
		},
		expectedScore = 100000,
	},
	["CustomColors"] = {
		levelName =  "Custom Colors",
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			hasCrates = true,
		},
		Properties = {
			additionalInitialPatterns = { --Three patterns apply specific gems here.
				[1] = { --Outer ring of Blue
					patternName = "OuterRing",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
				[2] = { --Middle ring of green
					patternName = "MiddleRing",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = { --Inner ring of crates
					patternName = "InnerRing",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
				},
			},
		},
		goals = {
			main = {"multiplier",5,},
			stars = {
				[1] = {"score",800000},
				[2] = {"score",1000000},
				[3] = {"score",1500000},
			},
		},
		expectedScore = 100000,
	},

	["Escape!"] = {
		levelName = "Escape!",
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			hasJailedSquares = true,
		},
		Properties = { 
			useMissingSquares = true,
			missingSquares = {
				patternName = "InnerRing",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LittleCratePattern7",
					isPatternSet = false,
					applyMatchFlags = false,
					specials = CascadePieceSpecials_Jailed,
					applyPieceSpecials = true,
					cancelSpecials = CascadePieceSpecials_Jailed,
					applyCancelSpecials = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",40000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000,
	},
	["Some1Some4"] = {
		levelName = "Some 1 Some 4",
		resource = "GameScreen_Land1",		
		--outtroScript = "Land8_Outtro",
		Features = {
			modeSpins13 = true,
			hasCoverage = true,
		},
		Properties = {
			additionalInitialPatterns = { --Most cells require 1 match to uncover
				[1] = {
					patternName = "LittleCoverage1",
					isPatternSet = false,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[2] = { --But some require 4 matches to uncover.
					patternName = "MiddleRing",
					isPatternSet = false,
					matchRequirement = 4,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",250000},
				[3] = {"score",500000},
			},
		},
		expectedScore = 100000,
	},
	["CrateFall"] = {
		levelName = "Crate Fall",
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			hasCrates = true,
		},
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecials_Crates,
                    frequencies = {1,1,1,1,1,1,},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["TreasureChestOld"] = {
		levelName = "Treasure Chest",
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
		},
		Properties = {
			additionalRegularPlacements = {
				[1] = {
					matchFlags = 0,
                    specials = CascadePieceSpecial_MatchAtBottom,
                    frequencies = {1,},
				}
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",500000},
				[2] = {"score",600000},
				[3] = {"score",700000},
			},
		},
		expectedScore = 100000,
	},

	["TreasureChest"] = {
		levelName = "Treasure Chest",
		resource = "GameScreen_Land1",		
		Features = {
			modeSpins13 = true,
			treasureChest = true,
		},
		Properties = {
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
		expectedScore = 100000,
	},

	["TripleStone"] = {
		levelName = "Rock and Roll",					
		resource = "GameScreen_Land1",		
		--introScript = "Land2_Tip1",
		--onlyShowCutsceneOnce = true,
		Features = {
			splashMode = true,
			modeSpins8 = true,
			hasCoverage = true,
			hasCrates = true,
			hasStones = true,
			regularBoard = true,
			gemTypes5 = true,
		},
		tricks = World2Tricks,
		boosts = World2Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "OuterRing_sides",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					matchRequirement = 1,
					applyMatchRequirement = true,
				},
				[2] = {
					patternName = "Line1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Stone,
					matchFlags = 0,
					extraHits = 2,
					applyExtraHits = true,
					skinVariant = "Stone",
					applySkinVariant = true,
					matchRequirement = 2,
					applyMatchRequirement = true,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",150000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["BarrelBurstsAndCrates"] = {
		levelName = "Barrel Example 12",
		resource = "GameScreen_Land12",
		Features = {
			splashMode = true,
			modeSpins7 = true,
			regularBoard = true,
			gemTypes4 = true,
			hasBarrelsOfFun = true,
		},
		tricks = World9Tricks,
		boosts = World9Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Crate",
					specials = CascadePieceSpecials_Crates,
					matchFlags = 0,
					weight = 12,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Horizontal Splash",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_HorizontalSplash,
					weight = 1,
				},
				{
					name = "Vertical Splash",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_VerticalSplash,
					weight = 1,
				},
				{
					name = "Area Splash",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					anyOneMatchFlag = true,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
			},
			additionalRegularPlacements = {
				[1] = {
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					isGemSpawner = true,
                    frequencies = {1,0,0,1,0,0,1,0,0,1},
				},
			},
		},
		goals = {
			main = {"getGem",20,"Barrel","Barrels",{specials = CascadePieceSpecials_Barrels, isGemSpawner = true},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",300000},
				[3] = {"score",500000},
			},
		},
	},

	["GiftBoxTest"] = {
		levelName = "Gift Boxes",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins6 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			spawnGemOnBreak = 
			{
				{
					name = "Blue Area",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Green Area",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Purple Area",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Red Area",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Yellow Area",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecial_AreaSplash,
					weight = 1,
				},
				{
					name = "Super Wild",
					matchFlags = CascadeMatchFlags_Wildcard,
					specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					weight = 8,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Line1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
				},
				[2] = {
					patternName = "Line2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyExtraHits = true,
					extraHits = 1,
				},
				[3] = {
					patternName = "Line3",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					applyExtraHits = true,
					extraHits = 2,
				},
			},
		},
		goals = {
			main = {"getGem",18,"Gift","Gifts",{specials = CascadePieceSpecials_Stone, isGemSpawner = true, extraHits = 0},},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["BurstTest"] = {
		levelName = "Super Wall",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasGiftBoxes = true,
			hasCoverage = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Make 2-hit",
					delay = 0,
					{
						name = "Gift Box",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Make 1-hit",},
						extraHits = 1,
						weight = 1,
					},
				},
				[2] = {
					name = "Make 1-hit",
					delay = 0,
					{
						name = "Gift Box",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						spawnTypes = {"Make Stone",},
						extraHits = 0,
						weight = 1,
					},
				},
				[3] = {
					name = "Make Stone",
					delay = 0,
					{
						name = "Stone",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Stone",
						extraHits = 2,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "CrateBottomBlock2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Make 2-hit",},
					applyMatchRequirement = true,
					matchRequirement = 2,
					applyExtraHits = true,
					extraHits = 2,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
				[2] = {
					patternName = "Bug_TestPattern2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
				},
				[3] = {
					patternName = "Bug_TestPattern1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
				},
			},
		},
		goals = {
			main = {"patterns",0,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["PortalTest"] = {
		levelName = "Portal Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			treasureChest = true,
			hasPortals = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			portals = {
				[1] = {{2,3},{3,2},"PortalEntrance_1","PortalExit_1"},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Always Superwild",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Superwild",
						weight = 1,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "DoubleQuarantine_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Superwild"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
	["PortalTest2"] = {
		levelName = "Portal Test 2",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			treasureChest = true,
			hasPortals = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			portals = {
				[1] = {{0,0},{3,2},"PortalEntrance_1","PortalExit_1"},
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "AmberBombsB1", 
				isPatternSet = false,
			},
			additionalNamedMixes = {
				[1] = {
					name = "Always Superwild",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 1,
							reset = true,
						},
					},
					{
						name = "Superwild",
						weight = 1,
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "DoubleQuarantine_Lava",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchFlags = true,
					matchFlags = 0,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Always Superwild"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
	["PortalTest3"] = {
		levelName = "Portal Test 3",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			treasureChest = true,
			hasPortals = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			portals = {
				[1] = {{0,7},{4,0},"",""},
				[2] = {{1,7},{5,0},"PortalEntrance_1_Wide","PortalExit_1_Wide"},
				[3] = {{2,7},{6,0},"",""},
			},
			useMissingReels = true,
			missingReels = {
				patternName = "TowerToTheClouds_Reels", 
				isPatternSet = false,
			},
			useMissingSquares = true,
			missingSquares = {
				patternName = "VerticalStripeCenterLarge", 
				isPatternSet = false,
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["LaserTestLevel"] = {
		levelName = "Lasers Pew Pew Pew!",
		resource = "GameScreen_Land24",	
		Features = {
			regularBoard = true, 
			modeSpins3 = true, 
			splashMode = true,
			gemTypes4 = true, 
		},
		tricks = World25Tricks,
		boosts = World25Boosts,
		Properties = {
			useMissingReels = true,
            missingReels = {
				patternName = "ReelPosition1", 
				isPatternSet = false,
            },
			additionalNamedMixes = {
				[1] = {
					name = "LaserH",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
						spawnTypes = {"LaserH",},
						weight = 1,
					},
				},
				[2] = {
					name = "LaserV",
					delay = 0,
					{
						name = "Laser",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
						spawnTypes = {"LaserV",},
						weight = 1,
					},
				},
			},
			endGameProperties = {
				additionalNamedMixes = {
					[1] = {
						name = "LaserH",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							weight = 1,
							skinVariant = "LaserH",
						},
					},
					[2] = {
						name = "LaserV",
						delay = 0,
						{
							name = "Laser",
							matchFlags = CascadeMatchFlags_CommonPiece4,
							specials = CascadePieceSpecials_Laser,
							weight = 1,
							skinVariant = "LaserV",
						},
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "PatternVille_1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_HorizontalSplash,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserH",},
				},
				{
					patternName = "Row7Evens_large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Laser | CascadePieceSpecial_VerticalSplash,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece4,
					applyIsGemSpawner = true,
					isGemSpawner = true,
					spawnTypes = {"LaserV",},
				},
			},
		},		
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",75000},
				[3] = {"score",125000},
			},
		},
	},

	["IceTest"] = {
		levelName = "Ice Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasIce = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			boardPieceMix = {
				{
					name = "Blue",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 10,
				},
				{
					name = "Green",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 10,
				},
				{
					name = "Purple",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 10,
				},
				{
					name = "Red",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 10,
				},
				{
					name = "Yellow",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 10,
				},
				{
					name = "Blue Bomb",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					turnsToLoss = 15,
					weight = 1,
				},
				{
					name = "Green Bomb",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					turnsToLoss = 15,
					weight = 1,
				},
				{
					name = "Purple Bomb",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					turnsToLoss = 15,
					weight = 1,
				},
				{
					name = "Red Bomb",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecial_CantCover + CascadePieceSpecial_Valuable,
					turnsToLoss = 15,
					weight = 1,
				},
				{
					name = "Boulder Bomb",
					matchFlags = 0,
					specials = CascadePieceSpecials_Barrels,
					turnsToLoss = 10,
					weight = 2,
				},
				{
					name = "Chest Bomb",
					matchFlags = 0,
					specials = CascadePieceSpecials_Treasure,
					turnsToLoss = 30,
					weight = 1,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "Ledge1_row2",
					isPatternSet = false,
					applySpreadSpecials = true,
					spreadSpecials = CascadePieceSpecials_Ice,
				},
				[2] = {
					patternName = "Ledge1_row3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	
	["MakerPortalTest1"] = {
		--Makers that make through a portal. 
		--Test that the thing that comes out sometimes comes out one side and sometimes the other.
		levelName = "Maker Portal Test 1",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Make One Boulder",
					delay = 0,
					{
						name = "Boulder 1",
						weight = 1,
						matchFlags = 0,
						specials = CascadePieceSpecials_Barrels,
					},
					events = {
						{
							eventType = "emitCount",
							count = 2,
							reset = true,
							newDelay = 1,
						}
					},
				},
			},
			portals = {
				[1] = {{3,6},{1,5},"PortalEntrance_1","PortalExit_1"},
				[2] = {{3,7},{5,5},"PortalEntrance_1","PortalExit_1"},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "MakerPortalTest1_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				[2] = {
					patternName = "MakerPortalTest1_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make One Boulder"},
				},
				[3] = {
					patternName = "MakerPortalTest1_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["MakerPortalTest2"] = {
		--Test that makers know to stop making when a FallUp is emitted, just like Don'tMoveDown, and don't shuffle FallUp pieces in a way that leads to desynchronization
		levelName = "Maker Portal Test 2",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Half Balloons",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Not-a-Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "MakerPortalTest2_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				[2] = {
					patternName = "MakerPortalTest2_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Half Balloons"},
				},
				[3] = {
					patternName = "MakerPortalTest2_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},


	["MakerPortalTest3"] = {
		--Test that makers count space upwards if they make upwards.
		levelName = "Maker Portal Test 3",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Make Balloons Slowly",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
					},
					events = {
						{
							eventType = "emitCount",
							count = 2,
							reset = true,
							newDelay = 1,
						},
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "MakerPortalTest3_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				[2] = {
					patternName = "MakerPortalTest3_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Balloons Slowly"},
				},
				[3] = {
					patternName = "MakerPortalTest3_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["MakerPortalTest4"] = {
		--Test that makers know to stop making when a non-FallUp is emitted if they make upwards
		levelName = "Maker Portal Test 4",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Half Balloons",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
					},
					{
						name = "Not-a-Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "MakerPortalTest4_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				[2] = {
					patternName = "MakerPortalTest4_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Half Balloons"},
				},
				[3] = {
					patternName = "MakerPortalTest4_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	
	["MakerPortalTest5"] = {
		--Test that upward makers also respect portals
		--Test that the thing that comes out sometimes comes out one side and sometimes the other.
		levelName = "Maker Portal Test 5",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Make One Boulder",
					delay = 0,
					{
						name = "Balloon 1",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Balloon,
					},
					events = {
						{
							eventType = "emitCount",
							count = 2,
							reset = true,
							newDelay = 1,
						}
					},
				},
			},
			portals = {
				[1] = {{1,3},{3,3},"PortalEntrance_1","PortalExit_1"},
				[2] = {{5,3},{3,2},"PortalEntrance_1","PortalExit_1"},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "MakerPortalTest5_Steel",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
				},
				[2] = {
					patternName = "MakerPortalTest5_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_FlippedMaker,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make One Boulder"},
				},
				[3] = {
					patternName = "MakerPortalTest5_Clear",
					isPatternSet = false,
					clearPieces = true,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	
	["SteelGlassTest"] = {
		levelName = "SteelGlass Test 1",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasSteelGlass = true,
			hasChests = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "SteelGlassTest_SteelGlass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "SteelGlassTest_Treasure",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
			},
		},
		goals = {
			main = {"getGem",3,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	
	["SteelGlassTest2"] = {
		levelName = "SteelGlass Test 2",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
			hasSteelGlass = true,
			hasChests = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			useSteelGlass = true,
			steelGlass = {
				patternName = "SteelGlassTest_SteelGlass",
				isPatternSet = false,
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "SteelGlassTest_SteelGlass",
					isPatternSet = false,
					applyMatchRequirement = true,
					matchRequirement = 1,
				},
			},
		},
		goals = {
			main = {"patterns",0},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["PermanentSwitchTest"] = {
		levelName = "Permanent Switch Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On",
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker Icon Off",
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "Switch1_On",
						weight = 1,
					},
				},
				[2] = {
					name = "Make 1 Treasure",
					delay = -1,
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
							patterns = {"Set Maker Icon Off"},
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "Switch1_On",
							},
						}
					}
				}
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "PermanentSwitchTest_Stones",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
				},
				[2] = {
					patternName = "PermanentSwitchTest_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn"},
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On"},
				},
				[3] = {
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make 1 Treasure"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
		},
		goals = {
			main = {"getGem",1,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop",},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["TemporarySwitchTest"] = {
		levelName = "Temporary Switch Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On",
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker Icon Off",
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_On",
						spawnTypes = {"TurnOff"},
						matchPatterns = {"Set Maker Icon Off"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff",
					delay = 0,
					{
						name = "Switch_Off",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Off",
						spawnTypes = {"TurnOn"},
						matchPatterns = {"Set Maker Icon On"},
						weight = 1,
					},
				},
				[3] = {
					name = "Make Blue",
					delay = 0,
					{
						name = "Treasure",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "Switch1_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "Switch1_On",
							},
						},
					}
				}
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "PermanentSwitchTest_Stones",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
				},
				[2] = {
					patternName = "PermanentSwitchTest_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn"},
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On"},
				},
				[3] = {
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Blue",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["ColoredTemporarySwitchTest"] = {
		levelName = "Colored Temporary Switch Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On",
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker Icon Off",
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Jailed,
						skinVariant = "ColoredSwitch_1",
						icon = "Icon_Switch_On",
						spawnTypes = {"TurnOff"},
						matchPatterns = {"Set Maker Icon Off"},
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOff",
					delay = 0,
					{
						name = "Switch_Off",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Jailed,
						skinVariant = "ColoredSwitch_1",
						icon = "Icon_Switch_Off",
						spawnTypes = {"TurnOn"},
						matchPatterns = {"Set Maker Icon On"},
						weight = 1,
					},
				},
				[3] = {
					name = "Make Blue",
					delay = 0,
					{
						name = "Treasure",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "population",
							count = 1,
							newDelay = -1,
							comparator = "less",
							gemType = {
								skinVariant = "ColoredSwitch_1",
								icon = "Icon_Switch_On",
							},
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							comparator = "greater",
							gemType = {
								skinVariant = "ColoredSwitch_1",
								icon = "Icon_Switch_On",
							},
						},
					}
				}
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "PermanentSwitchTest_Switch",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Jailed,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn"},
					applySkinVariant = true,
					skinVariant = "ColoredSwitch_1",
					applyIcon = true,
					icon = "Icon_Switch_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On"},
				},
				[2] = {
					patternName = "PermanentSwitchTest_Maker",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Blue",},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["MultiSwitchTest"] = {
		levelName = "Multi Switch Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Set Maker Icon On 1",
					patternName = "MultiSwitchTest_Maker1",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				},
				[2] = {
					entryName = "Set Maker Icon On 2",
					patternName = "MultiSwitchTest_Maker2",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Maker_On",
				}
			},
			additionalNamedMixes = {
				[1] = {
					name = "TurnOn1",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "Switch1_On",
						weight = 1,
					},
				},
				[2] = {
					name = "TurnOn2",
					delay = 0,
					{
						name = "Switch_On",
						matchFlags = 0,
						specials = CascadePieceSpecials_Steel,
						skinVariant = "Switch2_On",
						weight = 1,
					},
				},
				[3] = {
					name = "Make Treasure 1",
					delay = -1,
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "Switch1_On",
							},
						}
					}
				},
				[4] = {
					name = "Make Treasure 2",
					delay = -1,
					{
						name = "Treasure",
						matchFlags = 0,
						specials = CascadePieceSpecials_Treasure,
						weight = 1,
					},
					events = {
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = -1,
						},
						[2] = {
							eventType = "population",
							count = 0,
							newDelay = 0,
							cooldown = -1,
							comparator = "greater",
							gemType = {
								skinVariant = "Switch2_On",
							},
						},
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "MultiSwitchTest_Stones",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applySkinVariant = true,
					skinVariant = "Stone",
					applyExtraHits = true,
					extraHits = 2,
				},
				[2] = {
					patternName = "MultiSwitchTest_Switch1",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn1"},
					applySkinVariant = true,
					skinVariant = "Switch1_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 1"},
				},
				[3] = {
					patternName = "MultiSwitchTest_Switch2",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"TurnOn2"},
					applySkinVariant = true,
					skinVariant = "Switch2_Off",
					applyMatchPatterns = true,
					matchPatterns = {"Set Maker Icon On 2"},
				},
				[4] = {
					patternName = "MultiSwitchTest_Maker1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Treasure 1"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
				[5] = {
					patternName = "MultiSwitchTest_Maker2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Make Treasure 2"},
					applyIcon = true,
					icon = "Icon_Maker_Off",
				},
			},
		},
		goals = {
			main = {"getGem",2,"Chest","Chests",{specials = CascadePieceSpecials_Treasure,},"Drop",},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["HammerBurstTest"] = {
		levelName = "Hammer Burst Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "Columns_middle",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
    --START ROH TEST LEVELS --
    ["RohTest01"] = {
        --Testing basic features, implementing a pattern, etc
        levelName = "The Letter R",
        resource = "GameScreen_Land1",  
        Features = {
            largeBoard = true,
            modeSpins4 = true, 
            splashMode = true,
            gemTypes6 = true,
            treasureChest = true,
            hasChests = true,
        },
        tricks = World1Tricks,
        boosts = World4Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "Letter_R", 
                isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
                patternName = "EdgeReels_Large", 
                isPatternSet = false,
            },
        },      
        goals = {
            main = {"finish",true,},
            stars = {
                [1] = {"score",24123},
                [2] = {"score",72268},
                [3] = {"score",121999},
            },
        },
    },
    ["RohTest02"] = {
        --Testing additionalInitialPatterns, additionalRegularPlacements, addToBoardPieceMix
        levelName = "Scatterbrained",
        resource = "GameScreen_Land1",  
        Features = {
            largeBoard = true,
            modeSpins6 = true, 
            splashMode = true,
            gemTypes5 = true,
            
        },
        tricks = World1Tricks,
        boosts = World4Boosts,
        Properties = {
            additionalInitialPatterns = {
                [1] = {
                    patternName = "Row3Vee",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Crates,
                    applyMatchFlags = true,
                    matchFlags = 0,
                },
                [2] = {
                    patternName = "Row4Center",
                    isPatternSet = false,
                    specials = CascadePieceSpecials_Vines,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Vines,
                    applyCancelSpecials = true,
                },
                [3] = {
                    patternName = "LowerCorners",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Lock,
                    applyMatchFlags = true,
                    matchFlags = 0,

                },
                [4] = {
                    patternName = "Scatter3",
                    isPatternSet = false,
                    applyGemEater = true,
                    gemEater = true,
                },
                [5] = {
                    patternName = "FenceTube_bottom",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    specials = CascadePieceSpecials_Balloon,
                    applyCancelSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Balloon,
                },
            },

            additionalRegularPlacements = {
                [1] = {
                    matchFlags = CascadeMatchFlags_Wildcard,
                    specials = CascadePieceSpecial_ClearKeyColorOnMatch,
                    frequencies = {1,3,5,7,9},
                },
            },

            addToBoardPieceMix = {
                {
                    name = "Orange",
                    matchFlags = CascadeMatchFlags_CommonPiece6,
                    weight = 10,  
                },
            },
        },      
        goals = {
            main = {"finish",true,},
            stars = {
                [1] = {"score",25000},
                [2] = {"score",75000},
                [3] = {"score",150000},
            },
        },
    },
    ["RohTest03"] = {
        --Testing goals - gemRemain
        levelName = "Avalanche",
        resource = "GameScreen_Land2",  
        Features = {
            modeSpins4 = true, 
            splashMode = true,
            gemTypes5 = true,

            treasureChest = true,
            hasChests = true,
        },
        tricks = World1Tricks,
        boosts = World4Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "BigCastle2_door", 
                isPatternSet = false,
            },
        },      
        goals = {
            main = {"getGem",3,"Chest","Chests",{specials=CascadePieceSpecials_Treasure,},"Drop"},
            stars = {
                [1] = {"score",25000},
                [2] = {"score",75000},
                [3] = {"score",150000},
            },
        },
    },
    ["RohTest04"] = {
        levelName = "Trench Run_ORIGINAL",               
        resource = "GameScreen_Land2",
        Features = {
            modeSpins6 = true,
            splashMode = true,
            largeBoard = true,
            hasMissingSquares = true,
            gemTypes4 = true,
            hasCrates = true,
        },
        tricks = World2Tricks,
        boosts = World2Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "Trench01", 
                isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
                patternName = "MissingLargeSideReels", 
                isPatternSet = false,
            },
            additionalInitialPatterns =
            {
                {
                    patternName = "StuckBalloons_makers",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 1,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                    applyMatchRequirement = true,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Stone","Stones",{specials = CascadePieceSpecials_Stone,},"Break"},
            stars = {
                [1] = {"score",300000},
                [2] = {"score",500000},
                [3] = {"score",1000000},
            },
        },
    },
    ["RohTest05"] = {
        levelName = "Double Team",                    
        resource = "GameScreen_Land2",  
        Features = {
            largeBoard = true,
            modeSpins6 = true,
            splashMode = true,
            hasMissingSquares = true,
            gemTypes4 = true,
            hasBarrels = true,
        },
        tricks = World2Tricks,
        boosts = World2Boosts,
        Properties = {
            useMissingSquares = true,
            missingSquares = {
                patternName = "Columns_LargeMiddle2", 
                isPatternSet = false,
            },
            useMissingReels = true,
            missingReels = {
                patternName = "MissingMiddleLargeReels", 
                isPatternSet = false,
            },
            additionalInitialPatterns =
            {
                {
                    patternName = "Column_LargeMiddle",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Barrels,
                    matchFlags = 0,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Boulder","Boulders",{specials = CascadePieceSpecials_Barrels,},"Break"},
            stars = {
                [1] = {"score",400000},
                [2] = {"score",600000},
                [3] = {"score",1000000},
            },
        },
    },

    ["RohTest07"] = {
        --CONCEPT: Drop chests through a board of scattered stones
        levelName = "Stone Garden",--Scatter Plot, Mine field
        resource = "GameScreen_Land3",      
        Features = {
            splashMode = true,
            modeSpins9 = true,
            largeBoard = true,
            gemTypes5 = true,
            treasureChest = true,
        },
        tricks = World3Tricks,
        boosts = World3Boosts,
        Properties = {
            additionalInitialPatterns = {
                [1] = {
                    -- patternName = "Scatter_RockGarden3",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 1,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                },
                -- [2] = {
                --     patternName = "Scatter_RockGarden2",
                --     isPatternSet = false,
                --     applyPieceSpecials = true,
                --     applyMatchFlags = true,
                --     specials = CascadePieceSpecials_Barrels,
                --     matchFlags = 0,
                -- },
            },
        },
        goals = {
            main = {"getGem",4,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
            stars = {
                [1] = {"score",200000},
                [2] = {"score",400000},
                [3] = {"score",600000},
            },
        },
        expectedScore = 100000,
    },

    ["RohTest09"] = {
        levelName = "Solitary Confinement",                    
        resource = "GameScreen_Land4",     
        Features = {
            modeSpins3 = true,
            splashMode = true,
            gemTypes5 = true,
            largeBoard = true,

            hasJailedSquares = true,
            hasCrates = true,
            hasBarrels = true,
            hasStones = true,
        },
        tricks = World4Tricks,
        boosts = World4Boosts,
        Properties = {
            additionalInitialPatterns = {
                [1] = {
                    patternName = "Single_8-4",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    specials = CascadePieceSpecials_Jailed,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyCancelSpecials = true,
                },
                [2] = {
                    patternName = "BottomSpikes",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Crates,
                    matchFlags = 0,
                },
                [3] = {
                    patternName = "InvertedTetris_Bottom1",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Stone,
                    matchFlags = 0,
                    extraHits = 1,
                    applyExtraHits = true,
                    skinVariant = "Stone",
                    applySkinVariant = true,
                    applyMatchRequirement = true,
                },
                [4] = {
                    patternName = "Single_4-4",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    specials = CascadePieceSpecials_Barrels,
                    matchFlags = 0,
                },
            },
        },
        goals = {
            main = {"getGem",1,"Jail","Jails",{specials = CascadePieceSpecials_Jailed,},"Break"},
            stars = {
                [1] = {"score",25000},
                [2] = {"score",50000},
                [3] = {"score",75000},
            },
        },
        expectedScore = 100000, --Uncomment to override expected high score calculations.
    },

    ["RohTest11"] = {
        --Land 4 side level concept (riffing on 49-"Meters")
        levelName = "Prison Towers",                   
        resource = "GameScreen_Land4",  
        Features = {
            modeSpins6 = true,
            splashMode = true,
            largeBoard = true,
            gemTypes5 = true,
            
            hasJailedSquares = true,
            hasCrates = true,
            hasChests = true,
        },
        tricks = World4Tricks,
        boosts = World4Boosts,
        Properties = {
            missingSquares = {
                patternName = "TopBottomSpots1", 
                isPatternSet = false,
            },

            additionalInitialPatterns = {
                [1] = {
                    patternName = "Poles3_large",
                    isPatternSet = false,
                    applyMatchFlags = false,
                    specials = CascadePieceSpecials_Jailed,
                    applyPieceSpecials = true,
                    cancelSpecials = CascadePieceSpecials_Jailed,
                    applyCancelSpecials = true,
                },
                [2] = {
                    patternName = "Poles3tops_large",
                    isPatternSet = false,
                    applyPieceSpecials = true,
                    applyMatchFlags = true,
                    matchFlags = 0,
                    specials = CascadePieceSpecials_Treasure,
                },
            },
        },
        goals = {
            main = {"gemsRemain",0,"Chest","Chests",{specials = CascadePieceSpecials_Treasure},"Drop"},
            stars = {
                [1] = {"score",150000},
                [2] = {"score",300000},
                [3] = {"score",600000},
            },
        },
        expectedScore = 100000, --Uncomment to override expected high score calculations.
    },
    -- END ROH TEST LEVELS --

	["MatchPatternTest"] = {
		levelName = "Match Pattern Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Make Left Side Blue",
					patternName = "LeftSide",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "RightSide",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_QuestionMark",
					applyMatchPatterns = true,
					matchPatterns = {"Make Left Side Blue",},
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	
	["FilterTest"] = {
		levelName = "Filtered Pattern Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Make Left Side Reds Blue",
					filter = {
						matchFlags = CascadeMatchFlags_CommonPiece4,
					},
					patternName = "LeftSide",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "RightSide",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_QuestionMark",
					applyMatchPatterns = true,
					matchPatterns = {"Make Left Side Reds Blue",},
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	
	["LinkTest"] = {
		levelName = "Link Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins8 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasLinks = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Link 1",
					delay = 0,
					events = {
						[1] = { --When all links are matched, stop making
							eventType = "population",
							count = 0,
							comparator = "equals",
							newDelay = -1,
							gemType = {
								spawnTypes = {"Link 1"},
							},
						},
					},
					{
						name = "Link 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						weight = 1,
						spawnTypes = {"Link 1"},
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Link,
						skinVariant = "Link1",
					},
				},
				[2] = {
					name = "Link 2",
					delay = 0,
					events = {
						[1] = { --When all links are matched, stop making
							eventType = "population",
							count = 0,
							comparator = "equals",
							newDelay = -1,
							gemType = {
								spawnTypes = {"Link 2"},
							},
						},
					},
					{
						name = "Link 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						weight = 1,
						spawnTypes = {"Link 2"},
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Jailed,
						skinVariant = "Link2_Jailed",
					},
				},
				[3] = {
					name = "Link 3",
					delay = 0,
					events = {
						[1] = { --When all links are matched, stop making
							eventType = "population",
							count = 0,
							comparator = "equals",
							newDelay = -1,
							gemType = {
								spawnTypes = {"Link 3"},
							},
						},
					},
					{
						name = "Link 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						weight = 1,
						spawnTypes = {"Link 3"},
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Link,
						skinVariant = "Link3",
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "LinkTest_Link1",
					isPatternSet = false,
					applySpawnTypes = true,
					spawnTypes = {"Link 1"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Link,
					applySkinVariant = true,
					skinVariant = "Link1",
				},
				[2] = {
					patternName = "LinkTest_Link2",
					isPatternSet = false,
					applySpawnTypes = true,
					spawnTypes = {"Link 2"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece2,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Jailed,
					applySkinVariant = true,
					skinVariant = "Link2_Jailed",
				},
				[3] = {
					patternName = "LinkTest_Link3",
					isPatternSet = false,
					applySpawnTypes = true,
					spawnTypes = {"Link 3"},
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Link,
					applySkinVariant = true,
					skinVariant = "Link3",
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Link","Links",{{specials = CascadePieceSpecials_Link,},{specials = CascadePieceSpecials_Jailed,}},"Break"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	
	["MatchPatternTest2"] = {
		levelName = "Match Pattern Test 2",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "Clear Left Side",
					patternName = "LeftSide",
					clearPieces = true,
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "RightSide",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_QuestionMark",
					applyMatchPatterns = true,
					matchPatterns = {"Clear Left Side",},
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	
	["PatternGemTest"] = {
		levelName = "Pattern Gem Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Replace Marked Gems",
					delay = 0,
					events = { --Make 1 gem every move
						[1] = {
							eventType = "emitCount",
							count = 2,
							newDelay = 4,
							reset = true,
						},
						[2] = {
							eventType = "getGem",
							gemType = {
								icon = "Icon_Marked",
								specials = CascadePieceSpecial_CantCover,
							},
							mewDelay = 2,
						},
					},
					{
						name = "Marked 1",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_CantCover,
						weight = 1,
					},
					{
						name = "Marked 2",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_CantCover,
						weight = 1,
					},
					{
						name = "Marked 3",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_CantCover,
						weight = 1,
					},
					{
						name = "Marked 4",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_CantCover,
						weight = 1,
					},
					{
						name = "Marked 5",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						icon = "Icon_Marked",
						specials = CascadePieceSpecial_CantCover,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				[1] = {
					patternName = "PatternGemTest_Stones",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 2,
				},
				[2] = {
					patternName = "PatternGemTest_Chests",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Treasure,
				},
				[3] = {
					patternName = "PatternGemTest_Patterned",
					isPatternSet = false,
					applyIcon = true,
					icon = "Icon_Marked",
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_CantCover,
				},
				[4] = {
					patternName = "PatternGemTest_Makers",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Replace Marked Gems",},
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Ring","Rings",{icon = "Icon_Marked",},},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
		
	["GoldBarTest"] = {
		levelName = "Gold Bar Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins7 = true,
			splashMode = true,
			gemTypes4 = true,
			largeBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "GoldBarTest_Gold1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchSizeRequirement = true,
					matchSizeRequirement = 8,
					applySkinVariant = true,
					skinVariant = "GoldBar1",
				},
				[2] = {
					patternName = "GoldBarTest_Gold2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchSizeRequirement = true,
					matchSizeRequirement = 12,
					applySkinVariant = true,
					skinVariant = "GoldBar2",
				},
				[3] = {
					patternName = "GoldBarTest_Gold3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applyMatchSizeRequirement = true,
					matchSizeRequirement = 16,
					applySkinVariant = true,
					skinVariant = "GoldBar3",
				},
			},
		},
		goals = {
			main = {"gemsRemain",0,"Gold Bar","Gold Bars",{specials = CascadePieceSpecials_Steel,},},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
		
	["AddPiecesTest"] = {
		levelName = "Add Pieces Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalInitialPatterns = {
				[1] = {
					patternName = "FullBoardSmall",
					isPatternSet = false,
					clearPieces = true,
				},
				[2] = {
					patternName = "LeftSide",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
		
	["AddPiecesTest2"] = {
		levelName = "Add Pieces Test 2",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasSwitches = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "MakeSomeBlue",
					patternName = "LeftSide",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"Toggle1"},
						weight = 1,
						matchPatterns = {"MakeSomeBlue",},
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "OuterBlock_bottomrightcorner_middle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"MakeSomeBlue",},
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	["AddPiecesTest3"] = {
		levelName = "Add Pieces Test 3",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasSwitches = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "MakeSomeBlue",
					patternName = "LeftSide",
					isPatternSet = false,
					addPieces = true,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece1,
				},
			},
			additionalNamedMixes = {
				[1] = {
					name = "Make left side blue always",
					delay = -1,
					events = {
						{
							eventType = "getGem",
							newDelay = -1,
							gemType = {
							},
							patterns = {"MakeSomeBlue"},
						},
					},
				},
			},
			additionalInitialPatterns = {
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	["SafesTest"] = {
		levelName = "Safes Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasSwitches = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Safe1_Step2",
					delay = 0,
					{
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe1_Step3"},
						weight = 1,
					},
				},
				{
					name = "Safe1_Step3",
					delay = 0,
					{
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable,
						spawnTypes = {"Superwild"},
						weight = 1,
					},
				},
				{
					name = "Superwild",
					delay = 0,
					{
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecial_ClearKeyColorOnMatch,
						weight = 1,
					},
				},
				{
					name = "Safe2_Step2",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step3"},
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step3"},
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step3"},
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step3"},
						weight = 1,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step3"},
						weight = 1,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step3"},
						weight = 1,
					},
				},
				{
					name = "Safe2_Step3",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step4"},
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step4"},
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step4"},
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step4"},
						weight = 1,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step4"},
						weight = 1,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Safe,
						spawnTypes = {"Safe2_Step4"},
						weight = 1,
					},
				},
				{
					name = "Safe2_Step4",
					delay = 0,
					{
						name = "Blue",
						matchFlags = CascadeMatchFlags_CommonPiece1,
						specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable,
						spawnTypes = {"Superwild"},
						weight = 1,
					},
					{
						name = "Green",
						matchFlags = CascadeMatchFlags_CommonPiece2,
						specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable,
						spawnTypes = {"Superwild"},
						weight = 1,
					},
					{
						name = "Purple",
						matchFlags = CascadeMatchFlags_CommonPiece3,
						specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable,
						spawnTypes = {"Superwild"},
						weight = 1,
					},
					{
						name = "Red",
						matchFlags = CascadeMatchFlags_CommonPiece4,
						specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable,
						spawnTypes = {"Superwild"},
						weight = 1,
					},
					{
						name = "Yellow",
						matchFlags = CascadeMatchFlags_CommonPiece5,
						specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable,
						spawnTypes = {"Superwild"},
						weight = 1,
					},
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable,
						spawnTypes = {"Superwild"},
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				--A safe with a fixed combination
				{
					patternName = "SafesTest_Safe1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step2"},
				},
				--A safe with a randomized combination
				{
					patternName = "SafesTest_Safe2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe2_Step2"},
				},
			},
		},
		goals = {
			main = {"getGem",2,"Safe","Safes",{specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable, },"Open"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["SafesTest2"] = { -- Safes using level definition macro functions
		levelName = "Safes Test 2",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins10 = true,
			splashMode = true,
			gemTypes4 = true,
			regularBoard = true,
			hasSwitches = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedMixes = ExecuteInline( -- executeInline is a wrapper function that allows us to execute arbitrary code here
				function () -- This declares an anonymous function that contains our code

					-- You can place any code here, but just return a list of piece mixes
					-- Also, be careful with commas!

					-- Our list of piece mixes... currently just contains the "SuperWild" mix
					local exampleNamedMixes = {
						{
							name = "Superwild",
							{
								matchFlags = CascadeMatchFlags_Wildcard,
								specials = CascadePieceSpecial_ClearKeyColorOnMatch,
								weight = 1,
							},
						},
					} -- No comma here!


					-- Add a safe to our list of piece mixes using the MakeFixedSafe function
					-- The combination is {1, 2, 3, 4, 2, 3}
					-- Numbers 1-6 correspond to the associated match flag, and 7 is Wild.
					-- The 0-th color of the combination should be specified in additionalInitialPatterns below.
					-- The prefix of the name is "Safe1". In additionalInitialPatterns, you should set the spawnTypes of the safe to "Safe1_Step1".
					-- This safe will drop the "Superwild" mix when you open it.
					table.insertall(exampleNamedMixes, MakeFixedSafe({1, 2, 3, 4, 2, 3}, "Safe1", "Superwild"))
					
					-- Add a safe to our list of piece mixes using the MakeRandomSafe function
					-- Similar to MakeFixedSafe, but instead of a list of numbers, it takes in a list of "possible" numbers for each step of the combination
					table.insertall(exampleNamedMixes, MakeRandomSafe({{1, 2}, {3, 4}, {1, 2}}, "Safe2", "Superwild"))

					-- The line below prints out the exampleNamedMixes table so that you can check if everything is correct. (Commented to not spam the console.)
					--logprint(SerializeToString(exampleNamedMixes))

					return exampleNamedMixes
				end -- End the function declaration
			), -- Need a comma here!
			additionalInitialPatterns = {
				--A safe with a fixed combination
				{
					patternName = "SafesTest_Safe1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_CommonPiece3, -- The "0-th" step of the safe is purple
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe1_Step1"},
				},
				--A safe with a randomized combination; not setting the match flag results in a random starting color on the safe
				{
					patternName = "SafesTest_Safe2",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Safe,
					applySpawnTypes = true,
					spawnTypes = {"Safe2_Step1"},
				},
			},
		},
		goals = {
			main = {"getGem",2,"Safe","Safes",{specials = CascadePieceSpecials_Safe | CascadePieceSpecial_Valuable, },"Open"},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},

	["GemEaterDelayTest"] = {
		levelName = "Gem Eater Delay Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			hasGemEaters = true,
			hasSteelBoulders = true,
			hasInedibleGems = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "Steel Boulders",
					delay = 0,
					events = { --1 steel boulder every match
						[1] = {
							eventType = "emitCount",
							count = 1,
							newDelay = 7,
							reset = true,
						},
					},
					{
						name = "Steel Boulder",
						matchFlags = 0,
						specials = CascadePieceSpecials_SteelBoulder,
						weight = 1,
					},
				},
			},
			boardPieceMix = {
				{
					name = "Piece1",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					weight = 2,
				},
				{
					name = "Piece2",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					weight = 2,
				},
				{
					name = "Piece3",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					weight = 2,
				},
				{
					name = "Piece4",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					weight = 2,
				},
				{
					name = "Piece5",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					weight = 2,
				},
				{
					name = "Piece1 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece1,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 1,
				},
				{
					name = "Piece2 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece2,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 1,
				},
				{
					name = "Piece3 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece3,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 1,
				},
				{
					name = "Piece4 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece4,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 1,
				},
				{
					name = "Piece5 Inedible",
					matchFlags = CascadeMatchFlags_CommonPiece5,
					specials = CascadePieceSpecials_Inedible_Bar,
					cancelSpecials = CascadePieceSpecials_Inedible_Bar,
					weight = 1,
				},
				
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BottomRow_Spot1_Large",
					isPatternSet = false,
					applyGemEater = true,
					gemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 0,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 6,
					clearPieces = true,
				},
				[2] = {
					patternName = "BottomRow_Spot2_Large",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 1,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 6,
				},
				[3] = {
					patternName = "BottomRow_Spot3_Large",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 2,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 6,
				},
				[4] = {
					patternName = "BottomRow_Spot4_Large",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 3,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 6,
				},
				[5] = {
					patternName = "BottomRow_Spot5_Large",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 4,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 6,
				},
				[6] = {
					patternName = "BottomRow_Spot6_Large",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 5,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 6,
				},
				[7] = {
					patternName = "BottomRow_Spot7_Large",
					isPatternSet = false,
					gemEater = true,
					applyGemEater = true,
					applyGemEaterDelay = true,
					gemEaterDelay = 6,
					applyGemEaterCooldown = true,
					gemEaterCooldown = 6,
				},
				[8] = {
					patternName = "Short_Help_BurstTeacher_Step2_Color1",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Steel,
					applySpawnBelowTypes = true,
					spawnBelowTypes = {"Steel Boulders"},
					applyCancelSpecials = true,
					cancelSpecials = 0,
				},
				[9] = {
					patternName = "Line2_large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Crates,
					applyCancelSpecials = true,
					cancelSpecials = 0,
				},
			},
		},
		goals = {
			main = {"eatGem",3,"Cannonball","Cannonballs",{specials = CascadePieceSpecials_SteelBoulder,},},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},

	["LavaBurstTest"] = {
		levelName = "Lava Burst Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			largeBoard = true,
			hasLava = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalInitialPatterns = { 
				[1] = {
					patternName = "BottomRow_Spot1_Large",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Lava,
				},
				[2] = {
					patternName = "BottomRow_Spot2_Large",
					isPatternSet = false,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_VerticalSplash + CascadePieceSpecial_AreaSplash,
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
	["RandomizedInitialPatternTest"] = {
		levelName = "Randomized InitialPattern Test",
		resource = "GameScreen_Land1",		
		Features = {
			splashMode = true,
			modeSpins5 = true,
			regularBoard = true,
			gemTypes5,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalNamedMixes = {
				[1] = {
					name = "BlueAndGreen",
					{
						name = "Blue",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
					},
					{
						name = "Green",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
					},
				},
			},
			additionalInitialPatterns = { 
				[1] = {
					patternName = "LeftSide",
					isPatternSet = false,
					replacePieces = {"BlueAndGreen"},
				},
			},
		},
		goals = {
			main = {"finish",true,},
			stars = {
				[1] = {"score",100000},
				[2] = {"score",200000},
				[3] = {"score",300000},
			},
		},
	},
		
	["RandomizedMatchPatternTest"] = {
		levelName = "RandomizedMatchPatternTest",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasSwitches = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "MakeBlueAndGreen",
					patternName = "LeftSide",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"Blue and Green Mix"},
				},
			},
			additionalNamedMixes = {
				{
					name = "Toggle1",
					delay = 0,
					{
						name = "Switch_Toggle1",
						matchFlags = 0,
						specials = CascadePieceSpecials_Stone,
						skinVariant = "Switch1_Toggle",
						spawnTypes = {"Toggle1"},
						weight = 1,
						matchPatterns = {"MakeBlueAndGreen",},
					},
				},
				{
					name = "Blue and Green Mix",
					{
						name = "Blue",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
					},
					{
						name = "Green",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
					},
				},
			},
			additionalInitialPatterns = { 
				{
					patternName = "OuterBlock_bottomrightcorner_middle",
					isPatternSet = false,
					applyPieceSpecials = true,
					applyMatchFlags = true,
					matchFlags = 0,
					specials = CascadePieceSpecials_Stone,
					applySpawnTypes = true,
					spawnTypes = {"Toggle1"},
					applySkinVariant = true,
					skinVariant = "Switch1_Toggle",
					applyMatchPatterns = true,
					matchPatterns = {"MakeBlueAndGreen",},
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	["RandomizedEventPatternTest"] = {
		levelName = "RandomizedEventPatternTest",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasSwitches = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalNamedPatterns = {
				[1] = {
					entryName = "MakeBlueAndGreen",
					patternName = "LeftSide",
					isPatternSet = false,
					addPieces = true,
					replacePieces = {"Blue and Green Mix",},
				},
			},
			additionalNamedMixes = {
				{
					name = "Make left side blue and green always",
					delay = -1,
					events = {
						{
							eventType = "getGem",
							newDelay = -1,
							gemType = {
							},
							patterns = {"MakeBlueAndGreen"},
						},
					},
				},
				{
					name = "Blue and Green Mix",
					{
						name = "Blue",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece1,
					},
					{
						name = "Green",
						weight = 1,
						matchFlags = CascadeMatchFlags_CommonPiece2,
					},
				},
			},
			additionalInitialPatterns = {
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	["WidePlusSplashTest"] = {
		levelName = "WidePlusSplash Test",					
		resource = "GameScreen_Land21",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasSwitches = true,
		},
		tricks = World21Tricks,
		boosts = World21Boosts,
		Properties = {
			additionalInitialPatterns = {
				{
					patternName = "Large 3,3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = CascadeMatchFlags_Wildcard,
					applyPieceSpecials = true,
					specials = CascadePieceSpecial_HorizontalSplash | CascadePieceSpecial_AreaSplash | CascadePieceSpecial_VerticalSplash,
				},
				{
					patternName = "Large 4,2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
				},
				{
					patternName = "Large 4,4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	["LockedPresentTest"] = {
		levelName = "Locked Present Test",					
		resource = "GameScreen_Land1",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			largeBoard = true,
			hasLockedGifts = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			additionalNamedMixes = {
				{
					name = "Wild Mix",
					delay = 0,
					{
						name = "Wild",
						matchFlags = CascadeMatchFlags_Wildcard,
						weight = 1,
					},
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "Large 3,3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Locked_Gift,
					applySpawnTypes = true,
					spawnTypes = {"Wild Mix"},
				},
				{
					patternName = "Large 4,2",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Locked_Gift,
					applyExtraHits = true,
					extraHits = 1,
					applySpawnTypes = true,
					spawnTypes = {"Wild Mix"},
				},
				{
					patternName = "Large 4,4",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Locked_Gift,
					applyExtraHits = true,
					extraHits = 2,
					applySpawnTypes = true,
					spawnTypes = {"Wild Mix"},
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
	["BoomerangTest"] = {
		levelName = "Boomerang Test",					
		resource = "GameScreen_Land1",
		Features = {
			modeSpins5 = true,
			splashMode = true,
			gemTypes5 = true,
			regularBoard = true,
			hasBoomerangs = true,
		},
		tricks = World1Tricks,
		boosts = World1Boosts,
		Properties = {
			addToReelPieceMix = {
				{
					name = "Boomerang",
					matchFlags = 0,
					specials = CascadePieceSpecials_Boomerang,
					weight = 11,
				},
			},
			additionalInitialPatterns = {
				{
					patternName = "UpperLine3",
					isPatternSet = false,
					applyMatchFlags = true,
					matchFlags = 0,
					applyPieceSpecials = true,
					specials = CascadePieceSpecials_Stone,
					applyExtraHits = true,
					extraHits = 1,
					applySkinVariant = true,
					skinVariant = "Stone",
				},
			},
		},
		goals = {
			main = {"finish",true},
			stars = {
				[1] = {"score",25000},
				[2] = {"score",50000},
				[3] = {"score",75000},
			},
		},
		expectedScore = 100000, 
	},
})